
/* Copyright (c) 2022, Qualcomm Innovation Center, Inc. All rights reserved.
 *
 * Permission to use, copy, modify, and/or distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#ifndef __WCSS_SEQ_HWIOREG_UMAC_H__
#define __WCSS_SEQ_HWIOREG_UMAC_H__
#include "seq_hwio.h"
#include "wcss_seq_hwiobase.h"
#ifdef SCALE_INCLUDES
#include "HALhwio.h"
#else
#include "msmhwio.h"
#endif

/*----------------------------------------------------------------------------
 * MODULE: MAC_UMXI_REG
 *--------------------------------------------------------------------------*/

#define MAC_UMXI_REG_REG_BASE                                                                               (UMAC_BASE      + 0x00030000)
#define MAC_UMXI_REG_REG_BASE_SIZE                                                                          0x4000
#define MAC_UMXI_REG_REG_BASE_USED                                                                          0x510
#define MAC_UMXI_REG_REG_BASE_PHYS                                                                          (UMAC_BASE_PHYS + 0x00030000)
#define MAC_UMXI_REG_REG_BASE_OFFS                                                                          0x00030000

#define HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_ADDR(x)                                                         ((x) + 0x0)
#define HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_PHYS(x)                                                         ((x) + 0x0)
#define HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_OFFS                                                            (0x0)
#define HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_RMSK                                                            0x8000007f
#define HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_POR                                                             0x00000000
#define HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_POR_RMSK                                                        0xffffffff
#define HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_ATTR                                                                         0x3
#define HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_ADDR(x))
#define HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_ADDR(x),m,v,HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_IN(x))
#define HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_CLOCK_GATE_EXTEND_BMSK                                          0x80000000
#define HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_CLOCK_GATE_EXTEND_SHFT                                                  31
#define HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_WR_PERF_CNT_1_BMSK                                                    0x40
#define HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_WR_PERF_CNT_1_SHFT                                                       6
#define HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_WR_PERF_CNT_0_BMSK                                                    0x20
#define HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_WR_PERF_CNT_0_SHFT                                                       5
#define HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_RD_PERF_CNT_3_BMSK                                                    0x10
#define HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_RD_PERF_CNT_3_SHFT                                                       4
#define HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_RD_PERF_CNT_2_BMSK                                                     0x8
#define HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_RD_PERF_CNT_2_SHFT                                                       3
#define HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_RD_PERF_CNT_1_BMSK                                                     0x4
#define HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_RD_PERF_CNT_1_SHFT                                                       2
#define HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_RD_PERF_CNT_0_BMSK                                                     0x2
#define HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_RD_PERF_CNT_0_SHFT                                                       1
#define HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_UNUSED_BMSK                                                            0x1
#define HWIO_UMAC_MXI_R0_CLOCK_GATE_DISABLE_UNUSED_SHFT                                                              0

#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE0_ADDR(x)                                                    ((x) + 0x4)
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE0_PHYS(x)                                                    ((x) + 0x4)
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE0_OFFS                                                       (0x4)
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE0_RMSK                                                       0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE0_POR                                                        0x00000000
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE0_POR_RMSK                                                   0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE0_ATTR                                                                    0x3
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE0_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE0_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE0_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE0_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE0_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE0_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE0_ADDR(x),m,v,HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE0_IN(x))
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE0_VALUE_BMSK                                                 0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE0_VALUE_SHFT                                                          0

#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE0_ADDR(x)                                                    ((x) + 0x8)
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE0_PHYS(x)                                                    ((x) + 0x8)
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE0_OFFS                                                       (0x8)
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE0_RMSK                                                             0xff
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE0_POR                                                        0x00000000
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE0_POR_RMSK                                                   0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE0_ATTR                                                                    0x3
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE0_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE0_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE0_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE0_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE0_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE0_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE0_ADDR(x),m,v,HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE0_IN(x))
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE0_VALUE_BMSK                                                       0xff
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE0_VALUE_SHFT                                                          0

#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE0_ADDR(x)                                                       ((x) + 0xc)
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE0_PHYS(x)                                                       ((x) + 0xc)
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE0_OFFS                                                          (0xc)
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE0_RMSK                                                          0x3fffffff
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE0_POR                                                           0x00000000
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE0_POR_RMSK                                                      0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE0_ATTR                                                                       0x3
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE0_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE0_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE0_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE0_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE0_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE0_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE0_ADDR(x),m,v,HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE0_IN(x))
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE0_VALUE_BMSK                                                    0x3fffffff
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE0_VALUE_SHFT                                                             0

#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE1_ADDR(x)                                                    ((x) + 0x10)
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE1_PHYS(x)                                                    ((x) + 0x10)
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE1_OFFS                                                       (0x10)
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE1_RMSK                                                       0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE1_POR                                                        0x00000000
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE1_POR_RMSK                                                   0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE1_ATTR                                                                    0x3
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE1_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE1_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE1_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE1_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE1_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE1_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE1_ADDR(x),m,v,HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE1_IN(x))
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE1_VALUE_BMSK                                                 0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_LSB_BASE1_VALUE_SHFT                                                          0

#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE1_ADDR(x)                                                    ((x) + 0x14)
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE1_PHYS(x)                                                    ((x) + 0x14)
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE1_OFFS                                                       (0x14)
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE1_RMSK                                                             0xff
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE1_POR                                                        0x00000000
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE1_POR_RMSK                                                   0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE1_ATTR                                                                    0x3
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE1_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE1_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE1_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE1_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE1_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE1_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE1_ADDR(x),m,v,HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE1_IN(x))
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE1_VALUE_BMSK                                                       0xff
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_MSB_BASE1_VALUE_SHFT                                                          0

#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE1_ADDR(x)                                                       ((x) + 0x18)
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE1_PHYS(x)                                                       ((x) + 0x18)
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE1_OFFS                                                          (0x18)
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE1_RMSK                                                          0x3fffffff
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE1_POR                                                           0x00000000
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE1_POR_RMSK                                                      0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE1_ATTR                                                                       0x3
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE1_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE1_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE1_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE1_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE1_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE1_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE1_ADDR(x),m,v,HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE1_IN(x))
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE1_VALUE_BMSK                                                    0x3fffffff
#define HWIO_UMAC_MXI_R0_MXI_PERF_ADDR_RANGE1_VALUE_SHFT                                                             0

#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_0_ADDR(x)                                                ((x) + 0x1c)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_0_PHYS(x)                                                ((x) + 0x1c)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_0_OFFS                                                   (0x1c)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_0_RMSK                                                   0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_0_POR                                                    0x00000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_0_POR_RMSK                                               0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_0_ATTR                                                                0x0
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_0_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_0_ADDR(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_0_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_0_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_0_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_0_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_0_ADDR(x),m,v,HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_0_IN(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_0_ADDRESS_RANGE_LIMIT_BMSK                               0xc0000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_0_ADDRESS_RANGE_LIMIT_SHFT                                       30
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_0_WINDOW_SIZE_BMSK                                       0x38000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_0_WINDOW_SIZE_SHFT                                               27
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_0_RESET_CNT_BMSK                                          0x4000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_0_RESET_CNT_SHFT                                                 26
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_0_CNTR_EN_BMSK                                            0x2000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_0_CNTR_EN_SHFT                                                   25
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_0_ID_BITMAP_BMSK                                          0x1ffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_0_ID_BITMAP_SHFT                                                  0

#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_0_ADDR(x)                                        ((x) + 0x20)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_0_PHYS(x)                                        ((x) + 0x20)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_0_OFFS                                           (0x20)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_0_RMSK                                           0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_0_POR                                            0x00000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_0_POR_RMSK                                       0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_0_ATTR                                                        0x3
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_0_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_0_ADDR(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_0_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_0_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_0_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_0_ADDR(x),m,v,HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_0_IN(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_0_ID_BITMAP_BMSK                                 0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_0_ID_BITMAP_SHFT                                          0

#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_1_ADDR(x)                                        ((x) + 0x24)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_1_PHYS(x)                                        ((x) + 0x24)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_1_OFFS                                           (0x24)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_1_RMSK                                           0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_1_POR                                            0x00000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_1_POR_RMSK                                       0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_1_ATTR                                                        0x3
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_1_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_1_ADDR(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_1_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_1_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_1_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_1_ADDR(x),m,v,HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_1_IN(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_1_ID_BITMAP_BMSK                                 0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_0_IX_1_ID_BITMAP_SHFT                                          0

#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_0_ADDR(x)                                                ((x) + 0x28)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_0_PHYS(x)                                                ((x) + 0x28)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_0_OFFS                                                   (0x28)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_0_RMSK                                                   0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_0_POR                                                    0x00000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_0_POR_RMSK                                               0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_0_ATTR                                                                0x1
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_0_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_0_ADDR(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_0_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_0_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_0_VALUE_BMSK                                             0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_0_VALUE_SHFT                                                      0

#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_0_ADDR(x)                                                 ((x) + 0x2c)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_0_PHYS(x)                                                 ((x) + 0x2c)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_0_OFFS                                                    (0x2c)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_0_RMSK                                                    0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_0_POR                                                     0x00000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_0_POR_RMSK                                                0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_0_ATTR                                                                 0x1
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_0_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_0_ADDR(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_0_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_0_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_0_VALUE_BMSK                                              0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_0_VALUE_SHFT                                                       0

#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_1_ADDR(x)                                                ((x) + 0x30)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_1_PHYS(x)                                                ((x) + 0x30)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_1_OFFS                                                   (0x30)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_1_RMSK                                                   0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_1_POR                                                    0x00000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_1_POR_RMSK                                               0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_1_ATTR                                                                0x0
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_1_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_1_ADDR(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_1_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_1_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_1_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_1_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_1_ADDR(x),m,v,HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_1_IN(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_1_ADDRESS_RANGE_LIMIT_BMSK                               0xc0000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_1_ADDRESS_RANGE_LIMIT_SHFT                                       30
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_1_WINDOW_SIZE_BMSK                                       0x38000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_1_WINDOW_SIZE_SHFT                                               27
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_1_RESET_CNT_BMSK                                          0x4000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_1_RESET_CNT_SHFT                                                 26
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_1_CNTR_EN_BMSK                                            0x2000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_1_CNTR_EN_SHFT                                                   25
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_1_ID_BITMAP_BMSK                                          0x1ffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_1_ID_BITMAP_SHFT                                                  0

#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_0_ADDR(x)                                        ((x) + 0x34)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_0_PHYS(x)                                        ((x) + 0x34)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_0_OFFS                                           (0x34)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_0_RMSK                                           0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_0_POR                                            0x00000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_0_POR_RMSK                                       0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_0_ATTR                                                        0x3
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_0_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_0_ADDR(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_0_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_0_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_0_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_0_ADDR(x),m,v,HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_0_IN(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_0_ID_BITMAP_BMSK                                 0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_0_ID_BITMAP_SHFT                                          0

#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_1_ADDR(x)                                        ((x) + 0x38)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_1_PHYS(x)                                        ((x) + 0x38)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_1_OFFS                                           (0x38)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_1_RMSK                                           0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_1_POR                                            0x00000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_1_POR_RMSK                                       0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_1_ATTR                                                        0x3
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_1_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_1_ADDR(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_1_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_1_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_1_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_1_ADDR(x),m,v,HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_1_IN(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_1_ID_BITMAP_BMSK                                 0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_1_IX_1_ID_BITMAP_SHFT                                          0

#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_1_ADDR(x)                                                ((x) + 0x3c)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_1_PHYS(x)                                                ((x) + 0x3c)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_1_OFFS                                                   (0x3c)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_1_RMSK                                                   0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_1_POR                                                    0x00000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_1_POR_RMSK                                               0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_1_ATTR                                                                0x1
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_1_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_1_ADDR(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_1_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_1_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_1_VALUE_BMSK                                             0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_1_VALUE_SHFT                                                      0

#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_1_ADDR(x)                                                 ((x) + 0x40)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_1_PHYS(x)                                                 ((x) + 0x40)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_1_OFFS                                                    (0x40)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_1_RMSK                                                    0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_1_POR                                                     0x00000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_1_POR_RMSK                                                0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_1_ATTR                                                                 0x1
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_1_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_1_ADDR(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_1_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_1_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_1_VALUE_BMSK                                              0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_1_VALUE_SHFT                                                       0

#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_2_ADDR(x)                                                ((x) + 0x44)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_2_PHYS(x)                                                ((x) + 0x44)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_2_OFFS                                                   (0x44)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_2_RMSK                                                   0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_2_POR                                                    0x00000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_2_POR_RMSK                                               0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_2_ATTR                                                                0x0
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_2_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_2_ADDR(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_2_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_2_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_2_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_2_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_2_ADDR(x),m,v,HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_2_IN(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_2_ADDRESS_RANGE_LIMIT_BMSK                               0xc0000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_2_ADDRESS_RANGE_LIMIT_SHFT                                       30
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_2_WINDOW_SIZE_BMSK                                       0x38000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_2_WINDOW_SIZE_SHFT                                               27
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_2_RESET_CNT_BMSK                                          0x4000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_2_RESET_CNT_SHFT                                                 26
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_2_CNTR_EN_BMSK                                            0x2000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_2_CNTR_EN_SHFT                                                   25
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_2_ID_BITMAP_BMSK                                          0x1ffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_2_ID_BITMAP_SHFT                                                  0

#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_0_ADDR(x)                                        ((x) + 0x48)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_0_PHYS(x)                                        ((x) + 0x48)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_0_OFFS                                           (0x48)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_0_RMSK                                           0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_0_POR                                            0x00000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_0_POR_RMSK                                       0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_0_ATTR                                                        0x3
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_0_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_0_ADDR(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_0_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_0_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_0_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_0_ADDR(x),m,v,HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_0_IN(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_0_ID_BITMAP_BMSK                                 0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_0_ID_BITMAP_SHFT                                          0

#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_1_ADDR(x)                                        ((x) + 0x4c)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_1_PHYS(x)                                        ((x) + 0x4c)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_1_OFFS                                           (0x4c)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_1_RMSK                                           0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_1_POR                                            0x00000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_1_POR_RMSK                                       0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_1_ATTR                                                        0x3
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_1_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_1_ADDR(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_1_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_1_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_1_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_1_ADDR(x),m,v,HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_1_IN(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_1_ID_BITMAP_BMSK                                 0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_2_IX_1_ID_BITMAP_SHFT                                          0

#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_2_ADDR(x)                                                ((x) + 0x50)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_2_PHYS(x)                                                ((x) + 0x50)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_2_OFFS                                                   (0x50)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_2_RMSK                                                   0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_2_POR                                                    0x00000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_2_POR_RMSK                                               0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_2_ATTR                                                                0x1
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_2_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_2_ADDR(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_2_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_2_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_2_VALUE_BMSK                                             0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_2_VALUE_SHFT                                                      0

#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_2_ADDR(x)                                                 ((x) + 0x54)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_2_PHYS(x)                                                 ((x) + 0x54)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_2_OFFS                                                    (0x54)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_2_RMSK                                                    0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_2_POR                                                     0x00000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_2_POR_RMSK                                                0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_2_ATTR                                                                 0x1
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_2_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_2_ADDR(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_2_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_2_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_2_VALUE_BMSK                                              0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_2_VALUE_SHFT                                                       0

#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_3_ADDR(x)                                                ((x) + 0x58)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_3_PHYS(x)                                                ((x) + 0x58)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_3_OFFS                                                   (0x58)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_3_RMSK                                                   0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_3_POR                                                    0x00000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_3_POR_RMSK                                               0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_3_ATTR                                                                0x0
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_3_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_3_ADDR(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_3_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_3_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_3_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_3_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_3_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_3_ADDR(x),m,v,HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_3_IN(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_3_ADDRESS_RANGE_LIMIT_BMSK                               0xc0000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_3_ADDRESS_RANGE_LIMIT_SHFT                                       30
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_3_WINDOW_SIZE_BMSK                                       0x38000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_3_WINDOW_SIZE_SHFT                                               27
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_3_RESET_CNT_BMSK                                          0x4000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_3_RESET_CNT_SHFT                                                 26
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_3_CNTR_EN_BMSK                                            0x2000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_3_CNTR_EN_SHFT                                                   25
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_3_ID_BITMAP_BMSK                                          0x1ffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_CFG_3_ID_BITMAP_SHFT                                                  0

#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_0_ADDR(x)                                        ((x) + 0x5c)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_0_PHYS(x)                                        ((x) + 0x5c)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_0_OFFS                                           (0x5c)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_0_RMSK                                           0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_0_POR                                            0x00000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_0_POR_RMSK                                       0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_0_ATTR                                                        0x3
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_0_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_0_ADDR(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_0_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_0_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_0_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_0_ADDR(x),m,v,HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_0_IN(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_0_ID_BITMAP_BMSK                                 0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_0_ID_BITMAP_SHFT                                          0

#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_1_ADDR(x)                                        ((x) + 0x60)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_1_PHYS(x)                                        ((x) + 0x60)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_1_OFFS                                           (0x60)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_1_RMSK                                           0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_1_POR                                            0x00000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_1_POR_RMSK                                       0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_1_ATTR                                                        0x3
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_1_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_1_ADDR(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_1_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_1_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_1_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_1_ADDR(x),m,v,HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_1_IN(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_1_ID_BITMAP_BMSK                                 0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_ID_CFG_3_IX_1_ID_BITMAP_SHFT                                          0

#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_3_ADDR(x)                                                ((x) + 0x64)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_3_PHYS(x)                                                ((x) + 0x64)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_3_OFFS                                                   (0x64)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_3_RMSK                                                   0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_3_POR                                                    0x00000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_3_POR_RMSK                                               0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_3_ATTR                                                                0x1
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_3_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_3_ADDR(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_3_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_3_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_3_VALUE_BMSK                                             0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_CNTR_VAL_3_VALUE_SHFT                                                      0

#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_3_ADDR(x)                                                 ((x) + 0x68)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_3_PHYS(x)                                                 ((x) + 0x68)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_3_OFFS                                                    (0x68)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_3_RMSK                                                    0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_3_POR                                                     0x00000000
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_3_POR_RMSK                                                0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_3_ATTR                                                                 0x1
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_3_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_3_ADDR(x))
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_3_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_3_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_3_VALUE_BMSK                                              0xffffffff
#define HWIO_UMAC_MXI_R0_UMAC_MXI_RD_PERF_TXN_CTR_3_VALUE_SHFT                                                       0

#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_0_ADDR(x)                                                     ((x) + 0x6c)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_0_PHYS(x)                                                     ((x) + 0x6c)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_0_OFFS                                                        (0x6c)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_0_RMSK                                                           0x70101
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_0_POR                                                         0x00000000
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_0_POR_RMSK                                                    0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_0_ATTR                                                                     0x0
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_0_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_0_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_0_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_0_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_0_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_0_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_0_ADDR(x),m,v,HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_0_IN(x))
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_0_WINDOW_SIZE_BMSK                                               0x70000
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_0_WINDOW_SIZE_SHFT                                                    16
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_0_RESET_CNT_BMSK                                                   0x100
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_0_RESET_CNT_SHFT                                                       8
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_0_CNTR_EN_BMSK                                                       0x1
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_0_CNTR_EN_SHFT                                                         0

#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_ADDR(x)                                                  ((x) + 0x70)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_PHYS(x)                                                  ((x) + 0x70)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_OFFS                                                     (0x70)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_RMSK                                                     0x3fffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_POR                                                      0x00000000
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_POR_RMSK                                                 0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_ATTR                                                                  0x3
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_ADDR(x),m,v,HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IN(x))
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_ID_BITMAP_BMSK                                           0x3fffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_ID_BITMAP_SHFT                                                    0

#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_0_ADDR(x)                                             ((x) + 0x74)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_0_PHYS(x)                                             ((x) + 0x74)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_0_OFFS                                                (0x74)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_0_RMSK                                                0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_0_POR                                                 0x00000000
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_0_POR_RMSK                                            0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_0_ATTR                                                             0x3
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_0_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_0_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_0_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_0_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_0_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_0_ADDR(x),m,v,HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_0_IN(x))
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_0_ID_BITMAP_BMSK                                      0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_0_ID_BITMAP_SHFT                                               0

#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_1_ADDR(x)                                             ((x) + 0x78)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_1_PHYS(x)                                             ((x) + 0x78)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_1_OFFS                                                (0x78)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_1_RMSK                                                0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_1_POR                                                 0x00000000
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_1_POR_RMSK                                            0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_1_ATTR                                                             0x3
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_1_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_1_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_1_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_1_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_1_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_1_ADDR(x),m,v,HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_1_IN(x))
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_1_ID_BITMAP_BMSK                                      0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_0_IX_1_ID_BITMAP_SHFT                                               0

#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_VAL_0_ADDR(x)                                                     ((x) + 0x7c)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_VAL_0_PHYS(x)                                                     ((x) + 0x7c)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_VAL_0_OFFS                                                        (0x7c)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_VAL_0_RMSK                                                        0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_VAL_0_POR                                                         0x00000000
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_VAL_0_POR_RMSK                                                    0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_VAL_0_ATTR                                                                     0x1
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_VAL_0_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_VAL_0_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_VAL_0_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_VAL_0_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_VAL_0_VALUE_BMSK                                                  0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_VAL_0_VALUE_SHFT                                                           0

#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_TXN_CTR_0_ADDR(x)                                                      ((x) + 0x80)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_TXN_CTR_0_PHYS(x)                                                      ((x) + 0x80)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_TXN_CTR_0_OFFS                                                         (0x80)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_TXN_CTR_0_RMSK                                                         0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_TXN_CTR_0_POR                                                          0x00000000
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_TXN_CTR_0_POR_RMSK                                                     0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_TXN_CTR_0_ATTR                                                                      0x1
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_TXN_CTR_0_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_WR_PERF_TXN_CTR_0_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_TXN_CTR_0_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_WR_PERF_TXN_CTR_0_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_TXN_CTR_0_VALUE_BMSK                                                   0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_TXN_CTR_0_VALUE_SHFT                                                            0

#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_1_ADDR(x)                                                     ((x) + 0x84)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_1_PHYS(x)                                                     ((x) + 0x84)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_1_OFFS                                                        (0x84)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_1_RMSK                                                           0x70101
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_1_POR                                                         0x00000000
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_1_POR_RMSK                                                    0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_1_ATTR                                                                     0x0
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_1_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_1_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_1_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_1_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_1_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_1_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_1_ADDR(x),m,v,HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_1_IN(x))
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_1_WINDOW_SIZE_BMSK                                               0x70000
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_1_WINDOW_SIZE_SHFT                                                    16
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_1_RESET_CNT_BMSK                                                   0x100
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_1_RESET_CNT_SHFT                                                       8
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_1_CNTR_EN_BMSK                                                       0x1
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_CFG_1_CNTR_EN_SHFT                                                         0

#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_0_ADDR(x)                                             ((x) + 0x88)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_0_PHYS(x)                                             ((x) + 0x88)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_0_OFFS                                                (0x88)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_0_RMSK                                                0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_0_POR                                                 0x00000000
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_0_POR_RMSK                                            0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_0_ATTR                                                             0x3
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_0_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_0_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_0_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_0_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_0_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_0_ADDR(x),m,v,HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_0_IN(x))
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_0_ID_BITMAP_BMSK                                      0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_0_ID_BITMAP_SHFT                                               0

#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_1_ADDR(x)                                             ((x) + 0x8c)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_1_PHYS(x)                                             ((x) + 0x8c)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_1_OFFS                                                (0x8c)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_1_RMSK                                                0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_1_POR                                                 0x00000000
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_1_POR_RMSK                                            0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_1_ATTR                                                             0x3
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_1_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_1_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_1_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_1_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_1_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_1_ADDR(x),m,v,HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_1_IN(x))
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_1_ID_BITMAP_BMSK                                      0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IX_1_ID_BITMAP_SHFT                                               0

#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_ADDR(x)                                                  ((x) + 0x90)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_PHYS(x)                                                  ((x) + 0x90)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_OFFS                                                     (0x90)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_RMSK                                                     0x3fffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_POR                                                      0x00000000
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_POR_RMSK                                                 0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_ATTR                                                                  0x3
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_ADDR(x),m,v,HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_IN(x))
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_ID_BITMAP_BMSK                                           0x3fffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_ID_CFG_1_ID_BITMAP_SHFT                                                    0

#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_VAL_1_ADDR(x)                                                     ((x) + 0x94)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_VAL_1_PHYS(x)                                                     ((x) + 0x94)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_VAL_1_OFFS                                                        (0x94)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_VAL_1_RMSK                                                        0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_VAL_1_POR                                                         0x00000000
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_VAL_1_POR_RMSK                                                    0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_VAL_1_ATTR                                                                     0x1
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_VAL_1_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_VAL_1_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_VAL_1_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_VAL_1_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_VAL_1_VALUE_BMSK                                                  0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_CNTR_VAL_1_VALUE_SHFT                                                           0

#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_TXN_CTR_1_ADDR(x)                                                      ((x) + 0x98)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_TXN_CTR_1_PHYS(x)                                                      ((x) + 0x98)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_TXN_CTR_1_OFFS                                                         (0x98)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_TXN_CTR_1_RMSK                                                         0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_TXN_CTR_1_POR                                                          0x00000000
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_TXN_CTR_1_POR_RMSK                                                     0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_TXN_CTR_1_ATTR                                                                      0x1
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_TXN_CTR_1_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_WR_PERF_TXN_CTR_1_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_TXN_CTR_1_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_WR_PERF_TXN_CTR_1_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_TXN_CTR_1_VALUE_BMSK                                                   0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_WR_PERF_TXN_CTR_1_VALUE_SHFT                                                            0

#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_REG_ADDR(x)                                                         ((x) + 0x9c)
#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_REG_PHYS(x)                                                         ((x) + 0x9c)
#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_REG_OFFS                                                            (0x9c)
#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_REG_RMSK                                                            0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_REG_POR                                                             0x00000000
#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_REG_POR_RMSK                                                        0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_REG_ATTR                                                                         0x3
#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_REG_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_REG_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_REG_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_REG_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_REG_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_REG_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_REG_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_REG_ADDR(x),m,v,HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_REG_IN(x))
#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_REG_WR_REMAP_EN_BMSK                                                0x80000000
#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_REG_WR_REMAP_EN_SHFT                                                        31
#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_REG_RD_REMAP_EN_BMSK                                                0x40000000
#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_REG_RD_REMAP_EN_SHFT                                                        30
#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_REG_REMAP_SEC_BMSK                                                  0x20000000
#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_REG_REMAP_SEC_SHFT                                                          29
#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_REG_REMAP_ADDR_BMSK                                                 0x1fffffff
#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_REG_REMAP_ADDR_SHFT                                                          0

#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_CFG_REG_ADDR(x)                                                     ((x) + 0xa0)
#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_CFG_REG_PHYS(x)                                                     ((x) + 0xa0)
#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_CFG_REG_OFFS                                                        (0xa0)
#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_CFG_REG_RMSK                                                               0x7
#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_CFG_REG_POR                                                         0x00000000
#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_CFG_REG_POR_RMSK                                                    0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_CFG_REG_ATTR                                                                     0x3
#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_CFG_REG_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_CFG_REG_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_CFG_REG_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_CFG_REG_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_CFG_REG_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_CFG_REG_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_CFG_REG_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_CFG_REG_ADDR(x),m,v,HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_CFG_REG_IN(x))
#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_CFG_REG_SIZE_OF_NULL_REMAP_BMSK                                            0x7
#define HWIO_UMAC_MXI_R0_MXI_NULL_REMAP_CFG_REG_SIZE_OF_NULL_REMAP_SHFT                                              0

#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_SS_UP_TIMEOUT_INT_CTRL_ADDR(x)                                        ((x) + 0xa4)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_SS_UP_TIMEOUT_INT_CTRL_PHYS(x)                                        ((x) + 0xa4)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_SS_UP_TIMEOUT_INT_CTRL_OFFS                                           (0xa4)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_SS_UP_TIMEOUT_INT_CTRL_RMSK                                            0x1ffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_SS_UP_TIMEOUT_INT_CTRL_POR                                            0x00001ffe
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_SS_UP_TIMEOUT_INT_CTRL_POR_RMSK                                       0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_SS_UP_TIMEOUT_INT_CTRL_ATTR                                                        0x3
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_SS_UP_TIMEOUT_INT_CTRL_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_SS_UP_TIMEOUT_INT_CTRL_ADDR(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_SS_UP_TIMEOUT_INT_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_SS_UP_TIMEOUT_INT_CTRL_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_SS_UP_TIMEOUT_INT_CTRL_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_SS_UP_TIMEOUT_INT_CTRL_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_SS_UP_TIMEOUT_INT_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_SS_UP_TIMEOUT_INT_CTRL_ADDR(x),m,v,HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_SS_UP_TIMEOUT_INT_CTRL_IN(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_SS_UP_TIMEOUT_INT_CTRL_GXI_SS_UP_TIMEOUT_STATS_BMSK                    0x1ffe000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_SS_UP_TIMEOUT_INT_CTRL_GXI_SS_UP_TIMEOUT_STATS_SHFT                           13
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_SS_UP_TIMEOUT_INT_CTRL_GXI_SS_UP_TIMEOUT_LIMIT_BMSK                       0x1ffe
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_SS_UP_TIMEOUT_INT_CTRL_GXI_SS_UP_TIMEOUT_LIMIT_SHFT                            1
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_SS_UP_TIMEOUT_INT_CTRL_GXI_SS_UP_TIMEOUT_INT_BMSK                            0x1
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_SS_UP_TIMEOUT_INT_CTRL_GXI_SS_UP_TIMEOUT_INT_SHFT                              0

#define HWIO_UMAC_MXI_R0_MXI_S_PARE_REGISTER_ADDR(x)                                                        ((x) + 0xa8)
#define HWIO_UMAC_MXI_R0_MXI_S_PARE_REGISTER_PHYS(x)                                                        ((x) + 0xa8)
#define HWIO_UMAC_MXI_R0_MXI_S_PARE_REGISTER_OFFS                                                           (0xa8)
#define HWIO_UMAC_MXI_R0_MXI_S_PARE_REGISTER_RMSK                                                           0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_S_PARE_REGISTER_POR                                                            0x00000000
#define HWIO_UMAC_MXI_R0_MXI_S_PARE_REGISTER_POR_RMSK                                                       0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_S_PARE_REGISTER_ATTR                                                                        0x3
#define HWIO_UMAC_MXI_R0_MXI_S_PARE_REGISTER_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_S_PARE_REGISTER_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_S_PARE_REGISTER_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_S_PARE_REGISTER_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_S_PARE_REGISTER_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_MXI_S_PARE_REGISTER_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_MXI_S_PARE_REGISTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_MXI_S_PARE_REGISTER_ADDR(x),m,v,HWIO_UMAC_MXI_R0_MXI_S_PARE_REGISTER_IN(x))
#define HWIO_UMAC_MXI_R0_MXI_S_PARE_REGISTER_VAL_BMSK                                                       0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_S_PARE_REGISTER_VAL_SHFT                                                                0

#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_LSB_ADDR(x)                                                 ((x) + 0xac)
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_LSB_PHYS(x)                                                 ((x) + 0xac)
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_LSB_OFFS                                                    (0xac)
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_LSB_RMSK                                                    0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_LSB_POR                                                     0x00000000
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_LSB_POR_RMSK                                                0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_LSB_ATTR                                                                 0x3
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_LSB_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_LSB_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_LSB_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_LSB_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_LSB_ADDR(x),m,v,HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_LSB_IN(x))
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_LSB_BASE_ADDR_LSB_BMSK                                      0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_LSB_BASE_ADDR_LSB_SHFT                                               0

#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_MSB_ADDR(x)                                                 ((x) + 0xb0)
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_MSB_PHYS(x)                                                 ((x) + 0xb0)
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_MSB_OFFS                                                    (0xb0)
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_MSB_RMSK                                                          0xff
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_MSB_POR                                                     0x00000000
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_MSB_POR_RMSK                                                0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_MSB_ATTR                                                                 0x3
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_MSB_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_MSB_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_MSB_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_MSB_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_MSB_ADDR(x),m,v,HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_MSB_IN(x))
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_MSB_BASE_ADDR_MSB_BMSK                                            0xff
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_BASE_MSB_BASE_ADDR_MSB_SHFT                                               0

#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_LSB_ADDR(x)                                                 ((x) + 0xb4)
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_LSB_PHYS(x)                                                 ((x) + 0xb4)
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_LSB_OFFS                                                    (0xb4)
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_LSB_RMSK                                                    0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_LSB_POR                                                     0x00000000
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_LSB_POR_RMSK                                                0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_LSB_ATTR                                                                 0x3
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_LSB_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_LSB_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_LSB_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_LSB_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_LSB_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_LSB_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_LSB_ADDR(x),m,v,HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_LSB_IN(x))
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_LSB_BASE_ADDR_MASK_LSB_BMSK                                 0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_LSB_BASE_ADDR_MASK_LSB_SHFT                                          0

#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_MSB_ADDR(x)                                                 ((x) + 0xb8)
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_MSB_PHYS(x)                                                 ((x) + 0xb8)
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_MSB_OFFS                                                    (0xb8)
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_MSB_RMSK                                                    0xc00000ff
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_MSB_POR                                                     0x00000010
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_MSB_POR_RMSK                                                0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_MSB_ATTR                                                                 0x3
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_MSB_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_MSB_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_MSB_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_MSB_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_MSB_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_MSB_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_MSB_ADDR(x),m,v,HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_MSB_IN(x))
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_MSB_SS_UP_CHK_ENABLE_BMSK                                   0x80000000
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_MSB_SS_UP_CHK_ENABLE_SHFT                                           31
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_MSB_PCIE_STATE_CHK_ENABLE_BMSK                              0x40000000
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_MSB_PCIE_STATE_CHK_ENABLE_SHFT                                      30
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_MSB_BASE_ADDR_MASK_MSB_BMSK                                       0xff
#define HWIO_UMAC_MXI_R0_MXI_INTERNAL_ADDR_MASK_MSB_BASE_ADDR_MASK_MSB_SHFT                                          0

#define HWIO_UMAC_MXI_R0_WMAC_GXI_TESTBUS_LOWER_ADDR(x)                                                     ((x) + 0xbc)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_TESTBUS_LOWER_PHYS(x)                                                     ((x) + 0xbc)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_TESTBUS_LOWER_OFFS                                                        (0xbc)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_TESTBUS_LOWER_RMSK                                                        0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_TESTBUS_LOWER_POR                                                         0x00000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_TESTBUS_LOWER_POR_RMSK                                                    0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_TESTBUS_LOWER_ATTR                                                                     0x1
#define HWIO_UMAC_MXI_R0_WMAC_GXI_TESTBUS_LOWER_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_TESTBUS_LOWER_ADDR(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_TESTBUS_LOWER_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_WMAC_GXI_TESTBUS_LOWER_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_TESTBUS_LOWER_VALUE_BMSK                                                  0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_TESTBUS_LOWER_VALUE_SHFT                                                           0

#define HWIO_UMAC_MXI_R0_WMAC_GXI_TESTBUS_UPPER_ADDR(x)                                                     ((x) + 0xc0)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_TESTBUS_UPPER_PHYS(x)                                                     ((x) + 0xc0)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_TESTBUS_UPPER_OFFS                                                        (0xc0)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_TESTBUS_UPPER_RMSK                                                              0xff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_TESTBUS_UPPER_POR                                                         0x00000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_TESTBUS_UPPER_POR_RMSK                                                    0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_TESTBUS_UPPER_ATTR                                                                     0x1
#define HWIO_UMAC_MXI_R0_WMAC_GXI_TESTBUS_UPPER_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_TESTBUS_UPPER_ADDR(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_TESTBUS_UPPER_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_WMAC_GXI_TESTBUS_UPPER_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_TESTBUS_UPPER_VALUE_BMSK                                                        0xff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_TESTBUS_UPPER_VALUE_SHFT                                                           0

#define HWIO_UMAC_MXI_R0_WMAC_GXI_SM_STATES_IX_0_ADDR(x)                                                    ((x) + 0xc4)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_SM_STATES_IX_0_PHYS(x)                                                    ((x) + 0xc4)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_SM_STATES_IX_0_OFFS                                                       (0xc4)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_SM_STATES_IX_0_RMSK                                                            0xfff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_SM_STATES_IX_0_POR                                                        0x00000211
#define HWIO_UMAC_MXI_R0_WMAC_GXI_SM_STATES_IX_0_POR_RMSK                                                   0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_SM_STATES_IX_0_ATTR                                                                    0x1
#define HWIO_UMAC_MXI_R0_WMAC_GXI_SM_STATES_IX_0_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_SM_STATES_IX_0_ADDR(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_SM_STATES_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_WMAC_GXI_SM_STATES_IX_0_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_SM_STATES_IX_0_SM_STATE_RD_ADDR_BMSK                                           0xe00
#define HWIO_UMAC_MXI_R0_WMAC_GXI_SM_STATES_IX_0_SM_STATE_RD_ADDR_SHFT                                               9
#define HWIO_UMAC_MXI_R0_WMAC_GXI_SM_STATES_IX_0_SM_STATE_WR_ADDR_BMSK                                           0x1f0
#define HWIO_UMAC_MXI_R0_WMAC_GXI_SM_STATES_IX_0_SM_STATE_WR_ADDR_SHFT                                               4
#define HWIO_UMAC_MXI_R0_WMAC_GXI_SM_STATES_IX_0_SM_STATE_WR_DATA_BMSK                                             0xf
#define HWIO_UMAC_MXI_R0_WMAC_GXI_SM_STATES_IX_0_SM_STATE_WR_DATA_SHFT                                               0

#define HWIO_UMAC_MXI_R0_WMAC_GXI_END_OF_TEST_CHECK_ADDR(x)                                                 ((x) + 0xc8)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_END_OF_TEST_CHECK_PHYS(x)                                                 ((x) + 0xc8)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_END_OF_TEST_CHECK_OFFS                                                    (0xc8)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_END_OF_TEST_CHECK_RMSK                                                           0x1
#define HWIO_UMAC_MXI_R0_WMAC_GXI_END_OF_TEST_CHECK_POR                                                     0x00000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_END_OF_TEST_CHECK_POR_RMSK                                                0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_END_OF_TEST_CHECK_ATTR                                                                 0x3
#define HWIO_UMAC_MXI_R0_WMAC_GXI_END_OF_TEST_CHECK_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_END_OF_TEST_CHECK_ADDR(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_END_OF_TEST_CHECK_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_WMAC_GXI_END_OF_TEST_CHECK_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_END_OF_TEST_CHECK_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_END_OF_TEST_CHECK_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_END_OF_TEST_CHECK_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_WMAC_GXI_END_OF_TEST_CHECK_ADDR(x),m,v,HWIO_UMAC_MXI_R0_WMAC_GXI_END_OF_TEST_CHECK_IN(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_END_OF_TEST_CHECK_END_OF_TEST_SELF_CHECK_BMSK                                    0x1
#define HWIO_UMAC_MXI_R0_WMAC_GXI_END_OF_TEST_CHECK_END_OF_TEST_SELF_CHECK_SHFT                                      0

#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_ADDR(x)                                                ((x) + 0xcc)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_PHYS(x)                                                ((x) + 0xcc)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_OFFS                                                   (0xcc)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_RMSK                                                   0x80003fff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_POR                                                    0x00000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_POR_RMSK                                               0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_ATTR                                                                0x3
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_ADDR(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_ADDR(x),m,v,HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_IN(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_CLOCK_GATE_EXTEND_BMSK                                 0x80000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_CLOCK_GATE_EXTEND_SHFT                                         31
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_SPARE_BMSK                                                 0x2000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_SPARE_SHFT                                                     13
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_RD_BST_FIFO_AXI_MAS_BMSK                                   0x1000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_RD_BST_FIFO_AXI_MAS_SHFT                                       12
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_WR_BST_FIFO_AXI_MAS_BMSK                                    0x800
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_WR_BST_FIFO_AXI_MAS_SHFT                                       11
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_WDOG_CTR_BMSK                                               0x400
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_WDOG_CTR_SHFT                                                  10
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_RD_FIFO_BMSK                                                0x200
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_RD_FIFO_SHFT                                                    9
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_WR_DATA_FIFO_BMSK                                           0x100
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_WR_DATA_FIFO_SHFT                                               8
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_WR_ADDR_FIFO_BMSK                                            0x80
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_WR_ADDR_FIFO_SHFT                                               7
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_RD_AXI_MAS_BMSK                                              0x40
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_RD_AXI_MAS_SHFT                                                 6
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_WR_DATA_AXI_MAS_BMSK                                         0x20
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_WR_DATA_AXI_MAS_SHFT                                            5
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_WR_ADDR_AXI_MAS_BMSK                                         0x10
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_WR_ADDR_AXI_MAS_SHFT                                            4
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_WR_DATA_CMD_BMSK                                              0x8
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_WR_DATA_CMD_SHFT                                                3
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_WR_ADDR_CMD_BMSK                                              0x4
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_WR_ADDR_CMD_SHFT                                                2
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_RD_CMD_BMSK                                                   0x2
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_RD_CMD_SHFT                                                     1
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_CORE_BMSK                                                     0x1
#define HWIO_UMAC_MXI_R0_WMAC_GXI_CLOCK_GATE_DISABLE_CORE_SHFT                                                       0

#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_INTS_ADDR(x)                                                      ((x) + 0xd0)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_INTS_PHYS(x)                                                      ((x) + 0xd0)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_INTS_OFFS                                                         (0xd0)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_INTS_RMSK                                                         0x81011f01
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_INTS_POR                                                          0x00000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_INTS_POR_RMSK                                                     0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_INTS_ATTR                                                                      0x1
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_INTS_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_INTS_ADDR(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_INTS_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_INTS_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_INTS_GXI_WR_LAST_ERR_INT_BMSK                                     0x80000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_INTS_GXI_WR_LAST_ERR_INT_SHFT                                             31
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_INTS_GXI_AXI_WR_ERR_INT_BMSK                                       0x1000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_INTS_GXI_AXI_WR_ERR_INT_SHFT                                              24
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_INTS_GXI_AXI_RD_ERR_INT_BMSK                                         0x10000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_INTS_GXI_AXI_RD_ERR_INT_SHFT                                              16
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_INTS_GXI_RD_ZERO_ADDR_ERR_INT_BMSK                                    0x1000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_INTS_GXI_RD_ZERO_ADDR_ERR_INT_SHFT                                        12
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_INTS_GXI_RD_ZERO_SIZE_ERR_INT_BMSK                                     0x800
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_INTS_GXI_RD_ZERO_SIZE_ERR_INT_SHFT                                        11
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_INTS_GXI_WR_ZERO_ADDR_ERR_INT_BMSK                                     0x400
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_INTS_GXI_WR_ZERO_ADDR_ERR_INT_SHFT                                        10
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_INTS_GXI_WR_ZERO_SIZE_ERR_INT_BMSK                                     0x200
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_INTS_GXI_WR_ZERO_SIZE_ERR_INT_SHFT                                         9
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_INTS_GXI_WDTIMEOUT_HW_ERR_INT_BMSK                                     0x100
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_INTS_GXI_WDTIMEOUT_HW_ERR_INT_SHFT                                         8
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_INTS_GXI_WDTIMEOUT_WARN_INT_BMSK                                         0x1
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_INTS_GXI_WDTIMEOUT_WARN_INT_SHFT                                           0

#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_STATS_ADDR(x)                                                     ((x) + 0xd4)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_STATS_PHYS(x)                                                     ((x) + 0xd4)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_STATS_OFFS                                                        (0xd4)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_STATS_RMSK                                                          0xffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_STATS_POR                                                         0x00000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_STATS_POR_RMSK                                                    0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_STATS_ATTR                                                                     0x1
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_STATS_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_STATS_ADDR(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_STATS_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_STATS_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_STATS_AXI_WR_LAST_ERR_PORT_BMSK                                     0xff0000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_STATS_AXI_WR_LAST_ERR_PORT_SHFT                                           16
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_STATS_AXI_WR_ERR_PORT_BMSK                                            0xff00
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_STATS_AXI_WR_ERR_PORT_SHFT                                                 8
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_STATS_AXI_RD_ERR_PORT_BMSK                                              0xff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ERR_STATS_AXI_RD_ERR_PORT_SHFT                                                 0

#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ZERO_ERR_STATS_ADDR(x)                                                ((x) + 0xd8)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ZERO_ERR_STATS_PHYS(x)                                                ((x) + 0xd8)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ZERO_ERR_STATS_OFFS                                                   (0xd8)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ZERO_ERR_STATS_RMSK                                                   0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ZERO_ERR_STATS_POR                                                    0x00000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ZERO_ERR_STATS_POR_RMSK                                               0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ZERO_ERR_STATS_ATTR                                                                0x1
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ZERO_ERR_STATS_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ZERO_ERR_STATS_ADDR(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ZERO_ERR_STATS_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ZERO_ERR_STATS_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ZERO_ERR_STATS_RD_ZERO_ADDR_PORT_BMSK                                 0xff000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ZERO_ERR_STATS_RD_ZERO_ADDR_PORT_SHFT                                         24
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ZERO_ERR_STATS_RD_ZERO_SIZE_PORT_BMSK                                   0xff0000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ZERO_ERR_STATS_RD_ZERO_SIZE_PORT_SHFT                                         16
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ZERO_ERR_STATS_WR_ZERO_ADDR_PORT_BMSK                                     0xff00
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ZERO_ERR_STATS_WR_ZERO_ADDR_PORT_SHFT                                          8
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ZERO_ERR_STATS_WR_ZERO_SIZE_PORT_BMSK                                       0xff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_ZERO_ERR_STATS_WR_ZERO_SIZE_PORT_SHFT                                          0

#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_INTS_ADDR(x)                                              ((x) + 0xdc)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_INTS_PHYS(x)                                              ((x) + 0xdc)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_INTS_OFFS                                                 (0xdc)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_INTS_RMSK                                                  0x1010101
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_INTS_POR                                                  0x00000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_INTS_POR_RMSK                                             0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_INTS_ATTR                                                              0x1
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_INTS_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_INTS_ADDR(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_INTS_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_INTS_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_INTS_GXI_PCIE_L0_WR_ACC_ERR_BMSK                           0x1000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_INTS_GXI_PCIE_L0_WR_ACC_ERR_SHFT                                  24
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_INTS_GXI_PCIE_L0_RD_ACC_ERR_BMSK                             0x10000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_INTS_GXI_PCIE_L0_RD_ACC_ERR_SHFT                                  16
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_INTS_GXI_PCIE_L0_WR_TIMEOUT_BMSK                               0x100
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_INTS_GXI_PCIE_L0_WR_TIMEOUT_SHFT                                   8
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_INTS_GXI_PCIE_L0_RD_TIMEOUT_BMSK                                 0x1
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_INTS_GXI_PCIE_L0_RD_TIMEOUT_SHFT                                   0

#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_STATS_ADDR(x)                                             ((x) + 0xe0)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_STATS_PHYS(x)                                             ((x) + 0xe0)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_STATS_OFFS                                                (0xe0)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_STATS_RMSK                                                    0xffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_STATS_POR                                                 0x00000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_STATS_POR_RMSK                                            0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_STATS_ATTR                                                             0x1
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_STATS_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_STATS_ADDR(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_STATS_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_STATS_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_STATS_AXI_WR_PCIE_L0_ACC_ERR_PORT_BMSK                        0xff00
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_STATS_AXI_WR_PCIE_L0_ACC_ERR_PORT_SHFT                             8
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_STATS_AXI_RD_PCIE_L0_ACC_ERR_PORT_BMSK                          0xff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_EXT_ACC_ERR_STATS_AXI_RD_PCIE_L0_ACC_ERR_PORT_SHFT                             0

#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_DEFAULT_CONTROL_ADDR(x)                                               ((x) + 0xe4)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_DEFAULT_CONTROL_PHYS(x)                                               ((x) + 0xe4)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_DEFAULT_CONTROL_OFFS                                                  (0xe4)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_DEFAULT_CONTROL_RMSK                                                  0xffff3f3f
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_DEFAULT_CONTROL_POR                                                   0x00000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_DEFAULT_CONTROL_POR_RMSK                                              0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_DEFAULT_CONTROL_ATTR                                                               0x3
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_DEFAULT_CONTROL_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_DEFAULT_CONTROL_ADDR(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_DEFAULT_CONTROL_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_DEFAULT_CONTROL_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_DEFAULT_CONTROL_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_DEFAULT_CONTROL_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_DEFAULT_CONTROL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_DEFAULT_CONTROL_ADDR(x),m,v,HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_DEFAULT_CONTROL_IN(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_DEFAULT_CONTROL_GXI_DEFAULT_MAX_PENDING_READ_DATA_BMSK                0xff000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_DEFAULT_CONTROL_GXI_DEFAULT_MAX_PENDING_READ_DATA_SHFT                        24
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_DEFAULT_CONTROL_GXI_DEFAULT_MAX_PENDING_WRITE_DATA_BMSK                 0xff0000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_DEFAULT_CONTROL_GXI_DEFAULT_MAX_PENDING_WRITE_DATA_SHFT                       16
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_DEFAULT_CONTROL_GXI_DEFAULT_MAX_PENDING_READS_BMSK                        0x3f00
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_DEFAULT_CONTROL_GXI_DEFAULT_MAX_PENDING_READS_SHFT                             8
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_DEFAULT_CONTROL_GXI_DEFAULT_MAX_PENDING_WRITES_BMSK                         0x3f
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_DEFAULT_CONTROL_GXI_DEFAULT_MAX_PENDING_WRITES_SHFT                            0

#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_REDUCED_CONTROL_ADDR(x)                                               ((x) + 0xe8)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_REDUCED_CONTROL_PHYS(x)                                               ((x) + 0xe8)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_REDUCED_CONTROL_OFFS                                                  (0xe8)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_REDUCED_CONTROL_RMSK                                                  0xffff3f3f
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_REDUCED_CONTROL_POR                                                   0x00000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_REDUCED_CONTROL_POR_RMSK                                              0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_REDUCED_CONTROL_ATTR                                                               0x3
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_REDUCED_CONTROL_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_REDUCED_CONTROL_ADDR(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_REDUCED_CONTROL_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_REDUCED_CONTROL_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_REDUCED_CONTROL_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_REDUCED_CONTROL_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_REDUCED_CONTROL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_REDUCED_CONTROL_ADDR(x),m,v,HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_REDUCED_CONTROL_IN(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_REDUCED_CONTROL_GXI_REDUCED_MAX_PENDING_READ_DATA_BMSK                0xff000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_REDUCED_CONTROL_GXI_REDUCED_MAX_PENDING_READ_DATA_SHFT                        24
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_REDUCED_CONTROL_GXI_REDUCED_MAX_PENDING_WRITE_DATA_BMSK                 0xff0000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_REDUCED_CONTROL_GXI_REDUCED_MAX_PENDING_WRITE_DATA_SHFT                       16
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_REDUCED_CONTROL_GXI_REDUCED_MAX_PENDING_READS_BMSK                        0x3f00
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_REDUCED_CONTROL_GXI_REDUCED_MAX_PENDING_READS_SHFT                             8
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_REDUCED_CONTROL_GXI_REDUCED_MAX_PENDING_WRITES_BMSK                         0x3f
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_REDUCED_CONTROL_GXI_REDUCED_MAX_PENDING_WRITES_SHFT                            0

#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_0_ADDR(x)                                             ((x) + 0xec)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_0_PHYS(x)                                             ((x) + 0xec)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_0_OFFS                                                (0xec)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_0_RMSK                                                0xefffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_0_POR                                                 0x46000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_0_POR_RMSK                                            0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_0_ATTR                                                             0x3
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_0_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_0_ADDR(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_0_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_0_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_0_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_0_ADDR(x),m,v,HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_0_IN(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_0_GXI_READ_BURST_SIZE_INT_BMSK                        0xe0000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_0_GXI_READ_BURST_SIZE_INT_SHFT                                29
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_0_GXI_READ_BURST_SIZE_EXT_BMSK                         0xe000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_0_GXI_READ_BURST_SIZE_EXT_SHFT                                25
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_0_GXI_READ_ISSUE_THRESHOLD_BMSK                        0x1ffe000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_0_GXI_READ_ISSUE_THRESHOLD_SHFT                               13
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_0_GXI_WRITE_PREFETCH_THRESHOLD_BMSK                       0x1ffe
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_0_GXI_WRITE_PREFETCH_THRESHOLD_SHFT                            1
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_0_GXI_CLEAR_STATS_BMSK                                       0x1
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_0_GXI_CLEAR_STATS_SHFT                                         0

#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_ADDR(x)                                             ((x) + 0xf0)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_PHYS(x)                                             ((x) + 0xf0)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_OFFS                                                (0xf0)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_RMSK                                                0xc00007ff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_POR                                                 0x00000013
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_POR_RMSK                                            0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_ATTR                                                             0x3
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_ADDR(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_ADDR(x),m,v,HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_IN(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_BURST_SIZE_SEL_ENABLE_BMSK                          0x80000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_BURST_SIZE_SEL_ENABLE_SHFT                                  31
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_BURST_SPLIT_DISABLE_BMSK                            0x40000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_BURST_SPLIT_DISABLE_SHFT                                    30
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_GXI_DELAYED_RD_FLUSH_BMSK                                0x400
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_GXI_DELAYED_RD_FLUSH_SHFT                                   10
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_GXI_DELAYED_WR_FLUSH_BMSK                                0x200
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_GXI_DELAYED_WR_FLUSH_SHFT                                    9
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_GXI_DISABLE_WR_PREFIL_BMSK                               0x100
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_GXI_DISABLE_WR_PREFIL_SHFT                                   8
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_GXI_MAX_WR_BOUNDARY_SPLIT_BMSK                            0x80
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_GXI_MAX_WR_BOUNDARY_SPLIT_SHFT                               7
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_GXI_MAX_RD_BOUNDARY_SPLIT_BMSK                            0x40
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_GXI_MAX_RD_BOUNDARY_SPLIT_SHFT                               6
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_GXI_WRITE_BURST_SIZE_INT_BMSK                             0x38
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_GXI_WRITE_BURST_SIZE_INT_SHFT                                3
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_GXI_WRITE_BURST_SIZE_EXT_BMSK                              0x7
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_MISC_CONTROL_IX_1_GXI_WRITE_BURST_SIZE_EXT_SHFT                                0

#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_CONTROL_ADDR(x)                                             ((x) + 0xf4)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_CONTROL_PHYS(x)                                             ((x) + 0xf4)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_CONTROL_OFFS                                                (0xf4)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_CONTROL_RMSK                                                0xffff0001
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_CONTROL_POR                                                 0x00ff0000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_CONTROL_POR_RMSK                                            0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_CONTROL_ATTR                                                             0x3
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_CONTROL_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_CONTROL_ADDR(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_CONTROL_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_CONTROL_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_CONTROL_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_CONTROL_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_CONTROL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_CONTROL_ADDR(x),m,v,HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_CONTROL_IN(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_CONTROL_GXI_WDOG_WARN_LIMIT_BMSK                            0xffff0000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_CONTROL_GXI_WDOG_WARN_LIMIT_SHFT                                    16
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_CONTROL_GXI_WDOG_WARN_DISABLE_BMSK                                 0x1
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_CONTROL_GXI_WDOG_WARN_DISABLE_SHFT                                   0

#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_STATUS_ADDR(x)                                              ((x) + 0xf8)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_STATUS_PHYS(x)                                              ((x) + 0xf8)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_STATUS_OFFS                                                 (0xf8)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_STATUS_RMSK                                                     0xffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_STATUS_POR                                                  0x00000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_STATUS_POR_RMSK                                             0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_STATUS_ATTR                                                              0x1
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_STATUS_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_STATUS_ADDR(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_STATUS_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_STATUS_GXI_WDOG_WARN_STATUS_BMSK                                0xffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_WARN_STATUS_GXI_WDOG_WARN_STATUS_SHFT                                     0

#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_IDLE_COUNTERS_ADDR(x)                                                 ((x) + 0xfc)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_IDLE_COUNTERS_PHYS(x)                                                 ((x) + 0xfc)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_IDLE_COUNTERS_OFFS                                                    (0xfc)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_IDLE_COUNTERS_RMSK                                                    0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_IDLE_COUNTERS_POR                                                     0x00000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_IDLE_COUNTERS_POR_RMSK                                                0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_IDLE_COUNTERS_ATTR                                                                 0x1
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_IDLE_COUNTERS_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_IDLE_COUNTERS_ADDR(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_IDLE_COUNTERS_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_IDLE_COUNTERS_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_IDLE_COUNTERS_GXI_READ_IDLE_CNT_BMSK                                  0xffff0000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_IDLE_COUNTERS_GXI_READ_IDLE_CNT_SHFT                                          16
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_IDLE_COUNTERS_GXI_WRITE_IDLE_CNT_BMSK                                     0xffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_IDLE_COUNTERS_GXI_WRITE_IDLE_CNT_SHFT                                          0

#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_CONTROL_ADDR(x)                                           ((x) + 0x100)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_CONTROL_PHYS(x)                                           ((x) + 0x100)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_CONTROL_OFFS                                              (0x100)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_CONTROL_RMSK                                              0xffff0001
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_CONTROL_POR                                               0x00ff0000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_CONTROL_POR_RMSK                                          0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_CONTROL_ATTR                                                           0x3
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_CONTROL_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_CONTROL_ADDR(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_CONTROL_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_CONTROL_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_CONTROL_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_CONTROL_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_CONTROL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_CONTROL_ADDR(x),m,v,HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_CONTROL_IN(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_CONTROL_GXI_WDOG_HW_ERR_LIMIT_BMSK                        0xffff0000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_CONTROL_GXI_WDOG_HW_ERR_LIMIT_SHFT                                16
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_CONTROL_GXI_WDOG_HW_ERR_DISABLE_BMSK                             0x1
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_CONTROL_GXI_WDOG_HW_ERR_DISABLE_SHFT                               0

#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_STATUS_ADDR(x)                                            ((x) + 0x104)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_STATUS_PHYS(x)                                            ((x) + 0x104)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_STATUS_OFFS                                               (0x104)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_STATUS_RMSK                                                   0xffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_STATUS_POR                                                0x00000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_STATUS_POR_RMSK                                           0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_STATUS_ATTR                                                            0x1
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_STATUS_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_STATUS_ADDR(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_STATUS_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_STATUS_GXI_WDOG_HW_ERR_STATUS_BMSK                            0xffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WDOG_HW_ERR_STATUS_GXI_WDOG_HW_ERR_STATUS_SHFT                                 0

#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_LATENCY_CTRL_ADDR(x)                                               ((x) + 0x108)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_LATENCY_CTRL_PHYS(x)                                               ((x) + 0x108)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_LATENCY_CTRL_OFFS                                                  (0x108)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_LATENCY_CTRL_RMSK                                                     0xfffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_LATENCY_CTRL_POR                                                   0x00000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_LATENCY_CTRL_POR_RMSK                                              0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_LATENCY_CTRL_ATTR                                                               0x3
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_LATENCY_CTRL_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_LATENCY_CTRL_ADDR(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_LATENCY_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_LATENCY_CTRL_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_LATENCY_CTRL_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_LATENCY_CTRL_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_LATENCY_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_LATENCY_CTRL_ADDR(x),m,v,HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_LATENCY_CTRL_IN(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_LATENCY_CTRL_AXI_LATENCY_RANGE_BMSK                                   0xe0000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_LATENCY_CTRL_AXI_LATENCY_RANGE_SHFT                                        17
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_LATENCY_CTRL_AXI_LATENCY_EN_BMSK                                      0x10000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_LATENCY_CTRL_AXI_LATENCY_EN_SHFT                                           16
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_LATENCY_CTRL_AXI_LATENCY_MIN_BMSK                                      0xffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_LATENCY_CTRL_AXI_LATENCY_MIN_SHFT                                           0

#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_LATENCY_CTRL_ADDR(x)                                               ((x) + 0x10c)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_LATENCY_CTRL_PHYS(x)                                               ((x) + 0x10c)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_LATENCY_CTRL_OFFS                                                  (0x10c)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_LATENCY_CTRL_RMSK                                                     0xfffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_LATENCY_CTRL_POR                                                   0x00000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_LATENCY_CTRL_POR_RMSK                                              0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_LATENCY_CTRL_ATTR                                                               0x3
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_LATENCY_CTRL_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_LATENCY_CTRL_ADDR(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_LATENCY_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_LATENCY_CTRL_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_LATENCY_CTRL_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_LATENCY_CTRL_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_LATENCY_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_LATENCY_CTRL_ADDR(x),m,v,HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_LATENCY_CTRL_IN(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_LATENCY_CTRL_AXI_LATENCY_RANGE_BMSK                                   0xe0000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_LATENCY_CTRL_AXI_LATENCY_RANGE_SHFT                                        17
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_LATENCY_CTRL_AXI_LATENCY_EN_BMSK                                      0x10000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_LATENCY_CTRL_AXI_LATENCY_EN_SHFT                                           16
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_LATENCY_CTRL_AXI_LATENCY_MIN_BMSK                                      0xffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_LATENCY_CTRL_AXI_LATENCY_MIN_SHFT                                           0

#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_0_ADDR(x)                                     ((x) + 0x110)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_0_PHYS(x)                                     ((x) + 0x110)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_0_OFFS                                        (0x110)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_0_RMSK                                        0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_0_POR                                         0x00000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_0_POR_RMSK                                    0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_0_ATTR                                                     0x3
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_0_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_0_ADDR(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_0_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_0_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_0_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_0_ADDR(x),m,v,HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_0_IN(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_0_VALUE_BMSK                                  0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_0_VALUE_SHFT                                           0

#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_0_ADDR(x)                                     ((x) + 0x114)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_0_PHYS(x)                                     ((x) + 0x114)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_0_OFFS                                        (0x114)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_0_RMSK                                        0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_0_POR                                         0x00000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_0_POR_RMSK                                    0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_0_ATTR                                                     0x3
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_0_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_0_ADDR(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_0_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_0_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_0_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_0_ADDR(x),m,v,HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_0_IN(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_0_VALUE_BMSK                                  0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_0_VALUE_SHFT                                           0

#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_1_ADDR(x)                                     ((x) + 0x118)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_1_PHYS(x)                                     ((x) + 0x118)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_1_OFFS                                        (0x118)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_1_RMSK                                        0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_1_POR                                         0x00000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_1_POR_RMSK                                    0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_1_ATTR                                                     0x3
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_1_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_1_ADDR(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_1_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_1_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_1_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_1_ADDR(x),m,v,HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_1_IN(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_1_VALUE_BMSK                                  0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_WR_ERR_STALL_DISABLE_IX_1_VALUE_SHFT                                           0

#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_1_ADDR(x)                                     ((x) + 0x11c)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_1_PHYS(x)                                     ((x) + 0x11c)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_1_OFFS                                        (0x11c)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_1_RMSK                                        0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_1_POR                                         0x00000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_1_POR_RMSK                                    0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_1_ATTR                                                     0x3
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_1_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_1_ADDR(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_1_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_1_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_1_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_1_ADDR(x),m,v,HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_1_IN(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_1_VALUE_BMSK                                  0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_RD_ERR_STALL_DISABLE_IX_1_VALUE_SHFT                                           0

#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_AXI_OUTSANDING_CTL_ADDR(x)                                            ((x) + 0x120)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_AXI_OUTSANDING_CTL_PHYS(x)                                            ((x) + 0x120)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_AXI_OUTSANDING_CTL_OFFS                                               (0x120)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_AXI_OUTSANDING_CTL_RMSK                                                   0xbfbf
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_AXI_OUTSANDING_CTL_POR                                                0x00000000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_AXI_OUTSANDING_CTL_POR_RMSK                                           0xffffffff
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_AXI_OUTSANDING_CTL_ATTR                                                            0x3
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_AXI_OUTSANDING_CTL_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_AXI_OUTSANDING_CTL_ADDR(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_AXI_OUTSANDING_CTL_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_AXI_OUTSANDING_CTL_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_AXI_OUTSANDING_CTL_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_AXI_OUTSANDING_CTL_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_AXI_OUTSANDING_CTL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_AXI_OUTSANDING_CTL_ADDR(x),m,v,HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_AXI_OUTSANDING_CTL_IN(x))
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_AXI_OUTSANDING_CTL_WR_OVR_EN_BMSK                                         0x8000
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_AXI_OUTSANDING_CTL_WR_OVR_EN_SHFT                                             15
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_AXI_OUTSANDING_CTL_WR_OVR_CNT_BMSK                                        0x3f00
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_AXI_OUTSANDING_CTL_WR_OVR_CNT_SHFT                                             8
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_AXI_OUTSANDING_CTL_RD_OVR_EN_BMSK                                           0x80
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_AXI_OUTSANDING_CTL_RD_OVR_EN_SHFT                                              7
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_AXI_OUTSANDING_CTL_RD_OVR_CNT_BMSK                                          0x3f
#define HWIO_UMAC_MXI_R0_WMAC_GXI_GXI_AXI_OUTSANDING_CTL_RD_OVR_CNT_SHFT                                             0

#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_CTL_ADDR(x)                                                       ((x) + 0x124)
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_CTL_PHYS(x)                                                       ((x) + 0x124)
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_CTL_OFFS                                                          (0x124)
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_CTL_RMSK                                                              0xbfbf
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_CTL_POR                                                           0x00000000
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_CTL_POR_RMSK                                                      0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_CTL_ATTR                                                                       0x3
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_CTL_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_CTL_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_CTL_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_CTL_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_CTL_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_CTL_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_CTL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_CTL_ADDR(x),m,v,HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_CTL_IN(x))
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_CTL_WR_CMD_FIFO_DBG_EN_BMSK                                           0x8000
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_CTL_WR_CMD_FIFO_DBG_EN_SHFT                                               15
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_CTL_WR_CMD_FIFO_ADDR_BMSK                                             0x3f00
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_CTL_WR_CMD_FIFO_ADDR_SHFT                                                  8
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_CTL_RD_CMD_FIFO_DBG_EN_BMSK                                             0x80
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_CTL_RD_CMD_FIFO_DBG_EN_SHFT                                                7
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_CTL_RD_CMD_FIFO_ADDR_BMSK                                               0x3f
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_CTL_RD_CMD_FIFO_ADDR_SHFT                                                  0

#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_STS_ADDR(x)                                                       ((x) + 0x128)
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_STS_PHYS(x)                                                       ((x) + 0x128)
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_STS_OFFS                                                          (0x128)
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_STS_RMSK                                                          0x3f3f3f3f
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_STS_POR                                                           0x00000000
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_STS_POR_RMSK                                                      0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_STS_ATTR                                                                       0x1
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_STS_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_STS_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_STS_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_STS_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_STS_WR_CMD_FIFO_WR_PTR_BMSK                                       0x3f000000
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_STS_WR_CMD_FIFO_WR_PTR_SHFT                                               24
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_STS_WR_CMD_FIFO_RD_PTR_BMSK                                         0x3f0000
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_STS_WR_CMD_FIFO_RD_PTR_SHFT                                               16
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_STS_RD_CMD_FIFO_WR_PTR_BMSK                                           0x3f00
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_STS_RD_CMD_FIFO_WR_PTR_SHFT                                                8
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_STS_RD_CMD_FIFO_RD_PTR_BMSK                                             0x3f
#define HWIO_UMAC_MXI_R0_MXI_CMD_FIFO_DBG_STS_RD_CMD_FIFO_RD_PTR_SHFT                                                0

#define HWIO_UMAC_MXI_R0_MXI_CMD_RD_CMD_DBG_LO_ADDR(x)                                                      ((x) + 0x12c)
#define HWIO_UMAC_MXI_R0_MXI_CMD_RD_CMD_DBG_LO_PHYS(x)                                                      ((x) + 0x12c)
#define HWIO_UMAC_MXI_R0_MXI_CMD_RD_CMD_DBG_LO_OFFS                                                         (0x12c)
#define HWIO_UMAC_MXI_R0_MXI_CMD_RD_CMD_DBG_LO_RMSK                                                         0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_CMD_RD_CMD_DBG_LO_POR                                                          0x00000000
#define HWIO_UMAC_MXI_R0_MXI_CMD_RD_CMD_DBG_LO_POR_RMSK                                                     0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_CMD_RD_CMD_DBG_LO_ATTR                                                                      0x1
#define HWIO_UMAC_MXI_R0_MXI_CMD_RD_CMD_DBG_LO_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_CMD_RD_CMD_DBG_LO_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_CMD_RD_CMD_DBG_LO_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_CMD_RD_CMD_DBG_LO_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_CMD_RD_CMD_DBG_LO_VALUE_BMSK                                                   0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_CMD_RD_CMD_DBG_LO_VALUE_SHFT                                                            0

#define HWIO_UMAC_MXI_R0_MXI_CMD_RD_CMD_DBG_HI_ADDR(x)                                                      ((x) + 0x130)
#define HWIO_UMAC_MXI_R0_MXI_CMD_RD_CMD_DBG_HI_PHYS(x)                                                      ((x) + 0x130)
#define HWIO_UMAC_MXI_R0_MXI_CMD_RD_CMD_DBG_HI_OFFS                                                         (0x130)
#define HWIO_UMAC_MXI_R0_MXI_CMD_RD_CMD_DBG_HI_RMSK                                                         0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_CMD_RD_CMD_DBG_HI_POR                                                          0x00000000
#define HWIO_UMAC_MXI_R0_MXI_CMD_RD_CMD_DBG_HI_POR_RMSK                                                     0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_CMD_RD_CMD_DBG_HI_ATTR                                                                      0x1
#define HWIO_UMAC_MXI_R0_MXI_CMD_RD_CMD_DBG_HI_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_CMD_RD_CMD_DBG_HI_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_CMD_RD_CMD_DBG_HI_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_CMD_RD_CMD_DBG_HI_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_CMD_RD_CMD_DBG_HI_VALUE_BMSK                                                   0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_CMD_RD_CMD_DBG_HI_VALUE_SHFT                                                            0

#define HWIO_UMAC_MXI_R0_MXI_CMD_WR_CMD_DBG_LO_ADDR(x)                                                      ((x) + 0x134)
#define HWIO_UMAC_MXI_R0_MXI_CMD_WR_CMD_DBG_LO_PHYS(x)                                                      ((x) + 0x134)
#define HWIO_UMAC_MXI_R0_MXI_CMD_WR_CMD_DBG_LO_OFFS                                                         (0x134)
#define HWIO_UMAC_MXI_R0_MXI_CMD_WR_CMD_DBG_LO_RMSK                                                         0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_CMD_WR_CMD_DBG_LO_POR                                                          0x00000000
#define HWIO_UMAC_MXI_R0_MXI_CMD_WR_CMD_DBG_LO_POR_RMSK                                                     0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_CMD_WR_CMD_DBG_LO_ATTR                                                                      0x1
#define HWIO_UMAC_MXI_R0_MXI_CMD_WR_CMD_DBG_LO_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_CMD_WR_CMD_DBG_LO_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_CMD_WR_CMD_DBG_LO_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_CMD_WR_CMD_DBG_LO_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_CMD_WR_CMD_DBG_LO_VALUE_BMSK                                                   0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_CMD_WR_CMD_DBG_LO_VALUE_SHFT                                                            0

#define HWIO_UMAC_MXI_R0_MXI_CMD_WR_CMD_DBG_HI_ADDR(x)                                                      ((x) + 0x138)
#define HWIO_UMAC_MXI_R0_MXI_CMD_WR_CMD_DBG_HI_PHYS(x)                                                      ((x) + 0x138)
#define HWIO_UMAC_MXI_R0_MXI_CMD_WR_CMD_DBG_HI_OFFS                                                         (0x138)
#define HWIO_UMAC_MXI_R0_MXI_CMD_WR_CMD_DBG_HI_RMSK                                                         0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_CMD_WR_CMD_DBG_HI_POR                                                          0x00000000
#define HWIO_UMAC_MXI_R0_MXI_CMD_WR_CMD_DBG_HI_POR_RMSK                                                     0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_CMD_WR_CMD_DBG_HI_ATTR                                                                      0x1
#define HWIO_UMAC_MXI_R0_MXI_CMD_WR_CMD_DBG_HI_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_CMD_WR_CMD_DBG_HI_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_CMD_WR_CMD_DBG_HI_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_CMD_WR_CMD_DBG_HI_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_CMD_WR_CMD_DBG_HI_VALUE_BMSK                                                   0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_CMD_WR_CMD_DBG_HI_VALUE_SHFT                                                            0

#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_LSB_ADDR(x)                                                       ((x) + 0x13c)
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_LSB_PHYS(x)                                                       ((x) + 0x13c)
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_LSB_OFFS                                                          (0x13c)
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_LSB_RMSK                                                          0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_LSB_POR                                                           0xff000000
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_LSB_ATTR                                                                       0x3
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_LSB_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_LSB_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_LSB_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_LSB_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_LSB_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_LSB_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_LSB_ADDR(x),m,v,HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_LSB_IN(x))
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_LSB_REG_SS_ADDR_MASK_LSB_BMSK                                     0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_LSB_REG_SS_ADDR_MASK_LSB_SHFT                                              0

#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_MSB_ADDR(x)                                                       ((x) + 0x140)
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_MSB_PHYS(x)                                                       ((x) + 0x140)
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_MSB_OFFS                                                          (0x140)
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_MSB_RMSK                                                                0xff
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_MSB_POR                                                           0x0000007f
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_MSB_ATTR                                                                       0x3
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_MSB_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_MSB_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_MSB_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_MSB_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_MSB_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_MSB_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_MSB_ADDR(x),m,v,HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_MSB_IN(x))
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_MSB_REG_SS_ADDR_MASK_MSB_BMSK                                           0xff
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_MASK_MSB_REG_SS_ADDR_MASK_MSB_SHFT                                              0

#define HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_LSB_ADDR(x)                                                   ((x) + 0x144)
#define HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_LSB_PHYS(x)                                                   ((x) + 0x144)
#define HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_LSB_OFFS                                                      (0x144)
#define HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_LSB_RMSK                                                      0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_LSB_POR                                                       0x00000000
#define HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_LSB_POR_RMSK                                                  0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_LSB_ATTR                                                                   0x3
#define HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_LSB_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_LSB_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_LSB_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_LSB_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_LSB_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_LSB_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_LSB_ADDR(x),m,v,HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_LSB_IN(x))
#define HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_LSB_REG_INT_ADDR_MASK_LSB_BMSK                                0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_LSB_REG_INT_ADDR_MASK_LSB_SHFT                                         0

#define HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_MSB_ADDR(x)                                                   ((x) + 0x148)
#define HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_MSB_PHYS(x)                                                   ((x) + 0x148)
#define HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_MSB_OFFS                                                      (0x148)
#define HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_MSB_RMSK                                                            0xff
#define HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_MSB_POR                                                       0x00000010
#define HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_MSB_POR_RMSK                                                  0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_MSB_ATTR                                                                   0x3
#define HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_MSB_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_MSB_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_MSB_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_MSB_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_MSB_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_MSB_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_MSB_ADDR(x),m,v,HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_MSB_IN(x))
#define HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_MSB_REG_INT_ADDR_MASK_MSB_BMSK                                      0xff
#define HWIO_UMAC_MXI_R0_MXI_SS_INT_ADDR_MASK_MSB_REG_INT_ADDR_MASK_MSB_SHFT                                         0

#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_LSB_ADDR(x)                                                      ((x) + 0x14c)
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_LSB_PHYS(x)                                                      ((x) + 0x14c)
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_LSB_OFFS                                                         (0x14c)
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_LSB_RMSK                                                         0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_LSB_POR                                                          0x00b80000
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_LSB_ATTR                                                                      0x3
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_LSB_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_LSB_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_LSB_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_LSB_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_LSB_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_LSB_ADDR(x),m,v,HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_LSB_IN(x))
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_LSB_REG_SS_ADDR_RANGE_LSB_BMSK                                   0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_LSB_REG_SS_ADDR_RANGE_LSB_SHFT                                            0

#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_MSB_ADDR(x)                                                      ((x) + 0x150)
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_MSB_PHYS(x)                                                      ((x) + 0x150)
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_MSB_OFFS                                                         (0x150)
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_MSB_RMSK                                                               0xff
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_MSB_POR                                                          0x00000010
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_MSB_ATTR                                                                      0x3
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_MSB_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_MSB_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_MSB_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_MSB_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_MSB_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_MSB_ADDR(x),m,v,HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_MSB_IN(x))
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_MSB_REG_SS_ADDR_RANGE_MSB_BMSK                                         0xff
#define HWIO_UMAC_MXI_R0_MXI_SS_ADDR_RANGE_MSB_REG_SS_ADDR_RANGE_MSB_SHFT                                            0

#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_ADDR(x)                                                         ((x) + 0x154)
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_PHYS(x)                                                         ((x) + 0x154)
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_OFFS                                                            (0x154)
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_RMSK                                                            0xff13ff13
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_POR                                                             0x00000000
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_POR_RMSK                                                        0xffffffff
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_ATTR                                                                         0x3
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_ADDR(x))
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_ADDR(x),m,v,HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_IN(x))
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_DATA_ADDR_PORT_ID_BMSK                                          0xff000000
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_DATA_ADDR_PORT_ID_SHFT                                                  24
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_DATA_ADDR_ERR_INJ_DONE_BMSK                                       0x100000
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_DATA_ADDR_ERR_INJ_DONE_SHFT                                             20
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_DATA_ADDR_PORT_CHK_EN_BMSK                                         0x20000
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_DATA_ADDR_PORT_CHK_EN_SHFT                                              17
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_DATA_ADDR_INJ_ENABLE_BMSK                                          0x10000
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_DATA_ADDR_INJ_ENABLE_SHFT                                               16
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_ADDR_PORT_ID_BMSK                                                   0xff00
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_ADDR_PORT_ID_SHFT                                                        8
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_ADDR_ERR_INJ_DONE_BMSK                                                0x10
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_ADDR_ERR_INJ_DONE_SHFT                                                   4
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_ADDR_PORT_CHK_EN_BMSK                                                  0x2
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_ADDR_PORT_CHK_EN_SHFT                                                    1
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_ADDR_INJ_ENABLE_BMSK                                                   0x1
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_CFG_ADDR_INJ_ENABLE_SHFT                                                     0

#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_ADDR(x)                                                         ((x) + 0x158)
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_PHYS(x)                                                         ((x) + 0x158)
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_OFFS                                                            (0x158)
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_RMSK                                                            0xff07ff07
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_POR                                                             0x00000000
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_POR_RMSK                                                        0xffffffff
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_ATTR                                                                         0x3
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_ADDR(x))
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_ADDR(x),m,v,HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_IN(x))
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_DATA_ADDR_PORT_ID_BMSK                                          0xff000000
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_DATA_ADDR_PORT_ID_SHFT                                                  24
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_DATA_ADDR_ERR_INJ_DONE_BMSK                                        0x40000
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_DATA_ADDR_ERR_INJ_DONE_SHFT                                             18
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_DATA_ADDR_PORT_CHK_EN_BMSK                                         0x20000
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_DATA_ADDR_PORT_CHK_EN_SHFT                                              17
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_DATA_ADDR_INJ_ENABLE_BMSK                                          0x10000
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_DATA_ADDR_INJ_ENABLE_SHFT                                               16
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_ADDR_PORT_ID_BMSK                                                   0xff00
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_ADDR_PORT_ID_SHFT                                                        8
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_ADDR_ERR_INJ_DONE_BMSK                                                 0x4
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_ADDR_ERR_INJ_DONE_SHFT                                                   2
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_ADDR_PORT_CHK_EN_BMSK                                                  0x2
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_ADDR_PORT_CHK_EN_SHFT                                                    1
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_ADDR_INJ_ENABLE_BMSK                                                   0x1
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_CFG_ADDR_INJ_ENABLE_SHFT                                                     0

#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_0_ADDR(x)                                                   ((x) + 0x15c)
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_0_PHYS(x)                                                   ((x) + 0x15c)
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_0_OFFS                                                      (0x15c)
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_0_RMSK                                                      0xffffffff
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_0_POR                                                       0x00000000
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_0_POR_RMSK                                                  0xffffffff
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_0_ATTR                                                                   0x3
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_0_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_0_ADDR(x))
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_0_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_0_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_0_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_0_ADDR(x),m,v,HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_0_IN(x))
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_0_ERR_ADDR_LSB_BMSK                                         0xffffffff
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_0_ERR_ADDR_LSB_SHFT                                                  0

#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_1_ADDR(x)                                                   ((x) + 0x160)
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_1_PHYS(x)                                                   ((x) + 0x160)
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_1_OFFS                                                      (0x160)
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_1_RMSK                                                            0xff
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_1_POR                                                       0x00000000
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_1_POR_RMSK                                                  0xffffffff
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_1_ATTR                                                                   0x3
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_1_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_1_ADDR(x))
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_1_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_1_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_1_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_1_ADDR(x),m,v,HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_1_IN(x))
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_1_ERR_ADDR_MSB_BMSK                                               0xff
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_ADDR_IX_1_ERR_ADDR_MSB_SHFT                                                  0

#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_0_ADDR(x)                                                   ((x) + 0x164)
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_0_PHYS(x)                                                   ((x) + 0x164)
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_0_OFFS                                                      (0x164)
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_0_RMSK                                                      0xffffffff
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_0_POR                                                       0x00000000
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_0_POR_RMSK                                                  0xffffffff
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_0_ATTR                                                                   0x3
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_0_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_0_ADDR(x))
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_0_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_0_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_0_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_0_ADDR(x),m,v,HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_0_IN(x))
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_0_ERR_DATA_LSB_BMSK                                         0xffffffff
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_0_ERR_DATA_LSB_SHFT                                                  0

#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_1_ADDR(x)                                                   ((x) + 0x168)
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_1_PHYS(x)                                                   ((x) + 0x168)
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_1_OFFS                                                      (0x168)
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_1_RMSK                                                      0xffffffff
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_1_POR                                                       0x00000000
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_1_POR_RMSK                                                  0xffffffff
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_1_ATTR                                                                   0x3
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_1_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_1_ADDR(x))
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_1_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_1_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_1_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_1_ADDR(x),m,v,HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_1_IN(x))
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_1_ERR_DATA_MSB_BMSK                                         0xffffffff
#define HWIO_UMAC_MXI_R0_GXI_WR_ERR_INJ_DATA_IX_1_ERR_DATA_MSB_SHFT                                                  0

#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_0_ADDR(x)                                                   ((x) + 0x16c)
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_0_PHYS(x)                                                   ((x) + 0x16c)
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_0_OFFS                                                      (0x16c)
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_0_RMSK                                                      0xffffffff
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_0_POR                                                       0x00000000
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_0_POR_RMSK                                                  0xffffffff
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_0_ATTR                                                                   0x3
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_0_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_0_ADDR(x))
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_0_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_0_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_0_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_0_ADDR(x),m,v,HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_0_IN(x))
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_0_ERR_ADDR_LSB_BMSK                                         0xffffffff
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_0_ERR_ADDR_LSB_SHFT                                                  0

#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_1_ADDR(x)                                                   ((x) + 0x170)
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_1_PHYS(x)                                                   ((x) + 0x170)
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_1_OFFS                                                      (0x170)
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_1_RMSK                                                            0xff
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_1_POR                                                       0x00000000
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_1_POR_RMSK                                                  0xffffffff
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_1_ATTR                                                                   0x3
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_1_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_1_ADDR(x))
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_1_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_1_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_1_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_1_ADDR(x),m,v,HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_1_IN(x))
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_1_ERR_ADDR_MSB_BMSK                                               0xff
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_ADDR_IX_1_ERR_ADDR_MSB_SHFT                                                  0

#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_0_ADDR(x)                                                   ((x) + 0x174)
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_0_PHYS(x)                                                   ((x) + 0x174)
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_0_OFFS                                                      (0x174)
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_0_RMSK                                                      0xffffffff
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_0_POR                                                       0x00000000
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_0_POR_RMSK                                                  0xffffffff
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_0_ATTR                                                                   0x3
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_0_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_0_ADDR(x))
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_0_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_0_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_0_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_0_ADDR(x),m,v,HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_0_IN(x))
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_0_ERR_DATA_LSB_BMSK                                         0xffffffff
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_0_ERR_DATA_LSB_SHFT                                                  0

#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_1_ADDR(x)                                                   ((x) + 0x178)
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_1_PHYS(x)                                                   ((x) + 0x178)
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_1_OFFS                                                      (0x178)
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_1_RMSK                                                      0xffffffff
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_1_POR                                                       0x00000000
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_1_POR_RMSK                                                  0xffffffff
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_1_ATTR                                                                   0x3
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_1_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_1_ADDR(x))
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_1_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_1_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_1_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_1_ADDR(x),m,v,HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_1_IN(x))
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_1_ERR_DATA_MSB_BMSK                                         0xffffffff
#define HWIO_UMAC_MXI_R0_GXI_RD_ERR_INJ_DATA_IX_1_ERR_DATA_MSB_SHFT                                                  0

#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ADDR(x)                                              ((x) + 0x17c)
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_PHYS(x)                                              ((x) + 0x17c)
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_OFFS                                                 (0x17c)
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_RMSK                                                 0x3fffffff
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_POR                                                  0x08000000
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_POR_RMSK                                             0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ATTR                                                              0x3
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ADDR(x),m,v,HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_IN(x))
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_TIMING_TRACKER_UNIT_BMSK                             0x20000000
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_TIMING_TRACKER_UNIT_SHFT                                     29
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_TRACK_WRITES_ENABLE_BMSK                             0x10000000
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_TRACK_WRITES_ENABLE_SHFT                                     28
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_TRACK_READS_ENABLE_BMSK                               0x8000000
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_TRACK_READS_ENABLE_SHFT                                      27
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_TRACKING_EN_FOR_TIMEOUT_BMSK                          0x4000000
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_TRACKING_EN_FOR_TIMEOUT_SHFT                                 26
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_TRACKING_EN_FOR_ERROR_BMSK                            0x2000000
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_TRACKING_EN_FOR_ERROR_SHFT                                   25
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_BMSK                                        0x1ffffff
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_SHFT                                                0

#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_0_ADDR(x)                               ((x) + 0x180)
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_0_PHYS(x)                               ((x) + 0x180)
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_0_OFFS                                  (0x180)
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_0_RMSK                                  0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_0_POR                                   0x00000000
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_0_POR_RMSK                              0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_0_ATTR                                               0x3
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_0_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_0_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_0_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_0_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_0_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_0_ADDR(x),m,v,HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_0_IN(x))
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_0_ID_BITMAP_BMSK                        0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_0_ID_BITMAP_SHFT                                 0

#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_1_ADDR(x)                               ((x) + 0x184)
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_1_PHYS(x)                               ((x) + 0x184)
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_1_OFFS                                  (0x184)
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_1_RMSK                                  0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_1_POR                                   0x00000000
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_1_POR_RMSK                              0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_1_ATTR                                               0x3
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_1_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_1_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_1_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_1_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_1_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_1_ADDR(x),m,v,HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_1_IN(x))
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_1_ID_BITMAP_BMSK                        0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_CTRL_ID_BITMAP_IX_1_ID_BITMAP_SHFT                                 0

#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_STATUS_ADDR(x)                                            ((x) + 0x188)
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_STATUS_PHYS(x)                                            ((x) + 0x188)
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_STATUS_OFFS                                               (0x188)
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_STATUS_RMSK                                                      0xf
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_STATUS_POR                                                0x00000000
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_STATUS_POR_RMSK                                           0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_STATUS_ATTR                                                            0x1
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_STATUS_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_STATUS_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_STATUS_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_STATUS_ERROR_TRACKING_ARRAY_INDEX_BMSK                           0xc
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_STATUS_ERROR_TRACKING_ARRAY_INDEX_SHFT                             2
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_STATUS_AXI_TIMEOUT_STATUS_BMSK                                   0x2
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_STATUS_AXI_TIMEOUT_STATUS_SHFT                                     1
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_STATUS_AXI_ERROR_STATUS_BMSK                                     0x1
#define HWIO_UMAC_MXI_R0_MXI_TRANSACTION_TRACKING_STATUS_AXI_ERROR_STATUS_SHFT                                       0

#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_L0_n_ADDR(base,n)                                       ((base) + 0X18C + (0x4*(n)))
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_L0_n_PHYS(base,n)                                       ((base) + 0X18C + (0x4*(n)))
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_L0_n_OFFS(n)                                            (0X18C + (0x4*(n)))
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_L0_n_RMSK                                               0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_L0_n_MAXn                                                        3
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_L0_n_POR                                                0x00000000
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_L0_n_POR_RMSK                                           0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_L0_n_ATTR                                                            0x1
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_L0_n_INI(base,n)                \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_L0_n_ADDR(base,n), HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_L0_n_RMSK)
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_L0_n_INMI(base,n,mask)        \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_L0_n_ADDR(base,n), mask)
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_L0_n_ADDR_LOW_BMSK                                      0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_L0_n_ADDR_LOW_SHFT                                               0

#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_HI_n_ADDR(base,n)                                       ((base) + 0X19C + (0x4*(n)))
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_HI_n_PHYS(base,n)                                       ((base) + 0X19C + (0x4*(n)))
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_HI_n_OFFS(n)                                            (0X19C + (0x4*(n)))
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_HI_n_RMSK                                               0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_HI_n_MAXn                                                        3
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_HI_n_POR                                                0x00000000
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_HI_n_POR_RMSK                                           0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_HI_n_ATTR                                                            0x1
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_HI_n_INI(base,n)                \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_HI_n_ADDR(base,n), HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_HI_n_RMSK)
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_HI_n_INMI(base,n,mask)        \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_HI_n_ADDR(base,n), mask)
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_HI_n_TRANSACTION_ONGOING_BMSK                           0x80000000
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_HI_n_TRANSACTION_ONGOING_SHFT                                   31
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_HI_n_NEXT_MISSED_CAPTURED_COUNT_BMSK                    0x70000000
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_HI_n_NEXT_MISSED_CAPTURED_COUNT_SHFT                            28
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_HI_n_TRANSACTION_TIME_BMSK                               0xfff0000
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_HI_n_TRANSACTION_TIME_SHFT                                      16
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_HI_n_TRANSACTION_SIZE_BMSK                                  0xc000
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_HI_n_TRANSACTION_SIZE_SHFT                                      14
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_HI_n_TRANSACTION_TYPE_BMSK                                  0x2000
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_HI_n_TRANSACTION_TYPE_SHFT                                      13
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_HI_n_MID_BMSK                                               0x1f00
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_HI_n_MID_SHFT                                                    8
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_HI_n_ADDR_HIGH_BMSK                                           0xff
#define HWIO_UMAC_MXI_R0_MXI_TRACKING_DETAILS_ARRAY_HI_n_ADDR_HIGH_SHFT                                              0

#define HWIO_UMAC_MXI_R0_MXI_CURRENT_TIMESTAMP_IX_0_ADDR(x)                                                 ((x) + 0x1ac)
#define HWIO_UMAC_MXI_R0_MXI_CURRENT_TIMESTAMP_IX_0_PHYS(x)                                                 ((x) + 0x1ac)
#define HWIO_UMAC_MXI_R0_MXI_CURRENT_TIMESTAMP_IX_0_OFFS                                                    (0x1ac)
#define HWIO_UMAC_MXI_R0_MXI_CURRENT_TIMESTAMP_IX_0_RMSK                                                    0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_CURRENT_TIMESTAMP_IX_0_POR                                                     0x00000000
#define HWIO_UMAC_MXI_R0_MXI_CURRENT_TIMESTAMP_IX_0_POR_RMSK                                                0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_CURRENT_TIMESTAMP_IX_0_ATTR                                                                 0x1
#define HWIO_UMAC_MXI_R0_MXI_CURRENT_TIMESTAMP_IX_0_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_CURRENT_TIMESTAMP_IX_0_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_CURRENT_TIMESTAMP_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_CURRENT_TIMESTAMP_IX_0_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_CURRENT_TIMESTAMP_IX_0_TIMESTAMP_BMSK                                          0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_CURRENT_TIMESTAMP_IX_0_TIMESTAMP_SHFT                                                   0

#define HWIO_UMAC_MXI_R0_MXI_CURRENT_TIMESTAMP_IX_1_ADDR(x)                                                 ((x) + 0x1b0)
#define HWIO_UMAC_MXI_R0_MXI_CURRENT_TIMESTAMP_IX_1_PHYS(x)                                                 ((x) + 0x1b0)
#define HWIO_UMAC_MXI_R0_MXI_CURRENT_TIMESTAMP_IX_1_OFFS                                                    (0x1b0)
#define HWIO_UMAC_MXI_R0_MXI_CURRENT_TIMESTAMP_IX_1_RMSK                                                    0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_CURRENT_TIMESTAMP_IX_1_POR                                                     0x00000000
#define HWIO_UMAC_MXI_R0_MXI_CURRENT_TIMESTAMP_IX_1_POR_RMSK                                                0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_CURRENT_TIMESTAMP_IX_1_ATTR                                                                 0x1
#define HWIO_UMAC_MXI_R0_MXI_CURRENT_TIMESTAMP_IX_1_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_MXI_CURRENT_TIMESTAMP_IX_1_ADDR(x))
#define HWIO_UMAC_MXI_R0_MXI_CURRENT_TIMESTAMP_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_MXI_CURRENT_TIMESTAMP_IX_1_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_MXI_CURRENT_TIMESTAMP_IX_1_TIMESTAMP_BMSK                                          0xffffffff
#define HWIO_UMAC_MXI_R0_MXI_CURRENT_TIMESTAMP_IX_1_TIMESTAMP_SHFT                                                   0

#define HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_ADDR(x)                                                  ((x) + 0x1b4)
#define HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_PHYS(x)                                                  ((x) + 0x1b4)
#define HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_OFFS                                                     (0x1b4)
#define HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_RMSK                                                          0xfff
#define HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_POR                                                      0x00000049
#define HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_POR_RMSK                                                 0xffffffff
#define HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_ATTR                                                                  0x3
#define HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_ADDR(x))
#define HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_ADDR(x),v)
#define HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_ADDR(x),m,v,HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_IN(x))
#define HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_TQM_SEC_BIT_OVERRIDE_VAL_BMSK                                 0xc00
#define HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_TQM_SEC_BIT_OVERRIDE_VAL_SHFT                                    10
#define HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_TQM_SEC_BIT_OVERRIDE_EN_BMSK                                  0x200
#define HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_TQM_SEC_BIT_OVERRIDE_EN_SHFT                                      9
#define HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_REO_SEC_BIT_OVERRIDE_VAL_BMSK                                 0x180
#define HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_REO_SEC_BIT_OVERRIDE_VAL_SHFT                                     7
#define HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_REO_SEC_BIT_OVERRIDE_EN_BMSK                                   0x40
#define HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_REO_SEC_BIT_OVERRIDE_EN_SHFT                                      6
#define HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_WBM_SEC_BIT_OVERRIDE_VAL_BMSK                                  0x30
#define HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_WBM_SEC_BIT_OVERRIDE_VAL_SHFT                                     4
#define HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_WBM_SEC_BIT_OVERRIDE_EN_BMSK                                    0x8
#define HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_WBM_SEC_BIT_OVERRIDE_EN_SHFT                                      3
#define HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_TCL_SEC_BIT_OVERRIDE_VAL_BMSK                                   0x6
#define HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_TCL_SEC_BIT_OVERRIDE_VAL_SHFT                                     1
#define HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_TCL_SEC_BIT_OVERRIDE_EN_BMSK                                    0x1
#define HWIO_UMAC_MXI_R0_GXI_SECURITY_BIT_OVERRIDE_TCL_SEC_BIT_OVERRIDE_EN_SHFT                                      0

#define HWIO_UMAC_MXI_R0_GXI_FLUSH_ERR_STATS_ADDR(x)                                                        ((x) + 0x1b8)
#define HWIO_UMAC_MXI_R0_GXI_FLUSH_ERR_STATS_PHYS(x)                                                        ((x) + 0x1b8)
#define HWIO_UMAC_MXI_R0_GXI_FLUSH_ERR_STATS_OFFS                                                           (0x1b8)
#define HWIO_UMAC_MXI_R0_GXI_FLUSH_ERR_STATS_RMSK                                                            0x1ff01ff
#define HWIO_UMAC_MXI_R0_GXI_FLUSH_ERR_STATS_POR                                                            0x00000000
#define HWIO_UMAC_MXI_R0_GXI_FLUSH_ERR_STATS_POR_RMSK                                                       0xffffffff
#define HWIO_UMAC_MXI_R0_GXI_FLUSH_ERR_STATS_ATTR                                                                        0x1
#define HWIO_UMAC_MXI_R0_GXI_FLUSH_ERR_STATS_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R0_GXI_FLUSH_ERR_STATS_ADDR(x))
#define HWIO_UMAC_MXI_R0_GXI_FLUSH_ERR_STATS_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R0_GXI_FLUSH_ERR_STATS_ADDR(x), m)
#define HWIO_UMAC_MXI_R0_GXI_FLUSH_ERR_STATS_WR_FLUSH_CNT_NOT_ZERO_BMSK                                      0x1000000
#define HWIO_UMAC_MXI_R0_GXI_FLUSH_ERR_STATS_WR_FLUSH_CNT_NOT_ZERO_SHFT                                             24
#define HWIO_UMAC_MXI_R0_GXI_FLUSH_ERR_STATS_WR_PORT_ID_BMSK                                                  0xff0000
#define HWIO_UMAC_MXI_R0_GXI_FLUSH_ERR_STATS_WR_PORT_ID_SHFT                                                        16
#define HWIO_UMAC_MXI_R0_GXI_FLUSH_ERR_STATS_RD_FLUSH_CNT_NOT_ZERO_BMSK                                          0x100
#define HWIO_UMAC_MXI_R0_GXI_FLUSH_ERR_STATS_RD_FLUSH_CNT_NOT_ZERO_SHFT                                              8
#define HWIO_UMAC_MXI_R0_GXI_FLUSH_ERR_STATS_RD_PORT_ID_BMSK                                                      0xff
#define HWIO_UMAC_MXI_R0_GXI_FLUSH_ERR_STATS_RD_PORT_ID_SHFT                                                         0

#define HWIO_UMAC_MXI_R1_TESTBUS_CTRL_ADDR(x)                                                               ((x) + 0x500)
#define HWIO_UMAC_MXI_R1_TESTBUS_CTRL_PHYS(x)                                                               ((x) + 0x500)
#define HWIO_UMAC_MXI_R1_TESTBUS_CTRL_OFFS                                                                  (0x500)
#define HWIO_UMAC_MXI_R1_TESTBUS_CTRL_RMSK                                                                     0x1001f
#define HWIO_UMAC_MXI_R1_TESTBUS_CTRL_POR                                                                   0x00000000
#define HWIO_UMAC_MXI_R1_TESTBUS_CTRL_POR_RMSK                                                              0xffffffff
#define HWIO_UMAC_MXI_R1_TESTBUS_CTRL_ATTR                                                                               0x3
#define HWIO_UMAC_MXI_R1_TESTBUS_CTRL_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R1_TESTBUS_CTRL_ADDR(x))
#define HWIO_UMAC_MXI_R1_TESTBUS_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R1_TESTBUS_CTRL_ADDR(x), m)
#define HWIO_UMAC_MXI_R1_TESTBUS_CTRL_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R1_TESTBUS_CTRL_ADDR(x),v)
#define HWIO_UMAC_MXI_R1_TESTBUS_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R1_TESTBUS_CTRL_ADDR(x),m,v,HWIO_UMAC_MXI_R1_TESTBUS_CTRL_IN(x))
#define HWIO_UMAC_MXI_R1_TESTBUS_CTRL_HW_ERROR_INTERRUPT_TESTBUS_OVERWRITE_BMSK                                0x10000
#define HWIO_UMAC_MXI_R1_TESTBUS_CTRL_HW_ERROR_INTERRUPT_TESTBUS_OVERWRITE_SHFT                                     16
#define HWIO_UMAC_MXI_R1_TESTBUS_CTRL_TESTBUS_SELECT_BMSK                                                         0x1f
#define HWIO_UMAC_MXI_R1_TESTBUS_CTRL_TESTBUS_SELECT_SHFT                                                            0

#define HWIO_UMAC_MXI_R1_EVENTMASK_IX_0_ADDR(x)                                                             ((x) + 0x504)
#define HWIO_UMAC_MXI_R1_EVENTMASK_IX_0_PHYS(x)                                                             ((x) + 0x504)
#define HWIO_UMAC_MXI_R1_EVENTMASK_IX_0_OFFS                                                                (0x504)
#define HWIO_UMAC_MXI_R1_EVENTMASK_IX_0_RMSK                                                                0xffffffff
#define HWIO_UMAC_MXI_R1_EVENTMASK_IX_0_POR                                                                 0xffffffff
#define HWIO_UMAC_MXI_R1_EVENTMASK_IX_0_POR_RMSK                                                            0xffffffff
#define HWIO_UMAC_MXI_R1_EVENTMASK_IX_0_ATTR                                                                             0x3
#define HWIO_UMAC_MXI_R1_EVENTMASK_IX_0_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R1_EVENTMASK_IX_0_ADDR(x))
#define HWIO_UMAC_MXI_R1_EVENTMASK_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R1_EVENTMASK_IX_0_ADDR(x), m)
#define HWIO_UMAC_MXI_R1_EVENTMASK_IX_0_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R1_EVENTMASK_IX_0_ADDR(x),v)
#define HWIO_UMAC_MXI_R1_EVENTMASK_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R1_EVENTMASK_IX_0_ADDR(x),m,v,HWIO_UMAC_MXI_R1_EVENTMASK_IX_0_IN(x))
#define HWIO_UMAC_MXI_R1_EVENTMASK_IX_0_MASK_BMSK                                                           0xffffffff
#define HWIO_UMAC_MXI_R1_EVENTMASK_IX_0_MASK_SHFT                                                                    0

#define HWIO_UMAC_MXI_R1_EVENTMASK_IX_1_ADDR(x)                                                             ((x) + 0x508)
#define HWIO_UMAC_MXI_R1_EVENTMASK_IX_1_PHYS(x)                                                             ((x) + 0x508)
#define HWIO_UMAC_MXI_R1_EVENTMASK_IX_1_OFFS                                                                (0x508)
#define HWIO_UMAC_MXI_R1_EVENTMASK_IX_1_RMSK                                                                0xffffffff
#define HWIO_UMAC_MXI_R1_EVENTMASK_IX_1_POR                                                                 0xffffffff
#define HWIO_UMAC_MXI_R1_EVENTMASK_IX_1_POR_RMSK                                                            0xffffffff
#define HWIO_UMAC_MXI_R1_EVENTMASK_IX_1_ATTR                                                                             0x3
#define HWIO_UMAC_MXI_R1_EVENTMASK_IX_1_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R1_EVENTMASK_IX_1_ADDR(x))
#define HWIO_UMAC_MXI_R1_EVENTMASK_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R1_EVENTMASK_IX_1_ADDR(x), m)
#define HWIO_UMAC_MXI_R1_EVENTMASK_IX_1_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R1_EVENTMASK_IX_1_ADDR(x),v)
#define HWIO_UMAC_MXI_R1_EVENTMASK_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R1_EVENTMASK_IX_1_ADDR(x),m,v,HWIO_UMAC_MXI_R1_EVENTMASK_IX_1_IN(x))
#define HWIO_UMAC_MXI_R1_EVENTMASK_IX_1_MASK_BMSK                                                           0xffffffff
#define HWIO_UMAC_MXI_R1_EVENTMASK_IX_1_MASK_SHFT                                                                    0

#define HWIO_UMAC_MXI_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDR(x)                                                  ((x) + 0x50c)
#define HWIO_UMAC_MXI_R1_REG_ACCESS_EVENT_GEN_CTRL_PHYS(x)                                                  ((x) + 0x50c)
#define HWIO_UMAC_MXI_R1_REG_ACCESS_EVENT_GEN_CTRL_OFFS                                                     (0x50c)
#define HWIO_UMAC_MXI_R1_REG_ACCESS_EVENT_GEN_CTRL_RMSK                                                     0xffffffff
#define HWIO_UMAC_MXI_R1_REG_ACCESS_EVENT_GEN_CTRL_POR                                                      0x7ffe0002
#define HWIO_UMAC_MXI_R1_REG_ACCESS_EVENT_GEN_CTRL_POR_RMSK                                                 0xffffffff
#define HWIO_UMAC_MXI_R1_REG_ACCESS_EVENT_GEN_CTRL_ATTR                                                                  0x3
#define HWIO_UMAC_MXI_R1_REG_ACCESS_EVENT_GEN_CTRL_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDR(x))
#define HWIO_UMAC_MXI_R1_REG_ACCESS_EVENT_GEN_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDR(x), m)
#define HWIO_UMAC_MXI_R1_REG_ACCESS_EVENT_GEN_CTRL_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDR(x),v)
#define HWIO_UMAC_MXI_R1_REG_ACCESS_EVENT_GEN_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDR(x),m,v,HWIO_UMAC_MXI_R1_REG_ACCESS_EVENT_GEN_CTRL_IN(x))
#define HWIO_UMAC_MXI_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDRESS_RANGE_END_BMSK                                   0xfffe0000
#define HWIO_UMAC_MXI_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDRESS_RANGE_END_SHFT                                           17
#define HWIO_UMAC_MXI_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDRESS_RANGE_START_BMSK                                    0x1fffc
#define HWIO_UMAC_MXI_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDRESS_RANGE_START_SHFT                                          2
#define HWIO_UMAC_MXI_R1_REG_ACCESS_EVENT_GEN_CTRL_WRITE_ACCESS_REPORT_ENABLE_BMSK                                 0x2
#define HWIO_UMAC_MXI_R1_REG_ACCESS_EVENT_GEN_CTRL_WRITE_ACCESS_REPORT_ENABLE_SHFT                                   1
#define HWIO_UMAC_MXI_R1_REG_ACCESS_EVENT_GEN_CTRL_READ_ACCESS_REPORT_ENABLE_BMSK                                  0x1
#define HWIO_UMAC_MXI_R1_REG_ACCESS_EVENT_GEN_CTRL_READ_ACCESS_REPORT_ENABLE_SHFT                                    0

#define HWIO_UMAC_MXI_R1_END_OF_TEST_CHECK_ADDR(x)                                                          ((x) + 0x510)
#define HWIO_UMAC_MXI_R1_END_OF_TEST_CHECK_PHYS(x)                                                          ((x) + 0x510)
#define HWIO_UMAC_MXI_R1_END_OF_TEST_CHECK_OFFS                                                             (0x510)
#define HWIO_UMAC_MXI_R1_END_OF_TEST_CHECK_RMSK                                                                    0x1
#define HWIO_UMAC_MXI_R1_END_OF_TEST_CHECK_POR                                                              0x00000000
#define HWIO_UMAC_MXI_R1_END_OF_TEST_CHECK_POR_RMSK                                                         0xffffffff
#define HWIO_UMAC_MXI_R1_END_OF_TEST_CHECK_ATTR                                                                          0x3
#define HWIO_UMAC_MXI_R1_END_OF_TEST_CHECK_IN(x)            \
                in_dword(HWIO_UMAC_MXI_R1_END_OF_TEST_CHECK_ADDR(x))
#define HWIO_UMAC_MXI_R1_END_OF_TEST_CHECK_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_MXI_R1_END_OF_TEST_CHECK_ADDR(x), m)
#define HWIO_UMAC_MXI_R1_END_OF_TEST_CHECK_OUT(x, v)            \
                out_dword(HWIO_UMAC_MXI_R1_END_OF_TEST_CHECK_ADDR(x),v)
#define HWIO_UMAC_MXI_R1_END_OF_TEST_CHECK_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_MXI_R1_END_OF_TEST_CHECK_ADDR(x),m,v,HWIO_UMAC_MXI_R1_END_OF_TEST_CHECK_IN(x))
#define HWIO_UMAC_MXI_R1_END_OF_TEST_CHECK_END_OF_TEST_SELF_CHECK_BMSK                                             0x1
#define HWIO_UMAC_MXI_R1_END_OF_TEST_CHECK_END_OF_TEST_SELF_CHECK_SHFT                                               0

/*----------------------------------------------------------------------------
 * MODULE: WBM_REG
 *--------------------------------------------------------------------------*/

#define WBM_REG_REG_BASE                                                                                        (UMAC_BASE      + 0x00034000)
#define WBM_REG_REG_BASE_SIZE                                                                                   0x4000
#define WBM_REG_REG_BASE_USED                                                                                   0x3124
#define WBM_REG_REG_BASE_PHYS                                                                                   (UMAC_BASE_PHYS + 0x00034000)
#define WBM_REG_REG_BASE_OFFS                                                                                   0x00034000

#define HWIO_WBM_R0_GENERAL_ENABLE_ADDR(x)                                                                      ((x) + 0x0)
#define HWIO_WBM_R0_GENERAL_ENABLE_PHYS(x)                                                                      ((x) + 0x0)
#define HWIO_WBM_R0_GENERAL_ENABLE_OFFS                                                                         (0x0)
#define HWIO_WBM_R0_GENERAL_ENABLE_RMSK                                                                              0x9ff
#define HWIO_WBM_R0_GENERAL_ENABLE_POR                                                                          0x00000020
#define HWIO_WBM_R0_GENERAL_ENABLE_POR_RMSK                                                                     0xffffffff
#define HWIO_WBM_R0_GENERAL_ENABLE_ATTR                                                                                      0x3
#define HWIO_WBM_R0_GENERAL_ENABLE_IN(x)            \
                in_dword(HWIO_WBM_R0_GENERAL_ENABLE_ADDR(x))
#define HWIO_WBM_R0_GENERAL_ENABLE_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_GENERAL_ENABLE_ADDR(x), m)
#define HWIO_WBM_R0_GENERAL_ENABLE_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_GENERAL_ENABLE_ADDR(x),v)
#define HWIO_WBM_R0_GENERAL_ENABLE_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_GENERAL_ENABLE_ADDR(x),m,v,HWIO_WBM_R0_GENERAL_ENABLE_IN(x))
#define HWIO_WBM_R0_GENERAL_ENABLE_LOWER_WATERMARK_DISABLE_BMSK                                                      0x800
#define HWIO_WBM_R0_GENERAL_ENABLE_LOWER_WATERMARK_DISABLE_SHFT                                                         11
#define HWIO_WBM_R0_GENERAL_ENABLE_LPM_CACHE_SELF_FLUSH_ENABLE_BMSK                                                  0x100
#define HWIO_WBM_R0_GENERAL_ENABLE_LPM_CACHE_SELF_FLUSH_ENABLE_SHFT                                                      8
#define HWIO_WBM_R0_GENERAL_ENABLE_LINK_DESC_CONTENT_CLEAR_ENABLE_BMSK                                                0x80
#define HWIO_WBM_R0_GENERAL_ENABLE_LINK_DESC_CONTENT_CLEAR_ENABLE_SHFT                                                   7
#define HWIO_WBM_R0_GENERAL_ENABLE_LINK_DESC_BYPASS_DISABLE_BMSK                                                      0x40
#define HWIO_WBM_R0_GENERAL_ENABLE_LINK_DESC_BYPASS_DISABLE_SHFT                                                         6
#define HWIO_WBM_R0_GENERAL_ENABLE_MSDU_BUFFER_BYPASS_DISABLE_BMSK                                                    0x20
#define HWIO_WBM_R0_GENERAL_ENABLE_MSDU_BUFFER_BYPASS_DISABLE_SHFT                                                       5
#define HWIO_WBM_R0_GENERAL_ENABLE_RELEASE_FUNCTION_ENABLE_BMSK                                                       0x10
#define HWIO_WBM_R0_GENERAL_ENABLE_RELEASE_FUNCTION_ENABLE_SHFT                                                          4
#define HWIO_WBM_R0_GENERAL_ENABLE_LINK_IDLE_LIST_CONSUMER_ENABLE_BMSK                                                 0x8
#define HWIO_WBM_R0_GENERAL_ENABLE_LINK_IDLE_LIST_CONSUMER_ENABLE_SHFT                                                   3
#define HWIO_WBM_R0_GENERAL_ENABLE_LINK_IDLE_LIST_PRODUCER_ENABLE_BMSK                                                 0x4
#define HWIO_WBM_R0_GENERAL_ENABLE_LINK_IDLE_LIST_PRODUCER_ENABLE_SHFT                                                   2
#define HWIO_WBM_R0_GENERAL_ENABLE_BUFFER_IDLE_LIST_CONSUMER_ENABLE_BMSK                                               0x2
#define HWIO_WBM_R0_GENERAL_ENABLE_BUFFER_IDLE_LIST_CONSUMER_ENABLE_SHFT                                                 1
#define HWIO_WBM_R0_GENERAL_ENABLE_BUFFER_IDLE_LIST_PRODUCER_ENABLE_BMSK                                               0x1
#define HWIO_WBM_R0_GENERAL_ENABLE_BUFFER_IDLE_LIST_PRODUCER_ENABLE_SHFT                                                 0

#define HWIO_WBM_R0_DUP_DET_CFG_ADDR(x)                                                                         ((x) + 0x4)
#define HWIO_WBM_R0_DUP_DET_CFG_PHYS(x)                                                                         ((x) + 0x4)
#define HWIO_WBM_R0_DUP_DET_CFG_OFFS                                                                            (0x4)
#define HWIO_WBM_R0_DUP_DET_CFG_RMSK                                                                                 0x1ff
#define HWIO_WBM_R0_DUP_DET_CFG_POR                                                                             0x000000ff
#define HWIO_WBM_R0_DUP_DET_CFG_POR_RMSK                                                                        0xffffffff
#define HWIO_WBM_R0_DUP_DET_CFG_ATTR                                                                                         0x3
#define HWIO_WBM_R0_DUP_DET_CFG_IN(x)            \
                in_dword(HWIO_WBM_R0_DUP_DET_CFG_ADDR(x))
#define HWIO_WBM_R0_DUP_DET_CFG_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_DUP_DET_CFG_ADDR(x), m)
#define HWIO_WBM_R0_DUP_DET_CFG_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_DUP_DET_CFG_ADDR(x),v)
#define HWIO_WBM_R0_DUP_DET_CFG_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_DUP_DET_CFG_ADDR(x),m,v,HWIO_WBM_R0_DUP_DET_CFG_IN(x))
#define HWIO_WBM_R0_DUP_DET_CFG_IDLE_DIST_DUP_CHECK_BMSK                                                             0x100
#define HWIO_WBM_R0_DUP_DET_CFG_IDLE_DIST_DUP_CHECK_SHFT                                                                 8
#define HWIO_WBM_R0_DUP_DET_CFG_SW_TX_RELEASE_RING_EN_BMSK                                                            0x80
#define HWIO_WBM_R0_DUP_DET_CFG_SW_TX_RELEASE_RING_EN_SHFT                                                               7
#define HWIO_WBM_R0_DUP_DET_CFG_FW_TX_RELEASE_RING_EN_BMSK                                                            0x40
#define HWIO_WBM_R0_DUP_DET_CFG_FW_TX_RELEASE_RING_EN_SHFT                                                               6
#define HWIO_WBM_R0_DUP_DET_CFG_TQM_RELEASE_RING_EN_BMSK                                                              0x20
#define HWIO_WBM_R0_DUP_DET_CFG_TQM_RELEASE_RING_EN_SHFT                                                                 5
#define HWIO_WBM_R0_DUP_DET_CFG_SW_RX_RELEASE_RING_EN_BMSK                                                            0x10
#define HWIO_WBM_R0_DUP_DET_CFG_SW_RX_RELEASE_RING_EN_SHFT                                                               4
#define HWIO_WBM_R0_DUP_DET_CFG_FW_RX_RELEASE_RING_EN_BMSK                                                             0x8
#define HWIO_WBM_R0_DUP_DET_CFG_FW_RX_RELEASE_RING_EN_SHFT                                                               3
#define HWIO_WBM_R0_DUP_DET_CFG_REO_RELEASE_RING_EN_BMSK                                                               0x4
#define HWIO_WBM_R0_DUP_DET_CFG_REO_RELEASE_RING_EN_SHFT                                                                 2
#define HWIO_WBM_R0_DUP_DET_CFG_RXDMA_RELEASE_RING_EN_BMSK                                                             0x2
#define HWIO_WBM_R0_DUP_DET_CFG_RXDMA_RELEASE_RING_EN_SHFT                                                               1
#define HWIO_WBM_R0_DUP_DET_CFG_DUPLICATE_DETECTION_ENABLE_BMSK                                                        0x1
#define HWIO_WBM_R0_DUP_DET_CFG_DUPLICATE_DETECTION_ENABLE_SHFT                                                          0

#define HWIO_WBM_R0_MLO_GXI_TRANSFER_PRIORITY_ADDR(x)                                                           ((x) + 0x8)
#define HWIO_WBM_R0_MLO_GXI_TRANSFER_PRIORITY_PHYS(x)                                                           ((x) + 0x8)
#define HWIO_WBM_R0_MLO_GXI_TRANSFER_PRIORITY_OFFS                                                              (0x8)
#define HWIO_WBM_R0_MLO_GXI_TRANSFER_PRIORITY_RMSK                                                                    0xff
#define HWIO_WBM_R0_MLO_GXI_TRANSFER_PRIORITY_POR                                                               0x00000000
#define HWIO_WBM_R0_MLO_GXI_TRANSFER_PRIORITY_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_MLO_GXI_TRANSFER_PRIORITY_ATTR                                                                           0x3
#define HWIO_WBM_R0_MLO_GXI_TRANSFER_PRIORITY_IN(x)            \
                in_dword(HWIO_WBM_R0_MLO_GXI_TRANSFER_PRIORITY_ADDR(x))
#define HWIO_WBM_R0_MLO_GXI_TRANSFER_PRIORITY_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_MLO_GXI_TRANSFER_PRIORITY_ADDR(x), m)
#define HWIO_WBM_R0_MLO_GXI_TRANSFER_PRIORITY_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_MLO_GXI_TRANSFER_PRIORITY_ADDR(x),v)
#define HWIO_WBM_R0_MLO_GXI_TRANSFER_PRIORITY_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_MLO_GXI_TRANSFER_PRIORITY_ADDR(x),m,v,HWIO_WBM_R0_MLO_GXI_TRANSFER_PRIORITY_IN(x))
#define HWIO_WBM_R0_MLO_GXI_TRANSFER_PRIORITY_WBM2WBM_OUT2_SRNG_P_MLO_BMSK                                            0xc0
#define HWIO_WBM_R0_MLO_GXI_TRANSFER_PRIORITY_WBM2WBM_OUT2_SRNG_P_MLO_SHFT                                               6
#define HWIO_WBM_R0_MLO_GXI_TRANSFER_PRIORITY_WBM2WBM_OUT1_SRNG_P_MLO_BMSK                                            0x30
#define HWIO_WBM_R0_MLO_GXI_TRANSFER_PRIORITY_WBM2WBM_OUT1_SRNG_P_MLO_SHFT                                               4
#define HWIO_WBM_R0_MLO_GXI_TRANSFER_PRIORITY_WBM2WBM_IN2_SRNG_C_MLO_BMSK                                              0xc
#define HWIO_WBM_R0_MLO_GXI_TRANSFER_PRIORITY_WBM2WBM_IN2_SRNG_C_MLO_SHFT                                                2
#define HWIO_WBM_R0_MLO_GXI_TRANSFER_PRIORITY_WBM2WBM_IN1_SRNG_C_MLO_BMSK                                              0x3
#define HWIO_WBM_R0_MLO_GXI_TRANSFER_PRIORITY_WBM2WBM_IN1_SRNG_C_MLO_SHFT                                                0

#define HWIO_WBM_R0_MLO_POSTED_WRITE_CTRL_ADDR(x)                                                               ((x) + 0xc)
#define HWIO_WBM_R0_MLO_POSTED_WRITE_CTRL_PHYS(x)                                                               ((x) + 0xc)
#define HWIO_WBM_R0_MLO_POSTED_WRITE_CTRL_OFFS                                                                  (0xc)
#define HWIO_WBM_R0_MLO_POSTED_WRITE_CTRL_RMSK                                                                         0x3
#define HWIO_WBM_R0_MLO_POSTED_WRITE_CTRL_POR                                                                   0x00000000
#define HWIO_WBM_R0_MLO_POSTED_WRITE_CTRL_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_MLO_POSTED_WRITE_CTRL_ATTR                                                                               0x3
#define HWIO_WBM_R0_MLO_POSTED_WRITE_CTRL_IN(x)            \
                in_dword(HWIO_WBM_R0_MLO_POSTED_WRITE_CTRL_ADDR(x))
#define HWIO_WBM_R0_MLO_POSTED_WRITE_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_MLO_POSTED_WRITE_CTRL_ADDR(x), m)
#define HWIO_WBM_R0_MLO_POSTED_WRITE_CTRL_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_MLO_POSTED_WRITE_CTRL_ADDR(x),v)
#define HWIO_WBM_R0_MLO_POSTED_WRITE_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_MLO_POSTED_WRITE_CTRL_ADDR(x),m,v,HWIO_WBM_R0_MLO_POSTED_WRITE_CTRL_IN(x))
#define HWIO_WBM_R0_MLO_POSTED_WRITE_CTRL_WBM2WBM_OUT2_BMSK                                                            0x2
#define HWIO_WBM_R0_MLO_POSTED_WRITE_CTRL_WBM2WBM_OUT2_SHFT                                                              1
#define HWIO_WBM_R0_MLO_POSTED_WRITE_CTRL_WBM2WBM_OUT1_BMSK                                                            0x1
#define HWIO_WBM_R0_MLO_POSTED_WRITE_CTRL_WBM2WBM_OUT1_SHFT                                                              0

#define HWIO_WBM_R0_VC_ID_CFG_ADDR(x)                                                                           ((x) + 0x10)
#define HWIO_WBM_R0_VC_ID_CFG_PHYS(x)                                                                           ((x) + 0x10)
#define HWIO_WBM_R0_VC_ID_CFG_OFFS                                                                              (0x10)
#define HWIO_WBM_R0_VC_ID_CFG_RMSK                                                                                  0xfbbe
#define HWIO_WBM_R0_VC_ID_CFG_POR                                                                               0x00000800
#define HWIO_WBM_R0_VC_ID_CFG_POR_RMSK                                                                          0xffffffff
#define HWIO_WBM_R0_VC_ID_CFG_ATTR                                                                                           0x3
#define HWIO_WBM_R0_VC_ID_CFG_IN(x)            \
                in_dword(HWIO_WBM_R0_VC_ID_CFG_ADDR(x))
#define HWIO_WBM_R0_VC_ID_CFG_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_VC_ID_CFG_ADDR(x), m)
#define HWIO_WBM_R0_VC_ID_CFG_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_VC_ID_CFG_ADDR(x),v)
#define HWIO_WBM_R0_VC_ID_CFG_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_VC_ID_CFG_ADDR(x),m,v,HWIO_WBM_R0_VC_ID_CFG_IN(x))
#define HWIO_WBM_R0_VC_ID_CFG_WBM2WBM_OUT2_VC_ID_BMSK                                                               0x8000
#define HWIO_WBM_R0_VC_ID_CFG_WBM2WBM_OUT2_VC_ID_SHFT                                                                   15
#define HWIO_WBM_R0_VC_ID_CFG_WBM2WBM_OUT1_VC_ID_BMSK                                                               0x4000
#define HWIO_WBM_R0_VC_ID_CFG_WBM2WBM_OUT1_VC_ID_SHFT                                                                   14
#define HWIO_WBM_R0_VC_ID_CFG_WBM2WBM_IN2_VC_ID_BMSK                                                                0x2000
#define HWIO_WBM_R0_VC_ID_CFG_WBM2WBM_IN2_VC_ID_SHFT                                                                    13
#define HWIO_WBM_R0_VC_ID_CFG_WBM2WBM_IN1_VC_ID_BMSK                                                                0x1000
#define HWIO_WBM_R0_VC_ID_CFG_WBM2WBM_IN1_VC_ID_SHFT                                                                    12
#define HWIO_WBM_R0_VC_ID_CFG_VA_GXI_VC_ID_BMSK                                                                      0x800
#define HWIO_WBM_R0_VC_ID_CFG_VA_GXI_VC_ID_SHFT                                                                         11
#define HWIO_WBM_R0_VC_ID_CFG_CACHE1_GXI_VC_ID_BMSK                                                                  0x200
#define HWIO_WBM_R0_VC_ID_CFG_CACHE1_GXI_VC_ID_SHFT                                                                      9
#define HWIO_WBM_R0_VC_ID_CFG_IDLE_LINK_P_RING_VC_ID_BMSK                                                            0x100
#define HWIO_WBM_R0_VC_ID_CFG_IDLE_LINK_P_RING_VC_ID_SHFT                                                                8
#define HWIO_WBM_R0_VC_ID_CFG_IDLE_LINK_C_RING_VC_ID_BMSK                                                             0x80
#define HWIO_WBM_R0_VC_ID_CFG_IDLE_LINK_C_RING_VC_ID_SHFT                                                                7
#define HWIO_WBM_R0_VC_ID_CFG_RXDMA0_RELEASE_RING_VC_ID_BMSK                                                          0x20
#define HWIO_WBM_R0_VC_ID_CFG_RXDMA0_RELEASE_RING_VC_ID_SHFT                                                             5
#define HWIO_WBM_R0_VC_ID_CFG_FW_RELEASE_RING_VC_ID_BMSK                                                              0x10
#define HWIO_WBM_R0_VC_ID_CFG_FW_RELEASE_RING_VC_ID_SHFT                                                                 4
#define HWIO_WBM_R0_VC_ID_CFG_SW_RELEASE_RING_VC_ID_BMSK                                                               0x8
#define HWIO_WBM_R0_VC_ID_CFG_SW_RELEASE_RING_VC_ID_SHFT                                                                 3
#define HWIO_WBM_R0_VC_ID_CFG_REO_RELEASE_RING_VC_ID_BMSK                                                              0x4
#define HWIO_WBM_R0_VC_ID_CFG_REO_RELEASE_RING_VC_ID_SHFT                                                                2
#define HWIO_WBM_R0_VC_ID_CFG_TQM_RELEASE_RING_VC_ID_BMSK                                                              0x2
#define HWIO_WBM_R0_VC_ID_CFG_TQM_RELEASE_RING_VC_ID_SHFT                                                                1

#define HWIO_WBM_R0_RELEASE_RING_ENABLE_ADDR(x)                                                                 ((x) + 0x14)
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_PHYS(x)                                                                 ((x) + 0x14)
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_OFFS                                                                    (0x14)
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_RMSK                                                                          0xfe
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_POR                                                                     0x00000000
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_ATTR                                                                                 0x3
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_IN(x)            \
                in_dword(HWIO_WBM_R0_RELEASE_RING_ENABLE_ADDR(x))
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RELEASE_RING_ENABLE_ADDR(x), m)
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_RELEASE_RING_ENABLE_ADDR(x),v)
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_RELEASE_RING_ENABLE_ADDR(x),m,v,HWIO_WBM_R0_RELEASE_RING_ENABLE_IN(x))
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_RXDMA2_RELEASE_RING_ENABLE_BMSK                                               0x80
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_RXDMA2_RELEASE_RING_ENABLE_SHFT                                                  7
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_RXDMA1_RELEASE_RING_ENABLE_BMSK                                               0x40
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_RXDMA1_RELEASE_RING_ENABLE_SHFT                                                  6
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_RXDMA0_RELEASE_RING_ENABLE_BMSK                                               0x20
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_RXDMA0_RELEASE_RING_ENABLE_SHFT                                                  5
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_FW_RELEASE_RING_ENABLE_BMSK                                                   0x10
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_FW_RELEASE_RING_ENABLE_SHFT                                                      4
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_SW_RELEASE_RING_ENABLE_BMSK                                                    0x8
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_SW_RELEASE_RING_ENABLE_SHFT                                                      3
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_REO_RELEASE_RING_ENABLE_BMSK                                                   0x4
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_REO_RELEASE_RING_ENABLE_SHFT                                                     2
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_TQM_RELEASE_RING_ENABLE_BMSK                                                   0x2
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_TQM_RELEASE_RING_ENABLE_SHFT                                                     1

#define HWIO_WBM_R0_RELEASE_RING_ENABLE_2_ADDR(x)                                                               ((x) + 0x18)
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_2_PHYS(x)                                                               ((x) + 0x18)
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_2_OFFS                                                                  (0x18)
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_2_RMSK                                                                         0x6
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_2_POR                                                                   0x00000000
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_2_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_2_ATTR                                                                               0x3
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_2_IN(x)            \
                in_dword(HWIO_WBM_R0_RELEASE_RING_ENABLE_2_ADDR(x))
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_2_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RELEASE_RING_ENABLE_2_ADDR(x), m)
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_2_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_RELEASE_RING_ENABLE_2_ADDR(x),v)
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_RELEASE_RING_ENABLE_2_ADDR(x),m,v,HWIO_WBM_R0_RELEASE_RING_ENABLE_2_IN(x))
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_2_MLO_IN2_RELEASE_RING_ENABLE_BMSK                                             0x4
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_2_MLO_IN2_RELEASE_RING_ENABLE_SHFT                                               2
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_2_MLO_IN1_RELEASE_RING_ENABLE_BMSK                                             0x2
#define HWIO_WBM_R0_RELEASE_RING_ENABLE_2_MLO_IN1_RELEASE_RING_ENABLE_SHFT                                               1

#define HWIO_WBM_R0_MSDU_BUFFER_RING_ENABLE_ADDR(x)                                                             ((x) + 0x1c)
#define HWIO_WBM_R0_MSDU_BUFFER_RING_ENABLE_PHYS(x)                                                             ((x) + 0x1c)
#define HWIO_WBM_R0_MSDU_BUFFER_RING_ENABLE_OFFS                                                                (0x1c)
#define HWIO_WBM_R0_MSDU_BUFFER_RING_ENABLE_RMSK                                                                      0x3f
#define HWIO_WBM_R0_MSDU_BUFFER_RING_ENABLE_POR                                                                 0x00000000
#define HWIO_WBM_R0_MSDU_BUFFER_RING_ENABLE_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_MSDU_BUFFER_RING_ENABLE_ATTR                                                                             0x3
#define HWIO_WBM_R0_MSDU_BUFFER_RING_ENABLE_IN(x)            \
                in_dword(HWIO_WBM_R0_MSDU_BUFFER_RING_ENABLE_ADDR(x))
#define HWIO_WBM_R0_MSDU_BUFFER_RING_ENABLE_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_MSDU_BUFFER_RING_ENABLE_ADDR(x), m)
#define HWIO_WBM_R0_MSDU_BUFFER_RING_ENABLE_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_MSDU_BUFFER_RING_ENABLE_ADDR(x),v)
#define HWIO_WBM_R0_MSDU_BUFFER_RING_ENABLE_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_MSDU_BUFFER_RING_ENABLE_ADDR(x),m,v,HWIO_WBM_R0_MSDU_BUFFER_RING_ENABLE_IN(x))
#define HWIO_WBM_R0_MSDU_BUFFER_RING_ENABLE_WBM2RXDMA2_BUF_RING_ENABLE_BMSK                                           0x20
#define HWIO_WBM_R0_MSDU_BUFFER_RING_ENABLE_WBM2RXDMA2_BUF_RING_ENABLE_SHFT                                              5
#define HWIO_WBM_R0_MSDU_BUFFER_RING_ENABLE_WBM2RXDMA1_BUF_RING_ENABLE_BMSK                                           0x10
#define HWIO_WBM_R0_MSDU_BUFFER_RING_ENABLE_WBM2RXDMA1_BUF_RING_ENABLE_SHFT                                              4
#define HWIO_WBM_R0_MSDU_BUFFER_RING_ENABLE_WBM2RXDMA0_BUF_RING_ENABLE_BMSK                                            0x8
#define HWIO_WBM_R0_MSDU_BUFFER_RING_ENABLE_WBM2RXDMA0_BUF_RING_ENABLE_SHFT                                              3
#define HWIO_WBM_R0_MSDU_BUFFER_RING_ENABLE_WBM2FW_BUF_RING_ENABLE_BMSK                                                0x4
#define HWIO_WBM_R0_MSDU_BUFFER_RING_ENABLE_WBM2FW_BUF_RING_ENABLE_SHFT                                                  2
#define HWIO_WBM_R0_MSDU_BUFFER_RING_ENABLE_WBM2SW_BUF_RING_ENABLE_BMSK                                                0x2
#define HWIO_WBM_R0_MSDU_BUFFER_RING_ENABLE_WBM2SW_BUF_RING_ENABLE_SHFT                                                  1
#define HWIO_WBM_R0_MSDU_BUFFER_RING_ENABLE_WBM2PPE_BUF_RING_ENABLE_BMSK                                               0x1
#define HWIO_WBM_R0_MSDU_BUFFER_RING_ENABLE_WBM2PPE_BUF_RING_ENABLE_SHFT                                                 0

#define HWIO_WBM_R0_LINK_DESC_RING_ENABLE_ADDR(x)                                                               ((x) + 0x20)
#define HWIO_WBM_R0_LINK_DESC_RING_ENABLE_PHYS(x)                                                               ((x) + 0x20)
#define HWIO_WBM_R0_LINK_DESC_RING_ENABLE_OFFS                                                                  (0x20)
#define HWIO_WBM_R0_LINK_DESC_RING_ENABLE_RMSK                                                                        0x7f
#define HWIO_WBM_R0_LINK_DESC_RING_ENABLE_POR                                                                   0x00000000
#define HWIO_WBM_R0_LINK_DESC_RING_ENABLE_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_LINK_DESC_RING_ENABLE_ATTR                                                                               0x3
#define HWIO_WBM_R0_LINK_DESC_RING_ENABLE_IN(x)            \
                in_dword(HWIO_WBM_R0_LINK_DESC_RING_ENABLE_ADDR(x))
#define HWIO_WBM_R0_LINK_DESC_RING_ENABLE_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_LINK_DESC_RING_ENABLE_ADDR(x), m)
#define HWIO_WBM_R0_LINK_DESC_RING_ENABLE_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_LINK_DESC_RING_ENABLE_ADDR(x),v)
#define HWIO_WBM_R0_LINK_DESC_RING_ENABLE_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_LINK_DESC_RING_ENABLE_ADDR(x),m,v,HWIO_WBM_R0_LINK_DESC_RING_ENABLE_IN(x))
#define HWIO_WBM_R0_LINK_DESC_RING_ENABLE_WBM2RXDMA2_LINK_RING_ENABLE_BMSK                                            0x40
#define HWIO_WBM_R0_LINK_DESC_RING_ENABLE_WBM2RXDMA2_LINK_RING_ENABLE_SHFT                                               6
#define HWIO_WBM_R0_LINK_DESC_RING_ENABLE_WBM2RXDMA1_LINK_RING_ENABLE_BMSK                                            0x20
#define HWIO_WBM_R0_LINK_DESC_RING_ENABLE_WBM2RXDMA1_LINK_RING_ENABLE_SHFT                                               5
#define HWIO_WBM_R0_LINK_DESC_RING_ENABLE_WBM2RXDMA0_LINK_RING_ENABLE_BMSK                                            0x10
#define HWIO_WBM_R0_LINK_DESC_RING_ENABLE_WBM2RXDMA0_LINK_RING_ENABLE_SHFT                                               4
#define HWIO_WBM_R0_LINK_DESC_RING_ENABLE_WBM2FW_LINK_RING_ENABLE_BMSK                                                 0x8
#define HWIO_WBM_R0_LINK_DESC_RING_ENABLE_WBM2FW_LINK_RING_ENABLE_SHFT                                                   3
#define HWIO_WBM_R0_LINK_DESC_RING_ENABLE_WBM2SW_LINK_RING_ENABLE_BMSK                                                 0x4
#define HWIO_WBM_R0_LINK_DESC_RING_ENABLE_WBM2SW_LINK_RING_ENABLE_SHFT                                                   2
#define HWIO_WBM_R0_LINK_DESC_RING_ENABLE_WBM2REO_LINK_RING_ENABLE_BMSK                                                0x2
#define HWIO_WBM_R0_LINK_DESC_RING_ENABLE_WBM2REO_LINK_RING_ENABLE_SHFT                                                  1
#define HWIO_WBM_R0_LINK_DESC_RING_ENABLE_WBM2TQM_LINK_RING_ENABLE_BMSK                                                0x1
#define HWIO_WBM_R0_LINK_DESC_RING_ENABLE_WBM2TQM_LINK_RING_ENABLE_SHFT                                                  0

#define HWIO_WBM_R0_OWN_CHIP_ID_ADDR(x)                                                                         ((x) + 0x24)
#define HWIO_WBM_R0_OWN_CHIP_ID_PHYS(x)                                                                         ((x) + 0x24)
#define HWIO_WBM_R0_OWN_CHIP_ID_OFFS                                                                            (0x24)
#define HWIO_WBM_R0_OWN_CHIP_ID_RMSK                                                                                   0xf
#define HWIO_WBM_R0_OWN_CHIP_ID_POR                                                                             0x00000001
#define HWIO_WBM_R0_OWN_CHIP_ID_POR_RMSK                                                                        0xffffffff
#define HWIO_WBM_R0_OWN_CHIP_ID_ATTR                                                                                         0x3
#define HWIO_WBM_R0_OWN_CHIP_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_OWN_CHIP_ID_ADDR(x))
#define HWIO_WBM_R0_OWN_CHIP_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_OWN_CHIP_ID_ADDR(x), m)
#define HWIO_WBM_R0_OWN_CHIP_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_OWN_CHIP_ID_ADDR(x),v)
#define HWIO_WBM_R0_OWN_CHIP_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_OWN_CHIP_ID_ADDR(x),m,v,HWIO_WBM_R0_OWN_CHIP_ID_IN(x))
#define HWIO_WBM_R0_OWN_CHIP_ID_RBM_BMSK                                                                               0xf
#define HWIO_WBM_R0_OWN_CHIP_ID_RBM_SHFT                                                                                 0

#define HWIO_WBM_R0_MLO_OUT1_CFG_ADDR(x)                                                                        ((x) + 0x28)
#define HWIO_WBM_R0_MLO_OUT1_CFG_PHYS(x)                                                                        ((x) + 0x28)
#define HWIO_WBM_R0_MLO_OUT1_CFG_OFFS                                                                           (0x28)
#define HWIO_WBM_R0_MLO_OUT1_CFG_RMSK                                                                                0x3ff
#define HWIO_WBM_R0_MLO_OUT1_CFG_POR                                                                            0x00000005
#define HWIO_WBM_R0_MLO_OUT1_CFG_POR_RMSK                                                                       0xffffffff
#define HWIO_WBM_R0_MLO_OUT1_CFG_ATTR                                                                                        0x3
#define HWIO_WBM_R0_MLO_OUT1_CFG_IN(x)            \
                in_dword(HWIO_WBM_R0_MLO_OUT1_CFG_ADDR(x))
#define HWIO_WBM_R0_MLO_OUT1_CFG_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_MLO_OUT1_CFG_ADDR(x), m)
#define HWIO_WBM_R0_MLO_OUT1_CFG_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_MLO_OUT1_CFG_ADDR(x),v)
#define HWIO_WBM_R0_MLO_OUT1_CFG_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_MLO_OUT1_CFG_ADDR(x),m,v,HWIO_WBM_R0_MLO_OUT1_CFG_IN(x))
#define HWIO_WBM_R0_MLO_OUT1_CFG_RBM2_BMSK                                                                           0x3c0
#define HWIO_WBM_R0_MLO_OUT1_CFG_RBM2_SHFT                                                                               6
#define HWIO_WBM_R0_MLO_OUT1_CFG_RBM2_ENABLE_BMSK                                                                     0x20
#define HWIO_WBM_R0_MLO_OUT1_CFG_RBM2_ENABLE_SHFT                                                                        5
#define HWIO_WBM_R0_MLO_OUT1_CFG_RBM1_BMSK                                                                            0x1e
#define HWIO_WBM_R0_MLO_OUT1_CFG_RBM1_SHFT                                                                               1
#define HWIO_WBM_R0_MLO_OUT1_CFG_RBM1_ENABLE_BMSK                                                                      0x1
#define HWIO_WBM_R0_MLO_OUT1_CFG_RBM1_ENABLE_SHFT                                                                        0

#define HWIO_WBM_R0_MLO_OUT2_CFG_ADDR(x)                                                                        ((x) + 0x2c)
#define HWIO_WBM_R0_MLO_OUT2_CFG_PHYS(x)                                                                        ((x) + 0x2c)
#define HWIO_WBM_R0_MLO_OUT2_CFG_OFFS                                                                           (0x2c)
#define HWIO_WBM_R0_MLO_OUT2_CFG_RMSK                                                                                0x3ff
#define HWIO_WBM_R0_MLO_OUT2_CFG_POR                                                                            0x00000007
#define HWIO_WBM_R0_MLO_OUT2_CFG_POR_RMSK                                                                       0xffffffff
#define HWIO_WBM_R0_MLO_OUT2_CFG_ATTR                                                                                        0x3
#define HWIO_WBM_R0_MLO_OUT2_CFG_IN(x)            \
                in_dword(HWIO_WBM_R0_MLO_OUT2_CFG_ADDR(x))
#define HWIO_WBM_R0_MLO_OUT2_CFG_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_MLO_OUT2_CFG_ADDR(x), m)
#define HWIO_WBM_R0_MLO_OUT2_CFG_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_MLO_OUT2_CFG_ADDR(x),v)
#define HWIO_WBM_R0_MLO_OUT2_CFG_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_MLO_OUT2_CFG_ADDR(x),m,v,HWIO_WBM_R0_MLO_OUT2_CFG_IN(x))
#define HWIO_WBM_R0_MLO_OUT2_CFG_RBM2_BMSK                                                                           0x3c0
#define HWIO_WBM_R0_MLO_OUT2_CFG_RBM2_SHFT                                                                               6
#define HWIO_WBM_R0_MLO_OUT2_CFG_RBM2_ENABLE_BMSK                                                                     0x20
#define HWIO_WBM_R0_MLO_OUT2_CFG_RBM2_ENABLE_SHFT                                                                        5
#define HWIO_WBM_R0_MLO_OUT2_CFG_RBM1_BMSK                                                                            0x1e
#define HWIO_WBM_R0_MLO_OUT2_CFG_RBM1_SHFT                                                                               1
#define HWIO_WBM_R0_MLO_OUT2_CFG_RBM1_ENABLE_BMSK                                                                      0x1
#define HWIO_WBM_R0_MLO_OUT2_CFG_RBM1_ENABLE_SHFT                                                                        0

#define HWIO_WBM_R0_MISC_RING_ENABLE_ADDR(x)                                                                    ((x) + 0x30)
#define HWIO_WBM_R0_MISC_RING_ENABLE_PHYS(x)                                                                    ((x) + 0x30)
#define HWIO_WBM_R0_MISC_RING_ENABLE_OFFS                                                                       (0x30)
#define HWIO_WBM_R0_MISC_RING_ENABLE_RMSK                                                                            0x7ff
#define HWIO_WBM_R0_MISC_RING_ENABLE_POR                                                                        0x000007ff
#define HWIO_WBM_R0_MISC_RING_ENABLE_POR_RMSK                                                                   0xffffffff
#define HWIO_WBM_R0_MISC_RING_ENABLE_ATTR                                                                                    0x3
#define HWIO_WBM_R0_MISC_RING_ENABLE_IN(x)            \
                in_dword(HWIO_WBM_R0_MISC_RING_ENABLE_ADDR(x))
#define HWIO_WBM_R0_MISC_RING_ENABLE_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_MISC_RING_ENABLE_ADDR(x), m)
#define HWIO_WBM_R0_MISC_RING_ENABLE_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_MISC_RING_ENABLE_ADDR(x),v)
#define HWIO_WBM_R0_MISC_RING_ENABLE_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_MISC_RING_ENABLE_ADDR(x),m,v,HWIO_WBM_R0_MISC_RING_ENABLE_IN(x))
#define HWIO_WBM_R0_MISC_RING_ENABLE_WBM2WBM_OUT2_MLO_RELEASE_RING_ENABLE_BMSK                                       0x400
#define HWIO_WBM_R0_MISC_RING_ENABLE_WBM2WBM_OUT2_MLO_RELEASE_RING_ENABLE_SHFT                                          10
#define HWIO_WBM_R0_MISC_RING_ENABLE_WBM2WBM_OUT1_MLO_RELEASE_RING_ENABLE_BMSK                                       0x200
#define HWIO_WBM_R0_MISC_RING_ENABLE_WBM2WBM_OUT1_MLO_RELEASE_RING_ENABLE_SHFT                                           9
#define HWIO_WBM_R0_MISC_RING_ENABLE_WBM2SW6_RELEASE_RING_ENABLE_BMSK                                                0x100
#define HWIO_WBM_R0_MISC_RING_ENABLE_WBM2SW6_RELEASE_RING_ENABLE_SHFT                                                    8
#define HWIO_WBM_R0_MISC_RING_ENABLE_WBM2SW5_RELEASE_RING_ENABLE_BMSK                                                 0x80
#define HWIO_WBM_R0_MISC_RING_ENABLE_WBM2SW5_RELEASE_RING_ENABLE_SHFT                                                    7
#define HWIO_WBM_R0_MISC_RING_ENABLE_WBM_ERROR_RELEASE_RING_ENABLE_BMSK                                               0x40
#define HWIO_WBM_R0_MISC_RING_ENABLE_WBM_ERROR_RELEASE_RING_ENABLE_SHFT                                                  6
#define HWIO_WBM_R0_MISC_RING_ENABLE_WBM2SW4_RELEASE_RING_ENABLE_BMSK                                                 0x20
#define HWIO_WBM_R0_MISC_RING_ENABLE_WBM2SW4_RELEASE_RING_ENABLE_SHFT                                                    5
#define HWIO_WBM_R0_MISC_RING_ENABLE_WBM2SW3_RELEASE_RING_ENABLE_BMSK                                                 0x10
#define HWIO_WBM_R0_MISC_RING_ENABLE_WBM2SW3_RELEASE_RING_ENABLE_SHFT                                                    4
#define HWIO_WBM_R0_MISC_RING_ENABLE_WBM2SW2_RELEASE_RING_ENABLE_BMSK                                                  0x8
#define HWIO_WBM_R0_MISC_RING_ENABLE_WBM2SW2_RELEASE_RING_ENABLE_SHFT                                                    3
#define HWIO_WBM_R0_MISC_RING_ENABLE_WBM2SW1_RELEASE_RING_ENABLE_BMSK                                                  0x4
#define HWIO_WBM_R0_MISC_RING_ENABLE_WBM2SW1_RELEASE_RING_ENABLE_SHFT                                                    2
#define HWIO_WBM_R0_MISC_RING_ENABLE_WBM2SW0_RELEASE_RING_ENABLE_BMSK                                                  0x2
#define HWIO_WBM_R0_MISC_RING_ENABLE_WBM2SW0_RELEASE_RING_ENABLE_SHFT                                                    1
#define HWIO_WBM_R0_MISC_RING_ENABLE_WBM2FW_RELEASE_RING_ENABLE_BMSK                                                   0x1
#define HWIO_WBM_R0_MISC_RING_ENABLE_WBM2FW_RELEASE_RING_ENABLE_SHFT                                                     0

#define HWIO_WBM_R0_RELEASE_RING_STATUS_ADDR(x)                                                                 ((x) + 0x34)
#define HWIO_WBM_R0_RELEASE_RING_STATUS_PHYS(x)                                                                 ((x) + 0x34)
#define HWIO_WBM_R0_RELEASE_RING_STATUS_OFFS                                                                    (0x34)
#define HWIO_WBM_R0_RELEASE_RING_STATUS_RMSK                                                                          0xfe
#define HWIO_WBM_R0_RELEASE_RING_STATUS_POR                                                                     0x00000000
#define HWIO_WBM_R0_RELEASE_RING_STATUS_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_RELEASE_RING_STATUS_ATTR                                                                                 0x1
#define HWIO_WBM_R0_RELEASE_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_RELEASE_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_RELEASE_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RELEASE_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_RELEASE_RING_STATUS_RXDMA2_RELEASE_RING_NOT_IDLE_BMSK                                             0x80
#define HWIO_WBM_R0_RELEASE_RING_STATUS_RXDMA2_RELEASE_RING_NOT_IDLE_SHFT                                                7
#define HWIO_WBM_R0_RELEASE_RING_STATUS_RXDMA1_RELEASE_RING_NOT_IDLE_BMSK                                             0x40
#define HWIO_WBM_R0_RELEASE_RING_STATUS_RXDMA1_RELEASE_RING_NOT_IDLE_SHFT                                                6
#define HWIO_WBM_R0_RELEASE_RING_STATUS_RXDMA0_RELEASE_RING_NOT_IDLE_BMSK                                             0x20
#define HWIO_WBM_R0_RELEASE_RING_STATUS_RXDMA0_RELEASE_RING_NOT_IDLE_SHFT                                                5
#define HWIO_WBM_R0_RELEASE_RING_STATUS_FW_RELEASE_RING_NOT_IDLE_BMSK                                                 0x10
#define HWIO_WBM_R0_RELEASE_RING_STATUS_FW_RELEASE_RING_NOT_IDLE_SHFT                                                    4
#define HWIO_WBM_R0_RELEASE_RING_STATUS_SW_RELEASE_RING_NOT_IDLE_BMSK                                                  0x8
#define HWIO_WBM_R0_RELEASE_RING_STATUS_SW_RELEASE_RING_NOT_IDLE_SHFT                                                    3
#define HWIO_WBM_R0_RELEASE_RING_STATUS_REO_RELEASE_RING_NOT_IDLE_BMSK                                                 0x4
#define HWIO_WBM_R0_RELEASE_RING_STATUS_REO_RELEASE_RING_NOT_IDLE_SHFT                                                   2
#define HWIO_WBM_R0_RELEASE_RING_STATUS_TQM_RELEASE_RING_NOT_IDLE_BMSK                                                 0x2
#define HWIO_WBM_R0_RELEASE_RING_STATUS_TQM_RELEASE_RING_NOT_IDLE_SHFT                                                   1

#define HWIO_WBM_R0_RELEASE_RING_STATUS_2_ADDR(x)                                                               ((x) + 0x38)
#define HWIO_WBM_R0_RELEASE_RING_STATUS_2_PHYS(x)                                                               ((x) + 0x38)
#define HWIO_WBM_R0_RELEASE_RING_STATUS_2_OFFS                                                                  (0x38)
#define HWIO_WBM_R0_RELEASE_RING_STATUS_2_RMSK                                                                         0x6
#define HWIO_WBM_R0_RELEASE_RING_STATUS_2_POR                                                                   0x00000000
#define HWIO_WBM_R0_RELEASE_RING_STATUS_2_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_RELEASE_RING_STATUS_2_ATTR                                                                               0x1
#define HWIO_WBM_R0_RELEASE_RING_STATUS_2_IN(x)            \
                in_dword(HWIO_WBM_R0_RELEASE_RING_STATUS_2_ADDR(x))
#define HWIO_WBM_R0_RELEASE_RING_STATUS_2_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RELEASE_RING_STATUS_2_ADDR(x), m)
#define HWIO_WBM_R0_RELEASE_RING_STATUS_2_WBM2WBM_IN2_MLO_RING_NOT_IDLE_BMSK                                           0x4
#define HWIO_WBM_R0_RELEASE_RING_STATUS_2_WBM2WBM_IN2_MLO_RING_NOT_IDLE_SHFT                                             2
#define HWIO_WBM_R0_RELEASE_RING_STATUS_2_WBM2WBM_IN1_MLO_RING_NOT_IDLE_BMSK                                           0x2
#define HWIO_WBM_R0_RELEASE_RING_STATUS_2_WBM2WBM_IN1_MLO_RING_NOT_IDLE_SHFT                                             1

#define HWIO_WBM_R0_DUP_DET_START_COOKIE_ADDR(x)                                                                ((x) + 0x3c)
#define HWIO_WBM_R0_DUP_DET_START_COOKIE_PHYS(x)                                                                ((x) + 0x3c)
#define HWIO_WBM_R0_DUP_DET_START_COOKIE_OFFS                                                                   (0x3c)
#define HWIO_WBM_R0_DUP_DET_START_COOKIE_RMSK                                                                      0xfffff
#define HWIO_WBM_R0_DUP_DET_START_COOKIE_POR                                                                    0x00000000
#define HWIO_WBM_R0_DUP_DET_START_COOKIE_POR_RMSK                                                               0xffffffff
#define HWIO_WBM_R0_DUP_DET_START_COOKIE_ATTR                                                                                0x3
#define HWIO_WBM_R0_DUP_DET_START_COOKIE_IN(x)            \
                in_dword(HWIO_WBM_R0_DUP_DET_START_COOKIE_ADDR(x))
#define HWIO_WBM_R0_DUP_DET_START_COOKIE_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_DUP_DET_START_COOKIE_ADDR(x), m)
#define HWIO_WBM_R0_DUP_DET_START_COOKIE_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_DUP_DET_START_COOKIE_ADDR(x),v)
#define HWIO_WBM_R0_DUP_DET_START_COOKIE_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_DUP_DET_START_COOKIE_ADDR(x),m,v,HWIO_WBM_R0_DUP_DET_START_COOKIE_IN(x))
#define HWIO_WBM_R0_DUP_DET_START_COOKIE_DUP_DET_START_COOKIE_BMSK                                                 0xfffff
#define HWIO_WBM_R0_DUP_DET_START_COOKIE_DUP_DET_START_COOKIE_SHFT                                                       0

#define HWIO_WBM_R0_SW_COOKIE_CFG0_ADDR(x)                                                                      ((x) + 0x40)
#define HWIO_WBM_R0_SW_COOKIE_CFG0_PHYS(x)                                                                      ((x) + 0x40)
#define HWIO_WBM_R0_SW_COOKIE_CFG0_OFFS                                                                         (0x40)
#define HWIO_WBM_R0_SW_COOKIE_CFG0_RMSK                                                                         0xffffffff
#define HWIO_WBM_R0_SW_COOKIE_CFG0_POR                                                                          0x00000000
#define HWIO_WBM_R0_SW_COOKIE_CFG0_POR_RMSK                                                                     0xffffffff
#define HWIO_WBM_R0_SW_COOKIE_CFG0_ATTR                                                                                      0x3
#define HWIO_WBM_R0_SW_COOKIE_CFG0_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_COOKIE_CFG0_ADDR(x))
#define HWIO_WBM_R0_SW_COOKIE_CFG0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_COOKIE_CFG0_ADDR(x), m)
#define HWIO_WBM_R0_SW_COOKIE_CFG0_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_COOKIE_CFG0_ADDR(x),v)
#define HWIO_WBM_R0_SW_COOKIE_CFG0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_COOKIE_CFG0_ADDR(x),m,v,HWIO_WBM_R0_SW_COOKIE_CFG0_IN(x))
#define HWIO_WBM_R0_SW_COOKIE_CFG0_CMEM_LUT_BASE_ADDR_31_0_BMSK                                                 0xffffffff
#define HWIO_WBM_R0_SW_COOKIE_CFG0_CMEM_LUT_BASE_ADDR_31_0_SHFT                                                          0

#define HWIO_WBM_R0_SW_COOKIE_CFG1_ADDR(x)                                                                      ((x) + 0x44)
#define HWIO_WBM_R0_SW_COOKIE_CFG1_PHYS(x)                                                                      ((x) + 0x44)
#define HWIO_WBM_R0_SW_COOKIE_CFG1_OFFS                                                                         (0x44)
#define HWIO_WBM_R0_SW_COOKIE_CFG1_RMSK                                                                            0x7ffff
#define HWIO_WBM_R0_SW_COOKIE_CFG1_POR                                                                          0x00011700
#define HWIO_WBM_R0_SW_COOKIE_CFG1_POR_RMSK                                                                     0xffffffff
#define HWIO_WBM_R0_SW_COOKIE_CFG1_ATTR                                                                                      0x3
#define HWIO_WBM_R0_SW_COOKIE_CFG1_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_COOKIE_CFG1_ADDR(x))
#define HWIO_WBM_R0_SW_COOKIE_CFG1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_COOKIE_CFG1_ADDR(x), m)
#define HWIO_WBM_R0_SW_COOKIE_CFG1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_COOKIE_CFG1_ADDR(x),v)
#define HWIO_WBM_R0_SW_COOKIE_CFG1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_COOKIE_CFG1_ADDR(x),m,v,HWIO_WBM_R0_SW_COOKIE_CFG1_IN(x))
#define HWIO_WBM_R0_SW_COOKIE_CFG1_PAGE_ALIGNMENT_BMSK                                                             0x40000
#define HWIO_WBM_R0_SW_COOKIE_CFG1_PAGE_ALIGNMENT_SHFT                                                                  18
#define HWIO_WBM_R0_SW_COOKIE_CFG1_COOKIE_OFFSET_MSB_BMSK                                                          0x3e000
#define HWIO_WBM_R0_SW_COOKIE_CFG1_COOKIE_OFFSET_MSB_SHFT                                                               13
#define HWIO_WBM_R0_SW_COOKIE_CFG1_COOKIE_PAGE_MSB_BMSK                                                             0x1f00
#define HWIO_WBM_R0_SW_COOKIE_CFG1_COOKIE_PAGE_MSB_SHFT                                                                  8
#define HWIO_WBM_R0_SW_COOKIE_CFG1_CMEM_LUT_BASE_ADDR_39_32_BMSK                                                      0xff
#define HWIO_WBM_R0_SW_COOKIE_CFG1_CMEM_LUT_BASE_ADDR_39_32_SHFT                                                         0

#define HWIO_WBM_R0_BP_WARNING_STATUS_ADDR(x)                                                                   ((x) + 0x48)
#define HWIO_WBM_R0_BP_WARNING_STATUS_PHYS(x)                                                                   ((x) + 0x48)
#define HWIO_WBM_R0_BP_WARNING_STATUS_OFFS                                                                      (0x48)
#define HWIO_WBM_R0_BP_WARNING_STATUS_RMSK                                                                      0xffffffff
#define HWIO_WBM_R0_BP_WARNING_STATUS_POR                                                                       0x00000000
#define HWIO_WBM_R0_BP_WARNING_STATUS_POR_RMSK                                                                  0xffffffff
#define HWIO_WBM_R0_BP_WARNING_STATUS_ATTR                                                                                   0x1
#define HWIO_WBM_R0_BP_WARNING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_BP_WARNING_STATUS_ADDR(x))
#define HWIO_WBM_R0_BP_WARNING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_BP_WARNING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_BP_WARNING_STATUS_BP_STATUS_BMSK                                                            0xffffffff
#define HWIO_WBM_R0_BP_WARNING_STATUS_BP_STATUS_SHFT                                                                     0

#define HWIO_WBM_R0_MSDU_BUFFER_RING_STATUS_ADDR(x)                                                             ((x) + 0x4c)
#define HWIO_WBM_R0_MSDU_BUFFER_RING_STATUS_PHYS(x)                                                             ((x) + 0x4c)
#define HWIO_WBM_R0_MSDU_BUFFER_RING_STATUS_OFFS                                                                (0x4c)
#define HWIO_WBM_R0_MSDU_BUFFER_RING_STATUS_RMSK                                                                      0x3f
#define HWIO_WBM_R0_MSDU_BUFFER_RING_STATUS_POR                                                                 0x00000000
#define HWIO_WBM_R0_MSDU_BUFFER_RING_STATUS_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_MSDU_BUFFER_RING_STATUS_ATTR                                                                             0x1
#define HWIO_WBM_R0_MSDU_BUFFER_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_MSDU_BUFFER_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_MSDU_BUFFER_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_MSDU_BUFFER_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_MSDU_BUFFER_RING_STATUS_WBM2RXDMA2_BUF_RING_NOT_IDLE_BMSK                                         0x20
#define HWIO_WBM_R0_MSDU_BUFFER_RING_STATUS_WBM2RXDMA2_BUF_RING_NOT_IDLE_SHFT                                            5
#define HWIO_WBM_R0_MSDU_BUFFER_RING_STATUS_WBM2RXDMA1_BUF_RING_NOT_IDLE_BMSK                                         0x10
#define HWIO_WBM_R0_MSDU_BUFFER_RING_STATUS_WBM2RXDMA1_BUF_RING_NOT_IDLE_SHFT                                            4
#define HWIO_WBM_R0_MSDU_BUFFER_RING_STATUS_WBM2RXDMA0_BUF_RING_NOT_IDLE_BMSK                                          0x8
#define HWIO_WBM_R0_MSDU_BUFFER_RING_STATUS_WBM2RXDMA0_BUF_RING_NOT_IDLE_SHFT                                            3
#define HWIO_WBM_R0_MSDU_BUFFER_RING_STATUS_WBM2FW_BUF_RING_NOT_IDLE_BMSK                                              0x4
#define HWIO_WBM_R0_MSDU_BUFFER_RING_STATUS_WBM2FW_BUF_RING_NOT_IDLE_SHFT                                                2
#define HWIO_WBM_R0_MSDU_BUFFER_RING_STATUS_WBM2SW_BUF_RING_NOT_IDLE_BMSK                                              0x2
#define HWIO_WBM_R0_MSDU_BUFFER_RING_STATUS_WBM2SW_BUF_RING_NOT_IDLE_SHFT                                                1
#define HWIO_WBM_R0_MSDU_BUFFER_RING_STATUS_WBM2PPE_BUF_RING_NOT_IDLE_BMSK                                             0x1
#define HWIO_WBM_R0_MSDU_BUFFER_RING_STATUS_WBM2PPE_BUF_RING_NOT_IDLE_SHFT                                               0

#define HWIO_WBM_R0_LINK_DESC_RING_STATUS_ADDR(x)                                                               ((x) + 0x50)
#define HWIO_WBM_R0_LINK_DESC_RING_STATUS_PHYS(x)                                                               ((x) + 0x50)
#define HWIO_WBM_R0_LINK_DESC_RING_STATUS_OFFS                                                                  (0x50)
#define HWIO_WBM_R0_LINK_DESC_RING_STATUS_RMSK                                                                        0x7f
#define HWIO_WBM_R0_LINK_DESC_RING_STATUS_POR                                                                   0x00000000
#define HWIO_WBM_R0_LINK_DESC_RING_STATUS_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_LINK_DESC_RING_STATUS_ATTR                                                                               0x1
#define HWIO_WBM_R0_LINK_DESC_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_LINK_DESC_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_LINK_DESC_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_LINK_DESC_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_LINK_DESC_RING_STATUS_WBM2RXDMA2_LINK_RING_NOT_IDLE_BMSK                                          0x40
#define HWIO_WBM_R0_LINK_DESC_RING_STATUS_WBM2RXDMA2_LINK_RING_NOT_IDLE_SHFT                                             6
#define HWIO_WBM_R0_LINK_DESC_RING_STATUS_WBM2RXDMA1_LINK_RING_NOT_IDLE_BMSK                                          0x20
#define HWIO_WBM_R0_LINK_DESC_RING_STATUS_WBM2RXDMA1_LINK_RING_NOT_IDLE_SHFT                                             5
#define HWIO_WBM_R0_LINK_DESC_RING_STATUS_WBM2RXDMA0_LINK_RING_NOT_IDLE_BMSK                                          0x10
#define HWIO_WBM_R0_LINK_DESC_RING_STATUS_WBM2RXDMA0_LINK_RING_NOT_IDLE_SHFT                                             4
#define HWIO_WBM_R0_LINK_DESC_RING_STATUS_WBM2FW_LINK_RING_NOT_IDLE_BMSK                                               0x8
#define HWIO_WBM_R0_LINK_DESC_RING_STATUS_WBM2FW_LINK_RING_NOT_IDLE_SHFT                                                 3
#define HWIO_WBM_R0_LINK_DESC_RING_STATUS_WBM2SW_LINK_RING_NOT_IDLE_BMSK                                               0x4
#define HWIO_WBM_R0_LINK_DESC_RING_STATUS_WBM2SW_LINK_RING_NOT_IDLE_SHFT                                                 2
#define HWIO_WBM_R0_LINK_DESC_RING_STATUS_WBM2REO_LINK_RING_NOT_IDLE_BMSK                                              0x2
#define HWIO_WBM_R0_LINK_DESC_RING_STATUS_WBM2REO_LINK_RING_NOT_IDLE_SHFT                                                1
#define HWIO_WBM_R0_LINK_DESC_RING_STATUS_WBM2TQM_LINK_RING_NOT_IDLE_BMSK                                              0x1
#define HWIO_WBM_R0_LINK_DESC_RING_STATUS_WBM2TQM_LINK_RING_NOT_IDLE_SHFT                                                0

#define HWIO_WBM_R0_MISC_RING_STATUS_ADDR(x)                                                                    ((x) + 0x54)
#define HWIO_WBM_R0_MISC_RING_STATUS_PHYS(x)                                                                    ((x) + 0x54)
#define HWIO_WBM_R0_MISC_RING_STATUS_OFFS                                                                       (0x54)
#define HWIO_WBM_R0_MISC_RING_STATUS_RMSK                                                                           0x1fff
#define HWIO_WBM_R0_MISC_RING_STATUS_POR                                                                        0x00000000
#define HWIO_WBM_R0_MISC_RING_STATUS_POR_RMSK                                                                   0xffffffff
#define HWIO_WBM_R0_MISC_RING_STATUS_ATTR                                                                                    0x1
#define HWIO_WBM_R0_MISC_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_MISC_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_MISC_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_MISC_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_MISC_RING_STATUS_SW6_BUFFER_RING_NOT_IDLE_BMSK                                                  0x1000
#define HWIO_WBM_R0_MISC_RING_STATUS_SW6_BUFFER_RING_NOT_IDLE_SHFT                                                      12
#define HWIO_WBM_R0_MISC_RING_STATUS_SW5_BUFFER_RING_NOT_IDLE_BMSK                                                   0x800
#define HWIO_WBM_R0_MISC_RING_STATUS_SW5_BUFFER_RING_NOT_IDLE_SHFT                                                      11
#define HWIO_WBM_R0_MISC_RING_STATUS_ERROR_RELEASE_RING_NOT_IDLE_BMSK                                                0x400
#define HWIO_WBM_R0_MISC_RING_STATUS_ERROR_RELEASE_RING_NOT_IDLE_SHFT                                                   10
#define HWIO_WBM_R0_MISC_RING_STATUS_SW4_BUFFER_RING_NOT_IDLE_BMSK                                                   0x200
#define HWIO_WBM_R0_MISC_RING_STATUS_SW4_BUFFER_RING_NOT_IDLE_SHFT                                                       9
#define HWIO_WBM_R0_MISC_RING_STATUS_SW3_BUFFER_RING_NOT_IDLE_BMSK                                                   0x100
#define HWIO_WBM_R0_MISC_RING_STATUS_SW3_BUFFER_RING_NOT_IDLE_SHFT                                                       8
#define HWIO_WBM_R0_MISC_RING_STATUS_SW2_BUFFER_RING_NOT_IDLE_BMSK                                                    0x80
#define HWIO_WBM_R0_MISC_RING_STATUS_SW2_BUFFER_RING_NOT_IDLE_SHFT                                                       7
#define HWIO_WBM_R0_MISC_RING_STATUS_SW1_BUFFER_RING_NOT_IDLE_BMSK                                                    0x40
#define HWIO_WBM_R0_MISC_RING_STATUS_SW1_BUFFER_RING_NOT_IDLE_SHFT                                                       6
#define HWIO_WBM_R0_MISC_RING_STATUS_SW0_BUFFER_RING_NOT_IDLE_BMSK                                                    0x20
#define HWIO_WBM_R0_MISC_RING_STATUS_SW0_BUFFER_RING_NOT_IDLE_SHFT                                                       5
#define HWIO_WBM_R0_MISC_RING_STATUS_FW_BUFFER_RING_NOT_IDLE_BMSK                                                     0x10
#define HWIO_WBM_R0_MISC_RING_STATUS_FW_BUFFER_RING_NOT_IDLE_SHFT                                                        4
#define HWIO_WBM_R0_MISC_RING_STATUS_LINK_IDLE_LIST_CONSUMER_NOT_IDLE_BMSK                                             0x8
#define HWIO_WBM_R0_MISC_RING_STATUS_LINK_IDLE_LIST_CONSUMER_NOT_IDLE_SHFT                                               3
#define HWIO_WBM_R0_MISC_RING_STATUS_LINK_IDLE_LIST_PRODUCER_NOT_IDLE_BMSK                                             0x4
#define HWIO_WBM_R0_MISC_RING_STATUS_LINK_IDLE_LIST_PRODUCER_NOT_IDLE_SHFT                                               2
#define HWIO_WBM_R0_MISC_RING_STATUS_BUFFER_IDLE_LIST_CONSUMER_NOT_IDLE_BMSK                                           0x2
#define HWIO_WBM_R0_MISC_RING_STATUS_BUFFER_IDLE_LIST_CONSUMER_NOT_IDLE_SHFT                                             1
#define HWIO_WBM_R0_MISC_RING_STATUS_BUFFER_IDLE_LIST_PRODUCER_NOT_IDLE_BMSK                                           0x1
#define HWIO_WBM_R0_MISC_RING_STATUS_BUFFER_IDLE_LIST_PRODUCER_NOT_IDLE_SHFT                                             0

#define HWIO_WBM_R0_RELEASE_RING_FLUSH_ADDR(x)                                                                  ((x) + 0x58)
#define HWIO_WBM_R0_RELEASE_RING_FLUSH_PHYS(x)                                                                  ((x) + 0x58)
#define HWIO_WBM_R0_RELEASE_RING_FLUSH_OFFS                                                                     (0x58)
#define HWIO_WBM_R0_RELEASE_RING_FLUSH_RMSK                                                                        0x13fff
#define HWIO_WBM_R0_RELEASE_RING_FLUSH_POR                                                                      0x00000000
#define HWIO_WBM_R0_RELEASE_RING_FLUSH_POR_RMSK                                                                 0xffffffff
#define HWIO_WBM_R0_RELEASE_RING_FLUSH_ATTR                                                                                  0x3
#define HWIO_WBM_R0_RELEASE_RING_FLUSH_IN(x)            \
                in_dword(HWIO_WBM_R0_RELEASE_RING_FLUSH_ADDR(x))
#define HWIO_WBM_R0_RELEASE_RING_FLUSH_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RELEASE_RING_FLUSH_ADDR(x), m)
#define HWIO_WBM_R0_RELEASE_RING_FLUSH_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_RELEASE_RING_FLUSH_ADDR(x),v)
#define HWIO_WBM_R0_RELEASE_RING_FLUSH_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_RELEASE_RING_FLUSH_ADDR(x),m,v,HWIO_WBM_R0_RELEASE_RING_FLUSH_IN(x))
#define HWIO_WBM_R0_RELEASE_RING_FLUSH_RELEASE_RING_AGE_IN_FLUSH_BMSK                                              0x10000
#define HWIO_WBM_R0_RELEASE_RING_FLUSH_RELEASE_RING_AGE_IN_FLUSH_SHFT                                                   16
#define HWIO_WBM_R0_RELEASE_RING_FLUSH_SW_RELEASE_FIFO_FLUSH_BMSK                                                   0x2000
#define HWIO_WBM_R0_RELEASE_RING_FLUSH_SW_RELEASE_FIFO_FLUSH_SHFT                                                       13
#define HWIO_WBM_R0_RELEASE_RING_FLUSH_SW_RELEASE_RING_AGE_FLUSH_BMSK                                               0x1000
#define HWIO_WBM_R0_RELEASE_RING_FLUSH_SW_RELEASE_RING_AGE_FLUSH_SHFT                                                   12
#define HWIO_WBM_R0_RELEASE_RING_FLUSH_RELEASE_RING_AGE_TIMEOUT_BMSK                                                 0xfff
#define HWIO_WBM_R0_RELEASE_RING_FLUSH_RELEASE_RING_AGE_TIMEOUT_SHFT                                                     0

#define HWIO_WBM_R0_IDLE_STATUS_ADDR(x)                                                                         ((x) + 0x5c)
#define HWIO_WBM_R0_IDLE_STATUS_PHYS(x)                                                                         ((x) + 0x5c)
#define HWIO_WBM_R0_IDLE_STATUS_OFFS                                                                            (0x5c)
#define HWIO_WBM_R0_IDLE_STATUS_RMSK                                                                              0x17ffff
#define HWIO_WBM_R0_IDLE_STATUS_POR                                                                             0x00000000
#define HWIO_WBM_R0_IDLE_STATUS_POR_RMSK                                                                        0xffffffff
#define HWIO_WBM_R0_IDLE_STATUS_ATTR                                                                                         0x1
#define HWIO_WBM_R0_IDLE_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_IDLE_STATUS_ADDR(x))
#define HWIO_WBM_R0_IDLE_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_IDLE_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_IDLE_STATUS_WBM2WBM_OUT2_MLO_PROD_FIFO_IN_IDLE_BMSK                                           0x100000
#define HWIO_WBM_R0_IDLE_STATUS_WBM2WBM_OUT2_MLO_PROD_FIFO_IN_IDLE_SHFT                                                 20
#define HWIO_WBM_R0_IDLE_STATUS_SW6_BUFFER_PROD_FIFO_IN_IDLE_BMSK                                                  0x40000
#define HWIO_WBM_R0_IDLE_STATUS_SW6_BUFFER_PROD_FIFO_IN_IDLE_SHFT                                                       18
#define HWIO_WBM_R0_IDLE_STATUS_SW5_BUFFER_PROD_FIFO_IN_IDLE_BMSK                                                  0x20000
#define HWIO_WBM_R0_IDLE_STATUS_SW5_BUFFER_PROD_FIFO_IN_IDLE_SHFT                                                       17
#define HWIO_WBM_R0_IDLE_STATUS_ERROR_RELEASE_PROD_FIFO_IN_IDLE_BMSK                                               0x10000
#define HWIO_WBM_R0_IDLE_STATUS_ERROR_RELEASE_PROD_FIFO_IN_IDLE_SHFT                                                    16
#define HWIO_WBM_R0_IDLE_STATUS_ALL_IN_IDLE_BMSK                                                                    0x8000
#define HWIO_WBM_R0_IDLE_STATUS_ALL_IN_IDLE_SHFT                                                                        15
#define HWIO_WBM_R0_IDLE_STATUS_ALL_APPLICATION_LOGIC_IN_IDLE_BMSK                                                  0x4000
#define HWIO_WBM_R0_IDLE_STATUS_ALL_APPLICATION_LOGIC_IN_IDLE_SHFT                                                      14
#define HWIO_WBM_R0_IDLE_STATUS_ALL_CONSUMER_RINGS_IN_IDLE_BMSK                                                     0x2000
#define HWIO_WBM_R0_IDLE_STATUS_ALL_CONSUMER_RINGS_IN_IDLE_SHFT                                                         13
#define HWIO_WBM_R0_IDLE_STATUS_ALL_PRODUCER_RINGS_IN_IDLE_BMSK                                                     0x1000
#define HWIO_WBM_R0_IDLE_STATUS_ALL_PRODUCER_RINGS_IN_IDLE_SHFT                                                         12
#define HWIO_WBM_R0_IDLE_STATUS_SW4_BUFFER_PROD_FIFO_IN_IDLE_BMSK                                                    0x800
#define HWIO_WBM_R0_IDLE_STATUS_SW4_BUFFER_PROD_FIFO_IN_IDLE_SHFT                                                       11
#define HWIO_WBM_R0_IDLE_STATUS_SW3_BUFFER_PROD_FIFO_IN_IDLE_BMSK                                                    0x400
#define HWIO_WBM_R0_IDLE_STATUS_SW3_BUFFER_PROD_FIFO_IN_IDLE_SHFT                                                       10
#define HWIO_WBM_R0_IDLE_STATUS_SW2_BUFFER_PROD_FIFO_IN_IDLE_BMSK                                                    0x200
#define HWIO_WBM_R0_IDLE_STATUS_SW2_BUFFER_PROD_FIFO_IN_IDLE_SHFT                                                        9
#define HWIO_WBM_R0_IDLE_STATUS_SW1_BUFFER_PROD_FIFO_IN_IDLE_BMSK                                                    0x100
#define HWIO_WBM_R0_IDLE_STATUS_SW1_BUFFER_PROD_FIFO_IN_IDLE_SHFT                                                        8
#define HWIO_WBM_R0_IDLE_STATUS_SW0_BUFFER_PROD_FIFO_IN_IDLE_BMSK                                                     0x80
#define HWIO_WBM_R0_IDLE_STATUS_SW0_BUFFER_PROD_FIFO_IN_IDLE_SHFT                                                        7
#define HWIO_WBM_R0_IDLE_STATUS_FW_BUFFER_PROD_FIFO_IN_IDLE_BMSK                                                      0x40
#define HWIO_WBM_R0_IDLE_STATUS_FW_BUFFER_PROD_FIFO_IN_IDLE_SHFT                                                         6
#define HWIO_WBM_R0_IDLE_STATUS_LINK_DESC_ZERO_OUT_FIFO_IN_IDLE_BMSK                                                  0x20
#define HWIO_WBM_R0_IDLE_STATUS_LINK_DESC_ZERO_OUT_FIFO_IN_IDLE_SHFT                                                     5
#define HWIO_WBM_R0_IDLE_STATUS_LINK_IDLE_LIST_DIST_FIFO_IN_IDLE_BMSK                                                 0x10
#define HWIO_WBM_R0_IDLE_STATUS_LINK_IDLE_LIST_DIST_FIFO_IN_IDLE_SHFT                                                    4
#define HWIO_WBM_R0_IDLE_STATUS_LINK_IDLE_LIST_PROD_FIFO_IN_IDLE_BMSK                                                  0x8
#define HWIO_WBM_R0_IDLE_STATUS_LINK_IDLE_LIST_PROD_FIFO_IN_IDLE_SHFT                                                    3
#define HWIO_WBM_R0_IDLE_STATUS_BUFFER_IDLE_LIST_DIST_FIFO_IN_IDLE_BMSK                                                0x4
#define HWIO_WBM_R0_IDLE_STATUS_BUFFER_IDLE_LIST_DIST_FIFO_IN_IDLE_SHFT                                                  2
#define HWIO_WBM_R0_IDLE_STATUS_BUFFER_IDLE_LIST_PROD_FIFO_IN_IDLE_BMSK                                                0x2
#define HWIO_WBM_R0_IDLE_STATUS_BUFFER_IDLE_LIST_PROD_FIFO_IN_IDLE_SHFT                                                  1
#define HWIO_WBM_R0_IDLE_STATUS_RELEASE_PARSER_FIFO_IN_IDLE_BMSK                                                       0x1
#define HWIO_WBM_R0_IDLE_STATUS_RELEASE_PARSER_FIFO_IN_IDLE_SHFT                                                         0

#define HWIO_WBM_R0_IDLE_SEQUENCE_ADDR(x)                                                                       ((x) + 0x70)
#define HWIO_WBM_R0_IDLE_SEQUENCE_PHYS(x)                                                                       ((x) + 0x70)
#define HWIO_WBM_R0_IDLE_SEQUENCE_OFFS                                                                          (0x70)
#define HWIO_WBM_R0_IDLE_SEQUENCE_RMSK                                                                                0x3f
#define HWIO_WBM_R0_IDLE_SEQUENCE_POR                                                                           0x00000000
#define HWIO_WBM_R0_IDLE_SEQUENCE_POR_RMSK                                                                      0xffffffff
#define HWIO_WBM_R0_IDLE_SEQUENCE_ATTR                                                                                       0x1
#define HWIO_WBM_R0_IDLE_SEQUENCE_IN(x)            \
                in_dword(HWIO_WBM_R0_IDLE_SEQUENCE_ADDR(x))
#define HWIO_WBM_R0_IDLE_SEQUENCE_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_IDLE_SEQUENCE_ADDR(x), m)
#define HWIO_WBM_R0_IDLE_SEQUENCE_WBM_RELEASE_RING_NOT_EMPTY_BMSK                                                     0x20
#define HWIO_WBM_R0_IDLE_SEQUENCE_WBM_RELEASE_RING_NOT_EMPTY_SHFT                                                        5
#define HWIO_WBM_R0_IDLE_SEQUENCE_WBM_IN_IDLE_BMSK                                                                    0x10
#define HWIO_WBM_R0_IDLE_SEQUENCE_WBM_IN_IDLE_SHFT                                                                       4
#define HWIO_WBM_R0_IDLE_SEQUENCE_IDLE_SEQUENCE_STATE_BMSK                                                             0xf
#define HWIO_WBM_R0_IDLE_SEQUENCE_IDLE_SEQUENCE_STATE_SHFT                                                               0

#define HWIO_WBM_R0_MSDU_PARSER_CONTROL_ADDR(x)                                                                 ((x) + 0x74)
#define HWIO_WBM_R0_MSDU_PARSER_CONTROL_PHYS(x)                                                                 ((x) + 0x74)
#define HWIO_WBM_R0_MSDU_PARSER_CONTROL_OFFS                                                                    (0x74)
#define HWIO_WBM_R0_MSDU_PARSER_CONTROL_RMSK                                                                           0x7
#define HWIO_WBM_R0_MSDU_PARSER_CONTROL_POR                                                                     0x00000000
#define HWIO_WBM_R0_MSDU_PARSER_CONTROL_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_MSDU_PARSER_CONTROL_ATTR                                                                                 0x3
#define HWIO_WBM_R0_MSDU_PARSER_CONTROL_IN(x)            \
                in_dword(HWIO_WBM_R0_MSDU_PARSER_CONTROL_ADDR(x))
#define HWIO_WBM_R0_MSDU_PARSER_CONTROL_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_MSDU_PARSER_CONTROL_ADDR(x), m)
#define HWIO_WBM_R0_MSDU_PARSER_CONTROL_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_MSDU_PARSER_CONTROL_ADDR(x),v)
#define HWIO_WBM_R0_MSDU_PARSER_CONTROL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_MSDU_PARSER_CONTROL_ADDR(x),m,v,HWIO_WBM_R0_MSDU_PARSER_CONTROL_IN(x))
#define HWIO_WBM_R0_MSDU_PARSER_CONTROL_DISABLE_CACHE_2_BMSK                                                           0x4
#define HWIO_WBM_R0_MSDU_PARSER_CONTROL_DISABLE_CACHE_2_SHFT                                                             2
#define HWIO_WBM_R0_MSDU_PARSER_CONTROL_FLUSH_CACHE_2_BMSK                                                             0x2
#define HWIO_WBM_R0_MSDU_PARSER_CONTROL_FLUSH_CACHE_2_SHFT                                                               1
#define HWIO_WBM_R0_MSDU_PARSER_CONTROL_FLUSH_CACHE_1_BMSK                                                             0x1
#define HWIO_WBM_R0_MSDU_PARSER_CONTROL_FLUSH_CACHE_1_SHFT                                                               0

#define HWIO_WBM_R0_MSDU_PARSER_STATUS_ADDR(x)                                                                  ((x) + 0x78)
#define HWIO_WBM_R0_MSDU_PARSER_STATUS_PHYS(x)                                                                  ((x) + 0x78)
#define HWIO_WBM_R0_MSDU_PARSER_STATUS_OFFS                                                                     (0x78)
#define HWIO_WBM_R0_MSDU_PARSER_STATUS_RMSK                                                                          0xfff
#define HWIO_WBM_R0_MSDU_PARSER_STATUS_POR                                                                      0x00000441
#define HWIO_WBM_R0_MSDU_PARSER_STATUS_POR_RMSK                                                                 0xffffffff
#define HWIO_WBM_R0_MSDU_PARSER_STATUS_ATTR                                                                                  0x1
#define HWIO_WBM_R0_MSDU_PARSER_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_MSDU_PARSER_STATUS_ADDR(x))
#define HWIO_WBM_R0_MSDU_PARSER_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_MSDU_PARSER_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_MSDU_PARSER_STATUS_FLUSH_CACHE_1_DONE_BMSK                                                       0x800
#define HWIO_WBM_R0_MSDU_PARSER_STATUS_FLUSH_CACHE_1_DONE_SHFT                                                          11
#define HWIO_WBM_R0_MSDU_PARSER_STATUS_MSDU_PARSER_CMD_FIFO_EMPTY_BMSK                                               0x400
#define HWIO_WBM_R0_MSDU_PARSER_STATUS_MSDU_PARSER_CMD_FIFO_EMPTY_SHFT                                                  10
#define HWIO_WBM_R0_MSDU_PARSER_STATUS_MSDU_DELINK_PARSER_STATE_BMSK                                                 0x3c0
#define HWIO_WBM_R0_MSDU_PARSER_STATUS_MSDU_DELINK_PARSER_STATE_SHFT                                                     6
#define HWIO_WBM_R0_MSDU_PARSER_STATUS_MSDU_PARSER_CMD_FIFO_IN_IDLE_BMSK                                              0x20
#define HWIO_WBM_R0_MSDU_PARSER_STATUS_MSDU_PARSER_CMD_FIFO_IN_IDLE_SHFT                                                 5
#define HWIO_WBM_R0_MSDU_PARSER_STATUS_CACHE_1_STATE_BMSK                                                             0x1f
#define HWIO_WBM_R0_MSDU_PARSER_STATUS_CACHE_1_STATE_SHFT                                                                0

#define HWIO_WBM_R0_MISC_CONTROL_ADDR(x)                                                                        ((x) + 0x7c)
#define HWIO_WBM_R0_MISC_CONTROL_PHYS(x)                                                                        ((x) + 0x7c)
#define HWIO_WBM_R0_MISC_CONTROL_OFFS                                                                           (0x7c)
#define HWIO_WBM_R0_MISC_CONTROL_RMSK                                                                           0xffffffff
#define HWIO_WBM_R0_MISC_CONTROL_POR                                                                            0x000001c0
#define HWIO_WBM_R0_MISC_CONTROL_POR_RMSK                                                                       0xffffffff
#define HWIO_WBM_R0_MISC_CONTROL_ATTR                                                                                        0x3
#define HWIO_WBM_R0_MISC_CONTROL_IN(x)            \
                in_dword(HWIO_WBM_R0_MISC_CONTROL_ADDR(x))
#define HWIO_WBM_R0_MISC_CONTROL_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_MISC_CONTROL_ADDR(x), m)
#define HWIO_WBM_R0_MISC_CONTROL_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_MISC_CONTROL_ADDR(x),v)
#define HWIO_WBM_R0_MISC_CONTROL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_MISC_CONTROL_ADDR(x),m,v,HWIO_WBM_R0_MISC_CONTROL_IN(x))
#define HWIO_WBM_R0_MISC_CONTROL_SPARE_CONTROL_BMSK                                                             0xfffffffc
#define HWIO_WBM_R0_MISC_CONTROL_SPARE_CONTROL_SHFT                                                                      2
#define HWIO_WBM_R0_MISC_CONTROL_GXI_WRITE_STRUCT_SWAP_BMSK                                                            0x2
#define HWIO_WBM_R0_MISC_CONTROL_GXI_WRITE_STRUCT_SWAP_SHFT                                                              1
#define HWIO_WBM_R0_MISC_CONTROL_GXI_READ_STRUCT_SWAP_BMSK                                                             0x1
#define HWIO_WBM_R0_MISC_CONTROL_GXI_READ_STRUCT_SWAP_SHFT                                                               0

#define HWIO_WBM_R0_SPARE_CTRL_2_ADDR(x)                                                                        ((x) + 0x80)
#define HWIO_WBM_R0_SPARE_CTRL_2_PHYS(x)                                                                        ((x) + 0x80)
#define HWIO_WBM_R0_SPARE_CTRL_2_OFFS                                                                           (0x80)
#define HWIO_WBM_R0_SPARE_CTRL_2_RMSK                                                                           0xffffffff
#define HWIO_WBM_R0_SPARE_CTRL_2_POR                                                                            0x00000000
#define HWIO_WBM_R0_SPARE_CTRL_2_POR_RMSK                                                                       0xffffffff
#define HWIO_WBM_R0_SPARE_CTRL_2_ATTR                                                                                        0x3
#define HWIO_WBM_R0_SPARE_CTRL_2_IN(x)            \
                in_dword(HWIO_WBM_R0_SPARE_CTRL_2_ADDR(x))
#define HWIO_WBM_R0_SPARE_CTRL_2_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SPARE_CTRL_2_ADDR(x), m)
#define HWIO_WBM_R0_SPARE_CTRL_2_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SPARE_CTRL_2_ADDR(x),v)
#define HWIO_WBM_R0_SPARE_CTRL_2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SPARE_CTRL_2_ADDR(x),m,v,HWIO_WBM_R0_SPARE_CTRL_2_IN(x))
#define HWIO_WBM_R0_SPARE_CTRL_2_SPARE_CONTROL_2_BMSK                                                           0xffffffff
#define HWIO_WBM_R0_SPARE_CTRL_2_SPARE_CONTROL_2_SHFT                                                                    0

#define HWIO_WBM_R0_RING_PRIORITY_CFG0_ADDR(x)                                                                  ((x) + 0x84)
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_PHYS(x)                                                                  ((x) + 0x84)
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_OFFS                                                                     (0x84)
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_RMSK                                                                      0x3ffffcf
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_POR                                                                      0x00000000
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_POR_RMSK                                                                 0xffffffff
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_ATTR                                                                                  0x3
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_IN(x)            \
                in_dword(HWIO_WBM_R0_RING_PRIORITY_CFG0_ADDR(x))
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RING_PRIORITY_CFG0_ADDR(x), m)
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_RING_PRIORITY_CFG0_ADDR(x),v)
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_RING_PRIORITY_CFG0_ADDR(x),m,v,HWIO_WBM_R0_RING_PRIORITY_CFG0_IN(x))
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_WBM2RXDMA0_LINK_RING_PRIORITY_BMSK                                        0x3000000
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_WBM2RXDMA0_LINK_RING_PRIORITY_SHFT                                               24
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_WBM2FW_LINK_RING_PRIORITY_BMSK                                             0xc00000
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_WBM2FW_LINK_RING_PRIORITY_SHFT                                                   22
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_WBM2SW_LINK_RING_PRIORITY_BMSK                                             0x300000
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_WBM2SW_LINK_RING_PRIORITY_SHFT                                                   20
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_WBM2REO_LINK_RING_PRIORITY_BMSK                                             0xc0000
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_WBM2REO_LINK_RING_PRIORITY_SHFT                                                  18
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_WBM2TQM_LINK_RING_PRIORITY_BMSK                                             0x30000
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_WBM2TQM_LINK_RING_PRIORITY_SHFT                                                  16
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_RXDMA0_RELEASE_RING_PRIORITY_BMSK                                            0xc000
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_RXDMA0_RELEASE_RING_PRIORITY_SHFT                                                14
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_FW_RELEASE_RING_PRIORITY_BMSK                                                0x3000
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_FW_RELEASE_RING_PRIORITY_SHFT                                                    12
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_SW_RELEASE_RING_PRIORITY_BMSK                                                 0xc00
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_SW_RELEASE_RING_PRIORITY_SHFT                                                    10
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_REO_RELEASE_RING_PRIORITY_BMSK                                                0x300
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_REO_RELEASE_RING_PRIORITY_SHFT                                                    8
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_TQM_RELEASE_RING_PRIORITY_BMSK                                                 0xc0
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_TQM_RELEASE_RING_PRIORITY_SHFT                                                    6
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_LINK_IDLE_LIST_CONSUMER_RING_PRIORITY_BMSK                                      0xc
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_LINK_IDLE_LIST_CONSUMER_RING_PRIORITY_SHFT                                        2
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_LINK_IDLE_LIST_PRODUCER_RING_PRIORITY_BMSK                                      0x3
#define HWIO_WBM_R0_RING_PRIORITY_CFG0_LINK_IDLE_LIST_PRODUCER_RING_PRIORITY_SHFT                                        0

#define HWIO_WBM_R0_RING_PRIORITY_CFG1_ADDR(x)                                                                  ((x) + 0x88)
#define HWIO_WBM_R0_RING_PRIORITY_CFG1_PHYS(x)                                                                  ((x) + 0x88)
#define HWIO_WBM_R0_RING_PRIORITY_CFG1_OFFS                                                                     (0x88)
#define HWIO_WBM_R0_RING_PRIORITY_CFG1_RMSK                                                                        0xfffff
#define HWIO_WBM_R0_RING_PRIORITY_CFG1_POR                                                                      0x00000000
#define HWIO_WBM_R0_RING_PRIORITY_CFG1_POR_RMSK                                                                 0xffffffff
#define HWIO_WBM_R0_RING_PRIORITY_CFG1_ATTR                                                                                  0x3
#define HWIO_WBM_R0_RING_PRIORITY_CFG1_IN(x)            \
                in_dword(HWIO_WBM_R0_RING_PRIORITY_CFG1_ADDR(x))
#define HWIO_WBM_R0_RING_PRIORITY_CFG1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RING_PRIORITY_CFG1_ADDR(x), m)
#define HWIO_WBM_R0_RING_PRIORITY_CFG1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_RING_PRIORITY_CFG1_ADDR(x),v)
#define HWIO_WBM_R0_RING_PRIORITY_CFG1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_RING_PRIORITY_CFG1_ADDR(x),m,v,HWIO_WBM_R0_RING_PRIORITY_CFG1_IN(x))
#define HWIO_WBM_R0_RING_PRIORITY_CFG1_SW_COOKIE_CONV_GXI_PRIORITY_BMSK                                            0xc0000
#define HWIO_WBM_R0_RING_PRIORITY_CFG1_SW_COOKIE_CONV_GXI_PRIORITY_SHFT                                                 18
#define HWIO_WBM_R0_RING_PRIORITY_CFG1_WBM2SW6_RELEASE_RING_PRIORITY_BMSK                                          0x30000
#define HWIO_WBM_R0_RING_PRIORITY_CFG1_WBM2SW6_RELEASE_RING_PRIORITY_SHFT                                               16
#define HWIO_WBM_R0_RING_PRIORITY_CFG1_WBM2SW5_RELEASE_RING_PRIORITY_BMSK                                           0xc000
#define HWIO_WBM_R0_RING_PRIORITY_CFG1_WBM2SW5_RELEASE_RING_PRIORITY_SHFT                                               14
#define HWIO_WBM_R0_RING_PRIORITY_CFG1_WBM_ERROR_RELEASE_RING_PRIORITY_BMSK                                         0x3000
#define HWIO_WBM_R0_RING_PRIORITY_CFG1_WBM_ERROR_RELEASE_RING_PRIORITY_SHFT                                             12
#define HWIO_WBM_R0_RING_PRIORITY_CFG1_WBM2SW4_RELEASE_RING_PRIORITY_BMSK                                            0xc00
#define HWIO_WBM_R0_RING_PRIORITY_CFG1_WBM2SW4_RELEASE_RING_PRIORITY_SHFT                                               10
#define HWIO_WBM_R0_RING_PRIORITY_CFG1_WBM2SW3_RELEASE_RING_PRIORITY_BMSK                                            0x300
#define HWIO_WBM_R0_RING_PRIORITY_CFG1_WBM2SW3_RELEASE_RING_PRIORITY_SHFT                                                8
#define HWIO_WBM_R0_RING_PRIORITY_CFG1_WBM2SW2_RELEASE_RING_PRIORITY_BMSK                                             0xc0
#define HWIO_WBM_R0_RING_PRIORITY_CFG1_WBM2SW2_RELEASE_RING_PRIORITY_SHFT                                                6
#define HWIO_WBM_R0_RING_PRIORITY_CFG1_WBM2SW1_RELEASE_RING_PRIORITY_BMSK                                             0x30
#define HWIO_WBM_R0_RING_PRIORITY_CFG1_WBM2SW1_RELEASE_RING_PRIORITY_SHFT                                                4
#define HWIO_WBM_R0_RING_PRIORITY_CFG1_WBM2SW0_RELEASE_RING_PRIORITY_BMSK                                              0xc
#define HWIO_WBM_R0_RING_PRIORITY_CFG1_WBM2SW0_RELEASE_RING_PRIORITY_SHFT                                                2
#define HWIO_WBM_R0_RING_PRIORITY_CFG1_WBM2FW_RELEASE_RING_PRIORITY_BMSK                                               0x3
#define HWIO_WBM_R0_RING_PRIORITY_CFG1_WBM2FW_RELEASE_RING_PRIORITY_SHFT                                                 0

#define HWIO_WBM_R0_WBM_CFG_2_ADDR(x)                                                                           ((x) + 0x90)
#define HWIO_WBM_R0_WBM_CFG_2_PHYS(x)                                                                           ((x) + 0x90)
#define HWIO_WBM_R0_WBM_CFG_2_OFFS                                                                              (0x90)
#define HWIO_WBM_R0_WBM_CFG_2_RMSK                                                                                    0x4b
#define HWIO_WBM_R0_WBM_CFG_2_POR                                                                               0x00000040
#define HWIO_WBM_R0_WBM_CFG_2_POR_RMSK                                                                          0xffffffff
#define HWIO_WBM_R0_WBM_CFG_2_ATTR                                                                                           0x3
#define HWIO_WBM_R0_WBM_CFG_2_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_CFG_2_ADDR(x))
#define HWIO_WBM_R0_WBM_CFG_2_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_CFG_2_ADDR(x), m)
#define HWIO_WBM_R0_WBM_CFG_2_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_CFG_2_ADDR(x),v)
#define HWIO_WBM_R0_WBM_CFG_2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_CFG_2_ADDR(x),m,v,HWIO_WBM_R0_WBM_CFG_2_IN(x))
#define HWIO_WBM_R0_WBM_CFG_2_COOKIE_DEBUG_SEL_BMSK                                                                   0x40
#define HWIO_WBM_R0_WBM_CFG_2_COOKIE_DEBUG_SEL_SHFT                                                                      6
#define HWIO_WBM_R0_WBM_CFG_2_COOKIE_CONV_INDICATION_EN_BMSK                                                           0x8
#define HWIO_WBM_R0_WBM_CFG_2_COOKIE_CONV_INDICATION_EN_SHFT                                                             3
#define HWIO_WBM_R0_WBM_CFG_2_ERROR_PATH_COOKIE_CONV_EN_BMSK                                                           0x2
#define HWIO_WBM_R0_WBM_CFG_2_ERROR_PATH_COOKIE_CONV_EN_SHFT                                                             1
#define HWIO_WBM_R0_WBM_CFG_2_RELEASE_PATH_COOKIE_CONV_EN_BMSK                                                         0x1
#define HWIO_WBM_R0_WBM_CFG_2_RELEASE_PATH_COOKIE_CONV_EN_SHFT                                                           0

#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_ADDR(x)                                                               ((x) + 0x94)
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_PHYS(x)                                                               ((x) + 0x94)
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_OFFS                                                                  (0x94)
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_RMSK                                                                       0x1ff
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_POR                                                                   0x000001fe
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_ATTR                                                                               0x3
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_ADDR(x))
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_ADDR(x), m)
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_ADDR(x),v)
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_ADDR(x),m,v,HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_IN(x))
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM_COOKIE_CONV_GLOBAL_ENABLE_BMSK                                         0x100
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM_COOKIE_CONV_GLOBAL_ENABLE_SHFT                                             8
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2SW6_COOKIE_CONVERSION_EN_BMSK                                           0x80
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2SW6_COOKIE_CONVERSION_EN_SHFT                                              7
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2SW5_COOKIE_CONVERSION_EN_BMSK                                           0x40
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2SW5_COOKIE_CONVERSION_EN_SHFT                                              6
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2SW4_COOKIE_CONVERSION_EN_BMSK                                           0x20
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2SW4_COOKIE_CONVERSION_EN_SHFT                                              5
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2SW3_COOKIE_CONVERSION_EN_BMSK                                           0x10
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2SW3_COOKIE_CONVERSION_EN_SHFT                                              4
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2SW2_COOKIE_CONVERSION_EN_BMSK                                            0x8
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2SW2_COOKIE_CONVERSION_EN_SHFT                                              3
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2SW1_COOKIE_CONVERSION_EN_BMSK                                            0x4
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2SW1_COOKIE_CONVERSION_EN_SHFT                                              2
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2SW0_COOKIE_CONVERSION_EN_BMSK                                            0x2
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2SW0_COOKIE_CONVERSION_EN_SHFT                                              1
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2FW_COOKIE_CONVERSION_EN_BMSK                                             0x1
#define HWIO_WBM_R0_SW_COOKIE_CONVERT_CFG_WBM2FW_COOKIE_CONVERSION_EN_SHFT                                               0

#define HWIO_WBM_R0_LINK_DESC_RING_CFG0_ADDR(x)                                                                 ((x) + 0x98)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG0_PHYS(x)                                                                 ((x) + 0x98)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG0_OFFS                                                                    (0x98)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG0_RMSK                                                                    0xffffffff
#define HWIO_WBM_R0_LINK_DESC_RING_CFG0_POR                                                                     0x00000000
#define HWIO_WBM_R0_LINK_DESC_RING_CFG0_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_LINK_DESC_RING_CFG0_ATTR                                                                                 0x3
#define HWIO_WBM_R0_LINK_DESC_RING_CFG0_IN(x)            \
                in_dword(HWIO_WBM_R0_LINK_DESC_RING_CFG0_ADDR(x))
#define HWIO_WBM_R0_LINK_DESC_RING_CFG0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_LINK_DESC_RING_CFG0_ADDR(x), m)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG0_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_LINK_DESC_RING_CFG0_ADDR(x),v)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_LINK_DESC_RING_CFG0_ADDR(x),m,v,HWIO_WBM_R0_LINK_DESC_RING_CFG0_IN(x))
#define HWIO_WBM_R0_LINK_DESC_RING_CFG0_WBM2REO_LINK_RING_WATERMARK_BMSK                                        0xffff0000
#define HWIO_WBM_R0_LINK_DESC_RING_CFG0_WBM2REO_LINK_RING_WATERMARK_SHFT                                                16
#define HWIO_WBM_R0_LINK_DESC_RING_CFG0_WBM2TQM_LINK_RING_WATERMARK_BMSK                                            0xffff
#define HWIO_WBM_R0_LINK_DESC_RING_CFG0_WBM2TQM_LINK_RING_WATERMARK_SHFT                                                 0

#define HWIO_WBM_R0_LINK_DESC_RING_CFG1_ADDR(x)                                                                 ((x) + 0x9c)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG1_PHYS(x)                                                                 ((x) + 0x9c)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG1_OFFS                                                                    (0x9c)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG1_RMSK                                                                    0xffffffff
#define HWIO_WBM_R0_LINK_DESC_RING_CFG1_POR                                                                     0x00000000
#define HWIO_WBM_R0_LINK_DESC_RING_CFG1_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_LINK_DESC_RING_CFG1_ATTR                                                                                 0x3
#define HWIO_WBM_R0_LINK_DESC_RING_CFG1_IN(x)            \
                in_dword(HWIO_WBM_R0_LINK_DESC_RING_CFG1_ADDR(x))
#define HWIO_WBM_R0_LINK_DESC_RING_CFG1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_LINK_DESC_RING_CFG1_ADDR(x), m)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_LINK_DESC_RING_CFG1_ADDR(x),v)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_LINK_DESC_RING_CFG1_ADDR(x),m,v,HWIO_WBM_R0_LINK_DESC_RING_CFG1_IN(x))
#define HWIO_WBM_R0_LINK_DESC_RING_CFG1_WBM2FW_LINK_RING_WATERMARK_BMSK                                         0xffff0000
#define HWIO_WBM_R0_LINK_DESC_RING_CFG1_WBM2FW_LINK_RING_WATERMARK_SHFT                                                 16
#define HWIO_WBM_R0_LINK_DESC_RING_CFG1_WBM2SW_LINK_RING_WATERMARK_BMSK                                             0xffff
#define HWIO_WBM_R0_LINK_DESC_RING_CFG1_WBM2SW_LINK_RING_WATERMARK_SHFT                                                  0

#define HWIO_WBM_R0_LINK_DESC_RING_CFG2_ADDR(x)                                                                 ((x) + 0xa0)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG2_PHYS(x)                                                                 ((x) + 0xa0)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG2_OFFS                                                                    (0xa0)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG2_RMSK                                                                        0xffff
#define HWIO_WBM_R0_LINK_DESC_RING_CFG2_POR                                                                     0x00000000
#define HWIO_WBM_R0_LINK_DESC_RING_CFG2_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_LINK_DESC_RING_CFG2_ATTR                                                                                 0x3
#define HWIO_WBM_R0_LINK_DESC_RING_CFG2_IN(x)            \
                in_dword(HWIO_WBM_R0_LINK_DESC_RING_CFG2_ADDR(x))
#define HWIO_WBM_R0_LINK_DESC_RING_CFG2_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_LINK_DESC_RING_CFG2_ADDR(x), m)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG2_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_LINK_DESC_RING_CFG2_ADDR(x),v)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_LINK_DESC_RING_CFG2_ADDR(x),m,v,HWIO_WBM_R0_LINK_DESC_RING_CFG2_IN(x))
#define HWIO_WBM_R0_LINK_DESC_RING_CFG2_WBM2RXDMA0_LINK_RING_WATERMARK_BMSK                                         0xffff
#define HWIO_WBM_R0_LINK_DESC_RING_CFG2_WBM2RXDMA0_LINK_RING_WATERMARK_SHFT                                              0

#define HWIO_WBM_R0_LINK_DESC_RING_CFG3_ADDR(x)                                                                 ((x) + 0xa4)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG3_PHYS(x)                                                                 ((x) + 0xa4)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG3_OFFS                                                                    (0xa4)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG3_RMSK                                                                    0xffffffff
#define HWIO_WBM_R0_LINK_DESC_RING_CFG3_POR                                                                     0x00000000
#define HWIO_WBM_R0_LINK_DESC_RING_CFG3_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_LINK_DESC_RING_CFG3_ATTR                                                                                 0x3
#define HWIO_WBM_R0_LINK_DESC_RING_CFG3_IN(x)            \
                in_dword(HWIO_WBM_R0_LINK_DESC_RING_CFG3_ADDR(x))
#define HWIO_WBM_R0_LINK_DESC_RING_CFG3_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_LINK_DESC_RING_CFG3_ADDR(x), m)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG3_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_LINK_DESC_RING_CFG3_ADDR(x),v)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG3_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_LINK_DESC_RING_CFG3_ADDR(x),m,v,HWIO_WBM_R0_LINK_DESC_RING_CFG3_IN(x))
#define HWIO_WBM_R0_LINK_DESC_RING_CFG3_WBM2REO_LINK_RING_WATERMARK_LOWER_BMSK                                  0xffff0000
#define HWIO_WBM_R0_LINK_DESC_RING_CFG3_WBM2REO_LINK_RING_WATERMARK_LOWER_SHFT                                          16
#define HWIO_WBM_R0_LINK_DESC_RING_CFG3_WBM2TQM_LINK_RING_WATERMARK_LOWER_BMSK                                      0xffff
#define HWIO_WBM_R0_LINK_DESC_RING_CFG3_WBM2TQM_LINK_RING_WATERMARK_LOWER_SHFT                                           0

#define HWIO_WBM_R0_LINK_DESC_RING_CFG4_ADDR(x)                                                                 ((x) + 0xa8)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG4_PHYS(x)                                                                 ((x) + 0xa8)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG4_OFFS                                                                    (0xa8)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG4_RMSK                                                                    0xffffffff
#define HWIO_WBM_R0_LINK_DESC_RING_CFG4_POR                                                                     0x00000000
#define HWIO_WBM_R0_LINK_DESC_RING_CFG4_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_LINK_DESC_RING_CFG4_ATTR                                                                                 0x3
#define HWIO_WBM_R0_LINK_DESC_RING_CFG4_IN(x)            \
                in_dword(HWIO_WBM_R0_LINK_DESC_RING_CFG4_ADDR(x))
#define HWIO_WBM_R0_LINK_DESC_RING_CFG4_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_LINK_DESC_RING_CFG4_ADDR(x), m)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG4_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_LINK_DESC_RING_CFG4_ADDR(x),v)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG4_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_LINK_DESC_RING_CFG4_ADDR(x),m,v,HWIO_WBM_R0_LINK_DESC_RING_CFG4_IN(x))
#define HWIO_WBM_R0_LINK_DESC_RING_CFG4_WBM2FW_LINK_RING_WATERMARK_LOWER_BMSK                                   0xffff0000
#define HWIO_WBM_R0_LINK_DESC_RING_CFG4_WBM2FW_LINK_RING_WATERMARK_LOWER_SHFT                                           16
#define HWIO_WBM_R0_LINK_DESC_RING_CFG4_WBM2SW_LINK_RING_WATERMARK_LOWER_BMSK                                       0xffff
#define HWIO_WBM_R0_LINK_DESC_RING_CFG4_WBM2SW_LINK_RING_WATERMARK_LOWER_SHFT                                            0

#define HWIO_WBM_R0_LINK_DESC_RING_CFG5_ADDR(x)                                                                 ((x) + 0xac)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG5_PHYS(x)                                                                 ((x) + 0xac)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG5_OFFS                                                                    (0xac)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG5_RMSK                                                                        0xffff
#define HWIO_WBM_R0_LINK_DESC_RING_CFG5_POR                                                                     0x00000000
#define HWIO_WBM_R0_LINK_DESC_RING_CFG5_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_LINK_DESC_RING_CFG5_ATTR                                                                                 0x3
#define HWIO_WBM_R0_LINK_DESC_RING_CFG5_IN(x)            \
                in_dword(HWIO_WBM_R0_LINK_DESC_RING_CFG5_ADDR(x))
#define HWIO_WBM_R0_LINK_DESC_RING_CFG5_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_LINK_DESC_RING_CFG5_ADDR(x), m)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG5_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_LINK_DESC_RING_CFG5_ADDR(x),v)
#define HWIO_WBM_R0_LINK_DESC_RING_CFG5_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_LINK_DESC_RING_CFG5_ADDR(x),m,v,HWIO_WBM_R0_LINK_DESC_RING_CFG5_IN(x))
#define HWIO_WBM_R0_LINK_DESC_RING_CFG5_WBM2RXDMA0_LINK_RING_WATERMARK_LOWER_BMSK                                   0xffff
#define HWIO_WBM_R0_LINK_DESC_RING_CFG5_WBM2RXDMA0_LINK_RING_WATERMARK_LOWER_SHFT                                        0

#define HWIO_WBM_R0_WATCHDOG_TIMEOUT_ADDR(x)                                                                    ((x) + 0xb0)
#define HWIO_WBM_R0_WATCHDOG_TIMEOUT_PHYS(x)                                                                    ((x) + 0xb0)
#define HWIO_WBM_R0_WATCHDOG_TIMEOUT_OFFS                                                                       (0xb0)
#define HWIO_WBM_R0_WATCHDOG_TIMEOUT_RMSK                                                                           0x3fff
#define HWIO_WBM_R0_WATCHDOG_TIMEOUT_POR                                                                        0x00000000
#define HWIO_WBM_R0_WATCHDOG_TIMEOUT_POR_RMSK                                                                   0xffffffff
#define HWIO_WBM_R0_WATCHDOG_TIMEOUT_ATTR                                                                                    0x3
#define HWIO_WBM_R0_WATCHDOG_TIMEOUT_IN(x)            \
                in_dword(HWIO_WBM_R0_WATCHDOG_TIMEOUT_ADDR(x))
#define HWIO_WBM_R0_WATCHDOG_TIMEOUT_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WATCHDOG_TIMEOUT_ADDR(x), m)
#define HWIO_WBM_R0_WATCHDOG_TIMEOUT_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WATCHDOG_TIMEOUT_ADDR(x),v)
#define HWIO_WBM_R0_WATCHDOG_TIMEOUT_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WATCHDOG_TIMEOUT_ADDR(x),m,v,HWIO_WBM_R0_WATCHDOG_TIMEOUT_IN(x))
#define HWIO_WBM_R0_WATCHDOG_TIMEOUT_RESOLUTION_UNITS_BMSK                                                          0x3000
#define HWIO_WBM_R0_WATCHDOG_TIMEOUT_RESOLUTION_UNITS_SHFT                                                              12
#define HWIO_WBM_R0_WATCHDOG_TIMEOUT_VALUE_BMSK                                                                      0xfff
#define HWIO_WBM_R0_WATCHDOG_TIMEOUT_VALUE_SHFT                                                                          0

#define HWIO_WBM_R0_WARNING_WATCHDOG_TIMEOUT_ADDR(x)                                                            ((x) + 0xb4)
#define HWIO_WBM_R0_WARNING_WATCHDOG_TIMEOUT_PHYS(x)                                                            ((x) + 0xb4)
#define HWIO_WBM_R0_WARNING_WATCHDOG_TIMEOUT_OFFS                                                               (0xb4)
#define HWIO_WBM_R0_WARNING_WATCHDOG_TIMEOUT_RMSK                                                                   0x3fff
#define HWIO_WBM_R0_WARNING_WATCHDOG_TIMEOUT_POR                                                                0x00000000
#define HWIO_WBM_R0_WARNING_WATCHDOG_TIMEOUT_POR_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_WARNING_WATCHDOG_TIMEOUT_ATTR                                                                            0x3
#define HWIO_WBM_R0_WARNING_WATCHDOG_TIMEOUT_IN(x)            \
                in_dword(HWIO_WBM_R0_WARNING_WATCHDOG_TIMEOUT_ADDR(x))
#define HWIO_WBM_R0_WARNING_WATCHDOG_TIMEOUT_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WARNING_WATCHDOG_TIMEOUT_ADDR(x), m)
#define HWIO_WBM_R0_WARNING_WATCHDOG_TIMEOUT_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WARNING_WATCHDOG_TIMEOUT_ADDR(x),v)
#define HWIO_WBM_R0_WARNING_WATCHDOG_TIMEOUT_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WARNING_WATCHDOG_TIMEOUT_ADDR(x),m,v,HWIO_WBM_R0_WARNING_WATCHDOG_TIMEOUT_IN(x))
#define HWIO_WBM_R0_WARNING_WATCHDOG_TIMEOUT_RESOLUTION_UNITS_BMSK                                                  0x3000
#define HWIO_WBM_R0_WARNING_WATCHDOG_TIMEOUT_RESOLUTION_UNITS_SHFT                                                      12
#define HWIO_WBM_R0_WARNING_WATCHDOG_TIMEOUT_VALUE_BMSK                                                              0xfff
#define HWIO_WBM_R0_WARNING_WATCHDOG_TIMEOUT_VALUE_SHFT                                                                  0

#define HWIO_WBM_R0_CACHE_CTRL_LPM_WATCHDOG_LIMIT_ADDR(x)                                                       ((x) + 0xb8)
#define HWIO_WBM_R0_CACHE_CTRL_LPM_WATCHDOG_LIMIT_PHYS(x)                                                       ((x) + 0xb8)
#define HWIO_WBM_R0_CACHE_CTRL_LPM_WATCHDOG_LIMIT_OFFS                                                          (0xb8)
#define HWIO_WBM_R0_CACHE_CTRL_LPM_WATCHDOG_LIMIT_RMSK                                                              0x3fff
#define HWIO_WBM_R0_CACHE_CTRL_LPM_WATCHDOG_LIMIT_POR                                                           0x00000000
#define HWIO_WBM_R0_CACHE_CTRL_LPM_WATCHDOG_LIMIT_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_CACHE_CTRL_LPM_WATCHDOG_LIMIT_ATTR                                                                       0x3
#define HWIO_WBM_R0_CACHE_CTRL_LPM_WATCHDOG_LIMIT_IN(x)            \
                in_dword(HWIO_WBM_R0_CACHE_CTRL_LPM_WATCHDOG_LIMIT_ADDR(x))
#define HWIO_WBM_R0_CACHE_CTRL_LPM_WATCHDOG_LIMIT_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_CACHE_CTRL_LPM_WATCHDOG_LIMIT_ADDR(x), m)
#define HWIO_WBM_R0_CACHE_CTRL_LPM_WATCHDOG_LIMIT_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_CACHE_CTRL_LPM_WATCHDOG_LIMIT_ADDR(x),v)
#define HWIO_WBM_R0_CACHE_CTRL_LPM_WATCHDOG_LIMIT_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_CACHE_CTRL_LPM_WATCHDOG_LIMIT_ADDR(x),m,v,HWIO_WBM_R0_CACHE_CTRL_LPM_WATCHDOG_LIMIT_IN(x))
#define HWIO_WBM_R0_CACHE_CTRL_LPM_WATCHDOG_LIMIT_RESOLUTION_UNITS_BMSK                                             0x3000
#define HWIO_WBM_R0_CACHE_CTRL_LPM_WATCHDOG_LIMIT_RESOLUTION_UNITS_SHFT                                                 12
#define HWIO_WBM_R0_CACHE_CTRL_LPM_WATCHDOG_LIMIT_VALUE_BMSK                                                         0xfff
#define HWIO_WBM_R0_CACHE_CTRL_LPM_WATCHDOG_LIMIT_VALUE_SHFT                                                             0

#define HWIO_WBM_R0_RLS_PARSER_SM_STUCK_INFO_ADDR(x)                                                            ((x) + 0xbc)
#define HWIO_WBM_R0_RLS_PARSER_SM_STUCK_INFO_PHYS(x)                                                            ((x) + 0xbc)
#define HWIO_WBM_R0_RLS_PARSER_SM_STUCK_INFO_OFFS                                                               (0xbc)
#define HWIO_WBM_R0_RLS_PARSER_SM_STUCK_INFO_RMSK                                                                 0x1fffff
#define HWIO_WBM_R0_RLS_PARSER_SM_STUCK_INFO_POR                                                                0x00000000
#define HWIO_WBM_R0_RLS_PARSER_SM_STUCK_INFO_POR_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_RLS_PARSER_SM_STUCK_INFO_ATTR                                                                            0x1
#define HWIO_WBM_R0_RLS_PARSER_SM_STUCK_INFO_IN(x)            \
                in_dword(HWIO_WBM_R0_RLS_PARSER_SM_STUCK_INFO_ADDR(x))
#define HWIO_WBM_R0_RLS_PARSER_SM_STUCK_INFO_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RLS_PARSER_SM_STUCK_INFO_ADDR(x), m)
#define HWIO_WBM_R0_RLS_PARSER_SM_STUCK_INFO_RD_DATA_DEST_ERR_BMSK                                                0x1e0000
#define HWIO_WBM_R0_RLS_PARSER_SM_STUCK_INFO_RD_DATA_DEST_ERR_SHFT                                                      17
#define HWIO_WBM_R0_RLS_PARSER_SM_STUCK_INFO_RD_DATA_DEST_BMSK                                                     0x1fff0
#define HWIO_WBM_R0_RLS_PARSER_SM_STUCK_INFO_RD_DATA_DEST_SHFT                                                           4
#define HWIO_WBM_R0_RLS_PARSER_SM_STUCK_INFO_P_STATE_ENC_BMSK                                                          0xf
#define HWIO_WBM_R0_RLS_PARSER_SM_STUCK_INFO_P_STATE_ENC_SHFT                                                            0

#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE_ADDR(x)                                                              ((x) + 0xc0)
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE_PHYS(x)                                                              ((x) + 0xc0)
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE_OFFS                                                                 (0xc0)
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE_RMSK                                                                 0xffffffff
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE_POR                                                                  0x00000000
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE_POR_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE_ATTR                                                                              0x1
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE_IN(x)            \
                in_dword(HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE_ADDR(x))
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE_ADDR(x), m)
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE_ERROR_OCCURRENCE_BMSK                                                0x80000000
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE_ERROR_OCCURRENCE_SHFT                                                        31
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE_ERROR_SOURCE_BMSK                                                    0x40000000
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE_ERROR_SOURCE_SHFT                                                            30
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE_ERROR_TYPE_BMSK                                                      0x30000000
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE_ERROR_TYPE_SHFT                                                              28
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE_SW_BUFFER_COOKIE_BMSK                                                 0xffffe00
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE_SW_BUFFER_COOKIE_SHFT                                                         9
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE_BM_ACTION_BMSK                                                            0x180
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE_BM_ACTION_SHFT                                                                7
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE_BUFFER_DESC_TYPE_BMSK                                                      0x70
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE_BUFFER_DESC_TYPE_SHFT                                                         4
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE_RETURN_BUFFER_MANAGER_BMSK                                                  0xf
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE_RETURN_BUFFER_MANAGER_SHFT                                                    0

#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE2_ADDR(x)                                                             ((x) + 0xc4)
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE2_PHYS(x)                                                             ((x) + 0xc4)
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE2_OFFS                                                                (0xc4)
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE2_RMSK                                                                       0x7
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE2_POR                                                                 0x00000000
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE2_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE2_ATTR                                                                             0x1
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE2_IN(x)            \
                in_dword(HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE2_ADDR(x))
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE2_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE2_ADDR(x), m)
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE2_RELEASE_SOURCE_MODULE_BMSK                                                 0x7
#define HWIO_WBM_R0_INTERRUPT_DATA_CAPTURE2_RELEASE_SOURCE_MODULE_SHFT                                                   0

#define HWIO_WBM_R0_INVALID_APB_ACC_ADDR_ADDR(x)                                                                ((x) + 0xc8)
#define HWIO_WBM_R0_INVALID_APB_ACC_ADDR_PHYS(x)                                                                ((x) + 0xc8)
#define HWIO_WBM_R0_INVALID_APB_ACC_ADDR_OFFS                                                                   (0xc8)
#define HWIO_WBM_R0_INVALID_APB_ACC_ADDR_RMSK                                                                      0x7ffff
#define HWIO_WBM_R0_INVALID_APB_ACC_ADDR_POR                                                                    0x00000000
#define HWIO_WBM_R0_INVALID_APB_ACC_ADDR_POR_RMSK                                                               0xffffffff
#define HWIO_WBM_R0_INVALID_APB_ACC_ADDR_ATTR                                                                                0x1
#define HWIO_WBM_R0_INVALID_APB_ACC_ADDR_IN(x)            \
                in_dword(HWIO_WBM_R0_INVALID_APB_ACC_ADDR_ADDR(x))
#define HWIO_WBM_R0_INVALID_APB_ACC_ADDR_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_INVALID_APB_ACC_ADDR_ADDR(x), m)
#define HWIO_WBM_R0_INVALID_APB_ACC_ADDR_ERR_TYPE_BMSK                                                             0x60000
#define HWIO_WBM_R0_INVALID_APB_ACC_ADDR_ERR_TYPE_SHFT                                                                  17
#define HWIO_WBM_R0_INVALID_APB_ACC_ADDR_ERR_ADDR_BMSK                                                             0x1ffff
#define HWIO_WBM_R0_INVALID_APB_ACC_ADDR_ERR_ADDR_SHFT                                                                   0

#define HWIO_WBM_R0_WATERMARK_LOWER_COUNTER_CTRL_ADDR(x)                                                        ((x) + 0xcc)
#define HWIO_WBM_R0_WATERMARK_LOWER_COUNTER_CTRL_PHYS(x)                                                        ((x) + 0xcc)
#define HWIO_WBM_R0_WATERMARK_LOWER_COUNTER_CTRL_OFFS                                                           (0xcc)
#define HWIO_WBM_R0_WATERMARK_LOWER_COUNTER_CTRL_RMSK                                                                  0x7
#define HWIO_WBM_R0_WATERMARK_LOWER_COUNTER_CTRL_POR                                                            0x00000000
#define HWIO_WBM_R0_WATERMARK_LOWER_COUNTER_CTRL_POR_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_WATERMARK_LOWER_COUNTER_CTRL_ATTR                                                                        0x3
#define HWIO_WBM_R0_WATERMARK_LOWER_COUNTER_CTRL_IN(x)            \
                in_dword(HWIO_WBM_R0_WATERMARK_LOWER_COUNTER_CTRL_ADDR(x))
#define HWIO_WBM_R0_WATERMARK_LOWER_COUNTER_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WATERMARK_LOWER_COUNTER_CTRL_ADDR(x), m)
#define HWIO_WBM_R0_WATERMARK_LOWER_COUNTER_CTRL_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WATERMARK_LOWER_COUNTER_CTRL_ADDR(x),v)
#define HWIO_WBM_R0_WATERMARK_LOWER_COUNTER_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WATERMARK_LOWER_COUNTER_CTRL_ADDR(x),m,v,HWIO_WBM_R0_WATERMARK_LOWER_COUNTER_CTRL_IN(x))
#define HWIO_WBM_R0_WATERMARK_LOWER_COUNTER_CTRL_BYPASS_COUNTER_FULL_BMSK                                              0x4
#define HWIO_WBM_R0_WATERMARK_LOWER_COUNTER_CTRL_BYPASS_COUNTER_FULL_SHFT                                                2
#define HWIO_WBM_R0_WATERMARK_LOWER_COUNTER_CTRL_FREEPOOL_COUNTER_FULL_BMSK                                            0x2
#define HWIO_WBM_R0_WATERMARK_LOWER_COUNTER_CTRL_FREEPOOL_COUNTER_FULL_SHFT                                              1
#define HWIO_WBM_R0_WATERMARK_LOWER_COUNTER_CTRL_COUNTER_CLR_BMSK                                                      0x1
#define HWIO_WBM_R0_WATERMARK_LOWER_COUNTER_CTRL_COUNTER_CLR_SHFT                                                        0

#define HWIO_WBM_R0_FREEPOOL_PATH_LINK_DIST_COUNTER_ADDR(x)                                                     ((x) + 0xd0)
#define HWIO_WBM_R0_FREEPOOL_PATH_LINK_DIST_COUNTER_PHYS(x)                                                     ((x) + 0xd0)
#define HWIO_WBM_R0_FREEPOOL_PATH_LINK_DIST_COUNTER_OFFS                                                        (0xd0)
#define HWIO_WBM_R0_FREEPOOL_PATH_LINK_DIST_COUNTER_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_FREEPOOL_PATH_LINK_DIST_COUNTER_POR                                                         0x00000000
#define HWIO_WBM_R0_FREEPOOL_PATH_LINK_DIST_COUNTER_POR_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_FREEPOOL_PATH_LINK_DIST_COUNTER_ATTR                                                                     0x1
#define HWIO_WBM_R0_FREEPOOL_PATH_LINK_DIST_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_FREEPOOL_PATH_LINK_DIST_COUNTER_ADDR(x))
#define HWIO_WBM_R0_FREEPOOL_PATH_LINK_DIST_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_FREEPOOL_PATH_LINK_DIST_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_FREEPOOL_PATH_LINK_DIST_COUNTER_VALUE_BMSK                                                  0xffffffff
#define HWIO_WBM_R0_FREEPOOL_PATH_LINK_DIST_COUNTER_VALUE_SHFT                                                           0

#define HWIO_WBM_R0_BYPASS_PATH_LINK_DIST_COUNTER_ADDR(x)                                                       ((x) + 0xd4)
#define HWIO_WBM_R0_BYPASS_PATH_LINK_DIST_COUNTER_PHYS(x)                                                       ((x) + 0xd4)
#define HWIO_WBM_R0_BYPASS_PATH_LINK_DIST_COUNTER_OFFS                                                          (0xd4)
#define HWIO_WBM_R0_BYPASS_PATH_LINK_DIST_COUNTER_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_BYPASS_PATH_LINK_DIST_COUNTER_POR                                                           0x00000000
#define HWIO_WBM_R0_BYPASS_PATH_LINK_DIST_COUNTER_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_BYPASS_PATH_LINK_DIST_COUNTER_ATTR                                                                       0x1
#define HWIO_WBM_R0_BYPASS_PATH_LINK_DIST_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_BYPASS_PATH_LINK_DIST_COUNTER_ADDR(x))
#define HWIO_WBM_R0_BYPASS_PATH_LINK_DIST_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_BYPASS_PATH_LINK_DIST_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_BYPASS_PATH_LINK_DIST_COUNTER_VALUE_BMSK                                                    0xffffffff
#define HWIO_WBM_R0_BYPASS_PATH_LINK_DIST_COUNTER_VALUE_SHFT                                                             0

#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_TQM_ADDR(x)                                                            ((x) + 0xd8)
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_TQM_PHYS(x)                                                            ((x) + 0xd8)
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_TQM_OFFS                                                               (0xd8)
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_TQM_RMSK                                                               0xffffffff
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_TQM_POR                                                                0x00000000
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_TQM_POR_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_TQM_ATTR                                                                            0x1
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_TQM_IN(x)            \
                in_dword(HWIO_WBM_R0_VALID_BELOW_LT_COUNT_TQM_ADDR(x))
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_TQM_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_VALID_BELOW_LT_COUNT_TQM_ADDR(x), m)
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_TQM_VALUE_BMSK                                                         0xffffffff
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_TQM_VALUE_SHFT                                                                  0

#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_REO_ADDR(x)                                                            ((x) + 0xdc)
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_REO_PHYS(x)                                                            ((x) + 0xdc)
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_REO_OFFS                                                               (0xdc)
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_REO_RMSK                                                               0xffffffff
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_REO_POR                                                                0x00000000
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_REO_POR_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_REO_ATTR                                                                            0x1
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_REO_IN(x)            \
                in_dword(HWIO_WBM_R0_VALID_BELOW_LT_COUNT_REO_ADDR(x))
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_REO_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_VALID_BELOW_LT_COUNT_REO_ADDR(x), m)
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_REO_VALUE_BMSK                                                         0xffffffff
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_REO_VALUE_SHFT                                                                  0

#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_SW_ADDR(x)                                                             ((x) + 0xe0)
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_SW_PHYS(x)                                                             ((x) + 0xe0)
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_SW_OFFS                                                                (0xe0)
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_SW_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_SW_POR                                                                 0x00000000
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_SW_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_SW_ATTR                                                                             0x1
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_SW_IN(x)            \
                in_dword(HWIO_WBM_R0_VALID_BELOW_LT_COUNT_SW_ADDR(x))
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_SW_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_VALID_BELOW_LT_COUNT_SW_ADDR(x), m)
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_SW_VALUE_BMSK                                                          0xffffffff
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_SW_VALUE_SHFT                                                                   0

#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_FW_ADDR(x)                                                             ((x) + 0xe4)
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_FW_PHYS(x)                                                             ((x) + 0xe4)
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_FW_OFFS                                                                (0xe4)
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_FW_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_FW_POR                                                                 0x00000000
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_FW_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_FW_ATTR                                                                             0x1
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_FW_IN(x)            \
                in_dword(HWIO_WBM_R0_VALID_BELOW_LT_COUNT_FW_ADDR(x))
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_FW_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_VALID_BELOW_LT_COUNT_FW_ADDR(x), m)
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_FW_VALUE_BMSK                                                          0xffffffff
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_FW_VALUE_SHFT                                                                   0

#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_RXDMA_ADDR(x)                                                          ((x) + 0xe8)
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_RXDMA_PHYS(x)                                                          ((x) + 0xe8)
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_RXDMA_OFFS                                                             (0xe8)
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_RXDMA_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_RXDMA_POR                                                              0x00000000
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_RXDMA_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_RXDMA_ATTR                                                                          0x1
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_RXDMA_IN(x)            \
                in_dword(HWIO_WBM_R0_VALID_BELOW_LT_COUNT_RXDMA_ADDR(x))
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_RXDMA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_VALID_BELOW_LT_COUNT_RXDMA_ADDR(x), m)
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_RXDMA_VALUE_BMSK                                                       0xffffffff
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_RXDMA_VALUE_SHFT                                                                0

#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_CLR_ADDR(x)                                                            ((x) + 0xec)
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_CLR_PHYS(x)                                                            ((x) + 0xec)
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_CLR_OFFS                                                               (0xec)
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_CLR_RMSK                                                                     0x1f
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_CLR_POR                                                                0x00000000
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_CLR_POR_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_CLR_ATTR                                                                            0x3
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_CLR_IN(x)            \
                in_dword(HWIO_WBM_R0_VALID_BELOW_LT_COUNT_CLR_ADDR(x))
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_CLR_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_VALID_BELOW_LT_COUNT_CLR_ADDR(x), m)
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_CLR_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_VALID_BELOW_LT_COUNT_CLR_ADDR(x),v)
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_CLR_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_VALID_BELOW_LT_COUNT_CLR_ADDR(x),m,v,HWIO_WBM_R0_VALID_BELOW_LT_COUNT_CLR_IN(x))
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_CLR_RXDMA_CLR_BMSK                                                           0x10
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_CLR_RXDMA_CLR_SHFT                                                              4
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_CLR_FW_CLR_BMSK                                                               0x8
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_CLR_FW_CLR_SHFT                                                                 3
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_CLR_SW_CLR_BMSK                                                               0x4
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_CLR_SW_CLR_SHFT                                                                 2
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_CLR_REO_CLR_BMSK                                                              0x2
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_CLR_REO_CLR_SHFT                                                                1
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_CLR_TQM_CLR_BMSK                                                              0x1
#define HWIO_WBM_R0_VALID_BELOW_LT_COUNT_CLR_TQM_CLR_SHFT                                                                0

#define HWIO_WBM_R0_MSDU_PARSE_DUP_DETECT_INDICATION_ADDR(x)                                                    ((x) + 0xf0)
#define HWIO_WBM_R0_MSDU_PARSE_DUP_DETECT_INDICATION_PHYS(x)                                                    ((x) + 0xf0)
#define HWIO_WBM_R0_MSDU_PARSE_DUP_DETECT_INDICATION_OFFS                                                       (0xf0)
#define HWIO_WBM_R0_MSDU_PARSE_DUP_DETECT_INDICATION_RMSK                                                        0x1ffffff
#define HWIO_WBM_R0_MSDU_PARSE_DUP_DETECT_INDICATION_POR                                                        0x00000000
#define HWIO_WBM_R0_MSDU_PARSE_DUP_DETECT_INDICATION_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_MSDU_PARSE_DUP_DETECT_INDICATION_ATTR                                                                    0x1
#define HWIO_WBM_R0_MSDU_PARSE_DUP_DETECT_INDICATION_IN(x)            \
                in_dword(HWIO_WBM_R0_MSDU_PARSE_DUP_DETECT_INDICATION_ADDR(x))
#define HWIO_WBM_R0_MSDU_PARSE_DUP_DETECT_INDICATION_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_MSDU_PARSE_DUP_DETECT_INDICATION_ADDR(x), m)
#define HWIO_WBM_R0_MSDU_PARSE_DUP_DETECT_INDICATION_COUNT_BMSK                                                  0x1e00000
#define HWIO_WBM_R0_MSDU_PARSE_DUP_DETECT_INDICATION_COUNT_SHFT                                                         21
#define HWIO_WBM_R0_MSDU_PARSE_DUP_DETECT_INDICATION_COOKIE_BMSK                                                  0x1ffffe
#define HWIO_WBM_R0_MSDU_PARSE_DUP_DETECT_INDICATION_COOKIE_SHFT                                                         1
#define HWIO_WBM_R0_MSDU_PARSE_DUP_DETECT_INDICATION_VALID_BMSK                                                        0x1
#define HWIO_WBM_R0_MSDU_PARSE_DUP_DETECT_INDICATION_VALID_SHFT                                                          0

#define HWIO_WBM_R0_RLS_PARSE_DUP_DETECT_INDICATION_ADDR(x)                                                     ((x) + 0xf4)
#define HWIO_WBM_R0_RLS_PARSE_DUP_DETECT_INDICATION_PHYS(x)                                                     ((x) + 0xf4)
#define HWIO_WBM_R0_RLS_PARSE_DUP_DETECT_INDICATION_OFFS                                                        (0xf4)
#define HWIO_WBM_R0_RLS_PARSE_DUP_DETECT_INDICATION_RMSK                                                         0x1ffffff
#define HWIO_WBM_R0_RLS_PARSE_DUP_DETECT_INDICATION_POR                                                         0x00000000
#define HWIO_WBM_R0_RLS_PARSE_DUP_DETECT_INDICATION_POR_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_RLS_PARSE_DUP_DETECT_INDICATION_ATTR                                                                     0x1
#define HWIO_WBM_R0_RLS_PARSE_DUP_DETECT_INDICATION_IN(x)            \
                in_dword(HWIO_WBM_R0_RLS_PARSE_DUP_DETECT_INDICATION_ADDR(x))
#define HWIO_WBM_R0_RLS_PARSE_DUP_DETECT_INDICATION_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RLS_PARSE_DUP_DETECT_INDICATION_ADDR(x), m)
#define HWIO_WBM_R0_RLS_PARSE_DUP_DETECT_INDICATION_COUNT_BMSK                                                   0x1e00000
#define HWIO_WBM_R0_RLS_PARSE_DUP_DETECT_INDICATION_COUNT_SHFT                                                          21
#define HWIO_WBM_R0_RLS_PARSE_DUP_DETECT_INDICATION_COOKIE_BMSK                                                   0x1ffffe
#define HWIO_WBM_R0_RLS_PARSE_DUP_DETECT_INDICATION_COOKIE_SHFT                                                          1
#define HWIO_WBM_R0_RLS_PARSE_DUP_DETECT_INDICATION_VALID_BMSK                                                         0x1
#define HWIO_WBM_R0_RLS_PARSE_DUP_DETECT_INDICATION_VALID_SHFT                                                           0

#define HWIO_WBM_R0_IDLE_DIST_DUP_DET_INDICATION_ADDR(x)                                                        ((x) + 0xf8)
#define HWIO_WBM_R0_IDLE_DIST_DUP_DET_INDICATION_PHYS(x)                                                        ((x) + 0xf8)
#define HWIO_WBM_R0_IDLE_DIST_DUP_DET_INDICATION_OFFS                                                           (0xf8)
#define HWIO_WBM_R0_IDLE_DIST_DUP_DET_INDICATION_RMSK                                                            0x1ffffff
#define HWIO_WBM_R0_IDLE_DIST_DUP_DET_INDICATION_POR                                                            0x00000000
#define HWIO_WBM_R0_IDLE_DIST_DUP_DET_INDICATION_POR_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_IDLE_DIST_DUP_DET_INDICATION_ATTR                                                                        0x1
#define HWIO_WBM_R0_IDLE_DIST_DUP_DET_INDICATION_IN(x)            \
                in_dword(HWIO_WBM_R0_IDLE_DIST_DUP_DET_INDICATION_ADDR(x))
#define HWIO_WBM_R0_IDLE_DIST_DUP_DET_INDICATION_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_IDLE_DIST_DUP_DET_INDICATION_ADDR(x), m)
#define HWIO_WBM_R0_IDLE_DIST_DUP_DET_INDICATION_COUNT_BMSK                                                      0x1e00000
#define HWIO_WBM_R0_IDLE_DIST_DUP_DET_INDICATION_COUNT_SHFT                                                             21
#define HWIO_WBM_R0_IDLE_DIST_DUP_DET_INDICATION_COOKIE_BMSK                                                      0x1ffffe
#define HWIO_WBM_R0_IDLE_DIST_DUP_DET_INDICATION_COOKIE_SHFT                                                             1
#define HWIO_WBM_R0_IDLE_DIST_DUP_DET_INDICATION_VALID_BMSK                                                            0x1
#define HWIO_WBM_R0_IDLE_DIST_DUP_DET_INDICATION_VALID_SHFT                                                              0

#define HWIO_WBM_R0_TQM_LINKS_DISTRIBUTED_ADDR(x)                                                               ((x) + 0xfc)
#define HWIO_WBM_R0_TQM_LINKS_DISTRIBUTED_PHYS(x)                                                               ((x) + 0xfc)
#define HWIO_WBM_R0_TQM_LINKS_DISTRIBUTED_OFFS                                                                  (0xfc)
#define HWIO_WBM_R0_TQM_LINKS_DISTRIBUTED_RMSK                                                                     0xfffff
#define HWIO_WBM_R0_TQM_LINKS_DISTRIBUTED_POR                                                                   0x00000000
#define HWIO_WBM_R0_TQM_LINKS_DISTRIBUTED_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_TQM_LINKS_DISTRIBUTED_ATTR                                                                               0x1
#define HWIO_WBM_R0_TQM_LINKS_DISTRIBUTED_IN(x)            \
                in_dword(HWIO_WBM_R0_TQM_LINKS_DISTRIBUTED_ADDR(x))
#define HWIO_WBM_R0_TQM_LINKS_DISTRIBUTED_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_TQM_LINKS_DISTRIBUTED_ADDR(x), m)
#define HWIO_WBM_R0_TQM_LINKS_DISTRIBUTED_COUNT_BMSK                                                               0xfffff
#define HWIO_WBM_R0_TQM_LINKS_DISTRIBUTED_COUNT_SHFT                                                                     0

#define HWIO_WBM_R0_REO_LINKS_DISTRIBUTED_ADDR(x)                                                               ((x) + 0x100)
#define HWIO_WBM_R0_REO_LINKS_DISTRIBUTED_PHYS(x)                                                               ((x) + 0x100)
#define HWIO_WBM_R0_REO_LINKS_DISTRIBUTED_OFFS                                                                  (0x100)
#define HWIO_WBM_R0_REO_LINKS_DISTRIBUTED_RMSK                                                                     0xfffff
#define HWIO_WBM_R0_REO_LINKS_DISTRIBUTED_POR                                                                   0x00000000
#define HWIO_WBM_R0_REO_LINKS_DISTRIBUTED_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_REO_LINKS_DISTRIBUTED_ATTR                                                                               0x1
#define HWIO_WBM_R0_REO_LINKS_DISTRIBUTED_IN(x)            \
                in_dword(HWIO_WBM_R0_REO_LINKS_DISTRIBUTED_ADDR(x))
#define HWIO_WBM_R0_REO_LINKS_DISTRIBUTED_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_REO_LINKS_DISTRIBUTED_ADDR(x), m)
#define HWIO_WBM_R0_REO_LINKS_DISTRIBUTED_COUNT_BMSK                                                               0xfffff
#define HWIO_WBM_R0_REO_LINKS_DISTRIBUTED_COUNT_SHFT                                                                     0

#define HWIO_WBM_R0_SW_LINKS_DISTRIBUTED_ADDR(x)                                                                ((x) + 0x104)
#define HWIO_WBM_R0_SW_LINKS_DISTRIBUTED_PHYS(x)                                                                ((x) + 0x104)
#define HWIO_WBM_R0_SW_LINKS_DISTRIBUTED_OFFS                                                                   (0x104)
#define HWIO_WBM_R0_SW_LINKS_DISTRIBUTED_RMSK                                                                      0xfffff
#define HWIO_WBM_R0_SW_LINKS_DISTRIBUTED_POR                                                                    0x00000000
#define HWIO_WBM_R0_SW_LINKS_DISTRIBUTED_POR_RMSK                                                               0xffffffff
#define HWIO_WBM_R0_SW_LINKS_DISTRIBUTED_ATTR                                                                                0x1
#define HWIO_WBM_R0_SW_LINKS_DISTRIBUTED_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_LINKS_DISTRIBUTED_ADDR(x))
#define HWIO_WBM_R0_SW_LINKS_DISTRIBUTED_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_LINKS_DISTRIBUTED_ADDR(x), m)
#define HWIO_WBM_R0_SW_LINKS_DISTRIBUTED_COUNT_BMSK                                                                0xfffff
#define HWIO_WBM_R0_SW_LINKS_DISTRIBUTED_COUNT_SHFT                                                                      0

#define HWIO_WBM_R0_FW_LINKS_DISTRIBUTED_ADDR(x)                                                                ((x) + 0x108)
#define HWIO_WBM_R0_FW_LINKS_DISTRIBUTED_PHYS(x)                                                                ((x) + 0x108)
#define HWIO_WBM_R0_FW_LINKS_DISTRIBUTED_OFFS                                                                   (0x108)
#define HWIO_WBM_R0_FW_LINKS_DISTRIBUTED_RMSK                                                                      0xfffff
#define HWIO_WBM_R0_FW_LINKS_DISTRIBUTED_POR                                                                    0x00000000
#define HWIO_WBM_R0_FW_LINKS_DISTRIBUTED_POR_RMSK                                                               0xffffffff
#define HWIO_WBM_R0_FW_LINKS_DISTRIBUTED_ATTR                                                                                0x1
#define HWIO_WBM_R0_FW_LINKS_DISTRIBUTED_IN(x)            \
                in_dword(HWIO_WBM_R0_FW_LINKS_DISTRIBUTED_ADDR(x))
#define HWIO_WBM_R0_FW_LINKS_DISTRIBUTED_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_FW_LINKS_DISTRIBUTED_ADDR(x), m)
#define HWIO_WBM_R0_FW_LINKS_DISTRIBUTED_COUNT_BMSK                                                                0xfffff
#define HWIO_WBM_R0_FW_LINKS_DISTRIBUTED_COUNT_SHFT                                                                      0

#define HWIO_WBM_R0_RXDMA0_LINKS_DISTRIBUTED_ADDR(x)                                                            ((x) + 0x10c)
#define HWIO_WBM_R0_RXDMA0_LINKS_DISTRIBUTED_PHYS(x)                                                            ((x) + 0x10c)
#define HWIO_WBM_R0_RXDMA0_LINKS_DISTRIBUTED_OFFS                                                               (0x10c)
#define HWIO_WBM_R0_RXDMA0_LINKS_DISTRIBUTED_RMSK                                                                  0xfffff
#define HWIO_WBM_R0_RXDMA0_LINKS_DISTRIBUTED_POR                                                                0x00000000
#define HWIO_WBM_R0_RXDMA0_LINKS_DISTRIBUTED_POR_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_RXDMA0_LINKS_DISTRIBUTED_ATTR                                                                            0x1
#define HWIO_WBM_R0_RXDMA0_LINKS_DISTRIBUTED_IN(x)            \
                in_dword(HWIO_WBM_R0_RXDMA0_LINKS_DISTRIBUTED_ADDR(x))
#define HWIO_WBM_R0_RXDMA0_LINKS_DISTRIBUTED_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RXDMA0_LINKS_DISTRIBUTED_ADDR(x), m)
#define HWIO_WBM_R0_RXDMA0_LINKS_DISTRIBUTED_COUNT_BMSK                                                            0xfffff
#define HWIO_WBM_R0_RXDMA0_LINKS_DISTRIBUTED_COUNT_SHFT                                                                  0

#define HWIO_WBM_R0_TOTAL_LINKS_DISTRIBUTED_ADDR(x)                                                             ((x) + 0x110)
#define HWIO_WBM_R0_TOTAL_LINKS_DISTRIBUTED_PHYS(x)                                                             ((x) + 0x110)
#define HWIO_WBM_R0_TOTAL_LINKS_DISTRIBUTED_OFFS                                                                (0x110)
#define HWIO_WBM_R0_TOTAL_LINKS_DISTRIBUTED_RMSK                                                                   0xfffff
#define HWIO_WBM_R0_TOTAL_LINKS_DISTRIBUTED_POR                                                                 0x00000000
#define HWIO_WBM_R0_TOTAL_LINKS_DISTRIBUTED_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_TOTAL_LINKS_DISTRIBUTED_ATTR                                                                             0x1
#define HWIO_WBM_R0_TOTAL_LINKS_DISTRIBUTED_IN(x)            \
                in_dword(HWIO_WBM_R0_TOTAL_LINKS_DISTRIBUTED_ADDR(x))
#define HWIO_WBM_R0_TOTAL_LINKS_DISTRIBUTED_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_TOTAL_LINKS_DISTRIBUTED_ADDR(x), m)
#define HWIO_WBM_R0_TOTAL_LINKS_DISTRIBUTED_COUNT_BMSK                                                             0xfffff
#define HWIO_WBM_R0_TOTAL_LINKS_DISTRIBUTED_COUNT_SHFT                                                                   0

#define HWIO_WBM_R0_TOTAL_LINKS_AVAILABLE_ADDR(x)                                                               ((x) + 0x114)
#define HWIO_WBM_R0_TOTAL_LINKS_AVAILABLE_PHYS(x)                                                               ((x) + 0x114)
#define HWIO_WBM_R0_TOTAL_LINKS_AVAILABLE_OFFS                                                                  (0x114)
#define HWIO_WBM_R0_TOTAL_LINKS_AVAILABLE_RMSK                                                                     0xfffff
#define HWIO_WBM_R0_TOTAL_LINKS_AVAILABLE_POR                                                                   0x00000000
#define HWIO_WBM_R0_TOTAL_LINKS_AVAILABLE_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_TOTAL_LINKS_AVAILABLE_ATTR                                                                               0x1
#define HWIO_WBM_R0_TOTAL_LINKS_AVAILABLE_IN(x)            \
                in_dword(HWIO_WBM_R0_TOTAL_LINKS_AVAILABLE_ADDR(x))
#define HWIO_WBM_R0_TOTAL_LINKS_AVAILABLE_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_TOTAL_LINKS_AVAILABLE_ADDR(x), m)
#define HWIO_WBM_R0_TOTAL_LINKS_AVAILABLE_COUNT_BMSK                                                               0xfffff
#define HWIO_WBM_R0_TOTAL_LINKS_AVAILABLE_COUNT_SHFT                                                                     0

#define HWIO_WBM_R0_DUP_DET_FIFO_RD_CTRL_ADDR(x)                                                                ((x) + 0x118)
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_CTRL_PHYS(x)                                                                ((x) + 0x118)
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_CTRL_OFFS                                                                   (0x118)
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_CTRL_RMSK                                                                        0x3ff
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_CTRL_POR                                                                    0x00000000
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_CTRL_POR_RMSK                                                               0xffffffff
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_CTRL_ATTR                                                                                0x3
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_CTRL_IN(x)            \
                in_dword(HWIO_WBM_R0_DUP_DET_FIFO_RD_CTRL_ADDR(x))
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_DUP_DET_FIFO_RD_CTRL_ADDR(x), m)
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_CTRL_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_DUP_DET_FIFO_RD_CTRL_ADDR(x),v)
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_DUP_DET_FIFO_RD_CTRL_ADDR(x),m,v,HWIO_WBM_R0_DUP_DET_FIFO_RD_CTRL_IN(x))
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_CTRL_RD_PTR_BMSK                                                                 0x3fe
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_CTRL_RD_PTR_SHFT                                                                     1
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_CTRL_RD_VALID_BMSK                                                                 0x1
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_CTRL_RD_VALID_SHFT                                                                   0

#define HWIO_WBM_R0_DUP_DET_FIFO_RD_DATA_0_ADDR(x)                                                              ((x) + 0x11c)
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_DATA_0_PHYS(x)                                                              ((x) + 0x11c)
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_DATA_0_OFFS                                                                 (0x11c)
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_DATA_0_RMSK                                                                 0xffffffff
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_DATA_0_POR                                                                  0x00000000
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_DATA_0_POR_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_DATA_0_ATTR                                                                              0x1
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_DATA_0_IN(x)            \
                in_dword(HWIO_WBM_R0_DUP_DET_FIFO_RD_DATA_0_ADDR(x))
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_DATA_0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_DUP_DET_FIFO_RD_DATA_0_ADDR(x), m)
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_DATA_0_RD_DATA_BMSK                                                         0xffffffff
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_DATA_0_RD_DATA_SHFT                                                                  0

#define HWIO_WBM_R0_DUP_DET_FIFO_RD_DATA_1_ADDR(x)                                                              ((x) + 0x120)
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_DATA_1_PHYS(x)                                                              ((x) + 0x120)
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_DATA_1_OFFS                                                                 (0x120)
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_DATA_1_RMSK                                                                 0xffffffff
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_DATA_1_POR                                                                  0x00000000
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_DATA_1_POR_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_DATA_1_ATTR                                                                              0x1
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_DATA_1_IN(x)            \
                in_dword(HWIO_WBM_R0_DUP_DET_FIFO_RD_DATA_1_ADDR(x))
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_DATA_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_DUP_DET_FIFO_RD_DATA_1_ADDR(x), m)
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_DATA_1_RD_DATA_BMSK                                                         0xffffffff
#define HWIO_WBM_R0_DUP_DET_FIFO_RD_DATA_1_RD_DATA_SHFT                                                                  0

#define HWIO_WBM_R0_IDLE_LIST_FIFO_DETAILS_ADDR(x)                                                              ((x) + 0x124)
#define HWIO_WBM_R0_IDLE_LIST_FIFO_DETAILS_PHYS(x)                                                              ((x) + 0x124)
#define HWIO_WBM_R0_IDLE_LIST_FIFO_DETAILS_OFFS                                                                 (0x124)
#define HWIO_WBM_R0_IDLE_LIST_FIFO_DETAILS_RMSK                                                                      0x1ff
#define HWIO_WBM_R0_IDLE_LIST_FIFO_DETAILS_POR                                                                  0x00000000
#define HWIO_WBM_R0_IDLE_LIST_FIFO_DETAILS_POR_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_IDLE_LIST_FIFO_DETAILS_ATTR                                                                              0x1
#define HWIO_WBM_R0_IDLE_LIST_FIFO_DETAILS_IN(x)            \
                in_dword(HWIO_WBM_R0_IDLE_LIST_FIFO_DETAILS_ADDR(x))
#define HWIO_WBM_R0_IDLE_LIST_FIFO_DETAILS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_IDLE_LIST_FIFO_DETAILS_ADDR(x), m)
#define HWIO_WBM_R0_IDLE_LIST_FIFO_DETAILS_INTERNAL_PTR_BMSK                                                         0x1e0
#define HWIO_WBM_R0_IDLE_LIST_FIFO_DETAILS_INTERNAL_PTR_SHFT                                                             5
#define HWIO_WBM_R0_IDLE_LIST_FIFO_DETAILS_UD_CNT_BMSK                                                                0x1f
#define HWIO_WBM_R0_IDLE_LIST_FIFO_DETAILS_UD_CNT_SHFT                                                                   0

#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_CTRL_ADDR(x)                                                              ((x) + 0x128)
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_CTRL_PHYS(x)                                                              ((x) + 0x128)
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_CTRL_OFFS                                                                 (0x128)
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_CTRL_RMSK                                                                       0x1f
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_CTRL_POR                                                                  0x00000000
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_CTRL_POR_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_CTRL_ATTR                                                                              0x3
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_CTRL_IN(x)            \
                in_dword(HWIO_WBM_R0_IDLE_LIST_FIFO_RD_CTRL_ADDR(x))
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_IDLE_LIST_FIFO_RD_CTRL_ADDR(x), m)
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_CTRL_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_IDLE_LIST_FIFO_RD_CTRL_ADDR(x),v)
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_IDLE_LIST_FIFO_RD_CTRL_ADDR(x),m,v,HWIO_WBM_R0_IDLE_LIST_FIFO_RD_CTRL_IN(x))
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_CTRL_RD_PTR_BMSK                                                                0x1e
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_CTRL_RD_PTR_SHFT                                                                   1
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_CTRL_RD_VALID_BMSK                                                               0x1
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_CTRL_RD_VALID_SHFT                                                                 0

#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_DATA_0_ADDR(x)                                                            ((x) + 0x12c)
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_DATA_0_PHYS(x)                                                            ((x) + 0x12c)
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_DATA_0_OFFS                                                               (0x12c)
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_DATA_0_RMSK                                                               0xffffffff
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_DATA_0_POR                                                                0x00000000
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_DATA_0_POR_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_DATA_0_ATTR                                                                            0x1
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_DATA_0_IN(x)            \
                in_dword(HWIO_WBM_R0_IDLE_LIST_FIFO_RD_DATA_0_ADDR(x))
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_DATA_0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_IDLE_LIST_FIFO_RD_DATA_0_ADDR(x), m)
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_DATA_0_RD_DATA_BMSK                                                       0xffffffff
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_DATA_0_RD_DATA_SHFT                                                                0

#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_DATA_1_ADDR(x)                                                            ((x) + 0x130)
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_DATA_1_PHYS(x)                                                            ((x) + 0x130)
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_DATA_1_OFFS                                                               (0x130)
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_DATA_1_RMSK                                                               0xffffffff
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_DATA_1_POR                                                                0x00000000
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_DATA_1_POR_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_DATA_1_ATTR                                                                            0x1
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_DATA_1_IN(x)            \
                in_dword(HWIO_WBM_R0_IDLE_LIST_FIFO_RD_DATA_1_ADDR(x))
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_DATA_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_IDLE_LIST_FIFO_RD_DATA_1_ADDR(x), m)
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_DATA_1_RD_DATA_BMSK                                                       0xffffffff
#define HWIO_WBM_R0_IDLE_LIST_FIFO_RD_DATA_1_RD_DATA_SHFT                                                                0

#define HWIO_WBM_R0_IDLE_PROD_FIFO_DETAILS_ADDR(x)                                                              ((x) + 0x134)
#define HWIO_WBM_R0_IDLE_PROD_FIFO_DETAILS_PHYS(x)                                                              ((x) + 0x134)
#define HWIO_WBM_R0_IDLE_PROD_FIFO_DETAILS_OFFS                                                                 (0x134)
#define HWIO_WBM_R0_IDLE_PROD_FIFO_DETAILS_RMSK                                                                    0x3ffff
#define HWIO_WBM_R0_IDLE_PROD_FIFO_DETAILS_POR                                                                  0x00000000
#define HWIO_WBM_R0_IDLE_PROD_FIFO_DETAILS_POR_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_IDLE_PROD_FIFO_DETAILS_ATTR                                                                              0x1
#define HWIO_WBM_R0_IDLE_PROD_FIFO_DETAILS_IN(x)            \
                in_dword(HWIO_WBM_R0_IDLE_PROD_FIFO_DETAILS_ADDR(x))
#define HWIO_WBM_R0_IDLE_PROD_FIFO_DETAILS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_IDLE_PROD_FIFO_DETAILS_ADDR(x), m)
#define HWIO_WBM_R0_IDLE_PROD_FIFO_DETAILS_INTERNAL_BF_RDPTR_BMSK                                                  0x3c000
#define HWIO_WBM_R0_IDLE_PROD_FIFO_DETAILS_INTERNAL_BF_RDPTR_SHFT                                                       14
#define HWIO_WBM_R0_IDLE_PROD_FIFO_DETAILS_BUD_CNT_BMSK                                                             0x3e00
#define HWIO_WBM_R0_IDLE_PROD_FIFO_DETAILS_BUD_CNT_SHFT                                                                  9
#define HWIO_WBM_R0_IDLE_PROD_FIFO_DETAILS_INTERNAL_RDPTR_BMSK                                                       0x1e0
#define HWIO_WBM_R0_IDLE_PROD_FIFO_DETAILS_INTERNAL_RDPTR_SHFT                                                           5
#define HWIO_WBM_R0_IDLE_PROD_FIFO_DETAILS_UD_CNT_BMSK                                                                0x1f
#define HWIO_WBM_R0_IDLE_PROD_FIFO_DETAILS_UD_CNT_SHFT                                                                   0

#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_CTRL_ADDR(x)                                                              ((x) + 0x138)
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_CTRL_PHYS(x)                                                              ((x) + 0x138)
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_CTRL_OFFS                                                                 (0x138)
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_CTRL_RMSK                                                                       0x1f
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_CTRL_POR                                                                  0x00000000
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_CTRL_POR_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_CTRL_ATTR                                                                              0x3
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_CTRL_IN(x)            \
                in_dword(HWIO_WBM_R0_IDLE_PROD_FIFO_RD_CTRL_ADDR(x))
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_IDLE_PROD_FIFO_RD_CTRL_ADDR(x), m)
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_CTRL_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_IDLE_PROD_FIFO_RD_CTRL_ADDR(x),v)
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_IDLE_PROD_FIFO_RD_CTRL_ADDR(x),m,v,HWIO_WBM_R0_IDLE_PROD_FIFO_RD_CTRL_IN(x))
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_CTRL_RD_PTR_BMSK                                                                0x1e
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_CTRL_RD_PTR_SHFT                                                                   1
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_CTRL_RD_VALID_BMSK                                                               0x1
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_CTRL_RD_VALID_SHFT                                                                 0

#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_DATA_0_ADDR(x)                                                            ((x) + 0x13c)
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_DATA_0_PHYS(x)                                                            ((x) + 0x13c)
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_DATA_0_OFFS                                                               (0x13c)
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_DATA_0_RMSK                                                               0xffffffff
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_DATA_0_POR                                                                0x00000000
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_DATA_0_POR_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_DATA_0_ATTR                                                                            0x1
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_DATA_0_IN(x)            \
                in_dword(HWIO_WBM_R0_IDLE_PROD_FIFO_RD_DATA_0_ADDR(x))
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_DATA_0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_IDLE_PROD_FIFO_RD_DATA_0_ADDR(x), m)
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_DATA_0_RD_DATA_BMSK                                                       0xffffffff
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_DATA_0_RD_DATA_SHFT                                                                0

#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_DATA_1_ADDR(x)                                                            ((x) + 0x140)
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_DATA_1_PHYS(x)                                                            ((x) + 0x140)
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_DATA_1_OFFS                                                               (0x140)
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_DATA_1_RMSK                                                               0xffffffff
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_DATA_1_POR                                                                0x00000000
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_DATA_1_POR_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_DATA_1_ATTR                                                                            0x1
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_DATA_1_IN(x)            \
                in_dword(HWIO_WBM_R0_IDLE_PROD_FIFO_RD_DATA_1_ADDR(x))
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_DATA_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_IDLE_PROD_FIFO_RD_DATA_1_ADDR(x), m)
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_DATA_1_RD_DATA_BMSK                                                       0xffffffff
#define HWIO_WBM_R0_IDLE_PROD_FIFO_RD_DATA_1_RD_DATA_SHFT                                                                0

#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_CTRL_ADDR(x)                                                           ((x) + 0x144)
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_CTRL_PHYS(x)                                                           ((x) + 0x144)
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_CTRL_OFFS                                                              (0x144)
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_CTRL_RMSK                                                                    0x1f
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_CTRL_POR                                                               0x00000000
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_CTRL_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_CTRL_ATTR                                                                           0x3
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_CTRL_IN(x)            \
                in_dword(HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_CTRL_ADDR(x))
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_CTRL_ADDR(x), m)
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_CTRL_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_CTRL_ADDR(x),v)
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_CTRL_ADDR(x),m,v,HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_CTRL_IN(x))
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_CTRL_RD_PTR_BMSK                                                             0x1e
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_CTRL_RD_PTR_SHFT                                                                1
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_CTRL_RD_VALID_BMSK                                                            0x1
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_CTRL_RD_VALID_SHFT                                                              0

#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_DATA_0_ADDR(x)                                                         ((x) + 0x148)
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_DATA_0_PHYS(x)                                                         ((x) + 0x148)
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_DATA_0_OFFS                                                            (0x148)
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_DATA_0_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_DATA_0_POR                                                             0x00000000
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_DATA_0_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_DATA_0_ATTR                                                                         0x1
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_DATA_0_IN(x)            \
                in_dword(HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_DATA_0_ADDR(x))
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_DATA_0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_DATA_0_ADDR(x), m)
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_DATA_0_RD_DATA_BMSK                                                    0xffffffff
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_DATA_0_RD_DATA_SHFT                                                             0

#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_DATA_1_ADDR(x)                                                         ((x) + 0x14c)
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_DATA_1_PHYS(x)                                                         ((x) + 0x14c)
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_DATA_1_OFFS                                                            (0x14c)
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_DATA_1_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_DATA_1_POR                                                             0x00000000
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_DATA_1_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_DATA_1_ATTR                                                                         0x1
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_DATA_1_IN(x)            \
                in_dword(HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_DATA_1_ADDR(x))
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_DATA_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_DATA_1_ADDR(x), m)
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_DATA_1_RD_DATA_BMSK                                                    0xffffffff
#define HWIO_WBM_R0_IDLE_PROD_BP_FIFO_RD_DATA_1_RD_DATA_SHFT                                                             0

#define HWIO_WBM_R0_RLS_PARSER_FIFO_DETAILS_ADDR(x)                                                             ((x) + 0x150)
#define HWIO_WBM_R0_RLS_PARSER_FIFO_DETAILS_PHYS(x)                                                             ((x) + 0x150)
#define HWIO_WBM_R0_RLS_PARSER_FIFO_DETAILS_OFFS                                                                (0x150)
#define HWIO_WBM_R0_RLS_PARSER_FIFO_DETAILS_RMSK                                                                     0x7ff
#define HWIO_WBM_R0_RLS_PARSER_FIFO_DETAILS_POR                                                                 0x00000000
#define HWIO_WBM_R0_RLS_PARSER_FIFO_DETAILS_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_RLS_PARSER_FIFO_DETAILS_ATTR                                                                             0x1
#define HWIO_WBM_R0_RLS_PARSER_FIFO_DETAILS_IN(x)            \
                in_dword(HWIO_WBM_R0_RLS_PARSER_FIFO_DETAILS_ADDR(x))
#define HWIO_WBM_R0_RLS_PARSER_FIFO_DETAILS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RLS_PARSER_FIFO_DETAILS_ADDR(x), m)
#define HWIO_WBM_R0_RLS_PARSER_FIFO_DETAILS_INTERNAL_PTR_BMSK                                                        0x7c0
#define HWIO_WBM_R0_RLS_PARSER_FIFO_DETAILS_INTERNAL_PTR_SHFT                                                            6
#define HWIO_WBM_R0_RLS_PARSER_FIFO_DETAILS_UD_CNT_BMSK                                                               0x3f
#define HWIO_WBM_R0_RLS_PARSER_FIFO_DETAILS_UD_CNT_SHFT                                                                  0

#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_CTRL_ADDR(x)                                                             ((x) + 0x154)
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_CTRL_PHYS(x)                                                             ((x) + 0x154)
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_CTRL_OFFS                                                                (0x154)
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_CTRL_RMSK                                                                      0x3f
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_CTRL_POR                                                                 0x00000000
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_CTRL_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_CTRL_ATTR                                                                             0x3
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_CTRL_IN(x)            \
                in_dword(HWIO_WBM_R0_RLS_PARSER_FIFO_RD_CTRL_ADDR(x))
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RLS_PARSER_FIFO_RD_CTRL_ADDR(x), m)
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_CTRL_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_RLS_PARSER_FIFO_RD_CTRL_ADDR(x),v)
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_RLS_PARSER_FIFO_RD_CTRL_ADDR(x),m,v,HWIO_WBM_R0_RLS_PARSER_FIFO_RD_CTRL_IN(x))
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_CTRL_RD_PTR_BMSK                                                               0x3e
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_CTRL_RD_PTR_SHFT                                                                  1
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_CTRL_RD_VALID_BMSK                                                              0x1
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_CTRL_RD_VALID_SHFT                                                                0

#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_DATA_0_ADDR(x)                                                           ((x) + 0x158)
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_DATA_0_PHYS(x)                                                           ((x) + 0x158)
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_DATA_0_OFFS                                                              (0x158)
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_DATA_0_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_DATA_0_POR                                                               0x00000000
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_DATA_0_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_DATA_0_ATTR                                                                           0x1
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_DATA_0_IN(x)            \
                in_dword(HWIO_WBM_R0_RLS_PARSER_FIFO_RD_DATA_0_ADDR(x))
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_DATA_0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RLS_PARSER_FIFO_RD_DATA_0_ADDR(x), m)
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_DATA_0_RD_DATA_BMSK                                                      0xffffffff
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_DATA_0_RD_DATA_SHFT                                                               0

#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_DATA_1_ADDR(x)                                                           ((x) + 0x15c)
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_DATA_1_PHYS(x)                                                           ((x) + 0x15c)
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_DATA_1_OFFS                                                              (0x15c)
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_DATA_1_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_DATA_1_POR                                                               0x00000000
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_DATA_1_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_DATA_1_ATTR                                                                           0x1
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_DATA_1_IN(x)            \
                in_dword(HWIO_WBM_R0_RLS_PARSER_FIFO_RD_DATA_1_ADDR(x))
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_DATA_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RLS_PARSER_FIFO_RD_DATA_1_ADDR(x), m)
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_DATA_1_RD_DATA_BMSK                                                      0xffffffff
#define HWIO_WBM_R0_RLS_PARSER_FIFO_RD_DATA_1_RD_DATA_SHFT                                                               0

#define HWIO_WBM_R0_SW0_PROD_FIFO_DETAILS_ADDR(x)                                                               ((x) + 0x160)
#define HWIO_WBM_R0_SW0_PROD_FIFO_DETAILS_PHYS(x)                                                               ((x) + 0x160)
#define HWIO_WBM_R0_SW0_PROD_FIFO_DETAILS_OFFS                                                                  (0x160)
#define HWIO_WBM_R0_SW0_PROD_FIFO_DETAILS_RMSK                                                                       0xfbf
#define HWIO_WBM_R0_SW0_PROD_FIFO_DETAILS_POR                                                                   0x00000000
#define HWIO_WBM_R0_SW0_PROD_FIFO_DETAILS_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_SW0_PROD_FIFO_DETAILS_ATTR                                                                               0x1
#define HWIO_WBM_R0_SW0_PROD_FIFO_DETAILS_IN(x)            \
                in_dword(HWIO_WBM_R0_SW0_PROD_FIFO_DETAILS_ADDR(x))
#define HWIO_WBM_R0_SW0_PROD_FIFO_DETAILS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW0_PROD_FIFO_DETAILS_ADDR(x), m)
#define HWIO_WBM_R0_SW0_PROD_FIFO_DETAILS_INTERNAL_PTR_BMSK                                                          0xf80
#define HWIO_WBM_R0_SW0_PROD_FIFO_DETAILS_INTERNAL_PTR_SHFT                                                              7
#define HWIO_WBM_R0_SW0_PROD_FIFO_DETAILS_UD_CNT_BMSK                                                                 0x3f
#define HWIO_WBM_R0_SW0_PROD_FIFO_DETAILS_UD_CNT_SHFT                                                                    0

#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_CTRL_ADDR(x)                                                               ((x) + 0x164)
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_CTRL_PHYS(x)                                                               ((x) + 0x164)
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_CTRL_OFFS                                                                  (0x164)
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_CTRL_RMSK                                                                        0x3f
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_CTRL_POR                                                                   0x00000000
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_CTRL_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_CTRL_ATTR                                                                               0x3
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_CTRL_IN(x)            \
                in_dword(HWIO_WBM_R0_SW0_PROD_FIFO_RD_CTRL_ADDR(x))
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW0_PROD_FIFO_RD_CTRL_ADDR(x), m)
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_CTRL_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW0_PROD_FIFO_RD_CTRL_ADDR(x),v)
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW0_PROD_FIFO_RD_CTRL_ADDR(x),m,v,HWIO_WBM_R0_SW0_PROD_FIFO_RD_CTRL_IN(x))
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_CTRL_RD_PTR_BMSK                                                                 0x3e
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_CTRL_RD_PTR_SHFT                                                                    1
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_CTRL_RD_VALID_BMSK                                                                0x1
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_CTRL_RD_VALID_SHFT                                                                  0

#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_DATA_0_ADDR(x)                                                             ((x) + 0x168)
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_DATA_0_PHYS(x)                                                             ((x) + 0x168)
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_DATA_0_OFFS                                                                (0x168)
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_DATA_0_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_DATA_0_POR                                                                 0x00000000
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_DATA_0_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_DATA_0_ATTR                                                                             0x1
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_DATA_0_IN(x)            \
                in_dword(HWIO_WBM_R0_SW0_PROD_FIFO_RD_DATA_0_ADDR(x))
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_DATA_0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW0_PROD_FIFO_RD_DATA_0_ADDR(x), m)
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_DATA_0_RD_DATA_BMSK                                                        0xffffffff
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_DATA_0_RD_DATA_SHFT                                                                 0

#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_DATA_1_ADDR(x)                                                             ((x) + 0x16c)
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_DATA_1_PHYS(x)                                                             ((x) + 0x16c)
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_DATA_1_OFFS                                                                (0x16c)
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_DATA_1_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_DATA_1_POR                                                                 0x00000000
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_DATA_1_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_DATA_1_ATTR                                                                             0x1
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_DATA_1_IN(x)            \
                in_dword(HWIO_WBM_R0_SW0_PROD_FIFO_RD_DATA_1_ADDR(x))
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_DATA_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW0_PROD_FIFO_RD_DATA_1_ADDR(x), m)
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_DATA_1_RD_DATA_BMSK                                                        0xffffffff
#define HWIO_WBM_R0_SW0_PROD_FIFO_RD_DATA_1_RD_DATA_SHFT                                                                 0

#define HWIO_WBM_R0_SW1_PROD_FIFO_DETAILS_ADDR(x)                                                               ((x) + 0x170)
#define HWIO_WBM_R0_SW1_PROD_FIFO_DETAILS_PHYS(x)                                                               ((x) + 0x170)
#define HWIO_WBM_R0_SW1_PROD_FIFO_DETAILS_OFFS                                                                  (0x170)
#define HWIO_WBM_R0_SW1_PROD_FIFO_DETAILS_RMSK                                                                       0xfbf
#define HWIO_WBM_R0_SW1_PROD_FIFO_DETAILS_POR                                                                   0x00000000
#define HWIO_WBM_R0_SW1_PROD_FIFO_DETAILS_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_SW1_PROD_FIFO_DETAILS_ATTR                                                                               0x1
#define HWIO_WBM_R0_SW1_PROD_FIFO_DETAILS_IN(x)            \
                in_dword(HWIO_WBM_R0_SW1_PROD_FIFO_DETAILS_ADDR(x))
#define HWIO_WBM_R0_SW1_PROD_FIFO_DETAILS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW1_PROD_FIFO_DETAILS_ADDR(x), m)
#define HWIO_WBM_R0_SW1_PROD_FIFO_DETAILS_INTERNAL_PTR_BMSK                                                          0xf80
#define HWIO_WBM_R0_SW1_PROD_FIFO_DETAILS_INTERNAL_PTR_SHFT                                                              7
#define HWIO_WBM_R0_SW1_PROD_FIFO_DETAILS_UD_CNT_BMSK                                                                 0x3f
#define HWIO_WBM_R0_SW1_PROD_FIFO_DETAILS_UD_CNT_SHFT                                                                    0

#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_CTRL_ADDR(x)                                                               ((x) + 0x174)
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_CTRL_PHYS(x)                                                               ((x) + 0x174)
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_CTRL_OFFS                                                                  (0x174)
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_CTRL_RMSK                                                                        0x3f
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_CTRL_POR                                                                   0x00000000
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_CTRL_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_CTRL_ATTR                                                                               0x3
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_CTRL_IN(x)            \
                in_dword(HWIO_WBM_R0_SW1_PROD_FIFO_RD_CTRL_ADDR(x))
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW1_PROD_FIFO_RD_CTRL_ADDR(x), m)
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_CTRL_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW1_PROD_FIFO_RD_CTRL_ADDR(x),v)
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW1_PROD_FIFO_RD_CTRL_ADDR(x),m,v,HWIO_WBM_R0_SW1_PROD_FIFO_RD_CTRL_IN(x))
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_CTRL_RD_PTR_BMSK                                                                 0x3e
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_CTRL_RD_PTR_SHFT                                                                    1
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_CTRL_RD_VALID_BMSK                                                                0x1
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_CTRL_RD_VALID_SHFT                                                                  0

#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_DATA_0_ADDR(x)                                                             ((x) + 0x178)
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_DATA_0_PHYS(x)                                                             ((x) + 0x178)
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_DATA_0_OFFS                                                                (0x178)
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_DATA_0_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_DATA_0_POR                                                                 0x00000000
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_DATA_0_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_DATA_0_ATTR                                                                             0x1
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_DATA_0_IN(x)            \
                in_dword(HWIO_WBM_R0_SW1_PROD_FIFO_RD_DATA_0_ADDR(x))
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_DATA_0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW1_PROD_FIFO_RD_DATA_0_ADDR(x), m)
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_DATA_0_RD_DATA_BMSK                                                        0xffffffff
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_DATA_0_RD_DATA_SHFT                                                                 0

#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_DATA_1_ADDR(x)                                                             ((x) + 0x17c)
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_DATA_1_PHYS(x)                                                             ((x) + 0x17c)
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_DATA_1_OFFS                                                                (0x17c)
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_DATA_1_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_DATA_1_POR                                                                 0x00000000
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_DATA_1_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_DATA_1_ATTR                                                                             0x1
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_DATA_1_IN(x)            \
                in_dword(HWIO_WBM_R0_SW1_PROD_FIFO_RD_DATA_1_ADDR(x))
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_DATA_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW1_PROD_FIFO_RD_DATA_1_ADDR(x), m)
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_DATA_1_RD_DATA_BMSK                                                        0xffffffff
#define HWIO_WBM_R0_SW1_PROD_FIFO_RD_DATA_1_RD_DATA_SHFT                                                                 0

#define HWIO_WBM_R0_SW2_PROD_FIFO_DETAILS_ADDR(x)                                                               ((x) + 0x180)
#define HWIO_WBM_R0_SW2_PROD_FIFO_DETAILS_PHYS(x)                                                               ((x) + 0x180)
#define HWIO_WBM_R0_SW2_PROD_FIFO_DETAILS_OFFS                                                                  (0x180)
#define HWIO_WBM_R0_SW2_PROD_FIFO_DETAILS_RMSK                                                                       0xfbf
#define HWIO_WBM_R0_SW2_PROD_FIFO_DETAILS_POR                                                                   0x00000000
#define HWIO_WBM_R0_SW2_PROD_FIFO_DETAILS_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_SW2_PROD_FIFO_DETAILS_ATTR                                                                               0x1
#define HWIO_WBM_R0_SW2_PROD_FIFO_DETAILS_IN(x)            \
                in_dword(HWIO_WBM_R0_SW2_PROD_FIFO_DETAILS_ADDR(x))
#define HWIO_WBM_R0_SW2_PROD_FIFO_DETAILS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW2_PROD_FIFO_DETAILS_ADDR(x), m)
#define HWIO_WBM_R0_SW2_PROD_FIFO_DETAILS_INTERNAL_PTR_BMSK                                                          0xf80
#define HWIO_WBM_R0_SW2_PROD_FIFO_DETAILS_INTERNAL_PTR_SHFT                                                              7
#define HWIO_WBM_R0_SW2_PROD_FIFO_DETAILS_UD_CNT_BMSK                                                                 0x3f
#define HWIO_WBM_R0_SW2_PROD_FIFO_DETAILS_UD_CNT_SHFT                                                                    0

#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_CTRL_ADDR(x)                                                               ((x) + 0x184)
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_CTRL_PHYS(x)                                                               ((x) + 0x184)
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_CTRL_OFFS                                                                  (0x184)
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_CTRL_RMSK                                                                        0x3f
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_CTRL_POR                                                                   0x00000000
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_CTRL_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_CTRL_ATTR                                                                               0x3
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_CTRL_IN(x)            \
                in_dword(HWIO_WBM_R0_SW2_PROD_FIFO_RD_CTRL_ADDR(x))
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW2_PROD_FIFO_RD_CTRL_ADDR(x), m)
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_CTRL_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW2_PROD_FIFO_RD_CTRL_ADDR(x),v)
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW2_PROD_FIFO_RD_CTRL_ADDR(x),m,v,HWIO_WBM_R0_SW2_PROD_FIFO_RD_CTRL_IN(x))
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_CTRL_RD_PTR_BMSK                                                                 0x3e
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_CTRL_RD_PTR_SHFT                                                                    1
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_CTRL_RD_VALID_BMSK                                                                0x1
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_CTRL_RD_VALID_SHFT                                                                  0

#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_DATA_0_ADDR(x)                                                             ((x) + 0x188)
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_DATA_0_PHYS(x)                                                             ((x) + 0x188)
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_DATA_0_OFFS                                                                (0x188)
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_DATA_0_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_DATA_0_POR                                                                 0x00000000
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_DATA_0_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_DATA_0_ATTR                                                                             0x1
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_DATA_0_IN(x)            \
                in_dword(HWIO_WBM_R0_SW2_PROD_FIFO_RD_DATA_0_ADDR(x))
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_DATA_0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW2_PROD_FIFO_RD_DATA_0_ADDR(x), m)
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_DATA_0_RD_DATA_BMSK                                                        0xffffffff
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_DATA_0_RD_DATA_SHFT                                                                 0

#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_DATA_1_ADDR(x)                                                             ((x) + 0x18c)
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_DATA_1_PHYS(x)                                                             ((x) + 0x18c)
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_DATA_1_OFFS                                                                (0x18c)
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_DATA_1_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_DATA_1_POR                                                                 0x00000000
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_DATA_1_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_DATA_1_ATTR                                                                             0x1
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_DATA_1_IN(x)            \
                in_dword(HWIO_WBM_R0_SW2_PROD_FIFO_RD_DATA_1_ADDR(x))
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_DATA_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW2_PROD_FIFO_RD_DATA_1_ADDR(x), m)
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_DATA_1_RD_DATA_BMSK                                                        0xffffffff
#define HWIO_WBM_R0_SW2_PROD_FIFO_RD_DATA_1_RD_DATA_SHFT                                                                 0

#define HWIO_WBM_R0_SW3_PROD_FIFO_DETAILS_ADDR(x)                                                               ((x) + 0x190)
#define HWIO_WBM_R0_SW3_PROD_FIFO_DETAILS_PHYS(x)                                                               ((x) + 0x190)
#define HWIO_WBM_R0_SW3_PROD_FIFO_DETAILS_OFFS                                                                  (0x190)
#define HWIO_WBM_R0_SW3_PROD_FIFO_DETAILS_RMSK                                                                       0xfbf
#define HWIO_WBM_R0_SW3_PROD_FIFO_DETAILS_POR                                                                   0x00000000
#define HWIO_WBM_R0_SW3_PROD_FIFO_DETAILS_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_SW3_PROD_FIFO_DETAILS_ATTR                                                                               0x1
#define HWIO_WBM_R0_SW3_PROD_FIFO_DETAILS_IN(x)            \
                in_dword(HWIO_WBM_R0_SW3_PROD_FIFO_DETAILS_ADDR(x))
#define HWIO_WBM_R0_SW3_PROD_FIFO_DETAILS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW3_PROD_FIFO_DETAILS_ADDR(x), m)
#define HWIO_WBM_R0_SW3_PROD_FIFO_DETAILS_INTERNAL_PTR_BMSK                                                          0xf80
#define HWIO_WBM_R0_SW3_PROD_FIFO_DETAILS_INTERNAL_PTR_SHFT                                                              7
#define HWIO_WBM_R0_SW3_PROD_FIFO_DETAILS_UD_CNT_BMSK                                                                 0x3f
#define HWIO_WBM_R0_SW3_PROD_FIFO_DETAILS_UD_CNT_SHFT                                                                    0

#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_CTRL_ADDR(x)                                                               ((x) + 0x194)
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_CTRL_PHYS(x)                                                               ((x) + 0x194)
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_CTRL_OFFS                                                                  (0x194)
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_CTRL_RMSK                                                                        0x3f
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_CTRL_POR                                                                   0x00000000
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_CTRL_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_CTRL_ATTR                                                                               0x3
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_CTRL_IN(x)            \
                in_dword(HWIO_WBM_R0_SW3_PROD_FIFO_RD_CTRL_ADDR(x))
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW3_PROD_FIFO_RD_CTRL_ADDR(x), m)
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_CTRL_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW3_PROD_FIFO_RD_CTRL_ADDR(x),v)
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW3_PROD_FIFO_RD_CTRL_ADDR(x),m,v,HWIO_WBM_R0_SW3_PROD_FIFO_RD_CTRL_IN(x))
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_CTRL_RD_PTR_BMSK                                                                 0x3e
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_CTRL_RD_PTR_SHFT                                                                    1
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_CTRL_RD_VALID_BMSK                                                                0x1
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_CTRL_RD_VALID_SHFT                                                                  0

#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_DATA_0_ADDR(x)                                                             ((x) + 0x198)
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_DATA_0_PHYS(x)                                                             ((x) + 0x198)
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_DATA_0_OFFS                                                                (0x198)
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_DATA_0_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_DATA_0_POR                                                                 0x00000000
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_DATA_0_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_DATA_0_ATTR                                                                             0x1
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_DATA_0_IN(x)            \
                in_dword(HWIO_WBM_R0_SW3_PROD_FIFO_RD_DATA_0_ADDR(x))
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_DATA_0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW3_PROD_FIFO_RD_DATA_0_ADDR(x), m)
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_DATA_0_RD_DATA_BMSK                                                        0xffffffff
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_DATA_0_RD_DATA_SHFT                                                                 0

#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_DATA_1_ADDR(x)                                                             ((x) + 0x19c)
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_DATA_1_PHYS(x)                                                             ((x) + 0x19c)
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_DATA_1_OFFS                                                                (0x19c)
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_DATA_1_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_DATA_1_POR                                                                 0x00000000
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_DATA_1_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_DATA_1_ATTR                                                                             0x1
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_DATA_1_IN(x)            \
                in_dword(HWIO_WBM_R0_SW3_PROD_FIFO_RD_DATA_1_ADDR(x))
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_DATA_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW3_PROD_FIFO_RD_DATA_1_ADDR(x), m)
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_DATA_1_RD_DATA_BMSK                                                        0xffffffff
#define HWIO_WBM_R0_SW3_PROD_FIFO_RD_DATA_1_RD_DATA_SHFT                                                                 0

#define HWIO_WBM_R0_SW4_PROD_FIFO_DETAILS_ADDR(x)                                                               ((x) + 0x1a0)
#define HWIO_WBM_R0_SW4_PROD_FIFO_DETAILS_PHYS(x)                                                               ((x) + 0x1a0)
#define HWIO_WBM_R0_SW4_PROD_FIFO_DETAILS_OFFS                                                                  (0x1a0)
#define HWIO_WBM_R0_SW4_PROD_FIFO_DETAILS_RMSK                                                                       0xfbf
#define HWIO_WBM_R0_SW4_PROD_FIFO_DETAILS_POR                                                                   0x00000000
#define HWIO_WBM_R0_SW4_PROD_FIFO_DETAILS_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_SW4_PROD_FIFO_DETAILS_ATTR                                                                               0x1
#define HWIO_WBM_R0_SW4_PROD_FIFO_DETAILS_IN(x)            \
                in_dword(HWIO_WBM_R0_SW4_PROD_FIFO_DETAILS_ADDR(x))
#define HWIO_WBM_R0_SW4_PROD_FIFO_DETAILS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW4_PROD_FIFO_DETAILS_ADDR(x), m)
#define HWIO_WBM_R0_SW4_PROD_FIFO_DETAILS_INTERNAL_PTR_BMSK                                                          0xf80
#define HWIO_WBM_R0_SW4_PROD_FIFO_DETAILS_INTERNAL_PTR_SHFT                                                              7
#define HWIO_WBM_R0_SW4_PROD_FIFO_DETAILS_UD_CNT_BMSK                                                                 0x3f
#define HWIO_WBM_R0_SW4_PROD_FIFO_DETAILS_UD_CNT_SHFT                                                                    0

#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_CTRL_ADDR(x)                                                               ((x) + 0x1a4)
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_CTRL_PHYS(x)                                                               ((x) + 0x1a4)
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_CTRL_OFFS                                                                  (0x1a4)
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_CTRL_RMSK                                                                        0x3f
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_CTRL_POR                                                                   0x00000000
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_CTRL_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_CTRL_ATTR                                                                               0x3
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_CTRL_IN(x)            \
                in_dword(HWIO_WBM_R0_SW4_PROD_FIFO_RD_CTRL_ADDR(x))
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW4_PROD_FIFO_RD_CTRL_ADDR(x), m)
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_CTRL_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW4_PROD_FIFO_RD_CTRL_ADDR(x),v)
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW4_PROD_FIFO_RD_CTRL_ADDR(x),m,v,HWIO_WBM_R0_SW4_PROD_FIFO_RD_CTRL_IN(x))
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_CTRL_RD_PTR_BMSK                                                                 0x3e
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_CTRL_RD_PTR_SHFT                                                                    1
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_CTRL_RD_VALID_BMSK                                                                0x1
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_CTRL_RD_VALID_SHFT                                                                  0

#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_DATA_0_ADDR(x)                                                             ((x) + 0x1a8)
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_DATA_0_PHYS(x)                                                             ((x) + 0x1a8)
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_DATA_0_OFFS                                                                (0x1a8)
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_DATA_0_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_DATA_0_POR                                                                 0x00000000
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_DATA_0_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_DATA_0_ATTR                                                                             0x1
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_DATA_0_IN(x)            \
                in_dword(HWIO_WBM_R0_SW4_PROD_FIFO_RD_DATA_0_ADDR(x))
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_DATA_0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW4_PROD_FIFO_RD_DATA_0_ADDR(x), m)
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_DATA_0_RD_DATA_BMSK                                                        0xffffffff
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_DATA_0_RD_DATA_SHFT                                                                 0

#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_DATA_1_ADDR(x)                                                             ((x) + 0x1ac)
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_DATA_1_PHYS(x)                                                             ((x) + 0x1ac)
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_DATA_1_OFFS                                                                (0x1ac)
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_DATA_1_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_DATA_1_POR                                                                 0x00000000
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_DATA_1_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_DATA_1_ATTR                                                                             0x1
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_DATA_1_IN(x)            \
                in_dword(HWIO_WBM_R0_SW4_PROD_FIFO_RD_DATA_1_ADDR(x))
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_DATA_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW4_PROD_FIFO_RD_DATA_1_ADDR(x), m)
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_DATA_1_RD_DATA_BMSK                                                        0xffffffff
#define HWIO_WBM_R0_SW4_PROD_FIFO_RD_DATA_1_RD_DATA_SHFT                                                                 0

#define HWIO_WBM_R0_SW5_PROD_FIFO_DETAILS_ADDR(x)                                                               ((x) + 0x1b0)
#define HWIO_WBM_R0_SW5_PROD_FIFO_DETAILS_PHYS(x)                                                               ((x) + 0x1b0)
#define HWIO_WBM_R0_SW5_PROD_FIFO_DETAILS_OFFS                                                                  (0x1b0)
#define HWIO_WBM_R0_SW5_PROD_FIFO_DETAILS_RMSK                                                                       0xfbf
#define HWIO_WBM_R0_SW5_PROD_FIFO_DETAILS_POR                                                                   0x00000000
#define HWIO_WBM_R0_SW5_PROD_FIFO_DETAILS_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_SW5_PROD_FIFO_DETAILS_ATTR                                                                               0x1
#define HWIO_WBM_R0_SW5_PROD_FIFO_DETAILS_IN(x)            \
                in_dword(HWIO_WBM_R0_SW5_PROD_FIFO_DETAILS_ADDR(x))
#define HWIO_WBM_R0_SW5_PROD_FIFO_DETAILS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW5_PROD_FIFO_DETAILS_ADDR(x), m)
#define HWIO_WBM_R0_SW5_PROD_FIFO_DETAILS_INTERNAL_PTR_BMSK                                                          0xf80
#define HWIO_WBM_R0_SW5_PROD_FIFO_DETAILS_INTERNAL_PTR_SHFT                                                              7
#define HWIO_WBM_R0_SW5_PROD_FIFO_DETAILS_UD_CNT_BMSK                                                                 0x3f
#define HWIO_WBM_R0_SW5_PROD_FIFO_DETAILS_UD_CNT_SHFT                                                                    0

#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_CTRL_ADDR(x)                                                               ((x) + 0x1b4)
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_CTRL_PHYS(x)                                                               ((x) + 0x1b4)
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_CTRL_OFFS                                                                  (0x1b4)
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_CTRL_RMSK                                                                        0x3f
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_CTRL_POR                                                                   0x00000000
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_CTRL_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_CTRL_ATTR                                                                               0x3
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_CTRL_IN(x)            \
                in_dword(HWIO_WBM_R0_SW5_PROD_FIFO_RD_CTRL_ADDR(x))
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW5_PROD_FIFO_RD_CTRL_ADDR(x), m)
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_CTRL_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW5_PROD_FIFO_RD_CTRL_ADDR(x),v)
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW5_PROD_FIFO_RD_CTRL_ADDR(x),m,v,HWIO_WBM_R0_SW5_PROD_FIFO_RD_CTRL_IN(x))
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_CTRL_RD_PTR_BMSK                                                                 0x3e
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_CTRL_RD_PTR_SHFT                                                                    1
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_CTRL_RD_VALID_BMSK                                                                0x1
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_CTRL_RD_VALID_SHFT                                                                  0

#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_DATA_0_ADDR(x)                                                             ((x) + 0x1b8)
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_DATA_0_PHYS(x)                                                             ((x) + 0x1b8)
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_DATA_0_OFFS                                                                (0x1b8)
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_DATA_0_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_DATA_0_POR                                                                 0x00000000
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_DATA_0_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_DATA_0_ATTR                                                                             0x1
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_DATA_0_IN(x)            \
                in_dword(HWIO_WBM_R0_SW5_PROD_FIFO_RD_DATA_0_ADDR(x))
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_DATA_0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW5_PROD_FIFO_RD_DATA_0_ADDR(x), m)
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_DATA_0_RD_DATA_BMSK                                                        0xffffffff
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_DATA_0_RD_DATA_SHFT                                                                 0

#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_DATA_1_ADDR(x)                                                             ((x) + 0x1bc)
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_DATA_1_PHYS(x)                                                             ((x) + 0x1bc)
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_DATA_1_OFFS                                                                (0x1bc)
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_DATA_1_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_DATA_1_POR                                                                 0x00000000
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_DATA_1_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_DATA_1_ATTR                                                                             0x1
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_DATA_1_IN(x)            \
                in_dword(HWIO_WBM_R0_SW5_PROD_FIFO_RD_DATA_1_ADDR(x))
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_DATA_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW5_PROD_FIFO_RD_DATA_1_ADDR(x), m)
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_DATA_1_RD_DATA_BMSK                                                        0xffffffff
#define HWIO_WBM_R0_SW5_PROD_FIFO_RD_DATA_1_RD_DATA_SHFT                                                                 0

#define HWIO_WBM_R0_SW6_PROD_FIFO_DETAILS_ADDR(x)                                                               ((x) + 0x1c0)
#define HWIO_WBM_R0_SW6_PROD_FIFO_DETAILS_PHYS(x)                                                               ((x) + 0x1c0)
#define HWIO_WBM_R0_SW6_PROD_FIFO_DETAILS_OFFS                                                                  (0x1c0)
#define HWIO_WBM_R0_SW6_PROD_FIFO_DETAILS_RMSK                                                                       0xfbf
#define HWIO_WBM_R0_SW6_PROD_FIFO_DETAILS_POR                                                                   0x00000000
#define HWIO_WBM_R0_SW6_PROD_FIFO_DETAILS_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_SW6_PROD_FIFO_DETAILS_ATTR                                                                               0x1
#define HWIO_WBM_R0_SW6_PROD_FIFO_DETAILS_IN(x)            \
                in_dword(HWIO_WBM_R0_SW6_PROD_FIFO_DETAILS_ADDR(x))
#define HWIO_WBM_R0_SW6_PROD_FIFO_DETAILS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW6_PROD_FIFO_DETAILS_ADDR(x), m)
#define HWIO_WBM_R0_SW6_PROD_FIFO_DETAILS_INTERNAL_PTR_BMSK                                                          0xf80
#define HWIO_WBM_R0_SW6_PROD_FIFO_DETAILS_INTERNAL_PTR_SHFT                                                              7
#define HWIO_WBM_R0_SW6_PROD_FIFO_DETAILS_UD_CNT_BMSK                                                                 0x3f
#define HWIO_WBM_R0_SW6_PROD_FIFO_DETAILS_UD_CNT_SHFT                                                                    0

#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_CTRL_ADDR(x)                                                               ((x) + 0x1c4)
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_CTRL_PHYS(x)                                                               ((x) + 0x1c4)
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_CTRL_OFFS                                                                  (0x1c4)
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_CTRL_RMSK                                                                        0x3f
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_CTRL_POR                                                                   0x00000000
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_CTRL_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_CTRL_ATTR                                                                               0x3
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_CTRL_IN(x)            \
                in_dword(HWIO_WBM_R0_SW6_PROD_FIFO_RD_CTRL_ADDR(x))
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW6_PROD_FIFO_RD_CTRL_ADDR(x), m)
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_CTRL_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW6_PROD_FIFO_RD_CTRL_ADDR(x),v)
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW6_PROD_FIFO_RD_CTRL_ADDR(x),m,v,HWIO_WBM_R0_SW6_PROD_FIFO_RD_CTRL_IN(x))
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_CTRL_RD_PTR_BMSK                                                                 0x3e
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_CTRL_RD_PTR_SHFT                                                                    1
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_CTRL_RD_VALID_BMSK                                                                0x1
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_CTRL_RD_VALID_SHFT                                                                  0

#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_DATA_0_ADDR(x)                                                             ((x) + 0x1c8)
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_DATA_0_PHYS(x)                                                             ((x) + 0x1c8)
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_DATA_0_OFFS                                                                (0x1c8)
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_DATA_0_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_DATA_0_POR                                                                 0x00000000
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_DATA_0_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_DATA_0_ATTR                                                                             0x1
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_DATA_0_IN(x)            \
                in_dword(HWIO_WBM_R0_SW6_PROD_FIFO_RD_DATA_0_ADDR(x))
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_DATA_0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW6_PROD_FIFO_RD_DATA_0_ADDR(x), m)
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_DATA_0_RD_DATA_BMSK                                                        0xffffffff
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_DATA_0_RD_DATA_SHFT                                                                 0

#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_DATA_1_ADDR(x)                                                             ((x) + 0x1cc)
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_DATA_1_PHYS(x)                                                             ((x) + 0x1cc)
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_DATA_1_OFFS                                                                (0x1cc)
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_DATA_1_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_DATA_1_POR                                                                 0x00000000
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_DATA_1_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_DATA_1_ATTR                                                                             0x1
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_DATA_1_IN(x)            \
                in_dword(HWIO_WBM_R0_SW6_PROD_FIFO_RD_DATA_1_ADDR(x))
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_DATA_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW6_PROD_FIFO_RD_DATA_1_ADDR(x), m)
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_DATA_1_RD_DATA_BMSK                                                        0xffffffff
#define HWIO_WBM_R0_SW6_PROD_FIFO_RD_DATA_1_RD_DATA_SHFT                                                                 0

#define HWIO_WBM_R0_FW_PROD_FIFO_DETAILS_ADDR(x)                                                                ((x) + 0x1d0)
#define HWIO_WBM_R0_FW_PROD_FIFO_DETAILS_PHYS(x)                                                                ((x) + 0x1d0)
#define HWIO_WBM_R0_FW_PROD_FIFO_DETAILS_OFFS                                                                   (0x1d0)
#define HWIO_WBM_R0_FW_PROD_FIFO_DETAILS_RMSK                                                                        0xfbf
#define HWIO_WBM_R0_FW_PROD_FIFO_DETAILS_POR                                                                    0x00000000
#define HWIO_WBM_R0_FW_PROD_FIFO_DETAILS_POR_RMSK                                                               0xffffffff
#define HWIO_WBM_R0_FW_PROD_FIFO_DETAILS_ATTR                                                                                0x1
#define HWIO_WBM_R0_FW_PROD_FIFO_DETAILS_IN(x)            \
                in_dword(HWIO_WBM_R0_FW_PROD_FIFO_DETAILS_ADDR(x))
#define HWIO_WBM_R0_FW_PROD_FIFO_DETAILS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_FW_PROD_FIFO_DETAILS_ADDR(x), m)
#define HWIO_WBM_R0_FW_PROD_FIFO_DETAILS_INTERNAL_PTR_BMSK                                                           0xf80
#define HWIO_WBM_R0_FW_PROD_FIFO_DETAILS_INTERNAL_PTR_SHFT                                                               7
#define HWIO_WBM_R0_FW_PROD_FIFO_DETAILS_UD_CNT_BMSK                                                                  0x3f
#define HWIO_WBM_R0_FW_PROD_FIFO_DETAILS_UD_CNT_SHFT                                                                     0

#define HWIO_WBM_R0_FW_PROD_FIFO_RD_CTRL_ADDR(x)                                                                ((x) + 0x1d4)
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_CTRL_PHYS(x)                                                                ((x) + 0x1d4)
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_CTRL_OFFS                                                                   (0x1d4)
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_CTRL_RMSK                                                                         0x3f
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_CTRL_POR                                                                    0x00000000
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_CTRL_POR_RMSK                                                               0xffffffff
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_CTRL_ATTR                                                                                0x3
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_CTRL_IN(x)            \
                in_dword(HWIO_WBM_R0_FW_PROD_FIFO_RD_CTRL_ADDR(x))
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_FW_PROD_FIFO_RD_CTRL_ADDR(x), m)
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_CTRL_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_FW_PROD_FIFO_RD_CTRL_ADDR(x),v)
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_FW_PROD_FIFO_RD_CTRL_ADDR(x),m,v,HWIO_WBM_R0_FW_PROD_FIFO_RD_CTRL_IN(x))
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_CTRL_RD_PTR_BMSK                                                                  0x3e
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_CTRL_RD_PTR_SHFT                                                                     1
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_CTRL_RD_VALID_BMSK                                                                 0x1
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_CTRL_RD_VALID_SHFT                                                                   0

#define HWIO_WBM_R0_FW_PROD_FIFO_RD_DATA_0_ADDR(x)                                                              ((x) + 0x1d8)
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_DATA_0_PHYS(x)                                                              ((x) + 0x1d8)
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_DATA_0_OFFS                                                                 (0x1d8)
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_DATA_0_RMSK                                                                 0xffffffff
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_DATA_0_POR                                                                  0x00000000
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_DATA_0_POR_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_DATA_0_ATTR                                                                              0x1
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_DATA_0_IN(x)            \
                in_dword(HWIO_WBM_R0_FW_PROD_FIFO_RD_DATA_0_ADDR(x))
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_DATA_0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_FW_PROD_FIFO_RD_DATA_0_ADDR(x), m)
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_DATA_0_RD_DATA_BMSK                                                         0xffffffff
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_DATA_0_RD_DATA_SHFT                                                                  0

#define HWIO_WBM_R0_FW_PROD_FIFO_RD_DATA_1_ADDR(x)                                                              ((x) + 0x1dc)
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_DATA_1_PHYS(x)                                                              ((x) + 0x1dc)
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_DATA_1_OFFS                                                                 (0x1dc)
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_DATA_1_RMSK                                                                 0xffffffff
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_DATA_1_POR                                                                  0x00000000
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_DATA_1_POR_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_DATA_1_ATTR                                                                              0x1
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_DATA_1_IN(x)            \
                in_dword(HWIO_WBM_R0_FW_PROD_FIFO_RD_DATA_1_ADDR(x))
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_DATA_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_FW_PROD_FIFO_RD_DATA_1_ADDR(x), m)
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_DATA_1_RD_DATA_BMSK                                                         0xffffffff
#define HWIO_WBM_R0_FW_PROD_FIFO_RD_DATA_1_RD_DATA_SHFT                                                                  0

#define HWIO_WBM_R0_ERR_PROD_FIFO_DETAILS_ADDR(x)                                                               ((x) + 0x1e0)
#define HWIO_WBM_R0_ERR_PROD_FIFO_DETAILS_PHYS(x)                                                               ((x) + 0x1e0)
#define HWIO_WBM_R0_ERR_PROD_FIFO_DETAILS_OFFS                                                                  (0x1e0)
#define HWIO_WBM_R0_ERR_PROD_FIFO_DETAILS_RMSK                                                                       0xfbf
#define HWIO_WBM_R0_ERR_PROD_FIFO_DETAILS_POR                                                                   0x00000000
#define HWIO_WBM_R0_ERR_PROD_FIFO_DETAILS_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_ERR_PROD_FIFO_DETAILS_ATTR                                                                               0x1
#define HWIO_WBM_R0_ERR_PROD_FIFO_DETAILS_IN(x)            \
                in_dword(HWIO_WBM_R0_ERR_PROD_FIFO_DETAILS_ADDR(x))
#define HWIO_WBM_R0_ERR_PROD_FIFO_DETAILS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_ERR_PROD_FIFO_DETAILS_ADDR(x), m)
#define HWIO_WBM_R0_ERR_PROD_FIFO_DETAILS_INTERNAL_PTR_BMSK                                                          0xf80
#define HWIO_WBM_R0_ERR_PROD_FIFO_DETAILS_INTERNAL_PTR_SHFT                                                              7
#define HWIO_WBM_R0_ERR_PROD_FIFO_DETAILS_UD_CNT_BMSK                                                                 0x3f
#define HWIO_WBM_R0_ERR_PROD_FIFO_DETAILS_UD_CNT_SHFT                                                                    0

#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_CTRL_ADDR(x)                                                               ((x) + 0x1e4)
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_CTRL_PHYS(x)                                                               ((x) + 0x1e4)
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_CTRL_OFFS                                                                  (0x1e4)
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_CTRL_RMSK                                                                        0x3f
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_CTRL_POR                                                                   0x00000000
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_CTRL_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_CTRL_ATTR                                                                               0x3
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_CTRL_IN(x)            \
                in_dword(HWIO_WBM_R0_ERR_PROD_FIFO_RD_CTRL_ADDR(x))
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_ERR_PROD_FIFO_RD_CTRL_ADDR(x), m)
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_CTRL_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_ERR_PROD_FIFO_RD_CTRL_ADDR(x),v)
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_ERR_PROD_FIFO_RD_CTRL_ADDR(x),m,v,HWIO_WBM_R0_ERR_PROD_FIFO_RD_CTRL_IN(x))
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_CTRL_RD_PTR_BMSK                                                                 0x3e
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_CTRL_RD_PTR_SHFT                                                                    1
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_CTRL_RD_VALID_BMSK                                                                0x1
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_CTRL_RD_VALID_SHFT                                                                  0

#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_DATA_0_ADDR(x)                                                             ((x) + 0x1e8)
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_DATA_0_PHYS(x)                                                             ((x) + 0x1e8)
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_DATA_0_OFFS                                                                (0x1e8)
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_DATA_0_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_DATA_0_POR                                                                 0x00000000
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_DATA_0_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_DATA_0_ATTR                                                                             0x1
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_DATA_0_IN(x)            \
                in_dword(HWIO_WBM_R0_ERR_PROD_FIFO_RD_DATA_0_ADDR(x))
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_DATA_0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_ERR_PROD_FIFO_RD_DATA_0_ADDR(x), m)
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_DATA_0_RD_DATA_BMSK                                                        0xffffffff
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_DATA_0_RD_DATA_SHFT                                                                 0

#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_DATA_1_ADDR(x)                                                             ((x) + 0x1ec)
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_DATA_1_PHYS(x)                                                             ((x) + 0x1ec)
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_DATA_1_OFFS                                                                (0x1ec)
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_DATA_1_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_DATA_1_POR                                                                 0x00000000
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_DATA_1_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_DATA_1_ATTR                                                                             0x1
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_DATA_1_IN(x)            \
                in_dword(HWIO_WBM_R0_ERR_PROD_FIFO_RD_DATA_1_ADDR(x))
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_DATA_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_ERR_PROD_FIFO_RD_DATA_1_ADDR(x), m)
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_DATA_1_RD_DATA_BMSK                                                        0xffffffff
#define HWIO_WBM_R0_ERR_PROD_FIFO_RD_DATA_1_RD_DATA_SHFT                                                                 0

#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_DETAILS_ADDR(x)                                                          ((x) + 0x1f0)
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_DETAILS_PHYS(x)                                                          ((x) + 0x1f0)
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_DETAILS_OFFS                                                             (0x1f0)
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_DETAILS_RMSK                                                                  0xfbf
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_DETAILS_POR                                                              0x00000000
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_DETAILS_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_DETAILS_ATTR                                                                          0x1
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_DETAILS_IN(x)            \
                in_dword(HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_DETAILS_ADDR(x))
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_DETAILS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_DETAILS_ADDR(x), m)
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_DETAILS_INTERNAL_PTR_BMSK                                                     0xf80
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_DETAILS_INTERNAL_PTR_SHFT                                                         7
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_DETAILS_UD_CNT_BMSK                                                            0x3f
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_DETAILS_UD_CNT_SHFT                                                               0

#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_CTRL_ADDR(x)                                                          ((x) + 0x1f4)
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_CTRL_PHYS(x)                                                          ((x) + 0x1f4)
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_CTRL_OFFS                                                             (0x1f4)
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_CTRL_RMSK                                                                   0x3f
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_CTRL_POR                                                              0x00000000
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_CTRL_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_CTRL_ATTR                                                                          0x3
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_CTRL_IN(x)            \
                in_dword(HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_CTRL_ADDR(x))
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_CTRL_ADDR(x), m)
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_CTRL_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_CTRL_ADDR(x),v)
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_CTRL_ADDR(x),m,v,HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_CTRL_IN(x))
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_CTRL_RD_PTR_BMSK                                                            0x3e
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_CTRL_RD_PTR_SHFT                                                               1
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_CTRL_RD_VALID_BMSK                                                           0x1
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_CTRL_RD_VALID_SHFT                                                             0

#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_DATA_0_ADDR(x)                                                        ((x) + 0x1f8)
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_DATA_0_PHYS(x)                                                        ((x) + 0x1f8)
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_DATA_0_OFFS                                                           (0x1f8)
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_DATA_0_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_DATA_0_POR                                                            0x00000000
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_DATA_0_POR_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_DATA_0_ATTR                                                                        0x1
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_DATA_0_IN(x)            \
                in_dword(HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_DATA_0_ADDR(x))
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_DATA_0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_DATA_0_ADDR(x), m)
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_DATA_0_RD_DATA_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_DATA_0_RD_DATA_SHFT                                                            0

#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_DATA_1_ADDR(x)                                                        ((x) + 0x1fc)
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_DATA_1_PHYS(x)                                                        ((x) + 0x1fc)
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_DATA_1_OFFS                                                           (0x1fc)
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_DATA_1_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_DATA_1_POR                                                            0x00000000
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_DATA_1_POR_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_DATA_1_ATTR                                                                        0x1
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_DATA_1_IN(x)            \
                in_dword(HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_DATA_1_ADDR(x))
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_DATA_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_DATA_1_ADDR(x), m)
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_DATA_1_RD_DATA_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_MLO_OUT1_PROD_FIFO_RD_DATA_1_RD_DATA_SHFT                                                            0

#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_DETAILS_ADDR(x)                                                          ((x) + 0x200)
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_DETAILS_PHYS(x)                                                          ((x) + 0x200)
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_DETAILS_OFFS                                                             (0x200)
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_DETAILS_RMSK                                                                  0xfbf
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_DETAILS_POR                                                              0x00000000
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_DETAILS_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_DETAILS_ATTR                                                                          0x1
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_DETAILS_IN(x)            \
                in_dword(HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_DETAILS_ADDR(x))
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_DETAILS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_DETAILS_ADDR(x), m)
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_DETAILS_INTERNAL_PTR_BMSK                                                     0xf80
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_DETAILS_INTERNAL_PTR_SHFT                                                         7
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_DETAILS_UD_CNT_BMSK                                                            0x3f
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_DETAILS_UD_CNT_SHFT                                                               0

#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_CTRL_ADDR(x)                                                          ((x) + 0x204)
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_CTRL_PHYS(x)                                                          ((x) + 0x204)
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_CTRL_OFFS                                                             (0x204)
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_CTRL_RMSK                                                                   0x3f
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_CTRL_POR                                                              0x00000000
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_CTRL_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_CTRL_ATTR                                                                          0x3
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_CTRL_IN(x)            \
                in_dword(HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_CTRL_ADDR(x))
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_CTRL_ADDR(x), m)
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_CTRL_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_CTRL_ADDR(x),v)
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_CTRL_ADDR(x),m,v,HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_CTRL_IN(x))
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_CTRL_RD_PTR_BMSK                                                            0x3e
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_CTRL_RD_PTR_SHFT                                                               1
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_CTRL_RD_VALID_BMSK                                                           0x1
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_CTRL_RD_VALID_SHFT                                                             0

#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_DATA_0_ADDR(x)                                                        ((x) + 0x208)
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_DATA_0_PHYS(x)                                                        ((x) + 0x208)
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_DATA_0_OFFS                                                           (0x208)
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_DATA_0_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_DATA_0_POR                                                            0x00000000
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_DATA_0_POR_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_DATA_0_ATTR                                                                        0x1
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_DATA_0_IN(x)            \
                in_dword(HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_DATA_0_ADDR(x))
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_DATA_0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_DATA_0_ADDR(x), m)
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_DATA_0_RD_DATA_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_DATA_0_RD_DATA_SHFT                                                            0

#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_DATA_1_ADDR(x)                                                        ((x) + 0x20c)
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_DATA_1_PHYS(x)                                                        ((x) + 0x20c)
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_DATA_1_OFFS                                                           (0x20c)
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_DATA_1_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_DATA_1_POR                                                            0x00000000
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_DATA_1_POR_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_DATA_1_ATTR                                                                        0x1
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_DATA_1_IN(x)            \
                in_dword(HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_DATA_1_ADDR(x))
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_DATA_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_DATA_1_ADDR(x), m)
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_DATA_1_RD_DATA_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_MLO_OUT2_PROD_FIFO_RD_DATA_1_RD_DATA_SHFT                                                            0

#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_CTRL_ADDR(x)                                                            ((x) + 0x210)
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_CTRL_PHYS(x)                                                            ((x) + 0x210)
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_CTRL_OFFS                                                               (0x210)
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_CTRL_RMSK                                                                     0x7f
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_CTRL_POR                                                                0x00000000
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_CTRL_POR_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_CTRL_ATTR                                                                            0x3
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_CTRL_IN(x)            \
                in_dword(HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_CTRL_ADDR(x))
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_CTRL_ADDR(x), m)
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_CTRL_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_CTRL_ADDR(x),v)
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_CTRL_ADDR(x),m,v,HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_CTRL_IN(x))
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_CTRL_RD_PTR_BMSK                                                              0x7e
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_CTRL_RD_PTR_SHFT                                                                 1
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_CTRL_RD_VALID_BMSK                                                             0x1
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_CTRL_RD_VALID_SHFT                                                               0

#define HWIO_WBM_R0_MSDU_PARSER_FIFO_DETAILS_ADDR(x)                                                            ((x) + 0x214)
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_DETAILS_PHYS(x)                                                            ((x) + 0x214)
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_DETAILS_OFFS                                                               (0x214)
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_DETAILS_RMSK                                                                   0x1fff
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_DETAILS_POR                                                                0x00000000
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_DETAILS_POR_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_DETAILS_ATTR                                                                            0x1
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_DETAILS_IN(x)            \
                in_dword(HWIO_WBM_R0_MSDU_PARSER_FIFO_DETAILS_ADDR(x))
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_DETAILS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_MSDU_PARSER_FIFO_DETAILS_ADDR(x), m)
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_DETAILS_INTERNAL_PTR_BMSK                                                      0x1f80
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_DETAILS_INTERNAL_PTR_SHFT                                                           7
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_DETAILS_UD_CNT_BMSK                                                              0x7f
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_DETAILS_UD_CNT_SHFT                                                                 0

#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_DATA_0_ADDR(x)                                                          ((x) + 0x218)
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_DATA_0_PHYS(x)                                                          ((x) + 0x218)
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_DATA_0_OFFS                                                             (0x218)
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_DATA_0_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_DATA_0_POR                                                              0x00000000
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_DATA_0_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_DATA_0_ATTR                                                                          0x1
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_DATA_0_IN(x)            \
                in_dword(HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_DATA_0_ADDR(x))
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_DATA_0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_DATA_0_ADDR(x), m)
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_DATA_0_RD_DATA_BMSK                                                     0xffffffff
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_DATA_0_RD_DATA_SHFT                                                              0

#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_DATA_1_ADDR(x)                                                          ((x) + 0x21c)
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_DATA_1_PHYS(x)                                                          ((x) + 0x21c)
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_DATA_1_OFFS                                                             (0x21c)
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_DATA_1_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_DATA_1_POR                                                              0x00000000
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_DATA_1_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_DATA_1_ATTR                                                                          0x1
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_DATA_1_IN(x)            \
                in_dword(HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_DATA_1_ADDR(x))
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_DATA_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_DATA_1_ADDR(x), m)
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_DATA_1_RD_DATA_BMSK                                                     0xffffffff
#define HWIO_WBM_R0_MSDU_PARSER_FIFO_RD_DATA_1_RD_DATA_SHFT                                                              0

#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_DETAILS_ADDR(x)                                                            ((x) + 0x220)
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_DETAILS_PHYS(x)                                                            ((x) + 0x220)
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_DETAILS_OFFS                                                               (0x220)
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_DETAILS_RMSK                                                                     0x1f
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_DETAILS_POR                                                                0x00000000
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_DETAILS_POR_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_DETAILS_ATTR                                                                            0x1
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_DETAILS_IN(x)            \
                in_dword(HWIO_WBM_R0_CACHE_CTRL0_FIFO_DETAILS_ADDR(x))
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_DETAILS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_CACHE_CTRL0_FIFO_DETAILS_ADDR(x), m)
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_DETAILS_INTERNAL_PTR_BMSK                                                        0x18
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_DETAILS_INTERNAL_PTR_SHFT                                                           3
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_DETAILS_UD_CNT_BMSK                                                               0x7
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_DETAILS_UD_CNT_SHFT                                                                 0

#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_CTRL_ADDR(x)                                                            ((x) + 0x224)
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_CTRL_PHYS(x)                                                            ((x) + 0x224)
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_CTRL_OFFS                                                               (0x224)
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_CTRL_RMSK                                                                      0x7
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_CTRL_POR                                                                0x00000000
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_CTRL_POR_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_CTRL_ATTR                                                                            0x3
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_CTRL_IN(x)            \
                in_dword(HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_CTRL_ADDR(x))
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_CTRL_ADDR(x), m)
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_CTRL_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_CTRL_ADDR(x),v)
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_CTRL_ADDR(x),m,v,HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_CTRL_IN(x))
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_CTRL_RD_PTR_BMSK                                                               0x6
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_CTRL_RD_PTR_SHFT                                                                 1
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_CTRL_RD_VALID_BMSK                                                             0x1
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_CTRL_RD_VALID_SHFT                                                               0

#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_DATA_0_ADDR(x)                                                          ((x) + 0x228)
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_DATA_0_PHYS(x)                                                          ((x) + 0x228)
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_DATA_0_OFFS                                                             (0x228)
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_DATA_0_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_DATA_0_POR                                                              0x00000000
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_DATA_0_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_DATA_0_ATTR                                                                          0x1
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_DATA_0_IN(x)            \
                in_dword(HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_DATA_0_ADDR(x))
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_DATA_0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_DATA_0_ADDR(x), m)
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_DATA_0_RD_DATA_BMSK                                                     0xffffffff
#define HWIO_WBM_R0_CACHE_CTRL0_FIFO_RD_DATA_0_RD_DATA_SHFT                                                              0

#define HWIO_WBM_R0_MSDU_PARSER_CURRENT_COOKIE_INFO_ADDR(x)                                                     ((x) + 0x238)
#define HWIO_WBM_R0_MSDU_PARSER_CURRENT_COOKIE_INFO_PHYS(x)                                                     ((x) + 0x238)
#define HWIO_WBM_R0_MSDU_PARSER_CURRENT_COOKIE_INFO_OFFS                                                        (0x238)
#define HWIO_WBM_R0_MSDU_PARSER_CURRENT_COOKIE_INFO_RMSK                                                         0xfffffff
#define HWIO_WBM_R0_MSDU_PARSER_CURRENT_COOKIE_INFO_POR                                                         0x00000000
#define HWIO_WBM_R0_MSDU_PARSER_CURRENT_COOKIE_INFO_POR_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_MSDU_PARSER_CURRENT_COOKIE_INFO_ATTR                                                                     0x1
#define HWIO_WBM_R0_MSDU_PARSER_CURRENT_COOKIE_INFO_IN(x)            \
                in_dword(HWIO_WBM_R0_MSDU_PARSER_CURRENT_COOKIE_INFO_ADDR(x))
#define HWIO_WBM_R0_MSDU_PARSER_CURRENT_COOKIE_INFO_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_MSDU_PARSER_CURRENT_COOKIE_INFO_ADDR(x), m)
#define HWIO_WBM_R0_MSDU_PARSER_CURRENT_COOKIE_INFO_VALUE_BMSK                                                   0xfffffff
#define HWIO_WBM_R0_MSDU_PARSER_CURRENT_COOKIE_INFO_VALUE_SHFT                                                           0

#define HWIO_WBM_R0_RLS_PARSER_CURRENT_COOKIE_INFO_ADDR(x)                                                      ((x) + 0x23c)
#define HWIO_WBM_R0_RLS_PARSER_CURRENT_COOKIE_INFO_PHYS(x)                                                      ((x) + 0x23c)
#define HWIO_WBM_R0_RLS_PARSER_CURRENT_COOKIE_INFO_OFFS                                                         (0x23c)
#define HWIO_WBM_R0_RLS_PARSER_CURRENT_COOKIE_INFO_RMSK                                                          0xfffffff
#define HWIO_WBM_R0_RLS_PARSER_CURRENT_COOKIE_INFO_POR                                                          0x00000000
#define HWIO_WBM_R0_RLS_PARSER_CURRENT_COOKIE_INFO_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_RLS_PARSER_CURRENT_COOKIE_INFO_ATTR                                                                      0x1
#define HWIO_WBM_R0_RLS_PARSER_CURRENT_COOKIE_INFO_IN(x)            \
                in_dword(HWIO_WBM_R0_RLS_PARSER_CURRENT_COOKIE_INFO_ADDR(x))
#define HWIO_WBM_R0_RLS_PARSER_CURRENT_COOKIE_INFO_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RLS_PARSER_CURRENT_COOKIE_INFO_ADDR(x), m)
#define HWIO_WBM_R0_RLS_PARSER_CURRENT_COOKIE_INFO_VALUE_BMSK                                                    0xfffffff
#define HWIO_WBM_R0_RLS_PARSER_CURRENT_COOKIE_INFO_VALUE_SHFT                                                            0

#define HWIO_WBM_R0_IDLE_LIST_CONTROL_ADDR(x)                                                                   ((x) + 0x240)
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_PHYS(x)                                                                   ((x) + 0x240)
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_OFFS                                                                      (0x240)
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_RMSK                                                                           0x7ff
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_POR                                                                       0x00000010
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_POR_RMSK                                                                  0xffffffff
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_ATTR                                                                                   0x3
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_IN(x)            \
                in_dword(HWIO_WBM_R0_IDLE_LIST_CONTROL_ADDR(x))
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_IDLE_LIST_CONTROL_ADDR(x), m)
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_IDLE_LIST_CONTROL_ADDR(x),v)
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_IDLE_LIST_CONTROL_ADDR(x),m,v,HWIO_WBM_R0_IDLE_LIST_CONTROL_IN(x))
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_SCATTER_BUFFER_SIZE_BMSK                                                       0x7fc
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_SCATTER_BUFFER_SIZE_SHFT                                                           2
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_LINK_DESC_IDLE_LIST_MODE_BMSK                                                    0x2
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_LINK_DESC_IDLE_LIST_MODE_SHFT                                                      1
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_BUFFER_IDLE_LIST_MODE_BMSK                                                       0x1
#define HWIO_WBM_R0_IDLE_LIST_CONTROL_BUFFER_IDLE_LIST_MODE_SHFT                                                         0

#define HWIO_WBM_R0_IDLE_LIST_SIZE_ADDR(x)                                                                      ((x) + 0x244)
#define HWIO_WBM_R0_IDLE_LIST_SIZE_PHYS(x)                                                                      ((x) + 0x244)
#define HWIO_WBM_R0_IDLE_LIST_SIZE_OFFS                                                                         (0x244)
#define HWIO_WBM_R0_IDLE_LIST_SIZE_RMSK                                                                         0xffffffff
#define HWIO_WBM_R0_IDLE_LIST_SIZE_POR                                                                          0x00020002
#define HWIO_WBM_R0_IDLE_LIST_SIZE_POR_RMSK                                                                     0xffffffff
#define HWIO_WBM_R0_IDLE_LIST_SIZE_ATTR                                                                                      0x3
#define HWIO_WBM_R0_IDLE_LIST_SIZE_IN(x)            \
                in_dword(HWIO_WBM_R0_IDLE_LIST_SIZE_ADDR(x))
#define HWIO_WBM_R0_IDLE_LIST_SIZE_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_IDLE_LIST_SIZE_ADDR(x), m)
#define HWIO_WBM_R0_IDLE_LIST_SIZE_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_IDLE_LIST_SIZE_ADDR(x),v)
#define HWIO_WBM_R0_IDLE_LIST_SIZE_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_IDLE_LIST_SIZE_ADDR(x),m,v,HWIO_WBM_R0_IDLE_LIST_SIZE_IN(x))
#define HWIO_WBM_R0_IDLE_LIST_SIZE_SCATTER_RING_SIZE_OF_IDLE_LINK_DESC_LIST_BMSK                                0xffff0000
#define HWIO_WBM_R0_IDLE_LIST_SIZE_SCATTER_RING_SIZE_OF_IDLE_LINK_DESC_LIST_SHFT                                        16
#define HWIO_WBM_R0_IDLE_LIST_SIZE_SCATTER_RING_SIZE_OF_IDLE_BUF_LIST_BMSK                                          0xffff
#define HWIO_WBM_R0_IDLE_LIST_SIZE_SCATTER_RING_SIZE_OF_IDLE_BUF_LIST_SHFT                                               0

#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_ADDR(x)                                                   ((x) + 0x250)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_PHYS(x)                                                   ((x) + 0x250)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_OFFS                                                      (0x250)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_POR                                                       0x00000000
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_POR_RMSK                                                  0xffffffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_ATTR                                                                   0x3
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_IN(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_BASE_ADDRESS_31_0_BMSK                                    0xffffffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_LSB_BASE_ADDRESS_31_0_SHFT                                             0

#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_ADDR(x)                                                   ((x) + 0x254)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_PHYS(x)                                                   ((x) + 0x254)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_OFFS                                                      (0x254)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_POR                                                       0x00000000
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_POR_RMSK                                                  0xffffffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_ATTR                                                                   0x3
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_IN(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_ADDRESS_MATCH_TAG_BMSK                                    0xffffff00
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_ADDRESS_MATCH_TAG_SHFT                                             8
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_BASE_ADDRESS_39_32_BMSK                                         0xff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_LIST_BASE_MSB_BASE_ADDRESS_39_32_SHFT                                            0

#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_ADDR(x)                                               ((x) + 0x260)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_PHYS(x)                                               ((x) + 0x260)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_OFFS                                                  (0x260)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_RMSK                                                  0xffffffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_POR                                                   0x00000000
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_POR_RMSK                                              0xffffffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_ATTR                                                               0x3
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_IN(x)            \
                in_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_ADDR(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_ADDR(x), m)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_ADDR(x),v)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_ADDR(x),m,v,HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_IN(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_BUFFER_ADDRESS_31_0_BMSK                              0xffffffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX0_BUFFER_ADDRESS_31_0_SHFT                                       0

#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_ADDR(x)                                               ((x) + 0x264)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_PHYS(x)                                               ((x) + 0x264)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_OFFS                                                  (0x264)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_RMSK                                                    0x1fffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_POR                                                   0x00000000
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_POR_RMSK                                              0xffffffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_ATTR                                                               0x3
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_IN(x)            \
                in_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_ADDR(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_ADDR(x), m)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_ADDR(x),v)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_ADDR(x),m,v,HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_IN(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_HEAD_POINTER_OFFSET_BMSK                                0x1fff00
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_HEAD_POINTER_OFFSET_SHFT                                       8
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_BUFFER_ADDRESS_39_32_BMSK                                   0xff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HEAD_INFO_IX1_BUFFER_ADDRESS_39_32_SHFT                                      0

#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_ADDR(x)                                               ((x) + 0x270)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_PHYS(x)                                               ((x) + 0x270)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_OFFS                                                  (0x270)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_RMSK                                                  0xffffffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_POR                                                   0x00000000
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_POR_RMSK                                              0xffffffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_ATTR                                                               0x3
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_IN(x)            \
                in_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_ADDR(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_ADDR(x), m)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_ADDR(x),v)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_ADDR(x),m,v,HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_IN(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_BUFFER_ADDRESS_31_0_BMSK                              0xffffffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX0_BUFFER_ADDRESS_31_0_SHFT                                       0

#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_ADDR(x)                                               ((x) + 0x274)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_PHYS(x)                                               ((x) + 0x274)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_OFFS                                                  (0x274)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_RMSK                                                    0x1fffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_POR                                                   0x00000000
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_POR_RMSK                                              0xffffffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_ATTR                                                               0x3
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_IN(x)            \
                in_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_ADDR(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_ADDR(x), m)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_ADDR(x),v)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_ADDR(x),m,v,HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_IN(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_TAIL_POINTER_OFFSET_BMSK                                0x1fff00
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_TAIL_POINTER_OFFSET_SHFT                                       8
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_BUFFER_ADDRESS_39_32_BMSK                                   0xff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TAIL_INFO_IX1_BUFFER_ADDRESS_39_32_SHFT                                      0

#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_ADDR(x)                                                          ((x) + 0x27c)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_PHYS(x)                                                          ((x) + 0x27c)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_OFFS                                                             (0x27c)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_RMSK                                                                0xfffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_POR                                                              0x00000000
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_ATTR                                                                          0x3
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_IN(x)            \
                in_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_ADDR(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_ADDR(x), m)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_ADDR(x),v)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_ADDR(x),m,v,HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_IN(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_SCAT_HEAD_PTR_BMSK                                                  0xfffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_HP_SCAT_HEAD_PTR_SHFT                                                        0

#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_ADDR(x)                                                          ((x) + 0x284)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_PHYS(x)                                                          ((x) + 0x284)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_OFFS                                                             (0x284)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_RMSK                                                                0xfffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_POR                                                              0x00000000
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_ATTR                                                                          0x3
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_IN(x)            \
                in_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_ADDR(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_ADDR(x), m)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_ADDR(x),v)
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_ADDR(x),m,v,HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_IN(x))
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_SCAT_TAIL_PTR_BMSK                                                  0xfffff
#define HWIO_WBM_R0_SCATTERED_LINK_DESC_PTR_TP_SCAT_TAIL_PTR_SHFT                                                        0

#define HWIO_WBM_R0_CLK_GATE_CTRL_ADDR(x)                                                                       ((x) + 0x288)
#define HWIO_WBM_R0_CLK_GATE_CTRL_PHYS(x)                                                                       ((x) + 0x288)
#define HWIO_WBM_R0_CLK_GATE_CTRL_OFFS                                                                          (0x288)
#define HWIO_WBM_R0_CLK_GATE_CTRL_RMSK                                                                            0x3fffff
#define HWIO_WBM_R0_CLK_GATE_CTRL_POR                                                                           0x00020000
#define HWIO_WBM_R0_CLK_GATE_CTRL_POR_RMSK                                                                      0xffffffff
#define HWIO_WBM_R0_CLK_GATE_CTRL_ATTR                                                                                       0x3
#define HWIO_WBM_R0_CLK_GATE_CTRL_IN(x)            \
                in_dword(HWIO_WBM_R0_CLK_GATE_CTRL_ADDR(x))
#define HWIO_WBM_R0_CLK_GATE_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_CLK_GATE_CTRL_ADDR(x), m)
#define HWIO_WBM_R0_CLK_GATE_CTRL_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_CLK_GATE_CTRL_ADDR(x),v)
#define HWIO_WBM_R0_CLK_GATE_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_CLK_GATE_CTRL_ADDR(x),m,v,HWIO_WBM_R0_CLK_GATE_CTRL_IN(x))
#define HWIO_WBM_R0_CLK_GATE_CTRL_CLK_GATE_DISABLE1_BMSK                                                          0x3c0000
#define HWIO_WBM_R0_CLK_GATE_CTRL_CLK_GATE_DISABLE1_SHFT                                                                18
#define HWIO_WBM_R0_CLK_GATE_CTRL_CLK_ENS_EXTEND_BMSK                                                              0x20000
#define HWIO_WBM_R0_CLK_GATE_CTRL_CLK_ENS_EXTEND_SHFT                                                                   17
#define HWIO_WBM_R0_CLK_GATE_CTRL_CLK_GATE_DISABLE_APB_BMSK                                                        0x10000
#define HWIO_WBM_R0_CLK_GATE_CTRL_CLK_GATE_DISABLE_APB_SHFT                                                             16
#define HWIO_WBM_R0_CLK_GATE_CTRL_CLK_GATE_DISABLE_BMSK                                                             0xffff
#define HWIO_WBM_R0_CLK_GATE_CTRL_CLK_GATE_DISABLE_SHFT                                                                  0

#define HWIO_WBM_R0_TQM_RELEASE_RING_BASE_LSB_ADDR(x)                                                           ((x) + 0x28c)
#define HWIO_WBM_R0_TQM_RELEASE_RING_BASE_LSB_PHYS(x)                                                           ((x) + 0x28c)
#define HWIO_WBM_R0_TQM_RELEASE_RING_BASE_LSB_OFFS                                                              (0x28c)
#define HWIO_WBM_R0_TQM_RELEASE_RING_BASE_LSB_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_BASE_LSB_POR                                                               0x00000000
#define HWIO_WBM_R0_TQM_RELEASE_RING_BASE_LSB_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_BASE_LSB_ATTR                                                                           0x3
#define HWIO_WBM_R0_TQM_RELEASE_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_TQM_RELEASE_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_TQM_RELEASE_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_TQM_RELEASE_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_TQM_RELEASE_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_TQM_RELEASE_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_TQM_RELEASE_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_TQM_RELEASE_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                           0xffffffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                    0

#define HWIO_WBM_R0_TQM_RELEASE_RING_BASE_MSB_ADDR(x)                                                           ((x) + 0x290)
#define HWIO_WBM_R0_TQM_RELEASE_RING_BASE_MSB_PHYS(x)                                                           ((x) + 0x290)
#define HWIO_WBM_R0_TQM_RELEASE_RING_BASE_MSB_OFFS                                                              (0x290)
#define HWIO_WBM_R0_TQM_RELEASE_RING_BASE_MSB_RMSK                                                                0xffffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_BASE_MSB_POR                                                               0x00000000
#define HWIO_WBM_R0_TQM_RELEASE_RING_BASE_MSB_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_BASE_MSB_ATTR                                                                           0x3
#define HWIO_WBM_R0_TQM_RELEASE_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_TQM_RELEASE_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_TQM_RELEASE_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_TQM_RELEASE_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_TQM_RELEASE_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_TQM_RELEASE_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_TQM_RELEASE_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_TQM_RELEASE_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_BASE_MSB_RING_SIZE_BMSK                                                      0xffff00
#define HWIO_WBM_R0_TQM_RELEASE_RING_BASE_MSB_RING_SIZE_SHFT                                                             8
#define HWIO_WBM_R0_TQM_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                 0xff
#define HWIO_WBM_R0_TQM_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                    0

#define HWIO_WBM_R0_TQM_RELEASE_RING_ID_ADDR(x)                                                                 ((x) + 0x294)
#define HWIO_WBM_R0_TQM_RELEASE_RING_ID_PHYS(x)                                                                 ((x) + 0x294)
#define HWIO_WBM_R0_TQM_RELEASE_RING_ID_OFFS                                                                    (0x294)
#define HWIO_WBM_R0_TQM_RELEASE_RING_ID_RMSK                                                                          0xff
#define HWIO_WBM_R0_TQM_RELEASE_RING_ID_POR                                                                     0x00000000
#define HWIO_WBM_R0_TQM_RELEASE_RING_ID_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_ID_ATTR                                                                                 0x3
#define HWIO_WBM_R0_TQM_RELEASE_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_TQM_RELEASE_RING_ID_ADDR(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_TQM_RELEASE_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_TQM_RELEASE_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_TQM_RELEASE_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_TQM_RELEASE_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_TQM_RELEASE_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_TQM_RELEASE_RING_ID_IN(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_ID_ENTRY_SIZE_BMSK                                                               0xff
#define HWIO_WBM_R0_TQM_RELEASE_RING_ID_ENTRY_SIZE_SHFT                                                                  0

#define HWIO_WBM_R0_TQM_RELEASE_RING_STATUS_ADDR(x)                                                             ((x) + 0x298)
#define HWIO_WBM_R0_TQM_RELEASE_RING_STATUS_PHYS(x)                                                             ((x) + 0x298)
#define HWIO_WBM_R0_TQM_RELEASE_RING_STATUS_OFFS                                                                (0x298)
#define HWIO_WBM_R0_TQM_RELEASE_RING_STATUS_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_STATUS_POR                                                                 0x00000000
#define HWIO_WBM_R0_TQM_RELEASE_RING_STATUS_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_STATUS_ATTR                                                                             0x1
#define HWIO_WBM_R0_TQM_RELEASE_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_TQM_RELEASE_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_TQM_RELEASE_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_TQM_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                0xffff0000
#define HWIO_WBM_R0_TQM_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                        16
#define HWIO_WBM_R0_TQM_RELEASE_RING_STATUS_NUM_VALID_WORDS_BMSK                                                    0xffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_STATUS_NUM_VALID_WORDS_SHFT                                                         0

#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_ADDR(x)                                                               ((x) + 0x29c)
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_PHYS(x)                                                               ((x) + 0x29c)
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_OFFS                                                                  (0x29c)
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_RMSK                                                                    0x3fffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_POR                                                                   0x00000080
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_ATTR                                                                               0x3
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_TQM_RELEASE_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_TQM_RELEASE_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_TQM_RELEASE_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_TQM_RELEASE_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_TQM_RELEASE_RING_MISC_IN(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_SPARE_CONTROL_BMSK                                                      0x3fc000
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_SPARE_CONTROL_SHFT                                                            14
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_SRNG_SM_STATE2_BMSK                                                       0x3000
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_SRNG_SM_STATE2_SHFT                                                           12
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_SRNG_SM_STATE1_BMSK                                                        0xf00
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_SRNG_SM_STATE1_SHFT                                                            8
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_SRNG_IS_IDLE_BMSK                                                           0x80
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_SRNG_IS_IDLE_SHFT                                                              7
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_SRNG_ENABLE_BMSK                                                            0x40
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_SRNG_ENABLE_SHFT                                                               6
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                      0x20
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                         5
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                       0x10
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                          4
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_MSI_SWAP_BIT_BMSK                                                            0x8
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_MSI_SWAP_BIT_SHFT                                                              3
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_SECURITY_BIT_BMSK                                                            0x4
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_SECURITY_BIT_SHFT                                                              2
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_LOOPCNT_DISABLE_BMSK                                                         0x2
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_LOOPCNT_DISABLE_SHFT                                                           1
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_RING_ID_DISABLE_BMSK                                                         0x1
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_RING_ID_DISABLE_SHFT                                                           0

#define HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_LSB_ADDR(x)                                                        ((x) + 0x2a8)
#define HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_LSB_PHYS(x)                                                        ((x) + 0x2a8)
#define HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_LSB_OFFS                                                           (0x2a8)
#define HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_LSB_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_LSB_POR                                                            0x00000000
#define HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_LSB_POR_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_LSB_ATTR                                                                        0x3
#define HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                      0xffffffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                               0

#define HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_MSB_ADDR(x)                                                        ((x) + 0x2ac)
#define HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_MSB_PHYS(x)                                                        ((x) + 0x2ac)
#define HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_MSB_OFFS                                                           (0x2ac)
#define HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_MSB_RMSK                                                                 0xff
#define HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_MSB_POR                                                            0x00000000
#define HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_MSB_POR_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_MSB_ATTR                                                                        0x3
#define HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                            0xff
#define HWIO_WBM_R0_TQM_RELEASE_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                               0

#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                             ((x) + 0x2bc)
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                             ((x) + 0x2bc)
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                (0x2bc)
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                0xffffffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX0_POR                                                 0x00000000
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                             0x3
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                             ((x) + 0x2c0)
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                             ((x) + 0x2c0)
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                (0x2c0)
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                    0xffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX1_POR                                                 0x00000000
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                             0x3
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                      0xffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                           0

#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_STATUS_ADDR(x)                                                ((x) + 0x2c4)
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_STATUS_PHYS(x)                                                ((x) + 0x2c4)
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_STATUS_OFFS                                                   (0x2c4)
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_STATUS_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_STATUS_POR                                                    0x00000000
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_STATUS_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_STATUS_ATTR                                                                0x1
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                     0xffff0000
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                             16
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                0x8000
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                    15
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                          0x7fff
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                               0

#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                             ((x) + 0x2c8)
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                             ((x) + 0x2c8)
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                (0x2c8)
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                     0x3ff
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_EMPTY_COUNTER_POR                                                 0x00000000
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                             0x3
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                  0x3ff
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                      0

#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                            ((x) + 0x2cc)
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                            ((x) + 0x2cc)
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_TIMER_OFFS                                               (0x2cc)
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                      0x7
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_TIMER_POR                                                0x00000003
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                            0x3
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                 0x7
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                   0

#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                           ((x) + 0x2d0)
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                           ((x) + 0x2d0)
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_STATUS_OFFS                                              (0x2d0)
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_STATUS_RMSK                                                0xffffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_STATUS_POR                                               0x00000000
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                          0xffffffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                           0x1
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                 0xff0000
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                       16
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                                0xffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                     0

#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_ADDR(x)                                                      ((x) + 0x2d4)
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_PHYS(x)                                                      ((x) + 0x2d4)
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_OFFS                                                         (0x2d4)
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_POR                                                          0x00000000
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_ADDR_BMSK                                                    0xffffffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_ADDR_SHFT                                                             0

#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_ADDR(x)                                                      ((x) + 0x2d8)
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_PHYS(x)                                                      ((x) + 0x2d8)
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_OFFS                                                         (0x2d8)
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_RMSK                                                              0x1ff
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_POR                                                          0x00000000
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                  0x100
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                      8
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_ADDR_BMSK                                                          0xff
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_ADDR_SHFT                                                             0

#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_DATA_ADDR(x)                                                          ((x) + 0x2dc)
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_DATA_PHYS(x)                                                          ((x) + 0x2dc)
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_DATA_OFFS                                                             (0x2dc)
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_DATA_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_DATA_POR                                                              0x00000000
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_DATA_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_DATA_ATTR                                                                          0x3
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_DATA_VALUE_BMSK                                                       0xffffffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_MSI1_DATA_VALUE_SHFT                                                                0

#define HWIO_WBM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x)                                                    ((x) + 0x2fc)
#define HWIO_WBM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_PHYS(x)                                                    ((x) + 0x2fc)
#define HWIO_WBM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_OFFS                                                       (0x2fc)
#define HWIO_WBM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_RMSK                                                           0xffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_POR                                                        0x00000000
#define HWIO_WBM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_ATTR                                                                    0x3
#define HWIO_WBM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                        0xffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                             0

#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_1_ADDR(x)                                                             ((x) + 0x300)
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_1_PHYS(x)                                                             ((x) + 0x300)
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_1_OFFS                                                                (0x300)
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_1_RMSK                                                                0xffff003f
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_1_POR                                                                 0x00000000
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_1_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_1_ATTR                                                                             0x3
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_TQM_RELEASE_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_TQM_RELEASE_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_TQM_RELEASE_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_TQM_RELEASE_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_TQM_RELEASE_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                       0xffff0000
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                               16
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                              0x3f
#define HWIO_WBM_R0_TQM_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                 0

#define HWIO_WBM_R0_REO_RELEASE_RING_BASE_LSB_ADDR(x)                                                           ((x) + 0x304)
#define HWIO_WBM_R0_REO_RELEASE_RING_BASE_LSB_PHYS(x)                                                           ((x) + 0x304)
#define HWIO_WBM_R0_REO_RELEASE_RING_BASE_LSB_OFFS                                                              (0x304)
#define HWIO_WBM_R0_REO_RELEASE_RING_BASE_LSB_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_REO_RELEASE_RING_BASE_LSB_POR                                                               0x00000000
#define HWIO_WBM_R0_REO_RELEASE_RING_BASE_LSB_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_REO_RELEASE_RING_BASE_LSB_ATTR                                                                           0x3
#define HWIO_WBM_R0_REO_RELEASE_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_REO_RELEASE_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_REO_RELEASE_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_REO_RELEASE_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_REO_RELEASE_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_REO_RELEASE_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_REO_RELEASE_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_REO_RELEASE_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                           0xffffffff
#define HWIO_WBM_R0_REO_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                    0

#define HWIO_WBM_R0_REO_RELEASE_RING_BASE_MSB_ADDR(x)                                                           ((x) + 0x308)
#define HWIO_WBM_R0_REO_RELEASE_RING_BASE_MSB_PHYS(x)                                                           ((x) + 0x308)
#define HWIO_WBM_R0_REO_RELEASE_RING_BASE_MSB_OFFS                                                              (0x308)
#define HWIO_WBM_R0_REO_RELEASE_RING_BASE_MSB_RMSK                                                                0xffffff
#define HWIO_WBM_R0_REO_RELEASE_RING_BASE_MSB_POR                                                               0x00000000
#define HWIO_WBM_R0_REO_RELEASE_RING_BASE_MSB_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_REO_RELEASE_RING_BASE_MSB_ATTR                                                                           0x3
#define HWIO_WBM_R0_REO_RELEASE_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_REO_RELEASE_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_REO_RELEASE_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_REO_RELEASE_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_REO_RELEASE_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_REO_RELEASE_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_REO_RELEASE_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_REO_RELEASE_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_BASE_MSB_RING_SIZE_BMSK                                                      0xffff00
#define HWIO_WBM_R0_REO_RELEASE_RING_BASE_MSB_RING_SIZE_SHFT                                                             8
#define HWIO_WBM_R0_REO_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                 0xff
#define HWIO_WBM_R0_REO_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                    0

#define HWIO_WBM_R0_REO_RELEASE_RING_ID_ADDR(x)                                                                 ((x) + 0x30c)
#define HWIO_WBM_R0_REO_RELEASE_RING_ID_PHYS(x)                                                                 ((x) + 0x30c)
#define HWIO_WBM_R0_REO_RELEASE_RING_ID_OFFS                                                                    (0x30c)
#define HWIO_WBM_R0_REO_RELEASE_RING_ID_RMSK                                                                          0xff
#define HWIO_WBM_R0_REO_RELEASE_RING_ID_POR                                                                     0x00000000
#define HWIO_WBM_R0_REO_RELEASE_RING_ID_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_REO_RELEASE_RING_ID_ATTR                                                                                 0x3
#define HWIO_WBM_R0_REO_RELEASE_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_REO_RELEASE_RING_ID_ADDR(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_REO_RELEASE_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_REO_RELEASE_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_REO_RELEASE_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_REO_RELEASE_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_REO_RELEASE_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_REO_RELEASE_RING_ID_IN(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_ID_ENTRY_SIZE_BMSK                                                               0xff
#define HWIO_WBM_R0_REO_RELEASE_RING_ID_ENTRY_SIZE_SHFT                                                                  0

#define HWIO_WBM_R0_REO_RELEASE_RING_STATUS_ADDR(x)                                                             ((x) + 0x310)
#define HWIO_WBM_R0_REO_RELEASE_RING_STATUS_PHYS(x)                                                             ((x) + 0x310)
#define HWIO_WBM_R0_REO_RELEASE_RING_STATUS_OFFS                                                                (0x310)
#define HWIO_WBM_R0_REO_RELEASE_RING_STATUS_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_REO_RELEASE_RING_STATUS_POR                                                                 0x00000000
#define HWIO_WBM_R0_REO_RELEASE_RING_STATUS_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_REO_RELEASE_RING_STATUS_ATTR                                                                             0x1
#define HWIO_WBM_R0_REO_RELEASE_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_REO_RELEASE_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_REO_RELEASE_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_REO_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                0xffff0000
#define HWIO_WBM_R0_REO_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                        16
#define HWIO_WBM_R0_REO_RELEASE_RING_STATUS_NUM_VALID_WORDS_BMSK                                                    0xffff
#define HWIO_WBM_R0_REO_RELEASE_RING_STATUS_NUM_VALID_WORDS_SHFT                                                         0

#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_ADDR(x)                                                               ((x) + 0x314)
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_PHYS(x)                                                               ((x) + 0x314)
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_OFFS                                                                  (0x314)
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_RMSK                                                                    0x3fffff
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_POR                                                                   0x00000080
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_ATTR                                                                               0x3
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_REO_RELEASE_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_REO_RELEASE_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_REO_RELEASE_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_REO_RELEASE_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_REO_RELEASE_RING_MISC_IN(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_SPARE_CONTROL_BMSK                                                      0x3fc000
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_SPARE_CONTROL_SHFT                                                            14
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_SRNG_SM_STATE2_BMSK                                                       0x3000
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_SRNG_SM_STATE2_SHFT                                                           12
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_SRNG_SM_STATE1_BMSK                                                        0xf00
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_SRNG_SM_STATE1_SHFT                                                            8
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_SRNG_IS_IDLE_BMSK                                                           0x80
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_SRNG_IS_IDLE_SHFT                                                              7
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_SRNG_ENABLE_BMSK                                                            0x40
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_SRNG_ENABLE_SHFT                                                               6
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                      0x20
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                         5
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                       0x10
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                          4
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_MSI_SWAP_BIT_BMSK                                                            0x8
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_MSI_SWAP_BIT_SHFT                                                              3
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_SECURITY_BIT_BMSK                                                            0x4
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_SECURITY_BIT_SHFT                                                              2
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_LOOPCNT_DISABLE_BMSK                                                         0x2
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_LOOPCNT_DISABLE_SHFT                                                           1
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_RING_ID_DISABLE_BMSK                                                         0x1
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_RING_ID_DISABLE_SHFT                                                           0

#define HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_LSB_ADDR(x)                                                        ((x) + 0x320)
#define HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_LSB_PHYS(x)                                                        ((x) + 0x320)
#define HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_LSB_OFFS                                                           (0x320)
#define HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_LSB_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_LSB_POR                                                            0x00000000
#define HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_LSB_POR_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_LSB_ATTR                                                                        0x3
#define HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                      0xffffffff
#define HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                               0

#define HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_MSB_ADDR(x)                                                        ((x) + 0x324)
#define HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_MSB_PHYS(x)                                                        ((x) + 0x324)
#define HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_MSB_OFFS                                                           (0x324)
#define HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_MSB_RMSK                                                                 0xff
#define HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_MSB_POR                                                            0x00000000
#define HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_MSB_POR_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_MSB_ATTR                                                                        0x3
#define HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                            0xff
#define HWIO_WBM_R0_REO_RELEASE_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                               0

#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                             ((x) + 0x334)
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                             ((x) + 0x334)
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                (0x334)
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                0xffffffff
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX0_POR                                                 0x00000000
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                             0x3
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                             ((x) + 0x338)
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                             ((x) + 0x338)
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                (0x338)
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                    0xffff
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX1_POR                                                 0x00000000
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                             0x3
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                      0xffff
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                           0

#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_STATUS_ADDR(x)                                                ((x) + 0x33c)
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_STATUS_PHYS(x)                                                ((x) + 0x33c)
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_STATUS_OFFS                                                   (0x33c)
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_STATUS_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_STATUS_POR                                                    0x00000000
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_STATUS_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_STATUS_ATTR                                                                0x1
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                     0xffff0000
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                             16
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                0x8000
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                    15
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                          0x7fff
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                               0

#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                             ((x) + 0x340)
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                             ((x) + 0x340)
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                (0x340)
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                     0x3ff
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_EMPTY_COUNTER_POR                                                 0x00000000
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                             0x3
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                  0x3ff
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                      0

#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                            ((x) + 0x344)
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                            ((x) + 0x344)
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_TIMER_OFFS                                               (0x344)
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                      0x7
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_TIMER_POR                                                0x00000003
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                            0x3
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                 0x7
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                   0

#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                           ((x) + 0x348)
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                           ((x) + 0x348)
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_STATUS_OFFS                                              (0x348)
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_STATUS_RMSK                                                0xffffff
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_STATUS_POR                                               0x00000000
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                          0xffffffff
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                           0x1
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                 0xff0000
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                       16
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                                0xffff
#define HWIO_WBM_R0_REO_RELEASE_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                     0

#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_LSB_ADDR(x)                                                      ((x) + 0x34c)
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_LSB_PHYS(x)                                                      ((x) + 0x34c)
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_LSB_OFFS                                                         (0x34c)
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_LSB_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_LSB_POR                                                          0x00000000
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_LSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_LSB_ADDR_BMSK                                                    0xffffffff
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_LSB_ADDR_SHFT                                                             0

#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_MSB_ADDR(x)                                                      ((x) + 0x350)
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_MSB_PHYS(x)                                                      ((x) + 0x350)
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_MSB_OFFS                                                         (0x350)
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_MSB_RMSK                                                              0x1ff
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_MSB_POR                                                          0x00000000
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_MSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                  0x100
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                      8
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_MSB_ADDR_BMSK                                                          0xff
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_BASE_MSB_ADDR_SHFT                                                             0

#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_DATA_ADDR(x)                                                          ((x) + 0x354)
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_DATA_PHYS(x)                                                          ((x) + 0x354)
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_DATA_OFFS                                                             (0x354)
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_DATA_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_DATA_POR                                                              0x00000000
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_DATA_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_DATA_ATTR                                                                          0x3
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_REO_RELEASE_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_REO_RELEASE_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_REO_RELEASE_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_REO_RELEASE_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_REO_RELEASE_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_DATA_VALUE_BMSK                                                       0xffffffff
#define HWIO_WBM_R0_REO_RELEASE_RING_MSI1_DATA_VALUE_SHFT                                                                0

#define HWIO_WBM_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x)                                                    ((x) + 0x374)
#define HWIO_WBM_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_PHYS(x)                                                    ((x) + 0x374)
#define HWIO_WBM_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_OFFS                                                       (0x374)
#define HWIO_WBM_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_RMSK                                                           0xffff
#define HWIO_WBM_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_POR                                                        0x00000000
#define HWIO_WBM_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_ATTR                                                                    0x3
#define HWIO_WBM_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                        0xffff
#define HWIO_WBM_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                             0

#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_1_ADDR(x)                                                             ((x) + 0x378)
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_1_PHYS(x)                                                             ((x) + 0x378)
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_1_OFFS                                                                (0x378)
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_1_RMSK                                                                0xffff003f
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_1_POR                                                                 0x00000000
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_1_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_1_ATTR                                                                             0x3
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_REO_RELEASE_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_REO_RELEASE_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_REO_RELEASE_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_REO_RELEASE_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_REO_RELEASE_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                       0xffff0000
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                               16
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                              0x3f
#define HWIO_WBM_R0_REO_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                 0

#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_ADDR(x)                                                            ((x) + 0x37c)
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_PHYS(x)                                                            ((x) + 0x37c)
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_OFFS                                                               (0x37c)
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_RMSK                                                               0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_POR                                                                0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_POR_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_ATTR                                                                            0x3
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                            0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                     0

#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_ADDR(x)                                                            ((x) + 0x380)
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_PHYS(x)                                                            ((x) + 0x380)
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_OFFS                                                               (0x380)
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_RMSK                                                                 0xffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_POR                                                                0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_POR_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_ATTR                                                                            0x3
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_RING_SIZE_BMSK                                                       0xffff00
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_RING_SIZE_SHFT                                                              8
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                  0xff
#define HWIO_WBM_R0_SW_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                     0

#define HWIO_WBM_R0_SW_RELEASE_RING_ID_ADDR(x)                                                                  ((x) + 0x384)
#define HWIO_WBM_R0_SW_RELEASE_RING_ID_PHYS(x)                                                                  ((x) + 0x384)
#define HWIO_WBM_R0_SW_RELEASE_RING_ID_OFFS                                                                     (0x384)
#define HWIO_WBM_R0_SW_RELEASE_RING_ID_RMSK                                                                           0xff
#define HWIO_WBM_R0_SW_RELEASE_RING_ID_POR                                                                      0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_ID_POR_RMSK                                                                 0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_ID_ATTR                                                                                  0x3
#define HWIO_WBM_R0_SW_RELEASE_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_ID_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_RELEASE_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_SW_RELEASE_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_RELEASE_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_SW_RELEASE_RING_ID_IN(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_ID_ENTRY_SIZE_BMSK                                                                0xff
#define HWIO_WBM_R0_SW_RELEASE_RING_ID_ENTRY_SIZE_SHFT                                                                   0

#define HWIO_WBM_R0_SW_RELEASE_RING_STATUS_ADDR(x)                                                              ((x) + 0x388)
#define HWIO_WBM_R0_SW_RELEASE_RING_STATUS_PHYS(x)                                                              ((x) + 0x388)
#define HWIO_WBM_R0_SW_RELEASE_RING_STATUS_OFFS                                                                 (0x388)
#define HWIO_WBM_R0_SW_RELEASE_RING_STATUS_RMSK                                                                 0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_STATUS_POR                                                                  0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_STATUS_POR_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_STATUS_ATTR                                                                              0x1
#define HWIO_WBM_R0_SW_RELEASE_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                 0xffff0000
#define HWIO_WBM_R0_SW_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                         16
#define HWIO_WBM_R0_SW_RELEASE_RING_STATUS_NUM_VALID_WORDS_BMSK                                                     0xffff
#define HWIO_WBM_R0_SW_RELEASE_RING_STATUS_NUM_VALID_WORDS_SHFT                                                          0

#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_ADDR(x)                                                                ((x) + 0x38c)
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_PHYS(x)                                                                ((x) + 0x38c)
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_OFFS                                                                   (0x38c)
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_RMSK                                                                     0x3fffff
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_POR                                                                    0x00000080
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_POR_RMSK                                                               0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_ATTR                                                                                0x3
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_RELEASE_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_RELEASE_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_SW_RELEASE_RING_MISC_IN(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_SPARE_CONTROL_BMSK                                                       0x3fc000
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_SPARE_CONTROL_SHFT                                                             14
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_SRNG_SM_STATE2_BMSK                                                        0x3000
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_SRNG_SM_STATE2_SHFT                                                            12
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_SRNG_SM_STATE1_BMSK                                                         0xf00
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_SRNG_SM_STATE1_SHFT                                                             8
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_SRNG_IS_IDLE_BMSK                                                            0x80
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_SRNG_IS_IDLE_SHFT                                                               7
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_SRNG_ENABLE_BMSK                                                             0x40
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_SRNG_ENABLE_SHFT                                                                6
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                       0x20
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                          5
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                        0x10
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                           4
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_MSI_SWAP_BIT_BMSK                                                             0x8
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_MSI_SWAP_BIT_SHFT                                                               3
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_SECURITY_BIT_BMSK                                                             0x4
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_SECURITY_BIT_SHFT                                                               2
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_LOOPCNT_DISABLE_BMSK                                                          0x2
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_LOOPCNT_DISABLE_SHFT                                                            1
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_RING_ID_DISABLE_BMSK                                                          0x1
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_RING_ID_DISABLE_SHFT                                                            0

#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_ADDR(x)                                                         ((x) + 0x398)
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_PHYS(x)                                                         ((x) + 0x398)
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_OFFS                                                            (0x398)
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_POR                                                             0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_ATTR                                                                         0x3
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                       0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                                0

#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_ADDR(x)                                                         ((x) + 0x39c)
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_PHYS(x)                                                         ((x) + 0x39c)
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_OFFS                                                            (0x39c)
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_RMSK                                                                  0xff
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_POR                                                             0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_ATTR                                                                         0x3
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                             0xff
#define HWIO_WBM_R0_SW_RELEASE_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                                0

#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                              ((x) + 0x3ac)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                              ((x) + 0x3ac)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                 (0x3ac)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_POR                                                  0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                             0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                              0x3
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                       0xffff0000
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                               16
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                   0x8000
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                       15
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                             0x7fff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                  0

#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                              ((x) + 0x3b0)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                              ((x) + 0x3b0)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                 (0x3b0)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                     0xffff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_POR                                                  0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                             0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                              0x3
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                       0xffff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                            0

#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_ADDR(x)                                                 ((x) + 0x3b4)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_PHYS(x)                                                 ((x) + 0x3b4)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_OFFS                                                    (0x3b4)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_POR                                                     0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_POR_RMSK                                                0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_ATTR                                                                 0x1
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                      0xffff0000
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                              16
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                 0x8000
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                     15
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                           0x7fff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                0

#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                              ((x) + 0x3b8)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                              ((x) + 0x3b8)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                 (0x3b8)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                      0x3ff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_POR                                                  0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                             0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                              0x3
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                   0x3ff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                       0

#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                             ((x) + 0x3bc)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                             ((x) + 0x3bc)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_OFFS                                                (0x3bc)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                       0x7
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_POR                                                 0x00000003
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                             0x3
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                  0x7
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                    0

#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                            ((x) + 0x3c0)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                            ((x) + 0x3c0)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_OFFS                                               (0x3c0)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_RMSK                                                 0xffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_POR                                                0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                            0x1
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                  0xff0000
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                        16
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                                 0xffff
#define HWIO_WBM_R0_SW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                      0

#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_ADDR(x)                                                       ((x) + 0x3c4)
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_PHYS(x)                                                       ((x) + 0x3c4)
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_OFFS                                                          (0x3c4)
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_POR                                                           0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_ADDR(x)                                                       ((x) + 0x3c8)
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_PHYS(x)                                                       ((x) + 0x3c8)
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_OFFS                                                          (0x3c8)
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_POR                                                           0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                   0x100
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                       8
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_ADDR(x)                                                           ((x) + 0x3cc)
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_PHYS(x)                                                           ((x) + 0x3cc)
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_OFFS                                                              (0x3cc)
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_POR                                                               0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_ATTR                                                                           0x3
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_MSI1_DATA_VALUE_SHFT                                                                 0

#define HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x)                                                     ((x) + 0x3ec)
#define HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_PHYS(x)                                                     ((x) + 0x3ec)
#define HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_OFFS                                                        (0x3ec)
#define HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_RMSK                                                            0xffff
#define HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_POR                                                         0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_POR_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_ATTR                                                                     0x3
#define HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                         0xffff
#define HWIO_WBM_R0_SW_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                              0

#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_ADDR(x)                                                              ((x) + 0x3f0)
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_PHYS(x)                                                              ((x) + 0x3f0)
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_OFFS                                                                 (0x3f0)
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_RMSK                                                                 0xffff003f
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_POR                                                                  0x00000000
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_POR_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_ATTR                                                                              0x3
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                        0xffff0000
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                16
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                               0x3f
#define HWIO_WBM_R0_SW_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                  0

#define HWIO_WBM_R0_FW_RELEASE_RING_BASE_LSB_ADDR(x)                                                            ((x) + 0x4e4)
#define HWIO_WBM_R0_FW_RELEASE_RING_BASE_LSB_PHYS(x)                                                            ((x) + 0x4e4)
#define HWIO_WBM_R0_FW_RELEASE_RING_BASE_LSB_OFFS                                                               (0x4e4)
#define HWIO_WBM_R0_FW_RELEASE_RING_BASE_LSB_RMSK                                                               0xffffffff
#define HWIO_WBM_R0_FW_RELEASE_RING_BASE_LSB_POR                                                                0x00000000
#define HWIO_WBM_R0_FW_RELEASE_RING_BASE_LSB_POR_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_FW_RELEASE_RING_BASE_LSB_ATTR                                                                            0x3
#define HWIO_WBM_R0_FW_RELEASE_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_FW_RELEASE_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_FW_RELEASE_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_FW_RELEASE_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_FW_RELEASE_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_FW_RELEASE_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_FW_RELEASE_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_FW_RELEASE_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                            0xffffffff
#define HWIO_WBM_R0_FW_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                     0

#define HWIO_WBM_R0_FW_RELEASE_RING_BASE_MSB_ADDR(x)                                                            ((x) + 0x4e8)
#define HWIO_WBM_R0_FW_RELEASE_RING_BASE_MSB_PHYS(x)                                                            ((x) + 0x4e8)
#define HWIO_WBM_R0_FW_RELEASE_RING_BASE_MSB_OFFS                                                               (0x4e8)
#define HWIO_WBM_R0_FW_RELEASE_RING_BASE_MSB_RMSK                                                                 0xffffff
#define HWIO_WBM_R0_FW_RELEASE_RING_BASE_MSB_POR                                                                0x00000000
#define HWIO_WBM_R0_FW_RELEASE_RING_BASE_MSB_POR_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_FW_RELEASE_RING_BASE_MSB_ATTR                                                                            0x3
#define HWIO_WBM_R0_FW_RELEASE_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_FW_RELEASE_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_FW_RELEASE_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_FW_RELEASE_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_FW_RELEASE_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_FW_RELEASE_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_FW_RELEASE_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_FW_RELEASE_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_BASE_MSB_RING_SIZE_BMSK                                                       0xffff00
#define HWIO_WBM_R0_FW_RELEASE_RING_BASE_MSB_RING_SIZE_SHFT                                                              8
#define HWIO_WBM_R0_FW_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                  0xff
#define HWIO_WBM_R0_FW_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                     0

#define HWIO_WBM_R0_FW_RELEASE_RING_ID_ADDR(x)                                                                  ((x) + 0x4ec)
#define HWIO_WBM_R0_FW_RELEASE_RING_ID_PHYS(x)                                                                  ((x) + 0x4ec)
#define HWIO_WBM_R0_FW_RELEASE_RING_ID_OFFS                                                                     (0x4ec)
#define HWIO_WBM_R0_FW_RELEASE_RING_ID_RMSK                                                                           0xff
#define HWIO_WBM_R0_FW_RELEASE_RING_ID_POR                                                                      0x00000000
#define HWIO_WBM_R0_FW_RELEASE_RING_ID_POR_RMSK                                                                 0xffffffff
#define HWIO_WBM_R0_FW_RELEASE_RING_ID_ATTR                                                                                  0x3
#define HWIO_WBM_R0_FW_RELEASE_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_FW_RELEASE_RING_ID_ADDR(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_FW_RELEASE_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_FW_RELEASE_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_FW_RELEASE_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_FW_RELEASE_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_FW_RELEASE_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_FW_RELEASE_RING_ID_IN(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_ID_ENTRY_SIZE_BMSK                                                                0xff
#define HWIO_WBM_R0_FW_RELEASE_RING_ID_ENTRY_SIZE_SHFT                                                                   0

#define HWIO_WBM_R0_FW_RELEASE_RING_STATUS_ADDR(x)                                                              ((x) + 0x4f0)
#define HWIO_WBM_R0_FW_RELEASE_RING_STATUS_PHYS(x)                                                              ((x) + 0x4f0)
#define HWIO_WBM_R0_FW_RELEASE_RING_STATUS_OFFS                                                                 (0x4f0)
#define HWIO_WBM_R0_FW_RELEASE_RING_STATUS_RMSK                                                                 0xffffffff
#define HWIO_WBM_R0_FW_RELEASE_RING_STATUS_POR                                                                  0x00000000
#define HWIO_WBM_R0_FW_RELEASE_RING_STATUS_POR_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_FW_RELEASE_RING_STATUS_ATTR                                                                              0x1
#define HWIO_WBM_R0_FW_RELEASE_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_FW_RELEASE_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_FW_RELEASE_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_FW_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                 0xffff0000
#define HWIO_WBM_R0_FW_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                         16
#define HWIO_WBM_R0_FW_RELEASE_RING_STATUS_NUM_VALID_WORDS_BMSK                                                     0xffff
#define HWIO_WBM_R0_FW_RELEASE_RING_STATUS_NUM_VALID_WORDS_SHFT                                                          0

#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_ADDR(x)                                                                ((x) + 0x4f4)
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_PHYS(x)                                                                ((x) + 0x4f4)
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_OFFS                                                                   (0x4f4)
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_RMSK                                                                     0x3fffff
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_POR                                                                    0x00000080
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_POR_RMSK                                                               0xffffffff
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_ATTR                                                                                0x3
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_FW_RELEASE_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_FW_RELEASE_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_FW_RELEASE_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_FW_RELEASE_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_FW_RELEASE_RING_MISC_IN(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_SPARE_CONTROL_BMSK                                                       0x3fc000
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_SPARE_CONTROL_SHFT                                                             14
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_SRNG_SM_STATE2_BMSK                                                        0x3000
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_SRNG_SM_STATE2_SHFT                                                            12
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_SRNG_SM_STATE1_BMSK                                                         0xf00
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_SRNG_SM_STATE1_SHFT                                                             8
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_SRNG_IS_IDLE_BMSK                                                            0x80
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_SRNG_IS_IDLE_SHFT                                                               7
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_SRNG_ENABLE_BMSK                                                             0x40
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_SRNG_ENABLE_SHFT                                                                6
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                       0x20
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                          5
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                        0x10
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                           4
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_MSI_SWAP_BIT_BMSK                                                             0x8
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_MSI_SWAP_BIT_SHFT                                                               3
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_SECURITY_BIT_BMSK                                                             0x4
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_SECURITY_BIT_SHFT                                                               2
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_LOOPCNT_DISABLE_BMSK                                                          0x2
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_LOOPCNT_DISABLE_SHFT                                                            1
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_RING_ID_DISABLE_BMSK                                                          0x1
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_RING_ID_DISABLE_SHFT                                                            0

#define HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_LSB_ADDR(x)                                                         ((x) + 0x500)
#define HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_LSB_PHYS(x)                                                         ((x) + 0x500)
#define HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_LSB_OFFS                                                            (0x500)
#define HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_LSB_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_LSB_POR                                                             0x00000000
#define HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_LSB_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_LSB_ATTR                                                                         0x3
#define HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                       0xffffffff
#define HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                                0

#define HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_MSB_ADDR(x)                                                         ((x) + 0x504)
#define HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_MSB_PHYS(x)                                                         ((x) + 0x504)
#define HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_MSB_OFFS                                                            (0x504)
#define HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_MSB_RMSK                                                                  0xff
#define HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_MSB_POR                                                             0x00000000
#define HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_MSB_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_MSB_ATTR                                                                         0x3
#define HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                             0xff
#define HWIO_WBM_R0_FW_RELEASE_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                                0

#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                              ((x) + 0x514)
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                              ((x) + 0x514)
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                 (0x514)
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_POR                                                  0x00000000
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                             0xffffffff
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                              0x3
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                       0xffff0000
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                               16
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                   0x8000
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                       15
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                             0x7fff
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                  0

#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                              ((x) + 0x518)
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                              ((x) + 0x518)
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                 (0x518)
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                     0xffff
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_POR                                                  0x00000000
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                             0xffffffff
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                              0x3
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                       0xffff
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                            0

#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_STATUS_ADDR(x)                                                 ((x) + 0x51c)
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_STATUS_PHYS(x)                                                 ((x) + 0x51c)
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_STATUS_OFFS                                                    (0x51c)
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_STATUS_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_STATUS_POR                                                     0x00000000
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_STATUS_POR_RMSK                                                0xffffffff
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_STATUS_ATTR                                                                 0x1
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                      0xffff0000
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                              16
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                 0x8000
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                     15
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                           0x7fff
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                0

#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                              ((x) + 0x520)
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                              ((x) + 0x520)
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                 (0x520)
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                      0x3ff
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_POR                                                  0x00000000
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                             0xffffffff
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                              0x3
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                   0x3ff
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                       0

#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                             ((x) + 0x524)
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                             ((x) + 0x524)
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_OFFS                                                (0x524)
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                       0x7
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_POR                                                 0x00000003
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                             0x3
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                  0x7
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                    0

#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                            ((x) + 0x528)
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                            ((x) + 0x528)
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_OFFS                                               (0x528)
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_RMSK                                                 0xffffff
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_POR                                                0x00000000
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                            0x1
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                  0xff0000
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                        16
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                                 0xffff
#define HWIO_WBM_R0_FW_RELEASE_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                      0

#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_LSB_ADDR(x)                                                       ((x) + 0x52c)
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_LSB_PHYS(x)                                                       ((x) + 0x52c)
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_LSB_OFFS                                                          (0x52c)
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_LSB_POR                                                           0x00000000
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_LSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_MSB_ADDR(x)                                                       ((x) + 0x530)
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_MSB_PHYS(x)                                                       ((x) + 0x530)
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_MSB_OFFS                                                          (0x530)
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_MSB_POR                                                           0x00000000
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_MSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                   0x100
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                       8
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_DATA_ADDR(x)                                                           ((x) + 0x534)
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_DATA_PHYS(x)                                                           ((x) + 0x534)
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_DATA_OFFS                                                              (0x534)
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_DATA_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_DATA_POR                                                               0x00000000
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_DATA_ATTR                                                                           0x3
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_FW_RELEASE_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_FW_RELEASE_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_FW_RELEASE_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_FW_RELEASE_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_FW_RELEASE_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_WBM_R0_FW_RELEASE_RING_MSI1_DATA_VALUE_SHFT                                                                 0

#define HWIO_WBM_R0_FW_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x)                                                     ((x) + 0x554)
#define HWIO_WBM_R0_FW_RELEASE_RING_HP_TP_SW_OFFSET_PHYS(x)                                                     ((x) + 0x554)
#define HWIO_WBM_R0_FW_RELEASE_RING_HP_TP_SW_OFFSET_OFFS                                                        (0x554)
#define HWIO_WBM_R0_FW_RELEASE_RING_HP_TP_SW_OFFSET_RMSK                                                            0xffff
#define HWIO_WBM_R0_FW_RELEASE_RING_HP_TP_SW_OFFSET_POR                                                         0x00000000
#define HWIO_WBM_R0_FW_RELEASE_RING_HP_TP_SW_OFFSET_POR_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_FW_RELEASE_RING_HP_TP_SW_OFFSET_ATTR                                                                     0x3
#define HWIO_WBM_R0_FW_RELEASE_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_FW_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_FW_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_FW_RELEASE_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_FW_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_FW_RELEASE_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_FW_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_FW_RELEASE_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                         0xffff
#define HWIO_WBM_R0_FW_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                              0

#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_1_ADDR(x)                                                              ((x) + 0x558)
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_1_PHYS(x)                                                              ((x) + 0x558)
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_1_OFFS                                                                 (0x558)
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_1_RMSK                                                                 0xffff003f
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_1_POR                                                                  0x00000000
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_1_POR_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_1_ATTR                                                                              0x3
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_FW_RELEASE_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_FW_RELEASE_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_FW_RELEASE_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_FW_RELEASE_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_FW_RELEASE_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                        0xffff0000
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                16
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                               0x3f
#define HWIO_WBM_R0_FW_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                  0

#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_LSB_ADDR(x)                                                        ((x) + 0x55c)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_LSB_PHYS(x)                                                        ((x) + 0x55c)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_LSB_OFFS                                                           (0x55c)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_LSB_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_LSB_POR                                                            0x00000000
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_LSB_POR_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_LSB_ATTR                                                                        0x3
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                        0xffffffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                 0

#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_MSB_ADDR(x)                                                        ((x) + 0x560)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_MSB_PHYS(x)                                                        ((x) + 0x560)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_MSB_OFFS                                                           (0x560)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_MSB_RMSK                                                             0xffffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_MSB_POR                                                            0x00000000
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_MSB_POR_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_MSB_ATTR                                                                        0x3
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_MSB_RING_SIZE_BMSK                                                   0xffff00
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_MSB_RING_SIZE_SHFT                                                          8
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                              0xff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                 0

#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_ID_ADDR(x)                                                              ((x) + 0x564)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_ID_PHYS(x)                                                              ((x) + 0x564)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_ID_OFFS                                                                 (0x564)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_ID_RMSK                                                                       0xff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_ID_POR                                                                  0x00000000
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_ID_POR_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_ID_ATTR                                                                              0x3
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_ID_ADDR(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RXDMA0_RELEASE_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_RXDMA0_RELEASE_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_RXDMA0_RELEASE_RING_ID_IN(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_ID_ENTRY_SIZE_BMSK                                                            0xff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_ID_ENTRY_SIZE_SHFT                                                               0

#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_STATUS_ADDR(x)                                                          ((x) + 0x568)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_STATUS_PHYS(x)                                                          ((x) + 0x568)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_STATUS_OFFS                                                             (0x568)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_STATUS_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_STATUS_POR                                                              0x00000000
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_STATUS_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_STATUS_ATTR                                                                          0x1
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RXDMA0_RELEASE_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                             0xffff0000
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                     16
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_STATUS_NUM_VALID_WORDS_BMSK                                                 0xffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_STATUS_NUM_VALID_WORDS_SHFT                                                      0

#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_ADDR(x)                                                            ((x) + 0x56c)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_PHYS(x)                                                            ((x) + 0x56c)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_OFFS                                                               (0x56c)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_RMSK                                                                 0x3fffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_POR                                                                0x00000080
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_POR_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_ATTR                                                                            0x3
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_IN(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_SPARE_CONTROL_BMSK                                                   0x3fc000
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_SPARE_CONTROL_SHFT                                                         14
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_SRNG_SM_STATE2_BMSK                                                    0x3000
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_SRNG_SM_STATE2_SHFT                                                        12
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_SRNG_SM_STATE1_BMSK                                                     0xf00
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_SRNG_SM_STATE1_SHFT                                                         8
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_SRNG_IS_IDLE_BMSK                                                        0x80
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_SRNG_IS_IDLE_SHFT                                                           7
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_SRNG_ENABLE_BMSK                                                         0x40
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_SRNG_ENABLE_SHFT                                                            6
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                   0x20
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                      5
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                    0x10
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                       4
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_MSI_SWAP_BIT_BMSK                                                         0x8
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_MSI_SWAP_BIT_SHFT                                                           3
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_SECURITY_BIT_BMSK                                                         0x4
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_SECURITY_BIT_SHFT                                                           2
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_LOOPCNT_DISABLE_BMSK                                                      0x2
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_LOOPCNT_DISABLE_SHFT                                                        1
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_RING_ID_DISABLE_BMSK                                                      0x1
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_RING_ID_DISABLE_SHFT                                                        0

#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_LSB_ADDR(x)                                                     ((x) + 0x578)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_LSB_PHYS(x)                                                     ((x) + 0x578)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_LSB_OFFS                                                        (0x578)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_LSB_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_LSB_POR                                                         0x00000000
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_LSB_POR_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_LSB_ATTR                                                                     0x3
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                   0xffffffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                            0

#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_MSB_ADDR(x)                                                     ((x) + 0x57c)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_MSB_PHYS(x)                                                     ((x) + 0x57c)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_MSB_OFFS                                                        (0x57c)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_MSB_RMSK                                                              0xff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_MSB_POR                                                         0x00000000
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_MSB_POR_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_MSB_ATTR                                                                     0x3
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                         0xff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                            0

#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                          ((x) + 0x58c)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                          ((x) + 0x58c)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX0_OFFS                                             (0x58c)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX0_RMSK                                             0xffffffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX0_POR                                              0x00000000
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                         0xffffffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                          0x3
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                   0xffff0000
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                           16
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                               0x8000
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                   15
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                         0x7fff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                              0

#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                          ((x) + 0x590)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                          ((x) + 0x590)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX1_OFFS                                             (0x590)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                 0xffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX1_POR                                              0x00000000
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                         0xffffffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                          0x3
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                   0xffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                        0

#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_STATUS_ADDR(x)                                             ((x) + 0x594)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_STATUS_PHYS(x)                                             ((x) + 0x594)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_STATUS_OFFS                                                (0x594)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_STATUS_RMSK                                                0xffffffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_STATUS_POR                                                 0x00000000
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_STATUS_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_STATUS_ATTR                                                             0x1
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                  0xffff0000
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                          16
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                             0x8000
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                 15
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                       0x7fff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                            0

#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                          ((x) + 0x598)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                          ((x) + 0x598)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_EMPTY_COUNTER_OFFS                                             (0x598)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                  0x3ff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_EMPTY_COUNTER_POR                                              0x00000000
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                         0xffffffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                          0x3
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                               0x3ff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                   0

#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                         ((x) + 0x59c)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                         ((x) + 0x59c)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_TIMER_OFFS                                            (0x59c)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                   0x7
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_TIMER_POR                                             0x00000003
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                        0xffffffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                         0x3
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                              0x7
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                0

#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                        ((x) + 0x5a0)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                        ((x) + 0x5a0)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_STATUS_OFFS                                           (0x5a0)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_STATUS_RMSK                                             0xffffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_STATUS_POR                                            0x00000000
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                       0xffffffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                        0x1
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                              0xff0000
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                    16
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                             0xffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                  0

#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_LSB_ADDR(x)                                                   ((x) + 0x5a4)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_LSB_PHYS(x)                                                   ((x) + 0x5a4)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_LSB_OFFS                                                      (0x5a4)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_LSB_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_LSB_POR                                                       0x00000000
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_LSB_POR_RMSK                                                  0xffffffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_LSB_ATTR                                                                   0x3
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_LSB_ADDR_BMSK                                                 0xffffffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_LSB_ADDR_SHFT                                                          0

#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_MSB_ADDR(x)                                                   ((x) + 0x5a8)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_MSB_PHYS(x)                                                   ((x) + 0x5a8)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_MSB_OFFS                                                      (0x5a8)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_MSB_RMSK                                                           0x1ff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_MSB_POR                                                       0x00000000
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_MSB_POR_RMSK                                                  0xffffffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_MSB_ATTR                                                                   0x3
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                               0x100
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                   8
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_MSB_ADDR_BMSK                                                       0xff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_BASE_MSB_ADDR_SHFT                                                          0

#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_DATA_ADDR(x)                                                       ((x) + 0x5ac)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_DATA_PHYS(x)                                                       ((x) + 0x5ac)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_DATA_OFFS                                                          (0x5ac)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_DATA_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_DATA_POR                                                           0x00000000
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_DATA_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_DATA_ATTR                                                                       0x3
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_DATA_VALUE_BMSK                                                    0xffffffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MSI1_DATA_VALUE_SHFT                                                             0

#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x)                                                 ((x) + 0x5cc)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_HP_TP_SW_OFFSET_PHYS(x)                                                 ((x) + 0x5cc)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_HP_TP_SW_OFFSET_OFFS                                                    (0x5cc)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_HP_TP_SW_OFFSET_RMSK                                                        0xffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_HP_TP_SW_OFFSET_POR                                                     0x00000000
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_HP_TP_SW_OFFSET_POR_RMSK                                                0xffffffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_HP_TP_SW_OFFSET_ATTR                                                                 0x3
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RXDMA0_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_RXDMA0_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_RXDMA0_RELEASE_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                     0xffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                          0

#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_1_ADDR(x)                                                          ((x) + 0x5d0)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_1_PHYS(x)                                                          ((x) + 0x5d0)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_1_OFFS                                                             (0x5d0)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_1_RMSK                                                             0xffff003f
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_1_POR                                                              0x00000000
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_1_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_1_ATTR                                                                          0x3
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                    0xffff0000
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                            16
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                           0x3f
#define HWIO_WBM_R0_RXDMA0_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                              0

#define HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_LSB_ADDR(x)                                                          ((x) + 0x994)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_LSB_PHYS(x)                                                          ((x) + 0x994)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_LSB_OFFS                                                             (0x994)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_LSB_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_LSB_POR                                                              0x00000000
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_LSB_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_LSB_ATTR                                                                          0x3
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                          0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                   0

#define HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_MSB_ADDR(x)                                                          ((x) + 0x998)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_MSB_PHYS(x)                                                          ((x) + 0x998)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_MSB_OFFS                                                             (0x998)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_MSB_RMSK                                                               0xffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_MSB_POR                                                              0x00000000
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_MSB_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_MSB_ATTR                                                                          0x3
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_MSB_RING_SIZE_BMSK                                                     0xffff00
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_MSB_RING_SIZE_SHFT                                                            8
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                0xff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                   0

#define HWIO_WBM_R0_WBM2TQM_LINK_RING_ID_ADDR(x)                                                                ((x) + 0x99c)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_ID_PHYS(x)                                                                ((x) + 0x99c)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_ID_OFFS                                                                   (0x99c)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_ID_RMSK                                                                       0xffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_ID_POR                                                                    0x00000000
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_ID_POR_RMSK                                                               0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_ID_ATTR                                                                                0x3
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_ID_ADDR(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2TQM_LINK_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2TQM_LINK_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_WBM2TQM_LINK_RING_ID_IN(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_ID_RING_ID_BMSK                                                               0xff00
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_ID_RING_ID_SHFT                                                                    8
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_ID_ENTRY_SIZE_BMSK                                                              0xff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_ID_ENTRY_SIZE_SHFT                                                                 0

#define HWIO_WBM_R0_WBM2TQM_LINK_RING_STATUS_ADDR(x)                                                            ((x) + 0x9a0)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_STATUS_PHYS(x)                                                            ((x) + 0x9a0)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_STATUS_OFFS                                                               (0x9a0)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_STATUS_RMSK                                                               0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_STATUS_POR                                                                0x00000000
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_STATUS_POR_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_STATUS_ATTR                                                                            0x1
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2TQM_LINK_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                               0xffff0000
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                       16
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_STATUS_NUM_VALID_WORDS_BMSK                                                   0xffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_STATUS_NUM_VALID_WORDS_SHFT                                                        0

#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_ADDR(x)                                                              ((x) + 0x9a4)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_PHYS(x)                                                              ((x) + 0x9a4)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_OFFS                                                                 (0x9a4)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_RMSK                                                                  0x7ffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_POR                                                                  0x00000080
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_POR_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_ATTR                                                                              0x3
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_IN(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                          0x4000000
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                 26
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_LOOP_CNT_BMSK                                                         0x3c00000
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_LOOP_CNT_SHFT                                                                22
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_SPARE_CONTROL_BMSK                                                     0x3fc000
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_SPARE_CONTROL_SHFT                                                           14
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_SRNG_SM_STATE2_BMSK                                                      0x3000
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_SRNG_SM_STATE2_SHFT                                                          12
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_SRNG_SM_STATE1_BMSK                                                       0xf00
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_SRNG_SM_STATE1_SHFT                                                           8
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_SRNG_IS_IDLE_BMSK                                                          0x80
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_SRNG_IS_IDLE_SHFT                                                             7
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_SRNG_ENABLE_BMSK                                                           0x40
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_SRNG_ENABLE_SHFT                                                              6
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                     0x20
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                        5
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                      0x10
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                         4
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_MSI_SWAP_BIT_BMSK                                                           0x8
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_MSI_SWAP_BIT_SHFT                                                             3
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_SECURITY_BIT_BMSK                                                           0x4
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_SECURITY_BIT_SHFT                                                             2
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_LOOPCNT_DISABLE_BMSK                                                        0x2
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_LOOPCNT_DISABLE_SHFT                                                          1
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_RING_ID_DISABLE_BMSK                                                        0x1
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_RING_ID_DISABLE_SHFT                                                          0

#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_LSB_ADDR(x)                                                       ((x) + 0x9a8)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_LSB_PHYS(x)                                                       ((x) + 0x9a8)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_LSB_OFFS                                                          (0x9a8)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_LSB_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_LSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_LSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                     0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                              0

#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_MSB_ADDR(x)                                                       ((x) + 0x9ac)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_MSB_PHYS(x)                                                       ((x) + 0x9ac)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_MSB_OFFS                                                          (0x9ac)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_MSB_RMSK                                                                0xff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_MSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_MSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                           0xff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                              0

#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_SETUP_ADDR(x)                                                ((x) + 0x9b8)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_SETUP_PHYS(x)                                                ((x) + 0x9b8)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_SETUP_OFFS                                                   (0x9b8)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_SETUP_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_SETUP_POR                                                    0x00000000
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_SETUP_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_SETUP_ATTR                                                                0x3
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                         0xffff0000
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                 16
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                     0x8000
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                         15
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                               0x7fff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                    0

#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_STATUS_ADDR(x)                                               ((x) + 0x9bc)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_STATUS_PHYS(x)                                               ((x) + 0x9bc)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_STATUS_OFFS                                                  (0x9bc)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_STATUS_RMSK                                                  0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_STATUS_POR                                                   0x00000000
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_STATUS_POR_RMSK                                              0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_STATUS_ATTR                                                               0x1
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                    0xffff0000
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                            16
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                            0x8000
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                15
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                         0x7fff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                              0

#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                             ((x) + 0x9c0)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                             ((x) + 0x9c0)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_FULL_COUNTER_OFFS                                                (0x9c0)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_FULL_COUNTER_RMSK                                                     0x3ff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_FULL_COUNTER_POR                                                 0x00000000
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_FULL_COUNTER_ATTR                                                             0x3
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                   0x3ff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                       0

#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_ADDR(x)                                                     ((x) + 0x9dc)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_PHYS(x)                                                     ((x) + 0x9dc)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_OFFS                                                        (0x9dc)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_POR                                                         0x00000000
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_POR_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_ATTR                                                                     0x3
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_ADDR_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_ADDR_SHFT                                                            0

#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_ADDR(x)                                                     ((x) + 0x9e0)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_PHYS(x)                                                     ((x) + 0x9e0)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_OFFS                                                        (0x9e0)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_RMSK                                                             0x1ff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_POR                                                         0x00000000
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_POR_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_ATTR                                                                     0x3
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                 0x100
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                     8
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_ADDR_BMSK                                                         0xff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_ADDR_SHFT                                                            0

#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_DATA_ADDR(x)                                                         ((x) + 0x9e4)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_DATA_PHYS(x)                                                         ((x) + 0x9e4)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_DATA_OFFS                                                            (0x9e4)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_DATA_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_DATA_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_DATA_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_DATA_ATTR                                                                         0x3
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_DATA_VALUE_BMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI1_DATA_VALUE_SHFT                                                               0

#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x)                                               ((x) + 0x9e8)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT2_SETUP_PHYS(x)                                               ((x) + 0x9e8)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT2_SETUP_OFFS                                                  (0x9e8)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT2_SETUP_RMSK                                                  0xffc0ffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT2_SETUP_POR                                                   0x00000000
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT2_SETUP_POR_RMSK                                              0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT2_SETUP_ATTR                                                               0x3
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                       0xff000000
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                               24
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                        0x800000
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                              23
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                      0x400000
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                            22
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                       0xffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                            0

#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_LSB_ADDR(x)                                                     ((x) + 0x9ec)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_LSB_PHYS(x)                                                     ((x) + 0x9ec)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_LSB_OFFS                                                        (0x9ec)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_LSB_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_LSB_POR                                                         0x00000000
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_LSB_POR_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_LSB_ATTR                                                                     0x3
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_LSB_ADDR_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_LSB_ADDR_SHFT                                                            0

#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_MSB_ADDR(x)                                                     ((x) + 0x9f0)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_MSB_PHYS(x)                                                     ((x) + 0x9f0)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_MSB_OFFS                                                        (0x9f0)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_MSB_RMSK                                                             0x1ff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_MSB_POR                                                         0x00000000
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_MSB_POR_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_MSB_ATTR                                                                     0x3
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                 0x100
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                     8
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_MSB_ADDR_BMSK                                                         0xff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_BASE_MSB_ADDR_SHFT                                                            0

#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_DATA_ADDR(x)                                                         ((x) + 0x9f4)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_DATA_PHYS(x)                                                         ((x) + 0x9f4)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_DATA_OFFS                                                            (0x9f4)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_DATA_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_DATA_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_DATA_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_DATA_ATTR                                                                         0x3
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_DATA_IN(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_DATA_VALUE_BMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MSI2_DATA_VALUE_SHFT                                                               0

#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_ADDR(x)                                                   ((x) + 0xa04)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_PHYS(x)                                                   ((x) + 0xa04)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_OFFS                                                      (0xa04)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_RMSK                                                          0xffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_POR                                                       0x00000000
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_POR_RMSK                                                  0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_ATTR                                                                   0x3
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                       0xffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                            0

#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_1_ADDR(x)                                                            ((x) + 0xa08)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_1_PHYS(x)                                                            ((x) + 0xa08)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_1_OFFS                                                               (0xa08)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_1_RMSK                                                               0xffff003f
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_1_POR                                                                0x00000000
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_1_POR_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_1_ATTR                                                                            0x3
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                      0xffff0000
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                              16
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                             0x3f
#define HWIO_WBM_R0_WBM2TQM_LINK_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                0

#define HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_LSB_ADDR(x)                                                          ((x) + 0xa0c)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_LSB_PHYS(x)                                                          ((x) + 0xa0c)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_LSB_OFFS                                                             (0xa0c)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_LSB_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_LSB_POR                                                              0x00000000
#define HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_LSB_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_LSB_ATTR                                                                          0x3
#define HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                          0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                   0

#define HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_MSB_ADDR(x)                                                          ((x) + 0xa10)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_MSB_PHYS(x)                                                          ((x) + 0xa10)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_MSB_OFFS                                                             (0xa10)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_MSB_RMSK                                                               0xffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_MSB_POR                                                              0x00000000
#define HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_MSB_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_MSB_ATTR                                                                          0x3
#define HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_MSB_RING_SIZE_BMSK                                                     0xffff00
#define HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_MSB_RING_SIZE_SHFT                                                            8
#define HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                0xff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                   0

#define HWIO_WBM_R0_WBM2REO_LINK_RING_ID_ADDR(x)                                                                ((x) + 0xa14)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_ID_PHYS(x)                                                                ((x) + 0xa14)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_ID_OFFS                                                                   (0xa14)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_ID_RMSK                                                                       0xffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_ID_POR                                                                    0x00000000
#define HWIO_WBM_R0_WBM2REO_LINK_RING_ID_POR_RMSK                                                               0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_ID_ATTR                                                                                0x3
#define HWIO_WBM_R0_WBM2REO_LINK_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_ID_ADDR(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2REO_LINK_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2REO_LINK_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_WBM2REO_LINK_RING_ID_IN(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_ID_RING_ID_BMSK                                                               0xff00
#define HWIO_WBM_R0_WBM2REO_LINK_RING_ID_RING_ID_SHFT                                                                    8
#define HWIO_WBM_R0_WBM2REO_LINK_RING_ID_ENTRY_SIZE_BMSK                                                              0xff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_ID_ENTRY_SIZE_SHFT                                                                 0

#define HWIO_WBM_R0_WBM2REO_LINK_RING_STATUS_ADDR(x)                                                            ((x) + 0xa18)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_STATUS_PHYS(x)                                                            ((x) + 0xa18)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_STATUS_OFFS                                                               (0xa18)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_STATUS_RMSK                                                               0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_STATUS_POR                                                                0x00000000
#define HWIO_WBM_R0_WBM2REO_LINK_RING_STATUS_POR_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_STATUS_ATTR                                                                            0x1
#define HWIO_WBM_R0_WBM2REO_LINK_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2REO_LINK_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                               0xffff0000
#define HWIO_WBM_R0_WBM2REO_LINK_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                       16
#define HWIO_WBM_R0_WBM2REO_LINK_RING_STATUS_NUM_VALID_WORDS_BMSK                                                   0xffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_STATUS_NUM_VALID_WORDS_SHFT                                                        0

#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_ADDR(x)                                                              ((x) + 0xa1c)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_PHYS(x)                                                              ((x) + 0xa1c)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_OFFS                                                                 (0xa1c)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_RMSK                                                                  0x7ffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_POR                                                                  0x00000080
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_POR_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_ATTR                                                                              0x3
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_IN(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                          0x4000000
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                 26
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_LOOP_CNT_BMSK                                                         0x3c00000
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_LOOP_CNT_SHFT                                                                22
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_SPARE_CONTROL_BMSK                                                     0x3fc000
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_SPARE_CONTROL_SHFT                                                           14
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_SRNG_SM_STATE2_BMSK                                                      0x3000
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_SRNG_SM_STATE2_SHFT                                                          12
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_SRNG_SM_STATE1_BMSK                                                       0xf00
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_SRNG_SM_STATE1_SHFT                                                           8
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_SRNG_IS_IDLE_BMSK                                                          0x80
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_SRNG_IS_IDLE_SHFT                                                             7
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_SRNG_ENABLE_BMSK                                                           0x40
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_SRNG_ENABLE_SHFT                                                              6
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                     0x20
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                        5
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                      0x10
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                         4
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_MSI_SWAP_BIT_BMSK                                                           0x8
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_MSI_SWAP_BIT_SHFT                                                             3
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_SECURITY_BIT_BMSK                                                           0x4
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_SECURITY_BIT_SHFT                                                             2
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_LOOPCNT_DISABLE_BMSK                                                        0x2
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_LOOPCNT_DISABLE_SHFT                                                          1
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_RING_ID_DISABLE_BMSK                                                        0x1
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_RING_ID_DISABLE_SHFT                                                          0

#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_LSB_ADDR(x)                                                       ((x) + 0xa20)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_LSB_PHYS(x)                                                       ((x) + 0xa20)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_LSB_OFFS                                                          (0xa20)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_LSB_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_LSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_LSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                     0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                              0

#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_MSB_ADDR(x)                                                       ((x) + 0xa24)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_MSB_PHYS(x)                                                       ((x) + 0xa24)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_MSB_OFFS                                                          (0xa24)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_MSB_RMSK                                                                0xff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_MSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_MSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                           0xff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                              0

#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_SETUP_ADDR(x)                                                ((x) + 0xa30)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_SETUP_PHYS(x)                                                ((x) + 0xa30)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_SETUP_OFFS                                                   (0xa30)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_SETUP_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_SETUP_POR                                                    0x00000000
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_SETUP_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_SETUP_ATTR                                                                0x3
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                         0xffff0000
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                 16
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                     0x8000
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                         15
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                               0x7fff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                    0

#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_STATUS_ADDR(x)                                               ((x) + 0xa34)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_STATUS_PHYS(x)                                               ((x) + 0xa34)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_STATUS_OFFS                                                  (0xa34)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_STATUS_RMSK                                                  0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_STATUS_POR                                                   0x00000000
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_STATUS_POR_RMSK                                              0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_STATUS_ATTR                                                               0x1
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                    0xffff0000
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                            16
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                            0x8000
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                15
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                         0x7fff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                              0

#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                             ((x) + 0xa38)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                             ((x) + 0xa38)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_FULL_COUNTER_OFFS                                                (0xa38)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_FULL_COUNTER_RMSK                                                     0x3ff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_FULL_COUNTER_POR                                                 0x00000000
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_FULL_COUNTER_ATTR                                                             0x3
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                   0x3ff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                       0

#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_LSB_ADDR(x)                                                     ((x) + 0xa54)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_LSB_PHYS(x)                                                     ((x) + 0xa54)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_LSB_OFFS                                                        (0xa54)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_LSB_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_LSB_POR                                                         0x00000000
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_LSB_POR_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_LSB_ATTR                                                                     0x3
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_LSB_ADDR_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_LSB_ADDR_SHFT                                                            0

#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_MSB_ADDR(x)                                                     ((x) + 0xa58)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_MSB_PHYS(x)                                                     ((x) + 0xa58)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_MSB_OFFS                                                        (0xa58)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_MSB_RMSK                                                             0x1ff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_MSB_POR                                                         0x00000000
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_MSB_POR_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_MSB_ATTR                                                                     0x3
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                 0x100
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                     8
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_MSB_ADDR_BMSK                                                         0xff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_BASE_MSB_ADDR_SHFT                                                            0

#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_DATA_ADDR(x)                                                         ((x) + 0xa5c)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_DATA_PHYS(x)                                                         ((x) + 0xa5c)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_DATA_OFFS                                                            (0xa5c)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_DATA_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_DATA_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_DATA_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_DATA_ATTR                                                                         0x3
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_DATA_VALUE_BMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI1_DATA_VALUE_SHFT                                                               0

#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x)                                               ((x) + 0xa60)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT2_SETUP_PHYS(x)                                               ((x) + 0xa60)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT2_SETUP_OFFS                                                  (0xa60)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT2_SETUP_RMSK                                                  0xffc0ffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT2_SETUP_POR                                                   0x00000000
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT2_SETUP_POR_RMSK                                              0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT2_SETUP_ATTR                                                               0x3
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                       0xff000000
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                               24
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                        0x800000
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                              23
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                      0x400000
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                            22
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                       0xffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                            0

#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_LSB_ADDR(x)                                                     ((x) + 0xa64)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_LSB_PHYS(x)                                                     ((x) + 0xa64)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_LSB_OFFS                                                        (0xa64)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_LSB_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_LSB_POR                                                         0x00000000
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_LSB_POR_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_LSB_ATTR                                                                     0x3
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_LSB_ADDR_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_LSB_ADDR_SHFT                                                            0

#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_MSB_ADDR(x)                                                     ((x) + 0xa68)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_MSB_PHYS(x)                                                     ((x) + 0xa68)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_MSB_OFFS                                                        (0xa68)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_MSB_RMSK                                                             0x1ff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_MSB_POR                                                         0x00000000
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_MSB_POR_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_MSB_ATTR                                                                     0x3
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                 0x100
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                     8
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_MSB_ADDR_BMSK                                                         0xff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_BASE_MSB_ADDR_SHFT                                                            0

#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_DATA_ADDR(x)                                                         ((x) + 0xa6c)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_DATA_PHYS(x)                                                         ((x) + 0xa6c)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_DATA_OFFS                                                            (0xa6c)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_DATA_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_DATA_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_DATA_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_DATA_ATTR                                                                         0x3
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_DATA_IN(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_DATA_VALUE_BMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MSI2_DATA_VALUE_SHFT                                                               0

#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_ADDR(x)                                                   ((x) + 0xa7c)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_PHYS(x)                                                   ((x) + 0xa7c)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_OFFS                                                      (0xa7c)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_RMSK                                                          0xffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_POR                                                       0x00000000
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_POR_RMSK                                                  0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_ATTR                                                                   0x3
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                       0xffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                            0

#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_1_ADDR(x)                                                            ((x) + 0xa80)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_1_PHYS(x)                                                            ((x) + 0xa80)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_1_OFFS                                                               (0xa80)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_1_RMSK                                                               0xffff003f
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_1_POR                                                                0x00000000
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_1_POR_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_1_ATTR                                                                            0x3
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                      0xffff0000
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                              16
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                             0x3f
#define HWIO_WBM_R0_WBM2REO_LINK_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_ADDR(x)                                                           ((x) + 0xa84)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_PHYS(x)                                                           ((x) + 0xa84)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_OFFS                                                              (0xa84)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_POR                                                               0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_ATTR                                                                           0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                    0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_ADDR(x)                                                           ((x) + 0xa88)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_PHYS(x)                                                           ((x) + 0xa88)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_OFFS                                                              (0xa88)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_RMSK                                                                0xffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_POR                                                               0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_ATTR                                                                           0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_RING_SIZE_BMSK                                                      0xffff00
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_RING_SIZE_SHFT                                                             8
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                 0xff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                    0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_ID_ADDR(x)                                                                 ((x) + 0xa8c)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_ID_PHYS(x)                                                                 ((x) + 0xa8c)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_ID_OFFS                                                                    (0xa8c)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_ID_RMSK                                                                        0xffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_ID_POR                                                                     0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_ID_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_ID_ATTR                                                                                 0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_ID_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_ID_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_ID_RING_ID_BMSK                                                                0xff00
#define HWIO_WBM_R0_WBM2SW_LINK_RING_ID_RING_ID_SHFT                                                                     8
#define HWIO_WBM_R0_WBM2SW_LINK_RING_ID_ENTRY_SIZE_BMSK                                                               0xff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_ID_ENTRY_SIZE_SHFT                                                                  0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_STATUS_ADDR(x)                                                             ((x) + 0xa90)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_STATUS_PHYS(x)                                                             ((x) + 0xa90)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_STATUS_OFFS                                                                (0xa90)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_STATUS_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_STATUS_POR                                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_STATUS_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_STATUS_ATTR                                                                             0x1
#define HWIO_WBM_R0_WBM2SW_LINK_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                0xffff0000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                        16
#define HWIO_WBM_R0_WBM2SW_LINK_RING_STATUS_NUM_VALID_WORDS_BMSK                                                    0xffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_STATUS_NUM_VALID_WORDS_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_ADDR(x)                                                               ((x) + 0xa94)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_PHYS(x)                                                               ((x) + 0xa94)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_OFFS                                                                  (0xa94)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_RMSK                                                                   0x7ffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_POR                                                                   0x00000080
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_ATTR                                                                               0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                           0x4000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                  26
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_LOOP_CNT_BMSK                                                          0x3c00000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_LOOP_CNT_SHFT                                                                 22
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_SPARE_CONTROL_BMSK                                                      0x3fc000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_SPARE_CONTROL_SHFT                                                            14
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_SRNG_SM_STATE2_BMSK                                                       0x3000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_SRNG_SM_STATE2_SHFT                                                           12
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_SRNG_SM_STATE1_BMSK                                                        0xf00
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_SRNG_SM_STATE1_SHFT                                                            8
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_SRNG_IS_IDLE_BMSK                                                           0x80
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_SRNG_IS_IDLE_SHFT                                                              7
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_SRNG_ENABLE_BMSK                                                            0x40
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_SRNG_ENABLE_SHFT                                                               6
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                      0x20
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                         5
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                       0x10
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                          4
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_MSI_SWAP_BIT_BMSK                                                            0x8
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_MSI_SWAP_BIT_SHFT                                                              3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_SECURITY_BIT_BMSK                                                            0x4
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_SECURITY_BIT_SHFT                                                              2
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_LOOPCNT_DISABLE_BMSK                                                         0x2
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_LOOPCNT_DISABLE_SHFT                                                           1
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_RING_ID_DISABLE_BMSK                                                         0x1
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_RING_ID_DISABLE_SHFT                                                           0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_ADDR(x)                                                        ((x) + 0xa98)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_PHYS(x)                                                        ((x) + 0xa98)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_OFFS                                                           (0xa98)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_POR                                                            0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_POR_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_ATTR                                                                        0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                      0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                               0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_ADDR(x)                                                        ((x) + 0xa9c)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_PHYS(x)                                                        ((x) + 0xa9c)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_OFFS                                                           (0xa9c)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_RMSK                                                                 0xff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_POR                                                            0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_POR_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_ATTR                                                                        0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                            0xff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                               0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_ADDR(x)                                                 ((x) + 0xaa8)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_PHYS(x)                                                 ((x) + 0xaa8)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_OFFS                                                    (0xaa8)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_POR                                                     0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_POR_RMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_ATTR                                                                 0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                          0xffff0000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                  16
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                      0x8000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                          15
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                                0x7fff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                     0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_ADDR(x)                                                ((x) + 0xaac)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_PHYS(x)                                                ((x) + 0xaac)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_OFFS                                                   (0xaac)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_POR                                                    0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_ATTR                                                                0x1
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                     0xffff0000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                             16
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                             0x8000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                 15
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                          0x7fff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                               0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                              ((x) + 0xab0)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                              ((x) + 0xab0)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_OFFS                                                 (0xab0)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_RMSK                                                      0x3ff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_POR                                                  0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                             0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_ATTR                                                              0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                    0x3ff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                        0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_ADDR(x)                                                      ((x) + 0xacc)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_PHYS(x)                                                      ((x) + 0xacc)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_OFFS                                                         (0xacc)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_ADDR_BMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_LSB_ADDR_SHFT                                                             0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_ADDR(x)                                                      ((x) + 0xad0)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_PHYS(x)                                                      ((x) + 0xad0)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_OFFS                                                         (0xad0)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_RMSK                                                              0x1ff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                  0x100
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                      8
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_ADDR_BMSK                                                          0xff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_BASE_MSB_ADDR_SHFT                                                             0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_ADDR(x)                                                          ((x) + 0xad4)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_PHYS(x)                                                          ((x) + 0xad4)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_OFFS                                                             (0xad4)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_POR                                                              0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_ATTR                                                                          0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_VALUE_BMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI1_DATA_VALUE_SHFT                                                                0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x)                                                ((x) + 0xad8)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_PHYS(x)                                                ((x) + 0xad8)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_OFFS                                                   (0xad8)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_RMSK                                                   0xffc0ffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_POR                                                    0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_ATTR                                                                0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                        0xff000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                                24
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                         0x800000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                               23
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                       0x400000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                             22
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                        0xffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                             0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_ADDR(x)                                                      ((x) + 0xadc)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_PHYS(x)                                                      ((x) + 0xadc)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_OFFS                                                         (0xadc)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_ADDR_BMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_LSB_ADDR_SHFT                                                             0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_ADDR(x)                                                      ((x) + 0xae0)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_PHYS(x)                                                      ((x) + 0xae0)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_OFFS                                                         (0xae0)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_RMSK                                                              0x1ff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                  0x100
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                      8
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_ADDR_BMSK                                                          0xff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_BASE_MSB_ADDR_SHFT                                                             0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_ADDR(x)                                                          ((x) + 0xae4)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_PHYS(x)                                                          ((x) + 0xae4)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_OFFS                                                             (0xae4)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_POR                                                              0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_ATTR                                                                          0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_VALUE_BMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MSI2_DATA_VALUE_SHFT                                                                0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_ADDR(x)                                                    ((x) + 0xaf4)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_PHYS(x)                                                    ((x) + 0xaf4)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_OFFS                                                       (0xaf4)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_RMSK                                                           0xffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                        0xffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                             0

#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_ADDR(x)                                                             ((x) + 0xaf8)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_PHYS(x)                                                             ((x) + 0xaf8)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_OFFS                                                                (0xaf8)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_RMSK                                                                0xffff003f
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_POR                                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_ATTR                                                                             0x3
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                       0xffff0000
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                               16
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                              0x3f
#define HWIO_WBM_R0_WBM2SW_LINK_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                 0

#define HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_LSB_ADDR(x)                                                           ((x) + 0xafc)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_LSB_PHYS(x)                                                           ((x) + 0xafc)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_LSB_OFFS                                                              (0xafc)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_LSB_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_LSB_POR                                                               0x00000000
#define HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_LSB_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_LSB_ATTR                                                                           0x3
#define HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                    0

#define HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_MSB_ADDR(x)                                                           ((x) + 0xb00)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_MSB_PHYS(x)                                                           ((x) + 0xb00)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_MSB_OFFS                                                              (0xb00)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_MSB_RMSK                                                                0xffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_MSB_POR                                                               0x00000000
#define HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_MSB_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_MSB_ATTR                                                                           0x3
#define HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_MSB_RING_SIZE_BMSK                                                      0xffff00
#define HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_MSB_RING_SIZE_SHFT                                                             8
#define HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                 0xff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                    0

#define HWIO_WBM_R0_WBM2FW_LINK_RING_ID_ADDR(x)                                                                 ((x) + 0xb04)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_ID_PHYS(x)                                                                 ((x) + 0xb04)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_ID_OFFS                                                                    (0xb04)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_ID_RMSK                                                                        0xffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_ID_POR                                                                     0x00000000
#define HWIO_WBM_R0_WBM2FW_LINK_RING_ID_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_ID_ATTR                                                                                 0x3
#define HWIO_WBM_R0_WBM2FW_LINK_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_ID_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_LINK_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_LINK_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_LINK_RING_ID_IN(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_ID_RING_ID_BMSK                                                                0xff00
#define HWIO_WBM_R0_WBM2FW_LINK_RING_ID_RING_ID_SHFT                                                                     8
#define HWIO_WBM_R0_WBM2FW_LINK_RING_ID_ENTRY_SIZE_BMSK                                                               0xff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_ID_ENTRY_SIZE_SHFT                                                                  0

#define HWIO_WBM_R0_WBM2FW_LINK_RING_STATUS_ADDR(x)                                                             ((x) + 0xb08)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_STATUS_PHYS(x)                                                             ((x) + 0xb08)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_STATUS_OFFS                                                                (0xb08)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_STATUS_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_STATUS_POR                                                                 0x00000000
#define HWIO_WBM_R0_WBM2FW_LINK_RING_STATUS_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_STATUS_ATTR                                                                             0x1
#define HWIO_WBM_R0_WBM2FW_LINK_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_LINK_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                0xffff0000
#define HWIO_WBM_R0_WBM2FW_LINK_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                        16
#define HWIO_WBM_R0_WBM2FW_LINK_RING_STATUS_NUM_VALID_WORDS_BMSK                                                    0xffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_STATUS_NUM_VALID_WORDS_SHFT                                                         0

#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_ADDR(x)                                                               ((x) + 0xb0c)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_PHYS(x)                                                               ((x) + 0xb0c)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_OFFS                                                                  (0xb0c)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_RMSK                                                                   0x7ffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_POR                                                                   0x00000080
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_ATTR                                                                               0x3
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_IN(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                           0x4000000
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                  26
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_LOOP_CNT_BMSK                                                          0x3c00000
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_LOOP_CNT_SHFT                                                                 22
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_SPARE_CONTROL_BMSK                                                      0x3fc000
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_SPARE_CONTROL_SHFT                                                            14
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_SRNG_SM_STATE2_BMSK                                                       0x3000
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_SRNG_SM_STATE2_SHFT                                                           12
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_SRNG_SM_STATE1_BMSK                                                        0xf00
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_SRNG_SM_STATE1_SHFT                                                            8
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_SRNG_IS_IDLE_BMSK                                                           0x80
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_SRNG_IS_IDLE_SHFT                                                              7
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_SRNG_ENABLE_BMSK                                                            0x40
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_SRNG_ENABLE_SHFT                                                               6
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                      0x20
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                         5
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                       0x10
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                          4
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_MSI_SWAP_BIT_BMSK                                                            0x8
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_MSI_SWAP_BIT_SHFT                                                              3
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_SECURITY_BIT_BMSK                                                            0x4
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_SECURITY_BIT_SHFT                                                              2
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_LOOPCNT_DISABLE_BMSK                                                         0x2
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_LOOPCNT_DISABLE_SHFT                                                           1
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_RING_ID_DISABLE_BMSK                                                         0x1
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_RING_ID_DISABLE_SHFT                                                           0

#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_LSB_ADDR(x)                                                        ((x) + 0xb10)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_LSB_PHYS(x)                                                        ((x) + 0xb10)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_LSB_OFFS                                                           (0xb10)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_LSB_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_LSB_POR                                                            0x00000000
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_LSB_POR_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_LSB_ATTR                                                                        0x3
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                      0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                               0

#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_MSB_ADDR(x)                                                        ((x) + 0xb14)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_MSB_PHYS(x)                                                        ((x) + 0xb14)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_MSB_OFFS                                                           (0xb14)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_MSB_RMSK                                                                 0xff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_MSB_POR                                                            0x00000000
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_MSB_POR_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_MSB_ATTR                                                                        0x3
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                            0xff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                               0

#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_SETUP_ADDR(x)                                                 ((x) + 0xb20)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_SETUP_PHYS(x)                                                 ((x) + 0xb20)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_SETUP_OFFS                                                    (0xb20)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_SETUP_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_SETUP_POR                                                     0x00000000
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_SETUP_POR_RMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_SETUP_ATTR                                                                 0x3
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                          0xffff0000
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                  16
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                      0x8000
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                          15
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                                0x7fff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                     0

#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_STATUS_ADDR(x)                                                ((x) + 0xb24)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_STATUS_PHYS(x)                                                ((x) + 0xb24)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_STATUS_OFFS                                                   (0xb24)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_STATUS_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_STATUS_POR                                                    0x00000000
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_STATUS_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_STATUS_ATTR                                                                0x1
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                     0xffff0000
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                             16
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                             0x8000
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                 15
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                          0x7fff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                               0

#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                              ((x) + 0xb28)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                              ((x) + 0xb28)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_FULL_COUNTER_OFFS                                                 (0xb28)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_FULL_COUNTER_RMSK                                                      0x3ff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_FULL_COUNTER_POR                                                  0x00000000
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                             0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_FULL_COUNTER_ATTR                                                              0x3
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                    0x3ff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                        0

#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_LSB_ADDR(x)                                                      ((x) + 0xb44)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_LSB_PHYS(x)                                                      ((x) + 0xb44)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_LSB_OFFS                                                         (0xb44)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_LSB_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_LSB_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_LSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_LSB_ADDR_BMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_LSB_ADDR_SHFT                                                             0

#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_MSB_ADDR(x)                                                      ((x) + 0xb48)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_MSB_PHYS(x)                                                      ((x) + 0xb48)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_MSB_OFFS                                                         (0xb48)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_MSB_RMSK                                                              0x1ff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_MSB_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_MSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                  0x100
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                      8
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_MSB_ADDR_BMSK                                                          0xff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_BASE_MSB_ADDR_SHFT                                                             0

#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_DATA_ADDR(x)                                                          ((x) + 0xb4c)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_DATA_PHYS(x)                                                          ((x) + 0xb4c)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_DATA_OFFS                                                             (0xb4c)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_DATA_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_DATA_POR                                                              0x00000000
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_DATA_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_DATA_ATTR                                                                          0x3
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_DATA_VALUE_BMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI1_DATA_VALUE_SHFT                                                                0

#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x)                                                ((x) + 0xb50)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT2_SETUP_PHYS(x)                                                ((x) + 0xb50)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT2_SETUP_OFFS                                                   (0xb50)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT2_SETUP_RMSK                                                   0xffc0ffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT2_SETUP_POR                                                    0x00000000
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT2_SETUP_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT2_SETUP_ATTR                                                                0x3
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                        0xff000000
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                                24
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                         0x800000
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                               23
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                       0x400000
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                             22
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                        0xffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                             0

#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_LSB_ADDR(x)                                                      ((x) + 0xb54)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_LSB_PHYS(x)                                                      ((x) + 0xb54)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_LSB_OFFS                                                         (0xb54)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_LSB_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_LSB_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_LSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_LSB_ADDR_BMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_LSB_ADDR_SHFT                                                             0

#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_MSB_ADDR(x)                                                      ((x) + 0xb58)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_MSB_PHYS(x)                                                      ((x) + 0xb58)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_MSB_OFFS                                                         (0xb58)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_MSB_RMSK                                                              0x1ff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_MSB_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_MSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                  0x100
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                      8
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_MSB_ADDR_BMSK                                                          0xff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_BASE_MSB_ADDR_SHFT                                                             0

#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_DATA_ADDR(x)                                                          ((x) + 0xb5c)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_DATA_PHYS(x)                                                          ((x) + 0xb5c)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_DATA_OFFS                                                             (0xb5c)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_DATA_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_DATA_POR                                                              0x00000000
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_DATA_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_DATA_ATTR                                                                          0x3
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_DATA_IN(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_DATA_VALUE_BMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MSI2_DATA_VALUE_SHFT                                                                0

#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_TP_SW_OFFSET_ADDR(x)                                                    ((x) + 0xb6c)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_TP_SW_OFFSET_PHYS(x)                                                    ((x) + 0xb6c)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_TP_SW_OFFSET_OFFS                                                       (0xb6c)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_TP_SW_OFFSET_RMSK                                                           0xffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_TP_SW_OFFSET_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_TP_SW_OFFSET_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_TP_SW_OFFSET_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_LINK_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_LINK_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_LINK_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                        0xffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                             0

#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_1_ADDR(x)                                                             ((x) + 0xb70)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_1_PHYS(x)                                                             ((x) + 0xb70)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_1_OFFS                                                                (0xb70)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_1_RMSK                                                                0xffff003f
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_1_POR                                                                 0x00000000
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_1_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_1_ATTR                                                                             0x3
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                       0xffff0000
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                               16
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                              0x3f
#define HWIO_WBM_R0_WBM2FW_LINK_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                 0

#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_LSB_ADDR(x)                                                       ((x) + 0xb74)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_LSB_PHYS(x)                                                       ((x) + 0xb74)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_LSB_OFFS                                                          (0xb74)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_LSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_LSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                       0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                0

#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_MSB_ADDR(x)                                                       ((x) + 0xb78)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_MSB_PHYS(x)                                                       ((x) + 0xb78)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_MSB_OFFS                                                          (0xb78)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_MSB_RMSK                                                            0xffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_MSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_MSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_MSB_RING_SIZE_BMSK                                                  0xffff00
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_MSB_RING_SIZE_SHFT                                                         8
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                             0xff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                0

#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_ID_ADDR(x)                                                             ((x) + 0xb7c)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_ID_PHYS(x)                                                             ((x) + 0xb7c)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_ID_OFFS                                                                (0xb7c)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_ID_RMSK                                                                    0xffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_ID_POR                                                                 0x00000000
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_ID_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_ID_ATTR                                                                             0x3
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_ID_ADDR(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_ID_IN(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_ID_RING_ID_BMSK                                                            0xff00
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_ID_RING_ID_SHFT                                                                 8
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_ID_ENTRY_SIZE_BMSK                                                           0xff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_ID_ENTRY_SIZE_SHFT                                                              0

#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_STATUS_ADDR(x)                                                         ((x) + 0xb80)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_STATUS_PHYS(x)                                                         ((x) + 0xb80)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_STATUS_OFFS                                                            (0xb80)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_STATUS_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_STATUS_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_STATUS_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_STATUS_ATTR                                                                         0x1
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                            0xffff0000
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                    16
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_STATUS_NUM_VALID_WORDS_BMSK                                                0xffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_STATUS_NUM_VALID_WORDS_SHFT                                                     0

#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_ADDR(x)                                                           ((x) + 0xb84)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_PHYS(x)                                                           ((x) + 0xb84)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_OFFS                                                              (0xb84)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_RMSK                                                               0x7ffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_POR                                                               0x00000080
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_ATTR                                                                           0x3
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_IN(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                       0x4000000
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                              26
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_LOOP_CNT_BMSK                                                      0x3c00000
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_LOOP_CNT_SHFT                                                             22
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_SPARE_CONTROL_BMSK                                                  0x3fc000
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_SPARE_CONTROL_SHFT                                                        14
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_SRNG_SM_STATE2_BMSK                                                   0x3000
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_SRNG_SM_STATE2_SHFT                                                       12
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_SRNG_SM_STATE1_BMSK                                                    0xf00
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_SRNG_SM_STATE1_SHFT                                                        8
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_SRNG_IS_IDLE_BMSK                                                       0x80
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_SRNG_IS_IDLE_SHFT                                                          7
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_SRNG_ENABLE_BMSK                                                        0x40
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_SRNG_ENABLE_SHFT                                                           6
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                  0x20
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                     5
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                   0x10
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                      4
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_MSI_SWAP_BIT_BMSK                                                        0x8
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_MSI_SWAP_BIT_SHFT                                                          3
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_SECURITY_BIT_BMSK                                                        0x4
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_SECURITY_BIT_SHFT                                                          2
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_LOOPCNT_DISABLE_BMSK                                                     0x2
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_LOOPCNT_DISABLE_SHFT                                                       1
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_RING_ID_DISABLE_BMSK                                                     0x1
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_RING_ID_DISABLE_SHFT                                                       0

#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_LSB_ADDR(x)                                                    ((x) + 0xb88)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_LSB_PHYS(x)                                                    ((x) + 0xb88)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_LSB_OFFS                                                       (0xb88)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_LSB_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_LSB_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_LSB_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_LSB_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                  0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                           0

#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_MSB_ADDR(x)                                                    ((x) + 0xb8c)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_MSB_PHYS(x)                                                    ((x) + 0xb8c)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_MSB_OFFS                                                       (0xb8c)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_MSB_RMSK                                                             0xff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_MSB_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_MSB_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_MSB_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                        0xff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                           0

#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_SETUP_ADDR(x)                                             ((x) + 0xb98)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_SETUP_PHYS(x)                                             ((x) + 0xb98)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_SETUP_OFFS                                                (0xb98)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_SETUP_RMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_SETUP_POR                                                 0x00000000
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_SETUP_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_SETUP_ATTR                                                             0x3
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_STATUS_ADDR(x)                                            ((x) + 0xb9c)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_STATUS_PHYS(x)                                            ((x) + 0xb9c)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_STATUS_OFFS                                               (0xb9c)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_STATUS_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_STATUS_POR                                                0x00000000
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_STATUS_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_STATUS_ATTR                                                            0x1
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                 0xffff0000
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                         16
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                         0x8000
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                             15
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                      0x7fff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                           0

#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                          ((x) + 0xba0)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                          ((x) + 0xba0)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_FULL_COUNTER_OFFS                                             (0xba0)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_FULL_COUNTER_RMSK                                                  0x3ff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_FULL_COUNTER_POR                                              0x00000000
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                         0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_FULL_COUNTER_ATTR                                                          0x3
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                0x3ff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                    0

#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_LSB_ADDR(x)                                                  ((x) + 0xbbc)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_LSB_PHYS(x)                                                  ((x) + 0xbbc)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_LSB_OFFS                                                     (0xbbc)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_LSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_LSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_MSB_ADDR(x)                                                  ((x) + 0xbc0)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_MSB_PHYS(x)                                                  ((x) + 0xbc0)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_MSB_OFFS                                                     (0xbc0)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_MSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_MSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                              0x100
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                  8
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_DATA_ADDR(x)                                                      ((x) + 0xbc4)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_DATA_PHYS(x)                                                      ((x) + 0xbc4)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_DATA_OFFS                                                         (0xbc4)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_DATA_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_DATA_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_DATA_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI1_DATA_VALUE_SHFT                                                            0

#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x)                                            ((x) + 0xbc8)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT2_SETUP_PHYS(x)                                            ((x) + 0xbc8)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT2_SETUP_OFFS                                               (0xbc8)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT2_SETUP_RMSK                                               0xffc0ffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT2_SETUP_POR                                                0x00000000
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT2_SETUP_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT2_SETUP_ATTR                                                            0x3
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                    0xff000000
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                            24
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                     0x800000
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                           23
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                   0x400000
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                         22
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                    0xffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                         0

#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_LSB_ADDR(x)                                                  ((x) + 0xbcc)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_LSB_PHYS(x)                                                  ((x) + 0xbcc)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_LSB_OFFS                                                     (0xbcc)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_LSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_LSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_MSB_ADDR(x)                                                  ((x) + 0xbd0)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_MSB_PHYS(x)                                                  ((x) + 0xbd0)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_MSB_OFFS                                                     (0xbd0)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_MSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_MSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                              0x100
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                  8
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_DATA_ADDR(x)                                                      ((x) + 0xbd4)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_DATA_PHYS(x)                                                      ((x) + 0xbd4)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_DATA_OFFS                                                         (0xbd4)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_DATA_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_DATA_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_DATA_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_DATA_IN(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MSI2_DATA_VALUE_SHFT                                                            0

#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_TP_SW_OFFSET_ADDR(x)                                                ((x) + 0xbe4)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_TP_SW_OFFSET_PHYS(x)                                                ((x) + 0xbe4)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_TP_SW_OFFSET_OFFS                                                   (0xbe4)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_TP_SW_OFFSET_RMSK                                                       0xffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_TP_SW_OFFSET_POR                                                    0x00000000
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_TP_SW_OFFSET_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_TP_SW_OFFSET_ATTR                                                                0x3
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                    0xffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                         0

#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_1_ADDR(x)                                                         ((x) + 0xbe8)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_1_PHYS(x)                                                         ((x) + 0xbe8)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_1_OFFS                                                            (0xbe8)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_1_RMSK                                                            0xffff003f
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_1_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_1_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_1_ATTR                                                                         0x3
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                   0xffff0000
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                           16
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                          0x3f
#define HWIO_WBM_R0_WBM2RXDMA0_LINK_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                             0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_ADDR(x)                                                         ((x) + 0xd3c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_PHYS(x)                                                         ((x) + 0xd3c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_OFFS                                                            (0xd3c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_ATTR                                                                         0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                         0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                  0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_ADDR(x)                                                         ((x) + 0xd40)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_PHYS(x)                                                         ((x) + 0xd40)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_OFFS                                                            (0xd40)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_RMSK                                                             0xfffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_ATTR                                                                         0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_RING_SIZE_BMSK                                                   0xfffff00
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_RING_SIZE_SHFT                                                           8
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                               0xff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                  0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_ADDR(x)                                                               ((x) + 0xd44)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_PHYS(x)                                                               ((x) + 0xd44)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_OFFS                                                                  (0xd44)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_RMSK                                                                      0xffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_POR                                                                   0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_ATTR                                                                               0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_RING_ID_BMSK                                                              0xff00
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_RING_ID_SHFT                                                                   8
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_ENTRY_SIZE_BMSK                                                             0xff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_ID_ENTRY_SIZE_SHFT                                                                0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_STATUS_ADDR(x)                                                           ((x) + 0xd48)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_STATUS_PHYS(x)                                                           ((x) + 0xd48)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_STATUS_OFFS                                                              (0xd48)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_STATUS_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_STATUS_POR                                                               0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_STATUS_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_STATUS_ATTR                                                                           0x1
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                              0xffff0000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                      16
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_STATUS_NUM_VALID_WORDS_BMSK                                                  0xffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_STATUS_NUM_VALID_WORDS_SHFT                                                       0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_ADDR(x)                                                             ((x) + 0xd4c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_PHYS(x)                                                             ((x) + 0xd4c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_OFFS                                                                (0xd4c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_RMSK                                                                 0x7ffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_POR                                                                 0x00000080
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_ATTR                                                                             0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                         0x4000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                26
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_LOOP_CNT_BMSK                                                        0x3c00000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_LOOP_CNT_SHFT                                                               22
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_SPARE_CONTROL_BMSK                                                    0x3fc000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_SPARE_CONTROL_SHFT                                                          14
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_SRNG_SM_STATE2_BMSK                                                     0x3000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_SRNG_SM_STATE2_SHFT                                                         12
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_SRNG_SM_STATE1_BMSK                                                      0xf00
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_SRNG_SM_STATE1_SHFT                                                          8
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_SRNG_IS_IDLE_BMSK                                                         0x80
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_SRNG_IS_IDLE_SHFT                                                            7
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_SRNG_ENABLE_BMSK                                                          0x40
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_SRNG_ENABLE_SHFT                                                             6
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                    0x20
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                       5
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                     0x10
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                        4
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_MSI_SWAP_BIT_BMSK                                                          0x8
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_MSI_SWAP_BIT_SHFT                                                            3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_SECURITY_BIT_BMSK                                                          0x4
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_SECURITY_BIT_SHFT                                                            2
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_LOOPCNT_DISABLE_BMSK                                                       0x2
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_LOOPCNT_DISABLE_SHFT                                                         1
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_RING_ID_DISABLE_BMSK                                                       0x1
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_RING_ID_DISABLE_SHFT                                                         0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_ADDR(x)                                                      ((x) + 0xd50)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_PHYS(x)                                                      ((x) + 0xd50)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_OFFS                                                         (0xd50)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                    0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                             0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_ADDR(x)                                                      ((x) + 0xd54)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_PHYS(x)                                                      ((x) + 0xd54)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_OFFS                                                         (0xd54)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_RMSK                                                               0xff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                          0xff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                             0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_ADDR(x)                                                      ((x) + 0xd58)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_PHYS(x)                                                      ((x) + 0xd58)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_OFFS                                                         (0xd58)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                    0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                             0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_ADDR(x)                                                      ((x) + 0xd5c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_PHYS(x)                                                      ((x) + 0xd5c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_OFFS                                                         (0xd5c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_RMSK                                                               0xff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                          0xff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                             0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_ADDR(x)                                               ((x) + 0xd60)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_PHYS(x)                                               ((x) + 0xd60)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_OFFS                                                  (0xd60)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_RMSK                                                  0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_POR                                                   0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_POR_RMSK                                              0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_ATTR                                                               0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                        0xffff0000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                16
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                    0x8000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                        15
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                              0x7fff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                   0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_ADDR(x)                                              ((x) + 0xd64)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_PHYS(x)                                              ((x) + 0xd64)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_OFFS                                                 (0xd64)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_POR                                                  0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_POR_RMSK                                             0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_ATTR                                                              0x1
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                   0xffff0000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                           16
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                           0x8000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                               15
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                        0x7fff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                             0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                            ((x) + 0xd68)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                            ((x) + 0xd68)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_OFFS                                               (0xd68)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_RMSK                                                    0x3ff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_POR                                                0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_ATTR                                                            0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                  0x3ff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                      0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                           ((x) + 0xd6c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                           ((x) + 0xd6c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_OFFS                                              (0xd6c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_RMSK                                              0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_POR                                               0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                          0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                           0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                    0xffff0000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                            16
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                0x8000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                    15
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                          0x7fff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                               0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                           ((x) + 0xd70)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                           ((x) + 0xd70)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_OFFS                                              (0xd70)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                  0xffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_POR                                               0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                          0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                           0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                    0xffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                         0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_ADDR(x)                                              ((x) + 0xd74)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_PHYS(x)                                              ((x) + 0xd74)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_OFFS                                                 (0xd74)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_POR                                                  0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_POR_RMSK                                             0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_ATTR                                                              0x1
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                   0xffff0000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                           16
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                              0x8000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                  15
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                        0x7fff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                             0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                           ((x) + 0xd78)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                           ((x) + 0xd78)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_OFFS                                              (0xd78)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                   0x3ff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_POR                                               0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                          0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                           0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                0x3ff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                    0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                          ((x) + 0xd7c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                          ((x) + 0xd7c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_OFFS                                             (0xd7c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                    0x7
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_POR                                              0x00000003
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                         0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                          0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                               0x7
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                 0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                         ((x) + 0xd80)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                         ((x) + 0xd80)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_STATUS_OFFS                                            (0xd80)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_STATUS_RMSK                                             0xfffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_STATUS_POR                                             0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                        0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                         0x1
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                              0xff00000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                     20
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                             0xfffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                   0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x)                                              ((x) + 0xd84)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_PHYS(x)                                              ((x) + 0xd84)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_OFFS                                                 (0xd84)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_RMSK                                                 0xffcfffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_POR                                                  0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_POR_RMSK                                             0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_ATTR                                                              0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                      0xff000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                              24
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                       0x800000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                             23
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                     0x400000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                           22
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                     0xfffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                           0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_ADDR(x)                                                  ((x) + 0xd88)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_PHYS(x)                                                  ((x) + 0xd88)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_OFFS                                                     (0xd88)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_RMSK                                                         0xffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                      0xffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                           0

#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_ADDR(x)                                                           ((x) + 0xd8c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_PHYS(x)                                                           ((x) + 0xd8c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_OFFS                                                              (0xd8c)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_RMSK                                                              0xffff003f
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_POR                                                               0x00000000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_ATTR                                                                           0x3
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                     0xffff0000
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                             16
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                            0x3f
#define HWIO_WBM_R0_WBM_IDLE_LINK_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                               0

#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_LSB_ADDR(x)                                                        ((x) + 0xd90)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_LSB_PHYS(x)                                                        ((x) + 0xd90)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_LSB_OFFS                                                           (0xd90)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_LSB_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_LSB_POR                                                            0x00000000
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_LSB_POR_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_LSB_ATTR                                                                        0x3
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                        0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                 0

#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_MSB_ADDR(x)                                                        ((x) + 0xd94)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_MSB_PHYS(x)                                                        ((x) + 0xd94)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_MSB_OFFS                                                           (0xd94)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_MSB_RMSK                                                             0xffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_MSB_POR                                                            0x00000000
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_MSB_POR_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_MSB_ATTR                                                                        0x3
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_MSB_RING_SIZE_BMSK                                                   0xffff00
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_MSB_RING_SIZE_SHFT                                                          8
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                              0xff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                 0

#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_ID_ADDR(x)                                                              ((x) + 0xd98)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_ID_PHYS(x)                                                              ((x) + 0xd98)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_ID_OFFS                                                                 (0xd98)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_ID_RMSK                                                                     0xffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_ID_POR                                                                  0x00000000
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_ID_POR_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_ID_ATTR                                                                              0x3
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_ID_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_RELEASE_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_RELEASE_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_RELEASE_RING_ID_IN(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_ID_RING_ID_BMSK                                                             0xff00
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_ID_RING_ID_SHFT                                                                  8
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_ID_ENTRY_SIZE_BMSK                                                            0xff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_ID_ENTRY_SIZE_SHFT                                                               0

#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_STATUS_ADDR(x)                                                          ((x) + 0xd9c)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_STATUS_PHYS(x)                                                          ((x) + 0xd9c)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_STATUS_OFFS                                                             (0xd9c)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_STATUS_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_STATUS_POR                                                              0x00000000
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_STATUS_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_STATUS_ATTR                                                                          0x1
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_RELEASE_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                             0xffff0000
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                     16
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_STATUS_NUM_VALID_WORDS_BMSK                                                 0xffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_STATUS_NUM_VALID_WORDS_SHFT                                                      0

#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_ADDR(x)                                                            ((x) + 0xda0)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_PHYS(x)                                                            ((x) + 0xda0)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_OFFS                                                               (0xda0)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_RMSK                                                                0x7ffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_POR                                                                0x00000080
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_POR_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_ATTR                                                                            0x3
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_IN(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                        0x4000000
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                               26
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_LOOP_CNT_BMSK                                                       0x3c00000
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_LOOP_CNT_SHFT                                                              22
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_SPARE_CONTROL_BMSK                                                   0x3fc000
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_SPARE_CONTROL_SHFT                                                         14
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_SRNG_SM_STATE2_BMSK                                                    0x3000
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_SRNG_SM_STATE2_SHFT                                                        12
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_SRNG_SM_STATE1_BMSK                                                     0xf00
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_SRNG_SM_STATE1_SHFT                                                         8
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_SRNG_IS_IDLE_BMSK                                                        0x80
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_SRNG_IS_IDLE_SHFT                                                           7
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_SRNG_ENABLE_BMSK                                                         0x40
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_SRNG_ENABLE_SHFT                                                            6
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                   0x20
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                      5
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                    0x10
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                       4
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_MSI_SWAP_BIT_BMSK                                                         0x8
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_MSI_SWAP_BIT_SHFT                                                           3
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_SECURITY_BIT_BMSK                                                         0x4
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_SECURITY_BIT_SHFT                                                           2
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_LOOPCNT_DISABLE_BMSK                                                      0x2
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_LOOPCNT_DISABLE_SHFT                                                        1
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_RING_ID_DISABLE_BMSK                                                      0x1
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_RING_ID_DISABLE_SHFT                                                        0

#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_LSB_ADDR(x)                                                     ((x) + 0xda4)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_LSB_PHYS(x)                                                     ((x) + 0xda4)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_LSB_OFFS                                                        (0xda4)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_LSB_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_LSB_POR                                                         0x00000000
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_LSB_POR_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_LSB_ATTR                                                                     0x3
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                   0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                            0

#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_MSB_ADDR(x)                                                     ((x) + 0xda8)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_MSB_PHYS(x)                                                     ((x) + 0xda8)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_MSB_OFFS                                                        (0xda8)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_MSB_RMSK                                                              0xff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_MSB_POR                                                         0x00000000
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_MSB_POR_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_MSB_ATTR                                                                     0x3
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                         0xff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                            0

#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x)                                              ((x) + 0xdb4)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_SETUP_PHYS(x)                                              ((x) + 0xdb4)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_SETUP_OFFS                                                 (0xdb4)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_SETUP_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_SETUP_POR                                                  0x00000000
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_SETUP_POR_RMSK                                             0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_SETUP_ATTR                                                              0x3
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                       0xffff0000
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                               16
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                   0x8000
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                       15
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                             0x7fff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                  0

#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x)                                             ((x) + 0xdb8)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_STATUS_PHYS(x)                                             ((x) + 0xdb8)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_STATUS_OFFS                                                (0xdb8)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_STATUS_RMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_STATUS_POR                                                 0x00000000
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_STATUS_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_STATUS_ATTR                                                             0x1
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                  0xffff0000
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                          16
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                          0x8000
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                              15
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                       0x7fff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                            0

#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                           ((x) + 0xdbc)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                           ((x) + 0xdbc)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_FULL_COUNTER_OFFS                                              (0xdbc)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_FULL_COUNTER_RMSK                                                   0x3ff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_FULL_COUNTER_POR                                               0x00000000
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                          0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_FULL_COUNTER_ATTR                                                           0x3
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                 0x3ff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                     0

#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_LSB_ADDR(x)                                                   ((x) + 0xdd8)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_LSB_PHYS(x)                                                   ((x) + 0xdd8)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_LSB_OFFS                                                      (0xdd8)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_LSB_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_LSB_POR                                                       0x00000000
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_LSB_POR_RMSK                                                  0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_LSB_ATTR                                                                   0x3
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_LSB_ADDR_BMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_LSB_ADDR_SHFT                                                          0

#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_MSB_ADDR(x)                                                   ((x) + 0xddc)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_MSB_PHYS(x)                                                   ((x) + 0xddc)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_MSB_OFFS                                                      (0xddc)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_MSB_RMSK                                                           0x1ff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_MSB_POR                                                       0x00000000
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_MSB_POR_RMSK                                                  0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_MSB_ATTR                                                                   0x3
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                               0x100
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                   8
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_MSB_ADDR_BMSK                                                       0xff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_BASE_MSB_ADDR_SHFT                                                          0

#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_DATA_ADDR(x)                                                       ((x) + 0xde0)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_DATA_PHYS(x)                                                       ((x) + 0xde0)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_DATA_OFFS                                                          (0xde0)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_DATA_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_DATA_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_DATA_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_DATA_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_DATA_VALUE_BMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI1_DATA_VALUE_SHFT                                                             0

#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x)                                             ((x) + 0xde4)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT2_SETUP_PHYS(x)                                             ((x) + 0xde4)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT2_SETUP_OFFS                                                (0xde4)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT2_SETUP_RMSK                                                0xffc0ffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT2_SETUP_POR                                                 0x00000000
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT2_SETUP_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT2_SETUP_ATTR                                                             0x3
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                     0xff000000
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                             24
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                      0x800000
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                            23
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                    0x400000
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                          22
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                     0xffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                          0

#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_LSB_ADDR(x)                                                   ((x) + 0xde8)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_LSB_PHYS(x)                                                   ((x) + 0xde8)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_LSB_OFFS                                                      (0xde8)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_LSB_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_LSB_POR                                                       0x00000000
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_LSB_POR_RMSK                                                  0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_LSB_ATTR                                                                   0x3
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_LSB_ADDR_BMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_LSB_ADDR_SHFT                                                          0

#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_MSB_ADDR(x)                                                   ((x) + 0xdec)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_MSB_PHYS(x)                                                   ((x) + 0xdec)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_MSB_OFFS                                                      (0xdec)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_MSB_RMSK                                                           0x1ff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_MSB_POR                                                       0x00000000
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_MSB_POR_RMSK                                                  0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_MSB_ATTR                                                                   0x3
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                               0x100
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                   8
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_MSB_ADDR_BMSK                                                       0xff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_BASE_MSB_ADDR_SHFT                                                          0

#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_DATA_ADDR(x)                                                       ((x) + 0xdf0)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_DATA_PHYS(x)                                                       ((x) + 0xdf0)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_DATA_OFFS                                                          (0xdf0)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_DATA_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_DATA_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_DATA_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_DATA_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_DATA_IN(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_DATA_VALUE_BMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MSI2_DATA_VALUE_SHFT                                                             0

#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x)                                                 ((x) + 0xe00)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_TP_SW_OFFSET_PHYS(x)                                                 ((x) + 0xe00)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_TP_SW_OFFSET_OFFS                                                    (0xe00)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_TP_SW_OFFSET_RMSK                                                        0xffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_TP_SW_OFFSET_POR                                                     0x00000000
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_TP_SW_OFFSET_POR_RMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_TP_SW_OFFSET_ATTR                                                                 0x3
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                     0xffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                          0

#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_1_ADDR(x)                                                          ((x) + 0xe04)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_1_PHYS(x)                                                          ((x) + 0xe04)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_1_OFFS                                                             (0xe04)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_1_RMSK                                                             0xffff003f
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_1_POR                                                              0x00000000
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_1_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_1_ATTR                                                                          0x3
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                    0xffff0000
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                            16
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                           0x3f
#define HWIO_WBM_R0_WBM2FW_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                              0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_ADDR(x)                                                       ((x) + 0xe08)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_PHYS(x)                                                       ((x) + 0xe08)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_OFFS                                                          (0xe08)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_ADDR(x)                                                       ((x) + 0xe0c)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_PHYS(x)                                                       ((x) + 0xe0c)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_OFFS                                                          (0xe0c)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_RMSK                                                           0xfffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_RING_SIZE_BMSK                                                 0xfffff00
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_RING_SIZE_SHFT                                                         8
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                             0xff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_ADDR(x)                                                             ((x) + 0xe10)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_PHYS(x)                                                             ((x) + 0xe10)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_OFFS                                                                (0xe10)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_RMSK                                                                    0xffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_POR                                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_ATTR                                                                             0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_RING_ID_BMSK                                                            0xff00
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_RING_ID_SHFT                                                                 8
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_ENTRY_SIZE_BMSK                                                           0xff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_ID_ENTRY_SIZE_SHFT                                                              0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_STATUS_ADDR(x)                                                         ((x) + 0xe14)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_STATUS_PHYS(x)                                                         ((x) + 0xe14)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_STATUS_OFFS                                                            (0xe14)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_STATUS_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_STATUS_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_STATUS_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_STATUS_ATTR                                                                         0x1
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                            0xffff0000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                    16
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_STATUS_NUM_VALID_WORDS_BMSK                                                0xffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_STATUS_NUM_VALID_WORDS_SHFT                                                     0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_ADDR(x)                                                           ((x) + 0xe18)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_PHYS(x)                                                           ((x) + 0xe18)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_OFFS                                                              (0xe18)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_RMSK                                                               0x7ffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_POR                                                               0x00000080
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_ATTR                                                                           0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                       0x4000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                              26
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_LOOP_CNT_BMSK                                                      0x3c00000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_LOOP_CNT_SHFT                                                             22
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_SPARE_CONTROL_BMSK                                                  0x3fc000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_SPARE_CONTROL_SHFT                                                        14
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_SRNG_SM_STATE2_BMSK                                                   0x3000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_SRNG_SM_STATE2_SHFT                                                       12
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_SRNG_SM_STATE1_BMSK                                                    0xf00
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_SRNG_SM_STATE1_SHFT                                                        8
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_SRNG_IS_IDLE_BMSK                                                       0x80
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_SRNG_IS_IDLE_SHFT                                                          7
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_SRNG_ENABLE_BMSK                                                        0x40
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_SRNG_ENABLE_SHFT                                                           6
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                  0x20
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                     5
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                   0x10
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                      4
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_MSI_SWAP_BIT_BMSK                                                        0x8
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_MSI_SWAP_BIT_SHFT                                                          3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_SECURITY_BIT_BMSK                                                        0x4
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_SECURITY_BIT_SHFT                                                          2
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_LOOPCNT_DISABLE_BMSK                                                     0x2
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_LOOPCNT_DISABLE_SHFT                                                       1
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_RING_ID_DISABLE_BMSK                                                     0x1
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_RING_ID_DISABLE_SHFT                                                       0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_ADDR(x)                                                    ((x) + 0xe1c)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_PHYS(x)                                                    ((x) + 0xe1c)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_OFFS                                                       (0xe1c)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                  0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                           0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_ADDR(x)                                                    ((x) + 0xe20)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_PHYS(x)                                                    ((x) + 0xe20)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_OFFS                                                       (0xe20)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_RMSK                                                             0xff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                        0xff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                           0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x)                                             ((x) + 0xe2c)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_PHYS(x)                                             ((x) + 0xe2c)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_OFFS                                                (0xe2c)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_RMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_POR                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_ATTR                                                             0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x)                                            ((x) + 0xe30)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_PHYS(x)                                            ((x) + 0xe30)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_OFFS                                               (0xe30)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_POR                                                0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_ATTR                                                            0x1
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                 0xffff0000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                         16
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                         0x8000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                             15
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                      0x7fff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                           0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                          ((x) + 0xe34)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                          ((x) + 0xe34)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_OFFS                                             (0xe34)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_RMSK                                                  0x3ff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_POR                                              0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_ATTR                                                          0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                0x3ff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                    0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_ADDR(x)                                                  ((x) + 0xe50)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_PHYS(x)                                                  ((x) + 0xe50)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_OFFS                                                     (0xe50)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_ADDR(x)                                                  ((x) + 0xe54)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_PHYS(x)                                                  ((x) + 0xe54)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_OFFS                                                     (0xe54)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                              0x100
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                  8
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_ADDR(x)                                                      ((x) + 0xe58)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_PHYS(x)                                                      ((x) + 0xe58)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_OFFS                                                         (0xe58)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI1_DATA_VALUE_SHFT                                                            0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x)                                            ((x) + 0xe5c)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_PHYS(x)                                            ((x) + 0xe5c)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_OFFS                                               (0xe5c)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_RMSK                                               0xffcfffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_POR                                                0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_ATTR                                                            0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                    0xff000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                            24
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                     0x800000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                           23
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                   0x400000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                         22
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                   0xfffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                         0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_ADDR(x)                                                  ((x) + 0xe60)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_PHYS(x)                                                  ((x) + 0xe60)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_OFFS                                                     (0xe60)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_ADDR(x)                                                  ((x) + 0xe64)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_PHYS(x)                                                  ((x) + 0xe64)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_OFFS                                                     (0xe64)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                              0x100
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                  8
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_ADDR(x)                                                      ((x) + 0xe68)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_PHYS(x)                                                      ((x) + 0xe68)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_OFFS                                                         (0xe68)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MSI2_DATA_VALUE_SHFT                                                            0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x)                                                ((x) + 0xe78)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_PHYS(x)                                                ((x) + 0xe78)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_OFFS                                                   (0xe78)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_RMSK                                                       0xffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_POR                                                    0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_ATTR                                                                0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                    0xffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                         0

#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_ADDR(x)                                                         ((x) + 0xe7c)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_PHYS(x)                                                         ((x) + 0xe7c)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_OFFS                                                            (0xe7c)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_RMSK                                                            0xffff003f
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_ATTR                                                                         0x3
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                   0xffff0000
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                           16
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                          0x3f
#define HWIO_WBM_R0_WBM2SW0_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                             0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_ADDR(x)                                                       ((x) + 0xe80)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_PHYS(x)                                                       ((x) + 0xe80)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_OFFS                                                          (0xe80)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_ADDR(x)                                                       ((x) + 0xe84)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_PHYS(x)                                                       ((x) + 0xe84)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_OFFS                                                          (0xe84)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_RMSK                                                           0xfffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_RING_SIZE_BMSK                                                 0xfffff00
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_RING_SIZE_SHFT                                                         8
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                             0xff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_ADDR(x)                                                             ((x) + 0xe88)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_PHYS(x)                                                             ((x) + 0xe88)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_OFFS                                                                (0xe88)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_RMSK                                                                    0xffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_POR                                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_ATTR                                                                             0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_RING_ID_BMSK                                                            0xff00
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_RING_ID_SHFT                                                                 8
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_ENTRY_SIZE_BMSK                                                           0xff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_ID_ENTRY_SIZE_SHFT                                                              0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_STATUS_ADDR(x)                                                         ((x) + 0xe8c)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_STATUS_PHYS(x)                                                         ((x) + 0xe8c)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_STATUS_OFFS                                                            (0xe8c)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_STATUS_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_STATUS_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_STATUS_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_STATUS_ATTR                                                                         0x1
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                            0xffff0000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                    16
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_STATUS_NUM_VALID_WORDS_BMSK                                                0xffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_STATUS_NUM_VALID_WORDS_SHFT                                                     0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_ADDR(x)                                                           ((x) + 0xe90)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_PHYS(x)                                                           ((x) + 0xe90)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_OFFS                                                              (0xe90)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_RMSK                                                               0x7ffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_POR                                                               0x00000080
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_ATTR                                                                           0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                       0x4000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                              26
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_LOOP_CNT_BMSK                                                      0x3c00000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_LOOP_CNT_SHFT                                                             22
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_SPARE_CONTROL_BMSK                                                  0x3fc000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_SPARE_CONTROL_SHFT                                                        14
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_SRNG_SM_STATE2_BMSK                                                   0x3000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_SRNG_SM_STATE2_SHFT                                                       12
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_SRNG_SM_STATE1_BMSK                                                    0xf00
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_SRNG_SM_STATE1_SHFT                                                        8
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_SRNG_IS_IDLE_BMSK                                                       0x80
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_SRNG_IS_IDLE_SHFT                                                          7
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_SRNG_ENABLE_BMSK                                                        0x40
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_SRNG_ENABLE_SHFT                                                           6
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                  0x20
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                     5
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                   0x10
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                      4
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_MSI_SWAP_BIT_BMSK                                                        0x8
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_MSI_SWAP_BIT_SHFT                                                          3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_SECURITY_BIT_BMSK                                                        0x4
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_SECURITY_BIT_SHFT                                                          2
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_LOOPCNT_DISABLE_BMSK                                                     0x2
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_LOOPCNT_DISABLE_SHFT                                                       1
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_RING_ID_DISABLE_BMSK                                                     0x1
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_RING_ID_DISABLE_SHFT                                                       0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_ADDR(x)                                                    ((x) + 0xe94)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_PHYS(x)                                                    ((x) + 0xe94)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_OFFS                                                       (0xe94)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                  0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                           0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_ADDR(x)                                                    ((x) + 0xe98)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_PHYS(x)                                                    ((x) + 0xe98)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_OFFS                                                       (0xe98)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_RMSK                                                             0xff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                        0xff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                           0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x)                                             ((x) + 0xea4)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_PHYS(x)                                             ((x) + 0xea4)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_OFFS                                                (0xea4)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_RMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_POR                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_ATTR                                                             0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x)                                            ((x) + 0xea8)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_PHYS(x)                                            ((x) + 0xea8)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_OFFS                                               (0xea8)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_POR                                                0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_ATTR                                                            0x1
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                 0xffff0000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                         16
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                         0x8000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                             15
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                      0x7fff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                           0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                          ((x) + 0xeac)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                          ((x) + 0xeac)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_OFFS                                             (0xeac)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_RMSK                                                  0x3ff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_POR                                              0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_ATTR                                                          0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                0x3ff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                    0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_ADDR(x)                                                  ((x) + 0xec8)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_PHYS(x)                                                  ((x) + 0xec8)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_OFFS                                                     (0xec8)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_ADDR(x)                                                  ((x) + 0xecc)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_PHYS(x)                                                  ((x) + 0xecc)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_OFFS                                                     (0xecc)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                              0x100
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                  8
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_ADDR(x)                                                      ((x) + 0xed0)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_PHYS(x)                                                      ((x) + 0xed0)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_OFFS                                                         (0xed0)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI1_DATA_VALUE_SHFT                                                            0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x)                                            ((x) + 0xed4)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_PHYS(x)                                            ((x) + 0xed4)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_OFFS                                               (0xed4)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_RMSK                                               0xffcfffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_POR                                                0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_ATTR                                                            0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                    0xff000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                            24
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                     0x800000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                           23
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                   0x400000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                         22
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                   0xfffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                         0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_ADDR(x)                                                  ((x) + 0xed8)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_PHYS(x)                                                  ((x) + 0xed8)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_OFFS                                                     (0xed8)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_ADDR(x)                                                  ((x) + 0xedc)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_PHYS(x)                                                  ((x) + 0xedc)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_OFFS                                                     (0xedc)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                              0x100
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                  8
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_ADDR(x)                                                      ((x) + 0xee0)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_PHYS(x)                                                      ((x) + 0xee0)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_OFFS                                                         (0xee0)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MSI2_DATA_VALUE_SHFT                                                            0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x)                                                ((x) + 0xef0)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_PHYS(x)                                                ((x) + 0xef0)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_OFFS                                                   (0xef0)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_RMSK                                                       0xffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_POR                                                    0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_ATTR                                                                0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                    0xffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                         0

#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_ADDR(x)                                                         ((x) + 0xef4)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_PHYS(x)                                                         ((x) + 0xef4)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_OFFS                                                            (0xef4)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_RMSK                                                            0xffff003f
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_ATTR                                                                         0x3
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                   0xffff0000
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                           16
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                          0x3f
#define HWIO_WBM_R0_WBM2SW1_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                             0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_ADDR(x)                                                       ((x) + 0xef8)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_PHYS(x)                                                       ((x) + 0xef8)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_OFFS                                                          (0xef8)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_ADDR(x)                                                       ((x) + 0xefc)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_PHYS(x)                                                       ((x) + 0xefc)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_OFFS                                                          (0xefc)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_RMSK                                                           0xfffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_RING_SIZE_BMSK                                                 0xfffff00
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_RING_SIZE_SHFT                                                         8
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                             0xff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_ADDR(x)                                                             ((x) + 0xf00)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_PHYS(x)                                                             ((x) + 0xf00)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_OFFS                                                                (0xf00)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_RMSK                                                                    0xffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_POR                                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_ATTR                                                                             0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_RING_ID_BMSK                                                            0xff00
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_RING_ID_SHFT                                                                 8
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_ENTRY_SIZE_BMSK                                                           0xff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_ID_ENTRY_SIZE_SHFT                                                              0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_STATUS_ADDR(x)                                                         ((x) + 0xf04)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_STATUS_PHYS(x)                                                         ((x) + 0xf04)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_STATUS_OFFS                                                            (0xf04)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_STATUS_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_STATUS_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_STATUS_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_STATUS_ATTR                                                                         0x1
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                            0xffff0000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                    16
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_STATUS_NUM_VALID_WORDS_BMSK                                                0xffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_STATUS_NUM_VALID_WORDS_SHFT                                                     0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_ADDR(x)                                                           ((x) + 0xf08)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_PHYS(x)                                                           ((x) + 0xf08)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_OFFS                                                              (0xf08)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_RMSK                                                               0x7ffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_POR                                                               0x00000080
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_ATTR                                                                           0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                       0x4000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                              26
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_LOOP_CNT_BMSK                                                      0x3c00000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_LOOP_CNT_SHFT                                                             22
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_SPARE_CONTROL_BMSK                                                  0x3fc000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_SPARE_CONTROL_SHFT                                                        14
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_SRNG_SM_STATE2_BMSK                                                   0x3000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_SRNG_SM_STATE2_SHFT                                                       12
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_SRNG_SM_STATE1_BMSK                                                    0xf00
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_SRNG_SM_STATE1_SHFT                                                        8
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_SRNG_IS_IDLE_BMSK                                                       0x80
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_SRNG_IS_IDLE_SHFT                                                          7
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_SRNG_ENABLE_BMSK                                                        0x40
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_SRNG_ENABLE_SHFT                                                           6
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                  0x20
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                     5
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                   0x10
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                      4
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_MSI_SWAP_BIT_BMSK                                                        0x8
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_MSI_SWAP_BIT_SHFT                                                          3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_SECURITY_BIT_BMSK                                                        0x4
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_SECURITY_BIT_SHFT                                                          2
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_LOOPCNT_DISABLE_BMSK                                                     0x2
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_LOOPCNT_DISABLE_SHFT                                                       1
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_RING_ID_DISABLE_BMSK                                                     0x1
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_RING_ID_DISABLE_SHFT                                                       0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_ADDR(x)                                                    ((x) + 0xf0c)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_PHYS(x)                                                    ((x) + 0xf0c)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_OFFS                                                       (0xf0c)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                  0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                           0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_ADDR(x)                                                    ((x) + 0xf10)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_PHYS(x)                                                    ((x) + 0xf10)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_OFFS                                                       (0xf10)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_RMSK                                                             0xff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                        0xff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                           0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x)                                             ((x) + 0xf1c)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_PHYS(x)                                             ((x) + 0xf1c)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_OFFS                                                (0xf1c)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_RMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_POR                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_ATTR                                                             0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x)                                            ((x) + 0xf20)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_PHYS(x)                                            ((x) + 0xf20)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_OFFS                                               (0xf20)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_POR                                                0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_ATTR                                                            0x1
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                 0xffff0000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                         16
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                         0x8000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                             15
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                      0x7fff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                           0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                          ((x) + 0xf24)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                          ((x) + 0xf24)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_OFFS                                             (0xf24)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_RMSK                                                  0x3ff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_POR                                              0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_ATTR                                                          0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                0x3ff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                    0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_ADDR(x)                                                  ((x) + 0xf40)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_PHYS(x)                                                  ((x) + 0xf40)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_OFFS                                                     (0xf40)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_ADDR(x)                                                  ((x) + 0xf44)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_PHYS(x)                                                  ((x) + 0xf44)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_OFFS                                                     (0xf44)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                              0x100
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                  8
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_ADDR(x)                                                      ((x) + 0xf48)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_PHYS(x)                                                      ((x) + 0xf48)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_OFFS                                                         (0xf48)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI1_DATA_VALUE_SHFT                                                            0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x)                                            ((x) + 0xf4c)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_PHYS(x)                                            ((x) + 0xf4c)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_OFFS                                               (0xf4c)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_RMSK                                               0xffcfffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_POR                                                0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_ATTR                                                            0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                    0xff000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                            24
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                     0x800000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                           23
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                   0x400000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                         22
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                   0xfffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                         0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_ADDR(x)                                                  ((x) + 0xf50)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_PHYS(x)                                                  ((x) + 0xf50)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_OFFS                                                     (0xf50)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_ADDR(x)                                                  ((x) + 0xf54)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_PHYS(x)                                                  ((x) + 0xf54)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_OFFS                                                     (0xf54)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                              0x100
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                  8
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_ADDR(x)                                                      ((x) + 0xf58)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_PHYS(x)                                                      ((x) + 0xf58)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_OFFS                                                         (0xf58)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MSI2_DATA_VALUE_SHFT                                                            0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x)                                                ((x) + 0xf68)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_PHYS(x)                                                ((x) + 0xf68)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_OFFS                                                   (0xf68)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_RMSK                                                       0xffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_POR                                                    0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_ATTR                                                                0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                    0xffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                         0

#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_ADDR(x)                                                         ((x) + 0xf6c)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_PHYS(x)                                                         ((x) + 0xf6c)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_OFFS                                                            (0xf6c)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_RMSK                                                            0xffff003f
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_ATTR                                                                         0x3
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                   0xffff0000
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                           16
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                          0x3f
#define HWIO_WBM_R0_WBM2SW2_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                             0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_ADDR(x)                                                       ((x) + 0xf70)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_PHYS(x)                                                       ((x) + 0xf70)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_OFFS                                                          (0xf70)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_ADDR(x)                                                       ((x) + 0xf74)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_PHYS(x)                                                       ((x) + 0xf74)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_OFFS                                                          (0xf74)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_RMSK                                                           0xfffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_RING_SIZE_BMSK                                                 0xfffff00
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_RING_SIZE_SHFT                                                         8
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                             0xff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_ADDR(x)                                                             ((x) + 0xf78)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_PHYS(x)                                                             ((x) + 0xf78)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_OFFS                                                                (0xf78)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_RMSK                                                                    0xffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_POR                                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_ATTR                                                                             0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_RING_ID_BMSK                                                            0xff00
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_RING_ID_SHFT                                                                 8
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_ENTRY_SIZE_BMSK                                                           0xff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_ID_ENTRY_SIZE_SHFT                                                              0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_STATUS_ADDR(x)                                                         ((x) + 0xf7c)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_STATUS_PHYS(x)                                                         ((x) + 0xf7c)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_STATUS_OFFS                                                            (0xf7c)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_STATUS_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_STATUS_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_STATUS_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_STATUS_ATTR                                                                         0x1
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                            0xffff0000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                    16
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_STATUS_NUM_VALID_WORDS_BMSK                                                0xffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_STATUS_NUM_VALID_WORDS_SHFT                                                     0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_ADDR(x)                                                           ((x) + 0xf80)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_PHYS(x)                                                           ((x) + 0xf80)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_OFFS                                                              (0xf80)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_RMSK                                                               0x7ffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_POR                                                               0x00000080
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_ATTR                                                                           0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                       0x4000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                              26
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_LOOP_CNT_BMSK                                                      0x3c00000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_LOOP_CNT_SHFT                                                             22
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_SPARE_CONTROL_BMSK                                                  0x3fc000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_SPARE_CONTROL_SHFT                                                        14
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_SRNG_SM_STATE2_BMSK                                                   0x3000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_SRNG_SM_STATE2_SHFT                                                       12
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_SRNG_SM_STATE1_BMSK                                                    0xf00
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_SRNG_SM_STATE1_SHFT                                                        8
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_SRNG_IS_IDLE_BMSK                                                       0x80
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_SRNG_IS_IDLE_SHFT                                                          7
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_SRNG_ENABLE_BMSK                                                        0x40
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_SRNG_ENABLE_SHFT                                                           6
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                  0x20
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                     5
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                   0x10
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                      4
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_MSI_SWAP_BIT_BMSK                                                        0x8
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_MSI_SWAP_BIT_SHFT                                                          3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_SECURITY_BIT_BMSK                                                        0x4
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_SECURITY_BIT_SHFT                                                          2
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_LOOPCNT_DISABLE_BMSK                                                     0x2
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_LOOPCNT_DISABLE_SHFT                                                       1
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_RING_ID_DISABLE_BMSK                                                     0x1
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_RING_ID_DISABLE_SHFT                                                       0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_ADDR(x)                                                    ((x) + 0xf84)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_PHYS(x)                                                    ((x) + 0xf84)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_OFFS                                                       (0xf84)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                  0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                           0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_ADDR(x)                                                    ((x) + 0xf88)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_PHYS(x)                                                    ((x) + 0xf88)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_OFFS                                                       (0xf88)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_RMSK                                                             0xff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                        0xff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                           0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x)                                             ((x) + 0xf94)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_PHYS(x)                                             ((x) + 0xf94)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_OFFS                                                (0xf94)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_RMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_POR                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_ATTR                                                             0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x)                                            ((x) + 0xf98)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_PHYS(x)                                            ((x) + 0xf98)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_OFFS                                               (0xf98)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_POR                                                0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_ATTR                                                            0x1
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                 0xffff0000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                         16
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                         0x8000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                             15
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                      0x7fff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                           0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                          ((x) + 0xf9c)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                          ((x) + 0xf9c)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_OFFS                                             (0xf9c)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_RMSK                                                  0x3ff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_POR                                              0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_ATTR                                                          0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                0x3ff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                    0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_ADDR(x)                                                  ((x) + 0xfb8)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_PHYS(x)                                                  ((x) + 0xfb8)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_OFFS                                                     (0xfb8)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_ADDR(x)                                                  ((x) + 0xfbc)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_PHYS(x)                                                  ((x) + 0xfbc)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_OFFS                                                     (0xfbc)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                              0x100
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                  8
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_ADDR(x)                                                      ((x) + 0xfc0)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_PHYS(x)                                                      ((x) + 0xfc0)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_OFFS                                                         (0xfc0)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI1_DATA_VALUE_SHFT                                                            0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x)                                            ((x) + 0xfc4)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_PHYS(x)                                            ((x) + 0xfc4)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_OFFS                                               (0xfc4)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_RMSK                                               0xffcfffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_POR                                                0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_ATTR                                                            0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                    0xff000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                            24
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                     0x800000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                           23
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                   0x400000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                         22
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                   0xfffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                         0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_ADDR(x)                                                  ((x) + 0xfc8)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_PHYS(x)                                                  ((x) + 0xfc8)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_OFFS                                                     (0xfc8)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_ADDR(x)                                                  ((x) + 0xfcc)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_PHYS(x)                                                  ((x) + 0xfcc)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_OFFS                                                     (0xfcc)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                              0x100
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                  8
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_ADDR(x)                                                      ((x) + 0xfd0)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_PHYS(x)                                                      ((x) + 0xfd0)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_OFFS                                                         (0xfd0)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MSI2_DATA_VALUE_SHFT                                                            0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x)                                                ((x) + 0xfe0)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_PHYS(x)                                                ((x) + 0xfe0)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_OFFS                                                   (0xfe0)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_RMSK                                                       0xffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_POR                                                    0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_ATTR                                                                0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                    0xffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                         0

#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_ADDR(x)                                                         ((x) + 0xfe4)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_PHYS(x)                                                         ((x) + 0xfe4)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_OFFS                                                            (0xfe4)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_RMSK                                                            0xffff003f
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_ATTR                                                                         0x3
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                   0xffff0000
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                           16
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                          0x3f
#define HWIO_WBM_R0_WBM2SW3_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                             0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_ADDR(x)                                                       ((x) + 0xfe8)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_PHYS(x)                                                       ((x) + 0xfe8)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_OFFS                                                          (0xfe8)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_ADDR(x)                                                       ((x) + 0xfec)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_PHYS(x)                                                       ((x) + 0xfec)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_OFFS                                                          (0xfec)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_RMSK                                                           0xfffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_RING_SIZE_BMSK                                                 0xfffff00
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_RING_SIZE_SHFT                                                         8
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                             0xff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_ADDR(x)                                                             ((x) + 0xff0)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_PHYS(x)                                                             ((x) + 0xff0)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_OFFS                                                                (0xff0)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_RMSK                                                                    0xffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_POR                                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_ATTR                                                                             0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_RING_ID_BMSK                                                            0xff00
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_RING_ID_SHFT                                                                 8
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_ENTRY_SIZE_BMSK                                                           0xff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_ID_ENTRY_SIZE_SHFT                                                              0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_STATUS_ADDR(x)                                                         ((x) + 0xff4)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_STATUS_PHYS(x)                                                         ((x) + 0xff4)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_STATUS_OFFS                                                            (0xff4)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_STATUS_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_STATUS_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_STATUS_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_STATUS_ATTR                                                                         0x1
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                            0xffff0000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                    16
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_STATUS_NUM_VALID_WORDS_BMSK                                                0xffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_STATUS_NUM_VALID_WORDS_SHFT                                                     0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_ADDR(x)                                                           ((x) + 0xff8)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_PHYS(x)                                                           ((x) + 0xff8)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_OFFS                                                              (0xff8)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_RMSK                                                               0x7ffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_POR                                                               0x00000080
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_ATTR                                                                           0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                       0x4000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                              26
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_LOOP_CNT_BMSK                                                      0x3c00000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_LOOP_CNT_SHFT                                                             22
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_SPARE_CONTROL_BMSK                                                  0x3fc000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_SPARE_CONTROL_SHFT                                                        14
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_SRNG_SM_STATE2_BMSK                                                   0x3000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_SRNG_SM_STATE2_SHFT                                                       12
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_SRNG_SM_STATE1_BMSK                                                    0xf00
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_SRNG_SM_STATE1_SHFT                                                        8
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_SRNG_IS_IDLE_BMSK                                                       0x80
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_SRNG_IS_IDLE_SHFT                                                          7
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_SRNG_ENABLE_BMSK                                                        0x40
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_SRNG_ENABLE_SHFT                                                           6
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                  0x20
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                     5
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                   0x10
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                      4
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_MSI_SWAP_BIT_BMSK                                                        0x8
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_MSI_SWAP_BIT_SHFT                                                          3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_SECURITY_BIT_BMSK                                                        0x4
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_SECURITY_BIT_SHFT                                                          2
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_LOOPCNT_DISABLE_BMSK                                                     0x2
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_LOOPCNT_DISABLE_SHFT                                                       1
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_RING_ID_DISABLE_BMSK                                                     0x1
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_RING_ID_DISABLE_SHFT                                                       0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_ADDR(x)                                                    ((x) + 0xffc)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_PHYS(x)                                                    ((x) + 0xffc)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_OFFS                                                       (0xffc)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                  0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                           0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_ADDR(x)                                                    ((x) + 0x1000)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_PHYS(x)                                                    ((x) + 0x1000)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_OFFS                                                       (0x1000)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_RMSK                                                             0xff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                        0xff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                           0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x)                                             ((x) + 0x100c)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_PHYS(x)                                             ((x) + 0x100c)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_OFFS                                                (0x100c)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_RMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_POR                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_ATTR                                                             0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x)                                            ((x) + 0x1010)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_PHYS(x)                                            ((x) + 0x1010)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_OFFS                                               (0x1010)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_POR                                                0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_ATTR                                                            0x1
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                 0xffff0000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                         16
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                         0x8000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                             15
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                      0x7fff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                           0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                          ((x) + 0x1014)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                          ((x) + 0x1014)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_OFFS                                             (0x1014)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_RMSK                                                  0x3ff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_POR                                              0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_ATTR                                                          0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                0x3ff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                    0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_ADDR(x)                                                  ((x) + 0x1030)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_PHYS(x)                                                  ((x) + 0x1030)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_OFFS                                                     (0x1030)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_ADDR(x)                                                  ((x) + 0x1034)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_PHYS(x)                                                  ((x) + 0x1034)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_OFFS                                                     (0x1034)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                              0x100
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                  8
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_ADDR(x)                                                      ((x) + 0x1038)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_PHYS(x)                                                      ((x) + 0x1038)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_OFFS                                                         (0x1038)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI1_DATA_VALUE_SHFT                                                            0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x)                                            ((x) + 0x103c)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_PHYS(x)                                            ((x) + 0x103c)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_OFFS                                               (0x103c)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_RMSK                                               0xffcfffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_POR                                                0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_ATTR                                                            0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                    0xff000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                            24
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                     0x800000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                           23
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                   0x400000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                         22
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                   0xfffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                         0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_ADDR(x)                                                  ((x) + 0x1040)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_PHYS(x)                                                  ((x) + 0x1040)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_OFFS                                                     (0x1040)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_ADDR(x)                                                  ((x) + 0x1044)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_PHYS(x)                                                  ((x) + 0x1044)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_OFFS                                                     (0x1044)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                              0x100
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                  8
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_ADDR(x)                                                      ((x) + 0x1048)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_PHYS(x)                                                      ((x) + 0x1048)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_OFFS                                                         (0x1048)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MSI2_DATA_VALUE_SHFT                                                            0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x)                                                ((x) + 0x1058)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_PHYS(x)                                                ((x) + 0x1058)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_OFFS                                                   (0x1058)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_RMSK                                                       0xffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_POR                                                    0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_ATTR                                                                0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                    0xffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                         0

#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_ADDR(x)                                                         ((x) + 0x105c)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_PHYS(x)                                                         ((x) + 0x105c)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_OFFS                                                            (0x105c)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_RMSK                                                            0xffff003f
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_ATTR                                                                         0x3
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                   0xffff0000
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                           16
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                          0x3f
#define HWIO_WBM_R0_WBM2SW4_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                             0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_ADDR(x)                                                       ((x) + 0x1060)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_PHYS(x)                                                       ((x) + 0x1060)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_OFFS                                                          (0x1060)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_ADDR(x)                                                       ((x) + 0x1064)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_PHYS(x)                                                       ((x) + 0x1064)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_OFFS                                                          (0x1064)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_RMSK                                                           0xfffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_RING_SIZE_BMSK                                                 0xfffff00
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_RING_SIZE_SHFT                                                         8
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                             0xff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_ADDR(x)                                                             ((x) + 0x1068)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_PHYS(x)                                                             ((x) + 0x1068)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_OFFS                                                                (0x1068)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_RMSK                                                                    0xffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_POR                                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_ATTR                                                                             0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_RING_ID_BMSK                                                            0xff00
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_RING_ID_SHFT                                                                 8
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_ENTRY_SIZE_BMSK                                                           0xff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_ID_ENTRY_SIZE_SHFT                                                              0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_STATUS_ADDR(x)                                                         ((x) + 0x106c)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_STATUS_PHYS(x)                                                         ((x) + 0x106c)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_STATUS_OFFS                                                            (0x106c)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_STATUS_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_STATUS_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_STATUS_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_STATUS_ATTR                                                                         0x1
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                            0xffff0000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                    16
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_STATUS_NUM_VALID_WORDS_BMSK                                                0xffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_STATUS_NUM_VALID_WORDS_SHFT                                                     0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_ADDR(x)                                                           ((x) + 0x1070)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_PHYS(x)                                                           ((x) + 0x1070)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_OFFS                                                              (0x1070)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_RMSK                                                               0x7ffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_POR                                                               0x00000080
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_ATTR                                                                           0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                       0x4000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                              26
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_LOOP_CNT_BMSK                                                      0x3c00000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_LOOP_CNT_SHFT                                                             22
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_SPARE_CONTROL_BMSK                                                  0x3fc000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_SPARE_CONTROL_SHFT                                                        14
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_SRNG_SM_STATE2_BMSK                                                   0x3000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_SRNG_SM_STATE2_SHFT                                                       12
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_SRNG_SM_STATE1_BMSK                                                    0xf00
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_SRNG_SM_STATE1_SHFT                                                        8
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_SRNG_IS_IDLE_BMSK                                                       0x80
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_SRNG_IS_IDLE_SHFT                                                          7
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_SRNG_ENABLE_BMSK                                                        0x40
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_SRNG_ENABLE_SHFT                                                           6
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                  0x20
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                     5
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                   0x10
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                      4
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_MSI_SWAP_BIT_BMSK                                                        0x8
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_MSI_SWAP_BIT_SHFT                                                          3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_SECURITY_BIT_BMSK                                                        0x4
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_SECURITY_BIT_SHFT                                                          2
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_LOOPCNT_DISABLE_BMSK                                                     0x2
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_LOOPCNT_DISABLE_SHFT                                                       1
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_RING_ID_DISABLE_BMSK                                                     0x1
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_RING_ID_DISABLE_SHFT                                                       0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_ADDR(x)                                                    ((x) + 0x1074)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_PHYS(x)                                                    ((x) + 0x1074)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_OFFS                                                       (0x1074)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                  0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                           0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_ADDR(x)                                                    ((x) + 0x1078)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_PHYS(x)                                                    ((x) + 0x1078)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_OFFS                                                       (0x1078)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_RMSK                                                             0xff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                        0xff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                           0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x)                                             ((x) + 0x1084)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_PHYS(x)                                             ((x) + 0x1084)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_OFFS                                                (0x1084)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_RMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_POR                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_ATTR                                                             0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x)                                            ((x) + 0x1088)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_PHYS(x)                                            ((x) + 0x1088)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_OFFS                                               (0x1088)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_POR                                                0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_ATTR                                                            0x1
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                 0xffff0000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                         16
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                         0x8000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                             15
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                      0x7fff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                           0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                          ((x) + 0x108c)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                          ((x) + 0x108c)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_OFFS                                             (0x108c)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_RMSK                                                  0x3ff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_POR                                              0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_ATTR                                                          0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                0x3ff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                    0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_ADDR(x)                                                  ((x) + 0x10a8)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_PHYS(x)                                                  ((x) + 0x10a8)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_OFFS                                                     (0x10a8)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_ADDR(x)                                                  ((x) + 0x10ac)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_PHYS(x)                                                  ((x) + 0x10ac)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_OFFS                                                     (0x10ac)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                              0x100
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                  8
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_ADDR(x)                                                      ((x) + 0x10b0)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_PHYS(x)                                                      ((x) + 0x10b0)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_OFFS                                                         (0x10b0)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI1_DATA_VALUE_SHFT                                                            0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x)                                            ((x) + 0x10b4)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_PHYS(x)                                            ((x) + 0x10b4)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_OFFS                                               (0x10b4)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_RMSK                                               0xffcfffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_POR                                                0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_ATTR                                                            0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                    0xff000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                            24
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                     0x800000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                           23
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                   0x400000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                         22
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                   0xfffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                         0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_ADDR(x)                                                  ((x) + 0x10b8)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_PHYS(x)                                                  ((x) + 0x10b8)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_OFFS                                                     (0x10b8)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_ADDR(x)                                                  ((x) + 0x10bc)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_PHYS(x)                                                  ((x) + 0x10bc)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_OFFS                                                     (0x10bc)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                              0x100
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                  8
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_ADDR(x)                                                      ((x) + 0x10c0)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_PHYS(x)                                                      ((x) + 0x10c0)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_OFFS                                                         (0x10c0)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MSI2_DATA_VALUE_SHFT                                                            0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x)                                                ((x) + 0x10d0)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_PHYS(x)                                                ((x) + 0x10d0)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_OFFS                                                   (0x10d0)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_RMSK                                                       0xffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_POR                                                    0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_ATTR                                                                0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                    0xffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                         0

#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_ADDR(x)                                                         ((x) + 0x10d4)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_PHYS(x)                                                         ((x) + 0x10d4)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_OFFS                                                            (0x10d4)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_RMSK                                                            0xffff003f
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_ATTR                                                                         0x3
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                   0xffff0000
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                           16
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                          0x3f
#define HWIO_WBM_R0_WBM2SW5_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                             0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_ADDR(x)                                                       ((x) + 0x10d8)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_PHYS(x)                                                       ((x) + 0x10d8)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_OFFS                                                          (0x10d8)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_ADDR(x)                                                       ((x) + 0x10dc)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_PHYS(x)                                                       ((x) + 0x10dc)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_OFFS                                                          (0x10dc)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_RMSK                                                           0xfffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_RING_SIZE_BMSK                                                 0xfffff00
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_RING_SIZE_SHFT                                                         8
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                             0xff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_ADDR(x)                                                             ((x) + 0x10e0)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_PHYS(x)                                                             ((x) + 0x10e0)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_OFFS                                                                (0x10e0)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_RMSK                                                                    0xffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_POR                                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_ATTR                                                                             0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_RING_ID_BMSK                                                            0xff00
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_RING_ID_SHFT                                                                 8
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_ENTRY_SIZE_BMSK                                                           0xff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_ID_ENTRY_SIZE_SHFT                                                              0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_STATUS_ADDR(x)                                                         ((x) + 0x10e4)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_STATUS_PHYS(x)                                                         ((x) + 0x10e4)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_STATUS_OFFS                                                            (0x10e4)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_STATUS_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_STATUS_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_STATUS_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_STATUS_ATTR                                                                         0x1
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                            0xffff0000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                    16
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_STATUS_NUM_VALID_WORDS_BMSK                                                0xffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_STATUS_NUM_VALID_WORDS_SHFT                                                     0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_ADDR(x)                                                           ((x) + 0x10e8)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_PHYS(x)                                                           ((x) + 0x10e8)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_OFFS                                                              (0x10e8)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_RMSK                                                               0x7ffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_POR                                                               0x00000080
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_ATTR                                                                           0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                       0x4000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                              26
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_LOOP_CNT_BMSK                                                      0x3c00000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_LOOP_CNT_SHFT                                                             22
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_SPARE_CONTROL_BMSK                                                  0x3fc000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_SPARE_CONTROL_SHFT                                                        14
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_SRNG_SM_STATE2_BMSK                                                   0x3000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_SRNG_SM_STATE2_SHFT                                                       12
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_SRNG_SM_STATE1_BMSK                                                    0xf00
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_SRNG_SM_STATE1_SHFT                                                        8
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_SRNG_IS_IDLE_BMSK                                                       0x80
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_SRNG_IS_IDLE_SHFT                                                          7
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_SRNG_ENABLE_BMSK                                                        0x40
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_SRNG_ENABLE_SHFT                                                           6
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                  0x20
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                     5
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                   0x10
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                      4
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_MSI_SWAP_BIT_BMSK                                                        0x8
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_MSI_SWAP_BIT_SHFT                                                          3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_SECURITY_BIT_BMSK                                                        0x4
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_SECURITY_BIT_SHFT                                                          2
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_LOOPCNT_DISABLE_BMSK                                                     0x2
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_LOOPCNT_DISABLE_SHFT                                                       1
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_RING_ID_DISABLE_BMSK                                                     0x1
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_RING_ID_DISABLE_SHFT                                                       0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_ADDR(x)                                                    ((x) + 0x10ec)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_PHYS(x)                                                    ((x) + 0x10ec)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_OFFS                                                       (0x10ec)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                  0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                           0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_ADDR(x)                                                    ((x) + 0x10f0)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_PHYS(x)                                                    ((x) + 0x10f0)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_OFFS                                                       (0x10f0)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_RMSK                                                             0xff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                        0xff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                           0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x)                                             ((x) + 0x10fc)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_PHYS(x)                                             ((x) + 0x10fc)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_OFFS                                                (0x10fc)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_RMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_POR                                                 0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_ATTR                                                             0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x)                                            ((x) + 0x1100)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_PHYS(x)                                            ((x) + 0x1100)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_OFFS                                               (0x1100)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_POR                                                0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_ATTR                                                            0x1
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                 0xffff0000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                         16
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                         0x8000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                             15
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                      0x7fff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                           0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                          ((x) + 0x1104)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                          ((x) + 0x1104)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_OFFS                                             (0x1104)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_RMSK                                                  0x3ff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_POR                                              0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_ATTR                                                          0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                0x3ff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                    0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_ADDR(x)                                                  ((x) + 0x1120)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_PHYS(x)                                                  ((x) + 0x1120)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_OFFS                                                     (0x1120)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_ADDR(x)                                                  ((x) + 0x1124)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_PHYS(x)                                                  ((x) + 0x1124)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_OFFS                                                     (0x1124)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                              0x100
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                  8
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_ADDR(x)                                                      ((x) + 0x1128)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_PHYS(x)                                                      ((x) + 0x1128)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_OFFS                                                         (0x1128)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI1_DATA_VALUE_SHFT                                                            0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x)                                            ((x) + 0x112c)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_PHYS(x)                                            ((x) + 0x112c)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_OFFS                                               (0x112c)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_RMSK                                               0xffcfffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_POR                                                0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_ATTR                                                            0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                    0xff000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                            24
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                     0x800000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                           23
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                   0x400000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                         22
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                   0xfffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                         0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_ADDR(x)                                                  ((x) + 0x1130)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_PHYS(x)                                                  ((x) + 0x1130)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_OFFS                                                     (0x1130)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_ADDR(x)                                                  ((x) + 0x1134)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_PHYS(x)                                                  ((x) + 0x1134)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_OFFS                                                     (0x1134)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                              0x100
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                  8
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_ADDR(x)                                                      ((x) + 0x1138)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_PHYS(x)                                                      ((x) + 0x1138)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_OFFS                                                         (0x1138)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MSI2_DATA_VALUE_SHFT                                                            0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x)                                                ((x) + 0x1148)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_PHYS(x)                                                ((x) + 0x1148)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_OFFS                                                   (0x1148)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_RMSK                                                       0xffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_POR                                                    0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_ATTR                                                                0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                    0xffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                         0

#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_ADDR(x)                                                         ((x) + 0x114c)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_PHYS(x)                                                         ((x) + 0x114c)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_OFFS                                                            (0x114c)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_RMSK                                                            0xffff003f
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_ATTR                                                                         0x3
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                   0xffff0000
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                           16
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                          0x3f
#define HWIO_WBM_R0_WBM2SW6_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                             0

#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_LSB_ADDR(x)                                                     ((x) + 0x1150)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_LSB_PHYS(x)                                                     ((x) + 0x1150)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_LSB_OFFS                                                        (0x1150)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_LSB_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_LSB_POR                                                         0x00000000
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_LSB_POR_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_LSB_ATTR                                                                     0x3
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                     0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                              0

#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_MSB_ADDR(x)                                                     ((x) + 0x1154)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_MSB_PHYS(x)                                                     ((x) + 0x1154)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_MSB_OFFS                                                        (0x1154)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_MSB_RMSK                                                         0xfffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_MSB_POR                                                         0x00000000
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_MSB_POR_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_MSB_ATTR                                                                     0x3
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_MSB_RING_SIZE_BMSK                                               0xfffff00
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_MSB_RING_SIZE_SHFT                                                       8
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                           0xff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                              0

#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_ID_ADDR(x)                                                           ((x) + 0x1158)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_ID_PHYS(x)                                                           ((x) + 0x1158)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_ID_OFFS                                                              (0x1158)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_ID_RMSK                                                                  0xffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_ID_POR                                                               0x00000000
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_ID_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_ID_ATTR                                                                           0x3
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_ID_ADDR(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_ID_IN(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_ID_RING_ID_BMSK                                                          0xff00
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_ID_RING_ID_SHFT                                                               8
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_ID_ENTRY_SIZE_BMSK                                                         0xff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_ID_ENTRY_SIZE_SHFT                                                            0

#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_STATUS_ADDR(x)                                                       ((x) + 0x115c)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_STATUS_PHYS(x)                                                       ((x) + 0x115c)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_STATUS_OFFS                                                          (0x115c)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_STATUS_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_STATUS_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_STATUS_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_STATUS_ATTR                                                                       0x1
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                          0xffff0000
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                  16
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_STATUS_NUM_VALID_WORDS_BMSK                                              0xffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_STATUS_NUM_VALID_WORDS_SHFT                                                   0

#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_ADDR(x)                                                         ((x) + 0x1160)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_PHYS(x)                                                         ((x) + 0x1160)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_OFFS                                                            (0x1160)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_RMSK                                                             0x7ffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_POR                                                             0x00000080
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_ATTR                                                                         0x3
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_IN(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                     0x4000000
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                            26
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_LOOP_CNT_BMSK                                                    0x3c00000
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_LOOP_CNT_SHFT                                                           22
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_SPARE_CONTROL_BMSK                                                0x3fc000
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_SPARE_CONTROL_SHFT                                                      14
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_SRNG_SM_STATE2_BMSK                                                 0x3000
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_SRNG_SM_STATE2_SHFT                                                     12
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_SRNG_SM_STATE1_BMSK                                                  0xf00
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_SRNG_SM_STATE1_SHFT                                                      8
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_SRNG_IS_IDLE_BMSK                                                     0x80
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_SRNG_IS_IDLE_SHFT                                                        7
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_SRNG_ENABLE_BMSK                                                      0x40
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_SRNG_ENABLE_SHFT                                                         6
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                0x20
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                   5
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                 0x10
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                    4
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_MSI_SWAP_BIT_BMSK                                                      0x8
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_MSI_SWAP_BIT_SHFT                                                        3
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_SECURITY_BIT_BMSK                                                      0x4
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_SECURITY_BIT_SHFT                                                        2
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_LOOPCNT_DISABLE_BMSK                                                   0x2
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_LOOPCNT_DISABLE_SHFT                                                     1
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_RING_ID_DISABLE_BMSK                                                   0x1
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_RING_ID_DISABLE_SHFT                                                     0

#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_LSB_ADDR(x)                                                  ((x) + 0x1164)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_LSB_PHYS(x)                                                  ((x) + 0x1164)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_LSB_OFFS                                                     (0x1164)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_LSB_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_LSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_LSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                         0

#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_MSB_ADDR(x)                                                  ((x) + 0x1168)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_MSB_PHYS(x)                                                  ((x) + 0x1168)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_MSB_OFFS                                                     (0x1168)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_MSB_RMSK                                                           0xff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_MSB_POR                                                      0x00000000
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_MSB_ATTR                                                                  0x3
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                      0xff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                         0

#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x)                                           ((x) + 0x1174)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_SETUP_PHYS(x)                                           ((x) + 0x1174)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_SETUP_OFFS                                              (0x1174)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_SETUP_RMSK                                              0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_SETUP_POR                                               0x00000000
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_SETUP_POR_RMSK                                          0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_SETUP_ATTR                                                           0x3
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                    0xffff0000
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                            16
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                0x8000
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                    15
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                          0x7fff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                               0

#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x)                                          ((x) + 0x1178)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_STATUS_PHYS(x)                                          ((x) + 0x1178)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_STATUS_OFFS                                             (0x1178)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_STATUS_RMSK                                             0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_STATUS_POR                                              0x00000000
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_STATUS_POR_RMSK                                         0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_STATUS_ATTR                                                          0x1
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK               0xffff0000
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                       16
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                       0x8000
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                           15
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                    0x7fff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                         0

#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                        ((x) + 0x117c)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                        ((x) + 0x117c)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_FULL_COUNTER_OFFS                                           (0x117c)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_FULL_COUNTER_RMSK                                                0x3ff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_FULL_COUNTER_POR                                            0x00000000
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                       0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_FULL_COUNTER_ATTR                                                        0x3
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                              0x3ff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                  0

#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_LSB_ADDR(x)                                                ((x) + 0x1198)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_LSB_PHYS(x)                                                ((x) + 0x1198)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_LSB_OFFS                                                   (0x1198)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_LSB_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_LSB_POR                                                    0x00000000
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_LSB_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_LSB_ATTR                                                                0x3
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_LSB_ADDR_BMSK                                              0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_LSB_ADDR_SHFT                                                       0

#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_MSB_ADDR(x)                                                ((x) + 0x119c)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_MSB_PHYS(x)                                                ((x) + 0x119c)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_MSB_OFFS                                                   (0x119c)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_MSB_RMSK                                                        0x1ff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_MSB_POR                                                    0x00000000
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_MSB_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_MSB_ATTR                                                                0x3
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                            0x100
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                8
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_MSB_ADDR_BMSK                                                    0xff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_BASE_MSB_ADDR_SHFT                                                       0

#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_DATA_ADDR(x)                                                    ((x) + 0x11a0)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_DATA_PHYS(x)                                                    ((x) + 0x11a0)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_DATA_OFFS                                                       (0x11a0)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_DATA_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_DATA_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_DATA_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_DATA_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_DATA_VALUE_BMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI1_DATA_VALUE_SHFT                                                          0

#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x)                                          ((x) + 0x11a4)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT2_SETUP_PHYS(x)                                          ((x) + 0x11a4)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT2_SETUP_OFFS                                             (0x11a4)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT2_SETUP_RMSK                                             0xffcfffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT2_SETUP_POR                                              0x00000000
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT2_SETUP_POR_RMSK                                         0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT2_SETUP_ATTR                                                          0x3
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                  0xff000000
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                          24
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                   0x800000
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                         23
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                 0x400000
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                       22
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                 0xfffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                       0

#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_LSB_ADDR(x)                                                ((x) + 0x11a8)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_LSB_PHYS(x)                                                ((x) + 0x11a8)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_LSB_OFFS                                                   (0x11a8)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_LSB_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_LSB_POR                                                    0x00000000
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_LSB_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_LSB_ATTR                                                                0x3
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_LSB_ADDR_BMSK                                              0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_LSB_ADDR_SHFT                                                       0

#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_MSB_ADDR(x)                                                ((x) + 0x11ac)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_MSB_PHYS(x)                                                ((x) + 0x11ac)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_MSB_OFFS                                                   (0x11ac)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_MSB_RMSK                                                        0x1ff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_MSB_POR                                                    0x00000000
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_MSB_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_MSB_ATTR                                                                0x3
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                            0x100
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                8
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_MSB_ADDR_BMSK                                                    0xff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_BASE_MSB_ADDR_SHFT                                                       0

#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_DATA_ADDR(x)                                                    ((x) + 0x11b0)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_DATA_PHYS(x)                                                    ((x) + 0x11b0)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_DATA_OFFS                                                       (0x11b0)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_DATA_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_DATA_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_DATA_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_DATA_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_DATA_IN(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_DATA_VALUE_BMSK                                                 0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MSI2_DATA_VALUE_SHFT                                                          0

#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x)                                              ((x) + 0x11c0)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_TP_SW_OFFSET_PHYS(x)                                              ((x) + 0x11c0)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_TP_SW_OFFSET_OFFS                                                 (0x11c0)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_TP_SW_OFFSET_RMSK                                                     0xffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_TP_SW_OFFSET_POR                                                  0x00000000
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_TP_SW_OFFSET_POR_RMSK                                             0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_TP_SW_OFFSET_ATTR                                                              0x3
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                  0xffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                       0

#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_1_ADDR(x)                                                       ((x) + 0x11c4)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_1_PHYS(x)                                                       ((x) + 0x11c4)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_1_OFFS                                                          (0x11c4)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_1_RMSK                                                          0xffff003f
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_1_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_1_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_1_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                 0xffff0000
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                         16
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                        0x3f
#define HWIO_WBM_R0_WBM_ERROR_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                           0

#define HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_LSB_ADDR(x)                                                           ((x) + 0x11c8)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_LSB_PHYS(x)                                                           ((x) + 0x11c8)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_LSB_OFFS                                                              (0x11c8)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_LSB_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_LSB_POR                                                               0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_LSB_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_LSB_ATTR                                                                           0x3
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                    0

#define HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_MSB_ADDR(x)                                                           ((x) + 0x11cc)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_MSB_PHYS(x)                                                           ((x) + 0x11cc)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_MSB_OFFS                                                              (0x11cc)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_MSB_RMSK                                                                0xffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_MSB_POR                                                               0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_MSB_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_MSB_ATTR                                                                           0x3
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_MSB_RING_SIZE_BMSK                                                      0xffff00
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_MSB_RING_SIZE_SHFT                                                             8
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                 0xff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                    0

#define HWIO_WBM_R0_WBM2WBM_IN1_RING_ID_ADDR(x)                                                                 ((x) + 0x11d0)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_ID_PHYS(x)                                                                 ((x) + 0x11d0)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_ID_OFFS                                                                    (0x11d0)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_ID_RMSK                                                                          0xff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_ID_POR                                                                     0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_ID_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_ID_ATTR                                                                                 0x3
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_ID_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN1_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN1_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN1_RING_ID_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_ID_ENTRY_SIZE_BMSK                                                               0xff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_ID_ENTRY_SIZE_SHFT                                                                  0

#define HWIO_WBM_R0_WBM2WBM_IN1_RING_STATUS_ADDR(x)                                                             ((x) + 0x11d4)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_STATUS_PHYS(x)                                                             ((x) + 0x11d4)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_STATUS_OFFS                                                                (0x11d4)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_STATUS_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_STATUS_POR                                                                 0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_STATUS_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_STATUS_ATTR                                                                             0x1
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN1_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                0xffff0000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                        16
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_STATUS_NUM_VALID_WORDS_BMSK                                                    0xffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_STATUS_NUM_VALID_WORDS_SHFT                                                         0

#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_ADDR(x)                                                               ((x) + 0x11d8)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_PHYS(x)                                                               ((x) + 0x11d8)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_OFFS                                                                  (0x11d8)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_RMSK                                                                    0x3fffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_POR                                                                   0x00000080
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_ATTR                                                                               0x3
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_SPARE_CONTROL_BMSK                                                      0x3fc000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_SPARE_CONTROL_SHFT                                                            14
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_SRNG_SM_STATE2_BMSK                                                       0x3000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_SRNG_SM_STATE2_SHFT                                                           12
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_SRNG_SM_STATE1_BMSK                                                        0xf00
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_SRNG_SM_STATE1_SHFT                                                            8
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_SRNG_IS_IDLE_BMSK                                                           0x80
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_SRNG_IS_IDLE_SHFT                                                              7
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_SRNG_ENABLE_BMSK                                                            0x40
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_SRNG_ENABLE_SHFT                                                               6
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                      0x20
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                         5
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                       0x10
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                          4
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_MSI_SWAP_BIT_BMSK                                                            0x8
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_MSI_SWAP_BIT_SHFT                                                              3
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_SECURITY_BIT_BMSK                                                            0x4
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_SECURITY_BIT_SHFT                                                              2
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_LOOPCNT_DISABLE_BMSK                                                         0x2
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_LOOPCNT_DISABLE_SHFT                                                           1
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_RING_ID_DISABLE_BMSK                                                         0x1
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_RING_ID_DISABLE_SHFT                                                           0

#define HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_LSB_ADDR(x)                                                        ((x) + 0x11e4)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_LSB_PHYS(x)                                                        ((x) + 0x11e4)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_LSB_OFFS                                                           (0x11e4)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_LSB_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_LSB_POR                                                            0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_LSB_POR_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_LSB_ATTR                                                                        0x3
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                      0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                               0

#define HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_MSB_ADDR(x)                                                        ((x) + 0x11e8)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_MSB_PHYS(x)                                                        ((x) + 0x11e8)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_MSB_OFFS                                                           (0x11e8)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_MSB_RMSK                                                                 0xff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_MSB_POR                                                            0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_MSB_POR_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_MSB_ATTR                                                                        0x3
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                            0xff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                               0

#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                             ((x) + 0x11f8)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                             ((x) + 0x11f8)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                (0x11f8)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX0_POR                                                 0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                             0x3
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                             ((x) + 0x11fc)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                             ((x) + 0x11fc)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                (0x11fc)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                    0xffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX1_POR                                                 0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                             0x3
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                      0xffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                           0

#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_STATUS_ADDR(x)                                                ((x) + 0x1200)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_STATUS_PHYS(x)                                                ((x) + 0x1200)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_STATUS_OFFS                                                   (0x1200)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_STATUS_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_STATUS_POR                                                    0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_STATUS_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_STATUS_ATTR                                                                0x1
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                     0xffff0000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                             16
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                0x8000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                    15
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                          0x7fff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                               0

#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                             ((x) + 0x1204)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                             ((x) + 0x1204)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                (0x1204)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                     0x3ff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_EMPTY_COUNTER_POR                                                 0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                             0x3
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                  0x3ff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                      0

#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                            ((x) + 0x1208)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                            ((x) + 0x1208)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_TIMER_OFFS                                               (0x1208)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                      0x7
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_TIMER_POR                                                0x00000003
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                            0x3
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                 0x7
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                   0

#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                           ((x) + 0x120c)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                           ((x) + 0x120c)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_STATUS_OFFS                                              (0x120c)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_STATUS_RMSK                                                0xffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_STATUS_POR                                               0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                          0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                           0x1
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                 0xff0000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                       16
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                                0xffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                     0

#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_LSB_ADDR(x)                                                      ((x) + 0x1210)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_LSB_PHYS(x)                                                      ((x) + 0x1210)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_LSB_OFFS                                                         (0x1210)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_LSB_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_LSB_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_LSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_LSB_ADDR_BMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_LSB_ADDR_SHFT                                                             0

#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_MSB_ADDR(x)                                                      ((x) + 0x1214)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_MSB_PHYS(x)                                                      ((x) + 0x1214)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_MSB_OFFS                                                         (0x1214)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_MSB_RMSK                                                              0x1ff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_MSB_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_MSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                  0x100
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                      8
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_MSB_ADDR_BMSK                                                          0xff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_BASE_MSB_ADDR_SHFT                                                             0

#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_DATA_ADDR(x)                                                          ((x) + 0x1218)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_DATA_PHYS(x)                                                          ((x) + 0x1218)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_DATA_OFFS                                                             (0x1218)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_DATA_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_DATA_POR                                                              0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_DATA_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_DATA_ATTR                                                                          0x3
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_DATA_VALUE_BMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MSI1_DATA_VALUE_SHFT                                                                0

#define HWIO_WBM_R0_WBM2WBM_IN1_RING_HP_TP_SW_OFFSET_ADDR(x)                                                    ((x) + 0x1238)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_HP_TP_SW_OFFSET_PHYS(x)                                                    ((x) + 0x1238)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_HP_TP_SW_OFFSET_OFFS                                                       (0x1238)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_HP_TP_SW_OFFSET_RMSK                                                           0xffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_HP_TP_SW_OFFSET_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_HP_TP_SW_OFFSET_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_HP_TP_SW_OFFSET_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN1_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN1_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN1_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                        0xffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                             0

#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_ADDR(x)                                                       ((x) + 0x123c)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_PHYS(x)                                                       ((x) + 0x123c)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_OFFS                                                          (0x123c)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_TIME_THRESHOLD_TO_DOORBELL_BMSK                               0xffff0000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_TIME_THRESHOLD_TO_DOORBELL_SHFT                                       16
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_FETCH_SAME_POINTER_ERR_INT_REG_CLR_BMSK                           0x8000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_FETCH_SAME_POINTER_ERR_INT_REG_CLR_SHFT                               15
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_NUM_THRESHOLD_TO_DOORBELL_BMSK                                    0x7e00
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_NUM_THRESHOLD_TO_DOORBELL_SHFT                                         9
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_SRNG_SM_STATE3_BMSK                                                0x180
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_SRNG_SM_STATE3_SHFT                                                    7
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_INTERVAL_OF_FETCH_POINTER_BMSK                                      0x70
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_INTERVAL_OF_FETCH_POINTER_SHFT                                         4
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_FETCH_SAME_POINTER_THRESHOLD_BMSK                                    0xf
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_FETCH_SAME_POINTER_THRESHOLD_SHFT                                      0

#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_ADDR(x)                                        ((x) + 0x1240)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_PHYS(x)                                        ((x) + 0x1240)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_OFFS                                           (0x1240)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_RMSK                                               0xffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_POR                                            0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_POR_RMSK                                       0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_ATTR                                                        0x3
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_MESSAGE_BMSK                                       0xffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_MESSAGE_SHFT                                            0

#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ADDR(x)                                    ((x) + 0x1244)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_PHYS(x)                                    ((x) + 0x1244)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_OFFS                                       (0x1244)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_RMSK                                       0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_POR                                        0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_POR_RMSK                                   0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ATTR                                                    0x3
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_VALUE_BMSK                                 0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_VALUE_SHFT                                          0

#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ADDR(x)                                    ((x) + 0x1248)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_PHYS(x)                                    ((x) + 0x1248)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_OFFS                                       (0x1248)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_RMSK                                             0xff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_POR                                        0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_POR_RMSK                                   0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ATTR                                                    0x3
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_VALUE_BMSK                                       0xff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_VALUE_SHFT                                          0

#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_ADDR(x)                                     ((x) + 0x124c)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_PHYS(x)                                     ((x) + 0x124c)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_OFFS                                        (0x124c)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_RMSK                                        0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_POR                                         0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_POR_RMSK                                    0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_ATTR                                                     0x3
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_VALUE_BMSK                                  0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_VALUE_SHFT                                           0

#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_ADDR(x)                                     ((x) + 0x1250)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_PHYS(x)                                     ((x) + 0x1250)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_OFFS                                        (0x1250)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_RMSK                                              0xff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_POR                                         0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_POR_RMSK                                    0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_ATTR                                                     0x3
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_VALUE_BMSK                                        0xff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_VALUE_SHFT                                           0

#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_1_ADDR(x)                                                             ((x) + 0x1254)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_1_PHYS(x)                                                             ((x) + 0x1254)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_1_OFFS                                                                (0x1254)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_1_RMSK                                                                0xffff003f
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_1_POR                                                                 0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_1_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_1_ATTR                                                                             0x3
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                       0xffff0000
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                               16
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                              0x3f
#define HWIO_WBM_R0_WBM2WBM_IN1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                 0

#define HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_LSB_ADDR(x)                                                           ((x) + 0x1258)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_LSB_PHYS(x)                                                           ((x) + 0x1258)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_LSB_OFFS                                                              (0x1258)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_LSB_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_LSB_POR                                                               0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_LSB_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_LSB_ATTR                                                                           0x3
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                    0

#define HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_MSB_ADDR(x)                                                           ((x) + 0x125c)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_MSB_PHYS(x)                                                           ((x) + 0x125c)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_MSB_OFFS                                                              (0x125c)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_MSB_RMSK                                                                0xffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_MSB_POR                                                               0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_MSB_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_MSB_ATTR                                                                           0x3
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_MSB_RING_SIZE_BMSK                                                      0xffff00
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_MSB_RING_SIZE_SHFT                                                             8
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                 0xff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                    0

#define HWIO_WBM_R0_WBM2WBM_IN2_RING_ID_ADDR(x)                                                                 ((x) + 0x1260)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_ID_PHYS(x)                                                                 ((x) + 0x1260)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_ID_OFFS                                                                    (0x1260)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_ID_RMSK                                                                          0xff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_ID_POR                                                                     0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_ID_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_ID_ATTR                                                                                 0x3
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_ID_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN2_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN2_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN2_RING_ID_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_ID_ENTRY_SIZE_BMSK                                                               0xff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_ID_ENTRY_SIZE_SHFT                                                                  0

#define HWIO_WBM_R0_WBM2WBM_IN2_RING_STATUS_ADDR(x)                                                             ((x) + 0x1264)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_STATUS_PHYS(x)                                                             ((x) + 0x1264)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_STATUS_OFFS                                                                (0x1264)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_STATUS_RMSK                                                                0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_STATUS_POR                                                                 0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_STATUS_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_STATUS_ATTR                                                                             0x1
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN2_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                0xffff0000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                        16
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_STATUS_NUM_VALID_WORDS_BMSK                                                    0xffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_STATUS_NUM_VALID_WORDS_SHFT                                                         0

#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_ADDR(x)                                                               ((x) + 0x1268)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_PHYS(x)                                                               ((x) + 0x1268)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_OFFS                                                                  (0x1268)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_RMSK                                                                    0x3fffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_POR                                                                   0x00000080
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_ATTR                                                                               0x3
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_SPARE_CONTROL_BMSK                                                      0x3fc000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_SPARE_CONTROL_SHFT                                                            14
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_SRNG_SM_STATE2_BMSK                                                       0x3000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_SRNG_SM_STATE2_SHFT                                                           12
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_SRNG_SM_STATE1_BMSK                                                        0xf00
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_SRNG_SM_STATE1_SHFT                                                            8
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_SRNG_IS_IDLE_BMSK                                                           0x80
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_SRNG_IS_IDLE_SHFT                                                              7
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_SRNG_ENABLE_BMSK                                                            0x40
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_SRNG_ENABLE_SHFT                                                               6
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                      0x20
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                         5
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                       0x10
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                          4
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_MSI_SWAP_BIT_BMSK                                                            0x8
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_MSI_SWAP_BIT_SHFT                                                              3
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_SECURITY_BIT_BMSK                                                            0x4
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_SECURITY_BIT_SHFT                                                              2
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_LOOPCNT_DISABLE_BMSK                                                         0x2
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_LOOPCNT_DISABLE_SHFT                                                           1
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_RING_ID_DISABLE_BMSK                                                         0x1
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_RING_ID_DISABLE_SHFT                                                           0

#define HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_LSB_ADDR(x)                                                        ((x) + 0x1274)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_LSB_PHYS(x)                                                        ((x) + 0x1274)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_LSB_OFFS                                                           (0x1274)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_LSB_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_LSB_POR                                                            0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_LSB_POR_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_LSB_ATTR                                                                        0x3
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                      0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                               0

#define HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_MSB_ADDR(x)                                                        ((x) + 0x1278)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_MSB_PHYS(x)                                                        ((x) + 0x1278)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_MSB_OFFS                                                           (0x1278)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_MSB_RMSK                                                                 0xff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_MSB_POR                                                            0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_MSB_POR_RMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_MSB_ATTR                                                                        0x3
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                            0xff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                               0

#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                             ((x) + 0x1288)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                             ((x) + 0x1288)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                (0x1288)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX0_POR                                                 0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                             0x3
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                             ((x) + 0x128c)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                             ((x) + 0x128c)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                (0x128c)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                    0xffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX1_POR                                                 0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                             0x3
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                      0xffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                           0

#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_STATUS_ADDR(x)                                                ((x) + 0x1290)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_STATUS_PHYS(x)                                                ((x) + 0x1290)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_STATUS_OFFS                                                   (0x1290)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_STATUS_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_STATUS_POR                                                    0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_STATUS_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_STATUS_ATTR                                                                0x1
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                     0xffff0000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                             16
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                0x8000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                    15
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                          0x7fff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                               0

#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                             ((x) + 0x1294)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                             ((x) + 0x1294)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                (0x1294)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                     0x3ff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_EMPTY_COUNTER_POR                                                 0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                             0x3
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                  0x3ff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                      0

#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                            ((x) + 0x1298)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                            ((x) + 0x1298)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_TIMER_OFFS                                               (0x1298)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                      0x7
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_TIMER_POR                                                0x00000003
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                           0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                            0x3
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                 0x7
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                   0

#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                           ((x) + 0x129c)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                           ((x) + 0x129c)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_STATUS_OFFS                                              (0x129c)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_STATUS_RMSK                                                0xffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_STATUS_POR                                               0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                          0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                           0x1
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                 0xff0000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                       16
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                                0xffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                     0

#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_LSB_ADDR(x)                                                      ((x) + 0x12a0)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_LSB_PHYS(x)                                                      ((x) + 0x12a0)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_LSB_OFFS                                                         (0x12a0)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_LSB_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_LSB_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_LSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_LSB_ADDR_BMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_LSB_ADDR_SHFT                                                             0

#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_MSB_ADDR(x)                                                      ((x) + 0x12a4)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_MSB_PHYS(x)                                                      ((x) + 0x12a4)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_MSB_OFFS                                                         (0x12a4)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_MSB_RMSK                                                              0x1ff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_MSB_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_MSB_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                  0x100
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                      8
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_MSB_ADDR_BMSK                                                          0xff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_BASE_MSB_ADDR_SHFT                                                             0

#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_DATA_ADDR(x)                                                          ((x) + 0x12a8)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_DATA_PHYS(x)                                                          ((x) + 0x12a8)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_DATA_OFFS                                                             (0x12a8)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_DATA_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_DATA_POR                                                              0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_DATA_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_DATA_ATTR                                                                          0x3
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_DATA_VALUE_BMSK                                                       0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MSI1_DATA_VALUE_SHFT                                                                0

#define HWIO_WBM_R0_WBM2WBM_IN2_RING_HP_TP_SW_OFFSET_ADDR(x)                                                    ((x) + 0x12c8)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_HP_TP_SW_OFFSET_PHYS(x)                                                    ((x) + 0x12c8)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_HP_TP_SW_OFFSET_OFFS                                                       (0x12c8)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_HP_TP_SW_OFFSET_RMSK                                                           0xffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_HP_TP_SW_OFFSET_POR                                                        0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_HP_TP_SW_OFFSET_POR_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_HP_TP_SW_OFFSET_ATTR                                                                    0x3
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN2_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN2_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN2_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                        0xffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                             0

#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_ADDR(x)                                                       ((x) + 0x12cc)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_PHYS(x)                                                       ((x) + 0x12cc)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_OFFS                                                          (0x12cc)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_TIME_THRESHOLD_TO_DOORBELL_BMSK                               0xffff0000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_TIME_THRESHOLD_TO_DOORBELL_SHFT                                       16
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_FETCH_SAME_POINTER_ERR_INT_REG_CLR_BMSK                           0x8000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_FETCH_SAME_POINTER_ERR_INT_REG_CLR_SHFT                               15
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_NUM_THRESHOLD_TO_DOORBELL_BMSK                                    0x7e00
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_NUM_THRESHOLD_TO_DOORBELL_SHFT                                         9
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_SRNG_SM_STATE3_BMSK                                                0x180
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_SRNG_SM_STATE3_SHFT                                                    7
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_INTERVAL_OF_FETCH_POINTER_BMSK                                      0x70
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_INTERVAL_OF_FETCH_POINTER_SHFT                                         4
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_FETCH_SAME_POINTER_THRESHOLD_BMSK                                    0xf
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_FETCH_SAME_POINTER_THRESHOLD_SHFT                                      0

#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_ADDR(x)                                        ((x) + 0x12d0)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_PHYS(x)                                        ((x) + 0x12d0)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_OFFS                                           (0x12d0)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_RMSK                                               0xffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_POR                                            0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_POR_RMSK                                       0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_ATTR                                                        0x3
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_MESSAGE_BMSK                                       0xffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_MESSAGE_SHFT                                            0

#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ADDR(x)                                    ((x) + 0x12d4)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_PHYS(x)                                    ((x) + 0x12d4)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_OFFS                                       (0x12d4)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_RMSK                                       0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_POR                                        0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_POR_RMSK                                   0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ATTR                                                    0x3
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_VALUE_BMSK                                 0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_VALUE_SHFT                                          0

#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ADDR(x)                                    ((x) + 0x12d8)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_PHYS(x)                                    ((x) + 0x12d8)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_OFFS                                       (0x12d8)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_RMSK                                             0xff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_POR                                        0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_POR_RMSK                                   0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ATTR                                                    0x3
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_VALUE_BMSK                                       0xff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_VALUE_SHFT                                          0

#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_ADDR(x)                                     ((x) + 0x12dc)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_PHYS(x)                                     ((x) + 0x12dc)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_OFFS                                        (0x12dc)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_RMSK                                        0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_POR                                         0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_POR_RMSK                                    0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_ATTR                                                     0x3
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_VALUE_BMSK                                  0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_VALUE_SHFT                                           0

#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_ADDR(x)                                     ((x) + 0x12e0)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_PHYS(x)                                     ((x) + 0x12e0)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_OFFS                                        (0x12e0)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_RMSK                                              0xff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_POR                                         0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_POR_RMSK                                    0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_ATTR                                                     0x3
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_VALUE_BMSK                                        0xff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_VALUE_SHFT                                           0

#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_1_ADDR(x)                                                             ((x) + 0x12e4)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_1_PHYS(x)                                                             ((x) + 0x12e4)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_1_OFFS                                                                (0x12e4)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_1_RMSK                                                                0xffff003f
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_1_POR                                                                 0x00000000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_1_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_1_ATTR                                                                             0x3
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                       0xffff0000
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                               16
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                              0x3f
#define HWIO_WBM_R0_WBM2WBM_IN2_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                 0

#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_LSB_ADDR(x)                                                          ((x) + 0x12e8)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_LSB_PHYS(x)                                                          ((x) + 0x12e8)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_LSB_OFFS                                                             (0x12e8)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_LSB_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_LSB_POR                                                              0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_LSB_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_LSB_ATTR                                                                          0x3
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                          0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                   0

#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_MSB_ADDR(x)                                                          ((x) + 0x12ec)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_MSB_PHYS(x)                                                          ((x) + 0x12ec)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_MSB_OFFS                                                             (0x12ec)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_MSB_RMSK                                                               0xffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_MSB_POR                                                              0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_MSB_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_MSB_ATTR                                                                          0x3
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_MSB_RING_SIZE_BMSK                                                     0xffff00
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_MSB_RING_SIZE_SHFT                                                            8
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                0xff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                   0

#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_ID_ADDR(x)                                                                ((x) + 0x12f0)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_ID_PHYS(x)                                                                ((x) + 0x12f0)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_ID_OFFS                                                                   (0x12f0)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_ID_RMSK                                                                       0xffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_ID_POR                                                                    0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_ID_POR_RMSK                                                               0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_ID_ATTR                                                                                0x3
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_ID_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT1_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT1_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT1_RING_ID_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_ID_RING_ID_BMSK                                                               0xff00
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_ID_RING_ID_SHFT                                                                    8
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_ID_ENTRY_SIZE_BMSK                                                              0xff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_ID_ENTRY_SIZE_SHFT                                                                 0

#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_STATUS_ADDR(x)                                                            ((x) + 0x12f4)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_STATUS_PHYS(x)                                                            ((x) + 0x12f4)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_STATUS_OFFS                                                               (0x12f4)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_STATUS_RMSK                                                               0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_STATUS_POR                                                                0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_STATUS_POR_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_STATUS_ATTR                                                                            0x1
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT1_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                               0xffff0000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                       16
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_STATUS_NUM_VALID_WORDS_BMSK                                                   0xffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_STATUS_NUM_VALID_WORDS_SHFT                                                        0

#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_ADDR(x)                                                              ((x) + 0x12f8)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_PHYS(x)                                                              ((x) + 0x12f8)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_OFFS                                                                 (0x12f8)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_RMSK                                                                  0x7ffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_POR                                                                  0x00000080
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_POR_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_ATTR                                                                              0x3
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                          0x4000000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                 26
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_LOOP_CNT_BMSK                                                         0x3c00000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_LOOP_CNT_SHFT                                                                22
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_SPARE_CONTROL_BMSK                                                     0x3fc000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_SPARE_CONTROL_SHFT                                                           14
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_SRNG_SM_STATE2_BMSK                                                      0x3000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_SRNG_SM_STATE2_SHFT                                                          12
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_SRNG_SM_STATE1_BMSK                                                       0xf00
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_SRNG_SM_STATE1_SHFT                                                           8
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_SRNG_IS_IDLE_BMSK                                                          0x80
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_SRNG_IS_IDLE_SHFT                                                             7
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_SRNG_ENABLE_BMSK                                                           0x40
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_SRNG_ENABLE_SHFT                                                              6
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                     0x20
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                        5
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                      0x10
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                         4
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_MSI_SWAP_BIT_BMSK                                                           0x8
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_MSI_SWAP_BIT_SHFT                                                             3
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_SECURITY_BIT_BMSK                                                           0x4
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_SECURITY_BIT_SHFT                                                             2
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_LOOPCNT_DISABLE_BMSK                                                        0x2
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_LOOPCNT_DISABLE_SHFT                                                          1
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_RING_ID_DISABLE_BMSK                                                        0x1
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_RING_ID_DISABLE_SHFT                                                          0

#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_LSB_ADDR(x)                                                       ((x) + 0x12fc)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_LSB_PHYS(x)                                                       ((x) + 0x12fc)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_LSB_OFFS                                                          (0x12fc)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_LSB_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_LSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_LSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                     0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                              0

#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_MSB_ADDR(x)                                                       ((x) + 0x1300)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_MSB_PHYS(x)                                                       ((x) + 0x1300)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_MSB_OFFS                                                          (0x1300)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_MSB_RMSK                                                                0xff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_MSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_MSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                           0xff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                              0

#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_SETUP_ADDR(x)                                                ((x) + 0x130c)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_SETUP_PHYS(x)                                                ((x) + 0x130c)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_SETUP_OFFS                                                   (0x130c)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_SETUP_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_SETUP_POR                                                    0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_SETUP_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_SETUP_ATTR                                                                0x3
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                         0xffff0000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                 16
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                     0x8000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                         15
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                               0x7fff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                    0

#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_STATUS_ADDR(x)                                               ((x) + 0x1310)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_STATUS_PHYS(x)                                               ((x) + 0x1310)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_STATUS_OFFS                                                  (0x1310)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_STATUS_RMSK                                                  0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_STATUS_POR                                                   0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_STATUS_POR_RMSK                                              0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_STATUS_ATTR                                                               0x1
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                    0xffff0000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                            16
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                            0x8000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                15
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                         0x7fff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                              0

#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                             ((x) + 0x1314)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                             ((x) + 0x1314)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_FULL_COUNTER_OFFS                                                (0x1314)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_FULL_COUNTER_RMSK                                                     0x3ff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_FULL_COUNTER_POR                                                 0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_FULL_COUNTER_ATTR                                                             0x3
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                   0x3ff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                       0

#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_LSB_ADDR(x)                                                     ((x) + 0x1330)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_LSB_PHYS(x)                                                     ((x) + 0x1330)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_LSB_OFFS                                                        (0x1330)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_LSB_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_LSB_POR                                                         0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_LSB_POR_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_LSB_ATTR                                                                     0x3
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_LSB_ADDR_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_LSB_ADDR_SHFT                                                            0

#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_MSB_ADDR(x)                                                     ((x) + 0x1334)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_MSB_PHYS(x)                                                     ((x) + 0x1334)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_MSB_OFFS                                                        (0x1334)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_MSB_RMSK                                                             0x1ff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_MSB_POR                                                         0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_MSB_POR_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_MSB_ATTR                                                                     0x3
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                 0x100
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                     8
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_MSB_ADDR_BMSK                                                         0xff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_BASE_MSB_ADDR_SHFT                                                            0

#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_DATA_ADDR(x)                                                         ((x) + 0x1338)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_DATA_PHYS(x)                                                         ((x) + 0x1338)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_DATA_OFFS                                                            (0x1338)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_DATA_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_DATA_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_DATA_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_DATA_ATTR                                                                         0x3
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_DATA_VALUE_BMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI1_DATA_VALUE_SHFT                                                               0

#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT2_SETUP_ADDR(x)                                               ((x) + 0x133c)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT2_SETUP_PHYS(x)                                               ((x) + 0x133c)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT2_SETUP_OFFS                                                  (0x133c)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT2_SETUP_RMSK                                                  0xffc0ffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT2_SETUP_POR                                                   0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT2_SETUP_POR_RMSK                                              0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT2_SETUP_ATTR                                                               0x3
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                       0xff000000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                               24
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                        0x800000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                              23
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                      0x400000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                            22
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                       0xffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                            0

#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_LSB_ADDR(x)                                                     ((x) + 0x1340)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_LSB_PHYS(x)                                                     ((x) + 0x1340)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_LSB_OFFS                                                        (0x1340)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_LSB_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_LSB_POR                                                         0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_LSB_POR_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_LSB_ATTR                                                                     0x3
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_LSB_ADDR_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_LSB_ADDR_SHFT                                                            0

#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_MSB_ADDR(x)                                                     ((x) + 0x1344)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_MSB_PHYS(x)                                                     ((x) + 0x1344)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_MSB_OFFS                                                        (0x1344)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_MSB_RMSK                                                             0x1ff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_MSB_POR                                                         0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_MSB_POR_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_MSB_ATTR                                                                     0x3
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                 0x100
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                     8
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_MSB_ADDR_BMSK                                                         0xff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_BASE_MSB_ADDR_SHFT                                                            0

#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_DATA_ADDR(x)                                                         ((x) + 0x1348)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_DATA_PHYS(x)                                                         ((x) + 0x1348)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_DATA_OFFS                                                            (0x1348)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_DATA_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_DATA_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_DATA_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_DATA_ATTR                                                                         0x3
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_DATA_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_DATA_VALUE_BMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MSI2_DATA_VALUE_SHFT                                                               0

#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_TP_SW_OFFSET_ADDR(x)                                                   ((x) + 0x1358)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_TP_SW_OFFSET_PHYS(x)                                                   ((x) + 0x1358)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_TP_SW_OFFSET_OFFS                                                      (0x1358)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_TP_SW_OFFSET_RMSK                                                          0xffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_TP_SW_OFFSET_POR                                                       0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_TP_SW_OFFSET_POR_RMSK                                                  0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_TP_SW_OFFSET_ATTR                                                                   0x3
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                       0xffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                            0

#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_ADDR(x)                                                      ((x) + 0x135c)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_PHYS(x)                                                      ((x) + 0x135c)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_OFFS                                                         (0x135c)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_TIME_THRESHOLD_TO_DOORBELL_BMSK                              0xffff0000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_TIME_THRESHOLD_TO_DOORBELL_SHFT                                      16
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_FETCH_SAME_POINTER_ERR_INT_REG_CLR_BMSK                          0x8000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_FETCH_SAME_POINTER_ERR_INT_REG_CLR_SHFT                              15
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_NUM_THRESHOLD_TO_DOORBELL_BMSK                                   0x7e00
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_NUM_THRESHOLD_TO_DOORBELL_SHFT                                        9
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_SRNG_SM_STATE3_BMSK                                               0x180
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_SRNG_SM_STATE3_SHFT                                                   7
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_INTERVAL_OF_FETCH_POINTER_BMSK                                     0x70
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_INTERVAL_OF_FETCH_POINTER_SHFT                                        4
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_FETCH_SAME_POINTER_THRESHOLD_BMSK                                   0xf
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_FETCH_SAME_POINTER_THRESHOLD_SHFT                                     0

#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_ADDR(x)                                       ((x) + 0x1360)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_PHYS(x)                                       ((x) + 0x1360)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_OFFS                                          (0x1360)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_RMSK                                              0xffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_POR                                           0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_POR_RMSK                                      0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_ATTR                                                       0x3
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_MESSAGE_BMSK                                      0xffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_MESSAGE_SHFT                                           0

#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_ADDR(x)                                   ((x) + 0x1364)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_PHYS(x)                                   ((x) + 0x1364)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_OFFS                                      (0x1364)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_RMSK                                      0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_POR                                       0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_POR_RMSK                                  0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_ATTR                                                   0x3
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_VALUE_BMSK                                0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_VALUE_SHFT                                         0

#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_ADDR(x)                                   ((x) + 0x1368)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_PHYS(x)                                   ((x) + 0x1368)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_OFFS                                      (0x1368)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_RMSK                                            0xff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_POR                                       0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_POR_RMSK                                  0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_ATTR                                                   0x3
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_VALUE_BMSK                                      0xff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_VALUE_SHFT                                         0

#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_ADDR(x)                                    ((x) + 0x136c)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_PHYS(x)                                    ((x) + 0x136c)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_OFFS                                       (0x136c)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_RMSK                                       0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_POR                                        0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_POR_RMSK                                   0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_ATTR                                                    0x3
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_VALUE_BMSK                                 0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_VALUE_SHFT                                          0

#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_ADDR(x)                                    ((x) + 0x1370)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_PHYS(x)                                    ((x) + 0x1370)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_OFFS                                       (0x1370)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_RMSK                                             0xff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_POR                                        0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_POR_RMSK                                   0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_ATTR                                                    0x3
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_VALUE_BMSK                                       0xff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_VALUE_SHFT                                          0

#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_1_ADDR(x)                                                            ((x) + 0x1374)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_1_PHYS(x)                                                            ((x) + 0x1374)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_1_OFFS                                                               (0x1374)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_1_RMSK                                                               0xffff003f
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_1_POR                                                                0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_1_POR_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_1_ATTR                                                                            0x3
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                      0xffff0000
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                              16
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                             0x3f
#define HWIO_WBM_R0_WBM2WBM_OUT1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                0

#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_LSB_ADDR(x)                                                          ((x) + 0x1378)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_LSB_PHYS(x)                                                          ((x) + 0x1378)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_LSB_OFFS                                                             (0x1378)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_LSB_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_LSB_POR                                                              0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_LSB_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_LSB_ATTR                                                                          0x3
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                          0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                   0

#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_MSB_ADDR(x)                                                          ((x) + 0x137c)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_MSB_PHYS(x)                                                          ((x) + 0x137c)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_MSB_OFFS                                                             (0x137c)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_MSB_RMSK                                                               0xffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_MSB_POR                                                              0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_MSB_POR_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_MSB_ATTR                                                                          0x3
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_MSB_RING_SIZE_BMSK                                                     0xffff00
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_MSB_RING_SIZE_SHFT                                                            8
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                0xff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                   0

#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_ID_ADDR(x)                                                                ((x) + 0x1380)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_ID_PHYS(x)                                                                ((x) + 0x1380)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_ID_OFFS                                                                   (0x1380)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_ID_RMSK                                                                       0xffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_ID_POR                                                                    0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_ID_POR_RMSK                                                               0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_ID_ATTR                                                                                0x3
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_ID_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_ID_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT2_RING_ID_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_ID_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_ID_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT2_RING_ID_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT2_RING_ID_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_ID_RING_ID_BMSK                                                               0xff00
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_ID_RING_ID_SHFT                                                                    8
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_ID_ENTRY_SIZE_BMSK                                                              0xff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_ID_ENTRY_SIZE_SHFT                                                                 0

#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_STATUS_ADDR(x)                                                            ((x) + 0x1384)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_STATUS_PHYS(x)                                                            ((x) + 0x1384)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_STATUS_OFFS                                                               (0x1384)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_STATUS_RMSK                                                               0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_STATUS_POR                                                                0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_STATUS_POR_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_STATUS_ATTR                                                                            0x1
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT2_RING_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                               0xffff0000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                       16
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_STATUS_NUM_VALID_WORDS_BMSK                                                   0xffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_STATUS_NUM_VALID_WORDS_SHFT                                                        0

#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_ADDR(x)                                                              ((x) + 0x1388)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_PHYS(x)                                                              ((x) + 0x1388)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_OFFS                                                                 (0x1388)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_RMSK                                                                  0x7ffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_POR                                                                  0x00000080
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_POR_RMSK                                                             0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_ATTR                                                                              0x3
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                          0x4000000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                 26
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_LOOP_CNT_BMSK                                                         0x3c00000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_LOOP_CNT_SHFT                                                                22
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_SPARE_CONTROL_BMSK                                                     0x3fc000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_SPARE_CONTROL_SHFT                                                           14
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_SRNG_SM_STATE2_BMSK                                                      0x3000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_SRNG_SM_STATE2_SHFT                                                          12
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_SRNG_SM_STATE1_BMSK                                                       0xf00
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_SRNG_SM_STATE1_SHFT                                                           8
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_SRNG_IS_IDLE_BMSK                                                          0x80
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_SRNG_IS_IDLE_SHFT                                                             7
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_SRNG_ENABLE_BMSK                                                           0x40
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_SRNG_ENABLE_SHFT                                                              6
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                     0x20
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                        5
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                      0x10
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                         4
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_MSI_SWAP_BIT_BMSK                                                           0x8
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_MSI_SWAP_BIT_SHFT                                                             3
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_SECURITY_BIT_BMSK                                                           0x4
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_SECURITY_BIT_SHFT                                                             2
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_LOOPCNT_DISABLE_BMSK                                                        0x2
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_LOOPCNT_DISABLE_SHFT                                                          1
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_RING_ID_DISABLE_BMSK                                                        0x1
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_RING_ID_DISABLE_SHFT                                                          0

#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_LSB_ADDR(x)                                                       ((x) + 0x138c)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_LSB_PHYS(x)                                                       ((x) + 0x138c)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_LSB_OFFS                                                          (0x138c)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_LSB_RMSK                                                          0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_LSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_LSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                     0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                              0

#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_MSB_ADDR(x)                                                       ((x) + 0x1390)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_MSB_PHYS(x)                                                       ((x) + 0x1390)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_MSB_OFFS                                                          (0x1390)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_MSB_RMSK                                                                0xff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_MSB_POR                                                           0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_MSB_ATTR                                                                       0x3
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                           0xff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                              0

#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_SETUP_ADDR(x)                                                ((x) + 0x139c)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_SETUP_PHYS(x)                                                ((x) + 0x139c)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_SETUP_OFFS                                                   (0x139c)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_SETUP_RMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_SETUP_POR                                                    0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_SETUP_POR_RMSK                                               0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_SETUP_ATTR                                                                0x3
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                         0xffff0000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                 16
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                     0x8000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                         15
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                               0x7fff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                    0

#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_STATUS_ADDR(x)                                               ((x) + 0x13a0)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_STATUS_PHYS(x)                                               ((x) + 0x13a0)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_STATUS_OFFS                                                  (0x13a0)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_STATUS_RMSK                                                  0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_STATUS_POR                                                   0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_STATUS_POR_RMSK                                              0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_STATUS_ATTR                                                               0x1
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                    0xffff0000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                            16
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                            0x8000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                15
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                         0x7fff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                              0

#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                             ((x) + 0x13a4)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                             ((x) + 0x13a4)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_FULL_COUNTER_OFFS                                                (0x13a4)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_FULL_COUNTER_RMSK                                                     0x3ff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_FULL_COUNTER_POR                                                 0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                            0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_FULL_COUNTER_ATTR                                                             0x3
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                   0x3ff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                       0

#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_LSB_ADDR(x)                                                     ((x) + 0x13c0)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_LSB_PHYS(x)                                                     ((x) + 0x13c0)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_LSB_OFFS                                                        (0x13c0)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_LSB_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_LSB_POR                                                         0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_LSB_POR_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_LSB_ATTR                                                                     0x3
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_LSB_ADDR_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_LSB_ADDR_SHFT                                                            0

#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_MSB_ADDR(x)                                                     ((x) + 0x13c4)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_MSB_PHYS(x)                                                     ((x) + 0x13c4)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_MSB_OFFS                                                        (0x13c4)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_MSB_RMSK                                                             0x1ff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_MSB_POR                                                         0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_MSB_POR_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_MSB_ATTR                                                                     0x3
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                 0x100
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                     8
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_MSB_ADDR_BMSK                                                         0xff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_BASE_MSB_ADDR_SHFT                                                            0

#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_DATA_ADDR(x)                                                         ((x) + 0x13c8)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_DATA_PHYS(x)                                                         ((x) + 0x13c8)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_DATA_OFFS                                                            (0x13c8)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_DATA_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_DATA_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_DATA_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_DATA_ATTR                                                                         0x3
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_DATA_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_DATA_VALUE_BMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI1_DATA_VALUE_SHFT                                                               0

#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT2_SETUP_ADDR(x)                                               ((x) + 0x13cc)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT2_SETUP_PHYS(x)                                               ((x) + 0x13cc)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT2_SETUP_OFFS                                                  (0x13cc)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT2_SETUP_RMSK                                                  0xffc0ffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT2_SETUP_POR                                                   0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT2_SETUP_POR_RMSK                                              0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT2_SETUP_ATTR                                                               0x3
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                       0xff000000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                               24
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                        0x800000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                              23
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                      0x400000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                            22
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                       0xffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                            0

#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_LSB_ADDR(x)                                                     ((x) + 0x13d0)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_LSB_PHYS(x)                                                     ((x) + 0x13d0)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_LSB_OFFS                                                        (0x13d0)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_LSB_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_LSB_POR                                                         0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_LSB_POR_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_LSB_ATTR                                                                     0x3
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_LSB_ADDR_BMSK                                                   0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_LSB_ADDR_SHFT                                                            0

#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_MSB_ADDR(x)                                                     ((x) + 0x13d4)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_MSB_PHYS(x)                                                     ((x) + 0x13d4)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_MSB_OFFS                                                        (0x13d4)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_MSB_RMSK                                                             0x1ff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_MSB_POR                                                         0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_MSB_POR_RMSK                                                    0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_MSB_ATTR                                                                     0x3
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                 0x100
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                     8
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_MSB_ADDR_BMSK                                                         0xff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_BASE_MSB_ADDR_SHFT                                                            0

#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_DATA_ADDR(x)                                                         ((x) + 0x13d8)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_DATA_PHYS(x)                                                         ((x) + 0x13d8)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_DATA_OFFS                                                            (0x13d8)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_DATA_RMSK                                                            0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_DATA_POR                                                             0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_DATA_POR_RMSK                                                        0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_DATA_ATTR                                                                         0x3
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_DATA_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_DATA_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_DATA_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_DATA_VALUE_BMSK                                                      0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MSI2_DATA_VALUE_SHFT                                                               0

#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_TP_SW_OFFSET_ADDR(x)                                                   ((x) + 0x13e8)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_TP_SW_OFFSET_PHYS(x)                                                   ((x) + 0x13e8)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_TP_SW_OFFSET_OFFS                                                      (0x13e8)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_TP_SW_OFFSET_RMSK                                                          0xffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_TP_SW_OFFSET_POR                                                       0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_TP_SW_OFFSET_POR_RMSK                                                  0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_TP_SW_OFFSET_ATTR                                                                   0x3
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                       0xffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                            0

#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_ADDR(x)                                                      ((x) + 0x13ec)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_PHYS(x)                                                      ((x) + 0x13ec)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_OFFS                                                         (0x13ec)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_RMSK                                                         0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_POR                                                          0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_POR_RMSK                                                     0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_ATTR                                                                      0x3
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_TIME_THRESHOLD_TO_DOORBELL_BMSK                              0xffff0000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_TIME_THRESHOLD_TO_DOORBELL_SHFT                                      16
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_FETCH_SAME_POINTER_ERR_INT_REG_CLR_BMSK                          0x8000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_FETCH_SAME_POINTER_ERR_INT_REG_CLR_SHFT                              15
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_NUM_THRESHOLD_TO_DOORBELL_BMSK                                   0x7e00
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_NUM_THRESHOLD_TO_DOORBELL_SHFT                                        9
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_SRNG_SM_STATE3_BMSK                                               0x180
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_SRNG_SM_STATE3_SHFT                                                   7
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_INTERVAL_OF_FETCH_POINTER_BMSK                                     0x70
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_INTERVAL_OF_FETCH_POINTER_SHFT                                        4
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_FETCH_SAME_POINTER_THRESHOLD_BMSK                                   0xf
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_FETCH_SAME_POINTER_THRESHOLD_SHFT                                     0

#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_ADDR(x)                                       ((x) + 0x13f0)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_PHYS(x)                                       ((x) + 0x13f0)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_OFFS                                          (0x13f0)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_RMSK                                              0xffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_POR                                           0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_POR_RMSK                                      0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_ATTR                                                       0x3
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_MESSAGE_BMSK                                      0xffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_MESSAGE_SHFT                                           0

#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_ADDR(x)                                   ((x) + 0x13f4)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_PHYS(x)                                   ((x) + 0x13f4)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_OFFS                                      (0x13f4)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_RMSK                                      0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_POR                                       0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_POR_RMSK                                  0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_ATTR                                                   0x3
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_VALUE_BMSK                                0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_VALUE_SHFT                                         0

#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_ADDR(x)                                   ((x) + 0x13f8)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_PHYS(x)                                   ((x) + 0x13f8)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_OFFS                                      (0x13f8)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_RMSK                                            0xff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_POR                                       0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_POR_RMSK                                  0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_ATTR                                                   0x3
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_VALUE_BMSK                                      0xff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_VALUE_SHFT                                         0

#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_ADDR(x)                                    ((x) + 0x13fc)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_PHYS(x)                                    ((x) + 0x13fc)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_OFFS                                       (0x13fc)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_RMSK                                       0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_POR                                        0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_POR_RMSK                                   0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_ATTR                                                    0x3
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_VALUE_BMSK                                 0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_VALUE_SHFT                                          0

#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_ADDR(x)                                    ((x) + 0x1400)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_PHYS(x)                                    ((x) + 0x1400)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_OFFS                                       (0x1400)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_RMSK                                             0xff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_POR                                        0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_POR_RMSK                                   0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_ATTR                                                    0x3
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_VALUE_BMSK                                       0xff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_VALUE_SHFT                                          0

#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_1_ADDR(x)                                                            ((x) + 0x1404)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_1_PHYS(x)                                                            ((x) + 0x1404)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_1_OFFS                                                               (0x1404)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_1_RMSK                                                               0xffff003f
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_1_POR                                                                0x00000000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_1_POR_RMSK                                                           0xffffffff
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_1_ATTR                                                                            0x3
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_1_IN(x)            \
                in_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_1_ADDR(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_1_ADDR(x), m)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_1_ADDR(x),v)
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_1_ADDR(x),m,v,HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_1_IN(x))
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                      0xffff0000
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                              16
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                             0x3f
#define HWIO_WBM_R0_WBM2WBM_OUT2_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                0

#define HWIO_WBM_R1_END_OF_TEST_CHECK_ADDR(x)                                                                   ((x) + 0x2000)
#define HWIO_WBM_R1_END_OF_TEST_CHECK_PHYS(x)                                                                   ((x) + 0x2000)
#define HWIO_WBM_R1_END_OF_TEST_CHECK_OFFS                                                                      (0x2000)
#define HWIO_WBM_R1_END_OF_TEST_CHECK_RMSK                                                                             0x1
#define HWIO_WBM_R1_END_OF_TEST_CHECK_POR                                                                       0x00000000
#define HWIO_WBM_R1_END_OF_TEST_CHECK_POR_RMSK                                                                  0xffffffff
#define HWIO_WBM_R1_END_OF_TEST_CHECK_ATTR                                                                                   0x3
#define HWIO_WBM_R1_END_OF_TEST_CHECK_IN(x)            \
                in_dword(HWIO_WBM_R1_END_OF_TEST_CHECK_ADDR(x))
#define HWIO_WBM_R1_END_OF_TEST_CHECK_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R1_END_OF_TEST_CHECK_ADDR(x), m)
#define HWIO_WBM_R1_END_OF_TEST_CHECK_OUT(x, v)            \
                out_dword(HWIO_WBM_R1_END_OF_TEST_CHECK_ADDR(x),v)
#define HWIO_WBM_R1_END_OF_TEST_CHECK_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R1_END_OF_TEST_CHECK_ADDR(x),m,v,HWIO_WBM_R1_END_OF_TEST_CHECK_IN(x))
#define HWIO_WBM_R1_END_OF_TEST_CHECK_END_OF_TEST_SELF_CHECK_BMSK                                                      0x1
#define HWIO_WBM_R1_END_OF_TEST_CHECK_END_OF_TEST_SELF_CHECK_SHFT                                                        0

#define HWIO_WBM_R1_TESTBUS_CTRL_ADDR(x)                                                                        ((x) + 0x2004)
#define HWIO_WBM_R1_TESTBUS_CTRL_PHYS(x)                                                                        ((x) + 0x2004)
#define HWIO_WBM_R1_TESTBUS_CTRL_OFFS                                                                           (0x2004)
#define HWIO_WBM_R1_TESTBUS_CTRL_RMSK                                                                                 0x3f
#define HWIO_WBM_R1_TESTBUS_CTRL_POR                                                                            0x00000000
#define HWIO_WBM_R1_TESTBUS_CTRL_POR_RMSK                                                                       0xffffffff
#define HWIO_WBM_R1_TESTBUS_CTRL_ATTR                                                                                        0x3
#define HWIO_WBM_R1_TESTBUS_CTRL_IN(x)            \
                in_dword(HWIO_WBM_R1_TESTBUS_CTRL_ADDR(x))
#define HWIO_WBM_R1_TESTBUS_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R1_TESTBUS_CTRL_ADDR(x), m)
#define HWIO_WBM_R1_TESTBUS_CTRL_OUT(x, v)            \
                out_dword(HWIO_WBM_R1_TESTBUS_CTRL_ADDR(x),v)
#define HWIO_WBM_R1_TESTBUS_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R1_TESTBUS_CTRL_ADDR(x),m,v,HWIO_WBM_R1_TESTBUS_CTRL_IN(x))
#define HWIO_WBM_R1_TESTBUS_CTRL_SELECT_WBM_BMSK                                                                      0x3f
#define HWIO_WBM_R1_TESTBUS_CTRL_SELECT_WBM_SHFT                                                                         0

#define HWIO_WBM_R1_TESTBUS_LOWER_ADDR(x)                                                                       ((x) + 0x2008)
#define HWIO_WBM_R1_TESTBUS_LOWER_PHYS(x)                                                                       ((x) + 0x2008)
#define HWIO_WBM_R1_TESTBUS_LOWER_OFFS                                                                          (0x2008)
#define HWIO_WBM_R1_TESTBUS_LOWER_RMSK                                                                          0xffffffff
#define HWIO_WBM_R1_TESTBUS_LOWER_POR                                                                           0x00000000
#define HWIO_WBM_R1_TESTBUS_LOWER_POR_RMSK                                                                      0xffffffff
#define HWIO_WBM_R1_TESTBUS_LOWER_ATTR                                                                                       0x1
#define HWIO_WBM_R1_TESTBUS_LOWER_IN(x)            \
                in_dword(HWIO_WBM_R1_TESTBUS_LOWER_ADDR(x))
#define HWIO_WBM_R1_TESTBUS_LOWER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R1_TESTBUS_LOWER_ADDR(x), m)
#define HWIO_WBM_R1_TESTBUS_LOWER_VALUE_BMSK                                                                    0xffffffff
#define HWIO_WBM_R1_TESTBUS_LOWER_VALUE_SHFT                                                                             0

#define HWIO_WBM_R1_TESTBUS_HIGHER_ADDR(x)                                                                      ((x) + 0x200c)
#define HWIO_WBM_R1_TESTBUS_HIGHER_PHYS(x)                                                                      ((x) + 0x200c)
#define HWIO_WBM_R1_TESTBUS_HIGHER_OFFS                                                                         (0x200c)
#define HWIO_WBM_R1_TESTBUS_HIGHER_RMSK                                                                               0xff
#define HWIO_WBM_R1_TESTBUS_HIGHER_POR                                                                          0x00000000
#define HWIO_WBM_R1_TESTBUS_HIGHER_POR_RMSK                                                                     0xffffffff
#define HWIO_WBM_R1_TESTBUS_HIGHER_ATTR                                                                                      0x1
#define HWIO_WBM_R1_TESTBUS_HIGHER_IN(x)            \
                in_dword(HWIO_WBM_R1_TESTBUS_HIGHER_ADDR(x))
#define HWIO_WBM_R1_TESTBUS_HIGHER_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R1_TESTBUS_HIGHER_ADDR(x), m)
#define HWIO_WBM_R1_TESTBUS_HIGHER_VALUE_BMSK                                                                         0xff
#define HWIO_WBM_R1_TESTBUS_HIGHER_VALUE_SHFT                                                                            0

#define HWIO_WBM_R1_SM_STATES_IX_0_ADDR(x)                                                                      ((x) + 0x2010)
#define HWIO_WBM_R1_SM_STATES_IX_0_PHYS(x)                                                                      ((x) + 0x2010)
#define HWIO_WBM_R1_SM_STATES_IX_0_OFFS                                                                         (0x2010)
#define HWIO_WBM_R1_SM_STATES_IX_0_RMSK                                                                         0x7fffffff
#define HWIO_WBM_R1_SM_STATES_IX_0_POR                                                                          0x00000000
#define HWIO_WBM_R1_SM_STATES_IX_0_POR_RMSK                                                                     0xffffffff
#define HWIO_WBM_R1_SM_STATES_IX_0_ATTR                                                                                      0x1
#define HWIO_WBM_R1_SM_STATES_IX_0_IN(x)            \
                in_dword(HWIO_WBM_R1_SM_STATES_IX_0_ADDR(x))
#define HWIO_WBM_R1_SM_STATES_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R1_SM_STATES_IX_0_ADDR(x), m)
#define HWIO_WBM_R1_SM_STATES_IX_0_SW2_BUFFER_P_STATE_BMSK                                                      0x60000000
#define HWIO_WBM_R1_SM_STATES_IX_0_SW2_BUFFER_P_STATE_SHFT                                                              29
#define HWIO_WBM_R1_SM_STATES_IX_0_SW1_BUFFER_P_STATE_BMSK                                                      0x18000000
#define HWIO_WBM_R1_SM_STATES_IX_0_SW1_BUFFER_P_STATE_SHFT                                                              27
#define HWIO_WBM_R1_SM_STATES_IX_0_SW0_BUFFER_P_STATE_BMSK                                                       0x6000000
#define HWIO_WBM_R1_SM_STATES_IX_0_SW0_BUFFER_P_STATE_SHFT                                                              25
#define HWIO_WBM_R1_SM_STATES_IX_0_FW_BUFFER_P_STATE_BMSK                                                        0x1800000
#define HWIO_WBM_R1_SM_STATES_IX_0_FW_BUFFER_P_STATE_SHFT                                                               23
#define HWIO_WBM_R1_SM_STATES_IX_0_LINK_DIST_P_STATE_BMSK                                                         0x600000
#define HWIO_WBM_R1_SM_STATES_IX_0_LINK_DIST_P_STATE_SHFT                                                               21
#define HWIO_WBM_R1_SM_STATES_IX_0_LINK_DIST_C_STATE_BMSK                                                         0x180000
#define HWIO_WBM_R1_SM_STATES_IX_0_LINK_DIST_C_STATE_SHFT                                                               19
#define HWIO_WBM_R1_SM_STATES_IX_0_BUFFER_DIST_P_STATE_BMSK                                                        0x60000
#define HWIO_WBM_R1_SM_STATES_IX_0_BUFFER_DIST_P_STATE_SHFT                                                             17
#define HWIO_WBM_R1_SM_STATES_IX_0_BUFFER_DIST_C_STATE_BMSK                                                        0x18000
#define HWIO_WBM_R1_SM_STATES_IX_0_BUFFER_DIST_C_STATE_SHFT                                                             15
#define HWIO_WBM_R1_SM_STATES_IX_0_LINK_IDLE_LIST_PROD_B_STATE_BMSK                                                 0x7000
#define HWIO_WBM_R1_SM_STATES_IX_0_LINK_IDLE_LIST_PROD_B_STATE_SHFT                                                     12
#define HWIO_WBM_R1_SM_STATES_IX_0_LINK_IDLE_LIST_PROD_P_STATE_BMSK                                                  0xc00
#define HWIO_WBM_R1_SM_STATES_IX_0_LINK_IDLE_LIST_PROD_P_STATE_SHFT                                                     10
#define HWIO_WBM_R1_SM_STATES_IX_0_BUFFER_IDLE_LIST_PROD_B_STATE_BMSK                                                0x380
#define HWIO_WBM_R1_SM_STATES_IX_0_BUFFER_IDLE_LIST_PROD_B_STATE_SHFT                                                    7
#define HWIO_WBM_R1_SM_STATES_IX_0_BUFFER_IDLE_LIST_PROD_P_STATE_BMSK                                                 0x60
#define HWIO_WBM_R1_SM_STATES_IX_0_BUFFER_IDLE_LIST_PROD_P_STATE_SHFT                                                    5
#define HWIO_WBM_R1_SM_STATES_IX_0_RLS_REQ_PARSE_P_STATE_BMSK                                                         0x1c
#define HWIO_WBM_R1_SM_STATES_IX_0_RLS_REQ_PARSE_P_STATE_SHFT                                                            2
#define HWIO_WBM_R1_SM_STATES_IX_0_RLS_REQ_PARSE_C_STATE_BMSK                                                          0x3
#define HWIO_WBM_R1_SM_STATES_IX_0_RLS_REQ_PARSE_C_STATE_SHFT                                                            0

#define HWIO_WBM_R1_SM_STATES_IX_1_ADDR(x)                                                                      ((x) + 0x2014)
#define HWIO_WBM_R1_SM_STATES_IX_1_PHYS(x)                                                                      ((x) + 0x2014)
#define HWIO_WBM_R1_SM_STATES_IX_1_OFFS                                                                         (0x2014)
#define HWIO_WBM_R1_SM_STATES_IX_1_RMSK                                                                         0xffffffff
#define HWIO_WBM_R1_SM_STATES_IX_1_POR                                                                          0x00000000
#define HWIO_WBM_R1_SM_STATES_IX_1_POR_RMSK                                                                     0xffffffff
#define HWIO_WBM_R1_SM_STATES_IX_1_ATTR                                                                                      0x1
#define HWIO_WBM_R1_SM_STATES_IX_1_IN(x)            \
                in_dword(HWIO_WBM_R1_SM_STATES_IX_1_ADDR(x))
#define HWIO_WBM_R1_SM_STATES_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R1_SM_STATES_IX_1_ADDR(x), m)
#define HWIO_WBM_R1_SM_STATES_IX_1_SW4_BUFFER_P_STATE_BMSK                                                      0xc0000000
#define HWIO_WBM_R1_SM_STATES_IX_1_SW4_BUFFER_P_STATE_SHFT                                                              30
#define HWIO_WBM_R1_SM_STATES_IX_1_IDLE_LINK_DIST_NULL_PTR_BMSK                                                 0x20000000
#define HWIO_WBM_R1_SM_STATES_IX_1_IDLE_LINK_DIST_NULL_PTR_SHFT                                                         29
#define HWIO_WBM_R1_SM_STATES_IX_1_IDLE_BUF_DIST_NULL_PTR_BMSK                                                  0x10000000
#define HWIO_WBM_R1_SM_STATES_IX_1_IDLE_BUF_DIST_NULL_PTR_SHFT                                                          28
#define HWIO_WBM_R1_SM_STATES_IX_1_IDLE_LINK_SCAT_SRNG_C_STATE_BMSK                                              0xe000000
#define HWIO_WBM_R1_SM_STATES_IX_1_IDLE_LINK_SCAT_SRNG_C_STATE_SHFT                                                     25
#define HWIO_WBM_R1_SM_STATES_IX_1_IDLE_LINK_SCAT_SRNG_P_STATE_BMSK                                              0x1c00000
#define HWIO_WBM_R1_SM_STATES_IX_1_IDLE_LINK_SCAT_SRNG_P_STATE_SHFT                                                     22
#define HWIO_WBM_R1_SM_STATES_IX_1_IDLE_BUF_SCAT_SRNG_C_STATE_BMSK                                                0x380000
#define HWIO_WBM_R1_SM_STATES_IX_1_IDLE_BUF_SCAT_SRNG_C_STATE_SHFT                                                      19
#define HWIO_WBM_R1_SM_STATES_IX_1_IDLE_BUF_SCAT_SRNG_P_STATE_BMSK                                                 0x70000
#define HWIO_WBM_R1_SM_STATES_IX_1_IDLE_BUF_SCAT_SRNG_P_STATE_SHFT                                                      16
#define HWIO_WBM_R1_SM_STATES_IX_1_IDLE_LINK_SRNG_C_STATE_BMSK                                                      0xe000
#define HWIO_WBM_R1_SM_STATES_IX_1_IDLE_LINK_SRNG_C_STATE_SHFT                                                          13
#define HWIO_WBM_R1_SM_STATES_IX_1_IDLE_LINK_SRNG_P_STATE_BMSK                                                      0x1c00
#define HWIO_WBM_R1_SM_STATES_IX_1_IDLE_LINK_SRNG_P_STATE_SHFT                                                          10
#define HWIO_WBM_R1_SM_STATES_IX_1_IDLE_BUF_SRNG_C_STATE_BMSK                                                        0x380
#define HWIO_WBM_R1_SM_STATES_IX_1_IDLE_BUF_SRNG_C_STATE_SHFT                                                            7
#define HWIO_WBM_R1_SM_STATES_IX_1_IDLE_BUF_SRNG_P_STATE_BMSK                                                         0x70
#define HWIO_WBM_R1_SM_STATES_IX_1_IDLE_BUF_SRNG_P_STATE_SHFT                                                            4
#define HWIO_WBM_R1_SM_STATES_IX_1_LINK_ZERO_OUT_STATE_BMSK                                                            0xc
#define HWIO_WBM_R1_SM_STATES_IX_1_LINK_ZERO_OUT_STATE_SHFT                                                              2
#define HWIO_WBM_R1_SM_STATES_IX_1_SW3_BUFFER_P_STATE_BMSK                                                             0x3
#define HWIO_WBM_R1_SM_STATES_IX_1_SW3_BUFFER_P_STATE_SHFT                                                               0

#define HWIO_WBM_R1_SM_STATES_IX_2_ADDR(x)                                                                      ((x) + 0x2018)
#define HWIO_WBM_R1_SM_STATES_IX_2_PHYS(x)                                                                      ((x) + 0x2018)
#define HWIO_WBM_R1_SM_STATES_IX_2_OFFS                                                                         (0x2018)
#define HWIO_WBM_R1_SM_STATES_IX_2_RMSK                                                                              0x3ff
#define HWIO_WBM_R1_SM_STATES_IX_2_POR                                                                          0x00000000
#define HWIO_WBM_R1_SM_STATES_IX_2_POR_RMSK                                                                     0xffffffff
#define HWIO_WBM_R1_SM_STATES_IX_2_ATTR                                                                                      0x1
#define HWIO_WBM_R1_SM_STATES_IX_2_IN(x)            \
                in_dword(HWIO_WBM_R1_SM_STATES_IX_2_ADDR(x))
#define HWIO_WBM_R1_SM_STATES_IX_2_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R1_SM_STATES_IX_2_ADDR(x), m)
#define HWIO_WBM_R1_SM_STATES_IX_2_MLO_OUT2_REL_P_STATE_BMSK                                                         0x300
#define HWIO_WBM_R1_SM_STATES_IX_2_MLO_OUT2_REL_P_STATE_SHFT                                                             8
#define HWIO_WBM_R1_SM_STATES_IX_2_MLO_OUT1_REL_P_STATE_BMSK                                                          0xc0
#define HWIO_WBM_R1_SM_STATES_IX_2_MLO_OUT1_REL_P_STATE_SHFT                                                             6
#define HWIO_WBM_R1_SM_STATES_IX_2_ERROR_RELEASE_P_STATE_BMSK                                                         0x30
#define HWIO_WBM_R1_SM_STATES_IX_2_ERROR_RELEASE_P_STATE_SHFT                                                            4
#define HWIO_WBM_R1_SM_STATES_IX_2_SW6_BUFFER_P_STATE_BMSK                                                             0xc
#define HWIO_WBM_R1_SM_STATES_IX_2_SW6_BUFFER_P_STATE_SHFT                                                               2
#define HWIO_WBM_R1_SM_STATES_IX_2_SW5_BUFFER_P_STATE_BMSK                                                             0x3
#define HWIO_WBM_R1_SM_STATES_IX_2_SW5_BUFFER_P_STATE_SHFT                                                               0

#define HWIO_WBM_R1_EVENTMASK_IX_0_ADDR(x)                                                                      ((x) + 0x201c)
#define HWIO_WBM_R1_EVENTMASK_IX_0_PHYS(x)                                                                      ((x) + 0x201c)
#define HWIO_WBM_R1_EVENTMASK_IX_0_OFFS                                                                         (0x201c)
#define HWIO_WBM_R1_EVENTMASK_IX_0_RMSK                                                                         0xffffffff
#define HWIO_WBM_R1_EVENTMASK_IX_0_POR                                                                          0xffffffff
#define HWIO_WBM_R1_EVENTMASK_IX_0_POR_RMSK                                                                     0xffffffff
#define HWIO_WBM_R1_EVENTMASK_IX_0_ATTR                                                                                      0x3
#define HWIO_WBM_R1_EVENTMASK_IX_0_IN(x)            \
                in_dword(HWIO_WBM_R1_EVENTMASK_IX_0_ADDR(x))
#define HWIO_WBM_R1_EVENTMASK_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R1_EVENTMASK_IX_0_ADDR(x), m)
#define HWIO_WBM_R1_EVENTMASK_IX_0_OUT(x, v)            \
                out_dword(HWIO_WBM_R1_EVENTMASK_IX_0_ADDR(x),v)
#define HWIO_WBM_R1_EVENTMASK_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R1_EVENTMASK_IX_0_ADDR(x),m,v,HWIO_WBM_R1_EVENTMASK_IX_0_IN(x))
#define HWIO_WBM_R1_EVENTMASK_IX_0_MASK_BMSK                                                                    0xffffffff
#define HWIO_WBM_R1_EVENTMASK_IX_0_MASK_SHFT                                                                             0

#define HWIO_WBM_R1_EVENTMASK_IX_1_ADDR(x)                                                                      ((x) + 0x2020)
#define HWIO_WBM_R1_EVENTMASK_IX_1_PHYS(x)                                                                      ((x) + 0x2020)
#define HWIO_WBM_R1_EVENTMASK_IX_1_OFFS                                                                         (0x2020)
#define HWIO_WBM_R1_EVENTMASK_IX_1_RMSK                                                                         0xffffffff
#define HWIO_WBM_R1_EVENTMASK_IX_1_POR                                                                          0xffffffff
#define HWIO_WBM_R1_EVENTMASK_IX_1_POR_RMSK                                                                     0xffffffff
#define HWIO_WBM_R1_EVENTMASK_IX_1_ATTR                                                                                      0x3
#define HWIO_WBM_R1_EVENTMASK_IX_1_IN(x)            \
                in_dword(HWIO_WBM_R1_EVENTMASK_IX_1_ADDR(x))
#define HWIO_WBM_R1_EVENTMASK_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R1_EVENTMASK_IX_1_ADDR(x), m)
#define HWIO_WBM_R1_EVENTMASK_IX_1_OUT(x, v)            \
                out_dword(HWIO_WBM_R1_EVENTMASK_IX_1_ADDR(x),v)
#define HWIO_WBM_R1_EVENTMASK_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R1_EVENTMASK_IX_1_ADDR(x),m,v,HWIO_WBM_R1_EVENTMASK_IX_1_IN(x))
#define HWIO_WBM_R1_EVENTMASK_IX_1_MASK_BMSK                                                                    0xffffffff
#define HWIO_WBM_R1_EVENTMASK_IX_1_MASK_SHFT                                                                             0

#define HWIO_WBM_R1_EVENTMASK_IX_2_ADDR(x)                                                                      ((x) + 0x2024)
#define HWIO_WBM_R1_EVENTMASK_IX_2_PHYS(x)                                                                      ((x) + 0x2024)
#define HWIO_WBM_R1_EVENTMASK_IX_2_OFFS                                                                         (0x2024)
#define HWIO_WBM_R1_EVENTMASK_IX_2_RMSK                                                                         0xffffffff
#define HWIO_WBM_R1_EVENTMASK_IX_2_POR                                                                          0xffffffff
#define HWIO_WBM_R1_EVENTMASK_IX_2_POR_RMSK                                                                     0xffffffff
#define HWIO_WBM_R1_EVENTMASK_IX_2_ATTR                                                                                      0x3
#define HWIO_WBM_R1_EVENTMASK_IX_2_IN(x)            \
                in_dword(HWIO_WBM_R1_EVENTMASK_IX_2_ADDR(x))
#define HWIO_WBM_R1_EVENTMASK_IX_2_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R1_EVENTMASK_IX_2_ADDR(x), m)
#define HWIO_WBM_R1_EVENTMASK_IX_2_OUT(x, v)            \
                out_dword(HWIO_WBM_R1_EVENTMASK_IX_2_ADDR(x),v)
#define HWIO_WBM_R1_EVENTMASK_IX_2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R1_EVENTMASK_IX_2_ADDR(x),m,v,HWIO_WBM_R1_EVENTMASK_IX_2_IN(x))
#define HWIO_WBM_R1_EVENTMASK_IX_2_MASK_BMSK                                                                    0xffffffff
#define HWIO_WBM_R1_EVENTMASK_IX_2_MASK_SHFT                                                                             0

#define HWIO_WBM_R1_EVENTMASK_IX_3_ADDR(x)                                                                      ((x) + 0x2028)
#define HWIO_WBM_R1_EVENTMASK_IX_3_PHYS(x)                                                                      ((x) + 0x2028)
#define HWIO_WBM_R1_EVENTMASK_IX_3_OFFS                                                                         (0x2028)
#define HWIO_WBM_R1_EVENTMASK_IX_3_RMSK                                                                         0xffffffff
#define HWIO_WBM_R1_EVENTMASK_IX_3_POR                                                                          0xffffffff
#define HWIO_WBM_R1_EVENTMASK_IX_3_POR_RMSK                                                                     0xffffffff
#define HWIO_WBM_R1_EVENTMASK_IX_3_ATTR                                                                                      0x3
#define HWIO_WBM_R1_EVENTMASK_IX_3_IN(x)            \
                in_dword(HWIO_WBM_R1_EVENTMASK_IX_3_ADDR(x))
#define HWIO_WBM_R1_EVENTMASK_IX_3_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R1_EVENTMASK_IX_3_ADDR(x), m)
#define HWIO_WBM_R1_EVENTMASK_IX_3_OUT(x, v)            \
                out_dword(HWIO_WBM_R1_EVENTMASK_IX_3_ADDR(x),v)
#define HWIO_WBM_R1_EVENTMASK_IX_3_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R1_EVENTMASK_IX_3_ADDR(x),m,v,HWIO_WBM_R1_EVENTMASK_IX_3_IN(x))
#define HWIO_WBM_R1_EVENTMASK_IX_3_MASK_BMSK                                                                    0xffffffff
#define HWIO_WBM_R1_EVENTMASK_IX_3_MASK_SHFT                                                                             0

#define HWIO_WBM_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDR(x)                                                           ((x) + 0x202c)
#define HWIO_WBM_R1_REG_ACCESS_EVENT_GEN_CTRL_PHYS(x)                                                           ((x) + 0x202c)
#define HWIO_WBM_R1_REG_ACCESS_EVENT_GEN_CTRL_OFFS                                                              (0x202c)
#define HWIO_WBM_R1_REG_ACCESS_EVENT_GEN_CTRL_RMSK                                                              0xffffffff
#define HWIO_WBM_R1_REG_ACCESS_EVENT_GEN_CTRL_POR                                                               0x7ffe0002
#define HWIO_WBM_R1_REG_ACCESS_EVENT_GEN_CTRL_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R1_REG_ACCESS_EVENT_GEN_CTRL_ATTR                                                                           0x3
#define HWIO_WBM_R1_REG_ACCESS_EVENT_GEN_CTRL_IN(x)            \
                in_dword(HWIO_WBM_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDR(x))
#define HWIO_WBM_R1_REG_ACCESS_EVENT_GEN_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDR(x), m)
#define HWIO_WBM_R1_REG_ACCESS_EVENT_GEN_CTRL_OUT(x, v)            \
                out_dword(HWIO_WBM_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDR(x),v)
#define HWIO_WBM_R1_REG_ACCESS_EVENT_GEN_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDR(x),m,v,HWIO_WBM_R1_REG_ACCESS_EVENT_GEN_CTRL_IN(x))
#define HWIO_WBM_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDRESS_RANGE_END_BMSK                                            0xfffe0000
#define HWIO_WBM_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDRESS_RANGE_END_SHFT                                                    17
#define HWIO_WBM_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDRESS_RANGE_START_BMSK                                             0x1fffc
#define HWIO_WBM_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDRESS_RANGE_START_SHFT                                                   2
#define HWIO_WBM_R1_REG_ACCESS_EVENT_GEN_CTRL_WRITE_ACCESS_REPORT_ENABLE_BMSK                                          0x2
#define HWIO_WBM_R1_REG_ACCESS_EVENT_GEN_CTRL_WRITE_ACCESS_REPORT_ENABLE_SHFT                                            1
#define HWIO_WBM_R1_REG_ACCESS_EVENT_GEN_CTRL_READ_ACCESS_REPORT_ENABLE_BMSK                                           0x1
#define HWIO_WBM_R1_REG_ACCESS_EVENT_GEN_CTRL_READ_ACCESS_REPORT_ENABLE_SHFT                                             0

#define HWIO_WBM_R2_TQM_RELEASE_RING_HP_ADDR(x)                                                                 ((x) + 0x3000)
#define HWIO_WBM_R2_TQM_RELEASE_RING_HP_PHYS(x)                                                                 ((x) + 0x3000)
#define HWIO_WBM_R2_TQM_RELEASE_RING_HP_OFFS                                                                    (0x3000)
#define HWIO_WBM_R2_TQM_RELEASE_RING_HP_RMSK                                                                        0xffff
#define HWIO_WBM_R2_TQM_RELEASE_RING_HP_POR                                                                     0x00000000
#define HWIO_WBM_R2_TQM_RELEASE_RING_HP_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R2_TQM_RELEASE_RING_HP_ATTR                                                                                 0x3
#define HWIO_WBM_R2_TQM_RELEASE_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_TQM_RELEASE_RING_HP_ADDR(x))
#define HWIO_WBM_R2_TQM_RELEASE_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_TQM_RELEASE_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_TQM_RELEASE_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_TQM_RELEASE_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_TQM_RELEASE_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_TQM_RELEASE_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_TQM_RELEASE_RING_HP_IN(x))
#define HWIO_WBM_R2_TQM_RELEASE_RING_HP_HEAD_PTR_BMSK                                                               0xffff
#define HWIO_WBM_R2_TQM_RELEASE_RING_HP_HEAD_PTR_SHFT                                                                    0

#define HWIO_WBM_R2_TQM_RELEASE_RING_TP_ADDR(x)                                                                 ((x) + 0x3004)
#define HWIO_WBM_R2_TQM_RELEASE_RING_TP_PHYS(x)                                                                 ((x) + 0x3004)
#define HWIO_WBM_R2_TQM_RELEASE_RING_TP_OFFS                                                                    (0x3004)
#define HWIO_WBM_R2_TQM_RELEASE_RING_TP_RMSK                                                                        0xffff
#define HWIO_WBM_R2_TQM_RELEASE_RING_TP_POR                                                                     0x00000000
#define HWIO_WBM_R2_TQM_RELEASE_RING_TP_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R2_TQM_RELEASE_RING_TP_ATTR                                                                                 0x3
#define HWIO_WBM_R2_TQM_RELEASE_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_TQM_RELEASE_RING_TP_ADDR(x))
#define HWIO_WBM_R2_TQM_RELEASE_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_TQM_RELEASE_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_TQM_RELEASE_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_TQM_RELEASE_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_TQM_RELEASE_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_TQM_RELEASE_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_TQM_RELEASE_RING_TP_IN(x))
#define HWIO_WBM_R2_TQM_RELEASE_RING_TP_TAIL_PTR_BMSK                                                               0xffff
#define HWIO_WBM_R2_TQM_RELEASE_RING_TP_TAIL_PTR_SHFT                                                                    0

#define HWIO_WBM_R2_REO_RELEASE_RING_HP_ADDR(x)                                                                 ((x) + 0x3008)
#define HWIO_WBM_R2_REO_RELEASE_RING_HP_PHYS(x)                                                                 ((x) + 0x3008)
#define HWIO_WBM_R2_REO_RELEASE_RING_HP_OFFS                                                                    (0x3008)
#define HWIO_WBM_R2_REO_RELEASE_RING_HP_RMSK                                                                        0xffff
#define HWIO_WBM_R2_REO_RELEASE_RING_HP_POR                                                                     0x00000000
#define HWIO_WBM_R2_REO_RELEASE_RING_HP_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R2_REO_RELEASE_RING_HP_ATTR                                                                                 0x3
#define HWIO_WBM_R2_REO_RELEASE_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_REO_RELEASE_RING_HP_ADDR(x))
#define HWIO_WBM_R2_REO_RELEASE_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_REO_RELEASE_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_REO_RELEASE_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_REO_RELEASE_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_REO_RELEASE_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_REO_RELEASE_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_REO_RELEASE_RING_HP_IN(x))
#define HWIO_WBM_R2_REO_RELEASE_RING_HP_HEAD_PTR_BMSK                                                               0xffff
#define HWIO_WBM_R2_REO_RELEASE_RING_HP_HEAD_PTR_SHFT                                                                    0

#define HWIO_WBM_R2_REO_RELEASE_RING_TP_ADDR(x)                                                                 ((x) + 0x300c)
#define HWIO_WBM_R2_REO_RELEASE_RING_TP_PHYS(x)                                                                 ((x) + 0x300c)
#define HWIO_WBM_R2_REO_RELEASE_RING_TP_OFFS                                                                    (0x300c)
#define HWIO_WBM_R2_REO_RELEASE_RING_TP_RMSK                                                                        0xffff
#define HWIO_WBM_R2_REO_RELEASE_RING_TP_POR                                                                     0x00000000
#define HWIO_WBM_R2_REO_RELEASE_RING_TP_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R2_REO_RELEASE_RING_TP_ATTR                                                                                 0x3
#define HWIO_WBM_R2_REO_RELEASE_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_REO_RELEASE_RING_TP_ADDR(x))
#define HWIO_WBM_R2_REO_RELEASE_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_REO_RELEASE_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_REO_RELEASE_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_REO_RELEASE_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_REO_RELEASE_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_REO_RELEASE_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_REO_RELEASE_RING_TP_IN(x))
#define HWIO_WBM_R2_REO_RELEASE_RING_TP_TAIL_PTR_BMSK                                                               0xffff
#define HWIO_WBM_R2_REO_RELEASE_RING_TP_TAIL_PTR_SHFT                                                                    0

#define HWIO_WBM_R2_SW_RELEASE_RING_HP_ADDR(x)                                                                  ((x) + 0x3010)
#define HWIO_WBM_R2_SW_RELEASE_RING_HP_PHYS(x)                                                                  ((x) + 0x3010)
#define HWIO_WBM_R2_SW_RELEASE_RING_HP_OFFS                                                                     (0x3010)
#define HWIO_WBM_R2_SW_RELEASE_RING_HP_RMSK                                                                         0xffff
#define HWIO_WBM_R2_SW_RELEASE_RING_HP_POR                                                                      0x00000000
#define HWIO_WBM_R2_SW_RELEASE_RING_HP_POR_RMSK                                                                 0xffffffff
#define HWIO_WBM_R2_SW_RELEASE_RING_HP_ATTR                                                                                  0x3
#define HWIO_WBM_R2_SW_RELEASE_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_SW_RELEASE_RING_HP_ADDR(x))
#define HWIO_WBM_R2_SW_RELEASE_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_SW_RELEASE_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_SW_RELEASE_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_SW_RELEASE_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_SW_RELEASE_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_SW_RELEASE_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_SW_RELEASE_RING_HP_IN(x))
#define HWIO_WBM_R2_SW_RELEASE_RING_HP_HEAD_PTR_BMSK                                                                0xffff
#define HWIO_WBM_R2_SW_RELEASE_RING_HP_HEAD_PTR_SHFT                                                                     0

#define HWIO_WBM_R2_SW_RELEASE_RING_TP_ADDR(x)                                                                  ((x) + 0x3014)
#define HWIO_WBM_R2_SW_RELEASE_RING_TP_PHYS(x)                                                                  ((x) + 0x3014)
#define HWIO_WBM_R2_SW_RELEASE_RING_TP_OFFS                                                                     (0x3014)
#define HWIO_WBM_R2_SW_RELEASE_RING_TP_RMSK                                                                         0xffff
#define HWIO_WBM_R2_SW_RELEASE_RING_TP_POR                                                                      0x00000000
#define HWIO_WBM_R2_SW_RELEASE_RING_TP_POR_RMSK                                                                 0xffffffff
#define HWIO_WBM_R2_SW_RELEASE_RING_TP_ATTR                                                                                  0x3
#define HWIO_WBM_R2_SW_RELEASE_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_SW_RELEASE_RING_TP_ADDR(x))
#define HWIO_WBM_R2_SW_RELEASE_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_SW_RELEASE_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_SW_RELEASE_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_SW_RELEASE_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_SW_RELEASE_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_SW_RELEASE_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_SW_RELEASE_RING_TP_IN(x))
#define HWIO_WBM_R2_SW_RELEASE_RING_TP_TAIL_PTR_BMSK                                                                0xffff
#define HWIO_WBM_R2_SW_RELEASE_RING_TP_TAIL_PTR_SHFT                                                                     0

#define HWIO_WBM_R2_FW_RELEASE_RING_HP_ADDR(x)                                                                  ((x) + 0x3028)
#define HWIO_WBM_R2_FW_RELEASE_RING_HP_PHYS(x)                                                                  ((x) + 0x3028)
#define HWIO_WBM_R2_FW_RELEASE_RING_HP_OFFS                                                                     (0x3028)
#define HWIO_WBM_R2_FW_RELEASE_RING_HP_RMSK                                                                         0xffff
#define HWIO_WBM_R2_FW_RELEASE_RING_HP_POR                                                                      0x00000000
#define HWIO_WBM_R2_FW_RELEASE_RING_HP_POR_RMSK                                                                 0xffffffff
#define HWIO_WBM_R2_FW_RELEASE_RING_HP_ATTR                                                                                  0x3
#define HWIO_WBM_R2_FW_RELEASE_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_FW_RELEASE_RING_HP_ADDR(x))
#define HWIO_WBM_R2_FW_RELEASE_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_FW_RELEASE_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_FW_RELEASE_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_FW_RELEASE_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_FW_RELEASE_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_FW_RELEASE_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_FW_RELEASE_RING_HP_IN(x))
#define HWIO_WBM_R2_FW_RELEASE_RING_HP_HEAD_PTR_BMSK                                                                0xffff
#define HWIO_WBM_R2_FW_RELEASE_RING_HP_HEAD_PTR_SHFT                                                                     0

#define HWIO_WBM_R2_FW_RELEASE_RING_TP_ADDR(x)                                                                  ((x) + 0x302c)
#define HWIO_WBM_R2_FW_RELEASE_RING_TP_PHYS(x)                                                                  ((x) + 0x302c)
#define HWIO_WBM_R2_FW_RELEASE_RING_TP_OFFS                                                                     (0x302c)
#define HWIO_WBM_R2_FW_RELEASE_RING_TP_RMSK                                                                         0xffff
#define HWIO_WBM_R2_FW_RELEASE_RING_TP_POR                                                                      0x00000000
#define HWIO_WBM_R2_FW_RELEASE_RING_TP_POR_RMSK                                                                 0xffffffff
#define HWIO_WBM_R2_FW_RELEASE_RING_TP_ATTR                                                                                  0x3
#define HWIO_WBM_R2_FW_RELEASE_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_FW_RELEASE_RING_TP_ADDR(x))
#define HWIO_WBM_R2_FW_RELEASE_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_FW_RELEASE_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_FW_RELEASE_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_FW_RELEASE_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_FW_RELEASE_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_FW_RELEASE_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_FW_RELEASE_RING_TP_IN(x))
#define HWIO_WBM_R2_FW_RELEASE_RING_TP_TAIL_PTR_BMSK                                                                0xffff
#define HWIO_WBM_R2_FW_RELEASE_RING_TP_TAIL_PTR_SHFT                                                                     0

#define HWIO_WBM_R2_RXDMA0_RELEASE_RING_HP_ADDR(x)                                                              ((x) + 0x3030)
#define HWIO_WBM_R2_RXDMA0_RELEASE_RING_HP_PHYS(x)                                                              ((x) + 0x3030)
#define HWIO_WBM_R2_RXDMA0_RELEASE_RING_HP_OFFS                                                                 (0x3030)
#define HWIO_WBM_R2_RXDMA0_RELEASE_RING_HP_RMSK                                                                     0xffff
#define HWIO_WBM_R2_RXDMA0_RELEASE_RING_HP_POR                                                                  0x00000000
#define HWIO_WBM_R2_RXDMA0_RELEASE_RING_HP_POR_RMSK                                                             0xffffffff
#define HWIO_WBM_R2_RXDMA0_RELEASE_RING_HP_ATTR                                                                              0x3
#define HWIO_WBM_R2_RXDMA0_RELEASE_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_RXDMA0_RELEASE_RING_HP_ADDR(x))
#define HWIO_WBM_R2_RXDMA0_RELEASE_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_RXDMA0_RELEASE_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_RXDMA0_RELEASE_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_RXDMA0_RELEASE_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_RXDMA0_RELEASE_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_RXDMA0_RELEASE_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_RXDMA0_RELEASE_RING_HP_IN(x))
#define HWIO_WBM_R2_RXDMA0_RELEASE_RING_HP_HEAD_PTR_BMSK                                                            0xffff
#define HWIO_WBM_R2_RXDMA0_RELEASE_RING_HP_HEAD_PTR_SHFT                                                                 0

#define HWIO_WBM_R2_RXDMA0_RELEASE_RING_TP_ADDR(x)                                                              ((x) + 0x3034)
#define HWIO_WBM_R2_RXDMA0_RELEASE_RING_TP_PHYS(x)                                                              ((x) + 0x3034)
#define HWIO_WBM_R2_RXDMA0_RELEASE_RING_TP_OFFS                                                                 (0x3034)
#define HWIO_WBM_R2_RXDMA0_RELEASE_RING_TP_RMSK                                                                     0xffff
#define HWIO_WBM_R2_RXDMA0_RELEASE_RING_TP_POR                                                                  0x00000000
#define HWIO_WBM_R2_RXDMA0_RELEASE_RING_TP_POR_RMSK                                                             0xffffffff
#define HWIO_WBM_R2_RXDMA0_RELEASE_RING_TP_ATTR                                                                              0x3
#define HWIO_WBM_R2_RXDMA0_RELEASE_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_RXDMA0_RELEASE_RING_TP_ADDR(x))
#define HWIO_WBM_R2_RXDMA0_RELEASE_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_RXDMA0_RELEASE_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_RXDMA0_RELEASE_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_RXDMA0_RELEASE_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_RXDMA0_RELEASE_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_RXDMA0_RELEASE_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_RXDMA0_RELEASE_RING_TP_IN(x))
#define HWIO_WBM_R2_RXDMA0_RELEASE_RING_TP_TAIL_PTR_BMSK                                                            0xffff
#define HWIO_WBM_R2_RXDMA0_RELEASE_RING_TP_TAIL_PTR_SHFT                                                                 0

#define HWIO_WBM_R2_WBM2TQM_LINK_RING_HP_ADDR(x)                                                                ((x) + 0x3078)
#define HWIO_WBM_R2_WBM2TQM_LINK_RING_HP_PHYS(x)                                                                ((x) + 0x3078)
#define HWIO_WBM_R2_WBM2TQM_LINK_RING_HP_OFFS                                                                   (0x3078)
#define HWIO_WBM_R2_WBM2TQM_LINK_RING_HP_RMSK                                                                       0xffff
#define HWIO_WBM_R2_WBM2TQM_LINK_RING_HP_POR                                                                    0x00000000
#define HWIO_WBM_R2_WBM2TQM_LINK_RING_HP_POR_RMSK                                                               0xffffffff
#define HWIO_WBM_R2_WBM2TQM_LINK_RING_HP_ATTR                                                                                0x3
#define HWIO_WBM_R2_WBM2TQM_LINK_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2TQM_LINK_RING_HP_ADDR(x))
#define HWIO_WBM_R2_WBM2TQM_LINK_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2TQM_LINK_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2TQM_LINK_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2TQM_LINK_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2TQM_LINK_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2TQM_LINK_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_WBM2TQM_LINK_RING_HP_IN(x))
#define HWIO_WBM_R2_WBM2TQM_LINK_RING_HP_HEAD_PTR_BMSK                                                              0xffff
#define HWIO_WBM_R2_WBM2TQM_LINK_RING_HP_HEAD_PTR_SHFT                                                                   0

#define HWIO_WBM_R2_WBM2TQM_LINK_RING_TP_ADDR(x)                                                                ((x) + 0x307c)
#define HWIO_WBM_R2_WBM2TQM_LINK_RING_TP_PHYS(x)                                                                ((x) + 0x307c)
#define HWIO_WBM_R2_WBM2TQM_LINK_RING_TP_OFFS                                                                   (0x307c)
#define HWIO_WBM_R2_WBM2TQM_LINK_RING_TP_RMSK                                                                       0xffff
#define HWIO_WBM_R2_WBM2TQM_LINK_RING_TP_POR                                                                    0x00000000
#define HWIO_WBM_R2_WBM2TQM_LINK_RING_TP_POR_RMSK                                                               0xffffffff
#define HWIO_WBM_R2_WBM2TQM_LINK_RING_TP_ATTR                                                                                0x3
#define HWIO_WBM_R2_WBM2TQM_LINK_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2TQM_LINK_RING_TP_ADDR(x))
#define HWIO_WBM_R2_WBM2TQM_LINK_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2TQM_LINK_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2TQM_LINK_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2TQM_LINK_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2TQM_LINK_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2TQM_LINK_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_WBM2TQM_LINK_RING_TP_IN(x))
#define HWIO_WBM_R2_WBM2TQM_LINK_RING_TP_TAIL_PTR_BMSK                                                              0xffff
#define HWIO_WBM_R2_WBM2TQM_LINK_RING_TP_TAIL_PTR_SHFT                                                                   0

#define HWIO_WBM_R2_WBM2REO_LINK_RING_HP_ADDR(x)                                                                ((x) + 0x3080)
#define HWIO_WBM_R2_WBM2REO_LINK_RING_HP_PHYS(x)                                                                ((x) + 0x3080)
#define HWIO_WBM_R2_WBM2REO_LINK_RING_HP_OFFS                                                                   (0x3080)
#define HWIO_WBM_R2_WBM2REO_LINK_RING_HP_RMSK                                                                       0xffff
#define HWIO_WBM_R2_WBM2REO_LINK_RING_HP_POR                                                                    0x00000000
#define HWIO_WBM_R2_WBM2REO_LINK_RING_HP_POR_RMSK                                                               0xffffffff
#define HWIO_WBM_R2_WBM2REO_LINK_RING_HP_ATTR                                                                                0x3
#define HWIO_WBM_R2_WBM2REO_LINK_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2REO_LINK_RING_HP_ADDR(x))
#define HWIO_WBM_R2_WBM2REO_LINK_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2REO_LINK_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2REO_LINK_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2REO_LINK_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2REO_LINK_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2REO_LINK_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_WBM2REO_LINK_RING_HP_IN(x))
#define HWIO_WBM_R2_WBM2REO_LINK_RING_HP_HEAD_PTR_BMSK                                                              0xffff
#define HWIO_WBM_R2_WBM2REO_LINK_RING_HP_HEAD_PTR_SHFT                                                                   0

#define HWIO_WBM_R2_WBM2REO_LINK_RING_TP_ADDR(x)                                                                ((x) + 0x3084)
#define HWIO_WBM_R2_WBM2REO_LINK_RING_TP_PHYS(x)                                                                ((x) + 0x3084)
#define HWIO_WBM_R2_WBM2REO_LINK_RING_TP_OFFS                                                                   (0x3084)
#define HWIO_WBM_R2_WBM2REO_LINK_RING_TP_RMSK                                                                       0xffff
#define HWIO_WBM_R2_WBM2REO_LINK_RING_TP_POR                                                                    0x00000000
#define HWIO_WBM_R2_WBM2REO_LINK_RING_TP_POR_RMSK                                                               0xffffffff
#define HWIO_WBM_R2_WBM2REO_LINK_RING_TP_ATTR                                                                                0x3
#define HWIO_WBM_R2_WBM2REO_LINK_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2REO_LINK_RING_TP_ADDR(x))
#define HWIO_WBM_R2_WBM2REO_LINK_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2REO_LINK_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2REO_LINK_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2REO_LINK_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2REO_LINK_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2REO_LINK_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_WBM2REO_LINK_RING_TP_IN(x))
#define HWIO_WBM_R2_WBM2REO_LINK_RING_TP_TAIL_PTR_BMSK                                                              0xffff
#define HWIO_WBM_R2_WBM2REO_LINK_RING_TP_TAIL_PTR_SHFT                                                                   0

#define HWIO_WBM_R2_WBM2SW_LINK_RING_HP_ADDR(x)                                                                 ((x) + 0x3088)
#define HWIO_WBM_R2_WBM2SW_LINK_RING_HP_PHYS(x)                                                                 ((x) + 0x3088)
#define HWIO_WBM_R2_WBM2SW_LINK_RING_HP_OFFS                                                                    (0x3088)
#define HWIO_WBM_R2_WBM2SW_LINK_RING_HP_RMSK                                                                        0xffff
#define HWIO_WBM_R2_WBM2SW_LINK_RING_HP_POR                                                                     0x00000000
#define HWIO_WBM_R2_WBM2SW_LINK_RING_HP_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R2_WBM2SW_LINK_RING_HP_ATTR                                                                                 0x3
#define HWIO_WBM_R2_WBM2SW_LINK_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2SW_LINK_RING_HP_ADDR(x))
#define HWIO_WBM_R2_WBM2SW_LINK_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2SW_LINK_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2SW_LINK_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2SW_LINK_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2SW_LINK_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2SW_LINK_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_WBM2SW_LINK_RING_HP_IN(x))
#define HWIO_WBM_R2_WBM2SW_LINK_RING_HP_HEAD_PTR_BMSK                                                               0xffff
#define HWIO_WBM_R2_WBM2SW_LINK_RING_HP_HEAD_PTR_SHFT                                                                    0

#define HWIO_WBM_R2_WBM2SW_LINK_RING_TP_ADDR(x)                                                                 ((x) + 0x308c)
#define HWIO_WBM_R2_WBM2SW_LINK_RING_TP_PHYS(x)                                                                 ((x) + 0x308c)
#define HWIO_WBM_R2_WBM2SW_LINK_RING_TP_OFFS                                                                    (0x308c)
#define HWIO_WBM_R2_WBM2SW_LINK_RING_TP_RMSK                                                                        0xffff
#define HWIO_WBM_R2_WBM2SW_LINK_RING_TP_POR                                                                     0x00000000
#define HWIO_WBM_R2_WBM2SW_LINK_RING_TP_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R2_WBM2SW_LINK_RING_TP_ATTR                                                                                 0x3
#define HWIO_WBM_R2_WBM2SW_LINK_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2SW_LINK_RING_TP_ADDR(x))
#define HWIO_WBM_R2_WBM2SW_LINK_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2SW_LINK_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2SW_LINK_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2SW_LINK_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2SW_LINK_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2SW_LINK_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_WBM2SW_LINK_RING_TP_IN(x))
#define HWIO_WBM_R2_WBM2SW_LINK_RING_TP_TAIL_PTR_BMSK                                                               0xffff
#define HWIO_WBM_R2_WBM2SW_LINK_RING_TP_TAIL_PTR_SHFT                                                                    0

#define HWIO_WBM_R2_WBM2FW_LINK_RING_HP_ADDR(x)                                                                 ((x) + 0x3090)
#define HWIO_WBM_R2_WBM2FW_LINK_RING_HP_PHYS(x)                                                                 ((x) + 0x3090)
#define HWIO_WBM_R2_WBM2FW_LINK_RING_HP_OFFS                                                                    (0x3090)
#define HWIO_WBM_R2_WBM2FW_LINK_RING_HP_RMSK                                                                        0xffff
#define HWIO_WBM_R2_WBM2FW_LINK_RING_HP_POR                                                                     0x00000000
#define HWIO_WBM_R2_WBM2FW_LINK_RING_HP_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R2_WBM2FW_LINK_RING_HP_ATTR                                                                                 0x3
#define HWIO_WBM_R2_WBM2FW_LINK_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2FW_LINK_RING_HP_ADDR(x))
#define HWIO_WBM_R2_WBM2FW_LINK_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2FW_LINK_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2FW_LINK_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2FW_LINK_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2FW_LINK_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2FW_LINK_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_WBM2FW_LINK_RING_HP_IN(x))
#define HWIO_WBM_R2_WBM2FW_LINK_RING_HP_HEAD_PTR_BMSK                                                               0xffff
#define HWIO_WBM_R2_WBM2FW_LINK_RING_HP_HEAD_PTR_SHFT                                                                    0

#define HWIO_WBM_R2_WBM2FW_LINK_RING_TP_ADDR(x)                                                                 ((x) + 0x3094)
#define HWIO_WBM_R2_WBM2FW_LINK_RING_TP_PHYS(x)                                                                 ((x) + 0x3094)
#define HWIO_WBM_R2_WBM2FW_LINK_RING_TP_OFFS                                                                    (0x3094)
#define HWIO_WBM_R2_WBM2FW_LINK_RING_TP_RMSK                                                                        0xffff
#define HWIO_WBM_R2_WBM2FW_LINK_RING_TP_POR                                                                     0x00000000
#define HWIO_WBM_R2_WBM2FW_LINK_RING_TP_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R2_WBM2FW_LINK_RING_TP_ATTR                                                                                 0x3
#define HWIO_WBM_R2_WBM2FW_LINK_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2FW_LINK_RING_TP_ADDR(x))
#define HWIO_WBM_R2_WBM2FW_LINK_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2FW_LINK_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2FW_LINK_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2FW_LINK_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2FW_LINK_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2FW_LINK_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_WBM2FW_LINK_RING_TP_IN(x))
#define HWIO_WBM_R2_WBM2FW_LINK_RING_TP_TAIL_PTR_BMSK                                                               0xffff
#define HWIO_WBM_R2_WBM2FW_LINK_RING_TP_TAIL_PTR_SHFT                                                                    0

#define HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_HP_ADDR(x)                                                             ((x) + 0x3098)
#define HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_HP_PHYS(x)                                                             ((x) + 0x3098)
#define HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_HP_OFFS                                                                (0x3098)
#define HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_HP_RMSK                                                                    0xffff
#define HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_HP_POR                                                                 0x00000000
#define HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_HP_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_HP_ATTR                                                                             0x3
#define HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_HP_ADDR(x))
#define HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_HP_IN(x))
#define HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_HP_HEAD_PTR_BMSK                                                           0xffff
#define HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_HP_HEAD_PTR_SHFT                                                                0

#define HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_TP_ADDR(x)                                                             ((x) + 0x309c)
#define HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_TP_PHYS(x)                                                             ((x) + 0x309c)
#define HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_TP_OFFS                                                                (0x309c)
#define HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_TP_RMSK                                                                    0xffff
#define HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_TP_POR                                                                 0x00000000
#define HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_TP_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_TP_ATTR                                                                             0x3
#define HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_TP_ADDR(x))
#define HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_TP_IN(x))
#define HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_TP_TAIL_PTR_BMSK                                                           0xffff
#define HWIO_WBM_R2_WBM2RXDMA0_LINK_RING_TP_TAIL_PTR_SHFT                                                                0

#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_ADDR(x)                                                               ((x) + 0x30b8)
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_PHYS(x)                                                               ((x) + 0x30b8)
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_OFFS                                                                  (0x30b8)
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_RMSK                                                                     0xfffff
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_POR                                                                   0x00000000
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_ATTR                                                                               0x3
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_ADDR(x))
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_IN(x))
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_HEAD_PTR_BMSK                                                            0xfffff
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_HP_HEAD_PTR_SHFT                                                                  0

#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_ADDR(x)                                                               ((x) + 0x30bc)
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_PHYS(x)                                                               ((x) + 0x30bc)
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_OFFS                                                                  (0x30bc)
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_RMSK                                                                     0xfffff
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_POR                                                                   0x00000000
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_POR_RMSK                                                              0xffffffff
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_ATTR                                                                               0x3
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_ADDR(x))
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_IN(x))
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_TAIL_PTR_BMSK                                                            0xfffff
#define HWIO_WBM_R2_WBM_IDLE_LINK_RING_TP_TAIL_PTR_SHFT                                                                  0

#define HWIO_WBM_R2_WBM2FW_RELEASE_RING_HP_ADDR(x)                                                              ((x) + 0x30c0)
#define HWIO_WBM_R2_WBM2FW_RELEASE_RING_HP_PHYS(x)                                                              ((x) + 0x30c0)
#define HWIO_WBM_R2_WBM2FW_RELEASE_RING_HP_OFFS                                                                 (0x30c0)
#define HWIO_WBM_R2_WBM2FW_RELEASE_RING_HP_RMSK                                                                     0xffff
#define HWIO_WBM_R2_WBM2FW_RELEASE_RING_HP_POR                                                                  0x00000000
#define HWIO_WBM_R2_WBM2FW_RELEASE_RING_HP_POR_RMSK                                                             0xffffffff
#define HWIO_WBM_R2_WBM2FW_RELEASE_RING_HP_ATTR                                                                              0x3
#define HWIO_WBM_R2_WBM2FW_RELEASE_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2FW_RELEASE_RING_HP_ADDR(x))
#define HWIO_WBM_R2_WBM2FW_RELEASE_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2FW_RELEASE_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2FW_RELEASE_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2FW_RELEASE_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2FW_RELEASE_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2FW_RELEASE_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_WBM2FW_RELEASE_RING_HP_IN(x))
#define HWIO_WBM_R2_WBM2FW_RELEASE_RING_HP_HEAD_PTR_BMSK                                                            0xffff
#define HWIO_WBM_R2_WBM2FW_RELEASE_RING_HP_HEAD_PTR_SHFT                                                                 0

#define HWIO_WBM_R2_WBM2FW_RELEASE_RING_TP_ADDR(x)                                                              ((x) + 0x30c4)
#define HWIO_WBM_R2_WBM2FW_RELEASE_RING_TP_PHYS(x)                                                              ((x) + 0x30c4)
#define HWIO_WBM_R2_WBM2FW_RELEASE_RING_TP_OFFS                                                                 (0x30c4)
#define HWIO_WBM_R2_WBM2FW_RELEASE_RING_TP_RMSK                                                                     0xffff
#define HWIO_WBM_R2_WBM2FW_RELEASE_RING_TP_POR                                                                  0x00000000
#define HWIO_WBM_R2_WBM2FW_RELEASE_RING_TP_POR_RMSK                                                             0xffffffff
#define HWIO_WBM_R2_WBM2FW_RELEASE_RING_TP_ATTR                                                                              0x3
#define HWIO_WBM_R2_WBM2FW_RELEASE_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2FW_RELEASE_RING_TP_ADDR(x))
#define HWIO_WBM_R2_WBM2FW_RELEASE_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2FW_RELEASE_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2FW_RELEASE_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2FW_RELEASE_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2FW_RELEASE_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2FW_RELEASE_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_WBM2FW_RELEASE_RING_TP_IN(x))
#define HWIO_WBM_R2_WBM2FW_RELEASE_RING_TP_TAIL_PTR_BMSK                                                            0xffff
#define HWIO_WBM_R2_WBM2FW_RELEASE_RING_TP_TAIL_PTR_SHFT                                                                 0

#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_ADDR(x)                                                             ((x) + 0x30c8)
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_PHYS(x)                                                             ((x) + 0x30c8)
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_OFFS                                                                (0x30c8)
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_RMSK                                                                   0xfffff
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_POR                                                                 0x00000000
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_ATTR                                                                             0x3
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_ADDR(x))
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_IN(x))
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_HEAD_PTR_BMSK                                                          0xfffff
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_HP_HEAD_PTR_SHFT                                                                0

#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_ADDR(x)                                                             ((x) + 0x30cc)
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_PHYS(x)                                                             ((x) + 0x30cc)
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_OFFS                                                                (0x30cc)
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_RMSK                                                                   0xfffff
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_POR                                                                 0x00000000
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_ATTR                                                                             0x3
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_ADDR(x))
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_IN(x))
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_TAIL_PTR_BMSK                                                          0xfffff
#define HWIO_WBM_R2_WBM2SW0_RELEASE_RING_TP_TAIL_PTR_SHFT                                                                0

#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_ADDR(x)                                                             ((x) + 0x30d0)
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_PHYS(x)                                                             ((x) + 0x30d0)
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_OFFS                                                                (0x30d0)
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_RMSK                                                                   0xfffff
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_POR                                                                 0x00000000
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_ATTR                                                                             0x3
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_ADDR(x))
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_IN(x))
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_HEAD_PTR_BMSK                                                          0xfffff
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_HP_HEAD_PTR_SHFT                                                                0

#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_ADDR(x)                                                             ((x) + 0x30d4)
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_PHYS(x)                                                             ((x) + 0x30d4)
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_OFFS                                                                (0x30d4)
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_RMSK                                                                   0xfffff
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_POR                                                                 0x00000000
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_ATTR                                                                             0x3
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_ADDR(x))
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_IN(x))
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_TAIL_PTR_BMSK                                                          0xfffff
#define HWIO_WBM_R2_WBM2SW1_RELEASE_RING_TP_TAIL_PTR_SHFT                                                                0

#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_ADDR(x)                                                             ((x) + 0x30d8)
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_PHYS(x)                                                             ((x) + 0x30d8)
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_OFFS                                                                (0x30d8)
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_RMSK                                                                   0xfffff
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_POR                                                                 0x00000000
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_ATTR                                                                             0x3
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_ADDR(x))
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_IN(x))
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_HEAD_PTR_BMSK                                                          0xfffff
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_HP_HEAD_PTR_SHFT                                                                0

#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_ADDR(x)                                                             ((x) + 0x30dc)
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_PHYS(x)                                                             ((x) + 0x30dc)
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_OFFS                                                                (0x30dc)
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_RMSK                                                                   0xfffff
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_POR                                                                 0x00000000
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_ATTR                                                                             0x3
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_ADDR(x))
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_IN(x))
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_TAIL_PTR_BMSK                                                          0xfffff
#define HWIO_WBM_R2_WBM2SW2_RELEASE_RING_TP_TAIL_PTR_SHFT                                                                0

#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_ADDR(x)                                                             ((x) + 0x30e0)
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_PHYS(x)                                                             ((x) + 0x30e0)
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_OFFS                                                                (0x30e0)
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_RMSK                                                                   0xfffff
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_POR                                                                 0x00000000
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_ATTR                                                                             0x3
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_ADDR(x))
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_IN(x))
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_HEAD_PTR_BMSK                                                          0xfffff
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_HP_HEAD_PTR_SHFT                                                                0

#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_ADDR(x)                                                             ((x) + 0x30e4)
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_PHYS(x)                                                             ((x) + 0x30e4)
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_OFFS                                                                (0x30e4)
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_RMSK                                                                   0xfffff
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_POR                                                                 0x00000000
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_ATTR                                                                             0x3
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_ADDR(x))
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_IN(x))
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_TAIL_PTR_BMSK                                                          0xfffff
#define HWIO_WBM_R2_WBM2SW3_RELEASE_RING_TP_TAIL_PTR_SHFT                                                                0

#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_ADDR(x)                                                             ((x) + 0x30e8)
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_PHYS(x)                                                             ((x) + 0x30e8)
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_OFFS                                                                (0x30e8)
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_RMSK                                                                   0xfffff
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_POR                                                                 0x00000000
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_ATTR                                                                             0x3
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_ADDR(x))
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_IN(x))
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_HEAD_PTR_BMSK                                                          0xfffff
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_HP_HEAD_PTR_SHFT                                                                0

#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_ADDR(x)                                                             ((x) + 0x30ec)
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_PHYS(x)                                                             ((x) + 0x30ec)
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_OFFS                                                                (0x30ec)
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_RMSK                                                                   0xfffff
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_POR                                                                 0x00000000
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_ATTR                                                                             0x3
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_ADDR(x))
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_IN(x))
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_TAIL_PTR_BMSK                                                          0xfffff
#define HWIO_WBM_R2_WBM2SW4_RELEASE_RING_TP_TAIL_PTR_SHFT                                                                0

#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_ADDR(x)                                                             ((x) + 0x30f0)
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_PHYS(x)                                                             ((x) + 0x30f0)
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_OFFS                                                                (0x30f0)
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_RMSK                                                                   0xfffff
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_POR                                                                 0x00000000
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_ATTR                                                                             0x3
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_ADDR(x))
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_IN(x))
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_HEAD_PTR_BMSK                                                          0xfffff
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_HP_HEAD_PTR_SHFT                                                                0

#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_ADDR(x)                                                             ((x) + 0x30f4)
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_PHYS(x)                                                             ((x) + 0x30f4)
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_OFFS                                                                (0x30f4)
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_RMSK                                                                   0xfffff
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_POR                                                                 0x00000000
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_ATTR                                                                             0x3
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_ADDR(x))
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_IN(x))
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_TAIL_PTR_BMSK                                                          0xfffff
#define HWIO_WBM_R2_WBM2SW5_RELEASE_RING_TP_TAIL_PTR_SHFT                                                                0

#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_ADDR(x)                                                             ((x) + 0x30f8)
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_PHYS(x)                                                             ((x) + 0x30f8)
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_OFFS                                                                (0x30f8)
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_RMSK                                                                   0xfffff
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_POR                                                                 0x00000000
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_ATTR                                                                             0x3
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_ADDR(x))
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_IN(x))
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_HEAD_PTR_BMSK                                                          0xfffff
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_HP_HEAD_PTR_SHFT                                                                0

#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_ADDR(x)                                                             ((x) + 0x30fc)
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_PHYS(x)                                                             ((x) + 0x30fc)
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_OFFS                                                                (0x30fc)
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_RMSK                                                                   0xfffff
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_POR                                                                 0x00000000
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_POR_RMSK                                                            0xffffffff
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_ATTR                                                                             0x3
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_ADDR(x))
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_IN(x))
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_TAIL_PTR_BMSK                                                          0xfffff
#define HWIO_WBM_R2_WBM2SW6_RELEASE_RING_TP_TAIL_PTR_SHFT                                                                0

#define HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_HP_ADDR(x)                                                           ((x) + 0x3100)
#define HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_HP_PHYS(x)                                                           ((x) + 0x3100)
#define HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_HP_OFFS                                                              (0x3100)
#define HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_HP_RMSK                                                                 0xfffff
#define HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_HP_POR                                                               0x00000000
#define HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_HP_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_HP_ATTR                                                                           0x3
#define HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_HP_ADDR(x))
#define HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_HP_IN(x))
#define HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_HP_HEAD_PTR_BMSK                                                        0xfffff
#define HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_HP_HEAD_PTR_SHFT                                                              0

#define HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_TP_ADDR(x)                                                           ((x) + 0x3104)
#define HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_TP_PHYS(x)                                                           ((x) + 0x3104)
#define HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_TP_OFFS                                                              (0x3104)
#define HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_TP_RMSK                                                                 0xfffff
#define HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_TP_POR                                                               0x00000000
#define HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_TP_POR_RMSK                                                          0xffffffff
#define HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_TP_ATTR                                                                           0x3
#define HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_TP_ADDR(x))
#define HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_TP_IN(x))
#define HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_TP_TAIL_PTR_BMSK                                                        0xfffff
#define HWIO_WBM_R2_WBM_ERROR_RELEASE_RING_TP_TAIL_PTR_SHFT                                                              0

#define HWIO_WBM_R2_WBM2WBM_IN1_RING_HP_ADDR(x)                                                                 ((x) + 0x3108)
#define HWIO_WBM_R2_WBM2WBM_IN1_RING_HP_PHYS(x)                                                                 ((x) + 0x3108)
#define HWIO_WBM_R2_WBM2WBM_IN1_RING_HP_OFFS                                                                    (0x3108)
#define HWIO_WBM_R2_WBM2WBM_IN1_RING_HP_RMSK                                                                        0xffff
#define HWIO_WBM_R2_WBM2WBM_IN1_RING_HP_POR                                                                     0x00000000
#define HWIO_WBM_R2_WBM2WBM_IN1_RING_HP_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R2_WBM2WBM_IN1_RING_HP_ATTR                                                                                 0x3
#define HWIO_WBM_R2_WBM2WBM_IN1_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2WBM_IN1_RING_HP_ADDR(x))
#define HWIO_WBM_R2_WBM2WBM_IN1_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2WBM_IN1_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2WBM_IN1_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2WBM_IN1_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2WBM_IN1_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2WBM_IN1_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_WBM2WBM_IN1_RING_HP_IN(x))
#define HWIO_WBM_R2_WBM2WBM_IN1_RING_HP_HEAD_PTR_BMSK                                                               0xffff
#define HWIO_WBM_R2_WBM2WBM_IN1_RING_HP_HEAD_PTR_SHFT                                                                    0

#define HWIO_WBM_R2_WBM2WBM_IN1_RING_TP_ADDR(x)                                                                 ((x) + 0x310c)
#define HWIO_WBM_R2_WBM2WBM_IN1_RING_TP_PHYS(x)                                                                 ((x) + 0x310c)
#define HWIO_WBM_R2_WBM2WBM_IN1_RING_TP_OFFS                                                                    (0x310c)
#define HWIO_WBM_R2_WBM2WBM_IN1_RING_TP_RMSK                                                                        0xffff
#define HWIO_WBM_R2_WBM2WBM_IN1_RING_TP_POR                                                                     0x00000000
#define HWIO_WBM_R2_WBM2WBM_IN1_RING_TP_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R2_WBM2WBM_IN1_RING_TP_ATTR                                                                                 0x3
#define HWIO_WBM_R2_WBM2WBM_IN1_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2WBM_IN1_RING_TP_ADDR(x))
#define HWIO_WBM_R2_WBM2WBM_IN1_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2WBM_IN1_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2WBM_IN1_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2WBM_IN1_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2WBM_IN1_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2WBM_IN1_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_WBM2WBM_IN1_RING_TP_IN(x))
#define HWIO_WBM_R2_WBM2WBM_IN1_RING_TP_TAIL_PTR_BMSK                                                               0xffff
#define HWIO_WBM_R2_WBM2WBM_IN1_RING_TP_TAIL_PTR_SHFT                                                                    0

#define HWIO_WBM_R2_WBM2WBM_IN2_RING_HP_ADDR(x)                                                                 ((x) + 0x3110)
#define HWIO_WBM_R2_WBM2WBM_IN2_RING_HP_PHYS(x)                                                                 ((x) + 0x3110)
#define HWIO_WBM_R2_WBM2WBM_IN2_RING_HP_OFFS                                                                    (0x3110)
#define HWIO_WBM_R2_WBM2WBM_IN2_RING_HP_RMSK                                                                        0xffff
#define HWIO_WBM_R2_WBM2WBM_IN2_RING_HP_POR                                                                     0x00000000
#define HWIO_WBM_R2_WBM2WBM_IN2_RING_HP_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R2_WBM2WBM_IN2_RING_HP_ATTR                                                                                 0x3
#define HWIO_WBM_R2_WBM2WBM_IN2_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2WBM_IN2_RING_HP_ADDR(x))
#define HWIO_WBM_R2_WBM2WBM_IN2_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2WBM_IN2_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2WBM_IN2_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2WBM_IN2_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2WBM_IN2_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2WBM_IN2_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_WBM2WBM_IN2_RING_HP_IN(x))
#define HWIO_WBM_R2_WBM2WBM_IN2_RING_HP_HEAD_PTR_BMSK                                                               0xffff
#define HWIO_WBM_R2_WBM2WBM_IN2_RING_HP_HEAD_PTR_SHFT                                                                    0

#define HWIO_WBM_R2_WBM2WBM_IN2_RING_TP_ADDR(x)                                                                 ((x) + 0x3114)
#define HWIO_WBM_R2_WBM2WBM_IN2_RING_TP_PHYS(x)                                                                 ((x) + 0x3114)
#define HWIO_WBM_R2_WBM2WBM_IN2_RING_TP_OFFS                                                                    (0x3114)
#define HWIO_WBM_R2_WBM2WBM_IN2_RING_TP_RMSK                                                                        0xffff
#define HWIO_WBM_R2_WBM2WBM_IN2_RING_TP_POR                                                                     0x00000000
#define HWIO_WBM_R2_WBM2WBM_IN2_RING_TP_POR_RMSK                                                                0xffffffff
#define HWIO_WBM_R2_WBM2WBM_IN2_RING_TP_ATTR                                                                                 0x3
#define HWIO_WBM_R2_WBM2WBM_IN2_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2WBM_IN2_RING_TP_ADDR(x))
#define HWIO_WBM_R2_WBM2WBM_IN2_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2WBM_IN2_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2WBM_IN2_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2WBM_IN2_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2WBM_IN2_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2WBM_IN2_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_WBM2WBM_IN2_RING_TP_IN(x))
#define HWIO_WBM_R2_WBM2WBM_IN2_RING_TP_TAIL_PTR_BMSK                                                               0xffff
#define HWIO_WBM_R2_WBM2WBM_IN2_RING_TP_TAIL_PTR_SHFT                                                                    0

#define HWIO_WBM_R2_WBM2WBM_OUT1_RING_HP_ADDR(x)                                                                ((x) + 0x3118)
#define HWIO_WBM_R2_WBM2WBM_OUT1_RING_HP_PHYS(x)                                                                ((x) + 0x3118)
#define HWIO_WBM_R2_WBM2WBM_OUT1_RING_HP_OFFS                                                                   (0x3118)
#define HWIO_WBM_R2_WBM2WBM_OUT1_RING_HP_RMSK                                                                       0xffff
#define HWIO_WBM_R2_WBM2WBM_OUT1_RING_HP_POR                                                                    0x00000000
#define HWIO_WBM_R2_WBM2WBM_OUT1_RING_HP_POR_RMSK                                                               0xffffffff
#define HWIO_WBM_R2_WBM2WBM_OUT1_RING_HP_ATTR                                                                                0x3
#define HWIO_WBM_R2_WBM2WBM_OUT1_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2WBM_OUT1_RING_HP_ADDR(x))
#define HWIO_WBM_R2_WBM2WBM_OUT1_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2WBM_OUT1_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2WBM_OUT1_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2WBM_OUT1_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2WBM_OUT1_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2WBM_OUT1_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_WBM2WBM_OUT1_RING_HP_IN(x))
#define HWIO_WBM_R2_WBM2WBM_OUT1_RING_HP_HEAD_PTR_BMSK                                                              0xffff
#define HWIO_WBM_R2_WBM2WBM_OUT1_RING_HP_HEAD_PTR_SHFT                                                                   0

#define HWIO_WBM_R2_WBM2WBM_OUT1_RING_TP_ADDR(x)                                                                ((x) + 0x311c)
#define HWIO_WBM_R2_WBM2WBM_OUT1_RING_TP_PHYS(x)                                                                ((x) + 0x311c)
#define HWIO_WBM_R2_WBM2WBM_OUT1_RING_TP_OFFS                                                                   (0x311c)
#define HWIO_WBM_R2_WBM2WBM_OUT1_RING_TP_RMSK                                                                       0xffff
#define HWIO_WBM_R2_WBM2WBM_OUT1_RING_TP_POR                                                                    0x00000000
#define HWIO_WBM_R2_WBM2WBM_OUT1_RING_TP_POR_RMSK                                                               0xffffffff
#define HWIO_WBM_R2_WBM2WBM_OUT1_RING_TP_ATTR                                                                                0x3
#define HWIO_WBM_R2_WBM2WBM_OUT1_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2WBM_OUT1_RING_TP_ADDR(x))
#define HWIO_WBM_R2_WBM2WBM_OUT1_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2WBM_OUT1_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2WBM_OUT1_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2WBM_OUT1_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2WBM_OUT1_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2WBM_OUT1_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_WBM2WBM_OUT1_RING_TP_IN(x))
#define HWIO_WBM_R2_WBM2WBM_OUT1_RING_TP_TAIL_PTR_BMSK                                                              0xffff
#define HWIO_WBM_R2_WBM2WBM_OUT1_RING_TP_TAIL_PTR_SHFT                                                                   0

#define HWIO_WBM_R2_WBM2WBM_OUT2_RING_HP_ADDR(x)                                                                ((x) + 0x3120)
#define HWIO_WBM_R2_WBM2WBM_OUT2_RING_HP_PHYS(x)                                                                ((x) + 0x3120)
#define HWIO_WBM_R2_WBM2WBM_OUT2_RING_HP_OFFS                                                                   (0x3120)
#define HWIO_WBM_R2_WBM2WBM_OUT2_RING_HP_RMSK                                                                       0xffff
#define HWIO_WBM_R2_WBM2WBM_OUT2_RING_HP_POR                                                                    0x00000000
#define HWIO_WBM_R2_WBM2WBM_OUT2_RING_HP_POR_RMSK                                                               0xffffffff
#define HWIO_WBM_R2_WBM2WBM_OUT2_RING_HP_ATTR                                                                                0x3
#define HWIO_WBM_R2_WBM2WBM_OUT2_RING_HP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2WBM_OUT2_RING_HP_ADDR(x))
#define HWIO_WBM_R2_WBM2WBM_OUT2_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2WBM_OUT2_RING_HP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2WBM_OUT2_RING_HP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2WBM_OUT2_RING_HP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2WBM_OUT2_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2WBM_OUT2_RING_HP_ADDR(x),m,v,HWIO_WBM_R2_WBM2WBM_OUT2_RING_HP_IN(x))
#define HWIO_WBM_R2_WBM2WBM_OUT2_RING_HP_HEAD_PTR_BMSK                                                              0xffff
#define HWIO_WBM_R2_WBM2WBM_OUT2_RING_HP_HEAD_PTR_SHFT                                                                   0

#define HWIO_WBM_R2_WBM2WBM_OUT2_RING_TP_ADDR(x)                                                                ((x) + 0x3124)
#define HWIO_WBM_R2_WBM2WBM_OUT2_RING_TP_PHYS(x)                                                                ((x) + 0x3124)
#define HWIO_WBM_R2_WBM2WBM_OUT2_RING_TP_OFFS                                                                   (0x3124)
#define HWIO_WBM_R2_WBM2WBM_OUT2_RING_TP_RMSK                                                                       0xffff
#define HWIO_WBM_R2_WBM2WBM_OUT2_RING_TP_POR                                                                    0x00000000
#define HWIO_WBM_R2_WBM2WBM_OUT2_RING_TP_POR_RMSK                                                               0xffffffff
#define HWIO_WBM_R2_WBM2WBM_OUT2_RING_TP_ATTR                                                                                0x3
#define HWIO_WBM_R2_WBM2WBM_OUT2_RING_TP_IN(x)            \
                in_dword(HWIO_WBM_R2_WBM2WBM_OUT2_RING_TP_ADDR(x))
#define HWIO_WBM_R2_WBM2WBM_OUT2_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_WBM_R2_WBM2WBM_OUT2_RING_TP_ADDR(x), m)
#define HWIO_WBM_R2_WBM2WBM_OUT2_RING_TP_OUT(x, v)            \
                out_dword(HWIO_WBM_R2_WBM2WBM_OUT2_RING_TP_ADDR(x),v)
#define HWIO_WBM_R2_WBM2WBM_OUT2_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_WBM_R2_WBM2WBM_OUT2_RING_TP_ADDR(x),m,v,HWIO_WBM_R2_WBM2WBM_OUT2_RING_TP_IN(x))
#define HWIO_WBM_R2_WBM2WBM_OUT2_RING_TP_TAIL_PTR_BMSK                                                              0xffff
#define HWIO_WBM_R2_WBM2WBM_OUT2_RING_TP_TAIL_PTR_SHFT                                                                   0

/*----------------------------------------------------------------------------
 * MODULE: REO_REG
 *--------------------------------------------------------------------------*/

#define REO_REG_REG_BASE                                                                                               (UMAC_BASE      + 0x00038000)
#define REO_REG_REG_BASE_SIZE                                                                                          0x4000
#define REO_REG_REG_BASE_USED                                                                                          0x30ac
#define REO_REG_REG_BASE_PHYS                                                                                          (UMAC_BASE_PHYS + 0x00038000)
#define REO_REG_REG_BASE_OFFS                                                                                          0x00038000

#define HWIO_REO_R0_GENERAL_ENABLE_ADDR(x)                                                                             ((x) + 0x0)
#define HWIO_REO_R0_GENERAL_ENABLE_PHYS(x)                                                                             ((x) + 0x0)
#define HWIO_REO_R0_GENERAL_ENABLE_OFFS                                                                                (0x0)
#define HWIO_REO_R0_GENERAL_ENABLE_RMSK                                                                                0xffffffff
#define HWIO_REO_R0_GENERAL_ENABLE_POR                                                                                 0x00000100
#define HWIO_REO_R0_GENERAL_ENABLE_POR_RMSK                                                                            0xffffffff
#define HWIO_REO_R0_GENERAL_ENABLE_ATTR                                                                                             0x3
#define HWIO_REO_R0_GENERAL_ENABLE_IN(x)            \
                in_dword(HWIO_REO_R0_GENERAL_ENABLE_ADDR(x))
#define HWIO_REO_R0_GENERAL_ENABLE_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_GENERAL_ENABLE_ADDR(x), m)
#define HWIO_REO_R0_GENERAL_ENABLE_OUT(x, v)            \
                out_dword(HWIO_REO_R0_GENERAL_ENABLE_ADDR(x),v)
#define HWIO_REO_R0_GENERAL_ENABLE_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_GENERAL_ENABLE_ADDR(x),m,v,HWIO_REO_R0_GENERAL_ENABLE_IN(x))
#define HWIO_REO_R0_GENERAL_ENABLE_SW2REO1_RING_ENABLE_BMSK                                                            0x80000000
#define HWIO_REO_R0_GENERAL_ENABLE_SW2REO1_RING_ENABLE_SHFT                                                                    31
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW6_RING_ENABLE_BMSK                                                            0x40000000
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW6_RING_ENABLE_SHFT                                                                    30
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW5_RING_ENABLE_BMSK                                                            0x20000000
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW5_RING_ENABLE_SHFT                                                                    29
#define HWIO_REO_R0_GENERAL_ENABLE_INVALIDATE_CACHE_FOR_ZERO_VLD_BMSK                                                  0x10000000
#define HWIO_REO_R0_GENERAL_ENABLE_INVALIDATE_CACHE_FOR_ZERO_VLD_SHFT                                                          28
#define HWIO_REO_R0_GENERAL_ENABLE_STRUCT_SWAP_DELINK_BMSK                                                              0x8000000
#define HWIO_REO_R0_GENERAL_ENABLE_STRUCT_SWAP_DELINK_SHFT                                                                     27
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW8_RING_ENABLE_BMSK                                                             0x4000000
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW8_RING_ENABLE_SHFT                                                                    26
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW7_RING_ENABLE_BMSK                                                             0x2000000
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW7_RING_ENABLE_SHFT                                                                    25
#define HWIO_REO_R0_GENERAL_ENABLE_SW2REO3_RING_ENABLE_BMSK                                                             0x1000000
#define HWIO_REO_R0_GENERAL_ENABLE_SW2REO3_RING_ENABLE_SHFT                                                                    24
#define HWIO_REO_R0_GENERAL_ENABLE_SW2REO2_RING_ENABLE_BMSK                                                              0x800000
#define HWIO_REO_R0_GENERAL_ENABLE_SW2REO2_RING_ENABLE_SHFT                                                                    23
#define HWIO_REO_R0_GENERAL_ENABLE_SW2REO_RING_ENABLE_BMSK                                                               0x400000
#define HWIO_REO_R0_GENERAL_ENABLE_SW2REO_RING_ENABLE_SHFT                                                                     22
#define HWIO_REO_R0_GENERAL_ENABLE_REO_CMD_RING_ENABLE_BMSK                                                              0x200000
#define HWIO_REO_R0_GENERAL_ENABLE_REO_CMD_RING_ENABLE_SHFT                                                                    21
#define HWIO_REO_R0_GENERAL_ENABLE_REO_STATUS_RING_ENABLE_BMSK                                                           0x100000
#define HWIO_REO_R0_GENERAL_ENABLE_REO_STATUS_RING_ENABLE_SHFT                                                                 20
#define HWIO_REO_R0_GENERAL_ENABLE_REO_RELEASE_RING_ENABLE_BMSK                                                           0x80000
#define HWIO_REO_R0_GENERAL_ENABLE_REO_RELEASE_RING_ENABLE_SHFT                                                                19
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW0_RING_ENABLE_BMSK                                                               0x40000
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW0_RING_ENABLE_SHFT                                                                    18
#define HWIO_REO_R0_GENERAL_ENABLE_REO2FW_RING_ENABLE_BMSK                                                                0x20000
#define HWIO_REO_R0_GENERAL_ENABLE_REO2FW_RING_ENABLE_SHFT                                                                     17
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW4_RING_ENABLE_BMSK                                                               0x10000
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW4_RING_ENABLE_SHFT                                                                    16
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW3_RING_ENABLE_BMSK                                                                0x8000
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW3_RING_ENABLE_SHFT                                                                    15
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW2_RING_ENABLE_BMSK                                                                0x4000
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW2_RING_ENABLE_SHFT                                                                    14
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW1_RING_ENABLE_BMSK                                                                0x2000
#define HWIO_REO_R0_GENERAL_ENABLE_REO2SW1_RING_ENABLE_SHFT                                                                    13
#define HWIO_REO_R0_GENERAL_ENABLE_WBM2REO_LINK_RING_ENABLE_BMSK                                                           0x1000
#define HWIO_REO_R0_GENERAL_ENABLE_WBM2REO_LINK_RING_ENABLE_SHFT                                                               12
#define HWIO_REO_R0_GENERAL_ENABLE_RXDMA2REO_RING_ENABLE_BMSK                                                               0xe00
#define HWIO_REO_R0_GENERAL_ENABLE_RXDMA2REO_RING_ENABLE_SHFT                                                                   9
#define HWIO_REO_R0_GENERAL_ENABLE_GLOBAL_PN_CHK_BMSK                                                                       0x100
#define HWIO_REO_R0_GENERAL_ENABLE_GLOBAL_PN_CHK_SHFT                                                                           8
#define HWIO_REO_R0_GENERAL_ENABLE_BACKUP_1_BMSK                                                                             0xe0
#define HWIO_REO_R0_GENERAL_ENABLE_BACKUP_1_SHFT                                                                                5
#define HWIO_REO_R0_GENERAL_ENABLE_REO2PPE_RING_ENABLE_BMSK                                                                  0x10
#define HWIO_REO_R0_GENERAL_ENABLE_REO2PPE_RING_ENABLE_SHFT                                                                     4
#define HWIO_REO_R0_GENERAL_ENABLE_AGING_FLUSH_ENABLE_BMSK                                                                    0x8
#define HWIO_REO_R0_GENERAL_ENABLE_AGING_FLUSH_ENABLE_SHFT                                                                      3
#define HWIO_REO_R0_GENERAL_ENABLE_AGING_LIST_ENABLE_BMSK                                                                     0x4
#define HWIO_REO_R0_GENERAL_ENABLE_AGING_LIST_ENABLE_SHFT                                                                       2
#define HWIO_REO_R0_GENERAL_ENABLE_REO_HWREORDER_DISABLE_BMSK                                                                 0x2
#define HWIO_REO_R0_GENERAL_ENABLE_REO_HWREORDER_DISABLE_SHFT                                                                   1
#define HWIO_REO_R0_GENERAL_ENABLE_REO_ENABLE_BMSK                                                                            0x1
#define HWIO_REO_R0_GENERAL_ENABLE_REO_ENABLE_SHFT                                                                              0

#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_ADDR(x)                                                                 ((x) + 0x4)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_PHYS(x)                                                                 ((x) + 0x4)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_OFFS                                                                    (0x4)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_POR                                                                     0x76543210
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_ATTR                                                                                 0x3
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_IN(x)            \
                in_dword(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_ADDR(x))
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_ADDR(x), m)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_OUT(x, v)            \
                out_dword(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_ADDR(x),v)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_ADDR(x),m,v,HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_IN(x))
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_7_BMSK                                                0xf0000000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_7_SHFT                                                        28
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_6_BMSK                                                 0xf000000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_6_SHFT                                                        24
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_5_BMSK                                                  0xf00000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_5_SHFT                                                        20
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_4_BMSK                                                   0xf0000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_4_SHFT                                                        16
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_3_BMSK                                                    0xf000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_3_SHFT                                                        12
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_2_BMSK                                                     0xf00
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_2_SHFT                                                         8
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_1_BMSK                                                      0xf0
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_1_SHFT                                                         4
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_0_BMSK                                                       0xf
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_0_DEST_RING_MAPPING_0_SHFT                                                         0

#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_ADDR(x)                                                                 ((x) + 0x8)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_PHYS(x)                                                                 ((x) + 0x8)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_OFFS                                                                    (0x8)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_POR                                                                     0x66666668
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_ATTR                                                                                 0x3
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_IN(x)            \
                in_dword(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_ADDR(x))
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_ADDR(x), m)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_ADDR(x),v)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_ADDR(x),m,v,HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_IN(x))
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_15_BMSK                                               0xf0000000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_15_SHFT                                                       28
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_14_BMSK                                                0xf000000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_14_SHFT                                                       24
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_13_BMSK                                                 0xf00000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_13_SHFT                                                       20
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_12_BMSK                                                  0xf0000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_12_SHFT                                                       16
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_11_BMSK                                                   0xf000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_11_SHFT                                                       12
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_10_BMSK                                                    0xf00
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_10_SHFT                                                        8
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_9_BMSK                                                      0xf0
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_9_SHFT                                                         4
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_8_BMSK                                                       0xf
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_1_DEST_RING_MAPPING_8_SHFT                                                         0

#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_ADDR(x)                                                                 ((x) + 0xc)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_PHYS(x)                                                                 ((x) + 0xc)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_OFFS                                                                    (0xc)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_POR                                                                     0x66666666
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_ATTR                                                                                 0x3
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_IN(x)            \
                in_dword(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_ADDR(x))
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_ADDR(x), m)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_OUT(x, v)            \
                out_dword(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_ADDR(x),v)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_ADDR(x),m,v,HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_IN(x))
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_23_BMSK                                               0xf0000000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_23_SHFT                                                       28
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_22_BMSK                                                0xf000000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_22_SHFT                                                       24
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_21_BMSK                                                 0xf00000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_21_SHFT                                                       20
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_20_BMSK                                                  0xf0000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_20_SHFT                                                       16
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_19_BMSK                                                   0xf000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_19_SHFT                                                       12
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_18_BMSK                                                    0xf00
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_18_SHFT                                                        8
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_17_BMSK                                                     0xf0
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_17_SHFT                                                        4
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_16_BMSK                                                      0xf
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_2_DEST_RING_MAPPING_16_SHFT                                                        0

#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_ADDR(x)                                                                 ((x) + 0x10)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_PHYS(x)                                                                 ((x) + 0x10)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_OFFS                                                                    (0x10)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_POR                                                                     0x66666666
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_ATTR                                                                                 0x3
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_IN(x)            \
                in_dword(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_ADDR(x))
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_ADDR(x), m)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_OUT(x, v)            \
                out_dword(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_ADDR(x),v)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_ADDR(x),m,v,HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_IN(x))
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_31_BMSK                                               0xf0000000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_31_SHFT                                                       28
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_30_BMSK                                                0xf000000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_30_SHFT                                                       24
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_29_BMSK                                                 0xf00000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_29_SHFT                                                       20
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_28_BMSK                                                  0xf0000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_28_SHFT                                                       16
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_27_BMSK                                                   0xf000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_27_SHFT                                                       12
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_26_BMSK                                                    0xf00
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_26_SHFT                                                        8
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_25_BMSK                                                     0xf0
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_25_SHFT                                                        4
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_24_BMSK                                                      0xf
#define HWIO_REO_R0_DESTINATION_RING_CTRL_IX_3_DEST_RING_MAPPING_24_SHFT                                                        0

#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_ADDR(x)                                                       ((x) + 0x14)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_PHYS(x)                                                       ((x) + 0x14)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_OFFS                                                          (0x14)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_RMSK                                                          0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_POR                                                           0x76543210
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_ATTR                                                                       0x3
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_IN(x)            \
                in_dword(HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_ADDR(x))
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_ADDR(x), m)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_OUT(x, v)            \
                out_dword(HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_ADDR(x),v)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_ADDR(x),m,v,HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_IN(x))
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_DEST_RING_MAPPING_TID_BASED_7_BMSK                            0xf0000000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_DEST_RING_MAPPING_TID_BASED_7_SHFT                                    28
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_DEST_RING_MAPPING_TID_BASED_6_BMSK                             0xf000000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_DEST_RING_MAPPING_TID_BASED_6_SHFT                                    24
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_DEST_RING_MAPPING_TID_BASED_5_BMSK                              0xf00000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_DEST_RING_MAPPING_TID_BASED_5_SHFT                                    20
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_DEST_RING_MAPPING_TID_BASED_4_BMSK                               0xf0000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_DEST_RING_MAPPING_TID_BASED_4_SHFT                                    16
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_DEST_RING_MAPPING_TID_BASED_3_BMSK                                0xf000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_DEST_RING_MAPPING_TID_BASED_3_SHFT                                    12
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_DEST_RING_MAPPING_TID_BASED_2_BMSK                                 0xf00
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_DEST_RING_MAPPING_TID_BASED_2_SHFT                                     8
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_DEST_RING_MAPPING_TID_BASED_1_BMSK                                  0xf0
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_DEST_RING_MAPPING_TID_BASED_1_SHFT                                     4
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_DEST_RING_MAPPING_TID_BASED_0_BMSK                                   0xf
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_0_DEST_RING_MAPPING_TID_BASED_0_SHFT                                     0

#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_ADDR(x)                                                       ((x) + 0x18)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_PHYS(x)                                                       ((x) + 0x18)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_OFFS                                                          (0x18)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_RMSK                                                          0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_POR                                                           0x66666668
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_ATTR                                                                       0x3
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_IN(x)            \
                in_dword(HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_ADDR(x))
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_ADDR(x), m)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_ADDR(x),v)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_ADDR(x),m,v,HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_IN(x))
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_DEST_RING_MAPPING_TID_BASED_15_BMSK                           0xf0000000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_DEST_RING_MAPPING_TID_BASED_15_SHFT                                   28
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_DEST_RING_MAPPING_TID_BASED_14_BMSK                            0xf000000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_DEST_RING_MAPPING_TID_BASED_14_SHFT                                   24
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_DEST_RING_MAPPING_TID_BASED_13_BMSK                             0xf00000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_DEST_RING_MAPPING_TID_BASED_13_SHFT                                   20
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_DEST_RING_MAPPING_TID_BASED_12_BMSK                              0xf0000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_DEST_RING_MAPPING_TID_BASED_12_SHFT                                   16
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_DEST_RING_MAPPING_TID_BASED_11_BMSK                               0xf000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_DEST_RING_MAPPING_TID_BASED_11_SHFT                                   12
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_DEST_RING_MAPPING_TID_BASED_10_BMSK                                0xf00
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_DEST_RING_MAPPING_TID_BASED_10_SHFT                                    8
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_DEST_RING_MAPPING_TID_BASED_9_BMSK                                  0xf0
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_DEST_RING_MAPPING_TID_BASED_9_SHFT                                     4
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_DEST_RING_MAPPING_TID_BASED_8_BMSK                                   0xf
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_1_DEST_RING_MAPPING_TID_BASED_8_SHFT                                     0

#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_ADDR(x)                                                       ((x) + 0x1c)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_PHYS(x)                                                       ((x) + 0x1c)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_OFFS                                                          (0x1c)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_RMSK                                                          0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_POR                                                           0x66666666
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_ATTR                                                                       0x3
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_IN(x)            \
                in_dword(HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_ADDR(x))
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_ADDR(x), m)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_OUT(x, v)            \
                out_dword(HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_ADDR(x),v)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_ADDR(x),m,v,HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_IN(x))
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_DEST_RING_MAPPING_TID_BASED_23_BMSK                           0xf0000000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_DEST_RING_MAPPING_TID_BASED_23_SHFT                                   28
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_DEST_RING_MAPPING_TID_BASED_22_BMSK                            0xf000000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_DEST_RING_MAPPING_TID_BASED_22_SHFT                                   24
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_DEST_RING_MAPPING_TID_BASED_21_BMSK                             0xf00000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_DEST_RING_MAPPING_TID_BASED_21_SHFT                                   20
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_DEST_RING_MAPPING_TID_BASED_20_BMSK                              0xf0000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_DEST_RING_MAPPING_TID_BASED_20_SHFT                                   16
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_DEST_RING_MAPPING_TID_BASED_19_BMSK                               0xf000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_DEST_RING_MAPPING_TID_BASED_19_SHFT                                   12
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_DEST_RING_MAPPING_TID_BASED_18_BMSK                                0xf00
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_DEST_RING_MAPPING_TID_BASED_18_SHFT                                    8
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_DEST_RING_MAPPING_TID_BASED_17_BMSK                                 0xf0
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_DEST_RING_MAPPING_TID_BASED_17_SHFT                                    4
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_DEST_RING_MAPPING_TID_BASED_16_BMSK                                  0xf
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_2_DEST_RING_MAPPING_TID_BASED_16_SHFT                                    0

#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_ADDR(x)                                                       ((x) + 0x20)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_PHYS(x)                                                       ((x) + 0x20)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_OFFS                                                          (0x20)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_RMSK                                                          0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_POR                                                           0x66666666
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_ATTR                                                                       0x3
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_IN(x)            \
                in_dword(HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_ADDR(x))
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_ADDR(x), m)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_OUT(x, v)            \
                out_dword(HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_ADDR(x),v)
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_ADDR(x),m,v,HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_IN(x))
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_DEST_RING_MAPPING_TID_BASED_31_BMSK                           0xf0000000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_DEST_RING_MAPPING_TID_BASED_31_SHFT                                   28
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_DEST_RING_MAPPING_TID_BASED_30_BMSK                            0xf000000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_DEST_RING_MAPPING_TID_BASED_30_SHFT                                   24
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_DEST_RING_MAPPING_TID_BASED_29_BMSK                             0xf00000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_DEST_RING_MAPPING_TID_BASED_29_SHFT                                   20
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_DEST_RING_MAPPING_TID_BASED_28_BMSK                              0xf0000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_DEST_RING_MAPPING_TID_BASED_28_SHFT                                   16
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_DEST_RING_MAPPING_TID_BASED_27_BMSK                               0xf000
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_DEST_RING_MAPPING_TID_BASED_27_SHFT                                   12
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_DEST_RING_MAPPING_TID_BASED_26_BMSK                                0xf00
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_DEST_RING_MAPPING_TID_BASED_26_SHFT                                    8
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_DEST_RING_MAPPING_TID_BASED_25_BMSK                                 0xf0
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_DEST_RING_MAPPING_TID_BASED_25_SHFT                                    4
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_DEST_RING_MAPPING_TID_BASED_24_BMSK                                  0xf
#define HWIO_REO_R0_DESTINATION_RING_CTRL_TID_BASED_IX_3_DEST_RING_MAPPING_TID_BASED_24_SHFT                                    0

#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_ADDR(x)                                                             ((x) + 0x24)
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_PHYS(x)                                                             ((x) + 0x24)
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_OFFS                                                                (0x24)
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_RMSK                                                                0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_POR                                                                 0x76543210
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_POR_RMSK                                                            0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_ATTR                                                                             0x3
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_IN(x)            \
                in_dword(HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_ADDR(x))
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_ADDR(x), m)
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_OUT(x, v)            \
                out_dword(HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_ADDR(x),v)
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_ADDR(x),m,v,HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_IN(x))
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_DEST_RING_ALT_MAPPING_7_BMSK                                        0xf0000000
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_DEST_RING_ALT_MAPPING_7_SHFT                                                28
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_DEST_RING_ALT_MAPPING_6_BMSK                                         0xf000000
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_DEST_RING_ALT_MAPPING_6_SHFT                                                24
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_DEST_RING_ALT_MAPPING_5_BMSK                                          0xf00000
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_DEST_RING_ALT_MAPPING_5_SHFT                                                20
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_DEST_RING_ALT_MAPPING_4_BMSK                                           0xf0000
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_DEST_RING_ALT_MAPPING_4_SHFT                                                16
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_DEST_RING_ALT_MAPPING_3_BMSK                                            0xf000
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_DEST_RING_ALT_MAPPING_3_SHFT                                                12
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_DEST_RING_ALT_MAPPING_2_BMSK                                             0xf00
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_DEST_RING_ALT_MAPPING_2_SHFT                                                 8
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_DEST_RING_ALT_MAPPING_1_BMSK                                              0xf0
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_DEST_RING_ALT_MAPPING_1_SHFT                                                 4
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_DEST_RING_ALT_MAPPING_0_BMSK                                               0xf
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_0_DEST_RING_ALT_MAPPING_0_SHFT                                                 0

#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_ADDR(x)                                                             ((x) + 0x28)
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_PHYS(x)                                                             ((x) + 0x28)
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_OFFS                                                                (0x28)
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_RMSK                                                                0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_POR                                                                 0x66666668
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_POR_RMSK                                                            0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_ATTR                                                                             0x3
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_IN(x)            \
                in_dword(HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_ADDR(x))
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_ADDR(x), m)
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_ADDR(x),v)
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_ADDR(x),m,v,HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_IN(x))
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_DEST_RING_ALT_MAPPING_15_BMSK                                       0xf0000000
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_DEST_RING_ALT_MAPPING_15_SHFT                                               28
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_DEST_RING_ALT_MAPPING_14_BMSK                                        0xf000000
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_DEST_RING_ALT_MAPPING_14_SHFT                                               24
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_DEST_RING_ALT_MAPPING_13_BMSK                                         0xf00000
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_DEST_RING_ALT_MAPPING_13_SHFT                                               20
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_DEST_RING_ALT_MAPPING_12_BMSK                                          0xf0000
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_DEST_RING_ALT_MAPPING_12_SHFT                                               16
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_DEST_RING_ALT_MAPPING_11_BMSK                                           0xf000
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_DEST_RING_ALT_MAPPING_11_SHFT                                               12
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_DEST_RING_ALT_MAPPING_10_BMSK                                            0xf00
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_DEST_RING_ALT_MAPPING_10_SHFT                                                8
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_DEST_RING_ALT_MAPPING_9_BMSK                                              0xf0
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_DEST_RING_ALT_MAPPING_9_SHFT                                                 4
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_DEST_RING_ALT_MAPPING_8_BMSK                                               0xf
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_1_DEST_RING_ALT_MAPPING_8_SHFT                                                 0

#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_ADDR(x)                                                             ((x) + 0x2c)
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_PHYS(x)                                                             ((x) + 0x2c)
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_OFFS                                                                (0x2c)
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_RMSK                                                                0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_POR                                                                 0x66666666
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_POR_RMSK                                                            0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_ATTR                                                                             0x3
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_IN(x)            \
                in_dword(HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_ADDR(x))
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_ADDR(x), m)
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_OUT(x, v)            \
                out_dword(HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_ADDR(x),v)
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_ADDR(x),m,v,HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_IN(x))
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_DEST_RING_ALT_MAPPING_23_BMSK                                       0xf0000000
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_DEST_RING_ALT_MAPPING_23_SHFT                                               28
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_DEST_RING_ALT_MAPPING_22_BMSK                                        0xf000000
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_DEST_RING_ALT_MAPPING_22_SHFT                                               24
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_DEST_RING_ALT_MAPPING_21_BMSK                                         0xf00000
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_DEST_RING_ALT_MAPPING_21_SHFT                                               20
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_DEST_RING_ALT_MAPPING_20_BMSK                                          0xf0000
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_DEST_RING_ALT_MAPPING_20_SHFT                                               16
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_DEST_RING_ALT_MAPPING_19_BMSK                                           0xf000
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_DEST_RING_ALT_MAPPING_19_SHFT                                               12
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_DEST_RING_ALT_MAPPING_18_BMSK                                            0xf00
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_DEST_RING_ALT_MAPPING_18_SHFT                                                8
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_DEST_RING_ALT_MAPPING_17_BMSK                                             0xf0
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_DEST_RING_ALT_MAPPING_17_SHFT                                                4
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_DEST_RING_ALT_MAPPING_16_BMSK                                              0xf
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_2_DEST_RING_ALT_MAPPING_16_SHFT                                                0

#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_ADDR(x)                                                             ((x) + 0x30)
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_PHYS(x)                                                             ((x) + 0x30)
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_OFFS                                                                (0x30)
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_RMSK                                                                0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_POR                                                                 0x66666666
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_POR_RMSK                                                            0xffffffff
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_ATTR                                                                             0x3
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_IN(x)            \
                in_dword(HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_ADDR(x))
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_ADDR(x), m)
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_OUT(x, v)            \
                out_dword(HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_ADDR(x),v)
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_ADDR(x),m,v,HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_IN(x))
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_DEST_RING_ALT_MAPPING_31_BMSK                                       0xf0000000
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_DEST_RING_ALT_MAPPING_31_SHFT                                               28
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_DEST_RING_ALT_MAPPING_30_BMSK                                        0xf000000
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_DEST_RING_ALT_MAPPING_30_SHFT                                               24
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_DEST_RING_ALT_MAPPING_29_BMSK                                         0xf00000
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_DEST_RING_ALT_MAPPING_29_SHFT                                               20
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_DEST_RING_ALT_MAPPING_28_BMSK                                          0xf0000
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_DEST_RING_ALT_MAPPING_28_SHFT                                               16
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_DEST_RING_ALT_MAPPING_27_BMSK                                           0xf000
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_DEST_RING_ALT_MAPPING_27_SHFT                                               12
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_DEST_RING_ALT_MAPPING_26_BMSK                                            0xf00
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_DEST_RING_ALT_MAPPING_26_SHFT                                                8
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_DEST_RING_ALT_MAPPING_25_BMSK                                             0xf0
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_DEST_RING_ALT_MAPPING_25_SHFT                                                4
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_DEST_RING_ALT_MAPPING_24_BMSK                                              0xf
#define HWIO_REO_R0_DESTINATION_RING_ALT_CTRL_IX_3_DEST_RING_ALT_MAPPING_24_SHFT                                                0

#define HWIO_REO_R0_TIMESTAMP_ADDR(x)                                                                                  ((x) + 0x34)
#define HWIO_REO_R0_TIMESTAMP_PHYS(x)                                                                                  ((x) + 0x34)
#define HWIO_REO_R0_TIMESTAMP_OFFS                                                                                     (0x34)
#define HWIO_REO_R0_TIMESTAMP_RMSK                                                                                     0xffffffff
#define HWIO_REO_R0_TIMESTAMP_POR                                                                                      0x00000000
#define HWIO_REO_R0_TIMESTAMP_POR_RMSK                                                                                 0xffffffff
#define HWIO_REO_R0_TIMESTAMP_ATTR                                                                                                  0x3
#define HWIO_REO_R0_TIMESTAMP_IN(x)            \
                in_dword(HWIO_REO_R0_TIMESTAMP_ADDR(x))
#define HWIO_REO_R0_TIMESTAMP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_TIMESTAMP_ADDR(x), m)
#define HWIO_REO_R0_TIMESTAMP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_TIMESTAMP_ADDR(x),v)
#define HWIO_REO_R0_TIMESTAMP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_TIMESTAMP_ADDR(x),m,v,HWIO_REO_R0_TIMESTAMP_IN(x))
#define HWIO_REO_R0_TIMESTAMP_TIMESTAMP_BMSK                                                                           0xffffffff
#define HWIO_REO_R0_TIMESTAMP_TIMESTAMP_SHFT                                                                                    0

#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_ADDR(x)                                                             ((x) + 0x38)
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_PHYS(x)                                                             ((x) + 0x38)
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_OFFS                                                                (0x38)
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_RMSK                                                                0xffffffff
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_POR                                                                 0x55555555
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_POR_RMSK                                                            0xffffffff
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_ATTR                                                                             0x3
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_IN(x)            \
                in_dword(HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_ADDR(x))
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_ADDR(x), m)
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_OUT(x, v)            \
                out_dword(HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_ADDR(x),v)
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_ADDR(x),m,v,HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_IN(x))
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_ERROR_DESTINATION_RING_7_BMSK                                       0xf0000000
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_ERROR_DESTINATION_RING_7_SHFT                                               28
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_ERROR_DESTINATION_RING_6_BMSK                                        0xf000000
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_ERROR_DESTINATION_RING_6_SHFT                                               24
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_ERROR_DESTINATION_RING_5_BMSK                                         0xf00000
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_ERROR_DESTINATION_RING_5_SHFT                                               20
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_ERROR_DESTINATION_RING_4_BMSK                                          0xf0000
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_ERROR_DESTINATION_RING_4_SHFT                                               16
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_ERROR_DESTINATION_RING_3_BMSK                                           0xf000
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_ERROR_DESTINATION_RING_3_SHFT                                               12
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_ERROR_DESTINATION_RING_2_BMSK                                            0xf00
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_ERROR_DESTINATION_RING_2_SHFT                                                8
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_ERROR_DESTINATION_RING_1_BMSK                                             0xf0
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_ERROR_DESTINATION_RING_1_SHFT                                                4
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_ERROR_DESTINATION_RING_0_BMSK                                              0xf
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_0_ERROR_DESTINATION_RING_0_SHFT                                                0

#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_ADDR(x)                                                             ((x) + 0x3c)
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_PHYS(x)                                                             ((x) + 0x3c)
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_OFFS                                                                (0x3c)
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_RMSK                                                                0xffffffff
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_POR                                                                 0x55555555
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_POR_RMSK                                                            0xffffffff
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_ATTR                                                                             0x3
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_IN(x)            \
                in_dword(HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_ADDR(x))
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_ADDR(x), m)
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_ADDR(x),v)
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_ADDR(x),m,v,HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_IN(x))
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_ERROR_DESTINATION_RING_OTHER_BMSK                                   0xf0000000
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_ERROR_DESTINATION_RING_OTHER_SHFT                                           28
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_ERROR_DESTINATION_RING_14_BMSK                                       0xf000000
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_ERROR_DESTINATION_RING_14_SHFT                                              24
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_ERROR_DESTINATION_RING_13_BMSK                                        0xf00000
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_ERROR_DESTINATION_RING_13_SHFT                                              20
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_ERROR_DESTINATION_RING_12_BMSK                                         0xf0000
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_ERROR_DESTINATION_RING_12_SHFT                                              16
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_ERROR_DESTINATION_RING_11_BMSK                                          0xf000
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_ERROR_DESTINATION_RING_11_SHFT                                              12
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_ERROR_DESTINATION_RING_10_BMSK                                           0xf00
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_ERROR_DESTINATION_RING_10_SHFT                                               8
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_ERROR_DESTINATION_RING_9_BMSK                                             0xf0
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_ERROR_DESTINATION_RING_9_SHFT                                                4
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_ERROR_DESTINATION_RING_8_BMSK                                              0xf
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_IX_1_ERROR_DESTINATION_RING_8_SHFT                                                0

#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_ADDR(x)                                                   ((x) + 0x40)
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_PHYS(x)                                                   ((x) + 0x40)
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_OFFS                                                      (0x40)
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_RMSK                                                      0xffffffff
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_POR                                                       0x55555555
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_POR_RMSK                                                  0xffffffff
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_ATTR                                                                   0x3
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_IN(x)            \
                in_dword(HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_ADDR(x))
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_ADDR(x), m)
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_OUT(x, v)            \
                out_dword(HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_ADDR(x),v)
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_ADDR(x),m,v,HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_IN(x))
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_ERROR_DESTINATION_RING_TID_BASED_7_BMSK                   0xf0000000
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_ERROR_DESTINATION_RING_TID_BASED_7_SHFT                           28
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_ERROR_DESTINATION_RING_TID_BASED_6_BMSK                    0xf000000
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_ERROR_DESTINATION_RING_TID_BASED_6_SHFT                           24
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_ERROR_DESTINATION_RING_TID_BASED_5_BMSK                     0xf00000
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_ERROR_DESTINATION_RING_TID_BASED_5_SHFT                           20
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_ERROR_DESTINATION_RING_TID_BASED_4_BMSK                      0xf0000
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_ERROR_DESTINATION_RING_TID_BASED_4_SHFT                           16
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_ERROR_DESTINATION_RING_TID_BASED_3_BMSK                       0xf000
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_ERROR_DESTINATION_RING_TID_BASED_3_SHFT                           12
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_ERROR_DESTINATION_RING_TID_BASED_2_BMSK                        0xf00
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_ERROR_DESTINATION_RING_TID_BASED_2_SHFT                            8
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_ERROR_DESTINATION_RING_TID_BASED_1_BMSK                         0xf0
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_ERROR_DESTINATION_RING_TID_BASED_1_SHFT                            4
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_ERROR_DESTINATION_RING_TID_BASED_0_BMSK                          0xf
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_0_ERROR_DESTINATION_RING_TID_BASED_0_SHFT                            0

#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_ADDR(x)                                                   ((x) + 0x44)
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_PHYS(x)                                                   ((x) + 0x44)
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_OFFS                                                      (0x44)
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_RMSK                                                      0xffffffff
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_POR                                                       0x55555555
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_POR_RMSK                                                  0xffffffff
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_ATTR                                                                   0x3
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_IN(x)            \
                in_dword(HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_ADDR(x))
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_ADDR(x), m)
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_ADDR(x),v)
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_ADDR(x),m,v,HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_IN(x))
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_ERROR_DESTINATION_RING_TID_BASED_OTHER_BMSK               0xf0000000
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_ERROR_DESTINATION_RING_TID_BASED_OTHER_SHFT                       28
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_ERROR_DESTINATION_RING_TID_BASED_14_BMSK                   0xf000000
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_ERROR_DESTINATION_RING_TID_BASED_14_SHFT                          24
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_ERROR_DESTINATION_RING_TID_BASED_13_BMSK                    0xf00000
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_ERROR_DESTINATION_RING_TID_BASED_13_SHFT                          20
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_ERROR_DESTINATION_RING_TID_BASED_12_BMSK                     0xf0000
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_ERROR_DESTINATION_RING_TID_BASED_12_SHFT                          16
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_ERROR_DESTINATION_RING_TID_BASED_11_BMSK                      0xf000
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_ERROR_DESTINATION_RING_TID_BASED_11_SHFT                          12
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_ERROR_DESTINATION_RING_TID_BASED_10_BMSK                       0xf00
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_ERROR_DESTINATION_RING_TID_BASED_10_SHFT                           8
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_ERROR_DESTINATION_RING_TID_BASED_9_BMSK                         0xf0
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_ERROR_DESTINATION_RING_TID_BASED_9_SHFT                            4
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_ERROR_DESTINATION_RING_TID_BASED_8_BMSK                          0xf
#define HWIO_REO_R0_ERROR_DESTINATION_MAPPING_TID_BASED_IX_1_ERROR_DESTINATION_RING_TID_BASED_8_SHFT                            0

#define HWIO_REO_R0_RDI_CTRL_SEL_WITH_TID_ADDR(x)                                                                      ((x) + 0x48)
#define HWIO_REO_R0_RDI_CTRL_SEL_WITH_TID_PHYS(x)                                                                      ((x) + 0x48)
#define HWIO_REO_R0_RDI_CTRL_SEL_WITH_TID_OFFS                                                                         (0x48)
#define HWIO_REO_R0_RDI_CTRL_SEL_WITH_TID_RMSK                                                                            0x1ffff
#define HWIO_REO_R0_RDI_CTRL_SEL_WITH_TID_POR                                                                          0x00000000
#define HWIO_REO_R0_RDI_CTRL_SEL_WITH_TID_POR_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_RDI_CTRL_SEL_WITH_TID_ATTR                                                                                      0x3
#define HWIO_REO_R0_RDI_CTRL_SEL_WITH_TID_IN(x)            \
                in_dword(HWIO_REO_R0_RDI_CTRL_SEL_WITH_TID_ADDR(x))
#define HWIO_REO_R0_RDI_CTRL_SEL_WITH_TID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RDI_CTRL_SEL_WITH_TID_ADDR(x), m)
#define HWIO_REO_R0_RDI_CTRL_SEL_WITH_TID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RDI_CTRL_SEL_WITH_TID_ADDR(x),v)
#define HWIO_REO_R0_RDI_CTRL_SEL_WITH_TID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RDI_CTRL_SEL_WITH_TID_ADDR(x),m,v,HWIO_REO_R0_RDI_CTRL_SEL_WITH_TID_IN(x))
#define HWIO_REO_R0_RDI_CTRL_SEL_WITH_TID_TID_CTRL_BMSK                                                                   0x1ffff
#define HWIO_REO_R0_RDI_CTRL_SEL_WITH_TID_TID_CTRL_SHFT                                                                         0

#define HWIO_REO_R0_IDLE_REQ_CTRL_ADDR(x)                                                                              ((x) + 0x4c)
#define HWIO_REO_R0_IDLE_REQ_CTRL_PHYS(x)                                                                              ((x) + 0x4c)
#define HWIO_REO_R0_IDLE_REQ_CTRL_OFFS                                                                                 (0x4c)
#define HWIO_REO_R0_IDLE_REQ_CTRL_RMSK                                                                                        0x3
#define HWIO_REO_R0_IDLE_REQ_CTRL_POR                                                                                  0x00000003
#define HWIO_REO_R0_IDLE_REQ_CTRL_POR_RMSK                                                                             0xffffffff
#define HWIO_REO_R0_IDLE_REQ_CTRL_ATTR                                                                                              0x3
#define HWIO_REO_R0_IDLE_REQ_CTRL_IN(x)            \
                in_dword(HWIO_REO_R0_IDLE_REQ_CTRL_ADDR(x))
#define HWIO_REO_R0_IDLE_REQ_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_IDLE_REQ_CTRL_ADDR(x), m)
#define HWIO_REO_R0_IDLE_REQ_CTRL_OUT(x, v)            \
                out_dword(HWIO_REO_R0_IDLE_REQ_CTRL_ADDR(x),v)
#define HWIO_REO_R0_IDLE_REQ_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_IDLE_REQ_CTRL_ADDR(x),m,v,HWIO_REO_R0_IDLE_REQ_CTRL_IN(x))
#define HWIO_REO_R0_IDLE_REQ_CTRL_IDLE_REQ_FLUSH_CACHE_BMSK                                                                   0x2
#define HWIO_REO_R0_IDLE_REQ_CTRL_IDLE_REQ_FLUSH_CACHE_SHFT                                                                     1
#define HWIO_REO_R0_IDLE_REQ_CTRL_IDLE_REQ_FLUSH_AGE_LIST_BMSK                                                                0x1
#define HWIO_REO_R0_IDLE_REQ_CTRL_IDLE_REQ_FLUSH_AGE_LIST_SHFT                                                                  0

#define HWIO_REO_R0_LAST_SN_0_ADDR(x)                                                                                  ((x) + 0x50)
#define HWIO_REO_R0_LAST_SN_0_PHYS(x)                                                                                  ((x) + 0x50)
#define HWIO_REO_R0_LAST_SN_0_OFFS                                                                                     (0x50)
#define HWIO_REO_R0_LAST_SN_0_RMSK                                                                                       0xffffff
#define HWIO_REO_R0_LAST_SN_0_POR                                                                                      0x00001001
#define HWIO_REO_R0_LAST_SN_0_POR_RMSK                                                                                 0xffffffff
#define HWIO_REO_R0_LAST_SN_0_ATTR                                                                                                  0x1
#define HWIO_REO_R0_LAST_SN_0_IN(x)            \
                in_dword(HWIO_REO_R0_LAST_SN_0_ADDR(x))
#define HWIO_REO_R0_LAST_SN_0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_LAST_SN_0_ADDR(x), m)
#define HWIO_REO_R0_LAST_SN_0_Q1_BMSK                                                                                    0xfff000
#define HWIO_REO_R0_LAST_SN_0_Q1_SHFT                                                                                          12
#define HWIO_REO_R0_LAST_SN_0_Q0_BMSK                                                                                       0xfff
#define HWIO_REO_R0_LAST_SN_0_Q0_SHFT                                                                                           0

#define HWIO_REO_R0_LAST_SN_1_ADDR(x)                                                                                  ((x) + 0x54)
#define HWIO_REO_R0_LAST_SN_1_PHYS(x)                                                                                  ((x) + 0x54)
#define HWIO_REO_R0_LAST_SN_1_OFFS                                                                                     (0x54)
#define HWIO_REO_R0_LAST_SN_1_RMSK                                                                                       0xffffff
#define HWIO_REO_R0_LAST_SN_1_POR                                                                                      0x00001001
#define HWIO_REO_R0_LAST_SN_1_POR_RMSK                                                                                 0xffffffff
#define HWIO_REO_R0_LAST_SN_1_ATTR                                                                                                  0x1
#define HWIO_REO_R0_LAST_SN_1_IN(x)            \
                in_dword(HWIO_REO_R0_LAST_SN_1_ADDR(x))
#define HWIO_REO_R0_LAST_SN_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_LAST_SN_1_ADDR(x), m)
#define HWIO_REO_R0_LAST_SN_1_Q3_BMSK                                                                                    0xfff000
#define HWIO_REO_R0_LAST_SN_1_Q3_SHFT                                                                                          12
#define HWIO_REO_R0_LAST_SN_1_Q2_BMSK                                                                                       0xfff
#define HWIO_REO_R0_LAST_SN_1_Q2_SHFT                                                                                           0

#define HWIO_REO_R0_LAST_SN_2_ADDR(x)                                                                                  ((x) + 0x58)
#define HWIO_REO_R0_LAST_SN_2_PHYS(x)                                                                                  ((x) + 0x58)
#define HWIO_REO_R0_LAST_SN_2_OFFS                                                                                     (0x58)
#define HWIO_REO_R0_LAST_SN_2_RMSK                                                                                       0xffffff
#define HWIO_REO_R0_LAST_SN_2_POR                                                                                      0x00001001
#define HWIO_REO_R0_LAST_SN_2_POR_RMSK                                                                                 0xffffffff
#define HWIO_REO_R0_LAST_SN_2_ATTR                                                                                                  0x1
#define HWIO_REO_R0_LAST_SN_2_IN(x)            \
                in_dword(HWIO_REO_R0_LAST_SN_2_ADDR(x))
#define HWIO_REO_R0_LAST_SN_2_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_LAST_SN_2_ADDR(x), m)
#define HWIO_REO_R0_LAST_SN_2_Q5_BMSK                                                                                    0xfff000
#define HWIO_REO_R0_LAST_SN_2_Q5_SHFT                                                                                          12
#define HWIO_REO_R0_LAST_SN_2_Q4_BMSK                                                                                       0xfff
#define HWIO_REO_R0_LAST_SN_2_Q4_SHFT                                                                                           0

#define HWIO_REO_R0_LAST_SN_3_ADDR(x)                                                                                  ((x) + 0x5c)
#define HWIO_REO_R0_LAST_SN_3_PHYS(x)                                                                                  ((x) + 0x5c)
#define HWIO_REO_R0_LAST_SN_3_OFFS                                                                                     (0x5c)
#define HWIO_REO_R0_LAST_SN_3_RMSK                                                                                       0xffffff
#define HWIO_REO_R0_LAST_SN_3_POR                                                                                      0x00001001
#define HWIO_REO_R0_LAST_SN_3_POR_RMSK                                                                                 0xffffffff
#define HWIO_REO_R0_LAST_SN_3_ATTR                                                                                                  0x1
#define HWIO_REO_R0_LAST_SN_3_IN(x)            \
                in_dword(HWIO_REO_R0_LAST_SN_3_ADDR(x))
#define HWIO_REO_R0_LAST_SN_3_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_LAST_SN_3_ADDR(x), m)
#define HWIO_REO_R0_LAST_SN_3_Q7_BMSK                                                                                    0xfff000
#define HWIO_REO_R0_LAST_SN_3_Q7_SHFT                                                                                          12
#define HWIO_REO_R0_LAST_SN_3_Q6_BMSK                                                                                       0xfff
#define HWIO_REO_R0_LAST_SN_3_Q6_SHFT                                                                                           0

#define HWIO_REO_R0_LAST_SN_4_ADDR(x)                                                                                  ((x) + 0x60)
#define HWIO_REO_R0_LAST_SN_4_PHYS(x)                                                                                  ((x) + 0x60)
#define HWIO_REO_R0_LAST_SN_4_OFFS                                                                                     (0x60)
#define HWIO_REO_R0_LAST_SN_4_RMSK                                                                                          0xfff
#define HWIO_REO_R0_LAST_SN_4_POR                                                                                      0x00000001
#define HWIO_REO_R0_LAST_SN_4_POR_RMSK                                                                                 0xffffffff
#define HWIO_REO_R0_LAST_SN_4_ATTR                                                                                                  0x1
#define HWIO_REO_R0_LAST_SN_4_IN(x)            \
                in_dword(HWIO_REO_R0_LAST_SN_4_ADDR(x))
#define HWIO_REO_R0_LAST_SN_4_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_LAST_SN_4_ADDR(x), m)
#define HWIO_REO_R0_LAST_SN_4_Q8_BMSK                                                                                       0xfff
#define HWIO_REO_R0_LAST_SN_4_Q8_SHFT                                                                                           0

#define HWIO_REO_R0_MODULE_STRESS_CONTROL_ADDR(x)                                                                      ((x) + 0x64)
#define HWIO_REO_R0_MODULE_STRESS_CONTROL_PHYS(x)                                                                      ((x) + 0x64)
#define HWIO_REO_R0_MODULE_STRESS_CONTROL_OFFS                                                                         (0x64)
#define HWIO_REO_R0_MODULE_STRESS_CONTROL_RMSK                                                                                0x1
#define HWIO_REO_R0_MODULE_STRESS_CONTROL_POR                                                                          0x00000000
#define HWIO_REO_R0_MODULE_STRESS_CONTROL_POR_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_MODULE_STRESS_CONTROL_ATTR                                                                                      0x3
#define HWIO_REO_R0_MODULE_STRESS_CONTROL_IN(x)            \
                in_dword(HWIO_REO_R0_MODULE_STRESS_CONTROL_ADDR(x))
#define HWIO_REO_R0_MODULE_STRESS_CONTROL_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_MODULE_STRESS_CONTROL_ADDR(x), m)
#define HWIO_REO_R0_MODULE_STRESS_CONTROL_OUT(x, v)            \
                out_dword(HWIO_REO_R0_MODULE_STRESS_CONTROL_ADDR(x),v)
#define HWIO_REO_R0_MODULE_STRESS_CONTROL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_MODULE_STRESS_CONTROL_ADDR(x),m,v,HWIO_REO_R0_MODULE_STRESS_CONTROL_IN(x))
#define HWIO_REO_R0_MODULE_STRESS_CONTROL_HANG_AND_CLEAR_ON_RESET_BMSK                                                        0x1
#define HWIO_REO_R0_MODULE_STRESS_CONTROL_HANG_AND_CLEAR_ON_RESET_SHFT                                                          0

#define HWIO_REO_R0_PN_IN_DEST_ADDR(x)                                                                                 ((x) + 0x68)
#define HWIO_REO_R0_PN_IN_DEST_PHYS(x)                                                                                 ((x) + 0x68)
#define HWIO_REO_R0_PN_IN_DEST_OFFS                                                                                    (0x68)
#define HWIO_REO_R0_PN_IN_DEST_RMSK                                                                                           0x1
#define HWIO_REO_R0_PN_IN_DEST_POR                                                                                     0x00000000
#define HWIO_REO_R0_PN_IN_DEST_POR_RMSK                                                                                0xffffffff
#define HWIO_REO_R0_PN_IN_DEST_ATTR                                                                                                 0x3
#define HWIO_REO_R0_PN_IN_DEST_IN(x)            \
                in_dword(HWIO_REO_R0_PN_IN_DEST_ADDR(x))
#define HWIO_REO_R0_PN_IN_DEST_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_PN_IN_DEST_ADDR(x), m)
#define HWIO_REO_R0_PN_IN_DEST_OUT(x, v)            \
                out_dword(HWIO_REO_R0_PN_IN_DEST_ADDR(x),v)
#define HWIO_REO_R0_PN_IN_DEST_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_PN_IN_DEST_ADDR(x),m,v,HWIO_REO_R0_PN_IN_DEST_IN(x))
#define HWIO_REO_R0_PN_IN_DEST_PN_FIELD_EN_IN_DEST_BMSK                                                                       0x1
#define HWIO_REO_R0_PN_IN_DEST_PN_FIELD_EN_IN_DEST_SHFT                                                                         0

#define HWIO_REO_R0_SW_COOKIE_CFG0_ADDR(x)                                                                             ((x) + 0x6c)
#define HWIO_REO_R0_SW_COOKIE_CFG0_PHYS(x)                                                                             ((x) + 0x6c)
#define HWIO_REO_R0_SW_COOKIE_CFG0_OFFS                                                                                (0x6c)
#define HWIO_REO_R0_SW_COOKIE_CFG0_RMSK                                                                                0xffffffff
#define HWIO_REO_R0_SW_COOKIE_CFG0_POR                                                                                 0x00000000
#define HWIO_REO_R0_SW_COOKIE_CFG0_POR_RMSK                                                                            0xffffffff
#define HWIO_REO_R0_SW_COOKIE_CFG0_ATTR                                                                                             0x3
#define HWIO_REO_R0_SW_COOKIE_CFG0_IN(x)            \
                in_dword(HWIO_REO_R0_SW_COOKIE_CFG0_ADDR(x))
#define HWIO_REO_R0_SW_COOKIE_CFG0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW_COOKIE_CFG0_ADDR(x), m)
#define HWIO_REO_R0_SW_COOKIE_CFG0_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW_COOKIE_CFG0_ADDR(x),v)
#define HWIO_REO_R0_SW_COOKIE_CFG0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW_COOKIE_CFG0_ADDR(x),m,v,HWIO_REO_R0_SW_COOKIE_CFG0_IN(x))
#define HWIO_REO_R0_SW_COOKIE_CFG0_CMEM_LUT_BASE_ADDR_31_0_BMSK                                                        0xffffffff
#define HWIO_REO_R0_SW_COOKIE_CFG0_CMEM_LUT_BASE_ADDR_31_0_SHFT                                                                 0

#define HWIO_REO_R0_SW_COOKIE_CFG1_ADDR(x)                                                                             ((x) + 0x70)
#define HWIO_REO_R0_SW_COOKIE_CFG1_PHYS(x)                                                                             ((x) + 0x70)
#define HWIO_REO_R0_SW_COOKIE_CFG1_OFFS                                                                                (0x70)
#define HWIO_REO_R0_SW_COOKIE_CFG1_RMSK                                                                                  0x1fffff
#define HWIO_REO_R0_SW_COOKIE_CFG1_POR                                                                                 0x00111700
#define HWIO_REO_R0_SW_COOKIE_CFG1_POR_RMSK                                                                            0xffffffff
#define HWIO_REO_R0_SW_COOKIE_CFG1_ATTR                                                                                             0x3
#define HWIO_REO_R0_SW_COOKIE_CFG1_IN(x)            \
                in_dword(HWIO_REO_R0_SW_COOKIE_CFG1_ADDR(x))
#define HWIO_REO_R0_SW_COOKIE_CFG1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW_COOKIE_CFG1_ADDR(x), m)
#define HWIO_REO_R0_SW_COOKIE_CFG1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW_COOKIE_CFG1_ADDR(x),v)
#define HWIO_REO_R0_SW_COOKIE_CFG1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW_COOKIE_CFG1_ADDR(x),m,v,HWIO_REO_R0_SW_COOKIE_CFG1_IN(x))
#define HWIO_REO_R0_SW_COOKIE_CFG1_SW_COOKIE_CONVERT_GLOBAL_ENABLE_BMSK                                                  0x100000
#define HWIO_REO_R0_SW_COOKIE_CFG1_SW_COOKIE_CONVERT_GLOBAL_ENABLE_SHFT                                                        20
#define HWIO_REO_R0_SW_COOKIE_CFG1_SW_COOKIE_CONVERT_ENABLE_BMSK                                                          0x80000
#define HWIO_REO_R0_SW_COOKIE_CFG1_SW_COOKIE_CONVERT_ENABLE_SHFT                                                               19
#define HWIO_REO_R0_SW_COOKIE_CFG1_PAGE_ALIGNMENT_BMSK                                                                    0x40000
#define HWIO_REO_R0_SW_COOKIE_CFG1_PAGE_ALIGNMENT_SHFT                                                                         18
#define HWIO_REO_R0_SW_COOKIE_CFG1_COOKIE_OFFSET_MSB_BMSK                                                                 0x3e000
#define HWIO_REO_R0_SW_COOKIE_CFG1_COOKIE_OFFSET_MSB_SHFT                                                                      13
#define HWIO_REO_R0_SW_COOKIE_CFG1_COOKIE_PAGE_MSB_BMSK                                                                    0x1f00
#define HWIO_REO_R0_SW_COOKIE_CFG1_COOKIE_PAGE_MSB_SHFT                                                                         8
#define HWIO_REO_R0_SW_COOKIE_CFG1_CMEM_LUT_BASE_ADDR_39_32_BMSK                                                             0xff
#define HWIO_REO_R0_SW_COOKIE_CFG1_CMEM_LUT_BASE_ADDR_39_32_SHFT                                                                0

#define HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_ADDR(x)                                                                       ((x) + 0x74)
#define HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_PHYS(x)                                                                       ((x) + 0x74)
#define HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_OFFS                                                                          (0x74)
#define HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_RMSK                                                                          0xffffffff
#define HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_POR                                                                           0x00000000
#define HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_POR_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_ATTR                                                                                       0x3
#define HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_IN(x)            \
                in_dword(HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_ADDR(x))
#define HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_ADDR(x), m)
#define HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_OUT(x, v)            \
                out_dword(HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_ADDR(x),v)
#define HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_ADDR(x),m,v,HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_IN(x))
#define HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_VALUE_BMSK                                                                    0xffffffff
#define HWIO_REO_R0_QDESC_LUT_BASE0_ADDR_VALUE_SHFT                                                                             0

#define HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_ADDR(x)                                                                       ((x) + 0x78)
#define HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_PHYS(x)                                                                       ((x) + 0x78)
#define HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_OFFS                                                                          (0x78)
#define HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_RMSK                                                                          0xffffffff
#define HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_POR                                                                           0x00000000
#define HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_POR_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_ATTR                                                                                       0x3
#define HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_IN(x)            \
                in_dword(HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_ADDR(x))
#define HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_ADDR(x), m)
#define HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_OUT(x, v)            \
                out_dword(HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_ADDR(x),v)
#define HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_ADDR(x),m,v,HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_IN(x))
#define HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_VALUE_BMSK                                                                    0xffffffff
#define HWIO_REO_R0_QDESC_LUT_BASE1_ADDR_VALUE_SHFT                                                                             0

#define HWIO_REO_R0_QDESC_ADDR_READ_ADDR(x)                                                                            ((x) + 0x7c)
#define HWIO_REO_R0_QDESC_ADDR_READ_PHYS(x)                                                                            ((x) + 0x7c)
#define HWIO_REO_R0_QDESC_ADDR_READ_OFFS                                                                               (0x7c)
#define HWIO_REO_R0_QDESC_ADDR_READ_RMSK                                                                                    0x1ff
#define HWIO_REO_R0_QDESC_ADDR_READ_POR                                                                                0x00000000
#define HWIO_REO_R0_QDESC_ADDR_READ_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R0_QDESC_ADDR_READ_ATTR                                                                                            0x3
#define HWIO_REO_R0_QDESC_ADDR_READ_IN(x)            \
                in_dword(HWIO_REO_R0_QDESC_ADDR_READ_ADDR(x))
#define HWIO_REO_R0_QDESC_ADDR_READ_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_QDESC_ADDR_READ_ADDR(x), m)
#define HWIO_REO_R0_QDESC_ADDR_READ_OUT(x, v)            \
                out_dword(HWIO_REO_R0_QDESC_ADDR_READ_ADDR(x),v)
#define HWIO_REO_R0_QDESC_ADDR_READ_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_QDESC_ADDR_READ_ADDR(x),m,v,HWIO_REO_R0_QDESC_ADDR_READ_IN(x))
#define HWIO_REO_R0_QDESC_ADDR_READ_GXI_SWAP_BMSK                                                                           0x100
#define HWIO_REO_R0_QDESC_ADDR_READ_GXI_SWAP_SHFT                                                                               8
#define HWIO_REO_R0_QDESC_ADDR_READ_LUT_FEATURE_ENABLE_BMSK                                                                  0x80
#define HWIO_REO_R0_QDESC_ADDR_READ_LUT_FEATURE_ENABLE_SHFT                                                                     7
#define HWIO_REO_R0_QDESC_ADDR_READ_CLEAR_QDESC_ARRAY_BMSK                                                                   0x40
#define HWIO_REO_R0_QDESC_ADDR_READ_CLEAR_QDESC_ARRAY_SHFT                                                                      6
#define HWIO_REO_R0_QDESC_ADDR_READ_INDEX_BMSK                                                                               0x3f
#define HWIO_REO_R0_QDESC_ADDR_READ_INDEX_SHFT                                                                                  0

#define HWIO_REO_R0_QDESC_ADDR_LOWER_ADDR(x)                                                                           ((x) + 0x80)
#define HWIO_REO_R0_QDESC_ADDR_LOWER_PHYS(x)                                                                           ((x) + 0x80)
#define HWIO_REO_R0_QDESC_ADDR_LOWER_OFFS                                                                              (0x80)
#define HWIO_REO_R0_QDESC_ADDR_LOWER_RMSK                                                                              0xffffffff
#define HWIO_REO_R0_QDESC_ADDR_LOWER_POR                                                                               0x00000000
#define HWIO_REO_R0_QDESC_ADDR_LOWER_POR_RMSK                                                                          0xffffffff
#define HWIO_REO_R0_QDESC_ADDR_LOWER_ATTR                                                                                           0x1
#define HWIO_REO_R0_QDESC_ADDR_LOWER_IN(x)            \
                in_dword(HWIO_REO_R0_QDESC_ADDR_LOWER_ADDR(x))
#define HWIO_REO_R0_QDESC_ADDR_LOWER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_QDESC_ADDR_LOWER_ADDR(x), m)
#define HWIO_REO_R0_QDESC_ADDR_LOWER_QDESC_ADDR_BMSK                                                                   0xffffffff
#define HWIO_REO_R0_QDESC_ADDR_LOWER_QDESC_ADDR_SHFT                                                                            0

#define HWIO_REO_R0_QDESC_ADDR_HIGHER_ADDR(x)                                                                          ((x) + 0x84)
#define HWIO_REO_R0_QDESC_ADDR_HIGHER_PHYS(x)                                                                          ((x) + 0x84)
#define HWIO_REO_R0_QDESC_ADDR_HIGHER_OFFS                                                                             (0x84)
#define HWIO_REO_R0_QDESC_ADDR_HIGHER_RMSK                                                                              0x3ffffff
#define HWIO_REO_R0_QDESC_ADDR_HIGHER_POR                                                                              0x00000000
#define HWIO_REO_R0_QDESC_ADDR_HIGHER_POR_RMSK                                                                         0xffffffff
#define HWIO_REO_R0_QDESC_ADDR_HIGHER_ATTR                                                                                          0x1
#define HWIO_REO_R0_QDESC_ADDR_HIGHER_IN(x)            \
                in_dword(HWIO_REO_R0_QDESC_ADDR_HIGHER_ADDR(x))
#define HWIO_REO_R0_QDESC_ADDR_HIGHER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_QDESC_ADDR_HIGHER_ADDR(x), m)
#define HWIO_REO_R0_QDESC_ADDR_HIGHER_Q_INDEX_BMSK                                                                      0x3ffff00
#define HWIO_REO_R0_QDESC_ADDR_HIGHER_Q_INDEX_SHFT                                                                              8
#define HWIO_REO_R0_QDESC_ADDR_HIGHER_QDESC_ADDR_BMSK                                                                        0xff
#define HWIO_REO_R0_QDESC_ADDR_HIGHER_QDESC_ADDR_SHFT                                                                           0

#define HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_ADDR(x)                                                                       ((x) + 0x88)
#define HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_PHYS(x)                                                                       ((x) + 0x88)
#define HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_OFFS                                                                          (0x88)
#define HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_RMSK                                                                              0x1fff
#define HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_POR                                                                           0x00000000
#define HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_POR_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_ATTR                                                                                       0x3
#define HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_IN(x)            \
                in_dword(HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_ADDR(x))
#define HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_ADDR(x), m)
#define HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_ADDR(x),v)
#define HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_ADDR(x),m,v,HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_IN(x))
#define HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_MAX_SUPPORTED_BMSK                                                                0x1fff
#define HWIO_REO_R0_QDESC_MAX_SW_PEER_ID_MAX_SUPPORTED_SHFT                                                                     0

#define HWIO_REO_R0_RX_STATS_CMD_ADDR(x)                                                                               ((x) + 0x8c)
#define HWIO_REO_R0_RX_STATS_CMD_PHYS(x)                                                                               ((x) + 0x8c)
#define HWIO_REO_R0_RX_STATS_CMD_OFFS                                                                                  (0x8c)
#define HWIO_REO_R0_RX_STATS_CMD_RMSK                                                                                        0xff
#define HWIO_REO_R0_RX_STATS_CMD_POR                                                                                   0x00000000
#define HWIO_REO_R0_RX_STATS_CMD_POR_RMSK                                                                              0xffffffff
#define HWIO_REO_R0_RX_STATS_CMD_ATTR                                                                                               0x3
#define HWIO_REO_R0_RX_STATS_CMD_IN(x)            \
                in_dword(HWIO_REO_R0_RX_STATS_CMD_ADDR(x))
#define HWIO_REO_R0_RX_STATS_CMD_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RX_STATS_CMD_ADDR(x), m)
#define HWIO_REO_R0_RX_STATS_CMD_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RX_STATS_CMD_ADDR(x),v)
#define HWIO_REO_R0_RX_STATS_CMD_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RX_STATS_CMD_ADDR(x),m,v,HWIO_REO_R0_RX_STATS_CMD_IN(x))
#define HWIO_REO_R0_RX_STATS_CMD_CLEAR_ALL_VDEV_ID_RX_STATS_BMSK                                                             0x80
#define HWIO_REO_R0_RX_STATS_CMD_CLEAR_ALL_VDEV_ID_RX_STATS_SHFT                                                                7
#define HWIO_REO_R0_RX_STATS_CMD_CLEAR_SINGLE_VDEV_RX_STATS_BMSK                                                             0x40
#define HWIO_REO_R0_RX_STATS_CMD_CLEAR_SINGLE_VDEV_RX_STATS_SHFT                                                                6
#define HWIO_REO_R0_RX_STATS_CMD_VDEV_ID_BMSK                                                                                0x3f
#define HWIO_REO_R0_RX_STATS_CMD_VDEV_ID_SHFT                                                                                   0

#define HWIO_REO_R0_RX_STATS_LOWER_ADDR(x)                                                                             ((x) + 0x90)
#define HWIO_REO_R0_RX_STATS_LOWER_PHYS(x)                                                                             ((x) + 0x90)
#define HWIO_REO_R0_RX_STATS_LOWER_OFFS                                                                                (0x90)
#define HWIO_REO_R0_RX_STATS_LOWER_RMSK                                                                                0xffffffff
#define HWIO_REO_R0_RX_STATS_LOWER_POR                                                                                 0x00000000
#define HWIO_REO_R0_RX_STATS_LOWER_POR_RMSK                                                                            0xffffffff
#define HWIO_REO_R0_RX_STATS_LOWER_ATTR                                                                                             0x1
#define HWIO_REO_R0_RX_STATS_LOWER_IN(x)            \
                in_dword(HWIO_REO_R0_RX_STATS_LOWER_ADDR(x))
#define HWIO_REO_R0_RX_STATS_LOWER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RX_STATS_LOWER_ADDR(x), m)
#define HWIO_REO_R0_RX_STATS_LOWER_MSDU_BYTE_COUNT_BMSK                                                                0xffffffff
#define HWIO_REO_R0_RX_STATS_LOWER_MSDU_BYTE_COUNT_SHFT                                                                         0

#define HWIO_REO_R0_RX_STATS_HIGHER_ADDR(x)                                                                            ((x) + 0x94)
#define HWIO_REO_R0_RX_STATS_HIGHER_PHYS(x)                                                                            ((x) + 0x94)
#define HWIO_REO_R0_RX_STATS_HIGHER_OFFS                                                                               (0x94)
#define HWIO_REO_R0_RX_STATS_HIGHER_RMSK                                                                               0xffffffff
#define HWIO_REO_R0_RX_STATS_HIGHER_POR                                                                                0x00000000
#define HWIO_REO_R0_RX_STATS_HIGHER_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R0_RX_STATS_HIGHER_ATTR                                                                                            0x1
#define HWIO_REO_R0_RX_STATS_HIGHER_IN(x)            \
                in_dword(HWIO_REO_R0_RX_STATS_HIGHER_ADDR(x))
#define HWIO_REO_R0_RX_STATS_HIGHER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RX_STATS_HIGHER_ADDR(x), m)
#define HWIO_REO_R0_RX_STATS_HIGHER_MSDU_COUNT_BMSK                                                                    0xfffffff0
#define HWIO_REO_R0_RX_STATS_HIGHER_MSDU_COUNT_SHFT                                                                             4
#define HWIO_REO_R0_RX_STATS_HIGHER_MSDU_BYTE_COUNT_BMSK                                                                      0xf
#define HWIO_REO_R0_RX_STATS_HIGHER_MSDU_BYTE_COUNT_SHFT                                                                        0

#define HWIO_REO_R0_RXDMA2REO0_RING_BASE_LSB_ADDR(x)                                                                   ((x) + 0x98)
#define HWIO_REO_R0_RXDMA2REO0_RING_BASE_LSB_PHYS(x)                                                                   ((x) + 0x98)
#define HWIO_REO_R0_RXDMA2REO0_RING_BASE_LSB_OFFS                                                                      (0x98)
#define HWIO_REO_R0_RXDMA2REO0_RING_BASE_LSB_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_RXDMA2REO0_RING_BASE_LSB_POR                                                                       0x00000000
#define HWIO_REO_R0_RXDMA2REO0_RING_BASE_LSB_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_RXDMA2REO0_RING_BASE_LSB_ATTR                                                                                   0x3
#define HWIO_REO_R0_RXDMA2REO0_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO0_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO0_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO0_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO0_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO0_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO0_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO0_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO0_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_RXDMA2REO0_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                                   0xffffffff
#define HWIO_REO_R0_RXDMA2REO0_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                            0

#define HWIO_REO_R0_RXDMA2REO0_RING_BASE_MSB_ADDR(x)                                                                   ((x) + 0x9c)
#define HWIO_REO_R0_RXDMA2REO0_RING_BASE_MSB_PHYS(x)                                                                   ((x) + 0x9c)
#define HWIO_REO_R0_RXDMA2REO0_RING_BASE_MSB_OFFS                                                                      (0x9c)
#define HWIO_REO_R0_RXDMA2REO0_RING_BASE_MSB_RMSK                                                                        0xffffff
#define HWIO_REO_R0_RXDMA2REO0_RING_BASE_MSB_POR                                                                       0x00000000
#define HWIO_REO_R0_RXDMA2REO0_RING_BASE_MSB_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_RXDMA2REO0_RING_BASE_MSB_ATTR                                                                                   0x3
#define HWIO_REO_R0_RXDMA2REO0_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO0_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO0_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO0_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO0_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO0_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO0_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO0_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO0_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_RXDMA2REO0_RING_BASE_MSB_RING_SIZE_BMSK                                                              0xffff00
#define HWIO_REO_R0_RXDMA2REO0_RING_BASE_MSB_RING_SIZE_SHFT                                                                     8
#define HWIO_REO_R0_RXDMA2REO0_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                         0xff
#define HWIO_REO_R0_RXDMA2REO0_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                            0

#define HWIO_REO_R0_RXDMA2REO0_RING_ID_ADDR(x)                                                                         ((x) + 0xa0)
#define HWIO_REO_R0_RXDMA2REO0_RING_ID_PHYS(x)                                                                         ((x) + 0xa0)
#define HWIO_REO_R0_RXDMA2REO0_RING_ID_OFFS                                                                            (0xa0)
#define HWIO_REO_R0_RXDMA2REO0_RING_ID_RMSK                                                                                  0xff
#define HWIO_REO_R0_RXDMA2REO0_RING_ID_POR                                                                             0x00000000
#define HWIO_REO_R0_RXDMA2REO0_RING_ID_POR_RMSK                                                                        0xffffffff
#define HWIO_REO_R0_RXDMA2REO0_RING_ID_ATTR                                                                                         0x3
#define HWIO_REO_R0_RXDMA2REO0_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO0_RING_ID_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO0_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO0_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO0_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO0_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO0_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO0_RING_ID_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO0_RING_ID_IN(x))
#define HWIO_REO_R0_RXDMA2REO0_RING_ID_ENTRY_SIZE_BMSK                                                                       0xff
#define HWIO_REO_R0_RXDMA2REO0_RING_ID_ENTRY_SIZE_SHFT                                                                          0

#define HWIO_REO_R0_RXDMA2REO0_RING_STATUS_ADDR(x)                                                                     ((x) + 0xa4)
#define HWIO_REO_R0_RXDMA2REO0_RING_STATUS_PHYS(x)                                                                     ((x) + 0xa4)
#define HWIO_REO_R0_RXDMA2REO0_RING_STATUS_OFFS                                                                        (0xa4)
#define HWIO_REO_R0_RXDMA2REO0_RING_STATUS_RMSK                                                                        0xffffffff
#define HWIO_REO_R0_RXDMA2REO0_RING_STATUS_POR                                                                         0x00000000
#define HWIO_REO_R0_RXDMA2REO0_RING_STATUS_POR_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_RXDMA2REO0_RING_STATUS_ATTR                                                                                     0x1
#define HWIO_REO_R0_RXDMA2REO0_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO0_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO0_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO0_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO0_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                        0xffff0000
#define HWIO_REO_R0_RXDMA2REO0_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                                16
#define HWIO_REO_R0_RXDMA2REO0_RING_STATUS_NUM_VALID_WORDS_BMSK                                                            0xffff
#define HWIO_REO_R0_RXDMA2REO0_RING_STATUS_NUM_VALID_WORDS_SHFT                                                                 0

#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_ADDR(x)                                                                       ((x) + 0xa8)
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_PHYS(x)                                                                       ((x) + 0xa8)
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_OFFS                                                                          (0xa8)
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_RMSK                                                                            0x3fffff
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_POR                                                                           0x00000080
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_POR_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_ATTR                                                                                       0x3
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO0_RING_MISC_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO0_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO0_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO0_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO0_RING_MISC_IN(x))
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_SPARE_CONTROL_BMSK                                                              0x3fc000
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_SPARE_CONTROL_SHFT                                                                    14
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_SRNG_SM_STATE2_BMSK                                                               0x3000
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_SRNG_SM_STATE2_SHFT                                                                   12
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_SRNG_SM_STATE1_BMSK                                                                0xf00
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_SRNG_SM_STATE1_SHFT                                                                    8
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_SRNG_IS_IDLE_BMSK                                                                   0x80
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_SRNG_IS_IDLE_SHFT                                                                      7
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_SRNG_ENABLE_BMSK                                                                    0x40
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_SRNG_ENABLE_SHFT                                                                       6
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                              0x20
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                                 5
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                               0x10
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                                  4
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_MSI_SWAP_BIT_BMSK                                                                    0x8
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_MSI_SWAP_BIT_SHFT                                                                      3
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_SECURITY_BIT_BMSK                                                                    0x4
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_SECURITY_BIT_SHFT                                                                      2
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_LOOPCNT_DISABLE_BMSK                                                                 0x2
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_LOOPCNT_DISABLE_SHFT                                                                   1
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_RING_ID_DISABLE_BMSK                                                                 0x1
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_RING_ID_DISABLE_SHFT                                                                   0

#define HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_LSB_ADDR(x)                                                                ((x) + 0xb4)
#define HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_LSB_PHYS(x)                                                                ((x) + 0xb4)
#define HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_LSB_OFFS                                                                   (0xb4)
#define HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_LSB_RMSK                                                                   0xffffffff
#define HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_LSB_POR                                                                    0x00000000
#define HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_LSB_POR_RMSK                                                               0xffffffff
#define HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_LSB_ATTR                                                                                0x3
#define HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                              0xffffffff
#define HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                                       0

#define HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_MSB_ADDR(x)                                                                ((x) + 0xb8)
#define HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_MSB_PHYS(x)                                                                ((x) + 0xb8)
#define HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_MSB_OFFS                                                                   (0xb8)
#define HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_MSB_RMSK                                                                         0xff
#define HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_MSB_POR                                                                    0x00000000
#define HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_MSB_POR_RMSK                                                               0xffffffff
#define HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_MSB_ATTR                                                                                0x3
#define HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                                    0xff
#define HWIO_REO_R0_RXDMA2REO0_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                                       0

#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                                     ((x) + 0xc8)
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                                     ((x) + 0xc8)
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                        (0xc8)
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                        0xffffffff
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX0_POR                                                         0x00000000
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                                    0xffffffff
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                                     0x3
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                              0xffff0000
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                                      16
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                          0x8000
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                              15
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                                    0x7fff
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                         0

#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                                     ((x) + 0xcc)
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                                     ((x) + 0xcc)
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                        (0xcc)
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                            0xffff
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX1_POR                                                         0x00000000
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                                    0xffffffff
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                                     0x3
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                              0xffff
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                                   0

#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_STATUS_ADDR(x)                                                        ((x) + 0xd0)
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_STATUS_PHYS(x)                                                        ((x) + 0xd0)
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_STATUS_OFFS                                                           (0xd0)
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_STATUS_RMSK                                                           0xffffffff
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_STATUS_POR                                                            0x00000000
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_STATUS_POR_RMSK                                                       0xffffffff
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_STATUS_ATTR                                                                        0x1
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                             0xffff0000
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                                     16
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                        0x8000
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                            15
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                                  0x7fff
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                       0

#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                                     ((x) + 0xd4)
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                                     ((x) + 0xd4)
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                        (0xd4)
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                             0x3ff
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_EMPTY_COUNTER_POR                                                         0x00000000
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                                    0xffffffff
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                                     0x3
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                          0x3ff
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                              0

#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                                    ((x) + 0xd8)
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                                    ((x) + 0xd8)
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_TIMER_OFFS                                                       (0xd8)
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                              0x7
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_TIMER_POR                                                        0x00000003
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                                   0xffffffff
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                                    0x3
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                         0x7
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                           0

#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                                   ((x) + 0xdc)
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                                   ((x) + 0xdc)
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_STATUS_OFFS                                                      (0xdc)
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_STATUS_RMSK                                                        0xffffff
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_STATUS_POR                                                       0x00000000
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                                  0xffffffff
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                                   0x1
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                         0xff0000
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                               16
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                                        0xffff
#define HWIO_REO_R0_RXDMA2REO0_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                             0

#define HWIO_REO_R0_RXDMA2REO0_RING_HP_TP_SW_OFFSET_ADDR(x)                                                            ((x) + 0x108)
#define HWIO_REO_R0_RXDMA2REO0_RING_HP_TP_SW_OFFSET_PHYS(x)                                                            ((x) + 0x108)
#define HWIO_REO_R0_RXDMA2REO0_RING_HP_TP_SW_OFFSET_OFFS                                                               (0x108)
#define HWIO_REO_R0_RXDMA2REO0_RING_HP_TP_SW_OFFSET_RMSK                                                                   0xffff
#define HWIO_REO_R0_RXDMA2REO0_RING_HP_TP_SW_OFFSET_POR                                                                0x00000000
#define HWIO_REO_R0_RXDMA2REO0_RING_HP_TP_SW_OFFSET_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_RXDMA2REO0_RING_HP_TP_SW_OFFSET_ATTR                                                                            0x3
#define HWIO_REO_R0_RXDMA2REO0_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO0_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO0_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO0_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO0_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO0_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO0_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO0_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO0_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_RXDMA2REO0_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                                0xffff
#define HWIO_REO_R0_RXDMA2REO0_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                                     0

#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_1_ADDR(x)                                                                     ((x) + 0x10c)
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_1_PHYS(x)                                                                     ((x) + 0x10c)
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_1_OFFS                                                                        (0x10c)
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_1_RMSK                                                                        0xffff003f
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_1_POR                                                                         0x00000000
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_1_POR_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_1_ATTR                                                                                     0x3
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO0_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO0_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO0_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO0_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO0_RING_MISC_1_IN(x))
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                               0xffff0000
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                       16
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                                      0x3f
#define HWIO_REO_R0_RXDMA2REO0_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                         0

#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_LSB_ADDR(x)                                                               ((x) + 0x110)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_LSB_PHYS(x)                                                               ((x) + 0x110)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_LSB_OFFS                                                                  (0x110)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_LSB_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_LSB_POR                                                                   0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_LSB_POR_RMSK                                                              0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_LSB_ATTR                                                                               0x3
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                               0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                        0

#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_MSB_ADDR(x)                                                               ((x) + 0x114)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_MSB_PHYS(x)                                                               ((x) + 0x114)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_MSB_OFFS                                                                  (0x114)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_MSB_RMSK                                                                    0xffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_MSB_POR                                                                   0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_MSB_POR_RMSK                                                              0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_MSB_ATTR                                                                               0x3
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_MSB_RING_SIZE_BMSK                                                          0xffff00
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_MSB_RING_SIZE_SHFT                                                                 8
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                     0xff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                        0

#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_ID_ADDR(x)                                                                     ((x) + 0x118)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_ID_PHYS(x)                                                                     ((x) + 0x118)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_ID_OFFS                                                                        (0x118)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_ID_RMSK                                                                              0xff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_ID_POR                                                                         0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_ID_POR_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_ID_ATTR                                                                                     0x3
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_ID_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO1_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO1_RING_ID_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO1_RING_ID_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_ID_ENTRY_SIZE_BMSK                                                                   0xff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_ID_ENTRY_SIZE_SHFT                                                                      0

#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_STATUS_ADDR(x)                                                                 ((x) + 0x11c)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_STATUS_PHYS(x)                                                                 ((x) + 0x11c)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_STATUS_OFFS                                                                    (0x11c)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_STATUS_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_STATUS_POR                                                                     0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_STATUS_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_STATUS_ATTR                                                                                 0x1
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO1_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                    0xffff0000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                            16
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_STATUS_NUM_VALID_WORDS_BMSK                                                        0xffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_STATUS_NUM_VALID_WORDS_SHFT                                                             0

#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_ADDR(x)                                                                   ((x) + 0x120)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_PHYS(x)                                                                   ((x) + 0x120)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_OFFS                                                                      (0x120)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_RMSK                                                                        0x3fffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_POR                                                                       0x00000080
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_ATTR                                                                                   0x3
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_SPARE_CONTROL_BMSK                                                          0x3fc000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_SPARE_CONTROL_SHFT                                                                14
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_SRNG_SM_STATE2_BMSK                                                           0x3000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_SRNG_SM_STATE2_SHFT                                                               12
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_SRNG_SM_STATE1_BMSK                                                            0xf00
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_SRNG_SM_STATE1_SHFT                                                                8
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_SRNG_IS_IDLE_BMSK                                                               0x80
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_SRNG_IS_IDLE_SHFT                                                                  7
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_SRNG_ENABLE_BMSK                                                                0x40
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_SRNG_ENABLE_SHFT                                                                   6
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                          0x20
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                             5
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                           0x10
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                              4
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_MSI_SWAP_BIT_BMSK                                                                0x8
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_MSI_SWAP_BIT_SHFT                                                                  3
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_SECURITY_BIT_BMSK                                                                0x4
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_SECURITY_BIT_SHFT                                                                  2
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_LOOPCNT_DISABLE_BMSK                                                             0x2
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_LOOPCNT_DISABLE_SHFT                                                               1
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_RING_ID_DISABLE_BMSK                                                             0x1
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_RING_ID_DISABLE_SHFT                                                               0

#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_LSB_ADDR(x)                                                            ((x) + 0x12c)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_LSB_PHYS(x)                                                            ((x) + 0x12c)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_LSB_OFFS                                                               (0x12c)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_LSB_RMSK                                                               0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_LSB_POR                                                                0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_LSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_LSB_ATTR                                                                            0x3
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                          0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                                   0

#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_MSB_ADDR(x)                                                            ((x) + 0x130)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_MSB_PHYS(x)                                                            ((x) + 0x130)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_MSB_OFFS                                                               (0x130)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_MSB_RMSK                                                                     0xff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_MSB_POR                                                                0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_MSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_MSB_ATTR                                                                            0x3
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                                0xff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                                   0

#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                                 ((x) + 0x140)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                                 ((x) + 0x140)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                    (0x140)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                    0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX0_POR                                                     0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                                0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                                 0x3
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                          0xffff0000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                                  16
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                      0x8000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                          15
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                                0x7fff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                     0

#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                                 ((x) + 0x144)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                                 ((x) + 0x144)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                    (0x144)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                        0xffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX1_POR                                                     0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                                0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                                 0x3
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                          0xffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                               0

#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_STATUS_ADDR(x)                                                    ((x) + 0x148)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_STATUS_PHYS(x)                                                    ((x) + 0x148)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_STATUS_OFFS                                                       (0x148)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_STATUS_RMSK                                                       0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_STATUS_POR                                                        0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_STATUS_POR_RMSK                                                   0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_STATUS_ATTR                                                                    0x1
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                         0xffff0000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                                 16
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                    0x8000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                        15
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                              0x7fff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                   0

#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                                 ((x) + 0x14c)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                                 ((x) + 0x14c)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                    (0x14c)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                         0x3ff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_EMPTY_COUNTER_POR                                                     0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                                0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                                 0x3
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                      0x3ff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                          0

#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                                ((x) + 0x150)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                                ((x) + 0x150)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_TIMER_OFFS                                                   (0x150)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                          0x7
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_TIMER_POR                                                    0x00000003
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                               0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                                0x3
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                     0x7
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                       0

#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                               ((x) + 0x154)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                               ((x) + 0x154)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_STATUS_OFFS                                                  (0x154)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_STATUS_RMSK                                                    0xffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_STATUS_POR                                                   0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                              0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                               0x1
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                     0xff0000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                           16
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                                    0xffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                         0

#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_LSB_ADDR(x)                                                          ((x) + 0x158)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_LSB_PHYS(x)                                                          ((x) + 0x158)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_LSB_OFFS                                                             (0x158)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_LSB_RMSK                                                             0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_LSB_POR                                                              0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_LSB_POR_RMSK                                                         0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_LSB_ATTR                                                                          0x3
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_LSB_ADDR_BMSK                                                        0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_LSB_ADDR_SHFT                                                                 0

#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_MSB_ADDR(x)                                                          ((x) + 0x15c)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_MSB_PHYS(x)                                                          ((x) + 0x15c)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_MSB_OFFS                                                             (0x15c)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_MSB_RMSK                                                                  0x1ff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_MSB_POR                                                              0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_MSB_POR_RMSK                                                         0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_MSB_ATTR                                                                          0x3
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                      0x100
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                          8
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_MSB_ADDR_BMSK                                                              0xff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_BASE_MSB_ADDR_SHFT                                                                 0

#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_DATA_ADDR(x)                                                              ((x) + 0x160)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_DATA_PHYS(x)                                                              ((x) + 0x160)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_DATA_OFFS                                                                 (0x160)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_DATA_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_DATA_POR                                                                  0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_DATA_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_DATA_ATTR                                                                              0x3
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_DATA_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_DATA_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_DATA_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_DATA_VALUE_BMSK                                                           0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MSI1_DATA_VALUE_SHFT                                                                    0

#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_HP_TP_SW_OFFSET_ADDR(x)                                                        ((x) + 0x180)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_HP_TP_SW_OFFSET_PHYS(x)                                                        ((x) + 0x180)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_HP_TP_SW_OFFSET_OFFS                                                           (0x180)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_HP_TP_SW_OFFSET_RMSK                                                               0xffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_HP_TP_SW_OFFSET_POR                                                            0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_HP_TP_SW_OFFSET_POR_RMSK                                                       0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_HP_TP_SW_OFFSET_ATTR                                                                        0x3
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO1_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO1_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO1_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                            0xffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                                 0

#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_ADDR(x)                                                           ((x) + 0x184)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_PHYS(x)                                                           ((x) + 0x184)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_OFFS                                                              (0x184)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_RMSK                                                              0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_POR                                                               0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_ATTR                                                                           0x3
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_TIME_THRESHOLD_TO_DOORBELL_BMSK                                   0xffff0000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_TIME_THRESHOLD_TO_DOORBELL_SHFT                                           16
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_FETCH_SAME_POINTER_ERR_INT_REG_CLR_BMSK                               0x8000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_FETCH_SAME_POINTER_ERR_INT_REG_CLR_SHFT                                   15
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_NUM_THRESHOLD_TO_DOORBELL_BMSK                                        0x7e00
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_NUM_THRESHOLD_TO_DOORBELL_SHFT                                             9
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_SRNG_SM_STATE3_BMSK                                                    0x180
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_SRNG_SM_STATE3_SHFT                                                        7
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_INTERVAL_OF_FETCH_POINTER_BMSK                                          0x70
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_INTERVAL_OF_FETCH_POINTER_SHFT                                             4
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_FETCH_SAME_POINTER_THRESHOLD_BMSK                                        0xf
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_FETCH_SAME_POINTER_THRESHOLD_SHFT                                          0

#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_DOORBELL_PRESS_ADDR(x)                                            ((x) + 0x188)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_DOORBELL_PRESS_PHYS(x)                                            ((x) + 0x188)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_DOORBELL_PRESS_OFFS                                               (0x188)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_DOORBELL_PRESS_RMSK                                                   0xffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_DOORBELL_PRESS_POR                                                0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_DOORBELL_PRESS_POR_RMSK                                           0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_DOORBELL_PRESS_ATTR                                                            0x3
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_DOORBELL_PRESS_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_DOORBELL_PRESS_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_DOORBELL_PRESS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_DOORBELL_PRESS_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_DOORBELL_PRESS_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_DOORBELL_PRESS_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_DOORBELL_PRESS_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_DOORBELL_PRESS_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_DOORBELL_PRESS_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_DOORBELL_PRESS_MESSAGE_BMSK                                           0xffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_MLO_DOORBELL_PRESS_MESSAGE_SHFT                                                0

#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ADDR(x)                                        ((x) + 0x18c)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_PHYS(x)                                        ((x) + 0x18c)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_OFFS                                           (0x18c)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_RMSK                                           0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_POR                                            0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_POR_RMSK                                       0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ATTR                                                        0x3
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_VALUE_BMSK                                     0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_VALUE_SHFT                                              0

#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ADDR(x)                                        ((x) + 0x190)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_PHYS(x)                                        ((x) + 0x190)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_OFFS                                           (0x190)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_RMSK                                                 0xff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_POR                                            0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_POR_RMSK                                       0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ATTR                                                        0x3
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_VALUE_BMSK                                           0xff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_VALUE_SHFT                                              0

#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_LSB_ADDR(x)                                         ((x) + 0x194)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_LSB_PHYS(x)                                         ((x) + 0x194)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_LSB_OFFS                                            (0x194)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_LSB_RMSK                                            0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_LSB_POR                                             0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_LSB_POR_RMSK                                        0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_LSB_ATTR                                                         0x3
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_LSB_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_LSB_VALUE_BMSK                                      0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_LSB_VALUE_SHFT                                               0

#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_MSB_ADDR(x)                                         ((x) + 0x198)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_MSB_PHYS(x)                                         ((x) + 0x198)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_MSB_OFFS                                            (0x198)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_MSB_RMSK                                                  0xff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_MSB_POR                                             0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_MSB_POR_RMSK                                        0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_MSB_ATTR                                                         0x3
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_MSB_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_MSB_VALUE_BMSK                                            0xff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_CONSUMER_POINTER_READ_ADDR_MSB_VALUE_SHFT                                               0

#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_1_ADDR(x)                                                                 ((x) + 0x19c)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_1_PHYS(x)                                                                 ((x) + 0x19c)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_1_OFFS                                                                    (0x19c)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_1_RMSK                                                                    0xffff003f
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_1_POR                                                                     0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_1_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_1_ATTR                                                                                 0x3
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_1_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                           0xffff0000
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                   16
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                                  0x3f
#define HWIO_REO_R0_RXDMA2REO_MLO1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                     0

#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_LSB_ADDR(x)                                                               ((x) + 0x1a0)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_LSB_PHYS(x)                                                               ((x) + 0x1a0)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_LSB_OFFS                                                                  (0x1a0)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_LSB_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_LSB_POR                                                                   0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_LSB_POR_RMSK                                                              0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_LSB_ATTR                                                                               0x3
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                               0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                        0

#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_MSB_ADDR(x)                                                               ((x) + 0x1a4)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_MSB_PHYS(x)                                                               ((x) + 0x1a4)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_MSB_OFFS                                                                  (0x1a4)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_MSB_RMSK                                                                    0xffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_MSB_POR                                                                   0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_MSB_POR_RMSK                                                              0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_MSB_ATTR                                                                               0x3
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_MSB_RING_SIZE_BMSK                                                          0xffff00
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_MSB_RING_SIZE_SHFT                                                                 8
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                     0xff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                        0

#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_ID_ADDR(x)                                                                     ((x) + 0x1a8)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_ID_PHYS(x)                                                                     ((x) + 0x1a8)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_ID_OFFS                                                                        (0x1a8)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_ID_RMSK                                                                              0xff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_ID_POR                                                                         0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_ID_POR_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_ID_ATTR                                                                                     0x3
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_ID_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO2_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO2_RING_ID_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO2_RING_ID_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_ID_ENTRY_SIZE_BMSK                                                                   0xff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_ID_ENTRY_SIZE_SHFT                                                                      0

#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_STATUS_ADDR(x)                                                                 ((x) + 0x1ac)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_STATUS_PHYS(x)                                                                 ((x) + 0x1ac)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_STATUS_OFFS                                                                    (0x1ac)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_STATUS_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_STATUS_POR                                                                     0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_STATUS_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_STATUS_ATTR                                                                                 0x1
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO2_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                    0xffff0000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                            16
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_STATUS_NUM_VALID_WORDS_BMSK                                                        0xffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_STATUS_NUM_VALID_WORDS_SHFT                                                             0

#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_ADDR(x)                                                                   ((x) + 0x1b0)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_PHYS(x)                                                                   ((x) + 0x1b0)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_OFFS                                                                      (0x1b0)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_RMSK                                                                        0x3fffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_POR                                                                       0x00000080
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_ATTR                                                                                   0x3
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_SPARE_CONTROL_BMSK                                                          0x3fc000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_SPARE_CONTROL_SHFT                                                                14
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_SRNG_SM_STATE2_BMSK                                                           0x3000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_SRNG_SM_STATE2_SHFT                                                               12
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_SRNG_SM_STATE1_BMSK                                                            0xf00
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_SRNG_SM_STATE1_SHFT                                                                8
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_SRNG_IS_IDLE_BMSK                                                               0x80
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_SRNG_IS_IDLE_SHFT                                                                  7
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_SRNG_ENABLE_BMSK                                                                0x40
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_SRNG_ENABLE_SHFT                                                                   6
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                          0x20
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                             5
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                           0x10
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                              4
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_MSI_SWAP_BIT_BMSK                                                                0x8
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_MSI_SWAP_BIT_SHFT                                                                  3
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_SECURITY_BIT_BMSK                                                                0x4
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_SECURITY_BIT_SHFT                                                                  2
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_LOOPCNT_DISABLE_BMSK                                                             0x2
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_LOOPCNT_DISABLE_SHFT                                                               1
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_RING_ID_DISABLE_BMSK                                                             0x1
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_RING_ID_DISABLE_SHFT                                                               0

#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_LSB_ADDR(x)                                                            ((x) + 0x1bc)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_LSB_PHYS(x)                                                            ((x) + 0x1bc)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_LSB_OFFS                                                               (0x1bc)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_LSB_RMSK                                                               0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_LSB_POR                                                                0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_LSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_LSB_ATTR                                                                            0x3
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                          0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                                   0

#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_MSB_ADDR(x)                                                            ((x) + 0x1c0)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_MSB_PHYS(x)                                                            ((x) + 0x1c0)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_MSB_OFFS                                                               (0x1c0)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_MSB_RMSK                                                                     0xff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_MSB_POR                                                                0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_MSB_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_MSB_ATTR                                                                            0x3
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                                0xff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                                   0

#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                                 ((x) + 0x1d0)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                                 ((x) + 0x1d0)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                    (0x1d0)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                    0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX0_POR                                                     0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                                0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                                 0x3
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                          0xffff0000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                                  16
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                      0x8000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                          15
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                                0x7fff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                     0

#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                                 ((x) + 0x1d4)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                                 ((x) + 0x1d4)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                    (0x1d4)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                        0xffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX1_POR                                                     0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                                0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                                 0x3
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                          0xffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                               0

#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_STATUS_ADDR(x)                                                    ((x) + 0x1d8)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_STATUS_PHYS(x)                                                    ((x) + 0x1d8)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_STATUS_OFFS                                                       (0x1d8)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_STATUS_RMSK                                                       0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_STATUS_POR                                                        0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_STATUS_POR_RMSK                                                   0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_STATUS_ATTR                                                                    0x1
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                         0xffff0000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                                 16
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                    0x8000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                        15
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                              0x7fff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                   0

#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                                 ((x) + 0x1dc)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                                 ((x) + 0x1dc)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                    (0x1dc)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                         0x3ff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_EMPTY_COUNTER_POR                                                     0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                                0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                                 0x3
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                      0x3ff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                          0

#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                                ((x) + 0x1e0)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                                ((x) + 0x1e0)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_TIMER_OFFS                                                   (0x1e0)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                          0x7
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_TIMER_POR                                                    0x00000003
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                               0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                                0x3
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                     0x7
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                       0

#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                               ((x) + 0x1e4)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                               ((x) + 0x1e4)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_STATUS_OFFS                                                  (0x1e4)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_STATUS_RMSK                                                    0xffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_STATUS_POR                                                   0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                              0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                               0x1
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                     0xff0000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                           16
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                                    0xffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                         0

#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_LSB_ADDR(x)                                                          ((x) + 0x1e8)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_LSB_PHYS(x)                                                          ((x) + 0x1e8)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_LSB_OFFS                                                             (0x1e8)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_LSB_RMSK                                                             0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_LSB_POR                                                              0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_LSB_POR_RMSK                                                         0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_LSB_ATTR                                                                          0x3
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_LSB_ADDR_BMSK                                                        0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_LSB_ADDR_SHFT                                                                 0

#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_MSB_ADDR(x)                                                          ((x) + 0x1ec)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_MSB_PHYS(x)                                                          ((x) + 0x1ec)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_MSB_OFFS                                                             (0x1ec)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_MSB_RMSK                                                                  0x1ff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_MSB_POR                                                              0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_MSB_POR_RMSK                                                         0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_MSB_ATTR                                                                          0x3
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                      0x100
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                          8
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_MSB_ADDR_BMSK                                                              0xff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_BASE_MSB_ADDR_SHFT                                                                 0

#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_DATA_ADDR(x)                                                              ((x) + 0x1f0)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_DATA_PHYS(x)                                                              ((x) + 0x1f0)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_DATA_OFFS                                                                 (0x1f0)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_DATA_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_DATA_POR                                                                  0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_DATA_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_DATA_ATTR                                                                              0x3
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_DATA_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_DATA_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_DATA_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_DATA_VALUE_BMSK                                                           0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MSI1_DATA_VALUE_SHFT                                                                    0

#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_HP_TP_SW_OFFSET_ADDR(x)                                                        ((x) + 0x210)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_HP_TP_SW_OFFSET_PHYS(x)                                                        ((x) + 0x210)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_HP_TP_SW_OFFSET_OFFS                                                           (0x210)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_HP_TP_SW_OFFSET_RMSK                                                               0xffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_HP_TP_SW_OFFSET_POR                                                            0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_HP_TP_SW_OFFSET_POR_RMSK                                                       0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_HP_TP_SW_OFFSET_ATTR                                                                        0x3
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO2_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO2_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO2_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                            0xffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                                 0

#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_ADDR(x)                                                           ((x) + 0x214)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_PHYS(x)                                                           ((x) + 0x214)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_OFFS                                                              (0x214)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_RMSK                                                              0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_POR                                                               0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_ATTR                                                                           0x3
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_TIME_THRESHOLD_TO_DOORBELL_BMSK                                   0xffff0000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_TIME_THRESHOLD_TO_DOORBELL_SHFT                                           16
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_FETCH_SAME_POINTER_ERR_INT_REG_CLR_BMSK                               0x8000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_FETCH_SAME_POINTER_ERR_INT_REG_CLR_SHFT                                   15
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_NUM_THRESHOLD_TO_DOORBELL_BMSK                                        0x7e00
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_NUM_THRESHOLD_TO_DOORBELL_SHFT                                             9
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_SRNG_SM_STATE3_BMSK                                                    0x180
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_SRNG_SM_STATE3_SHFT                                                        7
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_INTERVAL_OF_FETCH_POINTER_BMSK                                          0x70
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_INTERVAL_OF_FETCH_POINTER_SHFT                                             4
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_FETCH_SAME_POINTER_THRESHOLD_BMSK                                        0xf
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_FETCH_SAME_POINTER_THRESHOLD_SHFT                                          0

#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_DOORBELL_PRESS_ADDR(x)                                            ((x) + 0x218)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_DOORBELL_PRESS_PHYS(x)                                            ((x) + 0x218)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_DOORBELL_PRESS_OFFS                                               (0x218)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_DOORBELL_PRESS_RMSK                                                   0xffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_DOORBELL_PRESS_POR                                                0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_DOORBELL_PRESS_POR_RMSK                                           0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_DOORBELL_PRESS_ATTR                                                            0x3
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_DOORBELL_PRESS_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_DOORBELL_PRESS_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_DOORBELL_PRESS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_DOORBELL_PRESS_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_DOORBELL_PRESS_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_DOORBELL_PRESS_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_DOORBELL_PRESS_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_DOORBELL_PRESS_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_DOORBELL_PRESS_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_DOORBELL_PRESS_MESSAGE_BMSK                                           0xffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_MLO_DOORBELL_PRESS_MESSAGE_SHFT                                                0

#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ADDR(x)                                        ((x) + 0x21c)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_PHYS(x)                                        ((x) + 0x21c)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_OFFS                                           (0x21c)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_RMSK                                           0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_POR                                            0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_POR_RMSK                                       0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ATTR                                                        0x3
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_VALUE_BMSK                                     0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_VALUE_SHFT                                              0

#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ADDR(x)                                        ((x) + 0x220)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_PHYS(x)                                        ((x) + 0x220)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_OFFS                                           (0x220)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_RMSK                                                 0xff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_POR                                            0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_POR_RMSK                                       0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ATTR                                                        0x3
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_VALUE_BMSK                                           0xff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_VALUE_SHFT                                              0

#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_LSB_ADDR(x)                                         ((x) + 0x224)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_LSB_PHYS(x)                                         ((x) + 0x224)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_LSB_OFFS                                            (0x224)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_LSB_RMSK                                            0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_LSB_POR                                             0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_LSB_POR_RMSK                                        0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_LSB_ATTR                                                         0x3
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_LSB_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_LSB_VALUE_BMSK                                      0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_LSB_VALUE_SHFT                                               0

#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_MSB_ADDR(x)                                         ((x) + 0x228)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_MSB_PHYS(x)                                         ((x) + 0x228)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_MSB_OFFS                                            (0x228)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_MSB_RMSK                                                  0xff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_MSB_POR                                             0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_MSB_POR_RMSK                                        0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_MSB_ATTR                                                         0x3
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_MSB_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_MSB_VALUE_BMSK                                            0xff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_CONSUMER_POINTER_READ_ADDR_MSB_VALUE_SHFT                                               0

#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_1_ADDR(x)                                                                 ((x) + 0x22c)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_1_PHYS(x)                                                                 ((x) + 0x22c)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_1_OFFS                                                                    (0x22c)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_1_RMSK                                                                    0xffff003f
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_1_POR                                                                     0x00000000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_1_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_1_ATTR                                                                                 0x3
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_1_IN(x))
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                           0xffff0000
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                   16
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                                  0x3f
#define HWIO_REO_R0_RXDMA2REO_MLO2_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                     0

#define HWIO_REO_R0_WBM2REO_LINK_RING_BASE_LSB_ADDR(x)                                                                 ((x) + 0x230)
#define HWIO_REO_R0_WBM2REO_LINK_RING_BASE_LSB_PHYS(x)                                                                 ((x) + 0x230)
#define HWIO_REO_R0_WBM2REO_LINK_RING_BASE_LSB_OFFS                                                                    (0x230)
#define HWIO_REO_R0_WBM2REO_LINK_RING_BASE_LSB_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_WBM2REO_LINK_RING_BASE_LSB_POR                                                                     0x00000000
#define HWIO_REO_R0_WBM2REO_LINK_RING_BASE_LSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_WBM2REO_LINK_RING_BASE_LSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_WBM2REO_LINK_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_WBM2REO_LINK_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_WBM2REO_LINK_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_WBM2REO_LINK_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_WBM2REO_LINK_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_WBM2REO_LINK_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_WBM2REO_LINK_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_WBM2REO_LINK_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_WBM2REO_LINK_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_WBM2REO_LINK_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                                 0xffffffff
#define HWIO_REO_R0_WBM2REO_LINK_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                          0

#define HWIO_REO_R0_WBM2REO_LINK_RING_BASE_MSB_ADDR(x)                                                                 ((x) + 0x234)
#define HWIO_REO_R0_WBM2REO_LINK_RING_BASE_MSB_PHYS(x)                                                                 ((x) + 0x234)
#define HWIO_REO_R0_WBM2REO_LINK_RING_BASE_MSB_OFFS                                                                    (0x234)
#define HWIO_REO_R0_WBM2REO_LINK_RING_BASE_MSB_RMSK                                                                      0xffffff
#define HWIO_REO_R0_WBM2REO_LINK_RING_BASE_MSB_POR                                                                     0x00000000
#define HWIO_REO_R0_WBM2REO_LINK_RING_BASE_MSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_WBM2REO_LINK_RING_BASE_MSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_WBM2REO_LINK_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_WBM2REO_LINK_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_WBM2REO_LINK_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_WBM2REO_LINK_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_WBM2REO_LINK_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_WBM2REO_LINK_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_WBM2REO_LINK_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_WBM2REO_LINK_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_WBM2REO_LINK_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_WBM2REO_LINK_RING_BASE_MSB_RING_SIZE_BMSK                                                            0xffff00
#define HWIO_REO_R0_WBM2REO_LINK_RING_BASE_MSB_RING_SIZE_SHFT                                                                   8
#define HWIO_REO_R0_WBM2REO_LINK_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                       0xff
#define HWIO_REO_R0_WBM2REO_LINK_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                          0

#define HWIO_REO_R0_WBM2REO_LINK_RING_ID_ADDR(x)                                                                       ((x) + 0x238)
#define HWIO_REO_R0_WBM2REO_LINK_RING_ID_PHYS(x)                                                                       ((x) + 0x238)
#define HWIO_REO_R0_WBM2REO_LINK_RING_ID_OFFS                                                                          (0x238)
#define HWIO_REO_R0_WBM2REO_LINK_RING_ID_RMSK                                                                                0xff
#define HWIO_REO_R0_WBM2REO_LINK_RING_ID_POR                                                                           0x00000000
#define HWIO_REO_R0_WBM2REO_LINK_RING_ID_POR_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_WBM2REO_LINK_RING_ID_ATTR                                                                                       0x3
#define HWIO_REO_R0_WBM2REO_LINK_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_WBM2REO_LINK_RING_ID_ADDR(x))
#define HWIO_REO_R0_WBM2REO_LINK_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_WBM2REO_LINK_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_WBM2REO_LINK_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_WBM2REO_LINK_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_WBM2REO_LINK_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_WBM2REO_LINK_RING_ID_ADDR(x),m,v,HWIO_REO_R0_WBM2REO_LINK_RING_ID_IN(x))
#define HWIO_REO_R0_WBM2REO_LINK_RING_ID_ENTRY_SIZE_BMSK                                                                     0xff
#define HWIO_REO_R0_WBM2REO_LINK_RING_ID_ENTRY_SIZE_SHFT                                                                        0

#define HWIO_REO_R0_WBM2REO_LINK_RING_STATUS_ADDR(x)                                                                   ((x) + 0x23c)
#define HWIO_REO_R0_WBM2REO_LINK_RING_STATUS_PHYS(x)                                                                   ((x) + 0x23c)
#define HWIO_REO_R0_WBM2REO_LINK_RING_STATUS_OFFS                                                                      (0x23c)
#define HWIO_REO_R0_WBM2REO_LINK_RING_STATUS_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_WBM2REO_LINK_RING_STATUS_POR                                                                       0x00000000
#define HWIO_REO_R0_WBM2REO_LINK_RING_STATUS_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_WBM2REO_LINK_RING_STATUS_ATTR                                                                                   0x1
#define HWIO_REO_R0_WBM2REO_LINK_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_WBM2REO_LINK_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_WBM2REO_LINK_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_WBM2REO_LINK_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_WBM2REO_LINK_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                      0xffff0000
#define HWIO_REO_R0_WBM2REO_LINK_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                              16
#define HWIO_REO_R0_WBM2REO_LINK_RING_STATUS_NUM_VALID_WORDS_BMSK                                                          0xffff
#define HWIO_REO_R0_WBM2REO_LINK_RING_STATUS_NUM_VALID_WORDS_SHFT                                                               0

#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_ADDR(x)                                                                     ((x) + 0x240)
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_PHYS(x)                                                                     ((x) + 0x240)
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_OFFS                                                                        (0x240)
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_RMSK                                                                          0x3fffff
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_POR                                                                         0x00000080
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_POR_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_ATTR                                                                                     0x3
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_WBM2REO_LINK_RING_MISC_ADDR(x))
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_WBM2REO_LINK_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_WBM2REO_LINK_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_WBM2REO_LINK_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_WBM2REO_LINK_RING_MISC_IN(x))
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_SPARE_CONTROL_BMSK                                                            0x3fc000
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_SPARE_CONTROL_SHFT                                                                  14
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_SRNG_SM_STATE2_BMSK                                                             0x3000
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_SRNG_SM_STATE2_SHFT                                                                 12
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_SRNG_SM_STATE1_BMSK                                                              0xf00
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_SRNG_SM_STATE1_SHFT                                                                  8
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_SRNG_IS_IDLE_BMSK                                                                 0x80
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_SRNG_IS_IDLE_SHFT                                                                    7
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_SRNG_ENABLE_BMSK                                                                  0x40
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_SRNG_ENABLE_SHFT                                                                     6
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                            0x20
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                               5
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                             0x10
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                                4
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_MSI_SWAP_BIT_BMSK                                                                  0x8
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_MSI_SWAP_BIT_SHFT                                                                    3
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_SECURITY_BIT_BMSK                                                                  0x4
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_SECURITY_BIT_SHFT                                                                    2
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_LOOPCNT_DISABLE_BMSK                                                               0x2
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_LOOPCNT_DISABLE_SHFT                                                                 1
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_RING_ID_DISABLE_BMSK                                                               0x1
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_RING_ID_DISABLE_SHFT                                                                 0

#define HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_LSB_ADDR(x)                                                              ((x) + 0x24c)
#define HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_LSB_PHYS(x)                                                              ((x) + 0x24c)
#define HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_LSB_OFFS                                                                 (0x24c)
#define HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_LSB_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_LSB_POR                                                                  0x00000000
#define HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_LSB_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_LSB_ATTR                                                                              0x3
#define HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                            0xffffffff
#define HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                                     0

#define HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_MSB_ADDR(x)                                                              ((x) + 0x250)
#define HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_MSB_PHYS(x)                                                              ((x) + 0x250)
#define HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_MSB_OFFS                                                                 (0x250)
#define HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_MSB_RMSK                                                                       0xff
#define HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_MSB_POR                                                                  0x00000000
#define HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_MSB_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_MSB_ATTR                                                                              0x3
#define HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                                  0xff
#define HWIO_REO_R0_WBM2REO_LINK_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                                     0

#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                                   ((x) + 0x260)
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                                   ((x) + 0x260)
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                      (0x260)
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                      0xffffffff
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX0_POR                                                       0x00000000
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                                  0xffffffff
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                                   0x3
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                            0xffff0000
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                                    16
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                        0x8000
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                            15
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                                  0x7fff
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                       0

#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                                   ((x) + 0x264)
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                                   ((x) + 0x264)
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                      (0x264)
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                          0xffff
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX1_POR                                                       0x00000000
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                                  0xffffffff
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                                   0x3
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                            0xffff
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                                 0

#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_STATUS_ADDR(x)                                                      ((x) + 0x268)
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_STATUS_PHYS(x)                                                      ((x) + 0x268)
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_STATUS_OFFS                                                         (0x268)
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_STATUS_RMSK                                                         0xffffffff
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_STATUS_POR                                                          0x00000000
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_STATUS_POR_RMSK                                                     0xffffffff
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_STATUS_ATTR                                                                      0x1
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                           0xffff0000
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                                   16
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                      0x8000
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                          15
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                                0x7fff
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                     0

#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                                   ((x) + 0x26c)
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                                   ((x) + 0x26c)
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                      (0x26c)
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                           0x3ff
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_EMPTY_COUNTER_POR                                                       0x00000000
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                                  0xffffffff
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                                   0x3
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                        0x3ff
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                            0

#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                                  ((x) + 0x270)
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                                  ((x) + 0x270)
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_TIMER_OFFS                                                     (0x270)
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                            0x7
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_TIMER_POR                                                      0x00000003
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                                 0xffffffff
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                                  0x3
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                       0x7
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                         0

#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                                 ((x) + 0x274)
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                                 ((x) + 0x274)
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_STATUS_OFFS                                                    (0x274)
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_STATUS_RMSK                                                      0xffffff
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_STATUS_POR                                                     0x00000000
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                                0xffffffff
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                                 0x1
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                       0xff0000
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                             16
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                                      0xffff
#define HWIO_REO_R0_WBM2REO_LINK_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                           0

#define HWIO_REO_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_ADDR(x)                                                          ((x) + 0x2a0)
#define HWIO_REO_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_PHYS(x)                                                          ((x) + 0x2a0)
#define HWIO_REO_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_OFFS                                                             (0x2a0)
#define HWIO_REO_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_RMSK                                                                 0xffff
#define HWIO_REO_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_POR                                                              0x00000000
#define HWIO_REO_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_POR_RMSK                                                         0xffffffff
#define HWIO_REO_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_ATTR                                                                          0x3
#define HWIO_REO_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                              0xffff
#define HWIO_REO_R0_WBM2REO_LINK_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                                   0

#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_1_ADDR(x)                                                                   ((x) + 0x2a4)
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_1_PHYS(x)                                                                   ((x) + 0x2a4)
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_1_OFFS                                                                      (0x2a4)
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_1_RMSK                                                                      0xffff003f
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_1_POR                                                                       0x00000000
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_1_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_1_ATTR                                                                                   0x3
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_WBM2REO_LINK_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_WBM2REO_LINK_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_WBM2REO_LINK_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_WBM2REO_LINK_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_WBM2REO_LINK_RING_MISC_1_IN(x))
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                             0xffff0000
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                     16
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                                    0x3f
#define HWIO_REO_R0_WBM2REO_LINK_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                       0

#define HWIO_REO_R0_REO_CMD_RING_BASE_LSB_ADDR(x)                                                                      ((x) + 0x2a8)
#define HWIO_REO_R0_REO_CMD_RING_BASE_LSB_PHYS(x)                                                                      ((x) + 0x2a8)
#define HWIO_REO_R0_REO_CMD_RING_BASE_LSB_OFFS                                                                         (0x2a8)
#define HWIO_REO_R0_REO_CMD_RING_BASE_LSB_RMSK                                                                         0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_BASE_LSB_POR                                                                          0x00000000
#define HWIO_REO_R0_REO_CMD_RING_BASE_LSB_POR_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_BASE_LSB_ATTR                                                                                      0x3
#define HWIO_REO_R0_REO_CMD_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_CMD_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO_CMD_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_CMD_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO_CMD_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO_CMD_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                                      0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                               0

#define HWIO_REO_R0_REO_CMD_RING_BASE_MSB_ADDR(x)                                                                      ((x) + 0x2ac)
#define HWIO_REO_R0_REO_CMD_RING_BASE_MSB_PHYS(x)                                                                      ((x) + 0x2ac)
#define HWIO_REO_R0_REO_CMD_RING_BASE_MSB_OFFS                                                                         (0x2ac)
#define HWIO_REO_R0_REO_CMD_RING_BASE_MSB_RMSK                                                                           0xffffff
#define HWIO_REO_R0_REO_CMD_RING_BASE_MSB_POR                                                                          0x00000000
#define HWIO_REO_R0_REO_CMD_RING_BASE_MSB_POR_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_BASE_MSB_ATTR                                                                                      0x3
#define HWIO_REO_R0_REO_CMD_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_CMD_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO_CMD_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_CMD_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO_CMD_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO_CMD_RING_BASE_MSB_RING_SIZE_BMSK                                                                 0xffff00
#define HWIO_REO_R0_REO_CMD_RING_BASE_MSB_RING_SIZE_SHFT                                                                        8
#define HWIO_REO_R0_REO_CMD_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                            0xff
#define HWIO_REO_R0_REO_CMD_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                               0

#define HWIO_REO_R0_REO_CMD_RING_ID_ADDR(x)                                                                            ((x) + 0x2b0)
#define HWIO_REO_R0_REO_CMD_RING_ID_PHYS(x)                                                                            ((x) + 0x2b0)
#define HWIO_REO_R0_REO_CMD_RING_ID_OFFS                                                                               (0x2b0)
#define HWIO_REO_R0_REO_CMD_RING_ID_RMSK                                                                                     0xff
#define HWIO_REO_R0_REO_CMD_RING_ID_POR                                                                                0x00000000
#define HWIO_REO_R0_REO_CMD_RING_ID_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_ID_ATTR                                                                                            0x3
#define HWIO_REO_R0_REO_CMD_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_ID_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_CMD_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_REO_CMD_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_CMD_RING_ID_ADDR(x),m,v,HWIO_REO_R0_REO_CMD_RING_ID_IN(x))
#define HWIO_REO_R0_REO_CMD_RING_ID_ENTRY_SIZE_BMSK                                                                          0xff
#define HWIO_REO_R0_REO_CMD_RING_ID_ENTRY_SIZE_SHFT                                                                             0

#define HWIO_REO_R0_REO_CMD_RING_STATUS_ADDR(x)                                                                        ((x) + 0x2b4)
#define HWIO_REO_R0_REO_CMD_RING_STATUS_PHYS(x)                                                                        ((x) + 0x2b4)
#define HWIO_REO_R0_REO_CMD_RING_STATUS_OFFS                                                                           (0x2b4)
#define HWIO_REO_R0_REO_CMD_RING_STATUS_RMSK                                                                           0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_STATUS_POR                                                                            0x00000000
#define HWIO_REO_R0_REO_CMD_RING_STATUS_POR_RMSK                                                                       0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_STATUS_ATTR                                                                                        0x1
#define HWIO_REO_R0_REO_CMD_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                           0xffff0000
#define HWIO_REO_R0_REO_CMD_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                                   16
#define HWIO_REO_R0_REO_CMD_RING_STATUS_NUM_VALID_WORDS_BMSK                                                               0xffff
#define HWIO_REO_R0_REO_CMD_RING_STATUS_NUM_VALID_WORDS_SHFT                                                                    0

#define HWIO_REO_R0_REO_CMD_RING_MISC_ADDR(x)                                                                          ((x) + 0x2b8)
#define HWIO_REO_R0_REO_CMD_RING_MISC_PHYS(x)                                                                          ((x) + 0x2b8)
#define HWIO_REO_R0_REO_CMD_RING_MISC_OFFS                                                                             (0x2b8)
#define HWIO_REO_R0_REO_CMD_RING_MISC_RMSK                                                                               0x3fffff
#define HWIO_REO_R0_REO_CMD_RING_MISC_POR                                                                              0x00000080
#define HWIO_REO_R0_REO_CMD_RING_MISC_POR_RMSK                                                                         0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_MISC_ATTR                                                                                          0x3
#define HWIO_REO_R0_REO_CMD_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_MISC_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_CMD_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_REO_CMD_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_CMD_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_REO_CMD_RING_MISC_IN(x))
#define HWIO_REO_R0_REO_CMD_RING_MISC_SPARE_CONTROL_BMSK                                                                 0x3fc000
#define HWIO_REO_R0_REO_CMD_RING_MISC_SPARE_CONTROL_SHFT                                                                       14
#define HWIO_REO_R0_REO_CMD_RING_MISC_SRNG_SM_STATE2_BMSK                                                                  0x3000
#define HWIO_REO_R0_REO_CMD_RING_MISC_SRNG_SM_STATE2_SHFT                                                                      12
#define HWIO_REO_R0_REO_CMD_RING_MISC_SRNG_SM_STATE1_BMSK                                                                   0xf00
#define HWIO_REO_R0_REO_CMD_RING_MISC_SRNG_SM_STATE1_SHFT                                                                       8
#define HWIO_REO_R0_REO_CMD_RING_MISC_SRNG_IS_IDLE_BMSK                                                                      0x80
#define HWIO_REO_R0_REO_CMD_RING_MISC_SRNG_IS_IDLE_SHFT                                                                         7
#define HWIO_REO_R0_REO_CMD_RING_MISC_SRNG_ENABLE_BMSK                                                                       0x40
#define HWIO_REO_R0_REO_CMD_RING_MISC_SRNG_ENABLE_SHFT                                                                          6
#define HWIO_REO_R0_REO_CMD_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                                 0x20
#define HWIO_REO_R0_REO_CMD_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                                    5
#define HWIO_REO_R0_REO_CMD_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                                  0x10
#define HWIO_REO_R0_REO_CMD_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                                     4
#define HWIO_REO_R0_REO_CMD_RING_MISC_MSI_SWAP_BIT_BMSK                                                                       0x8
#define HWIO_REO_R0_REO_CMD_RING_MISC_MSI_SWAP_BIT_SHFT                                                                         3
#define HWIO_REO_R0_REO_CMD_RING_MISC_SECURITY_BIT_BMSK                                                                       0x4
#define HWIO_REO_R0_REO_CMD_RING_MISC_SECURITY_BIT_SHFT                                                                         2
#define HWIO_REO_R0_REO_CMD_RING_MISC_LOOPCNT_DISABLE_BMSK                                                                    0x2
#define HWIO_REO_R0_REO_CMD_RING_MISC_LOOPCNT_DISABLE_SHFT                                                                      1
#define HWIO_REO_R0_REO_CMD_RING_MISC_RING_ID_DISABLE_BMSK                                                                    0x1
#define HWIO_REO_R0_REO_CMD_RING_MISC_RING_ID_DISABLE_SHFT                                                                      0

#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_ADDR(x)                                                                   ((x) + 0x2c4)
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_PHYS(x)                                                                   ((x) + 0x2c4)
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_OFFS                                                                      (0x2c4)
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_POR                                                                       0x00000000
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_ATTR                                                                                   0x3
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                                 0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                                          0

#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_ADDR(x)                                                                   ((x) + 0x2c8)
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_PHYS(x)                                                                   ((x) + 0x2c8)
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_OFFS                                                                      (0x2c8)
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_RMSK                                                                            0xff
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_POR                                                                       0x00000000
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_ATTR                                                                                   0x3
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                                       0xff
#define HWIO_REO_R0_REO_CMD_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                                          0

#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                                        ((x) + 0x2d8)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                                        ((x) + 0x2d8)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                           (0x2d8)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_POR                                                            0x00000000
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                                       0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                                        0x3
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                                 0xffff0000
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                                         16
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                             0x8000
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                                 15
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                                       0x7fff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                            0

#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                                        ((x) + 0x2dc)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                                        ((x) + 0x2dc)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                           (0x2dc)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                               0xffff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_POR                                                            0x00000000
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                                       0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                                        0x3
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                                 0xffff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                                      0

#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_ADDR(x)                                                           ((x) + 0x2e0)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_PHYS(x)                                                           ((x) + 0x2e0)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_OFFS                                                              (0x2e0)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_POR                                                               0x00000000
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_ATTR                                                                           0x1
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                                0xffff0000
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                                        16
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                           0x8000
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                               15
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                                     0x7fff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                          0

#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                                        ((x) + 0x2e4)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                                        ((x) + 0x2e4)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                           (0x2e4)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                                0x3ff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_POR                                                            0x00000000
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                                       0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                                        0x3
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                             0x3ff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                                 0

#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                                       ((x) + 0x2e8)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                                       ((x) + 0x2e8)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_OFFS                                                          (0x2e8)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                                 0x7
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_POR                                                           0x00000003
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                                       0x3
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                            0x7
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                              0

#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                                      ((x) + 0x2ec)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                                      ((x) + 0x2ec)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_STATUS_OFFS                                                         (0x2ec)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_STATUS_RMSK                                                           0xffffff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_STATUS_POR                                                          0x00000000
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                                     0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                                      0x1
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                            0xff0000
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                                  16
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                                           0xffff
#define HWIO_REO_R0_REO_CMD_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                                0

#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_ADDR(x)                                                                 ((x) + 0x2f0)
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_PHYS(x)                                                                 ((x) + 0x2f0)
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_OFFS                                                                    (0x2f0)
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_POR                                                                     0x00000000
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_ADDR_BMSK                                                               0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_LSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_ADDR(x)                                                                 ((x) + 0x2f4)
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_PHYS(x)                                                                 ((x) + 0x2f4)
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_OFFS                                                                    (0x2f4)
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_RMSK                                                                         0x1ff
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_POR                                                                     0x00000000
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                             0x100
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                                 8
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_ADDR_BMSK                                                                     0xff
#define HWIO_REO_R0_REO_CMD_RING_MSI1_BASE_MSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_ADDR(x)                                                                     ((x) + 0x2f8)
#define HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_PHYS(x)                                                                     ((x) + 0x2f8)
#define HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_OFFS                                                                        (0x2f8)
#define HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_RMSK                                                                        0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_POR                                                                         0x00000000
#define HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_POR_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_ATTR                                                                                     0x3
#define HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_ADDR(x),m,v,HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_IN(x))
#define HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_VALUE_BMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_MSI1_DATA_VALUE_SHFT                                                                           0

#define HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_ADDR(x)                                                               ((x) + 0x318)
#define HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_PHYS(x)                                                               ((x) + 0x318)
#define HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_OFFS                                                                  (0x318)
#define HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_RMSK                                                                      0xffff
#define HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_POR                                                                   0x00000000
#define HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_POR_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_ATTR                                                                               0x3
#define HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                                   0xffff
#define HWIO_REO_R0_REO_CMD_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                                        0

#define HWIO_REO_R0_REO_CMD_RING_MISC_1_ADDR(x)                                                                        ((x) + 0x31c)
#define HWIO_REO_R0_REO_CMD_RING_MISC_1_PHYS(x)                                                                        ((x) + 0x31c)
#define HWIO_REO_R0_REO_CMD_RING_MISC_1_OFFS                                                                           (0x31c)
#define HWIO_REO_R0_REO_CMD_RING_MISC_1_RMSK                                                                           0xffff003f
#define HWIO_REO_R0_REO_CMD_RING_MISC_1_POR                                                                            0x00000000
#define HWIO_REO_R0_REO_CMD_RING_MISC_1_POR_RMSK                                                                       0xffffffff
#define HWIO_REO_R0_REO_CMD_RING_MISC_1_ATTR                                                                                        0x3
#define HWIO_REO_R0_REO_CMD_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_REO_CMD_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_REO_CMD_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_CMD_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_REO_CMD_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_CMD_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_REO_CMD_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_CMD_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_REO_CMD_RING_MISC_1_IN(x))
#define HWIO_REO_R0_REO_CMD_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                                  0xffff0000
#define HWIO_REO_R0_REO_CMD_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                          16
#define HWIO_REO_R0_REO_CMD_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                                         0x3f
#define HWIO_REO_R0_REO_CMD_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                            0

#define HWIO_REO_R0_SW2REO_RING_BASE_LSB_ADDR(x)                                                                       ((x) + 0x320)
#define HWIO_REO_R0_SW2REO_RING_BASE_LSB_PHYS(x)                                                                       ((x) + 0x320)
#define HWIO_REO_R0_SW2REO_RING_BASE_LSB_OFFS                                                                          (0x320)
#define HWIO_REO_R0_SW2REO_RING_BASE_LSB_RMSK                                                                          0xffffffff
#define HWIO_REO_R0_SW2REO_RING_BASE_LSB_POR                                                                           0x00000000
#define HWIO_REO_R0_SW2REO_RING_BASE_LSB_POR_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_SW2REO_RING_BASE_LSB_ATTR                                                                                       0x3
#define HWIO_REO_R0_SW2REO_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_SW2REO_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                                       0xffffffff
#define HWIO_REO_R0_SW2REO_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                                0

#define HWIO_REO_R0_SW2REO_RING_BASE_MSB_ADDR(x)                                                                       ((x) + 0x324)
#define HWIO_REO_R0_SW2REO_RING_BASE_MSB_PHYS(x)                                                                       ((x) + 0x324)
#define HWIO_REO_R0_SW2REO_RING_BASE_MSB_OFFS                                                                          (0x324)
#define HWIO_REO_R0_SW2REO_RING_BASE_MSB_RMSK                                                                            0xffffff
#define HWIO_REO_R0_SW2REO_RING_BASE_MSB_POR                                                                           0x00000000
#define HWIO_REO_R0_SW2REO_RING_BASE_MSB_POR_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_SW2REO_RING_BASE_MSB_ATTR                                                                                       0x3
#define HWIO_REO_R0_SW2REO_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_SW2REO_RING_BASE_MSB_RING_SIZE_BMSK                                                                  0xffff00
#define HWIO_REO_R0_SW2REO_RING_BASE_MSB_RING_SIZE_SHFT                                                                         8
#define HWIO_REO_R0_SW2REO_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                             0xff
#define HWIO_REO_R0_SW2REO_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                                0

#define HWIO_REO_R0_SW2REO_RING_ID_ADDR(x)                                                                             ((x) + 0x328)
#define HWIO_REO_R0_SW2REO_RING_ID_PHYS(x)                                                                             ((x) + 0x328)
#define HWIO_REO_R0_SW2REO_RING_ID_OFFS                                                                                (0x328)
#define HWIO_REO_R0_SW2REO_RING_ID_RMSK                                                                                      0xff
#define HWIO_REO_R0_SW2REO_RING_ID_POR                                                                                 0x00000000
#define HWIO_REO_R0_SW2REO_RING_ID_POR_RMSK                                                                            0xffffffff
#define HWIO_REO_R0_SW2REO_RING_ID_ATTR                                                                                             0x3
#define HWIO_REO_R0_SW2REO_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_ID_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_SW2REO_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO_RING_ID_ADDR(x),m,v,HWIO_REO_R0_SW2REO_RING_ID_IN(x))
#define HWIO_REO_R0_SW2REO_RING_ID_ENTRY_SIZE_BMSK                                                                           0xff
#define HWIO_REO_R0_SW2REO_RING_ID_ENTRY_SIZE_SHFT                                                                              0

#define HWIO_REO_R0_SW2REO_RING_STATUS_ADDR(x)                                                                         ((x) + 0x32c)
#define HWIO_REO_R0_SW2REO_RING_STATUS_PHYS(x)                                                                         ((x) + 0x32c)
#define HWIO_REO_R0_SW2REO_RING_STATUS_OFFS                                                                            (0x32c)
#define HWIO_REO_R0_SW2REO_RING_STATUS_RMSK                                                                            0xffffffff
#define HWIO_REO_R0_SW2REO_RING_STATUS_POR                                                                             0x00000000
#define HWIO_REO_R0_SW2REO_RING_STATUS_POR_RMSK                                                                        0xffffffff
#define HWIO_REO_R0_SW2REO_RING_STATUS_ATTR                                                                                         0x1
#define HWIO_REO_R0_SW2REO_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                            0xffff0000
#define HWIO_REO_R0_SW2REO_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                                    16
#define HWIO_REO_R0_SW2REO_RING_STATUS_NUM_VALID_WORDS_BMSK                                                                0xffff
#define HWIO_REO_R0_SW2REO_RING_STATUS_NUM_VALID_WORDS_SHFT                                                                     0

#define HWIO_REO_R0_SW2REO_RING_MISC_ADDR(x)                                                                           ((x) + 0x330)
#define HWIO_REO_R0_SW2REO_RING_MISC_PHYS(x)                                                                           ((x) + 0x330)
#define HWIO_REO_R0_SW2REO_RING_MISC_OFFS                                                                              (0x330)
#define HWIO_REO_R0_SW2REO_RING_MISC_RMSK                                                                                0x3fffff
#define HWIO_REO_R0_SW2REO_RING_MISC_POR                                                                               0x00000080
#define HWIO_REO_R0_SW2REO_RING_MISC_POR_RMSK                                                                          0xffffffff
#define HWIO_REO_R0_SW2REO_RING_MISC_ATTR                                                                                           0x3
#define HWIO_REO_R0_SW2REO_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_MISC_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_SW2REO_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_SW2REO_RING_MISC_IN(x))
#define HWIO_REO_R0_SW2REO_RING_MISC_SPARE_CONTROL_BMSK                                                                  0x3fc000
#define HWIO_REO_R0_SW2REO_RING_MISC_SPARE_CONTROL_SHFT                                                                        14
#define HWIO_REO_R0_SW2REO_RING_MISC_SRNG_SM_STATE2_BMSK                                                                   0x3000
#define HWIO_REO_R0_SW2REO_RING_MISC_SRNG_SM_STATE2_SHFT                                                                       12
#define HWIO_REO_R0_SW2REO_RING_MISC_SRNG_SM_STATE1_BMSK                                                                    0xf00
#define HWIO_REO_R0_SW2REO_RING_MISC_SRNG_SM_STATE1_SHFT                                                                        8
#define HWIO_REO_R0_SW2REO_RING_MISC_SRNG_IS_IDLE_BMSK                                                                       0x80
#define HWIO_REO_R0_SW2REO_RING_MISC_SRNG_IS_IDLE_SHFT                                                                          7
#define HWIO_REO_R0_SW2REO_RING_MISC_SRNG_ENABLE_BMSK                                                                        0x40
#define HWIO_REO_R0_SW2REO_RING_MISC_SRNG_ENABLE_SHFT                                                                           6
#define HWIO_REO_R0_SW2REO_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                                  0x20
#define HWIO_REO_R0_SW2REO_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                                     5
#define HWIO_REO_R0_SW2REO_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                                   0x10
#define HWIO_REO_R0_SW2REO_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                                      4
#define HWIO_REO_R0_SW2REO_RING_MISC_MSI_SWAP_BIT_BMSK                                                                        0x8
#define HWIO_REO_R0_SW2REO_RING_MISC_MSI_SWAP_BIT_SHFT                                                                          3
#define HWIO_REO_R0_SW2REO_RING_MISC_SECURITY_BIT_BMSK                                                                        0x4
#define HWIO_REO_R0_SW2REO_RING_MISC_SECURITY_BIT_SHFT                                                                          2
#define HWIO_REO_R0_SW2REO_RING_MISC_LOOPCNT_DISABLE_BMSK                                                                     0x2
#define HWIO_REO_R0_SW2REO_RING_MISC_LOOPCNT_DISABLE_SHFT                                                                       1
#define HWIO_REO_R0_SW2REO_RING_MISC_RING_ID_DISABLE_BMSK                                                                     0x1
#define HWIO_REO_R0_SW2REO_RING_MISC_RING_ID_DISABLE_SHFT                                                                       0

#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_ADDR(x)                                                                    ((x) + 0x33c)
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_PHYS(x)                                                                    ((x) + 0x33c)
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_OFFS                                                                       (0x33c)
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_RMSK                                                                       0xffffffff
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_POR                                                                        0x00000000
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_POR_RMSK                                                                   0xffffffff
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_ATTR                                                                                    0x3
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                                  0xffffffff
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                                           0

#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_ADDR(x)                                                                    ((x) + 0x340)
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_PHYS(x)                                                                    ((x) + 0x340)
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_OFFS                                                                       (0x340)
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_RMSK                                                                             0xff
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_POR                                                                        0x00000000
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_POR_RMSK                                                                   0xffffffff
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_ATTR                                                                                    0x3
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                                        0xff
#define HWIO_REO_R0_SW2REO_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                                           0

#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                                         ((x) + 0x350)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                                         ((x) + 0x350)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                            (0x350)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                            0xffffffff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_POR                                                             0x00000000
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                                         0x3
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                                  0xffff0000
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                                          16
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                              0x8000
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                                  15
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                                        0x7fff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                             0

#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                                         ((x) + 0x354)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                                         ((x) + 0x354)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                            (0x354)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                                0xffff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_POR                                                             0x00000000
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                                         0x3
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                                  0xffff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                                       0

#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_ADDR(x)                                                            ((x) + 0x358)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_PHYS(x)                                                            ((x) + 0x358)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_OFFS                                                               (0x358)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_RMSK                                                               0xffffffff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_POR                                                                0x00000000
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_ATTR                                                                            0x1
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                                 0xffff0000
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                                         16
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                            0x8000
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                                15
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                                      0x7fff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                           0

#define HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                                         ((x) + 0x35c)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                                         ((x) + 0x35c)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                            (0x35c)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                                 0x3ff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_POR                                                             0x00000000
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                                         0x3
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                              0x3ff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                                  0

#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                                        ((x) + 0x360)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                                        ((x) + 0x360)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_OFFS                                                           (0x360)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                                  0x7
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_POR                                                            0x00000003
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                                       0xffffffff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                                        0x3
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                             0x7
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                               0

#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                                       ((x) + 0x364)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                                       ((x) + 0x364)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_STATUS_OFFS                                                          (0x364)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_STATUS_RMSK                                                            0xffffff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_STATUS_POR                                                           0x00000000
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                                       0x1
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                             0xff0000
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                                   16
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                                            0xffff
#define HWIO_REO_R0_SW2REO_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                                 0

#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_ADDR(x)                                                                  ((x) + 0x368)
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_PHYS(x)                                                                  ((x) + 0x368)
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_OFFS                                                                     (0x368)
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_POR                                                                      0x00000000
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_ATTR                                                                                  0x3
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_ADDR_BMSK                                                                0xffffffff
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_LSB_ADDR_SHFT                                                                         0

#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_ADDR(x)                                                                  ((x) + 0x36c)
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_PHYS(x)                                                                  ((x) + 0x36c)
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_OFFS                                                                     (0x36c)
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_RMSK                                                                          0x1ff
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_POR                                                                      0x00000000
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_ATTR                                                                                  0x3
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                              0x100
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                                  8
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_ADDR_BMSK                                                                      0xff
#define HWIO_REO_R0_SW2REO_RING_MSI1_BASE_MSB_ADDR_SHFT                                                                         0

#define HWIO_REO_R0_SW2REO_RING_MSI1_DATA_ADDR(x)                                                                      ((x) + 0x370)
#define HWIO_REO_R0_SW2REO_RING_MSI1_DATA_PHYS(x)                                                                      ((x) + 0x370)
#define HWIO_REO_R0_SW2REO_RING_MSI1_DATA_OFFS                                                                         (0x370)
#define HWIO_REO_R0_SW2REO_RING_MSI1_DATA_RMSK                                                                         0xffffffff
#define HWIO_REO_R0_SW2REO_RING_MSI1_DATA_POR                                                                          0x00000000
#define HWIO_REO_R0_SW2REO_RING_MSI1_DATA_POR_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_SW2REO_RING_MSI1_DATA_ATTR                                                                                      0x3
#define HWIO_REO_R0_SW2REO_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_MSI1_DATA_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_REO_R0_SW2REO_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO_RING_MSI1_DATA_ADDR(x),m,v,HWIO_REO_R0_SW2REO_RING_MSI1_DATA_IN(x))
#define HWIO_REO_R0_SW2REO_RING_MSI1_DATA_VALUE_BMSK                                                                   0xffffffff
#define HWIO_REO_R0_SW2REO_RING_MSI1_DATA_VALUE_SHFT                                                                            0

#define HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_ADDR(x)                                                                ((x) + 0x390)
#define HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_PHYS(x)                                                                ((x) + 0x390)
#define HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_OFFS                                                                   (0x390)
#define HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_RMSK                                                                       0xffff
#define HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_POR                                                                    0x00000000
#define HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_POR_RMSK                                                               0xffffffff
#define HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_ATTR                                                                                0x3
#define HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                                    0xffff
#define HWIO_REO_R0_SW2REO_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                                         0

#define HWIO_REO_R0_SW2REO_RING_MISC_1_ADDR(x)                                                                         ((x) + 0x394)
#define HWIO_REO_R0_SW2REO_RING_MISC_1_PHYS(x)                                                                         ((x) + 0x394)
#define HWIO_REO_R0_SW2REO_RING_MISC_1_OFFS                                                                            (0x394)
#define HWIO_REO_R0_SW2REO_RING_MISC_1_RMSK                                                                            0xffff003f
#define HWIO_REO_R0_SW2REO_RING_MISC_1_POR                                                                             0x00000000
#define HWIO_REO_R0_SW2REO_RING_MISC_1_POR_RMSK                                                                        0xffffffff
#define HWIO_REO_R0_SW2REO_RING_MISC_1_ATTR                                                                                         0x3
#define HWIO_REO_R0_SW2REO_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_SW2REO_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_SW2REO_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_SW2REO_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_SW2REO_RING_MISC_1_IN(x))
#define HWIO_REO_R0_SW2REO_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                                   0xffff0000
#define HWIO_REO_R0_SW2REO_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                           16
#define HWIO_REO_R0_SW2REO_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                                          0x3f
#define HWIO_REO_R0_SW2REO_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                             0

#define HWIO_REO_R0_SW2REO1_RING_BASE_LSB_ADDR(x)                                                                      ((x) + 0x398)
#define HWIO_REO_R0_SW2REO1_RING_BASE_LSB_PHYS(x)                                                                      ((x) + 0x398)
#define HWIO_REO_R0_SW2REO1_RING_BASE_LSB_OFFS                                                                         (0x398)
#define HWIO_REO_R0_SW2REO1_RING_BASE_LSB_RMSK                                                                         0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_BASE_LSB_POR                                                                          0x00000000
#define HWIO_REO_R0_SW2REO1_RING_BASE_LSB_POR_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_BASE_LSB_ATTR                                                                                      0x3
#define HWIO_REO_R0_SW2REO1_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO1_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO1_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO1_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO1_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_SW2REO1_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                                      0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                               0

#define HWIO_REO_R0_SW2REO1_RING_BASE_MSB_ADDR(x)                                                                      ((x) + 0x39c)
#define HWIO_REO_R0_SW2REO1_RING_BASE_MSB_PHYS(x)                                                                      ((x) + 0x39c)
#define HWIO_REO_R0_SW2REO1_RING_BASE_MSB_OFFS                                                                         (0x39c)
#define HWIO_REO_R0_SW2REO1_RING_BASE_MSB_RMSK                                                                           0xffffff
#define HWIO_REO_R0_SW2REO1_RING_BASE_MSB_POR                                                                          0x00000000
#define HWIO_REO_R0_SW2REO1_RING_BASE_MSB_POR_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_BASE_MSB_ATTR                                                                                      0x3
#define HWIO_REO_R0_SW2REO1_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO1_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO1_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO1_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO1_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_SW2REO1_RING_BASE_MSB_RING_SIZE_BMSK                                                                 0xffff00
#define HWIO_REO_R0_SW2REO1_RING_BASE_MSB_RING_SIZE_SHFT                                                                        8
#define HWIO_REO_R0_SW2REO1_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                            0xff
#define HWIO_REO_R0_SW2REO1_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                               0

#define HWIO_REO_R0_SW2REO1_RING_ID_ADDR(x)                                                                            ((x) + 0x3a0)
#define HWIO_REO_R0_SW2REO1_RING_ID_PHYS(x)                                                                            ((x) + 0x3a0)
#define HWIO_REO_R0_SW2REO1_RING_ID_OFFS                                                                               (0x3a0)
#define HWIO_REO_R0_SW2REO1_RING_ID_RMSK                                                                                     0xff
#define HWIO_REO_R0_SW2REO1_RING_ID_POR                                                                                0x00000000
#define HWIO_REO_R0_SW2REO1_RING_ID_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_ID_ATTR                                                                                            0x3
#define HWIO_REO_R0_SW2REO1_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_ID_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO1_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_SW2REO1_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO1_RING_ID_ADDR(x),m,v,HWIO_REO_R0_SW2REO1_RING_ID_IN(x))
#define HWIO_REO_R0_SW2REO1_RING_ID_ENTRY_SIZE_BMSK                                                                          0xff
#define HWIO_REO_R0_SW2REO1_RING_ID_ENTRY_SIZE_SHFT                                                                             0

#define HWIO_REO_R0_SW2REO1_RING_STATUS_ADDR(x)                                                                        ((x) + 0x3a4)
#define HWIO_REO_R0_SW2REO1_RING_STATUS_PHYS(x)                                                                        ((x) + 0x3a4)
#define HWIO_REO_R0_SW2REO1_RING_STATUS_OFFS                                                                           (0x3a4)
#define HWIO_REO_R0_SW2REO1_RING_STATUS_RMSK                                                                           0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_STATUS_POR                                                                            0x00000000
#define HWIO_REO_R0_SW2REO1_RING_STATUS_POR_RMSK                                                                       0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_STATUS_ATTR                                                                                        0x1
#define HWIO_REO_R0_SW2REO1_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                           0xffff0000
#define HWIO_REO_R0_SW2REO1_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                                   16
#define HWIO_REO_R0_SW2REO1_RING_STATUS_NUM_VALID_WORDS_BMSK                                                               0xffff
#define HWIO_REO_R0_SW2REO1_RING_STATUS_NUM_VALID_WORDS_SHFT                                                                    0

#define HWIO_REO_R0_SW2REO1_RING_MISC_ADDR(x)                                                                          ((x) + 0x3a8)
#define HWIO_REO_R0_SW2REO1_RING_MISC_PHYS(x)                                                                          ((x) + 0x3a8)
#define HWIO_REO_R0_SW2REO1_RING_MISC_OFFS                                                                             (0x3a8)
#define HWIO_REO_R0_SW2REO1_RING_MISC_RMSK                                                                               0x3fffff
#define HWIO_REO_R0_SW2REO1_RING_MISC_POR                                                                              0x00000080
#define HWIO_REO_R0_SW2REO1_RING_MISC_POR_RMSK                                                                         0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_MISC_ATTR                                                                                          0x3
#define HWIO_REO_R0_SW2REO1_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_MISC_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO1_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_SW2REO1_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO1_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_SW2REO1_RING_MISC_IN(x))
#define HWIO_REO_R0_SW2REO1_RING_MISC_SPARE_CONTROL_BMSK                                                                 0x3fc000
#define HWIO_REO_R0_SW2REO1_RING_MISC_SPARE_CONTROL_SHFT                                                                       14
#define HWIO_REO_R0_SW2REO1_RING_MISC_SRNG_SM_STATE2_BMSK                                                                  0x3000
#define HWIO_REO_R0_SW2REO1_RING_MISC_SRNG_SM_STATE2_SHFT                                                                      12
#define HWIO_REO_R0_SW2REO1_RING_MISC_SRNG_SM_STATE1_BMSK                                                                   0xf00
#define HWIO_REO_R0_SW2REO1_RING_MISC_SRNG_SM_STATE1_SHFT                                                                       8
#define HWIO_REO_R0_SW2REO1_RING_MISC_SRNG_IS_IDLE_BMSK                                                                      0x80
#define HWIO_REO_R0_SW2REO1_RING_MISC_SRNG_IS_IDLE_SHFT                                                                         7
#define HWIO_REO_R0_SW2REO1_RING_MISC_SRNG_ENABLE_BMSK                                                                       0x40
#define HWIO_REO_R0_SW2REO1_RING_MISC_SRNG_ENABLE_SHFT                                                                          6
#define HWIO_REO_R0_SW2REO1_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                                 0x20
#define HWIO_REO_R0_SW2REO1_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                                    5
#define HWIO_REO_R0_SW2REO1_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                                  0x10
#define HWIO_REO_R0_SW2REO1_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                                     4
#define HWIO_REO_R0_SW2REO1_RING_MISC_MSI_SWAP_BIT_BMSK                                                                       0x8
#define HWIO_REO_R0_SW2REO1_RING_MISC_MSI_SWAP_BIT_SHFT                                                                         3
#define HWIO_REO_R0_SW2REO1_RING_MISC_SECURITY_BIT_BMSK                                                                       0x4
#define HWIO_REO_R0_SW2REO1_RING_MISC_SECURITY_BIT_SHFT                                                                         2
#define HWIO_REO_R0_SW2REO1_RING_MISC_LOOPCNT_DISABLE_BMSK                                                                    0x2
#define HWIO_REO_R0_SW2REO1_RING_MISC_LOOPCNT_DISABLE_SHFT                                                                      1
#define HWIO_REO_R0_SW2REO1_RING_MISC_RING_ID_DISABLE_BMSK                                                                    0x1
#define HWIO_REO_R0_SW2REO1_RING_MISC_RING_ID_DISABLE_SHFT                                                                      0

#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_ADDR(x)                                                                   ((x) + 0x3b4)
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_PHYS(x)                                                                   ((x) + 0x3b4)
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_OFFS                                                                      (0x3b4)
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_POR                                                                       0x00000000
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_ATTR                                                                                   0x3
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                                 0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                                          0

#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_ADDR(x)                                                                   ((x) + 0x3b8)
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_PHYS(x)                                                                   ((x) + 0x3b8)
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_OFFS                                                                      (0x3b8)
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_RMSK                                                                            0xff
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_POR                                                                       0x00000000
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_ATTR                                                                                   0x3
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                                       0xff
#define HWIO_REO_R0_SW2REO1_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                                          0

#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                                        ((x) + 0x3c8)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                                        ((x) + 0x3c8)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                           (0x3c8)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                           0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_POR                                                            0x00000000
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                                       0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                                        0x3
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                                 0xffff0000
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                                         16
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                             0x8000
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                                 15
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                                       0x7fff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                            0

#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                                        ((x) + 0x3cc)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                                        ((x) + 0x3cc)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                           (0x3cc)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                               0xffff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_POR                                                            0x00000000
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                                       0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                                        0x3
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                                 0xffff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                                      0

#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_ADDR(x)                                                           ((x) + 0x3d0)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_PHYS(x)                                                           ((x) + 0x3d0)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_OFFS                                                              (0x3d0)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_RMSK                                                              0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_POR                                                               0x00000000
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_ATTR                                                                           0x1
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                                0xffff0000
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                                        16
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                           0x8000
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                               15
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                                     0x7fff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                          0

#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                                        ((x) + 0x3d4)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                                        ((x) + 0x3d4)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                           (0x3d4)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                                0x3ff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_POR                                                            0x00000000
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                                       0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                                        0x3
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                             0x3ff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                                 0

#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                                       ((x) + 0x3d8)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                                       ((x) + 0x3d8)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_OFFS                                                          (0x3d8)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                                 0x7
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_POR                                                           0x00000003
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                                       0x3
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                            0x7
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                              0

#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                                      ((x) + 0x3dc)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                                      ((x) + 0x3dc)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_STATUS_OFFS                                                         (0x3dc)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_STATUS_RMSK                                                           0xffffff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_STATUS_POR                                                          0x00000000
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                                     0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                                      0x1
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                            0xff0000
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                                  16
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                                           0xffff
#define HWIO_REO_R0_SW2REO1_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                                0

#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_ADDR(x)                                                                 ((x) + 0x3e0)
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_PHYS(x)                                                                 ((x) + 0x3e0)
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_OFFS                                                                    (0x3e0)
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_POR                                                                     0x00000000
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_ADDR_BMSK                                                               0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_LSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_ADDR(x)                                                                 ((x) + 0x3e4)
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_PHYS(x)                                                                 ((x) + 0x3e4)
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_OFFS                                                                    (0x3e4)
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_RMSK                                                                         0x1ff
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_POR                                                                     0x00000000
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                             0x100
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                                 8
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_ADDR_BMSK                                                                     0xff
#define HWIO_REO_R0_SW2REO1_RING_MSI1_BASE_MSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_ADDR(x)                                                                     ((x) + 0x3e8)
#define HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_PHYS(x)                                                                     ((x) + 0x3e8)
#define HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_OFFS                                                                        (0x3e8)
#define HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_RMSK                                                                        0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_POR                                                                         0x00000000
#define HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_POR_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_ATTR                                                                                     0x3
#define HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_ADDR(x),m,v,HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_IN(x))
#define HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_VALUE_BMSK                                                                  0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_MSI1_DATA_VALUE_SHFT                                                                           0

#define HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_ADDR(x)                                                               ((x) + 0x408)
#define HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_PHYS(x)                                                               ((x) + 0x408)
#define HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_OFFS                                                                  (0x408)
#define HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_RMSK                                                                      0xffff
#define HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_POR                                                                   0x00000000
#define HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_POR_RMSK                                                              0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_ATTR                                                                               0x3
#define HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                                   0xffff
#define HWIO_REO_R0_SW2REO1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                                        0

#define HWIO_REO_R0_SW2REO1_RING_MISC_1_ADDR(x)                                                                        ((x) + 0x40c)
#define HWIO_REO_R0_SW2REO1_RING_MISC_1_PHYS(x)                                                                        ((x) + 0x40c)
#define HWIO_REO_R0_SW2REO1_RING_MISC_1_OFFS                                                                           (0x40c)
#define HWIO_REO_R0_SW2REO1_RING_MISC_1_RMSK                                                                           0xffff003f
#define HWIO_REO_R0_SW2REO1_RING_MISC_1_POR                                                                            0x00000000
#define HWIO_REO_R0_SW2REO1_RING_MISC_1_POR_RMSK                                                                       0xffffffff
#define HWIO_REO_R0_SW2REO1_RING_MISC_1_ATTR                                                                                        0x3
#define HWIO_REO_R0_SW2REO1_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_SW2REO1_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_SW2REO1_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_SW2REO1_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_SW2REO1_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_SW2REO1_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_SW2REO1_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_SW2REO1_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_SW2REO1_RING_MISC_1_IN(x))
#define HWIO_REO_R0_SW2REO1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                                  0xffff0000
#define HWIO_REO_R0_SW2REO1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                          16
#define HWIO_REO_R0_SW2REO1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                                         0x3f
#define HWIO_REO_R0_SW2REO1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                            0

#define HWIO_REO_R0_REO2SW1_RING_BASE_LSB_ADDR(x)                                                                      ((x) + 0x500)
#define HWIO_REO_R0_REO2SW1_RING_BASE_LSB_PHYS(x)                                                                      ((x) + 0x500)
#define HWIO_REO_R0_REO2SW1_RING_BASE_LSB_OFFS                                                                         (0x500)
#define HWIO_REO_R0_REO2SW1_RING_BASE_LSB_RMSK                                                                         0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_BASE_LSB_POR                                                                          0x00000000
#define HWIO_REO_R0_REO2SW1_RING_BASE_LSB_POR_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_BASE_LSB_ATTR                                                                                      0x3
#define HWIO_REO_R0_REO2SW1_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                               0

#define HWIO_REO_R0_REO2SW1_RING_BASE_MSB_ADDR(x)                                                                      ((x) + 0x504)
#define HWIO_REO_R0_REO2SW1_RING_BASE_MSB_PHYS(x)                                                                      ((x) + 0x504)
#define HWIO_REO_R0_REO2SW1_RING_BASE_MSB_OFFS                                                                         (0x504)
#define HWIO_REO_R0_REO2SW1_RING_BASE_MSB_RMSK                                                                          0xfffffff
#define HWIO_REO_R0_REO2SW1_RING_BASE_MSB_POR                                                                          0x00000000
#define HWIO_REO_R0_REO2SW1_RING_BASE_MSB_POR_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_BASE_MSB_ATTR                                                                                      0x3
#define HWIO_REO_R0_REO2SW1_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_BASE_MSB_RING_SIZE_BMSK                                                                0xfffff00
#define HWIO_REO_R0_REO2SW1_RING_BASE_MSB_RING_SIZE_SHFT                                                                        8
#define HWIO_REO_R0_REO2SW1_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                            0xff
#define HWIO_REO_R0_REO2SW1_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                               0

#define HWIO_REO_R0_REO2SW1_RING_ID_ADDR(x)                                                                            ((x) + 0x508)
#define HWIO_REO_R0_REO2SW1_RING_ID_PHYS(x)                                                                            ((x) + 0x508)
#define HWIO_REO_R0_REO2SW1_RING_ID_OFFS                                                                               (0x508)
#define HWIO_REO_R0_REO2SW1_RING_ID_RMSK                                                                                   0xffff
#define HWIO_REO_R0_REO2SW1_RING_ID_POR                                                                                0x00000000
#define HWIO_REO_R0_REO2SW1_RING_ID_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_ID_ATTR                                                                                            0x3
#define HWIO_REO_R0_REO2SW1_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_ID_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_ID_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_ID_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_ID_RING_ID_BMSK                                                                           0xff00
#define HWIO_REO_R0_REO2SW1_RING_ID_RING_ID_SHFT                                                                                8
#define HWIO_REO_R0_REO2SW1_RING_ID_ENTRY_SIZE_BMSK                                                                          0xff
#define HWIO_REO_R0_REO2SW1_RING_ID_ENTRY_SIZE_SHFT                                                                             0

#define HWIO_REO_R0_REO2SW1_RING_STATUS_ADDR(x)                                                                        ((x) + 0x50c)
#define HWIO_REO_R0_REO2SW1_RING_STATUS_PHYS(x)                                                                        ((x) + 0x50c)
#define HWIO_REO_R0_REO2SW1_RING_STATUS_OFFS                                                                           (0x50c)
#define HWIO_REO_R0_REO2SW1_RING_STATUS_RMSK                                                                           0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_STATUS_POR                                                                            0x00000000
#define HWIO_REO_R0_REO2SW1_RING_STATUS_POR_RMSK                                                                       0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_STATUS_ATTR                                                                                        0x1
#define HWIO_REO_R0_REO2SW1_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                           0xffff0000
#define HWIO_REO_R0_REO2SW1_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                                   16
#define HWIO_REO_R0_REO2SW1_RING_STATUS_NUM_VALID_WORDS_BMSK                                                               0xffff
#define HWIO_REO_R0_REO2SW1_RING_STATUS_NUM_VALID_WORDS_SHFT                                                                    0

#define HWIO_REO_R0_REO2SW1_RING_MISC_ADDR(x)                                                                          ((x) + 0x510)
#define HWIO_REO_R0_REO2SW1_RING_MISC_PHYS(x)                                                                          ((x) + 0x510)
#define HWIO_REO_R0_REO2SW1_RING_MISC_OFFS                                                                             (0x510)
#define HWIO_REO_R0_REO2SW1_RING_MISC_RMSK                                                                              0x7ffffff
#define HWIO_REO_R0_REO2SW1_RING_MISC_POR                                                                              0x00000080
#define HWIO_REO_R0_REO2SW1_RING_MISC_POR_RMSK                                                                         0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MISC_ATTR                                                                                          0x3
#define HWIO_REO_R0_REO2SW1_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_MISC_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_MISC_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                                      0x4000000
#define HWIO_REO_R0_REO2SW1_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                             26
#define HWIO_REO_R0_REO2SW1_RING_MISC_LOOP_CNT_BMSK                                                                     0x3c00000
#define HWIO_REO_R0_REO2SW1_RING_MISC_LOOP_CNT_SHFT                                                                            22
#define HWIO_REO_R0_REO2SW1_RING_MISC_SPARE_CONTROL_BMSK                                                                 0x3fc000
#define HWIO_REO_R0_REO2SW1_RING_MISC_SPARE_CONTROL_SHFT                                                                       14
#define HWIO_REO_R0_REO2SW1_RING_MISC_SRNG_SM_STATE2_BMSK                                                                  0x3000
#define HWIO_REO_R0_REO2SW1_RING_MISC_SRNG_SM_STATE2_SHFT                                                                      12
#define HWIO_REO_R0_REO2SW1_RING_MISC_SRNG_SM_STATE1_BMSK                                                                   0xf00
#define HWIO_REO_R0_REO2SW1_RING_MISC_SRNG_SM_STATE1_SHFT                                                                       8
#define HWIO_REO_R0_REO2SW1_RING_MISC_SRNG_IS_IDLE_BMSK                                                                      0x80
#define HWIO_REO_R0_REO2SW1_RING_MISC_SRNG_IS_IDLE_SHFT                                                                         7
#define HWIO_REO_R0_REO2SW1_RING_MISC_SRNG_ENABLE_BMSK                                                                       0x40
#define HWIO_REO_R0_REO2SW1_RING_MISC_SRNG_ENABLE_SHFT                                                                          6
#define HWIO_REO_R0_REO2SW1_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                                 0x20
#define HWIO_REO_R0_REO2SW1_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                                    5
#define HWIO_REO_R0_REO2SW1_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                                  0x10
#define HWIO_REO_R0_REO2SW1_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                                     4
#define HWIO_REO_R0_REO2SW1_RING_MISC_MSI_SWAP_BIT_BMSK                                                                       0x8
#define HWIO_REO_R0_REO2SW1_RING_MISC_MSI_SWAP_BIT_SHFT                                                                         3
#define HWIO_REO_R0_REO2SW1_RING_MISC_SECURITY_BIT_BMSK                                                                       0x4
#define HWIO_REO_R0_REO2SW1_RING_MISC_SECURITY_BIT_SHFT                                                                         2
#define HWIO_REO_R0_REO2SW1_RING_MISC_LOOPCNT_DISABLE_BMSK                                                                    0x2
#define HWIO_REO_R0_REO2SW1_RING_MISC_LOOPCNT_DISABLE_SHFT                                                                      1
#define HWIO_REO_R0_REO2SW1_RING_MISC_RING_ID_DISABLE_BMSK                                                                    0x1
#define HWIO_REO_R0_REO2SW1_RING_MISC_RING_ID_DISABLE_SHFT                                                                      0

#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_ADDR(x)                                                                   ((x) + 0x514)
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_PHYS(x)                                                                   ((x) + 0x514)
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_OFFS                                                                      (0x514)
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_POR                                                                       0x00000000
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_ATTR                                                                                   0x3
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                                 0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                                          0

#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_ADDR(x)                                                                   ((x) + 0x518)
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_PHYS(x)                                                                   ((x) + 0x518)
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_OFFS                                                                      (0x518)
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_RMSK                                                                            0xff
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_POR                                                                       0x00000000
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_ATTR                                                                                   0x3
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                                       0xff
#define HWIO_REO_R0_REO2SW1_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                                          0

#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_ADDR(x)                                                            ((x) + 0x524)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_PHYS(x)                                                            ((x) + 0x524)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_OFFS                                                               (0x524)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_POR                                                                0x00000000
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_ATTR                                                                            0x3
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                                     0xffff0000
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                             16
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                                 0x8000
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                                     15
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                                           0x7fff
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                                0

#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_ADDR(x)                                                           ((x) + 0x528)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_PHYS(x)                                                           ((x) + 0x528)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_OFFS                                                              (0x528)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_ATTR                                                                           0x1
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                                0xffff0000
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                                        16
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                                        0x8000
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                            15
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                                     0x7fff
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                          0

#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                                         ((x) + 0x52c)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                                         ((x) + 0x52c)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_OFFS                                                            (0x52c)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_RMSK                                                                 0x3ff
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_POR                                                             0x00000000
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_ATTR                                                                         0x3
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                               0x3ff
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                                   0

#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_ADDR(x)                                                                 ((x) + 0x548)
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_PHYS(x)                                                                 ((x) + 0x548)
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_OFFS                                                                    (0x548)
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_POR                                                                     0x00000000
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_ADDR_BMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_LSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_ADDR(x)                                                                 ((x) + 0x54c)
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_PHYS(x)                                                                 ((x) + 0x54c)
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_OFFS                                                                    (0x54c)
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_RMSK                                                                         0x1ff
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_POR                                                                     0x00000000
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                             0x100
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                                 8
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_ADDR_BMSK                                                                     0xff
#define HWIO_REO_R0_REO2SW1_RING_MSI1_BASE_MSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_ADDR(x)                                                                     ((x) + 0x550)
#define HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_PHYS(x)                                                                     ((x) + 0x550)
#define HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_OFFS                                                                        (0x550)
#define HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_RMSK                                                                        0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_POR                                                                         0x00000000
#define HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_POR_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_ATTR                                                                                     0x3
#define HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_VALUE_BMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MSI1_DATA_VALUE_SHFT                                                                           0

#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_ADDR(x)                                                           ((x) + 0x554)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_PHYS(x)                                                           ((x) + 0x554)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_OFFS                                                              (0x554)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_RMSK                                                              0xffcfffff
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_ATTR                                                                           0x3
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                                   0xff000000
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                                           24
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                                    0x800000
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                                          23
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                                  0x400000
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                                        22
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                                  0xfffff
#define HWIO_REO_R0_REO2SW1_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                                        0

#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_ADDR(x)                                                                 ((x) + 0x558)
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_PHYS(x)                                                                 ((x) + 0x558)
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_OFFS                                                                    (0x558)
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_POR                                                                     0x00000000
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_ADDR_BMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_LSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_ADDR(x)                                                                 ((x) + 0x55c)
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_PHYS(x)                                                                 ((x) + 0x55c)
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_OFFS                                                                    (0x55c)
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_RMSK                                                                         0x1ff
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_POR                                                                     0x00000000
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                             0x100
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                                 8
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_ADDR_BMSK                                                                     0xff
#define HWIO_REO_R0_REO2SW1_RING_MSI2_BASE_MSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_ADDR(x)                                                                     ((x) + 0x560)
#define HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_PHYS(x)                                                                     ((x) + 0x560)
#define HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_OFFS                                                                        (0x560)
#define HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_RMSK                                                                        0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_POR                                                                         0x00000000
#define HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_POR_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_ATTR                                                                                     0x3
#define HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_VALUE_BMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MSI2_DATA_VALUE_SHFT                                                                           0

#define HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_ADDR(x)                                                               ((x) + 0x570)
#define HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_PHYS(x)                                                               ((x) + 0x570)
#define HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_OFFS                                                                  (0x570)
#define HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_RMSK                                                                      0xffff
#define HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_POR                                                                   0x00000000
#define HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_POR_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_ATTR                                                                               0x3
#define HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                                   0xffff
#define HWIO_REO_R0_REO2SW1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                                        0

#define HWIO_REO_R0_REO2SW1_RING_MISC_1_ADDR(x)                                                                        ((x) + 0x574)
#define HWIO_REO_R0_REO2SW1_RING_MISC_1_PHYS(x)                                                                        ((x) + 0x574)
#define HWIO_REO_R0_REO2SW1_RING_MISC_1_OFFS                                                                           (0x574)
#define HWIO_REO_R0_REO2SW1_RING_MISC_1_RMSK                                                                           0xffff003f
#define HWIO_REO_R0_REO2SW1_RING_MISC_1_POR                                                                            0x00000000
#define HWIO_REO_R0_REO2SW1_RING_MISC_1_POR_RMSK                                                                       0xffffffff
#define HWIO_REO_R0_REO2SW1_RING_MISC_1_ATTR                                                                                        0x3
#define HWIO_REO_R0_REO2SW1_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW1_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_REO2SW1_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW1_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_REO2SW1_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW1_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_REO2SW1_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW1_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_REO2SW1_RING_MISC_1_IN(x))
#define HWIO_REO_R0_REO2SW1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                                  0xffff0000
#define HWIO_REO_R0_REO2SW1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                          16
#define HWIO_REO_R0_REO2SW1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                                         0x3f
#define HWIO_REO_R0_REO2SW1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                            0

#define HWIO_REO_R0_REO2SW2_RING_BASE_LSB_ADDR(x)                                                                      ((x) + 0x578)
#define HWIO_REO_R0_REO2SW2_RING_BASE_LSB_PHYS(x)                                                                      ((x) + 0x578)
#define HWIO_REO_R0_REO2SW2_RING_BASE_LSB_OFFS                                                                         (0x578)
#define HWIO_REO_R0_REO2SW2_RING_BASE_LSB_RMSK                                                                         0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_BASE_LSB_POR                                                                          0x00000000
#define HWIO_REO_R0_REO2SW2_RING_BASE_LSB_POR_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_BASE_LSB_ATTR                                                                                      0x3
#define HWIO_REO_R0_REO2SW2_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                               0

#define HWIO_REO_R0_REO2SW2_RING_BASE_MSB_ADDR(x)                                                                      ((x) + 0x57c)
#define HWIO_REO_R0_REO2SW2_RING_BASE_MSB_PHYS(x)                                                                      ((x) + 0x57c)
#define HWIO_REO_R0_REO2SW2_RING_BASE_MSB_OFFS                                                                         (0x57c)
#define HWIO_REO_R0_REO2SW2_RING_BASE_MSB_RMSK                                                                          0xfffffff
#define HWIO_REO_R0_REO2SW2_RING_BASE_MSB_POR                                                                          0x00000000
#define HWIO_REO_R0_REO2SW2_RING_BASE_MSB_POR_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_BASE_MSB_ATTR                                                                                      0x3
#define HWIO_REO_R0_REO2SW2_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_BASE_MSB_RING_SIZE_BMSK                                                                0xfffff00
#define HWIO_REO_R0_REO2SW2_RING_BASE_MSB_RING_SIZE_SHFT                                                                        8
#define HWIO_REO_R0_REO2SW2_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                            0xff
#define HWIO_REO_R0_REO2SW2_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                               0

#define HWIO_REO_R0_REO2SW2_RING_ID_ADDR(x)                                                                            ((x) + 0x580)
#define HWIO_REO_R0_REO2SW2_RING_ID_PHYS(x)                                                                            ((x) + 0x580)
#define HWIO_REO_R0_REO2SW2_RING_ID_OFFS                                                                               (0x580)
#define HWIO_REO_R0_REO2SW2_RING_ID_RMSK                                                                                   0xffff
#define HWIO_REO_R0_REO2SW2_RING_ID_POR                                                                                0x00000000
#define HWIO_REO_R0_REO2SW2_RING_ID_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_ID_ATTR                                                                                            0x3
#define HWIO_REO_R0_REO2SW2_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_ID_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_ID_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_ID_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_ID_RING_ID_BMSK                                                                           0xff00
#define HWIO_REO_R0_REO2SW2_RING_ID_RING_ID_SHFT                                                                                8
#define HWIO_REO_R0_REO2SW2_RING_ID_ENTRY_SIZE_BMSK                                                                          0xff
#define HWIO_REO_R0_REO2SW2_RING_ID_ENTRY_SIZE_SHFT                                                                             0

#define HWIO_REO_R0_REO2SW2_RING_STATUS_ADDR(x)                                                                        ((x) + 0x584)
#define HWIO_REO_R0_REO2SW2_RING_STATUS_PHYS(x)                                                                        ((x) + 0x584)
#define HWIO_REO_R0_REO2SW2_RING_STATUS_OFFS                                                                           (0x584)
#define HWIO_REO_R0_REO2SW2_RING_STATUS_RMSK                                                                           0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_STATUS_POR                                                                            0x00000000
#define HWIO_REO_R0_REO2SW2_RING_STATUS_POR_RMSK                                                                       0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_STATUS_ATTR                                                                                        0x1
#define HWIO_REO_R0_REO2SW2_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                           0xffff0000
#define HWIO_REO_R0_REO2SW2_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                                   16
#define HWIO_REO_R0_REO2SW2_RING_STATUS_NUM_VALID_WORDS_BMSK                                                               0xffff
#define HWIO_REO_R0_REO2SW2_RING_STATUS_NUM_VALID_WORDS_SHFT                                                                    0

#define HWIO_REO_R0_REO2SW2_RING_MISC_ADDR(x)                                                                          ((x) + 0x588)
#define HWIO_REO_R0_REO2SW2_RING_MISC_PHYS(x)                                                                          ((x) + 0x588)
#define HWIO_REO_R0_REO2SW2_RING_MISC_OFFS                                                                             (0x588)
#define HWIO_REO_R0_REO2SW2_RING_MISC_RMSK                                                                              0x7ffffff
#define HWIO_REO_R0_REO2SW2_RING_MISC_POR                                                                              0x00000080
#define HWIO_REO_R0_REO2SW2_RING_MISC_POR_RMSK                                                                         0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MISC_ATTR                                                                                          0x3
#define HWIO_REO_R0_REO2SW2_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_MISC_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_MISC_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                                      0x4000000
#define HWIO_REO_R0_REO2SW2_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                             26
#define HWIO_REO_R0_REO2SW2_RING_MISC_LOOP_CNT_BMSK                                                                     0x3c00000
#define HWIO_REO_R0_REO2SW2_RING_MISC_LOOP_CNT_SHFT                                                                            22
#define HWIO_REO_R0_REO2SW2_RING_MISC_SPARE_CONTROL_BMSK                                                                 0x3fc000
#define HWIO_REO_R0_REO2SW2_RING_MISC_SPARE_CONTROL_SHFT                                                                       14
#define HWIO_REO_R0_REO2SW2_RING_MISC_SRNG_SM_STATE2_BMSK                                                                  0x3000
#define HWIO_REO_R0_REO2SW2_RING_MISC_SRNG_SM_STATE2_SHFT                                                                      12
#define HWIO_REO_R0_REO2SW2_RING_MISC_SRNG_SM_STATE1_BMSK                                                                   0xf00
#define HWIO_REO_R0_REO2SW2_RING_MISC_SRNG_SM_STATE1_SHFT                                                                       8
#define HWIO_REO_R0_REO2SW2_RING_MISC_SRNG_IS_IDLE_BMSK                                                                      0x80
#define HWIO_REO_R0_REO2SW2_RING_MISC_SRNG_IS_IDLE_SHFT                                                                         7
#define HWIO_REO_R0_REO2SW2_RING_MISC_SRNG_ENABLE_BMSK                                                                       0x40
#define HWIO_REO_R0_REO2SW2_RING_MISC_SRNG_ENABLE_SHFT                                                                          6
#define HWIO_REO_R0_REO2SW2_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                                 0x20
#define HWIO_REO_R0_REO2SW2_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                                    5
#define HWIO_REO_R0_REO2SW2_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                                  0x10
#define HWIO_REO_R0_REO2SW2_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                                     4
#define HWIO_REO_R0_REO2SW2_RING_MISC_MSI_SWAP_BIT_BMSK                                                                       0x8
#define HWIO_REO_R0_REO2SW2_RING_MISC_MSI_SWAP_BIT_SHFT                                                                         3
#define HWIO_REO_R0_REO2SW2_RING_MISC_SECURITY_BIT_BMSK                                                                       0x4
#define HWIO_REO_R0_REO2SW2_RING_MISC_SECURITY_BIT_SHFT                                                                         2
#define HWIO_REO_R0_REO2SW2_RING_MISC_LOOPCNT_DISABLE_BMSK                                                                    0x2
#define HWIO_REO_R0_REO2SW2_RING_MISC_LOOPCNT_DISABLE_SHFT                                                                      1
#define HWIO_REO_R0_REO2SW2_RING_MISC_RING_ID_DISABLE_BMSK                                                                    0x1
#define HWIO_REO_R0_REO2SW2_RING_MISC_RING_ID_DISABLE_SHFT                                                                      0

#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_ADDR(x)                                                                   ((x) + 0x58c)
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_PHYS(x)                                                                   ((x) + 0x58c)
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_OFFS                                                                      (0x58c)
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_POR                                                                       0x00000000
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_ATTR                                                                                   0x3
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                                 0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                                          0

#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_ADDR(x)                                                                   ((x) + 0x590)
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_PHYS(x)                                                                   ((x) + 0x590)
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_OFFS                                                                      (0x590)
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_RMSK                                                                            0xff
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_POR                                                                       0x00000000
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_ATTR                                                                                   0x3
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                                       0xff
#define HWIO_REO_R0_REO2SW2_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                                          0

#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_ADDR(x)                                                            ((x) + 0x59c)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_PHYS(x)                                                            ((x) + 0x59c)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_OFFS                                                               (0x59c)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_POR                                                                0x00000000
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_ATTR                                                                            0x3
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                                     0xffff0000
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                             16
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                                 0x8000
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                                     15
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                                           0x7fff
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                                0

#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_ADDR(x)                                                           ((x) + 0x5a0)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_PHYS(x)                                                           ((x) + 0x5a0)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_OFFS                                                              (0x5a0)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_ATTR                                                                           0x1
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                                0xffff0000
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                                        16
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                                        0x8000
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                            15
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                                     0x7fff
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                          0

#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                                         ((x) + 0x5a4)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                                         ((x) + 0x5a4)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_OFFS                                                            (0x5a4)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_RMSK                                                                 0x3ff
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_POR                                                             0x00000000
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_ATTR                                                                         0x3
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                               0x3ff
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                                   0

#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_ADDR(x)                                                                 ((x) + 0x5c0)
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_PHYS(x)                                                                 ((x) + 0x5c0)
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_OFFS                                                                    (0x5c0)
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_POR                                                                     0x00000000
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_ADDR_BMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_LSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_ADDR(x)                                                                 ((x) + 0x5c4)
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_PHYS(x)                                                                 ((x) + 0x5c4)
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_OFFS                                                                    (0x5c4)
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_RMSK                                                                         0x1ff
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_POR                                                                     0x00000000
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                             0x100
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                                 8
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_ADDR_BMSK                                                                     0xff
#define HWIO_REO_R0_REO2SW2_RING_MSI1_BASE_MSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_ADDR(x)                                                                     ((x) + 0x5c8)
#define HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_PHYS(x)                                                                     ((x) + 0x5c8)
#define HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_OFFS                                                                        (0x5c8)
#define HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_RMSK                                                                        0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_POR                                                                         0x00000000
#define HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_POR_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_ATTR                                                                                     0x3
#define HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_VALUE_BMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MSI1_DATA_VALUE_SHFT                                                                           0

#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_ADDR(x)                                                           ((x) + 0x5cc)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_PHYS(x)                                                           ((x) + 0x5cc)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_OFFS                                                              (0x5cc)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_RMSK                                                              0xffcfffff
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_ATTR                                                                           0x3
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                                   0xff000000
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                                           24
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                                    0x800000
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                                          23
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                                  0x400000
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                                        22
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                                  0xfffff
#define HWIO_REO_R0_REO2SW2_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                                        0

#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_ADDR(x)                                                                 ((x) + 0x5d0)
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_PHYS(x)                                                                 ((x) + 0x5d0)
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_OFFS                                                                    (0x5d0)
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_POR                                                                     0x00000000
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_ADDR_BMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_LSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_ADDR(x)                                                                 ((x) + 0x5d4)
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_PHYS(x)                                                                 ((x) + 0x5d4)
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_OFFS                                                                    (0x5d4)
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_RMSK                                                                         0x1ff
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_POR                                                                     0x00000000
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                             0x100
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                                 8
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_ADDR_BMSK                                                                     0xff
#define HWIO_REO_R0_REO2SW2_RING_MSI2_BASE_MSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_ADDR(x)                                                                     ((x) + 0x5d8)
#define HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_PHYS(x)                                                                     ((x) + 0x5d8)
#define HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_OFFS                                                                        (0x5d8)
#define HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_RMSK                                                                        0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_POR                                                                         0x00000000
#define HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_POR_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_ATTR                                                                                     0x3
#define HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_VALUE_BMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MSI2_DATA_VALUE_SHFT                                                                           0

#define HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_ADDR(x)                                                               ((x) + 0x5e8)
#define HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_PHYS(x)                                                               ((x) + 0x5e8)
#define HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_OFFS                                                                  (0x5e8)
#define HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_RMSK                                                                      0xffff
#define HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_POR                                                                   0x00000000
#define HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_POR_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_ATTR                                                                               0x3
#define HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                                   0xffff
#define HWIO_REO_R0_REO2SW2_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                                        0

#define HWIO_REO_R0_REO2SW2_RING_MISC_1_ADDR(x)                                                                        ((x) + 0x5ec)
#define HWIO_REO_R0_REO2SW2_RING_MISC_1_PHYS(x)                                                                        ((x) + 0x5ec)
#define HWIO_REO_R0_REO2SW2_RING_MISC_1_OFFS                                                                           (0x5ec)
#define HWIO_REO_R0_REO2SW2_RING_MISC_1_RMSK                                                                           0xffff003f
#define HWIO_REO_R0_REO2SW2_RING_MISC_1_POR                                                                            0x00000000
#define HWIO_REO_R0_REO2SW2_RING_MISC_1_POR_RMSK                                                                       0xffffffff
#define HWIO_REO_R0_REO2SW2_RING_MISC_1_ATTR                                                                                        0x3
#define HWIO_REO_R0_REO2SW2_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW2_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_REO2SW2_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW2_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_REO2SW2_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW2_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_REO2SW2_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW2_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_REO2SW2_RING_MISC_1_IN(x))
#define HWIO_REO_R0_REO2SW2_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                                  0xffff0000
#define HWIO_REO_R0_REO2SW2_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                          16
#define HWIO_REO_R0_REO2SW2_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                                         0x3f
#define HWIO_REO_R0_REO2SW2_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                            0

#define HWIO_REO_R0_REO2SW3_RING_BASE_LSB_ADDR(x)                                                                      ((x) + 0x5f0)
#define HWIO_REO_R0_REO2SW3_RING_BASE_LSB_PHYS(x)                                                                      ((x) + 0x5f0)
#define HWIO_REO_R0_REO2SW3_RING_BASE_LSB_OFFS                                                                         (0x5f0)
#define HWIO_REO_R0_REO2SW3_RING_BASE_LSB_RMSK                                                                         0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_BASE_LSB_POR                                                                          0x00000000
#define HWIO_REO_R0_REO2SW3_RING_BASE_LSB_POR_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_BASE_LSB_ATTR                                                                                      0x3
#define HWIO_REO_R0_REO2SW3_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                               0

#define HWIO_REO_R0_REO2SW3_RING_BASE_MSB_ADDR(x)                                                                      ((x) + 0x5f4)
#define HWIO_REO_R0_REO2SW3_RING_BASE_MSB_PHYS(x)                                                                      ((x) + 0x5f4)
#define HWIO_REO_R0_REO2SW3_RING_BASE_MSB_OFFS                                                                         (0x5f4)
#define HWIO_REO_R0_REO2SW3_RING_BASE_MSB_RMSK                                                                          0xfffffff
#define HWIO_REO_R0_REO2SW3_RING_BASE_MSB_POR                                                                          0x00000000
#define HWIO_REO_R0_REO2SW3_RING_BASE_MSB_POR_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_BASE_MSB_ATTR                                                                                      0x3
#define HWIO_REO_R0_REO2SW3_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_BASE_MSB_RING_SIZE_BMSK                                                                0xfffff00
#define HWIO_REO_R0_REO2SW3_RING_BASE_MSB_RING_SIZE_SHFT                                                                        8
#define HWIO_REO_R0_REO2SW3_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                            0xff
#define HWIO_REO_R0_REO2SW3_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                               0

#define HWIO_REO_R0_REO2SW3_RING_ID_ADDR(x)                                                                            ((x) + 0x5f8)
#define HWIO_REO_R0_REO2SW3_RING_ID_PHYS(x)                                                                            ((x) + 0x5f8)
#define HWIO_REO_R0_REO2SW3_RING_ID_OFFS                                                                               (0x5f8)
#define HWIO_REO_R0_REO2SW3_RING_ID_RMSK                                                                                   0xffff
#define HWIO_REO_R0_REO2SW3_RING_ID_POR                                                                                0x00000000
#define HWIO_REO_R0_REO2SW3_RING_ID_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_ID_ATTR                                                                                            0x3
#define HWIO_REO_R0_REO2SW3_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_ID_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_ID_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_ID_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_ID_RING_ID_BMSK                                                                           0xff00
#define HWIO_REO_R0_REO2SW3_RING_ID_RING_ID_SHFT                                                                                8
#define HWIO_REO_R0_REO2SW3_RING_ID_ENTRY_SIZE_BMSK                                                                          0xff
#define HWIO_REO_R0_REO2SW3_RING_ID_ENTRY_SIZE_SHFT                                                                             0

#define HWIO_REO_R0_REO2SW3_RING_STATUS_ADDR(x)                                                                        ((x) + 0x5fc)
#define HWIO_REO_R0_REO2SW3_RING_STATUS_PHYS(x)                                                                        ((x) + 0x5fc)
#define HWIO_REO_R0_REO2SW3_RING_STATUS_OFFS                                                                           (0x5fc)
#define HWIO_REO_R0_REO2SW3_RING_STATUS_RMSK                                                                           0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_STATUS_POR                                                                            0x00000000
#define HWIO_REO_R0_REO2SW3_RING_STATUS_POR_RMSK                                                                       0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_STATUS_ATTR                                                                                        0x1
#define HWIO_REO_R0_REO2SW3_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                           0xffff0000
#define HWIO_REO_R0_REO2SW3_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                                   16
#define HWIO_REO_R0_REO2SW3_RING_STATUS_NUM_VALID_WORDS_BMSK                                                               0xffff
#define HWIO_REO_R0_REO2SW3_RING_STATUS_NUM_VALID_WORDS_SHFT                                                                    0

#define HWIO_REO_R0_REO2SW3_RING_MISC_ADDR(x)                                                                          ((x) + 0x600)
#define HWIO_REO_R0_REO2SW3_RING_MISC_PHYS(x)                                                                          ((x) + 0x600)
#define HWIO_REO_R0_REO2SW3_RING_MISC_OFFS                                                                             (0x600)
#define HWIO_REO_R0_REO2SW3_RING_MISC_RMSK                                                                              0x7ffffff
#define HWIO_REO_R0_REO2SW3_RING_MISC_POR                                                                              0x00000080
#define HWIO_REO_R0_REO2SW3_RING_MISC_POR_RMSK                                                                         0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MISC_ATTR                                                                                          0x3
#define HWIO_REO_R0_REO2SW3_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_MISC_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_MISC_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                                      0x4000000
#define HWIO_REO_R0_REO2SW3_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                             26
#define HWIO_REO_R0_REO2SW3_RING_MISC_LOOP_CNT_BMSK                                                                     0x3c00000
#define HWIO_REO_R0_REO2SW3_RING_MISC_LOOP_CNT_SHFT                                                                            22
#define HWIO_REO_R0_REO2SW3_RING_MISC_SPARE_CONTROL_BMSK                                                                 0x3fc000
#define HWIO_REO_R0_REO2SW3_RING_MISC_SPARE_CONTROL_SHFT                                                                       14
#define HWIO_REO_R0_REO2SW3_RING_MISC_SRNG_SM_STATE2_BMSK                                                                  0x3000
#define HWIO_REO_R0_REO2SW3_RING_MISC_SRNG_SM_STATE2_SHFT                                                                      12
#define HWIO_REO_R0_REO2SW3_RING_MISC_SRNG_SM_STATE1_BMSK                                                                   0xf00
#define HWIO_REO_R0_REO2SW3_RING_MISC_SRNG_SM_STATE1_SHFT                                                                       8
#define HWIO_REO_R0_REO2SW3_RING_MISC_SRNG_IS_IDLE_BMSK                                                                      0x80
#define HWIO_REO_R0_REO2SW3_RING_MISC_SRNG_IS_IDLE_SHFT                                                                         7
#define HWIO_REO_R0_REO2SW3_RING_MISC_SRNG_ENABLE_BMSK                                                                       0x40
#define HWIO_REO_R0_REO2SW3_RING_MISC_SRNG_ENABLE_SHFT                                                                          6
#define HWIO_REO_R0_REO2SW3_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                                 0x20
#define HWIO_REO_R0_REO2SW3_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                                    5
#define HWIO_REO_R0_REO2SW3_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                                  0x10
#define HWIO_REO_R0_REO2SW3_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                                     4
#define HWIO_REO_R0_REO2SW3_RING_MISC_MSI_SWAP_BIT_BMSK                                                                       0x8
#define HWIO_REO_R0_REO2SW3_RING_MISC_MSI_SWAP_BIT_SHFT                                                                         3
#define HWIO_REO_R0_REO2SW3_RING_MISC_SECURITY_BIT_BMSK                                                                       0x4
#define HWIO_REO_R0_REO2SW3_RING_MISC_SECURITY_BIT_SHFT                                                                         2
#define HWIO_REO_R0_REO2SW3_RING_MISC_LOOPCNT_DISABLE_BMSK                                                                    0x2
#define HWIO_REO_R0_REO2SW3_RING_MISC_LOOPCNT_DISABLE_SHFT                                                                      1
#define HWIO_REO_R0_REO2SW3_RING_MISC_RING_ID_DISABLE_BMSK                                                                    0x1
#define HWIO_REO_R0_REO2SW3_RING_MISC_RING_ID_DISABLE_SHFT                                                                      0

#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_ADDR(x)                                                                   ((x) + 0x604)
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_PHYS(x)                                                                   ((x) + 0x604)
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_OFFS                                                                      (0x604)
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_POR                                                                       0x00000000
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_ATTR                                                                                   0x3
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                                 0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                                          0

#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_ADDR(x)                                                                   ((x) + 0x608)
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_PHYS(x)                                                                   ((x) + 0x608)
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_OFFS                                                                      (0x608)
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_RMSK                                                                            0xff
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_POR                                                                       0x00000000
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_ATTR                                                                                   0x3
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                                       0xff
#define HWIO_REO_R0_REO2SW3_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                                          0

#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_ADDR(x)                                                            ((x) + 0x614)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_PHYS(x)                                                            ((x) + 0x614)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_OFFS                                                               (0x614)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_POR                                                                0x00000000
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_ATTR                                                                            0x3
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                                     0xffff0000
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                             16
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                                 0x8000
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                                     15
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                                           0x7fff
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                                0

#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_ADDR(x)                                                           ((x) + 0x618)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_PHYS(x)                                                           ((x) + 0x618)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_OFFS                                                              (0x618)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_ATTR                                                                           0x1
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                                0xffff0000
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                                        16
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                                        0x8000
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                            15
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                                     0x7fff
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                          0

#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                                         ((x) + 0x61c)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                                         ((x) + 0x61c)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_OFFS                                                            (0x61c)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_RMSK                                                                 0x3ff
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_POR                                                             0x00000000
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_ATTR                                                                         0x3
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                               0x3ff
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                                   0

#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_ADDR(x)                                                                 ((x) + 0x638)
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_PHYS(x)                                                                 ((x) + 0x638)
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_OFFS                                                                    (0x638)
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_POR                                                                     0x00000000
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_ADDR_BMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_LSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_ADDR(x)                                                                 ((x) + 0x63c)
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_PHYS(x)                                                                 ((x) + 0x63c)
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_OFFS                                                                    (0x63c)
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_RMSK                                                                         0x1ff
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_POR                                                                     0x00000000
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                             0x100
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                                 8
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_ADDR_BMSK                                                                     0xff
#define HWIO_REO_R0_REO2SW3_RING_MSI1_BASE_MSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_ADDR(x)                                                                     ((x) + 0x640)
#define HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_PHYS(x)                                                                     ((x) + 0x640)
#define HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_OFFS                                                                        (0x640)
#define HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_RMSK                                                                        0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_POR                                                                         0x00000000
#define HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_POR_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_ATTR                                                                                     0x3
#define HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_VALUE_BMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MSI1_DATA_VALUE_SHFT                                                                           0

#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_ADDR(x)                                                           ((x) + 0x644)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_PHYS(x)                                                           ((x) + 0x644)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_OFFS                                                              (0x644)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_RMSK                                                              0xffcfffff
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_ATTR                                                                           0x3
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                                   0xff000000
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                                           24
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                                    0x800000
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                                          23
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                                  0x400000
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                                        22
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                                  0xfffff
#define HWIO_REO_R0_REO2SW3_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                                        0

#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_ADDR(x)                                                                 ((x) + 0x648)
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_PHYS(x)                                                                 ((x) + 0x648)
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_OFFS                                                                    (0x648)
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_POR                                                                     0x00000000
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_ADDR_BMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_LSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_ADDR(x)                                                                 ((x) + 0x64c)
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_PHYS(x)                                                                 ((x) + 0x64c)
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_OFFS                                                                    (0x64c)
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_RMSK                                                                         0x1ff
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_POR                                                                     0x00000000
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                             0x100
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                                 8
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_ADDR_BMSK                                                                     0xff
#define HWIO_REO_R0_REO2SW3_RING_MSI2_BASE_MSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_ADDR(x)                                                                     ((x) + 0x650)
#define HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_PHYS(x)                                                                     ((x) + 0x650)
#define HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_OFFS                                                                        (0x650)
#define HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_RMSK                                                                        0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_POR                                                                         0x00000000
#define HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_POR_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_ATTR                                                                                     0x3
#define HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_VALUE_BMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MSI2_DATA_VALUE_SHFT                                                                           0

#define HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_ADDR(x)                                                               ((x) + 0x660)
#define HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_PHYS(x)                                                               ((x) + 0x660)
#define HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_OFFS                                                                  (0x660)
#define HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_RMSK                                                                      0xffff
#define HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_POR                                                                   0x00000000
#define HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_POR_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_ATTR                                                                               0x3
#define HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                                   0xffff
#define HWIO_REO_R0_REO2SW3_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                                        0

#define HWIO_REO_R0_REO2SW3_RING_MISC_1_ADDR(x)                                                                        ((x) + 0x664)
#define HWIO_REO_R0_REO2SW3_RING_MISC_1_PHYS(x)                                                                        ((x) + 0x664)
#define HWIO_REO_R0_REO2SW3_RING_MISC_1_OFFS                                                                           (0x664)
#define HWIO_REO_R0_REO2SW3_RING_MISC_1_RMSK                                                                           0xffff003f
#define HWIO_REO_R0_REO2SW3_RING_MISC_1_POR                                                                            0x00000000
#define HWIO_REO_R0_REO2SW3_RING_MISC_1_POR_RMSK                                                                       0xffffffff
#define HWIO_REO_R0_REO2SW3_RING_MISC_1_ATTR                                                                                        0x3
#define HWIO_REO_R0_REO2SW3_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW3_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_REO2SW3_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW3_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_REO2SW3_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW3_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_REO2SW3_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW3_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_REO2SW3_RING_MISC_1_IN(x))
#define HWIO_REO_R0_REO2SW3_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                                  0xffff0000
#define HWIO_REO_R0_REO2SW3_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                          16
#define HWIO_REO_R0_REO2SW3_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                                         0x3f
#define HWIO_REO_R0_REO2SW3_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                            0

#define HWIO_REO_R0_REO2SW4_RING_BASE_LSB_ADDR(x)                                                                      ((x) + 0x668)
#define HWIO_REO_R0_REO2SW4_RING_BASE_LSB_PHYS(x)                                                                      ((x) + 0x668)
#define HWIO_REO_R0_REO2SW4_RING_BASE_LSB_OFFS                                                                         (0x668)
#define HWIO_REO_R0_REO2SW4_RING_BASE_LSB_RMSK                                                                         0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_BASE_LSB_POR                                                                          0x00000000
#define HWIO_REO_R0_REO2SW4_RING_BASE_LSB_POR_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_BASE_LSB_ATTR                                                                                      0x3
#define HWIO_REO_R0_REO2SW4_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                               0

#define HWIO_REO_R0_REO2SW4_RING_BASE_MSB_ADDR(x)                                                                      ((x) + 0x66c)
#define HWIO_REO_R0_REO2SW4_RING_BASE_MSB_PHYS(x)                                                                      ((x) + 0x66c)
#define HWIO_REO_R0_REO2SW4_RING_BASE_MSB_OFFS                                                                         (0x66c)
#define HWIO_REO_R0_REO2SW4_RING_BASE_MSB_RMSK                                                                          0xfffffff
#define HWIO_REO_R0_REO2SW4_RING_BASE_MSB_POR                                                                          0x00000000
#define HWIO_REO_R0_REO2SW4_RING_BASE_MSB_POR_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_BASE_MSB_ATTR                                                                                      0x3
#define HWIO_REO_R0_REO2SW4_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_BASE_MSB_RING_SIZE_BMSK                                                                0xfffff00
#define HWIO_REO_R0_REO2SW4_RING_BASE_MSB_RING_SIZE_SHFT                                                                        8
#define HWIO_REO_R0_REO2SW4_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                            0xff
#define HWIO_REO_R0_REO2SW4_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                               0

#define HWIO_REO_R0_REO2SW4_RING_ID_ADDR(x)                                                                            ((x) + 0x670)
#define HWIO_REO_R0_REO2SW4_RING_ID_PHYS(x)                                                                            ((x) + 0x670)
#define HWIO_REO_R0_REO2SW4_RING_ID_OFFS                                                                               (0x670)
#define HWIO_REO_R0_REO2SW4_RING_ID_RMSK                                                                                   0xffff
#define HWIO_REO_R0_REO2SW4_RING_ID_POR                                                                                0x00000000
#define HWIO_REO_R0_REO2SW4_RING_ID_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_ID_ATTR                                                                                            0x3
#define HWIO_REO_R0_REO2SW4_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_ID_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_ID_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_ID_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_ID_RING_ID_BMSK                                                                           0xff00
#define HWIO_REO_R0_REO2SW4_RING_ID_RING_ID_SHFT                                                                                8
#define HWIO_REO_R0_REO2SW4_RING_ID_ENTRY_SIZE_BMSK                                                                          0xff
#define HWIO_REO_R0_REO2SW4_RING_ID_ENTRY_SIZE_SHFT                                                                             0

#define HWIO_REO_R0_REO2SW4_RING_STATUS_ADDR(x)                                                                        ((x) + 0x674)
#define HWIO_REO_R0_REO2SW4_RING_STATUS_PHYS(x)                                                                        ((x) + 0x674)
#define HWIO_REO_R0_REO2SW4_RING_STATUS_OFFS                                                                           (0x674)
#define HWIO_REO_R0_REO2SW4_RING_STATUS_RMSK                                                                           0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_STATUS_POR                                                                            0x00000000
#define HWIO_REO_R0_REO2SW4_RING_STATUS_POR_RMSK                                                                       0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_STATUS_ATTR                                                                                        0x1
#define HWIO_REO_R0_REO2SW4_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                           0xffff0000
#define HWIO_REO_R0_REO2SW4_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                                   16
#define HWIO_REO_R0_REO2SW4_RING_STATUS_NUM_VALID_WORDS_BMSK                                                               0xffff
#define HWIO_REO_R0_REO2SW4_RING_STATUS_NUM_VALID_WORDS_SHFT                                                                    0

#define HWIO_REO_R0_REO2SW4_RING_MISC_ADDR(x)                                                                          ((x) + 0x678)
#define HWIO_REO_R0_REO2SW4_RING_MISC_PHYS(x)                                                                          ((x) + 0x678)
#define HWIO_REO_R0_REO2SW4_RING_MISC_OFFS                                                                             (0x678)
#define HWIO_REO_R0_REO2SW4_RING_MISC_RMSK                                                                              0x7ffffff
#define HWIO_REO_R0_REO2SW4_RING_MISC_POR                                                                              0x00000080
#define HWIO_REO_R0_REO2SW4_RING_MISC_POR_RMSK                                                                         0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MISC_ATTR                                                                                          0x3
#define HWIO_REO_R0_REO2SW4_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_MISC_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_MISC_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                                      0x4000000
#define HWIO_REO_R0_REO2SW4_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                             26
#define HWIO_REO_R0_REO2SW4_RING_MISC_LOOP_CNT_BMSK                                                                     0x3c00000
#define HWIO_REO_R0_REO2SW4_RING_MISC_LOOP_CNT_SHFT                                                                            22
#define HWIO_REO_R0_REO2SW4_RING_MISC_SPARE_CONTROL_BMSK                                                                 0x3fc000
#define HWIO_REO_R0_REO2SW4_RING_MISC_SPARE_CONTROL_SHFT                                                                       14
#define HWIO_REO_R0_REO2SW4_RING_MISC_SRNG_SM_STATE2_BMSK                                                                  0x3000
#define HWIO_REO_R0_REO2SW4_RING_MISC_SRNG_SM_STATE2_SHFT                                                                      12
#define HWIO_REO_R0_REO2SW4_RING_MISC_SRNG_SM_STATE1_BMSK                                                                   0xf00
#define HWIO_REO_R0_REO2SW4_RING_MISC_SRNG_SM_STATE1_SHFT                                                                       8
#define HWIO_REO_R0_REO2SW4_RING_MISC_SRNG_IS_IDLE_BMSK                                                                      0x80
#define HWIO_REO_R0_REO2SW4_RING_MISC_SRNG_IS_IDLE_SHFT                                                                         7
#define HWIO_REO_R0_REO2SW4_RING_MISC_SRNG_ENABLE_BMSK                                                                       0x40
#define HWIO_REO_R0_REO2SW4_RING_MISC_SRNG_ENABLE_SHFT                                                                          6
#define HWIO_REO_R0_REO2SW4_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                                 0x20
#define HWIO_REO_R0_REO2SW4_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                                    5
#define HWIO_REO_R0_REO2SW4_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                                  0x10
#define HWIO_REO_R0_REO2SW4_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                                     4
#define HWIO_REO_R0_REO2SW4_RING_MISC_MSI_SWAP_BIT_BMSK                                                                       0x8
#define HWIO_REO_R0_REO2SW4_RING_MISC_MSI_SWAP_BIT_SHFT                                                                         3
#define HWIO_REO_R0_REO2SW4_RING_MISC_SECURITY_BIT_BMSK                                                                       0x4
#define HWIO_REO_R0_REO2SW4_RING_MISC_SECURITY_BIT_SHFT                                                                         2
#define HWIO_REO_R0_REO2SW4_RING_MISC_LOOPCNT_DISABLE_BMSK                                                                    0x2
#define HWIO_REO_R0_REO2SW4_RING_MISC_LOOPCNT_DISABLE_SHFT                                                                      1
#define HWIO_REO_R0_REO2SW4_RING_MISC_RING_ID_DISABLE_BMSK                                                                    0x1
#define HWIO_REO_R0_REO2SW4_RING_MISC_RING_ID_DISABLE_SHFT                                                                      0

#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_ADDR(x)                                                                   ((x) + 0x67c)
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_PHYS(x)                                                                   ((x) + 0x67c)
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_OFFS                                                                      (0x67c)
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_POR                                                                       0x00000000
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_ATTR                                                                                   0x3
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                                 0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                                          0

#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_ADDR(x)                                                                   ((x) + 0x680)
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_PHYS(x)                                                                   ((x) + 0x680)
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_OFFS                                                                      (0x680)
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_RMSK                                                                            0xff
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_POR                                                                       0x00000000
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_ATTR                                                                                   0x3
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                                       0xff
#define HWIO_REO_R0_REO2SW4_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                                          0

#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_ADDR(x)                                                            ((x) + 0x68c)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_PHYS(x)                                                            ((x) + 0x68c)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_OFFS                                                               (0x68c)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_POR                                                                0x00000000
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_ATTR                                                                            0x3
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                                     0xffff0000
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                             16
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                                 0x8000
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                                     15
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                                           0x7fff
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                                0

#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_ADDR(x)                                                           ((x) + 0x690)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_PHYS(x)                                                           ((x) + 0x690)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_OFFS                                                              (0x690)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_ATTR                                                                           0x1
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                                0xffff0000
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                                        16
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                                        0x8000
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                            15
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                                     0x7fff
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                          0

#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                                         ((x) + 0x694)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                                         ((x) + 0x694)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_OFFS                                                            (0x694)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_RMSK                                                                 0x3ff
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_POR                                                             0x00000000
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_ATTR                                                                         0x3
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                               0x3ff
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                                   0

#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_ADDR(x)                                                                 ((x) + 0x6b0)
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_PHYS(x)                                                                 ((x) + 0x6b0)
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_OFFS                                                                    (0x6b0)
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_POR                                                                     0x00000000
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_ADDR_BMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_LSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_ADDR(x)                                                                 ((x) + 0x6b4)
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_PHYS(x)                                                                 ((x) + 0x6b4)
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_OFFS                                                                    (0x6b4)
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_RMSK                                                                         0x1ff
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_POR                                                                     0x00000000
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                             0x100
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                                 8
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_ADDR_BMSK                                                                     0xff
#define HWIO_REO_R0_REO2SW4_RING_MSI1_BASE_MSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_ADDR(x)                                                                     ((x) + 0x6b8)
#define HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_PHYS(x)                                                                     ((x) + 0x6b8)
#define HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_OFFS                                                                        (0x6b8)
#define HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_RMSK                                                                        0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_POR                                                                         0x00000000
#define HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_POR_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_ATTR                                                                                     0x3
#define HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_VALUE_BMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MSI1_DATA_VALUE_SHFT                                                                           0

#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_ADDR(x)                                                           ((x) + 0x6bc)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_PHYS(x)                                                           ((x) + 0x6bc)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_OFFS                                                              (0x6bc)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_RMSK                                                              0xffcfffff
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_ATTR                                                                           0x3
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                                   0xff000000
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                                           24
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                                    0x800000
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                                          23
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                                  0x400000
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                                        22
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                                  0xfffff
#define HWIO_REO_R0_REO2SW4_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                                        0

#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_ADDR(x)                                                                 ((x) + 0x6c0)
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_PHYS(x)                                                                 ((x) + 0x6c0)
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_OFFS                                                                    (0x6c0)
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_POR                                                                     0x00000000
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_ADDR_BMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_LSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_ADDR(x)                                                                 ((x) + 0x6c4)
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_PHYS(x)                                                                 ((x) + 0x6c4)
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_OFFS                                                                    (0x6c4)
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_RMSK                                                                         0x1ff
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_POR                                                                     0x00000000
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                             0x100
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                                 8
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_ADDR_BMSK                                                                     0xff
#define HWIO_REO_R0_REO2SW4_RING_MSI2_BASE_MSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_ADDR(x)                                                                     ((x) + 0x6c8)
#define HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_PHYS(x)                                                                     ((x) + 0x6c8)
#define HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_OFFS                                                                        (0x6c8)
#define HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_RMSK                                                                        0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_POR                                                                         0x00000000
#define HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_POR_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_ATTR                                                                                     0x3
#define HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_VALUE_BMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MSI2_DATA_VALUE_SHFT                                                                           0

#define HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_ADDR(x)                                                               ((x) + 0x6d8)
#define HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_PHYS(x)                                                               ((x) + 0x6d8)
#define HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_OFFS                                                                  (0x6d8)
#define HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_RMSK                                                                      0xffff
#define HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_POR                                                                   0x00000000
#define HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_POR_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_ATTR                                                                               0x3
#define HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                                   0xffff
#define HWIO_REO_R0_REO2SW4_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                                        0

#define HWIO_REO_R0_REO2SW4_RING_MISC_1_ADDR(x)                                                                        ((x) + 0x6dc)
#define HWIO_REO_R0_REO2SW4_RING_MISC_1_PHYS(x)                                                                        ((x) + 0x6dc)
#define HWIO_REO_R0_REO2SW4_RING_MISC_1_OFFS                                                                           (0x6dc)
#define HWIO_REO_R0_REO2SW4_RING_MISC_1_RMSK                                                                           0xffff003f
#define HWIO_REO_R0_REO2SW4_RING_MISC_1_POR                                                                            0x00000000
#define HWIO_REO_R0_REO2SW4_RING_MISC_1_POR_RMSK                                                                       0xffffffff
#define HWIO_REO_R0_REO2SW4_RING_MISC_1_ATTR                                                                                        0x3
#define HWIO_REO_R0_REO2SW4_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW4_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_REO2SW4_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW4_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_REO2SW4_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW4_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_REO2SW4_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW4_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_REO2SW4_RING_MISC_1_IN(x))
#define HWIO_REO_R0_REO2SW4_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                                  0xffff0000
#define HWIO_REO_R0_REO2SW4_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                          16
#define HWIO_REO_R0_REO2SW4_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                                         0x3f
#define HWIO_REO_R0_REO2SW4_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                            0

#define HWIO_REO_R0_REO2SW5_RING_BASE_LSB_ADDR(x)                                                                      ((x) + 0x6e0)
#define HWIO_REO_R0_REO2SW5_RING_BASE_LSB_PHYS(x)                                                                      ((x) + 0x6e0)
#define HWIO_REO_R0_REO2SW5_RING_BASE_LSB_OFFS                                                                         (0x6e0)
#define HWIO_REO_R0_REO2SW5_RING_BASE_LSB_RMSK                                                                         0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_BASE_LSB_POR                                                                          0x00000000
#define HWIO_REO_R0_REO2SW5_RING_BASE_LSB_POR_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_BASE_LSB_ATTR                                                                                      0x3
#define HWIO_REO_R0_REO2SW5_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                               0

#define HWIO_REO_R0_REO2SW5_RING_BASE_MSB_ADDR(x)                                                                      ((x) + 0x6e4)
#define HWIO_REO_R0_REO2SW5_RING_BASE_MSB_PHYS(x)                                                                      ((x) + 0x6e4)
#define HWIO_REO_R0_REO2SW5_RING_BASE_MSB_OFFS                                                                         (0x6e4)
#define HWIO_REO_R0_REO2SW5_RING_BASE_MSB_RMSK                                                                          0xfffffff
#define HWIO_REO_R0_REO2SW5_RING_BASE_MSB_POR                                                                          0x00000000
#define HWIO_REO_R0_REO2SW5_RING_BASE_MSB_POR_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_BASE_MSB_ATTR                                                                                      0x3
#define HWIO_REO_R0_REO2SW5_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_BASE_MSB_RING_SIZE_BMSK                                                                0xfffff00
#define HWIO_REO_R0_REO2SW5_RING_BASE_MSB_RING_SIZE_SHFT                                                                        8
#define HWIO_REO_R0_REO2SW5_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                            0xff
#define HWIO_REO_R0_REO2SW5_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                               0

#define HWIO_REO_R0_REO2SW5_RING_ID_ADDR(x)                                                                            ((x) + 0x6e8)
#define HWIO_REO_R0_REO2SW5_RING_ID_PHYS(x)                                                                            ((x) + 0x6e8)
#define HWIO_REO_R0_REO2SW5_RING_ID_OFFS                                                                               (0x6e8)
#define HWIO_REO_R0_REO2SW5_RING_ID_RMSK                                                                                   0xffff
#define HWIO_REO_R0_REO2SW5_RING_ID_POR                                                                                0x00000000
#define HWIO_REO_R0_REO2SW5_RING_ID_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_ID_ATTR                                                                                            0x3
#define HWIO_REO_R0_REO2SW5_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_ID_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_ID_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_ID_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_ID_RING_ID_BMSK                                                                           0xff00
#define HWIO_REO_R0_REO2SW5_RING_ID_RING_ID_SHFT                                                                                8
#define HWIO_REO_R0_REO2SW5_RING_ID_ENTRY_SIZE_BMSK                                                                          0xff
#define HWIO_REO_R0_REO2SW5_RING_ID_ENTRY_SIZE_SHFT                                                                             0

#define HWIO_REO_R0_REO2SW5_RING_STATUS_ADDR(x)                                                                        ((x) + 0x6ec)
#define HWIO_REO_R0_REO2SW5_RING_STATUS_PHYS(x)                                                                        ((x) + 0x6ec)
#define HWIO_REO_R0_REO2SW5_RING_STATUS_OFFS                                                                           (0x6ec)
#define HWIO_REO_R0_REO2SW5_RING_STATUS_RMSK                                                                           0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_STATUS_POR                                                                            0x00000000
#define HWIO_REO_R0_REO2SW5_RING_STATUS_POR_RMSK                                                                       0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_STATUS_ATTR                                                                                        0x1
#define HWIO_REO_R0_REO2SW5_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                           0xffff0000
#define HWIO_REO_R0_REO2SW5_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                                   16
#define HWIO_REO_R0_REO2SW5_RING_STATUS_NUM_VALID_WORDS_BMSK                                                               0xffff
#define HWIO_REO_R0_REO2SW5_RING_STATUS_NUM_VALID_WORDS_SHFT                                                                    0

#define HWIO_REO_R0_REO2SW5_RING_MISC_ADDR(x)                                                                          ((x) + 0x6f0)
#define HWIO_REO_R0_REO2SW5_RING_MISC_PHYS(x)                                                                          ((x) + 0x6f0)
#define HWIO_REO_R0_REO2SW5_RING_MISC_OFFS                                                                             (0x6f0)
#define HWIO_REO_R0_REO2SW5_RING_MISC_RMSK                                                                              0x7ffffff
#define HWIO_REO_R0_REO2SW5_RING_MISC_POR                                                                              0x00000080
#define HWIO_REO_R0_REO2SW5_RING_MISC_POR_RMSK                                                                         0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MISC_ATTR                                                                                          0x3
#define HWIO_REO_R0_REO2SW5_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_MISC_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_MISC_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                                      0x4000000
#define HWIO_REO_R0_REO2SW5_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                             26
#define HWIO_REO_R0_REO2SW5_RING_MISC_LOOP_CNT_BMSK                                                                     0x3c00000
#define HWIO_REO_R0_REO2SW5_RING_MISC_LOOP_CNT_SHFT                                                                            22
#define HWIO_REO_R0_REO2SW5_RING_MISC_SPARE_CONTROL_BMSK                                                                 0x3fc000
#define HWIO_REO_R0_REO2SW5_RING_MISC_SPARE_CONTROL_SHFT                                                                       14
#define HWIO_REO_R0_REO2SW5_RING_MISC_SRNG_SM_STATE2_BMSK                                                                  0x3000
#define HWIO_REO_R0_REO2SW5_RING_MISC_SRNG_SM_STATE2_SHFT                                                                      12
#define HWIO_REO_R0_REO2SW5_RING_MISC_SRNG_SM_STATE1_BMSK                                                                   0xf00
#define HWIO_REO_R0_REO2SW5_RING_MISC_SRNG_SM_STATE1_SHFT                                                                       8
#define HWIO_REO_R0_REO2SW5_RING_MISC_SRNG_IS_IDLE_BMSK                                                                      0x80
#define HWIO_REO_R0_REO2SW5_RING_MISC_SRNG_IS_IDLE_SHFT                                                                         7
#define HWIO_REO_R0_REO2SW5_RING_MISC_SRNG_ENABLE_BMSK                                                                       0x40
#define HWIO_REO_R0_REO2SW5_RING_MISC_SRNG_ENABLE_SHFT                                                                          6
#define HWIO_REO_R0_REO2SW5_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                                 0x20
#define HWIO_REO_R0_REO2SW5_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                                    5
#define HWIO_REO_R0_REO2SW5_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                                  0x10
#define HWIO_REO_R0_REO2SW5_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                                     4
#define HWIO_REO_R0_REO2SW5_RING_MISC_MSI_SWAP_BIT_BMSK                                                                       0x8
#define HWIO_REO_R0_REO2SW5_RING_MISC_MSI_SWAP_BIT_SHFT                                                                         3
#define HWIO_REO_R0_REO2SW5_RING_MISC_SECURITY_BIT_BMSK                                                                       0x4
#define HWIO_REO_R0_REO2SW5_RING_MISC_SECURITY_BIT_SHFT                                                                         2
#define HWIO_REO_R0_REO2SW5_RING_MISC_LOOPCNT_DISABLE_BMSK                                                                    0x2
#define HWIO_REO_R0_REO2SW5_RING_MISC_LOOPCNT_DISABLE_SHFT                                                                      1
#define HWIO_REO_R0_REO2SW5_RING_MISC_RING_ID_DISABLE_BMSK                                                                    0x1
#define HWIO_REO_R0_REO2SW5_RING_MISC_RING_ID_DISABLE_SHFT                                                                      0

#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_ADDR(x)                                                                   ((x) + 0x6f4)
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_PHYS(x)                                                                   ((x) + 0x6f4)
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_OFFS                                                                      (0x6f4)
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_POR                                                                       0x00000000
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_ATTR                                                                                   0x3
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                                 0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                                          0

#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_ADDR(x)                                                                   ((x) + 0x6f8)
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_PHYS(x)                                                                   ((x) + 0x6f8)
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_OFFS                                                                      (0x6f8)
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_RMSK                                                                            0xff
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_POR                                                                       0x00000000
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_ATTR                                                                                   0x3
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                                       0xff
#define HWIO_REO_R0_REO2SW5_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                                          0

#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_ADDR(x)                                                            ((x) + 0x704)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_PHYS(x)                                                            ((x) + 0x704)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_OFFS                                                               (0x704)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_POR                                                                0x00000000
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_ATTR                                                                            0x3
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                                     0xffff0000
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                             16
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                                 0x8000
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                                     15
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                                           0x7fff
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                                0

#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_ADDR(x)                                                           ((x) + 0x708)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_PHYS(x)                                                           ((x) + 0x708)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_OFFS                                                              (0x708)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_ATTR                                                                           0x1
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                                0xffff0000
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                                        16
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                                        0x8000
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                            15
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                                     0x7fff
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                          0

#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                                         ((x) + 0x70c)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                                         ((x) + 0x70c)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_OFFS                                                            (0x70c)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_RMSK                                                                 0x3ff
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_POR                                                             0x00000000
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_ATTR                                                                         0x3
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                               0x3ff
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                                   0

#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_ADDR(x)                                                                 ((x) + 0x728)
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_PHYS(x)                                                                 ((x) + 0x728)
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_OFFS                                                                    (0x728)
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_POR                                                                     0x00000000
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_ADDR_BMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_LSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_ADDR(x)                                                                 ((x) + 0x72c)
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_PHYS(x)                                                                 ((x) + 0x72c)
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_OFFS                                                                    (0x72c)
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_RMSK                                                                         0x1ff
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_POR                                                                     0x00000000
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                             0x100
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                                 8
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_ADDR_BMSK                                                                     0xff
#define HWIO_REO_R0_REO2SW5_RING_MSI1_BASE_MSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_ADDR(x)                                                                     ((x) + 0x730)
#define HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_PHYS(x)                                                                     ((x) + 0x730)
#define HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_OFFS                                                                        (0x730)
#define HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_RMSK                                                                        0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_POR                                                                         0x00000000
#define HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_POR_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_ATTR                                                                                     0x3
#define HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_VALUE_BMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MSI1_DATA_VALUE_SHFT                                                                           0

#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_ADDR(x)                                                           ((x) + 0x734)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_PHYS(x)                                                           ((x) + 0x734)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_OFFS                                                              (0x734)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_RMSK                                                              0xffcfffff
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_ATTR                                                                           0x3
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                                   0xff000000
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                                           24
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                                    0x800000
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                                          23
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                                  0x400000
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                                        22
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                                  0xfffff
#define HWIO_REO_R0_REO2SW5_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                                        0

#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_ADDR(x)                                                                 ((x) + 0x738)
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_PHYS(x)                                                                 ((x) + 0x738)
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_OFFS                                                                    (0x738)
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_POR                                                                     0x00000000
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_ADDR_BMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_LSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_ADDR(x)                                                                 ((x) + 0x73c)
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_PHYS(x)                                                                 ((x) + 0x73c)
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_OFFS                                                                    (0x73c)
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_RMSK                                                                         0x1ff
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_POR                                                                     0x00000000
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                             0x100
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                                 8
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_ADDR_BMSK                                                                     0xff
#define HWIO_REO_R0_REO2SW5_RING_MSI2_BASE_MSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_ADDR(x)                                                                     ((x) + 0x740)
#define HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_PHYS(x)                                                                     ((x) + 0x740)
#define HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_OFFS                                                                        (0x740)
#define HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_RMSK                                                                        0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_POR                                                                         0x00000000
#define HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_POR_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_ATTR                                                                                     0x3
#define HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_VALUE_BMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MSI2_DATA_VALUE_SHFT                                                                           0

#define HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_ADDR(x)                                                               ((x) + 0x750)
#define HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_PHYS(x)                                                               ((x) + 0x750)
#define HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_OFFS                                                                  (0x750)
#define HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_RMSK                                                                      0xffff
#define HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_POR                                                                   0x00000000
#define HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_POR_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_ATTR                                                                               0x3
#define HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                                   0xffff
#define HWIO_REO_R0_REO2SW5_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                                        0

#define HWIO_REO_R0_REO2SW5_RING_MISC_1_ADDR(x)                                                                        ((x) + 0x754)
#define HWIO_REO_R0_REO2SW5_RING_MISC_1_PHYS(x)                                                                        ((x) + 0x754)
#define HWIO_REO_R0_REO2SW5_RING_MISC_1_OFFS                                                                           (0x754)
#define HWIO_REO_R0_REO2SW5_RING_MISC_1_RMSK                                                                           0xffff003f
#define HWIO_REO_R0_REO2SW5_RING_MISC_1_POR                                                                            0x00000000
#define HWIO_REO_R0_REO2SW5_RING_MISC_1_POR_RMSK                                                                       0xffffffff
#define HWIO_REO_R0_REO2SW5_RING_MISC_1_ATTR                                                                                        0x3
#define HWIO_REO_R0_REO2SW5_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW5_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_REO2SW5_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW5_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_REO2SW5_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW5_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_REO2SW5_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW5_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_REO2SW5_RING_MISC_1_IN(x))
#define HWIO_REO_R0_REO2SW5_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                                  0xffff0000
#define HWIO_REO_R0_REO2SW5_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                          16
#define HWIO_REO_R0_REO2SW5_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                                         0x3f
#define HWIO_REO_R0_REO2SW5_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                            0

#define HWIO_REO_R0_REO2SW6_RING_BASE_LSB_ADDR(x)                                                                      ((x) + 0x758)
#define HWIO_REO_R0_REO2SW6_RING_BASE_LSB_PHYS(x)                                                                      ((x) + 0x758)
#define HWIO_REO_R0_REO2SW6_RING_BASE_LSB_OFFS                                                                         (0x758)
#define HWIO_REO_R0_REO2SW6_RING_BASE_LSB_RMSK                                                                         0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_BASE_LSB_POR                                                                          0x00000000
#define HWIO_REO_R0_REO2SW6_RING_BASE_LSB_POR_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_BASE_LSB_ATTR                                                                                      0x3
#define HWIO_REO_R0_REO2SW6_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                               0

#define HWIO_REO_R0_REO2SW6_RING_BASE_MSB_ADDR(x)                                                                      ((x) + 0x75c)
#define HWIO_REO_R0_REO2SW6_RING_BASE_MSB_PHYS(x)                                                                      ((x) + 0x75c)
#define HWIO_REO_R0_REO2SW6_RING_BASE_MSB_OFFS                                                                         (0x75c)
#define HWIO_REO_R0_REO2SW6_RING_BASE_MSB_RMSK                                                                          0xfffffff
#define HWIO_REO_R0_REO2SW6_RING_BASE_MSB_POR                                                                          0x00000000
#define HWIO_REO_R0_REO2SW6_RING_BASE_MSB_POR_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_BASE_MSB_ATTR                                                                                      0x3
#define HWIO_REO_R0_REO2SW6_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_BASE_MSB_RING_SIZE_BMSK                                                                0xfffff00
#define HWIO_REO_R0_REO2SW6_RING_BASE_MSB_RING_SIZE_SHFT                                                                        8
#define HWIO_REO_R0_REO2SW6_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                            0xff
#define HWIO_REO_R0_REO2SW6_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                               0

#define HWIO_REO_R0_REO2SW6_RING_ID_ADDR(x)                                                                            ((x) + 0x760)
#define HWIO_REO_R0_REO2SW6_RING_ID_PHYS(x)                                                                            ((x) + 0x760)
#define HWIO_REO_R0_REO2SW6_RING_ID_OFFS                                                                               (0x760)
#define HWIO_REO_R0_REO2SW6_RING_ID_RMSK                                                                                   0xffff
#define HWIO_REO_R0_REO2SW6_RING_ID_POR                                                                                0x00000000
#define HWIO_REO_R0_REO2SW6_RING_ID_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_ID_ATTR                                                                                            0x3
#define HWIO_REO_R0_REO2SW6_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_ID_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_ID_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_ID_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_ID_RING_ID_BMSK                                                                           0xff00
#define HWIO_REO_R0_REO2SW6_RING_ID_RING_ID_SHFT                                                                                8
#define HWIO_REO_R0_REO2SW6_RING_ID_ENTRY_SIZE_BMSK                                                                          0xff
#define HWIO_REO_R0_REO2SW6_RING_ID_ENTRY_SIZE_SHFT                                                                             0

#define HWIO_REO_R0_REO2SW6_RING_STATUS_ADDR(x)                                                                        ((x) + 0x764)
#define HWIO_REO_R0_REO2SW6_RING_STATUS_PHYS(x)                                                                        ((x) + 0x764)
#define HWIO_REO_R0_REO2SW6_RING_STATUS_OFFS                                                                           (0x764)
#define HWIO_REO_R0_REO2SW6_RING_STATUS_RMSK                                                                           0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_STATUS_POR                                                                            0x00000000
#define HWIO_REO_R0_REO2SW6_RING_STATUS_POR_RMSK                                                                       0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_STATUS_ATTR                                                                                        0x1
#define HWIO_REO_R0_REO2SW6_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                           0xffff0000
#define HWIO_REO_R0_REO2SW6_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                                   16
#define HWIO_REO_R0_REO2SW6_RING_STATUS_NUM_VALID_WORDS_BMSK                                                               0xffff
#define HWIO_REO_R0_REO2SW6_RING_STATUS_NUM_VALID_WORDS_SHFT                                                                    0

#define HWIO_REO_R0_REO2SW6_RING_MISC_ADDR(x)                                                                          ((x) + 0x768)
#define HWIO_REO_R0_REO2SW6_RING_MISC_PHYS(x)                                                                          ((x) + 0x768)
#define HWIO_REO_R0_REO2SW6_RING_MISC_OFFS                                                                             (0x768)
#define HWIO_REO_R0_REO2SW6_RING_MISC_RMSK                                                                              0x7ffffff
#define HWIO_REO_R0_REO2SW6_RING_MISC_POR                                                                              0x00000080
#define HWIO_REO_R0_REO2SW6_RING_MISC_POR_RMSK                                                                         0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MISC_ATTR                                                                                          0x3
#define HWIO_REO_R0_REO2SW6_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_MISC_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_MISC_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                                      0x4000000
#define HWIO_REO_R0_REO2SW6_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                             26
#define HWIO_REO_R0_REO2SW6_RING_MISC_LOOP_CNT_BMSK                                                                     0x3c00000
#define HWIO_REO_R0_REO2SW6_RING_MISC_LOOP_CNT_SHFT                                                                            22
#define HWIO_REO_R0_REO2SW6_RING_MISC_SPARE_CONTROL_BMSK                                                                 0x3fc000
#define HWIO_REO_R0_REO2SW6_RING_MISC_SPARE_CONTROL_SHFT                                                                       14
#define HWIO_REO_R0_REO2SW6_RING_MISC_SRNG_SM_STATE2_BMSK                                                                  0x3000
#define HWIO_REO_R0_REO2SW6_RING_MISC_SRNG_SM_STATE2_SHFT                                                                      12
#define HWIO_REO_R0_REO2SW6_RING_MISC_SRNG_SM_STATE1_BMSK                                                                   0xf00
#define HWIO_REO_R0_REO2SW6_RING_MISC_SRNG_SM_STATE1_SHFT                                                                       8
#define HWIO_REO_R0_REO2SW6_RING_MISC_SRNG_IS_IDLE_BMSK                                                                      0x80
#define HWIO_REO_R0_REO2SW6_RING_MISC_SRNG_IS_IDLE_SHFT                                                                         7
#define HWIO_REO_R0_REO2SW6_RING_MISC_SRNG_ENABLE_BMSK                                                                       0x40
#define HWIO_REO_R0_REO2SW6_RING_MISC_SRNG_ENABLE_SHFT                                                                          6
#define HWIO_REO_R0_REO2SW6_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                                 0x20
#define HWIO_REO_R0_REO2SW6_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                                    5
#define HWIO_REO_R0_REO2SW6_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                                  0x10
#define HWIO_REO_R0_REO2SW6_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                                     4
#define HWIO_REO_R0_REO2SW6_RING_MISC_MSI_SWAP_BIT_BMSK                                                                       0x8
#define HWIO_REO_R0_REO2SW6_RING_MISC_MSI_SWAP_BIT_SHFT                                                                         3
#define HWIO_REO_R0_REO2SW6_RING_MISC_SECURITY_BIT_BMSK                                                                       0x4
#define HWIO_REO_R0_REO2SW6_RING_MISC_SECURITY_BIT_SHFT                                                                         2
#define HWIO_REO_R0_REO2SW6_RING_MISC_LOOPCNT_DISABLE_BMSK                                                                    0x2
#define HWIO_REO_R0_REO2SW6_RING_MISC_LOOPCNT_DISABLE_SHFT                                                                      1
#define HWIO_REO_R0_REO2SW6_RING_MISC_RING_ID_DISABLE_BMSK                                                                    0x1
#define HWIO_REO_R0_REO2SW6_RING_MISC_RING_ID_DISABLE_SHFT                                                                      0

#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_ADDR(x)                                                                   ((x) + 0x76c)
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_PHYS(x)                                                                   ((x) + 0x76c)
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_OFFS                                                                      (0x76c)
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_POR                                                                       0x00000000
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_ATTR                                                                                   0x3
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                                 0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                                          0

#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_ADDR(x)                                                                   ((x) + 0x770)
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_PHYS(x)                                                                   ((x) + 0x770)
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_OFFS                                                                      (0x770)
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_RMSK                                                                            0xff
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_POR                                                                       0x00000000
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_ATTR                                                                                   0x3
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                                       0xff
#define HWIO_REO_R0_REO2SW6_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                                          0

#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_ADDR(x)                                                            ((x) + 0x77c)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_PHYS(x)                                                            ((x) + 0x77c)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_OFFS                                                               (0x77c)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_POR                                                                0x00000000
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_ATTR                                                                            0x3
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                                     0xffff0000
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                             16
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                                 0x8000
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                                     15
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                                           0x7fff
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                                0

#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_ADDR(x)                                                           ((x) + 0x780)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_PHYS(x)                                                           ((x) + 0x780)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_OFFS                                                              (0x780)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_ATTR                                                                           0x1
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                                0xffff0000
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                                        16
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                                        0x8000
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                            15
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                                     0x7fff
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                          0

#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                                         ((x) + 0x784)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                                         ((x) + 0x784)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_OFFS                                                            (0x784)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_RMSK                                                                 0x3ff
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_POR                                                             0x00000000
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_ATTR                                                                         0x3
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                               0x3ff
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                                   0

#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_ADDR(x)                                                                 ((x) + 0x7a0)
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_PHYS(x)                                                                 ((x) + 0x7a0)
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_OFFS                                                                    (0x7a0)
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_POR                                                                     0x00000000
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_ADDR_BMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_LSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_ADDR(x)                                                                 ((x) + 0x7a4)
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_PHYS(x)                                                                 ((x) + 0x7a4)
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_OFFS                                                                    (0x7a4)
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_RMSK                                                                         0x1ff
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_POR                                                                     0x00000000
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                             0x100
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                                 8
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_ADDR_BMSK                                                                     0xff
#define HWIO_REO_R0_REO2SW6_RING_MSI1_BASE_MSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_ADDR(x)                                                                     ((x) + 0x7a8)
#define HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_PHYS(x)                                                                     ((x) + 0x7a8)
#define HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_OFFS                                                                        (0x7a8)
#define HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_RMSK                                                                        0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_POR                                                                         0x00000000
#define HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_POR_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_ATTR                                                                                     0x3
#define HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_VALUE_BMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MSI1_DATA_VALUE_SHFT                                                                           0

#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_ADDR(x)                                                           ((x) + 0x7ac)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_PHYS(x)                                                           ((x) + 0x7ac)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_OFFS                                                              (0x7ac)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_RMSK                                                              0xffcfffff
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_ATTR                                                                           0x3
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                                   0xff000000
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                                           24
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                                    0x800000
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                                          23
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                                  0x400000
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                                        22
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                                  0xfffff
#define HWIO_REO_R0_REO2SW6_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                                        0

#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_ADDR(x)                                                                 ((x) + 0x7b0)
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_PHYS(x)                                                                 ((x) + 0x7b0)
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_OFFS                                                                    (0x7b0)
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_POR                                                                     0x00000000
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_ADDR_BMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_LSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_ADDR(x)                                                                 ((x) + 0x7b4)
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_PHYS(x)                                                                 ((x) + 0x7b4)
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_OFFS                                                                    (0x7b4)
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_RMSK                                                                         0x1ff
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_POR                                                                     0x00000000
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                             0x100
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                                 8
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_ADDR_BMSK                                                                     0xff
#define HWIO_REO_R0_REO2SW6_RING_MSI2_BASE_MSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_ADDR(x)                                                                     ((x) + 0x7b8)
#define HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_PHYS(x)                                                                     ((x) + 0x7b8)
#define HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_OFFS                                                                        (0x7b8)
#define HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_RMSK                                                                        0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_POR                                                                         0x00000000
#define HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_POR_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_ATTR                                                                                     0x3
#define HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_VALUE_BMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MSI2_DATA_VALUE_SHFT                                                                           0

#define HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_ADDR(x)                                                               ((x) + 0x7c8)
#define HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_PHYS(x)                                                               ((x) + 0x7c8)
#define HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_OFFS                                                                  (0x7c8)
#define HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_RMSK                                                                      0xffff
#define HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_POR                                                                   0x00000000
#define HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_POR_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_ATTR                                                                               0x3
#define HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                                   0xffff
#define HWIO_REO_R0_REO2SW6_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                                        0

#define HWIO_REO_R0_REO2SW6_RING_MISC_1_ADDR(x)                                                                        ((x) + 0x7cc)
#define HWIO_REO_R0_REO2SW6_RING_MISC_1_PHYS(x)                                                                        ((x) + 0x7cc)
#define HWIO_REO_R0_REO2SW6_RING_MISC_1_OFFS                                                                           (0x7cc)
#define HWIO_REO_R0_REO2SW6_RING_MISC_1_RMSK                                                                           0xffff003f
#define HWIO_REO_R0_REO2SW6_RING_MISC_1_POR                                                                            0x00000000
#define HWIO_REO_R0_REO2SW6_RING_MISC_1_POR_RMSK                                                                       0xffffffff
#define HWIO_REO_R0_REO2SW6_RING_MISC_1_ATTR                                                                                        0x3
#define HWIO_REO_R0_REO2SW6_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW6_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_REO2SW6_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW6_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_REO2SW6_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW6_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_REO2SW6_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW6_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_REO2SW6_RING_MISC_1_IN(x))
#define HWIO_REO_R0_REO2SW6_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                                  0xffff0000
#define HWIO_REO_R0_REO2SW6_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                          16
#define HWIO_REO_R0_REO2SW6_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                                         0x3f
#define HWIO_REO_R0_REO2SW6_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                            0

#define HWIO_REO_R0_REO2SW0_RING_BASE_LSB_ADDR(x)                                                                      ((x) + 0x8c0)
#define HWIO_REO_R0_REO2SW0_RING_BASE_LSB_PHYS(x)                                                                      ((x) + 0x8c0)
#define HWIO_REO_R0_REO2SW0_RING_BASE_LSB_OFFS                                                                         (0x8c0)
#define HWIO_REO_R0_REO2SW0_RING_BASE_LSB_RMSK                                                                         0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_BASE_LSB_POR                                                                          0x00000000
#define HWIO_REO_R0_REO2SW0_RING_BASE_LSB_POR_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_BASE_LSB_ATTR                                                                                      0x3
#define HWIO_REO_R0_REO2SW0_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                                      0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                               0

#define HWIO_REO_R0_REO2SW0_RING_BASE_MSB_ADDR(x)                                                                      ((x) + 0x8c4)
#define HWIO_REO_R0_REO2SW0_RING_BASE_MSB_PHYS(x)                                                                      ((x) + 0x8c4)
#define HWIO_REO_R0_REO2SW0_RING_BASE_MSB_OFFS                                                                         (0x8c4)
#define HWIO_REO_R0_REO2SW0_RING_BASE_MSB_RMSK                                                                          0xfffffff
#define HWIO_REO_R0_REO2SW0_RING_BASE_MSB_POR                                                                          0x00000000
#define HWIO_REO_R0_REO2SW0_RING_BASE_MSB_POR_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_BASE_MSB_ATTR                                                                                      0x3
#define HWIO_REO_R0_REO2SW0_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_BASE_MSB_RING_SIZE_BMSK                                                                0xfffff00
#define HWIO_REO_R0_REO2SW0_RING_BASE_MSB_RING_SIZE_SHFT                                                                        8
#define HWIO_REO_R0_REO2SW0_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                            0xff
#define HWIO_REO_R0_REO2SW0_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                               0

#define HWIO_REO_R0_REO2SW0_RING_ID_ADDR(x)                                                                            ((x) + 0x8c8)
#define HWIO_REO_R0_REO2SW0_RING_ID_PHYS(x)                                                                            ((x) + 0x8c8)
#define HWIO_REO_R0_REO2SW0_RING_ID_OFFS                                                                               (0x8c8)
#define HWIO_REO_R0_REO2SW0_RING_ID_RMSK                                                                                   0xffff
#define HWIO_REO_R0_REO2SW0_RING_ID_POR                                                                                0x00000000
#define HWIO_REO_R0_REO2SW0_RING_ID_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_ID_ATTR                                                                                            0x3
#define HWIO_REO_R0_REO2SW0_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_ID_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_ID_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_ID_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_ID_RING_ID_BMSK                                                                           0xff00
#define HWIO_REO_R0_REO2SW0_RING_ID_RING_ID_SHFT                                                                                8
#define HWIO_REO_R0_REO2SW0_RING_ID_ENTRY_SIZE_BMSK                                                                          0xff
#define HWIO_REO_R0_REO2SW0_RING_ID_ENTRY_SIZE_SHFT                                                                             0

#define HWIO_REO_R0_REO2SW0_RING_STATUS_ADDR(x)                                                                        ((x) + 0x8cc)
#define HWIO_REO_R0_REO2SW0_RING_STATUS_PHYS(x)                                                                        ((x) + 0x8cc)
#define HWIO_REO_R0_REO2SW0_RING_STATUS_OFFS                                                                           (0x8cc)
#define HWIO_REO_R0_REO2SW0_RING_STATUS_RMSK                                                                           0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_STATUS_POR                                                                            0x00000000
#define HWIO_REO_R0_REO2SW0_RING_STATUS_POR_RMSK                                                                       0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_STATUS_ATTR                                                                                        0x1
#define HWIO_REO_R0_REO2SW0_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                           0xffff0000
#define HWIO_REO_R0_REO2SW0_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                                   16
#define HWIO_REO_R0_REO2SW0_RING_STATUS_NUM_VALID_WORDS_BMSK                                                               0xffff
#define HWIO_REO_R0_REO2SW0_RING_STATUS_NUM_VALID_WORDS_SHFT                                                                    0

#define HWIO_REO_R0_REO2SW0_RING_MISC_ADDR(x)                                                                          ((x) + 0x8d0)
#define HWIO_REO_R0_REO2SW0_RING_MISC_PHYS(x)                                                                          ((x) + 0x8d0)
#define HWIO_REO_R0_REO2SW0_RING_MISC_OFFS                                                                             (0x8d0)
#define HWIO_REO_R0_REO2SW0_RING_MISC_RMSK                                                                              0x7ffffff
#define HWIO_REO_R0_REO2SW0_RING_MISC_POR                                                                              0x00000080
#define HWIO_REO_R0_REO2SW0_RING_MISC_POR_RMSK                                                                         0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MISC_ATTR                                                                                          0x3
#define HWIO_REO_R0_REO2SW0_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_MISC_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_MISC_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                                      0x4000000
#define HWIO_REO_R0_REO2SW0_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                             26
#define HWIO_REO_R0_REO2SW0_RING_MISC_LOOP_CNT_BMSK                                                                     0x3c00000
#define HWIO_REO_R0_REO2SW0_RING_MISC_LOOP_CNT_SHFT                                                                            22
#define HWIO_REO_R0_REO2SW0_RING_MISC_SPARE_CONTROL_BMSK                                                                 0x3fc000
#define HWIO_REO_R0_REO2SW0_RING_MISC_SPARE_CONTROL_SHFT                                                                       14
#define HWIO_REO_R0_REO2SW0_RING_MISC_SRNG_SM_STATE2_BMSK                                                                  0x3000
#define HWIO_REO_R0_REO2SW0_RING_MISC_SRNG_SM_STATE2_SHFT                                                                      12
#define HWIO_REO_R0_REO2SW0_RING_MISC_SRNG_SM_STATE1_BMSK                                                                   0xf00
#define HWIO_REO_R0_REO2SW0_RING_MISC_SRNG_SM_STATE1_SHFT                                                                       8
#define HWIO_REO_R0_REO2SW0_RING_MISC_SRNG_IS_IDLE_BMSK                                                                      0x80
#define HWIO_REO_R0_REO2SW0_RING_MISC_SRNG_IS_IDLE_SHFT                                                                         7
#define HWIO_REO_R0_REO2SW0_RING_MISC_SRNG_ENABLE_BMSK                                                                       0x40
#define HWIO_REO_R0_REO2SW0_RING_MISC_SRNG_ENABLE_SHFT                                                                          6
#define HWIO_REO_R0_REO2SW0_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                                 0x20
#define HWIO_REO_R0_REO2SW0_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                                    5
#define HWIO_REO_R0_REO2SW0_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                                  0x10
#define HWIO_REO_R0_REO2SW0_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                                     4
#define HWIO_REO_R0_REO2SW0_RING_MISC_MSI_SWAP_BIT_BMSK                                                                       0x8
#define HWIO_REO_R0_REO2SW0_RING_MISC_MSI_SWAP_BIT_SHFT                                                                         3
#define HWIO_REO_R0_REO2SW0_RING_MISC_SECURITY_BIT_BMSK                                                                       0x4
#define HWIO_REO_R0_REO2SW0_RING_MISC_SECURITY_BIT_SHFT                                                                         2
#define HWIO_REO_R0_REO2SW0_RING_MISC_LOOPCNT_DISABLE_BMSK                                                                    0x2
#define HWIO_REO_R0_REO2SW0_RING_MISC_LOOPCNT_DISABLE_SHFT                                                                      1
#define HWIO_REO_R0_REO2SW0_RING_MISC_RING_ID_DISABLE_BMSK                                                                    0x1
#define HWIO_REO_R0_REO2SW0_RING_MISC_RING_ID_DISABLE_SHFT                                                                      0

#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_ADDR(x)                                                                   ((x) + 0x8d4)
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_PHYS(x)                                                                   ((x) + 0x8d4)
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_OFFS                                                                      (0x8d4)
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_POR                                                                       0x00000000
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_ATTR                                                                                   0x3
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                                 0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                                          0

#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_ADDR(x)                                                                   ((x) + 0x8d8)
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_PHYS(x)                                                                   ((x) + 0x8d8)
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_OFFS                                                                      (0x8d8)
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_RMSK                                                                            0xff
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_POR                                                                       0x00000000
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_ATTR                                                                                   0x3
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                                       0xff
#define HWIO_REO_R0_REO2SW0_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                                          0

#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_ADDR(x)                                                            ((x) + 0x8e4)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_PHYS(x)                                                            ((x) + 0x8e4)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_OFFS                                                               (0x8e4)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_POR                                                                0x00000000
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_ATTR                                                                            0x3
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                                     0xffff0000
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                             16
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                                 0x8000
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                                     15
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                                           0x7fff
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                                0

#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_ADDR(x)                                                           ((x) + 0x8e8)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_PHYS(x)                                                           ((x) + 0x8e8)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_OFFS                                                              (0x8e8)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_ATTR                                                                           0x1
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                                0xffff0000
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                                        16
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                                        0x8000
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                            15
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                                     0x7fff
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                          0

#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                                         ((x) + 0x8ec)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                                         ((x) + 0x8ec)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_OFFS                                                            (0x8ec)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_RMSK                                                                 0x3ff
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_POR                                                             0x00000000
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_ATTR                                                                         0x3
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                               0x3ff
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                                   0

#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_ADDR(x)                                                                 ((x) + 0x908)
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_PHYS(x)                                                                 ((x) + 0x908)
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_OFFS                                                                    (0x908)
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_POR                                                                     0x00000000
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_ADDR_BMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_LSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_ADDR(x)                                                                 ((x) + 0x90c)
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_PHYS(x)                                                                 ((x) + 0x90c)
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_OFFS                                                                    (0x90c)
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_RMSK                                                                         0x1ff
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_POR                                                                     0x00000000
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                             0x100
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                                 8
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_ADDR_BMSK                                                                     0xff
#define HWIO_REO_R0_REO2SW0_RING_MSI1_BASE_MSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_ADDR(x)                                                                     ((x) + 0x910)
#define HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_PHYS(x)                                                                     ((x) + 0x910)
#define HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_OFFS                                                                        (0x910)
#define HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_RMSK                                                                        0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_POR                                                                         0x00000000
#define HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_POR_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_ATTR                                                                                     0x3
#define HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_VALUE_BMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MSI1_DATA_VALUE_SHFT                                                                           0

#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_ADDR(x)                                                           ((x) + 0x914)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_PHYS(x)                                                           ((x) + 0x914)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_OFFS                                                              (0x914)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_RMSK                                                              0xffcfffff
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_POR                                                               0x00000000
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_ATTR                                                                           0x3
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                                   0xff000000
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                                           24
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                                    0x800000
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                                          23
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                                  0x400000
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                                        22
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                                  0xfffff
#define HWIO_REO_R0_REO2SW0_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                                        0

#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_ADDR(x)                                                                 ((x) + 0x918)
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_PHYS(x)                                                                 ((x) + 0x918)
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_OFFS                                                                    (0x918)
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_POR                                                                     0x00000000
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_ADDR_BMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_LSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_ADDR(x)                                                                 ((x) + 0x91c)
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_PHYS(x)                                                                 ((x) + 0x91c)
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_OFFS                                                                    (0x91c)
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_RMSK                                                                         0x1ff
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_POR                                                                     0x00000000
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_ATTR                                                                                 0x3
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                             0x100
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                                 8
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_ADDR_BMSK                                                                     0xff
#define HWIO_REO_R0_REO2SW0_RING_MSI2_BASE_MSB_ADDR_SHFT                                                                        0

#define HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_ADDR(x)                                                                     ((x) + 0x920)
#define HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_PHYS(x)                                                                     ((x) + 0x920)
#define HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_OFFS                                                                        (0x920)
#define HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_RMSK                                                                        0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_POR                                                                         0x00000000
#define HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_POR_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_ATTR                                                                                     0x3
#define HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_VALUE_BMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MSI2_DATA_VALUE_SHFT                                                                           0

#define HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_ADDR(x)                                                               ((x) + 0x930)
#define HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_PHYS(x)                                                               ((x) + 0x930)
#define HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_OFFS                                                                  (0x930)
#define HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_RMSK                                                                      0xffff
#define HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_POR                                                                   0x00000000
#define HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_POR_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_ATTR                                                                               0x3
#define HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                                   0xffff
#define HWIO_REO_R0_REO2SW0_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                                        0

#define HWIO_REO_R0_REO2SW0_RING_MISC_1_ADDR(x)                                                                        ((x) + 0x934)
#define HWIO_REO_R0_REO2SW0_RING_MISC_1_PHYS(x)                                                                        ((x) + 0x934)
#define HWIO_REO_R0_REO2SW0_RING_MISC_1_OFFS                                                                           (0x934)
#define HWIO_REO_R0_REO2SW0_RING_MISC_1_RMSK                                                                           0xffff003f
#define HWIO_REO_R0_REO2SW0_RING_MISC_1_POR                                                                            0x00000000
#define HWIO_REO_R0_REO2SW0_RING_MISC_1_POR_RMSK                                                                       0xffffffff
#define HWIO_REO_R0_REO2SW0_RING_MISC_1_ATTR                                                                                        0x3
#define HWIO_REO_R0_REO2SW0_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_REO2SW0_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_REO2SW0_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2SW0_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_REO2SW0_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2SW0_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_REO2SW0_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2SW0_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_REO2SW0_RING_MISC_1_IN(x))
#define HWIO_REO_R0_REO2SW0_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                                  0xffff0000
#define HWIO_REO_R0_REO2SW0_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                          16
#define HWIO_REO_R0_REO2SW0_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                                         0x3f
#define HWIO_REO_R0_REO2SW0_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                            0

#define HWIO_REO_R0_REO2FW_RING_BASE_LSB_ADDR(x)                                                                       ((x) + 0x9b0)
#define HWIO_REO_R0_REO2FW_RING_BASE_LSB_PHYS(x)                                                                       ((x) + 0x9b0)
#define HWIO_REO_R0_REO2FW_RING_BASE_LSB_OFFS                                                                          (0x9b0)
#define HWIO_REO_R0_REO2FW_RING_BASE_LSB_RMSK                                                                          0xffffffff
#define HWIO_REO_R0_REO2FW_RING_BASE_LSB_POR                                                                           0x00000000
#define HWIO_REO_R0_REO2FW_RING_BASE_LSB_POR_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_REO2FW_RING_BASE_LSB_ATTR                                                                                       0x3
#define HWIO_REO_R0_REO2FW_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2FW_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2FW_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2FW_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2FW_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2FW_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2FW_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2FW_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2FW_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2FW_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                                       0xffffffff
#define HWIO_REO_R0_REO2FW_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                                0

#define HWIO_REO_R0_REO2FW_RING_BASE_MSB_ADDR(x)                                                                       ((x) + 0x9b4)
#define HWIO_REO_R0_REO2FW_RING_BASE_MSB_PHYS(x)                                                                       ((x) + 0x9b4)
#define HWIO_REO_R0_REO2FW_RING_BASE_MSB_OFFS                                                                          (0x9b4)
#define HWIO_REO_R0_REO2FW_RING_BASE_MSB_RMSK                                                                           0xfffffff
#define HWIO_REO_R0_REO2FW_RING_BASE_MSB_POR                                                                           0x00000000
#define HWIO_REO_R0_REO2FW_RING_BASE_MSB_POR_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_REO2FW_RING_BASE_MSB_ATTR                                                                                       0x3
#define HWIO_REO_R0_REO2FW_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2FW_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2FW_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2FW_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2FW_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2FW_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2FW_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2FW_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2FW_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2FW_RING_BASE_MSB_RING_SIZE_BMSK                                                                 0xfffff00
#define HWIO_REO_R0_REO2FW_RING_BASE_MSB_RING_SIZE_SHFT                                                                         8
#define HWIO_REO_R0_REO2FW_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                             0xff
#define HWIO_REO_R0_REO2FW_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                                0

#define HWIO_REO_R0_REO2FW_RING_ID_ADDR(x)                                                                             ((x) + 0x9b8)
#define HWIO_REO_R0_REO2FW_RING_ID_PHYS(x)                                                                             ((x) + 0x9b8)
#define HWIO_REO_R0_REO2FW_RING_ID_OFFS                                                                                (0x9b8)
#define HWIO_REO_R0_REO2FW_RING_ID_RMSK                                                                                    0xffff
#define HWIO_REO_R0_REO2FW_RING_ID_POR                                                                                 0x00000000
#define HWIO_REO_R0_REO2FW_RING_ID_POR_RMSK                                                                            0xffffffff
#define HWIO_REO_R0_REO2FW_RING_ID_ATTR                                                                                             0x3
#define HWIO_REO_R0_REO2FW_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_REO2FW_RING_ID_ADDR(x))
#define HWIO_REO_R0_REO2FW_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2FW_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_REO2FW_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2FW_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_REO2FW_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2FW_RING_ID_ADDR(x),m,v,HWIO_REO_R0_REO2FW_RING_ID_IN(x))
#define HWIO_REO_R0_REO2FW_RING_ID_RING_ID_BMSK                                                                            0xff00
#define HWIO_REO_R0_REO2FW_RING_ID_RING_ID_SHFT                                                                                 8
#define HWIO_REO_R0_REO2FW_RING_ID_ENTRY_SIZE_BMSK                                                                           0xff
#define HWIO_REO_R0_REO2FW_RING_ID_ENTRY_SIZE_SHFT                                                                              0

#define HWIO_REO_R0_REO2FW_RING_STATUS_ADDR(x)                                                                         ((x) + 0x9bc)
#define HWIO_REO_R0_REO2FW_RING_STATUS_PHYS(x)                                                                         ((x) + 0x9bc)
#define HWIO_REO_R0_REO2FW_RING_STATUS_OFFS                                                                            (0x9bc)
#define HWIO_REO_R0_REO2FW_RING_STATUS_RMSK                                                                            0xffffffff
#define HWIO_REO_R0_REO2FW_RING_STATUS_POR                                                                             0x00000000
#define HWIO_REO_R0_REO2FW_RING_STATUS_POR_RMSK                                                                        0xffffffff
#define HWIO_REO_R0_REO2FW_RING_STATUS_ATTR                                                                                         0x1
#define HWIO_REO_R0_REO2FW_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2FW_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2FW_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2FW_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2FW_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                            0xffff0000
#define HWIO_REO_R0_REO2FW_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                                    16
#define HWIO_REO_R0_REO2FW_RING_STATUS_NUM_VALID_WORDS_BMSK                                                                0xffff
#define HWIO_REO_R0_REO2FW_RING_STATUS_NUM_VALID_WORDS_SHFT                                                                     0

#define HWIO_REO_R0_REO2FW_RING_MISC_ADDR(x)                                                                           ((x) + 0x9c0)
#define HWIO_REO_R0_REO2FW_RING_MISC_PHYS(x)                                                                           ((x) + 0x9c0)
#define HWIO_REO_R0_REO2FW_RING_MISC_OFFS                                                                              (0x9c0)
#define HWIO_REO_R0_REO2FW_RING_MISC_RMSK                                                                               0x7ffffff
#define HWIO_REO_R0_REO2FW_RING_MISC_POR                                                                               0x00000080
#define HWIO_REO_R0_REO2FW_RING_MISC_POR_RMSK                                                                          0xffffffff
#define HWIO_REO_R0_REO2FW_RING_MISC_ATTR                                                                                           0x3
#define HWIO_REO_R0_REO2FW_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_REO2FW_RING_MISC_ADDR(x))
#define HWIO_REO_R0_REO2FW_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2FW_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_REO2FW_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2FW_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_REO2FW_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2FW_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_REO2FW_RING_MISC_IN(x))
#define HWIO_REO_R0_REO2FW_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                                       0x4000000
#define HWIO_REO_R0_REO2FW_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                              26
#define HWIO_REO_R0_REO2FW_RING_MISC_LOOP_CNT_BMSK                                                                      0x3c00000
#define HWIO_REO_R0_REO2FW_RING_MISC_LOOP_CNT_SHFT                                                                             22
#define HWIO_REO_R0_REO2FW_RING_MISC_SPARE_CONTROL_BMSK                                                                  0x3fc000
#define HWIO_REO_R0_REO2FW_RING_MISC_SPARE_CONTROL_SHFT                                                                        14
#define HWIO_REO_R0_REO2FW_RING_MISC_SRNG_SM_STATE2_BMSK                                                                   0x3000
#define HWIO_REO_R0_REO2FW_RING_MISC_SRNG_SM_STATE2_SHFT                                                                       12
#define HWIO_REO_R0_REO2FW_RING_MISC_SRNG_SM_STATE1_BMSK                                                                    0xf00
#define HWIO_REO_R0_REO2FW_RING_MISC_SRNG_SM_STATE1_SHFT                                                                        8
#define HWIO_REO_R0_REO2FW_RING_MISC_SRNG_IS_IDLE_BMSK                                                                       0x80
#define HWIO_REO_R0_REO2FW_RING_MISC_SRNG_IS_IDLE_SHFT                                                                          7
#define HWIO_REO_R0_REO2FW_RING_MISC_SRNG_ENABLE_BMSK                                                                        0x40
#define HWIO_REO_R0_REO2FW_RING_MISC_SRNG_ENABLE_SHFT                                                                           6
#define HWIO_REO_R0_REO2FW_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                                  0x20
#define HWIO_REO_R0_REO2FW_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                                     5
#define HWIO_REO_R0_REO2FW_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                                   0x10
#define HWIO_REO_R0_REO2FW_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                                      4
#define HWIO_REO_R0_REO2FW_RING_MISC_MSI_SWAP_BIT_BMSK                                                                        0x8
#define HWIO_REO_R0_REO2FW_RING_MISC_MSI_SWAP_BIT_SHFT                                                                          3
#define HWIO_REO_R0_REO2FW_RING_MISC_SECURITY_BIT_BMSK                                                                        0x4
#define HWIO_REO_R0_REO2FW_RING_MISC_SECURITY_BIT_SHFT                                                                          2
#define HWIO_REO_R0_REO2FW_RING_MISC_LOOPCNT_DISABLE_BMSK                                                                     0x2
#define HWIO_REO_R0_REO2FW_RING_MISC_LOOPCNT_DISABLE_SHFT                                                                       1
#define HWIO_REO_R0_REO2FW_RING_MISC_RING_ID_DISABLE_BMSK                                                                     0x1
#define HWIO_REO_R0_REO2FW_RING_MISC_RING_ID_DISABLE_SHFT                                                                       0

#define HWIO_REO_R0_REO2FW_RING_HP_ADDR_LSB_ADDR(x)                                                                    ((x) + 0x9c4)
#define HWIO_REO_R0_REO2FW_RING_HP_ADDR_LSB_PHYS(x)                                                                    ((x) + 0x9c4)
#define HWIO_REO_R0_REO2FW_RING_HP_ADDR_LSB_OFFS                                                                       (0x9c4)
#define HWIO_REO_R0_REO2FW_RING_HP_ADDR_LSB_RMSK                                                                       0xffffffff
#define HWIO_REO_R0_REO2FW_RING_HP_ADDR_LSB_POR                                                                        0x00000000
#define HWIO_REO_R0_REO2FW_RING_HP_ADDR_LSB_POR_RMSK                                                                   0xffffffff
#define HWIO_REO_R0_REO2FW_RING_HP_ADDR_LSB_ATTR                                                                                    0x3
#define HWIO_REO_R0_REO2FW_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2FW_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_REO2FW_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2FW_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2FW_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2FW_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2FW_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2FW_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2FW_RING_HP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_REO2FW_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                                  0xffffffff
#define HWIO_REO_R0_REO2FW_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                                           0

#define HWIO_REO_R0_REO2FW_RING_HP_ADDR_MSB_ADDR(x)                                                                    ((x) + 0x9c8)
#define HWIO_REO_R0_REO2FW_RING_HP_ADDR_MSB_PHYS(x)                                                                    ((x) + 0x9c8)
#define HWIO_REO_R0_REO2FW_RING_HP_ADDR_MSB_OFFS                                                                       (0x9c8)
#define HWIO_REO_R0_REO2FW_RING_HP_ADDR_MSB_RMSK                                                                             0xff
#define HWIO_REO_R0_REO2FW_RING_HP_ADDR_MSB_POR                                                                        0x00000000
#define HWIO_REO_R0_REO2FW_RING_HP_ADDR_MSB_POR_RMSK                                                                   0xffffffff
#define HWIO_REO_R0_REO2FW_RING_HP_ADDR_MSB_ATTR                                                                                    0x3
#define HWIO_REO_R0_REO2FW_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2FW_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_REO2FW_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2FW_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2FW_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2FW_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2FW_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2FW_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2FW_RING_HP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_REO2FW_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                                        0xff
#define HWIO_REO_R0_REO2FW_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                                           0

#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_SETUP_ADDR(x)                                                             ((x) + 0x9d4)
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_SETUP_PHYS(x)                                                             ((x) + 0x9d4)
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_SETUP_OFFS                                                                (0x9d4)
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_SETUP_RMSK                                                                0xffffffff
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_SETUP_POR                                                                 0x00000000
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_SETUP_POR_RMSK                                                            0xffffffff
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_SETUP_ATTR                                                                             0x3
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                                      0xffff0000
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                              16
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                                  0x8000
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                                      15
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                                            0x7fff
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                                 0

#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_STATUS_ADDR(x)                                                            ((x) + 0x9d8)
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_STATUS_PHYS(x)                                                            ((x) + 0x9d8)
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_STATUS_OFFS                                                               (0x9d8)
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_STATUS_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_STATUS_POR                                                                0x00000000
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_STATUS_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_STATUS_ATTR                                                                            0x1
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                                 0xffff0000
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                                         16
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                                         0x8000
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                             15
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                                      0x7fff
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                           0

#define HWIO_REO_R0_REO2FW_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                                          ((x) + 0x9dc)
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                                          ((x) + 0x9dc)
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_FULL_COUNTER_OFFS                                                             (0x9dc)
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_FULL_COUNTER_RMSK                                                                  0x3ff
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_FULL_COUNTER_POR                                                              0x00000000
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                                         0xffffffff
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_FULL_COUNTER_ATTR                                                                          0x3
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_REO2FW_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2FW_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2FW_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2FW_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_REO_R0_REO2FW_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                                0x3ff
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                                    0

#define HWIO_REO_R0_REO2FW_RING_MSI1_BASE_LSB_ADDR(x)                                                                  ((x) + 0x9f8)
#define HWIO_REO_R0_REO2FW_RING_MSI1_BASE_LSB_PHYS(x)                                                                  ((x) + 0x9f8)
#define HWIO_REO_R0_REO2FW_RING_MSI1_BASE_LSB_OFFS                                                                     (0x9f8)
#define HWIO_REO_R0_REO2FW_RING_MSI1_BASE_LSB_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_REO2FW_RING_MSI1_BASE_LSB_POR                                                                      0x00000000
#define HWIO_REO_R0_REO2FW_RING_MSI1_BASE_LSB_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO2FW_RING_MSI1_BASE_LSB_ATTR                                                                                  0x3
#define HWIO_REO_R0_REO2FW_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2FW_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2FW_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2FW_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2FW_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2FW_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2FW_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2FW_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2FW_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2FW_RING_MSI1_BASE_LSB_ADDR_BMSK                                                                0xffffffff
#define HWIO_REO_R0_REO2FW_RING_MSI1_BASE_LSB_ADDR_SHFT                                                                         0

#define HWIO_REO_R0_REO2FW_RING_MSI1_BASE_MSB_ADDR(x)                                                                  ((x) + 0x9fc)
#define HWIO_REO_R0_REO2FW_RING_MSI1_BASE_MSB_PHYS(x)                                                                  ((x) + 0x9fc)
#define HWIO_REO_R0_REO2FW_RING_MSI1_BASE_MSB_OFFS                                                                     (0x9fc)
#define HWIO_REO_R0_REO2FW_RING_MSI1_BASE_MSB_RMSK                                                                          0x1ff
#define HWIO_REO_R0_REO2FW_RING_MSI1_BASE_MSB_POR                                                                      0x00000000
#define HWIO_REO_R0_REO2FW_RING_MSI1_BASE_MSB_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO2FW_RING_MSI1_BASE_MSB_ATTR                                                                                  0x3
#define HWIO_REO_R0_REO2FW_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2FW_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2FW_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2FW_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2FW_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2FW_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2FW_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2FW_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2FW_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2FW_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                              0x100
#define HWIO_REO_R0_REO2FW_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                                  8
#define HWIO_REO_R0_REO2FW_RING_MSI1_BASE_MSB_ADDR_BMSK                                                                      0xff
#define HWIO_REO_R0_REO2FW_RING_MSI1_BASE_MSB_ADDR_SHFT                                                                         0

#define HWIO_REO_R0_REO2FW_RING_MSI1_DATA_ADDR(x)                                                                      ((x) + 0xa00)
#define HWIO_REO_R0_REO2FW_RING_MSI1_DATA_PHYS(x)                                                                      ((x) + 0xa00)
#define HWIO_REO_R0_REO2FW_RING_MSI1_DATA_OFFS                                                                         (0xa00)
#define HWIO_REO_R0_REO2FW_RING_MSI1_DATA_RMSK                                                                         0xffffffff
#define HWIO_REO_R0_REO2FW_RING_MSI1_DATA_POR                                                                          0x00000000
#define HWIO_REO_R0_REO2FW_RING_MSI1_DATA_POR_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_REO2FW_RING_MSI1_DATA_ATTR                                                                                      0x3
#define HWIO_REO_R0_REO2FW_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2FW_RING_MSI1_DATA_ADDR(x))
#define HWIO_REO_R0_REO2FW_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2FW_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2FW_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2FW_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2FW_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2FW_RING_MSI1_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2FW_RING_MSI1_DATA_IN(x))
#define HWIO_REO_R0_REO2FW_RING_MSI1_DATA_VALUE_BMSK                                                                   0xffffffff
#define HWIO_REO_R0_REO2FW_RING_MSI1_DATA_VALUE_SHFT                                                                            0

#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT2_SETUP_ADDR(x)                                                            ((x) + 0xa04)
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT2_SETUP_PHYS(x)                                                            ((x) + 0xa04)
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT2_SETUP_OFFS                                                               (0xa04)
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT2_SETUP_RMSK                                                               0xffcfffff
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT2_SETUP_POR                                                                0x00000000
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT2_SETUP_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT2_SETUP_ATTR                                                                            0x3
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO2FW_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2FW_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2FW_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2FW_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO2FW_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                                    0xff000000
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                                            24
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                                     0x800000
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                                           23
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                                   0x400000
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                                         22
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                                   0xfffff
#define HWIO_REO_R0_REO2FW_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                                         0

#define HWIO_REO_R0_REO2FW_RING_MSI2_BASE_LSB_ADDR(x)                                                                  ((x) + 0xa08)
#define HWIO_REO_R0_REO2FW_RING_MSI2_BASE_LSB_PHYS(x)                                                                  ((x) + 0xa08)
#define HWIO_REO_R0_REO2FW_RING_MSI2_BASE_LSB_OFFS                                                                     (0xa08)
#define HWIO_REO_R0_REO2FW_RING_MSI2_BASE_LSB_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_REO2FW_RING_MSI2_BASE_LSB_POR                                                                      0x00000000
#define HWIO_REO_R0_REO2FW_RING_MSI2_BASE_LSB_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO2FW_RING_MSI2_BASE_LSB_ATTR                                                                                  0x3
#define HWIO_REO_R0_REO2FW_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2FW_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO2FW_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2FW_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO2FW_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2FW_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO2FW_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2FW_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO2FW_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO2FW_RING_MSI2_BASE_LSB_ADDR_BMSK                                                                0xffffffff
#define HWIO_REO_R0_REO2FW_RING_MSI2_BASE_LSB_ADDR_SHFT                                                                         0

#define HWIO_REO_R0_REO2FW_RING_MSI2_BASE_MSB_ADDR(x)                                                                  ((x) + 0xa0c)
#define HWIO_REO_R0_REO2FW_RING_MSI2_BASE_MSB_PHYS(x)                                                                  ((x) + 0xa0c)
#define HWIO_REO_R0_REO2FW_RING_MSI2_BASE_MSB_OFFS                                                                     (0xa0c)
#define HWIO_REO_R0_REO2FW_RING_MSI2_BASE_MSB_RMSK                                                                          0x1ff
#define HWIO_REO_R0_REO2FW_RING_MSI2_BASE_MSB_POR                                                                      0x00000000
#define HWIO_REO_R0_REO2FW_RING_MSI2_BASE_MSB_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO2FW_RING_MSI2_BASE_MSB_ATTR                                                                                  0x3
#define HWIO_REO_R0_REO2FW_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO2FW_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO2FW_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2FW_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO2FW_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2FW_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO2FW_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2FW_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO2FW_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO2FW_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                              0x100
#define HWIO_REO_R0_REO2FW_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                                  8
#define HWIO_REO_R0_REO2FW_RING_MSI2_BASE_MSB_ADDR_BMSK                                                                      0xff
#define HWIO_REO_R0_REO2FW_RING_MSI2_BASE_MSB_ADDR_SHFT                                                                         0

#define HWIO_REO_R0_REO2FW_RING_MSI2_DATA_ADDR(x)                                                                      ((x) + 0xa10)
#define HWIO_REO_R0_REO2FW_RING_MSI2_DATA_PHYS(x)                                                                      ((x) + 0xa10)
#define HWIO_REO_R0_REO2FW_RING_MSI2_DATA_OFFS                                                                         (0xa10)
#define HWIO_REO_R0_REO2FW_RING_MSI2_DATA_RMSK                                                                         0xffffffff
#define HWIO_REO_R0_REO2FW_RING_MSI2_DATA_POR                                                                          0x00000000
#define HWIO_REO_R0_REO2FW_RING_MSI2_DATA_POR_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_REO2FW_RING_MSI2_DATA_ATTR                                                                                      0x3
#define HWIO_REO_R0_REO2FW_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO2FW_RING_MSI2_DATA_ADDR(x))
#define HWIO_REO_R0_REO2FW_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2FW_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO2FW_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2FW_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO2FW_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2FW_RING_MSI2_DATA_ADDR(x),m,v,HWIO_REO_R0_REO2FW_RING_MSI2_DATA_IN(x))
#define HWIO_REO_R0_REO2FW_RING_MSI2_DATA_VALUE_BMSK                                                                   0xffffffff
#define HWIO_REO_R0_REO2FW_RING_MSI2_DATA_VALUE_SHFT                                                                            0

#define HWIO_REO_R0_REO2FW_RING_HP_TP_SW_OFFSET_ADDR(x)                                                                ((x) + 0xa20)
#define HWIO_REO_R0_REO2FW_RING_HP_TP_SW_OFFSET_PHYS(x)                                                                ((x) + 0xa20)
#define HWIO_REO_R0_REO2FW_RING_HP_TP_SW_OFFSET_OFFS                                                                   (0xa20)
#define HWIO_REO_R0_REO2FW_RING_HP_TP_SW_OFFSET_RMSK                                                                       0xffff
#define HWIO_REO_R0_REO2FW_RING_HP_TP_SW_OFFSET_POR                                                                    0x00000000
#define HWIO_REO_R0_REO2FW_RING_HP_TP_SW_OFFSET_POR_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO2FW_RING_HP_TP_SW_OFFSET_ATTR                                                                                0x3
#define HWIO_REO_R0_REO2FW_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_REO2FW_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_REO2FW_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2FW_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_REO2FW_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2FW_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_REO2FW_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2FW_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_REO2FW_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_REO2FW_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                                    0xffff
#define HWIO_REO_R0_REO2FW_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                                         0

#define HWIO_REO_R0_REO2FW_RING_MISC_1_ADDR(x)                                                                         ((x) + 0xa24)
#define HWIO_REO_R0_REO2FW_RING_MISC_1_PHYS(x)                                                                         ((x) + 0xa24)
#define HWIO_REO_R0_REO2FW_RING_MISC_1_OFFS                                                                            (0xa24)
#define HWIO_REO_R0_REO2FW_RING_MISC_1_RMSK                                                                            0xffff003f
#define HWIO_REO_R0_REO2FW_RING_MISC_1_POR                                                                             0x00000000
#define HWIO_REO_R0_REO2FW_RING_MISC_1_POR_RMSK                                                                        0xffffffff
#define HWIO_REO_R0_REO2FW_RING_MISC_1_ATTR                                                                                         0x3
#define HWIO_REO_R0_REO2FW_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_REO2FW_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_REO2FW_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO2FW_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_REO2FW_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO2FW_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_REO2FW_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO2FW_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_REO2FW_RING_MISC_1_IN(x))
#define HWIO_REO_R0_REO2FW_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                                   0xffff0000
#define HWIO_REO_R0_REO2FW_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                           16
#define HWIO_REO_R0_REO2FW_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                                          0x3f
#define HWIO_REO_R0_REO2FW_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                             0

#define HWIO_REO_R0_REO_RELEASE_RING_BASE_LSB_ADDR(x)                                                                  ((x) + 0xa28)
#define HWIO_REO_R0_REO_RELEASE_RING_BASE_LSB_PHYS(x)                                                                  ((x) + 0xa28)
#define HWIO_REO_R0_REO_RELEASE_RING_BASE_LSB_OFFS                                                                     (0xa28)
#define HWIO_REO_R0_REO_RELEASE_RING_BASE_LSB_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_REO_RELEASE_RING_BASE_LSB_POR                                                                      0x00000000
#define HWIO_REO_R0_REO_RELEASE_RING_BASE_LSB_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO_RELEASE_RING_BASE_LSB_ATTR                                                                                  0x3
#define HWIO_REO_R0_REO_RELEASE_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_RELEASE_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO_RELEASE_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_RELEASE_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO_RELEASE_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_RELEASE_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO_RELEASE_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_RELEASE_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO_RELEASE_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                                  0xffffffff
#define HWIO_REO_R0_REO_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                           0

#define HWIO_REO_R0_REO_RELEASE_RING_BASE_MSB_ADDR(x)                                                                  ((x) + 0xa2c)
#define HWIO_REO_R0_REO_RELEASE_RING_BASE_MSB_PHYS(x)                                                                  ((x) + 0xa2c)
#define HWIO_REO_R0_REO_RELEASE_RING_BASE_MSB_OFFS                                                                     (0xa2c)
#define HWIO_REO_R0_REO_RELEASE_RING_BASE_MSB_RMSK                                                                       0xffffff
#define HWIO_REO_R0_REO_RELEASE_RING_BASE_MSB_POR                                                                      0x00000000
#define HWIO_REO_R0_REO_RELEASE_RING_BASE_MSB_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO_RELEASE_RING_BASE_MSB_ATTR                                                                                  0x3
#define HWIO_REO_R0_REO_RELEASE_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_RELEASE_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO_RELEASE_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_RELEASE_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO_RELEASE_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_RELEASE_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO_RELEASE_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_RELEASE_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO_RELEASE_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO_RELEASE_RING_BASE_MSB_RING_SIZE_BMSK                                                             0xffff00
#define HWIO_REO_R0_REO_RELEASE_RING_BASE_MSB_RING_SIZE_SHFT                                                                    8
#define HWIO_REO_R0_REO_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                        0xff
#define HWIO_REO_R0_REO_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                           0

#define HWIO_REO_R0_REO_RELEASE_RING_ID_ADDR(x)                                                                        ((x) + 0xa30)
#define HWIO_REO_R0_REO_RELEASE_RING_ID_PHYS(x)                                                                        ((x) + 0xa30)
#define HWIO_REO_R0_REO_RELEASE_RING_ID_OFFS                                                                           (0xa30)
#define HWIO_REO_R0_REO_RELEASE_RING_ID_RMSK                                                                               0xffff
#define HWIO_REO_R0_REO_RELEASE_RING_ID_POR                                                                            0x00000000
#define HWIO_REO_R0_REO_RELEASE_RING_ID_POR_RMSK                                                                       0xffffffff
#define HWIO_REO_R0_REO_RELEASE_RING_ID_ATTR                                                                                        0x3
#define HWIO_REO_R0_REO_RELEASE_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_REO_RELEASE_RING_ID_ADDR(x))
#define HWIO_REO_R0_REO_RELEASE_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_RELEASE_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_REO_RELEASE_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_RELEASE_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_REO_RELEASE_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_RELEASE_RING_ID_ADDR(x),m,v,HWIO_REO_R0_REO_RELEASE_RING_ID_IN(x))
#define HWIO_REO_R0_REO_RELEASE_RING_ID_RING_ID_BMSK                                                                       0xff00
#define HWIO_REO_R0_REO_RELEASE_RING_ID_RING_ID_SHFT                                                                            8
#define HWIO_REO_R0_REO_RELEASE_RING_ID_ENTRY_SIZE_BMSK                                                                      0xff
#define HWIO_REO_R0_REO_RELEASE_RING_ID_ENTRY_SIZE_SHFT                                                                         0

#define HWIO_REO_R0_REO_RELEASE_RING_STATUS_ADDR(x)                                                                    ((x) + 0xa34)
#define HWIO_REO_R0_REO_RELEASE_RING_STATUS_PHYS(x)                                                                    ((x) + 0xa34)
#define HWIO_REO_R0_REO_RELEASE_RING_STATUS_OFFS                                                                       (0xa34)
#define HWIO_REO_R0_REO_RELEASE_RING_STATUS_RMSK                                                                       0xffffffff
#define HWIO_REO_R0_REO_RELEASE_RING_STATUS_POR                                                                        0x00000000
#define HWIO_REO_R0_REO_RELEASE_RING_STATUS_POR_RMSK                                                                   0xffffffff
#define HWIO_REO_R0_REO_RELEASE_RING_STATUS_ATTR                                                                                    0x1
#define HWIO_REO_R0_REO_RELEASE_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO_RELEASE_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_REO_RELEASE_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_RELEASE_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                       0xffff0000
#define HWIO_REO_R0_REO_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                               16
#define HWIO_REO_R0_REO_RELEASE_RING_STATUS_NUM_VALID_WORDS_BMSK                                                           0xffff
#define HWIO_REO_R0_REO_RELEASE_RING_STATUS_NUM_VALID_WORDS_SHFT                                                                0

#define HWIO_REO_R0_REO_RELEASE_RING_MISC_ADDR(x)                                                                      ((x) + 0xa38)
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_PHYS(x)                                                                      ((x) + 0xa38)
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_OFFS                                                                         (0xa38)
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_RMSK                                                                          0x7ffffff
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_POR                                                                          0x00000080
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_POR_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_ATTR                                                                                      0x3
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_REO_RELEASE_RING_MISC_ADDR(x))
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_RELEASE_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_RELEASE_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_RELEASE_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_REO_RELEASE_RING_MISC_IN(x))
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                                  0x4000000
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                         26
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_LOOP_CNT_BMSK                                                                 0x3c00000
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_LOOP_CNT_SHFT                                                                        22
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_SPARE_CONTROL_BMSK                                                             0x3fc000
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_SPARE_CONTROL_SHFT                                                                   14
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_SRNG_SM_STATE2_BMSK                                                              0x3000
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_SRNG_SM_STATE2_SHFT                                                                  12
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_SRNG_SM_STATE1_BMSK                                                               0xf00
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_SRNG_SM_STATE1_SHFT                                                                   8
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_SRNG_IS_IDLE_BMSK                                                                  0x80
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_SRNG_IS_IDLE_SHFT                                                                     7
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_SRNG_ENABLE_BMSK                                                                   0x40
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_SRNG_ENABLE_SHFT                                                                      6
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                             0x20
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                                5
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                              0x10
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                                 4
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_MSI_SWAP_BIT_BMSK                                                                   0x8
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_MSI_SWAP_BIT_SHFT                                                                     3
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_SECURITY_BIT_BMSK                                                                   0x4
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_SECURITY_BIT_SHFT                                                                     2
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_LOOPCNT_DISABLE_BMSK                                                                0x2
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_LOOPCNT_DISABLE_SHFT                                                                  1
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_RING_ID_DISABLE_BMSK                                                                0x1
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_RING_ID_DISABLE_SHFT                                                                  0

#define HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_LSB_ADDR(x)                                                               ((x) + 0xa3c)
#define HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_LSB_PHYS(x)                                                               ((x) + 0xa3c)
#define HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_LSB_OFFS                                                                  (0xa3c)
#define HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_LSB_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_LSB_POR                                                                   0x00000000
#define HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_LSB_POR_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_LSB_ATTR                                                                               0x3
#define HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                             0xffffffff
#define HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                                      0

#define HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_MSB_ADDR(x)                                                               ((x) + 0xa40)
#define HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_MSB_PHYS(x)                                                               ((x) + 0xa40)
#define HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_MSB_OFFS                                                                  (0xa40)
#define HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_MSB_RMSK                                                                        0xff
#define HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_MSB_POR                                                                   0x00000000
#define HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_MSB_POR_RMSK                                                              0xffffffff
#define HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_MSB_ATTR                                                                               0x3
#define HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                                   0xff
#define HWIO_REO_R0_REO_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                                      0

#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x)                                                        ((x) + 0xa4c)
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_SETUP_PHYS(x)                                                        ((x) + 0xa4c)
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_SETUP_OFFS                                                           (0xa4c)
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_SETUP_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_SETUP_POR                                                            0x00000000
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_SETUP_POR_RMSK                                                       0xffffffff
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_SETUP_ATTR                                                                        0x3
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                                 0xffff0000
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                         16
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                             0x8000
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                                 15
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                                       0x7fff
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                            0

#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x)                                                       ((x) + 0xa50)
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_STATUS_PHYS(x)                                                       ((x) + 0xa50)
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_STATUS_OFFS                                                          (0xa50)
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_STATUS_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_STATUS_POR                                                           0x00000000
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_STATUS_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_STATUS_ATTR                                                                       0x1
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                            0xffff0000
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                                    16
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                                    0x8000
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                        15
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                                 0x7fff
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                      0

#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                                     ((x) + 0xa54)
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                                     ((x) + 0xa54)
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_FULL_COUNTER_OFFS                                                        (0xa54)
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_FULL_COUNTER_RMSK                                                             0x3ff
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_FULL_COUNTER_POR                                                         0x00000000
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                                    0xffffffff
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_FULL_COUNTER_ATTR                                                                     0x3
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                           0x3ff
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                               0

#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x)                                                       ((x) + 0xa7c)
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT2_SETUP_PHYS(x)                                                       ((x) + 0xa7c)
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT2_SETUP_OFFS                                                          (0xa7c)
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT2_SETUP_RMSK                                                          0xffc0ffff
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT2_SETUP_POR                                                           0x00000000
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT2_SETUP_POR_RMSK                                                      0xffffffff
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT2_SETUP_ATTR                                                                       0x3
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                               0xff000000
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                                       24
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                                0x800000
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                                      23
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                              0x400000
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                                    22
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                               0xffff
#define HWIO_REO_R0_REO_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                                    0

#define HWIO_REO_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x)                                                           ((x) + 0xa98)
#define HWIO_REO_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_PHYS(x)                                                           ((x) + 0xa98)
#define HWIO_REO_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_OFFS                                                              (0xa98)
#define HWIO_REO_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_RMSK                                                                  0xffff
#define HWIO_REO_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_POR                                                               0x00000000
#define HWIO_REO_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_ATTR                                                                           0x3
#define HWIO_REO_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                               0xffff
#define HWIO_REO_R0_REO_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                                    0

#define HWIO_REO_R0_REO_RELEASE_RING_MISC_1_ADDR(x)                                                                    ((x) + 0xa9c)
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_1_PHYS(x)                                                                    ((x) + 0xa9c)
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_1_OFFS                                                                       (0xa9c)
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_1_RMSK                                                                       0xffff003f
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_1_POR                                                                        0x00000000
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_1_POR_RMSK                                                                   0xffffffff
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_1_ATTR                                                                                    0x3
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_REO_RELEASE_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_RELEASE_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_RELEASE_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_RELEASE_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_REO_RELEASE_RING_MISC_1_IN(x))
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                              0xffff0000
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                      16
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                                     0x3f
#define HWIO_REO_R0_REO_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                        0

#define HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_ADDR(x)                                                                   ((x) + 0xaa0)
#define HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_PHYS(x)                                                                   ((x) + 0xaa0)
#define HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_OFFS                                                                      (0xaa0)
#define HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_POR                                                                       0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_ATTR                                                                                   0x3
#define HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                                   0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                            0

#define HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_ADDR(x)                                                                   ((x) + 0xaa4)
#define HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_PHYS(x)                                                                   ((x) + 0xaa4)
#define HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_OFFS                                                                      (0xaa4)
#define HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_RMSK                                                                        0xffffff
#define HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_POR                                                                       0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_POR_RMSK                                                                  0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_ATTR                                                                                   0x3
#define HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_RING_SIZE_BMSK                                                              0xffff00
#define HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_RING_SIZE_SHFT                                                                     8
#define HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                         0xff
#define HWIO_REO_R0_REO_STATUS_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                            0

#define HWIO_REO_R0_REO_STATUS_RING_ID_ADDR(x)                                                                         ((x) + 0xaa8)
#define HWIO_REO_R0_REO_STATUS_RING_ID_PHYS(x)                                                                         ((x) + 0xaa8)
#define HWIO_REO_R0_REO_STATUS_RING_ID_OFFS                                                                            (0xaa8)
#define HWIO_REO_R0_REO_STATUS_RING_ID_RMSK                                                                                0xffff
#define HWIO_REO_R0_REO_STATUS_RING_ID_POR                                                                             0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_ID_POR_RMSK                                                                        0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_ID_ATTR                                                                                         0x3
#define HWIO_REO_R0_REO_STATUS_RING_ID_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_ID_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_ID_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_ID_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_ID_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_ID_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_ID_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_ID_RING_ID_BMSK                                                                        0xff00
#define HWIO_REO_R0_REO_STATUS_RING_ID_RING_ID_SHFT                                                                             8
#define HWIO_REO_R0_REO_STATUS_RING_ID_ENTRY_SIZE_BMSK                                                                       0xff
#define HWIO_REO_R0_REO_STATUS_RING_ID_ENTRY_SIZE_SHFT                                                                          0

#define HWIO_REO_R0_REO_STATUS_RING_STATUS_ADDR(x)                                                                     ((x) + 0xaac)
#define HWIO_REO_R0_REO_STATUS_RING_STATUS_PHYS(x)                                                                     ((x) + 0xaac)
#define HWIO_REO_R0_REO_STATUS_RING_STATUS_OFFS                                                                        (0xaac)
#define HWIO_REO_R0_REO_STATUS_RING_STATUS_RMSK                                                                        0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_STATUS_POR                                                                         0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_STATUS_POR_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_STATUS_ATTR                                                                                     0x1
#define HWIO_REO_R0_REO_STATUS_RING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_STATUS_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                        0xffff0000
#define HWIO_REO_R0_REO_STATUS_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                                16
#define HWIO_REO_R0_REO_STATUS_RING_STATUS_NUM_VALID_WORDS_BMSK                                                            0xffff
#define HWIO_REO_R0_REO_STATUS_RING_STATUS_NUM_VALID_WORDS_SHFT                                                                 0

#define HWIO_REO_R0_REO_STATUS_RING_MISC_ADDR(x)                                                                       ((x) + 0xab0)
#define HWIO_REO_R0_REO_STATUS_RING_MISC_PHYS(x)                                                                       ((x) + 0xab0)
#define HWIO_REO_R0_REO_STATUS_RING_MISC_OFFS                                                                          (0xab0)
#define HWIO_REO_R0_REO_STATUS_RING_MISC_RMSK                                                                           0x7ffffff
#define HWIO_REO_R0_REO_STATUS_RING_MISC_POR                                                                           0x00000080
#define HWIO_REO_R0_REO_STATUS_RING_MISC_POR_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MISC_ATTR                                                                                       0x3
#define HWIO_REO_R0_REO_STATUS_RING_MISC_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_MISC_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_MISC_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_MISC_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_MISC_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_MISC_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                                   0x4000000
#define HWIO_REO_R0_REO_STATUS_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                          26
#define HWIO_REO_R0_REO_STATUS_RING_MISC_LOOP_CNT_BMSK                                                                  0x3c00000
#define HWIO_REO_R0_REO_STATUS_RING_MISC_LOOP_CNT_SHFT                                                                         22
#define HWIO_REO_R0_REO_STATUS_RING_MISC_SPARE_CONTROL_BMSK                                                              0x3fc000
#define HWIO_REO_R0_REO_STATUS_RING_MISC_SPARE_CONTROL_SHFT                                                                    14
#define HWIO_REO_R0_REO_STATUS_RING_MISC_SRNG_SM_STATE2_BMSK                                                               0x3000
#define HWIO_REO_R0_REO_STATUS_RING_MISC_SRNG_SM_STATE2_SHFT                                                                   12
#define HWIO_REO_R0_REO_STATUS_RING_MISC_SRNG_SM_STATE1_BMSK                                                                0xf00
#define HWIO_REO_R0_REO_STATUS_RING_MISC_SRNG_SM_STATE1_SHFT                                                                    8
#define HWIO_REO_R0_REO_STATUS_RING_MISC_SRNG_IS_IDLE_BMSK                                                                   0x80
#define HWIO_REO_R0_REO_STATUS_RING_MISC_SRNG_IS_IDLE_SHFT                                                                      7
#define HWIO_REO_R0_REO_STATUS_RING_MISC_SRNG_ENABLE_BMSK                                                                    0x40
#define HWIO_REO_R0_REO_STATUS_RING_MISC_SRNG_ENABLE_SHFT                                                                       6
#define HWIO_REO_R0_REO_STATUS_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                              0x20
#define HWIO_REO_R0_REO_STATUS_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                                 5
#define HWIO_REO_R0_REO_STATUS_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                               0x10
#define HWIO_REO_R0_REO_STATUS_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                                  4
#define HWIO_REO_R0_REO_STATUS_RING_MISC_MSI_SWAP_BIT_BMSK                                                                    0x8
#define HWIO_REO_R0_REO_STATUS_RING_MISC_MSI_SWAP_BIT_SHFT                                                                      3
#define HWIO_REO_R0_REO_STATUS_RING_MISC_SECURITY_BIT_BMSK                                                                    0x4
#define HWIO_REO_R0_REO_STATUS_RING_MISC_SECURITY_BIT_SHFT                                                                      2
#define HWIO_REO_R0_REO_STATUS_RING_MISC_LOOPCNT_DISABLE_BMSK                                                                 0x2
#define HWIO_REO_R0_REO_STATUS_RING_MISC_LOOPCNT_DISABLE_SHFT                                                                   1
#define HWIO_REO_R0_REO_STATUS_RING_MISC_RING_ID_DISABLE_BMSK                                                                 0x1
#define HWIO_REO_R0_REO_STATUS_RING_MISC_RING_ID_DISABLE_SHFT                                                                   0

#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_ADDR(x)                                                                ((x) + 0xab4)
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_PHYS(x)                                                                ((x) + 0xab4)
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_OFFS                                                                   (0xab4)
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_RMSK                                                                   0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_POR                                                                    0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_POR_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_ATTR                                                                                0x3
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                              0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                                       0

#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_ADDR(x)                                                                ((x) + 0xab8)
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_PHYS(x)                                                                ((x) + 0xab8)
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_OFFS                                                                   (0xab8)
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_RMSK                                                                         0xff
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_POR                                                                    0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_POR_RMSK                                                               0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_ATTR                                                                                0x3
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                                    0xff
#define HWIO_REO_R0_REO_STATUS_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                                       0

#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_ADDR(x)                                                         ((x) + 0xac4)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_PHYS(x)                                                         ((x) + 0xac4)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_OFFS                                                            (0xac4)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_RMSK                                                            0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_POR                                                             0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_ATTR                                                                         0x3
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                                  0xffff0000
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                          16
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                              0x8000
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                                  15
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                                        0x7fff
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                             0

#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_ADDR(x)                                                        ((x) + 0xac8)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_PHYS(x)                                                        ((x) + 0xac8)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_OFFS                                                           (0xac8)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_POR                                                            0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_POR_RMSK                                                       0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_ATTR                                                                        0x1
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                             0xffff0000
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                                     16
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                                     0x8000
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                         15
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                                  0x7fff
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                       0

#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                                      ((x) + 0xacc)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                                      ((x) + 0xacc)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_OFFS                                                         (0xacc)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_RMSK                                                              0x3ff
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_POR                                                          0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                                     0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_ATTR                                                                      0x3
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                            0x3ff
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                                0

#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_ADDR(x)                                                              ((x) + 0xae8)
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_PHYS(x)                                                              ((x) + 0xae8)
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_OFFS                                                                 (0xae8)
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_POR                                                                  0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_ATTR                                                                              0x3
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_ADDR_BMSK                                                            0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_LSB_ADDR_SHFT                                                                     0

#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_ADDR(x)                                                              ((x) + 0xaec)
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_PHYS(x)                                                              ((x) + 0xaec)
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_OFFS                                                                 (0xaec)
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_RMSK                                                                      0x1ff
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_POR                                                                  0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_ATTR                                                                              0x3
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                          0x100
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                              8
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_ADDR_BMSK                                                                  0xff
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_BASE_MSB_ADDR_SHFT                                                                     0

#define HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_ADDR(x)                                                                  ((x) + 0xaf0)
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_PHYS(x)                                                                  ((x) + 0xaf0)
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_OFFS                                                                     (0xaf0)
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_POR                                                                      0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_ATTR                                                                                  0x3
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_VALUE_BMSK                                                               0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MSI1_DATA_VALUE_SHFT                                                                        0

#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_ADDR(x)                                                        ((x) + 0xaf4)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_PHYS(x)                                                        ((x) + 0xaf4)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_OFFS                                                           (0xaf4)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_RMSK                                                           0xffc0ffff
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_POR                                                            0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_POR_RMSK                                                       0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_ATTR                                                                        0x3
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                                0xff000000
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                                        24
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                                 0x800000
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                                       23
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                               0x400000
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                                     22
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                                0xffff
#define HWIO_REO_R0_REO_STATUS_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                                     0

#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_ADDR(x)                                                              ((x) + 0xaf8)
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_PHYS(x)                                                              ((x) + 0xaf8)
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_OFFS                                                                 (0xaf8)
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_POR                                                                  0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_ATTR                                                                              0x3
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_ADDR_BMSK                                                            0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_LSB_ADDR_SHFT                                                                     0

#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_ADDR(x)                                                              ((x) + 0xafc)
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_PHYS(x)                                                              ((x) + 0xafc)
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_OFFS                                                                 (0xafc)
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_RMSK                                                                      0x1ff
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_POR                                                                  0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_ATTR                                                                              0x3
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                          0x100
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                              8
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_ADDR_BMSK                                                                  0xff
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_BASE_MSB_ADDR_SHFT                                                                     0

#define HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_ADDR(x)                                                                  ((x) + 0xb00)
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_PHYS(x)                                                                  ((x) + 0xb00)
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_OFFS                                                                     (0xb00)
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_POR                                                                      0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_ATTR                                                                                  0x3
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_VALUE_BMSK                                                               0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MSI2_DATA_VALUE_SHFT                                                                        0

#define HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_ADDR(x)                                                            ((x) + 0xb10)
#define HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_PHYS(x)                                                            ((x) + 0xb10)
#define HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_OFFS                                                               (0xb10)
#define HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_RMSK                                                                   0xffff
#define HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_POR                                                                0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_ATTR                                                                            0x3
#define HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                                0xffff
#define HWIO_REO_R0_REO_STATUS_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                                     0

#define HWIO_REO_R0_REO_STATUS_RING_MISC_1_ADDR(x)                                                                     ((x) + 0xb14)
#define HWIO_REO_R0_REO_STATUS_RING_MISC_1_PHYS(x)                                                                     ((x) + 0xb14)
#define HWIO_REO_R0_REO_STATUS_RING_MISC_1_OFFS                                                                        (0xb14)
#define HWIO_REO_R0_REO_STATUS_RING_MISC_1_RMSK                                                                        0xffff003f
#define HWIO_REO_R0_REO_STATUS_RING_MISC_1_POR                                                                         0x00000000
#define HWIO_REO_R0_REO_STATUS_RING_MISC_1_POR_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_REO_STATUS_RING_MISC_1_ATTR                                                                                     0x3
#define HWIO_REO_R0_REO_STATUS_RING_MISC_1_IN(x)            \
                in_dword(HWIO_REO_R0_REO_STATUS_RING_MISC_1_ADDR(x))
#define HWIO_REO_R0_REO_STATUS_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_REO_STATUS_RING_MISC_1_ADDR(x), m)
#define HWIO_REO_R0_REO_STATUS_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_REO_STATUS_RING_MISC_1_ADDR(x),v)
#define HWIO_REO_R0_REO_STATUS_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_REO_STATUS_RING_MISC_1_ADDR(x),m,v,HWIO_REO_R0_REO_STATUS_RING_MISC_1_IN(x))
#define HWIO_REO_R0_REO_STATUS_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                               0xffff0000
#define HWIO_REO_R0_REO_STATUS_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                       16
#define HWIO_REO_R0_REO_STATUS_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                                      0x3f
#define HWIO_REO_R0_REO_STATUS_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                         0

#define HWIO_REO_R0_WATCHDOG_TIMEOUT_ADDR(x)                                                                           ((x) + 0xb18)
#define HWIO_REO_R0_WATCHDOG_TIMEOUT_PHYS(x)                                                                           ((x) + 0xb18)
#define HWIO_REO_R0_WATCHDOG_TIMEOUT_OFFS                                                                              (0xb18)
#define HWIO_REO_R0_WATCHDOG_TIMEOUT_RMSK                                                                              0xffff3fff
#define HWIO_REO_R0_WATCHDOG_TIMEOUT_POR                                                                               0x03e80fa0
#define HWIO_REO_R0_WATCHDOG_TIMEOUT_POR_RMSK                                                                          0xffffffff
#define HWIO_REO_R0_WATCHDOG_TIMEOUT_ATTR                                                                                           0x3
#define HWIO_REO_R0_WATCHDOG_TIMEOUT_IN(x)            \
                in_dword(HWIO_REO_R0_WATCHDOG_TIMEOUT_ADDR(x))
#define HWIO_REO_R0_WATCHDOG_TIMEOUT_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_WATCHDOG_TIMEOUT_ADDR(x), m)
#define HWIO_REO_R0_WATCHDOG_TIMEOUT_OUT(x, v)            \
                out_dword(HWIO_REO_R0_WATCHDOG_TIMEOUT_ADDR(x),v)
#define HWIO_REO_R0_WATCHDOG_TIMEOUT_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_WATCHDOG_TIMEOUT_ADDR(x),m,v,HWIO_REO_R0_WATCHDOG_TIMEOUT_IN(x))
#define HWIO_REO_R0_WATCHDOG_TIMEOUT_WARNING_TIMEOUT_BMSK                                                              0xffff0000
#define HWIO_REO_R0_WATCHDOG_TIMEOUT_WARNING_TIMEOUT_SHFT                                                                      16
#define HWIO_REO_R0_WATCHDOG_TIMEOUT_RESOLUTION_UNITS_BMSK                                                                 0x3000
#define HWIO_REO_R0_WATCHDOG_TIMEOUT_RESOLUTION_UNITS_SHFT                                                                     12
#define HWIO_REO_R0_WATCHDOG_TIMEOUT_ERROR_TIMEOUT_BMSK                                                                     0xfff
#define HWIO_REO_R0_WATCHDOG_TIMEOUT_ERROR_TIMEOUT_SHFT                                                                         0

#define HWIO_REO_R0_WATCHDOG_WARNING_STATUS_ADDR(x)                                                                    ((x) + 0xb1c)
#define HWIO_REO_R0_WATCHDOG_WARNING_STATUS_PHYS(x)                                                                    ((x) + 0xb1c)
#define HWIO_REO_R0_WATCHDOG_WARNING_STATUS_OFFS                                                                       (0xb1c)
#define HWIO_REO_R0_WATCHDOG_WARNING_STATUS_RMSK                                                                            0xe7f
#define HWIO_REO_R0_WATCHDOG_WARNING_STATUS_POR                                                                        0x00000000
#define HWIO_REO_R0_WATCHDOG_WARNING_STATUS_POR_RMSK                                                                   0xffffffff
#define HWIO_REO_R0_WATCHDOG_WARNING_STATUS_ATTR                                                                                    0x1
#define HWIO_REO_R0_WATCHDOG_WARNING_STATUS_IN(x)            \
                in_dword(HWIO_REO_R0_WATCHDOG_WARNING_STATUS_ADDR(x))
#define HWIO_REO_R0_WATCHDOG_WARNING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_WATCHDOG_WARNING_STATUS_ADDR(x), m)
#define HWIO_REO_R0_WATCHDOG_WARNING_STATUS_REO_RELEASE_RING_BACK_PRESSURE_BMSK                                             0x800
#define HWIO_REO_R0_WATCHDOG_WARNING_STATUS_REO_RELEASE_RING_BACK_PRESSURE_SHFT                                                11
#define HWIO_REO_R0_WATCHDOG_WARNING_STATUS_REO_STATUS_RING_BACK_PRESSURE_BMSK                                              0x400
#define HWIO_REO_R0_WATCHDOG_WARNING_STATUS_REO_STATUS_RING_BACK_PRESSURE_SHFT                                                 10
#define HWIO_REO_R0_WATCHDOG_WARNING_STATUS_REO2FW_RING_BACK_PRESSURE_BMSK                                                  0x200
#define HWIO_REO_R0_WATCHDOG_WARNING_STATUS_REO2FW_RING_BACK_PRESSURE_SHFT                                                      9
#define HWIO_REO_R0_WATCHDOG_WARNING_STATUS_REO2SW6_RING_BACK_PRESSURE_BMSK                                                  0x40
#define HWIO_REO_R0_WATCHDOG_WARNING_STATUS_REO2SW6_RING_BACK_PRESSURE_SHFT                                                     6
#define HWIO_REO_R0_WATCHDOG_WARNING_STATUS_REO2SW5_RING_BACK_PRESSURE_BMSK                                                  0x20
#define HWIO_REO_R0_WATCHDOG_WARNING_STATUS_REO2SW5_RING_BACK_PRESSURE_SHFT                                                     5
#define HWIO_REO_R0_WATCHDOG_WARNING_STATUS_REO2SW4_RING_BACK_PRESSURE_BMSK                                                  0x10
#define HWIO_REO_R0_WATCHDOG_WARNING_STATUS_REO2SW4_RING_BACK_PRESSURE_SHFT                                                     4
#define HWIO_REO_R0_WATCHDOG_WARNING_STATUS_REO2SW3_RING_BACK_PRESSURE_BMSK                                                   0x8
#define HWIO_REO_R0_WATCHDOG_WARNING_STATUS_REO2SW3_RING_BACK_PRESSURE_SHFT                                                     3
#define HWIO_REO_R0_WATCHDOG_WARNING_STATUS_REO2SW2_RING_BACK_PRESSURE_BMSK                                                   0x4
#define HWIO_REO_R0_WATCHDOG_WARNING_STATUS_REO2SW2_RING_BACK_PRESSURE_SHFT                                                     2
#define HWIO_REO_R0_WATCHDOG_WARNING_STATUS_REO2SW1_RING_BACK_PRESSURE_BMSK                                                   0x2
#define HWIO_REO_R0_WATCHDOG_WARNING_STATUS_REO2SW1_RING_BACK_PRESSURE_SHFT                                                     1
#define HWIO_REO_R0_WATCHDOG_WARNING_STATUS_REO2SW0_RING_BACK_PRESSURE_BMSK                                                   0x1
#define HWIO_REO_R0_WATCHDOG_WARNING_STATUS_REO2SW0_RING_BACK_PRESSURE_SHFT                                                     0

#define HWIO_REO_R0_INTERRUPT_DATA_CAPTURE_IX_0_ADDR(x)                                                                ((x) + 0xb20)
#define HWIO_REO_R0_INTERRUPT_DATA_CAPTURE_IX_0_PHYS(x)                                                                ((x) + 0xb20)
#define HWIO_REO_R0_INTERRUPT_DATA_CAPTURE_IX_0_OFFS                                                                   (0xb20)
#define HWIO_REO_R0_INTERRUPT_DATA_CAPTURE_IX_0_RMSK                                                                   0xffffffff
#define HWIO_REO_R0_INTERRUPT_DATA_CAPTURE_IX_0_POR                                                                    0x00000000
#define HWIO_REO_R0_INTERRUPT_DATA_CAPTURE_IX_0_POR_RMSK                                                               0xffffffff
#define HWIO_REO_R0_INTERRUPT_DATA_CAPTURE_IX_0_ATTR                                                                                0x1
#define HWIO_REO_R0_INTERRUPT_DATA_CAPTURE_IX_0_IN(x)            \
                in_dword(HWIO_REO_R0_INTERRUPT_DATA_CAPTURE_IX_0_ADDR(x))
#define HWIO_REO_R0_INTERRUPT_DATA_CAPTURE_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_INTERRUPT_DATA_CAPTURE_IX_0_ADDR(x), m)
#define HWIO_REO_R0_INTERRUPT_DATA_CAPTURE_IX_0_ERROR_DATA_BMSK                                                        0xffffffff
#define HWIO_REO_R0_INTERRUPT_DATA_CAPTURE_IX_0_ERROR_DATA_SHFT                                                                 0

#define HWIO_REO_R0_MSDU_BUF_COUNT_CFG_ADDR(x)                                                                         ((x) + 0xb24)
#define HWIO_REO_R0_MSDU_BUF_COUNT_CFG_PHYS(x)                                                                         ((x) + 0xb24)
#define HWIO_REO_R0_MSDU_BUF_COUNT_CFG_OFFS                                                                            (0xb24)
#define HWIO_REO_R0_MSDU_BUF_COUNT_CFG_RMSK                                                                                 0x1ff
#define HWIO_REO_R0_MSDU_BUF_COUNT_CFG_POR                                                                             0x0000002d
#define HWIO_REO_R0_MSDU_BUF_COUNT_CFG_POR_RMSK                                                                        0xffffffff
#define HWIO_REO_R0_MSDU_BUF_COUNT_CFG_ATTR                                                                                         0x3
#define HWIO_REO_R0_MSDU_BUF_COUNT_CFG_IN(x)            \
                in_dword(HWIO_REO_R0_MSDU_BUF_COUNT_CFG_ADDR(x))
#define HWIO_REO_R0_MSDU_BUF_COUNT_CFG_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_MSDU_BUF_COUNT_CFG_ADDR(x), m)
#define HWIO_REO_R0_MSDU_BUF_COUNT_CFG_OUT(x, v)            \
                out_dword(HWIO_REO_R0_MSDU_BUF_COUNT_CFG_ADDR(x),v)
#define HWIO_REO_R0_MSDU_BUF_COUNT_CFG_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_MSDU_BUF_COUNT_CFG_ADDR(x),m,v,HWIO_REO_R0_MSDU_BUF_COUNT_CFG_IN(x))
#define HWIO_REO_R0_MSDU_BUF_COUNT_CFG_THRESHOLD_BUF_COUNT_BMSK                                                             0x1fe
#define HWIO_REO_R0_MSDU_BUF_COUNT_CFG_THRESHOLD_BUF_COUNT_SHFT                                                                 1
#define HWIO_REO_R0_MSDU_BUF_COUNT_CFG_DROP_EN_BMSK                                                                           0x1
#define HWIO_REO_R0_MSDU_BUF_COUNT_CFG_DROP_EN_SHFT                                                                             0

#define HWIO_REO_R0_AGING_THRESHOLD_IX_0_ADDR(x)                                                                       ((x) + 0xb28)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_0_PHYS(x)                                                                       ((x) + 0xb28)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_0_OFFS                                                                          (0xb28)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_0_RMSK                                                                          0xffffffff
#define HWIO_REO_R0_AGING_THRESHOLD_IX_0_POR                                                                           0x000186a0
#define HWIO_REO_R0_AGING_THRESHOLD_IX_0_POR_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_AGING_THRESHOLD_IX_0_ATTR                                                                                       0x3
#define HWIO_REO_R0_AGING_THRESHOLD_IX_0_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_THRESHOLD_IX_0_ADDR(x))
#define HWIO_REO_R0_AGING_THRESHOLD_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_THRESHOLD_IX_0_ADDR(x), m)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_0_OUT(x, v)            \
                out_dword(HWIO_REO_R0_AGING_THRESHOLD_IX_0_ADDR(x),v)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_AGING_THRESHOLD_IX_0_ADDR(x),m,v,HWIO_REO_R0_AGING_THRESHOLD_IX_0_IN(x))
#define HWIO_REO_R0_AGING_THRESHOLD_IX_0_AGING_THRESHOLD_AC0_BMSK                                                      0xffffffff
#define HWIO_REO_R0_AGING_THRESHOLD_IX_0_AGING_THRESHOLD_AC0_SHFT                                                               0

#define HWIO_REO_R0_AGING_THRESHOLD_IX_1_ADDR(x)                                                                       ((x) + 0xb2c)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_1_PHYS(x)                                                                       ((x) + 0xb2c)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_1_OFFS                                                                          (0xb2c)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_1_RMSK                                                                          0xffffffff
#define HWIO_REO_R0_AGING_THRESHOLD_IX_1_POR                                                                           0x000186a0
#define HWIO_REO_R0_AGING_THRESHOLD_IX_1_POR_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_AGING_THRESHOLD_IX_1_ATTR                                                                                       0x3
#define HWIO_REO_R0_AGING_THRESHOLD_IX_1_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_THRESHOLD_IX_1_ADDR(x))
#define HWIO_REO_R0_AGING_THRESHOLD_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_THRESHOLD_IX_1_ADDR(x), m)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_AGING_THRESHOLD_IX_1_ADDR(x),v)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_AGING_THRESHOLD_IX_1_ADDR(x),m,v,HWIO_REO_R0_AGING_THRESHOLD_IX_1_IN(x))
#define HWIO_REO_R0_AGING_THRESHOLD_IX_1_AGING_THRESHOLD_AC1_BMSK                                                      0xffffffff
#define HWIO_REO_R0_AGING_THRESHOLD_IX_1_AGING_THRESHOLD_AC1_SHFT                                                               0

#define HWIO_REO_R0_AGING_THRESHOLD_IX_2_ADDR(x)                                                                       ((x) + 0xb30)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_2_PHYS(x)                                                                       ((x) + 0xb30)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_2_OFFS                                                                          (0xb30)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_2_RMSK                                                                          0xffffffff
#define HWIO_REO_R0_AGING_THRESHOLD_IX_2_POR                                                                           0x00009c40
#define HWIO_REO_R0_AGING_THRESHOLD_IX_2_POR_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_AGING_THRESHOLD_IX_2_ATTR                                                                                       0x3
#define HWIO_REO_R0_AGING_THRESHOLD_IX_2_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_THRESHOLD_IX_2_ADDR(x))
#define HWIO_REO_R0_AGING_THRESHOLD_IX_2_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_THRESHOLD_IX_2_ADDR(x), m)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_2_OUT(x, v)            \
                out_dword(HWIO_REO_R0_AGING_THRESHOLD_IX_2_ADDR(x),v)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_AGING_THRESHOLD_IX_2_ADDR(x),m,v,HWIO_REO_R0_AGING_THRESHOLD_IX_2_IN(x))
#define HWIO_REO_R0_AGING_THRESHOLD_IX_2_AGING_THRESHOLD_AC2_BMSK                                                      0xffffffff
#define HWIO_REO_R0_AGING_THRESHOLD_IX_2_AGING_THRESHOLD_AC2_SHFT                                                               0

#define HWIO_REO_R0_AGING_THRESHOLD_IX_3_ADDR(x)                                                                       ((x) + 0xb34)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_3_PHYS(x)                                                                       ((x) + 0xb34)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_3_OFFS                                                                          (0xb34)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_3_RMSK                                                                          0xffffffff
#define HWIO_REO_R0_AGING_THRESHOLD_IX_3_POR                                                                           0x00009c40
#define HWIO_REO_R0_AGING_THRESHOLD_IX_3_POR_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_AGING_THRESHOLD_IX_3_ATTR                                                                                       0x3
#define HWIO_REO_R0_AGING_THRESHOLD_IX_3_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_THRESHOLD_IX_3_ADDR(x))
#define HWIO_REO_R0_AGING_THRESHOLD_IX_3_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_THRESHOLD_IX_3_ADDR(x), m)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_3_OUT(x, v)            \
                out_dword(HWIO_REO_R0_AGING_THRESHOLD_IX_3_ADDR(x),v)
#define HWIO_REO_R0_AGING_THRESHOLD_IX_3_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_AGING_THRESHOLD_IX_3_ADDR(x),m,v,HWIO_REO_R0_AGING_THRESHOLD_IX_3_IN(x))
#define HWIO_REO_R0_AGING_THRESHOLD_IX_3_AGING_THRESHOLD_AC3_BMSK                                                      0xffffffff
#define HWIO_REO_R0_AGING_THRESHOLD_IX_3_AGING_THRESHOLD_AC3_SHFT                                                               0

#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_0_ADDR(x)                                                                 ((x) + 0xb38)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_0_PHYS(x)                                                                 ((x) + 0xb38)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_0_OFFS                                                                    (0xb38)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_0_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_0_POR                                                                     0x00000000
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_0_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_0_ATTR                                                                                 0x1
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_0_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_0_ADDR(x))
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_0_ADDR(x), m)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_0_AGING_HEADPTR_LO_BITS_BMSK                                              0xffffffff
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_0_AGING_HEADPTR_LO_BITS_SHFT                                                       0

#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_0_ADDR(x)                                                                 ((x) + 0xb3c)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_0_PHYS(x)                                                                 ((x) + 0xb3c)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_0_OFFS                                                                    (0xb3c)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_0_RMSK                                                                          0xff
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_0_POR                                                                     0x00000000
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_0_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_0_ATTR                                                                                 0x1
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_0_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_0_ADDR(x))
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_0_ADDR(x), m)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_0_AGING_HEADPTR_HI_BITS_BMSK                                                    0xff
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_0_AGING_HEADPTR_HI_BITS_SHFT                                                       0

#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_0_ADDR(x)                                                                 ((x) + 0xb40)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_0_PHYS(x)                                                                 ((x) + 0xb40)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_0_OFFS                                                                    (0xb40)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_0_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_0_POR                                                                     0x00000000
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_0_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_0_ATTR                                                                                 0x1
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_0_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_0_ADDR(x))
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_0_ADDR(x), m)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_0_AGING_TAILPTR_LO_BITS_BMSK                                              0xffffffff
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_0_AGING_TAILPTR_LO_BITS_SHFT                                                       0

#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_0_ADDR(x)                                                                 ((x) + 0xb44)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_0_PHYS(x)                                                                 ((x) + 0xb44)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_0_OFFS                                                                    (0xb44)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_0_RMSK                                                                          0xff
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_0_POR                                                                     0x00000000
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_0_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_0_ATTR                                                                                 0x1
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_0_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_0_ADDR(x))
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_0_ADDR(x), m)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_0_AGING_TAILPTR_HI_BITS_BMSK                                                    0xff
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_0_AGING_TAILPTR_HI_BITS_SHFT                                                       0

#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_1_ADDR(x)                                                                 ((x) + 0xb48)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_1_PHYS(x)                                                                 ((x) + 0xb48)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_1_OFFS                                                                    (0xb48)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_1_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_1_POR                                                                     0x00000000
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_1_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_1_ATTR                                                                                 0x1
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_1_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_1_ADDR(x))
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_1_ADDR(x), m)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_1_AGING_HEADPTR_LO_BITS_BMSK                                              0xffffffff
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_1_AGING_HEADPTR_LO_BITS_SHFT                                                       0

#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_1_ADDR(x)                                                                 ((x) + 0xb4c)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_1_PHYS(x)                                                                 ((x) + 0xb4c)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_1_OFFS                                                                    (0xb4c)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_1_RMSK                                                                          0xff
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_1_POR                                                                     0x00000000
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_1_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_1_ATTR                                                                                 0x1
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_1_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_1_ADDR(x))
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_1_ADDR(x), m)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_1_AGING_HEADPTR_HI_BITS_BMSK                                                    0xff
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_1_AGING_HEADPTR_HI_BITS_SHFT                                                       0

#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_1_ADDR(x)                                                                 ((x) + 0xb50)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_1_PHYS(x)                                                                 ((x) + 0xb50)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_1_OFFS                                                                    (0xb50)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_1_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_1_POR                                                                     0x00000000
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_1_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_1_ATTR                                                                                 0x1
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_1_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_1_ADDR(x))
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_1_ADDR(x), m)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_1_AGING_TAILPTR_LO_BITS_BMSK                                              0xffffffff
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_1_AGING_TAILPTR_LO_BITS_SHFT                                                       0

#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_1_ADDR(x)                                                                 ((x) + 0xb54)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_1_PHYS(x)                                                                 ((x) + 0xb54)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_1_OFFS                                                                    (0xb54)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_1_RMSK                                                                          0xff
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_1_POR                                                                     0x00000000
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_1_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_1_ATTR                                                                                 0x1
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_1_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_1_ADDR(x))
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_1_ADDR(x), m)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_1_AGING_TAILPTR_HI_BITS_BMSK                                                    0xff
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_1_AGING_TAILPTR_HI_BITS_SHFT                                                       0

#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_2_ADDR(x)                                                                 ((x) + 0xb58)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_2_PHYS(x)                                                                 ((x) + 0xb58)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_2_OFFS                                                                    (0xb58)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_2_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_2_POR                                                                     0x00000000
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_2_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_2_ATTR                                                                                 0x1
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_2_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_2_ADDR(x))
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_2_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_2_ADDR(x), m)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_2_AGING_HEADPTR_LO_BITS_BMSK                                              0xffffffff
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_2_AGING_HEADPTR_LO_BITS_SHFT                                                       0

#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_2_ADDR(x)                                                                 ((x) + 0xb5c)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_2_PHYS(x)                                                                 ((x) + 0xb5c)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_2_OFFS                                                                    (0xb5c)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_2_RMSK                                                                          0xff
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_2_POR                                                                     0x00000000
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_2_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_2_ATTR                                                                                 0x1
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_2_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_2_ADDR(x))
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_2_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_2_ADDR(x), m)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_2_AGING_HEADPTR_HI_BITS_BMSK                                                    0xff
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_2_AGING_HEADPTR_HI_BITS_SHFT                                                       0

#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_2_ADDR(x)                                                                 ((x) + 0xb60)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_2_PHYS(x)                                                                 ((x) + 0xb60)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_2_OFFS                                                                    (0xb60)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_2_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_2_POR                                                                     0x00000000
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_2_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_2_ATTR                                                                                 0x1
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_2_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_2_ADDR(x))
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_2_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_2_ADDR(x), m)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_2_AGING_TAILPTR_LO_BITS_BMSK                                              0xffffffff
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_2_AGING_TAILPTR_LO_BITS_SHFT                                                       0

#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_2_ADDR(x)                                                                 ((x) + 0xb64)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_2_PHYS(x)                                                                 ((x) + 0xb64)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_2_OFFS                                                                    (0xb64)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_2_RMSK                                                                          0xff
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_2_POR                                                                     0x00000000
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_2_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_2_ATTR                                                                                 0x1
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_2_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_2_ADDR(x))
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_2_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_2_ADDR(x), m)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_2_AGING_TAILPTR_HI_BITS_BMSK                                                    0xff
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_2_AGING_TAILPTR_HI_BITS_SHFT                                                       0

#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_3_ADDR(x)                                                                 ((x) + 0xb68)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_3_PHYS(x)                                                                 ((x) + 0xb68)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_3_OFFS                                                                    (0xb68)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_3_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_3_POR                                                                     0x00000000
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_3_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_3_ATTR                                                                                 0x1
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_3_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_3_ADDR(x))
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_3_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_3_ADDR(x), m)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_3_AGING_HEADPTR_LO_BITS_BMSK                                              0xffffffff
#define HWIO_REO_R0_AGING_LINK_HEADPTR_LO_IX_3_AGING_HEADPTR_LO_BITS_SHFT                                                       0

#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_3_ADDR(x)                                                                 ((x) + 0xb6c)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_3_PHYS(x)                                                                 ((x) + 0xb6c)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_3_OFFS                                                                    (0xb6c)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_3_RMSK                                                                          0xff
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_3_POR                                                                     0x00000000
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_3_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_3_ATTR                                                                                 0x1
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_3_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_3_ADDR(x))
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_3_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_3_ADDR(x), m)
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_3_AGING_HEADPTR_HI_BITS_BMSK                                                    0xff
#define HWIO_REO_R0_AGING_LINK_HEADPTR_HI_IX_3_AGING_HEADPTR_HI_BITS_SHFT                                                       0

#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_3_ADDR(x)                                                                 ((x) + 0xb70)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_3_PHYS(x)                                                                 ((x) + 0xb70)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_3_OFFS                                                                    (0xb70)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_3_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_3_POR                                                                     0x00000000
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_3_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_3_ATTR                                                                                 0x1
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_3_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_3_ADDR(x))
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_3_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_3_ADDR(x), m)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_3_AGING_TAILPTR_LO_BITS_BMSK                                              0xffffffff
#define HWIO_REO_R0_AGING_LINK_TAILPTR_LO_IX_3_AGING_TAILPTR_LO_BITS_SHFT                                                       0

#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_3_ADDR(x)                                                                 ((x) + 0xb74)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_3_PHYS(x)                                                                 ((x) + 0xb74)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_3_OFFS                                                                    (0xb74)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_3_RMSK                                                                          0xff
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_3_POR                                                                     0x00000000
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_3_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_3_ATTR                                                                                 0x1
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_3_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_3_ADDR(x))
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_3_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_3_ADDR(x), m)
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_3_AGING_TAILPTR_HI_BITS_BMSK                                                    0xff
#define HWIO_REO_R0_AGING_LINK_TAILPTR_HI_IX_3_AGING_TAILPTR_HI_BITS_SHFT                                                       0

#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_0_ADDR(x)                                                                      ((x) + 0xb78)
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_0_PHYS(x)                                                                      ((x) + 0xb78)
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_0_OFFS                                                                         (0xb78)
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_0_RMSK                                                                             0xffff
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_0_POR                                                                          0x00000000
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_0_POR_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_0_ATTR                                                                                      0x1
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_0_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_NUM_QUEUES_IX_0_ADDR(x))
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_NUM_QUEUES_IX_0_ADDR(x), m)
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_0_AGING_NUM_QUEUES_AC0_BMSK                                                        0xffff
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_0_AGING_NUM_QUEUES_AC0_SHFT                                                             0

#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_1_ADDR(x)                                                                      ((x) + 0xb7c)
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_1_PHYS(x)                                                                      ((x) + 0xb7c)
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_1_OFFS                                                                         (0xb7c)
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_1_RMSK                                                                             0xffff
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_1_POR                                                                          0x00000000
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_1_POR_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_1_ATTR                                                                                      0x1
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_1_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_NUM_QUEUES_IX_1_ADDR(x))
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_NUM_QUEUES_IX_1_ADDR(x), m)
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_1_AGING_NUM_QUEUES_AC1_BMSK                                                        0xffff
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_1_AGING_NUM_QUEUES_AC1_SHFT                                                             0

#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_2_ADDR(x)                                                                      ((x) + 0xb80)
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_2_PHYS(x)                                                                      ((x) + 0xb80)
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_2_OFFS                                                                         (0xb80)
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_2_RMSK                                                                             0xffff
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_2_POR                                                                          0x00000000
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_2_POR_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_2_ATTR                                                                                      0x1
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_2_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_NUM_QUEUES_IX_2_ADDR(x))
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_2_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_NUM_QUEUES_IX_2_ADDR(x), m)
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_2_AGING_NUM_QUEUES_AC2_BMSK                                                        0xffff
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_2_AGING_NUM_QUEUES_AC2_SHFT                                                             0

#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_3_ADDR(x)                                                                      ((x) + 0xb84)
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_3_PHYS(x)                                                                      ((x) + 0xb84)
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_3_OFFS                                                                         (0xb84)
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_3_RMSK                                                                             0xffff
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_3_POR                                                                          0x00000000
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_3_POR_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_3_ATTR                                                                                      0x1
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_3_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_NUM_QUEUES_IX_3_ADDR(x))
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_3_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_NUM_QUEUES_IX_3_ADDR(x), m)
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_3_AGING_NUM_QUEUES_AC3_BMSK                                                        0xffff
#define HWIO_REO_R0_AGING_NUM_QUEUES_IX_3_AGING_NUM_QUEUES_AC3_SHFT                                                             0

#define HWIO_REO_R0_AGING_TIMESTAMP_IX_0_ADDR(x)                                                                       ((x) + 0xb88)
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_0_PHYS(x)                                                                       ((x) + 0xb88)
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_0_OFFS                                                                          (0xb88)
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_0_RMSK                                                                          0xffffffff
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_0_POR                                                                           0x00000000
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_0_POR_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_0_ATTR                                                                                       0x1
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_0_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_TIMESTAMP_IX_0_ADDR(x))
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_TIMESTAMP_IX_0_ADDR(x), m)
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_0_AGING_TIMESTAMP_AC0_BMSK                                                      0xffffffff
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_0_AGING_TIMESTAMP_AC0_SHFT                                                               0

#define HWIO_REO_R0_AGING_TIMESTAMP_IX_1_ADDR(x)                                                                       ((x) + 0xb8c)
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_1_PHYS(x)                                                                       ((x) + 0xb8c)
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_1_OFFS                                                                          (0xb8c)
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_1_RMSK                                                                          0xffffffff
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_1_POR                                                                           0x00000000
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_1_POR_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_1_ATTR                                                                                       0x1
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_1_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_TIMESTAMP_IX_1_ADDR(x))
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_TIMESTAMP_IX_1_ADDR(x), m)
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_1_AGING_TIMESTAMP_AC1_BMSK                                                      0xffffffff
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_1_AGING_TIMESTAMP_AC1_SHFT                                                               0

#define HWIO_REO_R0_AGING_TIMESTAMP_IX_2_ADDR(x)                                                                       ((x) + 0xb90)
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_2_PHYS(x)                                                                       ((x) + 0xb90)
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_2_OFFS                                                                          (0xb90)
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_2_RMSK                                                                          0xffffffff
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_2_POR                                                                           0x00000000
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_2_POR_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_2_ATTR                                                                                       0x1
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_2_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_TIMESTAMP_IX_2_ADDR(x))
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_2_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_TIMESTAMP_IX_2_ADDR(x), m)
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_2_AGING_TIMESTAMP_AC2_BMSK                                                      0xffffffff
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_2_AGING_TIMESTAMP_AC2_SHFT                                                               0

#define HWIO_REO_R0_AGING_TIMESTAMP_IX_3_ADDR(x)                                                                       ((x) + 0xb94)
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_3_PHYS(x)                                                                       ((x) + 0xb94)
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_3_OFFS                                                                          (0xb94)
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_3_RMSK                                                                          0xffffffff
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_3_POR                                                                           0x00000000
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_3_POR_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_3_ATTR                                                                                       0x1
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_3_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_TIMESTAMP_IX_3_ADDR(x))
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_3_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_TIMESTAMP_IX_3_ADDR(x), m)
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_3_AGING_TIMESTAMP_AC3_BMSK                                                      0xffffffff
#define HWIO_REO_R0_AGING_TIMESTAMP_IX_3_AGING_TIMESTAMP_AC3_SHFT                                                               0

#define HWIO_REO_R0_AGING_CONTROL_ADDR(x)                                                                              ((x) + 0xb98)
#define HWIO_REO_R0_AGING_CONTROL_PHYS(x)                                                                              ((x) + 0xb98)
#define HWIO_REO_R0_AGING_CONTROL_OFFS                                                                                 (0xb98)
#define HWIO_REO_R0_AGING_CONTROL_RMSK                                                                                       0x1f
#define HWIO_REO_R0_AGING_CONTROL_POR                                                                                  0x00000000
#define HWIO_REO_R0_AGING_CONTROL_POR_RMSK                                                                             0xffffffff
#define HWIO_REO_R0_AGING_CONTROL_ATTR                                                                                              0x3
#define HWIO_REO_R0_AGING_CONTROL_IN(x)            \
                in_dword(HWIO_REO_R0_AGING_CONTROL_ADDR(x))
#define HWIO_REO_R0_AGING_CONTROL_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AGING_CONTROL_ADDR(x), m)
#define HWIO_REO_R0_AGING_CONTROL_OUT(x, v)            \
                out_dword(HWIO_REO_R0_AGING_CONTROL_ADDR(x),v)
#define HWIO_REO_R0_AGING_CONTROL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_AGING_CONTROL_ADDR(x),m,v,HWIO_REO_R0_AGING_CONTROL_IN(x))
#define HWIO_REO_R0_AGING_CONTROL_PERMPDU_UPDATE_THRESHOLD_BMSK                                                              0x1f
#define HWIO_REO_R0_AGING_CONTROL_PERMPDU_UPDATE_THRESHOLD_SHFT                                                                 0

#define HWIO_REO_R0_MISC_CTL_ADDR(x)                                                                                   ((x) + 0xb9c)
#define HWIO_REO_R0_MISC_CTL_PHYS(x)                                                                                   ((x) + 0xb9c)
#define HWIO_REO_R0_MISC_CTL_OFFS                                                                                      (0xb9c)
#define HWIO_REO_R0_MISC_CTL_RMSK                                                                                      0x1fffffff
#define HWIO_REO_R0_MISC_CTL_POR                                                                                       0x0cac0008
#define HWIO_REO_R0_MISC_CTL_POR_RMSK                                                                                  0xffffffff
#define HWIO_REO_R0_MISC_CTL_ATTR                                                                                                   0x3
#define HWIO_REO_R0_MISC_CTL_IN(x)            \
                in_dword(HWIO_REO_R0_MISC_CTL_ADDR(x))
#define HWIO_REO_R0_MISC_CTL_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_MISC_CTL_ADDR(x), m)
#define HWIO_REO_R0_MISC_CTL_OUT(x, v)            \
                out_dword(HWIO_REO_R0_MISC_CTL_ADDR(x),v)
#define HWIO_REO_R0_MISC_CTL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_MISC_CTL_ADDR(x),m,v,HWIO_REO_R0_MISC_CTL_IN(x))
#define HWIO_REO_R0_MISC_CTL_SOFT_REORDER_DEST_RING_BMSK                                                               0x1e000000
#define HWIO_REO_R0_MISC_CTL_SOFT_REORDER_DEST_RING_SHFT                                                                       25
#define HWIO_REO_R0_MISC_CTL_BAR_DEST_RING_BMSK                                                                         0x1e00000
#define HWIO_REO_R0_MISC_CTL_BAR_DEST_RING_SHFT                                                                                21
#define HWIO_REO_R0_MISC_CTL_FRAGMENT_DEST_RING_BMSK                                                                     0x1e0000
#define HWIO_REO_R0_MISC_CTL_FRAGMENT_DEST_RING_SHFT                                                                           17
#define HWIO_REO_R0_MISC_CTL_CACHE_FLUSH_Q_DESC_ONLY_BMSK                                                                 0x10000
#define HWIO_REO_R0_MISC_CTL_CACHE_FLUSH_Q_DESC_ONLY_SHFT                                                                      16
#define HWIO_REO_R0_MISC_CTL_MSI_ENABLE_CHK_BIT_BMSK                                                                       0x8000
#define HWIO_REO_R0_MISC_CTL_MSI_ENABLE_CHK_BIT_SHFT                                                                           15
#define HWIO_REO_R0_MISC_CTL_SPARE_CONTROL_BMSK                                                                            0x7fff
#define HWIO_REO_R0_MISC_CTL_SPARE_CONTROL_SHFT                                                                                 0

#define HWIO_REO_R0_MISC_CTL_2_ADDR(x)                                                                                 ((x) + 0xba0)
#define HWIO_REO_R0_MISC_CTL_2_PHYS(x)                                                                                 ((x) + 0xba0)
#define HWIO_REO_R0_MISC_CTL_2_OFFS                                                                                    (0xba0)
#define HWIO_REO_R0_MISC_CTL_2_RMSK                                                                                     0x3ffffff
#define HWIO_REO_R0_MISC_CTL_2_POR                                                                                     0x00000000
#define HWIO_REO_R0_MISC_CTL_2_POR_RMSK                                                                                0xffffffff
#define HWIO_REO_R0_MISC_CTL_2_ATTR                                                                                                 0x3
#define HWIO_REO_R0_MISC_CTL_2_IN(x)            \
                in_dword(HWIO_REO_R0_MISC_CTL_2_ADDR(x))
#define HWIO_REO_R0_MISC_CTL_2_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_MISC_CTL_2_ADDR(x), m)
#define HWIO_REO_R0_MISC_CTL_2_OUT(x, v)            \
                out_dword(HWIO_REO_R0_MISC_CTL_2_ADDR(x),v)
#define HWIO_REO_R0_MISC_CTL_2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_MISC_CTL_2_ADDR(x),m,v,HWIO_REO_R0_MISC_CTL_2_IN(x))
#define HWIO_REO_R0_MISC_CTL_2_REO2PPE_RING_PRIORITY_BMSK                                                               0x3000000
#define HWIO_REO_R0_MISC_CTL_2_REO2PPE_RING_PRIORITY_SHFT                                                                      24
#define HWIO_REO_R0_MISC_CTL_2_REO_STATUS_RING_PRIORITY_BMSK                                                             0xc00000
#define HWIO_REO_R0_MISC_CTL_2_REO_STATUS_RING_PRIORITY_SHFT                                                                   22
#define HWIO_REO_R0_MISC_CTL_2_REO_RELEASE_RING_PRIORITY_BMSK                                                            0x300000
#define HWIO_REO_R0_MISC_CTL_2_REO_RELEASE_RING_PRIORITY_SHFT                                                                  20
#define HWIO_REO_R0_MISC_CTL_2_REO2FW_RING_PRIORITY_BMSK                                                                  0xc0000
#define HWIO_REO_R0_MISC_CTL_2_REO2FW_RING_PRIORITY_SHFT                                                                       18
#define HWIO_REO_R0_MISC_CTL_2_REO2SW0_RING_PRIORITY_BMSK                                                                 0x30000
#define HWIO_REO_R0_MISC_CTL_2_REO2SW0_RING_PRIORITY_SHFT                                                                      16
#define HWIO_REO_R0_MISC_CTL_2_REO2SW8_RING_PRIORITY_BMSK                                                                  0xc000
#define HWIO_REO_R0_MISC_CTL_2_REO2SW8_RING_PRIORITY_SHFT                                                                      14
#define HWIO_REO_R0_MISC_CTL_2_REO2SW7_RING_PRIORITY_BMSK                                                                  0x3000
#define HWIO_REO_R0_MISC_CTL_2_REO2SW7_RING_PRIORITY_SHFT                                                                      12
#define HWIO_REO_R0_MISC_CTL_2_REO2SW6_RING_PRIORITY_BMSK                                                                   0xc00
#define HWIO_REO_R0_MISC_CTL_2_REO2SW6_RING_PRIORITY_SHFT                                                                      10
#define HWIO_REO_R0_MISC_CTL_2_REO2SW5_RING_PRIORITY_BMSK                                                                   0x300
#define HWIO_REO_R0_MISC_CTL_2_REO2SW5_RING_PRIORITY_SHFT                                                                       8
#define HWIO_REO_R0_MISC_CTL_2_REO2SW4_RING_PRIORITY_BMSK                                                                    0xc0
#define HWIO_REO_R0_MISC_CTL_2_REO2SW4_RING_PRIORITY_SHFT                                                                       6
#define HWIO_REO_R0_MISC_CTL_2_REO2SW3_RING_PRIORITY_BMSK                                                                    0x30
#define HWIO_REO_R0_MISC_CTL_2_REO2SW3_RING_PRIORITY_SHFT                                                                       4
#define HWIO_REO_R0_MISC_CTL_2_REO2SW2_RING_PRIORITY_BMSK                                                                     0xc
#define HWIO_REO_R0_MISC_CTL_2_REO2SW2_RING_PRIORITY_SHFT                                                                       2
#define HWIO_REO_R0_MISC_CTL_2_REO2SW1_RING_PRIORITY_BMSK                                                                     0x3
#define HWIO_REO_R0_MISC_CTL_2_REO2SW1_RING_PRIORITY_SHFT                                                                       0

#define HWIO_REO_R0_MISC_CTL_3_ADDR(x)                                                                                 ((x) + 0xba4)
#define HWIO_REO_R0_MISC_CTL_3_PHYS(x)                                                                                 ((x) + 0xba4)
#define HWIO_REO_R0_MISC_CTL_3_OFFS                                                                                    (0xba4)
#define HWIO_REO_R0_MISC_CTL_3_RMSK                                                                                         0xfff
#define HWIO_REO_R0_MISC_CTL_3_POR                                                                                     0x00000e00
#define HWIO_REO_R0_MISC_CTL_3_POR_RMSK                                                                                0xffffffff
#define HWIO_REO_R0_MISC_CTL_3_ATTR                                                                                                 0x3
#define HWIO_REO_R0_MISC_CTL_3_IN(x)            \
                in_dword(HWIO_REO_R0_MISC_CTL_3_ADDR(x))
#define HWIO_REO_R0_MISC_CTL_3_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_MISC_CTL_3_ADDR(x), m)
#define HWIO_REO_R0_MISC_CTL_3_OUT(x, v)            \
                out_dword(HWIO_REO_R0_MISC_CTL_3_ADDR(x),v)
#define HWIO_REO_R0_MISC_CTL_3_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_MISC_CTL_3_ADDR(x),m,v,HWIO_REO_R0_MISC_CTL_3_IN(x))
#define HWIO_REO_R0_MISC_CTL_3_REO_QDESC_VC_ID_BMSK                                                                         0x800
#define HWIO_REO_R0_MISC_CTL_3_REO_QDESC_VC_ID_SHFT                                                                            11
#define HWIO_REO_R0_MISC_CTL_3_REO_VA_VC_ID_BMSK                                                                            0x400
#define HWIO_REO_R0_MISC_CTL_3_REO_VA_VC_ID_SHFT                                                                               10
#define HWIO_REO_R0_MISC_CTL_3_SEQ_VC_ID_BMSK                                                                               0x200
#define HWIO_REO_R0_MISC_CTL_3_SEQ_VC_ID_SHFT                                                                                   9
#define HWIO_REO_R0_MISC_CTL_3_ENTR_LINK_DESC_VC_ID_BMSK                                                                    0x100
#define HWIO_REO_R0_MISC_CTL_3_ENTR_LINK_DESC_VC_ID_SHFT                                                                        8
#define HWIO_REO_R0_MISC_CTL_3_ENTR_CMD_VC_ID_BMSK                                                                           0x80
#define HWIO_REO_R0_MISC_CTL_3_ENTR_CMD_VC_ID_SHFT                                                                              7
#define HWIO_REO_R0_MISC_CTL_3_ENTR6_VC_ID_BMSK                                                                              0x40
#define HWIO_REO_R0_MISC_CTL_3_ENTR6_VC_ID_SHFT                                                                                 6
#define HWIO_REO_R0_MISC_CTL_3_ENTR5_VC_ID_BMSK                                                                              0x20
#define HWIO_REO_R0_MISC_CTL_3_ENTR5_VC_ID_SHFT                                                                                 5
#define HWIO_REO_R0_MISC_CTL_3_ENTR4_VC_ID_BMSK                                                                              0x10
#define HWIO_REO_R0_MISC_CTL_3_ENTR4_VC_ID_SHFT                                                                                 4
#define HWIO_REO_R0_MISC_CTL_3_ENTR3_VC_ID_BMSK                                                                               0x8
#define HWIO_REO_R0_MISC_CTL_3_ENTR3_VC_ID_SHFT                                                                                 3
#define HWIO_REO_R0_MISC_CTL_3_ENTR2_VC_ID_BMSK                                                                               0x4
#define HWIO_REO_R0_MISC_CTL_3_ENTR2_VC_ID_SHFT                                                                                 2
#define HWIO_REO_R0_MISC_CTL_3_ENTR1_VC_ID_BMSK                                                                               0x2
#define HWIO_REO_R0_MISC_CTL_3_ENTR1_VC_ID_SHFT                                                                                 1
#define HWIO_REO_R0_MISC_CTL_3_ENTR0_VC_ID_BMSK                                                                               0x1
#define HWIO_REO_R0_MISC_CTL_3_ENTR0_VC_ID_SHFT                                                                                 0

#define HWIO_REO_R0_MISC_CTL_4_ADDR(x)                                                                                 ((x) + 0xba8)
#define HWIO_REO_R0_MISC_CTL_4_PHYS(x)                                                                                 ((x) + 0xba8)
#define HWIO_REO_R0_MISC_CTL_4_OFFS                                                                                    (0xba8)
#define HWIO_REO_R0_MISC_CTL_4_RMSK                                                                                      0x1fffff
#define HWIO_REO_R0_MISC_CTL_4_POR                                                                                     0x00000000
#define HWIO_REO_R0_MISC_CTL_4_POR_RMSK                                                                                0xffffffff
#define HWIO_REO_R0_MISC_CTL_4_ATTR                                                                                                 0x3
#define HWIO_REO_R0_MISC_CTL_4_IN(x)            \
                in_dword(HWIO_REO_R0_MISC_CTL_4_ADDR(x))
#define HWIO_REO_R0_MISC_CTL_4_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_MISC_CTL_4_ADDR(x), m)
#define HWIO_REO_R0_MISC_CTL_4_OUT(x, v)            \
                out_dword(HWIO_REO_R0_MISC_CTL_4_ADDR(x),v)
#define HWIO_REO_R0_MISC_CTL_4_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_MISC_CTL_4_ADDR(x),m,v,HWIO_REO_R0_MISC_CTL_4_IN(x))
#define HWIO_REO_R0_MISC_CTL_4_CACHE_FLUSH_TIMER_ENABLE_BMSK                                                             0x100000
#define HWIO_REO_R0_MISC_CTL_4_CACHE_FLUSH_TIMER_ENABLE_SHFT                                                                   20
#define HWIO_REO_R0_MISC_CTL_4_CACHE_FLUSH_TIMER_LIMIT_BMSK                                                               0xfffff
#define HWIO_REO_R0_MISC_CTL_4_CACHE_FLUSH_TIMER_LIMIT_SHFT                                                                     0

#define HWIO_REO_R0_HIGH_MEMORY_THRESHOLD_ADDR(x)                                                                      ((x) + 0xcf4)
#define HWIO_REO_R0_HIGH_MEMORY_THRESHOLD_PHYS(x)                                                                      ((x) + 0xcf4)
#define HWIO_REO_R0_HIGH_MEMORY_THRESHOLD_OFFS                                                                         (0xcf4)
#define HWIO_REO_R0_HIGH_MEMORY_THRESHOLD_RMSK                                                                         0xffffffff
#define HWIO_REO_R0_HIGH_MEMORY_THRESHOLD_POR                                                                          0xffffffff
#define HWIO_REO_R0_HIGH_MEMORY_THRESHOLD_POR_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_HIGH_MEMORY_THRESHOLD_ATTR                                                                                      0x3
#define HWIO_REO_R0_HIGH_MEMORY_THRESHOLD_IN(x)            \
                in_dword(HWIO_REO_R0_HIGH_MEMORY_THRESHOLD_ADDR(x))
#define HWIO_REO_R0_HIGH_MEMORY_THRESHOLD_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_HIGH_MEMORY_THRESHOLD_ADDR(x), m)
#define HWIO_REO_R0_HIGH_MEMORY_THRESHOLD_OUT(x, v)            \
                out_dword(HWIO_REO_R0_HIGH_MEMORY_THRESHOLD_ADDR(x),v)
#define HWIO_REO_R0_HIGH_MEMORY_THRESHOLD_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_HIGH_MEMORY_THRESHOLD_ADDR(x),m,v,HWIO_REO_R0_HIGH_MEMORY_THRESHOLD_IN(x))
#define HWIO_REO_R0_HIGH_MEMORY_THRESHOLD_HIGH_MEMORY_THRESHOLD_BMSK                                                   0xffffffff
#define HWIO_REO_R0_HIGH_MEMORY_THRESHOLD_HIGH_MEMORY_THRESHOLD_SHFT                                                            0

#define HWIO_REO_R0_AC_BUFFERS_USED_IX_0_ADDR(x)                                                                       ((x) + 0xcf8)
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_0_PHYS(x)                                                                       ((x) + 0xcf8)
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_0_OFFS                                                                          (0xcf8)
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_0_RMSK                                                                          0xffffffff
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_0_POR                                                                           0x00000000
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_0_POR_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_0_ATTR                                                                                       0x1
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_0_IN(x)            \
                in_dword(HWIO_REO_R0_AC_BUFFERS_USED_IX_0_ADDR(x))
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AC_BUFFERS_USED_IX_0_ADDR(x), m)
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_0_BUFFERS_USED_BMSK                                                             0xffffffff
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_0_BUFFERS_USED_SHFT                                                                      0

#define HWIO_REO_R0_AC_BUFFERS_USED_IX_1_ADDR(x)                                                                       ((x) + 0xcfc)
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_1_PHYS(x)                                                                       ((x) + 0xcfc)
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_1_OFFS                                                                          (0xcfc)
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_1_RMSK                                                                          0xffffffff
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_1_POR                                                                           0x00000000
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_1_POR_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_1_ATTR                                                                                       0x1
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_1_IN(x)            \
                in_dword(HWIO_REO_R0_AC_BUFFERS_USED_IX_1_ADDR(x))
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AC_BUFFERS_USED_IX_1_ADDR(x), m)
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_1_BUFFERS_USED_BMSK                                                             0xffffffff
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_1_BUFFERS_USED_SHFT                                                                      0

#define HWIO_REO_R0_AC_BUFFERS_USED_IX_2_ADDR(x)                                                                       ((x) + 0xd00)
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_2_PHYS(x)                                                                       ((x) + 0xd00)
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_2_OFFS                                                                          (0xd00)
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_2_RMSK                                                                          0xffffffff
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_2_POR                                                                           0x00000000
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_2_POR_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_2_ATTR                                                                                       0x1
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_2_IN(x)            \
                in_dword(HWIO_REO_R0_AC_BUFFERS_USED_IX_2_ADDR(x))
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_2_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AC_BUFFERS_USED_IX_2_ADDR(x), m)
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_2_BUFFERS_USED_BMSK                                                             0xffffffff
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_2_BUFFERS_USED_SHFT                                                                      0

#define HWIO_REO_R0_AC_BUFFERS_USED_IX_3_ADDR(x)                                                                       ((x) + 0xd04)
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_3_PHYS(x)                                                                       ((x) + 0xd04)
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_3_OFFS                                                                          (0xd04)
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_3_RMSK                                                                          0xffffffff
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_3_POR                                                                           0x00000000
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_3_POR_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_3_ATTR                                                                                       0x1
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_3_IN(x)            \
                in_dword(HWIO_REO_R0_AC_BUFFERS_USED_IX_3_ADDR(x))
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_3_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_AC_BUFFERS_USED_IX_3_ADDR(x), m)
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_3_BUFFERS_USED_BMSK                                                             0xffffffff
#define HWIO_REO_R0_AC_BUFFERS_USED_IX_3_BUFFERS_USED_SHFT                                                                      0

#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_0_ADDR(x)                                                         ((x) + 0xd08)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_0_PHYS(x)                                                         ((x) + 0xd08)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_0_OFFS                                                            (0xd08)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_0_RMSK                                                              0xffffff
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_0_POR                                                             0x00ffffff
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_0_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_0_ATTR                                                                         0x3
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_0_IN(x)            \
                in_dword(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_0_ADDR(x))
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_0_ADDR(x), m)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_0_OUT(x, v)            \
                out_dword(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_0_ADDR(x),v)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_0_ADDR(x),m,v,HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_0_IN(x))
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_0_THRESHOLD_BMSK                                                    0xffffff
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_0_THRESHOLD_SHFT                                                           0

#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_1_ADDR(x)                                                         ((x) + 0xd0c)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_1_PHYS(x)                                                         ((x) + 0xd0c)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_1_OFFS                                                            (0xd0c)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_1_RMSK                                                              0xffffff
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_1_POR                                                             0x00ffffff
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_1_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_1_ATTR                                                                         0x3
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_1_IN(x)            \
                in_dword(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_1_ADDR(x))
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_1_ADDR(x), m)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_1_ADDR(x),v)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_1_ADDR(x),m,v,HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_1_IN(x))
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_1_THRESHOLD_BMSK                                                    0xffffff
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_1_THRESHOLD_SHFT                                                           0

#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_2_ADDR(x)                                                         ((x) + 0xd10)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_2_PHYS(x)                                                         ((x) + 0xd10)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_2_OFFS                                                            (0xd10)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_2_RMSK                                                              0xffffff
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_2_POR                                                             0x00ffffff
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_2_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_2_ATTR                                                                         0x3
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_2_IN(x)            \
                in_dword(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_2_ADDR(x))
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_2_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_2_ADDR(x), m)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_2_OUT(x, v)            \
                out_dword(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_2_ADDR(x),v)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_2_ADDR(x),m,v,HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_2_IN(x))
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_2_THRESHOLD_BMSK                                                    0xffffff
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_IX_2_THRESHOLD_SHFT                                                           0

#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_TOTAL_ADDR(x)                                                        ((x) + 0xd14)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_TOTAL_PHYS(x)                                                        ((x) + 0xd14)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_TOTAL_OFFS                                                           (0xd14)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_TOTAL_RMSK                                                            0x3ffffff
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_TOTAL_POR                                                            0x03ffffff
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_TOTAL_POR_RMSK                                                       0xffffffff
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_TOTAL_ATTR                                                                        0x3
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_TOTAL_IN(x)            \
                in_dword(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_TOTAL_ADDR(x))
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_TOTAL_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_TOTAL_ADDR(x), m)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_TOTAL_OUT(x, v)            \
                out_dword(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_TOTAL_ADDR(x),v)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_TOTAL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_TOTAL_ADDR(x),m,v,HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_TOTAL_IN(x))
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_TOTAL_THRESHOLD_BMSK                                                  0x3ffffff
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_THRESH_TOTAL_THRESHOLD_SHFT                                                          0

#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_0_ADDR(x)                                                                ((x) + 0xd18)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_0_PHYS(x)                                                                ((x) + 0xd18)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_0_OFFS                                                                   (0xd18)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_0_RMSK                                                                     0xffffff
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_0_POR                                                                    0x00000000
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_0_POR_RMSK                                                               0xffffffff
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_0_ATTR                                                                                0x3
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_0_IN(x)            \
                in_dword(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_0_ADDR(x))
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_0_ADDR(x), m)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_0_OUT(x, v)            \
                out_dword(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_0_ADDR(x),v)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_0_ADDR(x),m,v,HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_0_IN(x))
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_0_COUNT_BMSK                                                               0xffffff
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_0_COUNT_SHFT                                                                      0

#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_1_ADDR(x)                                                                ((x) + 0xd1c)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_1_PHYS(x)                                                                ((x) + 0xd1c)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_1_OFFS                                                                   (0xd1c)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_1_RMSK                                                                     0xffffff
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_1_POR                                                                    0x00000000
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_1_POR_RMSK                                                               0xffffffff
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_1_ATTR                                                                                0x3
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_1_IN(x)            \
                in_dword(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_1_ADDR(x))
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_1_ADDR(x), m)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_1_ADDR(x),v)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_1_ADDR(x),m,v,HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_1_IN(x))
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_1_COUNT_BMSK                                                               0xffffff
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_1_COUNT_SHFT                                                                      0

#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_2_ADDR(x)                                                                ((x) + 0xd20)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_2_PHYS(x)                                                                ((x) + 0xd20)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_2_OFFS                                                                   (0xd20)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_2_RMSK                                                                     0xffffff
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_2_POR                                                                    0x00000000
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_2_POR_RMSK                                                               0xffffffff
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_2_ATTR                                                                                0x3
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_2_IN(x)            \
                in_dword(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_2_ADDR(x))
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_2_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_2_ADDR(x), m)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_2_OUT(x, v)            \
                out_dword(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_2_ADDR(x),v)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_2_ADDR(x),m,v,HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_2_IN(x))
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_2_COUNT_BMSK                                                               0xffffff
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_IX_2_COUNT_SHFT                                                                      0

#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_CTRL_ADDR(x)                                                                ((x) + 0xd24)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_CTRL_PHYS(x)                                                                ((x) + 0xd24)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_CTRL_OFFS                                                                   (0xd24)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_CTRL_RMSK                                                                          0x1
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_CTRL_POR                                                                    0x00000000
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_CTRL_POR_RMSK                                                               0xffffffff
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_CTRL_ATTR                                                                                0x3
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_CTRL_IN(x)            \
                in_dword(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_CTRL_ADDR(x))
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_CTRL_ADDR(x), m)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_CTRL_OUT(x, v)            \
                out_dword(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_CTRL_ADDR(x),v)
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_CTRL_ADDR(x),m,v,HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_CTRL_IN(x))
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_CTRL_ENABLE_DESC_THRESH_TLV_BMSK                                                   0x1
#define HWIO_REO_R0_GLOBAL_LINK_DESC_COUNT_CTRL_ENABLE_DESC_THRESH_TLV_SHFT                                                     0

#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_0_ADDR(x)                                                              ((x) + 0xd28)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_0_PHYS(x)                                                              ((x) + 0xd28)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_0_OFFS                                                                 (0xd28)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_0_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_0_POR                                                                  0x00000000
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_0_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_0_ATTR                                                                              0x1
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_0_IN(x)            \
                in_dword(HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_0_ADDR(x))
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_0_ADDR(x), m)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_0_ADDRESS_LO_BITS_BMSK                                                 0xffffffff
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_0_ADDRESS_LO_BITS_SHFT                                                          0

#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_0_ADDR(x)                                                              ((x) + 0xd2c)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_0_PHYS(x)                                                              ((x) + 0xd2c)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_0_OFFS                                                                 (0xd2c)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_0_RMSK                                                                       0xff
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_0_POR                                                                  0x00000000
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_0_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_0_ATTR                                                                              0x1
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_0_IN(x)            \
                in_dword(HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_0_ADDR(x))
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_0_ADDR(x), m)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_0_ADDRESS_HI_BITS_BMSK                                                       0xff
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_0_ADDRESS_HI_BITS_SHFT                                                          0

#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_1_ADDR(x)                                                              ((x) + 0xd30)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_1_PHYS(x)                                                              ((x) + 0xd30)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_1_OFFS                                                                 (0xd30)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_1_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_1_POR                                                                  0x00000000
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_1_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_1_ATTR                                                                              0x1
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_1_IN(x)            \
                in_dword(HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_1_ADDR(x))
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_1_ADDR(x), m)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_1_ADDRESS_LO_BITS_BMSK                                                 0xffffffff
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_1_ADDRESS_LO_BITS_SHFT                                                          0

#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_1_ADDR(x)                                                              ((x) + 0xd34)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_1_PHYS(x)                                                              ((x) + 0xd34)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_1_OFFS                                                                 (0xd34)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_1_RMSK                                                                       0xff
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_1_POR                                                                  0x00000000
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_1_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_1_ATTR                                                                              0x1
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_1_IN(x)            \
                in_dword(HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_1_ADDR(x))
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_1_ADDR(x), m)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_1_ADDRESS_HI_BITS_BMSK                                                       0xff
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_1_ADDRESS_HI_BITS_SHFT                                                          0

#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_2_ADDR(x)                                                              ((x) + 0xd38)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_2_PHYS(x)                                                              ((x) + 0xd38)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_2_OFFS                                                                 (0xd38)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_2_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_2_POR                                                                  0x00000000
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_2_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_2_ATTR                                                                              0x1
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_2_IN(x)            \
                in_dword(HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_2_ADDR(x))
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_2_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_2_ADDR(x), m)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_2_ADDRESS_LO_BITS_BMSK                                                 0xffffffff
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_2_ADDRESS_LO_BITS_SHFT                                                          0

#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_2_ADDR(x)                                                              ((x) + 0xd3c)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_2_PHYS(x)                                                              ((x) + 0xd3c)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_2_OFFS                                                                 (0xd3c)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_2_RMSK                                                                       0xff
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_2_POR                                                                  0x00000000
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_2_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_2_ATTR                                                                              0x1
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_2_IN(x)            \
                in_dword(HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_2_ADDR(x))
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_2_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_2_ADDR(x), m)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_2_ADDRESS_HI_BITS_BMSK                                                       0xff
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_2_ADDRESS_HI_BITS_SHFT                                                          0

#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_3_ADDR(x)                                                              ((x) + 0xd40)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_3_PHYS(x)                                                              ((x) + 0xd40)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_3_OFFS                                                                 (0xd40)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_3_RMSK                                                                 0xffffffff
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_3_POR                                                                  0x00000000
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_3_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_3_ATTR                                                                              0x1
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_3_IN(x)            \
                in_dword(HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_3_ADDR(x))
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_3_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_3_ADDR(x), m)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_3_ADDRESS_LO_BITS_BMSK                                                 0xffffffff
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_LO_IX_3_ADDRESS_LO_BITS_SHFT                                                          0

#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_3_ADDR(x)                                                              ((x) + 0xd44)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_3_PHYS(x)                                                              ((x) + 0xd44)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_3_OFFS                                                                 (0xd44)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_3_RMSK                                                                       0xff
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_3_POR                                                                  0x00000000
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_3_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_3_ATTR                                                                              0x1
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_3_IN(x)            \
                in_dword(HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_3_ADDR(x))
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_3_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_3_ADDR(x), m)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_3_ADDRESS_HI_BITS_BMSK                                                       0xff
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_ADDR_HI_IX_3_ADDRESS_HI_BITS_SHFT                                                          0

#define HWIO_REO_R0_QUEUE_DESC_BLOCK_INFO_ADDR(x)                                                                      ((x) + 0xd48)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_INFO_PHYS(x)                                                                      ((x) + 0xd48)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_INFO_OFFS                                                                         (0xd48)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_INFO_RMSK                                                                               0x1f
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_INFO_POR                                                                          0x00000000
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_INFO_POR_RMSK                                                                     0xffffffff
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_INFO_ATTR                                                                                      0x1
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_INFO_IN(x)            \
                in_dword(HWIO_REO_R0_QUEUE_DESC_BLOCK_INFO_ADDR(x))
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_INFO_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_QUEUE_DESC_BLOCK_INFO_ADDR(x), m)
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_INFO_ENTIRE_CACHE_BLOCKED_BMSK                                                          0x10
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_INFO_ENTIRE_CACHE_BLOCKED_SHFT                                                             4
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_INFO_ADDRESS_VALID_BMSK                                                                  0xf
#define HWIO_REO_R0_QUEUE_DESC_BLOCK_INFO_ADDRESS_VALID_SHFT                                                                    0

#define HWIO_REO_R0_CACHE_CTL_CONFIG_ADDR(x)                                                                           ((x) + 0xd74)
#define HWIO_REO_R0_CACHE_CTL_CONFIG_PHYS(x)                                                                           ((x) + 0xd74)
#define HWIO_REO_R0_CACHE_CTL_CONFIG_OFFS                                                                              (0xd74)
#define HWIO_REO_R0_CACHE_CTL_CONFIG_RMSK                                                                              0xffffffff
#define HWIO_REO_R0_CACHE_CTL_CONFIG_POR                                                                               0x008609ff
#define HWIO_REO_R0_CACHE_CTL_CONFIG_POR_RMSK                                                                          0xffffffff
#define HWIO_REO_R0_CACHE_CTL_CONFIG_ATTR                                                                                           0x3
#define HWIO_REO_R0_CACHE_CTL_CONFIG_IN(x)            \
                in_dword(HWIO_REO_R0_CACHE_CTL_CONFIG_ADDR(x))
#define HWIO_REO_R0_CACHE_CTL_CONFIG_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_CACHE_CTL_CONFIG_ADDR(x), m)
#define HWIO_REO_R0_CACHE_CTL_CONFIG_OUT(x, v)            \
                out_dword(HWIO_REO_R0_CACHE_CTL_CONFIG_ADDR(x),v)
#define HWIO_REO_R0_CACHE_CTL_CONFIG_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_CACHE_CTL_CONFIG_ADDR(x),m,v,HWIO_REO_R0_CACHE_CTL_CONFIG_IN(x))
#define HWIO_REO_R0_CACHE_CTL_CONFIG_DESC_TYPE_SWAP_BMSK                                                               0xff000000
#define HWIO_REO_R0_CACHE_CTL_CONFIG_DESC_TYPE_SWAP_SHFT                                                                       24
#define HWIO_REO_R0_CACHE_CTL_CONFIG_ENABLE_LEGACY_SWAP_BMSK                                                             0x800000
#define HWIO_REO_R0_CACHE_CTL_CONFIG_ENABLE_LEGACY_SWAP_SHFT                                                                   23
#define HWIO_REO_R0_CACHE_CTL_CONFIG_WRITE_STRUCT_SWAP_BMSK                                                              0x400000
#define HWIO_REO_R0_CACHE_CTL_CONFIG_WRITE_STRUCT_SWAP_SHFT                                                                    22
#define HWIO_REO_R0_CACHE_CTL_CONFIG_READ_STRUCT_SWAP_BMSK                                                               0x200000
#define HWIO_REO_R0_CACHE_CTL_CONFIG_READ_STRUCT_SWAP_SHFT                                                                     21
#define HWIO_REO_R0_CACHE_CTL_CONFIG_WRITE_SECURITY_BMSK                                                                 0x100000
#define HWIO_REO_R0_CACHE_CTL_CONFIG_WRITE_SECURITY_SHFT                                                                       20
#define HWIO_REO_R0_CACHE_CTL_CONFIG_READ_SECURITY_BMSK                                                                   0x80000
#define HWIO_REO_R0_CACHE_CTL_CONFIG_READ_SECURITY_SHFT                                                                        19
#define HWIO_REO_R0_CACHE_CTL_CONFIG_BG_FLUSH_POST_WRITE_BMSK                                                             0x40000
#define HWIO_REO_R0_CACHE_CTL_CONFIG_BG_FLUSH_POST_WRITE_SHFT                                                                  18
#define HWIO_REO_R0_CACHE_CTL_CONFIG_CLIENT_FLUSH_POST_WRITE_BMSK                                                         0x20000
#define HWIO_REO_R0_CACHE_CTL_CONFIG_CLIENT_FLUSH_POST_WRITE_SHFT                                                              17
#define HWIO_REO_R0_CACHE_CTL_CONFIG_CACHE_EMPTY_THRESHOLD_BMSK                                                           0x1fe00
#define HWIO_REO_R0_CACHE_CTL_CONFIG_CACHE_EMPTY_THRESHOLD_SHFT                                                                 9
#define HWIO_REO_R0_CACHE_CTL_CONFIG_CACHE_LINE_USE_NUM_BMSK                                                                0x1ff
#define HWIO_REO_R0_CACHE_CTL_CONFIG_CACHE_LINE_USE_NUM_SHFT                                                                    0

#define HWIO_REO_R0_CACHE_CTL_CONTROL_ADDR(x)                                                                          ((x) + 0xd78)
#define HWIO_REO_R0_CACHE_CTL_CONTROL_PHYS(x)                                                                          ((x) + 0xd78)
#define HWIO_REO_R0_CACHE_CTL_CONTROL_OFFS                                                                             (0xd78)
#define HWIO_REO_R0_CACHE_CTL_CONTROL_RMSK                                                                                    0x3
#define HWIO_REO_R0_CACHE_CTL_CONTROL_POR                                                                              0x00000000
#define HWIO_REO_R0_CACHE_CTL_CONTROL_POR_RMSK                                                                         0xffffffff
#define HWIO_REO_R0_CACHE_CTL_CONTROL_ATTR                                                                                          0x3
#define HWIO_REO_R0_CACHE_CTL_CONTROL_IN(x)            \
                in_dword(HWIO_REO_R0_CACHE_CTL_CONTROL_ADDR(x))
#define HWIO_REO_R0_CACHE_CTL_CONTROL_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_CACHE_CTL_CONTROL_ADDR(x), m)
#define HWIO_REO_R0_CACHE_CTL_CONTROL_OUT(x, v)            \
                out_dword(HWIO_REO_R0_CACHE_CTL_CONTROL_ADDR(x),v)
#define HWIO_REO_R0_CACHE_CTL_CONTROL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_CACHE_CTL_CONTROL_ADDR(x),m,v,HWIO_REO_R0_CACHE_CTL_CONTROL_IN(x))
#define HWIO_REO_R0_CACHE_CTL_CONTROL_WRITE_POSTED_FOR_NON_POSTED_LINE_FLUSH_BMSK                                             0x2
#define HWIO_REO_R0_CACHE_CTL_CONTROL_WRITE_POSTED_FOR_NON_POSTED_LINE_FLUSH_SHFT                                               1
#define HWIO_REO_R0_CACHE_CTL_CONTROL_CACHE_RESET_BMSK                                                                        0x1
#define HWIO_REO_R0_CACHE_CTL_CONTROL_CACHE_RESET_SHFT                                                                          0

#define HWIO_REO_R0_CACHE_CTL_CONFIG_SET_ADDR(x)                                                                       ((x) + 0xd7c)
#define HWIO_REO_R0_CACHE_CTL_CONFIG_SET_PHYS(x)                                                                       ((x) + 0xd7c)
#define HWIO_REO_R0_CACHE_CTL_CONFIG_SET_OFFS                                                                          (0xd7c)
#define HWIO_REO_R0_CACHE_CTL_CONFIG_SET_RMSK                                                                           0x1ffffff
#define HWIO_REO_R0_CACHE_CTL_CONFIG_SET_POR                                                                           0x00000000
#define HWIO_REO_R0_CACHE_CTL_CONFIG_SET_POR_RMSK                                                                      0xffffffff
#define HWIO_REO_R0_CACHE_CTL_CONFIG_SET_ATTR                                                                                       0x3
#define HWIO_REO_R0_CACHE_CTL_CONFIG_SET_IN(x)            \
                in_dword(HWIO_REO_R0_CACHE_CTL_CONFIG_SET_ADDR(x))
#define HWIO_REO_R0_CACHE_CTL_CONFIG_SET_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_CACHE_CTL_CONFIG_SET_ADDR(x), m)
#define HWIO_REO_R0_CACHE_CTL_CONFIG_SET_OUT(x, v)            \
                out_dword(HWIO_REO_R0_CACHE_CTL_CONFIG_SET_ADDR(x),v)
#define HWIO_REO_R0_CACHE_CTL_CONFIG_SET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_CACHE_CTL_CONFIG_SET_ADDR(x),m,v,HWIO_REO_R0_CACHE_CTL_CONFIG_SET_IN(x))
#define HWIO_REO_R0_CACHE_CTL_CONFIG_SET_CONFIG_SET_BMSK                                                                0x1ffffff
#define HWIO_REO_R0_CACHE_CTL_CONFIG_SET_CONFIG_SET_SHFT                                                                        0

#define HWIO_REO_R0_CACHE_CTL_SET_SIZE_ADDR(x)                                                                         ((x) + 0xd80)
#define HWIO_REO_R0_CACHE_CTL_SET_SIZE_PHYS(x)                                                                         ((x) + 0xd80)
#define HWIO_REO_R0_CACHE_CTL_SET_SIZE_OFFS                                                                            (0xd80)
#define HWIO_REO_R0_CACHE_CTL_SET_SIZE_RMSK                                                                                 0x3ff
#define HWIO_REO_R0_CACHE_CTL_SET_SIZE_POR                                                                             0x000000f0
#define HWIO_REO_R0_CACHE_CTL_SET_SIZE_POR_RMSK                                                                        0xffffffff
#define HWIO_REO_R0_CACHE_CTL_SET_SIZE_ATTR                                                                                         0x3
#define HWIO_REO_R0_CACHE_CTL_SET_SIZE_IN(x)            \
                in_dword(HWIO_REO_R0_CACHE_CTL_SET_SIZE_ADDR(x))
#define HWIO_REO_R0_CACHE_CTL_SET_SIZE_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_CACHE_CTL_SET_SIZE_ADDR(x), m)
#define HWIO_REO_R0_CACHE_CTL_SET_SIZE_OUT(x, v)            \
                out_dword(HWIO_REO_R0_CACHE_CTL_SET_SIZE_ADDR(x),v)
#define HWIO_REO_R0_CACHE_CTL_SET_SIZE_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_CACHE_CTL_SET_SIZE_ADDR(x),m,v,HWIO_REO_R0_CACHE_CTL_SET_SIZE_IN(x))
#define HWIO_REO_R0_CACHE_CTL_SET_SIZE_SET1_SIZE_BMSK                                                                       0x3ff
#define HWIO_REO_R0_CACHE_CTL_SET_SIZE_SET1_SIZE_SHFT                                                                           0

#define HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_ADDR(x)                                                                     ((x) + 0xd84)
#define HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_PHYS(x)                                                                     ((x) + 0xd84)
#define HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_OFFS                                                                        (0xd84)
#define HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_RMSK                                                                               0x7
#define HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_POR                                                                         0x00000002
#define HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_POR_RMSK                                                                    0xffffffff
#define HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_ATTR                                                                                     0x3
#define HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_IN(x)            \
                in_dword(HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_ADDR(x))
#define HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_ADDR(x), m)
#define HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_OUT(x, v)            \
                out_dword(HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_ADDR(x),v)
#define HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_ADDR(x),m,v,HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_IN(x))
#define HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_VC_ID_BMSK                                                                         0x4
#define HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_VC_ID_SHFT                                                                           2
#define HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_GXI_PRIORITY_BMSK                                                                  0x3
#define HWIO_REO_R0_CACHE_CTL_GXI_PRIORITY_GXI_PRIORITY_SHFT                                                                    0

#define HWIO_REO_R0_CLK_GATE_CTRL_ADDR(x)                                                                              ((x) + 0xd88)
#define HWIO_REO_R0_CLK_GATE_CTRL_PHYS(x)                                                                              ((x) + 0xd88)
#define HWIO_REO_R0_CLK_GATE_CTRL_OFFS                                                                                 (0xd88)
#define HWIO_REO_R0_CLK_GATE_CTRL_RMSK                                                                                    0x7ffff
#define HWIO_REO_R0_CLK_GATE_CTRL_POR                                                                                  0x00000400
#define HWIO_REO_R0_CLK_GATE_CTRL_POR_RMSK                                                                             0xffffffff
#define HWIO_REO_R0_CLK_GATE_CTRL_ATTR                                                                                              0x3
#define HWIO_REO_R0_CLK_GATE_CTRL_IN(x)            \
                in_dword(HWIO_REO_R0_CLK_GATE_CTRL_ADDR(x))
#define HWIO_REO_R0_CLK_GATE_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_CLK_GATE_CTRL_ADDR(x), m)
#define HWIO_REO_R0_CLK_GATE_CTRL_OUT(x, v)            \
                out_dword(HWIO_REO_R0_CLK_GATE_CTRL_ADDR(x),v)
#define HWIO_REO_R0_CLK_GATE_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_CLK_GATE_CTRL_ADDR(x),m,v,HWIO_REO_R0_CLK_GATE_CTRL_IN(x))
#define HWIO_REO_R0_CLK_GATE_CTRL_RESERVE_7_BMSK                                                                          0x40000
#define HWIO_REO_R0_CLK_GATE_CTRL_RESERVE_7_SHFT                                                                               18
#define HWIO_REO_R0_CLK_GATE_CTRL_RESERVE_6_BMSK                                                                          0x20000
#define HWIO_REO_R0_CLK_GATE_CTRL_RESERVE_6_SHFT                                                                               17
#define HWIO_REO_R0_CLK_GATE_CTRL_RESERVE_5_BMSK                                                                          0x10000
#define HWIO_REO_R0_CLK_GATE_CTRL_RESERVE_5_SHFT                                                                               16
#define HWIO_REO_R0_CLK_GATE_CTRL_RESERVE_4_BMSK                                                                           0x8000
#define HWIO_REO_R0_CLK_GATE_CTRL_RESERVE_4_SHFT                                                                               15
#define HWIO_REO_R0_CLK_GATE_CTRL_RESERVE_3_BMSK                                                                           0x4000
#define HWIO_REO_R0_CLK_GATE_CTRL_RESERVE_3_SHFT                                                                               14
#define HWIO_REO_R0_CLK_GATE_CTRL_RESERVE_2_BMSK                                                                           0x2000
#define HWIO_REO_R0_CLK_GATE_CTRL_RESERVE_2_SHFT                                                                               13
#define HWIO_REO_R0_CLK_GATE_CTRL_REO_CLKGATE_DISABLE_SRNG_P_BMSK                                                          0x1000
#define HWIO_REO_R0_CLK_GATE_CTRL_REO_CLKGATE_DISABLE_SRNG_P_SHFT                                                              12
#define HWIO_REO_R0_CLK_GATE_CTRL_REO_CLKGATE_DISABLE_SRNG_C_BMSK                                                           0x800
#define HWIO_REO_R0_CLK_GATE_CTRL_REO_CLKGATE_DISABLE_SRNG_C_SHFT                                                              11
#define HWIO_REO_R0_CLK_GATE_CTRL_CLOCK_ENS_EXTEND_BMSK                                                                     0x400
#define HWIO_REO_R0_CLK_GATE_CTRL_CLOCK_ENS_EXTEND_SHFT                                                                        10
#define HWIO_REO_R0_CLK_GATE_CTRL_REO_CLKGATE_DISABLE_BMSK                                                                  0x3ff
#define HWIO_REO_R0_CLK_GATE_CTRL_REO_CLKGATE_DISABLE_SHFT                                                                      0

#define HWIO_REO_R0_EVENTMASK_IX_0_ADDR(x)                                                                             ((x) + 0xd8c)
#define HWIO_REO_R0_EVENTMASK_IX_0_PHYS(x)                                                                             ((x) + 0xd8c)
#define HWIO_REO_R0_EVENTMASK_IX_0_OFFS                                                                                (0xd8c)
#define HWIO_REO_R0_EVENTMASK_IX_0_RMSK                                                                                0xffffffff
#define HWIO_REO_R0_EVENTMASK_IX_0_POR                                                                                 0x00000000
#define HWIO_REO_R0_EVENTMASK_IX_0_POR_RMSK                                                                            0xffffffff
#define HWIO_REO_R0_EVENTMASK_IX_0_ATTR                                                                                             0x3
#define HWIO_REO_R0_EVENTMASK_IX_0_IN(x)            \
                in_dword(HWIO_REO_R0_EVENTMASK_IX_0_ADDR(x))
#define HWIO_REO_R0_EVENTMASK_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_EVENTMASK_IX_0_ADDR(x), m)
#define HWIO_REO_R0_EVENTMASK_IX_0_OUT(x, v)            \
                out_dword(HWIO_REO_R0_EVENTMASK_IX_0_ADDR(x),v)
#define HWIO_REO_R0_EVENTMASK_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_EVENTMASK_IX_0_ADDR(x),m,v,HWIO_REO_R0_EVENTMASK_IX_0_IN(x))
#define HWIO_REO_R0_EVENTMASK_IX_0_MASK_BMSK                                                                           0xffffffff
#define HWIO_REO_R0_EVENTMASK_IX_0_MASK_SHFT                                                                                    0

#define HWIO_REO_R0_EVENTMASK_IX_1_ADDR(x)                                                                             ((x) + 0xd90)
#define HWIO_REO_R0_EVENTMASK_IX_1_PHYS(x)                                                                             ((x) + 0xd90)
#define HWIO_REO_R0_EVENTMASK_IX_1_OFFS                                                                                (0xd90)
#define HWIO_REO_R0_EVENTMASK_IX_1_RMSK                                                                                0xffffffff
#define HWIO_REO_R0_EVENTMASK_IX_1_POR                                                                                 0x00000000
#define HWIO_REO_R0_EVENTMASK_IX_1_POR_RMSK                                                                            0xffffffff
#define HWIO_REO_R0_EVENTMASK_IX_1_ATTR                                                                                             0x3
#define HWIO_REO_R0_EVENTMASK_IX_1_IN(x)            \
                in_dword(HWIO_REO_R0_EVENTMASK_IX_1_ADDR(x))
#define HWIO_REO_R0_EVENTMASK_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_EVENTMASK_IX_1_ADDR(x), m)
#define HWIO_REO_R0_EVENTMASK_IX_1_OUT(x, v)            \
                out_dword(HWIO_REO_R0_EVENTMASK_IX_1_ADDR(x),v)
#define HWIO_REO_R0_EVENTMASK_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_EVENTMASK_IX_1_ADDR(x),m,v,HWIO_REO_R0_EVENTMASK_IX_1_IN(x))
#define HWIO_REO_R0_EVENTMASK_IX_1_MASK_BMSK                                                                           0xffffffff
#define HWIO_REO_R0_EVENTMASK_IX_1_MASK_SHFT                                                                                    0

#define HWIO_REO_R0_EVENTMASK_IX_2_ADDR(x)                                                                             ((x) + 0xd94)
#define HWIO_REO_R0_EVENTMASK_IX_2_PHYS(x)                                                                             ((x) + 0xd94)
#define HWIO_REO_R0_EVENTMASK_IX_2_OFFS                                                                                (0xd94)
#define HWIO_REO_R0_EVENTMASK_IX_2_RMSK                                                                                0xffffffff
#define HWIO_REO_R0_EVENTMASK_IX_2_POR                                                                                 0x00000000
#define HWIO_REO_R0_EVENTMASK_IX_2_POR_RMSK                                                                            0xffffffff
#define HWIO_REO_R0_EVENTMASK_IX_2_ATTR                                                                                             0x3
#define HWIO_REO_R0_EVENTMASK_IX_2_IN(x)            \
                in_dword(HWIO_REO_R0_EVENTMASK_IX_2_ADDR(x))
#define HWIO_REO_R0_EVENTMASK_IX_2_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_EVENTMASK_IX_2_ADDR(x), m)
#define HWIO_REO_R0_EVENTMASK_IX_2_OUT(x, v)            \
                out_dword(HWIO_REO_R0_EVENTMASK_IX_2_ADDR(x),v)
#define HWIO_REO_R0_EVENTMASK_IX_2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_EVENTMASK_IX_2_ADDR(x),m,v,HWIO_REO_R0_EVENTMASK_IX_2_IN(x))
#define HWIO_REO_R0_EVENTMASK_IX_2_MASK_BMSK                                                                           0xffffffff
#define HWIO_REO_R0_EVENTMASK_IX_2_MASK_SHFT                                                                                    0

#define HWIO_REO_R0_EVENTMASK_IX_3_ADDR(x)                                                                             ((x) + 0xd98)
#define HWIO_REO_R0_EVENTMASK_IX_3_PHYS(x)                                                                             ((x) + 0xd98)
#define HWIO_REO_R0_EVENTMASK_IX_3_OFFS                                                                                (0xd98)
#define HWIO_REO_R0_EVENTMASK_IX_3_RMSK                                                                                0xffffffff
#define HWIO_REO_R0_EVENTMASK_IX_3_POR                                                                                 0x00000000
#define HWIO_REO_R0_EVENTMASK_IX_3_POR_RMSK                                                                            0xffffffff
#define HWIO_REO_R0_EVENTMASK_IX_3_ATTR                                                                                             0x3
#define HWIO_REO_R0_EVENTMASK_IX_3_IN(x)            \
                in_dword(HWIO_REO_R0_EVENTMASK_IX_3_ADDR(x))
#define HWIO_REO_R0_EVENTMASK_IX_3_INM(x, m)            \
                in_dword_masked(HWIO_REO_R0_EVENTMASK_IX_3_ADDR(x), m)
#define HWIO_REO_R0_EVENTMASK_IX_3_OUT(x, v)            \
                out_dword(HWIO_REO_R0_EVENTMASK_IX_3_ADDR(x),v)
#define HWIO_REO_R0_EVENTMASK_IX_3_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R0_EVENTMASK_IX_3_ADDR(x),m,v,HWIO_REO_R0_EVENTMASK_IX_3_IN(x))
#define HWIO_REO_R0_EVENTMASK_IX_3_MASK_BMSK                                                                           0xffffffff
#define HWIO_REO_R0_EVENTMASK_IX_3_MASK_SHFT                                                                                    0

#define HWIO_REO_R1_MISC_DEBUG_CTRL_ADDR(x)                                                                            ((x) + 0x2000)
#define HWIO_REO_R1_MISC_DEBUG_CTRL_PHYS(x)                                                                            ((x) + 0x2000)
#define HWIO_REO_R1_MISC_DEBUG_CTRL_OFFS                                                                               (0x2000)
#define HWIO_REO_R1_MISC_DEBUG_CTRL_RMSK                                                                               0xffffffff
#define HWIO_REO_R1_MISC_DEBUG_CTRL_POR                                                                                0x100771f0
#define HWIO_REO_R1_MISC_DEBUG_CTRL_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R1_MISC_DEBUG_CTRL_ATTR                                                                                            0x3
#define HWIO_REO_R1_MISC_DEBUG_CTRL_IN(x)            \
                in_dword(HWIO_REO_R1_MISC_DEBUG_CTRL_ADDR(x))
#define HWIO_REO_R1_MISC_DEBUG_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_MISC_DEBUG_CTRL_ADDR(x), m)
#define HWIO_REO_R1_MISC_DEBUG_CTRL_OUT(x, v)            \
                out_dword(HWIO_REO_R1_MISC_DEBUG_CTRL_ADDR(x),v)
#define HWIO_REO_R1_MISC_DEBUG_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R1_MISC_DEBUG_CTRL_ADDR(x),m,v,HWIO_REO_R1_MISC_DEBUG_CTRL_IN(x))
#define HWIO_REO_R1_MISC_DEBUG_CTRL_DISABLE_SW_EXCEPTION_BMSK                                                          0x80000000
#define HWIO_REO_R1_MISC_DEBUG_CTRL_DISABLE_SW_EXCEPTION_SHFT                                                                  31
#define HWIO_REO_R1_MISC_DEBUG_CTRL_IDLE_REQ_BMSK                                                                      0x40000000
#define HWIO_REO_R1_MISC_DEBUG_CTRL_IDLE_REQ_SHFT                                                                              30
#define HWIO_REO_R1_MISC_DEBUG_CTRL_CMD_FIFO_RESUME_THRESH_BMSK                                                        0x3ff00000
#define HWIO_REO_R1_MISC_DEBUG_CTRL_CMD_FIFO_RESUME_THRESH_SHFT                                                                20
#define HWIO_REO_R1_MISC_DEBUG_CTRL_CMD_FIFO_STOP_THRESH_BMSK                                                             0xffc00
#define HWIO_REO_R1_MISC_DEBUG_CTRL_CMD_FIFO_STOP_THRESH_SHFT                                                                  10
#define HWIO_REO_R1_MISC_DEBUG_CTRL_CMD_FIFO_START_THRESH_BMSK                                                              0x3ff
#define HWIO_REO_R1_MISC_DEBUG_CTRL_CMD_FIFO_START_THRESH_SHFT                                                                  0

#define HWIO_REO_R1_MISC_PERF_DEBUG_CTRL_ADDR(x)                                                                       ((x) + 0x2004)
#define HWIO_REO_R1_MISC_PERF_DEBUG_CTRL_PHYS(x)                                                                       ((x) + 0x2004)
#define HWIO_REO_R1_MISC_PERF_DEBUG_CTRL_OFFS                                                                          (0x2004)
#define HWIO_REO_R1_MISC_PERF_DEBUG_CTRL_RMSK                                                                            0xffffff
#define HWIO_REO_R1_MISC_PERF_DEBUG_CTRL_POR                                                                           0x003ff03f
#define HWIO_REO_R1_MISC_PERF_DEBUG_CTRL_POR_RMSK                                                                      0xffffffff
#define HWIO_REO_R1_MISC_PERF_DEBUG_CTRL_ATTR                                                                                       0x3
#define HWIO_REO_R1_MISC_PERF_DEBUG_CTRL_IN(x)            \
                in_dword(HWIO_REO_R1_MISC_PERF_DEBUG_CTRL_ADDR(x))
#define HWIO_REO_R1_MISC_PERF_DEBUG_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_MISC_PERF_DEBUG_CTRL_ADDR(x), m)
#define HWIO_REO_R1_MISC_PERF_DEBUG_CTRL_OUT(x, v)            \
                out_dword(HWIO_REO_R1_MISC_PERF_DEBUG_CTRL_ADDR(x),v)
#define HWIO_REO_R1_MISC_PERF_DEBUG_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R1_MISC_PERF_DEBUG_CTRL_ADDR(x),m,v,HWIO_REO_R1_MISC_PERF_DEBUG_CTRL_IN(x))
#define HWIO_REO_R1_MISC_PERF_DEBUG_CTRL_RELEASE_RING_ACCUM_DELAY_BMSK                                                   0xfff000
#define HWIO_REO_R1_MISC_PERF_DEBUG_CTRL_RELEASE_RING_ACCUM_DELAY_SHFT                                                         12
#define HWIO_REO_R1_MISC_PERF_DEBUG_CTRL_PROD_RING_ACCUM_DELAY_BMSK                                                         0xfff
#define HWIO_REO_R1_MISC_PERF_DEBUG_CTRL_PROD_RING_ACCUM_DELAY_SHFT                                                             0

#define HWIO_REO_R1_CACHE_CTL_DEBUG_CONTROL_ADDR(x)                                                                    ((x) + 0x2008)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_CONTROL_PHYS(x)                                                                    ((x) + 0x2008)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_CONTROL_OFFS                                                                       (0x2008)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_CONTROL_RMSK                                                                           0x1fff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_CONTROL_POR                                                                        0x00001000
#define HWIO_REO_R1_CACHE_CTL_DEBUG_CONTROL_POR_RMSK                                                                   0xffffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_CONTROL_ATTR                                                                                    0x3
#define HWIO_REO_R1_CACHE_CTL_DEBUG_CONTROL_IN(x)            \
                in_dword(HWIO_REO_R1_CACHE_CTL_DEBUG_CONTROL_ADDR(x))
#define HWIO_REO_R1_CACHE_CTL_DEBUG_CONTROL_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_CACHE_CTL_DEBUG_CONTROL_ADDR(x), m)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_CONTROL_OUT(x, v)            \
                out_dword(HWIO_REO_R1_CACHE_CTL_DEBUG_CONTROL_ADDR(x),v)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_CONTROL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R1_CACHE_CTL_DEBUG_CONTROL_ADDR(x),m,v,HWIO_REO_R1_CACHE_CTL_DEBUG_CONTROL_IN(x))
#define HWIO_REO_R1_CACHE_CTL_DEBUG_CONTROL_CACHE_CMD_HOLD_ACK_BMSK                                                        0x1000
#define HWIO_REO_R1_CACHE_CTL_DEBUG_CONTROL_CACHE_CMD_HOLD_ACK_SHFT                                                            12
#define HWIO_REO_R1_CACHE_CTL_DEBUG_CONTROL_CACHE_CMD_HOLD_BMSK                                                             0x800
#define HWIO_REO_R1_CACHE_CTL_DEBUG_CONTROL_CACHE_CMD_HOLD_SHFT                                                                11
#define HWIO_REO_R1_CACHE_CTL_DEBUG_CONTROL_TAG_TABLE_UPDATE_BMSK                                                           0x400
#define HWIO_REO_R1_CACHE_CTL_DEBUG_CONTROL_TAG_TABLE_UPDATE_SHFT                                                              10
#define HWIO_REO_R1_CACHE_CTL_DEBUG_CONTROL_TAG_TABLE_SEL_BMSK                                                              0x3ff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_CONTROL_TAG_TABLE_SEL_SHFT                                                                  0

#define HWIO_REO_R1_CACHE_CTL_DEBUG_HIT_COUNT_ADDR(x)                                                                  ((x) + 0x200c)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HIT_COUNT_PHYS(x)                                                                  ((x) + 0x200c)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HIT_COUNT_OFFS                                                                     (0x200c)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HIT_COUNT_RMSK                                                                     0xffffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HIT_COUNT_POR                                                                      0x00000000
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HIT_COUNT_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HIT_COUNT_ATTR                                                                                  0x3
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HIT_COUNT_IN(x)            \
                in_dword(HWIO_REO_R1_CACHE_CTL_DEBUG_HIT_COUNT_ADDR(x))
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HIT_COUNT_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_CACHE_CTL_DEBUG_HIT_COUNT_ADDR(x), m)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HIT_COUNT_OUT(x, v)            \
                out_dword(HWIO_REO_R1_CACHE_CTL_DEBUG_HIT_COUNT_ADDR(x),v)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HIT_COUNT_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R1_CACHE_CTL_DEBUG_HIT_COUNT_ADDR(x),m,v,HWIO_REO_R1_CACHE_CTL_DEBUG_HIT_COUNT_IN(x))
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HIT_COUNT_CACHE_HIT_COUNT_BMSK                                                     0xffffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HIT_COUNT_CACHE_HIT_COUNT_SHFT                                                              0

#define HWIO_REO_R1_CACHE_CTL_DEBUG_MISS_COUNT_ADDR(x)                                                                 ((x) + 0x2010)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_MISS_COUNT_PHYS(x)                                                                 ((x) + 0x2010)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_MISS_COUNT_OFFS                                                                    (0x2010)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_MISS_COUNT_RMSK                                                                      0xffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_MISS_COUNT_POR                                                                     0x00000000
#define HWIO_REO_R1_CACHE_CTL_DEBUG_MISS_COUNT_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_MISS_COUNT_ATTR                                                                                 0x3
#define HWIO_REO_R1_CACHE_CTL_DEBUG_MISS_COUNT_IN(x)            \
                in_dword(HWIO_REO_R1_CACHE_CTL_DEBUG_MISS_COUNT_ADDR(x))
#define HWIO_REO_R1_CACHE_CTL_DEBUG_MISS_COUNT_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_CACHE_CTL_DEBUG_MISS_COUNT_ADDR(x), m)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_MISS_COUNT_OUT(x, v)            \
                out_dword(HWIO_REO_R1_CACHE_CTL_DEBUG_MISS_COUNT_ADDR(x),v)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_MISS_COUNT_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R1_CACHE_CTL_DEBUG_MISS_COUNT_ADDR(x),m,v,HWIO_REO_R1_CACHE_CTL_DEBUG_MISS_COUNT_IN(x))
#define HWIO_REO_R1_CACHE_CTL_DEBUG_MISS_COUNT_CACHE_MISS_COUNT_BMSK                                                     0xffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_MISS_COUNT_CACHE_MISS_COUNT_SHFT                                                            0

#define HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_ADDR(x)                                                              ((x) + 0x2014)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_PHYS(x)                                                              ((x) + 0x2014)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_OFFS                                                                 (0x2014)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_RMSK                                                                 0xffffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_POR                                                                  0x00000000
#define HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_ATTR                                                                              0x3
#define HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_IN(x)            \
                in_dword(HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_ADDR(x))
#define HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_ADDR(x), m)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_OUT(x, v)            \
                out_dword(HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_ADDR(x),v)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_ADDR(x),m,v,HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_IN(x))
#define HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_OVERWRITE_BMSK                                                       0xffffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_OVERWRITE_SHFT                                                                0

#define HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_ADDR(x)                                                             ((x) + 0x2018)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_PHYS(x)                                                             ((x) + 0x2018)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_OFFS                                                                (0x2018)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_RMSK                                                                0xffffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_POR                                                                 0x00000000
#define HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_POR_RMSK                                                            0xffffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_ATTR                                                                             0x3
#define HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_IN(x)            \
                in_dword(HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_ADDR(x))
#define HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_ADDR(x), m)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_OUT(x, v)            \
                out_dword(HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_ADDR(x),v)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_ADDR(x),m,v,HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_IN(x))
#define HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_OVERWRITE_BMSK                                                      0xffffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_OVERWRITE_SHFT                                                               0

#define HWIO_REO_R1_CACHE_CTL_DEBUG_STM_ADDR(x)                                                                        ((x) + 0x201c)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_STM_PHYS(x)                                                                        ((x) + 0x201c)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_STM_OFFS                                                                           (0x201c)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_STM_RMSK                                                                            0x1ffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_STM_POR                                                                            0x00000000
#define HWIO_REO_R1_CACHE_CTL_DEBUG_STM_POR_RMSK                                                                       0xffffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_STM_ATTR                                                                                        0x1
#define HWIO_REO_R1_CACHE_CTL_DEBUG_STM_IN(x)            \
                in_dword(HWIO_REO_R1_CACHE_CTL_DEBUG_STM_ADDR(x))
#define HWIO_REO_R1_CACHE_CTL_DEBUG_STM_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_CACHE_CTL_DEBUG_STM_ADDR(x), m)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_STM_STATE_BMSK                                                                      0x1ffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_STM_STATE_SHFT                                                                              0

#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST_ADDR(x)                                                                  ((x) + 0x2020)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST_PHYS(x)                                                                  ((x) + 0x2020)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST_OFFS                                                                     (0x2020)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST_RMSK                                                                       0x3fffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST_POR                                                                      0x00000000
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST_POR_RMSK                                                                 0xffffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST_ATTR                                                                                  0x1
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST_IN(x)            \
                in_dword(HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST_ADDR(x))
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST_ADDR(x), m)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST_MRU_FLAG_BMSK                                                              0x3ff800
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST_MRU_FLAG_SHFT                                                                    11
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST_LRU_FLAG_BMSK                                                                 0x7ff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST_LRU_FLAG_SHFT                                                                     0

#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST1_ADDR(x)                                                                 ((x) + 0x2024)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST1_PHYS(x)                                                                 ((x) + 0x2024)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST1_OFFS                                                                    (0x2024)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST1_RMSK                                                                      0x3fffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST1_POR                                                                     0x00000000
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST1_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST1_ATTR                                                                                 0x1
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST1_IN(x)            \
                in_dword(HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST1_ADDR(x))
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST1_ADDR(x), m)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST1_HEAD_FLAG_BMSK                                                            0x3ff800
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST1_HEAD_FLAG_SHFT                                                                  11
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST1_TAIL_FLAG_BMSK                                                               0x7ff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST1_TAIL_FLAG_SHFT                                                                   0

#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST2_ADDR(x)                                                                 ((x) + 0x2028)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST2_PHYS(x)                                                                 ((x) + 0x2028)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST2_OFFS                                                                    (0x2028)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST2_RMSK                                                                      0x3fffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST2_POR                                                                     0x00000000
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST2_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST2_ATTR                                                                                 0x1
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST2_IN(x)            \
                in_dword(HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST2_ADDR(x))
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST2_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST2_ADDR(x), m)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST2_MRU_FLAG_SET2_BMSK                                                        0x3ff800
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST2_MRU_FLAG_SET2_SHFT                                                              11
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST2_LRU_FLAG_SET2_BMSK                                                           0x7ff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST2_LRU_FLAG_SET2_SHFT                                                               0

#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST3_ADDR(x)                                                                 ((x) + 0x202c)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST3_PHYS(x)                                                                 ((x) + 0x202c)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST3_OFFS                                                                    (0x202c)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST3_RMSK                                                                      0x3fffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST3_POR                                                                     0x00000000
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST3_POR_RMSK                                                                0xffffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST3_ATTR                                                                                 0x1
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST3_IN(x)            \
                in_dword(HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST3_ADDR(x))
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST3_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST3_ADDR(x), m)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST3_HEAD_FLAG_SET2_BMSK                                                       0x3ff800
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST3_HEAD_FLAG_SET2_SHFT                                                             11
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST3_TAIL_FLAG_SET2_BMSK                                                          0x7ff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_LINK_LIST3_TAIL_FLAG_SET2_SHFT                                                              0

#define HWIO_REO_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_LOW_ADDR(x)                                                            ((x) + 0x2030)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_LOW_PHYS(x)                                                            ((x) + 0x2030)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_LOW_OFFS                                                               (0x2030)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_LOW_RMSK                                                               0xffffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_LOW_POR                                                                0x00000000
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_LOW_POR_RMSK                                                           0xffffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_LOW_ATTR                                                                            0x1
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_LOW_IN(x)            \
                in_dword(HWIO_REO_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_LOW_ADDR(x))
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_LOW_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_LOW_ADDR(x), m)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_LOW_VALUE_BMSK                                                         0xffffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_LOW_VALUE_SHFT                                                                  0

#define HWIO_REO_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_HIGH_ADDR(x)                                                           ((x) + 0x2034)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_HIGH_PHYS(x)                                                           ((x) + 0x2034)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_HIGH_OFFS                                                              (0x2034)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_HIGH_RMSK                                                              0xffffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_HIGH_POR                                                               0x00000000
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_HIGH_POR_RMSK                                                          0xffffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_HIGH_ATTR                                                                           0x1
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_HIGH_IN(x)            \
                in_dword(HWIO_REO_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_HIGH_ADDR(x))
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_HIGH_ADDR(x), m)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_HIGH_VALUE_BMSK                                                        0xffffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_HIGH_VALUE_SHFT                                                                 0

#define HWIO_REO_R1_CACHE_CTL_DEBUG_EMPTY_LINE_COUNTER_ADDR(x)                                                         ((x) + 0x2038)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_EMPTY_LINE_COUNTER_PHYS(x)                                                         ((x) + 0x2038)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_EMPTY_LINE_COUNTER_OFFS                                                            (0x2038)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_EMPTY_LINE_COUNTER_RMSK                                                               0xfffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_EMPTY_LINE_COUNTER_POR                                                             0x00000000
#define HWIO_REO_R1_CACHE_CTL_DEBUG_EMPTY_LINE_COUNTER_POR_RMSK                                                        0xffffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_EMPTY_LINE_COUNTER_ATTR                                                                         0x1
#define HWIO_REO_R1_CACHE_CTL_DEBUG_EMPTY_LINE_COUNTER_IN(x)            \
                in_dword(HWIO_REO_R1_CACHE_CTL_DEBUG_EMPTY_LINE_COUNTER_ADDR(x))
#define HWIO_REO_R1_CACHE_CTL_DEBUG_EMPTY_LINE_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_CACHE_CTL_DEBUG_EMPTY_LINE_COUNTER_ADDR(x), m)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_EMPTY_LINE_COUNTER_SET2_BMSK                                                          0xffc00
#define HWIO_REO_R1_CACHE_CTL_DEBUG_EMPTY_LINE_COUNTER_SET2_SHFT                                                               10
#define HWIO_REO_R1_CACHE_CTL_DEBUG_EMPTY_LINE_COUNTER_SET1_BMSK                                                            0x3ff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_EMPTY_LINE_COUNTER_SET1_SHFT                                                                0

#define HWIO_REO_R1_CACHE_CTL_END_OF_TEST_CHECK_ADDR(x)                                                                ((x) + 0x203c)
#define HWIO_REO_R1_CACHE_CTL_END_OF_TEST_CHECK_PHYS(x)                                                                ((x) + 0x203c)
#define HWIO_REO_R1_CACHE_CTL_END_OF_TEST_CHECK_OFFS                                                                   (0x203c)
#define HWIO_REO_R1_CACHE_CTL_END_OF_TEST_CHECK_RMSK                                                                          0x1
#define HWIO_REO_R1_CACHE_CTL_END_OF_TEST_CHECK_POR                                                                    0x00000000
#define HWIO_REO_R1_CACHE_CTL_END_OF_TEST_CHECK_POR_RMSK                                                               0xffffffff
#define HWIO_REO_R1_CACHE_CTL_END_OF_TEST_CHECK_ATTR                                                                                0x3
#define HWIO_REO_R1_CACHE_CTL_END_OF_TEST_CHECK_IN(x)            \
                in_dword(HWIO_REO_R1_CACHE_CTL_END_OF_TEST_CHECK_ADDR(x))
#define HWIO_REO_R1_CACHE_CTL_END_OF_TEST_CHECK_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_CACHE_CTL_END_OF_TEST_CHECK_ADDR(x), m)
#define HWIO_REO_R1_CACHE_CTL_END_OF_TEST_CHECK_OUT(x, v)            \
                out_dword(HWIO_REO_R1_CACHE_CTL_END_OF_TEST_CHECK_ADDR(x),v)
#define HWIO_REO_R1_CACHE_CTL_END_OF_TEST_CHECK_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R1_CACHE_CTL_END_OF_TEST_CHECK_ADDR(x),m,v,HWIO_REO_R1_CACHE_CTL_END_OF_TEST_CHECK_IN(x))
#define HWIO_REO_R1_CACHE_CTL_END_OF_TEST_CHECK_END_OF_TEST_SELF_CHECK_BMSK                                                   0x1
#define HWIO_REO_R1_CACHE_CTL_END_OF_TEST_CHECK_END_OF_TEST_SELF_CHECK_SHFT                                                     0

#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_ADDR(x)                                                              ((x) + 0x2040)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_PHYS(x)                                                              ((x) + 0x2040)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_OFFS                                                                 (0x2040)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_RMSK                                                                      0x7ff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_POR                                                                  0x00000000
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_ATTR                                                                              0x3
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_IN(x)            \
                in_dword(HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_ADDR(x))
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_ADDR(x), m)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_OUT(x, v)            \
                out_dword(HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_ADDR(x),v)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_ADDR(x),m,v,HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_IN(x))
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_BACKUP_BMSK                                                               0x7f8
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_BACKUP_SHFT                                                                   3
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_FLUSH_WITHOUT_INVALIDATE_BMSK                                               0x4
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_FLUSH_WITHOUT_INVALIDATE_SHFT                                                 2
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_FLUSH_ENTIRE_CACHE_BMSK                                                     0x2
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_FLUSH_ENTIRE_CACHE_SHFT                                                       1
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_FLUSH_REQ_BMSK                                                              0x1
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_FLUSH_REQ_SHFT                                                                0

#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_ADDR(x)                                                              ((x) + 0x2044)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_PHYS(x)                                                              ((x) + 0x2044)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_OFFS                                                                 (0x2044)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_RMSK                                                                 0xffffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_POR                                                                  0x00000000
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_ATTR                                                                              0x3
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_IN(x)            \
                in_dword(HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_ADDR(x))
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_ADDR(x), m)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_OUT(x, v)            \
                out_dword(HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_ADDR(x),v)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_ADDR(x),m,v,HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_IN(x))
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_FLUSH_ADDR_31_0_BMSK                                                 0xffffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_FLUSH_ADDR_31_0_SHFT                                                          0

#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_ADDR(x)                                                              ((x) + 0x2048)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_PHYS(x)                                                              ((x) + 0x2048)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_OFFS                                                                 (0x2048)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_RMSK                                                                       0xff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_POR                                                                  0x00000000
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_POR_RMSK                                                             0xffffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_ATTR                                                                              0x3
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_IN(x)            \
                in_dword(HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_ADDR(x))
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_ADDR(x), m)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_OUT(x, v)            \
                out_dword(HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_ADDR(x),v)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_ADDR(x),m,v,HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_IN(x))
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_FLUSH_ADDR_39_32_BMSK                                                      0xff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_FLUSH_ADDR_39_32_SHFT                                                         0

#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_ADDR(x)                                                               ((x) + 0x204c)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_PHYS(x)                                                               ((x) + 0x204c)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_OFFS                                                                  (0x204c)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_RMSK                                                                  0x3fffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_POR                                                                   0x00000001
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_POR_RMSK                                                              0xffffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_ATTR                                                                               0x1
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_IN(x)            \
                in_dword(HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_ADDR(x))
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_ADDR(x), m)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_BACKUP_BMSK                                                           0x3fc00000
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_BACKUP_SHFT                                                                   22
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_FLUSH_COUNT_BMSK                                                        0x3ff000
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_FLUSH_COUNT_SHFT                                                              12
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_FLUSH_STATUS_HW_IF_BUSY_BMSK                                               0x800
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_FLUSH_STATUS_HW_IF_BUSY_SHFT                                                  11
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_FLUSH_STATUS_ERROR_BMSK                                                    0x600
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_FLUSH_STATUS_ERROR_SHFT                                                        9
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_FLUSH_STATUS_CLIENT_ID_BMSK                                                0x1e0
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_FLUSH_STATUS_CLIENT_ID_SHFT                                                    5
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_FLUSH_STATUS_DESC_TYPE_BMSK                                                 0x1c
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_FLUSH_STATUS_DESC_TYPE_SHFT                                                    2
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_FLUSH_STATUS_HIT_BMSK                                                        0x2
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_FLUSH_STATUS_HIT_SHFT                                                          1
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_FLUSH_DONE_BMSK                                                              0x1
#define HWIO_REO_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_FLUSH_DONE_SHFT                                                                0

#define HWIO_REO_R1_CACHE_CTL_DEBUG_OWNER_CHECK_ADDR(x)                                                                ((x) + 0x2050)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_OWNER_CHECK_PHYS(x)                                                                ((x) + 0x2050)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_OWNER_CHECK_OFFS                                                                   (0x2050)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_OWNER_CHECK_RMSK                                                                         0xff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_OWNER_CHECK_POR                                                                    0x00000000
#define HWIO_REO_R1_CACHE_CTL_DEBUG_OWNER_CHECK_POR_RMSK                                                               0xffffffff
#define HWIO_REO_R1_CACHE_CTL_DEBUG_OWNER_CHECK_ATTR                                                                                0x1
#define HWIO_REO_R1_CACHE_CTL_DEBUG_OWNER_CHECK_IN(x)            \
                in_dword(HWIO_REO_R1_CACHE_CTL_DEBUG_OWNER_CHECK_ADDR(x))
#define HWIO_REO_R1_CACHE_CTL_DEBUG_OWNER_CHECK_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_CACHE_CTL_DEBUG_OWNER_CHECK_ADDR(x), m)
#define HWIO_REO_R1_CACHE_CTL_DEBUG_OWNER_CHECK_ACT_ADDR_BMSK                                                                0xf0
#define HWIO_REO_R1_CACHE_CTL_DEBUG_OWNER_CHECK_ACT_ADDR_SHFT                                                                   4
#define HWIO_REO_R1_CACHE_CTL_DEBUG_OWNER_CHECK_EXP_ADDR_BMSK                                                                 0xf
#define HWIO_REO_R1_CACHE_CTL_DEBUG_OWNER_CHECK_EXP_ADDR_SHFT                                                                   0

#define HWIO_REO_R1_END_OF_TEST_CHECK_ADDR(x)                                                                          ((x) + 0x2054)
#define HWIO_REO_R1_END_OF_TEST_CHECK_PHYS(x)                                                                          ((x) + 0x2054)
#define HWIO_REO_R1_END_OF_TEST_CHECK_OFFS                                                                             (0x2054)
#define HWIO_REO_R1_END_OF_TEST_CHECK_RMSK                                                                                    0x1
#define HWIO_REO_R1_END_OF_TEST_CHECK_POR                                                                              0x00000000
#define HWIO_REO_R1_END_OF_TEST_CHECK_POR_RMSK                                                                         0xffffffff
#define HWIO_REO_R1_END_OF_TEST_CHECK_ATTR                                                                                          0x3
#define HWIO_REO_R1_END_OF_TEST_CHECK_IN(x)            \
                in_dword(HWIO_REO_R1_END_OF_TEST_CHECK_ADDR(x))
#define HWIO_REO_R1_END_OF_TEST_CHECK_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_END_OF_TEST_CHECK_ADDR(x), m)
#define HWIO_REO_R1_END_OF_TEST_CHECK_OUT(x, v)            \
                out_dword(HWIO_REO_R1_END_OF_TEST_CHECK_ADDR(x),v)
#define HWIO_REO_R1_END_OF_TEST_CHECK_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R1_END_OF_TEST_CHECK_ADDR(x),m,v,HWIO_REO_R1_END_OF_TEST_CHECK_IN(x))
#define HWIO_REO_R1_END_OF_TEST_CHECK_END_OF_TEST_SELF_CHECK_BMSK                                                             0x1
#define HWIO_REO_R1_END_OF_TEST_CHECK_END_OF_TEST_SELF_CHECK_SHFT                                                               0

#define HWIO_REO_R1_SM_ALL_IDLE_ADDR(x)                                                                                ((x) + 0x2058)
#define HWIO_REO_R1_SM_ALL_IDLE_PHYS(x)                                                                                ((x) + 0x2058)
#define HWIO_REO_R1_SM_ALL_IDLE_OFFS                                                                                   (0x2058)
#define HWIO_REO_R1_SM_ALL_IDLE_RMSK                                                                                          0x7
#define HWIO_REO_R1_SM_ALL_IDLE_POR                                                                                    0x00000001
#define HWIO_REO_R1_SM_ALL_IDLE_POR_RMSK                                                                               0xffffffff
#define HWIO_REO_R1_SM_ALL_IDLE_ATTR                                                                                                0x1
#define HWIO_REO_R1_SM_ALL_IDLE_IN(x)            \
                in_dword(HWIO_REO_R1_SM_ALL_IDLE_ADDR(x))
#define HWIO_REO_R1_SM_ALL_IDLE_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_SM_ALL_IDLE_ADDR(x), m)
#define HWIO_REO_R1_SM_ALL_IDLE_REO_ENTRANCE_RINGS_NOT_EMPTY_BMSK                                                             0x4
#define HWIO_REO_R1_SM_ALL_IDLE_REO_ENTRANCE_RINGS_NOT_EMPTY_SHFT                                                               2
#define HWIO_REO_R1_SM_ALL_IDLE_REO_IN_IDLE_BMSK                                                                              0x2
#define HWIO_REO_R1_SM_ALL_IDLE_REO_IN_IDLE_SHFT                                                                                1
#define HWIO_REO_R1_SM_ALL_IDLE_ALL_STATES_IN_IDLE_BMSK                                                                       0x1
#define HWIO_REO_R1_SM_ALL_IDLE_ALL_STATES_IN_IDLE_SHFT                                                                         0

#define HWIO_REO_R1_TESTBUS_CTRL_ADDR(x)                                                                               ((x) + 0x205c)
#define HWIO_REO_R1_TESTBUS_CTRL_PHYS(x)                                                                               ((x) + 0x205c)
#define HWIO_REO_R1_TESTBUS_CTRL_OFFS                                                                                  (0x205c)
#define HWIO_REO_R1_TESTBUS_CTRL_RMSK                                                                                        0x7f
#define HWIO_REO_R1_TESTBUS_CTRL_POR                                                                                   0x00000000
#define HWIO_REO_R1_TESTBUS_CTRL_POR_RMSK                                                                              0xffffffff
#define HWIO_REO_R1_TESTBUS_CTRL_ATTR                                                                                               0x3
#define HWIO_REO_R1_TESTBUS_CTRL_IN(x)            \
                in_dword(HWIO_REO_R1_TESTBUS_CTRL_ADDR(x))
#define HWIO_REO_R1_TESTBUS_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_TESTBUS_CTRL_ADDR(x), m)
#define HWIO_REO_R1_TESTBUS_CTRL_OUT(x, v)            \
                out_dword(HWIO_REO_R1_TESTBUS_CTRL_ADDR(x),v)
#define HWIO_REO_R1_TESTBUS_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R1_TESTBUS_CTRL_ADDR(x),m,v,HWIO_REO_R1_TESTBUS_CTRL_IN(x))
#define HWIO_REO_R1_TESTBUS_CTRL_TESTBUS_SELECT_BMSK                                                                         0x7f
#define HWIO_REO_R1_TESTBUS_CTRL_TESTBUS_SELECT_SHFT                                                                            0

#define HWIO_REO_R1_TESTBUS_LOWER_ADDR(x)                                                                              ((x) + 0x2060)
#define HWIO_REO_R1_TESTBUS_LOWER_PHYS(x)                                                                              ((x) + 0x2060)
#define HWIO_REO_R1_TESTBUS_LOWER_OFFS                                                                                 (0x2060)
#define HWIO_REO_R1_TESTBUS_LOWER_RMSK                                                                                 0xffffffff
#define HWIO_REO_R1_TESTBUS_LOWER_POR                                                                                  0x00000000
#define HWIO_REO_R1_TESTBUS_LOWER_POR_RMSK                                                                             0xffffffff
#define HWIO_REO_R1_TESTBUS_LOWER_ATTR                                                                                              0x1
#define HWIO_REO_R1_TESTBUS_LOWER_IN(x)            \
                in_dword(HWIO_REO_R1_TESTBUS_LOWER_ADDR(x))
#define HWIO_REO_R1_TESTBUS_LOWER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_TESTBUS_LOWER_ADDR(x), m)
#define HWIO_REO_R1_TESTBUS_LOWER_VALUE_BMSK                                                                           0xffffffff
#define HWIO_REO_R1_TESTBUS_LOWER_VALUE_SHFT                                                                                    0

#define HWIO_REO_R1_TESTBUS_HIGHER_ADDR(x)                                                                             ((x) + 0x2064)
#define HWIO_REO_R1_TESTBUS_HIGHER_PHYS(x)                                                                             ((x) + 0x2064)
#define HWIO_REO_R1_TESTBUS_HIGHER_OFFS                                                                                (0x2064)
#define HWIO_REO_R1_TESTBUS_HIGHER_RMSK                                                                                      0xff
#define HWIO_REO_R1_TESTBUS_HIGHER_POR                                                                                 0x00000000
#define HWIO_REO_R1_TESTBUS_HIGHER_POR_RMSK                                                                            0xffffffff
#define HWIO_REO_R1_TESTBUS_HIGHER_ATTR                                                                                             0x1
#define HWIO_REO_R1_TESTBUS_HIGHER_IN(x)            \
                in_dword(HWIO_REO_R1_TESTBUS_HIGHER_ADDR(x))
#define HWIO_REO_R1_TESTBUS_HIGHER_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_TESTBUS_HIGHER_ADDR(x), m)
#define HWIO_REO_R1_TESTBUS_HIGHER_VALUE_BMSK                                                                                0xff
#define HWIO_REO_R1_TESTBUS_HIGHER_VALUE_SHFT                                                                                   0

#define HWIO_REO_R1_SM_STATES_IX_0_ADDR(x)                                                                             ((x) + 0x2068)
#define HWIO_REO_R1_SM_STATES_IX_0_PHYS(x)                                                                             ((x) + 0x2068)
#define HWIO_REO_R1_SM_STATES_IX_0_OFFS                                                                                (0x2068)
#define HWIO_REO_R1_SM_STATES_IX_0_RMSK                                                                                0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_0_POR                                                                                 0x00000000
#define HWIO_REO_R1_SM_STATES_IX_0_POR_RMSK                                                                            0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_0_ATTR                                                                                             0x1
#define HWIO_REO_R1_SM_STATES_IX_0_IN(x)            \
                in_dword(HWIO_REO_R1_SM_STATES_IX_0_ADDR(x))
#define HWIO_REO_R1_SM_STATES_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_SM_STATES_IX_0_ADDR(x), m)
#define HWIO_REO_R1_SM_STATES_IX_0_SM_STATE_BMSK                                                                       0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_0_SM_STATE_SHFT                                                                                0

#define HWIO_REO_R1_SM_STATES_IX_1_ADDR(x)                                                                             ((x) + 0x206c)
#define HWIO_REO_R1_SM_STATES_IX_1_PHYS(x)                                                                             ((x) + 0x206c)
#define HWIO_REO_R1_SM_STATES_IX_1_OFFS                                                                                (0x206c)
#define HWIO_REO_R1_SM_STATES_IX_1_RMSK                                                                                0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_1_POR                                                                                 0x00000000
#define HWIO_REO_R1_SM_STATES_IX_1_POR_RMSK                                                                            0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_1_ATTR                                                                                             0x1
#define HWIO_REO_R1_SM_STATES_IX_1_IN(x)            \
                in_dword(HWIO_REO_R1_SM_STATES_IX_1_ADDR(x))
#define HWIO_REO_R1_SM_STATES_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_SM_STATES_IX_1_ADDR(x), m)
#define HWIO_REO_R1_SM_STATES_IX_1_SM_STATE_BMSK                                                                       0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_1_SM_STATE_SHFT                                                                                0

#define HWIO_REO_R1_SM_STATES_IX_2_ADDR(x)                                                                             ((x) + 0x2070)
#define HWIO_REO_R1_SM_STATES_IX_2_PHYS(x)                                                                             ((x) + 0x2070)
#define HWIO_REO_R1_SM_STATES_IX_2_OFFS                                                                                (0x2070)
#define HWIO_REO_R1_SM_STATES_IX_2_RMSK                                                                                0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_2_POR                                                                                 0x00000000
#define HWIO_REO_R1_SM_STATES_IX_2_POR_RMSK                                                                            0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_2_ATTR                                                                                             0x1
#define HWIO_REO_R1_SM_STATES_IX_2_IN(x)            \
                in_dword(HWIO_REO_R1_SM_STATES_IX_2_ADDR(x))
#define HWIO_REO_R1_SM_STATES_IX_2_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_SM_STATES_IX_2_ADDR(x), m)
#define HWIO_REO_R1_SM_STATES_IX_2_SM_STATE_BMSK                                                                       0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_2_SM_STATE_SHFT                                                                                0

#define HWIO_REO_R1_SM_STATES_IX_3_ADDR(x)                                                                             ((x) + 0x2074)
#define HWIO_REO_R1_SM_STATES_IX_3_PHYS(x)                                                                             ((x) + 0x2074)
#define HWIO_REO_R1_SM_STATES_IX_3_OFFS                                                                                (0x2074)
#define HWIO_REO_R1_SM_STATES_IX_3_RMSK                                                                                0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_3_POR                                                                                 0x00000000
#define HWIO_REO_R1_SM_STATES_IX_3_POR_RMSK                                                                            0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_3_ATTR                                                                                             0x1
#define HWIO_REO_R1_SM_STATES_IX_3_IN(x)            \
                in_dword(HWIO_REO_R1_SM_STATES_IX_3_ADDR(x))
#define HWIO_REO_R1_SM_STATES_IX_3_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_SM_STATES_IX_3_ADDR(x), m)
#define HWIO_REO_R1_SM_STATES_IX_3_SM_STATE_BMSK                                                                       0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_3_SM_STATE_SHFT                                                                                0

#define HWIO_REO_R1_SM_STATES_IX_4_ADDR(x)                                                                             ((x) + 0x2078)
#define HWIO_REO_R1_SM_STATES_IX_4_PHYS(x)                                                                             ((x) + 0x2078)
#define HWIO_REO_R1_SM_STATES_IX_4_OFFS                                                                                (0x2078)
#define HWIO_REO_R1_SM_STATES_IX_4_RMSK                                                                                0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_4_POR                                                                                 0x00000000
#define HWIO_REO_R1_SM_STATES_IX_4_POR_RMSK                                                                            0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_4_ATTR                                                                                             0x1
#define HWIO_REO_R1_SM_STATES_IX_4_IN(x)            \
                in_dword(HWIO_REO_R1_SM_STATES_IX_4_ADDR(x))
#define HWIO_REO_R1_SM_STATES_IX_4_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_SM_STATES_IX_4_ADDR(x), m)
#define HWIO_REO_R1_SM_STATES_IX_4_SM_STATE_BMSK                                                                       0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_4_SM_STATE_SHFT                                                                                0

#define HWIO_REO_R1_SM_STATES_IX_5_ADDR(x)                                                                             ((x) + 0x207c)
#define HWIO_REO_R1_SM_STATES_IX_5_PHYS(x)                                                                             ((x) + 0x207c)
#define HWIO_REO_R1_SM_STATES_IX_5_OFFS                                                                                (0x207c)
#define HWIO_REO_R1_SM_STATES_IX_5_RMSK                                                                                0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_5_POR                                                                                 0x00000000
#define HWIO_REO_R1_SM_STATES_IX_5_POR_RMSK                                                                            0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_5_ATTR                                                                                             0x1
#define HWIO_REO_R1_SM_STATES_IX_5_IN(x)            \
                in_dword(HWIO_REO_R1_SM_STATES_IX_5_ADDR(x))
#define HWIO_REO_R1_SM_STATES_IX_5_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_SM_STATES_IX_5_ADDR(x), m)
#define HWIO_REO_R1_SM_STATES_IX_5_SM_STATE_BMSK                                                                       0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_5_SM_STATE_SHFT                                                                                0

#define HWIO_REO_R1_SM_STATES_IX_6_ADDR(x)                                                                             ((x) + 0x2080)
#define HWIO_REO_R1_SM_STATES_IX_6_PHYS(x)                                                                             ((x) + 0x2080)
#define HWIO_REO_R1_SM_STATES_IX_6_OFFS                                                                                (0x2080)
#define HWIO_REO_R1_SM_STATES_IX_6_RMSK                                                                                0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_6_POR                                                                                 0x00000000
#define HWIO_REO_R1_SM_STATES_IX_6_POR_RMSK                                                                            0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_6_ATTR                                                                                             0x1
#define HWIO_REO_R1_SM_STATES_IX_6_IN(x)            \
                in_dword(HWIO_REO_R1_SM_STATES_IX_6_ADDR(x))
#define HWIO_REO_R1_SM_STATES_IX_6_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_SM_STATES_IX_6_ADDR(x), m)
#define HWIO_REO_R1_SM_STATES_IX_6_SM_STATE_BMSK                                                                       0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_6_SM_STATE_SHFT                                                                                0

#define HWIO_REO_R1_SM_STATES_IX_7_ADDR(x)                                                                             ((x) + 0x2084)
#define HWIO_REO_R1_SM_STATES_IX_7_PHYS(x)                                                                             ((x) + 0x2084)
#define HWIO_REO_R1_SM_STATES_IX_7_OFFS                                                                                (0x2084)
#define HWIO_REO_R1_SM_STATES_IX_7_RMSK                                                                                0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_7_POR                                                                                 0x00000000
#define HWIO_REO_R1_SM_STATES_IX_7_POR_RMSK                                                                            0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_7_ATTR                                                                                             0x1
#define HWIO_REO_R1_SM_STATES_IX_7_IN(x)            \
                in_dword(HWIO_REO_R1_SM_STATES_IX_7_ADDR(x))
#define HWIO_REO_R1_SM_STATES_IX_7_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_SM_STATES_IX_7_ADDR(x), m)
#define HWIO_REO_R1_SM_STATES_IX_7_SM_STATE_BMSK                                                                       0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_7_SM_STATE_SHFT                                                                                0

#define HWIO_REO_R1_SM_STATES_IX_8_ADDR(x)                                                                             ((x) + 0x2088)
#define HWIO_REO_R1_SM_STATES_IX_8_PHYS(x)                                                                             ((x) + 0x2088)
#define HWIO_REO_R1_SM_STATES_IX_8_OFFS                                                                                (0x2088)
#define HWIO_REO_R1_SM_STATES_IX_8_RMSK                                                                                0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_8_POR                                                                                 0x00000000
#define HWIO_REO_R1_SM_STATES_IX_8_POR_RMSK                                                                            0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_8_ATTR                                                                                             0x1
#define HWIO_REO_R1_SM_STATES_IX_8_IN(x)            \
                in_dword(HWIO_REO_R1_SM_STATES_IX_8_ADDR(x))
#define HWIO_REO_R1_SM_STATES_IX_8_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_SM_STATES_IX_8_ADDR(x), m)
#define HWIO_REO_R1_SM_STATES_IX_8_SM_STATE_BMSK                                                                       0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_8_SM_STATE_SHFT                                                                                0

#define HWIO_REO_R1_SM_STATES_IX_9_ADDR(x)                                                                             ((x) + 0x208c)
#define HWIO_REO_R1_SM_STATES_IX_9_PHYS(x)                                                                             ((x) + 0x208c)
#define HWIO_REO_R1_SM_STATES_IX_9_OFFS                                                                                (0x208c)
#define HWIO_REO_R1_SM_STATES_IX_9_RMSK                                                                                0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_9_POR                                                                                 0x00000000
#define HWIO_REO_R1_SM_STATES_IX_9_POR_RMSK                                                                            0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_9_ATTR                                                                                             0x1
#define HWIO_REO_R1_SM_STATES_IX_9_IN(x)            \
                in_dword(HWIO_REO_R1_SM_STATES_IX_9_ADDR(x))
#define HWIO_REO_R1_SM_STATES_IX_9_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_SM_STATES_IX_9_ADDR(x), m)
#define HWIO_REO_R1_SM_STATES_IX_9_SM_STATE_BMSK                                                                       0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_9_SM_STATE_SHFT                                                                                0

#define HWIO_REO_R1_SM_STATES_IX_10_ADDR(x)                                                                            ((x) + 0x2090)
#define HWIO_REO_R1_SM_STATES_IX_10_PHYS(x)                                                                            ((x) + 0x2090)
#define HWIO_REO_R1_SM_STATES_IX_10_OFFS                                                                               (0x2090)
#define HWIO_REO_R1_SM_STATES_IX_10_RMSK                                                                               0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_10_POR                                                                                0x00000000
#define HWIO_REO_R1_SM_STATES_IX_10_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_10_ATTR                                                                                            0x1
#define HWIO_REO_R1_SM_STATES_IX_10_IN(x)            \
                in_dword(HWIO_REO_R1_SM_STATES_IX_10_ADDR(x))
#define HWIO_REO_R1_SM_STATES_IX_10_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_SM_STATES_IX_10_ADDR(x), m)
#define HWIO_REO_R1_SM_STATES_IX_10_SM_STATE_BMSK                                                                      0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_10_SM_STATE_SHFT                                                                               0

#define HWIO_REO_R1_SM_STATES_IX_11_ADDR(x)                                                                            ((x) + 0x2094)
#define HWIO_REO_R1_SM_STATES_IX_11_PHYS(x)                                                                            ((x) + 0x2094)
#define HWIO_REO_R1_SM_STATES_IX_11_OFFS                                                                               (0x2094)
#define HWIO_REO_R1_SM_STATES_IX_11_RMSK                                                                               0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_11_POR                                                                                0x00000000
#define HWIO_REO_R1_SM_STATES_IX_11_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_11_ATTR                                                                                            0x1
#define HWIO_REO_R1_SM_STATES_IX_11_IN(x)            \
                in_dword(HWIO_REO_R1_SM_STATES_IX_11_ADDR(x))
#define HWIO_REO_R1_SM_STATES_IX_11_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_SM_STATES_IX_11_ADDR(x), m)
#define HWIO_REO_R1_SM_STATES_IX_11_SM_STATE_BMSK                                                                      0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_11_SM_STATE_SHFT                                                                               0

#define HWIO_REO_R1_SM_STATES_IX_12_ADDR(x)                                                                            ((x) + 0x2098)
#define HWIO_REO_R1_SM_STATES_IX_12_PHYS(x)                                                                            ((x) + 0x2098)
#define HWIO_REO_R1_SM_STATES_IX_12_OFFS                                                                               (0x2098)
#define HWIO_REO_R1_SM_STATES_IX_12_RMSK                                                                               0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_12_POR                                                                                0x00000000
#define HWIO_REO_R1_SM_STATES_IX_12_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_12_ATTR                                                                                            0x1
#define HWIO_REO_R1_SM_STATES_IX_12_IN(x)            \
                in_dword(HWIO_REO_R1_SM_STATES_IX_12_ADDR(x))
#define HWIO_REO_R1_SM_STATES_IX_12_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_SM_STATES_IX_12_ADDR(x), m)
#define HWIO_REO_R1_SM_STATES_IX_12_SM_STATE_BMSK                                                                      0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_12_SM_STATE_SHFT                                                                               0

#define HWIO_REO_R1_SM_STATES_IX_13_ADDR(x)                                                                            ((x) + 0x209c)
#define HWIO_REO_R1_SM_STATES_IX_13_PHYS(x)                                                                            ((x) + 0x209c)
#define HWIO_REO_R1_SM_STATES_IX_13_OFFS                                                                               (0x209c)
#define HWIO_REO_R1_SM_STATES_IX_13_RMSK                                                                               0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_13_POR                                                                                0x00000000
#define HWIO_REO_R1_SM_STATES_IX_13_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_13_ATTR                                                                                            0x1
#define HWIO_REO_R1_SM_STATES_IX_13_IN(x)            \
                in_dword(HWIO_REO_R1_SM_STATES_IX_13_ADDR(x))
#define HWIO_REO_R1_SM_STATES_IX_13_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_SM_STATES_IX_13_ADDR(x), m)
#define HWIO_REO_R1_SM_STATES_IX_13_SM_STATE_BMSK                                                                      0xffffffff
#define HWIO_REO_R1_SM_STATES_IX_13_SM_STATE_SHFT                                                                               0

#define HWIO_REO_R1_IDLE_STATES_IX_0_ADDR(x)                                                                           ((x) + 0x20a0)
#define HWIO_REO_R1_IDLE_STATES_IX_0_PHYS(x)                                                                           ((x) + 0x20a0)
#define HWIO_REO_R1_IDLE_STATES_IX_0_OFFS                                                                              (0x20a0)
#define HWIO_REO_R1_IDLE_STATES_IX_0_RMSK                                                                              0xffffffff
#define HWIO_REO_R1_IDLE_STATES_IX_0_POR                                                                               0x00000000
#define HWIO_REO_R1_IDLE_STATES_IX_0_POR_RMSK                                                                          0xffffffff
#define HWIO_REO_R1_IDLE_STATES_IX_0_ATTR                                                                                           0x1
#define HWIO_REO_R1_IDLE_STATES_IX_0_IN(x)            \
                in_dword(HWIO_REO_R1_IDLE_STATES_IX_0_ADDR(x))
#define HWIO_REO_R1_IDLE_STATES_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_IDLE_STATES_IX_0_ADDR(x), m)
#define HWIO_REO_R1_IDLE_STATES_IX_0_IDLE_STATE_BMSK                                                                   0xffffffff
#define HWIO_REO_R1_IDLE_STATES_IX_0_IDLE_STATE_SHFT                                                                            0

#define HWIO_REO_R1_IDLE_STATES_IX_1_ADDR(x)                                                                           ((x) + 0x20a4)
#define HWIO_REO_R1_IDLE_STATES_IX_1_PHYS(x)                                                                           ((x) + 0x20a4)
#define HWIO_REO_R1_IDLE_STATES_IX_1_OFFS                                                                              (0x20a4)
#define HWIO_REO_R1_IDLE_STATES_IX_1_RMSK                                                                              0xffffffff
#define HWIO_REO_R1_IDLE_STATES_IX_1_POR                                                                               0x00000000
#define HWIO_REO_R1_IDLE_STATES_IX_1_POR_RMSK                                                                          0xffffffff
#define HWIO_REO_R1_IDLE_STATES_IX_1_ATTR                                                                                           0x1
#define HWIO_REO_R1_IDLE_STATES_IX_1_IN(x)            \
                in_dword(HWIO_REO_R1_IDLE_STATES_IX_1_ADDR(x))
#define HWIO_REO_R1_IDLE_STATES_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_IDLE_STATES_IX_1_ADDR(x), m)
#define HWIO_REO_R1_IDLE_STATES_IX_1_IDLE_STATE_BMSK                                                                   0xffffffff
#define HWIO_REO_R1_IDLE_STATES_IX_1_IDLE_STATE_SHFT                                                                            0

#define HWIO_REO_R1_MISC_DEBUG_STATUS_ADDR(x)                                                                          ((x) + 0x20a8)
#define HWIO_REO_R1_MISC_DEBUG_STATUS_PHYS(x)                                                                          ((x) + 0x20a8)
#define HWIO_REO_R1_MISC_DEBUG_STATUS_OFFS                                                                             (0x20a8)
#define HWIO_REO_R1_MISC_DEBUG_STATUS_RMSK                                                                                   0x3f
#define HWIO_REO_R1_MISC_DEBUG_STATUS_POR                                                                              0x00000000
#define HWIO_REO_R1_MISC_DEBUG_STATUS_POR_RMSK                                                                         0xffffffff
#define HWIO_REO_R1_MISC_DEBUG_STATUS_ATTR                                                                                          0x1
#define HWIO_REO_R1_MISC_DEBUG_STATUS_IN(x)            \
                in_dword(HWIO_REO_R1_MISC_DEBUG_STATUS_ADDR(x))
#define HWIO_REO_R1_MISC_DEBUG_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_MISC_DEBUG_STATUS_ADDR(x), m)
#define HWIO_REO_R1_MISC_DEBUG_STATUS_BUF_COUNT_EXCEEDED_FLAG_2_BMSK                                                         0x20
#define HWIO_REO_R1_MISC_DEBUG_STATUS_BUF_COUNT_EXCEEDED_FLAG_2_SHFT                                                            5
#define HWIO_REO_R1_MISC_DEBUG_STATUS_TMP_FIFO_FULL_2_BMSK                                                                   0x10
#define HWIO_REO_R1_MISC_DEBUG_STATUS_TMP_FIFO_FULL_2_SHFT                                                                      4
#define HWIO_REO_R1_MISC_DEBUG_STATUS_TMP_CMD_FIFO_FULL_2_BMSK                                                                0x8
#define HWIO_REO_R1_MISC_DEBUG_STATUS_TMP_CMD_FIFO_FULL_2_SHFT                                                                  3
#define HWIO_REO_R1_MISC_DEBUG_STATUS_BUF_COUNT_EXCEEDED_FLAG_BMSK                                                            0x4
#define HWIO_REO_R1_MISC_DEBUG_STATUS_BUF_COUNT_EXCEEDED_FLAG_SHFT                                                              2
#define HWIO_REO_R1_MISC_DEBUG_STATUS_TMP_FIFO_FULL_BMSK                                                                      0x2
#define HWIO_REO_R1_MISC_DEBUG_STATUS_TMP_FIFO_FULL_SHFT                                                                        1
#define HWIO_REO_R1_MISC_DEBUG_STATUS_TMP_CMD_FIFO_FULL_BMSK                                                                  0x1
#define HWIO_REO_R1_MISC_DEBUG_STATUS_TMP_CMD_FIFO_FULL_SHFT                                                                    0

#define HWIO_REO_R1_DEBUG_COUNTER_MSDU_BUF_COUNT_EXCEEDED_ADDR(x)                                                      ((x) + 0x20ac)
#define HWIO_REO_R1_DEBUG_COUNTER_MSDU_BUF_COUNT_EXCEEDED_PHYS(x)                                                      ((x) + 0x20ac)
#define HWIO_REO_R1_DEBUG_COUNTER_MSDU_BUF_COUNT_EXCEEDED_OFFS                                                         (0x20ac)
#define HWIO_REO_R1_DEBUG_COUNTER_MSDU_BUF_COUNT_EXCEEDED_RMSK                                                         0xffffffff
#define HWIO_REO_R1_DEBUG_COUNTER_MSDU_BUF_COUNT_EXCEEDED_POR                                                          0x00000000
#define HWIO_REO_R1_DEBUG_COUNTER_MSDU_BUF_COUNT_EXCEEDED_POR_RMSK                                                     0xffffffff
#define HWIO_REO_R1_DEBUG_COUNTER_MSDU_BUF_COUNT_EXCEEDED_ATTR                                                                      0x3
#define HWIO_REO_R1_DEBUG_COUNTER_MSDU_BUF_COUNT_EXCEEDED_IN(x)            \
                in_dword(HWIO_REO_R1_DEBUG_COUNTER_MSDU_BUF_COUNT_EXCEEDED_ADDR(x))
#define HWIO_REO_R1_DEBUG_COUNTER_MSDU_BUF_COUNT_EXCEEDED_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_DEBUG_COUNTER_MSDU_BUF_COUNT_EXCEEDED_ADDR(x), m)
#define HWIO_REO_R1_DEBUG_COUNTER_MSDU_BUF_COUNT_EXCEEDED_OUT(x, v)            \
                out_dword(HWIO_REO_R1_DEBUG_COUNTER_MSDU_BUF_COUNT_EXCEEDED_ADDR(x),v)
#define HWIO_REO_R1_DEBUG_COUNTER_MSDU_BUF_COUNT_EXCEEDED_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R1_DEBUG_COUNTER_MSDU_BUF_COUNT_EXCEEDED_ADDR(x),m,v,HWIO_REO_R1_DEBUG_COUNTER_MSDU_BUF_COUNT_EXCEEDED_IN(x))
#define HWIO_REO_R1_DEBUG_COUNTER_MSDU_BUF_COUNT_EXCEEDED_COUNT_BMSK                                                   0xffffffff
#define HWIO_REO_R1_DEBUG_COUNTER_MSDU_BUF_COUNT_EXCEEDED_COUNT_SHFT                                                            0

#define HWIO_REO_R1_INVALID_APB_ACCESS_ADDR(x)                                                                         ((x) + 0x20b0)
#define HWIO_REO_R1_INVALID_APB_ACCESS_PHYS(x)                                                                         ((x) + 0x20b0)
#define HWIO_REO_R1_INVALID_APB_ACCESS_OFFS                                                                            (0x20b0)
#define HWIO_REO_R1_INVALID_APB_ACCESS_RMSK                                                                               0x7ffff
#define HWIO_REO_R1_INVALID_APB_ACCESS_POR                                                                             0x00000000
#define HWIO_REO_R1_INVALID_APB_ACCESS_POR_RMSK                                                                        0xffffffff
#define HWIO_REO_R1_INVALID_APB_ACCESS_ATTR                                                                                         0x3
#define HWIO_REO_R1_INVALID_APB_ACCESS_IN(x)            \
                in_dword(HWIO_REO_R1_INVALID_APB_ACCESS_ADDR(x))
#define HWIO_REO_R1_INVALID_APB_ACCESS_INM(x, m)            \
                in_dword_masked(HWIO_REO_R1_INVALID_APB_ACCESS_ADDR(x), m)
#define HWIO_REO_R1_INVALID_APB_ACCESS_OUT(x, v)            \
                out_dword(HWIO_REO_R1_INVALID_APB_ACCESS_ADDR(x),v)
#define HWIO_REO_R1_INVALID_APB_ACCESS_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R1_INVALID_APB_ACCESS_ADDR(x),m,v,HWIO_REO_R1_INVALID_APB_ACCESS_IN(x))
#define HWIO_REO_R1_INVALID_APB_ACCESS_ERR_TYPE_BMSK                                                                      0x60000
#define HWIO_REO_R1_INVALID_APB_ACCESS_ERR_TYPE_SHFT                                                                           17
#define HWIO_REO_R1_INVALID_APB_ACCESS_ERR_ADDR_BMSK                                                                      0x1ffff
#define HWIO_REO_R1_INVALID_APB_ACCESS_ERR_ADDR_SHFT                                                                            0

#define HWIO_REO_R2_RXDMA2REO0_RING_HP_ADDR(x)                                                                         ((x) + 0x3000)
#define HWIO_REO_R2_RXDMA2REO0_RING_HP_PHYS(x)                                                                         ((x) + 0x3000)
#define HWIO_REO_R2_RXDMA2REO0_RING_HP_OFFS                                                                            (0x3000)
#define HWIO_REO_R2_RXDMA2REO0_RING_HP_RMSK                                                                                0xffff
#define HWIO_REO_R2_RXDMA2REO0_RING_HP_POR                                                                             0x00000000
#define HWIO_REO_R2_RXDMA2REO0_RING_HP_POR_RMSK                                                                        0xffffffff
#define HWIO_REO_R2_RXDMA2REO0_RING_HP_ATTR                                                                                         0x3
#define HWIO_REO_R2_RXDMA2REO0_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_RXDMA2REO0_RING_HP_ADDR(x))
#define HWIO_REO_R2_RXDMA2REO0_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_RXDMA2REO0_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_RXDMA2REO0_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_RXDMA2REO0_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_RXDMA2REO0_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_RXDMA2REO0_RING_HP_ADDR(x),m,v,HWIO_REO_R2_RXDMA2REO0_RING_HP_IN(x))
#define HWIO_REO_R2_RXDMA2REO0_RING_HP_HEAD_PTR_BMSK                                                                       0xffff
#define HWIO_REO_R2_RXDMA2REO0_RING_HP_HEAD_PTR_SHFT                                                                            0

#define HWIO_REO_R2_RXDMA2REO0_RING_TP_ADDR(x)                                                                         ((x) + 0x3004)
#define HWIO_REO_R2_RXDMA2REO0_RING_TP_PHYS(x)                                                                         ((x) + 0x3004)
#define HWIO_REO_R2_RXDMA2REO0_RING_TP_OFFS                                                                            (0x3004)
#define HWIO_REO_R2_RXDMA2REO0_RING_TP_RMSK                                                                                0xffff
#define HWIO_REO_R2_RXDMA2REO0_RING_TP_POR                                                                             0x00000000
#define HWIO_REO_R2_RXDMA2REO0_RING_TP_POR_RMSK                                                                        0xffffffff
#define HWIO_REO_R2_RXDMA2REO0_RING_TP_ATTR                                                                                         0x3
#define HWIO_REO_R2_RXDMA2REO0_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_RXDMA2REO0_RING_TP_ADDR(x))
#define HWIO_REO_R2_RXDMA2REO0_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_RXDMA2REO0_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_RXDMA2REO0_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_RXDMA2REO0_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_RXDMA2REO0_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_RXDMA2REO0_RING_TP_ADDR(x),m,v,HWIO_REO_R2_RXDMA2REO0_RING_TP_IN(x))
#define HWIO_REO_R2_RXDMA2REO0_RING_TP_TAIL_PTR_BMSK                                                                       0xffff
#define HWIO_REO_R2_RXDMA2REO0_RING_TP_TAIL_PTR_SHFT                                                                            0

#define HWIO_REO_R2_RXDMA2REO_MLO1_RING_HP_ADDR(x)                                                                     ((x) + 0x3008)
#define HWIO_REO_R2_RXDMA2REO_MLO1_RING_HP_PHYS(x)                                                                     ((x) + 0x3008)
#define HWIO_REO_R2_RXDMA2REO_MLO1_RING_HP_OFFS                                                                        (0x3008)
#define HWIO_REO_R2_RXDMA2REO_MLO1_RING_HP_RMSK                                                                            0xffff
#define HWIO_REO_R2_RXDMA2REO_MLO1_RING_HP_POR                                                                         0x00000000
#define HWIO_REO_R2_RXDMA2REO_MLO1_RING_HP_POR_RMSK                                                                    0xffffffff
#define HWIO_REO_R2_RXDMA2REO_MLO1_RING_HP_ATTR                                                                                     0x3
#define HWIO_REO_R2_RXDMA2REO_MLO1_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_RXDMA2REO_MLO1_RING_HP_ADDR(x))
#define HWIO_REO_R2_RXDMA2REO_MLO1_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_RXDMA2REO_MLO1_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_RXDMA2REO_MLO1_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_RXDMA2REO_MLO1_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_RXDMA2REO_MLO1_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_RXDMA2REO_MLO1_RING_HP_ADDR(x),m,v,HWIO_REO_R2_RXDMA2REO_MLO1_RING_HP_IN(x))
#define HWIO_REO_R2_RXDMA2REO_MLO1_RING_HP_HEAD_PTR_BMSK                                                                   0xffff
#define HWIO_REO_R2_RXDMA2REO_MLO1_RING_HP_HEAD_PTR_SHFT                                                                        0

#define HWIO_REO_R2_RXDMA2REO_MLO1_RING_TP_ADDR(x)                                                                     ((x) + 0x300c)
#define HWIO_REO_R2_RXDMA2REO_MLO1_RING_TP_PHYS(x)                                                                     ((x) + 0x300c)
#define HWIO_REO_R2_RXDMA2REO_MLO1_RING_TP_OFFS                                                                        (0x300c)
#define HWIO_REO_R2_RXDMA2REO_MLO1_RING_TP_RMSK                                                                            0xffff
#define HWIO_REO_R2_RXDMA2REO_MLO1_RING_TP_POR                                                                         0x00000000
#define HWIO_REO_R2_RXDMA2REO_MLO1_RING_TP_POR_RMSK                                                                    0xffffffff
#define HWIO_REO_R2_RXDMA2REO_MLO1_RING_TP_ATTR                                                                                     0x3
#define HWIO_REO_R2_RXDMA2REO_MLO1_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_RXDMA2REO_MLO1_RING_TP_ADDR(x))
#define HWIO_REO_R2_RXDMA2REO_MLO1_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_RXDMA2REO_MLO1_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_RXDMA2REO_MLO1_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_RXDMA2REO_MLO1_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_RXDMA2REO_MLO1_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_RXDMA2REO_MLO1_RING_TP_ADDR(x),m,v,HWIO_REO_R2_RXDMA2REO_MLO1_RING_TP_IN(x))
#define HWIO_REO_R2_RXDMA2REO_MLO1_RING_TP_TAIL_PTR_BMSK                                                                   0xffff
#define HWIO_REO_R2_RXDMA2REO_MLO1_RING_TP_TAIL_PTR_SHFT                                                                        0

#define HWIO_REO_R2_RXDMA2REO_MLO2_RING_HP_ADDR(x)                                                                     ((x) + 0x3010)
#define HWIO_REO_R2_RXDMA2REO_MLO2_RING_HP_PHYS(x)                                                                     ((x) + 0x3010)
#define HWIO_REO_R2_RXDMA2REO_MLO2_RING_HP_OFFS                                                                        (0x3010)
#define HWIO_REO_R2_RXDMA2REO_MLO2_RING_HP_RMSK                                                                            0xffff
#define HWIO_REO_R2_RXDMA2REO_MLO2_RING_HP_POR                                                                         0x00000000
#define HWIO_REO_R2_RXDMA2REO_MLO2_RING_HP_POR_RMSK                                                                    0xffffffff
#define HWIO_REO_R2_RXDMA2REO_MLO2_RING_HP_ATTR                                                                                     0x3
#define HWIO_REO_R2_RXDMA2REO_MLO2_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_RXDMA2REO_MLO2_RING_HP_ADDR(x))
#define HWIO_REO_R2_RXDMA2REO_MLO2_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_RXDMA2REO_MLO2_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_RXDMA2REO_MLO2_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_RXDMA2REO_MLO2_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_RXDMA2REO_MLO2_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_RXDMA2REO_MLO2_RING_HP_ADDR(x),m,v,HWIO_REO_R2_RXDMA2REO_MLO2_RING_HP_IN(x))
#define HWIO_REO_R2_RXDMA2REO_MLO2_RING_HP_HEAD_PTR_BMSK                                                                   0xffff
#define HWIO_REO_R2_RXDMA2REO_MLO2_RING_HP_HEAD_PTR_SHFT                                                                        0

#define HWIO_REO_R2_RXDMA2REO_MLO2_RING_TP_ADDR(x)                                                                     ((x) + 0x3014)
#define HWIO_REO_R2_RXDMA2REO_MLO2_RING_TP_PHYS(x)                                                                     ((x) + 0x3014)
#define HWIO_REO_R2_RXDMA2REO_MLO2_RING_TP_OFFS                                                                        (0x3014)
#define HWIO_REO_R2_RXDMA2REO_MLO2_RING_TP_RMSK                                                                            0xffff
#define HWIO_REO_R2_RXDMA2REO_MLO2_RING_TP_POR                                                                         0x00000000
#define HWIO_REO_R2_RXDMA2REO_MLO2_RING_TP_POR_RMSK                                                                    0xffffffff
#define HWIO_REO_R2_RXDMA2REO_MLO2_RING_TP_ATTR                                                                                     0x3
#define HWIO_REO_R2_RXDMA2REO_MLO2_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_RXDMA2REO_MLO2_RING_TP_ADDR(x))
#define HWIO_REO_R2_RXDMA2REO_MLO2_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_RXDMA2REO_MLO2_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_RXDMA2REO_MLO2_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_RXDMA2REO_MLO2_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_RXDMA2REO_MLO2_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_RXDMA2REO_MLO2_RING_TP_ADDR(x),m,v,HWIO_REO_R2_RXDMA2REO_MLO2_RING_TP_IN(x))
#define HWIO_REO_R2_RXDMA2REO_MLO2_RING_TP_TAIL_PTR_BMSK                                                                   0xffff
#define HWIO_REO_R2_RXDMA2REO_MLO2_RING_TP_TAIL_PTR_SHFT                                                                        0

#define HWIO_REO_R2_WBM2REO_LINK_RING_HP_ADDR(x)                                                                       ((x) + 0x3018)
#define HWIO_REO_R2_WBM2REO_LINK_RING_HP_PHYS(x)                                                                       ((x) + 0x3018)
#define HWIO_REO_R2_WBM2REO_LINK_RING_HP_OFFS                                                                          (0x3018)
#define HWIO_REO_R2_WBM2REO_LINK_RING_HP_RMSK                                                                              0xffff
#define HWIO_REO_R2_WBM2REO_LINK_RING_HP_POR                                                                           0x00000000
#define HWIO_REO_R2_WBM2REO_LINK_RING_HP_POR_RMSK                                                                      0xffffffff
#define HWIO_REO_R2_WBM2REO_LINK_RING_HP_ATTR                                                                                       0x3
#define HWIO_REO_R2_WBM2REO_LINK_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_WBM2REO_LINK_RING_HP_ADDR(x))
#define HWIO_REO_R2_WBM2REO_LINK_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_WBM2REO_LINK_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_WBM2REO_LINK_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_WBM2REO_LINK_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_WBM2REO_LINK_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_WBM2REO_LINK_RING_HP_ADDR(x),m,v,HWIO_REO_R2_WBM2REO_LINK_RING_HP_IN(x))
#define HWIO_REO_R2_WBM2REO_LINK_RING_HP_HEAD_PTR_BMSK                                                                     0xffff
#define HWIO_REO_R2_WBM2REO_LINK_RING_HP_HEAD_PTR_SHFT                                                                          0

#define HWIO_REO_R2_WBM2REO_LINK_RING_TP_ADDR(x)                                                                       ((x) + 0x301c)
#define HWIO_REO_R2_WBM2REO_LINK_RING_TP_PHYS(x)                                                                       ((x) + 0x301c)
#define HWIO_REO_R2_WBM2REO_LINK_RING_TP_OFFS                                                                          (0x301c)
#define HWIO_REO_R2_WBM2REO_LINK_RING_TP_RMSK                                                                              0xffff
#define HWIO_REO_R2_WBM2REO_LINK_RING_TP_POR                                                                           0x00000000
#define HWIO_REO_R2_WBM2REO_LINK_RING_TP_POR_RMSK                                                                      0xffffffff
#define HWIO_REO_R2_WBM2REO_LINK_RING_TP_ATTR                                                                                       0x3
#define HWIO_REO_R2_WBM2REO_LINK_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_WBM2REO_LINK_RING_TP_ADDR(x))
#define HWIO_REO_R2_WBM2REO_LINK_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_WBM2REO_LINK_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_WBM2REO_LINK_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_WBM2REO_LINK_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_WBM2REO_LINK_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_WBM2REO_LINK_RING_TP_ADDR(x),m,v,HWIO_REO_R2_WBM2REO_LINK_RING_TP_IN(x))
#define HWIO_REO_R2_WBM2REO_LINK_RING_TP_TAIL_PTR_BMSK                                                                     0xffff
#define HWIO_REO_R2_WBM2REO_LINK_RING_TP_TAIL_PTR_SHFT                                                                          0

#define HWIO_REO_R2_REO_CMD_RING_HP_ADDR(x)                                                                            ((x) + 0x3020)
#define HWIO_REO_R2_REO_CMD_RING_HP_PHYS(x)                                                                            ((x) + 0x3020)
#define HWIO_REO_R2_REO_CMD_RING_HP_OFFS                                                                               (0x3020)
#define HWIO_REO_R2_REO_CMD_RING_HP_RMSK                                                                                   0xffff
#define HWIO_REO_R2_REO_CMD_RING_HP_POR                                                                                0x00000000
#define HWIO_REO_R2_REO_CMD_RING_HP_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R2_REO_CMD_RING_HP_ATTR                                                                                            0x3
#define HWIO_REO_R2_REO_CMD_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_REO_CMD_RING_HP_ADDR(x))
#define HWIO_REO_R2_REO_CMD_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO_CMD_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_REO_CMD_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO_CMD_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_REO_CMD_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO_CMD_RING_HP_ADDR(x),m,v,HWIO_REO_R2_REO_CMD_RING_HP_IN(x))
#define HWIO_REO_R2_REO_CMD_RING_HP_HEAD_PTR_BMSK                                                                          0xffff
#define HWIO_REO_R2_REO_CMD_RING_HP_HEAD_PTR_SHFT                                                                               0

#define HWIO_REO_R2_REO_CMD_RING_TP_ADDR(x)                                                                            ((x) + 0x3024)
#define HWIO_REO_R2_REO_CMD_RING_TP_PHYS(x)                                                                            ((x) + 0x3024)
#define HWIO_REO_R2_REO_CMD_RING_TP_OFFS                                                                               (0x3024)
#define HWIO_REO_R2_REO_CMD_RING_TP_RMSK                                                                                   0xffff
#define HWIO_REO_R2_REO_CMD_RING_TP_POR                                                                                0x00000000
#define HWIO_REO_R2_REO_CMD_RING_TP_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R2_REO_CMD_RING_TP_ATTR                                                                                            0x3
#define HWIO_REO_R2_REO_CMD_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_REO_CMD_RING_TP_ADDR(x))
#define HWIO_REO_R2_REO_CMD_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO_CMD_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_REO_CMD_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO_CMD_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_REO_CMD_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO_CMD_RING_TP_ADDR(x),m,v,HWIO_REO_R2_REO_CMD_RING_TP_IN(x))
#define HWIO_REO_R2_REO_CMD_RING_TP_TAIL_PTR_BMSK                                                                          0xffff
#define HWIO_REO_R2_REO_CMD_RING_TP_TAIL_PTR_SHFT                                                                               0

#define HWIO_REO_R2_SW2REO_RING_HP_ADDR(x)                                                                             ((x) + 0x3028)
#define HWIO_REO_R2_SW2REO_RING_HP_PHYS(x)                                                                             ((x) + 0x3028)
#define HWIO_REO_R2_SW2REO_RING_HP_OFFS                                                                                (0x3028)
#define HWIO_REO_R2_SW2REO_RING_HP_RMSK                                                                                    0xffff
#define HWIO_REO_R2_SW2REO_RING_HP_POR                                                                                 0x00000000
#define HWIO_REO_R2_SW2REO_RING_HP_POR_RMSK                                                                            0xffffffff
#define HWIO_REO_R2_SW2REO_RING_HP_ATTR                                                                                             0x3
#define HWIO_REO_R2_SW2REO_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_SW2REO_RING_HP_ADDR(x))
#define HWIO_REO_R2_SW2REO_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_SW2REO_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_SW2REO_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_SW2REO_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_SW2REO_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_SW2REO_RING_HP_ADDR(x),m,v,HWIO_REO_R2_SW2REO_RING_HP_IN(x))
#define HWIO_REO_R2_SW2REO_RING_HP_HEAD_PTR_BMSK                                                                           0xffff
#define HWIO_REO_R2_SW2REO_RING_HP_HEAD_PTR_SHFT                                                                                0

#define HWIO_REO_R2_SW2REO_RING_TP_ADDR(x)                                                                             ((x) + 0x302c)
#define HWIO_REO_R2_SW2REO_RING_TP_PHYS(x)                                                                             ((x) + 0x302c)
#define HWIO_REO_R2_SW2REO_RING_TP_OFFS                                                                                (0x302c)
#define HWIO_REO_R2_SW2REO_RING_TP_RMSK                                                                                    0xffff
#define HWIO_REO_R2_SW2REO_RING_TP_POR                                                                                 0x00000000
#define HWIO_REO_R2_SW2REO_RING_TP_POR_RMSK                                                                            0xffffffff
#define HWIO_REO_R2_SW2REO_RING_TP_ATTR                                                                                             0x3
#define HWIO_REO_R2_SW2REO_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_SW2REO_RING_TP_ADDR(x))
#define HWIO_REO_R2_SW2REO_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_SW2REO_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_SW2REO_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_SW2REO_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_SW2REO_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_SW2REO_RING_TP_ADDR(x),m,v,HWIO_REO_R2_SW2REO_RING_TP_IN(x))
#define HWIO_REO_R2_SW2REO_RING_TP_TAIL_PTR_BMSK                                                                           0xffff
#define HWIO_REO_R2_SW2REO_RING_TP_TAIL_PTR_SHFT                                                                                0

#define HWIO_REO_R2_SW2REO1_RING_HP_ADDR(x)                                                                            ((x) + 0x3030)
#define HWIO_REO_R2_SW2REO1_RING_HP_PHYS(x)                                                                            ((x) + 0x3030)
#define HWIO_REO_R2_SW2REO1_RING_HP_OFFS                                                                               (0x3030)
#define HWIO_REO_R2_SW2REO1_RING_HP_RMSK                                                                                   0xffff
#define HWIO_REO_R2_SW2REO1_RING_HP_POR                                                                                0x00000000
#define HWIO_REO_R2_SW2REO1_RING_HP_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R2_SW2REO1_RING_HP_ATTR                                                                                            0x3
#define HWIO_REO_R2_SW2REO1_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_SW2REO1_RING_HP_ADDR(x))
#define HWIO_REO_R2_SW2REO1_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_SW2REO1_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_SW2REO1_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_SW2REO1_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_SW2REO1_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_SW2REO1_RING_HP_ADDR(x),m,v,HWIO_REO_R2_SW2REO1_RING_HP_IN(x))
#define HWIO_REO_R2_SW2REO1_RING_HP_HEAD_PTR_BMSK                                                                          0xffff
#define HWIO_REO_R2_SW2REO1_RING_HP_HEAD_PTR_SHFT                                                                               0

#define HWIO_REO_R2_SW2REO1_RING_TP_ADDR(x)                                                                            ((x) + 0x3034)
#define HWIO_REO_R2_SW2REO1_RING_TP_PHYS(x)                                                                            ((x) + 0x3034)
#define HWIO_REO_R2_SW2REO1_RING_TP_OFFS                                                                               (0x3034)
#define HWIO_REO_R2_SW2REO1_RING_TP_RMSK                                                                                   0xffff
#define HWIO_REO_R2_SW2REO1_RING_TP_POR                                                                                0x00000000
#define HWIO_REO_R2_SW2REO1_RING_TP_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R2_SW2REO1_RING_TP_ATTR                                                                                            0x3
#define HWIO_REO_R2_SW2REO1_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_SW2REO1_RING_TP_ADDR(x))
#define HWIO_REO_R2_SW2REO1_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_SW2REO1_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_SW2REO1_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_SW2REO1_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_SW2REO1_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_SW2REO1_RING_TP_ADDR(x),m,v,HWIO_REO_R2_SW2REO1_RING_TP_IN(x))
#define HWIO_REO_R2_SW2REO1_RING_TP_TAIL_PTR_BMSK                                                                          0xffff
#define HWIO_REO_R2_SW2REO1_RING_TP_TAIL_PTR_SHFT                                                                               0

#define HWIO_REO_R2_REO2SW1_RING_HP_ADDR(x)                                                                            ((x) + 0x3048)
#define HWIO_REO_R2_REO2SW1_RING_HP_PHYS(x)                                                                            ((x) + 0x3048)
#define HWIO_REO_R2_REO2SW1_RING_HP_OFFS                                                                               (0x3048)
#define HWIO_REO_R2_REO2SW1_RING_HP_RMSK                                                                                  0xfffff
#define HWIO_REO_R2_REO2SW1_RING_HP_POR                                                                                0x00000000
#define HWIO_REO_R2_REO2SW1_RING_HP_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R2_REO2SW1_RING_HP_ATTR                                                                                            0x3
#define HWIO_REO_R2_REO2SW1_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW1_RING_HP_ADDR(x))
#define HWIO_REO_R2_REO2SW1_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW1_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW1_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW1_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW1_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW1_RING_HP_ADDR(x),m,v,HWIO_REO_R2_REO2SW1_RING_HP_IN(x))
#define HWIO_REO_R2_REO2SW1_RING_HP_HEAD_PTR_BMSK                                                                         0xfffff
#define HWIO_REO_R2_REO2SW1_RING_HP_HEAD_PTR_SHFT                                                                               0

#define HWIO_REO_R2_REO2SW1_RING_TP_ADDR(x)                                                                            ((x) + 0x304c)
#define HWIO_REO_R2_REO2SW1_RING_TP_PHYS(x)                                                                            ((x) + 0x304c)
#define HWIO_REO_R2_REO2SW1_RING_TP_OFFS                                                                               (0x304c)
#define HWIO_REO_R2_REO2SW1_RING_TP_RMSK                                                                                  0xfffff
#define HWIO_REO_R2_REO2SW1_RING_TP_POR                                                                                0x00000000
#define HWIO_REO_R2_REO2SW1_RING_TP_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R2_REO2SW1_RING_TP_ATTR                                                                                            0x3
#define HWIO_REO_R2_REO2SW1_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW1_RING_TP_ADDR(x))
#define HWIO_REO_R2_REO2SW1_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW1_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW1_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW1_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW1_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW1_RING_TP_ADDR(x),m,v,HWIO_REO_R2_REO2SW1_RING_TP_IN(x))
#define HWIO_REO_R2_REO2SW1_RING_TP_TAIL_PTR_BMSK                                                                         0xfffff
#define HWIO_REO_R2_REO2SW1_RING_TP_TAIL_PTR_SHFT                                                                               0

#define HWIO_REO_R2_REO2SW2_RING_HP_ADDR(x)                                                                            ((x) + 0x3050)
#define HWIO_REO_R2_REO2SW2_RING_HP_PHYS(x)                                                                            ((x) + 0x3050)
#define HWIO_REO_R2_REO2SW2_RING_HP_OFFS                                                                               (0x3050)
#define HWIO_REO_R2_REO2SW2_RING_HP_RMSK                                                                                  0xfffff
#define HWIO_REO_R2_REO2SW2_RING_HP_POR                                                                                0x00000000
#define HWIO_REO_R2_REO2SW2_RING_HP_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R2_REO2SW2_RING_HP_ATTR                                                                                            0x3
#define HWIO_REO_R2_REO2SW2_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW2_RING_HP_ADDR(x))
#define HWIO_REO_R2_REO2SW2_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW2_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW2_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW2_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW2_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW2_RING_HP_ADDR(x),m,v,HWIO_REO_R2_REO2SW2_RING_HP_IN(x))
#define HWIO_REO_R2_REO2SW2_RING_HP_HEAD_PTR_BMSK                                                                         0xfffff
#define HWIO_REO_R2_REO2SW2_RING_HP_HEAD_PTR_SHFT                                                                               0

#define HWIO_REO_R2_REO2SW2_RING_TP_ADDR(x)                                                                            ((x) + 0x3054)
#define HWIO_REO_R2_REO2SW2_RING_TP_PHYS(x)                                                                            ((x) + 0x3054)
#define HWIO_REO_R2_REO2SW2_RING_TP_OFFS                                                                               (0x3054)
#define HWIO_REO_R2_REO2SW2_RING_TP_RMSK                                                                                  0xfffff
#define HWIO_REO_R2_REO2SW2_RING_TP_POR                                                                                0x00000000
#define HWIO_REO_R2_REO2SW2_RING_TP_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R2_REO2SW2_RING_TP_ATTR                                                                                            0x3
#define HWIO_REO_R2_REO2SW2_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW2_RING_TP_ADDR(x))
#define HWIO_REO_R2_REO2SW2_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW2_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW2_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW2_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW2_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW2_RING_TP_ADDR(x),m,v,HWIO_REO_R2_REO2SW2_RING_TP_IN(x))
#define HWIO_REO_R2_REO2SW2_RING_TP_TAIL_PTR_BMSK                                                                         0xfffff
#define HWIO_REO_R2_REO2SW2_RING_TP_TAIL_PTR_SHFT                                                                               0

#define HWIO_REO_R2_REO2SW3_RING_HP_ADDR(x)                                                                            ((x) + 0x3058)
#define HWIO_REO_R2_REO2SW3_RING_HP_PHYS(x)                                                                            ((x) + 0x3058)
#define HWIO_REO_R2_REO2SW3_RING_HP_OFFS                                                                               (0x3058)
#define HWIO_REO_R2_REO2SW3_RING_HP_RMSK                                                                                  0xfffff
#define HWIO_REO_R2_REO2SW3_RING_HP_POR                                                                                0x00000000
#define HWIO_REO_R2_REO2SW3_RING_HP_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R2_REO2SW3_RING_HP_ATTR                                                                                            0x3
#define HWIO_REO_R2_REO2SW3_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW3_RING_HP_ADDR(x))
#define HWIO_REO_R2_REO2SW3_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW3_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW3_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW3_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW3_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW3_RING_HP_ADDR(x),m,v,HWIO_REO_R2_REO2SW3_RING_HP_IN(x))
#define HWIO_REO_R2_REO2SW3_RING_HP_HEAD_PTR_BMSK                                                                         0xfffff
#define HWIO_REO_R2_REO2SW3_RING_HP_HEAD_PTR_SHFT                                                                               0

#define HWIO_REO_R2_REO2SW3_RING_TP_ADDR(x)                                                                            ((x) + 0x305c)
#define HWIO_REO_R2_REO2SW3_RING_TP_PHYS(x)                                                                            ((x) + 0x305c)
#define HWIO_REO_R2_REO2SW3_RING_TP_OFFS                                                                               (0x305c)
#define HWIO_REO_R2_REO2SW3_RING_TP_RMSK                                                                                  0xfffff
#define HWIO_REO_R2_REO2SW3_RING_TP_POR                                                                                0x00000000
#define HWIO_REO_R2_REO2SW3_RING_TP_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R2_REO2SW3_RING_TP_ATTR                                                                                            0x3
#define HWIO_REO_R2_REO2SW3_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW3_RING_TP_ADDR(x))
#define HWIO_REO_R2_REO2SW3_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW3_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW3_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW3_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW3_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW3_RING_TP_ADDR(x),m,v,HWIO_REO_R2_REO2SW3_RING_TP_IN(x))
#define HWIO_REO_R2_REO2SW3_RING_TP_TAIL_PTR_BMSK                                                                         0xfffff
#define HWIO_REO_R2_REO2SW3_RING_TP_TAIL_PTR_SHFT                                                                               0

#define HWIO_REO_R2_REO2SW4_RING_HP_ADDR(x)                                                                            ((x) + 0x3060)
#define HWIO_REO_R2_REO2SW4_RING_HP_PHYS(x)                                                                            ((x) + 0x3060)
#define HWIO_REO_R2_REO2SW4_RING_HP_OFFS                                                                               (0x3060)
#define HWIO_REO_R2_REO2SW4_RING_HP_RMSK                                                                                  0xfffff
#define HWIO_REO_R2_REO2SW4_RING_HP_POR                                                                                0x00000000
#define HWIO_REO_R2_REO2SW4_RING_HP_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R2_REO2SW4_RING_HP_ATTR                                                                                            0x3
#define HWIO_REO_R2_REO2SW4_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW4_RING_HP_ADDR(x))
#define HWIO_REO_R2_REO2SW4_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW4_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW4_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW4_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW4_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW4_RING_HP_ADDR(x),m,v,HWIO_REO_R2_REO2SW4_RING_HP_IN(x))
#define HWIO_REO_R2_REO2SW4_RING_HP_HEAD_PTR_BMSK                                                                         0xfffff
#define HWIO_REO_R2_REO2SW4_RING_HP_HEAD_PTR_SHFT                                                                               0

#define HWIO_REO_R2_REO2SW4_RING_TP_ADDR(x)                                                                            ((x) + 0x3064)
#define HWIO_REO_R2_REO2SW4_RING_TP_PHYS(x)                                                                            ((x) + 0x3064)
#define HWIO_REO_R2_REO2SW4_RING_TP_OFFS                                                                               (0x3064)
#define HWIO_REO_R2_REO2SW4_RING_TP_RMSK                                                                                  0xfffff
#define HWIO_REO_R2_REO2SW4_RING_TP_POR                                                                                0x00000000
#define HWIO_REO_R2_REO2SW4_RING_TP_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R2_REO2SW4_RING_TP_ATTR                                                                                            0x3
#define HWIO_REO_R2_REO2SW4_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW4_RING_TP_ADDR(x))
#define HWIO_REO_R2_REO2SW4_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW4_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW4_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW4_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW4_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW4_RING_TP_ADDR(x),m,v,HWIO_REO_R2_REO2SW4_RING_TP_IN(x))
#define HWIO_REO_R2_REO2SW4_RING_TP_TAIL_PTR_BMSK                                                                         0xfffff
#define HWIO_REO_R2_REO2SW4_RING_TP_TAIL_PTR_SHFT                                                                               0

#define HWIO_REO_R2_REO2SW5_RING_HP_ADDR(x)                                                                            ((x) + 0x3068)
#define HWIO_REO_R2_REO2SW5_RING_HP_PHYS(x)                                                                            ((x) + 0x3068)
#define HWIO_REO_R2_REO2SW5_RING_HP_OFFS                                                                               (0x3068)
#define HWIO_REO_R2_REO2SW5_RING_HP_RMSK                                                                                  0xfffff
#define HWIO_REO_R2_REO2SW5_RING_HP_POR                                                                                0x00000000
#define HWIO_REO_R2_REO2SW5_RING_HP_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R2_REO2SW5_RING_HP_ATTR                                                                                            0x3
#define HWIO_REO_R2_REO2SW5_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW5_RING_HP_ADDR(x))
#define HWIO_REO_R2_REO2SW5_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW5_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW5_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW5_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW5_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW5_RING_HP_ADDR(x),m,v,HWIO_REO_R2_REO2SW5_RING_HP_IN(x))
#define HWIO_REO_R2_REO2SW5_RING_HP_HEAD_PTR_BMSK                                                                         0xfffff
#define HWIO_REO_R2_REO2SW5_RING_HP_HEAD_PTR_SHFT                                                                               0

#define HWIO_REO_R2_REO2SW5_RING_TP_ADDR(x)                                                                            ((x) + 0x306c)
#define HWIO_REO_R2_REO2SW5_RING_TP_PHYS(x)                                                                            ((x) + 0x306c)
#define HWIO_REO_R2_REO2SW5_RING_TP_OFFS                                                                               (0x306c)
#define HWIO_REO_R2_REO2SW5_RING_TP_RMSK                                                                                  0xfffff
#define HWIO_REO_R2_REO2SW5_RING_TP_POR                                                                                0x00000000
#define HWIO_REO_R2_REO2SW5_RING_TP_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R2_REO2SW5_RING_TP_ATTR                                                                                            0x3
#define HWIO_REO_R2_REO2SW5_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW5_RING_TP_ADDR(x))
#define HWIO_REO_R2_REO2SW5_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW5_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW5_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW5_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW5_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW5_RING_TP_ADDR(x),m,v,HWIO_REO_R2_REO2SW5_RING_TP_IN(x))
#define HWIO_REO_R2_REO2SW5_RING_TP_TAIL_PTR_BMSK                                                                         0xfffff
#define HWIO_REO_R2_REO2SW5_RING_TP_TAIL_PTR_SHFT                                                                               0

#define HWIO_REO_R2_REO2SW6_RING_HP_ADDR(x)                                                                            ((x) + 0x3070)
#define HWIO_REO_R2_REO2SW6_RING_HP_PHYS(x)                                                                            ((x) + 0x3070)
#define HWIO_REO_R2_REO2SW6_RING_HP_OFFS                                                                               (0x3070)
#define HWIO_REO_R2_REO2SW6_RING_HP_RMSK                                                                                  0xfffff
#define HWIO_REO_R2_REO2SW6_RING_HP_POR                                                                                0x00000000
#define HWIO_REO_R2_REO2SW6_RING_HP_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R2_REO2SW6_RING_HP_ATTR                                                                                            0x3
#define HWIO_REO_R2_REO2SW6_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW6_RING_HP_ADDR(x))
#define HWIO_REO_R2_REO2SW6_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW6_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW6_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW6_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW6_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW6_RING_HP_ADDR(x),m,v,HWIO_REO_R2_REO2SW6_RING_HP_IN(x))
#define HWIO_REO_R2_REO2SW6_RING_HP_HEAD_PTR_BMSK                                                                         0xfffff
#define HWIO_REO_R2_REO2SW6_RING_HP_HEAD_PTR_SHFT                                                                               0

#define HWIO_REO_R2_REO2SW6_RING_TP_ADDR(x)                                                                            ((x) + 0x3074)
#define HWIO_REO_R2_REO2SW6_RING_TP_PHYS(x)                                                                            ((x) + 0x3074)
#define HWIO_REO_R2_REO2SW6_RING_TP_OFFS                                                                               (0x3074)
#define HWIO_REO_R2_REO2SW6_RING_TP_RMSK                                                                                  0xfffff
#define HWIO_REO_R2_REO2SW6_RING_TP_POR                                                                                0x00000000
#define HWIO_REO_R2_REO2SW6_RING_TP_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R2_REO2SW6_RING_TP_ATTR                                                                                            0x3
#define HWIO_REO_R2_REO2SW6_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW6_RING_TP_ADDR(x))
#define HWIO_REO_R2_REO2SW6_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW6_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW6_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW6_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW6_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW6_RING_TP_ADDR(x),m,v,HWIO_REO_R2_REO2SW6_RING_TP_IN(x))
#define HWIO_REO_R2_REO2SW6_RING_TP_TAIL_PTR_BMSK                                                                         0xfffff
#define HWIO_REO_R2_REO2SW6_RING_TP_TAIL_PTR_SHFT                                                                               0

#define HWIO_REO_R2_REO2SW0_RING_HP_ADDR(x)                                                                            ((x) + 0x3088)
#define HWIO_REO_R2_REO2SW0_RING_HP_PHYS(x)                                                                            ((x) + 0x3088)
#define HWIO_REO_R2_REO2SW0_RING_HP_OFFS                                                                               (0x3088)
#define HWIO_REO_R2_REO2SW0_RING_HP_RMSK                                                                                  0xfffff
#define HWIO_REO_R2_REO2SW0_RING_HP_POR                                                                                0x00000000
#define HWIO_REO_R2_REO2SW0_RING_HP_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R2_REO2SW0_RING_HP_ATTR                                                                                            0x3
#define HWIO_REO_R2_REO2SW0_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW0_RING_HP_ADDR(x))
#define HWIO_REO_R2_REO2SW0_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW0_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW0_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW0_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW0_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW0_RING_HP_ADDR(x),m,v,HWIO_REO_R2_REO2SW0_RING_HP_IN(x))
#define HWIO_REO_R2_REO2SW0_RING_HP_HEAD_PTR_BMSK                                                                         0xfffff
#define HWIO_REO_R2_REO2SW0_RING_HP_HEAD_PTR_SHFT                                                                               0

#define HWIO_REO_R2_REO2SW0_RING_TP_ADDR(x)                                                                            ((x) + 0x308c)
#define HWIO_REO_R2_REO2SW0_RING_TP_PHYS(x)                                                                            ((x) + 0x308c)
#define HWIO_REO_R2_REO2SW0_RING_TP_OFFS                                                                               (0x308c)
#define HWIO_REO_R2_REO2SW0_RING_TP_RMSK                                                                                  0xfffff
#define HWIO_REO_R2_REO2SW0_RING_TP_POR                                                                                0x00000000
#define HWIO_REO_R2_REO2SW0_RING_TP_POR_RMSK                                                                           0xffffffff
#define HWIO_REO_R2_REO2SW0_RING_TP_ATTR                                                                                            0x3
#define HWIO_REO_R2_REO2SW0_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2SW0_RING_TP_ADDR(x))
#define HWIO_REO_R2_REO2SW0_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2SW0_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_REO2SW0_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2SW0_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_REO2SW0_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2SW0_RING_TP_ADDR(x),m,v,HWIO_REO_R2_REO2SW0_RING_TP_IN(x))
#define HWIO_REO_R2_REO2SW0_RING_TP_TAIL_PTR_BMSK                                                                         0xfffff
#define HWIO_REO_R2_REO2SW0_RING_TP_TAIL_PTR_SHFT                                                                               0

#define HWIO_REO_R2_REO2FW_RING_HP_ADDR(x)                                                                             ((x) + 0x3098)
#define HWIO_REO_R2_REO2FW_RING_HP_PHYS(x)                                                                             ((x) + 0x3098)
#define HWIO_REO_R2_REO2FW_RING_HP_OFFS                                                                                (0x3098)
#define HWIO_REO_R2_REO2FW_RING_HP_RMSK                                                                                   0xfffff
#define HWIO_REO_R2_REO2FW_RING_HP_POR                                                                                 0x00000000
#define HWIO_REO_R2_REO2FW_RING_HP_POR_RMSK                                                                            0xffffffff
#define HWIO_REO_R2_REO2FW_RING_HP_ATTR                                                                                             0x3
#define HWIO_REO_R2_REO2FW_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2FW_RING_HP_ADDR(x))
#define HWIO_REO_R2_REO2FW_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2FW_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_REO2FW_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2FW_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_REO2FW_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2FW_RING_HP_ADDR(x),m,v,HWIO_REO_R2_REO2FW_RING_HP_IN(x))
#define HWIO_REO_R2_REO2FW_RING_HP_HEAD_PTR_BMSK                                                                          0xfffff
#define HWIO_REO_R2_REO2FW_RING_HP_HEAD_PTR_SHFT                                                                                0

#define HWIO_REO_R2_REO2FW_RING_TP_ADDR(x)                                                                             ((x) + 0x309c)
#define HWIO_REO_R2_REO2FW_RING_TP_PHYS(x)                                                                             ((x) + 0x309c)
#define HWIO_REO_R2_REO2FW_RING_TP_OFFS                                                                                (0x309c)
#define HWIO_REO_R2_REO2FW_RING_TP_RMSK                                                                                   0xfffff
#define HWIO_REO_R2_REO2FW_RING_TP_POR                                                                                 0x00000000
#define HWIO_REO_R2_REO2FW_RING_TP_POR_RMSK                                                                            0xffffffff
#define HWIO_REO_R2_REO2FW_RING_TP_ATTR                                                                                             0x3
#define HWIO_REO_R2_REO2FW_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_REO2FW_RING_TP_ADDR(x))
#define HWIO_REO_R2_REO2FW_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO2FW_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_REO2FW_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO2FW_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_REO2FW_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO2FW_RING_TP_ADDR(x),m,v,HWIO_REO_R2_REO2FW_RING_TP_IN(x))
#define HWIO_REO_R2_REO2FW_RING_TP_TAIL_PTR_BMSK                                                                          0xfffff
#define HWIO_REO_R2_REO2FW_RING_TP_TAIL_PTR_SHFT                                                                                0

#define HWIO_REO_R2_REO_RELEASE_RING_HP_ADDR(x)                                                                        ((x) + 0x30a0)
#define HWIO_REO_R2_REO_RELEASE_RING_HP_PHYS(x)                                                                        ((x) + 0x30a0)
#define HWIO_REO_R2_REO_RELEASE_RING_HP_OFFS                                                                           (0x30a0)
#define HWIO_REO_R2_REO_RELEASE_RING_HP_RMSK                                                                               0xffff
#define HWIO_REO_R2_REO_RELEASE_RING_HP_POR                                                                            0x00000000
#define HWIO_REO_R2_REO_RELEASE_RING_HP_POR_RMSK                                                                       0xffffffff
#define HWIO_REO_R2_REO_RELEASE_RING_HP_ATTR                                                                                        0x3
#define HWIO_REO_R2_REO_RELEASE_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_REO_RELEASE_RING_HP_ADDR(x))
#define HWIO_REO_R2_REO_RELEASE_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO_RELEASE_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_REO_RELEASE_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO_RELEASE_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_REO_RELEASE_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO_RELEASE_RING_HP_ADDR(x),m,v,HWIO_REO_R2_REO_RELEASE_RING_HP_IN(x))
#define HWIO_REO_R2_REO_RELEASE_RING_HP_HEAD_PTR_BMSK                                                                      0xffff
#define HWIO_REO_R2_REO_RELEASE_RING_HP_HEAD_PTR_SHFT                                                                           0

#define HWIO_REO_R2_REO_RELEASE_RING_TP_ADDR(x)                                                                        ((x) + 0x30a4)
#define HWIO_REO_R2_REO_RELEASE_RING_TP_PHYS(x)                                                                        ((x) + 0x30a4)
#define HWIO_REO_R2_REO_RELEASE_RING_TP_OFFS                                                                           (0x30a4)
#define HWIO_REO_R2_REO_RELEASE_RING_TP_RMSK                                                                               0xffff
#define HWIO_REO_R2_REO_RELEASE_RING_TP_POR                                                                            0x00000000
#define HWIO_REO_R2_REO_RELEASE_RING_TP_POR_RMSK                                                                       0xffffffff
#define HWIO_REO_R2_REO_RELEASE_RING_TP_ATTR                                                                                        0x3
#define HWIO_REO_R2_REO_RELEASE_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_REO_RELEASE_RING_TP_ADDR(x))
#define HWIO_REO_R2_REO_RELEASE_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO_RELEASE_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_REO_RELEASE_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO_RELEASE_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_REO_RELEASE_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO_RELEASE_RING_TP_ADDR(x),m,v,HWIO_REO_R2_REO_RELEASE_RING_TP_IN(x))
#define HWIO_REO_R2_REO_RELEASE_RING_TP_TAIL_PTR_BMSK                                                                      0xffff
#define HWIO_REO_R2_REO_RELEASE_RING_TP_TAIL_PTR_SHFT                                                                           0

#define HWIO_REO_R2_REO_STATUS_RING_HP_ADDR(x)                                                                         ((x) + 0x30a8)
#define HWIO_REO_R2_REO_STATUS_RING_HP_PHYS(x)                                                                         ((x) + 0x30a8)
#define HWIO_REO_R2_REO_STATUS_RING_HP_OFFS                                                                            (0x30a8)
#define HWIO_REO_R2_REO_STATUS_RING_HP_RMSK                                                                                0xffff
#define HWIO_REO_R2_REO_STATUS_RING_HP_POR                                                                             0x00000000
#define HWIO_REO_R2_REO_STATUS_RING_HP_POR_RMSK                                                                        0xffffffff
#define HWIO_REO_R2_REO_STATUS_RING_HP_ATTR                                                                                         0x3
#define HWIO_REO_R2_REO_STATUS_RING_HP_IN(x)            \
                in_dword(HWIO_REO_R2_REO_STATUS_RING_HP_ADDR(x))
#define HWIO_REO_R2_REO_STATUS_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO_STATUS_RING_HP_ADDR(x), m)
#define HWIO_REO_R2_REO_STATUS_RING_HP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO_STATUS_RING_HP_ADDR(x),v)
#define HWIO_REO_R2_REO_STATUS_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO_STATUS_RING_HP_ADDR(x),m,v,HWIO_REO_R2_REO_STATUS_RING_HP_IN(x))
#define HWIO_REO_R2_REO_STATUS_RING_HP_HEAD_PTR_BMSK                                                                       0xffff
#define HWIO_REO_R2_REO_STATUS_RING_HP_HEAD_PTR_SHFT                                                                            0

#define HWIO_REO_R2_REO_STATUS_RING_TP_ADDR(x)                                                                         ((x) + 0x30ac)
#define HWIO_REO_R2_REO_STATUS_RING_TP_PHYS(x)                                                                         ((x) + 0x30ac)
#define HWIO_REO_R2_REO_STATUS_RING_TP_OFFS                                                                            (0x30ac)
#define HWIO_REO_R2_REO_STATUS_RING_TP_RMSK                                                                                0xffff
#define HWIO_REO_R2_REO_STATUS_RING_TP_POR                                                                             0x00000000
#define HWIO_REO_R2_REO_STATUS_RING_TP_POR_RMSK                                                                        0xffffffff
#define HWIO_REO_R2_REO_STATUS_RING_TP_ATTR                                                                                         0x3
#define HWIO_REO_R2_REO_STATUS_RING_TP_IN(x)            \
                in_dword(HWIO_REO_R2_REO_STATUS_RING_TP_ADDR(x))
#define HWIO_REO_R2_REO_STATUS_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_REO_R2_REO_STATUS_RING_TP_ADDR(x), m)
#define HWIO_REO_R2_REO_STATUS_RING_TP_OUT(x, v)            \
                out_dword(HWIO_REO_R2_REO_STATUS_RING_TP_ADDR(x),v)
#define HWIO_REO_R2_REO_STATUS_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_REO_R2_REO_STATUS_RING_TP_ADDR(x),m,v,HWIO_REO_R2_REO_STATUS_RING_TP_IN(x))
#define HWIO_REO_R2_REO_STATUS_RING_TP_TAIL_PTR_BMSK                                                                       0xffff
#define HWIO_REO_R2_REO_STATUS_RING_TP_TAIL_PTR_SHFT                                                                            0

/*----------------------------------------------------------------------------
 * MODULE: TQM_REG
 *--------------------------------------------------------------------------*/

#define TQM_REG_REG_BASE                                                                                         (UMAC_BASE      + 0x0003c000)
#define TQM_REG_REG_BASE_SIZE                                                                                    0x4000
#define TQM_REG_REG_BASE_USED                                                                                    0x305c
#define TQM_REG_REG_BASE_PHYS                                                                                    (UMAC_BASE_PHYS + 0x0003c000)
#define TQM_REG_REG_BASE_OFFS                                                                                    0x0003c000

#define HWIO_TQM_R0_CONTROL_ADDR(x)                                                                              ((x) + 0x0)
#define HWIO_TQM_R0_CONTROL_PHYS(x)                                                                              ((x) + 0x0)
#define HWIO_TQM_R0_CONTROL_OFFS                                                                                 (0x0)
#define HWIO_TQM_R0_CONTROL_RMSK                                                                                       0x1b
#define HWIO_TQM_R0_CONTROL_POR                                                                                  0x00000012
#define HWIO_TQM_R0_CONTROL_POR_RMSK                                                                             0xffffffff
#define HWIO_TQM_R0_CONTROL_ATTR                                                                                              0x3
#define HWIO_TQM_R0_CONTROL_IN(x)            \
                in_dword(HWIO_TQM_R0_CONTROL_ADDR(x))
#define HWIO_TQM_R0_CONTROL_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_CONTROL_ADDR(x), m)
#define HWIO_TQM_R0_CONTROL_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_CONTROL_ADDR(x),v)
#define HWIO_TQM_R0_CONTROL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_CONTROL_ADDR(x),m,v,HWIO_TQM_R0_CONTROL_IN(x))
#define HWIO_TQM_R0_CONTROL_INIT_PREFETCH_BUFFER_PTRS_BMSK                                                             0x10
#define HWIO_TQM_R0_CONTROL_INIT_PREFETCH_BUFFER_PTRS_SHFT                                                                4
#define HWIO_TQM_R0_CONTROL_BLOCK_PREFETCH_BMSK                                                                         0x8
#define HWIO_TQM_R0_CONTROL_BLOCK_PREFETCH_SHFT                                                                           3
#define HWIO_TQM_R0_CONTROL_CONCURRENT_PROC_BMSK                                                                        0x2
#define HWIO_TQM_R0_CONTROL_CONCURRENT_PROC_SHFT                                                                          1
#define HWIO_TQM_R0_CONTROL_ENABLE_BMSK                                                                                 0x1
#define HWIO_TQM_R0_CONTROL_ENABLE_SHFT                                                                                   0

#define HWIO_TQM_R0_PAUSE_CONTROL_ADDR(x)                                                                        ((x) + 0x4)
#define HWIO_TQM_R0_PAUSE_CONTROL_PHYS(x)                                                                        ((x) + 0x4)
#define HWIO_TQM_R0_PAUSE_CONTROL_OFFS                                                                           (0x4)
#define HWIO_TQM_R0_PAUSE_CONTROL_RMSK                                                                                  0x7
#define HWIO_TQM_R0_PAUSE_CONTROL_POR                                                                            0x00000003
#define HWIO_TQM_R0_PAUSE_CONTROL_POR_RMSK                                                                       0xffffffff
#define HWIO_TQM_R0_PAUSE_CONTROL_ATTR                                                                                        0x3
#define HWIO_TQM_R0_PAUSE_CONTROL_IN(x)            \
                in_dword(HWIO_TQM_R0_PAUSE_CONTROL_ADDR(x))
#define HWIO_TQM_R0_PAUSE_CONTROL_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_PAUSE_CONTROL_ADDR(x), m)
#define HWIO_TQM_R0_PAUSE_CONTROL_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_PAUSE_CONTROL_ADDR(x),v)
#define HWIO_TQM_R0_PAUSE_CONTROL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_PAUSE_CONTROL_ADDR(x),m,v,HWIO_TQM_R0_PAUSE_CONTROL_IN(x))
#define HWIO_TQM_R0_PAUSE_CONTROL_ENABLE_HW_ACKED_MPDU_BMSK                                                             0x4
#define HWIO_TQM_R0_PAUSE_CONTROL_ENABLE_HW_ACKED_MPDU_SHFT                                                               2
#define HWIO_TQM_R0_PAUSE_CONTROL_ENABLE_HWSCH_CMD_BMSK                                                                 0x2
#define HWIO_TQM_R0_PAUSE_CONTROL_ENABLE_HWSCH_CMD_SHFT                                                                   1
#define HWIO_TQM_R0_PAUSE_CONTROL_ENABLE_SW_CMD_BMSK                                                                    0x1
#define HWIO_TQM_R0_PAUSE_CONTROL_ENABLE_SW_CMD_SHFT                                                                      0

#define HWIO_TQM_R0_MISC_CONTROL_ADDR(x)                                                                         ((x) + 0x8)
#define HWIO_TQM_R0_MISC_CONTROL_PHYS(x)                                                                         ((x) + 0x8)
#define HWIO_TQM_R0_MISC_CONTROL_OFFS                                                                            (0x8)
#define HWIO_TQM_R0_MISC_CONTROL_RMSK                                                                                 0x3ff
#define HWIO_TQM_R0_MISC_CONTROL_POR                                                                             0x00000010
#define HWIO_TQM_R0_MISC_CONTROL_POR_RMSK                                                                        0xffffffff
#define HWIO_TQM_R0_MISC_CONTROL_ATTR                                                                                         0x3
#define HWIO_TQM_R0_MISC_CONTROL_IN(x)            \
                in_dword(HWIO_TQM_R0_MISC_CONTROL_ADDR(x))
#define HWIO_TQM_R0_MISC_CONTROL_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_MISC_CONTROL_ADDR(x), m)
#define HWIO_TQM_R0_MISC_CONTROL_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_MISC_CONTROL_ADDR(x),v)
#define HWIO_TQM_R0_MISC_CONTROL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_MISC_CONTROL_ADDR(x),m,v,HWIO_TQM_R0_MISC_CONTROL_IN(x))
#define HWIO_TQM_R0_MISC_CONTROL_GEN_ACKED_MPDU_INFO_END_BMSK                                                         0x200
#define HWIO_TQM_R0_MISC_CONTROL_GEN_ACKED_MPDU_INFO_END_SHFT                                                             9
#define HWIO_TQM_R0_MISC_CONTROL_RETAIN_CACHE_BMSK                                                                    0x100
#define HWIO_TQM_R0_MISC_CONTROL_RETAIN_CACHE_SHFT                                                                        8
#define HWIO_TQM_R0_MISC_CONTROL_FLUSH_IDLE_COUNT_BMSK                                                                 0xff
#define HWIO_TQM_R0_MISC_CONTROL_FLUSH_IDLE_COUNT_SHFT                                                                    0

#define HWIO_TQM_R0_LINK_0_ADDR(x)                                                                               ((x) + 0xc)
#define HWIO_TQM_R0_LINK_0_PHYS(x)                                                                               ((x) + 0xc)
#define HWIO_TQM_R0_LINK_0_OFFS                                                                                  (0xc)
#define HWIO_TQM_R0_LINK_0_RMSK                                                                                        0x3f
#define HWIO_TQM_R0_LINK_0_POR                                                                                   0x00000000
#define HWIO_TQM_R0_LINK_0_POR_RMSK                                                                              0xffffffff
#define HWIO_TQM_R0_LINK_0_ATTR                                                                                               0x3
#define HWIO_TQM_R0_LINK_0_IN(x)            \
                in_dword(HWIO_TQM_R0_LINK_0_ADDR(x))
#define HWIO_TQM_R0_LINK_0_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_LINK_0_ADDR(x), m)
#define HWIO_TQM_R0_LINK_0_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_LINK_0_ADDR(x),v)
#define HWIO_TQM_R0_LINK_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_LINK_0_ADDR(x),m,v,HWIO_TQM_R0_LINK_0_IN(x))
#define HWIO_TQM_R0_LINK_0_SESSION_ID_BMSK                                                                             0x3f
#define HWIO_TQM_R0_LINK_0_SESSION_ID_SHFT                                                                                0

#define HWIO_TQM_R0_LINK_1_ADDR(x)                                                                               ((x) + 0x10)
#define HWIO_TQM_R0_LINK_1_PHYS(x)                                                                               ((x) + 0x10)
#define HWIO_TQM_R0_LINK_1_OFFS                                                                                  (0x10)
#define HWIO_TQM_R0_LINK_1_RMSK                                                                                        0x3f
#define HWIO_TQM_R0_LINK_1_POR                                                                                   0x00000000
#define HWIO_TQM_R0_LINK_1_POR_RMSK                                                                              0xffffffff
#define HWIO_TQM_R0_LINK_1_ATTR                                                                                               0x3
#define HWIO_TQM_R0_LINK_1_IN(x)            \
                in_dword(HWIO_TQM_R0_LINK_1_ADDR(x))
#define HWIO_TQM_R0_LINK_1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_LINK_1_ADDR(x), m)
#define HWIO_TQM_R0_LINK_1_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_LINK_1_ADDR(x),v)
#define HWIO_TQM_R0_LINK_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_LINK_1_ADDR(x),m,v,HWIO_TQM_R0_LINK_1_IN(x))
#define HWIO_TQM_R0_LINK_1_SESSION_ID_BMSK                                                                             0x3f
#define HWIO_TQM_R0_LINK_1_SESSION_ID_SHFT                                                                                0

#define HWIO_TQM_R0_LINK_A_ADDR(x)                                                                               ((x) + 0x14)
#define HWIO_TQM_R0_LINK_A_PHYS(x)                                                                               ((x) + 0x14)
#define HWIO_TQM_R0_LINK_A_OFFS                                                                                  (0x14)
#define HWIO_TQM_R0_LINK_A_RMSK                                                                                        0xff
#define HWIO_TQM_R0_LINK_A_POR                                                                                   0x00000000
#define HWIO_TQM_R0_LINK_A_POR_RMSK                                                                              0xffffffff
#define HWIO_TQM_R0_LINK_A_ATTR                                                                                               0x3
#define HWIO_TQM_R0_LINK_A_IN(x)            \
                in_dword(HWIO_TQM_R0_LINK_A_ADDR(x))
#define HWIO_TQM_R0_LINK_A_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_LINK_A_ADDR(x), m)
#define HWIO_TQM_R0_LINK_A_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_LINK_A_ADDR(x),v)
#define HWIO_TQM_R0_LINK_A_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_LINK_A_ADDR(x),m,v,HWIO_TQM_R0_LINK_A_IN(x))
#define HWIO_TQM_R0_LINK_A_SESSION_ID_BMSK                                                                             0xff
#define HWIO_TQM_R0_LINK_A_SESSION_ID_SHFT                                                                                0

#define HWIO_TQM_R0_LINK_B_ADDR(x)                                                                               ((x) + 0x18)
#define HWIO_TQM_R0_LINK_B_PHYS(x)                                                                               ((x) + 0x18)
#define HWIO_TQM_R0_LINK_B_OFFS                                                                                  (0x18)
#define HWIO_TQM_R0_LINK_B_RMSK                                                                                        0xff
#define HWIO_TQM_R0_LINK_B_POR                                                                                   0x00000000
#define HWIO_TQM_R0_LINK_B_POR_RMSK                                                                              0xffffffff
#define HWIO_TQM_R0_LINK_B_ATTR                                                                                               0x3
#define HWIO_TQM_R0_LINK_B_IN(x)            \
                in_dword(HWIO_TQM_R0_LINK_B_ADDR(x))
#define HWIO_TQM_R0_LINK_B_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_LINK_B_ADDR(x), m)
#define HWIO_TQM_R0_LINK_B_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_LINK_B_ADDR(x),v)
#define HWIO_TQM_R0_LINK_B_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_LINK_B_ADDR(x),m,v,HWIO_TQM_R0_LINK_B_IN(x))
#define HWIO_TQM_R0_LINK_B_SESSION_ID_BMSK                                                                             0xff
#define HWIO_TQM_R0_LINK_B_SESSION_ID_SHFT                                                                                0

#define HWIO_TQM_R0_LINK_C_ADDR(x)                                                                               ((x) + 0x1c)
#define HWIO_TQM_R0_LINK_C_PHYS(x)                                                                               ((x) + 0x1c)
#define HWIO_TQM_R0_LINK_C_OFFS                                                                                  (0x1c)
#define HWIO_TQM_R0_LINK_C_RMSK                                                                                        0xff
#define HWIO_TQM_R0_LINK_C_POR                                                                                   0x00000000
#define HWIO_TQM_R0_LINK_C_POR_RMSK                                                                              0xffffffff
#define HWIO_TQM_R0_LINK_C_ATTR                                                                                               0x3
#define HWIO_TQM_R0_LINK_C_IN(x)            \
                in_dword(HWIO_TQM_R0_LINK_C_ADDR(x))
#define HWIO_TQM_R0_LINK_C_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_LINK_C_ADDR(x), m)
#define HWIO_TQM_R0_LINK_C_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_LINK_C_ADDR(x),v)
#define HWIO_TQM_R0_LINK_C_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_LINK_C_ADDR(x),m,v,HWIO_TQM_R0_LINK_C_IN(x))
#define HWIO_TQM_R0_LINK_C_SESSION_ID_BMSK                                                                             0xff
#define HWIO_TQM_R0_LINK_C_SESSION_ID_SHFT                                                                                0

#define HWIO_TQM_R0_LINK_D_ADDR(x)                                                                               ((x) + 0x20)
#define HWIO_TQM_R0_LINK_D_PHYS(x)                                                                               ((x) + 0x20)
#define HWIO_TQM_R0_LINK_D_OFFS                                                                                  (0x20)
#define HWIO_TQM_R0_LINK_D_RMSK                                                                                        0xff
#define HWIO_TQM_R0_LINK_D_POR                                                                                   0x00000000
#define HWIO_TQM_R0_LINK_D_POR_RMSK                                                                              0xffffffff
#define HWIO_TQM_R0_LINK_D_ATTR                                                                                               0x3
#define HWIO_TQM_R0_LINK_D_IN(x)            \
                in_dword(HWIO_TQM_R0_LINK_D_ADDR(x))
#define HWIO_TQM_R0_LINK_D_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_LINK_D_ADDR(x), m)
#define HWIO_TQM_R0_LINK_D_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_LINK_D_ADDR(x),v)
#define HWIO_TQM_R0_LINK_D_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_LINK_D_ADDR(x),m,v,HWIO_TQM_R0_LINK_D_IN(x))
#define HWIO_TQM_R0_LINK_D_SESSION_ID_BMSK                                                                             0xff
#define HWIO_TQM_R0_LINK_D_SESSION_ID_SHFT                                                                                0

#define HWIO_TQM_R0_LINK_E_ADDR(x)                                                                               ((x) + 0x24)
#define HWIO_TQM_R0_LINK_E_PHYS(x)                                                                               ((x) + 0x24)
#define HWIO_TQM_R0_LINK_E_OFFS                                                                                  (0x24)
#define HWIO_TQM_R0_LINK_E_RMSK                                                                                        0xff
#define HWIO_TQM_R0_LINK_E_POR                                                                                   0x00000000
#define HWIO_TQM_R0_LINK_E_POR_RMSK                                                                              0xffffffff
#define HWIO_TQM_R0_LINK_E_ATTR                                                                                               0x3
#define HWIO_TQM_R0_LINK_E_IN(x)            \
                in_dword(HWIO_TQM_R0_LINK_E_ADDR(x))
#define HWIO_TQM_R0_LINK_E_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_LINK_E_ADDR(x), m)
#define HWIO_TQM_R0_LINK_E_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_LINK_E_ADDR(x),v)
#define HWIO_TQM_R0_LINK_E_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_LINK_E_ADDR(x),m,v,HWIO_TQM_R0_LINK_E_IN(x))
#define HWIO_TQM_R0_LINK_E_SESSION_ID_BMSK                                                                             0xff
#define HWIO_TQM_R0_LINK_E_SESSION_ID_SHFT                                                                                0

#define HWIO_TQM_R0_LINK_F_ADDR(x)                                                                               ((x) + 0x28)
#define HWIO_TQM_R0_LINK_F_PHYS(x)                                                                               ((x) + 0x28)
#define HWIO_TQM_R0_LINK_F_OFFS                                                                                  (0x28)
#define HWIO_TQM_R0_LINK_F_RMSK                                                                                        0xff
#define HWIO_TQM_R0_LINK_F_POR                                                                                   0x00000000
#define HWIO_TQM_R0_LINK_F_POR_RMSK                                                                              0xffffffff
#define HWIO_TQM_R0_LINK_F_ATTR                                                                                               0x3
#define HWIO_TQM_R0_LINK_F_IN(x)            \
                in_dword(HWIO_TQM_R0_LINK_F_ADDR(x))
#define HWIO_TQM_R0_LINK_F_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_LINK_F_ADDR(x), m)
#define HWIO_TQM_R0_LINK_F_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_LINK_F_ADDR(x),v)
#define HWIO_TQM_R0_LINK_F_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_LINK_F_ADDR(x),m,v,HWIO_TQM_R0_LINK_F_IN(x))
#define HWIO_TQM_R0_LINK_F_SESSION_ID_BMSK                                                                             0xff
#define HWIO_TQM_R0_LINK_F_SESSION_ID_SHFT                                                                                0

#define HWIO_TQM_R0_LINK_G_ADDR(x)                                                                               ((x) + 0x2c)
#define HWIO_TQM_R0_LINK_G_PHYS(x)                                                                               ((x) + 0x2c)
#define HWIO_TQM_R0_LINK_G_OFFS                                                                                  (0x2c)
#define HWIO_TQM_R0_LINK_G_RMSK                                                                                        0xff
#define HWIO_TQM_R0_LINK_G_POR                                                                                   0x00000000
#define HWIO_TQM_R0_LINK_G_POR_RMSK                                                                              0xffffffff
#define HWIO_TQM_R0_LINK_G_ATTR                                                                                               0x3
#define HWIO_TQM_R0_LINK_G_IN(x)            \
                in_dword(HWIO_TQM_R0_LINK_G_ADDR(x))
#define HWIO_TQM_R0_LINK_G_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_LINK_G_ADDR(x), m)
#define HWIO_TQM_R0_LINK_G_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_LINK_G_ADDR(x),v)
#define HWIO_TQM_R0_LINK_G_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_LINK_G_ADDR(x),m,v,HWIO_TQM_R0_LINK_G_IN(x))
#define HWIO_TQM_R0_LINK_G_SESSION_ID_BMSK                                                                             0xff
#define HWIO_TQM_R0_LINK_G_SESSION_ID_SHFT                                                                                0

#define HWIO_TQM_R0_UPDATE_TX_MPDU_COUNT_SM_CONTROL_ADDR(x)                                                      ((x) + 0x30)
#define HWIO_TQM_R0_UPDATE_TX_MPDU_COUNT_SM_CONTROL_PHYS(x)                                                      ((x) + 0x30)
#define HWIO_TQM_R0_UPDATE_TX_MPDU_COUNT_SM_CONTROL_OFFS                                                         (0x30)
#define HWIO_TQM_R0_UPDATE_TX_MPDU_COUNT_SM_CONTROL_RMSK                                                              0x3ff
#define HWIO_TQM_R0_UPDATE_TX_MPDU_COUNT_SM_CONTROL_POR                                                          0x0000000a
#define HWIO_TQM_R0_UPDATE_TX_MPDU_COUNT_SM_CONTROL_POR_RMSK                                                     0xffffffff
#define HWIO_TQM_R0_UPDATE_TX_MPDU_COUNT_SM_CONTROL_ATTR                                                                      0x3
#define HWIO_TQM_R0_UPDATE_TX_MPDU_COUNT_SM_CONTROL_IN(x)            \
                in_dword(HWIO_TQM_R0_UPDATE_TX_MPDU_COUNT_SM_CONTROL_ADDR(x))
#define HWIO_TQM_R0_UPDATE_TX_MPDU_COUNT_SM_CONTROL_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_UPDATE_TX_MPDU_COUNT_SM_CONTROL_ADDR(x), m)
#define HWIO_TQM_R0_UPDATE_TX_MPDU_COUNT_SM_CONTROL_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_UPDATE_TX_MPDU_COUNT_SM_CONTROL_ADDR(x),v)
#define HWIO_TQM_R0_UPDATE_TX_MPDU_COUNT_SM_CONTROL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_UPDATE_TX_MPDU_COUNT_SM_CONTROL_ADDR(x),m,v,HWIO_TQM_R0_UPDATE_TX_MPDU_COUNT_SM_CONTROL_IN(x))
#define HWIO_TQM_R0_UPDATE_TX_MPDU_COUNT_SM_CONTROL_ENABLE_PREFETCH_BMSK                                              0x200
#define HWIO_TQM_R0_UPDATE_TX_MPDU_COUNT_SM_CONTROL_ENABLE_PREFETCH_SHFT                                                  9
#define HWIO_TQM_R0_UPDATE_TX_MPDU_COUNT_SM_CONTROL_CMD_EXECUTION_TIME_VALID_BMSK                                     0x100
#define HWIO_TQM_R0_UPDATE_TX_MPDU_COUNT_SM_CONTROL_CMD_EXECUTION_TIME_VALID_SHFT                                         8
#define HWIO_TQM_R0_UPDATE_TX_MPDU_COUNT_SM_CONTROL_MAX_CMD_EXECUTION_TIME_BMSK                                        0xff
#define HWIO_TQM_R0_UPDATE_TX_MPDU_COUNT_SM_CONTROL_MAX_CMD_EXECUTION_TIME_SHFT                                           0

#define HWIO_TQM_R0_TCL2TQM_RING_BASE_LSB_ADDR(x)                                                                ((x) + 0x34)
#define HWIO_TQM_R0_TCL2TQM_RING_BASE_LSB_PHYS(x)                                                                ((x) + 0x34)
#define HWIO_TQM_R0_TCL2TQM_RING_BASE_LSB_OFFS                                                                   (0x34)
#define HWIO_TQM_R0_TCL2TQM_RING_BASE_LSB_RMSK                                                                   0xffffffff
#define HWIO_TQM_R0_TCL2TQM_RING_BASE_LSB_POR                                                                    0x00000000
#define HWIO_TQM_R0_TCL2TQM_RING_BASE_LSB_POR_RMSK                                                               0xffffffff
#define HWIO_TQM_R0_TCL2TQM_RING_BASE_LSB_ATTR                                                                                0x3
#define HWIO_TQM_R0_TCL2TQM_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TCL2TQM_RING_BASE_LSB_ADDR(x))
#define HWIO_TQM_R0_TCL2TQM_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TCL2TQM_RING_BASE_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TCL2TQM_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TCL2TQM_RING_BASE_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TCL2TQM_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TCL2TQM_RING_BASE_LSB_ADDR(x),m,v,HWIO_TQM_R0_TCL2TQM_RING_BASE_LSB_IN(x))
#define HWIO_TQM_R0_TCL2TQM_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                                0xffffffff
#define HWIO_TQM_R0_TCL2TQM_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                         0

#define HWIO_TQM_R0_TCL2TQM_RING_BASE_MSB_ADDR(x)                                                                ((x) + 0x38)
#define HWIO_TQM_R0_TCL2TQM_RING_BASE_MSB_PHYS(x)                                                                ((x) + 0x38)
#define HWIO_TQM_R0_TCL2TQM_RING_BASE_MSB_OFFS                                                                   (0x38)
#define HWIO_TQM_R0_TCL2TQM_RING_BASE_MSB_RMSK                                                                     0xffffff
#define HWIO_TQM_R0_TCL2TQM_RING_BASE_MSB_POR                                                                    0x00000000
#define HWIO_TQM_R0_TCL2TQM_RING_BASE_MSB_POR_RMSK                                                               0xffffffff
#define HWIO_TQM_R0_TCL2TQM_RING_BASE_MSB_ATTR                                                                                0x3
#define HWIO_TQM_R0_TCL2TQM_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TCL2TQM_RING_BASE_MSB_ADDR(x))
#define HWIO_TQM_R0_TCL2TQM_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TCL2TQM_RING_BASE_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TCL2TQM_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TCL2TQM_RING_BASE_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TCL2TQM_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TCL2TQM_RING_BASE_MSB_ADDR(x),m,v,HWIO_TQM_R0_TCL2TQM_RING_BASE_MSB_IN(x))
#define HWIO_TQM_R0_TCL2TQM_RING_BASE_MSB_RING_SIZE_BMSK                                                           0xffff00
#define HWIO_TQM_R0_TCL2TQM_RING_BASE_MSB_RING_SIZE_SHFT                                                                  8
#define HWIO_TQM_R0_TCL2TQM_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                      0xff
#define HWIO_TQM_R0_TCL2TQM_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                         0

#define HWIO_TQM_R0_TCL2TQM_RING_ID_ADDR(x)                                                                      ((x) + 0x3c)
#define HWIO_TQM_R0_TCL2TQM_RING_ID_PHYS(x)                                                                      ((x) + 0x3c)
#define HWIO_TQM_R0_TCL2TQM_RING_ID_OFFS                                                                         (0x3c)
#define HWIO_TQM_R0_TCL2TQM_RING_ID_RMSK                                                                               0xff
#define HWIO_TQM_R0_TCL2TQM_RING_ID_POR                                                                          0x00000000
#define HWIO_TQM_R0_TCL2TQM_RING_ID_POR_RMSK                                                                     0xffffffff
#define HWIO_TQM_R0_TCL2TQM_RING_ID_ATTR                                                                                      0x3
#define HWIO_TQM_R0_TCL2TQM_RING_ID_IN(x)            \
                in_dword(HWIO_TQM_R0_TCL2TQM_RING_ID_ADDR(x))
#define HWIO_TQM_R0_TCL2TQM_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TCL2TQM_RING_ID_ADDR(x), m)
#define HWIO_TQM_R0_TCL2TQM_RING_ID_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TCL2TQM_RING_ID_ADDR(x),v)
#define HWIO_TQM_R0_TCL2TQM_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TCL2TQM_RING_ID_ADDR(x),m,v,HWIO_TQM_R0_TCL2TQM_RING_ID_IN(x))
#define HWIO_TQM_R0_TCL2TQM_RING_ID_ENTRY_SIZE_BMSK                                                                    0xff
#define HWIO_TQM_R0_TCL2TQM_RING_ID_ENTRY_SIZE_SHFT                                                                       0

#define HWIO_TQM_R0_TCL2TQM_RING_STATUS_ADDR(x)                                                                  ((x) + 0x40)
#define HWIO_TQM_R0_TCL2TQM_RING_STATUS_PHYS(x)                                                                  ((x) + 0x40)
#define HWIO_TQM_R0_TCL2TQM_RING_STATUS_OFFS                                                                     (0x40)
#define HWIO_TQM_R0_TCL2TQM_RING_STATUS_RMSK                                                                     0xffffffff
#define HWIO_TQM_R0_TCL2TQM_RING_STATUS_POR                                                                      0x00000000
#define HWIO_TQM_R0_TCL2TQM_RING_STATUS_POR_RMSK                                                                 0xffffffff
#define HWIO_TQM_R0_TCL2TQM_RING_STATUS_ATTR                                                                                  0x1
#define HWIO_TQM_R0_TCL2TQM_RING_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_TCL2TQM_RING_STATUS_ADDR(x))
#define HWIO_TQM_R0_TCL2TQM_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TCL2TQM_RING_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_TCL2TQM_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                     0xffff0000
#define HWIO_TQM_R0_TCL2TQM_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                             16
#define HWIO_TQM_R0_TCL2TQM_RING_STATUS_NUM_VALID_WORDS_BMSK                                                         0xffff
#define HWIO_TQM_R0_TCL2TQM_RING_STATUS_NUM_VALID_WORDS_SHFT                                                              0

#define HWIO_TQM_R0_TCL2TQM_RING_MISC_ADDR(x)                                                                    ((x) + 0x44)
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_PHYS(x)                                                                    ((x) + 0x44)
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_OFFS                                                                       (0x44)
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_RMSK                                                                         0x3fffff
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_POR                                                                        0x00000080
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_POR_RMSK                                                                   0xffffffff
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_ATTR                                                                                    0x3
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_IN(x)            \
                in_dword(HWIO_TQM_R0_TCL2TQM_RING_MISC_ADDR(x))
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TCL2TQM_RING_MISC_ADDR(x), m)
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TCL2TQM_RING_MISC_ADDR(x),v)
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TCL2TQM_RING_MISC_ADDR(x),m,v,HWIO_TQM_R0_TCL2TQM_RING_MISC_IN(x))
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_SPARE_CONTROL_BMSK                                                           0x3fc000
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_SPARE_CONTROL_SHFT                                                                 14
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_SRNG_SM_STATE2_BMSK                                                            0x3000
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_SRNG_SM_STATE2_SHFT                                                                12
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_SRNG_SM_STATE1_BMSK                                                             0xf00
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_SRNG_SM_STATE1_SHFT                                                                 8
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_SRNG_IS_IDLE_BMSK                                                                0x80
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_SRNG_IS_IDLE_SHFT                                                                   7
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_SRNG_ENABLE_BMSK                                                                 0x40
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_SRNG_ENABLE_SHFT                                                                    6
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                           0x20
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                              5
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                            0x10
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                               4
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_MSI_SWAP_BIT_BMSK                                                                 0x8
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_MSI_SWAP_BIT_SHFT                                                                   3
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_SECURITY_BIT_BMSK                                                                 0x4
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_SECURITY_BIT_SHFT                                                                   2
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_LOOPCNT_DISABLE_BMSK                                                              0x2
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_LOOPCNT_DISABLE_SHFT                                                                1
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_RING_ID_DISABLE_BMSK                                                              0x1
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_RING_ID_DISABLE_SHFT                                                                0

#define HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_LSB_ADDR(x)                                                             ((x) + 0x50)
#define HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_LSB_PHYS(x)                                                             ((x) + 0x50)
#define HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_LSB_OFFS                                                                (0x50)
#define HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_LSB_RMSK                                                                0xffffffff
#define HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_LSB_POR                                                                 0x00000000
#define HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_LSB_POR_RMSK                                                            0xffffffff
#define HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_LSB_ATTR                                                                             0x3
#define HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_LSB_IN(x))
#define HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                           0xffffffff
#define HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                                    0

#define HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_MSB_ADDR(x)                                                             ((x) + 0x54)
#define HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_MSB_PHYS(x)                                                             ((x) + 0x54)
#define HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_MSB_OFFS                                                                (0x54)
#define HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_MSB_RMSK                                                                      0xff
#define HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_MSB_POR                                                                 0x00000000
#define HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_MSB_POR_RMSK                                                            0xffffffff
#define HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_MSB_ATTR                                                                             0x3
#define HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_MSB_IN(x))
#define HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                                 0xff
#define HWIO_TQM_R0_TCL2TQM_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                                    0

#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                                  ((x) + 0x64)
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                                  ((x) + 0x64)
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                     (0x64)
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                     0xffffffff
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX0_POR                                                      0x00000000
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                                 0xffffffff
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                                  0x3
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                           0xffff0000
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                                   16
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                       0x8000
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                           15
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                                 0x7fff
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                      0

#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                                  ((x) + 0x68)
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                                  ((x) + 0x68)
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                     (0x68)
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                         0xffff
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX1_POR                                                      0x00000000
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                                 0xffffffff
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                                  0x3
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                           0xffff
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                                0

#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_STATUS_ADDR(x)                                                     ((x) + 0x6c)
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_STATUS_PHYS(x)                                                     ((x) + 0x6c)
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_STATUS_OFFS                                                        (0x6c)
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_STATUS_RMSK                                                        0xffffffff
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_STATUS_POR                                                         0x00000000
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_STATUS_POR_RMSK                                                    0xffffffff
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_STATUS_ATTR                                                                     0x1
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                          0xffff0000
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                                  16
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                     0x8000
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                         15
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                               0x7fff
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                    0

#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                                  ((x) + 0x70)
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                                  ((x) + 0x70)
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                     (0x70)
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                          0x3ff
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_EMPTY_COUNTER_POR                                                      0x00000000
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                                 0xffffffff
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                                  0x3
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                       0x3ff
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                           0

#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                                 ((x) + 0x74)
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                                 ((x) + 0x74)
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_TIMER_OFFS                                                    (0x74)
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                           0x7
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_TIMER_POR                                                     0x00000003
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                                0xffffffff
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                                 0x3
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                      0x7
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                        0

#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                                ((x) + 0x78)
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                                ((x) + 0x78)
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_STATUS_OFFS                                                   (0x78)
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_STATUS_RMSK                                                     0xffffff
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_STATUS_POR                                                    0x00000000
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                               0xffffffff
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                                0x1
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                      0xff0000
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                            16
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                                     0xffff
#define HWIO_TQM_R0_TCL2TQM_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                          0

#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_LSB_ADDR(x)                                                           ((x) + 0x7c)
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_LSB_PHYS(x)                                                           ((x) + 0x7c)
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_LSB_OFFS                                                              (0x7c)
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_LSB_RMSK                                                              0xffffffff
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_LSB_POR                                                               0x00000000
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_LSB_POR_RMSK                                                          0xffffffff
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_LSB_ATTR                                                                           0x3
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_LSB_ADDR_BMSK                                                         0xffffffff
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_LSB_ADDR_SHFT                                                                  0

#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_MSB_ADDR(x)                                                           ((x) + 0x80)
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_MSB_PHYS(x)                                                           ((x) + 0x80)
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_MSB_OFFS                                                              (0x80)
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_MSB_RMSK                                                                   0x1ff
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_MSB_POR                                                               0x00000000
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_MSB_POR_RMSK                                                          0xffffffff
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_MSB_ATTR                                                                           0x3
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                       0x100
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                           8
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_MSB_ADDR_BMSK                                                               0xff
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_BASE_MSB_ADDR_SHFT                                                                  0

#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_DATA_ADDR(x)                                                               ((x) + 0x84)
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_DATA_PHYS(x)                                                               ((x) + 0x84)
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_DATA_OFFS                                                                  (0x84)
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_DATA_RMSK                                                                  0xffffffff
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_DATA_POR                                                                   0x00000000
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_DATA_POR_RMSK                                                              0xffffffff
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_DATA_ATTR                                                                               0x3
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_TQM_R0_TCL2TQM_RING_MSI1_DATA_ADDR(x))
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TCL2TQM_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TCL2TQM_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TCL2TQM_RING_MSI1_DATA_ADDR(x),m,v,HWIO_TQM_R0_TCL2TQM_RING_MSI1_DATA_IN(x))
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_DATA_VALUE_BMSK                                                            0xffffffff
#define HWIO_TQM_R0_TCL2TQM_RING_MSI1_DATA_VALUE_SHFT                                                                     0

#define HWIO_TQM_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_ADDR(x)                                                         ((x) + 0xa4)
#define HWIO_TQM_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_PHYS(x)                                                         ((x) + 0xa4)
#define HWIO_TQM_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_OFFS                                                            (0xa4)
#define HWIO_TQM_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_RMSK                                                                0xffff
#define HWIO_TQM_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_POR                                                             0x00000000
#define HWIO_TQM_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_POR_RMSK                                                        0xffffffff
#define HWIO_TQM_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_ATTR                                                                         0x3
#define HWIO_TQM_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_TQM_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_TQM_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_TQM_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_TQM_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_TQM_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_TQM_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                             0xffff
#define HWIO_TQM_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                                  0

#define HWIO_TQM_R0_TCL2TQM_RING_MISC_1_ADDR(x)                                                                  ((x) + 0xa8)
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_1_PHYS(x)                                                                  ((x) + 0xa8)
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_1_OFFS                                                                     (0xa8)
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_1_RMSK                                                                     0xffff003f
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_1_POR                                                                      0x00000000
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_1_POR_RMSK                                                                 0xffffffff
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_1_ATTR                                                                                  0x3
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_1_IN(x)            \
                in_dword(HWIO_TQM_R0_TCL2TQM_RING_MISC_1_ADDR(x))
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TCL2TQM_RING_MISC_1_ADDR(x), m)
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TCL2TQM_RING_MISC_1_ADDR(x),v)
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TCL2TQM_RING_MISC_1_ADDR(x),m,v,HWIO_TQM_R0_TCL2TQM_RING_MISC_1_IN(x))
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                            0xffff0000
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                    16
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                                   0x3f
#define HWIO_TQM_R0_TCL2TQM_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                      0

#define HWIO_TQM_R0_FW2TQM_RING_BASE_LSB_ADDR(x)                                                                 ((x) + 0xac)
#define HWIO_TQM_R0_FW2TQM_RING_BASE_LSB_PHYS(x)                                                                 ((x) + 0xac)
#define HWIO_TQM_R0_FW2TQM_RING_BASE_LSB_OFFS                                                                    (0xac)
#define HWIO_TQM_R0_FW2TQM_RING_BASE_LSB_RMSK                                                                    0xffffffff
#define HWIO_TQM_R0_FW2TQM_RING_BASE_LSB_POR                                                                     0x00000000
#define HWIO_TQM_R0_FW2TQM_RING_BASE_LSB_POR_RMSK                                                                0xffffffff
#define HWIO_TQM_R0_FW2TQM_RING_BASE_LSB_ATTR                                                                                 0x3
#define HWIO_TQM_R0_FW2TQM_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_FW2TQM_RING_BASE_LSB_ADDR(x))
#define HWIO_TQM_R0_FW2TQM_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_FW2TQM_RING_BASE_LSB_ADDR(x), m)
#define HWIO_TQM_R0_FW2TQM_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_FW2TQM_RING_BASE_LSB_ADDR(x),v)
#define HWIO_TQM_R0_FW2TQM_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_FW2TQM_RING_BASE_LSB_ADDR(x),m,v,HWIO_TQM_R0_FW2TQM_RING_BASE_LSB_IN(x))
#define HWIO_TQM_R0_FW2TQM_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                                 0xffffffff
#define HWIO_TQM_R0_FW2TQM_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                          0

#define HWIO_TQM_R0_FW2TQM_RING_BASE_MSB_ADDR(x)                                                                 ((x) + 0xb0)
#define HWIO_TQM_R0_FW2TQM_RING_BASE_MSB_PHYS(x)                                                                 ((x) + 0xb0)
#define HWIO_TQM_R0_FW2TQM_RING_BASE_MSB_OFFS                                                                    (0xb0)
#define HWIO_TQM_R0_FW2TQM_RING_BASE_MSB_RMSK                                                                      0xffffff
#define HWIO_TQM_R0_FW2TQM_RING_BASE_MSB_POR                                                                     0x00000000
#define HWIO_TQM_R0_FW2TQM_RING_BASE_MSB_POR_RMSK                                                                0xffffffff
#define HWIO_TQM_R0_FW2TQM_RING_BASE_MSB_ATTR                                                                                 0x3
#define HWIO_TQM_R0_FW2TQM_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_FW2TQM_RING_BASE_MSB_ADDR(x))
#define HWIO_TQM_R0_FW2TQM_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_FW2TQM_RING_BASE_MSB_ADDR(x), m)
#define HWIO_TQM_R0_FW2TQM_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_FW2TQM_RING_BASE_MSB_ADDR(x),v)
#define HWIO_TQM_R0_FW2TQM_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_FW2TQM_RING_BASE_MSB_ADDR(x),m,v,HWIO_TQM_R0_FW2TQM_RING_BASE_MSB_IN(x))
#define HWIO_TQM_R0_FW2TQM_RING_BASE_MSB_RING_SIZE_BMSK                                                            0xffff00
#define HWIO_TQM_R0_FW2TQM_RING_BASE_MSB_RING_SIZE_SHFT                                                                   8
#define HWIO_TQM_R0_FW2TQM_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                       0xff
#define HWIO_TQM_R0_FW2TQM_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                          0

#define HWIO_TQM_R0_FW2TQM_RING_ID_ADDR(x)                                                                       ((x) + 0xb4)
#define HWIO_TQM_R0_FW2TQM_RING_ID_PHYS(x)                                                                       ((x) + 0xb4)
#define HWIO_TQM_R0_FW2TQM_RING_ID_OFFS                                                                          (0xb4)
#define HWIO_TQM_R0_FW2TQM_RING_ID_RMSK                                                                                0xff
#define HWIO_TQM_R0_FW2TQM_RING_ID_POR                                                                           0x00000000
#define HWIO_TQM_R0_FW2TQM_RING_ID_POR_RMSK                                                                      0xffffffff
#define HWIO_TQM_R0_FW2TQM_RING_ID_ATTR                                                                                       0x3
#define HWIO_TQM_R0_FW2TQM_RING_ID_IN(x)            \
                in_dword(HWIO_TQM_R0_FW2TQM_RING_ID_ADDR(x))
#define HWIO_TQM_R0_FW2TQM_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_FW2TQM_RING_ID_ADDR(x), m)
#define HWIO_TQM_R0_FW2TQM_RING_ID_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_FW2TQM_RING_ID_ADDR(x),v)
#define HWIO_TQM_R0_FW2TQM_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_FW2TQM_RING_ID_ADDR(x),m,v,HWIO_TQM_R0_FW2TQM_RING_ID_IN(x))
#define HWIO_TQM_R0_FW2TQM_RING_ID_ENTRY_SIZE_BMSK                                                                     0xff
#define HWIO_TQM_R0_FW2TQM_RING_ID_ENTRY_SIZE_SHFT                                                                        0

#define HWIO_TQM_R0_FW2TQM_RING_STATUS_ADDR(x)                                                                   ((x) + 0xb8)
#define HWIO_TQM_R0_FW2TQM_RING_STATUS_PHYS(x)                                                                   ((x) + 0xb8)
#define HWIO_TQM_R0_FW2TQM_RING_STATUS_OFFS                                                                      (0xb8)
#define HWIO_TQM_R0_FW2TQM_RING_STATUS_RMSK                                                                      0xffffffff
#define HWIO_TQM_R0_FW2TQM_RING_STATUS_POR                                                                       0x00000000
#define HWIO_TQM_R0_FW2TQM_RING_STATUS_POR_RMSK                                                                  0xffffffff
#define HWIO_TQM_R0_FW2TQM_RING_STATUS_ATTR                                                                                   0x1
#define HWIO_TQM_R0_FW2TQM_RING_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_FW2TQM_RING_STATUS_ADDR(x))
#define HWIO_TQM_R0_FW2TQM_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_FW2TQM_RING_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_FW2TQM_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                      0xffff0000
#define HWIO_TQM_R0_FW2TQM_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                              16
#define HWIO_TQM_R0_FW2TQM_RING_STATUS_NUM_VALID_WORDS_BMSK                                                          0xffff
#define HWIO_TQM_R0_FW2TQM_RING_STATUS_NUM_VALID_WORDS_SHFT                                                               0

#define HWIO_TQM_R0_FW2TQM_RING_MISC_ADDR(x)                                                                     ((x) + 0xbc)
#define HWIO_TQM_R0_FW2TQM_RING_MISC_PHYS(x)                                                                     ((x) + 0xbc)
#define HWIO_TQM_R0_FW2TQM_RING_MISC_OFFS                                                                        (0xbc)
#define HWIO_TQM_R0_FW2TQM_RING_MISC_RMSK                                                                          0x3fffff
#define HWIO_TQM_R0_FW2TQM_RING_MISC_POR                                                                         0x00000080
#define HWIO_TQM_R0_FW2TQM_RING_MISC_POR_RMSK                                                                    0xffffffff
#define HWIO_TQM_R0_FW2TQM_RING_MISC_ATTR                                                                                     0x3
#define HWIO_TQM_R0_FW2TQM_RING_MISC_IN(x)            \
                in_dword(HWIO_TQM_R0_FW2TQM_RING_MISC_ADDR(x))
#define HWIO_TQM_R0_FW2TQM_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_FW2TQM_RING_MISC_ADDR(x), m)
#define HWIO_TQM_R0_FW2TQM_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_FW2TQM_RING_MISC_ADDR(x),v)
#define HWIO_TQM_R0_FW2TQM_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_FW2TQM_RING_MISC_ADDR(x),m,v,HWIO_TQM_R0_FW2TQM_RING_MISC_IN(x))
#define HWIO_TQM_R0_FW2TQM_RING_MISC_SPARE_CONTROL_BMSK                                                            0x3fc000
#define HWIO_TQM_R0_FW2TQM_RING_MISC_SPARE_CONTROL_SHFT                                                                  14
#define HWIO_TQM_R0_FW2TQM_RING_MISC_SRNG_SM_STATE2_BMSK                                                             0x3000
#define HWIO_TQM_R0_FW2TQM_RING_MISC_SRNG_SM_STATE2_SHFT                                                                 12
#define HWIO_TQM_R0_FW2TQM_RING_MISC_SRNG_SM_STATE1_BMSK                                                              0xf00
#define HWIO_TQM_R0_FW2TQM_RING_MISC_SRNG_SM_STATE1_SHFT                                                                  8
#define HWIO_TQM_R0_FW2TQM_RING_MISC_SRNG_IS_IDLE_BMSK                                                                 0x80
#define HWIO_TQM_R0_FW2TQM_RING_MISC_SRNG_IS_IDLE_SHFT                                                                    7
#define HWIO_TQM_R0_FW2TQM_RING_MISC_SRNG_ENABLE_BMSK                                                                  0x40
#define HWIO_TQM_R0_FW2TQM_RING_MISC_SRNG_ENABLE_SHFT                                                                     6
#define HWIO_TQM_R0_FW2TQM_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                            0x20
#define HWIO_TQM_R0_FW2TQM_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                               5
#define HWIO_TQM_R0_FW2TQM_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                             0x10
#define HWIO_TQM_R0_FW2TQM_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                                4
#define HWIO_TQM_R0_FW2TQM_RING_MISC_MSI_SWAP_BIT_BMSK                                                                  0x8
#define HWIO_TQM_R0_FW2TQM_RING_MISC_MSI_SWAP_BIT_SHFT                                                                    3
#define HWIO_TQM_R0_FW2TQM_RING_MISC_SECURITY_BIT_BMSK                                                                  0x4
#define HWIO_TQM_R0_FW2TQM_RING_MISC_SECURITY_BIT_SHFT                                                                    2
#define HWIO_TQM_R0_FW2TQM_RING_MISC_LOOPCNT_DISABLE_BMSK                                                               0x2
#define HWIO_TQM_R0_FW2TQM_RING_MISC_LOOPCNT_DISABLE_SHFT                                                                 1
#define HWIO_TQM_R0_FW2TQM_RING_MISC_RING_ID_DISABLE_BMSK                                                               0x1
#define HWIO_TQM_R0_FW2TQM_RING_MISC_RING_ID_DISABLE_SHFT                                                                 0

#define HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_LSB_ADDR(x)                                                              ((x) + 0xc8)
#define HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_LSB_PHYS(x)                                                              ((x) + 0xc8)
#define HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_LSB_OFFS                                                                 (0xc8)
#define HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_LSB_RMSK                                                                 0xffffffff
#define HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_LSB_POR                                                                  0x00000000
#define HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_LSB_POR_RMSK                                                             0xffffffff
#define HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_LSB_ATTR                                                                              0x3
#define HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_LSB_IN(x))
#define HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                            0xffffffff
#define HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                                     0

#define HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_MSB_ADDR(x)                                                              ((x) + 0xcc)
#define HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_MSB_PHYS(x)                                                              ((x) + 0xcc)
#define HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_MSB_OFFS                                                                 (0xcc)
#define HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_MSB_RMSK                                                                       0xff
#define HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_MSB_POR                                                                  0x00000000
#define HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_MSB_POR_RMSK                                                             0xffffffff
#define HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_MSB_ATTR                                                                              0x3
#define HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_MSB_IN(x))
#define HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                                  0xff
#define HWIO_TQM_R0_FW2TQM_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                                     0

#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                                   ((x) + 0xdc)
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                                   ((x) + 0xdc)
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                      (0xdc)
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                      0xffffffff
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX0_POR                                                       0x00000000
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                                  0xffffffff
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                                   0x3
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                            0xffff0000
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                                    16
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                        0x8000
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                            15
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                                  0x7fff
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                       0

#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                                   ((x) + 0xe0)
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                                   ((x) + 0xe0)
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                      (0xe0)
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                          0xffff
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX1_POR                                                       0x00000000
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                                  0xffffffff
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                                   0x3
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                            0xffff
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                                 0

#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_STATUS_ADDR(x)                                                      ((x) + 0xe4)
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_STATUS_PHYS(x)                                                      ((x) + 0xe4)
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_STATUS_OFFS                                                         (0xe4)
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_STATUS_RMSK                                                         0xffffffff
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_STATUS_POR                                                          0x00000000
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_STATUS_POR_RMSK                                                     0xffffffff
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_STATUS_ATTR                                                                      0x1
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                           0xffff0000
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                                   16
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                      0x8000
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                          15
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                                0x7fff
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                     0

#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                                   ((x) + 0xe8)
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                                   ((x) + 0xe8)
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                      (0xe8)
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                           0x3ff
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_EMPTY_COUNTER_POR                                                       0x00000000
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                                  0xffffffff
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                                   0x3
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_TQM_R0_FW2TQM_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_FW2TQM_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_FW2TQM_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_FW2TQM_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_TQM_R0_FW2TQM_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                        0x3ff
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                            0

#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                                  ((x) + 0xec)
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                                  ((x) + 0xec)
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_TIMER_OFFS                                                     (0xec)
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                            0x7
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_TIMER_POR                                                      0x00000003
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                                 0xffffffff
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                                  0x3
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                       0x7
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                         0

#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                                 ((x) + 0xf0)
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                                 ((x) + 0xf0)
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_STATUS_OFFS                                                    (0xf0)
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_STATUS_RMSK                                                      0xffffff
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_STATUS_POR                                                     0x00000000
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                                0xffffffff
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                                 0x1
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                       0xff0000
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                             16
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                                      0xffff
#define HWIO_TQM_R0_FW2TQM_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                           0

#define HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_LSB_ADDR(x)                                                            ((x) + 0xf4)
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_LSB_PHYS(x)                                                            ((x) + 0xf4)
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_LSB_OFFS                                                               (0xf4)
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_LSB_RMSK                                                               0xffffffff
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_LSB_POR                                                                0x00000000
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_LSB_POR_RMSK                                                           0xffffffff
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_LSB_ATTR                                                                            0x3
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_LSB_ADDR_BMSK                                                          0xffffffff
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_LSB_ADDR_SHFT                                                                   0

#define HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_MSB_ADDR(x)                                                            ((x) + 0xf8)
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_MSB_PHYS(x)                                                            ((x) + 0xf8)
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_MSB_OFFS                                                               (0xf8)
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_MSB_RMSK                                                                    0x1ff
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_MSB_POR                                                                0x00000000
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_MSB_POR_RMSK                                                           0xffffffff
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_MSB_ATTR                                                                            0x3
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                        0x100
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                            8
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_MSB_ADDR_BMSK                                                                0xff
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_BASE_MSB_ADDR_SHFT                                                                   0

#define HWIO_TQM_R0_FW2TQM_RING_MSI1_DATA_ADDR(x)                                                                ((x) + 0xfc)
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_DATA_PHYS(x)                                                                ((x) + 0xfc)
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_DATA_OFFS                                                                   (0xfc)
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_DATA_RMSK                                                                   0xffffffff
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_DATA_POR                                                                    0x00000000
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_DATA_POR_RMSK                                                               0xffffffff
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_DATA_ATTR                                                                                0x3
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_TQM_R0_FW2TQM_RING_MSI1_DATA_ADDR(x))
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_FW2TQM_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_FW2TQM_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_FW2TQM_RING_MSI1_DATA_ADDR(x),m,v,HWIO_TQM_R0_FW2TQM_RING_MSI1_DATA_IN(x))
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_DATA_VALUE_BMSK                                                             0xffffffff
#define HWIO_TQM_R0_FW2TQM_RING_MSI1_DATA_VALUE_SHFT                                                                      0

#define HWIO_TQM_R0_FW2TQM_RING_HP_TP_SW_OFFSET_ADDR(x)                                                          ((x) + 0x11c)
#define HWIO_TQM_R0_FW2TQM_RING_HP_TP_SW_OFFSET_PHYS(x)                                                          ((x) + 0x11c)
#define HWIO_TQM_R0_FW2TQM_RING_HP_TP_SW_OFFSET_OFFS                                                             (0x11c)
#define HWIO_TQM_R0_FW2TQM_RING_HP_TP_SW_OFFSET_RMSK                                                                 0xffff
#define HWIO_TQM_R0_FW2TQM_RING_HP_TP_SW_OFFSET_POR                                                              0x00000000
#define HWIO_TQM_R0_FW2TQM_RING_HP_TP_SW_OFFSET_POR_RMSK                                                         0xffffffff
#define HWIO_TQM_R0_FW2TQM_RING_HP_TP_SW_OFFSET_ATTR                                                                          0x3
#define HWIO_TQM_R0_FW2TQM_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_TQM_R0_FW2TQM_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_TQM_R0_FW2TQM_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_FW2TQM_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_TQM_R0_FW2TQM_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_FW2TQM_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_TQM_R0_FW2TQM_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_FW2TQM_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_TQM_R0_FW2TQM_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_TQM_R0_FW2TQM_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                              0xffff
#define HWIO_TQM_R0_FW2TQM_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                                   0

#define HWIO_TQM_R0_FW2TQM_RING_MISC_1_ADDR(x)                                                                   ((x) + 0x120)
#define HWIO_TQM_R0_FW2TQM_RING_MISC_1_PHYS(x)                                                                   ((x) + 0x120)
#define HWIO_TQM_R0_FW2TQM_RING_MISC_1_OFFS                                                                      (0x120)
#define HWIO_TQM_R0_FW2TQM_RING_MISC_1_RMSK                                                                      0xffff003f
#define HWIO_TQM_R0_FW2TQM_RING_MISC_1_POR                                                                       0x00000000
#define HWIO_TQM_R0_FW2TQM_RING_MISC_1_POR_RMSK                                                                  0xffffffff
#define HWIO_TQM_R0_FW2TQM_RING_MISC_1_ATTR                                                                                   0x3
#define HWIO_TQM_R0_FW2TQM_RING_MISC_1_IN(x)            \
                in_dword(HWIO_TQM_R0_FW2TQM_RING_MISC_1_ADDR(x))
#define HWIO_TQM_R0_FW2TQM_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_FW2TQM_RING_MISC_1_ADDR(x), m)
#define HWIO_TQM_R0_FW2TQM_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_FW2TQM_RING_MISC_1_ADDR(x),v)
#define HWIO_TQM_R0_FW2TQM_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_FW2TQM_RING_MISC_1_ADDR(x),m,v,HWIO_TQM_R0_FW2TQM_RING_MISC_1_IN(x))
#define HWIO_TQM_R0_FW2TQM_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                             0xffff0000
#define HWIO_TQM_R0_FW2TQM_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                     16
#define HWIO_TQM_R0_FW2TQM_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                                    0x3f
#define HWIO_TQM_R0_FW2TQM_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                       0

#define HWIO_TQM_R0_SW_CMD_RING_BASE_LSB_ADDR(x)                                                                 ((x) + 0x124)
#define HWIO_TQM_R0_SW_CMD_RING_BASE_LSB_PHYS(x)                                                                 ((x) + 0x124)
#define HWIO_TQM_R0_SW_CMD_RING_BASE_LSB_OFFS                                                                    (0x124)
#define HWIO_TQM_R0_SW_CMD_RING_BASE_LSB_RMSK                                                                    0xffffffff
#define HWIO_TQM_R0_SW_CMD_RING_BASE_LSB_POR                                                                     0x00000000
#define HWIO_TQM_R0_SW_CMD_RING_BASE_LSB_POR_RMSK                                                                0xffffffff
#define HWIO_TQM_R0_SW_CMD_RING_BASE_LSB_ATTR                                                                                 0x3
#define HWIO_TQM_R0_SW_CMD_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD_RING_BASE_LSB_ADDR(x))
#define HWIO_TQM_R0_SW_CMD_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD_RING_BASE_LSB_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SW_CMD_RING_BASE_LSB_ADDR(x),v)
#define HWIO_TQM_R0_SW_CMD_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SW_CMD_RING_BASE_LSB_ADDR(x),m,v,HWIO_TQM_R0_SW_CMD_RING_BASE_LSB_IN(x))
#define HWIO_TQM_R0_SW_CMD_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                                 0xffffffff
#define HWIO_TQM_R0_SW_CMD_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                          0

#define HWIO_TQM_R0_SW_CMD_RING_BASE_MSB_ADDR(x)                                                                 ((x) + 0x128)
#define HWIO_TQM_R0_SW_CMD_RING_BASE_MSB_PHYS(x)                                                                 ((x) + 0x128)
#define HWIO_TQM_R0_SW_CMD_RING_BASE_MSB_OFFS                                                                    (0x128)
#define HWIO_TQM_R0_SW_CMD_RING_BASE_MSB_RMSK                                                                      0xffffff
#define HWIO_TQM_R0_SW_CMD_RING_BASE_MSB_POR                                                                     0x00000000
#define HWIO_TQM_R0_SW_CMD_RING_BASE_MSB_POR_RMSK                                                                0xffffffff
#define HWIO_TQM_R0_SW_CMD_RING_BASE_MSB_ATTR                                                                                 0x3
#define HWIO_TQM_R0_SW_CMD_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD_RING_BASE_MSB_ADDR(x))
#define HWIO_TQM_R0_SW_CMD_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD_RING_BASE_MSB_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SW_CMD_RING_BASE_MSB_ADDR(x),v)
#define HWIO_TQM_R0_SW_CMD_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SW_CMD_RING_BASE_MSB_ADDR(x),m,v,HWIO_TQM_R0_SW_CMD_RING_BASE_MSB_IN(x))
#define HWIO_TQM_R0_SW_CMD_RING_BASE_MSB_RING_SIZE_BMSK                                                            0xffff00
#define HWIO_TQM_R0_SW_CMD_RING_BASE_MSB_RING_SIZE_SHFT                                                                   8
#define HWIO_TQM_R0_SW_CMD_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                       0xff
#define HWIO_TQM_R0_SW_CMD_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                          0

#define HWIO_TQM_R0_SW_CMD_RING_ID_ADDR(x)                                                                       ((x) + 0x12c)
#define HWIO_TQM_R0_SW_CMD_RING_ID_PHYS(x)                                                                       ((x) + 0x12c)
#define HWIO_TQM_R0_SW_CMD_RING_ID_OFFS                                                                          (0x12c)
#define HWIO_TQM_R0_SW_CMD_RING_ID_RMSK                                                                                0xff
#define HWIO_TQM_R0_SW_CMD_RING_ID_POR                                                                           0x00000000
#define HWIO_TQM_R0_SW_CMD_RING_ID_POR_RMSK                                                                      0xffffffff
#define HWIO_TQM_R0_SW_CMD_RING_ID_ATTR                                                                                       0x3
#define HWIO_TQM_R0_SW_CMD_RING_ID_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD_RING_ID_ADDR(x))
#define HWIO_TQM_R0_SW_CMD_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD_RING_ID_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD_RING_ID_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SW_CMD_RING_ID_ADDR(x),v)
#define HWIO_TQM_R0_SW_CMD_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SW_CMD_RING_ID_ADDR(x),m,v,HWIO_TQM_R0_SW_CMD_RING_ID_IN(x))
#define HWIO_TQM_R0_SW_CMD_RING_ID_ENTRY_SIZE_BMSK                                                                     0xff
#define HWIO_TQM_R0_SW_CMD_RING_ID_ENTRY_SIZE_SHFT                                                                        0

#define HWIO_TQM_R0_SW_CMD_RING_STATUS_ADDR(x)                                                                   ((x) + 0x130)
#define HWIO_TQM_R0_SW_CMD_RING_STATUS_PHYS(x)                                                                   ((x) + 0x130)
#define HWIO_TQM_R0_SW_CMD_RING_STATUS_OFFS                                                                      (0x130)
#define HWIO_TQM_R0_SW_CMD_RING_STATUS_RMSK                                                                      0xffffffff
#define HWIO_TQM_R0_SW_CMD_RING_STATUS_POR                                                                       0x00000000
#define HWIO_TQM_R0_SW_CMD_RING_STATUS_POR_RMSK                                                                  0xffffffff
#define HWIO_TQM_R0_SW_CMD_RING_STATUS_ATTR                                                                                   0x1
#define HWIO_TQM_R0_SW_CMD_RING_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD_RING_STATUS_ADDR(x))
#define HWIO_TQM_R0_SW_CMD_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD_RING_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                      0xffff0000
#define HWIO_TQM_R0_SW_CMD_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                              16
#define HWIO_TQM_R0_SW_CMD_RING_STATUS_NUM_VALID_WORDS_BMSK                                                          0xffff
#define HWIO_TQM_R0_SW_CMD_RING_STATUS_NUM_VALID_WORDS_SHFT                                                               0

#define HWIO_TQM_R0_SW_CMD_RING_MISC_ADDR(x)                                                                     ((x) + 0x134)
#define HWIO_TQM_R0_SW_CMD_RING_MISC_PHYS(x)                                                                     ((x) + 0x134)
#define HWIO_TQM_R0_SW_CMD_RING_MISC_OFFS                                                                        (0x134)
#define HWIO_TQM_R0_SW_CMD_RING_MISC_RMSK                                                                          0x3fffff
#define HWIO_TQM_R0_SW_CMD_RING_MISC_POR                                                                         0x00000080
#define HWIO_TQM_R0_SW_CMD_RING_MISC_POR_RMSK                                                                    0xffffffff
#define HWIO_TQM_R0_SW_CMD_RING_MISC_ATTR                                                                                     0x3
#define HWIO_TQM_R0_SW_CMD_RING_MISC_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD_RING_MISC_ADDR(x))
#define HWIO_TQM_R0_SW_CMD_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD_RING_MISC_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SW_CMD_RING_MISC_ADDR(x),v)
#define HWIO_TQM_R0_SW_CMD_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SW_CMD_RING_MISC_ADDR(x),m,v,HWIO_TQM_R0_SW_CMD_RING_MISC_IN(x))
#define HWIO_TQM_R0_SW_CMD_RING_MISC_SPARE_CONTROL_BMSK                                                            0x3fc000
#define HWIO_TQM_R0_SW_CMD_RING_MISC_SPARE_CONTROL_SHFT                                                                  14
#define HWIO_TQM_R0_SW_CMD_RING_MISC_SRNG_SM_STATE2_BMSK                                                             0x3000
#define HWIO_TQM_R0_SW_CMD_RING_MISC_SRNG_SM_STATE2_SHFT                                                                 12
#define HWIO_TQM_R0_SW_CMD_RING_MISC_SRNG_SM_STATE1_BMSK                                                              0xf00
#define HWIO_TQM_R0_SW_CMD_RING_MISC_SRNG_SM_STATE1_SHFT                                                                  8
#define HWIO_TQM_R0_SW_CMD_RING_MISC_SRNG_IS_IDLE_BMSK                                                                 0x80
#define HWIO_TQM_R0_SW_CMD_RING_MISC_SRNG_IS_IDLE_SHFT                                                                    7
#define HWIO_TQM_R0_SW_CMD_RING_MISC_SRNG_ENABLE_BMSK                                                                  0x40
#define HWIO_TQM_R0_SW_CMD_RING_MISC_SRNG_ENABLE_SHFT                                                                     6
#define HWIO_TQM_R0_SW_CMD_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                            0x20
#define HWIO_TQM_R0_SW_CMD_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                               5
#define HWIO_TQM_R0_SW_CMD_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                             0x10
#define HWIO_TQM_R0_SW_CMD_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                                4
#define HWIO_TQM_R0_SW_CMD_RING_MISC_MSI_SWAP_BIT_BMSK                                                                  0x8
#define HWIO_TQM_R0_SW_CMD_RING_MISC_MSI_SWAP_BIT_SHFT                                                                    3
#define HWIO_TQM_R0_SW_CMD_RING_MISC_SECURITY_BIT_BMSK                                                                  0x4
#define HWIO_TQM_R0_SW_CMD_RING_MISC_SECURITY_BIT_SHFT                                                                    2
#define HWIO_TQM_R0_SW_CMD_RING_MISC_LOOPCNT_DISABLE_BMSK                                                               0x2
#define HWIO_TQM_R0_SW_CMD_RING_MISC_LOOPCNT_DISABLE_SHFT                                                                 1
#define HWIO_TQM_R0_SW_CMD_RING_MISC_RING_ID_DISABLE_BMSK                                                               0x1
#define HWIO_TQM_R0_SW_CMD_RING_MISC_RING_ID_DISABLE_SHFT                                                                 0

#define HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_LSB_ADDR(x)                                                              ((x) + 0x140)
#define HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_LSB_PHYS(x)                                                              ((x) + 0x140)
#define HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_LSB_OFFS                                                                 (0x140)
#define HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_LSB_RMSK                                                                 0xffffffff
#define HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_LSB_POR                                                                  0x00000000
#define HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_LSB_POR_RMSK                                                             0xffffffff
#define HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_LSB_ATTR                                                                              0x3
#define HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_LSB_IN(x))
#define HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                            0xffffffff
#define HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                                     0

#define HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_MSB_ADDR(x)                                                              ((x) + 0x144)
#define HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_MSB_PHYS(x)                                                              ((x) + 0x144)
#define HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_MSB_OFFS                                                                 (0x144)
#define HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_MSB_RMSK                                                                       0xff
#define HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_MSB_POR                                                                  0x00000000
#define HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_MSB_POR_RMSK                                                             0xffffffff
#define HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_MSB_ATTR                                                                              0x3
#define HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_MSB_IN(x))
#define HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                                  0xff
#define HWIO_TQM_R0_SW_CMD_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                                     0

#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                                   ((x) + 0x154)
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                                   ((x) + 0x154)
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                      (0x154)
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                      0xffffffff
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX0_POR                                                       0x00000000
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                                  0xffffffff
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                                   0x3
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                            0xffff0000
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                                    16
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                        0x8000
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                            15
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                                  0x7fff
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                       0

#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                                   ((x) + 0x158)
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                                   ((x) + 0x158)
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                      (0x158)
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                          0xffff
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX1_POR                                                       0x00000000
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                                  0xffffffff
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                                   0x3
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                            0xffff
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                                 0

#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_STATUS_ADDR(x)                                                      ((x) + 0x15c)
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_STATUS_PHYS(x)                                                      ((x) + 0x15c)
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_STATUS_OFFS                                                         (0x15c)
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_STATUS_RMSK                                                         0xffffffff
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_STATUS_POR                                                          0x00000000
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_STATUS_POR_RMSK                                                     0xffffffff
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_STATUS_ATTR                                                                      0x1
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                           0xffff0000
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                                   16
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                      0x8000
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                          15
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                                0x7fff
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                     0

#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                                   ((x) + 0x160)
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                                   ((x) + 0x160)
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                      (0x160)
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                           0x3ff
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_EMPTY_COUNTER_POR                                                       0x00000000
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                                  0xffffffff
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                                   0x3
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SW_CMD_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SW_CMD_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_TQM_R0_SW_CMD_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                        0x3ff
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                            0

#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                                  ((x) + 0x164)
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                                  ((x) + 0x164)
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_TIMER_OFFS                                                     (0x164)
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                            0x7
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_TIMER_POR                                                      0x00000003
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                                 0xffffffff
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                                  0x3
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                       0x7
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                         0

#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                                 ((x) + 0x168)
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                                 ((x) + 0x168)
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_STATUS_OFFS                                                    (0x168)
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_STATUS_RMSK                                                      0xffffff
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_STATUS_POR                                                     0x00000000
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                                0xffffffff
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                                 0x1
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                       0xff0000
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                             16
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                                      0xffff
#define HWIO_TQM_R0_SW_CMD_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                           0

#define HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_LSB_ADDR(x)                                                            ((x) + 0x16c)
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_LSB_PHYS(x)                                                            ((x) + 0x16c)
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_LSB_OFFS                                                               (0x16c)
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_LSB_RMSK                                                               0xffffffff
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_LSB_POR                                                                0x00000000
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_LSB_POR_RMSK                                                           0xffffffff
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_LSB_ATTR                                                                            0x3
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_LSB_ADDR_BMSK                                                          0xffffffff
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_LSB_ADDR_SHFT                                                                   0

#define HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_MSB_ADDR(x)                                                            ((x) + 0x170)
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_MSB_PHYS(x)                                                            ((x) + 0x170)
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_MSB_OFFS                                                               (0x170)
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_MSB_RMSK                                                                    0x1ff
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_MSB_POR                                                                0x00000000
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_MSB_POR_RMSK                                                           0xffffffff
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_MSB_ATTR                                                                            0x3
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                        0x100
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                            8
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_MSB_ADDR_BMSK                                                                0xff
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_BASE_MSB_ADDR_SHFT                                                                   0

#define HWIO_TQM_R0_SW_CMD_RING_MSI1_DATA_ADDR(x)                                                                ((x) + 0x174)
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_DATA_PHYS(x)                                                                ((x) + 0x174)
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_DATA_OFFS                                                                   (0x174)
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_DATA_RMSK                                                                   0xffffffff
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_DATA_POR                                                                    0x00000000
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_DATA_POR_RMSK                                                               0xffffffff
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_DATA_ATTR                                                                                0x3
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD_RING_MSI1_DATA_ADDR(x))
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SW_CMD_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SW_CMD_RING_MSI1_DATA_ADDR(x),m,v,HWIO_TQM_R0_SW_CMD_RING_MSI1_DATA_IN(x))
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_DATA_VALUE_BMSK                                                             0xffffffff
#define HWIO_TQM_R0_SW_CMD_RING_MSI1_DATA_VALUE_SHFT                                                                      0

#define HWIO_TQM_R0_SW_CMD_RING_HP_TP_SW_OFFSET_ADDR(x)                                                          ((x) + 0x194)
#define HWIO_TQM_R0_SW_CMD_RING_HP_TP_SW_OFFSET_PHYS(x)                                                          ((x) + 0x194)
#define HWIO_TQM_R0_SW_CMD_RING_HP_TP_SW_OFFSET_OFFS                                                             (0x194)
#define HWIO_TQM_R0_SW_CMD_RING_HP_TP_SW_OFFSET_RMSK                                                                 0xffff
#define HWIO_TQM_R0_SW_CMD_RING_HP_TP_SW_OFFSET_POR                                                              0x00000000
#define HWIO_TQM_R0_SW_CMD_RING_HP_TP_SW_OFFSET_POR_RMSK                                                         0xffffffff
#define HWIO_TQM_R0_SW_CMD_RING_HP_TP_SW_OFFSET_ATTR                                                                          0x3
#define HWIO_TQM_R0_SW_CMD_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_TQM_R0_SW_CMD_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SW_CMD_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_TQM_R0_SW_CMD_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SW_CMD_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_TQM_R0_SW_CMD_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_TQM_R0_SW_CMD_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                              0xffff
#define HWIO_TQM_R0_SW_CMD_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                                   0

#define HWIO_TQM_R0_SW_CMD_RING_MISC_1_ADDR(x)                                                                   ((x) + 0x198)
#define HWIO_TQM_R0_SW_CMD_RING_MISC_1_PHYS(x)                                                                   ((x) + 0x198)
#define HWIO_TQM_R0_SW_CMD_RING_MISC_1_OFFS                                                                      (0x198)
#define HWIO_TQM_R0_SW_CMD_RING_MISC_1_RMSK                                                                      0xffff003f
#define HWIO_TQM_R0_SW_CMD_RING_MISC_1_POR                                                                       0x00000000
#define HWIO_TQM_R0_SW_CMD_RING_MISC_1_POR_RMSK                                                                  0xffffffff
#define HWIO_TQM_R0_SW_CMD_RING_MISC_1_ATTR                                                                                   0x3
#define HWIO_TQM_R0_SW_CMD_RING_MISC_1_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD_RING_MISC_1_ADDR(x))
#define HWIO_TQM_R0_SW_CMD_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD_RING_MISC_1_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SW_CMD_RING_MISC_1_ADDR(x),v)
#define HWIO_TQM_R0_SW_CMD_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SW_CMD_RING_MISC_1_ADDR(x),m,v,HWIO_TQM_R0_SW_CMD_RING_MISC_1_IN(x))
#define HWIO_TQM_R0_SW_CMD_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                             0xffff0000
#define HWIO_TQM_R0_SW_CMD_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                     16
#define HWIO_TQM_R0_SW_CMD_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                                    0x3f
#define HWIO_TQM_R0_SW_CMD_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                       0

#define HWIO_TQM_R0_SW_CMD1_RING_BASE_LSB_ADDR(x)                                                                ((x) + 0x19c)
#define HWIO_TQM_R0_SW_CMD1_RING_BASE_LSB_PHYS(x)                                                                ((x) + 0x19c)
#define HWIO_TQM_R0_SW_CMD1_RING_BASE_LSB_OFFS                                                                   (0x19c)
#define HWIO_TQM_R0_SW_CMD1_RING_BASE_LSB_RMSK                                                                   0xffffffff
#define HWIO_TQM_R0_SW_CMD1_RING_BASE_LSB_POR                                                                    0x00000000
#define HWIO_TQM_R0_SW_CMD1_RING_BASE_LSB_POR_RMSK                                                               0xffffffff
#define HWIO_TQM_R0_SW_CMD1_RING_BASE_LSB_ATTR                                                                                0x3
#define HWIO_TQM_R0_SW_CMD1_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD1_RING_BASE_LSB_ADDR(x))
#define HWIO_TQM_R0_SW_CMD1_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD1_RING_BASE_LSB_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD1_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SW_CMD1_RING_BASE_LSB_ADDR(x),v)
#define HWIO_TQM_R0_SW_CMD1_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SW_CMD1_RING_BASE_LSB_ADDR(x),m,v,HWIO_TQM_R0_SW_CMD1_RING_BASE_LSB_IN(x))
#define HWIO_TQM_R0_SW_CMD1_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                                0xffffffff
#define HWIO_TQM_R0_SW_CMD1_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                         0

#define HWIO_TQM_R0_SW_CMD1_RING_BASE_MSB_ADDR(x)                                                                ((x) + 0x1a0)
#define HWIO_TQM_R0_SW_CMD1_RING_BASE_MSB_PHYS(x)                                                                ((x) + 0x1a0)
#define HWIO_TQM_R0_SW_CMD1_RING_BASE_MSB_OFFS                                                                   (0x1a0)
#define HWIO_TQM_R0_SW_CMD1_RING_BASE_MSB_RMSK                                                                     0xffffff
#define HWIO_TQM_R0_SW_CMD1_RING_BASE_MSB_POR                                                                    0x00000000
#define HWIO_TQM_R0_SW_CMD1_RING_BASE_MSB_POR_RMSK                                                               0xffffffff
#define HWIO_TQM_R0_SW_CMD1_RING_BASE_MSB_ATTR                                                                                0x3
#define HWIO_TQM_R0_SW_CMD1_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD1_RING_BASE_MSB_ADDR(x))
#define HWIO_TQM_R0_SW_CMD1_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD1_RING_BASE_MSB_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD1_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SW_CMD1_RING_BASE_MSB_ADDR(x),v)
#define HWIO_TQM_R0_SW_CMD1_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SW_CMD1_RING_BASE_MSB_ADDR(x),m,v,HWIO_TQM_R0_SW_CMD1_RING_BASE_MSB_IN(x))
#define HWIO_TQM_R0_SW_CMD1_RING_BASE_MSB_RING_SIZE_BMSK                                                           0xffff00
#define HWIO_TQM_R0_SW_CMD1_RING_BASE_MSB_RING_SIZE_SHFT                                                                  8
#define HWIO_TQM_R0_SW_CMD1_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                      0xff
#define HWIO_TQM_R0_SW_CMD1_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                         0

#define HWIO_TQM_R0_SW_CMD1_RING_ID_ADDR(x)                                                                      ((x) + 0x1a4)
#define HWIO_TQM_R0_SW_CMD1_RING_ID_PHYS(x)                                                                      ((x) + 0x1a4)
#define HWIO_TQM_R0_SW_CMD1_RING_ID_OFFS                                                                         (0x1a4)
#define HWIO_TQM_R0_SW_CMD1_RING_ID_RMSK                                                                               0xff
#define HWIO_TQM_R0_SW_CMD1_RING_ID_POR                                                                          0x00000000
#define HWIO_TQM_R0_SW_CMD1_RING_ID_POR_RMSK                                                                     0xffffffff
#define HWIO_TQM_R0_SW_CMD1_RING_ID_ATTR                                                                                      0x3
#define HWIO_TQM_R0_SW_CMD1_RING_ID_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD1_RING_ID_ADDR(x))
#define HWIO_TQM_R0_SW_CMD1_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD1_RING_ID_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD1_RING_ID_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SW_CMD1_RING_ID_ADDR(x),v)
#define HWIO_TQM_R0_SW_CMD1_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SW_CMD1_RING_ID_ADDR(x),m,v,HWIO_TQM_R0_SW_CMD1_RING_ID_IN(x))
#define HWIO_TQM_R0_SW_CMD1_RING_ID_ENTRY_SIZE_BMSK                                                                    0xff
#define HWIO_TQM_R0_SW_CMD1_RING_ID_ENTRY_SIZE_SHFT                                                                       0

#define HWIO_TQM_R0_SW_CMD1_RING_STATUS_ADDR(x)                                                                  ((x) + 0x1a8)
#define HWIO_TQM_R0_SW_CMD1_RING_STATUS_PHYS(x)                                                                  ((x) + 0x1a8)
#define HWIO_TQM_R0_SW_CMD1_RING_STATUS_OFFS                                                                     (0x1a8)
#define HWIO_TQM_R0_SW_CMD1_RING_STATUS_RMSK                                                                     0xffffffff
#define HWIO_TQM_R0_SW_CMD1_RING_STATUS_POR                                                                      0x00000000
#define HWIO_TQM_R0_SW_CMD1_RING_STATUS_POR_RMSK                                                                 0xffffffff
#define HWIO_TQM_R0_SW_CMD1_RING_STATUS_ATTR                                                                                  0x1
#define HWIO_TQM_R0_SW_CMD1_RING_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD1_RING_STATUS_ADDR(x))
#define HWIO_TQM_R0_SW_CMD1_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD1_RING_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD1_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                     0xffff0000
#define HWIO_TQM_R0_SW_CMD1_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                             16
#define HWIO_TQM_R0_SW_CMD1_RING_STATUS_NUM_VALID_WORDS_BMSK                                                         0xffff
#define HWIO_TQM_R0_SW_CMD1_RING_STATUS_NUM_VALID_WORDS_SHFT                                                              0

#define HWIO_TQM_R0_SW_CMD1_RING_MISC_ADDR(x)                                                                    ((x) + 0x1ac)
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_PHYS(x)                                                                    ((x) + 0x1ac)
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_OFFS                                                                       (0x1ac)
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_RMSK                                                                         0x3fffff
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_POR                                                                        0x00000080
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_POR_RMSK                                                                   0xffffffff
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_ATTR                                                                                    0x3
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD1_RING_MISC_ADDR(x))
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD1_RING_MISC_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SW_CMD1_RING_MISC_ADDR(x),v)
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SW_CMD1_RING_MISC_ADDR(x),m,v,HWIO_TQM_R0_SW_CMD1_RING_MISC_IN(x))
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_SPARE_CONTROL_BMSK                                                           0x3fc000
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_SPARE_CONTROL_SHFT                                                                 14
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_SRNG_SM_STATE2_BMSK                                                            0x3000
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_SRNG_SM_STATE2_SHFT                                                                12
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_SRNG_SM_STATE1_BMSK                                                             0xf00
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_SRNG_SM_STATE1_SHFT                                                                 8
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_SRNG_IS_IDLE_BMSK                                                                0x80
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_SRNG_IS_IDLE_SHFT                                                                   7
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_SRNG_ENABLE_BMSK                                                                 0x40
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_SRNG_ENABLE_SHFT                                                                    6
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                           0x20
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                              5
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                            0x10
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                               4
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_MSI_SWAP_BIT_BMSK                                                                 0x8
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_MSI_SWAP_BIT_SHFT                                                                   3
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_SECURITY_BIT_BMSK                                                                 0x4
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_SECURITY_BIT_SHFT                                                                   2
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_LOOPCNT_DISABLE_BMSK                                                              0x2
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_LOOPCNT_DISABLE_SHFT                                                                1
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_RING_ID_DISABLE_BMSK                                                              0x1
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_RING_ID_DISABLE_SHFT                                                                0

#define HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_LSB_ADDR(x)                                                             ((x) + 0x1b8)
#define HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_LSB_PHYS(x)                                                             ((x) + 0x1b8)
#define HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_LSB_OFFS                                                                (0x1b8)
#define HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_LSB_RMSK                                                                0xffffffff
#define HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_LSB_POR                                                                 0x00000000
#define HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_LSB_POR_RMSK                                                            0xffffffff
#define HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_LSB_ATTR                                                                             0x3
#define HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_LSB_IN(x))
#define HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                           0xffffffff
#define HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                                    0

#define HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_MSB_ADDR(x)                                                             ((x) + 0x1bc)
#define HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_MSB_PHYS(x)                                                             ((x) + 0x1bc)
#define HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_MSB_OFFS                                                                (0x1bc)
#define HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_MSB_RMSK                                                                      0xff
#define HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_MSB_POR                                                                 0x00000000
#define HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_MSB_POR_RMSK                                                            0xffffffff
#define HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_MSB_ATTR                                                                             0x3
#define HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_MSB_IN(x))
#define HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                                 0xff
#define HWIO_TQM_R0_SW_CMD1_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                                    0

#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                                  ((x) + 0x1cc)
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                                  ((x) + 0x1cc)
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                     (0x1cc)
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                     0xffffffff
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX0_POR                                                      0x00000000
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                                 0xffffffff
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                                  0x3
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                           0xffff0000
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                                   16
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                       0x8000
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                           15
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                                 0x7fff
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                      0

#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                                  ((x) + 0x1d0)
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                                  ((x) + 0x1d0)
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                     (0x1d0)
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                         0xffff
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX1_POR                                                      0x00000000
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                                 0xffffffff
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                                  0x3
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                           0xffff
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                                0

#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_STATUS_ADDR(x)                                                     ((x) + 0x1d4)
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_STATUS_PHYS(x)                                                     ((x) + 0x1d4)
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_STATUS_OFFS                                                        (0x1d4)
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_STATUS_RMSK                                                        0xffffffff
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_STATUS_POR                                                         0x00000000
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_STATUS_POR_RMSK                                                    0xffffffff
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_STATUS_ATTR                                                                     0x1
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                          0xffff0000
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                                  16
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                     0x8000
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                         15
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                               0x7fff
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                    0

#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                                  ((x) + 0x1d8)
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                                  ((x) + 0x1d8)
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                     (0x1d8)
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                          0x3ff
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_EMPTY_COUNTER_POR                                                      0x00000000
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                                 0xffffffff
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                                  0x3
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                       0x3ff
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                           0

#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                                 ((x) + 0x1dc)
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                                 ((x) + 0x1dc)
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_TIMER_OFFS                                                    (0x1dc)
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                           0x7
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_TIMER_POR                                                     0x00000003
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                                0xffffffff
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                                 0x3
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                      0x7
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                        0

#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                                ((x) + 0x1e0)
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                                ((x) + 0x1e0)
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_STATUS_OFFS                                                   (0x1e0)
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_STATUS_RMSK                                                     0xffffff
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_STATUS_POR                                                    0x00000000
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                               0xffffffff
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                                0x1
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                      0xff0000
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                            16
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                                     0xffff
#define HWIO_TQM_R0_SW_CMD1_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                          0

#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_LSB_ADDR(x)                                                           ((x) + 0x1e4)
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_LSB_PHYS(x)                                                           ((x) + 0x1e4)
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_LSB_OFFS                                                              (0x1e4)
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_LSB_RMSK                                                              0xffffffff
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_LSB_POR                                                               0x00000000
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_LSB_POR_RMSK                                                          0xffffffff
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_LSB_ATTR                                                                           0x3
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_LSB_ADDR_BMSK                                                         0xffffffff
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_LSB_ADDR_SHFT                                                                  0

#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_MSB_ADDR(x)                                                           ((x) + 0x1e8)
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_MSB_PHYS(x)                                                           ((x) + 0x1e8)
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_MSB_OFFS                                                              (0x1e8)
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_MSB_RMSK                                                                   0x1ff
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_MSB_POR                                                               0x00000000
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_MSB_POR_RMSK                                                          0xffffffff
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_MSB_ATTR                                                                           0x3
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                       0x100
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                           8
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_MSB_ADDR_BMSK                                                               0xff
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_BASE_MSB_ADDR_SHFT                                                                  0

#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_DATA_ADDR(x)                                                               ((x) + 0x1ec)
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_DATA_PHYS(x)                                                               ((x) + 0x1ec)
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_DATA_OFFS                                                                  (0x1ec)
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_DATA_RMSK                                                                  0xffffffff
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_DATA_POR                                                                   0x00000000
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_DATA_POR_RMSK                                                              0xffffffff
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_DATA_ATTR                                                                               0x3
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD1_RING_MSI1_DATA_ADDR(x))
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD1_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SW_CMD1_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SW_CMD1_RING_MSI1_DATA_ADDR(x),m,v,HWIO_TQM_R0_SW_CMD1_RING_MSI1_DATA_IN(x))
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_DATA_VALUE_BMSK                                                            0xffffffff
#define HWIO_TQM_R0_SW_CMD1_RING_MSI1_DATA_VALUE_SHFT                                                                     0

#define HWIO_TQM_R0_SW_CMD1_RING_HP_TP_SW_OFFSET_ADDR(x)                                                         ((x) + 0x20c)
#define HWIO_TQM_R0_SW_CMD1_RING_HP_TP_SW_OFFSET_PHYS(x)                                                         ((x) + 0x20c)
#define HWIO_TQM_R0_SW_CMD1_RING_HP_TP_SW_OFFSET_OFFS                                                            (0x20c)
#define HWIO_TQM_R0_SW_CMD1_RING_HP_TP_SW_OFFSET_RMSK                                                                0xffff
#define HWIO_TQM_R0_SW_CMD1_RING_HP_TP_SW_OFFSET_POR                                                             0x00000000
#define HWIO_TQM_R0_SW_CMD1_RING_HP_TP_SW_OFFSET_POR_RMSK                                                        0xffffffff
#define HWIO_TQM_R0_SW_CMD1_RING_HP_TP_SW_OFFSET_ATTR                                                                         0x3
#define HWIO_TQM_R0_SW_CMD1_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD1_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_TQM_R0_SW_CMD1_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD1_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD1_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SW_CMD1_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_TQM_R0_SW_CMD1_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SW_CMD1_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_TQM_R0_SW_CMD1_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_TQM_R0_SW_CMD1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                             0xffff
#define HWIO_TQM_R0_SW_CMD1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                                  0

#define HWIO_TQM_R0_SW_CMD1_RING_MISC_1_ADDR(x)                                                                  ((x) + 0x210)
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_1_PHYS(x)                                                                  ((x) + 0x210)
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_1_OFFS                                                                     (0x210)
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_1_RMSK                                                                     0xffff003f
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_1_POR                                                                      0x00000000
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_1_POR_RMSK                                                                 0xffffffff
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_1_ATTR                                                                                  0x3
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_1_IN(x)            \
                in_dword(HWIO_TQM_R0_SW_CMD1_RING_MISC_1_ADDR(x))
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SW_CMD1_RING_MISC_1_ADDR(x), m)
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SW_CMD1_RING_MISC_1_ADDR(x),v)
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SW_CMD1_RING_MISC_1_ADDR(x),m,v,HWIO_TQM_R0_SW_CMD1_RING_MISC_1_IN(x))
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                            0xffff0000
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                    16
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                                   0x3f
#define HWIO_TQM_R0_SW_CMD1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                      0

#define HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_LSB_ADDR(x)                                                           ((x) + 0x214)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_LSB_PHYS(x)                                                           ((x) + 0x214)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_LSB_OFFS                                                              (0x214)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_LSB_RMSK                                                              0xffffffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_LSB_POR                                                               0x00000000
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_LSB_POR_RMSK                                                          0xffffffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_LSB_ATTR                                                                           0x3
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_LSB_ADDR(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_LSB_ADDR(x), m)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_LSB_ADDR(x),v)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_LSB_ADDR(x),m,v,HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_LSB_IN(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                           0xffffffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                    0

#define HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_MSB_ADDR(x)                                                           ((x) + 0x218)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_MSB_PHYS(x)                                                           ((x) + 0x218)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_MSB_OFFS                                                              (0x218)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_MSB_RMSK                                                                0xffffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_MSB_POR                                                               0x00000000
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_MSB_POR_RMSK                                                          0xffffffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_MSB_ATTR                                                                           0x3
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_MSB_ADDR(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_MSB_ADDR(x), m)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_MSB_ADDR(x),v)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_MSB_ADDR(x),m,v,HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_MSB_IN(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_MSB_RING_SIZE_BMSK                                                      0xffff00
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_MSB_RING_SIZE_SHFT                                                             8
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                 0xff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                    0

#define HWIO_TQM_R0_WBM2TQM_LINK_RING_ID_ADDR(x)                                                                 ((x) + 0x21c)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_ID_PHYS(x)                                                                 ((x) + 0x21c)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_ID_OFFS                                                                    (0x21c)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_ID_RMSK                                                                          0xff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_ID_POR                                                                     0x00000000
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_ID_POR_RMSK                                                                0xffffffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_ID_ATTR                                                                                 0x3
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_ID_IN(x)            \
                in_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_ID_ADDR(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_WBM2TQM_LINK_RING_ID_ADDR(x), m)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_ID_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_ID_ADDR(x),v)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_WBM2TQM_LINK_RING_ID_ADDR(x),m,v,HWIO_TQM_R0_WBM2TQM_LINK_RING_ID_IN(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_ID_ENTRY_SIZE_BMSK                                                               0xff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_ID_ENTRY_SIZE_SHFT                                                                  0

#define HWIO_TQM_R0_WBM2TQM_LINK_RING_STATUS_ADDR(x)                                                             ((x) + 0x220)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_STATUS_PHYS(x)                                                             ((x) + 0x220)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_STATUS_OFFS                                                                (0x220)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_STATUS_RMSK                                                                0xffffffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_STATUS_POR                                                                 0x00000000
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_STATUS_POR_RMSK                                                            0xffffffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_STATUS_ATTR                                                                             0x1
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_STATUS_ADDR(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_WBM2TQM_LINK_RING_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                0xffff0000
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                        16
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_STATUS_NUM_VALID_WORDS_BMSK                                                    0xffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_STATUS_NUM_VALID_WORDS_SHFT                                                         0

#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_ADDR(x)                                                               ((x) + 0x224)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_PHYS(x)                                                               ((x) + 0x224)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_OFFS                                                                  (0x224)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_RMSK                                                                    0x3fffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_POR                                                                   0x00000080
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_POR_RMSK                                                              0xffffffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_ATTR                                                                               0x3
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_IN(x)            \
                in_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_ADDR(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_ADDR(x), m)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_ADDR(x),v)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_ADDR(x),m,v,HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_IN(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_SPARE_CONTROL_BMSK                                                      0x3fc000
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_SPARE_CONTROL_SHFT                                                            14
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_SRNG_SM_STATE2_BMSK                                                       0x3000
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_SRNG_SM_STATE2_SHFT                                                           12
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_SRNG_SM_STATE1_BMSK                                                        0xf00
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_SRNG_SM_STATE1_SHFT                                                            8
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_SRNG_IS_IDLE_BMSK                                                           0x80
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_SRNG_IS_IDLE_SHFT                                                              7
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_SRNG_ENABLE_BMSK                                                            0x40
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_SRNG_ENABLE_SHFT                                                               6
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                      0x20
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                         5
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                       0x10
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                          4
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_MSI_SWAP_BIT_BMSK                                                            0x8
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_MSI_SWAP_BIT_SHFT                                                              3
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_SECURITY_BIT_BMSK                                                            0x4
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_SECURITY_BIT_SHFT                                                              2
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_LOOPCNT_DISABLE_BMSK                                                         0x2
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_LOOPCNT_DISABLE_SHFT                                                           1
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_RING_ID_DISABLE_BMSK                                                         0x1
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_RING_ID_DISABLE_SHFT                                                           0

#define HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_LSB_ADDR(x)                                                        ((x) + 0x230)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_LSB_PHYS(x)                                                        ((x) + 0x230)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_LSB_OFFS                                                           (0x230)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_LSB_RMSK                                                           0xffffffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_LSB_POR                                                            0x00000000
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_LSB_POR_RMSK                                                       0xffffffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_LSB_ATTR                                                                        0x3
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_LSB_IN(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                      0xffffffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                               0

#define HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_MSB_ADDR(x)                                                        ((x) + 0x234)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_MSB_PHYS(x)                                                        ((x) + 0x234)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_MSB_OFFS                                                           (0x234)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_MSB_RMSK                                                                 0xff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_MSB_POR                                                            0x00000000
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_MSB_POR_RMSK                                                       0xffffffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_MSB_ATTR                                                                        0x3
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_MSB_IN(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                            0xff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                               0

#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                             ((x) + 0x244)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                             ((x) + 0x244)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                (0x244)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                0xffffffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX0_POR                                                 0x00000000
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                            0xffffffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                             0x3
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                             ((x) + 0x248)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                             ((x) + 0x248)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                (0x248)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                    0xffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX1_POR                                                 0x00000000
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                            0xffffffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                             0x3
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                      0xffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                           0

#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_STATUS_ADDR(x)                                                ((x) + 0x24c)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_STATUS_PHYS(x)                                                ((x) + 0x24c)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_STATUS_OFFS                                                   (0x24c)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_STATUS_RMSK                                                   0xffffffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_STATUS_POR                                                    0x00000000
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_STATUS_POR_RMSK                                               0xffffffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_STATUS_ATTR                                                                0x1
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                     0xffff0000
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                             16
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                0x8000
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                    15
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                          0x7fff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                               0

#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                             ((x) + 0x250)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                             ((x) + 0x250)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                (0x250)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                     0x3ff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_EMPTY_COUNTER_POR                                                 0x00000000
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                            0xffffffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                             0x3
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                  0x3ff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                      0

#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                            ((x) + 0x254)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                            ((x) + 0x254)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_TIMER_OFFS                                               (0x254)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                      0x7
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_TIMER_POR                                                0x00000003
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                           0xffffffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                            0x3
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                 0x7
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                   0

#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                           ((x) + 0x258)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                           ((x) + 0x258)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_STATUS_OFFS                                              (0x258)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_STATUS_RMSK                                                0xffffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_STATUS_POR                                               0x00000000
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                          0xffffffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                           0x1
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                 0xff0000
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                       16
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                                0xffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                     0

#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_ADDR(x)                                                      ((x) + 0x25c)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_PHYS(x)                                                      ((x) + 0x25c)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_OFFS                                                         (0x25c)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_RMSK                                                         0xffffffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_POR                                                          0x00000000
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_ATTR                                                                      0x3
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_ADDR_BMSK                                                    0xffffffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_LSB_ADDR_SHFT                                                             0

#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_ADDR(x)                                                      ((x) + 0x260)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_PHYS(x)                                                      ((x) + 0x260)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_OFFS                                                         (0x260)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_RMSK                                                              0x1ff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_POR                                                          0x00000000
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_ATTR                                                                      0x3
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                  0x100
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                      8
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_ADDR_BMSK                                                          0xff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_BASE_MSB_ADDR_SHFT                                                             0

#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_DATA_ADDR(x)                                                          ((x) + 0x264)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_DATA_PHYS(x)                                                          ((x) + 0x264)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_DATA_OFFS                                                             (0x264)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_DATA_RMSK                                                             0xffffffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_DATA_POR                                                              0x00000000
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_DATA_POR_RMSK                                                         0xffffffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_DATA_ATTR                                                                          0x3
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_DATA_ADDR(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_DATA_ADDR(x),m,v,HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_DATA_IN(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_DATA_VALUE_BMSK                                                       0xffffffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MSI1_DATA_VALUE_SHFT                                                                0

#define HWIO_TQM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_ADDR(x)                                                    ((x) + 0x284)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_PHYS(x)                                                    ((x) + 0x284)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_OFFS                                                       (0x284)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_RMSK                                                           0xffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_POR                                                        0x00000000
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_POR_RMSK                                                   0xffffffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_ATTR                                                                    0x3
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_TQM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                        0xffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                             0

#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_1_ADDR(x)                                                             ((x) + 0x288)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_1_PHYS(x)                                                             ((x) + 0x288)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_1_OFFS                                                                (0x288)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_1_RMSK                                                                0xffff003f
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_1_POR                                                                 0x00000000
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_1_POR_RMSK                                                            0xffffffff
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_1_ATTR                                                                             0x3
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_1_IN(x)            \
                in_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_1_ADDR(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_1_ADDR(x), m)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_1_ADDR(x),v)
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_1_ADDR(x),m,v,HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_1_IN(x))
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                       0xffff0000
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                               16
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                              0x3f
#define HWIO_TQM_R0_WBM2TQM_LINK_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                 0

#define HWIO_TQM_R0_TQM_RELEASE_RING_BASE_LSB_ADDR(x)                                                            ((x) + 0x28c)
#define HWIO_TQM_R0_TQM_RELEASE_RING_BASE_LSB_PHYS(x)                                                            ((x) + 0x28c)
#define HWIO_TQM_R0_TQM_RELEASE_RING_BASE_LSB_OFFS                                                               (0x28c)
#define HWIO_TQM_R0_TQM_RELEASE_RING_BASE_LSB_RMSK                                                               0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_BASE_LSB_POR                                                                0x00000000
#define HWIO_TQM_R0_TQM_RELEASE_RING_BASE_LSB_POR_RMSK                                                           0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_BASE_LSB_ATTR                                                                            0x3
#define HWIO_TQM_R0_TQM_RELEASE_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_RELEASE_RING_BASE_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_RELEASE_RING_BASE_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM_RELEASE_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_RELEASE_RING_BASE_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM_RELEASE_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_RELEASE_RING_BASE_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM_RELEASE_RING_BASE_LSB_IN(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                            0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                     0

#define HWIO_TQM_R0_TQM_RELEASE_RING_BASE_MSB_ADDR(x)                                                            ((x) + 0x290)
#define HWIO_TQM_R0_TQM_RELEASE_RING_BASE_MSB_PHYS(x)                                                            ((x) + 0x290)
#define HWIO_TQM_R0_TQM_RELEASE_RING_BASE_MSB_OFFS                                                               (0x290)
#define HWIO_TQM_R0_TQM_RELEASE_RING_BASE_MSB_RMSK                                                                 0xffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_BASE_MSB_POR                                                                0x00000000
#define HWIO_TQM_R0_TQM_RELEASE_RING_BASE_MSB_POR_RMSK                                                           0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_BASE_MSB_ATTR                                                                            0x3
#define HWIO_TQM_R0_TQM_RELEASE_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_RELEASE_RING_BASE_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_RELEASE_RING_BASE_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM_RELEASE_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_RELEASE_RING_BASE_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM_RELEASE_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_RELEASE_RING_BASE_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM_RELEASE_RING_BASE_MSB_IN(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_BASE_MSB_RING_SIZE_BMSK                                                       0xffff00
#define HWIO_TQM_R0_TQM_RELEASE_RING_BASE_MSB_RING_SIZE_SHFT                                                              8
#define HWIO_TQM_R0_TQM_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                  0xff
#define HWIO_TQM_R0_TQM_RELEASE_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                     0

#define HWIO_TQM_R0_TQM_RELEASE_RING_ID_ADDR(x)                                                                  ((x) + 0x294)
#define HWIO_TQM_R0_TQM_RELEASE_RING_ID_PHYS(x)                                                                  ((x) + 0x294)
#define HWIO_TQM_R0_TQM_RELEASE_RING_ID_OFFS                                                                     (0x294)
#define HWIO_TQM_R0_TQM_RELEASE_RING_ID_RMSK                                                                         0xffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_ID_POR                                                                      0x00000000
#define HWIO_TQM_R0_TQM_RELEASE_RING_ID_POR_RMSK                                                                 0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_ID_ATTR                                                                                  0x3
#define HWIO_TQM_R0_TQM_RELEASE_RING_ID_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_RELEASE_RING_ID_ADDR(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_RELEASE_RING_ID_ADDR(x), m)
#define HWIO_TQM_R0_TQM_RELEASE_RING_ID_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_RELEASE_RING_ID_ADDR(x),v)
#define HWIO_TQM_R0_TQM_RELEASE_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_RELEASE_RING_ID_ADDR(x),m,v,HWIO_TQM_R0_TQM_RELEASE_RING_ID_IN(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_ID_RING_ID_BMSK                                                                 0xff00
#define HWIO_TQM_R0_TQM_RELEASE_RING_ID_RING_ID_SHFT                                                                      8
#define HWIO_TQM_R0_TQM_RELEASE_RING_ID_ENTRY_SIZE_BMSK                                                                0xff
#define HWIO_TQM_R0_TQM_RELEASE_RING_ID_ENTRY_SIZE_SHFT                                                                   0

#define HWIO_TQM_R0_TQM_RELEASE_RING_STATUS_ADDR(x)                                                              ((x) + 0x298)
#define HWIO_TQM_R0_TQM_RELEASE_RING_STATUS_PHYS(x)                                                              ((x) + 0x298)
#define HWIO_TQM_R0_TQM_RELEASE_RING_STATUS_OFFS                                                                 (0x298)
#define HWIO_TQM_R0_TQM_RELEASE_RING_STATUS_RMSK                                                                 0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_STATUS_POR                                                                  0x00000000
#define HWIO_TQM_R0_TQM_RELEASE_RING_STATUS_POR_RMSK                                                             0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_STATUS_ATTR                                                                              0x1
#define HWIO_TQM_R0_TQM_RELEASE_RING_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_RELEASE_RING_STATUS_ADDR(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_RELEASE_RING_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_TQM_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                 0xffff0000
#define HWIO_TQM_R0_TQM_RELEASE_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                         16
#define HWIO_TQM_R0_TQM_RELEASE_RING_STATUS_NUM_VALID_WORDS_BMSK                                                     0xffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_STATUS_NUM_VALID_WORDS_SHFT                                                          0

#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_ADDR(x)                                                                ((x) + 0x29c)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_PHYS(x)                                                                ((x) + 0x29c)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_OFFS                                                                   (0x29c)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_RMSK                                                                    0x7ffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_POR                                                                    0x00000080
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_POR_RMSK                                                               0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_ATTR                                                                                0x3
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_RELEASE_RING_MISC_ADDR(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_RELEASE_RING_MISC_ADDR(x), m)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_RELEASE_RING_MISC_ADDR(x),v)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_RELEASE_RING_MISC_ADDR(x),m,v,HWIO_TQM_R0_TQM_RELEASE_RING_MISC_IN(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                            0x4000000
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                   26
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_LOOP_CNT_BMSK                                                           0x3c00000
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_LOOP_CNT_SHFT                                                                  22
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_SPARE_CONTROL_BMSK                                                       0x3fc000
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_SPARE_CONTROL_SHFT                                                             14
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_SRNG_SM_STATE2_BMSK                                                        0x3000
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_SRNG_SM_STATE2_SHFT                                                            12
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_SRNG_SM_STATE1_BMSK                                                         0xf00
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_SRNG_SM_STATE1_SHFT                                                             8
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_SRNG_IS_IDLE_BMSK                                                            0x80
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_SRNG_IS_IDLE_SHFT                                                               7
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_SRNG_ENABLE_BMSK                                                             0x40
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_SRNG_ENABLE_SHFT                                                                6
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                       0x20
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                          5
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                        0x10
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                           4
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_MSI_SWAP_BIT_BMSK                                                             0x8
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_MSI_SWAP_BIT_SHFT                                                               3
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_SECURITY_BIT_BMSK                                                             0x4
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_SECURITY_BIT_SHFT                                                               2
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_LOOPCNT_DISABLE_BMSK                                                          0x2
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_LOOPCNT_DISABLE_SHFT                                                            1
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_RING_ID_DISABLE_BMSK                                                          0x1
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_RING_ID_DISABLE_SHFT                                                            0

#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_LSB_ADDR(x)                                                         ((x) + 0x2a0)
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_LSB_PHYS(x)                                                         ((x) + 0x2a0)
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_LSB_OFFS                                                            (0x2a0)
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_LSB_RMSK                                                            0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_LSB_POR                                                             0x00000000
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_LSB_POR_RMSK                                                        0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_LSB_ATTR                                                                         0x3
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_LSB_IN(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                       0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                                0

#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_MSB_ADDR(x)                                                         ((x) + 0x2a4)
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_MSB_PHYS(x)                                                         ((x) + 0x2a4)
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_MSB_OFFS                                                            (0x2a4)
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_MSB_RMSK                                                                  0xff
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_MSB_POR                                                             0x00000000
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_MSB_POR_RMSK                                                        0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_MSB_ATTR                                                                         0x3
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_MSB_IN(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                             0xff
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                                0

#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x)                                                  ((x) + 0x2b0)
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_SETUP_PHYS(x)                                                  ((x) + 0x2b0)
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_SETUP_OFFS                                                     (0x2b0)
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_SETUP_RMSK                                                     0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_SETUP_POR                                                      0x00000000
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_SETUP_POR_RMSK                                                 0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_SETUP_ATTR                                                                  0x3
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                           0xffff0000
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                   16
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                       0x8000
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                           15
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                                 0x7fff
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                      0

#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x)                                                 ((x) + 0x2b4)
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_STATUS_PHYS(x)                                                 ((x) + 0x2b4)
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_STATUS_OFFS                                                    (0x2b4)
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_STATUS_RMSK                                                    0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_STATUS_POR                                                     0x00000000
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_STATUS_POR_RMSK                                                0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_STATUS_ATTR                                                                 0x1
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                      0xffff0000
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                              16
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                              0x8000
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                  15
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                           0x7fff
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                0

#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                               ((x) + 0x2b8)
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                               ((x) + 0x2b8)
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_FULL_COUNTER_OFFS                                                  (0x2b8)
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_FULL_COUNTER_RMSK                                                       0x3ff
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_FULL_COUNTER_POR                                                   0x00000000
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                              0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_FULL_COUNTER_ATTR                                                               0x3
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                     0x3ff
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                         0

#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_ADDR(x)                                                       ((x) + 0x2d4)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_PHYS(x)                                                       ((x) + 0x2d4)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_OFFS                                                          (0x2d4)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_POR                                                           0x00000000
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_ATTR                                                                       0x3
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_ADDR(x)                                                       ((x) + 0x2d8)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_PHYS(x)                                                       ((x) + 0x2d8)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_OFFS                                                          (0x2d8)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_POR                                                           0x00000000
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_ATTR                                                                       0x3
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                   0x100
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                       8
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_DATA_ADDR(x)                                                           ((x) + 0x2dc)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_DATA_PHYS(x)                                                           ((x) + 0x2dc)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_DATA_OFFS                                                              (0x2dc)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_DATA_RMSK                                                              0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_DATA_POR                                                               0x00000000
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_DATA_ATTR                                                                           0x3
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_DATA_ADDR(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_DATA_ADDR(x),m,v,HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_DATA_IN(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI1_DATA_VALUE_SHFT                                                                 0

#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x)                                                 ((x) + 0x2e0)
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT2_SETUP_PHYS(x)                                                 ((x) + 0x2e0)
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT2_SETUP_OFFS                                                    (0x2e0)
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT2_SETUP_RMSK                                                    0xffc0ffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT2_SETUP_POR                                                     0x00000000
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT2_SETUP_POR_RMSK                                                0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT2_SETUP_ATTR                                                                 0x3
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                         0xff000000
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                                 24
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                          0x800000
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                                23
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                        0x400000
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                              22
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                         0xffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                              0

#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_LSB_ADDR(x)                                                       ((x) + 0x2e4)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_LSB_PHYS(x)                                                       ((x) + 0x2e4)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_LSB_OFFS                                                          (0x2e4)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_LSB_POR                                                           0x00000000
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_LSB_ATTR                                                                       0x3
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_MSB_ADDR(x)                                                       ((x) + 0x2e8)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_MSB_PHYS(x)                                                       ((x) + 0x2e8)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_MSB_OFFS                                                          (0x2e8)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_MSB_POR                                                           0x00000000
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_MSB_ATTR                                                                       0x3
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                   0x100
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                       8
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_DATA_ADDR(x)                                                           ((x) + 0x2ec)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_DATA_PHYS(x)                                                           ((x) + 0x2ec)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_DATA_OFFS                                                              (0x2ec)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_DATA_RMSK                                                              0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_DATA_POR                                                               0x00000000
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_DATA_ATTR                                                                           0x3
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_DATA_ADDR(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_DATA_ADDR(x),m,v,HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_DATA_IN(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_MSI2_DATA_VALUE_SHFT                                                                 0

#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x)                                                     ((x) + 0x2fc)
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_PHYS(x)                                                     ((x) + 0x2fc)
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_OFFS                                                        (0x2fc)
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_RMSK                                                            0xffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_POR                                                         0x00000000
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_POR_RMSK                                                    0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_ATTR                                                                     0x3
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_TQM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                         0xffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                              0

#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_1_ADDR(x)                                                              ((x) + 0x300)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_1_PHYS(x)                                                              ((x) + 0x300)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_1_OFFS                                                                 (0x300)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_1_RMSK                                                                 0xffff003f
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_1_POR                                                                  0x00000000
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_1_POR_RMSK                                                             0xffffffff
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_1_ATTR                                                                              0x3
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_1_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_RELEASE_RING_MISC_1_ADDR(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_RELEASE_RING_MISC_1_ADDR(x), m)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_RELEASE_RING_MISC_1_ADDR(x),v)
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_RELEASE_RING_MISC_1_ADDR(x),m,v,HWIO_TQM_R0_TQM_RELEASE_RING_MISC_1_IN(x))
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                        0xffff0000
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                16
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                               0x3f
#define HWIO_TQM_R0_TQM_RELEASE_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                  0

#define HWIO_TQM_R0_TQM_STATUS_RING_BASE_LSB_ADDR(x)                                                             ((x) + 0x304)
#define HWIO_TQM_R0_TQM_STATUS_RING_BASE_LSB_PHYS(x)                                                             ((x) + 0x304)
#define HWIO_TQM_R0_TQM_STATUS_RING_BASE_LSB_OFFS                                                                (0x304)
#define HWIO_TQM_R0_TQM_STATUS_RING_BASE_LSB_RMSK                                                                0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_BASE_LSB_POR                                                                 0x00000000
#define HWIO_TQM_R0_TQM_STATUS_RING_BASE_LSB_POR_RMSK                                                            0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_BASE_LSB_ATTR                                                                             0x3
#define HWIO_TQM_R0_TQM_STATUS_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS_RING_BASE_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS_RING_BASE_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS_RING_BASE_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS_RING_BASE_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS_RING_BASE_LSB_IN(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                             0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                      0

#define HWIO_TQM_R0_TQM_STATUS_RING_BASE_MSB_ADDR(x)                                                             ((x) + 0x308)
#define HWIO_TQM_R0_TQM_STATUS_RING_BASE_MSB_PHYS(x)                                                             ((x) + 0x308)
#define HWIO_TQM_R0_TQM_STATUS_RING_BASE_MSB_OFFS                                                                (0x308)
#define HWIO_TQM_R0_TQM_STATUS_RING_BASE_MSB_RMSK                                                                  0xffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_BASE_MSB_POR                                                                 0x00000000
#define HWIO_TQM_R0_TQM_STATUS_RING_BASE_MSB_POR_RMSK                                                            0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_BASE_MSB_ATTR                                                                             0x3
#define HWIO_TQM_R0_TQM_STATUS_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS_RING_BASE_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS_RING_BASE_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS_RING_BASE_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS_RING_BASE_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS_RING_BASE_MSB_IN(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_BASE_MSB_RING_SIZE_BMSK                                                        0xffff00
#define HWIO_TQM_R0_TQM_STATUS_RING_BASE_MSB_RING_SIZE_SHFT                                                               8
#define HWIO_TQM_R0_TQM_STATUS_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                   0xff
#define HWIO_TQM_R0_TQM_STATUS_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                      0

#define HWIO_TQM_R0_TQM_STATUS_RING_ID_ADDR(x)                                                                   ((x) + 0x30c)
#define HWIO_TQM_R0_TQM_STATUS_RING_ID_PHYS(x)                                                                   ((x) + 0x30c)
#define HWIO_TQM_R0_TQM_STATUS_RING_ID_OFFS                                                                      (0x30c)
#define HWIO_TQM_R0_TQM_STATUS_RING_ID_RMSK                                                                          0xffff
#define HWIO_TQM_R0_TQM_STATUS_RING_ID_POR                                                                       0x00000000
#define HWIO_TQM_R0_TQM_STATUS_RING_ID_POR_RMSK                                                                  0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_ID_ATTR                                                                                   0x3
#define HWIO_TQM_R0_TQM_STATUS_RING_ID_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS_RING_ID_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS_RING_ID_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS_RING_ID_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS_RING_ID_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS_RING_ID_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS_RING_ID_IN(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_ID_RING_ID_BMSK                                                                  0xff00
#define HWIO_TQM_R0_TQM_STATUS_RING_ID_RING_ID_SHFT                                                                       8
#define HWIO_TQM_R0_TQM_STATUS_RING_ID_ENTRY_SIZE_BMSK                                                                 0xff
#define HWIO_TQM_R0_TQM_STATUS_RING_ID_ENTRY_SIZE_SHFT                                                                    0

#define HWIO_TQM_R0_TQM_STATUS_RING_STATUS_ADDR(x)                                                               ((x) + 0x310)
#define HWIO_TQM_R0_TQM_STATUS_RING_STATUS_PHYS(x)                                                               ((x) + 0x310)
#define HWIO_TQM_R0_TQM_STATUS_RING_STATUS_OFFS                                                                  (0x310)
#define HWIO_TQM_R0_TQM_STATUS_RING_STATUS_RMSK                                                                  0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_STATUS_POR                                                                   0x00000000
#define HWIO_TQM_R0_TQM_STATUS_RING_STATUS_POR_RMSK                                                              0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_STATUS_ATTR                                                                               0x1
#define HWIO_TQM_R0_TQM_STATUS_RING_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS_RING_STATUS_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS_RING_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                  0xffff0000
#define HWIO_TQM_R0_TQM_STATUS_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                          16
#define HWIO_TQM_R0_TQM_STATUS_RING_STATUS_NUM_VALID_WORDS_BMSK                                                      0xffff
#define HWIO_TQM_R0_TQM_STATUS_RING_STATUS_NUM_VALID_WORDS_SHFT                                                           0

#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_ADDR(x)                                                                 ((x) + 0x314)
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_PHYS(x)                                                                 ((x) + 0x314)
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_OFFS                                                                    (0x314)
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_RMSK                                                                     0x7ffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_POR                                                                     0x00000080
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_POR_RMSK                                                                0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_ATTR                                                                                 0x3
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS_RING_MISC_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS_RING_MISC_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS_RING_MISC_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS_RING_MISC_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS_RING_MISC_IN(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                             0x4000000
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                    26
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_LOOP_CNT_BMSK                                                            0x3c00000
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_LOOP_CNT_SHFT                                                                   22
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_SPARE_CONTROL_BMSK                                                        0x3fc000
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_SPARE_CONTROL_SHFT                                                              14
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_SRNG_SM_STATE2_BMSK                                                         0x3000
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_SRNG_SM_STATE2_SHFT                                                             12
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_SRNG_SM_STATE1_BMSK                                                          0xf00
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_SRNG_SM_STATE1_SHFT                                                              8
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_SRNG_IS_IDLE_BMSK                                                             0x80
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_SRNG_IS_IDLE_SHFT                                                                7
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_SRNG_ENABLE_BMSK                                                              0x40
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_SRNG_ENABLE_SHFT                                                                 6
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                        0x20
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                           5
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                         0x10
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                            4
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_MSI_SWAP_BIT_BMSK                                                              0x8
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_MSI_SWAP_BIT_SHFT                                                                3
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_SECURITY_BIT_BMSK                                                              0x4
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_SECURITY_BIT_SHFT                                                                2
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_LOOPCNT_DISABLE_BMSK                                                           0x2
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_LOOPCNT_DISABLE_SHFT                                                             1
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_RING_ID_DISABLE_BMSK                                                           0x1
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_RING_ID_DISABLE_SHFT                                                             0

#define HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_LSB_ADDR(x)                                                          ((x) + 0x318)
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_LSB_PHYS(x)                                                          ((x) + 0x318)
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_LSB_OFFS                                                             (0x318)
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_LSB_RMSK                                                             0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_LSB_POR                                                              0x00000000
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_LSB_POR_RMSK                                                         0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_LSB_ATTR                                                                          0x3
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_LSB_IN(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                        0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                                 0

#define HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_MSB_ADDR(x)                                                          ((x) + 0x31c)
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_MSB_PHYS(x)                                                          ((x) + 0x31c)
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_MSB_OFFS                                                             (0x31c)
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_MSB_RMSK                                                                   0xff
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_MSB_POR                                                              0x00000000
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_MSB_POR_RMSK                                                         0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_MSB_ATTR                                                                          0x3
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_MSB_IN(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                              0xff
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                                 0

#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_SETUP_ADDR(x)                                                   ((x) + 0x328)
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_SETUP_PHYS(x)                                                   ((x) + 0x328)
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_SETUP_OFFS                                                      (0x328)
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_SETUP_RMSK                                                      0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_SETUP_POR                                                       0x00000000
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_SETUP_POR_RMSK                                                  0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_SETUP_ATTR                                                                   0x3
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                            0xffff0000
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                    16
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                        0x8000
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                            15
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                                  0x7fff
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                       0

#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_STATUS_ADDR(x)                                                  ((x) + 0x32c)
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_STATUS_PHYS(x)                                                  ((x) + 0x32c)
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_STATUS_OFFS                                                     (0x32c)
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_STATUS_RMSK                                                     0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_STATUS_POR                                                      0x00000000
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_STATUS_POR_RMSK                                                 0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_STATUS_ATTR                                                                  0x1
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                       0xffff0000
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                               16
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                               0x8000
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                   15
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                            0x7fff
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                 0

#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                                ((x) + 0x330)
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                                ((x) + 0x330)
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_FULL_COUNTER_OFFS                                                   (0x330)
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_FULL_COUNTER_RMSK                                                        0x3ff
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_FULL_COUNTER_POR                                                    0x00000000
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                               0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_FULL_COUNTER_ATTR                                                                0x3
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                      0x3ff
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                          0

#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_LSB_ADDR(x)                                                        ((x) + 0x34c)
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_LSB_PHYS(x)                                                        ((x) + 0x34c)
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_LSB_OFFS                                                           (0x34c)
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_LSB_RMSK                                                           0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_LSB_POR                                                            0x00000000
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_LSB_POR_RMSK                                                       0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_LSB_ATTR                                                                        0x3
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_LSB_ADDR_BMSK                                                      0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_LSB_ADDR_SHFT                                                               0

#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_MSB_ADDR(x)                                                        ((x) + 0x350)
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_MSB_PHYS(x)                                                        ((x) + 0x350)
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_MSB_OFFS                                                           (0x350)
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_MSB_RMSK                                                                0x1ff
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_MSB_POR                                                            0x00000000
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_MSB_POR_RMSK                                                       0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_MSB_ATTR                                                                        0x3
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                    0x100
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                        8
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_MSB_ADDR_BMSK                                                            0xff
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_BASE_MSB_ADDR_SHFT                                                               0

#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_DATA_ADDR(x)                                                            ((x) + 0x354)
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_DATA_PHYS(x)                                                            ((x) + 0x354)
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_DATA_OFFS                                                               (0x354)
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_DATA_RMSK                                                               0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_DATA_POR                                                                0x00000000
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_DATA_POR_RMSK                                                           0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_DATA_ATTR                                                                            0x3
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS_RING_MSI1_DATA_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS_RING_MSI1_DATA_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS_RING_MSI1_DATA_IN(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_DATA_VALUE_BMSK                                                         0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI1_DATA_VALUE_SHFT                                                                  0

#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT2_SETUP_ADDR(x)                                                  ((x) + 0x358)
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT2_SETUP_PHYS(x)                                                  ((x) + 0x358)
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT2_SETUP_OFFS                                                     (0x358)
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT2_SETUP_RMSK                                                     0xffc0ffff
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT2_SETUP_POR                                                      0x00000000
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT2_SETUP_POR_RMSK                                                 0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT2_SETUP_ATTR                                                                  0x3
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                          0xff000000
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                                  24
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                           0x800000
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                                 23
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                         0x400000
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                               22
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                          0xffff
#define HWIO_TQM_R0_TQM_STATUS_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                               0

#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_LSB_ADDR(x)                                                        ((x) + 0x35c)
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_LSB_PHYS(x)                                                        ((x) + 0x35c)
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_LSB_OFFS                                                           (0x35c)
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_LSB_RMSK                                                           0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_LSB_POR                                                            0x00000000
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_LSB_POR_RMSK                                                       0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_LSB_ATTR                                                                        0x3
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_LSB_ADDR_BMSK                                                      0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_LSB_ADDR_SHFT                                                               0

#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_MSB_ADDR(x)                                                        ((x) + 0x360)
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_MSB_PHYS(x)                                                        ((x) + 0x360)
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_MSB_OFFS                                                           (0x360)
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_MSB_RMSK                                                                0x1ff
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_MSB_POR                                                            0x00000000
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_MSB_POR_RMSK                                                       0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_MSB_ATTR                                                                        0x3
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                    0x100
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                        8
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_MSB_ADDR_BMSK                                                            0xff
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_BASE_MSB_ADDR_SHFT                                                               0

#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_DATA_ADDR(x)                                                            ((x) + 0x364)
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_DATA_PHYS(x)                                                            ((x) + 0x364)
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_DATA_OFFS                                                               (0x364)
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_DATA_RMSK                                                               0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_DATA_POR                                                                0x00000000
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_DATA_POR_RMSK                                                           0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_DATA_ATTR                                                                            0x3
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS_RING_MSI2_DATA_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS_RING_MSI2_DATA_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS_RING_MSI2_DATA_IN(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_DATA_VALUE_BMSK                                                         0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_MSI2_DATA_VALUE_SHFT                                                                  0

#define HWIO_TQM_R0_TQM_STATUS_RING_HP_TP_SW_OFFSET_ADDR(x)                                                      ((x) + 0x374)
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_TP_SW_OFFSET_PHYS(x)                                                      ((x) + 0x374)
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_TP_SW_OFFSET_OFFS                                                         (0x374)
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_TP_SW_OFFSET_RMSK                                                             0xffff
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_TP_SW_OFFSET_POR                                                          0x00000000
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_TP_SW_OFFSET_POR_RMSK                                                     0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_TP_SW_OFFSET_ATTR                                                                      0x3
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                          0xffff
#define HWIO_TQM_R0_TQM_STATUS_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                               0

#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_1_ADDR(x)                                                               ((x) + 0x378)
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_1_PHYS(x)                                                               ((x) + 0x378)
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_1_OFFS                                                                  (0x378)
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_1_RMSK                                                                  0xffff003f
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_1_POR                                                                   0x00000000
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_1_POR_RMSK                                                              0xffffffff
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_1_ATTR                                                                               0x3
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_1_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS_RING_MISC_1_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS_RING_MISC_1_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS_RING_MISC_1_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS_RING_MISC_1_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS_RING_MISC_1_IN(x))
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                         0xffff0000
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                 16
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                                0x3f
#define HWIO_TQM_R0_TQM_STATUS_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                   0

#define HWIO_TQM_R0_TQM_STATUS1_RING_BASE_LSB_ADDR(x)                                                            ((x) + 0x37c)
#define HWIO_TQM_R0_TQM_STATUS1_RING_BASE_LSB_PHYS(x)                                                            ((x) + 0x37c)
#define HWIO_TQM_R0_TQM_STATUS1_RING_BASE_LSB_OFFS                                                               (0x37c)
#define HWIO_TQM_R0_TQM_STATUS1_RING_BASE_LSB_RMSK                                                               0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_BASE_LSB_POR                                                                0x00000000
#define HWIO_TQM_R0_TQM_STATUS1_RING_BASE_LSB_POR_RMSK                                                           0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_BASE_LSB_ATTR                                                                            0x3
#define HWIO_TQM_R0_TQM_STATUS1_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS1_RING_BASE_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS1_RING_BASE_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS1_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS1_RING_BASE_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS1_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS1_RING_BASE_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS1_RING_BASE_LSB_IN(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                            0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                     0

#define HWIO_TQM_R0_TQM_STATUS1_RING_BASE_MSB_ADDR(x)                                                            ((x) + 0x380)
#define HWIO_TQM_R0_TQM_STATUS1_RING_BASE_MSB_PHYS(x)                                                            ((x) + 0x380)
#define HWIO_TQM_R0_TQM_STATUS1_RING_BASE_MSB_OFFS                                                               (0x380)
#define HWIO_TQM_R0_TQM_STATUS1_RING_BASE_MSB_RMSK                                                                 0xffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_BASE_MSB_POR                                                                0x00000000
#define HWIO_TQM_R0_TQM_STATUS1_RING_BASE_MSB_POR_RMSK                                                           0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_BASE_MSB_ATTR                                                                            0x3
#define HWIO_TQM_R0_TQM_STATUS1_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS1_RING_BASE_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS1_RING_BASE_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS1_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS1_RING_BASE_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS1_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS1_RING_BASE_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS1_RING_BASE_MSB_IN(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_BASE_MSB_RING_SIZE_BMSK                                                       0xffff00
#define HWIO_TQM_R0_TQM_STATUS1_RING_BASE_MSB_RING_SIZE_SHFT                                                              8
#define HWIO_TQM_R0_TQM_STATUS1_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                  0xff
#define HWIO_TQM_R0_TQM_STATUS1_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                     0

#define HWIO_TQM_R0_TQM_STATUS1_RING_ID_ADDR(x)                                                                  ((x) + 0x384)
#define HWIO_TQM_R0_TQM_STATUS1_RING_ID_PHYS(x)                                                                  ((x) + 0x384)
#define HWIO_TQM_R0_TQM_STATUS1_RING_ID_OFFS                                                                     (0x384)
#define HWIO_TQM_R0_TQM_STATUS1_RING_ID_RMSK                                                                         0xffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_ID_POR                                                                      0x00000000
#define HWIO_TQM_R0_TQM_STATUS1_RING_ID_POR_RMSK                                                                 0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_ID_ATTR                                                                                  0x3
#define HWIO_TQM_R0_TQM_STATUS1_RING_ID_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS1_RING_ID_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS1_RING_ID_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS1_RING_ID_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS1_RING_ID_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS1_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS1_RING_ID_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS1_RING_ID_IN(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_ID_RING_ID_BMSK                                                                 0xff00
#define HWIO_TQM_R0_TQM_STATUS1_RING_ID_RING_ID_SHFT                                                                      8
#define HWIO_TQM_R0_TQM_STATUS1_RING_ID_ENTRY_SIZE_BMSK                                                                0xff
#define HWIO_TQM_R0_TQM_STATUS1_RING_ID_ENTRY_SIZE_SHFT                                                                   0

#define HWIO_TQM_R0_TQM_STATUS1_RING_STATUS_ADDR(x)                                                              ((x) + 0x388)
#define HWIO_TQM_R0_TQM_STATUS1_RING_STATUS_PHYS(x)                                                              ((x) + 0x388)
#define HWIO_TQM_R0_TQM_STATUS1_RING_STATUS_OFFS                                                                 (0x388)
#define HWIO_TQM_R0_TQM_STATUS1_RING_STATUS_RMSK                                                                 0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_STATUS_POR                                                                  0x00000000
#define HWIO_TQM_R0_TQM_STATUS1_RING_STATUS_POR_RMSK                                                             0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_STATUS_ATTR                                                                              0x1
#define HWIO_TQM_R0_TQM_STATUS1_RING_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS1_RING_STATUS_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS1_RING_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS1_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                 0xffff0000
#define HWIO_TQM_R0_TQM_STATUS1_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                         16
#define HWIO_TQM_R0_TQM_STATUS1_RING_STATUS_NUM_VALID_WORDS_BMSK                                                     0xffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_STATUS_NUM_VALID_WORDS_SHFT                                                          0

#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_ADDR(x)                                                                ((x) + 0x38c)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_PHYS(x)                                                                ((x) + 0x38c)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_OFFS                                                                   (0x38c)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_RMSK                                                                    0x7ffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_POR                                                                    0x00000080
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_POR_RMSK                                                               0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_ATTR                                                                                0x3
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS1_RING_MISC_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS1_RING_MISC_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS1_RING_MISC_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS1_RING_MISC_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS1_RING_MISC_IN(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                            0x4000000
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                   26
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_LOOP_CNT_BMSK                                                           0x3c00000
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_LOOP_CNT_SHFT                                                                  22
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_SPARE_CONTROL_BMSK                                                       0x3fc000
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_SPARE_CONTROL_SHFT                                                             14
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_SRNG_SM_STATE2_BMSK                                                        0x3000
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_SRNG_SM_STATE2_SHFT                                                            12
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_SRNG_SM_STATE1_BMSK                                                         0xf00
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_SRNG_SM_STATE1_SHFT                                                             8
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_SRNG_IS_IDLE_BMSK                                                            0x80
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_SRNG_IS_IDLE_SHFT                                                               7
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_SRNG_ENABLE_BMSK                                                             0x40
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_SRNG_ENABLE_SHFT                                                                6
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                       0x20
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                          5
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                        0x10
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                           4
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_MSI_SWAP_BIT_BMSK                                                             0x8
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_MSI_SWAP_BIT_SHFT                                                               3
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_SECURITY_BIT_BMSK                                                             0x4
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_SECURITY_BIT_SHFT                                                               2
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_LOOPCNT_DISABLE_BMSK                                                          0x2
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_LOOPCNT_DISABLE_SHFT                                                            1
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_RING_ID_DISABLE_BMSK                                                          0x1
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_RING_ID_DISABLE_SHFT                                                            0

#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_LSB_ADDR(x)                                                         ((x) + 0x390)
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_LSB_PHYS(x)                                                         ((x) + 0x390)
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_LSB_OFFS                                                            (0x390)
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_LSB_RMSK                                                            0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_LSB_POR                                                             0x00000000
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_LSB_POR_RMSK                                                        0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_LSB_ATTR                                                                         0x3
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_LSB_IN(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                       0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                                0

#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_MSB_ADDR(x)                                                         ((x) + 0x394)
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_MSB_PHYS(x)                                                         ((x) + 0x394)
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_MSB_OFFS                                                            (0x394)
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_MSB_RMSK                                                                  0xff
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_MSB_POR                                                             0x00000000
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_MSB_POR_RMSK                                                        0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_MSB_ATTR                                                                         0x3
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_MSB_IN(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                             0xff
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                                0

#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_SETUP_ADDR(x)                                                  ((x) + 0x3a0)
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_SETUP_PHYS(x)                                                  ((x) + 0x3a0)
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_SETUP_OFFS                                                     (0x3a0)
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_SETUP_RMSK                                                     0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_SETUP_POR                                                      0x00000000
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_SETUP_POR_RMSK                                                 0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_SETUP_ATTR                                                                  0x3
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                           0xffff0000
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                   16
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                       0x8000
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                           15
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                                 0x7fff
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                      0

#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_STATUS_ADDR(x)                                                 ((x) + 0x3a4)
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_STATUS_PHYS(x)                                                 ((x) + 0x3a4)
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_STATUS_OFFS                                                    (0x3a4)
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_STATUS_RMSK                                                    0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_STATUS_POR                                                     0x00000000
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_STATUS_POR_RMSK                                                0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_STATUS_ATTR                                                                 0x1
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                      0xffff0000
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                              16
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                              0x8000
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                  15
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                           0x7fff
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                0

#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                               ((x) + 0x3a8)
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                               ((x) + 0x3a8)
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_FULL_COUNTER_OFFS                                                  (0x3a8)
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_FULL_COUNTER_RMSK                                                       0x3ff
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_FULL_COUNTER_POR                                                   0x00000000
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                              0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_FULL_COUNTER_ATTR                                                               0x3
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                     0x3ff
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                         0

#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_LSB_ADDR(x)                                                       ((x) + 0x3c4)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_LSB_PHYS(x)                                                       ((x) + 0x3c4)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_LSB_OFFS                                                          (0x3c4)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_LSB_POR                                                           0x00000000
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_LSB_ATTR                                                                       0x3
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_MSB_ADDR(x)                                                       ((x) + 0x3c8)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_MSB_PHYS(x)                                                       ((x) + 0x3c8)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_MSB_OFFS                                                          (0x3c8)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_MSB_POR                                                           0x00000000
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_MSB_ATTR                                                                       0x3
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                   0x100
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                       8
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_DATA_ADDR(x)                                                           ((x) + 0x3cc)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_DATA_PHYS(x)                                                           ((x) + 0x3cc)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_DATA_OFFS                                                              (0x3cc)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_DATA_RMSK                                                              0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_DATA_POR                                                               0x00000000
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_DATA_ATTR                                                                           0x3
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_DATA_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_DATA_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_DATA_IN(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI1_DATA_VALUE_SHFT                                                                 0

#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT2_SETUP_ADDR(x)                                                 ((x) + 0x3d0)
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT2_SETUP_PHYS(x)                                                 ((x) + 0x3d0)
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT2_SETUP_OFFS                                                    (0x3d0)
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT2_SETUP_RMSK                                                    0xffc0ffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT2_SETUP_POR                                                     0x00000000
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT2_SETUP_POR_RMSK                                                0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT2_SETUP_ATTR                                                                 0x3
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                         0xff000000
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                                 24
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                          0x800000
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                                23
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                        0x400000
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                              22
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                         0xffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                              0

#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_LSB_ADDR(x)                                                       ((x) + 0x3d4)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_LSB_PHYS(x)                                                       ((x) + 0x3d4)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_LSB_OFFS                                                          (0x3d4)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_LSB_POR                                                           0x00000000
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_LSB_ATTR                                                                       0x3
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_MSB_ADDR(x)                                                       ((x) + 0x3d8)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_MSB_PHYS(x)                                                       ((x) + 0x3d8)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_MSB_OFFS                                                          (0x3d8)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_MSB_POR                                                           0x00000000
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_MSB_ATTR                                                                       0x3
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                   0x100
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                       8
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_DATA_ADDR(x)                                                           ((x) + 0x3dc)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_DATA_PHYS(x)                                                           ((x) + 0x3dc)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_DATA_OFFS                                                              (0x3dc)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_DATA_RMSK                                                              0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_DATA_POR                                                               0x00000000
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_DATA_ATTR                                                                           0x3
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_DATA_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_DATA_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_DATA_IN(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_MSI2_DATA_VALUE_SHFT                                                                 0

#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_TP_SW_OFFSET_ADDR(x)                                                     ((x) + 0x3ec)
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_TP_SW_OFFSET_PHYS(x)                                                     ((x) + 0x3ec)
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_TP_SW_OFFSET_OFFS                                                        (0x3ec)
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_TP_SW_OFFSET_RMSK                                                            0xffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_TP_SW_OFFSET_POR                                                         0x00000000
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_TP_SW_OFFSET_POR_RMSK                                                    0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_TP_SW_OFFSET_ATTR                                                                     0x3
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS1_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS1_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS1_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS1_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS1_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                         0xffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                              0

#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_1_ADDR(x)                                                              ((x) + 0x3f0)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_1_PHYS(x)                                                              ((x) + 0x3f0)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_1_OFFS                                                                 (0x3f0)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_1_RMSK                                                                 0xffff003f
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_1_POR                                                                  0x00000000
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_1_POR_RMSK                                                             0xffffffff
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_1_ATTR                                                                              0x3
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_1_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_STATUS1_RING_MISC_1_ADDR(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_STATUS1_RING_MISC_1_ADDR(x), m)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM_STATUS1_RING_MISC_1_ADDR(x),v)
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM_STATUS1_RING_MISC_1_ADDR(x),m,v,HWIO_TQM_R0_TQM_STATUS1_RING_MISC_1_IN(x))
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                        0xffff0000
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                16
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                               0x3f
#define HWIO_TQM_R0_TQM_STATUS1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                  0

#define HWIO_TQM_R0_CACHE_CTL_CONFIG_ADDR(x)                                                                     ((x) + 0x3f4)
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_PHYS(x)                                                                     ((x) + 0x3f4)
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_OFFS                                                                        (0x3f4)
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_RMSK                                                                        0xffffffff
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_POR                                                                         0x008609ff
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_POR_RMSK                                                                    0xffffffff
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_ATTR                                                                                     0x3
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_IN(x)            \
                in_dword(HWIO_TQM_R0_CACHE_CTL_CONFIG_ADDR(x))
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_CACHE_CTL_CONFIG_ADDR(x), m)
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_CACHE_CTL_CONFIG_ADDR(x),v)
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_CACHE_CTL_CONFIG_ADDR(x),m,v,HWIO_TQM_R0_CACHE_CTL_CONFIG_IN(x))
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_DESC_TYPE_SWAP_BMSK                                                         0xff000000
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_DESC_TYPE_SWAP_SHFT                                                                 24
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_ENABLE_LEGACY_SWAP_BMSK                                                       0x800000
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_ENABLE_LEGACY_SWAP_SHFT                                                             23
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_WRITE_STRUCT_SWAP_BMSK                                                        0x400000
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_WRITE_STRUCT_SWAP_SHFT                                                              22
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_READ_STRUCT_SWAP_BMSK                                                         0x200000
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_READ_STRUCT_SWAP_SHFT                                                               21
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_WRITE_SECURITY_BMSK                                                           0x100000
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_WRITE_SECURITY_SHFT                                                                 20
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_READ_SECURITY_BMSK                                                             0x80000
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_READ_SECURITY_SHFT                                                                  19
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_BG_FLUSH_POST_WRITE_BMSK                                                       0x40000
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_BG_FLUSH_POST_WRITE_SHFT                                                            18
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_CLIENT_FLUSH_POST_WRITE_BMSK                                                   0x20000
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_CLIENT_FLUSH_POST_WRITE_SHFT                                                        17
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_CACHE_EMPTY_THRESHOLD_BMSK                                                     0x1fe00
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_CACHE_EMPTY_THRESHOLD_SHFT                                                           9
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_CACHE_LINE_USE_NUM_BMSK                                                          0x1ff
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_CACHE_LINE_USE_NUM_SHFT                                                              0

#define HWIO_TQM_R0_CACHE_CTL_CONTROL_ADDR(x)                                                                    ((x) + 0x3f8)
#define HWIO_TQM_R0_CACHE_CTL_CONTROL_PHYS(x)                                                                    ((x) + 0x3f8)
#define HWIO_TQM_R0_CACHE_CTL_CONTROL_OFFS                                                                       (0x3f8)
#define HWIO_TQM_R0_CACHE_CTL_CONTROL_RMSK                                                                              0x3
#define HWIO_TQM_R0_CACHE_CTL_CONTROL_POR                                                                        0x00000000
#define HWIO_TQM_R0_CACHE_CTL_CONTROL_POR_RMSK                                                                   0xffffffff
#define HWIO_TQM_R0_CACHE_CTL_CONTROL_ATTR                                                                                    0x3
#define HWIO_TQM_R0_CACHE_CTL_CONTROL_IN(x)            \
                in_dword(HWIO_TQM_R0_CACHE_CTL_CONTROL_ADDR(x))
#define HWIO_TQM_R0_CACHE_CTL_CONTROL_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_CACHE_CTL_CONTROL_ADDR(x), m)
#define HWIO_TQM_R0_CACHE_CTL_CONTROL_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_CACHE_CTL_CONTROL_ADDR(x),v)
#define HWIO_TQM_R0_CACHE_CTL_CONTROL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_CACHE_CTL_CONTROL_ADDR(x),m,v,HWIO_TQM_R0_CACHE_CTL_CONTROL_IN(x))
#define HWIO_TQM_R0_CACHE_CTL_CONTROL_WRITE_POSTED_FOR_NON_POSTED_LINE_FLUSH_BMSK                                       0x2
#define HWIO_TQM_R0_CACHE_CTL_CONTROL_WRITE_POSTED_FOR_NON_POSTED_LINE_FLUSH_SHFT                                         1
#define HWIO_TQM_R0_CACHE_CTL_CONTROL_CACHE_RESET_BMSK                                                                  0x1
#define HWIO_TQM_R0_CACHE_CTL_CONTROL_CACHE_RESET_SHFT                                                                    0

#define HWIO_TQM_R0_CACHE_CTL_CONFIG_SET_ADDR(x)                                                                 ((x) + 0x3fc)
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_SET_PHYS(x)                                                                 ((x) + 0x3fc)
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_SET_OFFS                                                                    (0x3fc)
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_SET_RMSK                                                                     0x1ffffff
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_SET_POR                                                                     0x00000000
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_SET_POR_RMSK                                                                0xffffffff
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_SET_ATTR                                                                                 0x3
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_SET_IN(x)            \
                in_dword(HWIO_TQM_R0_CACHE_CTL_CONFIG_SET_ADDR(x))
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_SET_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_CACHE_CTL_CONFIG_SET_ADDR(x), m)
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_SET_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_CACHE_CTL_CONFIG_SET_ADDR(x),v)
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_SET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_CACHE_CTL_CONFIG_SET_ADDR(x),m,v,HWIO_TQM_R0_CACHE_CTL_CONFIG_SET_IN(x))
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_SET_CONFIG_SET_BMSK                                                          0x1ffffff
#define HWIO_TQM_R0_CACHE_CTL_CONFIG_SET_CONFIG_SET_SHFT                                                                  0

#define HWIO_TQM_R0_CACHE_CTL_SET_SIZE_ADDR(x)                                                                   ((x) + 0x400)
#define HWIO_TQM_R0_CACHE_CTL_SET_SIZE_PHYS(x)                                                                   ((x) + 0x400)
#define HWIO_TQM_R0_CACHE_CTL_SET_SIZE_OFFS                                                                      (0x400)
#define HWIO_TQM_R0_CACHE_CTL_SET_SIZE_RMSK                                                                           0x3ff
#define HWIO_TQM_R0_CACHE_CTL_SET_SIZE_POR                                                                       0x000000f0
#define HWIO_TQM_R0_CACHE_CTL_SET_SIZE_POR_RMSK                                                                  0xffffffff
#define HWIO_TQM_R0_CACHE_CTL_SET_SIZE_ATTR                                                                                   0x3
#define HWIO_TQM_R0_CACHE_CTL_SET_SIZE_IN(x)            \
                in_dword(HWIO_TQM_R0_CACHE_CTL_SET_SIZE_ADDR(x))
#define HWIO_TQM_R0_CACHE_CTL_SET_SIZE_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_CACHE_CTL_SET_SIZE_ADDR(x), m)
#define HWIO_TQM_R0_CACHE_CTL_SET_SIZE_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_CACHE_CTL_SET_SIZE_ADDR(x),v)
#define HWIO_TQM_R0_CACHE_CTL_SET_SIZE_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_CACHE_CTL_SET_SIZE_ADDR(x),m,v,HWIO_TQM_R0_CACHE_CTL_SET_SIZE_IN(x))
#define HWIO_TQM_R0_CACHE_CTL_SET_SIZE_SET1_SIZE_BMSK                                                                 0x3ff
#define HWIO_TQM_R0_CACHE_CTL_SET_SIZE_SET1_SIZE_SHFT                                                                     0

#define HWIO_TQM_R0_CACHE_CTL_GXI_PRIORITY_ADDR(x)                                                               ((x) + 0x404)
#define HWIO_TQM_R0_CACHE_CTL_GXI_PRIORITY_PHYS(x)                                                               ((x) + 0x404)
#define HWIO_TQM_R0_CACHE_CTL_GXI_PRIORITY_OFFS                                                                  (0x404)
#define HWIO_TQM_R0_CACHE_CTL_GXI_PRIORITY_RMSK                                                                         0x7
#define HWIO_TQM_R0_CACHE_CTL_GXI_PRIORITY_POR                                                                   0x00000002
#define HWIO_TQM_R0_CACHE_CTL_GXI_PRIORITY_POR_RMSK                                                              0xffffffff
#define HWIO_TQM_R0_CACHE_CTL_GXI_PRIORITY_ATTR                                                                               0x3
#define HWIO_TQM_R0_CACHE_CTL_GXI_PRIORITY_IN(x)            \
                in_dword(HWIO_TQM_R0_CACHE_CTL_GXI_PRIORITY_ADDR(x))
#define HWIO_TQM_R0_CACHE_CTL_GXI_PRIORITY_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_CACHE_CTL_GXI_PRIORITY_ADDR(x), m)
#define HWIO_TQM_R0_CACHE_CTL_GXI_PRIORITY_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_CACHE_CTL_GXI_PRIORITY_ADDR(x),v)
#define HWIO_TQM_R0_CACHE_CTL_GXI_PRIORITY_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_CACHE_CTL_GXI_PRIORITY_ADDR(x),m,v,HWIO_TQM_R0_CACHE_CTL_GXI_PRIORITY_IN(x))
#define HWIO_TQM_R0_CACHE_CTL_GXI_PRIORITY_VC_ID_BMSK                                                                   0x4
#define HWIO_TQM_R0_CACHE_CTL_GXI_PRIORITY_VC_ID_SHFT                                                                     2
#define HWIO_TQM_R0_CACHE_CTL_GXI_PRIORITY_GXI_PRIORITY_BMSK                                                            0x3
#define HWIO_TQM_R0_CACHE_CTL_GXI_PRIORITY_GXI_PRIORITY_SHFT                                                              0

#define HWIO_TQM_R0_CMD_AND_PTR_PREFETCH_ADDR(x)                                                                 ((x) + 0x408)
#define HWIO_TQM_R0_CMD_AND_PTR_PREFETCH_PHYS(x)                                                                 ((x) + 0x408)
#define HWIO_TQM_R0_CMD_AND_PTR_PREFETCH_OFFS                                                                    (0x408)
#define HWIO_TQM_R0_CMD_AND_PTR_PREFETCH_RMSK                                                                    0xffffffff
#define HWIO_TQM_R0_CMD_AND_PTR_PREFETCH_POR                                                                     0x10041c10
#define HWIO_TQM_R0_CMD_AND_PTR_PREFETCH_POR_RMSK                                                                0xffffffff
#define HWIO_TQM_R0_CMD_AND_PTR_PREFETCH_ATTR                                                                                 0x3
#define HWIO_TQM_R0_CMD_AND_PTR_PREFETCH_IN(x)            \
                in_dword(HWIO_TQM_R0_CMD_AND_PTR_PREFETCH_ADDR(x))
#define HWIO_TQM_R0_CMD_AND_PTR_PREFETCH_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_CMD_AND_PTR_PREFETCH_ADDR(x), m)
#define HWIO_TQM_R0_CMD_AND_PTR_PREFETCH_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_CMD_AND_PTR_PREFETCH_ADDR(x),v)
#define HWIO_TQM_R0_CMD_AND_PTR_PREFETCH_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_CMD_AND_PTR_PREFETCH_ADDR(x),m,v,HWIO_TQM_R0_CMD_AND_PTR_PREFETCH_IN(x))
#define HWIO_TQM_R0_CMD_AND_PTR_PREFETCH_MIN_READ_SIZE_BMSK                                                      0xff000000
#define HWIO_TQM_R0_CMD_AND_PTR_PREFETCH_MIN_READ_SIZE_SHFT                                                              24
#define HWIO_TQM_R0_CMD_AND_PTR_PREFETCH_DESC_THRESHOLD_BMSK                                                       0xff0000
#define HWIO_TQM_R0_CMD_AND_PTR_PREFETCH_DESC_THRESHOLD_SHFT                                                             16
#define HWIO_TQM_R0_CMD_AND_PTR_PREFETCH_CMD_THRESHOLD_BMSK                                                          0xff00
#define HWIO_TQM_R0_CMD_AND_PTR_PREFETCH_CMD_THRESHOLD_SHFT                                                               8
#define HWIO_TQM_R0_CMD_AND_PTR_PREFETCH_ENTRANCE_THRESHOLD_BMSK                                                       0xff
#define HWIO_TQM_R0_CMD_AND_PTR_PREFETCH_ENTRANCE_THRESHOLD_SHFT                                                          0

#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_0_ADDR(x)                                                          ((x) + 0x40c)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_0_PHYS(x)                                                          ((x) + 0x40c)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_0_OFFS                                                             (0x40c)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_0_RMSK                                                              0x3ff03ff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_0_POR                                                              0x002f0000
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_0_POR_RMSK                                                         0xffffffff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_0_ATTR                                                                          0x3
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_0_IN(x)            \
                in_dword(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_0_ADDR(x))
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_0_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_0_ADDR(x), m)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_0_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_0_ADDR(x),v)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_0_ADDR(x),m,v,HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_0_IN(x))
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_0_SW_CMD_END_ADDR_BMSK                                              0x3ff0000
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_0_SW_CMD_END_ADDR_SHFT                                                     16
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_0_SW_CMD_START_ADDR_BMSK                                                0x3ff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_0_SW_CMD_START_ADDR_SHFT                                                    0

#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_1_ADDR(x)                                                          ((x) + 0x410)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_1_PHYS(x)                                                          ((x) + 0x410)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_1_OFFS                                                             (0x410)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_1_RMSK                                                              0x3ff03ff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_1_POR                                                              0x008b0030
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_1_POR_RMSK                                                         0xffffffff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_1_ATTR                                                                          0x3
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_1_IN(x)            \
                in_dword(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_1_ADDR(x))
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_1_ADDR(x), m)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_1_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_1_ADDR(x),v)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_1_ADDR(x),m,v,HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_1_IN(x))
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_1_HWSCH_CMD1_END_ADDR_BMSK                                          0x3ff0000
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_1_HWSCH_CMD1_END_ADDR_SHFT                                                 16
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_1_HWSCH_CMD1_START_ADDR_BMSK                                            0x3ff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_1_HWSCH_CMD1_START_ADDR_SHFT                                                0

#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_2_ADDR(x)                                                          ((x) + 0x414)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_2_PHYS(x)                                                          ((x) + 0x414)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_2_OFFS                                                             (0x414)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_2_RMSK                                                              0x3ff03ff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_2_POR                                                              0x00bb008c
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_2_POR_RMSK                                                         0xffffffff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_2_ATTR                                                                          0x3
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_2_IN(x)            \
                in_dword(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_2_ADDR(x))
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_2_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_2_ADDR(x), m)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_2_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_2_ADDR(x),v)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_2_ADDR(x),m,v,HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_2_IN(x))
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_2_MSDU_ENTRANCE1_CMD_END_ADDR_BMSK                                  0x3ff0000
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_2_MSDU_ENTRANCE1_CMD_END_ADDR_SHFT                                         16
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_2_MSDU_ENTRANCE1_CMD_START_ADDR_BMSK                                    0x3ff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_2_MSDU_ENTRANCE1_CMD_START_ADDR_SHFT                                        0

#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_4_ADDR(x)                                                          ((x) + 0x418)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_4_PHYS(x)                                                          ((x) + 0x418)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_4_OFFS                                                             (0x418)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_4_RMSK                                                              0x3ff03ff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_4_POR                                                              0x00d300bc
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_4_POR_RMSK                                                         0xffffffff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_4_ATTR                                                                          0x3
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_4_IN(x)            \
                in_dword(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_4_ADDR(x))
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_4_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_4_ADDR(x), m)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_4_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_4_ADDR(x),v)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_4_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_4_ADDR(x),m,v,HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_4_IN(x))
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_4_DESC_PTRS_END_ADDR_BMSK                                           0x3ff0000
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_4_DESC_PTRS_END_ADDR_SHFT                                                  16
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_4_DESC_PTRS_START_ADDR_BMSK                                             0x3ff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_4_DESC_PTRS_START_ADDR_SHFT                                                 0

#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_6_ADDR(x)                                                          ((x) + 0x41c)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_6_PHYS(x)                                                          ((x) + 0x41c)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_6_OFFS                                                             (0x41c)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_6_RMSK                                                              0x3ff03ff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_6_POR                                                              0x012f00d4
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_6_POR_RMSK                                                         0xffffffff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_6_ATTR                                                                          0x3
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_6_IN(x)            \
                in_dword(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_6_ADDR(x))
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_6_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_6_ADDR(x), m)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_6_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_6_ADDR(x),v)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_6_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_6_ADDR(x),m,v,HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_6_IN(x))
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_6_HWSCH_CMD2_END_ADDR_BMSK                                          0x3ff0000
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_6_HWSCH_CMD2_END_ADDR_SHFT                                                 16
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_6_HWSCH_CMD2_START_ADDR_BMSK                                            0x3ff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_6_HWSCH_CMD2_START_ADDR_SHFT                                                0

#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_8_ADDR(x)                                                          ((x) + 0x420)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_8_PHYS(x)                                                          ((x) + 0x420)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_8_OFFS                                                             (0x420)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_8_RMSK                                                              0x3ff03ff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_8_POR                                                              0x015f0130
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_8_POR_RMSK                                                         0xffffffff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_8_ATTR                                                                          0x3
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_8_IN(x)            \
                in_dword(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_8_ADDR(x))
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_8_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_8_ADDR(x), m)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_8_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_8_ADDR(x),v)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_8_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_8_ADDR(x),m,v,HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_8_IN(x))
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_8_MSDU_ENTRANCE3_CMD_END_ADDR_BMSK                                  0x3ff0000
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_8_MSDU_ENTRANCE3_CMD_END_ADDR_SHFT                                         16
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_8_MSDU_ENTRANCE3_CMD_START_ADDR_BMSK                                    0x3ff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_8_MSDU_ENTRANCE3_CMD_START_ADDR_SHFT                                        0

#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_9_ADDR(x)                                                          ((x) + 0x424)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_9_PHYS(x)                                                          ((x) + 0x424)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_9_OFFS                                                             (0x424)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_9_RMSK                                                              0x3ff03ff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_9_POR                                                              0x018f0160
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_9_POR_RMSK                                                         0xffffffff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_9_ATTR                                                                          0x3
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_9_IN(x)            \
                in_dword(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_9_ADDR(x))
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_9_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_9_ADDR(x), m)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_9_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_9_ADDR(x),v)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_9_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_9_ADDR(x),m,v,HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_9_IN(x))
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_9_SW_CMD1_END_ADDR_BMSK                                             0x3ff0000
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_9_SW_CMD1_END_ADDR_SHFT                                                    16
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_9_SW_CMD1_START_ADDR_BMSK                                               0x3ff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_9_SW_CMD1_START_ADDR_SHFT                                                   0

#define HWIO_TQM_R0_STATUS_BUFFER_PARTITION_ADDR(x)                                                              ((x) + 0x428)
#define HWIO_TQM_R0_STATUS_BUFFER_PARTITION_PHYS(x)                                                              ((x) + 0x428)
#define HWIO_TQM_R0_STATUS_BUFFER_PARTITION_OFFS                                                                 (0x428)
#define HWIO_TQM_R0_STATUS_BUFFER_PARTITION_RMSK                                                                     0x1f7f
#define HWIO_TQM_R0_STATUS_BUFFER_PARTITION_POR                                                                  0x00001441
#define HWIO_TQM_R0_STATUS_BUFFER_PARTITION_POR_RMSK                                                             0xffffffff
#define HWIO_TQM_R0_STATUS_BUFFER_PARTITION_ATTR                                                                              0x3
#define HWIO_TQM_R0_STATUS_BUFFER_PARTITION_IN(x)            \
                in_dword(HWIO_TQM_R0_STATUS_BUFFER_PARTITION_ADDR(x))
#define HWIO_TQM_R0_STATUS_BUFFER_PARTITION_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_STATUS_BUFFER_PARTITION_ADDR(x), m)
#define HWIO_TQM_R0_STATUS_BUFFER_PARTITION_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_STATUS_BUFFER_PARTITION_ADDR(x),v)
#define HWIO_TQM_R0_STATUS_BUFFER_PARTITION_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_STATUS_BUFFER_PARTITION_ADDR(x),m,v,HWIO_TQM_R0_STATUS_BUFFER_PARTITION_IN(x))
#define HWIO_TQM_R0_STATUS_BUFFER_PARTITION_ISSUE_MULTIPLE_BMSK                                                      0x1000
#define HWIO_TQM_R0_STATUS_BUFFER_PARTITION_ISSUE_MULTIPLE_SHFT                                                          12
#define HWIO_TQM_R0_STATUS_BUFFER_PARTITION_WAIT_THRESHOLD_BMSK                                                       0xf00
#define HWIO_TQM_R0_STATUS_BUFFER_PARTITION_WAIT_THRESHOLD_SHFT                                                           8
#define HWIO_TQM_R0_STATUS_BUFFER_PARTITION_STATUS0_END_ADDR_BMSK                                                      0x7f
#define HWIO_TQM_R0_STATUS_BUFFER_PARTITION_STATUS0_END_ADDR_SHFT                                                         0

#define HWIO_TQM_R0_WATCHDOG_ADDR(x)                                                                             ((x) + 0x42c)
#define HWIO_TQM_R0_WATCHDOG_PHYS(x)                                                                             ((x) + 0x42c)
#define HWIO_TQM_R0_WATCHDOG_OFFS                                                                                (0x42c)
#define HWIO_TQM_R0_WATCHDOG_RMSK                                                                                0x7fffffff
#define HWIO_TQM_R0_WATCHDOG_POR                                                                                 0x00002710
#define HWIO_TQM_R0_WATCHDOG_POR_RMSK                                                                            0xffffffff
#define HWIO_TQM_R0_WATCHDOG_ATTR                                                                                             0x3
#define HWIO_TQM_R0_WATCHDOG_IN(x)            \
                in_dword(HWIO_TQM_R0_WATCHDOG_ADDR(x))
#define HWIO_TQM_R0_WATCHDOG_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_WATCHDOG_ADDR(x), m)
#define HWIO_TQM_R0_WATCHDOG_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_WATCHDOG_ADDR(x),v)
#define HWIO_TQM_R0_WATCHDOG_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_WATCHDOG_ADDR(x),m,v,HWIO_TQM_R0_WATCHDOG_IN(x))
#define HWIO_TQM_R0_WATCHDOG_STATUS_BMSK                                                                         0x7fff0000
#define HWIO_TQM_R0_WATCHDOG_STATUS_SHFT                                                                                 16
#define HWIO_TQM_R0_WATCHDOG_LIMIT_BMSK                                                                              0xffff
#define HWIO_TQM_R0_WATCHDOG_LIMIT_SHFT                                                                                   0

#define HWIO_TQM_R0_TESTBUS_CTRL_ADDR(x)                                                                         ((x) + 0x430)
#define HWIO_TQM_R0_TESTBUS_CTRL_PHYS(x)                                                                         ((x) + 0x430)
#define HWIO_TQM_R0_TESTBUS_CTRL_OFFS                                                                            (0x430)
#define HWIO_TQM_R0_TESTBUS_CTRL_RMSK                                                                            0xffffffff
#define HWIO_TQM_R0_TESTBUS_CTRL_POR                                                                             0x00000000
#define HWIO_TQM_R0_TESTBUS_CTRL_POR_RMSK                                                                        0xffffffff
#define HWIO_TQM_R0_TESTBUS_CTRL_ATTR                                                                                         0x3
#define HWIO_TQM_R0_TESTBUS_CTRL_IN(x)            \
                in_dword(HWIO_TQM_R0_TESTBUS_CTRL_ADDR(x))
#define HWIO_TQM_R0_TESTBUS_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TESTBUS_CTRL_ADDR(x), m)
#define HWIO_TQM_R0_TESTBUS_CTRL_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TESTBUS_CTRL_ADDR(x),v)
#define HWIO_TQM_R0_TESTBUS_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TESTBUS_CTRL_ADDR(x),m,v,HWIO_TQM_R0_TESTBUS_CTRL_IN(x))
#define HWIO_TQM_R0_TESTBUS_CTRL_SELECT_TQM_BMSK                                                                 0xffffffff
#define HWIO_TQM_R0_TESTBUS_CTRL_SELECT_TQM_SHFT                                                                          0

#define HWIO_TQM_R0_TESTBUS_LOWER_ADDR(x)                                                                        ((x) + 0x434)
#define HWIO_TQM_R0_TESTBUS_LOWER_PHYS(x)                                                                        ((x) + 0x434)
#define HWIO_TQM_R0_TESTBUS_LOWER_OFFS                                                                           (0x434)
#define HWIO_TQM_R0_TESTBUS_LOWER_RMSK                                                                           0xffffffff
#define HWIO_TQM_R0_TESTBUS_LOWER_POR                                                                            0x00000000
#define HWIO_TQM_R0_TESTBUS_LOWER_POR_RMSK                                                                       0xffffffff
#define HWIO_TQM_R0_TESTBUS_LOWER_ATTR                                                                                        0x1
#define HWIO_TQM_R0_TESTBUS_LOWER_IN(x)            \
                in_dword(HWIO_TQM_R0_TESTBUS_LOWER_ADDR(x))
#define HWIO_TQM_R0_TESTBUS_LOWER_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TESTBUS_LOWER_ADDR(x), m)
#define HWIO_TQM_R0_TESTBUS_LOWER_VALUE_BMSK                                                                     0xffffffff
#define HWIO_TQM_R0_TESTBUS_LOWER_VALUE_SHFT                                                                              0

#define HWIO_TQM_R0_TESTBUS_UPPER_ADDR(x)                                                                        ((x) + 0x438)
#define HWIO_TQM_R0_TESTBUS_UPPER_PHYS(x)                                                                        ((x) + 0x438)
#define HWIO_TQM_R0_TESTBUS_UPPER_OFFS                                                                           (0x438)
#define HWIO_TQM_R0_TESTBUS_UPPER_RMSK                                                                                 0xff
#define HWIO_TQM_R0_TESTBUS_UPPER_POR                                                                            0x00000000
#define HWIO_TQM_R0_TESTBUS_UPPER_POR_RMSK                                                                       0xffffffff
#define HWIO_TQM_R0_TESTBUS_UPPER_ATTR                                                                                        0x1
#define HWIO_TQM_R0_TESTBUS_UPPER_IN(x)            \
                in_dword(HWIO_TQM_R0_TESTBUS_UPPER_ADDR(x))
#define HWIO_TQM_R0_TESTBUS_UPPER_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TESTBUS_UPPER_ADDR(x), m)
#define HWIO_TQM_R0_TESTBUS_UPPER_VALUE_BMSK                                                                           0xff
#define HWIO_TQM_R0_TESTBUS_UPPER_VALUE_SHFT                                                                              0

#define HWIO_TQM_R0_EVENTMASK_IX_0_ADDR(x)                                                                       ((x) + 0x43c)
#define HWIO_TQM_R0_EVENTMASK_IX_0_PHYS(x)                                                                       ((x) + 0x43c)
#define HWIO_TQM_R0_EVENTMASK_IX_0_OFFS                                                                          (0x43c)
#define HWIO_TQM_R0_EVENTMASK_IX_0_RMSK                                                                          0xffffffff
#define HWIO_TQM_R0_EVENTMASK_IX_0_POR                                                                           0xffffffff
#define HWIO_TQM_R0_EVENTMASK_IX_0_POR_RMSK                                                                      0xffffffff
#define HWIO_TQM_R0_EVENTMASK_IX_0_ATTR                                                                                       0x3
#define HWIO_TQM_R0_EVENTMASK_IX_0_IN(x)            \
                in_dword(HWIO_TQM_R0_EVENTMASK_IX_0_ADDR(x))
#define HWIO_TQM_R0_EVENTMASK_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_EVENTMASK_IX_0_ADDR(x), m)
#define HWIO_TQM_R0_EVENTMASK_IX_0_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_EVENTMASK_IX_0_ADDR(x),v)
#define HWIO_TQM_R0_EVENTMASK_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_EVENTMASK_IX_0_ADDR(x),m,v,HWIO_TQM_R0_EVENTMASK_IX_0_IN(x))
#define HWIO_TQM_R0_EVENTMASK_IX_0_MASK_BMSK                                                                     0xffffffff
#define HWIO_TQM_R0_EVENTMASK_IX_0_MASK_SHFT                                                                              0

#define HWIO_TQM_R0_EVENTMASK_IX_1_ADDR(x)                                                                       ((x) + 0x440)
#define HWIO_TQM_R0_EVENTMASK_IX_1_PHYS(x)                                                                       ((x) + 0x440)
#define HWIO_TQM_R0_EVENTMASK_IX_1_OFFS                                                                          (0x440)
#define HWIO_TQM_R0_EVENTMASK_IX_1_RMSK                                                                          0xffffffff
#define HWIO_TQM_R0_EVENTMASK_IX_1_POR                                                                           0xffffffff
#define HWIO_TQM_R0_EVENTMASK_IX_1_POR_RMSK                                                                      0xffffffff
#define HWIO_TQM_R0_EVENTMASK_IX_1_ATTR                                                                                       0x3
#define HWIO_TQM_R0_EVENTMASK_IX_1_IN(x)            \
                in_dword(HWIO_TQM_R0_EVENTMASK_IX_1_ADDR(x))
#define HWIO_TQM_R0_EVENTMASK_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_EVENTMASK_IX_1_ADDR(x), m)
#define HWIO_TQM_R0_EVENTMASK_IX_1_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_EVENTMASK_IX_1_ADDR(x),v)
#define HWIO_TQM_R0_EVENTMASK_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_EVENTMASK_IX_1_ADDR(x),m,v,HWIO_TQM_R0_EVENTMASK_IX_1_IN(x))
#define HWIO_TQM_R0_EVENTMASK_IX_1_MASK_BMSK                                                                     0xffffffff
#define HWIO_TQM_R0_EVENTMASK_IX_1_MASK_SHFT                                                                              0

#define HWIO_TQM_R0_EVENTMASK_IX_2_ADDR(x)                                                                       ((x) + 0x444)
#define HWIO_TQM_R0_EVENTMASK_IX_2_PHYS(x)                                                                       ((x) + 0x444)
#define HWIO_TQM_R0_EVENTMASK_IX_2_OFFS                                                                          (0x444)
#define HWIO_TQM_R0_EVENTMASK_IX_2_RMSK                                                                          0xffffffff
#define HWIO_TQM_R0_EVENTMASK_IX_2_POR                                                                           0xffffffff
#define HWIO_TQM_R0_EVENTMASK_IX_2_POR_RMSK                                                                      0xffffffff
#define HWIO_TQM_R0_EVENTMASK_IX_2_ATTR                                                                                       0x3
#define HWIO_TQM_R0_EVENTMASK_IX_2_IN(x)            \
                in_dword(HWIO_TQM_R0_EVENTMASK_IX_2_ADDR(x))
#define HWIO_TQM_R0_EVENTMASK_IX_2_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_EVENTMASK_IX_2_ADDR(x), m)
#define HWIO_TQM_R0_EVENTMASK_IX_2_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_EVENTMASK_IX_2_ADDR(x),v)
#define HWIO_TQM_R0_EVENTMASK_IX_2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_EVENTMASK_IX_2_ADDR(x),m,v,HWIO_TQM_R0_EVENTMASK_IX_2_IN(x))
#define HWIO_TQM_R0_EVENTMASK_IX_2_MASK_BMSK                                                                     0xffffffff
#define HWIO_TQM_R0_EVENTMASK_IX_2_MASK_SHFT                                                                              0

#define HWIO_TQM_R0_EVENTMASK_IX_3_ADDR(x)                                                                       ((x) + 0x448)
#define HWIO_TQM_R0_EVENTMASK_IX_3_PHYS(x)                                                                       ((x) + 0x448)
#define HWIO_TQM_R0_EVENTMASK_IX_3_OFFS                                                                          (0x448)
#define HWIO_TQM_R0_EVENTMASK_IX_3_RMSK                                                                          0xffffffff
#define HWIO_TQM_R0_EVENTMASK_IX_3_POR                                                                           0xffffffff
#define HWIO_TQM_R0_EVENTMASK_IX_3_POR_RMSK                                                                      0xffffffff
#define HWIO_TQM_R0_EVENTMASK_IX_3_ATTR                                                                                       0x3
#define HWIO_TQM_R0_EVENTMASK_IX_3_IN(x)            \
                in_dword(HWIO_TQM_R0_EVENTMASK_IX_3_ADDR(x))
#define HWIO_TQM_R0_EVENTMASK_IX_3_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_EVENTMASK_IX_3_ADDR(x), m)
#define HWIO_TQM_R0_EVENTMASK_IX_3_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_EVENTMASK_IX_3_ADDR(x),v)
#define HWIO_TQM_R0_EVENTMASK_IX_3_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_EVENTMASK_IX_3_ADDR(x),m,v,HWIO_TQM_R0_EVENTMASK_IX_3_IN(x))
#define HWIO_TQM_R0_EVENTMASK_IX_3_MASK_BMSK                                                                     0xffffffff
#define HWIO_TQM_R0_EVENTMASK_IX_3_MASK_SHFT                                                                              0

#define HWIO_TQM_R0_REG_ACCESS_EVENT_GEN_CTRL_ADDR(x)                                                            ((x) + 0x44c)
#define HWIO_TQM_R0_REG_ACCESS_EVENT_GEN_CTRL_PHYS(x)                                                            ((x) + 0x44c)
#define HWIO_TQM_R0_REG_ACCESS_EVENT_GEN_CTRL_OFFS                                                               (0x44c)
#define HWIO_TQM_R0_REG_ACCESS_EVENT_GEN_CTRL_RMSK                                                               0xffffffff
#define HWIO_TQM_R0_REG_ACCESS_EVENT_GEN_CTRL_POR                                                                0x7ffe0002
#define HWIO_TQM_R0_REG_ACCESS_EVENT_GEN_CTRL_POR_RMSK                                                           0xffffffff
#define HWIO_TQM_R0_REG_ACCESS_EVENT_GEN_CTRL_ATTR                                                                            0x3
#define HWIO_TQM_R0_REG_ACCESS_EVENT_GEN_CTRL_IN(x)            \
                in_dword(HWIO_TQM_R0_REG_ACCESS_EVENT_GEN_CTRL_ADDR(x))
#define HWIO_TQM_R0_REG_ACCESS_EVENT_GEN_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_REG_ACCESS_EVENT_GEN_CTRL_ADDR(x), m)
#define HWIO_TQM_R0_REG_ACCESS_EVENT_GEN_CTRL_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_REG_ACCESS_EVENT_GEN_CTRL_ADDR(x),v)
#define HWIO_TQM_R0_REG_ACCESS_EVENT_GEN_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_REG_ACCESS_EVENT_GEN_CTRL_ADDR(x),m,v,HWIO_TQM_R0_REG_ACCESS_EVENT_GEN_CTRL_IN(x))
#define HWIO_TQM_R0_REG_ACCESS_EVENT_GEN_CTRL_ADDRESS_RANGE_END_BMSK                                             0xfffe0000
#define HWIO_TQM_R0_REG_ACCESS_EVENT_GEN_CTRL_ADDRESS_RANGE_END_SHFT                                                     17
#define HWIO_TQM_R0_REG_ACCESS_EVENT_GEN_CTRL_ADDRESS_RANGE_START_BMSK                                              0x1fffc
#define HWIO_TQM_R0_REG_ACCESS_EVENT_GEN_CTRL_ADDRESS_RANGE_START_SHFT                                                    2
#define HWIO_TQM_R0_REG_ACCESS_EVENT_GEN_CTRL_WRITE_ACCESS_REPORT_ENABLE_BMSK                                           0x2
#define HWIO_TQM_R0_REG_ACCESS_EVENT_GEN_CTRL_WRITE_ACCESS_REPORT_ENABLE_SHFT                                             1
#define HWIO_TQM_R0_REG_ACCESS_EVENT_GEN_CTRL_READ_ACCESS_REPORT_ENABLE_BMSK                                            0x1
#define HWIO_TQM_R0_REG_ACCESS_EVENT_GEN_CTRL_READ_ACCESS_REPORT_ENABLE_SHFT                                              0

#define HWIO_TQM_R0_END_OF_TEST_CHECK_ADDR(x)                                                                    ((x) + 0x450)
#define HWIO_TQM_R0_END_OF_TEST_CHECK_PHYS(x)                                                                    ((x) + 0x450)
#define HWIO_TQM_R0_END_OF_TEST_CHECK_OFFS                                                                       (0x450)
#define HWIO_TQM_R0_END_OF_TEST_CHECK_RMSK                                                                              0x1
#define HWIO_TQM_R0_END_OF_TEST_CHECK_POR                                                                        0x00000000
#define HWIO_TQM_R0_END_OF_TEST_CHECK_POR_RMSK                                                                   0xffffffff
#define HWIO_TQM_R0_END_OF_TEST_CHECK_ATTR                                                                                    0x3
#define HWIO_TQM_R0_END_OF_TEST_CHECK_IN(x)            \
                in_dword(HWIO_TQM_R0_END_OF_TEST_CHECK_ADDR(x))
#define HWIO_TQM_R0_END_OF_TEST_CHECK_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_END_OF_TEST_CHECK_ADDR(x), m)
#define HWIO_TQM_R0_END_OF_TEST_CHECK_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_END_OF_TEST_CHECK_ADDR(x),v)
#define HWIO_TQM_R0_END_OF_TEST_CHECK_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_END_OF_TEST_CHECK_ADDR(x),m,v,HWIO_TQM_R0_END_OF_TEST_CHECK_IN(x))
#define HWIO_TQM_R0_END_OF_TEST_CHECK_END_OF_TEST_SELF_CHECK_BMSK                                                       0x1
#define HWIO_TQM_R0_END_OF_TEST_CHECK_END_OF_TEST_SELF_CHECK_SHFT                                                         0

#define HWIO_TQM_R0_INVALID_APB_ACC_ADDR_ADDR(x)                                                                 ((x) + 0x454)
#define HWIO_TQM_R0_INVALID_APB_ACC_ADDR_PHYS(x)                                                                 ((x) + 0x454)
#define HWIO_TQM_R0_INVALID_APB_ACC_ADDR_OFFS                                                                    (0x454)
#define HWIO_TQM_R0_INVALID_APB_ACC_ADDR_RMSK                                                                       0x1ffff
#define HWIO_TQM_R0_INVALID_APB_ACC_ADDR_POR                                                                     0x00000000
#define HWIO_TQM_R0_INVALID_APB_ACC_ADDR_POR_RMSK                                                                0xffffffff
#define HWIO_TQM_R0_INVALID_APB_ACC_ADDR_ATTR                                                                                 0x1
#define HWIO_TQM_R0_INVALID_APB_ACC_ADDR_IN(x)            \
                in_dword(HWIO_TQM_R0_INVALID_APB_ACC_ADDR_ADDR(x))
#define HWIO_TQM_R0_INVALID_APB_ACC_ADDR_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_INVALID_APB_ACC_ADDR_ADDR(x), m)
#define HWIO_TQM_R0_INVALID_APB_ACC_ADDR_VALUE_BMSK                                                                 0x1ffff
#define HWIO_TQM_R0_INVALID_APB_ACC_ADDR_VALUE_SHFT                                                                       0

#define HWIO_TQM_R0_SM_STATES_IX0_ADDR(x)                                                                        ((x) + 0x458)
#define HWIO_TQM_R0_SM_STATES_IX0_PHYS(x)                                                                        ((x) + 0x458)
#define HWIO_TQM_R0_SM_STATES_IX0_OFFS                                                                           (0x458)
#define HWIO_TQM_R0_SM_STATES_IX0_RMSK                                                                           0x3fffffff
#define HWIO_TQM_R0_SM_STATES_IX0_POR                                                                            0x00000000
#define HWIO_TQM_R0_SM_STATES_IX0_POR_RMSK                                                                       0xffffffff
#define HWIO_TQM_R0_SM_STATES_IX0_ATTR                                                                                        0x1
#define HWIO_TQM_R0_SM_STATES_IX0_IN(x)            \
                in_dword(HWIO_TQM_R0_SM_STATES_IX0_ADDR(x))
#define HWIO_TQM_R0_SM_STATES_IX0_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SM_STATES_IX0_ADDR(x), m)
#define HWIO_TQM_R0_SM_STATES_IX0_GET_QUEUE_STATS_SM_BMSK                                                        0x3e000000
#define HWIO_TQM_R0_SM_STATES_IX0_GET_QUEUE_STATS_SM_SHFT                                                                25
#define HWIO_TQM_R0_SM_STATES_IX0_GET_MPDU_HEAD_INFO_SM_BMSK                                                      0x1e00000
#define HWIO_TQM_R0_SM_STATES_IX0_GET_MPDU_HEAD_INFO_SM_SHFT                                                             21
#define HWIO_TQM_R0_SM_STATES_IX0_FLUSH_AND_UNBLOCK_CACHE_SM_BMSK                                                  0x180000
#define HWIO_TQM_R0_SM_STATES_IX0_FLUSH_AND_UNBLOCK_CACHE_SM_SHFT                                                        19
#define HWIO_TQM_R0_SM_STATES_IX0_ADD_MPDU_LINK_SM_BMSK                                                             0x78000
#define HWIO_TQM_R0_SM_STATES_IX0_ADD_MPDU_LINK_SM_SHFT                                                                  15
#define HWIO_TQM_R0_SM_STATES_IX0_CREATE_MPDU_SM_BMSK                                                                0x7c00
#define HWIO_TQM_R0_SM_STATES_IX0_CREATE_MPDU_SM_SHFT                                                                    10
#define HWIO_TQM_R0_SM_STATES_IX0_GEN_MPDU_SM_BMSK                                                                    0x3e0
#define HWIO_TQM_R0_SM_STATES_IX0_GEN_MPDU_SM_SHFT                                                                        5
#define HWIO_TQM_R0_SM_STATES_IX0_ADD_MSDU_SM_BMSK                                                                     0x1f
#define HWIO_TQM_R0_SM_STATES_IX0_ADD_MSDU_SM_SHFT                                                                        0

#define HWIO_TQM_R0_SM_STATES_IX1_ADDR(x)                                                                        ((x) + 0x45c)
#define HWIO_TQM_R0_SM_STATES_IX1_PHYS(x)                                                                        ((x) + 0x45c)
#define HWIO_TQM_R0_SM_STATES_IX1_OFFS                                                                           (0x45c)
#define HWIO_TQM_R0_SM_STATES_IX1_RMSK                                                                           0xffffffff
#define HWIO_TQM_R0_SM_STATES_IX1_POR                                                                            0x00000000
#define HWIO_TQM_R0_SM_STATES_IX1_POR_RMSK                                                                       0xffffffff
#define HWIO_TQM_R0_SM_STATES_IX1_ATTR                                                                                        0x1
#define HWIO_TQM_R0_SM_STATES_IX1_IN(x)            \
                in_dword(HWIO_TQM_R0_SM_STATES_IX1_ADDR(x))
#define HWIO_TQM_R0_SM_STATES_IX1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SM_STATES_IX1_ADDR(x), m)
#define HWIO_TQM_R0_SM_STATES_IX1_ARB_STATUS_BLK1_SM_BMSK                                                        0xc0000000
#define HWIO_TQM_R0_SM_STATES_IX1_ARB_STATUS_BLK1_SM_SHFT                                                                30
#define HWIO_TQM_R0_SM_STATES_IX1_ARB_STATUS_BLK0_SM_BMSK                                                        0x30000000
#define HWIO_TQM_R0_SM_STATES_IX1_ARB_STATUS_BLK0_SM_SHFT                                                                28
#define HWIO_TQM_R0_SM_STATES_IX1_UPDATE_TX_MPDU_COUNT_SM_BMSK                                                    0xf800000
#define HWIO_TQM_R0_SM_STATES_IX1_UPDATE_TX_MPDU_COUNT_SM_SHFT                                                           23
#define HWIO_TQM_R0_SM_STATES_IX1_REM_MSDU_SM_BMSK                                                                 0x7c0000
#define HWIO_TQM_R0_SM_STATES_IX1_REM_MSDU_SM_SHFT                                                                       18
#define HWIO_TQM_R0_SM_STATES_IX1_REM_MPDU_SM_BMSK                                                                  0x3f000
#define HWIO_TQM_R0_SM_STATES_IX1_REM_MPDU_SM_SHFT                                                                       12
#define HWIO_TQM_R0_SM_STATES_IX1_WRITE_CMD_SM_BMSK                                                                   0xe00
#define HWIO_TQM_R0_SM_STATES_IX1_WRITE_CMD_SM_SHFT                                                                       9
#define HWIO_TQM_R0_SM_STATES_IX1_LIST_MPDU_MAIN_SM_BMSK                                                              0x1f0
#define HWIO_TQM_R0_SM_STATES_IX1_LIST_MPDU_MAIN_SM_SHFT                                                                  4
#define HWIO_TQM_R0_SM_STATES_IX1_LIST_TLV_SM_BMSK                                                                      0xf
#define HWIO_TQM_R0_SM_STATES_IX1_LIST_TLV_SM_SHFT                                                                        0

#define HWIO_TQM_R0_SM_STATES_IX2_ADDR(x)                                                                        ((x) + 0x460)
#define HWIO_TQM_R0_SM_STATES_IX2_PHYS(x)                                                                        ((x) + 0x460)
#define HWIO_TQM_R0_SM_STATES_IX2_OFFS                                                                           (0x460)
#define HWIO_TQM_R0_SM_STATES_IX2_RMSK                                                                           0xffffffff
#define HWIO_TQM_R0_SM_STATES_IX2_POR                                                                            0x00000000
#define HWIO_TQM_R0_SM_STATES_IX2_POR_RMSK                                                                       0xffffffff
#define HWIO_TQM_R0_SM_STATES_IX2_ATTR                                                                                        0x1
#define HWIO_TQM_R0_SM_STATES_IX2_IN(x)            \
                in_dword(HWIO_TQM_R0_SM_STATES_IX2_ADDR(x))
#define HWIO_TQM_R0_SM_STATES_IX2_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SM_STATES_IX2_ADDR(x), m)
#define HWIO_TQM_R0_SM_STATES_IX2_ARB_ASYNC_SM_BMSK                                                              0x80000000
#define HWIO_TQM_R0_SM_STATES_IX2_ARB_ASYNC_SM_SHFT                                                                      31
#define HWIO_TQM_R0_SM_STATES_IX2_ARB_MSDU_ENT_SM_BMSK                                                           0x70000000
#define HWIO_TQM_R0_SM_STATES_IX2_ARB_MSDU_ENT_SM_SHFT                                                                   28
#define HWIO_TQM_R0_SM_STATES_IX2_ARB_SW_CMD_SM_BMSK                                                              0xf000000
#define HWIO_TQM_R0_SM_STATES_IX2_ARB_SW_CMD_SM_SHFT                                                                     24
#define HWIO_TQM_R0_SM_STATES_IX2_ARB_HWSCH_CMD_SM_BMSK                                                            0xf00000
#define HWIO_TQM_R0_SM_STATES_IX2_ARB_HWSCH_CMD_SM_SHFT                                                                  20
#define HWIO_TQM_R0_SM_STATES_IX2_PREFETCH_READ_SM_BMSK                                                             0xc0000
#define HWIO_TQM_R0_SM_STATES_IX2_PREFETCH_READ_SM_SHFT                                                                  18
#define HWIO_TQM_R0_SM_STATES_IX2_PREFETCH_SM_BMSK                                                                  0x3ffff
#define HWIO_TQM_R0_SM_STATES_IX2_PREFETCH_SM_SHFT                                                                        0

#define HWIO_TQM_R0_SM_STATES_IX3_ADDR(x)                                                                        ((x) + 0x464)
#define HWIO_TQM_R0_SM_STATES_IX3_PHYS(x)                                                                        ((x) + 0x464)
#define HWIO_TQM_R0_SM_STATES_IX3_OFFS                                                                           (0x464)
#define HWIO_TQM_R0_SM_STATES_IX3_RMSK                                                                             0xffffff
#define HWIO_TQM_R0_SM_STATES_IX3_POR                                                                            0x00000000
#define HWIO_TQM_R0_SM_STATES_IX3_POR_RMSK                                                                       0xffffffff
#define HWIO_TQM_R0_SM_STATES_IX3_ATTR                                                                                        0x1
#define HWIO_TQM_R0_SM_STATES_IX3_IN(x)            \
                in_dword(HWIO_TQM_R0_SM_STATES_IX3_ADDR(x))
#define HWIO_TQM_R0_SM_STATES_IX3_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SM_STATES_IX3_ADDR(x), m)
#define HWIO_TQM_R0_SM_STATES_IX3_PREFETCH_SM_BMSK                                                                 0xff0000
#define HWIO_TQM_R0_SM_STATES_IX3_PREFETCH_SM_SHFT                                                                       16
#define HWIO_TQM_R0_SM_STATES_IX3_TQM2TQM_OUT2_SM_STATE_BMSK                                                         0xc000
#define HWIO_TQM_R0_SM_STATES_IX3_TQM2TQM_OUT2_SM_STATE_SHFT                                                             14
#define HWIO_TQM_R0_SM_STATES_IX3_TQM2TQM_OUT1_SM_STATE_BMSK                                                         0x3000
#define HWIO_TQM_R0_SM_STATES_IX3_TQM2TQM_OUT1_SM_STATE_SHFT                                                             12
#define HWIO_TQM_R0_SM_STATES_IX3_UPDATE_QUEUE_DESC_SM_BMSK                                                           0xf80
#define HWIO_TQM_R0_SM_STATES_IX3_UPDATE_QUEUE_DESC_SM_SHFT                                                               7
#define HWIO_TQM_R0_SM_STATES_IX3_AXI_TO_TLV_SM_BMSK                                                                   0x60
#define HWIO_TQM_R0_SM_STATES_IX3_AXI_TO_TLV_SM_SHFT                                                                      5
#define HWIO_TQM_R0_SM_STATES_IX3_LIST_TLV_STATE_BMSK                                                                  0x1c
#define HWIO_TQM_R0_SM_STATES_IX3_LIST_TLV_STATE_SHFT                                                                     2
#define HWIO_TQM_R0_SM_STATES_IX3_DATA_ALIGN_SM_BMSK                                                                    0x3
#define HWIO_TQM_R0_SM_STATES_IX3_DATA_ALIGN_SM_SHFT                                                                      0

#define HWIO_TQM_R0_MISC_CFG_ADDR(x)                                                                             ((x) + 0x468)
#define HWIO_TQM_R0_MISC_CFG_PHYS(x)                                                                             ((x) + 0x468)
#define HWIO_TQM_R0_MISC_CFG_OFFS                                                                                (0x468)
#define HWIO_TQM_R0_MISC_CFG_RMSK                                                                                0xffdfefff
#define HWIO_TQM_R0_MISC_CFG_POR                                                                                 0x9a576fe0
#define HWIO_TQM_R0_MISC_CFG_POR_RMSK                                                                            0xffffffff
#define HWIO_TQM_R0_MISC_CFG_ATTR                                                                                             0x3
#define HWIO_TQM_R0_MISC_CFG_IN(x)            \
                in_dword(HWIO_TQM_R0_MISC_CFG_ADDR(x))
#define HWIO_TQM_R0_MISC_CFG_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_MISC_CFG_ADDR(x), m)
#define HWIO_TQM_R0_MISC_CFG_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_MISC_CFG_ADDR(x),v)
#define HWIO_TQM_R0_MISC_CFG_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_MISC_CFG_ADDR(x),m,v,HWIO_TQM_R0_MISC_CFG_IN(x))
#define HWIO_TQM_R0_MISC_CFG_ENABLE_ROUTING_CHECKS_BMSK                                                          0x80000000
#define HWIO_TQM_R0_MISC_CFG_ENABLE_ROUTING_CHECKS_SHFT                                                                  31
#define HWIO_TQM_R0_MISC_CFG_DISABLE_LINK_STARVATION_WAIT_BMSK                                                   0x40000000
#define HWIO_TQM_R0_MISC_CFG_DISABLE_LINK_STARVATION_WAIT_SHFT                                                           30
#define HWIO_TQM_R0_MISC_CFG_DISABLE_STATUS_FOR_INVALID_FLOW_BMSK                                                0x20000000
#define HWIO_TQM_R0_MISC_CFG_DISABLE_STATUS_FOR_INVALID_FLOW_SHFT                                                        29
#define HWIO_TQM_R0_MISC_CFG_ENB_ACKED_MPDU_QUEUE_OVERVIEW_BMSK                                                  0x10000000
#define HWIO_TQM_R0_MISC_CFG_ENB_ACKED_MPDU_QUEUE_OVERVIEW_SHFT                                                          28
#define HWIO_TQM_R0_MISC_CFG_ENABLE_TLV_FILTER_BMSK                                                               0x8000000
#define HWIO_TQM_R0_MISC_CFG_ENABLE_TLV_FILTER_SHFT                                                                      27
#define HWIO_TQM_R0_MISC_CFG_SEND_MSI_AFTER_IDLE_RESP_BMSK                                                        0x4000000
#define HWIO_TQM_R0_MISC_CFG_SEND_MSI_AFTER_IDLE_RESP_SHFT                                                               26
#define HWIO_TQM_R0_MISC_CFG_FILTER_INVALID_ADDRESS_IN_COMMANDS_BMSK                                              0x2000000
#define HWIO_TQM_R0_MISC_CFG_FILTER_INVALID_ADDRESS_IN_COMMANDS_SHFT                                                     25
#define HWIO_TQM_R0_MISC_CFG_STATUS1_WRITE_POSTED_BMSK                                                            0x1000000
#define HWIO_TQM_R0_MISC_CFG_STATUS1_WRITE_POSTED_SHFT                                                                   24
#define HWIO_TQM_R0_MISC_CFG_STATUS_WRITE_POSTED_BMSK                                                              0x800000
#define HWIO_TQM_R0_MISC_CFG_STATUS_WRITE_POSTED_SHFT                                                                    23
#define HWIO_TQM_R0_MISC_CFG_UPDATE_FW2TQM_TP_AT_8W_BOUNDARY_BMSK                                                  0x400000
#define HWIO_TQM_R0_MISC_CFG_UPDATE_FW2TQM_TP_AT_8W_BOUNDARY_SHFT                                                        22
#define HWIO_TQM_R0_MISC_CFG_UPDATE_TCL2TQM_TP_AT_8W_BOUNDARY_BMSK                                                 0x100000
#define HWIO_TQM_R0_MISC_CFG_UPDATE_TCL2TQM_TP_AT_8W_BOUNDARY_SHFT                                                       20
#define HWIO_TQM_R0_MISC_CFG_ENABLE_FILTER_GEN_MPDU_EMPTY_STATUS_BMSK                                               0x80000
#define HWIO_TQM_R0_MISC_CFG_ENABLE_FILTER_GEN_MPDU_EMPTY_STATUS_SHFT                                                    19
#define HWIO_TQM_R0_MISC_CFG_ENABLE_INVALIDATE_CACHE_FOR_INVALID_DESC_BMSK                                          0x40000
#define HWIO_TQM_R0_MISC_CFG_ENABLE_INVALIDATE_CACHE_FOR_INVALID_DESC_SHFT                                               18
#define HWIO_TQM_R0_MISC_CFG_ENABLE_UPDATE_TX_COUNT_DURING_FLUSH_BMSK                                               0x20000
#define HWIO_TQM_R0_MISC_CFG_ENABLE_UPDATE_TX_COUNT_DURING_FLUSH_SHFT                                                    17
#define HWIO_TQM_R0_MISC_CFG_ENABLE_BA_PROC_DURING_FLUSH_BMSK                                                       0x10000
#define HWIO_TQM_R0_MISC_CFG_ENABLE_BA_PROC_DURING_FLUSH_SHFT                                                            16
#define HWIO_TQM_R0_MISC_CFG_WRITE_CMD_SWAP_BIT_BMSK                                                                 0x8000
#define HWIO_TQM_R0_MISC_CFG_WRITE_CMD_SWAP_BIT_SHFT                                                                     15
#define HWIO_TQM_R0_MISC_CFG_WRITE_CMD_POSTED_BMSK                                                                   0x4000
#define HWIO_TQM_R0_MISC_CFG_WRITE_CMD_POSTED_SHFT                                                                       14
#define HWIO_TQM_R0_MISC_CFG_DESC_PTR_RELEASE_POSTED_BMSK                                                            0x2000
#define HWIO_TQM_R0_MISC_CFG_DESC_PTR_RELEASE_POSTED_SHFT                                                                13
#define HWIO_TQM_R0_MISC_CFG_FW_TX_NOTIFY_REM_MSDU_BMSK                                                               0x800
#define HWIO_TQM_R0_MISC_CFG_FW_TX_NOTIFY_REM_MSDU_SHFT                                                                  11
#define HWIO_TQM_R0_MISC_CFG_FW_TX_NOTIFY_LIST_MPDU_BMSK                                                              0x400
#define HWIO_TQM_R0_MISC_CFG_FW_TX_NOTIFY_LIST_MPDU_SHFT                                                                 10
#define HWIO_TQM_R0_MISC_CFG_FW_TX_NOTIFY_GEN_MPDU_BMSK                                                               0x200
#define HWIO_TQM_R0_MISC_CFG_FW_TX_NOTIFY_GEN_MPDU_SHFT                                                                   9
#define HWIO_TQM_R0_MISC_CFG_FW_TX_NOTIFY_REM_MPDU_BMSK                                                               0x100
#define HWIO_TQM_R0_MISC_CFG_FW_TX_NOTIFY_REM_MPDU_SHFT                                                                   8
#define HWIO_TQM_R0_MISC_CFG_FW_TX_NOTIFY_ACKED_MPDU_BMSK                                                              0x80
#define HWIO_TQM_R0_MISC_CFG_FW_TX_NOTIFY_ACKED_MPDU_SHFT                                                                 7
#define HWIO_TQM_R0_MISC_CFG_FORCE_TO_REPORT_STATUS_BMSK                                                               0x40
#define HWIO_TQM_R0_MISC_CFG_FORCE_TO_REPORT_STATUS_SHFT                                                                  6
#define HWIO_TQM_R0_MISC_CFG_LIST_MPDU_POSTED_BMSK                                                                     0x20
#define HWIO_TQM_R0_MISC_CFG_LIST_MPDU_POSTED_SHFT                                                                        5
#define HWIO_TQM_R0_MISC_CFG_LIST_MPDU_SWAP_BIT_BMSK                                                                   0x10
#define HWIO_TQM_R0_MISC_CFG_LIST_MPDU_SWAP_BIT_SHFT                                                                      4
#define HWIO_TQM_R0_MISC_CFG_LIST_MPDU_SECURITY_BIT_BMSK                                                                0x8
#define HWIO_TQM_R0_MISC_CFG_LIST_MPDU_SECURITY_BIT_SHFT                                                                  3
#define HWIO_TQM_R0_MISC_CFG_GEN_MPDU_POSTED_BMSK                                                                       0x4
#define HWIO_TQM_R0_MISC_CFG_GEN_MPDU_POSTED_SHFT                                                                         2
#define HWIO_TQM_R0_MISC_CFG_GEN_MPDU_SWAP_BIT_BMSK                                                                     0x2
#define HWIO_TQM_R0_MISC_CFG_GEN_MPDU_SWAP_BIT_SHFT                                                                       1
#define HWIO_TQM_R0_MISC_CFG_GEN_MPDU_SECURITY_BIT_BMSK                                                                 0x1
#define HWIO_TQM_R0_MISC_CFG_GEN_MPDU_SECURITY_BIT_SHFT                                                                   0

#define HWIO_TQM_R0_MISC_CFG_1_ADDR(x)                                                                           ((x) + 0x46c)
#define HWIO_TQM_R0_MISC_CFG_1_PHYS(x)                                                                           ((x) + 0x46c)
#define HWIO_TQM_R0_MISC_CFG_1_OFFS                                                                              (0x46c)
#define HWIO_TQM_R0_MISC_CFG_1_RMSK                                                                                   0x7ff
#define HWIO_TQM_R0_MISC_CFG_1_POR                                                                               0x00000040
#define HWIO_TQM_R0_MISC_CFG_1_POR_RMSK                                                                          0xffffffff
#define HWIO_TQM_R0_MISC_CFG_1_ATTR                                                                                           0x3
#define HWIO_TQM_R0_MISC_CFG_1_IN(x)            \
                in_dword(HWIO_TQM_R0_MISC_CFG_1_ADDR(x))
#define HWIO_TQM_R0_MISC_CFG_1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_MISC_CFG_1_ADDR(x), m)
#define HWIO_TQM_R0_MISC_CFG_1_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_MISC_CFG_1_ADDR(x),v)
#define HWIO_TQM_R0_MISC_CFG_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_MISC_CFG_1_ADDR(x),m,v,HWIO_TQM_R0_MISC_CFG_1_IN(x))
#define HWIO_TQM_R0_MISC_CFG_1_DISABLE_MLO_OWNER_BASED_ACK_PROCESS_BMSK                                               0x400
#define HWIO_TQM_R0_MISC_CFG_1_DISABLE_MLO_OWNER_BASED_ACK_PROCESS_SHFT                                                  10
#define HWIO_TQM_R0_MISC_CFG_1_ENB_TQM2TQM_GEN_MPDUS_BMSK                                                             0x200
#define HWIO_TQM_R0_MISC_CFG_1_ENB_TQM2TQM_GEN_MPDUS_SHFT                                                                 9
#define HWIO_TQM_R0_MISC_CFG_1_ENB_MLO_FRAGMENTATION_BMSK                                                             0x100
#define HWIO_TQM_R0_MISC_CFG_1_ENB_MLO_FRAGMENTATION_SHFT                                                                 8
#define HWIO_TQM_R0_MISC_CFG_1_ENB_SESSION_ID_BMSK                                                                     0x80
#define HWIO_TQM_R0_MISC_CFG_1_ENB_SESSION_ID_SHFT                                                                        7
#define HWIO_TQM_R0_MISC_CFG_1_ENB_OWNER_CHECK_BMSK                                                                    0x40
#define HWIO_TQM_R0_MISC_CFG_1_ENB_OWNER_CHECK_SHFT                                                                       6
#define HWIO_TQM_R0_MISC_CFG_1_DISABLE_DROP_COUNT_UPDATES_FOR_MULTICAST_BMSK                                           0x20
#define HWIO_TQM_R0_MISC_CFG_1_DISABLE_DROP_COUNT_UPDATES_FOR_MULTICAST_SHFT                                              5
#define HWIO_TQM_R0_MISC_CFG_1_UNMASK_EVENT_BUS_POT_BMSK                                                               0x10
#define HWIO_TQM_R0_MISC_CFG_1_UNMASK_EVENT_BUS_POT_SHFT                                                                  4
#define HWIO_TQM_R0_MISC_CFG_1_ALLOW_REGISTER_FLUSH_ACK_BMSK                                                            0x8
#define HWIO_TQM_R0_MISC_CFG_1_ALLOW_REGISTER_FLUSH_ACK_SHFT                                                              3
#define HWIO_TQM_R0_MISC_CFG_1_DISABLE_SINGLE_FLOW_CONCURRENCY_BMSK                                                     0x4
#define HWIO_TQM_R0_MISC_CFG_1_DISABLE_SINGLE_FLOW_CONCURRENCY_SHFT                                                       2
#define HWIO_TQM_R0_MISC_CFG_1_DISABLE_UPDATE_REQUIREMENT_CHECK_BMSK                                                    0x2
#define HWIO_TQM_R0_MISC_CFG_1_DISABLE_UPDATE_REQUIREMENT_CHECK_SHFT                                                      1
#define HWIO_TQM_R0_MISC_CFG_1_DISABLE_PREFETCH_FIX_BMSK                                                                0x1
#define HWIO_TQM_R0_MISC_CFG_1_DISABLE_PREFETCH_FIX_SHFT                                                                  0

#define HWIO_TQM_R0_CLKGATE_CTRL_ADDR(x)                                                                         ((x) + 0x470)
#define HWIO_TQM_R0_CLKGATE_CTRL_PHYS(x)                                                                         ((x) + 0x470)
#define HWIO_TQM_R0_CLKGATE_CTRL_OFFS                                                                            (0x470)
#define HWIO_TQM_R0_CLKGATE_CTRL_RMSK                                                                            0xdfffffff
#define HWIO_TQM_R0_CLKGATE_CTRL_POR                                                                             0x00000000
#define HWIO_TQM_R0_CLKGATE_CTRL_POR_RMSK                                                                        0xffffffff
#define HWIO_TQM_R0_CLKGATE_CTRL_ATTR                                                                                         0x3
#define HWIO_TQM_R0_CLKGATE_CTRL_IN(x)            \
                in_dword(HWIO_TQM_R0_CLKGATE_CTRL_ADDR(x))
#define HWIO_TQM_R0_CLKGATE_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_CLKGATE_CTRL_ADDR(x), m)
#define HWIO_TQM_R0_CLKGATE_CTRL_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_CLKGATE_CTRL_ADDR(x),v)
#define HWIO_TQM_R0_CLKGATE_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_CLKGATE_CTRL_ADDR(x),m,v,HWIO_TQM_R0_CLKGATE_CTRL_IN(x))
#define HWIO_TQM_R0_CLKGATE_CTRL_CLOCK_ENS_EXTEND_BMSK                                                           0x80000000
#define HWIO_TQM_R0_CLKGATE_CTRL_CLOCK_ENS_EXTEND_SHFT                                                                   31
#define HWIO_TQM_R0_CLKGATE_CTRL_CLK_GATE_DISABLE_APB_BMSK                                                       0x40000000
#define HWIO_TQM_R0_CLKGATE_CTRL_CLK_GATE_DISABLE_APB_SHFT                                                               30
#define HWIO_TQM_R0_CLKGATE_CTRL_COMMON_LOGIC_DESC_DISABLE_BMSK                                                  0x10000000
#define HWIO_TQM_R0_CLKGATE_CTRL_COMMON_LOGIC_DESC_DISABLE_SHFT                                                          28
#define HWIO_TQM_R0_CLKGATE_CTRL_HWSCH_TX_TLV2_DISABLE_BMSK                                                       0x8000000
#define HWIO_TQM_R0_CLKGATE_CTRL_HWSCH_TX_TLV2_DISABLE_SHFT                                                              27
#define HWIO_TQM_R0_CLKGATE_CTRL_HWSCH_TX_TLV1_DISABLE_BMSK                                                       0x4000000
#define HWIO_TQM_R0_CLKGATE_CTRL_HWSCH_TX_TLV1_DISABLE_SHFT                                                              26
#define HWIO_TQM_R0_CLKGATE_CTRL_DESC_REL_RING_DISABLE_BMSK                                                       0x2000000
#define HWIO_TQM_R0_CLKGATE_CTRL_DESC_REL_RING_DISABLE_SHFT                                                              25
#define HWIO_TQM_R0_CLKGATE_CTRL_STATUS1_RING_DISABLE_BMSK                                                        0x1000000
#define HWIO_TQM_R0_CLKGATE_CTRL_STATUS1_RING_DISABLE_SHFT                                                               24
#define HWIO_TQM_R0_CLKGATE_CTRL_STATUS_RING_DISABLE_BMSK                                                          0x800000
#define HWIO_TQM_R0_CLKGATE_CTRL_STATUS_RING_DISABLE_SHFT                                                                23
#define HWIO_TQM_R0_CLKGATE_CTRL_DESC_PTR_RING_DISABLE_BMSK                                                        0x400000
#define HWIO_TQM_R0_CLKGATE_CTRL_DESC_PTR_RING_DISABLE_SHFT                                                              22
#define HWIO_TQM_R0_CLKGATE_CTRL_SW_CMD1_RING_DISABLE_BMSK                                                         0x200000
#define HWIO_TQM_R0_CLKGATE_CTRL_SW_CMD1_RING_DISABLE_SHFT                                                               21
#define HWIO_TQM_R0_CLKGATE_CTRL_SW_CMD_RING_DISABLE_BMSK                                                          0x100000
#define HWIO_TQM_R0_CLKGATE_CTRL_SW_CMD_RING_DISABLE_SHFT                                                                20
#define HWIO_TQM_R0_CLKGATE_CTRL_MSDU_ENT3_RING_DISABLE_BMSK                                                        0x80000
#define HWIO_TQM_R0_CLKGATE_CTRL_MSDU_ENT3_RING_DISABLE_SHFT                                                             19
#define HWIO_TQM_R0_CLKGATE_CTRL_MSDU_ENT1_RING_DISABLE_BMSK                                                        0x40000
#define HWIO_TQM_R0_CLKGATE_CTRL_MSDU_ENT1_RING_DISABLE_SHFT                                                             18
#define HWIO_TQM_R0_CLKGATE_CTRL_UPDATE_QUEUE_DESC_CLK_GATE_DISABLE_BMSK                                            0x20000
#define HWIO_TQM_R0_CLKGATE_CTRL_UPDATE_QUEUE_DESC_CLK_GATE_DISABLE_SHFT                                                 17
#define HWIO_TQM_R0_CLKGATE_CTRL_CACHE_MEM_CLK_GATE_DISABLE_BMSK                                                    0x10000
#define HWIO_TQM_R0_CLKGATE_CTRL_CACHE_MEM_CLK_GATE_DISABLE_SHFT                                                         16
#define HWIO_TQM_R0_CLKGATE_CTRL_TLV_IF_CLK_GATE_DISABLE_BMSK                                                        0x8000
#define HWIO_TQM_R0_CLKGATE_CTRL_TLV_IF_CLK_GATE_DISABLE_SHFT                                                            15
#define HWIO_TQM_R0_CLKGATE_CTRL_AXI_IF_CLK_GATE_DISABLE_BMSK                                                        0x4000
#define HWIO_TQM_R0_CLKGATE_CTRL_AXI_IF_CLK_GATE_DISABLE_SHFT                                                            14
#define HWIO_TQM_R0_CLKGATE_CTRL_COMMON_LOGIC_CLK_GATE_DISABLE_BMSK                                                  0x2000
#define HWIO_TQM_R0_CLKGATE_CTRL_COMMON_LOGIC_CLK_GATE_DISABLE_SHFT                                                      13
#define HWIO_TQM_R0_CLKGATE_CTRL_FLUSH_UNBLK_CACHE_CLK_GATE_DISABLE_BMSK                                             0x1000
#define HWIO_TQM_R0_CLKGATE_CTRL_FLUSH_UNBLK_CACHE_CLK_GATE_DISABLE_SHFT                                                 12
#define HWIO_TQM_R0_CLKGATE_CTRL_GET_MPDU_HEAD_INFO_CLK_GATE_DISABLE_BMSK                                             0x800
#define HWIO_TQM_R0_CLKGATE_CTRL_GET_MPDU_HEAD_INFO_CLK_GATE_DISABLE_SHFT                                                11
#define HWIO_TQM_R0_CLKGATE_CTRL_REM_MSDU_CLK_GATE_DISABLE_BMSK                                                       0x400
#define HWIO_TQM_R0_CLKGATE_CTRL_REM_MSDU_CLK_GATE_DISABLE_SHFT                                                          10
#define HWIO_TQM_R0_CLKGATE_CTRL_REM_MPDU_CLK_GATE_DISABLE_BMSK                                                       0x200
#define HWIO_TQM_R0_CLKGATE_CTRL_REM_MPDU_CLK_GATE_DISABLE_SHFT                                                           9
#define HWIO_TQM_R0_CLKGATE_CTRL_GET_QUEUE_STATS_CLK_GATE_DISABLE_BMSK                                                0x100
#define HWIO_TQM_R0_CLKGATE_CTRL_GET_QUEUE_STATS_CLK_GATE_DISABLE_SHFT                                                    8
#define HWIO_TQM_R0_CLKGATE_CTRL_TX_MPDU_COUNT_CLK_GATE_DISABLE_BMSK                                                   0x80
#define HWIO_TQM_R0_CLKGATE_CTRL_TX_MPDU_COUNT_CLK_GATE_DISABLE_SHFT                                                      7
#define HWIO_TQM_R0_CLKGATE_CTRL_LIST_MPDU_CLK_GATE_DISABLE_BMSK                                                       0x40
#define HWIO_TQM_R0_CLKGATE_CTRL_LIST_MPDU_CLK_GATE_DISABLE_SHFT                                                          6
#define HWIO_TQM_R0_CLKGATE_CTRL_GEN_MPDU_CLK_GATE_DISABLE_BMSK                                                        0x20
#define HWIO_TQM_R0_CLKGATE_CTRL_GEN_MPDU_CLK_GATE_DISABLE_SHFT                                                           5
#define HWIO_TQM_R0_CLKGATE_CTRL_ADD_MSDU_CLK_GATE_DISABLE_BMSK                                                        0x10
#define HWIO_TQM_R0_CLKGATE_CTRL_ADD_MSDU_CLK_GATE_DISABLE_SHFT                                                           4
#define HWIO_TQM_R0_CLKGATE_CTRL_ARBITER_CLK_GATE_DISABLE_BMSK                                                          0x8
#define HWIO_TQM_R0_CLKGATE_CTRL_ARBITER_CLK_GATE_DISABLE_SHFT                                                            3
#define HWIO_TQM_R0_CLKGATE_CTRL_PREFETCH_CLK_GATE_DISABLE_BMSK                                                         0x4
#define HWIO_TQM_R0_CLKGATE_CTRL_PREFETCH_CLK_GATE_DISABLE_SHFT                                                           2
#define HWIO_TQM_R0_CLKGATE_CTRL_CACHE_CTL_CLK_GATE_DISABLE_BMSK                                                        0x2
#define HWIO_TQM_R0_CLKGATE_CTRL_CACHE_CTL_CLK_GATE_DISABLE_SHFT                                                          1
#define HWIO_TQM_R0_CLKGATE_CTRL_TOP_CLK_GATE_DISABLE_BMSK                                                              0x1
#define HWIO_TQM_R0_CLKGATE_CTRL_TOP_CLK_GATE_DISABLE_SHFT                                                                0

#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER0_ADDR(x)                                                             ((x) + 0x474)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER0_PHYS(x)                                                             ((x) + 0x474)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER0_OFFS                                                                (0x474)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER0_RMSK                                                                  0xffffff
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER0_POR                                                                 0x00000000
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER0_POR_RMSK                                                            0xffffffff
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER0_ATTR                                                                             0x3
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER0_IN(x)            \
                in_dword(HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER0_ADDR(x))
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER0_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER0_ADDR(x), m)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER0_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER0_ADDR(x),v)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER0_ADDR(x),m,v,HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER0_IN(x))
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER0_LINK_DESCRIPTOR_COUNTER_BMSK                                          0xffffff
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER0_LINK_DESCRIPTOR_COUNTER_SHFT                                                 0

#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER1_ADDR(x)                                                             ((x) + 0x478)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER1_PHYS(x)                                                             ((x) + 0x478)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER1_OFFS                                                                (0x478)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER1_RMSK                                                                  0xffffff
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER1_POR                                                                 0x00000000
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER1_POR_RMSK                                                            0xffffffff
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER1_ATTR                                                                             0x3
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER1_IN(x)            \
                in_dword(HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER1_ADDR(x))
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER1_ADDR(x), m)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER1_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER1_ADDR(x),v)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER1_ADDR(x),m,v,HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER1_IN(x))
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER1_LINK_DESCRIPTOR_COUNTER_BMSK                                          0xffffff
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER1_LINK_DESCRIPTOR_COUNTER_SHFT                                                 0

#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER2_ADDR(x)                                                             ((x) + 0x47c)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER2_PHYS(x)                                                             ((x) + 0x47c)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER2_OFFS                                                                (0x47c)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER2_RMSK                                                                  0xffffff
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER2_POR                                                                 0x00000000
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER2_POR_RMSK                                                            0xffffffff
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER2_ATTR                                                                             0x3
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER2_IN(x)            \
                in_dword(HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER2_ADDR(x))
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER2_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER2_ADDR(x), m)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER2_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER2_ADDR(x),v)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER2_ADDR(x),m,v,HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER2_IN(x))
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER2_LINK_DESCRIPTOR_COUNTER_BMSK                                          0xffffff
#define HWIO_TQM_R0_LINK_DESCRIPTOR_COUNTER2_LINK_DESCRIPTOR_COUNTER_SHFT                                                 0

#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD0_ADDR(x)                                                           ((x) + 0x480)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD0_PHYS(x)                                                           ((x) + 0x480)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD0_OFFS                                                              (0x480)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD0_RMSK                                                              0xf0ffffff
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD0_POR                                                               0x00ffffff
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD0_POR_RMSK                                                          0xffffffff
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD0_ATTR                                                                           0x3
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD0_IN(x)            \
                in_dword(HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD0_ADDR(x))
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD0_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD0_ADDR(x), m)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD0_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD0_ADDR(x),v)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD0_ADDR(x),m,v,HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD0_IN(x))
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD0_MESSAGE_ENABLE_BMSK                                               0x80000000
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD0_MESSAGE_ENABLE_SHFT                                                       31
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD0_MESSAGE_GENERATED_BMSK                                            0x40000000
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD0_MESSAGE_GENERATED_SHFT                                                    30
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD0_PAUSE_ENABLE_BMSK                                                 0x20000000
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD0_PAUSE_ENABLE_SHFT                                                         29
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD0_PAUSE_STATUS_BMSK                                                 0x10000000
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD0_PAUSE_STATUS_SHFT                                                         28
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD0_LINK_DESCRIPTOR_COUNTER0_THRESHOLD_BMSK                             0xffffff
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD0_LINK_DESCRIPTOR_COUNTER0_THRESHOLD_SHFT                                    0

#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD1_ADDR(x)                                                           ((x) + 0x484)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD1_PHYS(x)                                                           ((x) + 0x484)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD1_OFFS                                                              (0x484)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD1_RMSK                                                              0xf0ffffff
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD1_POR                                                               0x00000000
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD1_POR_RMSK                                                          0xffffffff
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD1_ATTR                                                                           0x3
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD1_IN(x)            \
                in_dword(HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD1_ADDR(x))
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD1_ADDR(x), m)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD1_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD1_ADDR(x),v)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD1_ADDR(x),m,v,HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD1_IN(x))
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD1_MESSAGE_ENABLE_BMSK                                               0x80000000
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD1_MESSAGE_ENABLE_SHFT                                                       31
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD1_MESSAGE_GENERATED_BMSK                                            0x40000000
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD1_MESSAGE_GENERATED_SHFT                                                    30
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD1_PAUSE_ENABLE_BMSK                                                 0x20000000
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD1_PAUSE_ENABLE_SHFT                                                         29
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD1_PAUSE_STATUS_BMSK                                                 0x10000000
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD1_PAUSE_STATUS_SHFT                                                         28
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD1_LINK_DESCRIPTOR_COUNTER1_THRESHOLD_BMSK                             0xffffff
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD1_LINK_DESCRIPTOR_COUNTER1_THRESHOLD_SHFT                                    0

#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD2_ADDR(x)                                                           ((x) + 0x488)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD2_PHYS(x)                                                           ((x) + 0x488)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD2_OFFS                                                              (0x488)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD2_RMSK                                                              0xf0ffffff
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD2_POR                                                               0x00000000
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD2_POR_RMSK                                                          0xffffffff
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD2_ATTR                                                                           0x3
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD2_IN(x)            \
                in_dword(HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD2_ADDR(x))
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD2_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD2_ADDR(x), m)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD2_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD2_ADDR(x),v)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD2_ADDR(x),m,v,HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD2_IN(x))
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD2_MESSAGE_ENABLE_BMSK                                               0x80000000
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD2_MESSAGE_ENABLE_SHFT                                                       31
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD2_MESSAGE_GENERATED_BMSK                                            0x40000000
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD2_MESSAGE_GENERATED_SHFT                                                    30
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD2_PAUSE_ENABLE_BMSK                                                 0x20000000
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD2_PAUSE_ENABLE_SHFT                                                         29
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD2_PAUSE_STATUS_BMSK                                                 0x10000000
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD2_PAUSE_STATUS_SHFT                                                         28
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD2_LINK_DESCRIPTOR_COUNTER2_THRESHOLD_BMSK                             0xffffff
#define HWIO_TQM_R0_LINK_DESCRIPTOR_THRESHOLD2_LINK_DESCRIPTOR_COUNTER2_THRESHOLD_SHFT                                    0

#define HWIO_TQM_R0_AGGREGATE_LINK_DESCRIPTOR_THRESHOLD_ADDR(x)                                                  ((x) + 0x48c)
#define HWIO_TQM_R0_AGGREGATE_LINK_DESCRIPTOR_THRESHOLD_PHYS(x)                                                  ((x) + 0x48c)
#define HWIO_TQM_R0_AGGREGATE_LINK_DESCRIPTOR_THRESHOLD_OFFS                                                     (0x48c)
#define HWIO_TQM_R0_AGGREGATE_LINK_DESCRIPTOR_THRESHOLD_RMSK                                                     0xf3ffffff
#define HWIO_TQM_R0_AGGREGATE_LINK_DESCRIPTOR_THRESHOLD_POR                                                      0x00000000
#define HWIO_TQM_R0_AGGREGATE_LINK_DESCRIPTOR_THRESHOLD_POR_RMSK                                                 0xffffffff
#define HWIO_TQM_R0_AGGREGATE_LINK_DESCRIPTOR_THRESHOLD_ATTR                                                                  0x3
#define HWIO_TQM_R0_AGGREGATE_LINK_DESCRIPTOR_THRESHOLD_IN(x)            \
                in_dword(HWIO_TQM_R0_AGGREGATE_LINK_DESCRIPTOR_THRESHOLD_ADDR(x))
#define HWIO_TQM_R0_AGGREGATE_LINK_DESCRIPTOR_THRESHOLD_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_AGGREGATE_LINK_DESCRIPTOR_THRESHOLD_ADDR(x), m)
#define HWIO_TQM_R0_AGGREGATE_LINK_DESCRIPTOR_THRESHOLD_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_AGGREGATE_LINK_DESCRIPTOR_THRESHOLD_ADDR(x),v)
#define HWIO_TQM_R0_AGGREGATE_LINK_DESCRIPTOR_THRESHOLD_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_AGGREGATE_LINK_DESCRIPTOR_THRESHOLD_ADDR(x),m,v,HWIO_TQM_R0_AGGREGATE_LINK_DESCRIPTOR_THRESHOLD_IN(x))
#define HWIO_TQM_R0_AGGREGATE_LINK_DESCRIPTOR_THRESHOLD_MESSAGE_ENABLE_BMSK                                      0x80000000
#define HWIO_TQM_R0_AGGREGATE_LINK_DESCRIPTOR_THRESHOLD_MESSAGE_ENABLE_SHFT                                              31
#define HWIO_TQM_R0_AGGREGATE_LINK_DESCRIPTOR_THRESHOLD_MESSAGE_GENERATED_BMSK                                   0x40000000
#define HWIO_TQM_R0_AGGREGATE_LINK_DESCRIPTOR_THRESHOLD_MESSAGE_GENERATED_SHFT                                           30
#define HWIO_TQM_R0_AGGREGATE_LINK_DESCRIPTOR_THRESHOLD_PAUSE_ENABLE_BMSK                                        0x20000000
#define HWIO_TQM_R0_AGGREGATE_LINK_DESCRIPTOR_THRESHOLD_PAUSE_ENABLE_SHFT                                                29
#define HWIO_TQM_R0_AGGREGATE_LINK_DESCRIPTOR_THRESHOLD_PAUSE_STATUS_BMSK                                        0x10000000
#define HWIO_TQM_R0_AGGREGATE_LINK_DESCRIPTOR_THRESHOLD_PAUSE_STATUS_SHFT                                                28
#define HWIO_TQM_R0_AGGREGATE_LINK_DESCRIPTOR_THRESHOLD_LINK_DESCRIPTOR_COUNTER_SUM_THRESHOLD_BMSK                0x3ffffff
#define HWIO_TQM_R0_AGGREGATE_LINK_DESCRIPTOR_THRESHOLD_LINK_DESCRIPTOR_COUNTER_SUM_THRESHOLD_SHFT                        0

#define HWIO_TQM_R0_LINK_DESCRIPTOR_PRIORITY_CONTROL_ADDR(x)                                                     ((x) + 0x490)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_PRIORITY_CONTROL_PHYS(x)                                                     ((x) + 0x490)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_PRIORITY_CONTROL_OFFS                                                        (0x490)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_PRIORITY_CONTROL_RMSK                                                        0xa3ff17ff
#define HWIO_TQM_R0_LINK_DESCRIPTOR_PRIORITY_CONTROL_POR                                                         0x00ff0000
#define HWIO_TQM_R0_LINK_DESCRIPTOR_PRIORITY_CONTROL_POR_RMSK                                                    0xffffffff
#define HWIO_TQM_R0_LINK_DESCRIPTOR_PRIORITY_CONTROL_ATTR                                                                     0x3
#define HWIO_TQM_R0_LINK_DESCRIPTOR_PRIORITY_CONTROL_IN(x)            \
                in_dword(HWIO_TQM_R0_LINK_DESCRIPTOR_PRIORITY_CONTROL_ADDR(x))
#define HWIO_TQM_R0_LINK_DESCRIPTOR_PRIORITY_CONTROL_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_LINK_DESCRIPTOR_PRIORITY_CONTROL_ADDR(x), m)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_PRIORITY_CONTROL_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_LINK_DESCRIPTOR_PRIORITY_CONTROL_ADDR(x),v)
#define HWIO_TQM_R0_LINK_DESCRIPTOR_PRIORITY_CONTROL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_LINK_DESCRIPTOR_PRIORITY_CONTROL_ADDR(x),m,v,HWIO_TQM_R0_LINK_DESCRIPTOR_PRIORITY_CONTROL_IN(x))
#define HWIO_TQM_R0_LINK_DESCRIPTOR_PRIORITY_CONTROL_BLOCK_STATUS_FW2TQM_BMSK                                    0x80000000
#define HWIO_TQM_R0_LINK_DESCRIPTOR_PRIORITY_CONTROL_BLOCK_STATUS_FW2TQM_SHFT                                            31
#define HWIO_TQM_R0_LINK_DESCRIPTOR_PRIORITY_CONTROL_BLOCK_STATUS_TCL2TQM_BMSK                                   0x20000000
#define HWIO_TQM_R0_LINK_DESCRIPTOR_PRIORITY_CONTROL_BLOCK_STATUS_TCL2TQM_SHFT                                           29
#define HWIO_TQM_R0_LINK_DESCRIPTOR_PRIORITY_CONTROL_UNPAUSE_LINK_DESC_THRESHOLD_BMSK                             0x3ff0000
#define HWIO_TQM_R0_LINK_DESCRIPTOR_PRIORITY_CONTROL_UNPAUSE_LINK_DESC_THRESHOLD_SHFT                                    16
#define HWIO_TQM_R0_LINK_DESCRIPTOR_PRIORITY_CONTROL_BLOCK_FW2TQM_BMSK                                               0x1000
#define HWIO_TQM_R0_LINK_DESCRIPTOR_PRIORITY_CONTROL_BLOCK_FW2TQM_SHFT                                                   12
#define HWIO_TQM_R0_LINK_DESCRIPTOR_PRIORITY_CONTROL_BLOCK_TCL2TQM_BMSK                                               0x400
#define HWIO_TQM_R0_LINK_DESCRIPTOR_PRIORITY_CONTROL_BLOCK_TCL2TQM_SHFT                                                  10
#define HWIO_TQM_R0_LINK_DESCRIPTOR_PRIORITY_CONTROL_LINK_DESC_THRESHOLD_BMSK                                         0x3ff
#define HWIO_TQM_R0_LINK_DESCRIPTOR_PRIORITY_CONTROL_LINK_DESC_THRESHOLD_SHFT                                             0

#define HWIO_TQM_R0_DESC_PTR_RELEASE_ADDR(x)                                                                     ((x) + 0x494)
#define HWIO_TQM_R0_DESC_PTR_RELEASE_PHYS(x)                                                                     ((x) + 0x494)
#define HWIO_TQM_R0_DESC_PTR_RELEASE_OFFS                                                                        (0x494)
#define HWIO_TQM_R0_DESC_PTR_RELEASE_RMSK                                                                            0xffff
#define HWIO_TQM_R0_DESC_PTR_RELEASE_POR                                                                         0x00001740
#define HWIO_TQM_R0_DESC_PTR_RELEASE_POR_RMSK                                                                    0xffffffff
#define HWIO_TQM_R0_DESC_PTR_RELEASE_ATTR                                                                                     0x3
#define HWIO_TQM_R0_DESC_PTR_RELEASE_IN(x)            \
                in_dword(HWIO_TQM_R0_DESC_PTR_RELEASE_ADDR(x))
#define HWIO_TQM_R0_DESC_PTR_RELEASE_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_DESC_PTR_RELEASE_ADDR(x), m)
#define HWIO_TQM_R0_DESC_PTR_RELEASE_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_DESC_PTR_RELEASE_ADDR(x),v)
#define HWIO_TQM_R0_DESC_PTR_RELEASE_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_DESC_PTR_RELEASE_ADDR(x),m,v,HWIO_TQM_R0_DESC_PTR_RELEASE_IN(x))
#define HWIO_TQM_R0_DESC_PTR_RELEASE_THRESH_BMSK                                                                     0xff00
#define HWIO_TQM_R0_DESC_PTR_RELEASE_THRESH_SHFT                                                                          8
#define HWIO_TQM_R0_DESC_PTR_RELEASE_TIMEOUT_BMSK                                                                      0xff
#define HWIO_TQM_R0_DESC_PTR_RELEASE_TIMEOUT_SHFT                                                                         0

#define HWIO_TQM_R0_FLOW_QUEUE_DESC_CACHE_LINE_STATUS_ADDR(x)                                                    ((x) + 0x498)
#define HWIO_TQM_R0_FLOW_QUEUE_DESC_CACHE_LINE_STATUS_PHYS(x)                                                    ((x) + 0x498)
#define HWIO_TQM_R0_FLOW_QUEUE_DESC_CACHE_LINE_STATUS_OFFS                                                       (0x498)
#define HWIO_TQM_R0_FLOW_QUEUE_DESC_CACHE_LINE_STATUS_RMSK                                                           0xffff
#define HWIO_TQM_R0_FLOW_QUEUE_DESC_CACHE_LINE_STATUS_POR                                                        0x00000000
#define HWIO_TQM_R0_FLOW_QUEUE_DESC_CACHE_LINE_STATUS_POR_RMSK                                                   0xffffffff
#define HWIO_TQM_R0_FLOW_QUEUE_DESC_CACHE_LINE_STATUS_ATTR                                                                    0x1
#define HWIO_TQM_R0_FLOW_QUEUE_DESC_CACHE_LINE_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_FLOW_QUEUE_DESC_CACHE_LINE_STATUS_ADDR(x))
#define HWIO_TQM_R0_FLOW_QUEUE_DESC_CACHE_LINE_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_FLOW_QUEUE_DESC_CACHE_LINE_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_FLOW_QUEUE_DESC_CACHE_LINE_STATUS_LINE_ADDRESS_BMSK                                              0xffe0
#define HWIO_TQM_R0_FLOW_QUEUE_DESC_CACHE_LINE_STATUS_LINE_ADDRESS_SHFT                                                   5
#define HWIO_TQM_R0_FLOW_QUEUE_DESC_CACHE_LINE_STATUS_LOCK_ID_BMSK                                                     0x1e
#define HWIO_TQM_R0_FLOW_QUEUE_DESC_CACHE_LINE_STATUS_LOCK_ID_SHFT                                                        1
#define HWIO_TQM_R0_FLOW_QUEUE_DESC_CACHE_LINE_STATUS_IS_LOCKED_BMSK                                                    0x1
#define HWIO_TQM_R0_FLOW_QUEUE_DESC_CACHE_LINE_STATUS_IS_LOCKED_SHFT                                                      0

#define HWIO_TQM_R0_FLOW_QUEUE_DESC_ADD_MSDU_CACHE_LINE_STATUS_ADDR(x)                                           ((x) + 0x49c)
#define HWIO_TQM_R0_FLOW_QUEUE_DESC_ADD_MSDU_CACHE_LINE_STATUS_PHYS(x)                                           ((x) + 0x49c)
#define HWIO_TQM_R0_FLOW_QUEUE_DESC_ADD_MSDU_CACHE_LINE_STATUS_OFFS                                              (0x49c)
#define HWIO_TQM_R0_FLOW_QUEUE_DESC_ADD_MSDU_CACHE_LINE_STATUS_RMSK                                                  0xffff
#define HWIO_TQM_R0_FLOW_QUEUE_DESC_ADD_MSDU_CACHE_LINE_STATUS_POR                                               0x00000000
#define HWIO_TQM_R0_FLOW_QUEUE_DESC_ADD_MSDU_CACHE_LINE_STATUS_POR_RMSK                                          0xffffffff
#define HWIO_TQM_R0_FLOW_QUEUE_DESC_ADD_MSDU_CACHE_LINE_STATUS_ATTR                                                           0x1
#define HWIO_TQM_R0_FLOW_QUEUE_DESC_ADD_MSDU_CACHE_LINE_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_FLOW_QUEUE_DESC_ADD_MSDU_CACHE_LINE_STATUS_ADDR(x))
#define HWIO_TQM_R0_FLOW_QUEUE_DESC_ADD_MSDU_CACHE_LINE_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_FLOW_QUEUE_DESC_ADD_MSDU_CACHE_LINE_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_FLOW_QUEUE_DESC_ADD_MSDU_CACHE_LINE_STATUS_LINE_ADDRESS_BMSK                                     0xfffe
#define HWIO_TQM_R0_FLOW_QUEUE_DESC_ADD_MSDU_CACHE_LINE_STATUS_LINE_ADDRESS_SHFT                                          1
#define HWIO_TQM_R0_FLOW_QUEUE_DESC_ADD_MSDU_CACHE_LINE_STATUS_IS_LOCKED_BMSK                                           0x1
#define HWIO_TQM_R0_FLOW_QUEUE_DESC_ADD_MSDU_CACHE_LINE_STATUS_IS_LOCKED_SHFT                                             0

#define HWIO_TQM_R0_MPDU_QUEUE_HEAD_DESC_CACHE_LINE_STATUS_ADDR(x)                                               ((x) + 0x4a0)
#define HWIO_TQM_R0_MPDU_QUEUE_HEAD_DESC_CACHE_LINE_STATUS_PHYS(x)                                               ((x) + 0x4a0)
#define HWIO_TQM_R0_MPDU_QUEUE_HEAD_DESC_CACHE_LINE_STATUS_OFFS                                                  (0x4a0)
#define HWIO_TQM_R0_MPDU_QUEUE_HEAD_DESC_CACHE_LINE_STATUS_RMSK                                                      0xffff
#define HWIO_TQM_R0_MPDU_QUEUE_HEAD_DESC_CACHE_LINE_STATUS_POR                                                   0x00000000
#define HWIO_TQM_R0_MPDU_QUEUE_HEAD_DESC_CACHE_LINE_STATUS_POR_RMSK                                              0xffffffff
#define HWIO_TQM_R0_MPDU_QUEUE_HEAD_DESC_CACHE_LINE_STATUS_ATTR                                                               0x1
#define HWIO_TQM_R0_MPDU_QUEUE_HEAD_DESC_CACHE_LINE_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_MPDU_QUEUE_HEAD_DESC_CACHE_LINE_STATUS_ADDR(x))
#define HWIO_TQM_R0_MPDU_QUEUE_HEAD_DESC_CACHE_LINE_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_MPDU_QUEUE_HEAD_DESC_CACHE_LINE_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_MPDU_QUEUE_HEAD_DESC_CACHE_LINE_STATUS_LINE_ADDRESS_BMSK                                         0xffe0
#define HWIO_TQM_R0_MPDU_QUEUE_HEAD_DESC_CACHE_LINE_STATUS_LINE_ADDRESS_SHFT                                              5
#define HWIO_TQM_R0_MPDU_QUEUE_HEAD_DESC_CACHE_LINE_STATUS_LOCK_ID_BMSK                                                0x1e
#define HWIO_TQM_R0_MPDU_QUEUE_HEAD_DESC_CACHE_LINE_STATUS_LOCK_ID_SHFT                                                   1
#define HWIO_TQM_R0_MPDU_QUEUE_HEAD_DESC_CACHE_LINE_STATUS_IS_LOCKED_BMSK                                               0x1
#define HWIO_TQM_R0_MPDU_QUEUE_HEAD_DESC_CACHE_LINE_STATUS_IS_LOCKED_SHFT                                                 0

#define HWIO_TQM_R0_MSDU_LINK_DESC_CACHE_LINE_STATUS_ADDR(x)                                                     ((x) + 0x4a4)
#define HWIO_TQM_R0_MSDU_LINK_DESC_CACHE_LINE_STATUS_PHYS(x)                                                     ((x) + 0x4a4)
#define HWIO_TQM_R0_MSDU_LINK_DESC_CACHE_LINE_STATUS_OFFS                                                        (0x4a4)
#define HWIO_TQM_R0_MSDU_LINK_DESC_CACHE_LINE_STATUS_RMSK                                                            0xffff
#define HWIO_TQM_R0_MSDU_LINK_DESC_CACHE_LINE_STATUS_POR                                                         0x00000000
#define HWIO_TQM_R0_MSDU_LINK_DESC_CACHE_LINE_STATUS_POR_RMSK                                                    0xffffffff
#define HWIO_TQM_R0_MSDU_LINK_DESC_CACHE_LINE_STATUS_ATTR                                                                     0x1
#define HWIO_TQM_R0_MSDU_LINK_DESC_CACHE_LINE_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_MSDU_LINK_DESC_CACHE_LINE_STATUS_ADDR(x))
#define HWIO_TQM_R0_MSDU_LINK_DESC_CACHE_LINE_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_MSDU_LINK_DESC_CACHE_LINE_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_MSDU_LINK_DESC_CACHE_LINE_STATUS_LINE_ADDRESS_BMSK                                               0xffe0
#define HWIO_TQM_R0_MSDU_LINK_DESC_CACHE_LINE_STATUS_LINE_ADDRESS_SHFT                                                    5
#define HWIO_TQM_R0_MSDU_LINK_DESC_CACHE_LINE_STATUS_LOCK_ID_BMSK                                                      0x1e
#define HWIO_TQM_R0_MSDU_LINK_DESC_CACHE_LINE_STATUS_LOCK_ID_SHFT                                                         1
#define HWIO_TQM_R0_MSDU_LINK_DESC_CACHE_LINE_STATUS_IS_LOCKED_BMSK                                                     0x1
#define HWIO_TQM_R0_MSDU_LINK_DESC_CACHE_LINE_STATUS_IS_LOCKED_SHFT                                                       0

#define HWIO_TQM_R0_MSDU_LINK_DESC_ADD_MSDU_CACHE_LINE_STATUS_ADDR(x)                                            ((x) + 0x4a8)
#define HWIO_TQM_R0_MSDU_LINK_DESC_ADD_MSDU_CACHE_LINE_STATUS_PHYS(x)                                            ((x) + 0x4a8)
#define HWIO_TQM_R0_MSDU_LINK_DESC_ADD_MSDU_CACHE_LINE_STATUS_OFFS                                               (0x4a8)
#define HWIO_TQM_R0_MSDU_LINK_DESC_ADD_MSDU_CACHE_LINE_STATUS_RMSK                                                   0xffe1
#define HWIO_TQM_R0_MSDU_LINK_DESC_ADD_MSDU_CACHE_LINE_STATUS_POR                                                0x00000000
#define HWIO_TQM_R0_MSDU_LINK_DESC_ADD_MSDU_CACHE_LINE_STATUS_POR_RMSK                                           0xffffffff
#define HWIO_TQM_R0_MSDU_LINK_DESC_ADD_MSDU_CACHE_LINE_STATUS_ATTR                                                            0x1
#define HWIO_TQM_R0_MSDU_LINK_DESC_ADD_MSDU_CACHE_LINE_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_MSDU_LINK_DESC_ADD_MSDU_CACHE_LINE_STATUS_ADDR(x))
#define HWIO_TQM_R0_MSDU_LINK_DESC_ADD_MSDU_CACHE_LINE_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_MSDU_LINK_DESC_ADD_MSDU_CACHE_LINE_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_MSDU_LINK_DESC_ADD_MSDU_CACHE_LINE_STATUS_LINE_ADDRESS_BMSK                                      0xffe0
#define HWIO_TQM_R0_MSDU_LINK_DESC_ADD_MSDU_CACHE_LINE_STATUS_LINE_ADDRESS_SHFT                                           5
#define HWIO_TQM_R0_MSDU_LINK_DESC_ADD_MSDU_CACHE_LINE_STATUS_IS_LOCKED_BMSK                                            0x1
#define HWIO_TQM_R0_MSDU_LINK_DESC_ADD_MSDU_CACHE_LINE_STATUS_IS_LOCKED_SHFT                                              0

#define HWIO_TQM_R0_MPDU_LINK_DESC_0_DESC_CACHE_LINE_STATUS_ADDR(x)                                              ((x) + 0x4ac)
#define HWIO_TQM_R0_MPDU_LINK_DESC_0_DESC_CACHE_LINE_STATUS_PHYS(x)                                              ((x) + 0x4ac)
#define HWIO_TQM_R0_MPDU_LINK_DESC_0_DESC_CACHE_LINE_STATUS_OFFS                                                 (0x4ac)
#define HWIO_TQM_R0_MPDU_LINK_DESC_0_DESC_CACHE_LINE_STATUS_RMSK                                                     0xffff
#define HWIO_TQM_R0_MPDU_LINK_DESC_0_DESC_CACHE_LINE_STATUS_POR                                                  0x00000000
#define HWIO_TQM_R0_MPDU_LINK_DESC_0_DESC_CACHE_LINE_STATUS_POR_RMSK                                             0xffffffff
#define HWIO_TQM_R0_MPDU_LINK_DESC_0_DESC_CACHE_LINE_STATUS_ATTR                                                              0x1
#define HWIO_TQM_R0_MPDU_LINK_DESC_0_DESC_CACHE_LINE_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_MPDU_LINK_DESC_0_DESC_CACHE_LINE_STATUS_ADDR(x))
#define HWIO_TQM_R0_MPDU_LINK_DESC_0_DESC_CACHE_LINE_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_MPDU_LINK_DESC_0_DESC_CACHE_LINE_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_MPDU_LINK_DESC_0_DESC_CACHE_LINE_STATUS_LINE_ADDRESS_BMSK                                        0xffe0
#define HWIO_TQM_R0_MPDU_LINK_DESC_0_DESC_CACHE_LINE_STATUS_LINE_ADDRESS_SHFT                                             5
#define HWIO_TQM_R0_MPDU_LINK_DESC_0_DESC_CACHE_LINE_STATUS_LOCK_ID_BMSK                                               0x1e
#define HWIO_TQM_R0_MPDU_LINK_DESC_0_DESC_CACHE_LINE_STATUS_LOCK_ID_SHFT                                                  1
#define HWIO_TQM_R0_MPDU_LINK_DESC_0_DESC_CACHE_LINE_STATUS_IS_LOCKED_BMSK                                              0x1
#define HWIO_TQM_R0_MPDU_LINK_DESC_0_DESC_CACHE_LINE_STATUS_IS_LOCKED_SHFT                                                0

#define HWIO_TQM_R0_MPDU_LINK_DESC_1_CACHE_LINE_STATUS_ADDR(x)                                                   ((x) + 0x4b0)
#define HWIO_TQM_R0_MPDU_LINK_DESC_1_CACHE_LINE_STATUS_PHYS(x)                                                   ((x) + 0x4b0)
#define HWIO_TQM_R0_MPDU_LINK_DESC_1_CACHE_LINE_STATUS_OFFS                                                      (0x4b0)
#define HWIO_TQM_R0_MPDU_LINK_DESC_1_CACHE_LINE_STATUS_RMSK                                                          0xffff
#define HWIO_TQM_R0_MPDU_LINK_DESC_1_CACHE_LINE_STATUS_POR                                                       0x00000000
#define HWIO_TQM_R0_MPDU_LINK_DESC_1_CACHE_LINE_STATUS_POR_RMSK                                                  0xffffffff
#define HWIO_TQM_R0_MPDU_LINK_DESC_1_CACHE_LINE_STATUS_ATTR                                                                   0x1
#define HWIO_TQM_R0_MPDU_LINK_DESC_1_CACHE_LINE_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_MPDU_LINK_DESC_1_CACHE_LINE_STATUS_ADDR(x))
#define HWIO_TQM_R0_MPDU_LINK_DESC_1_CACHE_LINE_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_MPDU_LINK_DESC_1_CACHE_LINE_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_MPDU_LINK_DESC_1_CACHE_LINE_STATUS_LINE_ADDRESS_BMSK                                             0xffe0
#define HWIO_TQM_R0_MPDU_LINK_DESC_1_CACHE_LINE_STATUS_LINE_ADDRESS_SHFT                                                  5
#define HWIO_TQM_R0_MPDU_LINK_DESC_1_CACHE_LINE_STATUS_LOCK_ID_BMSK                                                    0x1e
#define HWIO_TQM_R0_MPDU_LINK_DESC_1_CACHE_LINE_STATUS_LOCK_ID_SHFT                                                       1
#define HWIO_TQM_R0_MPDU_LINK_DESC_1_CACHE_LINE_STATUS_IS_LOCKED_BMSK                                                   0x1
#define HWIO_TQM_R0_MPDU_LINK_DESC_1_CACHE_LINE_STATUS_IS_LOCKED_SHFT                                                     0

#define HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_0_CACHE_LINE_STATUS_ADDR(x)                                              ((x) + 0x4b4)
#define HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_0_CACHE_LINE_STATUS_PHYS(x)                                              ((x) + 0x4b4)
#define HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_0_CACHE_LINE_STATUS_OFFS                                                 (0x4b4)
#define HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_0_CACHE_LINE_STATUS_RMSK                                                     0xffff
#define HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_0_CACHE_LINE_STATUS_POR                                                  0x00000000
#define HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_0_CACHE_LINE_STATUS_POR_RMSK                                             0xffffffff
#define HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_0_CACHE_LINE_STATUS_ATTR                                                              0x1
#define HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_0_CACHE_LINE_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_0_CACHE_LINE_STATUS_ADDR(x))
#define HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_0_CACHE_LINE_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_0_CACHE_LINE_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_0_CACHE_LINE_STATUS_LINE_ADDRESS_BMSK                                        0xffe0
#define HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_0_CACHE_LINE_STATUS_LINE_ADDRESS_SHFT                                             5
#define HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_0_CACHE_LINE_STATUS_LOCK_ID_BMSK                                               0x1e
#define HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_0_CACHE_LINE_STATUS_LOCK_ID_SHFT                                                  1
#define HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_0_CACHE_LINE_STATUS_IS_LOCKED_BMSK                                              0x1
#define HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_0_CACHE_LINE_STATUS_IS_LOCKED_SHFT                                                0

#define HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_1_CACHE_LINE_STATUS_ADDR(x)                                              ((x) + 0x4b8)
#define HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_1_CACHE_LINE_STATUS_PHYS(x)                                              ((x) + 0x4b8)
#define HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_1_CACHE_LINE_STATUS_OFFS                                                 (0x4b8)
#define HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_1_CACHE_LINE_STATUS_RMSK                                                     0xffff
#define HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_1_CACHE_LINE_STATUS_POR                                                  0x00000000
#define HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_1_CACHE_LINE_STATUS_POR_RMSK                                             0xffffffff
#define HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_1_CACHE_LINE_STATUS_ATTR                                                              0x1
#define HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_1_CACHE_LINE_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_1_CACHE_LINE_STATUS_ADDR(x))
#define HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_1_CACHE_LINE_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_1_CACHE_LINE_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_1_CACHE_LINE_STATUS_LINE_ADDRESS_BMSK                                        0xffe0
#define HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_1_CACHE_LINE_STATUS_LINE_ADDRESS_SHFT                                             5
#define HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_1_CACHE_LINE_STATUS_LOCK_ID_BMSK                                               0x1e
#define HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_1_CACHE_LINE_STATUS_LOCK_ID_SHFT                                                  1
#define HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_1_CACHE_LINE_STATUS_IS_LOCKED_BMSK                                              0x1
#define HWIO_TQM_R0_MPDU_QUEUE_EXT_DESC_1_CACHE_LINE_STATUS_IS_LOCKED_SHFT                                                0

#define HWIO_TQM_R0_ERROR_STATUS_1_ADDR(x)                                                                       ((x) + 0x4bc)
#define HWIO_TQM_R0_ERROR_STATUS_1_PHYS(x)                                                                       ((x) + 0x4bc)
#define HWIO_TQM_R0_ERROR_STATUS_1_OFFS                                                                          (0x4bc)
#define HWIO_TQM_R0_ERROR_STATUS_1_RMSK                                                                              0x3fff
#define HWIO_TQM_R0_ERROR_STATUS_1_POR                                                                           0x00000000
#define HWIO_TQM_R0_ERROR_STATUS_1_POR_RMSK                                                                      0xffffffff
#define HWIO_TQM_R0_ERROR_STATUS_1_ATTR                                                                                       0x0
#define HWIO_TQM_R0_ERROR_STATUS_1_IN(x)            \
                in_dword(HWIO_TQM_R0_ERROR_STATUS_1_ADDR(x))
#define HWIO_TQM_R0_ERROR_STATUS_1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_ERROR_STATUS_1_ADDR(x), m)
#define HWIO_TQM_R0_ERROR_STATUS_1_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_ERROR_STATUS_1_ADDR(x),v)
#define HWIO_TQM_R0_ERROR_STATUS_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_ERROR_STATUS_1_ADDR(x),m,v,HWIO_TQM_R0_ERROR_STATUS_1_IN(x))
#define HWIO_TQM_R0_ERROR_STATUS_1_SW_PROG_ERROR_TQM2TQM_IN2_RING_BMSK                                               0x2000
#define HWIO_TQM_R0_ERROR_STATUS_1_SW_PROG_ERROR_TQM2TQM_IN2_RING_SHFT                                                   13
#define HWIO_TQM_R0_ERROR_STATUS_1_SW_PROG_ERROR_TQM2TQM_IN1_RING_BMSK                                               0x1000
#define HWIO_TQM_R0_ERROR_STATUS_1_SW_PROG_ERROR_TQM2TQM_IN1_RING_SHFT                                                   12
#define HWIO_TQM_R0_ERROR_STATUS_1_SW_PROG_ERROR_SW_CMD_1_RING_BMSK                                                   0x800
#define HWIO_TQM_R0_ERROR_STATUS_1_SW_PROG_ERROR_SW_CMD_1_RING_SHFT                                                      11
#define HWIO_TQM_R0_ERROR_STATUS_1_SW_PROG_ERROR_SW_CMD_0_RING_BMSK                                                   0x400
#define HWIO_TQM_R0_ERROR_STATUS_1_SW_PROG_ERROR_SW_CMD_0_RING_SHFT                                                      10
#define HWIO_TQM_R0_ERROR_STATUS_1_SW_PROG_ERROR_UPDATE_TX_MPDU_COUNT_BMSK                                            0x200
#define HWIO_TQM_R0_ERROR_STATUS_1_SW_PROG_ERROR_UPDATE_TX_MPDU_COUNT_SHFT                                                9
#define HWIO_TQM_R0_ERROR_STATUS_1_SW_PROG_ERROR_REM_MSDU_BMSK                                                        0x100
#define HWIO_TQM_R0_ERROR_STATUS_1_SW_PROG_ERROR_REM_MSDU_SHFT                                                            8
#define HWIO_TQM_R0_ERROR_STATUS_1_SW_PROG_ERROR_ACKED_MPDU_BMSK                                                       0x80
#define HWIO_TQM_R0_ERROR_STATUS_1_SW_PROG_ERROR_ACKED_MPDU_SHFT                                                          7
#define HWIO_TQM_R0_ERROR_STATUS_1_SW_PROG_ERROR_REM_MPDU_BMSK                                                         0x40
#define HWIO_TQM_R0_ERROR_STATUS_1_SW_PROG_ERROR_REM_MPDU_SHFT                                                            6
#define HWIO_TQM_R0_ERROR_STATUS_1_SW_PROG_ERROR_LIST_MPDU_BMSK                                                        0x20
#define HWIO_TQM_R0_ERROR_STATUS_1_SW_PROG_ERROR_LIST_MPDU_SHFT                                                           5
#define HWIO_TQM_R0_ERROR_STATUS_1_SW_PROG_ERROR_GET_MPDU_QUEUE_STATS_BMSK                                             0x10
#define HWIO_TQM_R0_ERROR_STATUS_1_SW_PROG_ERROR_GET_MPDU_QUEUE_STATS_SHFT                                                4
#define HWIO_TQM_R0_ERROR_STATUS_1_SW_PROG_ERROR_GET_FLOW_QUEUE_STATS_BMSK                                              0x8
#define HWIO_TQM_R0_ERROR_STATUS_1_SW_PROG_ERROR_GET_FLOW_QUEUE_STATS_SHFT                                                3
#define HWIO_TQM_R0_ERROR_STATUS_1_SW_PROG_ERROR_GET_MPDU_HEAD_INFO_BMSK                                                0x4
#define HWIO_TQM_R0_ERROR_STATUS_1_SW_PROG_ERROR_GET_MPDU_HEAD_INFO_SHFT                                                  2
#define HWIO_TQM_R0_ERROR_STATUS_1_SW_PROG_ERROR_GEN_MPDU_BMSK                                                          0x2
#define HWIO_TQM_R0_ERROR_STATUS_1_SW_PROG_ERROR_GEN_MPDU_SHFT                                                            1
#define HWIO_TQM_R0_ERROR_STATUS_1_SW_PROG_ERROR_ADD_MSDU_BMSK                                                          0x1
#define HWIO_TQM_R0_ERROR_STATUS_1_SW_PROG_ERROR_ADD_MSDU_SHFT                                                            0

#define HWIO_TQM_R0_TLV_IF_ADDR(x)                                                                               ((x) + 0x4c0)
#define HWIO_TQM_R0_TLV_IF_PHYS(x)                                                                               ((x) + 0x4c0)
#define HWIO_TQM_R0_TLV_IF_OFFS                                                                                  (0x4c0)
#define HWIO_TQM_R0_TLV_IF_RMSK                                                                                         0x7
#define HWIO_TQM_R0_TLV_IF_POR                                                                                   0x00000000
#define HWIO_TQM_R0_TLV_IF_POR_RMSK                                                                              0xffffffff
#define HWIO_TQM_R0_TLV_IF_ATTR                                                                                               0x3
#define HWIO_TQM_R0_TLV_IF_IN(x)            \
                in_dword(HWIO_TQM_R0_TLV_IF_ADDR(x))
#define HWIO_TQM_R0_TLV_IF_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TLV_IF_ADDR(x), m)
#define HWIO_TQM_R0_TLV_IF_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TLV_IF_ADDR(x),v)
#define HWIO_TQM_R0_TLV_IF_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TLV_IF_ADDR(x),m,v,HWIO_TQM_R0_TLV_IF_IN(x))
#define HWIO_TQM_R0_TLV_IF_ASYNC_GP_FIFO_2_SYNC_RESET_BMSK                                                              0x4
#define HWIO_TQM_R0_TLV_IF_ASYNC_GP_FIFO_2_SYNC_RESET_SHFT                                                                2
#define HWIO_TQM_R0_TLV_IF_ASYNC_GP_FIFO_1_SYNC_RESET_BMSK                                                              0x2
#define HWIO_TQM_R0_TLV_IF_ASYNC_GP_FIFO_1_SYNC_RESET_SHFT                                                                1
#define HWIO_TQM_R0_TLV_IF_ASYNC_GP_FIFO_0_SYNC_RESET_BMSK                                                              0x1
#define HWIO_TQM_R0_TLV_IF_ASYNC_GP_FIFO_0_SYNC_RESET_SHFT                                                                0

#define HWIO_TQM_R0_TQM_REFERENCE_TIMESTAMP_ADDR(x)                                                              ((x) + 0x4c4)
#define HWIO_TQM_R0_TQM_REFERENCE_TIMESTAMP_PHYS(x)                                                              ((x) + 0x4c4)
#define HWIO_TQM_R0_TQM_REFERENCE_TIMESTAMP_OFFS                                                                 (0x4c4)
#define HWIO_TQM_R0_TQM_REFERENCE_TIMESTAMP_RMSK                                                                 0xffffffff
#define HWIO_TQM_R0_TQM_REFERENCE_TIMESTAMP_POR                                                                  0x00000000
#define HWIO_TQM_R0_TQM_REFERENCE_TIMESTAMP_POR_RMSK                                                             0xffffffff
#define HWIO_TQM_R0_TQM_REFERENCE_TIMESTAMP_ATTR                                                                              0x1
#define HWIO_TQM_R0_TQM_REFERENCE_TIMESTAMP_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM_REFERENCE_TIMESTAMP_ADDR(x))
#define HWIO_TQM_R0_TQM_REFERENCE_TIMESTAMP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM_REFERENCE_TIMESTAMP_ADDR(x), m)
#define HWIO_TQM_R0_TQM_REFERENCE_TIMESTAMP_TQM_REFERENCE_TIMESTAMP_BMSK                                         0xffffffff
#define HWIO_TQM_R0_TQM_REFERENCE_TIMESTAMP_TQM_REFERENCE_TIMESTAMP_SHFT                                                  0

#define HWIO_TQM_R0_SPARE_ADDR(x)                                                                                ((x) + 0x4c8)
#define HWIO_TQM_R0_SPARE_PHYS(x)                                                                                ((x) + 0x4c8)
#define HWIO_TQM_R0_SPARE_OFFS                                                                                   (0x4c8)
#define HWIO_TQM_R0_SPARE_RMSK                                                                                   0xffffffff
#define HWIO_TQM_R0_SPARE_POR                                                                                    0x00000000
#define HWIO_TQM_R0_SPARE_POR_RMSK                                                                               0xffffffff
#define HWIO_TQM_R0_SPARE_ATTR                                                                                                0x3
#define HWIO_TQM_R0_SPARE_IN(x)            \
                in_dword(HWIO_TQM_R0_SPARE_ADDR(x))
#define HWIO_TQM_R0_SPARE_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SPARE_ADDR(x), m)
#define HWIO_TQM_R0_SPARE_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SPARE_ADDR(x),v)
#define HWIO_TQM_R0_SPARE_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SPARE_ADDR(x),m,v,HWIO_TQM_R0_SPARE_IN(x))
#define HWIO_TQM_R0_SPARE_SPAREBITS_BMSK                                                                         0xffffffff
#define HWIO_TQM_R0_SPARE_SPAREBITS_SHFT                                                                                  0

#define HWIO_TQM_R0_SPEAR_ADDR(x)                                                                                ((x) + 0x4cc)
#define HWIO_TQM_R0_SPEAR_PHYS(x)                                                                                ((x) + 0x4cc)
#define HWIO_TQM_R0_SPEAR_OFFS                                                                                   (0x4cc)
#define HWIO_TQM_R0_SPEAR_RMSK                                                                                   0xffffffff
#define HWIO_TQM_R0_SPEAR_POR                                                                                    0x00000000
#define HWIO_TQM_R0_SPEAR_POR_RMSK                                                                               0xffffffff
#define HWIO_TQM_R0_SPEAR_ATTR                                                                                                0x3
#define HWIO_TQM_R0_SPEAR_IN(x)            \
                in_dword(HWIO_TQM_R0_SPEAR_ADDR(x))
#define HWIO_TQM_R0_SPEAR_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_SPEAR_ADDR(x), m)
#define HWIO_TQM_R0_SPEAR_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_SPEAR_ADDR(x),v)
#define HWIO_TQM_R0_SPEAR_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_SPEAR_ADDR(x),m,v,HWIO_TQM_R0_SPEAR_IN(x))
#define HWIO_TQM_R0_SPEAR_SPEAR_BMSK                                                                             0xffffffff
#define HWIO_TQM_R0_SPEAR_SPEAR_SHFT                                                                                      0

#define HWIO_TQM_R0_ENABLE_NON_POSTED_FLUSH_ADDR(x)                                                              ((x) + 0x4d0)
#define HWIO_TQM_R0_ENABLE_NON_POSTED_FLUSH_PHYS(x)                                                              ((x) + 0x4d0)
#define HWIO_TQM_R0_ENABLE_NON_POSTED_FLUSH_OFFS                                                                 (0x4d0)
#define HWIO_TQM_R0_ENABLE_NON_POSTED_FLUSH_RMSK                                                                       0x1f
#define HWIO_TQM_R0_ENABLE_NON_POSTED_FLUSH_POR                                                                  0x00000001
#define HWIO_TQM_R0_ENABLE_NON_POSTED_FLUSH_POR_RMSK                                                             0xffffffff
#define HWIO_TQM_R0_ENABLE_NON_POSTED_FLUSH_ATTR                                                                              0x3
#define HWIO_TQM_R0_ENABLE_NON_POSTED_FLUSH_IN(x)            \
                in_dword(HWIO_TQM_R0_ENABLE_NON_POSTED_FLUSH_ADDR(x))
#define HWIO_TQM_R0_ENABLE_NON_POSTED_FLUSH_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_ENABLE_NON_POSTED_FLUSH_ADDR(x), m)
#define HWIO_TQM_R0_ENABLE_NON_POSTED_FLUSH_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_ENABLE_NON_POSTED_FLUSH_ADDR(x),v)
#define HWIO_TQM_R0_ENABLE_NON_POSTED_FLUSH_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_ENABLE_NON_POSTED_FLUSH_ADDR(x),m,v,HWIO_TQM_R0_ENABLE_NON_POSTED_FLUSH_IN(x))
#define HWIO_TQM_R0_ENABLE_NON_POSTED_FLUSH_FOR_REM_MPDU_BMSK                                                          0x10
#define HWIO_TQM_R0_ENABLE_NON_POSTED_FLUSH_FOR_REM_MPDU_SHFT                                                             4
#define HWIO_TQM_R0_ENABLE_NON_POSTED_FLUSH_FOR_REM_MSDU_BMSK                                                           0x8
#define HWIO_TQM_R0_ENABLE_NON_POSTED_FLUSH_FOR_REM_MSDU_SHFT                                                             3
#define HWIO_TQM_R0_ENABLE_NON_POSTED_FLUSH_FOR_UPDATE_MSDU_FLOW_BMSK                                                   0x4
#define HWIO_TQM_R0_ENABLE_NON_POSTED_FLUSH_FOR_UPDATE_MSDU_FLOW_SHFT                                                     2
#define HWIO_TQM_R0_ENABLE_NON_POSTED_FLUSH_FOR_UPDATE_MPDU_QUEUE_BMSK                                                  0x2
#define HWIO_TQM_R0_ENABLE_NON_POSTED_FLUSH_FOR_UPDATE_MPDU_QUEUE_SHFT                                                    1
#define HWIO_TQM_R0_ENABLE_NON_POSTED_FLUSH_FOR_GEN_MPDUS_BMSK                                                          0x1
#define HWIO_TQM_R0_ENABLE_NON_POSTED_FLUSH_FOR_GEN_MPDUS_SHFT                                                            0

#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_ADDR(x)                                                                ((x) + 0x4d4)
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_PHYS(x)                                                                ((x) + 0x4d4)
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_OFFS                                                                   (0x4d4)
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_RMSK                                                                     0x3fffff
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_POR                                                                    0x00150000
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_POR_RMSK                                                               0xffffffff
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_ATTR                                                                                0x3
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_IN(x)            \
                in_dword(HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_ADDR(x))
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_ADDR(x), m)
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_ADDR(x),v)
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_ADDR(x),m,v,HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_IN(x))
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_BAR_ASSIST_BMSK                                                          0x300000
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_BAR_ASSIST_SHFT                                                                20
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_LIST_MPDU_BMSK                                                            0xc0000
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_LIST_MPDU_SHFT                                                                 18
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_MISC_TRANSFERS_BMSK                                                       0x30000
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_MISC_TRANSFERS_SHFT                                                            16
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_STATUS1_RING_BMSK                                                          0xc000
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_STATUS1_RING_SHFT                                                              14
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_STATUS_RING_BMSK                                                           0x3000
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_STATUS_RING_SHFT                                                               12
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_DESC_PTR_RELEASE_RING_BMSK                                                  0xc00
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_DESC_PTR_RELEASE_RING_SHFT                                                     10
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_DESC_PTR_FETCH_RING_BMSK                                                    0x300
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_DESC_PTR_FETCH_RING_SHFT                                                        8
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_SW_CMD1_RING_BMSK                                                            0xc0
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_SW_CMD1_RING_SHFT                                                               6
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_SW_CMD_RING_BMSK                                                             0x30
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_SW_CMD_RING_SHFT                                                                4
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_FW2TQM_ENTRANCE_RING_BMSK                                                     0xc
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_FW2TQM_ENTRANCE_RING_SHFT                                                       2
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_TCL2TQM_ENTRANCE_RING_BMSK                                                    0x3
#define HWIO_TQM_R0_GXI_TRANSFER_PRIORITY_TCL2TQM_ENTRANCE_RING_SHFT                                                      0

#define HWIO_TQM_R0_VC_ID_ADDR(x)                                                                                ((x) + 0x4d8)
#define HWIO_TQM_R0_VC_ID_PHYS(x)                                                                                ((x) + 0x4d8)
#define HWIO_TQM_R0_VC_ID_OFFS                                                                                   (0x4d8)
#define HWIO_TQM_R0_VC_ID_RMSK                                                                                         0x3f
#define HWIO_TQM_R0_VC_ID_POR                                                                                    0x00000000
#define HWIO_TQM_R0_VC_ID_POR_RMSK                                                                               0xffffffff
#define HWIO_TQM_R0_VC_ID_ATTR                                                                                                0x3
#define HWIO_TQM_R0_VC_ID_IN(x)            \
                in_dword(HWIO_TQM_R0_VC_ID_ADDR(x))
#define HWIO_TQM_R0_VC_ID_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_VC_ID_ADDR(x), m)
#define HWIO_TQM_R0_VC_ID_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_VC_ID_ADDR(x),v)
#define HWIO_TQM_R0_VC_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_VC_ID_ADDR(x),m,v,HWIO_TQM_R0_VC_ID_IN(x))
#define HWIO_TQM_R0_VC_ID_WBM2TQM_C_SRNG_BMSK                                                                          0x20
#define HWIO_TQM_R0_VC_ID_WBM2TQM_C_SRNG_SHFT                                                                             5
#define HWIO_TQM_R0_VC_ID_SW_CMD1_C_SRNG_BMSK                                                                          0x10
#define HWIO_TQM_R0_VC_ID_SW_CMD1_C_SRNG_SHFT                                                                             4
#define HWIO_TQM_R0_VC_ID_SW_CMD_C_SRNG_BMSK                                                                            0x8
#define HWIO_TQM_R0_VC_ID_SW_CMD_C_SRNG_SHFT                                                                              3
#define HWIO_TQM_R0_VC_ID_FW2TQM_ENTRANCE_C_SRNG_BMSK                                                                   0x4
#define HWIO_TQM_R0_VC_ID_FW2TQM_ENTRANCE_C_SRNG_SHFT                                                                     2
#define HWIO_TQM_R0_VC_ID_TCL2TQM_ENTRANCE_C_SRNG_BMSK                                                                  0x2
#define HWIO_TQM_R0_VC_ID_TCL2TQM_ENTRANCE_C_SRNG_SHFT                                                                    1
#define HWIO_TQM_R0_VC_ID_MISC_TRANSFER_BMSK                                                                            0x1
#define HWIO_TQM_R0_VC_ID_MISC_TRANSFER_SHFT                                                                              0

#define HWIO_TQM_R0_BARRIER_RD_CTL_0_ADDR(x)                                                                     ((x) + 0x4dc)
#define HWIO_TQM_R0_BARRIER_RD_CTL_0_PHYS(x)                                                                     ((x) + 0x4dc)
#define HWIO_TQM_R0_BARRIER_RD_CTL_0_OFFS                                                                        (0x4dc)
#define HWIO_TQM_R0_BARRIER_RD_CTL_0_RMSK                                                                        0xffffffff
#define HWIO_TQM_R0_BARRIER_RD_CTL_0_POR                                                                         0x00000000
#define HWIO_TQM_R0_BARRIER_RD_CTL_0_POR_RMSK                                                                    0xffffffff
#define HWIO_TQM_R0_BARRIER_RD_CTL_0_ATTR                                                                                     0x3
#define HWIO_TQM_R0_BARRIER_RD_CTL_0_IN(x)            \
                in_dword(HWIO_TQM_R0_BARRIER_RD_CTL_0_ADDR(x))
#define HWIO_TQM_R0_BARRIER_RD_CTL_0_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_BARRIER_RD_CTL_0_ADDR(x), m)
#define HWIO_TQM_R0_BARRIER_RD_CTL_0_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_BARRIER_RD_CTL_0_ADDR(x),v)
#define HWIO_TQM_R0_BARRIER_RD_CTL_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_BARRIER_RD_CTL_0_ADDR(x),m,v,HWIO_TQM_R0_BARRIER_RD_CTL_0_IN(x))
#define HWIO_TQM_R0_BARRIER_RD_CTL_0_LSB_BMSK                                                                    0xffffffff
#define HWIO_TQM_R0_BARRIER_RD_CTL_0_LSB_SHFT                                                                             0

#define HWIO_TQM_R0_BARRIER_RD_CTL_1_ADDR(x)                                                                     ((x) + 0x4e0)
#define HWIO_TQM_R0_BARRIER_RD_CTL_1_PHYS(x)                                                                     ((x) + 0x4e0)
#define HWIO_TQM_R0_BARRIER_RD_CTL_1_OFFS                                                                        (0x4e0)
#define HWIO_TQM_R0_BARRIER_RD_CTL_1_RMSK                                                                              0xff
#define HWIO_TQM_R0_BARRIER_RD_CTL_1_POR                                                                         0x00000000
#define HWIO_TQM_R0_BARRIER_RD_CTL_1_POR_RMSK                                                                    0xffffffff
#define HWIO_TQM_R0_BARRIER_RD_CTL_1_ATTR                                                                                     0x3
#define HWIO_TQM_R0_BARRIER_RD_CTL_1_IN(x)            \
                in_dword(HWIO_TQM_R0_BARRIER_RD_CTL_1_ADDR(x))
#define HWIO_TQM_R0_BARRIER_RD_CTL_1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_BARRIER_RD_CTL_1_ADDR(x), m)
#define HWIO_TQM_R0_BARRIER_RD_CTL_1_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_BARRIER_RD_CTL_1_ADDR(x),v)
#define HWIO_TQM_R0_BARRIER_RD_CTL_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_BARRIER_RD_CTL_1_ADDR(x),m,v,HWIO_TQM_R0_BARRIER_RD_CTL_1_IN(x))
#define HWIO_TQM_R0_BARRIER_RD_CTL_1_MSB_BMSK                                                                          0xff
#define HWIO_TQM_R0_BARRIER_RD_CTL_1_MSB_SHFT                                                                             0

#define HWIO_TQM_R0_DROPPED_MSDU_COUNT_ADDR(x)                                                                   ((x) + 0x4e4)
#define HWIO_TQM_R0_DROPPED_MSDU_COUNT_PHYS(x)                                                                   ((x) + 0x4e4)
#define HWIO_TQM_R0_DROPPED_MSDU_COUNT_OFFS                                                                      (0x4e4)
#define HWIO_TQM_R0_DROPPED_MSDU_COUNT_RMSK                                                                      0xffffffff
#define HWIO_TQM_R0_DROPPED_MSDU_COUNT_POR                                                                       0x00000000
#define HWIO_TQM_R0_DROPPED_MSDU_COUNT_POR_RMSK                                                                  0xffffffff
#define HWIO_TQM_R0_DROPPED_MSDU_COUNT_ATTR                                                                                   0x3
#define HWIO_TQM_R0_DROPPED_MSDU_COUNT_IN(x)            \
                in_dword(HWIO_TQM_R0_DROPPED_MSDU_COUNT_ADDR(x))
#define HWIO_TQM_R0_DROPPED_MSDU_COUNT_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_DROPPED_MSDU_COUNT_ADDR(x), m)
#define HWIO_TQM_R0_DROPPED_MSDU_COUNT_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_DROPPED_MSDU_COUNT_ADDR(x),v)
#define HWIO_TQM_R0_DROPPED_MSDU_COUNT_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_DROPPED_MSDU_COUNT_ADDR(x),m,v,HWIO_TQM_R0_DROPPED_MSDU_COUNT_IN(x))
#define HWIO_TQM_R0_DROPPED_MSDU_COUNT_VALUE_BMSK                                                                0xffffffff
#define HWIO_TQM_R0_DROPPED_MSDU_COUNT_VALUE_SHFT                                                                         0

#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_0_ADDR(x)                                                            ((x) + 0x4e8)
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_0_PHYS(x)                                                            ((x) + 0x4e8)
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_0_OFFS                                                               (0x4e8)
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_0_RMSK                                                               0xffffffff
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_0_POR                                                                0x00000000
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_0_POR_RMSK                                                           0xffffffff
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_0_ATTR                                                                            0x3
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_0_IN(x)            \
                in_dword(HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_0_ADDR(x))
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_0_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_0_ADDR(x), m)
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_0_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_0_ADDR(x),v)
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_0_ADDR(x),m,v,HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_0_IN(x))
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_0_VALUE_BMSK                                                         0xffffffff
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_0_VALUE_SHFT                                                                  0

#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_1_ADDR(x)                                                            ((x) + 0x4ec)
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_1_PHYS(x)                                                            ((x) + 0x4ec)
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_1_OFFS                                                               (0x4ec)
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_1_RMSK                                                               0xffffffff
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_1_POR                                                                0x00000000
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_1_POR_RMSK                                                           0xffffffff
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_1_ATTR                                                                            0x3
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_1_IN(x)            \
                in_dword(HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_1_ADDR(x))
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_1_ADDR(x), m)
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_1_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_1_ADDR(x),v)
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_1_ADDR(x),m,v,HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_1_IN(x))
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_1_VALUE_BMSK                                                         0xffffffff
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_1_VALUE_SHFT                                                                  0

#define HWIO_TQM_R0_DROPPED_MSDU_COUNT_VDEV_ID_MISMATCH_ADDR(x)                                                  ((x) + 0x4f0)
#define HWIO_TQM_R0_DROPPED_MSDU_COUNT_VDEV_ID_MISMATCH_PHYS(x)                                                  ((x) + 0x4f0)
#define HWIO_TQM_R0_DROPPED_MSDU_COUNT_VDEV_ID_MISMATCH_OFFS                                                     (0x4f0)
#define HWIO_TQM_R0_DROPPED_MSDU_COUNT_VDEV_ID_MISMATCH_RMSK                                                     0xffffffff
#define HWIO_TQM_R0_DROPPED_MSDU_COUNT_VDEV_ID_MISMATCH_POR                                                      0x00000000
#define HWIO_TQM_R0_DROPPED_MSDU_COUNT_VDEV_ID_MISMATCH_POR_RMSK                                                 0xffffffff
#define HWIO_TQM_R0_DROPPED_MSDU_COUNT_VDEV_ID_MISMATCH_ATTR                                                                  0x3
#define HWIO_TQM_R0_DROPPED_MSDU_COUNT_VDEV_ID_MISMATCH_IN(x)            \
                in_dword(HWIO_TQM_R0_DROPPED_MSDU_COUNT_VDEV_ID_MISMATCH_ADDR(x))
#define HWIO_TQM_R0_DROPPED_MSDU_COUNT_VDEV_ID_MISMATCH_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_DROPPED_MSDU_COUNT_VDEV_ID_MISMATCH_ADDR(x), m)
#define HWIO_TQM_R0_DROPPED_MSDU_COUNT_VDEV_ID_MISMATCH_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_DROPPED_MSDU_COUNT_VDEV_ID_MISMATCH_ADDR(x),v)
#define HWIO_TQM_R0_DROPPED_MSDU_COUNT_VDEV_ID_MISMATCH_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_DROPPED_MSDU_COUNT_VDEV_ID_MISMATCH_ADDR(x),m,v,HWIO_TQM_R0_DROPPED_MSDU_COUNT_VDEV_ID_MISMATCH_IN(x))
#define HWIO_TQM_R0_DROPPED_MSDU_COUNT_VDEV_ID_MISMATCH_VALUE_BMSK                                               0xffffffff
#define HWIO_TQM_R0_DROPPED_MSDU_COUNT_VDEV_ID_MISMATCH_VALUE_SHFT                                                        0

#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_0_ADDR(x)                                           ((x) + 0x4f4)
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_0_PHYS(x)                                           ((x) + 0x4f4)
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_0_OFFS                                              (0x4f4)
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_0_RMSK                                              0xffffffff
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_0_POR                                               0x00000000
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_0_POR_RMSK                                          0xffffffff
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_0_ATTR                                                           0x3
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_0_IN(x)            \
                in_dword(HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_0_ADDR(x))
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_0_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_0_ADDR(x), m)
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_0_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_0_ADDR(x),v)
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_0_ADDR(x),m,v,HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_0_IN(x))
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_0_VALUE_BMSK                                        0xffffffff
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_0_VALUE_SHFT                                                 0

#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_1_ADDR(x)                                           ((x) + 0x4f8)
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_1_PHYS(x)                                           ((x) + 0x4f8)
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_1_OFFS                                              (0x4f8)
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_1_RMSK                                              0xffffffff
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_1_POR                                               0x00000000
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_1_POR_RMSK                                          0xffffffff
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_1_ATTR                                                           0x3
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_1_IN(x)            \
                in_dword(HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_1_ADDR(x))
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_1_ADDR(x), m)
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_1_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_1_ADDR(x),v)
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_1_ADDR(x),m,v,HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_1_IN(x))
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_1_VALUE_BMSK                                        0xffffffff
#define HWIO_TQM_R0_DROPPED_MSDU_BYTE_COUNT_VDEV_ID_MISMATCH_1_VALUE_SHFT                                                 0

#define HWIO_TQM_R0_ADD_MSDU_CMD_NUM_MSB_ADDR(x)                                                                 ((x) + 0x4fc)
#define HWIO_TQM_R0_ADD_MSDU_CMD_NUM_MSB_PHYS(x)                                                                 ((x) + 0x4fc)
#define HWIO_TQM_R0_ADD_MSDU_CMD_NUM_MSB_OFFS                                                                    (0x4fc)
#define HWIO_TQM_R0_ADD_MSDU_CMD_NUM_MSB_RMSK                                                                          0xff
#define HWIO_TQM_R0_ADD_MSDU_CMD_NUM_MSB_POR                                                                     0x00000000
#define HWIO_TQM_R0_ADD_MSDU_CMD_NUM_MSB_POR_RMSK                                                                0xffffffff
#define HWIO_TQM_R0_ADD_MSDU_CMD_NUM_MSB_ATTR                                                                                 0x3
#define HWIO_TQM_R0_ADD_MSDU_CMD_NUM_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_ADD_MSDU_CMD_NUM_MSB_ADDR(x))
#define HWIO_TQM_R0_ADD_MSDU_CMD_NUM_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_ADD_MSDU_CMD_NUM_MSB_ADDR(x), m)
#define HWIO_TQM_R0_ADD_MSDU_CMD_NUM_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_ADD_MSDU_CMD_NUM_MSB_ADDR(x),v)
#define HWIO_TQM_R0_ADD_MSDU_CMD_NUM_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_ADD_MSDU_CMD_NUM_MSB_ADDR(x),m,v,HWIO_TQM_R0_ADD_MSDU_CMD_NUM_MSB_IN(x))
#define HWIO_TQM_R0_ADD_MSDU_CMD_NUM_MSB_VALUE_BMSK                                                                    0xff
#define HWIO_TQM_R0_ADD_MSDU_CMD_NUM_MSB_VALUE_SHFT                                                                       0

#define HWIO_TQM_R0_UNLOCKED_CONCURRENCY_ADDR(x)                                                                 ((x) + 0x500)
#define HWIO_TQM_R0_UNLOCKED_CONCURRENCY_PHYS(x)                                                                 ((x) + 0x500)
#define HWIO_TQM_R0_UNLOCKED_CONCURRENCY_OFFS                                                                    (0x500)
#define HWIO_TQM_R0_UNLOCKED_CONCURRENCY_RMSK                                                                    0x3fffffff
#define HWIO_TQM_R0_UNLOCKED_CONCURRENCY_POR                                                                     0x00000000
#define HWIO_TQM_R0_UNLOCKED_CONCURRENCY_POR_RMSK                                                                0xffffffff
#define HWIO_TQM_R0_UNLOCKED_CONCURRENCY_ATTR                                                                                 0x3
#define HWIO_TQM_R0_UNLOCKED_CONCURRENCY_IN(x)            \
                in_dword(HWIO_TQM_R0_UNLOCKED_CONCURRENCY_ADDR(x))
#define HWIO_TQM_R0_UNLOCKED_CONCURRENCY_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_UNLOCKED_CONCURRENCY_ADDR(x), m)
#define HWIO_TQM_R0_UNLOCKED_CONCURRENCY_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_UNLOCKED_CONCURRENCY_ADDR(x),v)
#define HWIO_TQM_R0_UNLOCKED_CONCURRENCY_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_UNLOCKED_CONCURRENCY_ADDR(x),m,v,HWIO_TQM_R0_UNLOCKED_CONCURRENCY_IN(x))
#define HWIO_TQM_R0_UNLOCKED_CONCURRENCY_ENB_MSDU_PREF_BMSK                                                      0x20000000
#define HWIO_TQM_R0_UNLOCKED_CONCURRENCY_ENB_MSDU_PREF_SHFT                                                              29
#define HWIO_TQM_R0_UNLOCKED_CONCURRENCY_MPDU_COUNT_BMSK                                                         0x1ffe0000
#define HWIO_TQM_R0_UNLOCKED_CONCURRENCY_MPDU_COUNT_SHFT                                                                 17
#define HWIO_TQM_R0_UNLOCKED_CONCURRENCY_MSDU_COUNT_BMSK                                                            0x1fffe
#define HWIO_TQM_R0_UNLOCKED_CONCURRENCY_MSDU_COUNT_SHFT                                                                  1
#define HWIO_TQM_R0_UNLOCKED_CONCURRENCY_ENB_BMSK                                                                       0x1
#define HWIO_TQM_R0_UNLOCKED_CONCURRENCY_ENB_SHFT                                                                         0

#define HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_LSB_ADDR(x)                                                            ((x) + 0x504)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_LSB_PHYS(x)                                                            ((x) + 0x504)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_LSB_OFFS                                                               (0x504)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_LSB_RMSK                                                               0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_LSB_POR                                                                0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_LSB_POR_RMSK                                                           0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_LSB_ATTR                                                                            0x3
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_LSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                            0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                     0

#define HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_MSB_ADDR(x)                                                            ((x) + 0x508)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_MSB_PHYS(x)                                                            ((x) + 0x508)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_MSB_OFFS                                                               (0x508)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_MSB_RMSK                                                                 0xffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_MSB_POR                                                                0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_MSB_POR_RMSK                                                           0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_MSB_ATTR                                                                            0x3
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_MSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_MSB_RING_SIZE_BMSK                                                       0xffff00
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_MSB_RING_SIZE_SHFT                                                              8
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                  0xff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                     0

#define HWIO_TQM_R0_TQM2TQM_IN1_RING_ID_ADDR(x)                                                                  ((x) + 0x50c)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_ID_PHYS(x)                                                                  ((x) + 0x50c)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_ID_OFFS                                                                     (0x50c)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_ID_RMSK                                                                           0xff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_ID_POR                                                                      0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_ID_POR_RMSK                                                                 0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_ID_ATTR                                                                                  0x3
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_ID_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_ID_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN1_RING_ID_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_ID_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_ID_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN1_RING_ID_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN1_RING_ID_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_ID_ENTRY_SIZE_BMSK                                                                0xff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_ID_ENTRY_SIZE_SHFT                                                                   0

#define HWIO_TQM_R0_TQM2TQM_IN1_RING_STATUS_ADDR(x)                                                              ((x) + 0x510)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_STATUS_PHYS(x)                                                              ((x) + 0x510)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_STATUS_OFFS                                                                 (0x510)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_STATUS_RMSK                                                                 0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_STATUS_POR                                                                  0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_STATUS_POR_RMSK                                                             0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_STATUS_ATTR                                                                              0x1
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_STATUS_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN1_RING_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                 0xffff0000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                         16
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_STATUS_NUM_VALID_WORDS_BMSK                                                     0xffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_STATUS_NUM_VALID_WORDS_SHFT                                                          0

#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_ADDR(x)                                                                ((x) + 0x514)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_PHYS(x)                                                                ((x) + 0x514)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_OFFS                                                                   (0x514)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_RMSK                                                                     0x3fffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_POR                                                                    0x00000080
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_POR_RMSK                                                               0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_ATTR                                                                                0x3
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_SPARE_CONTROL_BMSK                                                       0x3fc000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_SPARE_CONTROL_SHFT                                                             14
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_SRNG_SM_STATE2_BMSK                                                        0x3000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_SRNG_SM_STATE2_SHFT                                                            12
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_SRNG_SM_STATE1_BMSK                                                         0xf00
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_SRNG_SM_STATE1_SHFT                                                             8
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_SRNG_IS_IDLE_BMSK                                                            0x80
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_SRNG_IS_IDLE_SHFT                                                               7
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_SRNG_ENABLE_BMSK                                                             0x40
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_SRNG_ENABLE_SHFT                                                                6
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                       0x20
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                          5
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                        0x10
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                           4
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_MSI_SWAP_BIT_BMSK                                                             0x8
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_MSI_SWAP_BIT_SHFT                                                               3
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_SECURITY_BIT_BMSK                                                             0x4
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_SECURITY_BIT_SHFT                                                               2
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_LOOPCNT_DISABLE_BMSK                                                          0x2
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_LOOPCNT_DISABLE_SHFT                                                            1
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_RING_ID_DISABLE_BMSK                                                          0x1
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_RING_ID_DISABLE_SHFT                                                            0

#define HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_LSB_ADDR(x)                                                         ((x) + 0x520)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_LSB_PHYS(x)                                                         ((x) + 0x520)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_LSB_OFFS                                                            (0x520)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_LSB_RMSK                                                            0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_LSB_POR                                                             0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_LSB_POR_RMSK                                                        0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_LSB_ATTR                                                                         0x3
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_LSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                       0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                                0

#define HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_MSB_ADDR(x)                                                         ((x) + 0x524)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_MSB_PHYS(x)                                                         ((x) + 0x524)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_MSB_OFFS                                                            (0x524)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_MSB_RMSK                                                                  0xff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_MSB_POR                                                             0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_MSB_POR_RMSK                                                        0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_MSB_ATTR                                                                         0x3
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_MSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                             0xff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                                0

#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                              ((x) + 0x534)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                              ((x) + 0x534)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                 (0x534)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                 0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX0_POR                                                  0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                             0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                              0x3
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                       0xffff0000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                               16
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                   0x8000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                       15
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                             0x7fff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                  0

#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                              ((x) + 0x538)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                              ((x) + 0x538)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                 (0x538)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                     0xffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX1_POR                                                  0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                             0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                              0x3
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                       0xffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                            0

#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_STATUS_ADDR(x)                                                 ((x) + 0x53c)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_STATUS_PHYS(x)                                                 ((x) + 0x53c)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_STATUS_OFFS                                                    (0x53c)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_STATUS_RMSK                                                    0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_STATUS_POR                                                     0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_STATUS_POR_RMSK                                                0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_STATUS_ATTR                                                                 0x1
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                      0xffff0000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                              16
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                 0x8000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                     15
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                           0x7fff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                0

#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                              ((x) + 0x540)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                              ((x) + 0x540)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                 (0x540)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                      0x3ff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_EMPTY_COUNTER_POR                                                  0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                             0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                              0x3
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                   0x3ff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                       0

#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                             ((x) + 0x544)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                             ((x) + 0x544)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_TIMER_OFFS                                                (0x544)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                       0x7
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_TIMER_POR                                                 0x00000003
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                            0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                             0x3
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                  0x7
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                    0

#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                            ((x) + 0x548)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                            ((x) + 0x548)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_STATUS_OFFS                                               (0x548)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_STATUS_RMSK                                                 0xffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_STATUS_POR                                                0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                           0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                            0x1
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                  0xff0000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                        16
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                                 0xffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                      0

#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_LSB_ADDR(x)                                                       ((x) + 0x54c)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_LSB_PHYS(x)                                                       ((x) + 0x54c)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_LSB_OFFS                                                          (0x54c)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_LSB_POR                                                           0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_LSB_ATTR                                                                       0x3
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_MSB_ADDR(x)                                                       ((x) + 0x550)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_MSB_PHYS(x)                                                       ((x) + 0x550)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_MSB_OFFS                                                          (0x550)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_MSB_POR                                                           0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_MSB_ATTR                                                                       0x3
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                   0x100
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                       8
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_DATA_ADDR(x)                                                           ((x) + 0x554)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_DATA_PHYS(x)                                                           ((x) + 0x554)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_DATA_OFFS                                                              (0x554)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_DATA_RMSK                                                              0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_DATA_POR                                                               0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_DATA_ATTR                                                                           0x3
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_DATA_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_DATA_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_DATA_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MSI1_DATA_VALUE_SHFT                                                                 0

#define HWIO_TQM_R0_TQM2TQM_IN1_RING_HP_TP_SW_OFFSET_ADDR(x)                                                     ((x) + 0x574)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_HP_TP_SW_OFFSET_PHYS(x)                                                     ((x) + 0x574)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_HP_TP_SW_OFFSET_OFFS                                                        (0x574)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_HP_TP_SW_OFFSET_RMSK                                                            0xffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_HP_TP_SW_OFFSET_POR                                                         0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_HP_TP_SW_OFFSET_POR_RMSK                                                    0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_HP_TP_SW_OFFSET_ATTR                                                                     0x3
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN1_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN1_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN1_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                         0xffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                              0

#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_ADDR(x)                                                        ((x) + 0x578)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_PHYS(x)                                                        ((x) + 0x578)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_OFFS                                                           (0x578)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_RMSK                                                           0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_POR                                                            0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_POR_RMSK                                                       0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_ATTR                                                                        0x3
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_TIME_THRESHOLD_TO_DOORBELL_BMSK                                0xffff0000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_TIME_THRESHOLD_TO_DOORBELL_SHFT                                        16
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_FETCH_SAME_POINTER_ERR_INT_REG_CLR_BMSK                            0x8000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_FETCH_SAME_POINTER_ERR_INT_REG_CLR_SHFT                                15
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_NUM_THRESHOLD_TO_DOORBELL_BMSK                                     0x7e00
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_NUM_THRESHOLD_TO_DOORBELL_SHFT                                          9
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_SRNG_SM_STATE3_BMSK                                                 0x180
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_SRNG_SM_STATE3_SHFT                                                     7
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_INTERVAL_OF_FETCH_POINTER_BMSK                                       0x70
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_INTERVAL_OF_FETCH_POINTER_SHFT                                          4
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_FETCH_SAME_POINTER_THRESHOLD_BMSK                                     0xf
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_FETCH_SAME_POINTER_THRESHOLD_SHFT                                       0

#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_ADDR(x)                                         ((x) + 0x57c)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_PHYS(x)                                         ((x) + 0x57c)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_OFFS                                            (0x57c)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_RMSK                                                0xffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_POR                                             0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_POR_RMSK                                        0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_ATTR                                                         0x3
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_MESSAGE_BMSK                                        0xffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_MLO_DOORBELL_PRESS_MESSAGE_SHFT                                             0

#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ADDR(x)                                     ((x) + 0x580)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_PHYS(x)                                     ((x) + 0x580)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_OFFS                                        (0x580)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_RMSK                                        0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_POR                                         0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_POR_RMSK                                    0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ATTR                                                     0x3
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_VALUE_BMSK                                  0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_VALUE_SHFT                                           0

#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ADDR(x)                                     ((x) + 0x584)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_PHYS(x)                                     ((x) + 0x584)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_OFFS                                        (0x584)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_RMSK                                              0xff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_POR                                         0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_POR_RMSK                                    0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ATTR                                                     0x3
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_VALUE_BMSK                                        0xff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_VALUE_SHFT                                           0

#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_ADDR(x)                                      ((x) + 0x588)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_PHYS(x)                                      ((x) + 0x588)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_OFFS                                         (0x588)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_RMSK                                         0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_POR                                          0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_POR_RMSK                                     0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_ATTR                                                      0x3
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_VALUE_BMSK                                   0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_LSB_VALUE_SHFT                                            0

#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_ADDR(x)                                      ((x) + 0x58c)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_PHYS(x)                                      ((x) + 0x58c)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_OFFS                                         (0x58c)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_RMSK                                               0xff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_POR                                          0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_POR_RMSK                                     0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_ATTR                                                      0x3
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_VALUE_BMSK                                         0xff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_CONSUMER_POINTER_READ_ADDR_MSB_VALUE_SHFT                                            0

#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_1_ADDR(x)                                                              ((x) + 0x590)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_1_PHYS(x)                                                              ((x) + 0x590)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_1_OFFS                                                                 (0x590)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_1_RMSK                                                                 0xffff003f
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_1_POR                                                                  0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_1_POR_RMSK                                                             0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_1_ATTR                                                                              0x3
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_1_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_1_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_1_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_1_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_1_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_1_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                        0xffff0000
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                16
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                               0x3f
#define HWIO_TQM_R0_TQM2TQM_IN1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                  0

#define HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_LSB_ADDR(x)                                                            ((x) + 0x594)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_LSB_PHYS(x)                                                            ((x) + 0x594)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_LSB_OFFS                                                               (0x594)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_LSB_RMSK                                                               0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_LSB_POR                                                                0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_LSB_POR_RMSK                                                           0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_LSB_ATTR                                                                            0x3
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_LSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                            0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                     0

#define HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_MSB_ADDR(x)                                                            ((x) + 0x598)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_MSB_PHYS(x)                                                            ((x) + 0x598)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_MSB_OFFS                                                               (0x598)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_MSB_RMSK                                                                 0xffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_MSB_POR                                                                0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_MSB_POR_RMSK                                                           0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_MSB_ATTR                                                                            0x3
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_MSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_MSB_RING_SIZE_BMSK                                                       0xffff00
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_MSB_RING_SIZE_SHFT                                                              8
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                  0xff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                     0

#define HWIO_TQM_R0_TQM2TQM_IN2_RING_ID_ADDR(x)                                                                  ((x) + 0x59c)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_ID_PHYS(x)                                                                  ((x) + 0x59c)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_ID_OFFS                                                                     (0x59c)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_ID_RMSK                                                                           0xff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_ID_POR                                                                      0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_ID_POR_RMSK                                                                 0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_ID_ATTR                                                                                  0x3
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_ID_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_ID_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN2_RING_ID_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_ID_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_ID_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN2_RING_ID_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN2_RING_ID_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_ID_ENTRY_SIZE_BMSK                                                                0xff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_ID_ENTRY_SIZE_SHFT                                                                   0

#define HWIO_TQM_R0_TQM2TQM_IN2_RING_STATUS_ADDR(x)                                                              ((x) + 0x5a0)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_STATUS_PHYS(x)                                                              ((x) + 0x5a0)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_STATUS_OFFS                                                                 (0x5a0)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_STATUS_RMSK                                                                 0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_STATUS_POR                                                                  0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_STATUS_POR_RMSK                                                             0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_STATUS_ATTR                                                                              0x1
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_STATUS_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN2_RING_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                 0xffff0000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                         16
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_STATUS_NUM_VALID_WORDS_BMSK                                                     0xffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_STATUS_NUM_VALID_WORDS_SHFT                                                          0

#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_ADDR(x)                                                                ((x) + 0x5a4)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_PHYS(x)                                                                ((x) + 0x5a4)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_OFFS                                                                   (0x5a4)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_RMSK                                                                     0x3fffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_POR                                                                    0x00000080
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_POR_RMSK                                                               0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_ATTR                                                                                0x3
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_SPARE_CONTROL_BMSK                                                       0x3fc000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_SPARE_CONTROL_SHFT                                                             14
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_SRNG_SM_STATE2_BMSK                                                        0x3000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_SRNG_SM_STATE2_SHFT                                                            12
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_SRNG_SM_STATE1_BMSK                                                         0xf00
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_SRNG_SM_STATE1_SHFT                                                             8
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_SRNG_IS_IDLE_BMSK                                                            0x80
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_SRNG_IS_IDLE_SHFT                                                               7
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_SRNG_ENABLE_BMSK                                                             0x40
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_SRNG_ENABLE_SHFT                                                                6
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                       0x20
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                          5
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                        0x10
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                           4
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_MSI_SWAP_BIT_BMSK                                                             0x8
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_MSI_SWAP_BIT_SHFT                                                               3
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_SECURITY_BIT_BMSK                                                             0x4
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_SECURITY_BIT_SHFT                                                               2
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_LOOPCNT_DISABLE_BMSK                                                          0x2
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_LOOPCNT_DISABLE_SHFT                                                            1
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_RING_ID_DISABLE_BMSK                                                          0x1
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_RING_ID_DISABLE_SHFT                                                            0

#define HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_LSB_ADDR(x)                                                         ((x) + 0x5b0)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_LSB_PHYS(x)                                                         ((x) + 0x5b0)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_LSB_OFFS                                                            (0x5b0)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_LSB_RMSK                                                            0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_LSB_POR                                                             0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_LSB_POR_RMSK                                                        0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_LSB_ATTR                                                                         0x3
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_LSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                       0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                                0

#define HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_MSB_ADDR(x)                                                         ((x) + 0x5b4)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_MSB_PHYS(x)                                                         ((x) + 0x5b4)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_MSB_OFFS                                                            (0x5b4)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_MSB_RMSK                                                                  0xff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_MSB_POR                                                             0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_MSB_POR_RMSK                                                        0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_MSB_ATTR                                                                         0x3
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_MSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                             0xff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                                0

#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                              ((x) + 0x5c4)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                              ((x) + 0x5c4)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                 (0x5c4)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                 0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX0_POR                                                  0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                             0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                              0x3
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                       0xffff0000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                               16
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                   0x8000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                       15
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                             0x7fff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                  0

#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                              ((x) + 0x5c8)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                              ((x) + 0x5c8)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                 (0x5c8)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                     0xffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX1_POR                                                  0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                             0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                              0x3
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                       0xffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                            0

#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_STATUS_ADDR(x)                                                 ((x) + 0x5cc)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_STATUS_PHYS(x)                                                 ((x) + 0x5cc)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_STATUS_OFFS                                                    (0x5cc)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_STATUS_RMSK                                                    0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_STATUS_POR                                                     0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_STATUS_POR_RMSK                                                0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_STATUS_ATTR                                                                 0x1
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                      0xffff0000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                              16
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                 0x8000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                     15
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                           0x7fff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                0

#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                              ((x) + 0x5d0)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                              ((x) + 0x5d0)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                 (0x5d0)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                      0x3ff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_EMPTY_COUNTER_POR                                                  0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                             0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                              0x3
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                   0x3ff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                       0

#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                             ((x) + 0x5d4)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                             ((x) + 0x5d4)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_TIMER_OFFS                                                (0x5d4)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                       0x7
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_TIMER_POR                                                 0x00000003
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                            0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                             0x3
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                  0x7
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                    0

#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                            ((x) + 0x5d8)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                            ((x) + 0x5d8)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_STATUS_OFFS                                               (0x5d8)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_STATUS_RMSK                                                 0xffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_STATUS_POR                                                0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                           0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                            0x1
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                  0xff0000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                        16
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                                 0xffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                      0

#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_LSB_ADDR(x)                                                       ((x) + 0x5dc)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_LSB_PHYS(x)                                                       ((x) + 0x5dc)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_LSB_OFFS                                                          (0x5dc)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_LSB_POR                                                           0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_LSB_ATTR                                                                       0x3
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_MSB_ADDR(x)                                                       ((x) + 0x5e0)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_MSB_PHYS(x)                                                       ((x) + 0x5e0)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_MSB_OFFS                                                          (0x5e0)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_MSB_POR                                                           0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_MSB_ATTR                                                                       0x3
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                   0x100
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                       8
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_DATA_ADDR(x)                                                           ((x) + 0x5e4)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_DATA_PHYS(x)                                                           ((x) + 0x5e4)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_DATA_OFFS                                                              (0x5e4)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_DATA_RMSK                                                              0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_DATA_POR                                                               0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_DATA_ATTR                                                                           0x3
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_DATA_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_DATA_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_DATA_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MSI1_DATA_VALUE_SHFT                                                                 0

#define HWIO_TQM_R0_TQM2TQM_IN2_RING_HP_TP_SW_OFFSET_ADDR(x)                                                     ((x) + 0x604)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_HP_TP_SW_OFFSET_PHYS(x)                                                     ((x) + 0x604)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_HP_TP_SW_OFFSET_OFFS                                                        (0x604)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_HP_TP_SW_OFFSET_RMSK                                                            0xffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_HP_TP_SW_OFFSET_POR                                                         0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_HP_TP_SW_OFFSET_POR_RMSK                                                    0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_HP_TP_SW_OFFSET_ATTR                                                                     0x3
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN2_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN2_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN2_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                         0xffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                              0

#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_ADDR(x)                                                        ((x) + 0x608)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_PHYS(x)                                                        ((x) + 0x608)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_OFFS                                                           (0x608)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_RMSK                                                           0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_POR                                                            0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_POR_RMSK                                                       0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_ATTR                                                                        0x3
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_TIME_THRESHOLD_TO_DOORBELL_BMSK                                0xffff0000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_TIME_THRESHOLD_TO_DOORBELL_SHFT                                        16
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_FETCH_SAME_POINTER_ERR_INT_REG_CLR_BMSK                            0x8000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_FETCH_SAME_POINTER_ERR_INT_REG_CLR_SHFT                                15
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_NUM_THRESHOLD_TO_DOORBELL_BMSK                                     0x7e00
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_NUM_THRESHOLD_TO_DOORBELL_SHFT                                          9
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_SRNG_SM_STATE3_BMSK                                                 0x180
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_SRNG_SM_STATE3_SHFT                                                     7
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_INTERVAL_OF_FETCH_POINTER_BMSK                                       0x70
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_INTERVAL_OF_FETCH_POINTER_SHFT                                          4
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_FETCH_SAME_POINTER_THRESHOLD_BMSK                                     0xf
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_FETCH_SAME_POINTER_THRESHOLD_SHFT                                       0

#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_ADDR(x)                                         ((x) + 0x60c)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_PHYS(x)                                         ((x) + 0x60c)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_OFFS                                            (0x60c)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_RMSK                                                0xffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_POR                                             0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_POR_RMSK                                        0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_ATTR                                                         0x3
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_MESSAGE_BMSK                                        0xffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_MLO_DOORBELL_PRESS_MESSAGE_SHFT                                             0

#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ADDR(x)                                     ((x) + 0x610)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_PHYS(x)                                     ((x) + 0x610)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_OFFS                                        (0x610)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_RMSK                                        0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_POR                                         0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_POR_RMSK                                    0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ATTR                                                     0x3
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_VALUE_BMSK                                  0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_LSB_VALUE_SHFT                                           0

#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ADDR(x)                                     ((x) + 0x614)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_PHYS(x)                                     ((x) + 0x614)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_OFFS                                        (0x614)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_RMSK                                              0xff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_POR                                         0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_POR_RMSK                                    0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ATTR                                                     0x3
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_VALUE_BMSK                                        0xff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_DOORBELL_RING_ADDR_MSB_VALUE_SHFT                                           0

#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_ADDR(x)                                      ((x) + 0x618)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_PHYS(x)                                      ((x) + 0x618)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_OFFS                                         (0x618)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_RMSK                                         0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_POR                                          0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_POR_RMSK                                     0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_ATTR                                                      0x3
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_VALUE_BMSK                                   0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_LSB_VALUE_SHFT                                            0

#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_ADDR(x)                                      ((x) + 0x61c)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_PHYS(x)                                      ((x) + 0x61c)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_OFFS                                         (0x61c)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_RMSK                                               0xff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_POR                                          0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_POR_RMSK                                     0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_ATTR                                                      0x3
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_VALUE_BMSK                                         0xff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_CONSUMER_POINTER_READ_ADDR_MSB_VALUE_SHFT                                            0

#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_1_ADDR(x)                                                              ((x) + 0x620)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_1_PHYS(x)                                                              ((x) + 0x620)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_1_OFFS                                                                 (0x620)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_1_RMSK                                                                 0xffff003f
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_1_POR                                                                  0x00000000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_1_POR_RMSK                                                             0xffffffff
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_1_ATTR                                                                              0x3
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_1_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_1_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_1_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_1_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_1_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_1_IN(x))
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                        0xffff0000
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                16
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                               0x3f
#define HWIO_TQM_R0_TQM2TQM_IN2_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                  0

#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_LSB_ADDR(x)                                                           ((x) + 0x624)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_LSB_PHYS(x)                                                           ((x) + 0x624)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_LSB_OFFS                                                              (0x624)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_LSB_RMSK                                                              0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_LSB_POR                                                               0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_LSB_POR_RMSK                                                          0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_LSB_ATTR                                                                           0x3
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_LSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                           0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                    0

#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_MSB_ADDR(x)                                                           ((x) + 0x628)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_MSB_PHYS(x)                                                           ((x) + 0x628)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_MSB_OFFS                                                              (0x628)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_MSB_RMSK                                                                0xffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_MSB_POR                                                               0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_MSB_POR_RMSK                                                          0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_MSB_ATTR                                                                           0x3
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_MSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_MSB_RING_SIZE_BMSK                                                      0xffff00
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_MSB_RING_SIZE_SHFT                                                             8
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                 0xff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                    0

#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_ID_ADDR(x)                                                                 ((x) + 0x62c)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_ID_PHYS(x)                                                                 ((x) + 0x62c)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_ID_OFFS                                                                    (0x62c)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_ID_RMSK                                                                        0xffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_ID_POR                                                                     0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_ID_POR_RMSK                                                                0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_ID_ATTR                                                                                 0x3
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_ID_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_ID_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT1_RING_ID_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_ID_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_ID_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT1_RING_ID_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT1_RING_ID_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_ID_RING_ID_BMSK                                                                0xff00
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_ID_RING_ID_SHFT                                                                     8
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_ID_ENTRY_SIZE_BMSK                                                               0xff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_ID_ENTRY_SIZE_SHFT                                                                  0

#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_STATUS_ADDR(x)                                                             ((x) + 0x630)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_STATUS_PHYS(x)                                                             ((x) + 0x630)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_STATUS_OFFS                                                                (0x630)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_STATUS_RMSK                                                                0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_STATUS_POR                                                                 0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_STATUS_POR_RMSK                                                            0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_STATUS_ATTR                                                                             0x1
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_STATUS_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT1_RING_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                0xffff0000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                        16
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_STATUS_NUM_VALID_WORDS_BMSK                                                    0xffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_STATUS_NUM_VALID_WORDS_SHFT                                                         0

#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_ADDR(x)                                                               ((x) + 0x634)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_PHYS(x)                                                               ((x) + 0x634)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_OFFS                                                                  (0x634)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_RMSK                                                                   0x7ffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_POR                                                                   0x00000080
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_POR_RMSK                                                              0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_ATTR                                                                               0x3
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                           0x4000000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                  26
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_LOOP_CNT_BMSK                                                          0x3c00000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_LOOP_CNT_SHFT                                                                 22
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_SPARE_CONTROL_BMSK                                                      0x3fc000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_SPARE_CONTROL_SHFT                                                            14
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_SRNG_SM_STATE2_BMSK                                                       0x3000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_SRNG_SM_STATE2_SHFT                                                           12
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_SRNG_SM_STATE1_BMSK                                                        0xf00
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_SRNG_SM_STATE1_SHFT                                                            8
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_SRNG_IS_IDLE_BMSK                                                           0x80
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_SRNG_IS_IDLE_SHFT                                                              7
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_SRNG_ENABLE_BMSK                                                            0x40
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_SRNG_ENABLE_SHFT                                                               6
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                      0x20
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                         5
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                       0x10
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                          4
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_MSI_SWAP_BIT_BMSK                                                            0x8
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_MSI_SWAP_BIT_SHFT                                                              3
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_SECURITY_BIT_BMSK                                                            0x4
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_SECURITY_BIT_SHFT                                                              2
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_LOOPCNT_DISABLE_BMSK                                                         0x2
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_LOOPCNT_DISABLE_SHFT                                                           1
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_RING_ID_DISABLE_BMSK                                                         0x1
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_RING_ID_DISABLE_SHFT                                                           0

#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_LSB_ADDR(x)                                                        ((x) + 0x638)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_LSB_PHYS(x)                                                        ((x) + 0x638)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_LSB_OFFS                                                           (0x638)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_LSB_RMSK                                                           0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_LSB_POR                                                            0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_LSB_POR_RMSK                                                       0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_LSB_ATTR                                                                        0x3
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_LSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                      0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                               0

#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_MSB_ADDR(x)                                                        ((x) + 0x63c)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_MSB_PHYS(x)                                                        ((x) + 0x63c)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_MSB_OFFS                                                           (0x63c)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_MSB_RMSK                                                                 0xff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_MSB_POR                                                            0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_MSB_POR_RMSK                                                       0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_MSB_ATTR                                                                        0x3
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_MSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                            0xff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                               0

#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_SETUP_ADDR(x)                                                 ((x) + 0x648)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_SETUP_PHYS(x)                                                 ((x) + 0x648)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_SETUP_OFFS                                                    (0x648)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_SETUP_RMSK                                                    0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_SETUP_POR                                                     0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_SETUP_POR_RMSK                                                0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_SETUP_ATTR                                                                 0x3
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                          0xffff0000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                  16
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                      0x8000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                          15
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                                0x7fff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                     0

#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_STATUS_ADDR(x)                                                ((x) + 0x64c)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_STATUS_PHYS(x)                                                ((x) + 0x64c)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_STATUS_OFFS                                                   (0x64c)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_STATUS_RMSK                                                   0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_STATUS_POR                                                    0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_STATUS_POR_RMSK                                               0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_STATUS_ATTR                                                                0x1
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                     0xffff0000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                             16
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                             0x8000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                 15
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                          0x7fff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                               0

#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                              ((x) + 0x650)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                              ((x) + 0x650)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_FULL_COUNTER_OFFS                                                 (0x650)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_FULL_COUNTER_RMSK                                                      0x3ff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_FULL_COUNTER_POR                                                  0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                             0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_FULL_COUNTER_ATTR                                                              0x3
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                    0x3ff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                        0

#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_LSB_ADDR(x)                                                      ((x) + 0x66c)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_LSB_PHYS(x)                                                      ((x) + 0x66c)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_LSB_OFFS                                                         (0x66c)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_LSB_RMSK                                                         0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_LSB_POR                                                          0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_LSB_ATTR                                                                      0x3
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_LSB_ADDR_BMSK                                                    0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_LSB_ADDR_SHFT                                                             0

#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_MSB_ADDR(x)                                                      ((x) + 0x670)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_MSB_PHYS(x)                                                      ((x) + 0x670)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_MSB_OFFS                                                         (0x670)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_MSB_RMSK                                                              0x1ff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_MSB_POR                                                          0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_MSB_ATTR                                                                      0x3
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                  0x100
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                      8
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_MSB_ADDR_BMSK                                                          0xff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_BASE_MSB_ADDR_SHFT                                                             0

#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_DATA_ADDR(x)                                                          ((x) + 0x674)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_DATA_PHYS(x)                                                          ((x) + 0x674)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_DATA_OFFS                                                             (0x674)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_DATA_RMSK                                                             0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_DATA_POR                                                              0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_DATA_POR_RMSK                                                         0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_DATA_ATTR                                                                          0x3
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_DATA_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_DATA_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_DATA_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_DATA_VALUE_BMSK                                                       0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI1_DATA_VALUE_SHFT                                                                0

#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT2_SETUP_ADDR(x)                                                ((x) + 0x678)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT2_SETUP_PHYS(x)                                                ((x) + 0x678)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT2_SETUP_OFFS                                                   (0x678)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT2_SETUP_RMSK                                                   0xffc0ffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT2_SETUP_POR                                                    0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT2_SETUP_POR_RMSK                                               0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT2_SETUP_ATTR                                                                0x3
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                        0xff000000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                                24
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                         0x800000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                               23
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                       0x400000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                             22
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                        0xffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                             0

#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_LSB_ADDR(x)                                                      ((x) + 0x67c)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_LSB_PHYS(x)                                                      ((x) + 0x67c)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_LSB_OFFS                                                         (0x67c)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_LSB_RMSK                                                         0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_LSB_POR                                                          0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_LSB_ATTR                                                                      0x3
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_LSB_ADDR_BMSK                                                    0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_LSB_ADDR_SHFT                                                             0

#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_MSB_ADDR(x)                                                      ((x) + 0x680)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_MSB_PHYS(x)                                                      ((x) + 0x680)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_MSB_OFFS                                                         (0x680)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_MSB_RMSK                                                              0x1ff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_MSB_POR                                                          0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_MSB_ATTR                                                                      0x3
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                  0x100
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                      8
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_MSB_ADDR_BMSK                                                          0xff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_BASE_MSB_ADDR_SHFT                                                             0

#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_DATA_ADDR(x)                                                          ((x) + 0x684)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_DATA_PHYS(x)                                                          ((x) + 0x684)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_DATA_OFFS                                                             (0x684)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_DATA_RMSK                                                             0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_DATA_POR                                                              0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_DATA_POR_RMSK                                                         0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_DATA_ATTR                                                                          0x3
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_DATA_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_DATA_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_DATA_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_DATA_VALUE_BMSK                                                       0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MSI2_DATA_VALUE_SHFT                                                                0

#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_TP_SW_OFFSET_ADDR(x)                                                    ((x) + 0x694)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_TP_SW_OFFSET_PHYS(x)                                                    ((x) + 0x694)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_TP_SW_OFFSET_OFFS                                                       (0x694)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_TP_SW_OFFSET_RMSK                                                           0xffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_TP_SW_OFFSET_POR                                                        0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_TP_SW_OFFSET_POR_RMSK                                                   0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_TP_SW_OFFSET_ATTR                                                                    0x3
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                        0xffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                             0

#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_ADDR(x)                                                       ((x) + 0x698)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_PHYS(x)                                                       ((x) + 0x698)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_OFFS                                                          (0x698)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_RMSK                                                          0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_POR                                                           0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_POR_RMSK                                                      0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_ATTR                                                                       0x3
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_TIME_THRESHOLD_TO_DOORBELL_BMSK                               0xffff0000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_TIME_THRESHOLD_TO_DOORBELL_SHFT                                       16
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_FETCH_SAME_POINTER_ERR_INT_REG_CLR_BMSK                           0x8000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_FETCH_SAME_POINTER_ERR_INT_REG_CLR_SHFT                               15
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_NUM_THRESHOLD_TO_DOORBELL_BMSK                                    0x7e00
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_NUM_THRESHOLD_TO_DOORBELL_SHFT                                         9
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_SRNG_SM_STATE3_BMSK                                                0x180
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_SRNG_SM_STATE3_SHFT                                                    7
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_INTERVAL_OF_FETCH_POINTER_BMSK                                      0x70
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_INTERVAL_OF_FETCH_POINTER_SHFT                                         4
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_FETCH_SAME_POINTER_THRESHOLD_BMSK                                    0xf
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_FETCH_SAME_POINTER_THRESHOLD_SHFT                                      0

#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_ADDR(x)                                        ((x) + 0x69c)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_PHYS(x)                                        ((x) + 0x69c)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_OFFS                                           (0x69c)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_RMSK                                               0xffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_POR                                            0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_POR_RMSK                                       0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_ATTR                                                        0x3
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_MESSAGE_BMSK                                       0xffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_MLO_DOORBELL_PRESS_MESSAGE_SHFT                                            0

#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_ADDR(x)                                    ((x) + 0x6a0)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_PHYS(x)                                    ((x) + 0x6a0)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_OFFS                                       (0x6a0)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_RMSK                                       0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_POR                                        0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_POR_RMSK                                   0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_ATTR                                                    0x3
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_VALUE_BMSK                                 0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_VALUE_SHFT                                          0

#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_ADDR(x)                                    ((x) + 0x6a4)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_PHYS(x)                                    ((x) + 0x6a4)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_OFFS                                       (0x6a4)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_RMSK                                             0xff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_POR                                        0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_POR_RMSK                                   0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_ATTR                                                    0x3
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_VALUE_BMSK                                       0xff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_VALUE_SHFT                                          0

#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_ADDR(x)                                     ((x) + 0x6a8)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_PHYS(x)                                     ((x) + 0x6a8)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_OFFS                                        (0x6a8)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_RMSK                                        0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_POR                                         0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_POR_RMSK                                    0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_ATTR                                                     0x3
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_VALUE_BMSK                                  0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_LSB_VALUE_SHFT                                           0

#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_ADDR(x)                                     ((x) + 0x6ac)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_PHYS(x)                                     ((x) + 0x6ac)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_OFFS                                        (0x6ac)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_RMSK                                              0xff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_POR                                         0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_POR_RMSK                                    0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_ATTR                                                     0x3
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_VALUE_BMSK                                        0xff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_PRODUCER_POINTER_READ_ADDR_MSB_VALUE_SHFT                                           0

#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_1_ADDR(x)                                                             ((x) + 0x6b0)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_1_PHYS(x)                                                             ((x) + 0x6b0)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_1_OFFS                                                                (0x6b0)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_1_RMSK                                                                0xffff003f
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_1_POR                                                                 0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_1_POR_RMSK                                                            0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_1_ATTR                                                                             0x3
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_1_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_1_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_1_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_1_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_1_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_1_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                       0xffff0000
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                               16
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                              0x3f
#define HWIO_TQM_R0_TQM2TQM_OUT1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                 0

#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_LSB_ADDR(x)                                                           ((x) + 0x6b4)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_LSB_PHYS(x)                                                           ((x) + 0x6b4)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_LSB_OFFS                                                              (0x6b4)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_LSB_RMSK                                                              0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_LSB_POR                                                               0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_LSB_POR_RMSK                                                          0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_LSB_ATTR                                                                           0x3
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_LSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                           0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                    0

#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_MSB_ADDR(x)                                                           ((x) + 0x6b8)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_MSB_PHYS(x)                                                           ((x) + 0x6b8)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_MSB_OFFS                                                              (0x6b8)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_MSB_RMSK                                                                0xffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_MSB_POR                                                               0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_MSB_POR_RMSK                                                          0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_MSB_ATTR                                                                           0x3
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_MSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_MSB_RING_SIZE_BMSK                                                      0xffff00
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_MSB_RING_SIZE_SHFT                                                             8
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                 0xff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                    0

#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_ID_ADDR(x)                                                                 ((x) + 0x6bc)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_ID_PHYS(x)                                                                 ((x) + 0x6bc)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_ID_OFFS                                                                    (0x6bc)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_ID_RMSK                                                                        0xffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_ID_POR                                                                     0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_ID_POR_RMSK                                                                0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_ID_ATTR                                                                                 0x3
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_ID_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_ID_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT2_RING_ID_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_ID_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_ID_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT2_RING_ID_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT2_RING_ID_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_ID_RING_ID_BMSK                                                                0xff00
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_ID_RING_ID_SHFT                                                                     8
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_ID_ENTRY_SIZE_BMSK                                                               0xff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_ID_ENTRY_SIZE_SHFT                                                                  0

#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_STATUS_ADDR(x)                                                             ((x) + 0x6c0)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_STATUS_PHYS(x)                                                             ((x) + 0x6c0)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_STATUS_OFFS                                                                (0x6c0)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_STATUS_RMSK                                                                0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_STATUS_POR                                                                 0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_STATUS_POR_RMSK                                                            0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_STATUS_ATTR                                                                             0x1
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_STATUS_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT2_RING_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                0xffff0000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                        16
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_STATUS_NUM_VALID_WORDS_BMSK                                                    0xffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_STATUS_NUM_VALID_WORDS_SHFT                                                         0

#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_ADDR(x)                                                               ((x) + 0x6c4)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_PHYS(x)                                                               ((x) + 0x6c4)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_OFFS                                                                  (0x6c4)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_RMSK                                                                   0x7ffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_POR                                                                   0x00000080
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_POR_RMSK                                                              0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_ATTR                                                                               0x3
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                           0x4000000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                  26
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_LOOP_CNT_BMSK                                                          0x3c00000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_LOOP_CNT_SHFT                                                                 22
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_SPARE_CONTROL_BMSK                                                      0x3fc000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_SPARE_CONTROL_SHFT                                                            14
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_SRNG_SM_STATE2_BMSK                                                       0x3000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_SRNG_SM_STATE2_SHFT                                                           12
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_SRNG_SM_STATE1_BMSK                                                        0xf00
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_SRNG_SM_STATE1_SHFT                                                            8
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_SRNG_IS_IDLE_BMSK                                                           0x80
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_SRNG_IS_IDLE_SHFT                                                              7
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_SRNG_ENABLE_BMSK                                                            0x40
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_SRNG_ENABLE_SHFT                                                               6
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                      0x20
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                         5
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                       0x10
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                          4
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_MSI_SWAP_BIT_BMSK                                                            0x8
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_MSI_SWAP_BIT_SHFT                                                              3
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_SECURITY_BIT_BMSK                                                            0x4
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_SECURITY_BIT_SHFT                                                              2
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_LOOPCNT_DISABLE_BMSK                                                         0x2
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_LOOPCNT_DISABLE_SHFT                                                           1
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_RING_ID_DISABLE_BMSK                                                         0x1
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_RING_ID_DISABLE_SHFT                                                           0

#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_LSB_ADDR(x)                                                        ((x) + 0x6c8)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_LSB_PHYS(x)                                                        ((x) + 0x6c8)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_LSB_OFFS                                                           (0x6c8)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_LSB_RMSK                                                           0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_LSB_POR                                                            0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_LSB_POR_RMSK                                                       0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_LSB_ATTR                                                                        0x3
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_LSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                      0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                               0

#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_MSB_ADDR(x)                                                        ((x) + 0x6cc)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_MSB_PHYS(x)                                                        ((x) + 0x6cc)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_MSB_OFFS                                                           (0x6cc)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_MSB_RMSK                                                                 0xff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_MSB_POR                                                            0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_MSB_POR_RMSK                                                       0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_MSB_ATTR                                                                        0x3
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_MSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                            0xff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                               0

#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_SETUP_ADDR(x)                                                 ((x) + 0x6d8)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_SETUP_PHYS(x)                                                 ((x) + 0x6d8)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_SETUP_OFFS                                                    (0x6d8)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_SETUP_RMSK                                                    0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_SETUP_POR                                                     0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_SETUP_POR_RMSK                                                0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_SETUP_ATTR                                                                 0x3
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                          0xffff0000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                  16
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                      0x8000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                          15
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                                0x7fff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                     0

#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_STATUS_ADDR(x)                                                ((x) + 0x6dc)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_STATUS_PHYS(x)                                                ((x) + 0x6dc)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_STATUS_OFFS                                                   (0x6dc)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_STATUS_RMSK                                                   0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_STATUS_POR                                                    0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_STATUS_POR_RMSK                                               0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_STATUS_ATTR                                                                0x1
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                     0xffff0000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                             16
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                             0x8000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                 15
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                          0x7fff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                               0

#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                              ((x) + 0x6e0)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                              ((x) + 0x6e0)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_FULL_COUNTER_OFFS                                                 (0x6e0)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_FULL_COUNTER_RMSK                                                      0x3ff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_FULL_COUNTER_POR                                                  0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                             0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_FULL_COUNTER_ATTR                                                              0x3
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                    0x3ff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                        0

#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_LSB_ADDR(x)                                                      ((x) + 0x6fc)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_LSB_PHYS(x)                                                      ((x) + 0x6fc)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_LSB_OFFS                                                         (0x6fc)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_LSB_RMSK                                                         0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_LSB_POR                                                          0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_LSB_ATTR                                                                      0x3
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_LSB_ADDR_BMSK                                                    0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_LSB_ADDR_SHFT                                                             0

#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_MSB_ADDR(x)                                                      ((x) + 0x700)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_MSB_PHYS(x)                                                      ((x) + 0x700)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_MSB_OFFS                                                         (0x700)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_MSB_RMSK                                                              0x1ff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_MSB_POR                                                          0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_MSB_ATTR                                                                      0x3
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                  0x100
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                      8
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_MSB_ADDR_BMSK                                                          0xff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_BASE_MSB_ADDR_SHFT                                                             0

#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_DATA_ADDR(x)                                                          ((x) + 0x704)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_DATA_PHYS(x)                                                          ((x) + 0x704)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_DATA_OFFS                                                             (0x704)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_DATA_RMSK                                                             0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_DATA_POR                                                              0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_DATA_POR_RMSK                                                         0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_DATA_ATTR                                                                          0x3
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_DATA_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_DATA_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_DATA_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_DATA_VALUE_BMSK                                                       0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI1_DATA_VALUE_SHFT                                                                0

#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT2_SETUP_ADDR(x)                                                ((x) + 0x708)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT2_SETUP_PHYS(x)                                                ((x) + 0x708)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT2_SETUP_OFFS                                                   (0x708)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT2_SETUP_RMSK                                                   0xffc0ffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT2_SETUP_POR                                                    0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT2_SETUP_POR_RMSK                                               0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT2_SETUP_ATTR                                                                0x3
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                        0xff000000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                                24
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                         0x800000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                               23
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                       0x400000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                             22
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                        0xffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                             0

#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_LSB_ADDR(x)                                                      ((x) + 0x70c)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_LSB_PHYS(x)                                                      ((x) + 0x70c)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_LSB_OFFS                                                         (0x70c)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_LSB_RMSK                                                         0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_LSB_POR                                                          0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_LSB_ATTR                                                                      0x3
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_LSB_ADDR_BMSK                                                    0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_LSB_ADDR_SHFT                                                             0

#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_MSB_ADDR(x)                                                      ((x) + 0x710)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_MSB_PHYS(x)                                                      ((x) + 0x710)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_MSB_OFFS                                                         (0x710)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_MSB_RMSK                                                              0x1ff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_MSB_POR                                                          0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_MSB_ATTR                                                                      0x3
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                  0x100
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                      8
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_MSB_ADDR_BMSK                                                          0xff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_BASE_MSB_ADDR_SHFT                                                             0

#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_DATA_ADDR(x)                                                          ((x) + 0x714)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_DATA_PHYS(x)                                                          ((x) + 0x714)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_DATA_OFFS                                                             (0x714)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_DATA_RMSK                                                             0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_DATA_POR                                                              0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_DATA_POR_RMSK                                                         0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_DATA_ATTR                                                                          0x3
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_DATA_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_DATA_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_DATA_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_DATA_VALUE_BMSK                                                       0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MSI2_DATA_VALUE_SHFT                                                                0

#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_TP_SW_OFFSET_ADDR(x)                                                    ((x) + 0x724)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_TP_SW_OFFSET_PHYS(x)                                                    ((x) + 0x724)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_TP_SW_OFFSET_OFFS                                                       (0x724)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_TP_SW_OFFSET_RMSK                                                           0xffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_TP_SW_OFFSET_POR                                                        0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_TP_SW_OFFSET_POR_RMSK                                                   0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_TP_SW_OFFSET_ATTR                                                                    0x3
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                        0xffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                             0

#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_ADDR(x)                                                       ((x) + 0x728)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_PHYS(x)                                                       ((x) + 0x728)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_OFFS                                                          (0x728)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_RMSK                                                          0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_POR                                                           0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_POR_RMSK                                                      0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_ATTR                                                                       0x3
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_TIME_THRESHOLD_TO_DOORBELL_BMSK                               0xffff0000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_TIME_THRESHOLD_TO_DOORBELL_SHFT                                       16
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_FETCH_SAME_POINTER_ERR_INT_REG_CLR_BMSK                           0x8000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_FETCH_SAME_POINTER_ERR_INT_REG_CLR_SHFT                               15
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_NUM_THRESHOLD_TO_DOORBELL_BMSK                                    0x7e00
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_NUM_THRESHOLD_TO_DOORBELL_SHFT                                         9
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_SRNG_SM_STATE3_BMSK                                                0x180
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_SRNG_SM_STATE3_SHFT                                                    7
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_INTERVAL_OF_FETCH_POINTER_BMSK                                      0x70
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_INTERVAL_OF_FETCH_POINTER_SHFT                                         4
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_FETCH_SAME_POINTER_THRESHOLD_BMSK                                    0xf
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_FETCH_SAME_POINTER_THRESHOLD_SHFT                                      0

#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_ADDR(x)                                        ((x) + 0x72c)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_PHYS(x)                                        ((x) + 0x72c)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_OFFS                                           (0x72c)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_RMSK                                               0xffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_POR                                            0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_POR_RMSK                                       0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_ATTR                                                        0x3
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_MESSAGE_BMSK                                       0xffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_MLO_DOORBELL_PRESS_MESSAGE_SHFT                                            0

#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_ADDR(x)                                    ((x) + 0x730)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_PHYS(x)                                    ((x) + 0x730)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_OFFS                                       (0x730)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_RMSK                                       0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_POR                                        0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_POR_RMSK                                   0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_ATTR                                                    0x3
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_VALUE_BMSK                                 0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_LSB_VALUE_SHFT                                          0

#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_ADDR(x)                                    ((x) + 0x734)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_PHYS(x)                                    ((x) + 0x734)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_OFFS                                       (0x734)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_RMSK                                             0xff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_POR                                        0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_POR_RMSK                                   0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_ATTR                                                    0x3
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_VALUE_BMSK                                       0xff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_DOORBELL_RING_ADDR_MSB_VALUE_SHFT                                          0

#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_ADDR(x)                                     ((x) + 0x738)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_PHYS(x)                                     ((x) + 0x738)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_OFFS                                        (0x738)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_RMSK                                        0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_POR                                         0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_POR_RMSK                                    0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_ATTR                                                     0x3
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_VALUE_BMSK                                  0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_LSB_VALUE_SHFT                                           0

#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_ADDR(x)                                     ((x) + 0x73c)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_PHYS(x)                                     ((x) + 0x73c)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_OFFS                                        (0x73c)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_RMSK                                              0xff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_POR                                         0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_POR_RMSK                                    0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_ATTR                                                     0x3
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_VALUE_BMSK                                        0xff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_PRODUCER_POINTER_READ_ADDR_MSB_VALUE_SHFT                                           0

#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_1_ADDR(x)                                                             ((x) + 0x740)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_1_PHYS(x)                                                             ((x) + 0x740)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_1_OFFS                                                                (0x740)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_1_RMSK                                                                0xffff003f
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_1_POR                                                                 0x00000000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_1_POR_RMSK                                                            0xffffffff
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_1_ATTR                                                                             0x3
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_1_IN(x)            \
                in_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_1_ADDR(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_1_ADDR(x), m)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_1_ADDR(x),v)
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_1_ADDR(x),m,v,HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_1_IN(x))
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                       0xffff0000
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                               16
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                              0x3f
#define HWIO_TQM_R0_TQM2TQM_OUT2_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                 0

#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_A_ADDR(x)                                                          ((x) + 0x744)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_A_PHYS(x)                                                          ((x) + 0x744)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_A_OFFS                                                             (0x744)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_A_RMSK                                                              0x3ff03ff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_A_POR                                                              0x01df0190
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_A_POR_RMSK                                                         0xffffffff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_A_ATTR                                                                          0x3
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_A_IN(x)            \
                in_dword(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_A_ADDR(x))
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_A_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_A_ADDR(x), m)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_A_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_A_ADDR(x),v)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_A_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_A_ADDR(x),m,v,HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_A_IN(x))
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_A_END_ADDR_BMSK                                                     0x3ff0000
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_A_END_ADDR_SHFT                                                            16
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_A_START_ADDR_BMSK                                                       0x3ff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_A_START_ADDR_SHFT                                                           0

#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_B_ADDR(x)                                                          ((x) + 0x748)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_B_PHYS(x)                                                          ((x) + 0x748)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_B_OFFS                                                             (0x748)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_B_RMSK                                                              0x3ff03ff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_B_POR                                                              0x022f01e0
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_B_POR_RMSK                                                         0xffffffff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_B_ATTR                                                                          0x3
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_B_IN(x)            \
                in_dword(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_B_ADDR(x))
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_B_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_B_ADDR(x), m)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_B_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_B_ADDR(x),v)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_B_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_B_ADDR(x),m,v,HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_B_IN(x))
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_B_END_ADDR_BMSK                                                     0x3ff0000
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_B_END_ADDR_SHFT                                                            16
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_B_START_ADDR_BMSK                                                       0x3ff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_B_START_ADDR_SHFT                                                           0

#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_C_ADDR(x)                                                          ((x) + 0x74c)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_C_PHYS(x)                                                          ((x) + 0x74c)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_C_OFFS                                                             (0x74c)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_C_RMSK                                                              0x3ff03ff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_C_POR                                                              0x027f0230
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_C_POR_RMSK                                                         0xffffffff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_C_ATTR                                                                          0x3
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_C_IN(x)            \
                in_dword(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_C_ADDR(x))
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_C_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_C_ADDR(x), m)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_C_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_C_ADDR(x),v)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_C_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_C_ADDR(x),m,v,HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_C_IN(x))
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_C_END_ADDR_BMSK                                                     0x3ff0000
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_C_END_ADDR_SHFT                                                            16
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_C_START_ADDR_BMSK                                                       0x3ff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_C_START_ADDR_SHFT                                                           0

#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_D_ADDR(x)                                                          ((x) + 0x750)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_D_PHYS(x)                                                          ((x) + 0x750)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_D_OFFS                                                             (0x750)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_D_RMSK                                                              0x3ff03ff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_D_POR                                                              0x02cf0280
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_D_POR_RMSK                                                         0xffffffff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_D_ATTR                                                                          0x3
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_D_IN(x)            \
                in_dword(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_D_ADDR(x))
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_D_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_D_ADDR(x), m)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_D_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_D_ADDR(x),v)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_D_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_D_ADDR(x),m,v,HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_D_IN(x))
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_D_END_ADDR_BMSK                                                     0x3ff0000
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_D_END_ADDR_SHFT                                                            16
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_D_START_ADDR_BMSK                                                       0x3ff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_D_START_ADDR_SHFT                                                           0

#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_E_ADDR(x)                                                          ((x) + 0x754)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_E_PHYS(x)                                                          ((x) + 0x754)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_E_OFFS                                                             (0x754)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_E_RMSK                                                              0x3ff03ff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_E_POR                                                              0x02e702d0
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_E_POR_RMSK                                                         0xffffffff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_E_ATTR                                                                          0x3
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_E_IN(x)            \
                in_dword(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_E_ADDR(x))
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_E_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_E_ADDR(x), m)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_E_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_E_ADDR(x),v)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_E_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_E_ADDR(x),m,v,HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_E_IN(x))
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_E_END_ADDR_BMSK                                                     0x3ff0000
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_E_END_ADDR_SHFT                                                            16
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_E_START_ADDR_BMSK                                                       0x3ff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_E_START_ADDR_SHFT                                                           0

#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_F_ADDR(x)                                                          ((x) + 0x758)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_F_PHYS(x)                                                          ((x) + 0x758)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_F_OFFS                                                             (0x758)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_F_RMSK                                                              0x3ff03ff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_F_POR                                                              0x02ff02e8
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_F_POR_RMSK                                                         0xffffffff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_F_ATTR                                                                          0x3
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_F_IN(x)            \
                in_dword(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_F_ADDR(x))
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_F_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_F_ADDR(x), m)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_F_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_F_ADDR(x),v)
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_F_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_F_ADDR(x),m,v,HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_F_IN(x))
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_F_END_ADDR_BMSK                                                     0x3ff0000
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_F_END_ADDR_SHFT                                                            16
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_F_START_ADDR_BMSK                                                       0x3ff
#define HWIO_TQM_R0_PREFETCH_MEMORY_PARTITION_F_START_ADDR_SHFT                                                           0

#define HWIO_TQM_R0_MLO_CHIP_ID_ADDR(x)                                                                          ((x) + 0x75c)
#define HWIO_TQM_R0_MLO_CHIP_ID_PHYS(x)                                                                          ((x) + 0x75c)
#define HWIO_TQM_R0_MLO_CHIP_ID_OFFS                                                                             (0x75c)
#define HWIO_TQM_R0_MLO_CHIP_ID_RMSK                                                                                    0x3
#define HWIO_TQM_R0_MLO_CHIP_ID_POR                                                                              0x00000000
#define HWIO_TQM_R0_MLO_CHIP_ID_POR_RMSK                                                                         0xffffffff
#define HWIO_TQM_R0_MLO_CHIP_ID_ATTR                                                                                          0x3
#define HWIO_TQM_R0_MLO_CHIP_ID_IN(x)            \
                in_dword(HWIO_TQM_R0_MLO_CHIP_ID_ADDR(x))
#define HWIO_TQM_R0_MLO_CHIP_ID_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_MLO_CHIP_ID_ADDR(x), m)
#define HWIO_TQM_R0_MLO_CHIP_ID_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_MLO_CHIP_ID_ADDR(x),v)
#define HWIO_TQM_R0_MLO_CHIP_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_MLO_CHIP_ID_ADDR(x),m,v,HWIO_TQM_R0_MLO_CHIP_ID_IN(x))
#define HWIO_TQM_R0_MLO_CHIP_ID_VALUE_BMSK                                                                              0x3
#define HWIO_TQM_R0_MLO_CHIP_ID_VALUE_SHFT                                                                                0

#define HWIO_TQM_R0_MLO_VC_ID_ADDR(x)                                                                            ((x) + 0x760)
#define HWIO_TQM_R0_MLO_VC_ID_PHYS(x)                                                                            ((x) + 0x760)
#define HWIO_TQM_R0_MLO_VC_ID_OFFS                                                                               (0x760)
#define HWIO_TQM_R0_MLO_VC_ID_RMSK                                                                                      0xf
#define HWIO_TQM_R0_MLO_VC_ID_POR                                                                                0x00000000
#define HWIO_TQM_R0_MLO_VC_ID_POR_RMSK                                                                           0xffffffff
#define HWIO_TQM_R0_MLO_VC_ID_ATTR                                                                                            0x3
#define HWIO_TQM_R0_MLO_VC_ID_IN(x)            \
                in_dword(HWIO_TQM_R0_MLO_VC_ID_ADDR(x))
#define HWIO_TQM_R0_MLO_VC_ID_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_MLO_VC_ID_ADDR(x), m)
#define HWIO_TQM_R0_MLO_VC_ID_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_MLO_VC_ID_ADDR(x),v)
#define HWIO_TQM_R0_MLO_VC_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_MLO_VC_ID_ADDR(x),m,v,HWIO_TQM_R0_MLO_VC_ID_IN(x))
#define HWIO_TQM_R0_MLO_VC_ID_TQM2TQM_OUT2_MLO_P_SRNG_BMSK                                                              0x8
#define HWIO_TQM_R0_MLO_VC_ID_TQM2TQM_OUT2_MLO_P_SRNG_SHFT                                                                3
#define HWIO_TQM_R0_MLO_VC_ID_TQM2TQM_OUT1_MLO_P_SRNG_BMSK                                                              0x4
#define HWIO_TQM_R0_MLO_VC_ID_TQM2TQM_OUT1_MLO_P_SRNG_SHFT                                                                2
#define HWIO_TQM_R0_MLO_VC_ID_TQM2TQM_IN2_MLO_C_SRNG_BMSK                                                               0x2
#define HWIO_TQM_R0_MLO_VC_ID_TQM2TQM_IN2_MLO_C_SRNG_SHFT                                                                 1
#define HWIO_TQM_R0_MLO_VC_ID_TQM2TQM_IN1_MLO_C_SRNG_BMSK                                                               0x1
#define HWIO_TQM_R0_MLO_VC_ID_TQM2TQM_IN1_MLO_C_SRNG_SHFT                                                                 0

#define HWIO_TQM_R0_MLO_GXI_TRANSFER_PRIORITY_ADDR(x)                                                            ((x) + 0x764)
#define HWIO_TQM_R0_MLO_GXI_TRANSFER_PRIORITY_PHYS(x)                                                            ((x) + 0x764)
#define HWIO_TQM_R0_MLO_GXI_TRANSFER_PRIORITY_OFFS                                                               (0x764)
#define HWIO_TQM_R0_MLO_GXI_TRANSFER_PRIORITY_RMSK                                                                     0xff
#define HWIO_TQM_R0_MLO_GXI_TRANSFER_PRIORITY_POR                                                                0x00000000
#define HWIO_TQM_R0_MLO_GXI_TRANSFER_PRIORITY_POR_RMSK                                                           0xffffffff
#define HWIO_TQM_R0_MLO_GXI_TRANSFER_PRIORITY_ATTR                                                                            0x3
#define HWIO_TQM_R0_MLO_GXI_TRANSFER_PRIORITY_IN(x)            \
                in_dword(HWIO_TQM_R0_MLO_GXI_TRANSFER_PRIORITY_ADDR(x))
#define HWIO_TQM_R0_MLO_GXI_TRANSFER_PRIORITY_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_MLO_GXI_TRANSFER_PRIORITY_ADDR(x), m)
#define HWIO_TQM_R0_MLO_GXI_TRANSFER_PRIORITY_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_MLO_GXI_TRANSFER_PRIORITY_ADDR(x),v)
#define HWIO_TQM_R0_MLO_GXI_TRANSFER_PRIORITY_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_MLO_GXI_TRANSFER_PRIORITY_ADDR(x),m,v,HWIO_TQM_R0_MLO_GXI_TRANSFER_PRIORITY_IN(x))
#define HWIO_TQM_R0_MLO_GXI_TRANSFER_PRIORITY_TQM2TQM_OUT2_SRNG_P_MLO_BMSK                                             0xc0
#define HWIO_TQM_R0_MLO_GXI_TRANSFER_PRIORITY_TQM2TQM_OUT2_SRNG_P_MLO_SHFT                                                6
#define HWIO_TQM_R0_MLO_GXI_TRANSFER_PRIORITY_TQM2TQM_OUT1_SRNG_P_MLO_BMSK                                             0x30
#define HWIO_TQM_R0_MLO_GXI_TRANSFER_PRIORITY_TQM2TQM_OUT1_SRNG_P_MLO_SHFT                                                4
#define HWIO_TQM_R0_MLO_GXI_TRANSFER_PRIORITY_TQM2TQM_IN2_SRNG_C_MLO_BMSK                                               0xc
#define HWIO_TQM_R0_MLO_GXI_TRANSFER_PRIORITY_TQM2TQM_IN2_SRNG_C_MLO_SHFT                                                 2
#define HWIO_TQM_R0_MLO_GXI_TRANSFER_PRIORITY_TQM2TQM_IN1_SRNG_C_MLO_BMSK                                               0x3
#define HWIO_TQM_R0_MLO_GXI_TRANSFER_PRIORITY_TQM2TQM_IN1_SRNG_C_MLO_SHFT                                                 0

#define HWIO_TQM_R0_MLO_POSTED_WRITE_CTRL_ADDR(x)                                                                ((x) + 0x768)
#define HWIO_TQM_R0_MLO_POSTED_WRITE_CTRL_PHYS(x)                                                                ((x) + 0x768)
#define HWIO_TQM_R0_MLO_POSTED_WRITE_CTRL_OFFS                                                                   (0x768)
#define HWIO_TQM_R0_MLO_POSTED_WRITE_CTRL_RMSK                                                                          0x3
#define HWIO_TQM_R0_MLO_POSTED_WRITE_CTRL_POR                                                                    0x00000000
#define HWIO_TQM_R0_MLO_POSTED_WRITE_CTRL_POR_RMSK                                                               0xffffffff
#define HWIO_TQM_R0_MLO_POSTED_WRITE_CTRL_ATTR                                                                                0x3
#define HWIO_TQM_R0_MLO_POSTED_WRITE_CTRL_IN(x)            \
                in_dword(HWIO_TQM_R0_MLO_POSTED_WRITE_CTRL_ADDR(x))
#define HWIO_TQM_R0_MLO_POSTED_WRITE_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_MLO_POSTED_WRITE_CTRL_ADDR(x), m)
#define HWIO_TQM_R0_MLO_POSTED_WRITE_CTRL_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_MLO_POSTED_WRITE_CTRL_ADDR(x),v)
#define HWIO_TQM_R0_MLO_POSTED_WRITE_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_MLO_POSTED_WRITE_CTRL_ADDR(x),m,v,HWIO_TQM_R0_MLO_POSTED_WRITE_CTRL_IN(x))
#define HWIO_TQM_R0_MLO_POSTED_WRITE_CTRL_TQM2TQM_OUT2_BMSK                                                             0x2
#define HWIO_TQM_R0_MLO_POSTED_WRITE_CTRL_TQM2TQM_OUT2_SHFT                                                               1
#define HWIO_TQM_R0_MLO_POSTED_WRITE_CTRL_TQM2TQM_OUT1_BMSK                                                             0x1
#define HWIO_TQM_R0_MLO_POSTED_WRITE_CTRL_TQM2TQM_OUT1_SHFT                                                               0

#define HWIO_TQM_R0_MLO_STATUS_WRITE_CTRL_ADDR(x)                                                                ((x) + 0x76c)
#define HWIO_TQM_R0_MLO_STATUS_WRITE_CTRL_PHYS(x)                                                                ((x) + 0x76c)
#define HWIO_TQM_R0_MLO_STATUS_WRITE_CTRL_OFFS                                                                   (0x76c)
#define HWIO_TQM_R0_MLO_STATUS_WRITE_CTRL_RMSK                                                                        0xfff
#define HWIO_TQM_R0_MLO_STATUS_WRITE_CTRL_POR                                                                    0x00000003
#define HWIO_TQM_R0_MLO_STATUS_WRITE_CTRL_POR_RMSK                                                               0xffffffff
#define HWIO_TQM_R0_MLO_STATUS_WRITE_CTRL_ATTR                                                                                0x3
#define HWIO_TQM_R0_MLO_STATUS_WRITE_CTRL_IN(x)            \
                in_dword(HWIO_TQM_R0_MLO_STATUS_WRITE_CTRL_ADDR(x))
#define HWIO_TQM_R0_MLO_STATUS_WRITE_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R0_MLO_STATUS_WRITE_CTRL_ADDR(x), m)
#define HWIO_TQM_R0_MLO_STATUS_WRITE_CTRL_OUT(x, v)            \
                out_dword(HWIO_TQM_R0_MLO_STATUS_WRITE_CTRL_ADDR(x),v)
#define HWIO_TQM_R0_MLO_STATUS_WRITE_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R0_MLO_STATUS_WRITE_CTRL_ADDR(x),m,v,HWIO_TQM_R0_MLO_STATUS_WRITE_CTRL_IN(x))
#define HWIO_TQM_R0_MLO_STATUS_WRITE_CTRL_TQM2TQM_OUT2_WRITE_THRESHOLD_BMSK                                           0xf00
#define HWIO_TQM_R0_MLO_STATUS_WRITE_CTRL_TQM2TQM_OUT2_WRITE_THRESHOLD_SHFT                                               8
#define HWIO_TQM_R0_MLO_STATUS_WRITE_CTRL_TQM2TQM_OUT1_WRITE_THRESHOLD_BMSK                                            0xf0
#define HWIO_TQM_R0_MLO_STATUS_WRITE_CTRL_TQM2TQM_OUT1_WRITE_THRESHOLD_SHFT                                               4
#define HWIO_TQM_R0_MLO_STATUS_WRITE_CTRL_TQM2TQM_OUT2_ISSUE_MULTIPLE_TLVS_BMSK                                         0x8
#define HWIO_TQM_R0_MLO_STATUS_WRITE_CTRL_TQM2TQM_OUT2_ISSUE_MULTIPLE_TLVS_SHFT                                           3
#define HWIO_TQM_R0_MLO_STATUS_WRITE_CTRL_TQM2TQM_OUT1_ISSUE_MULTIPLE_TLVS_BMSK                                         0x4
#define HWIO_TQM_R0_MLO_STATUS_WRITE_CTRL_TQM2TQM_OUT1_ISSUE_MULTIPLE_TLVS_SHFT                                           2
#define HWIO_TQM_R0_MLO_STATUS_WRITE_CTRL_ENB_TQM2TQM_OUT2_BMSK                                                         0x2
#define HWIO_TQM_R0_MLO_STATUS_WRITE_CTRL_ENB_TQM2TQM_OUT2_SHFT                                                           1
#define HWIO_TQM_R0_MLO_STATUS_WRITE_CTRL_ENB_TQM2TQM_OUT1_BMSK                                                         0x1
#define HWIO_TQM_R0_MLO_STATUS_WRITE_CTRL_ENB_TQM2TQM_OUT1_SHFT                                                           0

#define HWIO_TQM_R1_CACHE_CTL_DEBUG_CONTROL_ADDR(x)                                                              ((x) + 0x2000)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_CONTROL_PHYS(x)                                                              ((x) + 0x2000)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_CONTROL_OFFS                                                                 (0x2000)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_CONTROL_RMSK                                                                     0x1fff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_CONTROL_POR                                                                  0x00001000
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_CONTROL_POR_RMSK                                                             0xffffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_CONTROL_ATTR                                                                              0x3
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_CONTROL_IN(x)            \
                in_dword(HWIO_TQM_R1_CACHE_CTL_DEBUG_CONTROL_ADDR(x))
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_CONTROL_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_CACHE_CTL_DEBUG_CONTROL_ADDR(x), m)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_CONTROL_OUT(x, v)            \
                out_dword(HWIO_TQM_R1_CACHE_CTL_DEBUG_CONTROL_ADDR(x),v)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_CONTROL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R1_CACHE_CTL_DEBUG_CONTROL_ADDR(x),m,v,HWIO_TQM_R1_CACHE_CTL_DEBUG_CONTROL_IN(x))
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_CONTROL_CACHE_CMD_HOLD_ACK_BMSK                                                  0x1000
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_CONTROL_CACHE_CMD_HOLD_ACK_SHFT                                                      12
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_CONTROL_CACHE_CMD_HOLD_BMSK                                                       0x800
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_CONTROL_CACHE_CMD_HOLD_SHFT                                                          11
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_CONTROL_TAG_TABLE_UPDATE_BMSK                                                     0x400
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_CONTROL_TAG_TABLE_UPDATE_SHFT                                                        10
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_CONTROL_TAG_TABLE_SEL_BMSK                                                        0x3ff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_CONTROL_TAG_TABLE_SEL_SHFT                                                            0

#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HIT_COUNT_ADDR(x)                                                            ((x) + 0x2004)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HIT_COUNT_PHYS(x)                                                            ((x) + 0x2004)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HIT_COUNT_OFFS                                                               (0x2004)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HIT_COUNT_RMSK                                                               0xffffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HIT_COUNT_POR                                                                0x00000000
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HIT_COUNT_POR_RMSK                                                           0xffffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HIT_COUNT_ATTR                                                                            0x3
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HIT_COUNT_IN(x)            \
                in_dword(HWIO_TQM_R1_CACHE_CTL_DEBUG_HIT_COUNT_ADDR(x))
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HIT_COUNT_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_CACHE_CTL_DEBUG_HIT_COUNT_ADDR(x), m)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HIT_COUNT_OUT(x, v)            \
                out_dword(HWIO_TQM_R1_CACHE_CTL_DEBUG_HIT_COUNT_ADDR(x),v)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HIT_COUNT_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R1_CACHE_CTL_DEBUG_HIT_COUNT_ADDR(x),m,v,HWIO_TQM_R1_CACHE_CTL_DEBUG_HIT_COUNT_IN(x))
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HIT_COUNT_CACHE_HIT_COUNT_BMSK                                               0xffffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HIT_COUNT_CACHE_HIT_COUNT_SHFT                                                        0

#define HWIO_TQM_R1_CACHE_CTL_DEBUG_MISS_COUNT_ADDR(x)                                                           ((x) + 0x2008)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_MISS_COUNT_PHYS(x)                                                           ((x) + 0x2008)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_MISS_COUNT_OFFS                                                              (0x2008)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_MISS_COUNT_RMSK                                                                0xffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_MISS_COUNT_POR                                                               0x00000000
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_MISS_COUNT_POR_RMSK                                                          0xffffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_MISS_COUNT_ATTR                                                                           0x3
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_MISS_COUNT_IN(x)            \
                in_dword(HWIO_TQM_R1_CACHE_CTL_DEBUG_MISS_COUNT_ADDR(x))
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_MISS_COUNT_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_CACHE_CTL_DEBUG_MISS_COUNT_ADDR(x), m)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_MISS_COUNT_OUT(x, v)            \
                out_dword(HWIO_TQM_R1_CACHE_CTL_DEBUG_MISS_COUNT_ADDR(x),v)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_MISS_COUNT_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R1_CACHE_CTL_DEBUG_MISS_COUNT_ADDR(x),m,v,HWIO_TQM_R1_CACHE_CTL_DEBUG_MISS_COUNT_IN(x))
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_MISS_COUNT_CACHE_MISS_COUNT_BMSK                                               0xffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_MISS_COUNT_CACHE_MISS_COUNT_SHFT                                                      0

#define HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_ADDR(x)                                                        ((x) + 0x200c)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_PHYS(x)                                                        ((x) + 0x200c)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_OFFS                                                           (0x200c)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_RMSK                                                           0xffffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_POR                                                            0x00000000
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_POR_RMSK                                                       0xffffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_ATTR                                                                        0x3
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_IN(x)            \
                in_dword(HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_ADDR(x))
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_ADDR(x), m)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_OUT(x, v)            \
                out_dword(HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_ADDR(x),v)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_ADDR(x),m,v,HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_IN(x))
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_OVERWRITE_BMSK                                                 0xffffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_LOW_OVERWRITE_SHFT                                                          0

#define HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_ADDR(x)                                                       ((x) + 0x2010)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_PHYS(x)                                                       ((x) + 0x2010)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_OFFS                                                          (0x2010)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_RMSK                                                          0xffffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_POR                                                           0x00000000
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_POR_RMSK                                                      0xffffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_ATTR                                                                       0x3
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_IN(x)            \
                in_dword(HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_ADDR(x))
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_ADDR(x), m)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_OUT(x, v)            \
                out_dword(HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_ADDR(x),v)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_ADDR(x),m,v,HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_IN(x))
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_OVERWRITE_BMSK                                                0xffffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_TAG_TABLE_HIGH_OVERWRITE_SHFT                                                         0

#define HWIO_TQM_R1_CACHE_CTL_DEBUG_STM_ADDR(x)                                                                  ((x) + 0x2014)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_STM_PHYS(x)                                                                  ((x) + 0x2014)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_STM_OFFS                                                                     (0x2014)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_STM_RMSK                                                                      0x1ffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_STM_POR                                                                      0x00000000
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_STM_POR_RMSK                                                                 0xffffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_STM_ATTR                                                                                  0x1
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_STM_IN(x)            \
                in_dword(HWIO_TQM_R1_CACHE_CTL_DEBUG_STM_ADDR(x))
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_STM_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_CACHE_CTL_DEBUG_STM_ADDR(x), m)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_STM_STATE_BMSK                                                                0x1ffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_STM_STATE_SHFT                                                                        0

#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST_ADDR(x)                                                            ((x) + 0x2018)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST_PHYS(x)                                                            ((x) + 0x2018)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST_OFFS                                                               (0x2018)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST_RMSK                                                                 0x3fffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST_POR                                                                0x00000000
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST_POR_RMSK                                                           0xffffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST_ATTR                                                                            0x1
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST_IN(x)            \
                in_dword(HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST_ADDR(x))
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST_ADDR(x), m)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST_MRU_FLAG_BMSK                                                        0x3ff800
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST_MRU_FLAG_SHFT                                                              11
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST_LRU_FLAG_BMSK                                                           0x7ff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST_LRU_FLAG_SHFT                                                               0

#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST1_ADDR(x)                                                           ((x) + 0x201c)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST1_PHYS(x)                                                           ((x) + 0x201c)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST1_OFFS                                                              (0x201c)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST1_RMSK                                                                0x3fffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST1_POR                                                               0x00000000
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST1_POR_RMSK                                                          0xffffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST1_ATTR                                                                           0x1
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST1_IN(x)            \
                in_dword(HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST1_ADDR(x))
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST1_ADDR(x), m)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST1_HEAD_FLAG_BMSK                                                      0x3ff800
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST1_HEAD_FLAG_SHFT                                                            11
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST1_TAIL_FLAG_BMSK                                                         0x7ff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST1_TAIL_FLAG_SHFT                                                             0

#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST2_ADDR(x)                                                           ((x) + 0x2020)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST2_PHYS(x)                                                           ((x) + 0x2020)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST2_OFFS                                                              (0x2020)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST2_RMSK                                                                0x3fffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST2_POR                                                               0x00000000
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST2_POR_RMSK                                                          0xffffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST2_ATTR                                                                           0x1
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST2_IN(x)            \
                in_dword(HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST2_ADDR(x))
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST2_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST2_ADDR(x), m)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST2_MRU_FLAG_SET2_BMSK                                                  0x3ff800
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST2_MRU_FLAG_SET2_SHFT                                                        11
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST2_LRU_FLAG_SET2_BMSK                                                     0x7ff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST2_LRU_FLAG_SET2_SHFT                                                         0

#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST3_ADDR(x)                                                           ((x) + 0x2024)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST3_PHYS(x)                                                           ((x) + 0x2024)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST3_OFFS                                                              (0x2024)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST3_RMSK                                                                0x3fffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST3_POR                                                               0x00000000
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST3_POR_RMSK                                                          0xffffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST3_ATTR                                                                           0x1
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST3_IN(x)            \
                in_dword(HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST3_ADDR(x))
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST3_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST3_ADDR(x), m)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST3_HEAD_FLAG_SET2_BMSK                                                 0x3ff800
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST3_HEAD_FLAG_SET2_SHFT                                                       11
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST3_TAIL_FLAG_SET2_BMSK                                                    0x7ff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_LINK_LIST3_TAIL_FLAG_SET2_SHFT                                                        0

#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_LOW_ADDR(x)                                                      ((x) + 0x2028)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_LOW_PHYS(x)                                                      ((x) + 0x2028)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_LOW_OFFS                                                         (0x2028)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_LOW_RMSK                                                         0xffffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_LOW_POR                                                          0x00000000
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_LOW_POR_RMSK                                                     0xffffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_LOW_ATTR                                                                      0x1
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_LOW_IN(x)            \
                in_dword(HWIO_TQM_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_LOW_ADDR(x))
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_LOW_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_LOW_ADDR(x), m)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_LOW_VALUE_BMSK                                                   0xffffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_LOW_VALUE_SHFT                                                            0

#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_HIGH_ADDR(x)                                                     ((x) + 0x202c)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_HIGH_PHYS(x)                                                     ((x) + 0x202c)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_HIGH_OFFS                                                        (0x202c)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_HIGH_RMSK                                                        0xffffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_HIGH_POR                                                         0x00000000
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_HIGH_POR_RMSK                                                    0xffffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_HIGH_ATTR                                                                     0x1
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_HIGH_IN(x)            \
                in_dword(HWIO_TQM_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_HIGH_ADDR(x))
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_HIGH_ADDR(x), m)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_HIGH_VALUE_BMSK                                                  0xffffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_HW_ERR_INFO_HIGH_VALUE_SHFT                                                           0

#define HWIO_TQM_R1_CACHE_CTL_DEBUG_EMPTY_LINE_COUNTER_ADDR(x)                                                   ((x) + 0x2030)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_EMPTY_LINE_COUNTER_PHYS(x)                                                   ((x) + 0x2030)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_EMPTY_LINE_COUNTER_OFFS                                                      (0x2030)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_EMPTY_LINE_COUNTER_RMSK                                                         0xfffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_EMPTY_LINE_COUNTER_POR                                                       0x00000000
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_EMPTY_LINE_COUNTER_POR_RMSK                                                  0xffffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_EMPTY_LINE_COUNTER_ATTR                                                                   0x1
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_EMPTY_LINE_COUNTER_IN(x)            \
                in_dword(HWIO_TQM_R1_CACHE_CTL_DEBUG_EMPTY_LINE_COUNTER_ADDR(x))
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_EMPTY_LINE_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_CACHE_CTL_DEBUG_EMPTY_LINE_COUNTER_ADDR(x), m)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_EMPTY_LINE_COUNTER_SET2_BMSK                                                    0xffc00
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_EMPTY_LINE_COUNTER_SET2_SHFT                                                         10
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_EMPTY_LINE_COUNTER_SET1_BMSK                                                      0x3ff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_EMPTY_LINE_COUNTER_SET1_SHFT                                                          0

#define HWIO_TQM_R1_CACHE_CTL_END_OF_TEST_CHECK_ADDR(x)                                                          ((x) + 0x2034)
#define HWIO_TQM_R1_CACHE_CTL_END_OF_TEST_CHECK_PHYS(x)                                                          ((x) + 0x2034)
#define HWIO_TQM_R1_CACHE_CTL_END_OF_TEST_CHECK_OFFS                                                             (0x2034)
#define HWIO_TQM_R1_CACHE_CTL_END_OF_TEST_CHECK_RMSK                                                                    0x1
#define HWIO_TQM_R1_CACHE_CTL_END_OF_TEST_CHECK_POR                                                              0x00000000
#define HWIO_TQM_R1_CACHE_CTL_END_OF_TEST_CHECK_POR_RMSK                                                         0xffffffff
#define HWIO_TQM_R1_CACHE_CTL_END_OF_TEST_CHECK_ATTR                                                                          0x3
#define HWIO_TQM_R1_CACHE_CTL_END_OF_TEST_CHECK_IN(x)            \
                in_dword(HWIO_TQM_R1_CACHE_CTL_END_OF_TEST_CHECK_ADDR(x))
#define HWIO_TQM_R1_CACHE_CTL_END_OF_TEST_CHECK_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_CACHE_CTL_END_OF_TEST_CHECK_ADDR(x), m)
#define HWIO_TQM_R1_CACHE_CTL_END_OF_TEST_CHECK_OUT(x, v)            \
                out_dword(HWIO_TQM_R1_CACHE_CTL_END_OF_TEST_CHECK_ADDR(x),v)
#define HWIO_TQM_R1_CACHE_CTL_END_OF_TEST_CHECK_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R1_CACHE_CTL_END_OF_TEST_CHECK_ADDR(x),m,v,HWIO_TQM_R1_CACHE_CTL_END_OF_TEST_CHECK_IN(x))
#define HWIO_TQM_R1_CACHE_CTL_END_OF_TEST_CHECK_END_OF_TEST_SELF_CHECK_BMSK                                             0x1
#define HWIO_TQM_R1_CACHE_CTL_END_OF_TEST_CHECK_END_OF_TEST_SELF_CHECK_SHFT                                               0

#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_ADDR(x)                                                        ((x) + 0x2038)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_PHYS(x)                                                        ((x) + 0x2038)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_OFFS                                                           (0x2038)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_RMSK                                                                0x7ff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_POR                                                            0x00000000
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_POR_RMSK                                                       0xffffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_ATTR                                                                        0x3
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_IN(x)            \
                in_dword(HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_ADDR(x))
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_ADDR(x), m)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_OUT(x, v)            \
                out_dword(HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_ADDR(x),v)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_ADDR(x),m,v,HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_IN(x))
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_BACKUP_BMSK                                                         0x7f8
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_BACKUP_SHFT                                                             3
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_FLUSH_WITHOUT_INVALIDATE_BMSK                                         0x4
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_FLUSH_WITHOUT_INVALIDATE_SHFT                                           2
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_FLUSH_ENTIRE_CACHE_BMSK                                               0x2
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_FLUSH_ENTIRE_CACHE_SHFT                                                 1
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_FLUSH_REQ_BMSK                                                        0x1
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG1_FLUSH_REQ_SHFT                                                          0

#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_ADDR(x)                                                        ((x) + 0x203c)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_PHYS(x)                                                        ((x) + 0x203c)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_OFFS                                                           (0x203c)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_RMSK                                                           0xffffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_POR                                                            0x00000000
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_POR_RMSK                                                       0xffffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_ATTR                                                                        0x3
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_IN(x)            \
                in_dword(HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_ADDR(x))
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_ADDR(x), m)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_OUT(x, v)            \
                out_dword(HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_ADDR(x),v)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_ADDR(x),m,v,HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_IN(x))
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_FLUSH_ADDR_31_0_BMSK                                           0xffffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG2_FLUSH_ADDR_31_0_SHFT                                                    0

#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_ADDR(x)                                                        ((x) + 0x2040)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_PHYS(x)                                                        ((x) + 0x2040)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_OFFS                                                           (0x2040)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_RMSK                                                                 0xff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_POR                                                            0x00000000
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_POR_RMSK                                                       0xffffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_ATTR                                                                        0x3
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_IN(x)            \
                in_dword(HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_ADDR(x))
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_ADDR(x), m)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_OUT(x, v)            \
                out_dword(HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_ADDR(x),v)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_ADDR(x),m,v,HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_IN(x))
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_FLUSH_ADDR_39_32_BMSK                                                0xff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_CONFIG3_FLUSH_ADDR_39_32_SHFT                                                   0

#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_ADDR(x)                                                         ((x) + 0x2044)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_PHYS(x)                                                         ((x) + 0x2044)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_OFFS                                                            (0x2044)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_RMSK                                                            0x3fffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_POR                                                             0x00000001
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_POR_RMSK                                                        0xffffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_ATTR                                                                         0x1
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_ADDR(x))
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_ADDR(x), m)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_BACKUP_BMSK                                                     0x3fc00000
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_BACKUP_SHFT                                                             22
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_FLUSH_COUNT_BMSK                                                  0x3ff000
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_FLUSH_COUNT_SHFT                                                        12
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_FLUSH_STATUS_HW_IF_BUSY_BMSK                                         0x800
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_FLUSH_STATUS_HW_IF_BUSY_SHFT                                            11
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_FLUSH_STATUS_ERROR_BMSK                                              0x600
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_FLUSH_STATUS_ERROR_SHFT                                                  9
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_FLUSH_STATUS_CLIENT_ID_BMSK                                          0x1e0
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_FLUSH_STATUS_CLIENT_ID_SHFT                                              5
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_FLUSH_STATUS_DESC_TYPE_BMSK                                           0x1c
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_FLUSH_STATUS_DESC_TYPE_SHFT                                              2
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_FLUSH_STATUS_HIT_BMSK                                                  0x2
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_FLUSH_STATUS_HIT_SHFT                                                    1
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_FLUSH_DONE_BMSK                                                        0x1
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_FLUSH_STATUS_FLUSH_DONE_SHFT                                                          0

#define HWIO_TQM_R1_CACHE_CTL_DEBUG_OWNER_CHECK_ADDR(x)                                                          ((x) + 0x2048)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_OWNER_CHECK_PHYS(x)                                                          ((x) + 0x2048)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_OWNER_CHECK_OFFS                                                             (0x2048)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_OWNER_CHECK_RMSK                                                                   0xff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_OWNER_CHECK_POR                                                              0x00000000
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_OWNER_CHECK_POR_RMSK                                                         0xffffffff
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_OWNER_CHECK_ATTR                                                                          0x1
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_OWNER_CHECK_IN(x)            \
                in_dword(HWIO_TQM_R1_CACHE_CTL_DEBUG_OWNER_CHECK_ADDR(x))
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_OWNER_CHECK_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_CACHE_CTL_DEBUG_OWNER_CHECK_ADDR(x), m)
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_OWNER_CHECK_ACT_ADDR_BMSK                                                          0xf0
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_OWNER_CHECK_ACT_ADDR_SHFT                                                             4
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_OWNER_CHECK_EXP_ADDR_BMSK                                                           0xf
#define HWIO_TQM_R1_CACHE_CTL_DEBUG_OWNER_CHECK_EXP_ADDR_SHFT                                                             0

#define HWIO_TQM_R1_PREFETCH_BUF_ADDR(x)                                                                         ((x) + 0x204c)
#define HWIO_TQM_R1_PREFETCH_BUF_PHYS(x)                                                                         ((x) + 0x204c)
#define HWIO_TQM_R1_PREFETCH_BUF_OFFS                                                                            (0x204c)
#define HWIO_TQM_R1_PREFETCH_BUF_RMSK                                                                                 0x7ff
#define HWIO_TQM_R1_PREFETCH_BUF_POR                                                                             0x00000000
#define HWIO_TQM_R1_PREFETCH_BUF_POR_RMSK                                                                        0xffffffff
#define HWIO_TQM_R1_PREFETCH_BUF_ATTR                                                                                         0x3
#define HWIO_TQM_R1_PREFETCH_BUF_IN(x)            \
                in_dword(HWIO_TQM_R1_PREFETCH_BUF_ADDR(x))
#define HWIO_TQM_R1_PREFETCH_BUF_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_PREFETCH_BUF_ADDR(x), m)
#define HWIO_TQM_R1_PREFETCH_BUF_OUT(x, v)            \
                out_dword(HWIO_TQM_R1_PREFETCH_BUF_ADDR(x),v)
#define HWIO_TQM_R1_PREFETCH_BUF_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R1_PREFETCH_BUF_ADDR(x),m,v,HWIO_TQM_R1_PREFETCH_BUF_IN(x))
#define HWIO_TQM_R1_PREFETCH_BUF_ADDR_BMSK                                                                            0x7ff
#define HWIO_TQM_R1_PREFETCH_BUF_ADDR_SHFT                                                                                0

#define HWIO_TQM_R1_PREFETCH_BUF_DATA_ADDR(x)                                                                    ((x) + 0x2050)
#define HWIO_TQM_R1_PREFETCH_BUF_DATA_PHYS(x)                                                                    ((x) + 0x2050)
#define HWIO_TQM_R1_PREFETCH_BUF_DATA_OFFS                                                                       (0x2050)
#define HWIO_TQM_R1_PREFETCH_BUF_DATA_RMSK                                                                       0xffffffff
#define HWIO_TQM_R1_PREFETCH_BUF_DATA_POR                                                                        0x00000000
#define HWIO_TQM_R1_PREFETCH_BUF_DATA_POR_RMSK                                                                   0xffffffff
#define HWIO_TQM_R1_PREFETCH_BUF_DATA_ATTR                                                                                    0x1
#define HWIO_TQM_R1_PREFETCH_BUF_DATA_IN(x)            \
                in_dword(HWIO_TQM_R1_PREFETCH_BUF_DATA_ADDR(x))
#define HWIO_TQM_R1_PREFETCH_BUF_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_PREFETCH_BUF_DATA_ADDR(x), m)
#define HWIO_TQM_R1_PREFETCH_BUF_DATA_VALUE_BMSK                                                                 0xffffffff
#define HWIO_TQM_R1_PREFETCH_BUF_DATA_VALUE_SHFT                                                                          0

#define HWIO_TQM_R1_CACHE_BUF_ADDR(x)                                                                            ((x) + 0x2054)
#define HWIO_TQM_R1_CACHE_BUF_PHYS(x)                                                                            ((x) + 0x2054)
#define HWIO_TQM_R1_CACHE_BUF_OFFS                                                                               (0x2054)
#define HWIO_TQM_R1_CACHE_BUF_RMSK                                                                                   0x7fff
#define HWIO_TQM_R1_CACHE_BUF_POR                                                                                0x00000000
#define HWIO_TQM_R1_CACHE_BUF_POR_RMSK                                                                           0xffffffff
#define HWIO_TQM_R1_CACHE_BUF_ATTR                                                                                            0x3
#define HWIO_TQM_R1_CACHE_BUF_IN(x)            \
                in_dword(HWIO_TQM_R1_CACHE_BUF_ADDR(x))
#define HWIO_TQM_R1_CACHE_BUF_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_CACHE_BUF_ADDR(x), m)
#define HWIO_TQM_R1_CACHE_BUF_OUT(x, v)            \
                out_dword(HWIO_TQM_R1_CACHE_BUF_ADDR(x),v)
#define HWIO_TQM_R1_CACHE_BUF_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R1_CACHE_BUF_ADDR(x),m,v,HWIO_TQM_R1_CACHE_BUF_IN(x))
#define HWIO_TQM_R1_CACHE_BUF_ADDR_BMSK                                                                              0x7fff
#define HWIO_TQM_R1_CACHE_BUF_ADDR_SHFT                                                                                   0

#define HWIO_TQM_R1_CACHE_BUF_DATA_ADDR(x)                                                                       ((x) + 0x2058)
#define HWIO_TQM_R1_CACHE_BUF_DATA_PHYS(x)                                                                       ((x) + 0x2058)
#define HWIO_TQM_R1_CACHE_BUF_DATA_OFFS                                                                          (0x2058)
#define HWIO_TQM_R1_CACHE_BUF_DATA_RMSK                                                                          0xffffffff
#define HWIO_TQM_R1_CACHE_BUF_DATA_POR                                                                           0x00000000
#define HWIO_TQM_R1_CACHE_BUF_DATA_POR_RMSK                                                                      0xffffffff
#define HWIO_TQM_R1_CACHE_BUF_DATA_ATTR                                                                                       0x1
#define HWIO_TQM_R1_CACHE_BUF_DATA_IN(x)            \
                in_dword(HWIO_TQM_R1_CACHE_BUF_DATA_ADDR(x))
#define HWIO_TQM_R1_CACHE_BUF_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_CACHE_BUF_DATA_ADDR(x), m)
#define HWIO_TQM_R1_CACHE_BUF_DATA_VALUE_BMSK                                                                    0xffffffff
#define HWIO_TQM_R1_CACHE_BUF_DATA_VALUE_SHFT                                                                             0

#define HWIO_TQM_R1_MISC_DEBUG_CTRL_ADDR(x)                                                                      ((x) + 0x205c)
#define HWIO_TQM_R1_MISC_DEBUG_CTRL_PHYS(x)                                                                      ((x) + 0x205c)
#define HWIO_TQM_R1_MISC_DEBUG_CTRL_OFFS                                                                         (0x205c)
#define HWIO_TQM_R1_MISC_DEBUG_CTRL_RMSK                                                                                0x3
#define HWIO_TQM_R1_MISC_DEBUG_CTRL_POR                                                                          0x00000000
#define HWIO_TQM_R1_MISC_DEBUG_CTRL_POR_RMSK                                                                     0xffffffff
#define HWIO_TQM_R1_MISC_DEBUG_CTRL_ATTR                                                                                      0x3
#define HWIO_TQM_R1_MISC_DEBUG_CTRL_IN(x)            \
                in_dword(HWIO_TQM_R1_MISC_DEBUG_CTRL_ADDR(x))
#define HWIO_TQM_R1_MISC_DEBUG_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_MISC_DEBUG_CTRL_ADDR(x), m)
#define HWIO_TQM_R1_MISC_DEBUG_CTRL_OUT(x, v)            \
                out_dword(HWIO_TQM_R1_MISC_DEBUG_CTRL_ADDR(x),v)
#define HWIO_TQM_R1_MISC_DEBUG_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R1_MISC_DEBUG_CTRL_ADDR(x),m,v,HWIO_TQM_R1_MISC_DEBUG_CTRL_IN(x))
#define HWIO_TQM_R1_MISC_DEBUG_CTRL_IDLE_REQ_BMSK                                                                       0x2
#define HWIO_TQM_R1_MISC_DEBUG_CTRL_IDLE_REQ_SHFT                                                                         1
#define HWIO_TQM_R1_MISC_DEBUG_CTRL_IDLE_REQ_DONE_BMSK                                                                  0x1
#define HWIO_TQM_R1_MISC_DEBUG_CTRL_IDLE_REQ_DONE_SHFT                                                                    0

#define HWIO_TQM_R1_LOG_ADDR(x)                                                                                  ((x) + 0x2060)
#define HWIO_TQM_R1_LOG_PHYS(x)                                                                                  ((x) + 0x2060)
#define HWIO_TQM_R1_LOG_OFFS                                                                                     (0x2060)
#define HWIO_TQM_R1_LOG_RMSK                                                                                      0xfffffff
#define HWIO_TQM_R1_LOG_POR                                                                                      0x0fffffff
#define HWIO_TQM_R1_LOG_POR_RMSK                                                                                 0xffffffff
#define HWIO_TQM_R1_LOG_ATTR                                                                                                  0x1
#define HWIO_TQM_R1_LOG_IN(x)            \
                in_dword(HWIO_TQM_R1_LOG_ADDR(x))
#define HWIO_TQM_R1_LOG_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_LOG_ADDR(x), m)
#define HWIO_TQM_R1_LOG_CURR_CMD_IDX_BMSK                                                                         0xf000000
#define HWIO_TQM_R1_LOG_CURR_CMD_IDX_SHFT                                                                                24
#define HWIO_TQM_R1_LOG_CURR_CMD_NUM_BMSK                                                                          0xffffff
#define HWIO_TQM_R1_LOG_CURR_CMD_NUM_SHFT                                                                                 0

#define HWIO_TQM_R1_BANK_SM_STATES_IX0_ADDR(x)                                                                   ((x) + 0x2064)
#define HWIO_TQM_R1_BANK_SM_STATES_IX0_PHYS(x)                                                                   ((x) + 0x2064)
#define HWIO_TQM_R1_BANK_SM_STATES_IX0_OFFS                                                                      (0x2064)
#define HWIO_TQM_R1_BANK_SM_STATES_IX0_RMSK                                                                      0x3fffffff
#define HWIO_TQM_R1_BANK_SM_STATES_IX0_POR                                                                       0x00000000
#define HWIO_TQM_R1_BANK_SM_STATES_IX0_POR_RMSK                                                                  0xffffffff
#define HWIO_TQM_R1_BANK_SM_STATES_IX0_ATTR                                                                                   0x1
#define HWIO_TQM_R1_BANK_SM_STATES_IX0_IN(x)            \
                in_dword(HWIO_TQM_R1_BANK_SM_STATES_IX0_ADDR(x))
#define HWIO_TQM_R1_BANK_SM_STATES_IX0_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_BANK_SM_STATES_IX0_ADDR(x), m)
#define HWIO_TQM_R1_BANK_SM_STATES_IX0_GET_QUEUE_STATS_SM_BMSK                                                   0x3e000000
#define HWIO_TQM_R1_BANK_SM_STATES_IX0_GET_QUEUE_STATS_SM_SHFT                                                           25
#define HWIO_TQM_R1_BANK_SM_STATES_IX0_GET_MPDU_HEAD_INFO_SM_BMSK                                                 0x1e00000
#define HWIO_TQM_R1_BANK_SM_STATES_IX0_GET_MPDU_HEAD_INFO_SM_SHFT                                                        21
#define HWIO_TQM_R1_BANK_SM_STATES_IX0_FLUSH_AND_UNBLOCK_CACHE_SM_BMSK                                             0x180000
#define HWIO_TQM_R1_BANK_SM_STATES_IX0_FLUSH_AND_UNBLOCK_CACHE_SM_SHFT                                                   19
#define HWIO_TQM_R1_BANK_SM_STATES_IX0_ADD_MPDU_LINK_SM_BMSK                                                        0x78000
#define HWIO_TQM_R1_BANK_SM_STATES_IX0_ADD_MPDU_LINK_SM_SHFT                                                             15
#define HWIO_TQM_R1_BANK_SM_STATES_IX0_CREATE_MPDU_SM_BMSK                                                           0x7c00
#define HWIO_TQM_R1_BANK_SM_STATES_IX0_CREATE_MPDU_SM_SHFT                                                               10
#define HWIO_TQM_R1_BANK_SM_STATES_IX0_GEN_MPDU_SM_BMSK                                                               0x3e0
#define HWIO_TQM_R1_BANK_SM_STATES_IX0_GEN_MPDU_SM_SHFT                                                                   5
#define HWIO_TQM_R1_BANK_SM_STATES_IX0_ADD_MSDU_SM_BMSK                                                                0x1f
#define HWIO_TQM_R1_BANK_SM_STATES_IX0_ADD_MSDU_SM_SHFT                                                                   0

#define HWIO_TQM_R1_BANK_SM_STATES_IX1_ADDR(x)                                                                   ((x) + 0x2068)
#define HWIO_TQM_R1_BANK_SM_STATES_IX1_PHYS(x)                                                                   ((x) + 0x2068)
#define HWIO_TQM_R1_BANK_SM_STATES_IX1_OFFS                                                                      (0x2068)
#define HWIO_TQM_R1_BANK_SM_STATES_IX1_RMSK                                                                      0xffffffff
#define HWIO_TQM_R1_BANK_SM_STATES_IX1_POR                                                                       0x00000000
#define HWIO_TQM_R1_BANK_SM_STATES_IX1_POR_RMSK                                                                  0xffffffff
#define HWIO_TQM_R1_BANK_SM_STATES_IX1_ATTR                                                                                   0x1
#define HWIO_TQM_R1_BANK_SM_STATES_IX1_IN(x)            \
                in_dword(HWIO_TQM_R1_BANK_SM_STATES_IX1_ADDR(x))
#define HWIO_TQM_R1_BANK_SM_STATES_IX1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_BANK_SM_STATES_IX1_ADDR(x), m)
#define HWIO_TQM_R1_BANK_SM_STATES_IX1_ARB_STATUS_BLK1_SM_BMSK                                                   0xc0000000
#define HWIO_TQM_R1_BANK_SM_STATES_IX1_ARB_STATUS_BLK1_SM_SHFT                                                           30
#define HWIO_TQM_R1_BANK_SM_STATES_IX1_ARB_STATUS_BLK0_SM_BMSK                                                   0x30000000
#define HWIO_TQM_R1_BANK_SM_STATES_IX1_ARB_STATUS_BLK0_SM_SHFT                                                           28
#define HWIO_TQM_R1_BANK_SM_STATES_IX1_UPDATE_TX_MPDU_COUNT_SM_BMSK                                               0xf800000
#define HWIO_TQM_R1_BANK_SM_STATES_IX1_UPDATE_TX_MPDU_COUNT_SM_SHFT                                                      23
#define HWIO_TQM_R1_BANK_SM_STATES_IX1_REM_MSDU_SM_BMSK                                                            0x7c0000
#define HWIO_TQM_R1_BANK_SM_STATES_IX1_REM_MSDU_SM_SHFT                                                                  18
#define HWIO_TQM_R1_BANK_SM_STATES_IX1_REM_MPDU_SM_BMSK                                                             0x3f000
#define HWIO_TQM_R1_BANK_SM_STATES_IX1_REM_MPDU_SM_SHFT                                                                  12
#define HWIO_TQM_R1_BANK_SM_STATES_IX1_WRITE_CMD_SM_BMSK                                                              0xe00
#define HWIO_TQM_R1_BANK_SM_STATES_IX1_WRITE_CMD_SM_SHFT                                                                  9
#define HWIO_TQM_R1_BANK_SM_STATES_IX1_LIST_MPDU_MAIN_SM_BMSK                                                         0x1f0
#define HWIO_TQM_R1_BANK_SM_STATES_IX1_LIST_MPDU_MAIN_SM_SHFT                                                             4
#define HWIO_TQM_R1_BANK_SM_STATES_IX1_LIST_TLV_SM_BMSK                                                                 0xf
#define HWIO_TQM_R1_BANK_SM_STATES_IX1_LIST_TLV_SM_SHFT                                                                   0

#define HWIO_TQM_R1_BANK_SM_STATES_IX2_ADDR(x)                                                                   ((x) + 0x206c)
#define HWIO_TQM_R1_BANK_SM_STATES_IX2_PHYS(x)                                                                   ((x) + 0x206c)
#define HWIO_TQM_R1_BANK_SM_STATES_IX2_OFFS                                                                      (0x206c)
#define HWIO_TQM_R1_BANK_SM_STATES_IX2_RMSK                                                                      0xffffffff
#define HWIO_TQM_R1_BANK_SM_STATES_IX2_POR                                                                       0x00000000
#define HWIO_TQM_R1_BANK_SM_STATES_IX2_POR_RMSK                                                                  0xffffffff
#define HWIO_TQM_R1_BANK_SM_STATES_IX2_ATTR                                                                                   0x1
#define HWIO_TQM_R1_BANK_SM_STATES_IX2_IN(x)            \
                in_dword(HWIO_TQM_R1_BANK_SM_STATES_IX2_ADDR(x))
#define HWIO_TQM_R1_BANK_SM_STATES_IX2_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_BANK_SM_STATES_IX2_ADDR(x), m)
#define HWIO_TQM_R1_BANK_SM_STATES_IX2_ARB_ASYNC_SM_BMSK                                                         0x80000000
#define HWIO_TQM_R1_BANK_SM_STATES_IX2_ARB_ASYNC_SM_SHFT                                                                 31
#define HWIO_TQM_R1_BANK_SM_STATES_IX2_ARB_MSDU_ENT_SM_BMSK                                                      0x70000000
#define HWIO_TQM_R1_BANK_SM_STATES_IX2_ARB_MSDU_ENT_SM_SHFT                                                              28
#define HWIO_TQM_R1_BANK_SM_STATES_IX2_ARB_SW_CMD_SM_BMSK                                                         0xf000000
#define HWIO_TQM_R1_BANK_SM_STATES_IX2_ARB_SW_CMD_SM_SHFT                                                                24
#define HWIO_TQM_R1_BANK_SM_STATES_IX2_ARB_HWSCH_CMD_SM_BMSK                                                       0xf00000
#define HWIO_TQM_R1_BANK_SM_STATES_IX2_ARB_HWSCH_CMD_SM_SHFT                                                             20
#define HWIO_TQM_R1_BANK_SM_STATES_IX2_PREFETCH_READ_SM_BMSK                                                        0xc0000
#define HWIO_TQM_R1_BANK_SM_STATES_IX2_PREFETCH_READ_SM_SHFT                                                             18
#define HWIO_TQM_R1_BANK_SM_STATES_IX2_PREFETCH_SM_BMSK                                                             0x3ffff
#define HWIO_TQM_R1_BANK_SM_STATES_IX2_PREFETCH_SM_SHFT                                                                   0

#define HWIO_TQM_R1_BANK_SM_STATES_IX3_ADDR(x)                                                                   ((x) + 0x2070)
#define HWIO_TQM_R1_BANK_SM_STATES_IX3_PHYS(x)                                                                   ((x) + 0x2070)
#define HWIO_TQM_R1_BANK_SM_STATES_IX3_OFFS                                                                      (0x2070)
#define HWIO_TQM_R1_BANK_SM_STATES_IX3_RMSK                                                                        0xffffff
#define HWIO_TQM_R1_BANK_SM_STATES_IX3_POR                                                                       0x00000000
#define HWIO_TQM_R1_BANK_SM_STATES_IX3_POR_RMSK                                                                  0xffffffff
#define HWIO_TQM_R1_BANK_SM_STATES_IX3_ATTR                                                                                   0x1
#define HWIO_TQM_R1_BANK_SM_STATES_IX3_IN(x)            \
                in_dword(HWIO_TQM_R1_BANK_SM_STATES_IX3_ADDR(x))
#define HWIO_TQM_R1_BANK_SM_STATES_IX3_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_BANK_SM_STATES_IX3_ADDR(x), m)
#define HWIO_TQM_R1_BANK_SM_STATES_IX3_PREFETCH_SM_BMSK                                                            0xff0000
#define HWIO_TQM_R1_BANK_SM_STATES_IX3_PREFETCH_SM_SHFT                                                                  16
#define HWIO_TQM_R1_BANK_SM_STATES_IX3_TQM2TQM_OUT2_SM_STATE_BMSK                                                    0xc000
#define HWIO_TQM_R1_BANK_SM_STATES_IX3_TQM2TQM_OUT2_SM_STATE_SHFT                                                        14
#define HWIO_TQM_R1_BANK_SM_STATES_IX3_TQM2TQM_OUT1_SM_STATE_BMSK                                                    0x3000
#define HWIO_TQM_R1_BANK_SM_STATES_IX3_TQM2TQM_OUT1_SM_STATE_SHFT                                                        12
#define HWIO_TQM_R1_BANK_SM_STATES_IX3_UPDATE_QUEUE_DESC_SM_BMSK                                                      0xf80
#define HWIO_TQM_R1_BANK_SM_STATES_IX3_UPDATE_QUEUE_DESC_SM_SHFT                                                          7
#define HWIO_TQM_R1_BANK_SM_STATES_IX3_AXI_TO_TLV_SM_BMSK                                                              0x60
#define HWIO_TQM_R1_BANK_SM_STATES_IX3_AXI_TO_TLV_SM_SHFT                                                                 5
#define HWIO_TQM_R1_BANK_SM_STATES_IX3_LIST_TLV_STATE_BMSK                                                             0x1c
#define HWIO_TQM_R1_BANK_SM_STATES_IX3_LIST_TLV_STATE_SHFT                                                                2
#define HWIO_TQM_R1_BANK_SM_STATES_IX3_DATA_ALIGN_SM_BMSK                                                               0x3
#define HWIO_TQM_R1_BANK_SM_STATES_IX3_DATA_ALIGN_SM_SHFT                                                                 0

#define HWIO_TQM_R1_CCMN_IDLE_ADDR(x)                                                                            ((x) + 0x2074)
#define HWIO_TQM_R1_CCMN_IDLE_PHYS(x)                                                                            ((x) + 0x2074)
#define HWIO_TQM_R1_CCMN_IDLE_OFFS                                                                               (0x2074)
#define HWIO_TQM_R1_CCMN_IDLE_RMSK                                                                               0xffffffff
#define HWIO_TQM_R1_CCMN_IDLE_POR                                                                                0x00000000
#define HWIO_TQM_R1_CCMN_IDLE_POR_RMSK                                                                           0xffffffff
#define HWIO_TQM_R1_CCMN_IDLE_ATTR                                                                                            0x1
#define HWIO_TQM_R1_CCMN_IDLE_IN(x)            \
                in_dword(HWIO_TQM_R1_CCMN_IDLE_ADDR(x))
#define HWIO_TQM_R1_CCMN_IDLE_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_CCMN_IDLE_ADDR(x), m)
#define HWIO_TQM_R1_CCMN_IDLE_SOURCES_BMSK                                                                       0xffffffff
#define HWIO_TQM_R1_CCMN_IDLE_SOURCES_SHFT                                                                                0

#define HWIO_TQM_R1_CURRENT_COMMAND_ADDR(x)                                                                      ((x) + 0x2078)
#define HWIO_TQM_R1_CURRENT_COMMAND_PHYS(x)                                                                      ((x) + 0x2078)
#define HWIO_TQM_R1_CURRENT_COMMAND_OFFS                                                                         (0x2078)
#define HWIO_TQM_R1_CURRENT_COMMAND_RMSK                                                                         0xffffffff
#define HWIO_TQM_R1_CURRENT_COMMAND_POR                                                                          0x00000000
#define HWIO_TQM_R1_CURRENT_COMMAND_POR_RMSK                                                                     0xffffffff
#define HWIO_TQM_R1_CURRENT_COMMAND_ATTR                                                                                      0x1
#define HWIO_TQM_R1_CURRENT_COMMAND_IN(x)            \
                in_dword(HWIO_TQM_R1_CURRENT_COMMAND_ADDR(x))
#define HWIO_TQM_R1_CURRENT_COMMAND_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_CURRENT_COMMAND_ADDR(x), m)
#define HWIO_TQM_R1_CURRENT_COMMAND_POINTER_BMSK                                                                 0xf0000000
#define HWIO_TQM_R1_CURRENT_COMMAND_POINTER_SHFT                                                                         28
#define HWIO_TQM_R1_CURRENT_COMMAND_INDEX_6_BMSK                                                                  0xf000000
#define HWIO_TQM_R1_CURRENT_COMMAND_INDEX_6_SHFT                                                                         24
#define HWIO_TQM_R1_CURRENT_COMMAND_INDEX_5_BMSK                                                                   0xf00000
#define HWIO_TQM_R1_CURRENT_COMMAND_INDEX_5_SHFT                                                                         20
#define HWIO_TQM_R1_CURRENT_COMMAND_INDEX_4_BMSK                                                                    0xf0000
#define HWIO_TQM_R1_CURRENT_COMMAND_INDEX_4_SHFT                                                                         16
#define HWIO_TQM_R1_CURRENT_COMMAND_INDEX_3_BMSK                                                                     0xf000
#define HWIO_TQM_R1_CURRENT_COMMAND_INDEX_3_SHFT                                                                         12
#define HWIO_TQM_R1_CURRENT_COMMAND_INDEX_2_BMSK                                                                      0xf00
#define HWIO_TQM_R1_CURRENT_COMMAND_INDEX_2_SHFT                                                                          8
#define HWIO_TQM_R1_CURRENT_COMMAND_INDEX_1_BMSK                                                                       0xf0
#define HWIO_TQM_R1_CURRENT_COMMAND_INDEX_1_SHFT                                                                          4
#define HWIO_TQM_R1_CURRENT_COMMAND_INDEX_0_BMSK                                                                        0xf
#define HWIO_TQM_R1_CURRENT_COMMAND_INDEX_0_SHFT                                                                          0

#define HWIO_TQM_R1_LOG_ADD_MSDU_ADDR(x)                                                                         ((x) + 0x207c)
#define HWIO_TQM_R1_LOG_ADD_MSDU_PHYS(x)                                                                         ((x) + 0x207c)
#define HWIO_TQM_R1_LOG_ADD_MSDU_OFFS                                                                            (0x207c)
#define HWIO_TQM_R1_LOG_ADD_MSDU_RMSK                                                                              0xffffff
#define HWIO_TQM_R1_LOG_ADD_MSDU_POR                                                                             0x00ffffff
#define HWIO_TQM_R1_LOG_ADD_MSDU_POR_RMSK                                                                        0xffffffff
#define HWIO_TQM_R1_LOG_ADD_MSDU_ATTR                                                                                         0x1
#define HWIO_TQM_R1_LOG_ADD_MSDU_IN(x)            \
                in_dword(HWIO_TQM_R1_LOG_ADD_MSDU_ADDR(x))
#define HWIO_TQM_R1_LOG_ADD_MSDU_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_LOG_ADD_MSDU_ADDR(x), m)
#define HWIO_TQM_R1_LOG_ADD_MSDU_CURR_CMD_NUM_BMSK                                                                 0xffffff
#define HWIO_TQM_R1_LOG_ADD_MSDU_CURR_CMD_NUM_SHFT                                                                        0

#define HWIO_TQM_R1_LOG_TIMESTAMP_IX0_ADDR(x)                                                                    ((x) + 0x2080)
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX0_PHYS(x)                                                                    ((x) + 0x2080)
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX0_OFFS                                                                       (0x2080)
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX0_RMSK                                                                       0x3fffffff
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX0_POR                                                                        0x00000000
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX0_POR_RMSK                                                                   0xffffffff
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX0_ATTR                                                                                    0x1
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX0_IN(x)            \
                in_dword(HWIO_TQM_R1_LOG_TIMESTAMP_IX0_ADDR(x))
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_LOG_TIMESTAMP_IX0_ADDR(x), m)
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX0_INDEX_2_BMSK                                                               0x3ff00000
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX0_INDEX_2_SHFT                                                                       20
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX0_INDEX_1_BMSK                                                                  0xffc00
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX0_INDEX_1_SHFT                                                                       10
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX0_INDEX_0_BMSK                                                                    0x3ff
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX0_INDEX_0_SHFT                                                                        0

#define HWIO_TQM_R1_LOG_TIMESTAMP_IX1_ADDR(x)                                                                    ((x) + 0x2084)
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX1_PHYS(x)                                                                    ((x) + 0x2084)
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX1_OFFS                                                                       (0x2084)
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX1_RMSK                                                                       0x3fffffff
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX1_POR                                                                        0x00000000
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX1_POR_RMSK                                                                   0xffffffff
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX1_ATTR                                                                                    0x1
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX1_IN(x)            \
                in_dword(HWIO_TQM_R1_LOG_TIMESTAMP_IX1_ADDR(x))
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_LOG_TIMESTAMP_IX1_ADDR(x), m)
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX1_INDEX_5_BMSK                                                               0x3ff00000
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX1_INDEX_5_SHFT                                                                       20
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX1_INDEX_4_BMSK                                                                  0xffc00
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX1_INDEX_4_SHFT                                                                       10
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX1_INDEX_3_BMSK                                                                    0x3ff
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX1_INDEX_3_SHFT                                                                        0

#define HWIO_TQM_R1_LOG_TIMESTAMP_IX2_ADDR(x)                                                                    ((x) + 0x2088)
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX2_PHYS(x)                                                                    ((x) + 0x2088)
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX2_OFFS                                                                       (0x2088)
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX2_RMSK                                                                         0x7fffff
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX2_POR                                                                        0x00000000
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX2_POR_RMSK                                                                   0xffffffff
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX2_ATTR                                                                                    0x1
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX2_IN(x)            \
                in_dword(HWIO_TQM_R1_LOG_TIMESTAMP_IX2_ADDR(x))
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX2_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_LOG_TIMESTAMP_IX2_ADDR(x), m)
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX2_POINTER_BMSK                                                                 0x700000
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX2_POINTER_SHFT                                                                       20
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX2_INDEX_7_BMSK                                                                  0xffc00
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX2_INDEX_7_SHFT                                                                       10
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX2_INDEX_6_BMSK                                                                    0x3ff
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX2_INDEX_6_SHFT                                                                        0

#define HWIO_TQM_R1_LOG_TIMESTAMP_IX3_ADDR(x)                                                                    ((x) + 0x208c)
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX3_PHYS(x)                                                                    ((x) + 0x208c)
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX3_OFFS                                                                       (0x208c)
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX3_RMSK                                                                       0xffffffff
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX3_POR                                                                        0x00000000
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX3_POR_RMSK                                                                   0xffffffff
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX3_ATTR                                                                                    0x1
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX3_IN(x)            \
                in_dword(HWIO_TQM_R1_LOG_TIMESTAMP_IX3_ADDR(x))
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX3_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_LOG_TIMESTAMP_IX3_ADDR(x), m)
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX3_WATCHDOG_SNAPSHOT_BMSK                                                     0xfffffc00
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX3_WATCHDOG_SNAPSHOT_SHFT                                                             10
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX3_TIMESTAMP_BMSK                                                                  0x3ff
#define HWIO_TQM_R1_LOG_TIMESTAMP_IX3_TIMESTAMP_SHFT                                                                      0

#define HWIO_TQM_R1_WATCHDOG_STATUS_IX0_ADDR(x)                                                                  ((x) + 0x2090)
#define HWIO_TQM_R1_WATCHDOG_STATUS_IX0_PHYS(x)                                                                  ((x) + 0x2090)
#define HWIO_TQM_R1_WATCHDOG_STATUS_IX0_OFFS                                                                     (0x2090)
#define HWIO_TQM_R1_WATCHDOG_STATUS_IX0_RMSK                                                                     0xffffffff
#define HWIO_TQM_R1_WATCHDOG_STATUS_IX0_POR                                                                      0x00000000
#define HWIO_TQM_R1_WATCHDOG_STATUS_IX0_POR_RMSK                                                                 0xffffffff
#define HWIO_TQM_R1_WATCHDOG_STATUS_IX0_ATTR                                                                                  0x1
#define HWIO_TQM_R1_WATCHDOG_STATUS_IX0_IN(x)            \
                in_dword(HWIO_TQM_R1_WATCHDOG_STATUS_IX0_ADDR(x))
#define HWIO_TQM_R1_WATCHDOG_STATUS_IX0_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_WATCHDOG_STATUS_IX0_ADDR(x), m)
#define HWIO_TQM_R1_WATCHDOG_STATUS_IX0_SW_SM_WATCHDOG_BMSK                                                      0xffff0000
#define HWIO_TQM_R1_WATCHDOG_STATUS_IX0_SW_SM_WATCHDOG_SHFT                                                              16
#define HWIO_TQM_R1_WATCHDOG_STATUS_IX0_HW_SM_WATCHDOG_BMSK                                                          0xffff
#define HWIO_TQM_R1_WATCHDOG_STATUS_IX0_HW_SM_WATCHDOG_SHFT                                                               0

#define HWIO_TQM_R1_WATCHDOG_STATUS_IX1_ADDR(x)                                                                  ((x) + 0x2094)
#define HWIO_TQM_R1_WATCHDOG_STATUS_IX1_PHYS(x)                                                                  ((x) + 0x2094)
#define HWIO_TQM_R1_WATCHDOG_STATUS_IX1_OFFS                                                                     (0x2094)
#define HWIO_TQM_R1_WATCHDOG_STATUS_IX1_RMSK                                                                       0x1fffff
#define HWIO_TQM_R1_WATCHDOG_STATUS_IX1_POR                                                                      0x00000000
#define HWIO_TQM_R1_WATCHDOG_STATUS_IX1_POR_RMSK                                                                 0xffffffff
#define HWIO_TQM_R1_WATCHDOG_STATUS_IX1_ATTR                                                                                  0x1
#define HWIO_TQM_R1_WATCHDOG_STATUS_IX1_IN(x)            \
                in_dword(HWIO_TQM_R1_WATCHDOG_STATUS_IX1_ADDR(x))
#define HWIO_TQM_R1_WATCHDOG_STATUS_IX1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_WATCHDOG_STATUS_IX1_ADDR(x), m)
#define HWIO_TQM_R1_WATCHDOG_STATUS_IX1_IDLE_SEQUENCE_SM_BMSK                                                      0x1f0000
#define HWIO_TQM_R1_WATCHDOG_STATUS_IX1_IDLE_SEQUENCE_SM_SHFT                                                            16
#define HWIO_TQM_R1_WATCHDOG_STATUS_IX1_ENTRANCE_SM_WATCHDOG_BMSK                                                    0xffff
#define HWIO_TQM_R1_WATCHDOG_STATUS_IX1_ENTRANCE_SM_WATCHDOG_SHFT                                                         0

#define HWIO_TQM_R1_LOG_ADD_MSDU_FETCH_ADDR(x)                                                                   ((x) + 0x2098)
#define HWIO_TQM_R1_LOG_ADD_MSDU_FETCH_PHYS(x)                                                                   ((x) + 0x2098)
#define HWIO_TQM_R1_LOG_ADD_MSDU_FETCH_OFFS                                                                      (0x2098)
#define HWIO_TQM_R1_LOG_ADD_MSDU_FETCH_RMSK                                                                      0xffffffff
#define HWIO_TQM_R1_LOG_ADD_MSDU_FETCH_POR                                                                       0x00000000
#define HWIO_TQM_R1_LOG_ADD_MSDU_FETCH_POR_RMSK                                                                  0xffffffff
#define HWIO_TQM_R1_LOG_ADD_MSDU_FETCH_ATTR                                                                                   0x1
#define HWIO_TQM_R1_LOG_ADD_MSDU_FETCH_IN(x)            \
                in_dword(HWIO_TQM_R1_LOG_ADD_MSDU_FETCH_ADDR(x))
#define HWIO_TQM_R1_LOG_ADD_MSDU_FETCH_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_LOG_ADD_MSDU_FETCH_ADDR(x), m)
#define HWIO_TQM_R1_LOG_ADD_MSDU_FETCH_ADDRESS_BMSK                                                              0xffffffff
#define HWIO_TQM_R1_LOG_ADD_MSDU_FETCH_ADDRESS_SHFT                                                                       0

#define HWIO_TQM_R1_LOG_GEN_MPDU_FETCH_ADDR(x)                                                                   ((x) + 0x209c)
#define HWIO_TQM_R1_LOG_GEN_MPDU_FETCH_PHYS(x)                                                                   ((x) + 0x209c)
#define HWIO_TQM_R1_LOG_GEN_MPDU_FETCH_OFFS                                                                      (0x209c)
#define HWIO_TQM_R1_LOG_GEN_MPDU_FETCH_RMSK                                                                      0xffffffff
#define HWIO_TQM_R1_LOG_GEN_MPDU_FETCH_POR                                                                       0x00000000
#define HWIO_TQM_R1_LOG_GEN_MPDU_FETCH_POR_RMSK                                                                  0xffffffff
#define HWIO_TQM_R1_LOG_GEN_MPDU_FETCH_ATTR                                                                                   0x1
#define HWIO_TQM_R1_LOG_GEN_MPDU_FETCH_IN(x)            \
                in_dword(HWIO_TQM_R1_LOG_GEN_MPDU_FETCH_ADDR(x))
#define HWIO_TQM_R1_LOG_GEN_MPDU_FETCH_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_LOG_GEN_MPDU_FETCH_ADDR(x), m)
#define HWIO_TQM_R1_LOG_GEN_MPDU_FETCH_ADDRESS_BMSK                                                              0xffffffff
#define HWIO_TQM_R1_LOG_GEN_MPDU_FETCH_ADDRESS_SHFT                                                                       0

#define HWIO_TQM_R1_IDLE_SEQUENCE_LOG_ADDR(x)                                                                    ((x) + 0x20a0)
#define HWIO_TQM_R1_IDLE_SEQUENCE_LOG_PHYS(x)                                                                    ((x) + 0x20a0)
#define HWIO_TQM_R1_IDLE_SEQUENCE_LOG_OFFS                                                                       (0x20a0)
#define HWIO_TQM_R1_IDLE_SEQUENCE_LOG_RMSK                                                                       0x7fffffff
#define HWIO_TQM_R1_IDLE_SEQUENCE_LOG_POR                                                                        0x71d1e1a1
#define HWIO_TQM_R1_IDLE_SEQUENCE_LOG_POR_RMSK                                                                   0xffffffff
#define HWIO_TQM_R1_IDLE_SEQUENCE_LOG_ATTR                                                                                    0x1
#define HWIO_TQM_R1_IDLE_SEQUENCE_LOG_IN(x)            \
                in_dword(HWIO_TQM_R1_IDLE_SEQUENCE_LOG_ADDR(x))
#define HWIO_TQM_R1_IDLE_SEQUENCE_LOG_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_IDLE_SEQUENCE_LOG_ADDR(x), m)
#define HWIO_TQM_R1_IDLE_SEQUENCE_LOG_TIMER_1_BMSK                                                               0x7fff0000
#define HWIO_TQM_R1_IDLE_SEQUENCE_LOG_TIMER_1_SHFT                                                                       16
#define HWIO_TQM_R1_IDLE_SEQUENCE_LOG_TIMER_0_BMSK                                                                   0xfffe
#define HWIO_TQM_R1_IDLE_SEQUENCE_LOG_TIMER_0_SHFT                                                                        1
#define HWIO_TQM_R1_IDLE_SEQUENCE_LOG_INDEX_BMSK                                                                        0x1
#define HWIO_TQM_R1_IDLE_SEQUENCE_LOG_INDEX_SHFT                                                                          0

#define HWIO_TQM_R1_SCH2TQM0_TLV_INTF_STATUS_ADDR(x)                                                             ((x) + 0x20a4)
#define HWIO_TQM_R1_SCH2TQM0_TLV_INTF_STATUS_PHYS(x)                                                             ((x) + 0x20a4)
#define HWIO_TQM_R1_SCH2TQM0_TLV_INTF_STATUS_OFFS                                                                (0x20a4)
#define HWIO_TQM_R1_SCH2TQM0_TLV_INTF_STATUS_RMSK                                                                 0x3ffff3f
#define HWIO_TQM_R1_SCH2TQM0_TLV_INTF_STATUS_POR                                                                 0x00000000
#define HWIO_TQM_R1_SCH2TQM0_TLV_INTF_STATUS_POR_RMSK                                                            0xffffffff
#define HWIO_TQM_R1_SCH2TQM0_TLV_INTF_STATUS_ATTR                                                                             0x1
#define HWIO_TQM_R1_SCH2TQM0_TLV_INTF_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R1_SCH2TQM0_TLV_INTF_STATUS_ADDR(x))
#define HWIO_TQM_R1_SCH2TQM0_TLV_INTF_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_SCH2TQM0_TLV_INTF_STATUS_ADDR(x), m)
#define HWIO_TQM_R1_SCH2TQM0_TLV_INTF_STATUS_FREE_SLOTS_BMSK                                                      0x3ff0000
#define HWIO_TQM_R1_SCH2TQM0_TLV_INTF_STATUS_FREE_SLOTS_SHFT                                                             16
#define HWIO_TQM_R1_SCH2TQM0_TLV_INTF_STATUS_CURR_REQ_LEN_BMSK                                                       0xff00
#define HWIO_TQM_R1_SCH2TQM0_TLV_INTF_STATUS_CURR_REQ_LEN_SHFT                                                            8
#define HWIO_TQM_R1_SCH2TQM0_TLV_INTF_STATUS_FLUSH_STATE_BMSK                                                          0x30
#define HWIO_TQM_R1_SCH2TQM0_TLV_INTF_STATUS_FLUSH_STATE_SHFT                                                             4
#define HWIO_TQM_R1_SCH2TQM0_TLV_INTF_STATUS_SM_STATE_BMSK                                                              0xe
#define HWIO_TQM_R1_SCH2TQM0_TLV_INTF_STATUS_SM_STATE_SHFT                                                                1
#define HWIO_TQM_R1_SCH2TQM0_TLV_INTF_STATUS_IDLE_BMSK                                                                  0x1
#define HWIO_TQM_R1_SCH2TQM0_TLV_INTF_STATUS_IDLE_SHFT                                                                    0

#define HWIO_TQM_R1_SCH2TQM0_STATUS_ADDR(x)                                                                      ((x) + 0x20a8)
#define HWIO_TQM_R1_SCH2TQM0_STATUS_PHYS(x)                                                                      ((x) + 0x20a8)
#define HWIO_TQM_R1_SCH2TQM0_STATUS_OFFS                                                                         (0x20a8)
#define HWIO_TQM_R1_SCH2TQM0_STATUS_RMSK                                                                         0x7fffffff
#define HWIO_TQM_R1_SCH2TQM0_STATUS_POR                                                                          0x00000000
#define HWIO_TQM_R1_SCH2TQM0_STATUS_POR_RMSK                                                                     0xffffffff
#define HWIO_TQM_R1_SCH2TQM0_STATUS_ATTR                                                                                      0x1
#define HWIO_TQM_R1_SCH2TQM0_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R1_SCH2TQM0_STATUS_ADDR(x))
#define HWIO_TQM_R1_SCH2TQM0_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_SCH2TQM0_STATUS_ADDR(x), m)
#define HWIO_TQM_R1_SCH2TQM0_STATUS_FLUSH_SESSION_ID_BMSK                                                        0x7f800000
#define HWIO_TQM_R1_SCH2TQM0_STATUS_FLUSH_SESSION_ID_SHFT                                                                23
#define HWIO_TQM_R1_SCH2TQM0_STATUS_FLUSH_SRC_ID_BMSK                                                              0x700000
#define HWIO_TQM_R1_SCH2TQM0_STATUS_FLUSH_SRC_ID_SHFT                                                                    20
#define HWIO_TQM_R1_SCH2TQM0_STATUS_FLUSH_STATUS_BMSK                                                               0xf0000
#define HWIO_TQM_R1_SCH2TQM0_STATUS_FLUSH_STATUS_SHFT                                                                    16
#define HWIO_TQM_R1_SCH2TQM0_STATUS_HEADER_BMSK                                                                      0xffff
#define HWIO_TQM_R1_SCH2TQM0_STATUS_HEADER_SHFT                                                                           0

#define HWIO_TQM_R1_SCH2TQM1_TLV_INTF_STATUS_ADDR(x)                                                             ((x) + 0x20ac)
#define HWIO_TQM_R1_SCH2TQM1_TLV_INTF_STATUS_PHYS(x)                                                             ((x) + 0x20ac)
#define HWIO_TQM_R1_SCH2TQM1_TLV_INTF_STATUS_OFFS                                                                (0x20ac)
#define HWIO_TQM_R1_SCH2TQM1_TLV_INTF_STATUS_RMSK                                                                 0x3ffff3f
#define HWIO_TQM_R1_SCH2TQM1_TLV_INTF_STATUS_POR                                                                 0x00000000
#define HWIO_TQM_R1_SCH2TQM1_TLV_INTF_STATUS_POR_RMSK                                                            0xffffffff
#define HWIO_TQM_R1_SCH2TQM1_TLV_INTF_STATUS_ATTR                                                                             0x1
#define HWIO_TQM_R1_SCH2TQM1_TLV_INTF_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R1_SCH2TQM1_TLV_INTF_STATUS_ADDR(x))
#define HWIO_TQM_R1_SCH2TQM1_TLV_INTF_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_SCH2TQM1_TLV_INTF_STATUS_ADDR(x), m)
#define HWIO_TQM_R1_SCH2TQM1_TLV_INTF_STATUS_FREE_SLOTS_BMSK                                                      0x3ff0000
#define HWIO_TQM_R1_SCH2TQM1_TLV_INTF_STATUS_FREE_SLOTS_SHFT                                                             16
#define HWIO_TQM_R1_SCH2TQM1_TLV_INTF_STATUS_CURR_REQ_LEN_BMSK                                                       0xff00
#define HWIO_TQM_R1_SCH2TQM1_TLV_INTF_STATUS_CURR_REQ_LEN_SHFT                                                            8
#define HWIO_TQM_R1_SCH2TQM1_TLV_INTF_STATUS_FLUSH_STATE_BMSK                                                          0x30
#define HWIO_TQM_R1_SCH2TQM1_TLV_INTF_STATUS_FLUSH_STATE_SHFT                                                             4
#define HWIO_TQM_R1_SCH2TQM1_TLV_INTF_STATUS_SM_STATE_BMSK                                                              0xe
#define HWIO_TQM_R1_SCH2TQM1_TLV_INTF_STATUS_SM_STATE_SHFT                                                                1
#define HWIO_TQM_R1_SCH2TQM1_TLV_INTF_STATUS_IDLE_BMSK                                                                  0x1
#define HWIO_TQM_R1_SCH2TQM1_TLV_INTF_STATUS_IDLE_SHFT                                                                    0

#define HWIO_TQM_R1_SCH2TQM1_STATUS_ADDR(x)                                                                      ((x) + 0x20b0)
#define HWIO_TQM_R1_SCH2TQM1_STATUS_PHYS(x)                                                                      ((x) + 0x20b0)
#define HWIO_TQM_R1_SCH2TQM1_STATUS_OFFS                                                                         (0x20b0)
#define HWIO_TQM_R1_SCH2TQM1_STATUS_RMSK                                                                         0x7fffffff
#define HWIO_TQM_R1_SCH2TQM1_STATUS_POR                                                                          0x00000000
#define HWIO_TQM_R1_SCH2TQM1_STATUS_POR_RMSK                                                                     0xffffffff
#define HWIO_TQM_R1_SCH2TQM1_STATUS_ATTR                                                                                      0x1
#define HWIO_TQM_R1_SCH2TQM1_STATUS_IN(x)            \
                in_dword(HWIO_TQM_R1_SCH2TQM1_STATUS_ADDR(x))
#define HWIO_TQM_R1_SCH2TQM1_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_SCH2TQM1_STATUS_ADDR(x), m)
#define HWIO_TQM_R1_SCH2TQM1_STATUS_FLUSH_SESSION_ID_BMSK                                                        0x7f800000
#define HWIO_TQM_R1_SCH2TQM1_STATUS_FLUSH_SESSION_ID_SHFT                                                                23
#define HWIO_TQM_R1_SCH2TQM1_STATUS_FLUSH_SRC_ID_BMSK                                                              0x700000
#define HWIO_TQM_R1_SCH2TQM1_STATUS_FLUSH_SRC_ID_SHFT                                                                    20
#define HWIO_TQM_R1_SCH2TQM1_STATUS_FLUSH_STATUS_BMSK                                                               0xf0000
#define HWIO_TQM_R1_SCH2TQM1_STATUS_FLUSH_STATUS_SHFT                                                                    16
#define HWIO_TQM_R1_SCH2TQM1_STATUS_HEADER_BMSK                                                                      0xffff
#define HWIO_TQM_R1_SCH2TQM1_STATUS_HEADER_SHFT                                                                           0

#define HWIO_TQM_R1_FLUSH_ADDR(x)                                                                                ((x) + 0x20b4)
#define HWIO_TQM_R1_FLUSH_PHYS(x)                                                                                ((x) + 0x20b4)
#define HWIO_TQM_R1_FLUSH_OFFS                                                                                   (0x20b4)
#define HWIO_TQM_R1_FLUSH_RMSK                                                                                   0xffffffff
#define HWIO_TQM_R1_FLUSH_POR                                                                                    0x00000000
#define HWIO_TQM_R1_FLUSH_POR_RMSK                                                                               0xffffffff
#define HWIO_TQM_R1_FLUSH_ATTR                                                                                                0x3
#define HWIO_TQM_R1_FLUSH_IN(x)            \
                in_dword(HWIO_TQM_R1_FLUSH_ADDR(x))
#define HWIO_TQM_R1_FLUSH_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_FLUSH_ADDR(x), m)
#define HWIO_TQM_R1_FLUSH_OUT(x, v)            \
                out_dword(HWIO_TQM_R1_FLUSH_ADDR(x),v)
#define HWIO_TQM_R1_FLUSH_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R1_FLUSH_ADDR(x),m,v,HWIO_TQM_R1_FLUSH_IN(x))
#define HWIO_TQM_R1_FLUSH_BACKUP_10_BMSK                                                                         0x80000000
#define HWIO_TQM_R1_FLUSH_BACKUP_10_SHFT                                                                                 31
#define HWIO_TQM_R1_FLUSH_BACKUP_9_BMSK                                                                          0x40000000
#define HWIO_TQM_R1_FLUSH_BACKUP_9_SHFT                                                                                  30
#define HWIO_TQM_R1_FLUSH_BACKUP_8_BMSK                                                                          0x20000000
#define HWIO_TQM_R1_FLUSH_BACKUP_8_SHFT                                                                                  29
#define HWIO_TQM_R1_FLUSH_BACKUP_7_BMSK                                                                          0x10000000
#define HWIO_TQM_R1_FLUSH_BACKUP_7_SHFT                                                                                  28
#define HWIO_TQM_R1_FLUSH_BACKUP_6_BMSK                                                                           0x8000000
#define HWIO_TQM_R1_FLUSH_BACKUP_6_SHFT                                                                                  27
#define HWIO_TQM_R1_FLUSH_BACKUP_5_BMSK                                                                           0x4000000
#define HWIO_TQM_R1_FLUSH_BACKUP_5_SHFT                                                                                  26
#define HWIO_TQM_R1_FLUSH_BACKUP_4_BMSK                                                                           0x2000000
#define HWIO_TQM_R1_FLUSH_BACKUP_4_SHFT                                                                                  25
#define HWIO_TQM_R1_FLUSH_BACKUP_3_BMSK                                                                           0x1000000
#define HWIO_TQM_R1_FLUSH_BACKUP_3_SHFT                                                                                  24
#define HWIO_TQM_R1_FLUSH_BACKUP_2_BMSK                                                                            0x800000
#define HWIO_TQM_R1_FLUSH_BACKUP_2_SHFT                                                                                  23
#define HWIO_TQM_R1_FLUSH_BACKUP_1_BMSK                                                                            0x400000
#define HWIO_TQM_R1_FLUSH_BACKUP_1_SHFT                                                                                  22
#define HWIO_TQM_R1_FLUSH_BACKUP_0_BMSK                                                                            0x200000
#define HWIO_TQM_R1_FLUSH_BACKUP_0_SHFT                                                                                  21
#define HWIO_TQM_R1_FLUSH_CMD_AND_PTR_PREFETCH_FLUSH_P_BMSK                                                        0x100000
#define HWIO_TQM_R1_FLUSH_CMD_AND_PTR_PREFETCH_FLUSH_P_SHFT                                                              20
#define HWIO_TQM_R1_FLUSH_CMD_ARBITER_FLUSH_P_BMSK                                                                  0x80000
#define HWIO_TQM_R1_FLUSH_CMD_ARBITER_FLUSH_P_SHFT                                                                       19
#define HWIO_TQM_R1_FLUSH_COMMON_LOGIC_FLUSH_P_BMSK                                                                 0x40000
#define HWIO_TQM_R1_FLUSH_COMMON_LOGIC_FLUSH_P_SHFT                                                                      18
#define HWIO_TQM_R1_FLUSH_ADD_MSDU_SM_FLUSH_P_BMSK                                                                  0x20000
#define HWIO_TQM_R1_FLUSH_ADD_MSDU_SM_FLUSH_P_SHFT                                                                       17
#define HWIO_TQM_R1_FLUSH_GEN_MPDU_SM_FLUSH_P_BMSK                                                                  0x10000
#define HWIO_TQM_R1_FLUSH_GEN_MPDU_SM_FLUSH_P_SHFT                                                                       16
#define HWIO_TQM_R1_FLUSH_UPDATE_TX_MPDU_COUNT_SM_FLUSH_P_BMSK                                                       0x8000
#define HWIO_TQM_R1_FLUSH_UPDATE_TX_MPDU_COUNT_SM_FLUSH_P_SHFT                                                           15
#define HWIO_TQM_R1_FLUSH_LIST_MPDU_SM_FLUSH_P_BMSK                                                                  0x4000
#define HWIO_TQM_R1_FLUSH_LIST_MPDU_SM_FLUSH_P_SHFT                                                                      14
#define HWIO_TQM_R1_FLUSH_WRITE_CMD_SM_FLUSH_P_BMSK                                                                  0x2000
#define HWIO_TQM_R1_FLUSH_WRITE_CMD_SM_FLUSH_P_SHFT                                                                      13
#define HWIO_TQM_R1_FLUSH_ACKED_MPDU_SM_FLUSH_P_BMSK                                                                 0x1000
#define HWIO_TQM_R1_FLUSH_ACKED_MPDU_SM_FLUSH_P_SHFT                                                                     12
#define HWIO_TQM_R1_FLUSH_REM_MPDU_SM_FLUSH_P_BMSK                                                                    0x800
#define HWIO_TQM_R1_FLUSH_REM_MPDU_SM_FLUSH_P_SHFT                                                                       11
#define HWIO_TQM_R1_FLUSH_REM_MSDU_SM_FLUSH_P_BMSK                                                                    0x400
#define HWIO_TQM_R1_FLUSH_REM_MSDU_SM_FLUSH_P_SHFT                                                                       10
#define HWIO_TQM_R1_FLUSH_HWSCH_AXI_IF_FLUSH_P_BMSK                                                                   0x200
#define HWIO_TQM_R1_FLUSH_HWSCH_AXI_IF_FLUSH_P_SHFT                                                                       9
#define HWIO_TQM_R1_FLUSH_AXI_TO_TLV_FLUSH_P_BMSK                                                                     0x100
#define HWIO_TQM_R1_FLUSH_AXI_TO_TLV_FLUSH_P_SHFT                                                                         8
#define HWIO_TQM_R1_FLUSH_GET_MPDU_HEAD_INFO_SM_FLUSH_P_BMSK                                                           0x80
#define HWIO_TQM_R1_FLUSH_GET_MPDU_HEAD_INFO_SM_FLUSH_P_SHFT                                                              7
#define HWIO_TQM_R1_FLUSH_GET_MPDU_QUEUE_STAT_SM_FLUSH_P_BMSK                                                          0x40
#define HWIO_TQM_R1_FLUSH_GET_MPDU_QUEUE_STAT_SM_FLUSH_P_SHFT                                                             6
#define HWIO_TQM_R1_FLUSH_GET_MSDU_FLOW_STAT_SM_FLUSH_P_BMSK                                                           0x20
#define HWIO_TQM_R1_FLUSH_GET_MSDU_FLOW_STAT_SM_FLUSH_P_SHFT                                                              5
#define HWIO_TQM_R1_FLUSH_FLUSH_CACHE_SM_FLUSH_P_BMSK                                                                  0x10
#define HWIO_TQM_R1_FLUSH_FLUSH_CACHE_SM_FLUSH_P_SHFT                                                                     4
#define HWIO_TQM_R1_FLUSH_UNBLOCK_CACHE_SM_FLUSH_P_BMSK                                                                 0x8
#define HWIO_TQM_R1_FLUSH_UNBLOCK_CACHE_SM_FLUSH_P_SHFT                                                                   3
#define HWIO_TQM_R1_FLUSH_UPDATE_TX_MPDU_QUEUE_HEAD_SM_FLUSH_P_BMSK                                                     0x4
#define HWIO_TQM_R1_FLUSH_UPDATE_TX_MPDU_QUEUE_HEAD_SM_FLUSH_P_SHFT                                                       2
#define HWIO_TQM_R1_FLUSH_UPDATE_TX_MSDU_FLOW_SM_FLUSH_P_BMSK                                                           0x2
#define HWIO_TQM_R1_FLUSH_UPDATE_TX_MSDU_FLOW_SM_FLUSH_P_SHFT                                                             1
#define HWIO_TQM_R1_FLUSH_TQM_IDLE_SEQUENCE_FLUSH_P_BMSK                                                                0x1
#define HWIO_TQM_R1_FLUSH_TQM_IDLE_SEQUENCE_FLUSH_P_SHFT                                                                  0

#define HWIO_TQM_R1_WARN_WDG_0_ADDR(x)                                                                           ((x) + 0x20b8)
#define HWIO_TQM_R1_WARN_WDG_0_PHYS(x)                                                                           ((x) + 0x20b8)
#define HWIO_TQM_R1_WARN_WDG_0_OFFS                                                                              (0x20b8)
#define HWIO_TQM_R1_WARN_WDG_0_RMSK                                                                              0xffffffff
#define HWIO_TQM_R1_WARN_WDG_0_POR                                                                               0x00000000
#define HWIO_TQM_R1_WARN_WDG_0_POR_RMSK                                                                          0xffffffff
#define HWIO_TQM_R1_WARN_WDG_0_ATTR                                                                                           0x3
#define HWIO_TQM_R1_WARN_WDG_0_IN(x)            \
                in_dword(HWIO_TQM_R1_WARN_WDG_0_ADDR(x))
#define HWIO_TQM_R1_WARN_WDG_0_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_WARN_WDG_0_ADDR(x), m)
#define HWIO_TQM_R1_WARN_WDG_0_OUT(x, v)            \
                out_dword(HWIO_TQM_R1_WARN_WDG_0_ADDR(x),v)
#define HWIO_TQM_R1_WARN_WDG_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R1_WARN_WDG_0_ADDR(x),m,v,HWIO_TQM_R1_WARN_WDG_0_IN(x))
#define HWIO_TQM_R1_WARN_WDG_0_RELEASE_FIFO_STATUS_BMSK                                                          0xffff0000
#define HWIO_TQM_R1_WARN_WDG_0_RELEASE_FIFO_STATUS_SHFT                                                                  16
#define HWIO_TQM_R1_WARN_WDG_0_RELEASE_FIFO_LIMIT_BMSK                                                               0xffff
#define HWIO_TQM_R1_WARN_WDG_0_RELEASE_FIFO_LIMIT_SHFT                                                                    0

#define HWIO_TQM_R1_WARN_WDG_1_ADDR(x)                                                                           ((x) + 0x20bc)
#define HWIO_TQM_R1_WARN_WDG_1_PHYS(x)                                                                           ((x) + 0x20bc)
#define HWIO_TQM_R1_WARN_WDG_1_OFFS                                                                              (0x20bc)
#define HWIO_TQM_R1_WARN_WDG_1_RMSK                                                                              0xffffffff
#define HWIO_TQM_R1_WARN_WDG_1_POR                                                                               0x00000000
#define HWIO_TQM_R1_WARN_WDG_1_POR_RMSK                                                                          0xffffffff
#define HWIO_TQM_R1_WARN_WDG_1_ATTR                                                                                           0x3
#define HWIO_TQM_R1_WARN_WDG_1_IN(x)            \
                in_dword(HWIO_TQM_R1_WARN_WDG_1_ADDR(x))
#define HWIO_TQM_R1_WARN_WDG_1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_WARN_WDG_1_ADDR(x), m)
#define HWIO_TQM_R1_WARN_WDG_1_OUT(x, v)            \
                out_dword(HWIO_TQM_R1_WARN_WDG_1_ADDR(x),v)
#define HWIO_TQM_R1_WARN_WDG_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R1_WARN_WDG_1_ADDR(x),m,v,HWIO_TQM_R1_WARN_WDG_1_IN(x))
#define HWIO_TQM_R1_WARN_WDG_1_DESC_RING_FIFO_STATUS_BMSK                                                        0xffff0000
#define HWIO_TQM_R1_WARN_WDG_1_DESC_RING_FIFO_STATUS_SHFT                                                                16
#define HWIO_TQM_R1_WARN_WDG_1_DESC_RING_FIFO_LIMIT_BMSK                                                             0xffff
#define HWIO_TQM_R1_WARN_WDG_1_DESC_RING_FIFO_LIMIT_SHFT                                                                  0

#define HWIO_TQM_R1_WARN_WDG_2_ADDR(x)                                                                           ((x) + 0x20c0)
#define HWIO_TQM_R1_WARN_WDG_2_PHYS(x)                                                                           ((x) + 0x20c0)
#define HWIO_TQM_R1_WARN_WDG_2_OFFS                                                                              (0x20c0)
#define HWIO_TQM_R1_WARN_WDG_2_RMSK                                                                              0xffffffff
#define HWIO_TQM_R1_WARN_WDG_2_POR                                                                               0x00000000
#define HWIO_TQM_R1_WARN_WDG_2_POR_RMSK                                                                          0xffffffff
#define HWIO_TQM_R1_WARN_WDG_2_ATTR                                                                                           0x3
#define HWIO_TQM_R1_WARN_WDG_2_IN(x)            \
                in_dword(HWIO_TQM_R1_WARN_WDG_2_ADDR(x))
#define HWIO_TQM_R1_WARN_WDG_2_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_WARN_WDG_2_ADDR(x), m)
#define HWIO_TQM_R1_WARN_WDG_2_OUT(x, v)            \
                out_dword(HWIO_TQM_R1_WARN_WDG_2_ADDR(x),v)
#define HWIO_TQM_R1_WARN_WDG_2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R1_WARN_WDG_2_ADDR(x),m,v,HWIO_TQM_R1_WARN_WDG_2_IN(x))
#define HWIO_TQM_R1_WARN_WDG_2_STATUS_RING_FIFO_STATUS_BMSK                                                      0xffff0000
#define HWIO_TQM_R1_WARN_WDG_2_STATUS_RING_FIFO_STATUS_SHFT                                                              16
#define HWIO_TQM_R1_WARN_WDG_2_STATUS_RING_FIFO_LIMIT_BMSK                                                           0xffff
#define HWIO_TQM_R1_WARN_WDG_2_STATUS_RING_FIFO_LIMIT_SHFT                                                                0

#define HWIO_TQM_R1_WARN_WDG_3_ADDR(x)                                                                           ((x) + 0x20c4)
#define HWIO_TQM_R1_WARN_WDG_3_PHYS(x)                                                                           ((x) + 0x20c4)
#define HWIO_TQM_R1_WARN_WDG_3_OFFS                                                                              (0x20c4)
#define HWIO_TQM_R1_WARN_WDG_3_RMSK                                                                              0xffffffff
#define HWIO_TQM_R1_WARN_WDG_3_POR                                                                               0x00000000
#define HWIO_TQM_R1_WARN_WDG_3_POR_RMSK                                                                          0xffffffff
#define HWIO_TQM_R1_WARN_WDG_3_ATTR                                                                                           0x3
#define HWIO_TQM_R1_WARN_WDG_3_IN(x)            \
                in_dword(HWIO_TQM_R1_WARN_WDG_3_ADDR(x))
#define HWIO_TQM_R1_WARN_WDG_3_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_WARN_WDG_3_ADDR(x), m)
#define HWIO_TQM_R1_WARN_WDG_3_OUT(x, v)            \
                out_dword(HWIO_TQM_R1_WARN_WDG_3_ADDR(x),v)
#define HWIO_TQM_R1_WARN_WDG_3_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R1_WARN_WDG_3_ADDR(x),m,v,HWIO_TQM_R1_WARN_WDG_3_IN(x))
#define HWIO_TQM_R1_WARN_WDG_3_STATUS1_RING_FIFO_STATUS_BMSK                                                     0xffff0000
#define HWIO_TQM_R1_WARN_WDG_3_STATUS1_RING_FIFO_STATUS_SHFT                                                             16
#define HWIO_TQM_R1_WARN_WDG_3_STATUS1_RING_FIFO_LIMIT_BMSK                                                          0xffff
#define HWIO_TQM_R1_WARN_WDG_3_STATUS1_RING_FIFO_LIMIT_SHFT                                                               0

#define HWIO_TQM_R1_WARN_WDG_4_ADDR(x)                                                                           ((x) + 0x20c8)
#define HWIO_TQM_R1_WARN_WDG_4_PHYS(x)                                                                           ((x) + 0x20c8)
#define HWIO_TQM_R1_WARN_WDG_4_OFFS                                                                              (0x20c8)
#define HWIO_TQM_R1_WARN_WDG_4_RMSK                                                                              0xffffffff
#define HWIO_TQM_R1_WARN_WDG_4_POR                                                                               0x00000000
#define HWIO_TQM_R1_WARN_WDG_4_POR_RMSK                                                                          0xffffffff
#define HWIO_TQM_R1_WARN_WDG_4_ATTR                                                                                           0x3
#define HWIO_TQM_R1_WARN_WDG_4_IN(x)            \
                in_dword(HWIO_TQM_R1_WARN_WDG_4_ADDR(x))
#define HWIO_TQM_R1_WARN_WDG_4_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_WARN_WDG_4_ADDR(x), m)
#define HWIO_TQM_R1_WARN_WDG_4_OUT(x, v)            \
                out_dword(HWIO_TQM_R1_WARN_WDG_4_ADDR(x),v)
#define HWIO_TQM_R1_WARN_WDG_4_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R1_WARN_WDG_4_ADDR(x),m,v,HWIO_TQM_R1_WARN_WDG_4_IN(x))
#define HWIO_TQM_R1_WARN_WDG_4_TLV_FIFO_STATUS_BMSK                                                              0xffff0000
#define HWIO_TQM_R1_WARN_WDG_4_TLV_FIFO_STATUS_SHFT                                                                      16
#define HWIO_TQM_R1_WARN_WDG_4_TLV_FIFO_LIMIT_BMSK                                                                   0xffff
#define HWIO_TQM_R1_WARN_WDG_4_TLV_FIFO_LIMIT_SHFT                                                                        0

#define HWIO_TQM_R1_WARN_WDG_STATUS_0_ADDR(x)                                                                    ((x) + 0x20cc)
#define HWIO_TQM_R1_WARN_WDG_STATUS_0_PHYS(x)                                                                    ((x) + 0x20cc)
#define HWIO_TQM_R1_WARN_WDG_STATUS_0_OFFS                                                                       (0x20cc)
#define HWIO_TQM_R1_WARN_WDG_STATUS_0_RMSK                                                                             0x1f
#define HWIO_TQM_R1_WARN_WDG_STATUS_0_POR                                                                        0x00000000
#define HWIO_TQM_R1_WARN_WDG_STATUS_0_POR_RMSK                                                                   0xffffffff
#define HWIO_TQM_R1_WARN_WDG_STATUS_0_ATTR                                                                                    0x0
#define HWIO_TQM_R1_WARN_WDG_STATUS_0_IN(x)            \
                in_dword(HWIO_TQM_R1_WARN_WDG_STATUS_0_ADDR(x))
#define HWIO_TQM_R1_WARN_WDG_STATUS_0_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_WARN_WDG_STATUS_0_ADDR(x), m)
#define HWIO_TQM_R1_WARN_WDG_STATUS_0_OUT(x, v)            \
                out_dword(HWIO_TQM_R1_WARN_WDG_STATUS_0_ADDR(x),v)
#define HWIO_TQM_R1_WARN_WDG_STATUS_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R1_WARN_WDG_STATUS_0_ADDR(x),m,v,HWIO_TQM_R1_WARN_WDG_STATUS_0_IN(x))
#define HWIO_TQM_R1_WARN_WDG_STATUS_0_TLV_FIFO_FULL_INTERRUPT_BMSK                                                     0x10
#define HWIO_TQM_R1_WARN_WDG_STATUS_0_TLV_FIFO_FULL_INTERRUPT_SHFT                                                        4
#define HWIO_TQM_R1_WARN_WDG_STATUS_0_STATUS1_RING_FIFO_FULL_INTERRUPT_BMSK                                             0x8
#define HWIO_TQM_R1_WARN_WDG_STATUS_0_STATUS1_RING_FIFO_FULL_INTERRUPT_SHFT                                               3
#define HWIO_TQM_R1_WARN_WDG_STATUS_0_STATUS_RING_FIFO_FULL_INTERRUPT_BMSK                                              0x4
#define HWIO_TQM_R1_WARN_WDG_STATUS_0_STATUS_RING_FIFO_FULL_INTERRUPT_SHFT                                                2
#define HWIO_TQM_R1_WARN_WDG_STATUS_0_DESC_RING_FIFO_EMPTY_INTERRUPT_BMSK                                               0x2
#define HWIO_TQM_R1_WARN_WDG_STATUS_0_DESC_RING_FIFO_EMPTY_INTERRUPT_SHFT                                                 1
#define HWIO_TQM_R1_WARN_WDG_STATUS_0_RELEASE_RING_FIFO_FULL_INTERRUPT_BMSK                                             0x1
#define HWIO_TQM_R1_WARN_WDG_STATUS_0_RELEASE_RING_FIFO_FULL_INTERRUPT_SHFT                                               0

#define HWIO_TQM_R1_ERR_WDG_0_ADDR(x)                                                                            ((x) + 0x20d0)
#define HWIO_TQM_R1_ERR_WDG_0_PHYS(x)                                                                            ((x) + 0x20d0)
#define HWIO_TQM_R1_ERR_WDG_0_OFFS                                                                               (0x20d0)
#define HWIO_TQM_R1_ERR_WDG_0_RMSK                                                                               0xffffffff
#define HWIO_TQM_R1_ERR_WDG_0_POR                                                                                0x00000000
#define HWIO_TQM_R1_ERR_WDG_0_POR_RMSK                                                                           0xffffffff
#define HWIO_TQM_R1_ERR_WDG_0_ATTR                                                                                            0x3
#define HWIO_TQM_R1_ERR_WDG_0_IN(x)            \
                in_dword(HWIO_TQM_R1_ERR_WDG_0_ADDR(x))
#define HWIO_TQM_R1_ERR_WDG_0_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_ERR_WDG_0_ADDR(x), m)
#define HWIO_TQM_R1_ERR_WDG_0_OUT(x, v)            \
                out_dword(HWIO_TQM_R1_ERR_WDG_0_ADDR(x),v)
#define HWIO_TQM_R1_ERR_WDG_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R1_ERR_WDG_0_ADDR(x),m,v,HWIO_TQM_R1_ERR_WDG_0_IN(x))
#define HWIO_TQM_R1_ERR_WDG_0_HW_SM_STATUS_BMSK                                                                  0xffff0000
#define HWIO_TQM_R1_ERR_WDG_0_HW_SM_STATUS_SHFT                                                                          16
#define HWIO_TQM_R1_ERR_WDG_0_HW_SM_LIMIT_BMSK                                                                       0xffff
#define HWIO_TQM_R1_ERR_WDG_0_HW_SM_LIMIT_SHFT                                                                            0

#define HWIO_TQM_R1_ERR_WDG_1_ADDR(x)                                                                            ((x) + 0x20d4)
#define HWIO_TQM_R1_ERR_WDG_1_PHYS(x)                                                                            ((x) + 0x20d4)
#define HWIO_TQM_R1_ERR_WDG_1_OFFS                                                                               (0x20d4)
#define HWIO_TQM_R1_ERR_WDG_1_RMSK                                                                               0xffffffff
#define HWIO_TQM_R1_ERR_WDG_1_POR                                                                                0x00000000
#define HWIO_TQM_R1_ERR_WDG_1_POR_RMSK                                                                           0xffffffff
#define HWIO_TQM_R1_ERR_WDG_1_ATTR                                                                                            0x3
#define HWIO_TQM_R1_ERR_WDG_1_IN(x)            \
                in_dword(HWIO_TQM_R1_ERR_WDG_1_ADDR(x))
#define HWIO_TQM_R1_ERR_WDG_1_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_ERR_WDG_1_ADDR(x), m)
#define HWIO_TQM_R1_ERR_WDG_1_OUT(x, v)            \
                out_dword(HWIO_TQM_R1_ERR_WDG_1_ADDR(x),v)
#define HWIO_TQM_R1_ERR_WDG_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R1_ERR_WDG_1_ADDR(x),m,v,HWIO_TQM_R1_ERR_WDG_1_IN(x))
#define HWIO_TQM_R1_ERR_WDG_1_SW_SM_STATUS_BMSK                                                                  0xffff0000
#define HWIO_TQM_R1_ERR_WDG_1_SW_SM_STATUS_SHFT                                                                          16
#define HWIO_TQM_R1_ERR_WDG_1_SW_SM_LIMIT_BMSK                                                                       0xffff
#define HWIO_TQM_R1_ERR_WDG_1_SW_SM_LIMIT_SHFT                                                                            0

#define HWIO_TQM_R1_ERR_WDG_2_ADDR(x)                                                                            ((x) + 0x20d8)
#define HWIO_TQM_R1_ERR_WDG_2_PHYS(x)                                                                            ((x) + 0x20d8)
#define HWIO_TQM_R1_ERR_WDG_2_OFFS                                                                               (0x20d8)
#define HWIO_TQM_R1_ERR_WDG_2_RMSK                                                                               0xffffffff
#define HWIO_TQM_R1_ERR_WDG_2_POR                                                                                0x00000000
#define HWIO_TQM_R1_ERR_WDG_2_POR_RMSK                                                                           0xffffffff
#define HWIO_TQM_R1_ERR_WDG_2_ATTR                                                                                            0x3
#define HWIO_TQM_R1_ERR_WDG_2_IN(x)            \
                in_dword(HWIO_TQM_R1_ERR_WDG_2_ADDR(x))
#define HWIO_TQM_R1_ERR_WDG_2_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_ERR_WDG_2_ADDR(x), m)
#define HWIO_TQM_R1_ERR_WDG_2_OUT(x, v)            \
                out_dword(HWIO_TQM_R1_ERR_WDG_2_ADDR(x),v)
#define HWIO_TQM_R1_ERR_WDG_2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R1_ERR_WDG_2_ADDR(x),m,v,HWIO_TQM_R1_ERR_WDG_2_IN(x))
#define HWIO_TQM_R1_ERR_WDG_2_ENT_SM_STATUS_BMSK                                                                 0xffff0000
#define HWIO_TQM_R1_ERR_WDG_2_ENT_SM_STATUS_SHFT                                                                         16
#define HWIO_TQM_R1_ERR_WDG_2_ENT_SM_LIMIT_BMSK                                                                      0xffff
#define HWIO_TQM_R1_ERR_WDG_2_ENT_SM_LIMIT_SHFT                                                                           0

#define HWIO_TQM_R1_ERROR_STATUS_0_ADDR(x)                                                                       ((x) + 0x20dc)
#define HWIO_TQM_R1_ERROR_STATUS_0_PHYS(x)                                                                       ((x) + 0x20dc)
#define HWIO_TQM_R1_ERROR_STATUS_0_OFFS                                                                          (0x20dc)
#define HWIO_TQM_R1_ERROR_STATUS_0_RMSK                                                                                 0x7
#define HWIO_TQM_R1_ERROR_STATUS_0_POR                                                                           0x00000000
#define HWIO_TQM_R1_ERROR_STATUS_0_POR_RMSK                                                                      0xffffffff
#define HWIO_TQM_R1_ERROR_STATUS_0_ATTR                                                                                       0x0
#define HWIO_TQM_R1_ERROR_STATUS_0_IN(x)            \
                in_dword(HWIO_TQM_R1_ERROR_STATUS_0_ADDR(x))
#define HWIO_TQM_R1_ERROR_STATUS_0_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_ERROR_STATUS_0_ADDR(x), m)
#define HWIO_TQM_R1_ERROR_STATUS_0_OUT(x, v)            \
                out_dword(HWIO_TQM_R1_ERROR_STATUS_0_ADDR(x),v)
#define HWIO_TQM_R1_ERROR_STATUS_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R1_ERROR_STATUS_0_ADDR(x),m,v,HWIO_TQM_R1_ERROR_STATUS_0_IN(x))
#define HWIO_TQM_R1_ERROR_STATUS_0_MSDU_ENT_SM_INTERRUPT_BMSK                                                           0x4
#define HWIO_TQM_R1_ERROR_STATUS_0_MSDU_ENT_SM_INTERRUPT_SHFT                                                             2
#define HWIO_TQM_R1_ERROR_STATUS_0_SW_CMD_SM_INTERRUPT_BMSK                                                             0x2
#define HWIO_TQM_R1_ERROR_STATUS_0_SW_CMD_SM_INTERRUPT_SHFT                                                               1
#define HWIO_TQM_R1_ERROR_STATUS_0_HWSCH_SM_INTERRUPT_BMSK                                                              0x1
#define HWIO_TQM_R1_ERROR_STATUS_0_HWSCH_SM_INTERRUPT_SHFT                                                                0

#define HWIO_TQM_R1_CORRUPTED_CMD_SOURCE_ADDR(x)                                                                 ((x) + 0x20e0)
#define HWIO_TQM_R1_CORRUPTED_CMD_SOURCE_PHYS(x)                                                                 ((x) + 0x20e0)
#define HWIO_TQM_R1_CORRUPTED_CMD_SOURCE_OFFS                                                                    (0x20e0)
#define HWIO_TQM_R1_CORRUPTED_CMD_SOURCE_RMSK                                                                    0xffffffff
#define HWIO_TQM_R1_CORRUPTED_CMD_SOURCE_POR                                                                     0x00000000
#define HWIO_TQM_R1_CORRUPTED_CMD_SOURCE_POR_RMSK                                                                0xffffffff
#define HWIO_TQM_R1_CORRUPTED_CMD_SOURCE_ATTR                                                                                 0x1
#define HWIO_TQM_R1_CORRUPTED_CMD_SOURCE_IN(x)            \
                in_dword(HWIO_TQM_R1_CORRUPTED_CMD_SOURCE_ADDR(x))
#define HWIO_TQM_R1_CORRUPTED_CMD_SOURCE_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R1_CORRUPTED_CMD_SOURCE_ADDR(x), m)
#define HWIO_TQM_R1_CORRUPTED_CMD_SOURCE_TLV_HDR_BMSK                                                            0xffff0000
#define HWIO_TQM_R1_CORRUPTED_CMD_SOURCE_TLV_HDR_SHFT                                                                    16
#define HWIO_TQM_R1_CORRUPTED_CMD_SOURCE_VALUE_3_BMSK                                                                0xf000
#define HWIO_TQM_R1_CORRUPTED_CMD_SOURCE_VALUE_3_SHFT                                                                    12
#define HWIO_TQM_R1_CORRUPTED_CMD_SOURCE_VALUE_2_BMSK                                                                 0xf00
#define HWIO_TQM_R1_CORRUPTED_CMD_SOURCE_VALUE_2_SHFT                                                                     8
#define HWIO_TQM_R1_CORRUPTED_CMD_SOURCE_VALUE_1_BMSK                                                                  0xf0
#define HWIO_TQM_R1_CORRUPTED_CMD_SOURCE_VALUE_1_SHFT                                                                     4
#define HWIO_TQM_R1_CORRUPTED_CMD_SOURCE_VALUE_0_BMSK                                                                   0xf
#define HWIO_TQM_R1_CORRUPTED_CMD_SOURCE_VALUE_0_SHFT                                                                     0

#define HWIO_TQM_R2_TCL2TQM_RING_HP_ADDR(x)                                                                      ((x) + 0x3000)
#define HWIO_TQM_R2_TCL2TQM_RING_HP_PHYS(x)                                                                      ((x) + 0x3000)
#define HWIO_TQM_R2_TCL2TQM_RING_HP_OFFS                                                                         (0x3000)
#define HWIO_TQM_R2_TCL2TQM_RING_HP_RMSK                                                                             0xffff
#define HWIO_TQM_R2_TCL2TQM_RING_HP_POR                                                                          0x00000000
#define HWIO_TQM_R2_TCL2TQM_RING_HP_POR_RMSK                                                                     0xffffffff
#define HWIO_TQM_R2_TCL2TQM_RING_HP_ATTR                                                                                      0x3
#define HWIO_TQM_R2_TCL2TQM_RING_HP_IN(x)            \
                in_dword(HWIO_TQM_R2_TCL2TQM_RING_HP_ADDR(x))
#define HWIO_TQM_R2_TCL2TQM_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R2_TCL2TQM_RING_HP_ADDR(x), m)
#define HWIO_TQM_R2_TCL2TQM_RING_HP_OUT(x, v)            \
                out_dword(HWIO_TQM_R2_TCL2TQM_RING_HP_ADDR(x),v)
#define HWIO_TQM_R2_TCL2TQM_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R2_TCL2TQM_RING_HP_ADDR(x),m,v,HWIO_TQM_R2_TCL2TQM_RING_HP_IN(x))
#define HWIO_TQM_R2_TCL2TQM_RING_HP_HEAD_PTR_BMSK                                                                    0xffff
#define HWIO_TQM_R2_TCL2TQM_RING_HP_HEAD_PTR_SHFT                                                                         0

#define HWIO_TQM_R2_TCL2TQM_RING_TP_ADDR(x)                                                                      ((x) + 0x3004)
#define HWIO_TQM_R2_TCL2TQM_RING_TP_PHYS(x)                                                                      ((x) + 0x3004)
#define HWIO_TQM_R2_TCL2TQM_RING_TP_OFFS                                                                         (0x3004)
#define HWIO_TQM_R2_TCL2TQM_RING_TP_RMSK                                                                             0xffff
#define HWIO_TQM_R2_TCL2TQM_RING_TP_POR                                                                          0x00000000
#define HWIO_TQM_R2_TCL2TQM_RING_TP_POR_RMSK                                                                     0xffffffff
#define HWIO_TQM_R2_TCL2TQM_RING_TP_ATTR                                                                                      0x3
#define HWIO_TQM_R2_TCL2TQM_RING_TP_IN(x)            \
                in_dword(HWIO_TQM_R2_TCL2TQM_RING_TP_ADDR(x))
#define HWIO_TQM_R2_TCL2TQM_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R2_TCL2TQM_RING_TP_ADDR(x), m)
#define HWIO_TQM_R2_TCL2TQM_RING_TP_OUT(x, v)            \
                out_dword(HWIO_TQM_R2_TCL2TQM_RING_TP_ADDR(x),v)
#define HWIO_TQM_R2_TCL2TQM_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R2_TCL2TQM_RING_TP_ADDR(x),m,v,HWIO_TQM_R2_TCL2TQM_RING_TP_IN(x))
#define HWIO_TQM_R2_TCL2TQM_RING_TP_TAIL_PTR_BMSK                                                                    0xffff
#define HWIO_TQM_R2_TCL2TQM_RING_TP_TAIL_PTR_SHFT                                                                         0

#define HWIO_TQM_R2_FW2TQM_RING_HP_ADDR(x)                                                                       ((x) + 0x3008)
#define HWIO_TQM_R2_FW2TQM_RING_HP_PHYS(x)                                                                       ((x) + 0x3008)
#define HWIO_TQM_R2_FW2TQM_RING_HP_OFFS                                                                          (0x3008)
#define HWIO_TQM_R2_FW2TQM_RING_HP_RMSK                                                                              0xffff
#define HWIO_TQM_R2_FW2TQM_RING_HP_POR                                                                           0x00000000
#define HWIO_TQM_R2_FW2TQM_RING_HP_POR_RMSK                                                                      0xffffffff
#define HWIO_TQM_R2_FW2TQM_RING_HP_ATTR                                                                                       0x3
#define HWIO_TQM_R2_FW2TQM_RING_HP_IN(x)            \
                in_dword(HWIO_TQM_R2_FW2TQM_RING_HP_ADDR(x))
#define HWIO_TQM_R2_FW2TQM_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R2_FW2TQM_RING_HP_ADDR(x), m)
#define HWIO_TQM_R2_FW2TQM_RING_HP_OUT(x, v)            \
                out_dword(HWIO_TQM_R2_FW2TQM_RING_HP_ADDR(x),v)
#define HWIO_TQM_R2_FW2TQM_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R2_FW2TQM_RING_HP_ADDR(x),m,v,HWIO_TQM_R2_FW2TQM_RING_HP_IN(x))
#define HWIO_TQM_R2_FW2TQM_RING_HP_HEAD_PTR_BMSK                                                                     0xffff
#define HWIO_TQM_R2_FW2TQM_RING_HP_HEAD_PTR_SHFT                                                                          0

#define HWIO_TQM_R2_FW2TQM_RING_TP_ADDR(x)                                                                       ((x) + 0x300c)
#define HWIO_TQM_R2_FW2TQM_RING_TP_PHYS(x)                                                                       ((x) + 0x300c)
#define HWIO_TQM_R2_FW2TQM_RING_TP_OFFS                                                                          (0x300c)
#define HWIO_TQM_R2_FW2TQM_RING_TP_RMSK                                                                              0xffff
#define HWIO_TQM_R2_FW2TQM_RING_TP_POR                                                                           0x00000000
#define HWIO_TQM_R2_FW2TQM_RING_TP_POR_RMSK                                                                      0xffffffff
#define HWIO_TQM_R2_FW2TQM_RING_TP_ATTR                                                                                       0x3
#define HWIO_TQM_R2_FW2TQM_RING_TP_IN(x)            \
                in_dword(HWIO_TQM_R2_FW2TQM_RING_TP_ADDR(x))
#define HWIO_TQM_R2_FW2TQM_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R2_FW2TQM_RING_TP_ADDR(x), m)
#define HWIO_TQM_R2_FW2TQM_RING_TP_OUT(x, v)            \
                out_dword(HWIO_TQM_R2_FW2TQM_RING_TP_ADDR(x),v)
#define HWIO_TQM_R2_FW2TQM_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R2_FW2TQM_RING_TP_ADDR(x),m,v,HWIO_TQM_R2_FW2TQM_RING_TP_IN(x))
#define HWIO_TQM_R2_FW2TQM_RING_TP_TAIL_PTR_BMSK                                                                     0xffff
#define HWIO_TQM_R2_FW2TQM_RING_TP_TAIL_PTR_SHFT                                                                          0

#define HWIO_TQM_R2_SW_CMD_RING_HP_ADDR(x)                                                                       ((x) + 0x3010)
#define HWIO_TQM_R2_SW_CMD_RING_HP_PHYS(x)                                                                       ((x) + 0x3010)
#define HWIO_TQM_R2_SW_CMD_RING_HP_OFFS                                                                          (0x3010)
#define HWIO_TQM_R2_SW_CMD_RING_HP_RMSK                                                                              0xffff
#define HWIO_TQM_R2_SW_CMD_RING_HP_POR                                                                           0x00000000
#define HWIO_TQM_R2_SW_CMD_RING_HP_POR_RMSK                                                                      0xffffffff
#define HWIO_TQM_R2_SW_CMD_RING_HP_ATTR                                                                                       0x3
#define HWIO_TQM_R2_SW_CMD_RING_HP_IN(x)            \
                in_dword(HWIO_TQM_R2_SW_CMD_RING_HP_ADDR(x))
#define HWIO_TQM_R2_SW_CMD_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R2_SW_CMD_RING_HP_ADDR(x), m)
#define HWIO_TQM_R2_SW_CMD_RING_HP_OUT(x, v)            \
                out_dword(HWIO_TQM_R2_SW_CMD_RING_HP_ADDR(x),v)
#define HWIO_TQM_R2_SW_CMD_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R2_SW_CMD_RING_HP_ADDR(x),m,v,HWIO_TQM_R2_SW_CMD_RING_HP_IN(x))
#define HWIO_TQM_R2_SW_CMD_RING_HP_HEAD_PTR_BMSK                                                                     0xffff
#define HWIO_TQM_R2_SW_CMD_RING_HP_HEAD_PTR_SHFT                                                                          0

#define HWIO_TQM_R2_SW_CMD_RING_TP_ADDR(x)                                                                       ((x) + 0x3014)
#define HWIO_TQM_R2_SW_CMD_RING_TP_PHYS(x)                                                                       ((x) + 0x3014)
#define HWIO_TQM_R2_SW_CMD_RING_TP_OFFS                                                                          (0x3014)
#define HWIO_TQM_R2_SW_CMD_RING_TP_RMSK                                                                              0xffff
#define HWIO_TQM_R2_SW_CMD_RING_TP_POR                                                                           0x00000000
#define HWIO_TQM_R2_SW_CMD_RING_TP_POR_RMSK                                                                      0xffffffff
#define HWIO_TQM_R2_SW_CMD_RING_TP_ATTR                                                                                       0x3
#define HWIO_TQM_R2_SW_CMD_RING_TP_IN(x)            \
                in_dword(HWIO_TQM_R2_SW_CMD_RING_TP_ADDR(x))
#define HWIO_TQM_R2_SW_CMD_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R2_SW_CMD_RING_TP_ADDR(x), m)
#define HWIO_TQM_R2_SW_CMD_RING_TP_OUT(x, v)            \
                out_dword(HWIO_TQM_R2_SW_CMD_RING_TP_ADDR(x),v)
#define HWIO_TQM_R2_SW_CMD_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R2_SW_CMD_RING_TP_ADDR(x),m,v,HWIO_TQM_R2_SW_CMD_RING_TP_IN(x))
#define HWIO_TQM_R2_SW_CMD_RING_TP_TAIL_PTR_BMSK                                                                     0xffff
#define HWIO_TQM_R2_SW_CMD_RING_TP_TAIL_PTR_SHFT                                                                          0

#define HWIO_TQM_R2_SW_CMD1_RING_HP_ADDR(x)                                                                      ((x) + 0x3018)
#define HWIO_TQM_R2_SW_CMD1_RING_HP_PHYS(x)                                                                      ((x) + 0x3018)
#define HWIO_TQM_R2_SW_CMD1_RING_HP_OFFS                                                                         (0x3018)
#define HWIO_TQM_R2_SW_CMD1_RING_HP_RMSK                                                                             0xffff
#define HWIO_TQM_R2_SW_CMD1_RING_HP_POR                                                                          0x00000000
#define HWIO_TQM_R2_SW_CMD1_RING_HP_POR_RMSK                                                                     0xffffffff
#define HWIO_TQM_R2_SW_CMD1_RING_HP_ATTR                                                                                      0x3
#define HWIO_TQM_R2_SW_CMD1_RING_HP_IN(x)            \
                in_dword(HWIO_TQM_R2_SW_CMD1_RING_HP_ADDR(x))
#define HWIO_TQM_R2_SW_CMD1_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R2_SW_CMD1_RING_HP_ADDR(x), m)
#define HWIO_TQM_R2_SW_CMD1_RING_HP_OUT(x, v)            \
                out_dword(HWIO_TQM_R2_SW_CMD1_RING_HP_ADDR(x),v)
#define HWIO_TQM_R2_SW_CMD1_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R2_SW_CMD1_RING_HP_ADDR(x),m,v,HWIO_TQM_R2_SW_CMD1_RING_HP_IN(x))
#define HWIO_TQM_R2_SW_CMD1_RING_HP_HEAD_PTR_BMSK                                                                    0xffff
#define HWIO_TQM_R2_SW_CMD1_RING_HP_HEAD_PTR_SHFT                                                                         0

#define HWIO_TQM_R2_SW_CMD1_RING_TP_ADDR(x)                                                                      ((x) + 0x301c)
#define HWIO_TQM_R2_SW_CMD1_RING_TP_PHYS(x)                                                                      ((x) + 0x301c)
#define HWIO_TQM_R2_SW_CMD1_RING_TP_OFFS                                                                         (0x301c)
#define HWIO_TQM_R2_SW_CMD1_RING_TP_RMSK                                                                             0xffff
#define HWIO_TQM_R2_SW_CMD1_RING_TP_POR                                                                          0x00000000
#define HWIO_TQM_R2_SW_CMD1_RING_TP_POR_RMSK                                                                     0xffffffff
#define HWIO_TQM_R2_SW_CMD1_RING_TP_ATTR                                                                                      0x3
#define HWIO_TQM_R2_SW_CMD1_RING_TP_IN(x)            \
                in_dword(HWIO_TQM_R2_SW_CMD1_RING_TP_ADDR(x))
#define HWIO_TQM_R2_SW_CMD1_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R2_SW_CMD1_RING_TP_ADDR(x), m)
#define HWIO_TQM_R2_SW_CMD1_RING_TP_OUT(x, v)            \
                out_dword(HWIO_TQM_R2_SW_CMD1_RING_TP_ADDR(x),v)
#define HWIO_TQM_R2_SW_CMD1_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R2_SW_CMD1_RING_TP_ADDR(x),m,v,HWIO_TQM_R2_SW_CMD1_RING_TP_IN(x))
#define HWIO_TQM_R2_SW_CMD1_RING_TP_TAIL_PTR_BMSK                                                                    0xffff
#define HWIO_TQM_R2_SW_CMD1_RING_TP_TAIL_PTR_SHFT                                                                         0

#define HWIO_TQM_R2_WBM2TQM_LINK_RING_HP_ADDR(x)                                                                 ((x) + 0x3020)
#define HWIO_TQM_R2_WBM2TQM_LINK_RING_HP_PHYS(x)                                                                 ((x) + 0x3020)
#define HWIO_TQM_R2_WBM2TQM_LINK_RING_HP_OFFS                                                                    (0x3020)
#define HWIO_TQM_R2_WBM2TQM_LINK_RING_HP_RMSK                                                                        0xffff
#define HWIO_TQM_R2_WBM2TQM_LINK_RING_HP_POR                                                                     0x00000000
#define HWIO_TQM_R2_WBM2TQM_LINK_RING_HP_POR_RMSK                                                                0xffffffff
#define HWIO_TQM_R2_WBM2TQM_LINK_RING_HP_ATTR                                                                                 0x3
#define HWIO_TQM_R2_WBM2TQM_LINK_RING_HP_IN(x)            \
                in_dword(HWIO_TQM_R2_WBM2TQM_LINK_RING_HP_ADDR(x))
#define HWIO_TQM_R2_WBM2TQM_LINK_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R2_WBM2TQM_LINK_RING_HP_ADDR(x), m)
#define HWIO_TQM_R2_WBM2TQM_LINK_RING_HP_OUT(x, v)            \
                out_dword(HWIO_TQM_R2_WBM2TQM_LINK_RING_HP_ADDR(x),v)
#define HWIO_TQM_R2_WBM2TQM_LINK_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R2_WBM2TQM_LINK_RING_HP_ADDR(x),m,v,HWIO_TQM_R2_WBM2TQM_LINK_RING_HP_IN(x))
#define HWIO_TQM_R2_WBM2TQM_LINK_RING_HP_HEAD_PTR_BMSK                                                               0xffff
#define HWIO_TQM_R2_WBM2TQM_LINK_RING_HP_HEAD_PTR_SHFT                                                                    0

#define HWIO_TQM_R2_WBM2TQM_LINK_RING_TP_ADDR(x)                                                                 ((x) + 0x3024)
#define HWIO_TQM_R2_WBM2TQM_LINK_RING_TP_PHYS(x)                                                                 ((x) + 0x3024)
#define HWIO_TQM_R2_WBM2TQM_LINK_RING_TP_OFFS                                                                    (0x3024)
#define HWIO_TQM_R2_WBM2TQM_LINK_RING_TP_RMSK                                                                        0xffff
#define HWIO_TQM_R2_WBM2TQM_LINK_RING_TP_POR                                                                     0x00000000
#define HWIO_TQM_R2_WBM2TQM_LINK_RING_TP_POR_RMSK                                                                0xffffffff
#define HWIO_TQM_R2_WBM2TQM_LINK_RING_TP_ATTR                                                                                 0x3
#define HWIO_TQM_R2_WBM2TQM_LINK_RING_TP_IN(x)            \
                in_dword(HWIO_TQM_R2_WBM2TQM_LINK_RING_TP_ADDR(x))
#define HWIO_TQM_R2_WBM2TQM_LINK_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R2_WBM2TQM_LINK_RING_TP_ADDR(x), m)
#define HWIO_TQM_R2_WBM2TQM_LINK_RING_TP_OUT(x, v)            \
                out_dword(HWIO_TQM_R2_WBM2TQM_LINK_RING_TP_ADDR(x),v)
#define HWIO_TQM_R2_WBM2TQM_LINK_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R2_WBM2TQM_LINK_RING_TP_ADDR(x),m,v,HWIO_TQM_R2_WBM2TQM_LINK_RING_TP_IN(x))
#define HWIO_TQM_R2_WBM2TQM_LINK_RING_TP_TAIL_PTR_BMSK                                                               0xffff
#define HWIO_TQM_R2_WBM2TQM_LINK_RING_TP_TAIL_PTR_SHFT                                                                    0

#define HWIO_TQM_R2_TQM_RELEASE_RING_HP_ADDR(x)                                                                  ((x) + 0x3028)
#define HWIO_TQM_R2_TQM_RELEASE_RING_HP_PHYS(x)                                                                  ((x) + 0x3028)
#define HWIO_TQM_R2_TQM_RELEASE_RING_HP_OFFS                                                                     (0x3028)
#define HWIO_TQM_R2_TQM_RELEASE_RING_HP_RMSK                                                                         0xffff
#define HWIO_TQM_R2_TQM_RELEASE_RING_HP_POR                                                                      0x00000000
#define HWIO_TQM_R2_TQM_RELEASE_RING_HP_POR_RMSK                                                                 0xffffffff
#define HWIO_TQM_R2_TQM_RELEASE_RING_HP_ATTR                                                                                  0x3
#define HWIO_TQM_R2_TQM_RELEASE_RING_HP_IN(x)            \
                in_dword(HWIO_TQM_R2_TQM_RELEASE_RING_HP_ADDR(x))
#define HWIO_TQM_R2_TQM_RELEASE_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R2_TQM_RELEASE_RING_HP_ADDR(x), m)
#define HWIO_TQM_R2_TQM_RELEASE_RING_HP_OUT(x, v)            \
                out_dword(HWIO_TQM_R2_TQM_RELEASE_RING_HP_ADDR(x),v)
#define HWIO_TQM_R2_TQM_RELEASE_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R2_TQM_RELEASE_RING_HP_ADDR(x),m,v,HWIO_TQM_R2_TQM_RELEASE_RING_HP_IN(x))
#define HWIO_TQM_R2_TQM_RELEASE_RING_HP_HEAD_PTR_BMSK                                                                0xffff
#define HWIO_TQM_R2_TQM_RELEASE_RING_HP_HEAD_PTR_SHFT                                                                     0

#define HWIO_TQM_R2_TQM_RELEASE_RING_TP_ADDR(x)                                                                  ((x) + 0x302c)
#define HWIO_TQM_R2_TQM_RELEASE_RING_TP_PHYS(x)                                                                  ((x) + 0x302c)
#define HWIO_TQM_R2_TQM_RELEASE_RING_TP_OFFS                                                                     (0x302c)
#define HWIO_TQM_R2_TQM_RELEASE_RING_TP_RMSK                                                                         0xffff
#define HWIO_TQM_R2_TQM_RELEASE_RING_TP_POR                                                                      0x00000000
#define HWIO_TQM_R2_TQM_RELEASE_RING_TP_POR_RMSK                                                                 0xffffffff
#define HWIO_TQM_R2_TQM_RELEASE_RING_TP_ATTR                                                                                  0x3
#define HWIO_TQM_R2_TQM_RELEASE_RING_TP_IN(x)            \
                in_dword(HWIO_TQM_R2_TQM_RELEASE_RING_TP_ADDR(x))
#define HWIO_TQM_R2_TQM_RELEASE_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R2_TQM_RELEASE_RING_TP_ADDR(x), m)
#define HWIO_TQM_R2_TQM_RELEASE_RING_TP_OUT(x, v)            \
                out_dword(HWIO_TQM_R2_TQM_RELEASE_RING_TP_ADDR(x),v)
#define HWIO_TQM_R2_TQM_RELEASE_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R2_TQM_RELEASE_RING_TP_ADDR(x),m,v,HWIO_TQM_R2_TQM_RELEASE_RING_TP_IN(x))
#define HWIO_TQM_R2_TQM_RELEASE_RING_TP_TAIL_PTR_BMSK                                                                0xffff
#define HWIO_TQM_R2_TQM_RELEASE_RING_TP_TAIL_PTR_SHFT                                                                     0

#define HWIO_TQM_R2_TQM_STATUS_RING_HP_ADDR(x)                                                                   ((x) + 0x3030)
#define HWIO_TQM_R2_TQM_STATUS_RING_HP_PHYS(x)                                                                   ((x) + 0x3030)
#define HWIO_TQM_R2_TQM_STATUS_RING_HP_OFFS                                                                      (0x3030)
#define HWIO_TQM_R2_TQM_STATUS_RING_HP_RMSK                                                                          0xffff
#define HWIO_TQM_R2_TQM_STATUS_RING_HP_POR                                                                       0x00000000
#define HWIO_TQM_R2_TQM_STATUS_RING_HP_POR_RMSK                                                                  0xffffffff
#define HWIO_TQM_R2_TQM_STATUS_RING_HP_ATTR                                                                                   0x3
#define HWIO_TQM_R2_TQM_STATUS_RING_HP_IN(x)            \
                in_dword(HWIO_TQM_R2_TQM_STATUS_RING_HP_ADDR(x))
#define HWIO_TQM_R2_TQM_STATUS_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R2_TQM_STATUS_RING_HP_ADDR(x), m)
#define HWIO_TQM_R2_TQM_STATUS_RING_HP_OUT(x, v)            \
                out_dword(HWIO_TQM_R2_TQM_STATUS_RING_HP_ADDR(x),v)
#define HWIO_TQM_R2_TQM_STATUS_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R2_TQM_STATUS_RING_HP_ADDR(x),m,v,HWIO_TQM_R2_TQM_STATUS_RING_HP_IN(x))
#define HWIO_TQM_R2_TQM_STATUS_RING_HP_HEAD_PTR_BMSK                                                                 0xffff
#define HWIO_TQM_R2_TQM_STATUS_RING_HP_HEAD_PTR_SHFT                                                                      0

#define HWIO_TQM_R2_TQM_STATUS_RING_TP_ADDR(x)                                                                   ((x) + 0x3034)
#define HWIO_TQM_R2_TQM_STATUS_RING_TP_PHYS(x)                                                                   ((x) + 0x3034)
#define HWIO_TQM_R2_TQM_STATUS_RING_TP_OFFS                                                                      (0x3034)
#define HWIO_TQM_R2_TQM_STATUS_RING_TP_RMSK                                                                          0xffff
#define HWIO_TQM_R2_TQM_STATUS_RING_TP_POR                                                                       0x00000000
#define HWIO_TQM_R2_TQM_STATUS_RING_TP_POR_RMSK                                                                  0xffffffff
#define HWIO_TQM_R2_TQM_STATUS_RING_TP_ATTR                                                                                   0x3
#define HWIO_TQM_R2_TQM_STATUS_RING_TP_IN(x)            \
                in_dword(HWIO_TQM_R2_TQM_STATUS_RING_TP_ADDR(x))
#define HWIO_TQM_R2_TQM_STATUS_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R2_TQM_STATUS_RING_TP_ADDR(x), m)
#define HWIO_TQM_R2_TQM_STATUS_RING_TP_OUT(x, v)            \
                out_dword(HWIO_TQM_R2_TQM_STATUS_RING_TP_ADDR(x),v)
#define HWIO_TQM_R2_TQM_STATUS_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R2_TQM_STATUS_RING_TP_ADDR(x),m,v,HWIO_TQM_R2_TQM_STATUS_RING_TP_IN(x))
#define HWIO_TQM_R2_TQM_STATUS_RING_TP_TAIL_PTR_BMSK                                                                 0xffff
#define HWIO_TQM_R2_TQM_STATUS_RING_TP_TAIL_PTR_SHFT                                                                      0

#define HWIO_TQM_R2_TQM_STATUS1_RING_HP_ADDR(x)                                                                  ((x) + 0x3038)
#define HWIO_TQM_R2_TQM_STATUS1_RING_HP_PHYS(x)                                                                  ((x) + 0x3038)
#define HWIO_TQM_R2_TQM_STATUS1_RING_HP_OFFS                                                                     (0x3038)
#define HWIO_TQM_R2_TQM_STATUS1_RING_HP_RMSK                                                                         0xffff
#define HWIO_TQM_R2_TQM_STATUS1_RING_HP_POR                                                                      0x00000000
#define HWIO_TQM_R2_TQM_STATUS1_RING_HP_POR_RMSK                                                                 0xffffffff
#define HWIO_TQM_R2_TQM_STATUS1_RING_HP_ATTR                                                                                  0x3
#define HWIO_TQM_R2_TQM_STATUS1_RING_HP_IN(x)            \
                in_dword(HWIO_TQM_R2_TQM_STATUS1_RING_HP_ADDR(x))
#define HWIO_TQM_R2_TQM_STATUS1_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R2_TQM_STATUS1_RING_HP_ADDR(x), m)
#define HWIO_TQM_R2_TQM_STATUS1_RING_HP_OUT(x, v)            \
                out_dword(HWIO_TQM_R2_TQM_STATUS1_RING_HP_ADDR(x),v)
#define HWIO_TQM_R2_TQM_STATUS1_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R2_TQM_STATUS1_RING_HP_ADDR(x),m,v,HWIO_TQM_R2_TQM_STATUS1_RING_HP_IN(x))
#define HWIO_TQM_R2_TQM_STATUS1_RING_HP_HEAD_PTR_BMSK                                                                0xffff
#define HWIO_TQM_R2_TQM_STATUS1_RING_HP_HEAD_PTR_SHFT                                                                     0

#define HWIO_TQM_R2_TQM_STATUS1_RING_TP_ADDR(x)                                                                  ((x) + 0x303c)
#define HWIO_TQM_R2_TQM_STATUS1_RING_TP_PHYS(x)                                                                  ((x) + 0x303c)
#define HWIO_TQM_R2_TQM_STATUS1_RING_TP_OFFS                                                                     (0x303c)
#define HWIO_TQM_R2_TQM_STATUS1_RING_TP_RMSK                                                                         0xffff
#define HWIO_TQM_R2_TQM_STATUS1_RING_TP_POR                                                                      0x00000000
#define HWIO_TQM_R2_TQM_STATUS1_RING_TP_POR_RMSK                                                                 0xffffffff
#define HWIO_TQM_R2_TQM_STATUS1_RING_TP_ATTR                                                                                  0x3
#define HWIO_TQM_R2_TQM_STATUS1_RING_TP_IN(x)            \
                in_dword(HWIO_TQM_R2_TQM_STATUS1_RING_TP_ADDR(x))
#define HWIO_TQM_R2_TQM_STATUS1_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R2_TQM_STATUS1_RING_TP_ADDR(x), m)
#define HWIO_TQM_R2_TQM_STATUS1_RING_TP_OUT(x, v)            \
                out_dword(HWIO_TQM_R2_TQM_STATUS1_RING_TP_ADDR(x),v)
#define HWIO_TQM_R2_TQM_STATUS1_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R2_TQM_STATUS1_RING_TP_ADDR(x),m,v,HWIO_TQM_R2_TQM_STATUS1_RING_TP_IN(x))
#define HWIO_TQM_R2_TQM_STATUS1_RING_TP_TAIL_PTR_BMSK                                                                0xffff
#define HWIO_TQM_R2_TQM_STATUS1_RING_TP_TAIL_PTR_SHFT                                                                     0

#define HWIO_TQM_R2_TQM2TQM_IN1_RING_HP_ADDR(x)                                                                  ((x) + 0x3040)
#define HWIO_TQM_R2_TQM2TQM_IN1_RING_HP_PHYS(x)                                                                  ((x) + 0x3040)
#define HWIO_TQM_R2_TQM2TQM_IN1_RING_HP_OFFS                                                                     (0x3040)
#define HWIO_TQM_R2_TQM2TQM_IN1_RING_HP_RMSK                                                                         0xffff
#define HWIO_TQM_R2_TQM2TQM_IN1_RING_HP_POR                                                                      0x00000000
#define HWIO_TQM_R2_TQM2TQM_IN1_RING_HP_POR_RMSK                                                                 0xffffffff
#define HWIO_TQM_R2_TQM2TQM_IN1_RING_HP_ATTR                                                                                  0x3
#define HWIO_TQM_R2_TQM2TQM_IN1_RING_HP_IN(x)            \
                in_dword(HWIO_TQM_R2_TQM2TQM_IN1_RING_HP_ADDR(x))
#define HWIO_TQM_R2_TQM2TQM_IN1_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R2_TQM2TQM_IN1_RING_HP_ADDR(x), m)
#define HWIO_TQM_R2_TQM2TQM_IN1_RING_HP_OUT(x, v)            \
                out_dword(HWIO_TQM_R2_TQM2TQM_IN1_RING_HP_ADDR(x),v)
#define HWIO_TQM_R2_TQM2TQM_IN1_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R2_TQM2TQM_IN1_RING_HP_ADDR(x),m,v,HWIO_TQM_R2_TQM2TQM_IN1_RING_HP_IN(x))
#define HWIO_TQM_R2_TQM2TQM_IN1_RING_HP_HEAD_PTR_BMSK                                                                0xffff
#define HWIO_TQM_R2_TQM2TQM_IN1_RING_HP_HEAD_PTR_SHFT                                                                     0

#define HWIO_TQM_R2_TQM2TQM_IN1_RING_TP_ADDR(x)                                                                  ((x) + 0x3044)
#define HWIO_TQM_R2_TQM2TQM_IN1_RING_TP_PHYS(x)                                                                  ((x) + 0x3044)
#define HWIO_TQM_R2_TQM2TQM_IN1_RING_TP_OFFS                                                                     (0x3044)
#define HWIO_TQM_R2_TQM2TQM_IN1_RING_TP_RMSK                                                                         0xffff
#define HWIO_TQM_R2_TQM2TQM_IN1_RING_TP_POR                                                                      0x00000000
#define HWIO_TQM_R2_TQM2TQM_IN1_RING_TP_POR_RMSK                                                                 0xffffffff
#define HWIO_TQM_R2_TQM2TQM_IN1_RING_TP_ATTR                                                                                  0x3
#define HWIO_TQM_R2_TQM2TQM_IN1_RING_TP_IN(x)            \
                in_dword(HWIO_TQM_R2_TQM2TQM_IN1_RING_TP_ADDR(x))
#define HWIO_TQM_R2_TQM2TQM_IN1_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R2_TQM2TQM_IN1_RING_TP_ADDR(x), m)
#define HWIO_TQM_R2_TQM2TQM_IN1_RING_TP_OUT(x, v)            \
                out_dword(HWIO_TQM_R2_TQM2TQM_IN1_RING_TP_ADDR(x),v)
#define HWIO_TQM_R2_TQM2TQM_IN1_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R2_TQM2TQM_IN1_RING_TP_ADDR(x),m,v,HWIO_TQM_R2_TQM2TQM_IN1_RING_TP_IN(x))
#define HWIO_TQM_R2_TQM2TQM_IN1_RING_TP_TAIL_PTR_BMSK                                                                0xffff
#define HWIO_TQM_R2_TQM2TQM_IN1_RING_TP_TAIL_PTR_SHFT                                                                     0

#define HWIO_TQM_R2_TQM2TQM_IN2_RING_HP_ADDR(x)                                                                  ((x) + 0x3048)
#define HWIO_TQM_R2_TQM2TQM_IN2_RING_HP_PHYS(x)                                                                  ((x) + 0x3048)
#define HWIO_TQM_R2_TQM2TQM_IN2_RING_HP_OFFS                                                                     (0x3048)
#define HWIO_TQM_R2_TQM2TQM_IN2_RING_HP_RMSK                                                                         0xffff
#define HWIO_TQM_R2_TQM2TQM_IN2_RING_HP_POR                                                                      0x00000000
#define HWIO_TQM_R2_TQM2TQM_IN2_RING_HP_POR_RMSK                                                                 0xffffffff
#define HWIO_TQM_R2_TQM2TQM_IN2_RING_HP_ATTR                                                                                  0x3
#define HWIO_TQM_R2_TQM2TQM_IN2_RING_HP_IN(x)            \
                in_dword(HWIO_TQM_R2_TQM2TQM_IN2_RING_HP_ADDR(x))
#define HWIO_TQM_R2_TQM2TQM_IN2_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R2_TQM2TQM_IN2_RING_HP_ADDR(x), m)
#define HWIO_TQM_R2_TQM2TQM_IN2_RING_HP_OUT(x, v)            \
                out_dword(HWIO_TQM_R2_TQM2TQM_IN2_RING_HP_ADDR(x),v)
#define HWIO_TQM_R2_TQM2TQM_IN2_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R2_TQM2TQM_IN2_RING_HP_ADDR(x),m,v,HWIO_TQM_R2_TQM2TQM_IN2_RING_HP_IN(x))
#define HWIO_TQM_R2_TQM2TQM_IN2_RING_HP_HEAD_PTR_BMSK                                                                0xffff
#define HWIO_TQM_R2_TQM2TQM_IN2_RING_HP_HEAD_PTR_SHFT                                                                     0

#define HWIO_TQM_R2_TQM2TQM_IN2_RING_TP_ADDR(x)                                                                  ((x) + 0x304c)
#define HWIO_TQM_R2_TQM2TQM_IN2_RING_TP_PHYS(x)                                                                  ((x) + 0x304c)
#define HWIO_TQM_R2_TQM2TQM_IN2_RING_TP_OFFS                                                                     (0x304c)
#define HWIO_TQM_R2_TQM2TQM_IN2_RING_TP_RMSK                                                                         0xffff
#define HWIO_TQM_R2_TQM2TQM_IN2_RING_TP_POR                                                                      0x00000000
#define HWIO_TQM_R2_TQM2TQM_IN2_RING_TP_POR_RMSK                                                                 0xffffffff
#define HWIO_TQM_R2_TQM2TQM_IN2_RING_TP_ATTR                                                                                  0x3
#define HWIO_TQM_R2_TQM2TQM_IN2_RING_TP_IN(x)            \
                in_dword(HWIO_TQM_R2_TQM2TQM_IN2_RING_TP_ADDR(x))
#define HWIO_TQM_R2_TQM2TQM_IN2_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R2_TQM2TQM_IN2_RING_TP_ADDR(x), m)
#define HWIO_TQM_R2_TQM2TQM_IN2_RING_TP_OUT(x, v)            \
                out_dword(HWIO_TQM_R2_TQM2TQM_IN2_RING_TP_ADDR(x),v)
#define HWIO_TQM_R2_TQM2TQM_IN2_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R2_TQM2TQM_IN2_RING_TP_ADDR(x),m,v,HWIO_TQM_R2_TQM2TQM_IN2_RING_TP_IN(x))
#define HWIO_TQM_R2_TQM2TQM_IN2_RING_TP_TAIL_PTR_BMSK                                                                0xffff
#define HWIO_TQM_R2_TQM2TQM_IN2_RING_TP_TAIL_PTR_SHFT                                                                     0

#define HWIO_TQM_R2_TQM2TQM_OUT1_RING_HP_ADDR(x)                                                                 ((x) + 0x3050)
#define HWIO_TQM_R2_TQM2TQM_OUT1_RING_HP_PHYS(x)                                                                 ((x) + 0x3050)
#define HWIO_TQM_R2_TQM2TQM_OUT1_RING_HP_OFFS                                                                    (0x3050)
#define HWIO_TQM_R2_TQM2TQM_OUT1_RING_HP_RMSK                                                                        0xffff
#define HWIO_TQM_R2_TQM2TQM_OUT1_RING_HP_POR                                                                     0x00000000
#define HWIO_TQM_R2_TQM2TQM_OUT1_RING_HP_POR_RMSK                                                                0xffffffff
#define HWIO_TQM_R2_TQM2TQM_OUT1_RING_HP_ATTR                                                                                 0x3
#define HWIO_TQM_R2_TQM2TQM_OUT1_RING_HP_IN(x)            \
                in_dword(HWIO_TQM_R2_TQM2TQM_OUT1_RING_HP_ADDR(x))
#define HWIO_TQM_R2_TQM2TQM_OUT1_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R2_TQM2TQM_OUT1_RING_HP_ADDR(x), m)
#define HWIO_TQM_R2_TQM2TQM_OUT1_RING_HP_OUT(x, v)            \
                out_dword(HWIO_TQM_R2_TQM2TQM_OUT1_RING_HP_ADDR(x),v)
#define HWIO_TQM_R2_TQM2TQM_OUT1_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R2_TQM2TQM_OUT1_RING_HP_ADDR(x),m,v,HWIO_TQM_R2_TQM2TQM_OUT1_RING_HP_IN(x))
#define HWIO_TQM_R2_TQM2TQM_OUT1_RING_HP_HEAD_PTR_BMSK                                                               0xffff
#define HWIO_TQM_R2_TQM2TQM_OUT1_RING_HP_HEAD_PTR_SHFT                                                                    0

#define HWIO_TQM_R2_TQM2TQM_OUT1_RING_TP_ADDR(x)                                                                 ((x) + 0x3054)
#define HWIO_TQM_R2_TQM2TQM_OUT1_RING_TP_PHYS(x)                                                                 ((x) + 0x3054)
#define HWIO_TQM_R2_TQM2TQM_OUT1_RING_TP_OFFS                                                                    (0x3054)
#define HWIO_TQM_R2_TQM2TQM_OUT1_RING_TP_RMSK                                                                        0xffff
#define HWIO_TQM_R2_TQM2TQM_OUT1_RING_TP_POR                                                                     0x00000000
#define HWIO_TQM_R2_TQM2TQM_OUT1_RING_TP_POR_RMSK                                                                0xffffffff
#define HWIO_TQM_R2_TQM2TQM_OUT1_RING_TP_ATTR                                                                                 0x3
#define HWIO_TQM_R2_TQM2TQM_OUT1_RING_TP_IN(x)            \
                in_dword(HWIO_TQM_R2_TQM2TQM_OUT1_RING_TP_ADDR(x))
#define HWIO_TQM_R2_TQM2TQM_OUT1_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R2_TQM2TQM_OUT1_RING_TP_ADDR(x), m)
#define HWIO_TQM_R2_TQM2TQM_OUT1_RING_TP_OUT(x, v)            \
                out_dword(HWIO_TQM_R2_TQM2TQM_OUT1_RING_TP_ADDR(x),v)
#define HWIO_TQM_R2_TQM2TQM_OUT1_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R2_TQM2TQM_OUT1_RING_TP_ADDR(x),m,v,HWIO_TQM_R2_TQM2TQM_OUT1_RING_TP_IN(x))
#define HWIO_TQM_R2_TQM2TQM_OUT1_RING_TP_TAIL_PTR_BMSK                                                               0xffff
#define HWIO_TQM_R2_TQM2TQM_OUT1_RING_TP_TAIL_PTR_SHFT                                                                    0

#define HWIO_TQM_R2_TQM2TQM_OUT2_RING_HP_ADDR(x)                                                                 ((x) + 0x3058)
#define HWIO_TQM_R2_TQM2TQM_OUT2_RING_HP_PHYS(x)                                                                 ((x) + 0x3058)
#define HWIO_TQM_R2_TQM2TQM_OUT2_RING_HP_OFFS                                                                    (0x3058)
#define HWIO_TQM_R2_TQM2TQM_OUT2_RING_HP_RMSK                                                                        0xffff
#define HWIO_TQM_R2_TQM2TQM_OUT2_RING_HP_POR                                                                     0x00000000
#define HWIO_TQM_R2_TQM2TQM_OUT2_RING_HP_POR_RMSK                                                                0xffffffff
#define HWIO_TQM_R2_TQM2TQM_OUT2_RING_HP_ATTR                                                                                 0x3
#define HWIO_TQM_R2_TQM2TQM_OUT2_RING_HP_IN(x)            \
                in_dword(HWIO_TQM_R2_TQM2TQM_OUT2_RING_HP_ADDR(x))
#define HWIO_TQM_R2_TQM2TQM_OUT2_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R2_TQM2TQM_OUT2_RING_HP_ADDR(x), m)
#define HWIO_TQM_R2_TQM2TQM_OUT2_RING_HP_OUT(x, v)            \
                out_dword(HWIO_TQM_R2_TQM2TQM_OUT2_RING_HP_ADDR(x),v)
#define HWIO_TQM_R2_TQM2TQM_OUT2_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R2_TQM2TQM_OUT2_RING_HP_ADDR(x),m,v,HWIO_TQM_R2_TQM2TQM_OUT2_RING_HP_IN(x))
#define HWIO_TQM_R2_TQM2TQM_OUT2_RING_HP_HEAD_PTR_BMSK                                                               0xffff
#define HWIO_TQM_R2_TQM2TQM_OUT2_RING_HP_HEAD_PTR_SHFT                                                                    0

#define HWIO_TQM_R2_TQM2TQM_OUT2_RING_TP_ADDR(x)                                                                 ((x) + 0x305c)
#define HWIO_TQM_R2_TQM2TQM_OUT2_RING_TP_PHYS(x)                                                                 ((x) + 0x305c)
#define HWIO_TQM_R2_TQM2TQM_OUT2_RING_TP_OFFS                                                                    (0x305c)
#define HWIO_TQM_R2_TQM2TQM_OUT2_RING_TP_RMSK                                                                        0xffff
#define HWIO_TQM_R2_TQM2TQM_OUT2_RING_TP_POR                                                                     0x00000000
#define HWIO_TQM_R2_TQM2TQM_OUT2_RING_TP_POR_RMSK                                                                0xffffffff
#define HWIO_TQM_R2_TQM2TQM_OUT2_RING_TP_ATTR                                                                                 0x3
#define HWIO_TQM_R2_TQM2TQM_OUT2_RING_TP_IN(x)            \
                in_dword(HWIO_TQM_R2_TQM2TQM_OUT2_RING_TP_ADDR(x))
#define HWIO_TQM_R2_TQM2TQM_OUT2_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_TQM_R2_TQM2TQM_OUT2_RING_TP_ADDR(x), m)
#define HWIO_TQM_R2_TQM2TQM_OUT2_RING_TP_OUT(x, v)            \
                out_dword(HWIO_TQM_R2_TQM2TQM_OUT2_RING_TP_ADDR(x),v)
#define HWIO_TQM_R2_TQM2TQM_OUT2_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TQM_R2_TQM2TQM_OUT2_RING_TP_ADDR(x),m,v,HWIO_TQM_R2_TQM2TQM_OUT2_RING_TP_IN(x))
#define HWIO_TQM_R2_TQM2TQM_OUT2_RING_TP_TAIL_PTR_BMSK                                                               0xffff
#define HWIO_TQM_R2_TQM2TQM_OUT2_RING_TP_TAIL_PTR_SHFT                                                                    0

/*----------------------------------------------------------------------------
 * MODULE: MAC_UMCMN_REG
 *--------------------------------------------------------------------------*/

#define MAC_UMCMN_REG_REG_BASE                                                                  (UMAC_BASE      + 0x00040000)
#define MAC_UMCMN_REG_REG_BASE_SIZE                                                             0x4000
#define MAC_UMCMN_REG_REG_BASE_USED                                                             0x200c
#define MAC_UMCMN_REG_REG_BASE_PHYS                                                             (UMAC_BASE_PHYS + 0x00040000)
#define MAC_UMCMN_REG_REG_BASE_OFFS                                                             0x00040000

#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_ADDR(x)                                                  ((x) + 0x0)
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_PHYS(x)                                                  ((x) + 0x0)
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_OFFS                                                     (0x0)
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_RMSK                                                       0x6ffe22
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_POR                                                      0x006ffe22
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_POR_RMSK                                                 0xffffffff
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_ATTR                                                                  0x3
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_IN(x)            \
                in_dword(HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_ADDR(x))
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_ADDR(x), m)
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_ADDR(x),v)
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_ADDR(x),m,v,HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_IN(x))
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_MXI_BMSK                                                   0x400000
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_MXI_SHFT                                                         22
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_UMAC_DBG_BMSK                                              0x200000
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_UMAC_DBG_SHFT                                                    21
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_TRC_APB_BMSK                                                0x80000
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_TRC_APB_SHFT                                                     19
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_TRC_BMSK                                                    0x40000
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_TRC_SHFT                                                         18
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_WBM_APB_BMSK                                                0x20000
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_WBM_APB_SHFT                                                     17
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_WBM_BMSK                                                    0x10000
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_WBM_SHFT                                                         16
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_TQM_APB_BMSK                                                 0x8000
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_TQM_APB_SHFT                                                     15
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_TQM_BMSK                                                     0x4000
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_TQM_SHFT                                                         14
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_TCL_APB_BMSK                                                 0x2000
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_TCL_APB_SHFT                                                     13
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_TCL_BMSK                                                     0x1000
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_TCL_SHFT                                                         12
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_REO_APB_BMSK                                                  0x800
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_REO_APB_SHFT                                                     11
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_REO_BMSK                                                      0x400
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_REO_SHFT                                                         10
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_NOC_DBG_BMSK                                                  0x200
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_NOC_DBG_SHFT                                                      9
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_CMEM_BMSK                                                      0x20
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_CMEM_SHFT                                                         5
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_NOC_BMSK                                                        0x2
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKEN_NOC_SHFT                                                          1

#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_ADDR(x)                                        ((x) + 0x4)
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_PHYS(x)                                        ((x) + 0x4)
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_OFFS                                           (0x4)
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_RMSK                                             0x6ffc22
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_POR                                            0x00000002
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_POR_RMSK                                       0xffffffff
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_ATTR                                                        0x3
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_IN(x)            \
                in_dword(HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_ADDR(x))
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_ADDR(x), m)
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_ADDR(x),v)
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_ADDR(x),m,v,HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_IN(x))
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_MXI_BMSK                                         0x400000
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_MXI_SHFT                                               22
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_UMAC_DBG_BMSK                                    0x200000
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_UMAC_DBG_SHFT                                          21
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_TRC_APB_BMSK                                      0x80000
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_TRC_APB_SHFT                                           19
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_TRC_BMSK                                          0x40000
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_TRC_SHFT                                               18
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_WBM_APB_BMSK                                      0x20000
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_WBM_APB_SHFT                                           17
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_WBM_BMSK                                          0x10000
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_WBM_SHFT                                               16
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_TQM_APB_BMSK                                       0x8000
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_TQM_APB_SHFT                                           15
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_TQM_BMSK                                           0x4000
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_TQM_SHFT                                               14
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_TCL_APB_BMSK                                       0x2000
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_TCL_APB_SHFT                                           13
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_TCL_BMSK                                           0x1000
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_TCL_SHFT                                               12
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_REO_APB_BMSK                                        0x800
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_REO_APB_SHFT                                           11
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_REO_BMSK                                            0x400
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_REO_SHFT                                               10
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_CMEM_BMSK                                            0x20
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_CMEM_SHFT                                               5
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_NOC_BMSK                                              0x2
#define HWIO_UMCMN_R0_UMRCM_ROOT_CLKGATE_DISABLE_NOC_SHFT                                                1

#define HWIO_UMCMN_R0_UMRCM_SOFTRESET_ADDR(x)                                                   ((x) + 0x8)
#define HWIO_UMCMN_R0_UMRCM_SOFTRESET_PHYS(x)                                                   ((x) + 0x8)
#define HWIO_UMCMN_R0_UMRCM_SOFTRESET_OFFS                                                      (0x8)
#define HWIO_UMCMN_R0_UMRCM_SOFTRESET_RMSK                                                           0xdf3
#define HWIO_UMCMN_R0_UMRCM_SOFTRESET_POR                                                       0x00000000
#define HWIO_UMCMN_R0_UMRCM_SOFTRESET_POR_RMSK                                                  0xffffffff
#define HWIO_UMCMN_R0_UMRCM_SOFTRESET_ATTR                                                                   0x3
#define HWIO_UMCMN_R0_UMRCM_SOFTRESET_IN(x)            \
                in_dword(HWIO_UMCMN_R0_UMRCM_SOFTRESET_ADDR(x))
#define HWIO_UMCMN_R0_UMRCM_SOFTRESET_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_UMRCM_SOFTRESET_ADDR(x), m)
#define HWIO_UMCMN_R0_UMRCM_SOFTRESET_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_UMRCM_SOFTRESET_ADDR(x),v)
#define HWIO_UMCMN_R0_UMRCM_SOFTRESET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_UMRCM_SOFTRESET_ADDR(x),m,v,HWIO_UMCMN_R0_UMRCM_SOFTRESET_IN(x))
#define HWIO_UMCMN_R0_UMRCM_SOFTRESET_MXI_BMSK                                                       0x800
#define HWIO_UMCMN_R0_UMRCM_SOFTRESET_MXI_SHFT                                                          11
#define HWIO_UMCMN_R0_UMRCM_SOFTRESET_UMAC_DBG_BMSK                                                  0x400
#define HWIO_UMCMN_R0_UMRCM_SOFTRESET_UMAC_DBG_SHFT                                                     10
#define HWIO_UMCMN_R0_UMRCM_SOFTRESET_TRC_BMSK                                                       0x100
#define HWIO_UMCMN_R0_UMRCM_SOFTRESET_TRC_SHFT                                                           8
#define HWIO_UMCMN_R0_UMRCM_SOFTRESET_WBM_BMSK                                                        0x80
#define HWIO_UMCMN_R0_UMRCM_SOFTRESET_WBM_SHFT                                                           7
#define HWIO_UMCMN_R0_UMRCM_SOFTRESET_TQM_BMSK                                                        0x40
#define HWIO_UMCMN_R0_UMRCM_SOFTRESET_TQM_SHFT                                                           6
#define HWIO_UMCMN_R0_UMRCM_SOFTRESET_TCL_BMSK                                                        0x20
#define HWIO_UMCMN_R0_UMRCM_SOFTRESET_TCL_SHFT                                                           5
#define HWIO_UMCMN_R0_UMRCM_SOFTRESET_REO_BMSK                                                        0x10
#define HWIO_UMCMN_R0_UMRCM_SOFTRESET_REO_SHFT                                                           4
#define HWIO_UMCMN_R0_UMRCM_SOFTRESET_CMEM_BMSK                                                        0x2
#define HWIO_UMCMN_R0_UMRCM_SOFTRESET_CMEM_SHFT                                                          1
#define HWIO_UMCMN_R0_UMRCM_SOFTRESET_NOC_BMSK                                                         0x1
#define HWIO_UMCMN_R0_UMRCM_SOFTRESET_NOC_SHFT                                                           0

#define HWIO_UMCMN_R0_UMRCM_CONFIGRESET_ADDR(x)                                                 ((x) + 0xc)
#define HWIO_UMCMN_R0_UMRCM_CONFIGRESET_PHYS(x)                                                 ((x) + 0xc)
#define HWIO_UMCMN_R0_UMRCM_CONFIGRESET_OFFS                                                    (0xc)
#define HWIO_UMCMN_R0_UMRCM_CONFIGRESET_RMSK                                                          0x7e
#define HWIO_UMCMN_R0_UMRCM_CONFIGRESET_POR                                                     0x00000000
#define HWIO_UMCMN_R0_UMRCM_CONFIGRESET_POR_RMSK                                                0xffffffff
#define HWIO_UMCMN_R0_UMRCM_CONFIGRESET_ATTR                                                                 0x3
#define HWIO_UMCMN_R0_UMRCM_CONFIGRESET_IN(x)            \
                in_dword(HWIO_UMCMN_R0_UMRCM_CONFIGRESET_ADDR(x))
#define HWIO_UMCMN_R0_UMRCM_CONFIGRESET_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_UMRCM_CONFIGRESET_ADDR(x), m)
#define HWIO_UMCMN_R0_UMRCM_CONFIGRESET_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_UMRCM_CONFIGRESET_ADDR(x),v)
#define HWIO_UMCMN_R0_UMRCM_CONFIGRESET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_UMRCM_CONFIGRESET_ADDR(x),m,v,HWIO_UMCMN_R0_UMRCM_CONFIGRESET_IN(x))
#define HWIO_UMCMN_R0_UMRCM_CONFIGRESET_MXI_BMSK                                                      0x40
#define HWIO_UMCMN_R0_UMRCM_CONFIGRESET_MXI_SHFT                                                         6
#define HWIO_UMCMN_R0_UMRCM_CONFIGRESET_TRC_BMSK                                                      0x20
#define HWIO_UMCMN_R0_UMRCM_CONFIGRESET_TRC_SHFT                                                         5
#define HWIO_UMCMN_R0_UMRCM_CONFIGRESET_WBM_BMSK                                                      0x10
#define HWIO_UMCMN_R0_UMRCM_CONFIGRESET_WBM_SHFT                                                         4
#define HWIO_UMCMN_R0_UMRCM_CONFIGRESET_TQM_BMSK                                                       0x8
#define HWIO_UMCMN_R0_UMRCM_CONFIGRESET_TQM_SHFT                                                         3
#define HWIO_UMCMN_R0_UMRCM_CONFIGRESET_TCL_BMSK                                                       0x4
#define HWIO_UMCMN_R0_UMRCM_CONFIGRESET_TCL_SHFT                                                         2
#define HWIO_UMCMN_R0_UMRCM_CONFIGRESET_REO_BMSK                                                       0x2
#define HWIO_UMCMN_R0_UMRCM_CONFIGRESET_REO_SHFT                                                         1

#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_ADDR(x)                                             ((x) + 0x10)
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_PHYS(x)                                             ((x) + 0x10)
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_OFFS                                                (0x10)
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_RMSK                                                  0xcffc22
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_POR                                                 0x00000000
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_POR_RMSK                                            0xffffffff
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_ATTR                                                             0x3
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_IN(x)            \
                in_dword(HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_ADDR(x))
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_ADDR(x), m)
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_ADDR(x),v)
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_ADDR(x),m,v,HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_IN(x))
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_MXI_BMSK                                              0x800000
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_MXI_SHFT                                                    23
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_UMAC_DBG_BMSK                                         0x400000
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_UMAC_DBG_SHFT                                               22
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_TRC_APB_BMSK                                           0x80000
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_TRC_APB_SHFT                                                19
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_TRC_BMSK                                               0x40000
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_TRC_SHFT                                                    18
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_WBM_APB_BMSK                                           0x20000
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_WBM_APB_SHFT                                                17
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_WBM_BMSK                                               0x10000
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_WBM_SHFT                                                    16
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_TQM_APB_BMSK                                            0x8000
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_TQM_APB_SHFT                                                15
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_TQM_BMSK                                                0x4000
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_TQM_SHFT                                                    14
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_TCL_APB_BMSK                                            0x2000
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_TCL_APB_SHFT                                                13
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_TCL_BMSK                                                0x1000
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_TCL_SHFT                                                    12
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_REO_APB_BMSK                                             0x800
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_REO_APB_SHFT                                                11
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_REO_BMSK                                                 0x400
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_REO_SHFT                                                    10
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_CMEM_BMSK                                                 0x20
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_CMEM_SHFT                                                    5
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_NOC_BMSK                                                   0x2
#define HWIO_UMCMN_R0_UMRCM_CLKGATE_DISABLE_NOC_SHFT                                                     1

#define HWIO_UMCMN_R0_UMAC_RTL_VERSION_ADDR(x)                                                  ((x) + 0x14)
#define HWIO_UMCMN_R0_UMAC_RTL_VERSION_PHYS(x)                                                  ((x) + 0x14)
#define HWIO_UMCMN_R0_UMAC_RTL_VERSION_OFFS                                                     (0x14)
#define HWIO_UMCMN_R0_UMAC_RTL_VERSION_RMSK                                                     0xffffffff
#define HWIO_UMCMN_R0_UMAC_RTL_VERSION_POR                                                      0x00000000
#define HWIO_UMCMN_R0_UMAC_RTL_VERSION_POR_RMSK                                                 0xffffffff
#define HWIO_UMCMN_R0_UMAC_RTL_VERSION_ATTR                                                                  0x1
#define HWIO_UMCMN_R0_UMAC_RTL_VERSION_IN(x)            \
                in_dword(HWIO_UMCMN_R0_UMAC_RTL_VERSION_ADDR(x))
#define HWIO_UMCMN_R0_UMAC_RTL_VERSION_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_UMAC_RTL_VERSION_ADDR(x), m)
#define HWIO_UMCMN_R0_UMAC_RTL_VERSION_VAL_BMSK                                                 0xffffffff
#define HWIO_UMCMN_R0_UMAC_RTL_VERSION_VAL_SHFT                                                          0

#define HWIO_UMCMN_R0_ASYNC_FIFO_SOFTRESET_ADDR(x)                                              ((x) + 0x18)
#define HWIO_UMCMN_R0_ASYNC_FIFO_SOFTRESET_PHYS(x)                                              ((x) + 0x18)
#define HWIO_UMCMN_R0_ASYNC_FIFO_SOFTRESET_OFFS                                                 (0x18)
#define HWIO_UMCMN_R0_ASYNC_FIFO_SOFTRESET_RMSK                                                       0x1f
#define HWIO_UMCMN_R0_ASYNC_FIFO_SOFTRESET_POR                                                  0x00000000
#define HWIO_UMCMN_R0_ASYNC_FIFO_SOFTRESET_POR_RMSK                                             0xffffffff
#define HWIO_UMCMN_R0_ASYNC_FIFO_SOFTRESET_ATTR                                                              0x3
#define HWIO_UMCMN_R0_ASYNC_FIFO_SOFTRESET_IN(x)            \
                in_dword(HWIO_UMCMN_R0_ASYNC_FIFO_SOFTRESET_ADDR(x))
#define HWIO_UMCMN_R0_ASYNC_FIFO_SOFTRESET_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_ASYNC_FIFO_SOFTRESET_ADDR(x), m)
#define HWIO_UMCMN_R0_ASYNC_FIFO_SOFTRESET_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_ASYNC_FIFO_SOFTRESET_ADDR(x),v)
#define HWIO_UMCMN_R0_ASYNC_FIFO_SOFTRESET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_ASYNC_FIFO_SOFTRESET_ADDR(x),m,v,HWIO_UMCMN_R0_ASYNC_FIFO_SOFTRESET_IN(x))
#define HWIO_UMCMN_R0_ASYNC_FIFO_SOFTRESET_PHY2_BMSK                                                  0x10
#define HWIO_UMCMN_R0_ASYNC_FIFO_SOFTRESET_PHY2_SHFT                                                     4
#define HWIO_UMCMN_R0_ASYNC_FIFO_SOFTRESET_PHY1_BMSK                                                   0x8
#define HWIO_UMCMN_R0_ASYNC_FIFO_SOFTRESET_PHY1_SHFT                                                     3
#define HWIO_UMCMN_R0_ASYNC_FIFO_SOFTRESET_WMAC3_BMSK                                                  0x4
#define HWIO_UMCMN_R0_ASYNC_FIFO_SOFTRESET_WMAC3_SHFT                                                    2
#define HWIO_UMCMN_R0_ASYNC_FIFO_SOFTRESET_WMAC2_BMSK                                                  0x2
#define HWIO_UMCMN_R0_ASYNC_FIFO_SOFTRESET_WMAC2_SHFT                                                    1
#define HWIO_UMCMN_R0_ASYNC_FIFO_SOFTRESET_WMAC1_BMSK                                                  0x1
#define HWIO_UMCMN_R0_ASYNC_FIFO_SOFTRESET_WMAC1_SHFT                                                    0

#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_ADDR(x)                                                  ((x) + 0x1c)
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_PHYS(x)                                                  ((x) + 0x1c)
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_OFFS                                                     (0x1c)
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_RMSK                                                     0xffffffff
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_POR                                                      0x00000000
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_POR_RMSK                                                 0xffffffff
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_ATTR                                                                  0x3
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_IN(x)            \
                in_dword(HWIO_UMCMN_R0_CLK_GATE_DISABLE_ADDR(x))
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_CLK_GATE_DISABLE_ADDR(x), m)
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_CLK_GATE_DISABLE_ADDR(x),v)
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_CLK_GATE_DISABLE_ADDR(x),m,v,HWIO_UMCMN_R0_CLK_GATE_DISABLE_IN(x))
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_CLK_ENS_EXTEND_BMSK                                      0x80000000
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_CLK_ENS_EXTEND_SHFT                                              31
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_CLK_ENS_EXTEND_APB_BMSK                                  0x40000000
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_CLK_ENS_EXTEND_APB_SHFT                                          30
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_TBD_BMSK                                                 0x3fffff80
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_TBD_SHFT                                                          7
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_RRI_BMSK                                                       0x40
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_RRI_SHFT                                                          6
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_APB_VAL_BMSK                                                   0x20
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_APB_VAL_SHFT                                                      5
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_INTR_EXTEND_BMSK                                               0x10
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_INTR_EXTEND_SHFT                                                  4
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_IND_INTR_BMSK                                                   0x8
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_IND_INTR_SHFT                                                     3
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_PCIE_LOW_POWER_REQ_BMSK                                         0x4
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_PCIE_LOW_POWER_REQ_SHFT                                           2
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_UMAC_IDLE_GENERATE_BMSK                                         0x2
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_UMAC_IDLE_GENERATE_SHFT                                           1
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_UMCMN_TOP_BMSK                                                  0x1
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_UMCMN_TOP_SHFT                                                    0

#define HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_ADDR(x)                                                ((x) + 0x20)
#define HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_PHYS(x)                                                ((x) + 0x20)
#define HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_OFFS                                                   (0x20)
#define HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_RMSK                                                          0xf
#define HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_POR                                                    0x00000001
#define HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_POR_RMSK                                               0xffffffff
#define HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_ATTR                                                                0x3
#define HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_IN(x)            \
                in_dword(HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_ADDR(x))
#define HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_ADDR(x), m)
#define HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_ADDR(x),v)
#define HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_ADDR(x),m,v,HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_IN(x))
#define HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_VALUE_BMSK                                                    0xf
#define HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_VALUE_SHFT                                                      0

#define HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_EN_ADDR(x)                                             ((x) + 0x24)
#define HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_EN_PHYS(x)                                             ((x) + 0x24)
#define HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_EN_OFFS                                                (0x24)
#define HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_EN_RMSK                                                       0x1
#define HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_EN_POR                                                 0x00000001
#define HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_EN_POR_RMSK                                            0xffffffff
#define HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_EN_ATTR                                                             0x3
#define HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_EN_IN(x)            \
                in_dword(HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_EN_ADDR(x))
#define HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_EN_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_EN_ADDR(x), m)
#define HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_EN_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_EN_ADDR(x),v)
#define HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_EN_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_EN_ADDR(x),m,v,HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_EN_IN(x))
#define HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_EN_VALUE_BMSK                                                 0x1
#define HWIO_UMCMN_R0_NOC_PRGMBL_AXCACHE_EN_VALUE_SHFT                                                   0

#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_0_ADDR(x)                                                   ((x) + 0x28)
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_0_PHYS(x)                                                   ((x) + 0x28)
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_0_OFFS                                                      (0x28)
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_0_RMSK                                                       0xfffffff
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_0_POR                                                       0x00000000
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_0_POR_RMSK                                                  0xffffffff
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_0_ATTR                                                                   0x3
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_0_IN(x)            \
                in_dword(HWIO_UMCMN_R0_CMEM_SEC_CTRL_0_ADDR(x))
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_0_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_CMEM_SEC_CTRL_0_ADDR(x), m)
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_0_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_CMEM_SEC_CTRL_0_ADDR(x),v)
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_CMEM_SEC_CTRL_0_ADDR(x),m,v,HWIO_UMCMN_R0_CMEM_SEC_CTRL_0_IN(x))
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_0_SIZE_BMSK                                                  0xfff0000
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_0_SIZE_SHFT                                                         16
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_0_BASE_BMSK                                                     0xffff
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_0_BASE_SHFT                                                          0

#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_1_ADDR(x)                                                   ((x) + 0x2c)
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_1_PHYS(x)                                                   ((x) + 0x2c)
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_1_OFFS                                                      (0x2c)
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_1_RMSK                                                       0xfffffff
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_1_POR                                                       0x00000000
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_1_POR_RMSK                                                  0xffffffff
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_1_ATTR                                                                   0x3
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_1_IN(x)            \
                in_dword(HWIO_UMCMN_R0_CMEM_SEC_CTRL_1_ADDR(x))
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_1_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_CMEM_SEC_CTRL_1_ADDR(x), m)
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_1_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_CMEM_SEC_CTRL_1_ADDR(x),v)
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_CMEM_SEC_CTRL_1_ADDR(x),m,v,HWIO_UMCMN_R0_CMEM_SEC_CTRL_1_IN(x))
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_1_SIZE_BMSK                                                  0xfff0000
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_1_SIZE_SHFT                                                         16
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_1_BASE_BMSK                                                     0xffff
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_1_BASE_SHFT                                                          0

#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_2_ADDR(x)                                                   ((x) + 0x30)
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_2_PHYS(x)                                                   ((x) + 0x30)
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_2_OFFS                                                      (0x30)
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_2_RMSK                                                       0xfffffff
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_2_POR                                                       0x00000000
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_2_POR_RMSK                                                  0xffffffff
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_2_ATTR                                                                   0x3
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_2_IN(x)            \
                in_dword(HWIO_UMCMN_R0_CMEM_SEC_CTRL_2_ADDR(x))
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_2_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_CMEM_SEC_CTRL_2_ADDR(x), m)
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_2_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_CMEM_SEC_CTRL_2_ADDR(x),v)
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_CMEM_SEC_CTRL_2_ADDR(x),m,v,HWIO_UMCMN_R0_CMEM_SEC_CTRL_2_IN(x))
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_2_SIZE_BMSK                                                  0xfff0000
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_2_SIZE_SHFT                                                         16
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_2_BASE_BMSK                                                     0xffff
#define HWIO_UMCMN_R0_CMEM_SEC_CTRL_2_BASE_SHFT                                                          0

#define HWIO_UMCMN_R0_ISR_P_ADDR(x)                                                             ((x) + 0x34)
#define HWIO_UMCMN_R0_ISR_P_PHYS(x)                                                             ((x) + 0x34)
#define HWIO_UMCMN_R0_ISR_P_OFFS                                                                (0x34)
#define HWIO_UMCMN_R0_ISR_P_RMSK                                                                   0x3fffd
#define HWIO_UMCMN_R0_ISR_P_POR                                                                 0x00000000
#define HWIO_UMCMN_R0_ISR_P_POR_RMSK                                                            0xffffffff
#define HWIO_UMCMN_R0_ISR_P_ATTR                                                                             0x0
#define HWIO_UMCMN_R0_ISR_P_IN(x)            \
                in_dword(HWIO_UMCMN_R0_ISR_P_ADDR(x))
#define HWIO_UMCMN_R0_ISR_P_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_ISR_P_ADDR(x), m)
#define HWIO_UMCMN_R0_ISR_P_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_ISR_P_ADDR(x),v)
#define HWIO_UMCMN_R0_ISR_P_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_ISR_P_ADDR(x),m,v,HWIO_UMCMN_R0_ISR_P_IN(x))
#define HWIO_UMCMN_R0_ISR_P_GXI_BMSK                                                               0x20000
#define HWIO_UMCMN_R0_ISR_P_GXI_SHFT                                                                    17
#define HWIO_UMCMN_R0_ISR_P_TQM2_BMSK                                                              0x10000
#define HWIO_UMCMN_R0_ISR_P_TQM2_SHFT                                                                   16
#define HWIO_UMCMN_R0_ISR_P_TQM1_BMSK                                                               0x8000
#define HWIO_UMCMN_R0_ISR_P_TQM1_SHFT                                                                   15
#define HWIO_UMCMN_R0_ISR_P_TQM0_BMSK                                                               0x4000
#define HWIO_UMCMN_R0_ISR_P_TQM0_SHFT                                                                   14
#define HWIO_UMCMN_R0_ISR_P_TCL1_BMSK                                                               0x2000
#define HWIO_UMCMN_R0_ISR_P_TCL1_SHFT                                                                   13
#define HWIO_UMCMN_R0_ISR_P_TCL0_BMSK                                                               0x1000
#define HWIO_UMCMN_R0_ISR_P_TCL0_SHFT                                                                   12
#define HWIO_UMCMN_R0_ISR_P_REO4_BMSK                                                                0x800
#define HWIO_UMCMN_R0_ISR_P_REO4_SHFT                                                                   11
#define HWIO_UMCMN_R0_ISR_P_REO3_BMSK                                                                0x400
#define HWIO_UMCMN_R0_ISR_P_REO3_SHFT                                                                   10
#define HWIO_UMCMN_R0_ISR_P_REO2_BMSK                                                                0x200
#define HWIO_UMCMN_R0_ISR_P_REO2_SHFT                                                                    9
#define HWIO_UMCMN_R0_ISR_P_REO1_BMSK                                                                0x100
#define HWIO_UMCMN_R0_ISR_P_REO1_SHFT                                                                    8
#define HWIO_UMCMN_R0_ISR_P_REO0_BMSK                                                                 0x80
#define HWIO_UMCMN_R0_ISR_P_REO0_SHFT                                                                    7
#define HWIO_UMCMN_R0_ISR_P_WBM3_BMSK                                                                 0x40
#define HWIO_UMCMN_R0_ISR_P_WBM3_SHFT                                                                    6
#define HWIO_UMCMN_R0_ISR_P_WBM2_BMSK                                                                 0x20
#define HWIO_UMCMN_R0_ISR_P_WBM2_SHFT                                                                    5
#define HWIO_UMCMN_R0_ISR_P_WBM1_BMSK                                                                 0x10
#define HWIO_UMCMN_R0_ISR_P_WBM1_SHFT                                                                    4
#define HWIO_UMCMN_R0_ISR_P_WBM0_BMSK                                                                  0x8
#define HWIO_UMCMN_R0_ISR_P_WBM0_SHFT                                                                    3
#define HWIO_UMCMN_R0_ISR_P_MEM_BMSK                                                                   0x4
#define HWIO_UMCMN_R0_ISR_P_MEM_SHFT                                                                     2
#define HWIO_UMCMN_R0_ISR_P_APB_BMSK                                                                   0x1
#define HWIO_UMCMN_R0_ISR_P_APB_SHFT                                                                     0

#define HWIO_UMCMN_R0_ISR_S0_ADDR(x)                                                            ((x) + 0x38)
#define HWIO_UMCMN_R0_ISR_S0_PHYS(x)                                                            ((x) + 0x38)
#define HWIO_UMCMN_R0_ISR_S0_OFFS                                                               (0x38)
#define HWIO_UMCMN_R0_ISR_S0_RMSK                                                                0x71fffff
#define HWIO_UMCMN_R0_ISR_S0_POR                                                                0x00000000
#define HWIO_UMCMN_R0_ISR_S0_POR_RMSK                                                           0xffffffff
#define HWIO_UMCMN_R0_ISR_S0_ATTR                                                                            0x0
#define HWIO_UMCMN_R0_ISR_S0_IN(x)            \
                in_dword(HWIO_UMCMN_R0_ISR_S0_ADDR(x))
#define HWIO_UMCMN_R0_ISR_S0_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_ISR_S0_ADDR(x), m)
#define HWIO_UMCMN_R0_ISR_S0_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_ISR_S0_ADDR(x),v)
#define HWIO_UMCMN_R0_ISR_S0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_ISR_S0_ADDR(x),m,v,HWIO_UMCMN_R0_ISR_S0_IN(x))
#define HWIO_UMCMN_R0_ISR_S0_MXI_APB_RD_INVALID_BMSK                                             0x4000000
#define HWIO_UMCMN_R0_ISR_S0_MXI_APB_RD_INVALID_SHFT                                                    26
#define HWIO_UMCMN_R0_ISR_S0_MXI_APB_WR_INVALID_BMSK                                             0x2000000
#define HWIO_UMCMN_R0_ISR_S0_MXI_APB_WR_INVALID_SHFT                                                    25
#define HWIO_UMCMN_R0_ISR_S0_MXI_APB_WR_TO_RD_INVALID_BMSK                                       0x1000000
#define HWIO_UMCMN_R0_ISR_S0_MXI_APB_WR_TO_RD_INVALID_SHFT                                              24
#define HWIO_UMCMN_R0_ISR_S0_UMCMN_APB_RD_INVALID_BMSK                                            0x100000
#define HWIO_UMCMN_R0_ISR_S0_UMCMN_APB_RD_INVALID_SHFT                                                  20
#define HWIO_UMCMN_R0_ISR_S0_UMCMN_APB_WR_INVALID_BMSK                                             0x80000
#define HWIO_UMCMN_R0_ISR_S0_UMCMN_APB_WR_INVALID_SHFT                                                  19
#define HWIO_UMCMN_R0_ISR_S0_UMCMN_APB_WR_TO_RD_INVALID_BMSK                                       0x40000
#define HWIO_UMCMN_R0_ISR_S0_UMCMN_APB_WR_TO_RD_INVALID_SHFT                                            18
#define HWIO_UMCMN_R0_ISR_S0_TQM_APB_RD_INVALID_BMSK                                               0x20000
#define HWIO_UMCMN_R0_ISR_S0_TQM_APB_RD_INVALID_SHFT                                                    17
#define HWIO_UMCMN_R0_ISR_S0_TQM_APB_WR_INVALID_BMSK                                               0x10000
#define HWIO_UMCMN_R0_ISR_S0_TQM_APB_WR_INVALID_SHFT                                                    16
#define HWIO_UMCMN_R0_ISR_S0_TQM_APB_WR_TO_RD_INVALID_BMSK                                          0x8000
#define HWIO_UMCMN_R0_ISR_S0_TQM_APB_WR_TO_RD_INVALID_SHFT                                              15
#define HWIO_UMCMN_R0_ISR_S0_CMN_PRSR_APB_RD_INVALID_BMSK                                           0x4000
#define HWIO_UMCMN_R0_ISR_S0_CMN_PRSR_APB_RD_INVALID_SHFT                                               14
#define HWIO_UMCMN_R0_ISR_S0_CMN_PRSR_APB_WR_INVALID_BMSK                                           0x2000
#define HWIO_UMCMN_R0_ISR_S0_CMN_PRSR_APB_WR_INVALID_SHFT                                               13
#define HWIO_UMCMN_R0_ISR_S0_CMN_PRSR_APB_WR_TO_RD_INVALID_BMSK                                     0x1000
#define HWIO_UMCMN_R0_ISR_S0_CMN_PRSR_APB_WR_TO_RD_INVALID_SHFT                                         12
#define HWIO_UMCMN_R0_ISR_S0_CCE_APB_RD_INVALID_BMSK                                                 0x800
#define HWIO_UMCMN_R0_ISR_S0_CCE_APB_RD_INVALID_SHFT                                                    11
#define HWIO_UMCMN_R0_ISR_S0_CCE_APB_WR_INVALID_BMSK                                                 0x400
#define HWIO_UMCMN_R0_ISR_S0_CCE_APB_WR_INVALID_SHFT                                                    10
#define HWIO_UMCMN_R0_ISR_S0_CCE_APB_WR_TO_RD_INVALID_BMSK                                           0x200
#define HWIO_UMCMN_R0_ISR_S0_CCE_APB_WR_TO_RD_INVALID_SHFT                                               9
#define HWIO_UMCMN_R0_ISR_S0_WBM_APB_RD_INVALID_BMSK                                                 0x100
#define HWIO_UMCMN_R0_ISR_S0_WBM_APB_RD_INVALID_SHFT                                                     8
#define HWIO_UMCMN_R0_ISR_S0_WBM_APB_WR_INVALID_BMSK                                                  0x80
#define HWIO_UMCMN_R0_ISR_S0_WBM_APB_WR_INVALID_SHFT                                                     7
#define HWIO_UMCMN_R0_ISR_S0_WBM_APB_WR_TO_RD_INVALID_BMSK                                            0x40
#define HWIO_UMCMN_R0_ISR_S0_WBM_APB_WR_TO_RD_INVALID_SHFT                                               6
#define HWIO_UMCMN_R0_ISR_S0_TCL_APB_RD_INVALID_BMSK                                                  0x20
#define HWIO_UMCMN_R0_ISR_S0_TCL_APB_RD_INVALID_SHFT                                                     5
#define HWIO_UMCMN_R0_ISR_S0_TCL_APB_WR_INVALID_BMSK                                                  0x10
#define HWIO_UMCMN_R0_ISR_S0_TCL_APB_WR_INVALID_SHFT                                                     4
#define HWIO_UMCMN_R0_ISR_S0_TCL_APB_WR_TO_RD_INVALID_BMSK                                             0x8
#define HWIO_UMCMN_R0_ISR_S0_TCL_APB_WR_TO_RD_INVALID_SHFT                                               3
#define HWIO_UMCMN_R0_ISR_S0_REO_APB_RD_INVALID_BMSK                                                   0x4
#define HWIO_UMCMN_R0_ISR_S0_REO_APB_RD_INVALID_SHFT                                                     2
#define HWIO_UMCMN_R0_ISR_S0_REO_APB_WR_INVALID_BMSK                                                   0x2
#define HWIO_UMCMN_R0_ISR_S0_REO_APB_WR_INVALID_SHFT                                                     1
#define HWIO_UMCMN_R0_ISR_S0_REO_APB_WR_TO_RD_INVALID_BMSK                                             0x1
#define HWIO_UMCMN_R0_ISR_S0_REO_APB_WR_TO_RD_INVALID_SHFT                                               0

#define HWIO_UMCMN_R0_ISR_S2_ADDR(x)                                                            ((x) + 0x3c)
#define HWIO_UMCMN_R0_ISR_S2_PHYS(x)                                                            ((x) + 0x3c)
#define HWIO_UMCMN_R0_ISR_S2_OFFS                                                               (0x3c)
#define HWIO_UMCMN_R0_ISR_S2_RMSK                                                                      0xf
#define HWIO_UMCMN_R0_ISR_S2_POR                                                                0x00000000
#define HWIO_UMCMN_R0_ISR_S2_POR_RMSK                                                           0xffffffff
#define HWIO_UMCMN_R0_ISR_S2_ATTR                                                                            0x0
#define HWIO_UMCMN_R0_ISR_S2_IN(x)            \
                in_dword(HWIO_UMCMN_R0_ISR_S2_ADDR(x))
#define HWIO_UMCMN_R0_ISR_S2_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_ISR_S2_ADDR(x), m)
#define HWIO_UMCMN_R0_ISR_S2_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_ISR_S2_ADDR(x),v)
#define HWIO_UMCMN_R0_ISR_S2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_ISR_S2_ADDR(x),m,v,HWIO_UMCMN_R0_ISR_S2_IN(x))
#define HWIO_UMCMN_R0_ISR_S2_MEM_REMOTE_ACC_ERR_BMSK                                                   0x8
#define HWIO_UMCMN_R0_ISR_S2_MEM_REMOTE_ACC_ERR_SHFT                                                     3
#define HWIO_UMCMN_R0_ISR_S2_MEM_ACC_RANGE_ERR_BMSK                                                    0x4
#define HWIO_UMCMN_R0_ISR_S2_MEM_ACC_RANGE_ERR_SHFT                                                      2
#define HWIO_UMCMN_R0_ISR_S2_MEM_NON_SEC_ACC_ERR2_BMSK                                                 0x2
#define HWIO_UMCMN_R0_ISR_S2_MEM_NON_SEC_ACC_ERR2_SHFT                                                   1
#define HWIO_UMCMN_R0_ISR_S2_MEM_NON_SEC_ACC_ERR1_BMSK                                                 0x1
#define HWIO_UMCMN_R0_ISR_S2_MEM_NON_SEC_ACC_ERR1_SHFT                                                   0

#define HWIO_UMCMN_R0_ISR_S3_ADDR(x)                                                            ((x) + 0x40)
#define HWIO_UMCMN_R0_ISR_S3_PHYS(x)                                                            ((x) + 0x40)
#define HWIO_UMCMN_R0_ISR_S3_OFFS                                                               (0x40)
#define HWIO_UMCMN_R0_ISR_S3_RMSK                                                               0xffffffff
#define HWIO_UMCMN_R0_ISR_S3_POR                                                                0x00000000
#define HWIO_UMCMN_R0_ISR_S3_POR_RMSK                                                           0xffffffff
#define HWIO_UMCMN_R0_ISR_S3_ATTR                                                                            0x0
#define HWIO_UMCMN_R0_ISR_S3_IN(x)            \
                in_dword(HWIO_UMCMN_R0_ISR_S3_ADDR(x))
#define HWIO_UMCMN_R0_ISR_S3_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_ISR_S3_ADDR(x), m)
#define HWIO_UMCMN_R0_ISR_S3_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_ISR_S3_ADDR(x),v)
#define HWIO_UMCMN_R0_ISR_S3_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_ISR_S3_ADDR(x),m,v,HWIO_UMCMN_R0_ISR_S3_IN(x))
#define HWIO_UMCMN_R0_ISR_S3_MSDU_PARSER_DUP_DET_EVENT_INTR_BMSK                                0x80000000
#define HWIO_UMCMN_R0_ISR_S3_MSDU_PARSER_DUP_DET_EVENT_INTR_SHFT                                        31
#define HWIO_UMCMN_R0_ISR_S3_REL_PARSER_DUP_DET_EVENT_INTR_BMSK                                 0x40000000
#define HWIO_UMCMN_R0_ISR_S3_REL_PARSER_DUP_DET_EVENT_INTR_SHFT                                         30
#define HWIO_UMCMN_R0_ISR_S3_LINK_DIST_DUP_DET_EVENT_INTR_BMSK                                  0x20000000
#define HWIO_UMCMN_R0_ISR_S3_LINK_DIST_DUP_DET_EVENT_INTR_SHFT                                          29
#define HWIO_UMCMN_R0_ISR_S3_SW_COOKIE_IDLE_TIMEOUT_BMSK                                        0x10000000
#define HWIO_UMCMN_R0_ISR_S3_SW_COOKIE_IDLE_TIMEOUT_SHFT                                                28
#define HWIO_UMCMN_R0_ISR_S3_DELINK_B2B_DUPLI_PTR_INTR_BMSK                                      0x8000000
#define HWIO_UMCMN_R0_ISR_S3_DELINK_B2B_DUPLI_PTR_INTR_SHFT                                             27
#define HWIO_UMCMN_R0_ISR_S3_LINK_DIST_B2B_DUPLI_INTR_BMSK                                       0x4000000
#define HWIO_UMCMN_R0_ISR_S3_LINK_DIST_B2B_DUPLI_INTR_SHFT                                              26
#define HWIO_UMCMN_R0_ISR_S3_IDLE_SEQUENCE_WD_INTR_BMSK                                          0x2000000
#define HWIO_UMCMN_R0_ISR_S3_IDLE_SEQUENCE_WD_INTR_SHFT                                                 25
#define HWIO_UMCMN_R0_ISR_S3_WBM_VA_CONV_ERR_INT_BMSK                                            0x1000000
#define HWIO_UMCMN_R0_ISR_S3_WBM_VA_CONV_ERR_INT_SHFT                                                   24
#define HWIO_UMCMN_R0_ISR_S3_WBM_BP_WARN_INT_BMSK                                                 0x800000
#define HWIO_UMCMN_R0_ISR_S3_WBM_BP_WARN_INT_SHFT                                                       23
#define HWIO_UMCMN_R0_ISR_S3_WBM_SW6_BUF_PROD_WDG_BMSK                                            0x400000
#define HWIO_UMCMN_R0_ISR_S3_WBM_SW6_BUF_PROD_WDG_SHFT                                                  22
#define HWIO_UMCMN_R0_ISR_S3_WBM_SW5_BUF_PROD_WDG_BMSK                                            0x200000
#define HWIO_UMCMN_R0_ISR_S3_WBM_SW5_BUF_PROD_WDG_SHFT                                                  21
#define HWIO_UMCMN_R0_ISR_S3_WBM_SW4_BUF_PROD_WDG_BMSK                                            0x100000
#define HWIO_UMCMN_R0_ISR_S3_WBM_SW4_BUF_PROD_WDG_SHFT                                                  20
#define HWIO_UMCMN_R0_ISR_S3_WBM_ERROR_BUF_PROD_WDG_BMSK                                           0x80000
#define HWIO_UMCMN_R0_ISR_S3_WBM_ERROR_BUF_PROD_WDG_SHFT                                                19
#define HWIO_UMCMN_R0_ISR_S3_WBM_MSDU_PARSER_ERR_BMSK                                              0x70000
#define HWIO_UMCMN_R0_ISR_S3_WBM_MSDU_PARSER_ERR_SHFT                                                   16
#define HWIO_UMCMN_R0_ISR_S3_WBM_LINK_IDLE_LIST_SCAT_SRNG_ERR_BMSK                                  0x8000
#define HWIO_UMCMN_R0_ISR_S3_WBM_LINK_IDLE_LIST_SCAT_SRNG_ERR_SHFT                                      15
#define HWIO_UMCMN_R0_ISR_S3_WBM_LINK_IDLE_LIST_SCAT_SRNG_WDG_BMSK                                  0x4000
#define HWIO_UMCMN_R0_ISR_S3_WBM_LINK_IDLE_LIST_SCAT_SRNG_WDG_SHFT                                      14
#define HWIO_UMCMN_R0_ISR_S3_WBM_BUF_IDLE_LIST_SCAT_SRNG_ERR_BMSK                                   0x2000
#define HWIO_UMCMN_R0_ISR_S3_WBM_BUF_IDLE_LIST_SCAT_SRNG_ERR_SHFT                                       13
#define HWIO_UMCMN_R0_ISR_S3_WBM_BUF_IDLE_LIST_SCAT_SRNG_WDG_BMSK                                   0x1000
#define HWIO_UMCMN_R0_ISR_S3_WBM_BUF_IDLE_LIST_SCAT_SRNG_WDG_SHFT                                       12
#define HWIO_UMCMN_R0_ISR_S3_WBM_MSDU_DELINK_PARSE_ERR_BMSK                                          0x800
#define HWIO_UMCMN_R0_ISR_S3_WBM_MSDU_DELINK_PARSE_ERR_SHFT                                             11
#define HWIO_UMCMN_R0_ISR_S3_WBM_MSDU_DELINK_WDG_BMSK                                                0x400
#define HWIO_UMCMN_R0_ISR_S3_WBM_MSDU_DELINK_WDG_SHFT                                                   10
#define HWIO_UMCMN_R0_ISR_S3_WBM_LNK_IDLE_LIST_DIST_C_WDG_BMSK                                       0x200
#define HWIO_UMCMN_R0_ISR_S3_WBM_LNK_IDLE_LIST_DIST_C_WDG_SHFT                                           9
#define HWIO_UMCMN_R0_ISR_S3_WBM_LNK_IDLE_LIST_DIST_P_WDG_BMSK                                       0x100
#define HWIO_UMCMN_R0_ISR_S3_WBM_LNK_IDLE_LIST_DIST_P_WDG_SHFT                                           8
#define HWIO_UMCMN_R0_ISR_S3_WBM_FW_BUF_PROD_WDG_BMSK                                                 0x80
#define HWIO_UMCMN_R0_ISR_S3_WBM_FW_BUF_PROD_WDG_SHFT                                                    7
#define HWIO_UMCMN_R0_ISR_S3_WBM_SW3_BUF_PROD_WDG_BMSK                                                0x40
#define HWIO_UMCMN_R0_ISR_S3_WBM_SW3_BUF_PROD_WDG_SHFT                                                   6
#define HWIO_UMCMN_R0_ISR_S3_WBM_SW2_BUF_PROD_WDG_BMSK                                                0x20
#define HWIO_UMCMN_R0_ISR_S3_WBM_SW2_BUF_PROD_WDG_SHFT                                                   5
#define HWIO_UMCMN_R0_ISR_S3_WBM_SW1_BUF_PROD_WDG_BMSK                                                0x10
#define HWIO_UMCMN_R0_ISR_S3_WBM_SW1_BUF_PROD_WDG_SHFT                                                   4
#define HWIO_UMCMN_R0_ISR_S3_WBM_SW0_BUF_PROD_WDG_BMSK                                                 0x8
#define HWIO_UMCMN_R0_ISR_S3_WBM_SW0_BUF_PROD_WDG_SHFT                                                   3
#define HWIO_UMCMN_R0_ISR_S3_WBM_LNK_IDLE_LIST_PROD_WDG_BMSK                                           0x4
#define HWIO_UMCMN_R0_ISR_S3_WBM_LNK_IDLE_LIST_PROD_WDG_SHFT                                             2
#define HWIO_UMCMN_R0_ISR_S3_WBM_REL_REQ_PARSER_C_WDG_BMSK                                             0x2
#define HWIO_UMCMN_R0_ISR_S3_WBM_REL_REQ_PARSER_C_WDG_SHFT                                               1
#define HWIO_UMCMN_R0_ISR_S3_WBM_REL_REQ_PARSER_P_WDG_BMSK                                             0x1
#define HWIO_UMCMN_R0_ISR_S3_WBM_REL_REQ_PARSER_P_WDG_SHFT                                               0

#define HWIO_UMCMN_R0_ISR_S4_ADDR(x)                                                            ((x) + 0x44)
#define HWIO_UMCMN_R0_ISR_S4_PHYS(x)                                                            ((x) + 0x44)
#define HWIO_UMCMN_R0_ISR_S4_OFFS                                                               (0x44)
#define HWIO_UMCMN_R0_ISR_S4_RMSK                                                               0xffffffff
#define HWIO_UMCMN_R0_ISR_S4_POR                                                                0x00000000
#define HWIO_UMCMN_R0_ISR_S4_POR_RMSK                                                           0xffffffff
#define HWIO_UMCMN_R0_ISR_S4_ATTR                                                                            0x0
#define HWIO_UMCMN_R0_ISR_S4_IN(x)            \
                in_dword(HWIO_UMCMN_R0_ISR_S4_ADDR(x))
#define HWIO_UMCMN_R0_ISR_S4_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_ISR_S4_ADDR(x), m)
#define HWIO_UMCMN_R0_ISR_S4_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_ISR_S4_ADDR(x),v)
#define HWIO_UMCMN_R0_ISR_S4_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_ISR_S4_ADDR(x),m,v,HWIO_UMCMN_R0_ISR_S4_IN(x))
#define HWIO_UMCMN_R0_ISR_S4_WBM2SW6_RELEASE_RING_WDG_ERR_BMSK                                  0x80000000
#define HWIO_UMCMN_R0_ISR_S4_WBM2SW6_RELEASE_RING_WDG_ERR_SHFT                                          31
#define HWIO_UMCMN_R0_ISR_S4_WBM2SW5_RELEASE_RING_WDG_ERR_BMSK                                  0x40000000
#define HWIO_UMCMN_R0_ISR_S4_WBM2SW5_RELEASE_RING_WDG_ERR_SHFT                                          30
#define HWIO_UMCMN_R0_ISR_S4_WBM2ERROR_RELEASE_RING_WDG_ERR_BMSK                                0x20000000
#define HWIO_UMCMN_R0_ISR_S4_WBM2ERROR_RELEASE_RING_WDG_ERR_SHFT                                        29
#define HWIO_UMCMN_R0_ISR_S4_WBM2SW4_RELEASE_RING_WDG_ERR_BMSK                                  0x10000000
#define HWIO_UMCMN_R0_ISR_S4_WBM2SW4_RELEASE_RING_WDG_ERR_SHFT                                          28
#define HWIO_UMCMN_R0_ISR_S4_WBM2SW3_RELEASE_RING_WDG_ERR_BMSK                                   0x8000000
#define HWIO_UMCMN_R0_ISR_S4_WBM2SW3_RELEASE_RING_WDG_ERR_SHFT                                          27
#define HWIO_UMCMN_R0_ISR_S4_WBM2SW2_RELEASE_RING_WDG_ERR_BMSK                                   0x4000000
#define HWIO_UMCMN_R0_ISR_S4_WBM2SW2_RELEASE_RING_WDG_ERR_SHFT                                          26
#define HWIO_UMCMN_R0_ISR_S4_WBM2SW1_RELEASE_RING_WDG_ERR_BMSK                                   0x2000000
#define HWIO_UMCMN_R0_ISR_S4_WBM2SW1_RELEASE_RING_WDG_ERR_SHFT                                          25
#define HWIO_UMCMN_R0_ISR_S4_WBM2SW0_RELEASE_RING_WDG_ERR_BMSK                                   0x1000000
#define HWIO_UMCMN_R0_ISR_S4_WBM2SW0_RELEASE_RING_WDG_ERR_SHFT                                          24
#define HWIO_UMCMN_R0_ISR_S4_WBM2FW_RELEASE_RING_WDG_ERR_BMSK                                     0x800000
#define HWIO_UMCMN_R0_ISR_S4_WBM2FW_RELEASE_RING_WDG_ERR_SHFT                                           23
#define HWIO_UMCMN_R0_ISR_S4_WBM_IDLE_LINK_RING_WDG_ERR_BMSK                                      0x400000
#define HWIO_UMCMN_R0_ISR_S4_WBM_IDLE_LINK_RING_WDG_ERR_SHFT                                            22
#define HWIO_UMCMN_R0_ISR_S4_WBM_IDLE_BUF_RING_WDG_ERR_BMSK                                       0x200000
#define HWIO_UMCMN_R0_ISR_S4_WBM_IDLE_BUF_RING_WDG_ERR_SHFT                                             21
#define HWIO_UMCMN_R0_ISR_S4_WBM2RXDMA2_LINK_RING_WDG_ERR_BMSK                                    0x100000
#define HWIO_UMCMN_R0_ISR_S4_WBM2RXDMA2_LINK_RING_WDG_ERR_SHFT                                          20
#define HWIO_UMCMN_R0_ISR_S4_WBM2RXDMA1_LINK_RING_WDG_ERR_BMSK                                     0x80000
#define HWIO_UMCMN_R0_ISR_S4_WBM2RXDMA1_LINK_RING_WDG_ERR_SHFT                                          19
#define HWIO_UMCMN_R0_ISR_S4_WBM2RXDMA0_LINK_RING_WDG_ERR_BMSK                                     0x40000
#define HWIO_UMCMN_R0_ISR_S4_WBM2RXDMA0_LINK_RING_WDG_ERR_SHFT                                          18
#define HWIO_UMCMN_R0_ISR_S4_WBM2FW_LINK_RING_WDG_ERR_BMSK                                         0x20000
#define HWIO_UMCMN_R0_ISR_S4_WBM2FW_LINK_RING_WDG_ERR_SHFT                                              17
#define HWIO_UMCMN_R0_ISR_S4_WBM2SW_LINK_RING_WDG_ERR_BMSK                                         0x10000
#define HWIO_UMCMN_R0_ISR_S4_WBM2SW_LINK_RING_WDG_ERR_SHFT                                              16
#define HWIO_UMCMN_R0_ISR_S4_WBM2REO_LINK_RING_WDG_ERR_BMSK                                         0x8000
#define HWIO_UMCMN_R0_ISR_S4_WBM2REO_LINK_RING_WDG_ERR_SHFT                                             15
#define HWIO_UMCMN_R0_ISR_S4_WBM2TQM_LINK_RING_WDG_ERR_BMSK                                         0x4000
#define HWIO_UMCMN_R0_ISR_S4_WBM2TQM_LINK_RING_WDG_ERR_SHFT                                             14
#define HWIO_UMCMN_R0_ISR_S4_WBM2RXDMA2_BUF_RING_WDG_ERR_BMSK                                       0x2000
#define HWIO_UMCMN_R0_ISR_S4_WBM2RXDMA2_BUF_RING_WDG_ERR_SHFT                                           13
#define HWIO_UMCMN_R0_ISR_S4_WBM2RXDMA1_BUF_RING_WDG_ERR_BMSK                                       0x1000
#define HWIO_UMCMN_R0_ISR_S4_WBM2RXDMA1_BUF_RING_WDG_ERR_SHFT                                           12
#define HWIO_UMCMN_R0_ISR_S4_WBM2RXDMA0_BUF_RING_WDG_ERR_BMSK                                        0x800
#define HWIO_UMCMN_R0_ISR_S4_WBM2RXDMA0_BUF_RING_WDG_ERR_SHFT                                           11
#define HWIO_UMCMN_R0_ISR_S4_WBM2FW_BUF_RING_WDG_ERR_BMSK                                            0x400
#define HWIO_UMCMN_R0_ISR_S4_WBM2FW_BUF_RING_WDG_ERR_SHFT                                               10
#define HWIO_UMCMN_R0_ISR_S4_WBM2SW_BUF_RING_WDG_ERR_BMSK                                            0x200
#define HWIO_UMCMN_R0_ISR_S4_WBM2SW_BUF_RING_WDG_ERR_SHFT                                                9
#define HWIO_UMCMN_R0_ISR_S4_WBM2PPE_BUF_RING_WDG_ERR_BMSK                                           0x100
#define HWIO_UMCMN_R0_ISR_S4_WBM2PPE_BUF_RING_WDG_ERR_SHFT                                               8
#define HWIO_UMCMN_R0_ISR_S4_RXDMA2_RELEASE_RING_WDG_ERR_BMSK                                         0x80
#define HWIO_UMCMN_R0_ISR_S4_RXDMA2_RELEASE_RING_WDG_ERR_SHFT                                            7
#define HWIO_UMCMN_R0_ISR_S4_RXDMA1_RELEASE_RING_WDG_ERR_BMSK                                         0x40
#define HWIO_UMCMN_R0_ISR_S4_RXDMA1_RELEASE_RING_WDG_ERR_SHFT                                            6
#define HWIO_UMCMN_R0_ISR_S4_RXDMA0_RELEASE_RING_WDG_ERR_BMSK                                         0x20
#define HWIO_UMCMN_R0_ISR_S4_RXDMA0_RELEASE_RING_WDG_ERR_SHFT                                            5
#define HWIO_UMCMN_R0_ISR_S4_FW_RELEASE_RING_WDG_ERR_BMSK                                             0x10
#define HWIO_UMCMN_R0_ISR_S4_FW_RELEASE_RING_WDG_ERR_SHFT                                                4
#define HWIO_UMCMN_R0_ISR_S4_SW_RELEASE_RING_WDG_ERR_BMSK                                              0x8
#define HWIO_UMCMN_R0_ISR_S4_SW_RELEASE_RING_WDG_ERR_SHFT                                                3
#define HWIO_UMCMN_R0_ISR_S4_REO_RELEASE_RING_WDG_ERR_BMSK                                             0x4
#define HWIO_UMCMN_R0_ISR_S4_REO_RELEASE_RING_WDG_ERR_SHFT                                               2
#define HWIO_UMCMN_R0_ISR_S4_TQM_RELEASE_RING_WDG_ERR_BMSK                                             0x2
#define HWIO_UMCMN_R0_ISR_S4_TQM_RELEASE_RING_WDG_ERR_SHFT                                               1
#define HWIO_UMCMN_R0_ISR_S4_PPE_RELEASE_RING_WDG_ERR_BMSK                                             0x1
#define HWIO_UMCMN_R0_ISR_S4_PPE_RELEASE_RING_WDG_ERR_SHFT                                               0

#define HWIO_UMCMN_R0_ISR_S5_ADDR(x)                                                            ((x) + 0x48)
#define HWIO_UMCMN_R0_ISR_S5_PHYS(x)                                                            ((x) + 0x48)
#define HWIO_UMCMN_R0_ISR_S5_OFFS                                                               (0x48)
#define HWIO_UMCMN_R0_ISR_S5_RMSK                                                               0xffffffff
#define HWIO_UMCMN_R0_ISR_S5_POR                                                                0x00000000
#define HWIO_UMCMN_R0_ISR_S5_POR_RMSK                                                           0xffffffff
#define HWIO_UMCMN_R0_ISR_S5_ATTR                                                                            0x0
#define HWIO_UMCMN_R0_ISR_S5_IN(x)            \
                in_dword(HWIO_UMCMN_R0_ISR_S5_ADDR(x))
#define HWIO_UMCMN_R0_ISR_S5_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_ISR_S5_ADDR(x), m)
#define HWIO_UMCMN_R0_ISR_S5_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_ISR_S5_ADDR(x),v)
#define HWIO_UMCMN_R0_ISR_S5_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_ISR_S5_ADDR(x),m,v,HWIO_UMCMN_R0_ISR_S5_IN(x))
#define HWIO_UMCMN_R0_ISR_S5_WBM2SW6_RELEASE_RING_REQ_ERR_BMSK                                  0x80000000
#define HWIO_UMCMN_R0_ISR_S5_WBM2SW6_RELEASE_RING_REQ_ERR_SHFT                                          31
#define HWIO_UMCMN_R0_ISR_S5_WBM2SW5_RELEASE_RING_REQ_ERR_BMSK                                  0x40000000
#define HWIO_UMCMN_R0_ISR_S5_WBM2SW5_RELEASE_RING_REQ_ERR_SHFT                                          30
#define HWIO_UMCMN_R0_ISR_S5_WBM2ERROR_RELEASE_RING_REQ_ERR_BMSK                                0x20000000
#define HWIO_UMCMN_R0_ISR_S5_WBM2ERROR_RELEASE_RING_REQ_ERR_SHFT                                        29
#define HWIO_UMCMN_R0_ISR_S5_WBM2SW4_RELEASE_RING_REQ_ERR_BMSK                                  0x10000000
#define HWIO_UMCMN_R0_ISR_S5_WBM2SW4_RELEASE_RING_REQ_ERR_SHFT                                          28
#define HWIO_UMCMN_R0_ISR_S5_WBM2SW3_RELEASE_RING_REQ_ERR_BMSK                                   0x8000000
#define HWIO_UMCMN_R0_ISR_S5_WBM2SW3_RELEASE_RING_REQ_ERR_SHFT                                          27
#define HWIO_UMCMN_R0_ISR_S5_WBM2SW2_RELEASE_RING_REQ_ERR_BMSK                                   0x4000000
#define HWIO_UMCMN_R0_ISR_S5_WBM2SW2_RELEASE_RING_REQ_ERR_SHFT                                          26
#define HWIO_UMCMN_R0_ISR_S5_WBM2SW1_RELEASE_RING_REQ_ERR_BMSK                                   0x2000000
#define HWIO_UMCMN_R0_ISR_S5_WBM2SW1_RELEASE_RING_REQ_ERR_SHFT                                          25
#define HWIO_UMCMN_R0_ISR_S5_WBM2SW0_RELEASE_RING_REQ_ERR_BMSK                                   0x1000000
#define HWIO_UMCMN_R0_ISR_S5_WBM2SW0_RELEASE_RING_REQ_ERR_SHFT                                          24
#define HWIO_UMCMN_R0_ISR_S5_WBM2FW_RELEASE_RING_REQ_ERR_BMSK                                     0x800000
#define HWIO_UMCMN_R0_ISR_S5_WBM2FW_RELEASE_RING_REQ_ERR_SHFT                                           23
#define HWIO_UMCMN_R0_ISR_S5_WBM_IDLE_LINK_RING_REQ_ERR_BMSK                                      0x400000
#define HWIO_UMCMN_R0_ISR_S5_WBM_IDLE_LINK_RING_REQ_ERR_SHFT                                            22
#define HWIO_UMCMN_R0_ISR_S5_WBM_IDLE_BUF_RING_REQ_ERR_BMSK                                       0x200000
#define HWIO_UMCMN_R0_ISR_S5_WBM_IDLE_BUF_RING_REQ_ERR_SHFT                                             21
#define HWIO_UMCMN_R0_ISR_S5_WBM2RXDMA2_LINK_RING_REQ_ERR_BMSK                                    0x100000
#define HWIO_UMCMN_R0_ISR_S5_WBM2RXDMA2_LINK_RING_REQ_ERR_SHFT                                          20
#define HWIO_UMCMN_R0_ISR_S5_WBM2RXDMA1_LINK_RING_REQ_ERR_BMSK                                     0x80000
#define HWIO_UMCMN_R0_ISR_S5_WBM2RXDMA1_LINK_RING_REQ_ERR_SHFT                                          19
#define HWIO_UMCMN_R0_ISR_S5_WBM2RXDMA0_LINK_RING_REQ_ERR_BMSK                                     0x40000
#define HWIO_UMCMN_R0_ISR_S5_WBM2RXDMA0_LINK_RING_REQ_ERR_SHFT                                          18
#define HWIO_UMCMN_R0_ISR_S5_WBM2FW_LINK_RING_REQ_ERR_BMSK                                         0x20000
#define HWIO_UMCMN_R0_ISR_S5_WBM2FW_LINK_RING_REQ_ERR_SHFT                                              17
#define HWIO_UMCMN_R0_ISR_S5_WBM2SW_LINK_RING_REQ_ERR_BMSK                                         0x10000
#define HWIO_UMCMN_R0_ISR_S5_WBM2SW_LINK_RING_REQ_ERR_SHFT                                              16
#define HWIO_UMCMN_R0_ISR_S5_WBM2REO_LINK_RING_REQ_ERR_BMSK                                         0x8000
#define HWIO_UMCMN_R0_ISR_S5_WBM2REO_LINK_RING_REQ_ERR_SHFT                                             15
#define HWIO_UMCMN_R0_ISR_S5_WBM2TQM_LINK_RING_REQ_ERR_BMSK                                         0x4000
#define HWIO_UMCMN_R0_ISR_S5_WBM2TQM_LINK_RING_REQ_ERR_SHFT                                             14
#define HWIO_UMCMN_R0_ISR_S5_WBM2RXDMA2_BUF_RING_REQ_ERR_BMSK                                       0x2000
#define HWIO_UMCMN_R0_ISR_S5_WBM2RXDMA2_BUF_RING_REQ_ERR_SHFT                                           13
#define HWIO_UMCMN_R0_ISR_S5_WBM2RXDMA1_BUF_RING_REQ_ERR_BMSK                                       0x1000
#define HWIO_UMCMN_R0_ISR_S5_WBM2RXDMA1_BUF_RING_REQ_ERR_SHFT                                           12
#define HWIO_UMCMN_R0_ISR_S5_WBM2RXDMA0_BUF_RING_REQ_ERR_BMSK                                        0x800
#define HWIO_UMCMN_R0_ISR_S5_WBM2RXDMA0_BUF_RING_REQ_ERR_SHFT                                           11
#define HWIO_UMCMN_R0_ISR_S5_WBM2FW_BUF_RING_REQ_ERR_BMSK                                            0x400
#define HWIO_UMCMN_R0_ISR_S5_WBM2FW_BUF_RING_REQ_ERR_SHFT                                               10
#define HWIO_UMCMN_R0_ISR_S5_WBM2SW_BUF_RING_REQ_ERR_BMSK                                            0x200
#define HWIO_UMCMN_R0_ISR_S5_WBM2SW_BUF_RING_REQ_ERR_SHFT                                                9
#define HWIO_UMCMN_R0_ISR_S5_WBM2PPE_BUF_RING_REQ_ERR_BMSK                                           0x100
#define HWIO_UMCMN_R0_ISR_S5_WBM2PPE_BUF_RING_REQ_ERR_SHFT                                               8
#define HWIO_UMCMN_R0_ISR_S5_RXDMA2_RELEASE_RING_REQ_ERR_BMSK                                         0x80
#define HWIO_UMCMN_R0_ISR_S5_RXDMA2_RELEASE_RING_REQ_ERR_SHFT                                            7
#define HWIO_UMCMN_R0_ISR_S5_RXDMA1_RELEASE_RING_REQ_ERR_BMSK                                         0x40
#define HWIO_UMCMN_R0_ISR_S5_RXDMA1_RELEASE_RING_REQ_ERR_SHFT                                            6
#define HWIO_UMCMN_R0_ISR_S5_RXDMA0_RELEASE_RING_REQ_ERR_BMSK                                         0x20
#define HWIO_UMCMN_R0_ISR_S5_RXDMA0_RELEASE_RING_REQ_ERR_SHFT                                            5
#define HWIO_UMCMN_R0_ISR_S5_FW_RELEASE_RING_REQ_ERR_BMSK                                             0x10
#define HWIO_UMCMN_R0_ISR_S5_FW_RELEASE_RING_REQ_ERR_SHFT                                                4
#define HWIO_UMCMN_R0_ISR_S5_SW_RELEASE_RING_REQ_ERR_BMSK                                              0x8
#define HWIO_UMCMN_R0_ISR_S5_SW_RELEASE_RING_REQ_ERR_SHFT                                                3
#define HWIO_UMCMN_R0_ISR_S5_REO_RELEASE_RING_REQ_ERR_BMSK                                             0x4
#define HWIO_UMCMN_R0_ISR_S5_REO_RELEASE_RING_REQ_ERR_SHFT                                               2
#define HWIO_UMCMN_R0_ISR_S5_TQM_RELEASE_RING_REQ_ERR_BMSK                                             0x2
#define HWIO_UMCMN_R0_ISR_S5_TQM_RELEASE_RING_REQ_ERR_SHFT                                               1
#define HWIO_UMCMN_R0_ISR_S5_PPE_RELEASE_RING_REQ_ERR_BMSK                                             0x1
#define HWIO_UMCMN_R0_ISR_S5_PPE_RELEASE_RING_REQ_ERR_SHFT                                               0

#define HWIO_UMCMN_R0_ISR_S6_ADDR(x)                                                            ((x) + 0x4c)
#define HWIO_UMCMN_R0_ISR_S6_PHYS(x)                                                            ((x) + 0x4c)
#define HWIO_UMCMN_R0_ISR_S6_OFFS                                                               (0x4c)
#define HWIO_UMCMN_R0_ISR_S6_RMSK                                                                 0x3fffff
#define HWIO_UMCMN_R0_ISR_S6_POR                                                                0x00000000
#define HWIO_UMCMN_R0_ISR_S6_POR_RMSK                                                           0xffffffff
#define HWIO_UMCMN_R0_ISR_S6_ATTR                                                                            0x0
#define HWIO_UMCMN_R0_ISR_S6_IN(x)            \
                in_dword(HWIO_UMCMN_R0_ISR_S6_ADDR(x))
#define HWIO_UMCMN_R0_ISR_S6_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_ISR_S6_ADDR(x), m)
#define HWIO_UMCMN_R0_ISR_S6_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_ISR_S6_ADDR(x),v)
#define HWIO_UMCMN_R0_ISR_S6_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_ISR_S6_ADDR(x),m,v,HWIO_UMCMN_R0_ISR_S6_IN(x))
#define HWIO_UMCMN_R0_ISR_S6_REO2PPE_RING_WDG_BMSK                                                0x200000
#define HWIO_UMCMN_R0_ISR_S6_REO2PPE_RING_WDG_SHFT                                                      21
#define HWIO_UMCMN_R0_ISR_S6_REO2SW8_RING_WDG_BMSK                                                0x100000
#define HWIO_UMCMN_R0_ISR_S6_REO2SW8_RING_WDG_SHFT                                                      20
#define HWIO_UMCMN_R0_ISR_S6_REO2SW7_RING_WDG_BMSK                                                 0x80000
#define HWIO_UMCMN_R0_ISR_S6_REO2SW7_RING_WDG_SHFT                                                      19
#define HWIO_UMCMN_R0_ISR_S6_REO_STATUS_RING_WDG_BMSK                                              0x40000
#define HWIO_UMCMN_R0_ISR_S6_REO_STATUS_RING_WDG_SHFT                                                   18
#define HWIO_UMCMN_R0_ISR_S6_REO_RELEASE_RING_WDG_BMSK                                             0x20000
#define HWIO_UMCMN_R0_ISR_S6_REO_RELEASE_RING_WDG_SHFT                                                  17
#define HWIO_UMCMN_R0_ISR_S6_REO2FW_RING_WDG_BMSK                                                  0x10000
#define HWIO_UMCMN_R0_ISR_S6_REO2FW_RING_WDG_SHFT                                                       16
#define HWIO_UMCMN_R0_ISR_S6_REO2SW0_RING_WDG_BMSK                                                  0x8000
#define HWIO_UMCMN_R0_ISR_S6_REO2SW0_RING_WDG_SHFT                                                      15
#define HWIO_UMCMN_R0_ISR_S6_REO2SW6_RING_WDG_BMSK                                                  0x4000
#define HWIO_UMCMN_R0_ISR_S6_REO2SW6_RING_WDG_SHFT                                                      14
#define HWIO_UMCMN_R0_ISR_S6_REO2SW5_RING_WDG_BMSK                                                  0x2000
#define HWIO_UMCMN_R0_ISR_S6_REO2SW5_RING_WDG_SHFT                                                      13
#define HWIO_UMCMN_R0_ISR_S6_REO2SW4_RING_WDG_BMSK                                                  0x1000
#define HWIO_UMCMN_R0_ISR_S6_REO2SW4_RING_WDG_SHFT                                                      12
#define HWIO_UMCMN_R0_ISR_S6_REO2SW3_RING_WDG_BMSK                                                   0x800
#define HWIO_UMCMN_R0_ISR_S6_REO2SW3_RING_WDG_SHFT                                                      11
#define HWIO_UMCMN_R0_ISR_S6_REO2SW2_RING_WDG_BMSK                                                   0x400
#define HWIO_UMCMN_R0_ISR_S6_REO2SW2_RING_WDG_SHFT                                                      10
#define HWIO_UMCMN_R0_ISR_S6_REO2SW1_RING_WDG_BMSK                                                   0x200
#define HWIO_UMCMN_R0_ISR_S6_REO2SW1_RING_WDG_SHFT                                                       9
#define HWIO_UMCMN_R0_ISR_S6_SW2REO_RING_WDG_BMSK                                                    0x100
#define HWIO_UMCMN_R0_ISR_S6_SW2REO_RING_WDG_SHFT                                                        8
#define HWIO_UMCMN_R0_ISR_S6_SW2REO1_RING_WDG_BMSK                                                    0x80
#define HWIO_UMCMN_R0_ISR_S6_SW2REO1_RING_WDG_SHFT                                                       7
#define HWIO_UMCMN_R0_ISR_S6_SW2REO2_RING_WDG_BMSK                                                    0x40
#define HWIO_UMCMN_R0_ISR_S6_SW2REO2_RING_WDG_SHFT                                                       6
#define HWIO_UMCMN_R0_ISR_S6_SW2REO3_RING_WDG_BMSK                                                    0x20
#define HWIO_UMCMN_R0_ISR_S6_SW2REO3_RING_WDG_SHFT                                                       5
#define HWIO_UMCMN_R0_ISR_S6_REO_CMD_RING_WDG_BMSK                                                    0x10
#define HWIO_UMCMN_R0_ISR_S6_REO_CMD_RING_WDG_SHFT                                                       4
#define HWIO_UMCMN_R0_ISR_S6_WBM2REO_LINK_RING_WDG_BMSK                                                0x8
#define HWIO_UMCMN_R0_ISR_S6_WBM2REO_LINK_RING_WDG_SHFT                                                  3
#define HWIO_UMCMN_R0_ISR_S6_RXDMA2REO2_MLO_RING_WDG_BMSK                                              0x4
#define HWIO_UMCMN_R0_ISR_S6_RXDMA2REO2_MLO_RING_WDG_SHFT                                                2
#define HWIO_UMCMN_R0_ISR_S6_RXDMA2REO1_MLO_RING_WDG_BMSK                                              0x2
#define HWIO_UMCMN_R0_ISR_S6_RXDMA2REO1_MLO_RING_WDG_SHFT                                                1
#define HWIO_UMCMN_R0_ISR_S6_RXDMA2REO0_RING_WDG_BMSK                                                  0x1
#define HWIO_UMCMN_R0_ISR_S6_RXDMA2REO0_RING_WDG_SHFT                                                    0

#define HWIO_UMCMN_R0_ISR_S7_ADDR(x)                                                            ((x) + 0x50)
#define HWIO_UMCMN_R0_ISR_S7_PHYS(x)                                                            ((x) + 0x50)
#define HWIO_UMCMN_R0_ISR_S7_OFFS                                                               (0x50)
#define HWIO_UMCMN_R0_ISR_S7_RMSK                                                               0xffff000f
#define HWIO_UMCMN_R0_ISR_S7_POR                                                                0x00000000
#define HWIO_UMCMN_R0_ISR_S7_POR_RMSK                                                           0xffffffff
#define HWIO_UMCMN_R0_ISR_S7_ATTR                                                                            0x0
#define HWIO_UMCMN_R0_ISR_S7_IN(x)            \
                in_dword(HWIO_UMCMN_R0_ISR_S7_ADDR(x))
#define HWIO_UMCMN_R0_ISR_S7_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_ISR_S7_ADDR(x), m)
#define HWIO_UMCMN_R0_ISR_S7_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_ISR_S7_ADDR(x),v)
#define HWIO_UMCMN_R0_ISR_S7_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_ISR_S7_ADDR(x),m,v,HWIO_UMCMN_R0_ISR_S7_IN(x))
#define HWIO_UMCMN_R0_ISR_S7_REO_CACHE_INT_BMSK                                                 0xffff0000
#define HWIO_UMCMN_R0_ISR_S7_REO_CACHE_INT_SHFT                                                         16
#define HWIO_UMCMN_R0_ISR_S7_REO_AC_BUF_OVER_THRESH_BMSK                                               0xf
#define HWIO_UMCMN_R0_ISR_S7_REO_AC_BUF_OVER_THRESH_SHFT                                                 0

#define HWIO_UMCMN_R0_ISR_S8_ADDR(x)                                                            ((x) + 0x54)
#define HWIO_UMCMN_R0_ISR_S8_PHYS(x)                                                            ((x) + 0x54)
#define HWIO_UMCMN_R0_ISR_S8_OFFS                                                               (0x54)
#define HWIO_UMCMN_R0_ISR_S8_RMSK                                                               0xffffffff
#define HWIO_UMCMN_R0_ISR_S8_POR                                                                0x00000000
#define HWIO_UMCMN_R0_ISR_S8_POR_RMSK                                                           0xffffffff
#define HWIO_UMCMN_R0_ISR_S8_ATTR                                                                            0x0
#define HWIO_UMCMN_R0_ISR_S8_IN(x)            \
                in_dword(HWIO_UMCMN_R0_ISR_S8_ADDR(x))
#define HWIO_UMCMN_R0_ISR_S8_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_ISR_S8_ADDR(x), m)
#define HWIO_UMCMN_R0_ISR_S8_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_ISR_S8_ADDR(x),v)
#define HWIO_UMCMN_R0_ISR_S8_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_ISR_S8_ADDR(x),m,v,HWIO_UMCMN_R0_ISR_S8_IN(x))
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_RESERVED_BMSK                                         0xfff00000
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_RESERVED_SHFT                                                 20
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_INVALID_TLV_CMD_BMSK                                     0x80000
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_INVALID_TLV_CMD_SHFT                                          19
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_RX_QUEUE_NUM_MISMATCH_BMSK                               0x40000
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_RX_QUEUE_NUM_MISMATCH_SHFT                                    18
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_REORDER_SW_ZERO_DESC_BMSK                                0x20000
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_REORDER_SW_ZERO_DESC_SHFT                                     17
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_REORDER_AGE_ZERO_DESC_BMSK                               0x10000
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_REORDER_AGE_ZERO_DESC_SHFT                                    16
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_REORDER_ZERO_MSDU_LINK_PTR_BMSK                           0x8000
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_REORDER_ZERO_MSDU_LINK_PTR_SHFT                               15
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_REORDER_ZERO_MPDU_LINK_PTR_BMSK                           0x4000
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_REORDER_ZERO_MPDU_LINK_PTR_SHFT                               14
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_SEQ_ZERO_MSDU_BUF_PTR_BMSK                                0x2000
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_SEQ_ZERO_MSDU_BUF_PTR_SHFT                                    13
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_DD_BA_NON_AMPDU_BMSK                                      0x1000
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_DD_BA_NON_AMPDU_SHFT                                          12
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_SEQ_PN_ERR_BMSK                                            0x800
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_SEQ_PN_ERR_SHFT                                               11
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_DD_BAR_SNEQUAL_BMSK                                        0x400
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_DD_BAR_SNEQUAL_SHFT                                           10
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_DD_BAR_NONBA_BMSK                                          0x200
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_DD_BAR_NONBA_SHFT                                              9
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_DD_OOR_BAR_BMSK                                            0x100
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_DD_OOR_BAR_SHFT                                                8
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_DD_OOR_REG_BMSK                                             0x80
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_DD_OOR_REG_SHFT                                                7
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_DD_2K_BAR_BMSK                                              0x40
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_DD_2K_BAR_SHFT                                                 6
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_DD_2K_REG_BMSK                                              0x20
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_DD_2K_REG_SHFT                                                 5
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_DD_BA_DD_BMSK                                               0x10
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_DD_BA_DD_SHFT                                                  4
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_DD_NONBA_DD_BMSK                                             0x8
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_DD_NONBA_DD_SHFT                                               3
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_DD_AMPDU_NONBA_BMSK                                          0x4
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_DD_AMPDU_NONBA_SHFT                                            2
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_DD_QD_NOTVALID_BMSK                                          0x2
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_DD_QD_NOTVALID_SHFT                                            1
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_REORDER_QD_ADDR_ZERO_BMSK                                    0x1
#define HWIO_UMCMN_R0_ISR_S8_REO_ERR_INTR_REORDER_QD_ADDR_ZERO_SHFT                                      0

#define HWIO_UMCMN_R0_ISR_S9_ADDR(x)                                                            ((x) + 0x58)
#define HWIO_UMCMN_R0_ISR_S9_PHYS(x)                                                            ((x) + 0x58)
#define HWIO_UMCMN_R0_ISR_S9_OFFS                                                               (0x58)
#define HWIO_UMCMN_R0_ISR_S9_RMSK                                                                 0xffffff
#define HWIO_UMCMN_R0_ISR_S9_POR                                                                0x00000000
#define HWIO_UMCMN_R0_ISR_S9_POR_RMSK                                                           0xffffffff
#define HWIO_UMCMN_R0_ISR_S9_ATTR                                                                            0x0
#define HWIO_UMCMN_R0_ISR_S9_IN(x)            \
                in_dword(HWIO_UMCMN_R0_ISR_S9_ADDR(x))
#define HWIO_UMCMN_R0_ISR_S9_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_ISR_S9_ADDR(x), m)
#define HWIO_UMCMN_R0_ISR_S9_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_ISR_S9_ADDR(x),v)
#define HWIO_UMCMN_R0_ISR_S9_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_ISR_S9_ADDR(x),m,v,HWIO_UMCMN_R0_ISR_S9_IN(x))
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_BMSK                                            0xf00000
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_SHFT                                                  20
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_WARNING_INTR_BMSK                                    0x80000
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_WARNING_INTR_SHFT                                         19
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_HOST7_PROD_BMSK                                  0x40000
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_HOST7_PROD_SHFT                                       18
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_HOST6_PROD_BMSK                                  0x20000
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_HOST6_PROD_SHFT                                       17
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_HOST5_PROD_BMSK                                  0x10000
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_HOST5_PROD_SHFT                                       16
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_HOST4_PROD_BMSK                                   0x8000
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_HOST4_PROD_SHFT                                       15
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_STATUS_PROD_BMSK                                  0x4000
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_STATUS_PROD_SHFT                                      14
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_RELEASE_PROD_BMSK                                 0x2000
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_RELEASE_PROD_SHFT                                     13
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_WIFI_PROD_BMSK                                    0x1000
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_WIFI_PROD_SHFT                                        12
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_TCL_PROD_BMSK                                      0x800
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_TCL_PROD_SHFT                                         11
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_HOST3_PROD_BMSK                                    0x400
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_HOST3_PROD_SHFT                                       10
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_HOST2_PROD_BMSK                                    0x200
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_HOST2_PROD_SHFT                                        9
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_HOST1_PROD_BMSK                                    0x100
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_HOST1_PROD_SHFT                                        8
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_HOST0_PROD_BMSK                                     0x80
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_HOST0_PROD_SHFT                                        7
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_SEQUENCER_BMSK                                      0x40
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_SEQUENCER_SHFT                                         6
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_REORDER_BMSK                                        0x20
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_REORDER_SHFT                                           5
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_MPDU_LINK_PREFETCH_BMSK                             0x10
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_MPDU_LINK_PREFETCH_SHFT                                4
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_REO_CMD_TLV_BMSK                                     0x8
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_REO_CMD_TLV_SHFT                                       3
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_REO_CMD_PREFETCH_BMSK                                0x4
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_REO_CMD_PREFETCH_SHFT                                  2
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_REO_RING_PREFETCH_BMSK                               0x2
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_REO_RING_PREFETCH_SHFT                                 1
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_REO_RING_PREFETCH_READ_BMSK                          0x1
#define HWIO_UMCMN_R0_ISR_S9_REO_RESERVED_WDG_ERR_REO_RING_PREFETCH_READ_SHFT                            0

#define HWIO_UMCMN_R0_ISR_S10_ADDR(x)                                                           ((x) + 0x5c)
#define HWIO_UMCMN_R0_ISR_S10_PHYS(x)                                                           ((x) + 0x5c)
#define HWIO_UMCMN_R0_ISR_S10_OFFS                                                              (0x5c)
#define HWIO_UMCMN_R0_ISR_S10_RMSK                                                                 0x3ffff
#define HWIO_UMCMN_R0_ISR_S10_POR                                                               0x00000000
#define HWIO_UMCMN_R0_ISR_S10_POR_RMSK                                                          0xffffffff
#define HWIO_UMCMN_R0_ISR_S10_ATTR                                                                           0x0
#define HWIO_UMCMN_R0_ISR_S10_IN(x)            \
                in_dword(HWIO_UMCMN_R0_ISR_S10_ADDR(x))
#define HWIO_UMCMN_R0_ISR_S10_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_ISR_S10_ADDR(x), m)
#define HWIO_UMCMN_R0_ISR_S10_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_ISR_S10_ADDR(x),v)
#define HWIO_UMCMN_R0_ISR_S10_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_ISR_S10_ADDR(x),m,v,HWIO_UMCMN_R0_ISR_S10_IN(x))
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_HOST_SRNG11_REQ_ERR_BMSK                            0x20000
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_HOST_SRNG11_REQ_ERR_SHFT                                 17
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_HOST_SRNG10_REQ_ERR_BMSK                            0x10000
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_HOST_SRNG10_REQ_ERR_SHFT                                 16
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_HOST_SRNG9_REQ_ERR_BMSK                              0x8000
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_HOST_SRNG9_REQ_ERR_SHFT                                  15
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_HOST_SRNG8_REQ_ERR_BMSK                              0x4000
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_HOST_SRNG8_REQ_ERR_SHFT                                  14
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_HOST_SRNG7_REQ_ERR_BMSK                              0x2000
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_HOST_SRNG7_REQ_ERR_SHFT                                  13
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_HOST_SRNG6_REQ_ERR_BMSK                              0x1000
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_HOST_SRNG6_REQ_ERR_SHFT                                  12
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_HOST_SRNG5_REQ_ERR_BMSK                               0x800
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_HOST_SRNG5_REQ_ERR_SHFT                                  11
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_HOST_SRNG4_REQ_ERR_BMSK                               0x400
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_HOST_SRNG4_REQ_ERR_SHFT                                  10
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_HOST_SRNG3_REQ_ERR_BMSK                               0x200
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_HOST_SRNG3_REQ_ERR_SHFT                                   9
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_HOST_SRNG2_REQ_ERR_BMSK                               0x100
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_HOST_SRNG2_REQ_ERR_SHFT                                   8
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_HOST_SRNG1_REQ_ERR_BMSK                                0x80
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_HOST_SRNG1_REQ_ERR_SHFT                                   7
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_HOST_SRNG0_REQ_ERR_BMSK                                0x40
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_HOST_SRNG0_REQ_ERR_SHFT                                   6
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_REO_CMD_SRNG_REQ_ERR_BMSK                              0x20
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_REO_CMD_SRNG_REQ_ERR_SHFT                                 5
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_LINK_DESC_SRNG_REQ_ERR_BMSK                            0x10
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_LINK_DESC_SRNG_REQ_ERR_SHFT                               4
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_ENTR_SRNG3_REQ_ERR_BMSK                                 0x8
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_ENTR_SRNG3_REQ_ERR_SHFT                                   3
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_ENTR_SRNG2_REQ_ERR_BMSK                                 0x4
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_ENTR_SRNG2_REQ_ERR_SHFT                                   2
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_ENTR_SRNG1_REQ_ERR_BMSK                                 0x2
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_ENTR_SRNG1_REQ_ERR_SHFT                                   1
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_ENTR_SRNG0_REQ_ERR_BMSK                                 0x1
#define HWIO_UMCMN_R0_ISR_S10_REO_RESERVED_INT_ENTR_SRNG0_REQ_ERR_SHFT                                   0

#define HWIO_UMCMN_R0_ISR_S11_ADDR(x)                                                           ((x) + 0x60)
#define HWIO_UMCMN_R0_ISR_S11_PHYS(x)                                                           ((x) + 0x60)
#define HWIO_UMCMN_R0_ISR_S11_OFFS                                                              (0x60)
#define HWIO_UMCMN_R0_ISR_S11_RMSK                                                               0x3ffffff
#define HWIO_UMCMN_R0_ISR_S11_POR                                                               0x00000000
#define HWIO_UMCMN_R0_ISR_S11_POR_RMSK                                                          0xffffffff
#define HWIO_UMCMN_R0_ISR_S11_ATTR                                                                           0x0
#define HWIO_UMCMN_R0_ISR_S11_IN(x)            \
                in_dword(HWIO_UMCMN_R0_ISR_S11_ADDR(x))
#define HWIO_UMCMN_R0_ISR_S11_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_ISR_S11_ADDR(x), m)
#define HWIO_UMCMN_R0_ISR_S11_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_ISR_S11_ADDR(x),v)
#define HWIO_UMCMN_R0_ISR_S11_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_ISR_S11_ADDR(x),m,v,HWIO_UMCMN_R0_ISR_S11_IN(x))
#define HWIO_UMCMN_R0_ISR_S11_TCL_PPE2TCL1_RING_WDG_ERR_BMSK                                     0x2000000
#define HWIO_UMCMN_R0_ISR_S11_TCL_PPE2TCL1_RING_WDG_ERR_SHFT                                            25
#define HWIO_UMCMN_R0_ISR_S11_TCL_PPE2TCL1_RING_REQ_ERR_BMSK                                     0x1000000
#define HWIO_UMCMN_R0_ISR_S11_TCL_PPE2TCL1_RING_REQ_ERR_SHFT                                            24
#define HWIO_UMCMN_R0_ISR_S11_TCL_SW2TCL_CREDIT2_RING_WDG_ERR_BMSK                                0x800000
#define HWIO_UMCMN_R0_ISR_S11_TCL_SW2TCL_CREDIT2_RING_WDG_ERR_SHFT                                      23
#define HWIO_UMCMN_R0_ISR_S11_TCL_SW2TCL_CREDIT2_RING_REQ_ERR_BMSK                                0x400000
#define HWIO_UMCMN_R0_ISR_S11_TCL_SW2TCL_CREDIT2_RING_REQ_ERR_SHFT                                      22
#define HWIO_UMCMN_R0_ISR_S11_TCL_SW2TCL5_RING_WDG_ERR_BMSK                                       0x200000
#define HWIO_UMCMN_R0_ISR_S11_TCL_SW2TCL5_RING_WDG_ERR_SHFT                                             21
#define HWIO_UMCMN_R0_ISR_S11_TCL_SW2TCL5_RING_REQ_ERR_BMSK                                       0x100000
#define HWIO_UMCMN_R0_ISR_S11_TCL_SW2TCL5_RING_REQ_ERR_SHFT                                             20
#define HWIO_UMCMN_R0_ISR_S11_TCL_SW2TCL4_RING_WDG_ERR_BMSK                                        0x80000
#define HWIO_UMCMN_R0_ISR_S11_TCL_SW2TCL4_RING_WDG_ERR_SHFT                                             19
#define HWIO_UMCMN_R0_ISR_S11_TCL_SW2TCL4_RING_REQ_ERR_BMSK                                        0x40000
#define HWIO_UMCMN_R0_ISR_S11_TCL_SW2TCL4_RING_REQ_ERR_SHFT                                             18
#define HWIO_UMCMN_R0_ISR_S11_TCL_STATUS2_RING_WDG_ERR_BMSK                                        0x20000
#define HWIO_UMCMN_R0_ISR_S11_TCL_STATUS2_RING_WDG_ERR_SHFT                                             17
#define HWIO_UMCMN_R0_ISR_S11_TCL_STATUS2_RING_REQ_ERR_BMSK                                        0x10000
#define HWIO_UMCMN_R0_ISR_S11_TCL_STATUS2_RING_REQ_ERR_SHFT                                             16
#define HWIO_UMCMN_R0_ISR_S11_TCL_STATUS1_RING_WDG_ERR_BMSK                                         0x8000
#define HWIO_UMCMN_R0_ISR_S11_TCL_STATUS1_RING_WDG_ERR_SHFT                                             15
#define HWIO_UMCMN_R0_ISR_S11_TCL_STATUS1_RING_REQ_ERR_BMSK                                         0x4000
#define HWIO_UMCMN_R0_ISR_S11_TCL_STATUS1_RING_REQ_ERR_SHFT                                             14
#define HWIO_UMCMN_R0_ISR_S11_TCL_TCL2FW_RING_WDG_ERR_BMSK                                          0x2000
#define HWIO_UMCMN_R0_ISR_S11_TCL_TCL2FW_RING_WDG_ERR_SHFT                                              13
#define HWIO_UMCMN_R0_ISR_S11_TCL_TCL2FW_RING_REQ_ERR_BMSK                                          0x1000
#define HWIO_UMCMN_R0_ISR_S11_TCL_TCL2FW_RING_REQ_ERR_SHFT                                              12
#define HWIO_UMCMN_R0_ISR_S11_TCL_TCL2TQM_RING_WDG_ERR_BMSK                                          0x800
#define HWIO_UMCMN_R0_ISR_S11_TCL_TCL2TQM_RING_WDG_ERR_SHFT                                             11
#define HWIO_UMCMN_R0_ISR_S11_TCL_TCL2TQM_RING_REQ_ERR_BMSK                                          0x400
#define HWIO_UMCMN_R0_ISR_S11_TCL_TCL2TQM_RING_REQ_ERR_SHFT                                             10
#define HWIO_UMCMN_R0_ISR_S11_TCL_SW2TCL_CREDIT_RING_WDG_ERR_BMSK                                    0x200
#define HWIO_UMCMN_R0_ISR_S11_TCL_SW2TCL_CREDIT_RING_WDG_ERR_SHFT                                        9
#define HWIO_UMCMN_R0_ISR_S11_TCL_SW2TCL_CREDIT_RING_REQ_ERR_BMSK                                    0x100
#define HWIO_UMCMN_R0_ISR_S11_TCL_SW2TCL_CREDIT_RING_REQ_ERR_SHFT                                        8
#define HWIO_UMCMN_R0_ISR_S11_TCL_FW2TCL1_RING_WDG_ERR_BMSK                                           0x80
#define HWIO_UMCMN_R0_ISR_S11_TCL_FW2TCL1_RING_WDG_ERR_SHFT                                              7
#define HWIO_UMCMN_R0_ISR_S11_TCL_FW2TCL1_RING_REQ_ERR_BMSK                                           0x40
#define HWIO_UMCMN_R0_ISR_S11_TCL_FW2TCL1_RING_REQ_ERR_SHFT                                              6
#define HWIO_UMCMN_R0_ISR_S11_TCL_SW2TCL3_RING_WDG_ERR_BMSK                                           0x20
#define HWIO_UMCMN_R0_ISR_S11_TCL_SW2TCL3_RING_WDG_ERR_SHFT                                              5
#define HWIO_UMCMN_R0_ISR_S11_TCL_SW2TCL3_RING_REQ_ERR_BMSK                                           0x10
#define HWIO_UMCMN_R0_ISR_S11_TCL_SW2TCL3_RING_REQ_ERR_SHFT                                              4
#define HWIO_UMCMN_R0_ISR_S11_TCL_SW2TCL2_RING_WDG_ERR_BMSK                                            0x8
#define HWIO_UMCMN_R0_ISR_S11_TCL_SW2TCL2_RING_WDG_ERR_SHFT                                              3
#define HWIO_UMCMN_R0_ISR_S11_TCL_SW2TCL2_RING_REQ_ERR_BMSK                                            0x4
#define HWIO_UMCMN_R0_ISR_S11_TCL_SW2TCL2_RING_REQ_ERR_SHFT                                              2
#define HWIO_UMCMN_R0_ISR_S11_TCL_SW2TCL1_RING_WDG_ERR_BMSK                                            0x2
#define HWIO_UMCMN_R0_ISR_S11_TCL_SW2TCL1_RING_WDG_ERR_SHFT                                              1
#define HWIO_UMCMN_R0_ISR_S11_TCL_SW2TCL1_RING_REQ_ERR_BMSK                                            0x1
#define HWIO_UMCMN_R0_ISR_S11_TCL_SW2TCL1_RING_REQ_ERR_SHFT                                              0

#define HWIO_UMCMN_R0_ISR_S12_ADDR(x)                                                           ((x) + 0x64)
#define HWIO_UMCMN_R0_ISR_S12_PHYS(x)                                                           ((x) + 0x64)
#define HWIO_UMCMN_R0_ISR_S12_OFFS                                                              (0x64)
#define HWIO_UMCMN_R0_ISR_S12_RMSK                                                                0x3fffff
#define HWIO_UMCMN_R0_ISR_S12_POR                                                               0x00000000
#define HWIO_UMCMN_R0_ISR_S12_POR_RMSK                                                          0xffffffff
#define HWIO_UMCMN_R0_ISR_S12_ATTR                                                                           0x0
#define HWIO_UMCMN_R0_ISR_S12_IN(x)            \
                in_dword(HWIO_UMCMN_R0_ISR_S12_ADDR(x))
#define HWIO_UMCMN_R0_ISR_S12_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_ISR_S12_ADDR(x), m)
#define HWIO_UMCMN_R0_ISR_S12_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_ISR_S12_ADDR(x),v)
#define HWIO_UMCMN_R0_ISR_S12_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_ISR_S12_ADDR(x),m,v,HWIO_UMCMN_R0_ISR_S12_IN(x))
#define HWIO_UMCMN_R0_ISR_S12_TCL_PARSER_OUT_TLV_SEQ_ERR_BMSK                                     0x200000
#define HWIO_UMCMN_R0_ISR_S12_TCL_PARSER_OUT_TLV_SEQ_ERR_SHFT                                           21
#define HWIO_UMCMN_R0_ISR_S12_TCL_PPE2TCL1_ZERO_LEN_ERR_BMSK                                      0x100000
#define HWIO_UMCMN_R0_ISR_S12_TCL_PPE2TCL1_ZERO_LEN_ERR_SHFT                                            20
#define HWIO_UMCMN_R0_ISR_S12_TCL_SW2TCL_CREDIT2_ZERO_LEN_ERR_BMSK                                 0x80000
#define HWIO_UMCMN_R0_ISR_S12_TCL_SW2TCL_CREDIT2_ZERO_LEN_ERR_SHFT                                      19
#define HWIO_UMCMN_R0_ISR_S12_TCL_BUFFER_LENGTH_ERROR_INT_BMSK                                     0x40000
#define HWIO_UMCMN_R0_ISR_S12_TCL_BUFFER_LENGTH_ERROR_INT_SHFT                                          18
#define HWIO_UMCMN_R0_ISR_S12_TCL_BANK_ID_ERR_BMSK                                                 0x20000
#define HWIO_UMCMN_R0_ISR_S12_TCL_BANK_ID_ERR_SHFT                                                      17
#define HWIO_UMCMN_R0_ISR_S12_TCL_WDG_WARNING_BMSK                                                 0x10000
#define HWIO_UMCMN_R0_ISR_S12_TCL_WDG_WARNING_SHFT                                                      16
#define HWIO_UMCMN_R0_ISR_S12_TCL_SW2TCL5_ZERO_LEN_ERR_BMSK                                         0x8000
#define HWIO_UMCMN_R0_ISR_S12_TCL_SW2TCL5_ZERO_LEN_ERR_SHFT                                             15
#define HWIO_UMCMN_R0_ISR_S12_TCL_SW2TCL4_ZERO_LEN_ERR_BMSK                                         0x4000
#define HWIO_UMCMN_R0_ISR_S12_TCL_SW2TCL4_ZERO_LEN_ERR_SHFT                                             14
#define HWIO_UMCMN_R0_ISR_S12_TCL_CCE_ERR_CLASSIFY_DIS_BMSK                                         0x2000
#define HWIO_UMCMN_R0_ISR_S12_TCL_CCE_ERR_CLASSIFY_DIS_SHFT                                             13
#define HWIO_UMCMN_R0_ISR_S12_TCL_CCE_WDG_TO_BMSK                                                   0x1000
#define HWIO_UMCMN_R0_ISR_S12_TCL_CCE_WDG_TO_SHFT                                                       12
#define HWIO_UMCMN_R0_ISR_S12_TCL_CMN_PRSR_IPV6_JUMBOGRAM_BMSK                                       0x800
#define HWIO_UMCMN_R0_ISR_S12_TCL_CMN_PRSR_IPV6_JUMBOGRAM_SHFT                                          11
#define HWIO_UMCMN_R0_ISR_S12_TCL_CMN_PRSR_IPV6_EXT_HD_BYTES_EXCEED_BMSK                             0x400
#define HWIO_UMCMN_R0_ISR_S12_TCL_CMN_PRSR_IPV6_EXT_HD_BYTES_EXCEED_SHFT                                10
#define HWIO_UMCMN_R0_ISR_S12_TCL_CMN_PRSR_MSDU_LEN_ERR_BMSK                                         0x200
#define HWIO_UMCMN_R0_ISR_S12_TCL_CMN_PRSR_MSDU_LEN_ERR_SHFT                                             9
#define HWIO_UMCMN_R0_ISR_S12_TCL_CMN_PRSR_ETH_ERR_BMSK                                              0x100
#define HWIO_UMCMN_R0_ISR_S12_TCL_CMN_PRSR_ETH_ERR_SHFT                                                  8
#define HWIO_UMCMN_R0_ISR_S12_TCL_CMN_PRSR_WMAC_ERR_BMSK                                              0x80
#define HWIO_UMCMN_R0_ISR_S12_TCL_CMN_PRSR_WMAC_ERR_SHFT                                                 7
#define HWIO_UMCMN_R0_ISR_S12_TCL_CMN_PRSR_WDG_TO_BMSK                                                0x40
#define HWIO_UMCMN_R0_ISR_S12_TCL_CMN_PRSR_WDG_TO_SHFT                                                   6
#define HWIO_UMCMN_R0_ISR_S12_TCL_SW2TCL_CREDIT_ZERO_LEN_ERR_BMSK                                     0x20
#define HWIO_UMCMN_R0_ISR_S12_TCL_SW2TCL_CREDIT_ZERO_LEN_ERR_SHFT                                        5
#define HWIO_UMCMN_R0_ISR_S12_TCL_FW2TCL1_ZERO_LEN_ERR_BMSK                                           0x10
#define HWIO_UMCMN_R0_ISR_S12_TCL_FW2TCL1_ZERO_LEN_ERR_SHFT                                              4
#define HWIO_UMCMN_R0_ISR_S12_TCL_SW2TCL3_ZERO_LEN_ERR_BMSK                                            0x8
#define HWIO_UMCMN_R0_ISR_S12_TCL_SW2TCL3_ZERO_LEN_ERR_SHFT                                              3
#define HWIO_UMCMN_R0_ISR_S12_TCL_SW2TCL2_ZERO_LEN_ERR_BMSK                                            0x4
#define HWIO_UMCMN_R0_ISR_S12_TCL_SW2TCL2_ZERO_LEN_ERR_SHFT                                              2
#define HWIO_UMCMN_R0_ISR_S12_TCL_SW2TCL1_ZERO_LEN_ERR_BMSK                                            0x2
#define HWIO_UMCMN_R0_ISR_S12_TCL_SW2TCL1_ZERO_LEN_ERR_SHFT                                              1
#define HWIO_UMCMN_R0_ISR_S12_TCL_WDG_ERR_BMSK                                                         0x1
#define HWIO_UMCMN_R0_ISR_S12_TCL_WDG_ERR_SHFT                                                           0

#define HWIO_UMCMN_R0_ISR_S13_ADDR(x)                                                           ((x) + 0x68)
#define HWIO_UMCMN_R0_ISR_S13_PHYS(x)                                                           ((x) + 0x68)
#define HWIO_UMCMN_R0_ISR_S13_OFFS                                                              (0x68)
#define HWIO_UMCMN_R0_ISR_S13_RMSK                                                                 0x3ffff
#define HWIO_UMCMN_R0_ISR_S13_POR                                                               0x00000000
#define HWIO_UMCMN_R0_ISR_S13_POR_RMSK                                                          0xffffffff
#define HWIO_UMCMN_R0_ISR_S13_ATTR                                                                           0x0
#define HWIO_UMCMN_R0_ISR_S13_IN(x)            \
                in_dword(HWIO_UMCMN_R0_ISR_S13_ADDR(x))
#define HWIO_UMCMN_R0_ISR_S13_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_ISR_S13_ADDR(x), m)
#define HWIO_UMCMN_R0_ISR_S13_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_ISR_S13_ADDR(x),v)
#define HWIO_UMCMN_R0_ISR_S13_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_ISR_S13_ADDR(x),m,v,HWIO_UMCMN_R0_ISR_S13_IN(x))
#define HWIO_UMCMN_R0_ISR_S13_TQM_DESC_PTR_RELEASE_RING_REQ_ERR_BMSK                               0x20000
#define HWIO_UMCMN_R0_ISR_S13_TQM_DESC_PTR_RELEASE_RING_REQ_ERR_SHFT                                    17
#define HWIO_UMCMN_R0_ISR_S13_TQM_DESC_PTR_RELEASE_RING_WDG_ERR_BMSK                               0x10000
#define HWIO_UMCMN_R0_ISR_S13_TQM_DESC_PTR_RELEASE_RING_WDG_ERR_SHFT                                    16
#define HWIO_UMCMN_R0_ISR_S13_TQM_STATUS1_UPDATE_RING_REQ_ERR_BMSK                                  0x8000
#define HWIO_UMCMN_R0_ISR_S13_TQM_STATUS1_UPDATE_RING_REQ_ERR_SHFT                                      15
#define HWIO_UMCMN_R0_ISR_S13_TQM_STATUS1_UPDATE_RING_WDG_ERR_BMSK                                  0x4000
#define HWIO_UMCMN_R0_ISR_S13_TQM_STATUS1_UPDATE_RING_WDG_ERR_SHFT                                      14
#define HWIO_UMCMN_R0_ISR_S13_TQM_STATUS_UPDATE_RING_REQ_ERR_BMSK                                   0x2000
#define HWIO_UMCMN_R0_ISR_S13_TQM_STATUS_UPDATE_RING_REQ_ERR_SHFT                                       13
#define HWIO_UMCMN_R0_ISR_S13_TQM_STATUS_UPDATE_RING_WDG_ERR_BMSK                                   0x1000
#define HWIO_UMCMN_R0_ISR_S13_TQM_STATUS_UPDATE_RING_WDG_ERR_SHFT                                       12
#define HWIO_UMCMN_R0_ISR_S13_TQM_DESC_PTR_FETCH_RING_REQ_ERR_BMSK                                   0x800
#define HWIO_UMCMN_R0_ISR_S13_TQM_DESC_PTR_FETCH_RING_REQ_ERR_SHFT                                      11
#define HWIO_UMCMN_R0_ISR_S13_TQM_DESC_PTR_FETCH_RING_WDG_ERR_BMSK                                   0x400
#define HWIO_UMCMN_R0_ISR_S13_TQM_DESC_PTR_FETCH_RING_WDG_ERR_SHFT                                      10
#define HWIO_UMCMN_R0_ISR_S13_TQM_HWSCH_TLV1_LINK_ID_MISMATCH_ERR_BMSK                               0x200
#define HWIO_UMCMN_R0_ISR_S13_TQM_HWSCH_TLV1_LINK_ID_MISMATCH_ERR_SHFT                                   9
#define HWIO_UMCMN_R0_ISR_S13_TQM_HWSCH_TLV1_FLUSH_REQ_ERR_BMSK                                      0x100
#define HWIO_UMCMN_R0_ISR_S13_TQM_HWSCH_TLV1_FLUSH_REQ_ERR_SHFT                                          8
#define HWIO_UMCMN_R0_ISR_S13_TQM_HWSCH_TLV0_LINK_ID_MISMATCH_ERR_BMSK                                0x80
#define HWIO_UMCMN_R0_ISR_S13_TQM_HWSCH_TLV0_LINK_ID_MISMATCH_ERR_SHFT                                   7
#define HWIO_UMCMN_R0_ISR_S13_TQM_HWSCH_TLV0_FLUSH_REQ_ERR_BMSK                                       0x40
#define HWIO_UMCMN_R0_ISR_S13_TQM_HWSCH_TLV0_FLUSH_REQ_ERR_SHFT                                          6
#define HWIO_UMCMN_R0_ISR_S13_TQM_SW_CMD_RING_REQ_ERR_BMSK                                            0x20
#define HWIO_UMCMN_R0_ISR_S13_TQM_SW_CMD_RING_REQ_ERR_SHFT                                               5
#define HWIO_UMCMN_R0_ISR_S13_TQM_SW_CMD_RING_WDG_ERR_BMSK                                            0x10
#define HWIO_UMCMN_R0_ISR_S13_TQM_SW_CMD_RING_WDG_ERR_SHFT                                               4
#define HWIO_UMCMN_R0_ISR_S13_TQM_MSDU_ENT3_RING_REQ_ERR_BMSK                                          0x8
#define HWIO_UMCMN_R0_ISR_S13_TQM_MSDU_ENT3_RING_REQ_ERR_SHFT                                            3
#define HWIO_UMCMN_R0_ISR_S13_TQM_MSDU_ENT3_RING_WDG_ERR_BMSK                                          0x4
#define HWIO_UMCMN_R0_ISR_S13_TQM_MSDU_ENT3_RING_WDG_ERR_SHFT                                            2
#define HWIO_UMCMN_R0_ISR_S13_TQM_MSDU_ENT1_RING_REQ_ERR_BMSK                                          0x2
#define HWIO_UMCMN_R0_ISR_S13_TQM_MSDU_ENT1_RING_REQ_ERR_SHFT                                            1
#define HWIO_UMCMN_R0_ISR_S13_TQM_MSDU_ENT1_RING_WDG_ERR_BMSK                                          0x1
#define HWIO_UMCMN_R0_ISR_S13_TQM_MSDU_ENT1_RING_WDG_ERR_SHFT                                            0

#define HWIO_UMCMN_R0_ISR_S14_ADDR(x)                                                           ((x) + 0x6c)
#define HWIO_UMCMN_R0_ISR_S14_PHYS(x)                                                           ((x) + 0x6c)
#define HWIO_UMCMN_R0_ISR_S14_OFFS                                                              (0x6c)
#define HWIO_UMCMN_R0_ISR_S14_RMSK                                                               0x7ffffff
#define HWIO_UMCMN_R0_ISR_S14_POR                                                               0x00000000
#define HWIO_UMCMN_R0_ISR_S14_POR_RMSK                                                          0xffffffff
#define HWIO_UMCMN_R0_ISR_S14_ATTR                                                                           0x0
#define HWIO_UMCMN_R0_ISR_S14_IN(x)            \
                in_dword(HWIO_UMCMN_R0_ISR_S14_ADDR(x))
#define HWIO_UMCMN_R0_ISR_S14_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_ISR_S14_ADDR(x), m)
#define HWIO_UMCMN_R0_ISR_S14_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_ISR_S14_ADDR(x),v)
#define HWIO_UMCMN_R0_ISR_S14_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_ISR_S14_ADDR(x),m,v,HWIO_UMCMN_R0_ISR_S14_IN(x))
#define HWIO_UMCMN_R0_ISR_S14_TQM2TQM_OUT2_SRNG_P_FETCH_POLLING_TIMEOUT_INT_BMSK                 0x4000000
#define HWIO_UMCMN_R0_ISR_S14_TQM2TQM_OUT2_SRNG_P_FETCH_POLLING_TIMEOUT_INT_SHFT                        26
#define HWIO_UMCMN_R0_ISR_S14_TQM2TQM_OUT2_SRNG_P_REQ_ERR_INT_BMSK                               0x2000000
#define HWIO_UMCMN_R0_ISR_S14_TQM2TQM_OUT2_SRNG_P_REQ_ERR_INT_SHFT                                      25
#define HWIO_UMCMN_R0_ISR_S14_TQM2TQM_OUT2_SRNG_P_WATCHDOG_ERR_INT_BMSK                          0x1000000
#define HWIO_UMCMN_R0_ISR_S14_TQM2TQM_OUT2_SRNG_P_WATCHDOG_ERR_INT_SHFT                                 24
#define HWIO_UMCMN_R0_ISR_S14_TQM2TQM_OUT1_SRNG_P_FETCH_POLLING_TIMEOUT_INT_BMSK                  0x800000
#define HWIO_UMCMN_R0_ISR_S14_TQM2TQM_OUT1_SRNG_P_FETCH_POLLING_TIMEOUT_INT_SHFT                        23
#define HWIO_UMCMN_R0_ISR_S14_TQM2TQM_OUT1_SRNG_P_REQ_ERR_INT_BMSK                                0x400000
#define HWIO_UMCMN_R0_ISR_S14_TQM2TQM_OUT1_SRNG_P_REQ_ERR_INT_SHFT                                      22
#define HWIO_UMCMN_R0_ISR_S14_TQM2TQM_OUT1_SRNG_P_WATCHDOG_ERR_INT_BMSK                           0x200000
#define HWIO_UMCMN_R0_ISR_S14_TQM2TQM_OUT1_SRNG_P_WATCHDOG_ERR_INT_SHFT                                 21
#define HWIO_UMCMN_R0_ISR_S14_TQM2TQM_IN2_SRNG_C_FETCH_POLLING_TIMEOUT_INT_BMSK                   0x100000
#define HWIO_UMCMN_R0_ISR_S14_TQM2TQM_IN2_SRNG_C_FETCH_POLLING_TIMEOUT_INT_SHFT                         20
#define HWIO_UMCMN_R0_ISR_S14_TQM2TQM_IN2_SRNG_C_REQ_ERR_INT_BMSK                                  0x80000
#define HWIO_UMCMN_R0_ISR_S14_TQM2TQM_IN2_SRNG_C_REQ_ERR_INT_SHFT                                       19
#define HWIO_UMCMN_R0_ISR_S14_TQM2TQM_IN2_SRNG_C_WATCHDOG_ERR_INT_BMSK                             0x40000
#define HWIO_UMCMN_R0_ISR_S14_TQM2TQM_IN2_SRNG_C_WATCHDOG_ERR_INT_SHFT                                  18
#define HWIO_UMCMN_R0_ISR_S14_TQM2TQM_IN1_SRNG_C_FETCH_POLLING_TIMEOUT_INT_BMSK                    0x20000
#define HWIO_UMCMN_R0_ISR_S14_TQM2TQM_IN1_SRNG_C_FETCH_POLLING_TIMEOUT_INT_SHFT                         17
#define HWIO_UMCMN_R0_ISR_S14_TQM2TQM_IN1_SRNG_C_REQ_ERR_INT_BMSK                                  0x10000
#define HWIO_UMCMN_R0_ISR_S14_TQM2TQM_IN1_SRNG_C_REQ_ERR_INT_SHFT                                       16
#define HWIO_UMCMN_R0_ISR_S14_TQM2TQM_IN1_SRNG_C_WATCHDOG_ERR_INT_BMSK                              0x8000
#define HWIO_UMCMN_R0_ISR_S14_TQM2TQM_IN1_SRNG_C_WATCHDOG_ERR_INT_SHFT                                  15
#define HWIO_UMCMN_R0_ISR_S14_TQM_CACHE_CTL_ERR_BMSK                                                0x7ff8
#define HWIO_UMCMN_R0_ISR_S14_TQM_CACHE_CTL_ERR_SHFT                                                     3
#define HWIO_UMCMN_R0_ISR_S14_TQM_WARNING_WDG_TIMEOUT_BMSK                                             0x4
#define HWIO_UMCMN_R0_ISR_S14_TQM_WARNING_WDG_TIMEOUT_SHFT                                               2
#define HWIO_UMCMN_R0_ISR_S14_TQM_HW_ERROR_INTR_TIMEOUT_BMSK                                           0x2
#define HWIO_UMCMN_R0_ISR_S14_TQM_HW_ERROR_INTR_TIMEOUT_SHFT                                             1
#define HWIO_UMCMN_R0_ISR_S14_TQM_SW_PRGM_ERR_BMSK                                                     0x1
#define HWIO_UMCMN_R0_ISR_S14_TQM_SW_PRGM_ERR_SHFT                                                       0

#define HWIO_UMCMN_R0_ISR_S15_ADDR(x)                                                           ((x) + 0x70)
#define HWIO_UMCMN_R0_ISR_S15_PHYS(x)                                                           ((x) + 0x70)
#define HWIO_UMCMN_R0_ISR_S15_OFFS                                                              (0x70)
#define HWIO_UMCMN_R0_ISR_S15_RMSK                                                                  0x7fff
#define HWIO_UMCMN_R0_ISR_S15_POR                                                               0x00000000
#define HWIO_UMCMN_R0_ISR_S15_POR_RMSK                                                          0xffffffff
#define HWIO_UMCMN_R0_ISR_S15_ATTR                                                                           0x0
#define HWIO_UMCMN_R0_ISR_S15_IN(x)            \
                in_dword(HWIO_UMCMN_R0_ISR_S15_ADDR(x))
#define HWIO_UMCMN_R0_ISR_S15_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_ISR_S15_ADDR(x), m)
#define HWIO_UMCMN_R0_ISR_S15_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_ISR_S15_ADDR(x),v)
#define HWIO_UMCMN_R0_ISR_S15_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_ISR_S15_ADDR(x),m,v,HWIO_UMCMN_R0_ISR_S15_IN(x))
#define HWIO_UMCMN_R0_ISR_S15_TQM_UNPAUSE_LINK_DESC_THRESHOLD_BMSK                                  0x4000
#define HWIO_UMCMN_R0_ISR_S15_TQM_UNPAUSE_LINK_DESC_THRESHOLD_SHFT                                      14
#define HWIO_UMCMN_R0_ISR_S15_TQM_ILLEGAL_HWSCH_CMD_BMSK                                            0x2000
#define HWIO_UMCMN_R0_ISR_S15_TQM_ILLEGAL_HWSCH_CMD_SHFT                                                13
#define HWIO_UMCMN_R0_ISR_S15_TQM_ILLEGAL_SW_CMD_BMSK                                               0x1000
#define HWIO_UMCMN_R0_ISR_S15_TQM_ILLEGAL_SW_CMD_SHFT                                                   12
#define HWIO_UMCMN_R0_ISR_S15_TQM_LINK_DESC_CNT2_DEC_EMPTY_BMSK                                      0x800
#define HWIO_UMCMN_R0_ISR_S15_TQM_LINK_DESC_CNT2_DEC_EMPTY_SHFT                                         11
#define HWIO_UMCMN_R0_ISR_S15_TQM_LINK_DESC_CNT1_DEC_EMPTY_BMSK                                      0x400
#define HWIO_UMCMN_R0_ISR_S15_TQM_LINK_DESC_CNT1_DEC_EMPTY_SHFT                                         10
#define HWIO_UMCMN_R0_ISR_S15_TQM_LINK_DESC_CNT0_DEC_EMPTY_BMSK                                      0x200
#define HWIO_UMCMN_R0_ISR_S15_TQM_LINK_DESC_CNT0_DEC_EMPTY_SHFT                                          9
#define HWIO_UMCMN_R0_ISR_S15_TQM_LINK_DESC_CNT2_SATURATE_BMSK                                       0x100
#define HWIO_UMCMN_R0_ISR_S15_TQM_LINK_DESC_CNT2_SATURATE_SHFT                                           8
#define HWIO_UMCMN_R0_ISR_S15_TQM_LINK_DESC_CNT1_SATURATE_BMSK                                        0x80
#define HWIO_UMCMN_R0_ISR_S15_TQM_LINK_DESC_CNT1_SATURATE_SHFT                                           7
#define HWIO_UMCMN_R0_ISR_S15_TQM_LINK_DESC_CNT0_SATURATE_BMSK                                        0x40
#define HWIO_UMCMN_R0_ISR_S15_TQM_LINK_DESC_CNT0_SATURATE_SHFT                                           6
#define HWIO_UMCMN_R0_ISR_S15_TQM_LINK_DESC_THRESHOLD2_REACHED_BMSK                                   0x20
#define HWIO_UMCMN_R0_ISR_S15_TQM_LINK_DESC_THRESHOLD2_REACHED_SHFT                                      5
#define HWIO_UMCMN_R0_ISR_S15_TQM_LINK_DESC_THRESHOLD1_REACHED_BMSK                                   0x10
#define HWIO_UMCMN_R0_ISR_S15_TQM_LINK_DESC_THRESHOLD1_REACHED_SHFT                                      4
#define HWIO_UMCMN_R0_ISR_S15_TQM_LINK_DESC_THRESHOLD0_REACHED_BMSK                                    0x8
#define HWIO_UMCMN_R0_ISR_S15_TQM_LINK_DESC_THRESHOLD0_REACHED_SHFT                                      3
#define HWIO_UMCMN_R0_ISR_S15_TQM_AGGR_LINK_DESC_THRESHOLD_REACHED_BMSK                                0x4
#define HWIO_UMCMN_R0_ISR_S15_TQM_AGGR_LINK_DESC_THRESHOLD_REACHED_SHFT                                  2
#define HWIO_UMCMN_R0_ISR_S15_TQM_SW_CMD1_RING_REQ_ERR_BMSK                                            0x2
#define HWIO_UMCMN_R0_ISR_S15_TQM_SW_CMD1_RING_REQ_ERR_SHFT                                              1
#define HWIO_UMCMN_R0_ISR_S15_TQM_SW_CMD1_RING_WDG_ERR_BMSK                                            0x1
#define HWIO_UMCMN_R0_ISR_S15_TQM_SW_CMD1_RING_WDG_ERR_SHFT                                              0

#define HWIO_UMCMN_R0_ISR_S16_ADDR(x)                                                           ((x) + 0x74)
#define HWIO_UMCMN_R0_ISR_S16_PHYS(x)                                                           ((x) + 0x74)
#define HWIO_UMCMN_R0_ISR_S16_OFFS                                                              (0x74)
#define HWIO_UMCMN_R0_ISR_S16_RMSK                                                                   0x1ff
#define HWIO_UMCMN_R0_ISR_S16_POR                                                               0x00000000
#define HWIO_UMCMN_R0_ISR_S16_POR_RMSK                                                          0xffffffff
#define HWIO_UMCMN_R0_ISR_S16_ATTR                                                                           0x0
#define HWIO_UMCMN_R0_ISR_S16_IN(x)            \
                in_dword(HWIO_UMCMN_R0_ISR_S16_ADDR(x))
#define HWIO_UMCMN_R0_ISR_S16_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_ISR_S16_ADDR(x), m)
#define HWIO_UMCMN_R0_ISR_S16_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_ISR_S16_ADDR(x),v)
#define HWIO_UMCMN_R0_ISR_S16_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_ISR_S16_ADDR(x),m,v,HWIO_UMCMN_R0_ISR_S16_IN(x))
#define HWIO_UMCMN_R0_ISR_S16_MXI_RD_ZERO_ADDR_ERR_BMSK                                              0x100
#define HWIO_UMCMN_R0_ISR_S16_MXI_RD_ZERO_ADDR_ERR_SHFT                                                  8
#define HWIO_UMCMN_R0_ISR_S16_MXI_RD_ZERO_SIZE_ERR_BMSK                                               0x80
#define HWIO_UMCMN_R0_ISR_S16_MXI_RD_ZERO_SIZE_ERR_SHFT                                                  7
#define HWIO_UMCMN_R0_ISR_S16_MXI_WR_ZERO_ADDR_ERR_BMSK                                               0x40
#define HWIO_UMCMN_R0_ISR_S16_MXI_WR_ZERO_ADDR_ERR_SHFT                                                  6
#define HWIO_UMCMN_R0_ISR_S16_MXI_WR_ZERO_SIZE_ERR_BMSK                                               0x20
#define HWIO_UMCMN_R0_ISR_S16_MXI_WR_ZERO_SIZE_ERR_SHFT                                                  5
#define HWIO_UMCMN_R0_ISR_S16_MXI_GXI_WDTO_ERR_BMSK                                                   0x10
#define HWIO_UMCMN_R0_ISR_S16_MXI_GXI_WDTO_ERR_SHFT                                                      4
#define HWIO_UMCMN_R0_ISR_S16_MXI_GXI_AXI_WR_ERR_BMSK                                                  0x8
#define HWIO_UMCMN_R0_ISR_S16_MXI_GXI_AXI_WR_ERR_SHFT                                                    3
#define HWIO_UMCMN_R0_ISR_S16_MXI_GXI_AXI_RD_ERR_BMSK                                                  0x4
#define HWIO_UMCMN_R0_ISR_S16_MXI_GXI_AXI_RD_ERR_SHFT                                                    2
#define HWIO_UMCMN_R0_ISR_S16_MXI_GXI_LAST_WR_ERR_BMSK                                                 0x2
#define HWIO_UMCMN_R0_ISR_S16_MXI_GXI_LAST_WR_ERR_SHFT                                                   1
#define HWIO_UMCMN_R0_ISR_S16_MXI_GXI_WDTO_WAR_BMSK                                                    0x1
#define HWIO_UMCMN_R0_ISR_S16_MXI_GXI_WDTO_WAR_SHFT                                                      0

#define HWIO_UMCMN_R0_ISR_S17_ADDR(x)                                                           ((x) + 0x78)
#define HWIO_UMCMN_R0_ISR_S17_PHYS(x)                                                           ((x) + 0x78)
#define HWIO_UMCMN_R0_ISR_S17_OFFS                                                              (0x78)
#define HWIO_UMCMN_R0_ISR_S17_RMSK                                                                  0xffff
#define HWIO_UMCMN_R0_ISR_S17_POR                                                               0x00000000
#define HWIO_UMCMN_R0_ISR_S17_POR_RMSK                                                          0xffffffff
#define HWIO_UMCMN_R0_ISR_S17_ATTR                                                                           0x0
#define HWIO_UMCMN_R0_ISR_S17_IN(x)            \
                in_dword(HWIO_UMCMN_R0_ISR_S17_ADDR(x))
#define HWIO_UMCMN_R0_ISR_S17_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_ISR_S17_ADDR(x), m)
#define HWIO_UMCMN_R0_ISR_S17_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_ISR_S17_ADDR(x),v)
#define HWIO_UMCMN_R0_ISR_S17_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_ISR_S17_ADDR(x),m,v,HWIO_UMCMN_R0_ISR_S17_IN(x))
#define HWIO_UMCMN_R0_ISR_S17_WBM2WBM_OUT2_MLO_P_WATCHDOG_ERR_INT_BMSK                              0x8000
#define HWIO_UMCMN_R0_ISR_S17_WBM2WBM_OUT2_MLO_P_WATCHDOG_ERR_INT_SHFT                                  15
#define HWIO_UMCMN_R0_ISR_S17_WBM2WBM_OUT1_MLO_P_WATCHDOG_ERR_INT_BMSK                              0x4000
#define HWIO_UMCMN_R0_ISR_S17_WBM2WBM_OUT1_MLO_P_WATCHDOG_ERR_INT_SHFT                                  14
#define HWIO_UMCMN_R0_ISR_S17_WBM2WBM_OUT2_RING_REQ_ERROR_INTR_BMSK                                 0x2000
#define HWIO_UMCMN_R0_ISR_S17_WBM2WBM_OUT2_RING_REQ_ERROR_INTR_SHFT                                     13
#define HWIO_UMCMN_R0_ISR_S17_WBM2WBM_OUT1_RING_REQ_ERROR_INTR_BMSK                                 0x1000
#define HWIO_UMCMN_R0_ISR_S17_WBM2WBM_OUT1_RING_REQ_ERROR_INTR_SHFT                                     12
#define HWIO_UMCMN_R0_ISR_S17_WBM2WBM_OUT2_RING_WATCHDOG_ERR_INTR_BMSK                               0x800
#define HWIO_UMCMN_R0_ISR_S17_WBM2WBM_OUT2_RING_WATCHDOG_ERR_INTR_SHFT                                  11
#define HWIO_UMCMN_R0_ISR_S17_WBM2WBM_OUT1_RING_WATCHDOG_ERR_INTR_BMSK                               0x400
#define HWIO_UMCMN_R0_ISR_S17_WBM2WBM_OUT1_RING_WATCHDOG_ERR_INTR_SHFT                                  10
#define HWIO_UMCMN_R0_ISR_S17_WBM2WBM_IN2_RING_WATCHDOG_ERR_INTR_BMSK                                0x200
#define HWIO_UMCMN_R0_ISR_S17_WBM2WBM_IN2_RING_WATCHDOG_ERR_INTR_SHFT                                    9
#define HWIO_UMCMN_R0_ISR_S17_WBM2WBM_IN1_RING_WATCHDOG_ERR_INTR_BMSK                                0x100
#define HWIO_UMCMN_R0_ISR_S17_WBM2WBM_IN1_RING_WATCHDOG_ERR_INTR_SHFT                                    8
#define HWIO_UMCMN_R0_ISR_S17_WBM2WBM_IN2_RING_REQ_ERROR_INTR_BMSK                                    0x80
#define HWIO_UMCMN_R0_ISR_S17_WBM2WBM_IN2_RING_REQ_ERROR_INTR_SHFT                                       7
#define HWIO_UMCMN_R0_ISR_S17_WBM2WBM_IN1_RING_REQ_ERROR_INTR_BMSK                                    0x40
#define HWIO_UMCMN_R0_ISR_S17_WBM2WBM_IN1_RING_REQ_ERROR_INTR_SHFT                                       6
#define HWIO_UMCMN_R0_ISR_S17_WBM2WBM_OUT2_FETCH_POINTER_ERR_INTR_BMSK                                0x20
#define HWIO_UMCMN_R0_ISR_S17_WBM2WBM_OUT2_FETCH_POINTER_ERR_INTR_SHFT                                   5
#define HWIO_UMCMN_R0_ISR_S17_WBM2WBM_OUT1_FETCH_POINTER_ERR_INTR_BMSK                                0x10
#define HWIO_UMCMN_R0_ISR_S17_WBM2WBM_OUT1_FETCH_POINTER_ERR_INTR_SHFT                                   4
#define HWIO_UMCMN_R0_ISR_S17_WBM2WBM_IN2_FETCH_POINTER_ERR_INTR_BMSK                                  0x8
#define HWIO_UMCMN_R0_ISR_S17_WBM2WBM_IN2_FETCH_POINTER_ERR_INTR_SHFT                                    3
#define HWIO_UMCMN_R0_ISR_S17_WBM2WBM_IN1_FETCH_POINTER_ERR_INTR_BMSK                                  0x4
#define HWIO_UMCMN_R0_ISR_S17_WBM2WBM_IN1_FETCH_POINTER_ERR_INTR_SHFT                                    2
#define HWIO_UMCMN_R0_ISR_S17_SW1_RELEASE_RING_REQ_ERROR_INTR_BMSK                                     0x2
#define HWIO_UMCMN_R0_ISR_S17_SW1_RELEASE_RING_REQ_ERROR_INTR_SHFT                                       1
#define HWIO_UMCMN_R0_ISR_S17_SW1_RELEASE_RING_WATCHDOG_ERR_INTR_BMSK                                  0x1
#define HWIO_UMCMN_R0_ISR_S17_SW1_RELEASE_RING_WATCHDOG_ERR_INTR_SHFT                                    0

#define HWIO_UMCMN_R0_IMR_P_ADDR(x)                                                             ((x) + 0x7c)
#define HWIO_UMCMN_R0_IMR_P_PHYS(x)                                                             ((x) + 0x7c)
#define HWIO_UMCMN_R0_IMR_P_OFFS                                                                (0x7c)
#define HWIO_UMCMN_R0_IMR_P_RMSK                                                                   0x3fffd
#define HWIO_UMCMN_R0_IMR_P_POR                                                                 0x00000000
#define HWIO_UMCMN_R0_IMR_P_POR_RMSK                                                            0xffffffff
#define HWIO_UMCMN_R0_IMR_P_ATTR                                                                             0x3
#define HWIO_UMCMN_R0_IMR_P_IN(x)            \
                in_dword(HWIO_UMCMN_R0_IMR_P_ADDR(x))
#define HWIO_UMCMN_R0_IMR_P_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_IMR_P_ADDR(x), m)
#define HWIO_UMCMN_R0_IMR_P_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_IMR_P_ADDR(x),v)
#define HWIO_UMCMN_R0_IMR_P_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_IMR_P_ADDR(x),m,v,HWIO_UMCMN_R0_IMR_P_IN(x))
#define HWIO_UMCMN_R0_IMR_P_GXI_BMSK                                                               0x20000
#define HWIO_UMCMN_R0_IMR_P_GXI_SHFT                                                                    17
#define HWIO_UMCMN_R0_IMR_P_TQM2_BMSK                                                              0x10000
#define HWIO_UMCMN_R0_IMR_P_TQM2_SHFT                                                                   16
#define HWIO_UMCMN_R0_IMR_P_TQM1_BMSK                                                               0x8000
#define HWIO_UMCMN_R0_IMR_P_TQM1_SHFT                                                                   15
#define HWIO_UMCMN_R0_IMR_P_TQM0_BMSK                                                               0x4000
#define HWIO_UMCMN_R0_IMR_P_TQM0_SHFT                                                                   14
#define HWIO_UMCMN_R0_IMR_P_TCL1_BMSK                                                               0x2000
#define HWIO_UMCMN_R0_IMR_P_TCL1_SHFT                                                                   13
#define HWIO_UMCMN_R0_IMR_P_TCL0_BMSK                                                               0x1000
#define HWIO_UMCMN_R0_IMR_P_TCL0_SHFT                                                                   12
#define HWIO_UMCMN_R0_IMR_P_REO4_BMSK                                                                0x800
#define HWIO_UMCMN_R0_IMR_P_REO4_SHFT                                                                   11
#define HWIO_UMCMN_R0_IMR_P_REO3_BMSK                                                                0x400
#define HWIO_UMCMN_R0_IMR_P_REO3_SHFT                                                                   10
#define HWIO_UMCMN_R0_IMR_P_REO2_BMSK                                                                0x200
#define HWIO_UMCMN_R0_IMR_P_REO2_SHFT                                                                    9
#define HWIO_UMCMN_R0_IMR_P_REO1_BMSK                                                                0x100
#define HWIO_UMCMN_R0_IMR_P_REO1_SHFT                                                                    8
#define HWIO_UMCMN_R0_IMR_P_REO0_BMSK                                                                 0x80
#define HWIO_UMCMN_R0_IMR_P_REO0_SHFT                                                                    7
#define HWIO_UMCMN_R0_IMR_P_WBM3_BMSK                                                                 0x40
#define HWIO_UMCMN_R0_IMR_P_WBM3_SHFT                                                                    6
#define HWIO_UMCMN_R0_IMR_P_WBM2_BMSK                                                                 0x20
#define HWIO_UMCMN_R0_IMR_P_WBM2_SHFT                                                                    5
#define HWIO_UMCMN_R0_IMR_P_WBM1_BMSK                                                                 0x10
#define HWIO_UMCMN_R0_IMR_P_WBM1_SHFT                                                                    4
#define HWIO_UMCMN_R0_IMR_P_WBM0_BMSK                                                                  0x8
#define HWIO_UMCMN_R0_IMR_P_WBM0_SHFT                                                                    3
#define HWIO_UMCMN_R0_IMR_P_MEM_BMSK                                                                   0x4
#define HWIO_UMCMN_R0_IMR_P_MEM_SHFT                                                                     2
#define HWIO_UMCMN_R0_IMR_P_APB_BMSK                                                                   0x1
#define HWIO_UMCMN_R0_IMR_P_APB_SHFT                                                                     0

#define HWIO_UMCMN_R0_IMR_S0_ADDR(x)                                                            ((x) + 0x80)
#define HWIO_UMCMN_R0_IMR_S0_PHYS(x)                                                            ((x) + 0x80)
#define HWIO_UMCMN_R0_IMR_S0_OFFS                                                               (0x80)
#define HWIO_UMCMN_R0_IMR_S0_RMSK                                                                0x71fffff
#define HWIO_UMCMN_R0_IMR_S0_POR                                                                0x00000000
#define HWIO_UMCMN_R0_IMR_S0_POR_RMSK                                                           0xffffffff
#define HWIO_UMCMN_R0_IMR_S0_ATTR                                                                            0x3
#define HWIO_UMCMN_R0_IMR_S0_IN(x)            \
                in_dword(HWIO_UMCMN_R0_IMR_S0_ADDR(x))
#define HWIO_UMCMN_R0_IMR_S0_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_IMR_S0_ADDR(x), m)
#define HWIO_UMCMN_R0_IMR_S0_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_IMR_S0_ADDR(x),v)
#define HWIO_UMCMN_R0_IMR_S0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_IMR_S0_ADDR(x),m,v,HWIO_UMCMN_R0_IMR_S0_IN(x))
#define HWIO_UMCMN_R0_IMR_S0_MXI_APB_RD_INVALID_BMSK                                             0x4000000
#define HWIO_UMCMN_R0_IMR_S0_MXI_APB_RD_INVALID_SHFT                                                    26
#define HWIO_UMCMN_R0_IMR_S0_MXI_APB_WR_INVALID_BMSK                                             0x2000000
#define HWIO_UMCMN_R0_IMR_S0_MXI_APB_WR_INVALID_SHFT                                                    25
#define HWIO_UMCMN_R0_IMR_S0_MXI_APB_WR_TO_RD_INVALID_BMSK                                       0x1000000
#define HWIO_UMCMN_R0_IMR_S0_MXI_APB_WR_TO_RD_INVALID_SHFT                                              24
#define HWIO_UMCMN_R0_IMR_S0_UMCMN_APB_RD_INVALID_BMSK                                            0x100000
#define HWIO_UMCMN_R0_IMR_S0_UMCMN_APB_RD_INVALID_SHFT                                                  20
#define HWIO_UMCMN_R0_IMR_S0_UMCMN_APB_WR_INVALID_BMSK                                             0x80000
#define HWIO_UMCMN_R0_IMR_S0_UMCMN_APB_WR_INVALID_SHFT                                                  19
#define HWIO_UMCMN_R0_IMR_S0_UMCMN_APB_WR_TO_RD_INVALID_BMSK                                       0x40000
#define HWIO_UMCMN_R0_IMR_S0_UMCMN_APB_WR_TO_RD_INVALID_SHFT                                            18
#define HWIO_UMCMN_R0_IMR_S0_TQM_APB_RD_INVALID_BMSK                                               0x20000
#define HWIO_UMCMN_R0_IMR_S0_TQM_APB_RD_INVALID_SHFT                                                    17
#define HWIO_UMCMN_R0_IMR_S0_TQM_APB_WR_INVALID_BMSK                                               0x10000
#define HWIO_UMCMN_R0_IMR_S0_TQM_APB_WR_INVALID_SHFT                                                    16
#define HWIO_UMCMN_R0_IMR_S0_TQM_APB_WR_TO_RD_INVALID_BMSK                                          0x8000
#define HWIO_UMCMN_R0_IMR_S0_TQM_APB_WR_TO_RD_INVALID_SHFT                                              15
#define HWIO_UMCMN_R0_IMR_S0_CMN_PRSR_APB_RD_INVALID_BMSK                                           0x4000
#define HWIO_UMCMN_R0_IMR_S0_CMN_PRSR_APB_RD_INVALID_SHFT                                               14
#define HWIO_UMCMN_R0_IMR_S0_CMN_PRSR_APB_WR_INVALID_BMSK                                           0x2000
#define HWIO_UMCMN_R0_IMR_S0_CMN_PRSR_APB_WR_INVALID_SHFT                                               13
#define HWIO_UMCMN_R0_IMR_S0_CMN_PRSR_APB_WR_TO_RD_INVALID_BMSK                                     0x1000
#define HWIO_UMCMN_R0_IMR_S0_CMN_PRSR_APB_WR_TO_RD_INVALID_SHFT                                         12
#define HWIO_UMCMN_R0_IMR_S0_CCE_APB_RD_INVALID_BMSK                                                 0x800
#define HWIO_UMCMN_R0_IMR_S0_CCE_APB_RD_INVALID_SHFT                                                    11
#define HWIO_UMCMN_R0_IMR_S0_CCE_APB_WR_INVALID_BMSK                                                 0x400
#define HWIO_UMCMN_R0_IMR_S0_CCE_APB_WR_INVALID_SHFT                                                    10
#define HWIO_UMCMN_R0_IMR_S0_CCE_APB_WR_TO_RD_INVALID_BMSK                                           0x200
#define HWIO_UMCMN_R0_IMR_S0_CCE_APB_WR_TO_RD_INVALID_SHFT                                               9
#define HWIO_UMCMN_R0_IMR_S0_WBM_APB_RD_INVALID_BMSK                                                 0x100
#define HWIO_UMCMN_R0_IMR_S0_WBM_APB_RD_INVALID_SHFT                                                     8
#define HWIO_UMCMN_R0_IMR_S0_WBM_APB_WR_INVALID_BMSK                                                  0x80
#define HWIO_UMCMN_R0_IMR_S0_WBM_APB_WR_INVALID_SHFT                                                     7
#define HWIO_UMCMN_R0_IMR_S0_WBM_APB_WR_TO_RD_INVALID_BMSK                                            0x40
#define HWIO_UMCMN_R0_IMR_S0_WBM_APB_WR_TO_RD_INVALID_SHFT                                               6
#define HWIO_UMCMN_R0_IMR_S0_TCL_APB_RD_INVALID_BMSK                                                  0x20
#define HWIO_UMCMN_R0_IMR_S0_TCL_APB_RD_INVALID_SHFT                                                     5
#define HWIO_UMCMN_R0_IMR_S0_TCL_APB_WR_INVALID_BMSK                                                  0x10
#define HWIO_UMCMN_R0_IMR_S0_TCL_APB_WR_INVALID_SHFT                                                     4
#define HWIO_UMCMN_R0_IMR_S0_TCL_APB_WR_TO_RD_INVALID_BMSK                                             0x8
#define HWIO_UMCMN_R0_IMR_S0_TCL_APB_WR_TO_RD_INVALID_SHFT                                               3
#define HWIO_UMCMN_R0_IMR_S0_REO_APB_RD_INVALID_BMSK                                                   0x4
#define HWIO_UMCMN_R0_IMR_S0_REO_APB_RD_INVALID_SHFT                                                     2
#define HWIO_UMCMN_R0_IMR_S0_REO_APB_WR_INVALID_BMSK                                                   0x2
#define HWIO_UMCMN_R0_IMR_S0_REO_APB_WR_INVALID_SHFT                                                     1
#define HWIO_UMCMN_R0_IMR_S0_REO_APB_WR_TO_RD_INVALID_BMSK                                             0x1
#define HWIO_UMCMN_R0_IMR_S0_REO_APB_WR_TO_RD_INVALID_SHFT                                               0

#define HWIO_UMCMN_R0_IMR_S2_ADDR(x)                                                            ((x) + 0x84)
#define HWIO_UMCMN_R0_IMR_S2_PHYS(x)                                                            ((x) + 0x84)
#define HWIO_UMCMN_R0_IMR_S2_OFFS                                                               (0x84)
#define HWIO_UMCMN_R0_IMR_S2_RMSK                                                                      0xf
#define HWIO_UMCMN_R0_IMR_S2_POR                                                                0x00000000
#define HWIO_UMCMN_R0_IMR_S2_POR_RMSK                                                           0xffffffff
#define HWIO_UMCMN_R0_IMR_S2_ATTR                                                                            0x3
#define HWIO_UMCMN_R0_IMR_S2_IN(x)            \
                in_dword(HWIO_UMCMN_R0_IMR_S2_ADDR(x))
#define HWIO_UMCMN_R0_IMR_S2_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_IMR_S2_ADDR(x), m)
#define HWIO_UMCMN_R0_IMR_S2_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_IMR_S2_ADDR(x),v)
#define HWIO_UMCMN_R0_IMR_S2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_IMR_S2_ADDR(x),m,v,HWIO_UMCMN_R0_IMR_S2_IN(x))
#define HWIO_UMCMN_R0_IMR_S2_MEM_REMOTE_ACC_ERR_BMSK                                                   0x8
#define HWIO_UMCMN_R0_IMR_S2_MEM_REMOTE_ACC_ERR_SHFT                                                     3
#define HWIO_UMCMN_R0_IMR_S2_MEM_ACC_RANGE_ERR_BMSK                                                    0x4
#define HWIO_UMCMN_R0_IMR_S2_MEM_ACC_RANGE_ERR_SHFT                                                      2
#define HWIO_UMCMN_R0_IMR_S2_MEM_NON_SEC_ACC_ERR2_BMSK                                                 0x2
#define HWIO_UMCMN_R0_IMR_S2_MEM_NON_SEC_ACC_ERR2_SHFT                                                   1
#define HWIO_UMCMN_R0_IMR_S2_MEM_NON_SEC_ACC_ERR1_BMSK                                                 0x1
#define HWIO_UMCMN_R0_IMR_S2_MEM_NON_SEC_ACC_ERR1_SHFT                                                   0

#define HWIO_UMCMN_R0_IMR_S3_ADDR(x)                                                            ((x) + 0x88)
#define HWIO_UMCMN_R0_IMR_S3_PHYS(x)                                                            ((x) + 0x88)
#define HWIO_UMCMN_R0_IMR_S3_OFFS                                                               (0x88)
#define HWIO_UMCMN_R0_IMR_S3_RMSK                                                               0xffffffff
#define HWIO_UMCMN_R0_IMR_S3_POR                                                                0x00000000
#define HWIO_UMCMN_R0_IMR_S3_POR_RMSK                                                           0xffffffff
#define HWIO_UMCMN_R0_IMR_S3_ATTR                                                                            0x3
#define HWIO_UMCMN_R0_IMR_S3_IN(x)            \
                in_dword(HWIO_UMCMN_R0_IMR_S3_ADDR(x))
#define HWIO_UMCMN_R0_IMR_S3_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_IMR_S3_ADDR(x), m)
#define HWIO_UMCMN_R0_IMR_S3_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_IMR_S3_ADDR(x),v)
#define HWIO_UMCMN_R0_IMR_S3_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_IMR_S3_ADDR(x),m,v,HWIO_UMCMN_R0_IMR_S3_IN(x))
#define HWIO_UMCMN_R0_IMR_S3_MSDU_PARSER_DUP_DET_EVENT_INTR_BMSK                                0x80000000
#define HWIO_UMCMN_R0_IMR_S3_MSDU_PARSER_DUP_DET_EVENT_INTR_SHFT                                        31
#define HWIO_UMCMN_R0_IMR_S3_REL_PARSER_DUP_DET_EVENT_INTR_BMSK                                 0x40000000
#define HWIO_UMCMN_R0_IMR_S3_REL_PARSER_DUP_DET_EVENT_INTR_SHFT                                         30
#define HWIO_UMCMN_R0_IMR_S3_LINK_DIST_DUP_DET_EVENT_INTR_BMSK                                  0x20000000
#define HWIO_UMCMN_R0_IMR_S3_LINK_DIST_DUP_DET_EVENT_INTR_SHFT                                          29
#define HWIO_UMCMN_R0_IMR_S3_SW_COOKIE_IDLE_TIMEOUT_BMSK                                        0x10000000
#define HWIO_UMCMN_R0_IMR_S3_SW_COOKIE_IDLE_TIMEOUT_SHFT                                                28
#define HWIO_UMCMN_R0_IMR_S3_DELINK_B2B_DUPLI_PTR_INTR_BMSK                                      0x8000000
#define HWIO_UMCMN_R0_IMR_S3_DELINK_B2B_DUPLI_PTR_INTR_SHFT                                             27
#define HWIO_UMCMN_R0_IMR_S3_LINK_DIST_B2B_DUPLI_INTR_BMSK                                       0x4000000
#define HWIO_UMCMN_R0_IMR_S3_LINK_DIST_B2B_DUPLI_INTR_SHFT                                              26
#define HWIO_UMCMN_R0_IMR_S3_IDLE_SEQUENCE_WD_INTR_BMSK                                          0x2000000
#define HWIO_UMCMN_R0_IMR_S3_IDLE_SEQUENCE_WD_INTR_SHFT                                                 25
#define HWIO_UMCMN_R0_IMR_S3_WBM_VA_CONV_ERR_INT_BMSK                                            0x1000000
#define HWIO_UMCMN_R0_IMR_S3_WBM_VA_CONV_ERR_INT_SHFT                                                   24
#define HWIO_UMCMN_R0_IMR_S3_WBM_BP_WARN_INT_BMSK                                                 0x800000
#define HWIO_UMCMN_R0_IMR_S3_WBM_BP_WARN_INT_SHFT                                                       23
#define HWIO_UMCMN_R0_IMR_S3_WBM_SW6_BUF_PROD_WDG_BMSK                                            0x400000
#define HWIO_UMCMN_R0_IMR_S3_WBM_SW6_BUF_PROD_WDG_SHFT                                                  22
#define HWIO_UMCMN_R0_IMR_S3_WBM_SW5_BUF_PROD_WDG_BMSK                                            0x200000
#define HWIO_UMCMN_R0_IMR_S3_WBM_SW5_BUF_PROD_WDG_SHFT                                                  21
#define HWIO_UMCMN_R0_IMR_S3_WBM_SW4_BUF_PROD_WDG_BMSK                                            0x100000
#define HWIO_UMCMN_R0_IMR_S3_WBM_SW4_BUF_PROD_WDG_SHFT                                                  20
#define HWIO_UMCMN_R0_IMR_S3_WBM_ERROR_BUF_PROD_WDG_BMSK                                           0x80000
#define HWIO_UMCMN_R0_IMR_S3_WBM_ERROR_BUF_PROD_WDG_SHFT                                                19
#define HWIO_UMCMN_R0_IMR_S3_WBM_MSDU_PARSER_ERR_BMSK                                              0x70000
#define HWIO_UMCMN_R0_IMR_S3_WBM_MSDU_PARSER_ERR_SHFT                                                   16
#define HWIO_UMCMN_R0_IMR_S3_WBM_LINK_IDLE_LIST_SCAT_SRNG_ERR_BMSK                                  0x8000
#define HWIO_UMCMN_R0_IMR_S3_WBM_LINK_IDLE_LIST_SCAT_SRNG_ERR_SHFT                                      15
#define HWIO_UMCMN_R0_IMR_S3_WBM_LINK_IDLE_LIST_SCAT_SRNG_WDG_BMSK                                  0x4000
#define HWIO_UMCMN_R0_IMR_S3_WBM_LINK_IDLE_LIST_SCAT_SRNG_WDG_SHFT                                      14
#define HWIO_UMCMN_R0_IMR_S3_WBM_BUF_IDLE_LIST_SCAT_SRNG_ERR_BMSK                                   0x2000
#define HWIO_UMCMN_R0_IMR_S3_WBM_BUF_IDLE_LIST_SCAT_SRNG_ERR_SHFT                                       13
#define HWIO_UMCMN_R0_IMR_S3_WBM_BUF_IDLE_LIST_SCAT_SRNG_WDG_BMSK                                   0x1000
#define HWIO_UMCMN_R0_IMR_S3_WBM_BUF_IDLE_LIST_SCAT_SRNG_WDG_SHFT                                       12
#define HWIO_UMCMN_R0_IMR_S3_WBM_MSDU_DELINK_PARSE_ERR_BMSK                                          0x800
#define HWIO_UMCMN_R0_IMR_S3_WBM_MSDU_DELINK_PARSE_ERR_SHFT                                             11
#define HWIO_UMCMN_R0_IMR_S3_WBM_MSDU_DELINK_WDG_BMSK                                                0x400
#define HWIO_UMCMN_R0_IMR_S3_WBM_MSDU_DELINK_WDG_SHFT                                                   10
#define HWIO_UMCMN_R0_IMR_S3_WBM_LNK_IDLE_LIST_DIST_C_WDG_BMSK                                       0x200
#define HWIO_UMCMN_R0_IMR_S3_WBM_LNK_IDLE_LIST_DIST_C_WDG_SHFT                                           9
#define HWIO_UMCMN_R0_IMR_S3_WBM_LNK_IDLE_LIST_DIST_P_WDG_BMSK                                       0x100
#define HWIO_UMCMN_R0_IMR_S3_WBM_LNK_IDLE_LIST_DIST_P_WDG_SHFT                                           8
#define HWIO_UMCMN_R0_IMR_S3_WBM_FW_BUF_PROD_WDG_BMSK                                                 0x80
#define HWIO_UMCMN_R0_IMR_S3_WBM_FW_BUF_PROD_WDG_SHFT                                                    7
#define HWIO_UMCMN_R0_IMR_S3_WBM_SW3_BUF_PROD_WDG_BMSK                                                0x40
#define HWIO_UMCMN_R0_IMR_S3_WBM_SW3_BUF_PROD_WDG_SHFT                                                   6
#define HWIO_UMCMN_R0_IMR_S3_WBM_SW2_BUF_PROD_WDG_BMSK                                                0x20
#define HWIO_UMCMN_R0_IMR_S3_WBM_SW2_BUF_PROD_WDG_SHFT                                                   5
#define HWIO_UMCMN_R0_IMR_S3_WBM_SW1_BUF_PROD_WDG_BMSK                                                0x10
#define HWIO_UMCMN_R0_IMR_S3_WBM_SW1_BUF_PROD_WDG_SHFT                                                   4
#define HWIO_UMCMN_R0_IMR_S3_WBM_SW0_BUF_PROD_WDG_BMSK                                                 0x8
#define HWIO_UMCMN_R0_IMR_S3_WBM_SW0_BUF_PROD_WDG_SHFT                                                   3
#define HWIO_UMCMN_R0_IMR_S3_WBM_LNK_IDLE_LIST_PROD_WDG_BMSK                                           0x4
#define HWIO_UMCMN_R0_IMR_S3_WBM_LNK_IDLE_LIST_PROD_WDG_SHFT                                             2
#define HWIO_UMCMN_R0_IMR_S3_WBM_REL_REQ_PARSER_C_WDG_BMSK                                             0x2
#define HWIO_UMCMN_R0_IMR_S3_WBM_REL_REQ_PARSER_C_WDG_SHFT                                               1
#define HWIO_UMCMN_R0_IMR_S3_WBM_REL_REQ_PARSER_P_WDG_BMSK                                             0x1
#define HWIO_UMCMN_R0_IMR_S3_WBM_REL_REQ_PARSER_P_WDG_SHFT                                               0

#define HWIO_UMCMN_R0_IMR_S4_ADDR(x)                                                            ((x) + 0x8c)
#define HWIO_UMCMN_R0_IMR_S4_PHYS(x)                                                            ((x) + 0x8c)
#define HWIO_UMCMN_R0_IMR_S4_OFFS                                                               (0x8c)
#define HWIO_UMCMN_R0_IMR_S4_RMSK                                                               0xffffffff
#define HWIO_UMCMN_R0_IMR_S4_POR                                                                0x00000000
#define HWIO_UMCMN_R0_IMR_S4_POR_RMSK                                                           0xffffffff
#define HWIO_UMCMN_R0_IMR_S4_ATTR                                                                            0x3
#define HWIO_UMCMN_R0_IMR_S4_IN(x)            \
                in_dword(HWIO_UMCMN_R0_IMR_S4_ADDR(x))
#define HWIO_UMCMN_R0_IMR_S4_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_IMR_S4_ADDR(x), m)
#define HWIO_UMCMN_R0_IMR_S4_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_IMR_S4_ADDR(x),v)
#define HWIO_UMCMN_R0_IMR_S4_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_IMR_S4_ADDR(x),m,v,HWIO_UMCMN_R0_IMR_S4_IN(x))
#define HWIO_UMCMN_R0_IMR_S4_WBM2SW6_RELEASE_RING_WDG_ERR_BMSK                                  0x80000000
#define HWIO_UMCMN_R0_IMR_S4_WBM2SW6_RELEASE_RING_WDG_ERR_SHFT                                          31
#define HWIO_UMCMN_R0_IMR_S4_WBM2SW5_RELEASE_RING_WDG_ERR_BMSK                                  0x40000000
#define HWIO_UMCMN_R0_IMR_S4_WBM2SW5_RELEASE_RING_WDG_ERR_SHFT                                          30
#define HWIO_UMCMN_R0_IMR_S4_WBM2ERROR_RELEASE_RING_WDG_ERR_BMSK                                0x20000000
#define HWIO_UMCMN_R0_IMR_S4_WBM2ERROR_RELEASE_RING_WDG_ERR_SHFT                                        29
#define HWIO_UMCMN_R0_IMR_S4_WBM2SW4_RELEASE_RING_WDG_ERR_BMSK                                  0x10000000
#define HWIO_UMCMN_R0_IMR_S4_WBM2SW4_RELEASE_RING_WDG_ERR_SHFT                                          28
#define HWIO_UMCMN_R0_IMR_S4_WBM2SW3_RELEASE_RING_WDG_ERR_BMSK                                   0x8000000
#define HWIO_UMCMN_R0_IMR_S4_WBM2SW3_RELEASE_RING_WDG_ERR_SHFT                                          27
#define HWIO_UMCMN_R0_IMR_S4_WBM2SW2_RELEASE_RING_WDG_ERR_BMSK                                   0x4000000
#define HWIO_UMCMN_R0_IMR_S4_WBM2SW2_RELEASE_RING_WDG_ERR_SHFT                                          26
#define HWIO_UMCMN_R0_IMR_S4_WBM2SW1_RELEASE_RING_WDG_ERR_BMSK                                   0x2000000
#define HWIO_UMCMN_R0_IMR_S4_WBM2SW1_RELEASE_RING_WDG_ERR_SHFT                                          25
#define HWIO_UMCMN_R0_IMR_S4_WBM2SW0_RELEASE_RING_WDG_ERR_BMSK                                   0x1000000
#define HWIO_UMCMN_R0_IMR_S4_WBM2SW0_RELEASE_RING_WDG_ERR_SHFT                                          24
#define HWIO_UMCMN_R0_IMR_S4_WBM2FW_RELEASE_RING_WDG_ERR_BMSK                                     0x800000
#define HWIO_UMCMN_R0_IMR_S4_WBM2FW_RELEASE_RING_WDG_ERR_SHFT                                           23
#define HWIO_UMCMN_R0_IMR_S4_WBM_IDLE_LINK_RING_WDG_ERR_BMSK                                      0x400000
#define HWIO_UMCMN_R0_IMR_S4_WBM_IDLE_LINK_RING_WDG_ERR_SHFT                                            22
#define HWIO_UMCMN_R0_IMR_S4_WBM_IDLE_BUF_RING_WDG_ERR_BMSK                                       0x200000
#define HWIO_UMCMN_R0_IMR_S4_WBM_IDLE_BUF_RING_WDG_ERR_SHFT                                             21
#define HWIO_UMCMN_R0_IMR_S4_WBM2RXDMA2_LINK_RING_WDG_ERR_BMSK                                    0x100000
#define HWIO_UMCMN_R0_IMR_S4_WBM2RXDMA2_LINK_RING_WDG_ERR_SHFT                                          20
#define HWIO_UMCMN_R0_IMR_S4_WBM2RXDMA1_LINK_RING_WDG_ERR_BMSK                                     0x80000
#define HWIO_UMCMN_R0_IMR_S4_WBM2RXDMA1_LINK_RING_WDG_ERR_SHFT                                          19
#define HWIO_UMCMN_R0_IMR_S4_WBM2RXDMA0_LINK_RING_WDG_ERR_BMSK                                     0x40000
#define HWIO_UMCMN_R0_IMR_S4_WBM2RXDMA0_LINK_RING_WDG_ERR_SHFT                                          18
#define HWIO_UMCMN_R0_IMR_S4_WBM2FW_LINK_RING_WDG_ERR_BMSK                                         0x20000
#define HWIO_UMCMN_R0_IMR_S4_WBM2FW_LINK_RING_WDG_ERR_SHFT                                              17
#define HWIO_UMCMN_R0_IMR_S4_WBM2SW_LINK_RING_WDG_ERR_BMSK                                         0x10000
#define HWIO_UMCMN_R0_IMR_S4_WBM2SW_LINK_RING_WDG_ERR_SHFT                                              16
#define HWIO_UMCMN_R0_IMR_S4_WBM2REO_LINK_RING_WDG_ERR_BMSK                                         0x8000
#define HWIO_UMCMN_R0_IMR_S4_WBM2REO_LINK_RING_WDG_ERR_SHFT                                             15
#define HWIO_UMCMN_R0_IMR_S4_WBM2TQM_LINK_RING_WDG_ERR_BMSK                                         0x4000
#define HWIO_UMCMN_R0_IMR_S4_WBM2TQM_LINK_RING_WDG_ERR_SHFT                                             14
#define HWIO_UMCMN_R0_IMR_S4_WBM2RXDMA2_BUF_RING_WDG_ERR_BMSK                                       0x2000
#define HWIO_UMCMN_R0_IMR_S4_WBM2RXDMA2_BUF_RING_WDG_ERR_SHFT                                           13
#define HWIO_UMCMN_R0_IMR_S4_WBM2RXDMA1_BUF_RING_WDG_ERR_BMSK                                       0x1000
#define HWIO_UMCMN_R0_IMR_S4_WBM2RXDMA1_BUF_RING_WDG_ERR_SHFT                                           12
#define HWIO_UMCMN_R0_IMR_S4_WBM2RXDMA0_BUF_RING_WDG_ERR_BMSK                                        0x800
#define HWIO_UMCMN_R0_IMR_S4_WBM2RXDMA0_BUF_RING_WDG_ERR_SHFT                                           11
#define HWIO_UMCMN_R0_IMR_S4_WBM2FW_BUF_RING_WDG_ERR_BMSK                                            0x400
#define HWIO_UMCMN_R0_IMR_S4_WBM2FW_BUF_RING_WDG_ERR_SHFT                                               10
#define HWIO_UMCMN_R0_IMR_S4_WBM2SW_BUF_RING_WDG_ERR_BMSK                                            0x200
#define HWIO_UMCMN_R0_IMR_S4_WBM2SW_BUF_RING_WDG_ERR_SHFT                                                9
#define HWIO_UMCMN_R0_IMR_S4_WBM2PPE_BUF_RING_WDG_ERR_BMSK                                           0x100
#define HWIO_UMCMN_R0_IMR_S4_WBM2PPE_BUF_RING_WDG_ERR_SHFT                                               8
#define HWIO_UMCMN_R0_IMR_S4_RXDMA2_RELEASE_RING_WDG_ERR_BMSK                                         0x80
#define HWIO_UMCMN_R0_IMR_S4_RXDMA2_RELEASE_RING_WDG_ERR_SHFT                                            7
#define HWIO_UMCMN_R0_IMR_S4_RXDMA1_RELEASE_RING_WDG_ERR_BMSK                                         0x40
#define HWIO_UMCMN_R0_IMR_S4_RXDMA1_RELEASE_RING_WDG_ERR_SHFT                                            6
#define HWIO_UMCMN_R0_IMR_S4_RXDMA0_RELEASE_RING_WDG_ERR_BMSK                                         0x20
#define HWIO_UMCMN_R0_IMR_S4_RXDMA0_RELEASE_RING_WDG_ERR_SHFT                                            5
#define HWIO_UMCMN_R0_IMR_S4_FW_RELEASE_RING_WDG_ERR_BMSK                                             0x10
#define HWIO_UMCMN_R0_IMR_S4_FW_RELEASE_RING_WDG_ERR_SHFT                                                4
#define HWIO_UMCMN_R0_IMR_S4_SW_RELEASE_RING_WDG_ERR_BMSK                                              0x8
#define HWIO_UMCMN_R0_IMR_S4_SW_RELEASE_RING_WDG_ERR_SHFT                                                3
#define HWIO_UMCMN_R0_IMR_S4_REO_RELEASE_RING_WDG_ERR_BMSK                                             0x4
#define HWIO_UMCMN_R0_IMR_S4_REO_RELEASE_RING_WDG_ERR_SHFT                                               2
#define HWIO_UMCMN_R0_IMR_S4_TQM_RELEASE_RING_WDG_ERR_BMSK                                             0x2
#define HWIO_UMCMN_R0_IMR_S4_TQM_RELEASE_RING_WDG_ERR_SHFT                                               1
#define HWIO_UMCMN_R0_IMR_S4_PPE_RELEASE_RING_WDG_ERR_BMSK                                             0x1
#define HWIO_UMCMN_R0_IMR_S4_PPE_RELEASE_RING_WDG_ERR_SHFT                                               0

#define HWIO_UMCMN_R0_IMR_S5_ADDR(x)                                                            ((x) + 0x90)
#define HWIO_UMCMN_R0_IMR_S5_PHYS(x)                                                            ((x) + 0x90)
#define HWIO_UMCMN_R0_IMR_S5_OFFS                                                               (0x90)
#define HWIO_UMCMN_R0_IMR_S5_RMSK                                                               0xffffffff
#define HWIO_UMCMN_R0_IMR_S5_POR                                                                0x00000000
#define HWIO_UMCMN_R0_IMR_S5_POR_RMSK                                                           0xffffffff
#define HWIO_UMCMN_R0_IMR_S5_ATTR                                                                            0x3
#define HWIO_UMCMN_R0_IMR_S5_IN(x)            \
                in_dword(HWIO_UMCMN_R0_IMR_S5_ADDR(x))
#define HWIO_UMCMN_R0_IMR_S5_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_IMR_S5_ADDR(x), m)
#define HWIO_UMCMN_R0_IMR_S5_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_IMR_S5_ADDR(x),v)
#define HWIO_UMCMN_R0_IMR_S5_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_IMR_S5_ADDR(x),m,v,HWIO_UMCMN_R0_IMR_S5_IN(x))
#define HWIO_UMCMN_R0_IMR_S5_WBM2SW6_RELEASE_RING_REQ_ERR_BMSK                                  0x80000000
#define HWIO_UMCMN_R0_IMR_S5_WBM2SW6_RELEASE_RING_REQ_ERR_SHFT                                          31
#define HWIO_UMCMN_R0_IMR_S5_WBM2SW5_RELEASE_RING_REQ_ERR_BMSK                                  0x40000000
#define HWIO_UMCMN_R0_IMR_S5_WBM2SW5_RELEASE_RING_REQ_ERR_SHFT                                          30
#define HWIO_UMCMN_R0_IMR_S5_WBM2ERROR_RELEASE_RING_REQ_ERR_BMSK                                0x20000000
#define HWIO_UMCMN_R0_IMR_S5_WBM2ERROR_RELEASE_RING_REQ_ERR_SHFT                                        29
#define HWIO_UMCMN_R0_IMR_S5_WBM2SW4_RELEASE_RING_REQ_ERR_BMSK                                  0x10000000
#define HWIO_UMCMN_R0_IMR_S5_WBM2SW4_RELEASE_RING_REQ_ERR_SHFT                                          28
#define HWIO_UMCMN_R0_IMR_S5_WBM2SW3_RELEASE_RING_REQ_ERR_BMSK                                   0x8000000
#define HWIO_UMCMN_R0_IMR_S5_WBM2SW3_RELEASE_RING_REQ_ERR_SHFT                                          27
#define HWIO_UMCMN_R0_IMR_S5_WBM2SW2_RELEASE_RING_REQ_ERR_BMSK                                   0x4000000
#define HWIO_UMCMN_R0_IMR_S5_WBM2SW2_RELEASE_RING_REQ_ERR_SHFT                                          26
#define HWIO_UMCMN_R0_IMR_S5_WBM2SW1_RELEASE_RING_REQ_ERR_BMSK                                   0x2000000
#define HWIO_UMCMN_R0_IMR_S5_WBM2SW1_RELEASE_RING_REQ_ERR_SHFT                                          25
#define HWIO_UMCMN_R0_IMR_S5_WBM2SW0_RELEASE_RING_REQ_ERR_BMSK                                   0x1000000
#define HWIO_UMCMN_R0_IMR_S5_WBM2SW0_RELEASE_RING_REQ_ERR_SHFT                                          24
#define HWIO_UMCMN_R0_IMR_S5_WBM2FW_RELEASE_RING_REQ_ERR_BMSK                                     0x800000
#define HWIO_UMCMN_R0_IMR_S5_WBM2FW_RELEASE_RING_REQ_ERR_SHFT                                           23
#define HWIO_UMCMN_R0_IMR_S5_WBM_IDLE_LINK_RING_REQ_ERR_BMSK                                      0x400000
#define HWIO_UMCMN_R0_IMR_S5_WBM_IDLE_LINK_RING_REQ_ERR_SHFT                                            22
#define HWIO_UMCMN_R0_IMR_S5_WBM_IDLE_BUF_RING_REQ_ERR_BMSK                                       0x200000
#define HWIO_UMCMN_R0_IMR_S5_WBM_IDLE_BUF_RING_REQ_ERR_SHFT                                             21
#define HWIO_UMCMN_R0_IMR_S5_WBM2RXDMA2_LINK_RING_REQ_ERR_BMSK                                    0x100000
#define HWIO_UMCMN_R0_IMR_S5_WBM2RXDMA2_LINK_RING_REQ_ERR_SHFT                                          20
#define HWIO_UMCMN_R0_IMR_S5_WBM2RXDMA1_LINK_RING_REQ_ERR_BMSK                                     0x80000
#define HWIO_UMCMN_R0_IMR_S5_WBM2RXDMA1_LINK_RING_REQ_ERR_SHFT                                          19
#define HWIO_UMCMN_R0_IMR_S5_WBM2RXDMA0_LINK_RING_REQ_ERR_BMSK                                     0x40000
#define HWIO_UMCMN_R0_IMR_S5_WBM2RXDMA0_LINK_RING_REQ_ERR_SHFT                                          18
#define HWIO_UMCMN_R0_IMR_S5_WBM2FW_LINK_RING_REQ_ERR_BMSK                                         0x20000
#define HWIO_UMCMN_R0_IMR_S5_WBM2FW_LINK_RING_REQ_ERR_SHFT                                              17
#define HWIO_UMCMN_R0_IMR_S5_WBM2SW_LINK_RING_REQ_ERR_BMSK                                         0x10000
#define HWIO_UMCMN_R0_IMR_S5_WBM2SW_LINK_RING_REQ_ERR_SHFT                                              16
#define HWIO_UMCMN_R0_IMR_S5_WBM2REO_LINK_RING_REQ_ERR_BMSK                                         0x8000
#define HWIO_UMCMN_R0_IMR_S5_WBM2REO_LINK_RING_REQ_ERR_SHFT                                             15
#define HWIO_UMCMN_R0_IMR_S5_WBM2TQM_LINK_RING_REQ_ERR_BMSK                                         0x4000
#define HWIO_UMCMN_R0_IMR_S5_WBM2TQM_LINK_RING_REQ_ERR_SHFT                                             14
#define HWIO_UMCMN_R0_IMR_S5_WBM2RXDMA2_BUF_RING_REQ_ERR_BMSK                                       0x2000
#define HWIO_UMCMN_R0_IMR_S5_WBM2RXDMA2_BUF_RING_REQ_ERR_SHFT                                           13
#define HWIO_UMCMN_R0_IMR_S5_WBM2RXDMA1_BUF_RING_REQ_ERR_BMSK                                       0x1000
#define HWIO_UMCMN_R0_IMR_S5_WBM2RXDMA1_BUF_RING_REQ_ERR_SHFT                                           12
#define HWIO_UMCMN_R0_IMR_S5_WBM2RXDMA0_BUF_RING_REQ_ERR_BMSK                                        0x800
#define HWIO_UMCMN_R0_IMR_S5_WBM2RXDMA0_BUF_RING_REQ_ERR_SHFT                                           11
#define HWIO_UMCMN_R0_IMR_S5_WBM2FW_BUF_RING_REQ_ERR_BMSK                                            0x400
#define HWIO_UMCMN_R0_IMR_S5_WBM2FW_BUF_RING_REQ_ERR_SHFT                                               10
#define HWIO_UMCMN_R0_IMR_S5_WBM2SW_BUF_RING_REQ_ERR_BMSK                                            0x200
#define HWIO_UMCMN_R0_IMR_S5_WBM2SW_BUF_RING_REQ_ERR_SHFT                                                9
#define HWIO_UMCMN_R0_IMR_S5_WBM2PPE_BUF_RING_REQ_ERR_BMSK                                           0x100
#define HWIO_UMCMN_R0_IMR_S5_WBM2PPE_BUF_RING_REQ_ERR_SHFT                                               8
#define HWIO_UMCMN_R0_IMR_S5_RXDMA2_RELEASE_RING_REQ_ERR_BMSK                                         0x80
#define HWIO_UMCMN_R0_IMR_S5_RXDMA2_RELEASE_RING_REQ_ERR_SHFT                                            7
#define HWIO_UMCMN_R0_IMR_S5_RXDMA1_RELEASE_RING_REQ_ERR_BMSK                                         0x40
#define HWIO_UMCMN_R0_IMR_S5_RXDMA1_RELEASE_RING_REQ_ERR_SHFT                                            6
#define HWIO_UMCMN_R0_IMR_S5_RXDMA0_RELEASE_RING_REQ_ERR_BMSK                                         0x20
#define HWIO_UMCMN_R0_IMR_S5_RXDMA0_RELEASE_RING_REQ_ERR_SHFT                                            5
#define HWIO_UMCMN_R0_IMR_S5_FW_RELEASE_RING_REQ_ERR_BMSK                                             0x10
#define HWIO_UMCMN_R0_IMR_S5_FW_RELEASE_RING_REQ_ERR_SHFT                                                4
#define HWIO_UMCMN_R0_IMR_S5_SW_RELEASE_RING_REQ_ERR_BMSK                                              0x8
#define HWIO_UMCMN_R0_IMR_S5_SW_RELEASE_RING_REQ_ERR_SHFT                                                3
#define HWIO_UMCMN_R0_IMR_S5_REO_RELEASE_RING_REQ_ERR_BMSK                                             0x4
#define HWIO_UMCMN_R0_IMR_S5_REO_RELEASE_RING_REQ_ERR_SHFT                                               2
#define HWIO_UMCMN_R0_IMR_S5_TQM_RELEASE_RING_REQ_ERR_BMSK                                             0x2
#define HWIO_UMCMN_R0_IMR_S5_TQM_RELEASE_RING_REQ_ERR_SHFT                                               1
#define HWIO_UMCMN_R0_IMR_S5_PPE_RELEASE_RING_REQ_ERR_BMSK                                             0x1
#define HWIO_UMCMN_R0_IMR_S5_PPE_RELEASE_RING_REQ_ERR_SHFT                                               0

#define HWIO_UMCMN_R0_IMR_S6_ADDR(x)                                                            ((x) + 0x94)
#define HWIO_UMCMN_R0_IMR_S6_PHYS(x)                                                            ((x) + 0x94)
#define HWIO_UMCMN_R0_IMR_S6_OFFS                                                               (0x94)
#define HWIO_UMCMN_R0_IMR_S6_RMSK                                                                 0x3fffff
#define HWIO_UMCMN_R0_IMR_S6_POR                                                                0x00000000
#define HWIO_UMCMN_R0_IMR_S6_POR_RMSK                                                           0xffffffff
#define HWIO_UMCMN_R0_IMR_S6_ATTR                                                                            0x3
#define HWIO_UMCMN_R0_IMR_S6_IN(x)            \
                in_dword(HWIO_UMCMN_R0_IMR_S6_ADDR(x))
#define HWIO_UMCMN_R0_IMR_S6_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_IMR_S6_ADDR(x), m)
#define HWIO_UMCMN_R0_IMR_S6_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_IMR_S6_ADDR(x),v)
#define HWIO_UMCMN_R0_IMR_S6_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_IMR_S6_ADDR(x),m,v,HWIO_UMCMN_R0_IMR_S6_IN(x))
#define HWIO_UMCMN_R0_IMR_S6_REO2PPE_RING_WDG_BMSK                                                0x200000
#define HWIO_UMCMN_R0_IMR_S6_REO2PPE_RING_WDG_SHFT                                                      21
#define HWIO_UMCMN_R0_IMR_S6_REO2SW8_RING_WDG_BMSK                                                0x100000
#define HWIO_UMCMN_R0_IMR_S6_REO2SW8_RING_WDG_SHFT                                                      20
#define HWIO_UMCMN_R0_IMR_S6_REO2SW7_RING_WDG_BMSK                                                 0x80000
#define HWIO_UMCMN_R0_IMR_S6_REO2SW7_RING_WDG_SHFT                                                      19
#define HWIO_UMCMN_R0_IMR_S6_REO_STATUS_RING_WDG_BMSK                                              0x40000
#define HWIO_UMCMN_R0_IMR_S6_REO_STATUS_RING_WDG_SHFT                                                   18
#define HWIO_UMCMN_R0_IMR_S6_REO_RELEASE_RING_WDG_BMSK                                             0x20000
#define HWIO_UMCMN_R0_IMR_S6_REO_RELEASE_RING_WDG_SHFT                                                  17
#define HWIO_UMCMN_R0_IMR_S6_REO2FW_RING_WDG_BMSK                                                  0x10000
#define HWIO_UMCMN_R0_IMR_S6_REO2FW_RING_WDG_SHFT                                                       16
#define HWIO_UMCMN_R0_IMR_S6_REO2SW0_RING_WDG_BMSK                                                  0x8000
#define HWIO_UMCMN_R0_IMR_S6_REO2SW0_RING_WDG_SHFT                                                      15
#define HWIO_UMCMN_R0_IMR_S6_REO2SW6_RING_WDG_BMSK                                                  0x4000
#define HWIO_UMCMN_R0_IMR_S6_REO2SW6_RING_WDG_SHFT                                                      14
#define HWIO_UMCMN_R0_IMR_S6_REO2SW5_RING_WDG_BMSK                                                  0x2000
#define HWIO_UMCMN_R0_IMR_S6_REO2SW5_RING_WDG_SHFT                                                      13
#define HWIO_UMCMN_R0_IMR_S6_REO2SW4_RING_WDG_BMSK                                                  0x1000
#define HWIO_UMCMN_R0_IMR_S6_REO2SW4_RING_WDG_SHFT                                                      12
#define HWIO_UMCMN_R0_IMR_S6_REO2SW3_RING_WDG_BMSK                                                   0x800
#define HWIO_UMCMN_R0_IMR_S6_REO2SW3_RING_WDG_SHFT                                                      11
#define HWIO_UMCMN_R0_IMR_S6_REO2SW2_RING_WDG_BMSK                                                   0x400
#define HWIO_UMCMN_R0_IMR_S6_REO2SW2_RING_WDG_SHFT                                                      10
#define HWIO_UMCMN_R0_IMR_S6_REO2SW1_RING_WDG_BMSK                                                   0x200
#define HWIO_UMCMN_R0_IMR_S6_REO2SW1_RING_WDG_SHFT                                                       9
#define HWIO_UMCMN_R0_IMR_S6_SW2REO_RING_WDG_BMSK                                                    0x100
#define HWIO_UMCMN_R0_IMR_S6_SW2REO_RING_WDG_SHFT                                                        8
#define HWIO_UMCMN_R0_IMR_S6_SW2REO1_RING_WDG_BMSK                                                    0x80
#define HWIO_UMCMN_R0_IMR_S6_SW2REO1_RING_WDG_SHFT                                                       7
#define HWIO_UMCMN_R0_IMR_S6_SW2REO2_RING_WDG_BMSK                                                    0x40
#define HWIO_UMCMN_R0_IMR_S6_SW2REO2_RING_WDG_SHFT                                                       6
#define HWIO_UMCMN_R0_IMR_S6_SW2REO3_RING_WDG_BMSK                                                    0x20
#define HWIO_UMCMN_R0_IMR_S6_SW2REO3_RING_WDG_SHFT                                                       5
#define HWIO_UMCMN_R0_IMR_S6_REO_CMD_RING_WDG_BMSK                                                    0x10
#define HWIO_UMCMN_R0_IMR_S6_REO_CMD_RING_WDG_SHFT                                                       4
#define HWIO_UMCMN_R0_IMR_S6_WBM2REO_LINK_RING_WDG_BMSK                                                0x8
#define HWIO_UMCMN_R0_IMR_S6_WBM2REO_LINK_RING_WDG_SHFT                                                  3
#define HWIO_UMCMN_R0_IMR_S6_RXDMA2REO2_MLO_RING_WDG_BMSK                                              0x4
#define HWIO_UMCMN_R0_IMR_S6_RXDMA2REO2_MLO_RING_WDG_SHFT                                                2
#define HWIO_UMCMN_R0_IMR_S6_RXDMA2REO1_MLO_RING_WDG_BMSK                                              0x2
#define HWIO_UMCMN_R0_IMR_S6_RXDMA2REO1_MLO_RING_WDG_SHFT                                                1
#define HWIO_UMCMN_R0_IMR_S6_RXDMA2REO0_RING_WDG_BMSK                                                  0x1
#define HWIO_UMCMN_R0_IMR_S6_RXDMA2REO0_RING_WDG_SHFT                                                    0

#define HWIO_UMCMN_R0_IMR_S7_ADDR(x)                                                            ((x) + 0x98)
#define HWIO_UMCMN_R0_IMR_S7_PHYS(x)                                                            ((x) + 0x98)
#define HWIO_UMCMN_R0_IMR_S7_OFFS                                                               (0x98)
#define HWIO_UMCMN_R0_IMR_S7_RMSK                                                               0xffff000f
#define HWIO_UMCMN_R0_IMR_S7_POR                                                                0x00000000
#define HWIO_UMCMN_R0_IMR_S7_POR_RMSK                                                           0xffffffff
#define HWIO_UMCMN_R0_IMR_S7_ATTR                                                                            0x3
#define HWIO_UMCMN_R0_IMR_S7_IN(x)            \
                in_dword(HWIO_UMCMN_R0_IMR_S7_ADDR(x))
#define HWIO_UMCMN_R0_IMR_S7_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_IMR_S7_ADDR(x), m)
#define HWIO_UMCMN_R0_IMR_S7_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_IMR_S7_ADDR(x),v)
#define HWIO_UMCMN_R0_IMR_S7_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_IMR_S7_ADDR(x),m,v,HWIO_UMCMN_R0_IMR_S7_IN(x))
#define HWIO_UMCMN_R0_IMR_S7_REO_CACHE_INT_BMSK                                                 0xffff0000
#define HWIO_UMCMN_R0_IMR_S7_REO_CACHE_INT_SHFT                                                         16
#define HWIO_UMCMN_R0_IMR_S7_REO_AC_BUF_OVER_THRESH_BMSK                                               0xf
#define HWIO_UMCMN_R0_IMR_S7_REO_AC_BUF_OVER_THRESH_SHFT                                                 0

#define HWIO_UMCMN_R0_IMR_S8_ADDR(x)                                                            ((x) + 0x9c)
#define HWIO_UMCMN_R0_IMR_S8_PHYS(x)                                                            ((x) + 0x9c)
#define HWIO_UMCMN_R0_IMR_S8_OFFS                                                               (0x9c)
#define HWIO_UMCMN_R0_IMR_S8_RMSK                                                               0xffffffff
#define HWIO_UMCMN_R0_IMR_S8_POR                                                                0x00000000
#define HWIO_UMCMN_R0_IMR_S8_POR_RMSK                                                           0xffffffff
#define HWIO_UMCMN_R0_IMR_S8_ATTR                                                                            0x3
#define HWIO_UMCMN_R0_IMR_S8_IN(x)            \
                in_dword(HWIO_UMCMN_R0_IMR_S8_ADDR(x))
#define HWIO_UMCMN_R0_IMR_S8_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_IMR_S8_ADDR(x), m)
#define HWIO_UMCMN_R0_IMR_S8_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_IMR_S8_ADDR(x),v)
#define HWIO_UMCMN_R0_IMR_S8_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_IMR_S8_ADDR(x),m,v,HWIO_UMCMN_R0_IMR_S8_IN(x))
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_RESERVED_BMSK                                         0xfff00000
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_RESERVED_SHFT                                                 20
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_INVALID_TLV_CMD_BMSK                                     0x80000
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_INVALID_TLV_CMD_SHFT                                          19
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_RX_QUEUE_NUM_MISMATCH_BMSK                               0x40000
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_RX_QUEUE_NUM_MISMATCH_SHFT                                    18
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_REORDER_SW_ZERO_DESC_BMSK                                0x20000
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_REORDER_SW_ZERO_DESC_SHFT                                     17
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_REORDER_AGE_ZERO_DESC_BMSK                               0x10000
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_REORDER_AGE_ZERO_DESC_SHFT                                    16
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_REORDER_ZERO_MSDU_LINK_PTR_BMSK                           0x8000
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_REORDER_ZERO_MSDU_LINK_PTR_SHFT                               15
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_REORDER_ZERO_MPDU_LINK_PTR_BMSK                           0x4000
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_REORDER_ZERO_MPDU_LINK_PTR_SHFT                               14
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_SEQ_ZERO_MSDU_BUF_PTR_BMSK                                0x2000
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_SEQ_ZERO_MSDU_BUF_PTR_SHFT                                    13
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_DD_BA_NON_AMPDU_BMSK                                      0x1000
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_DD_BA_NON_AMPDU_SHFT                                          12
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_SEQ_PN_ERR_BMSK                                            0x800
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_SEQ_PN_ERR_SHFT                                               11
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_DD_BAR_SNEQUAL_BMSK                                        0x400
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_DD_BAR_SNEQUAL_SHFT                                           10
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_DD_BAR_NONBA_BMSK                                          0x200
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_DD_BAR_NONBA_SHFT                                              9
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_DD_OOR_BAR_BMSK                                            0x100
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_DD_OOR_BAR_SHFT                                                8
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_DD_OOR_REG_BMSK                                             0x80
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_DD_OOR_REG_SHFT                                                7
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_DD_2K_BAR_BMSK                                              0x40
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_DD_2K_BAR_SHFT                                                 6
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_DD_2K_REG_BMSK                                              0x20
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_DD_2K_REG_SHFT                                                 5
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_DD_BA_DD_BMSK                                               0x10
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_DD_BA_DD_SHFT                                                  4
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_DD_NONBA_DD_BMSK                                             0x8
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_DD_NONBA_DD_SHFT                                               3
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_DD_AMPDU_NONBA_BMSK                                          0x4
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_DD_AMPDU_NONBA_SHFT                                            2
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_DD_QD_NOTVALID_BMSK                                          0x2
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_DD_QD_NOTVALID_SHFT                                            1
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_REORDER_QD_ADDR_ZERO_BMSK                                    0x1
#define HWIO_UMCMN_R0_IMR_S8_REO_ERR_INTR_REORDER_QD_ADDR_ZERO_SHFT                                      0

#define HWIO_UMCMN_R0_IMR_S9_ADDR(x)                                                            ((x) + 0xa0)
#define HWIO_UMCMN_R0_IMR_S9_PHYS(x)                                                            ((x) + 0xa0)
#define HWIO_UMCMN_R0_IMR_S9_OFFS                                                               (0xa0)
#define HWIO_UMCMN_R0_IMR_S9_RMSK                                                                 0xffffff
#define HWIO_UMCMN_R0_IMR_S9_POR                                                                0x00000000
#define HWIO_UMCMN_R0_IMR_S9_POR_RMSK                                                           0xffffffff
#define HWIO_UMCMN_R0_IMR_S9_ATTR                                                                            0x3
#define HWIO_UMCMN_R0_IMR_S9_IN(x)            \
                in_dword(HWIO_UMCMN_R0_IMR_S9_ADDR(x))
#define HWIO_UMCMN_R0_IMR_S9_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_IMR_S9_ADDR(x), m)
#define HWIO_UMCMN_R0_IMR_S9_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_IMR_S9_ADDR(x),v)
#define HWIO_UMCMN_R0_IMR_S9_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_IMR_S9_ADDR(x),m,v,HWIO_UMCMN_R0_IMR_S9_IN(x))
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_BMSK                                            0xf00000
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_SHFT                                                  20
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_WARNING_INTR_BMSK                                    0x80000
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_WARNING_INTR_SHFT                                         19
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_HOST7_PROD_BMSK                                  0x40000
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_HOST7_PROD_SHFT                                       18
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_HOST6_PROD_BMSK                                  0x20000
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_HOST6_PROD_SHFT                                       17
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_HOST5_PROD_BMSK                                  0x10000
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_HOST5_PROD_SHFT                                       16
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_HOST4_PROD_BMSK                                   0x8000
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_HOST4_PROD_SHFT                                       15
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_STATUS_PROD_BMSK                                  0x4000
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_STATUS_PROD_SHFT                                      14
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_RELEASE_PROD_BMSK                                 0x2000
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_RELEASE_PROD_SHFT                                     13
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_WIFI_PROD_BMSK                                    0x1000
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_WIFI_PROD_SHFT                                        12
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_TCL_PROD_BMSK                                      0x800
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_TCL_PROD_SHFT                                         11
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_HOST3_PROD_BMSK                                    0x400
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_HOST3_PROD_SHFT                                       10
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_HOST2_PROD_BMSK                                    0x200
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_HOST2_PROD_SHFT                                        9
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_HOST1_PROD_BMSK                                    0x100
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_HOST1_PROD_SHFT                                        8
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_HOST0_PROD_BMSK                                     0x80
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_HOST0_PROD_SHFT                                        7
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_SEQUENCER_BMSK                                      0x40
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_SEQUENCER_SHFT                                         6
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_REORDER_BMSK                                        0x20
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_REORDER_SHFT                                           5
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_MPDU_LINK_PREFETCH_BMSK                             0x10
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_MPDU_LINK_PREFETCH_SHFT                                4
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_REO_CMD_TLV_BMSK                                     0x8
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_REO_CMD_TLV_SHFT                                       3
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_REO_CMD_PREFETCH_BMSK                                0x4
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_REO_CMD_PREFETCH_SHFT                                  2
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_REO_RING_PREFETCH_BMSK                               0x2
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_REO_RING_PREFETCH_SHFT                                 1
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_REO_RING_PREFETCH_READ_BMSK                          0x1
#define HWIO_UMCMN_R0_IMR_S9_REO_RESERVED_WDG_ERR_REO_RING_PREFETCH_READ_SHFT                            0

#define HWIO_UMCMN_R0_IMR_S10_ADDR(x)                                                           ((x) + 0xa4)
#define HWIO_UMCMN_R0_IMR_S10_PHYS(x)                                                           ((x) + 0xa4)
#define HWIO_UMCMN_R0_IMR_S10_OFFS                                                              (0xa4)
#define HWIO_UMCMN_R0_IMR_S10_RMSK                                                                 0x3ffff
#define HWIO_UMCMN_R0_IMR_S10_POR                                                               0x00000000
#define HWIO_UMCMN_R0_IMR_S10_POR_RMSK                                                          0xffffffff
#define HWIO_UMCMN_R0_IMR_S10_ATTR                                                                           0x3
#define HWIO_UMCMN_R0_IMR_S10_IN(x)            \
                in_dword(HWIO_UMCMN_R0_IMR_S10_ADDR(x))
#define HWIO_UMCMN_R0_IMR_S10_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_IMR_S10_ADDR(x), m)
#define HWIO_UMCMN_R0_IMR_S10_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_IMR_S10_ADDR(x),v)
#define HWIO_UMCMN_R0_IMR_S10_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_IMR_S10_ADDR(x),m,v,HWIO_UMCMN_R0_IMR_S10_IN(x))
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_HOST_SRNG11_REQ_ERR_BMSK                            0x20000
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_HOST_SRNG11_REQ_ERR_SHFT                                 17
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_HOST_SRNG10_REQ_ERR_BMSK                            0x10000
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_HOST_SRNG10_REQ_ERR_SHFT                                 16
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_HOST_SRNG9_REQ_ERR_BMSK                              0x8000
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_HOST_SRNG9_REQ_ERR_SHFT                                  15
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_HOST_SRNG8_REQ_ERR_BMSK                              0x4000
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_HOST_SRNG8_REQ_ERR_SHFT                                  14
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_HOST_SRNG7_REQ_ERR_BMSK                              0x2000
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_HOST_SRNG7_REQ_ERR_SHFT                                  13
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_HOST_SRNG6_REQ_ERR_BMSK                              0x1000
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_HOST_SRNG6_REQ_ERR_SHFT                                  12
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_HOST_SRNG5_REQ_ERR_BMSK                               0x800
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_HOST_SRNG5_REQ_ERR_SHFT                                  11
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_HOST_SRNG4_REQ_ERR_BMSK                               0x400
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_HOST_SRNG4_REQ_ERR_SHFT                                  10
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_HOST_SRNG3_REQ_ERR_BMSK                               0x200
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_HOST_SRNG3_REQ_ERR_SHFT                                   9
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_HOST_SRNG2_REQ_ERR_BMSK                               0x100
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_HOST_SRNG2_REQ_ERR_SHFT                                   8
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_HOST_SRNG1_REQ_ERR_BMSK                                0x80
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_HOST_SRNG1_REQ_ERR_SHFT                                   7
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_HOST_SRNG0_REQ_ERR_BMSK                                0x40
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_HOST_SRNG0_REQ_ERR_SHFT                                   6
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_REO_CMD_SRNG_REQ_ERR_BMSK                              0x20
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_REO_CMD_SRNG_REQ_ERR_SHFT                                 5
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_LINK_DESC_SRNG_REQ_ERR_BMSK                            0x10
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_LINK_DESC_SRNG_REQ_ERR_SHFT                               4
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_ENTR_SRNG3_REQ_ERR_BMSK                                 0x8
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_ENTR_SRNG3_REQ_ERR_SHFT                                   3
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_ENTR_SRNG2_REQ_ERR_BMSK                                 0x4
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_ENTR_SRNG2_REQ_ERR_SHFT                                   2
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_ENTR_SRNG1_REQ_ERR_BMSK                                 0x2
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_ENTR_SRNG1_REQ_ERR_SHFT                                   1
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_ENTR_SRNG0_REQ_ERR_BMSK                                 0x1
#define HWIO_UMCMN_R0_IMR_S10_REO_RESERVED_INT_ENTR_SRNG0_REQ_ERR_SHFT                                   0

#define HWIO_UMCMN_R0_IMR_S11_ADDR(x)                                                           ((x) + 0xa8)
#define HWIO_UMCMN_R0_IMR_S11_PHYS(x)                                                           ((x) + 0xa8)
#define HWIO_UMCMN_R0_IMR_S11_OFFS                                                              (0xa8)
#define HWIO_UMCMN_R0_IMR_S11_RMSK                                                               0x3ffffff
#define HWIO_UMCMN_R0_IMR_S11_POR                                                               0x00000000
#define HWIO_UMCMN_R0_IMR_S11_POR_RMSK                                                          0xffffffff
#define HWIO_UMCMN_R0_IMR_S11_ATTR                                                                           0x3
#define HWIO_UMCMN_R0_IMR_S11_IN(x)            \
                in_dword(HWIO_UMCMN_R0_IMR_S11_ADDR(x))
#define HWIO_UMCMN_R0_IMR_S11_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_IMR_S11_ADDR(x), m)
#define HWIO_UMCMN_R0_IMR_S11_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_IMR_S11_ADDR(x),v)
#define HWIO_UMCMN_R0_IMR_S11_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_IMR_S11_ADDR(x),m,v,HWIO_UMCMN_R0_IMR_S11_IN(x))
#define HWIO_UMCMN_R0_IMR_S11_TCL_PPE2TCL1_RING_WDG_ERR_BMSK                                     0x2000000
#define HWIO_UMCMN_R0_IMR_S11_TCL_PPE2TCL1_RING_WDG_ERR_SHFT                                            25
#define HWIO_UMCMN_R0_IMR_S11_TCL_PPE2TCL1_RING_REQ_ERR_BMSK                                     0x1000000
#define HWIO_UMCMN_R0_IMR_S11_TCL_PPE2TCL1_RING_REQ_ERR_SHFT                                            24
#define HWIO_UMCMN_R0_IMR_S11_TCL_SW2TCL_CREDIT2_RING_WDG_ERR_BMSK                                0x800000
#define HWIO_UMCMN_R0_IMR_S11_TCL_SW2TCL_CREDIT2_RING_WDG_ERR_SHFT                                      23
#define HWIO_UMCMN_R0_IMR_S11_TCL_SW2TCL_CREDIT2_RING_REQ_ERR_BMSK                                0x400000
#define HWIO_UMCMN_R0_IMR_S11_TCL_SW2TCL_CREDIT2_RING_REQ_ERR_SHFT                                      22
#define HWIO_UMCMN_R0_IMR_S11_TCL_SW2TCL5_RING_WDG_ERR_BMSK                                       0x200000
#define HWIO_UMCMN_R0_IMR_S11_TCL_SW2TCL5_RING_WDG_ERR_SHFT                                             21
#define HWIO_UMCMN_R0_IMR_S11_TCL_SW2TCL5_RING_REQ_ERR_BMSK                                       0x100000
#define HWIO_UMCMN_R0_IMR_S11_TCL_SW2TCL5_RING_REQ_ERR_SHFT                                             20
#define HWIO_UMCMN_R0_IMR_S11_TCL_SW2TCL4_RING_WDG_ERR_BMSK                                        0x80000
#define HWIO_UMCMN_R0_IMR_S11_TCL_SW2TCL4_RING_WDG_ERR_SHFT                                             19
#define HWIO_UMCMN_R0_IMR_S11_TCL_SW2TCL4_RING_REQ_ERR_BMSK                                        0x40000
#define HWIO_UMCMN_R0_IMR_S11_TCL_SW2TCL4_RING_REQ_ERR_SHFT                                             18
#define HWIO_UMCMN_R0_IMR_S11_TCL_STATUS2_RING_WDG_ERR_BMSK                                        0x20000
#define HWIO_UMCMN_R0_IMR_S11_TCL_STATUS2_RING_WDG_ERR_SHFT                                             17
#define HWIO_UMCMN_R0_IMR_S11_TCL_STATUS2_RING_REQ_ERR_BMSK                                        0x10000
#define HWIO_UMCMN_R0_IMR_S11_TCL_STATUS2_RING_REQ_ERR_SHFT                                             16
#define HWIO_UMCMN_R0_IMR_S11_TCL_STATUS1_RING_WDG_ERR_BMSK                                         0x8000
#define HWIO_UMCMN_R0_IMR_S11_TCL_STATUS1_RING_WDG_ERR_SHFT                                             15
#define HWIO_UMCMN_R0_IMR_S11_TCL_STATUS1_RING_REQ_ERR_BMSK                                         0x4000
#define HWIO_UMCMN_R0_IMR_S11_TCL_STATUS1_RING_REQ_ERR_SHFT                                             14
#define HWIO_UMCMN_R0_IMR_S11_TCL_TCL2FW_RING_WDG_ERR_BMSK                                          0x2000
#define HWIO_UMCMN_R0_IMR_S11_TCL_TCL2FW_RING_WDG_ERR_SHFT                                              13
#define HWIO_UMCMN_R0_IMR_S11_TCL_TCL2FW_RING_REQ_ERR_BMSK                                          0x1000
#define HWIO_UMCMN_R0_IMR_S11_TCL_TCL2FW_RING_REQ_ERR_SHFT                                              12
#define HWIO_UMCMN_R0_IMR_S11_TCL_TCL2TQM_RING_WDG_ERR_BMSK                                          0x800
#define HWIO_UMCMN_R0_IMR_S11_TCL_TCL2TQM_RING_WDG_ERR_SHFT                                             11
#define HWIO_UMCMN_R0_IMR_S11_TCL_TCL2TQM_RING_REQ_ERR_BMSK                                          0x400
#define HWIO_UMCMN_R0_IMR_S11_TCL_TCL2TQM_RING_REQ_ERR_SHFT                                             10
#define HWIO_UMCMN_R0_IMR_S11_TCL_SW2TCL_CREDIT_RING_WDG_ERR_BMSK                                    0x200
#define HWIO_UMCMN_R0_IMR_S11_TCL_SW2TCL_CREDIT_RING_WDG_ERR_SHFT                                        9
#define HWIO_UMCMN_R0_IMR_S11_TCL_SW2TCL_CREDIT_RING_REQ_ERR_BMSK                                    0x100
#define HWIO_UMCMN_R0_IMR_S11_TCL_SW2TCL_CREDIT_RING_REQ_ERR_SHFT                                        8
#define HWIO_UMCMN_R0_IMR_S11_TCL_FW2TCL1_RING_WDG_ERR_BMSK                                           0x80
#define HWIO_UMCMN_R0_IMR_S11_TCL_FW2TCL1_RING_WDG_ERR_SHFT                                              7
#define HWIO_UMCMN_R0_IMR_S11_TCL_FW2TCL1_RING_REQ_ERR_BMSK                                           0x40
#define HWIO_UMCMN_R0_IMR_S11_TCL_FW2TCL1_RING_REQ_ERR_SHFT                                              6
#define HWIO_UMCMN_R0_IMR_S11_TCL_SW2TCL3_RING_WDG_ERR_BMSK                                           0x20
#define HWIO_UMCMN_R0_IMR_S11_TCL_SW2TCL3_RING_WDG_ERR_SHFT                                              5
#define HWIO_UMCMN_R0_IMR_S11_TCL_SW2TCL3_RING_REQ_ERR_BMSK                                           0x10
#define HWIO_UMCMN_R0_IMR_S11_TCL_SW2TCL3_RING_REQ_ERR_SHFT                                              4
#define HWIO_UMCMN_R0_IMR_S11_TCL_SW2TCL2_RING_WDG_ERR_BMSK                                            0x8
#define HWIO_UMCMN_R0_IMR_S11_TCL_SW2TCL2_RING_WDG_ERR_SHFT                                              3
#define HWIO_UMCMN_R0_IMR_S11_TCL_SW2TCL2_RING_REQ_ERR_BMSK                                            0x4
#define HWIO_UMCMN_R0_IMR_S11_TCL_SW2TCL2_RING_REQ_ERR_SHFT                                              2
#define HWIO_UMCMN_R0_IMR_S11_TCL_SW2TCL1_RING_WDG_ERR_BMSK                                            0x2
#define HWIO_UMCMN_R0_IMR_S11_TCL_SW2TCL1_RING_WDG_ERR_SHFT                                              1
#define HWIO_UMCMN_R0_IMR_S11_TCL_SW2TCL1_RING_REQ_ERR_BMSK                                            0x1
#define HWIO_UMCMN_R0_IMR_S11_TCL_SW2TCL1_RING_REQ_ERR_SHFT                                              0

#define HWIO_UMCMN_R0_IMR_S12_ADDR(x)                                                           ((x) + 0xac)
#define HWIO_UMCMN_R0_IMR_S12_PHYS(x)                                                           ((x) + 0xac)
#define HWIO_UMCMN_R0_IMR_S12_OFFS                                                              (0xac)
#define HWIO_UMCMN_R0_IMR_S12_RMSK                                                                0x3fffff
#define HWIO_UMCMN_R0_IMR_S12_POR                                                               0x00000000
#define HWIO_UMCMN_R0_IMR_S12_POR_RMSK                                                          0xffffffff
#define HWIO_UMCMN_R0_IMR_S12_ATTR                                                                           0x3
#define HWIO_UMCMN_R0_IMR_S12_IN(x)            \
                in_dword(HWIO_UMCMN_R0_IMR_S12_ADDR(x))
#define HWIO_UMCMN_R0_IMR_S12_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_IMR_S12_ADDR(x), m)
#define HWIO_UMCMN_R0_IMR_S12_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_IMR_S12_ADDR(x),v)
#define HWIO_UMCMN_R0_IMR_S12_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_IMR_S12_ADDR(x),m,v,HWIO_UMCMN_R0_IMR_S12_IN(x))
#define HWIO_UMCMN_R0_IMR_S12_TCL_PARSER_OUT_TLV_SEQ_ERR_BMSK                                     0x200000
#define HWIO_UMCMN_R0_IMR_S12_TCL_PARSER_OUT_TLV_SEQ_ERR_SHFT                                           21
#define HWIO_UMCMN_R0_IMR_S12_TCL_PPE2TCL1_ZERO_LEN_ERR_BMSK                                      0x100000
#define HWIO_UMCMN_R0_IMR_S12_TCL_PPE2TCL1_ZERO_LEN_ERR_SHFT                                            20
#define HWIO_UMCMN_R0_IMR_S12_TCL_SW2TCL_CREDIT2_ZERO_LEN_ERR_BMSK                                 0x80000
#define HWIO_UMCMN_R0_IMR_S12_TCL_SW2TCL_CREDIT2_ZERO_LEN_ERR_SHFT                                      19
#define HWIO_UMCMN_R0_IMR_S12_TCL_BUFFER_LENGTH_ERROR_INT_BMSK                                     0x40000
#define HWIO_UMCMN_R0_IMR_S12_TCL_BUFFER_LENGTH_ERROR_INT_SHFT                                          18
#define HWIO_UMCMN_R0_IMR_S12_TCL_BANK_ID_ERR_BMSK                                                 0x20000
#define HWIO_UMCMN_R0_IMR_S12_TCL_BANK_ID_ERR_SHFT                                                      17
#define HWIO_UMCMN_R0_IMR_S12_TCL_WDG_WARNING_BMSK                                                 0x10000
#define HWIO_UMCMN_R0_IMR_S12_TCL_WDG_WARNING_SHFT                                                      16
#define HWIO_UMCMN_R0_IMR_S12_TCL_SW2TCL5_ZERO_LEN_ERR_BMSK                                         0x8000
#define HWIO_UMCMN_R0_IMR_S12_TCL_SW2TCL5_ZERO_LEN_ERR_SHFT                                             15
#define HWIO_UMCMN_R0_IMR_S12_TCL_SW2TCL4_ZERO_LEN_ERR_BMSK                                         0x4000
#define HWIO_UMCMN_R0_IMR_S12_TCL_SW2TCL4_ZERO_LEN_ERR_SHFT                                             14
#define HWIO_UMCMN_R0_IMR_S12_TCL_CCE_ERR_CLASSIFY_DIS_BMSK                                         0x2000
#define HWIO_UMCMN_R0_IMR_S12_TCL_CCE_ERR_CLASSIFY_DIS_SHFT                                             13
#define HWIO_UMCMN_R0_IMR_S12_TCL_CCE_WDG_TO_BMSK                                                   0x1000
#define HWIO_UMCMN_R0_IMR_S12_TCL_CCE_WDG_TO_SHFT                                                       12
#define HWIO_UMCMN_R0_IMR_S12_TCL_CMN_PRSR_IPV6_JUMBOGRAM_BMSK                                       0x800
#define HWIO_UMCMN_R0_IMR_S12_TCL_CMN_PRSR_IPV6_JUMBOGRAM_SHFT                                          11
#define HWIO_UMCMN_R0_IMR_S12_TCL_CMN_PRSR_IPV6_EXT_HD_BYTES_EXCEED_BMSK                             0x400
#define HWIO_UMCMN_R0_IMR_S12_TCL_CMN_PRSR_IPV6_EXT_HD_BYTES_EXCEED_SHFT                                10
#define HWIO_UMCMN_R0_IMR_S12_TCL_CMN_PRSR_MSDU_LEN_ERR_BMSK                                         0x200
#define HWIO_UMCMN_R0_IMR_S12_TCL_CMN_PRSR_MSDU_LEN_ERR_SHFT                                             9
#define HWIO_UMCMN_R0_IMR_S12_TCL_CMN_PRSR_ETH_ERR_BMSK                                              0x100
#define HWIO_UMCMN_R0_IMR_S12_TCL_CMN_PRSR_ETH_ERR_SHFT                                                  8
#define HWIO_UMCMN_R0_IMR_S12_TCL_CMN_PRSR_WMAC_ERR_BMSK                                              0x80
#define HWIO_UMCMN_R0_IMR_S12_TCL_CMN_PRSR_WMAC_ERR_SHFT                                                 7
#define HWIO_UMCMN_R0_IMR_S12_TCL_CMN_PRSR_WDG_TO_BMSK                                                0x40
#define HWIO_UMCMN_R0_IMR_S12_TCL_CMN_PRSR_WDG_TO_SHFT                                                   6
#define HWIO_UMCMN_R0_IMR_S12_TCL_SW2TCL_CREDIT_ZERO_LEN_ERR_BMSK                                     0x20
#define HWIO_UMCMN_R0_IMR_S12_TCL_SW2TCL_CREDIT_ZERO_LEN_ERR_SHFT                                        5
#define HWIO_UMCMN_R0_IMR_S12_TCL_FW2TCL1_ZERO_LEN_ERR_BMSK                                           0x10
#define HWIO_UMCMN_R0_IMR_S12_TCL_FW2TCL1_ZERO_LEN_ERR_SHFT                                              4
#define HWIO_UMCMN_R0_IMR_S12_TCL_SW2TCL3_ZERO_LEN_ERR_BMSK                                            0x8
#define HWIO_UMCMN_R0_IMR_S12_TCL_SW2TCL3_ZERO_LEN_ERR_SHFT                                              3
#define HWIO_UMCMN_R0_IMR_S12_TCL_SW2TCL2_ZERO_LEN_ERR_BMSK                                            0x4
#define HWIO_UMCMN_R0_IMR_S12_TCL_SW2TCL2_ZERO_LEN_ERR_SHFT                                              2
#define HWIO_UMCMN_R0_IMR_S12_TCL_SW2TCL1_ZERO_LEN_ERR_BMSK                                            0x2
#define HWIO_UMCMN_R0_IMR_S12_TCL_SW2TCL1_ZERO_LEN_ERR_SHFT                                              1
#define HWIO_UMCMN_R0_IMR_S12_TCL_WDG_ERR_BMSK                                                         0x1
#define HWIO_UMCMN_R0_IMR_S12_TCL_WDG_ERR_SHFT                                                           0

#define HWIO_UMCMN_R0_IMR_S13_ADDR(x)                                                           ((x) + 0xb0)
#define HWIO_UMCMN_R0_IMR_S13_PHYS(x)                                                           ((x) + 0xb0)
#define HWIO_UMCMN_R0_IMR_S13_OFFS                                                              (0xb0)
#define HWIO_UMCMN_R0_IMR_S13_RMSK                                                                 0x3ffff
#define HWIO_UMCMN_R0_IMR_S13_POR                                                               0x00000000
#define HWIO_UMCMN_R0_IMR_S13_POR_RMSK                                                          0xffffffff
#define HWIO_UMCMN_R0_IMR_S13_ATTR                                                                           0x3
#define HWIO_UMCMN_R0_IMR_S13_IN(x)            \
                in_dword(HWIO_UMCMN_R0_IMR_S13_ADDR(x))
#define HWIO_UMCMN_R0_IMR_S13_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_IMR_S13_ADDR(x), m)
#define HWIO_UMCMN_R0_IMR_S13_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_IMR_S13_ADDR(x),v)
#define HWIO_UMCMN_R0_IMR_S13_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_IMR_S13_ADDR(x),m,v,HWIO_UMCMN_R0_IMR_S13_IN(x))
#define HWIO_UMCMN_R0_IMR_S13_TQM_DESC_PTR_RELEASE_RING_REQ_ERR_BMSK                               0x20000
#define HWIO_UMCMN_R0_IMR_S13_TQM_DESC_PTR_RELEASE_RING_REQ_ERR_SHFT                                    17
#define HWIO_UMCMN_R0_IMR_S13_TQM_DESC_PTR_RELEASE_RING_WDG_ERR_BMSK                               0x10000
#define HWIO_UMCMN_R0_IMR_S13_TQM_DESC_PTR_RELEASE_RING_WDG_ERR_SHFT                                    16
#define HWIO_UMCMN_R0_IMR_S13_TQM_STATUS1_UPDATE_RING_REQ_ERR_BMSK                                  0x8000
#define HWIO_UMCMN_R0_IMR_S13_TQM_STATUS1_UPDATE_RING_REQ_ERR_SHFT                                      15
#define HWIO_UMCMN_R0_IMR_S13_TQM_STATUS1_UPDATE_RING_WDG_ERR_BMSK                                  0x4000
#define HWIO_UMCMN_R0_IMR_S13_TQM_STATUS1_UPDATE_RING_WDG_ERR_SHFT                                      14
#define HWIO_UMCMN_R0_IMR_S13_TQM_STATUS_UPDATE_RING_REQ_ERR_BMSK                                   0x2000
#define HWIO_UMCMN_R0_IMR_S13_TQM_STATUS_UPDATE_RING_REQ_ERR_SHFT                                       13
#define HWIO_UMCMN_R0_IMR_S13_TQM_STATUS_UPDATE_RING_WDG_ERR_BMSK                                   0x1000
#define HWIO_UMCMN_R0_IMR_S13_TQM_STATUS_UPDATE_RING_WDG_ERR_SHFT                                       12
#define HWIO_UMCMN_R0_IMR_S13_TQM_DESC_PTR_FETCH_RING_REQ_ERR_BMSK                                   0x800
#define HWIO_UMCMN_R0_IMR_S13_TQM_DESC_PTR_FETCH_RING_REQ_ERR_SHFT                                      11
#define HWIO_UMCMN_R0_IMR_S13_TQM_DESC_PTR_FETCH_RING_WDG_ERR_BMSK                                   0x400
#define HWIO_UMCMN_R0_IMR_S13_TQM_DESC_PTR_FETCH_RING_WDG_ERR_SHFT                                      10
#define HWIO_UMCMN_R0_IMR_S13_TQM_HWSCH_TLV1_LINK_ID_MISMATCH_ERR_BMSK                               0x200
#define HWIO_UMCMN_R0_IMR_S13_TQM_HWSCH_TLV1_LINK_ID_MISMATCH_ERR_SHFT                                   9
#define HWIO_UMCMN_R0_IMR_S13_TQM_HWSCH_TLV1_FLUSH_REQ_ERR_BMSK                                      0x100
#define HWIO_UMCMN_R0_IMR_S13_TQM_HWSCH_TLV1_FLUSH_REQ_ERR_SHFT                                          8
#define HWIO_UMCMN_R0_IMR_S13_TQM_HWSCH_TLV0_LINK_ID_MISMATCH_ERR_BMSK                                0x80
#define HWIO_UMCMN_R0_IMR_S13_TQM_HWSCH_TLV0_LINK_ID_MISMATCH_ERR_SHFT                                   7
#define HWIO_UMCMN_R0_IMR_S13_TQM_HWSCH_TLV0_FLUSH_REQ_ERR_BMSK                                       0x40
#define HWIO_UMCMN_R0_IMR_S13_TQM_HWSCH_TLV0_FLUSH_REQ_ERR_SHFT                                          6
#define HWIO_UMCMN_R0_IMR_S13_TQM_SW_CMD_RING_REQ_ERR_BMSK                                            0x20
#define HWIO_UMCMN_R0_IMR_S13_TQM_SW_CMD_RING_REQ_ERR_SHFT                                               5
#define HWIO_UMCMN_R0_IMR_S13_TQM_SW_CMD_RING_WDG_ERR_BMSK                                            0x10
#define HWIO_UMCMN_R0_IMR_S13_TQM_SW_CMD_RING_WDG_ERR_SHFT                                               4
#define HWIO_UMCMN_R0_IMR_S13_TQM_MSDU_ENT3_RING_REQ_ERR_BMSK                                          0x8
#define HWIO_UMCMN_R0_IMR_S13_TQM_MSDU_ENT3_RING_REQ_ERR_SHFT                                            3
#define HWIO_UMCMN_R0_IMR_S13_TQM_MSDU_ENT3_RING_WDG_ERR_BMSK                                          0x4
#define HWIO_UMCMN_R0_IMR_S13_TQM_MSDU_ENT3_RING_WDG_ERR_SHFT                                            2
#define HWIO_UMCMN_R0_IMR_S13_TQM_MSDU_ENT1_RING_REQ_ERR_BMSK                                          0x2
#define HWIO_UMCMN_R0_IMR_S13_TQM_MSDU_ENT1_RING_REQ_ERR_SHFT                                            1
#define HWIO_UMCMN_R0_IMR_S13_TQM_MSDU_ENT1_RING_WDG_ERR_BMSK                                          0x1
#define HWIO_UMCMN_R0_IMR_S13_TQM_MSDU_ENT1_RING_WDG_ERR_SHFT                                            0

#define HWIO_UMCMN_R0_IMR_S14_ADDR(x)                                                           ((x) + 0xb4)
#define HWIO_UMCMN_R0_IMR_S14_PHYS(x)                                                           ((x) + 0xb4)
#define HWIO_UMCMN_R0_IMR_S14_OFFS                                                              (0xb4)
#define HWIO_UMCMN_R0_IMR_S14_RMSK                                                               0x7ffffff
#define HWIO_UMCMN_R0_IMR_S14_POR                                                               0x00000000
#define HWIO_UMCMN_R0_IMR_S14_POR_RMSK                                                          0xffffffff
#define HWIO_UMCMN_R0_IMR_S14_ATTR                                                                           0x3
#define HWIO_UMCMN_R0_IMR_S14_IN(x)            \
                in_dword(HWIO_UMCMN_R0_IMR_S14_ADDR(x))
#define HWIO_UMCMN_R0_IMR_S14_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_IMR_S14_ADDR(x), m)
#define HWIO_UMCMN_R0_IMR_S14_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_IMR_S14_ADDR(x),v)
#define HWIO_UMCMN_R0_IMR_S14_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_IMR_S14_ADDR(x),m,v,HWIO_UMCMN_R0_IMR_S14_IN(x))
#define HWIO_UMCMN_R0_IMR_S14_TQM2TQM_OUT2_SRNG_P_FETCH_POLLING_TIMEOUT_INT_BMSK                 0x4000000
#define HWIO_UMCMN_R0_IMR_S14_TQM2TQM_OUT2_SRNG_P_FETCH_POLLING_TIMEOUT_INT_SHFT                        26
#define HWIO_UMCMN_R0_IMR_S14_TQM2TQM_OUT2_SRNG_P_REQ_ERR_INT_BMSK                               0x2000000
#define HWIO_UMCMN_R0_IMR_S14_TQM2TQM_OUT2_SRNG_P_REQ_ERR_INT_SHFT                                      25
#define HWIO_UMCMN_R0_IMR_S14_TQM2TQM_OUT2_SRNG_P_WATCHDOG_ERR_INT_BMSK                          0x1000000
#define HWIO_UMCMN_R0_IMR_S14_TQM2TQM_OUT2_SRNG_P_WATCHDOG_ERR_INT_SHFT                                 24
#define HWIO_UMCMN_R0_IMR_S14_TQM2TQM_OUT1_SRNG_P_FETCH_POLLING_TIMEOUT_INT_BMSK                  0x800000
#define HWIO_UMCMN_R0_IMR_S14_TQM2TQM_OUT1_SRNG_P_FETCH_POLLING_TIMEOUT_INT_SHFT                        23
#define HWIO_UMCMN_R0_IMR_S14_TQM2TQM_OUT1_SRNG_P_REQ_ERR_INT_BMSK                                0x400000
#define HWIO_UMCMN_R0_IMR_S14_TQM2TQM_OUT1_SRNG_P_REQ_ERR_INT_SHFT                                      22
#define HWIO_UMCMN_R0_IMR_S14_TQM2TQM_OUT1_SRNG_P_WATCHDOG_ERR_INT_BMSK                           0x200000
#define HWIO_UMCMN_R0_IMR_S14_TQM2TQM_OUT1_SRNG_P_WATCHDOG_ERR_INT_SHFT                                 21
#define HWIO_UMCMN_R0_IMR_S14_TQM2TQM_IN2_SRNG_C_FETCH_POLLING_TIMEOUT_INT_BMSK                   0x100000
#define HWIO_UMCMN_R0_IMR_S14_TQM2TQM_IN2_SRNG_C_FETCH_POLLING_TIMEOUT_INT_SHFT                         20
#define HWIO_UMCMN_R0_IMR_S14_TQM2TQM_IN2_SRNG_C_REQ_ERR_INT_BMSK                                  0x80000
#define HWIO_UMCMN_R0_IMR_S14_TQM2TQM_IN2_SRNG_C_REQ_ERR_INT_SHFT                                       19
#define HWIO_UMCMN_R0_IMR_S14_TQM2TQM_IN2_SRNG_C_WATCHDOG_ERR_INT_BMSK                             0x40000
#define HWIO_UMCMN_R0_IMR_S14_TQM2TQM_IN2_SRNG_C_WATCHDOG_ERR_INT_SHFT                                  18
#define HWIO_UMCMN_R0_IMR_S14_TQM2TQM_IN1_SRNG_C_FETCH_POLLING_TIMEOUT_INT_BMSK                    0x20000
#define HWIO_UMCMN_R0_IMR_S14_TQM2TQM_IN1_SRNG_C_FETCH_POLLING_TIMEOUT_INT_SHFT                         17
#define HWIO_UMCMN_R0_IMR_S14_TQM2TQM_IN1_SRNG_C_REQ_ERR_INT_BMSK                                  0x10000
#define HWIO_UMCMN_R0_IMR_S14_TQM2TQM_IN1_SRNG_C_REQ_ERR_INT_SHFT                                       16
#define HWIO_UMCMN_R0_IMR_S14_TQM2TQM_IN1_SRNG_C_WATCHDOG_ERR_INT_BMSK                              0x8000
#define HWIO_UMCMN_R0_IMR_S14_TQM2TQM_IN1_SRNG_C_WATCHDOG_ERR_INT_SHFT                                  15
#define HWIO_UMCMN_R0_IMR_S14_TQM_CACHE_CTL_ERR_BMSK                                                0x7ff8
#define HWIO_UMCMN_R0_IMR_S14_TQM_CACHE_CTL_ERR_SHFT                                                     3
#define HWIO_UMCMN_R0_IMR_S14_TQM_WARNING_WDG_TIMEOUT_BMSK                                             0x4
#define HWIO_UMCMN_R0_IMR_S14_TQM_WARNING_WDG_TIMEOUT_SHFT                                               2
#define HWIO_UMCMN_R0_IMR_S14_TQM_HW_ERROR_INTR_TIMEOUT_BMSK                                           0x2
#define HWIO_UMCMN_R0_IMR_S14_TQM_HW_ERROR_INTR_TIMEOUT_SHFT                                             1
#define HWIO_UMCMN_R0_IMR_S14_TQM_SW_PRGM_ERR_BMSK                                                     0x1
#define HWIO_UMCMN_R0_IMR_S14_TQM_SW_PRGM_ERR_SHFT                                                       0

#define HWIO_UMCMN_R0_IMR_S15_ADDR(x)                                                           ((x) + 0xb8)
#define HWIO_UMCMN_R0_IMR_S15_PHYS(x)                                                           ((x) + 0xb8)
#define HWIO_UMCMN_R0_IMR_S15_OFFS                                                              (0xb8)
#define HWIO_UMCMN_R0_IMR_S15_RMSK                                                                  0x7fff
#define HWIO_UMCMN_R0_IMR_S15_POR                                                               0x00000000
#define HWIO_UMCMN_R0_IMR_S15_POR_RMSK                                                          0xffffffff
#define HWIO_UMCMN_R0_IMR_S15_ATTR                                                                           0x3
#define HWIO_UMCMN_R0_IMR_S15_IN(x)            \
                in_dword(HWIO_UMCMN_R0_IMR_S15_ADDR(x))
#define HWIO_UMCMN_R0_IMR_S15_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_IMR_S15_ADDR(x), m)
#define HWIO_UMCMN_R0_IMR_S15_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_IMR_S15_ADDR(x),v)
#define HWIO_UMCMN_R0_IMR_S15_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_IMR_S15_ADDR(x),m,v,HWIO_UMCMN_R0_IMR_S15_IN(x))
#define HWIO_UMCMN_R0_IMR_S15_TQM_UNPAUSE_LINK_DESC_THRESHOLD_BMSK                                  0x4000
#define HWIO_UMCMN_R0_IMR_S15_TQM_UNPAUSE_LINK_DESC_THRESHOLD_SHFT                                      14
#define HWIO_UMCMN_R0_IMR_S15_TQM_ILLEGAL_HWSCH_CMD_BMSK                                            0x2000
#define HWIO_UMCMN_R0_IMR_S15_TQM_ILLEGAL_HWSCH_CMD_SHFT                                                13
#define HWIO_UMCMN_R0_IMR_S15_TQM_ILLEGAL_SW_CMD_BMSK                                               0x1000
#define HWIO_UMCMN_R0_IMR_S15_TQM_ILLEGAL_SW_CMD_SHFT                                                   12
#define HWIO_UMCMN_R0_IMR_S15_TQM_LINK_DESC_CNT2_DEC_EMPTY_BMSK                                      0x800
#define HWIO_UMCMN_R0_IMR_S15_TQM_LINK_DESC_CNT2_DEC_EMPTY_SHFT                                         11
#define HWIO_UMCMN_R0_IMR_S15_TQM_LINK_DESC_CNT1_DEC_EMPTY_BMSK                                      0x400
#define HWIO_UMCMN_R0_IMR_S15_TQM_LINK_DESC_CNT1_DEC_EMPTY_SHFT                                         10
#define HWIO_UMCMN_R0_IMR_S15_TQM_LINK_DESC_CNT0_DEC_EMPTY_BMSK                                      0x200
#define HWIO_UMCMN_R0_IMR_S15_TQM_LINK_DESC_CNT0_DEC_EMPTY_SHFT                                          9
#define HWIO_UMCMN_R0_IMR_S15_TQM_LINK_DESC_CNT2_SATURATE_BMSK                                       0x100
#define HWIO_UMCMN_R0_IMR_S15_TQM_LINK_DESC_CNT2_SATURATE_SHFT                                           8
#define HWIO_UMCMN_R0_IMR_S15_TQM_LINK_DESC_CNT1_SATURATE_BMSK                                        0x80
#define HWIO_UMCMN_R0_IMR_S15_TQM_LINK_DESC_CNT1_SATURATE_SHFT                                           7
#define HWIO_UMCMN_R0_IMR_S15_TQM_LINK_DESC_CNT0_SATURATE_BMSK                                        0x40
#define HWIO_UMCMN_R0_IMR_S15_TQM_LINK_DESC_CNT0_SATURATE_SHFT                                           6
#define HWIO_UMCMN_R0_IMR_S15_TQM_LINK_DESC_THRESHOLD2_REACHED_BMSK                                   0x20
#define HWIO_UMCMN_R0_IMR_S15_TQM_LINK_DESC_THRESHOLD2_REACHED_SHFT                                      5
#define HWIO_UMCMN_R0_IMR_S15_TQM_LINK_DESC_THRESHOLD1_REACHED_BMSK                                   0x10
#define HWIO_UMCMN_R0_IMR_S15_TQM_LINK_DESC_THRESHOLD1_REACHED_SHFT                                      4
#define HWIO_UMCMN_R0_IMR_S15_TQM_LINK_DESC_THRESHOLD0_REACHED_BMSK                                    0x8
#define HWIO_UMCMN_R0_IMR_S15_TQM_LINK_DESC_THRESHOLD0_REACHED_SHFT                                      3
#define HWIO_UMCMN_R0_IMR_S15_TQM_AGGR_LINK_DESC_THRESHOLD_REACHED_BMSK                                0x4
#define HWIO_UMCMN_R0_IMR_S15_TQM_AGGR_LINK_DESC_THRESHOLD_REACHED_SHFT                                  2
#define HWIO_UMCMN_R0_IMR_S15_TQM_SW_CMD1_RING_REQ_ERR_BMSK                                            0x2
#define HWIO_UMCMN_R0_IMR_S15_TQM_SW_CMD1_RING_REQ_ERR_SHFT                                              1
#define HWIO_UMCMN_R0_IMR_S15_TQM_SW_CMD1_RING_WDG_ERR_BMSK                                            0x1
#define HWIO_UMCMN_R0_IMR_S15_TQM_SW_CMD1_RING_WDG_ERR_SHFT                                              0

#define HWIO_UMCMN_R0_IMR_S16_ADDR(x)                                                           ((x) + 0xbc)
#define HWIO_UMCMN_R0_IMR_S16_PHYS(x)                                                           ((x) + 0xbc)
#define HWIO_UMCMN_R0_IMR_S16_OFFS                                                              (0xbc)
#define HWIO_UMCMN_R0_IMR_S16_RMSK                                                                   0x1ff
#define HWIO_UMCMN_R0_IMR_S16_POR                                                               0x00000000
#define HWIO_UMCMN_R0_IMR_S16_POR_RMSK                                                          0xffffffff
#define HWIO_UMCMN_R0_IMR_S16_ATTR                                                                           0x3
#define HWIO_UMCMN_R0_IMR_S16_IN(x)            \
                in_dword(HWIO_UMCMN_R0_IMR_S16_ADDR(x))
#define HWIO_UMCMN_R0_IMR_S16_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_IMR_S16_ADDR(x), m)
#define HWIO_UMCMN_R0_IMR_S16_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_IMR_S16_ADDR(x),v)
#define HWIO_UMCMN_R0_IMR_S16_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_IMR_S16_ADDR(x),m,v,HWIO_UMCMN_R0_IMR_S16_IN(x))
#define HWIO_UMCMN_R0_IMR_S16_MXI_RD_ZERO_ADDR_ERR_BMSK                                              0x100
#define HWIO_UMCMN_R0_IMR_S16_MXI_RD_ZERO_ADDR_ERR_SHFT                                                  8
#define HWIO_UMCMN_R0_IMR_S16_MXI_RD_ZERO_SIZE_ERR_BMSK                                               0x80
#define HWIO_UMCMN_R0_IMR_S16_MXI_RD_ZERO_SIZE_ERR_SHFT                                                  7
#define HWIO_UMCMN_R0_IMR_S16_MXI_WR_ZERO_ADDR_ERR_BMSK                                               0x40
#define HWIO_UMCMN_R0_IMR_S16_MXI_WR_ZERO_ADDR_ERR_SHFT                                                  6
#define HWIO_UMCMN_R0_IMR_S16_MXI_WR_ZERO_SIZE_ERR_BMSK                                               0x20
#define HWIO_UMCMN_R0_IMR_S16_MXI_WR_ZERO_SIZE_ERR_SHFT                                                  5
#define HWIO_UMCMN_R0_IMR_S16_MXI_GXI_WDTO_ERR_BMSK                                                   0x10
#define HWIO_UMCMN_R0_IMR_S16_MXI_GXI_WDTO_ERR_SHFT                                                      4
#define HWIO_UMCMN_R0_IMR_S16_MXI_GXI_AXI_WR_ERR_BMSK                                                  0x8
#define HWIO_UMCMN_R0_IMR_S16_MXI_GXI_AXI_WR_ERR_SHFT                                                    3
#define HWIO_UMCMN_R0_IMR_S16_MXI_GXI_AXI_RD_ERR_BMSK                                                  0x4
#define HWIO_UMCMN_R0_IMR_S16_MXI_GXI_AXI_RD_ERR_SHFT                                                    2
#define HWIO_UMCMN_R0_IMR_S16_MXI_GXI_LAST_WR_ERR_BMSK                                                 0x2
#define HWIO_UMCMN_R0_IMR_S16_MXI_GXI_LAST_WR_ERR_SHFT                                                   1
#define HWIO_UMCMN_R0_IMR_S16_MXI_GXI_WDTO_WAR_BMSK                                                    0x1
#define HWIO_UMCMN_R0_IMR_S16_MXI_GXI_WDTO_WAR_SHFT                                                      0

#define HWIO_UMCMN_R0_IMR_S17_ADDR(x)                                                           ((x) + 0xc0)
#define HWIO_UMCMN_R0_IMR_S17_PHYS(x)                                                           ((x) + 0xc0)
#define HWIO_UMCMN_R0_IMR_S17_OFFS                                                              (0xc0)
#define HWIO_UMCMN_R0_IMR_S17_RMSK                                                                  0xffff
#define HWIO_UMCMN_R0_IMR_S17_POR                                                               0x00000000
#define HWIO_UMCMN_R0_IMR_S17_POR_RMSK                                                          0xffffffff
#define HWIO_UMCMN_R0_IMR_S17_ATTR                                                                           0x3
#define HWIO_UMCMN_R0_IMR_S17_IN(x)            \
                in_dword(HWIO_UMCMN_R0_IMR_S17_ADDR(x))
#define HWIO_UMCMN_R0_IMR_S17_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_IMR_S17_ADDR(x), m)
#define HWIO_UMCMN_R0_IMR_S17_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_IMR_S17_ADDR(x),v)
#define HWIO_UMCMN_R0_IMR_S17_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_IMR_S17_ADDR(x),m,v,HWIO_UMCMN_R0_IMR_S17_IN(x))
#define HWIO_UMCMN_R0_IMR_S17_WBM2WBM_OUT2_MLO_P_WATCHDOG_ERR_INT_BMSK                              0x8000
#define HWIO_UMCMN_R0_IMR_S17_WBM2WBM_OUT2_MLO_P_WATCHDOG_ERR_INT_SHFT                                  15
#define HWIO_UMCMN_R0_IMR_S17_WBM2WBM_OUT1_MLO_P_WATCHDOG_ERR_INT_BMSK                              0x4000
#define HWIO_UMCMN_R0_IMR_S17_WBM2WBM_OUT1_MLO_P_WATCHDOG_ERR_INT_SHFT                                  14
#define HWIO_UMCMN_R0_IMR_S17_WBM2WBM_OUT2_RING_REQ_ERROR_INTR_BMSK                                 0x2000
#define HWIO_UMCMN_R0_IMR_S17_WBM2WBM_OUT2_RING_REQ_ERROR_INTR_SHFT                                     13
#define HWIO_UMCMN_R0_IMR_S17_WBM2WBM_OUT1_RING_REQ_ERROR_INTR_BMSK                                 0x1000
#define HWIO_UMCMN_R0_IMR_S17_WBM2WBM_OUT1_RING_REQ_ERROR_INTR_SHFT                                     12
#define HWIO_UMCMN_R0_IMR_S17_WBM2WBM_OUT2_RING_WATCHDOG_ERR_INTR_BMSK                               0x800
#define HWIO_UMCMN_R0_IMR_S17_WBM2WBM_OUT2_RING_WATCHDOG_ERR_INTR_SHFT                                  11
#define HWIO_UMCMN_R0_IMR_S17_WBM2WBM_OUT1_RING_WATCHDOG_ERR_INTR_BMSK                               0x400
#define HWIO_UMCMN_R0_IMR_S17_WBM2WBM_OUT1_RING_WATCHDOG_ERR_INTR_SHFT                                  10
#define HWIO_UMCMN_R0_IMR_S17_WBM2WBM_IN2_RING_WATCHDOG_ERR_INTR_BMSK                                0x200
#define HWIO_UMCMN_R0_IMR_S17_WBM2WBM_IN2_RING_WATCHDOG_ERR_INTR_SHFT                                    9
#define HWIO_UMCMN_R0_IMR_S17_WBM2WBM_IN1_RING_WATCHDOG_ERR_INTR_BMSK                                0x100
#define HWIO_UMCMN_R0_IMR_S17_WBM2WBM_IN1_RING_WATCHDOG_ERR_INTR_SHFT                                    8
#define HWIO_UMCMN_R0_IMR_S17_WBM2WBM_IN2_RING_REQ_ERROR_INTR_BMSK                                    0x80
#define HWIO_UMCMN_R0_IMR_S17_WBM2WBM_IN2_RING_REQ_ERROR_INTR_SHFT                                       7
#define HWIO_UMCMN_R0_IMR_S17_WBM2WBM_IN1_RING_REQ_ERROR_INTR_BMSK                                    0x40
#define HWIO_UMCMN_R0_IMR_S17_WBM2WBM_IN1_RING_REQ_ERROR_INTR_SHFT                                       6
#define HWIO_UMCMN_R0_IMR_S17_WBM2WBM_OUT2_FETCH_POINTER_ERR_INTR_BMSK                                0x20
#define HWIO_UMCMN_R0_IMR_S17_WBM2WBM_OUT2_FETCH_POINTER_ERR_INTR_SHFT                                   5
#define HWIO_UMCMN_R0_IMR_S17_WBM2WBM_OUT1_FETCH_POINTER_ERR_INTR_BMSK                                0x10
#define HWIO_UMCMN_R0_IMR_S17_WBM2WBM_OUT1_FETCH_POINTER_ERR_INTR_SHFT                                   4
#define HWIO_UMCMN_R0_IMR_S17_WBM2WBM_IN2_FETCH_POINTER_ERR_INTR_BMSK                                  0x8
#define HWIO_UMCMN_R0_IMR_S17_WBM2WBM_IN2_FETCH_POINTER_ERR_INTR_SHFT                                    3
#define HWIO_UMCMN_R0_IMR_S17_WBM2WBM_IN1_FETCH_POINTER_ERR_INTR_BMSK                                  0x4
#define HWIO_UMCMN_R0_IMR_S17_WBM2WBM_IN1_FETCH_POINTER_ERR_INTR_SHFT                                    2
#define HWIO_UMCMN_R0_IMR_S17_SW1_RELEASE_RING_REQ_ERROR_INTR_BMSK                                     0x2
#define HWIO_UMCMN_R0_IMR_S17_SW1_RELEASE_RING_REQ_ERROR_INTR_SHFT                                       1
#define HWIO_UMCMN_R0_IMR_S17_SW1_RELEASE_RING_WATCHDOG_ERR_INTR_BMSK                                  0x1
#define HWIO_UMCMN_R0_IMR_S17_SW1_RELEASE_RING_WATCHDOG_ERR_INTR_SHFT                                    0

#define HWIO_UMCMN_R0_WOCLR_ISR_P_EN_ADDR(x)                                                    ((x) + 0xc4)
#define HWIO_UMCMN_R0_WOCLR_ISR_P_EN_PHYS(x)                                                    ((x) + 0xc4)
#define HWIO_UMCMN_R0_WOCLR_ISR_P_EN_OFFS                                                       (0xc4)
#define HWIO_UMCMN_R0_WOCLR_ISR_P_EN_RMSK                                                              0x1
#define HWIO_UMCMN_R0_WOCLR_ISR_P_EN_POR                                                        0x00000000
#define HWIO_UMCMN_R0_WOCLR_ISR_P_EN_POR_RMSK                                                   0xffffffff
#define HWIO_UMCMN_R0_WOCLR_ISR_P_EN_ATTR                                                                    0x3
#define HWIO_UMCMN_R0_WOCLR_ISR_P_EN_IN(x)            \
                in_dword(HWIO_UMCMN_R0_WOCLR_ISR_P_EN_ADDR(x))
#define HWIO_UMCMN_R0_WOCLR_ISR_P_EN_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_WOCLR_ISR_P_EN_ADDR(x), m)
#define HWIO_UMCMN_R0_WOCLR_ISR_P_EN_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_WOCLR_ISR_P_EN_ADDR(x),v)
#define HWIO_UMCMN_R0_WOCLR_ISR_P_EN_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_WOCLR_ISR_P_EN_ADDR(x),m,v,HWIO_UMCMN_R0_WOCLR_ISR_P_EN_IN(x))
#define HWIO_UMCMN_R0_WOCLR_ISR_P_EN_VAL_BMSK                                                          0x1
#define HWIO_UMCMN_R0_WOCLR_ISR_P_EN_VAL_SHFT                                                            0

#define HWIO_UMCMN_R0_UMAC_REVISION_ADDR(x)                                                     ((x) + 0xc8)
#define HWIO_UMCMN_R0_UMAC_REVISION_PHYS(x)                                                     ((x) + 0xc8)
#define HWIO_UMCMN_R0_UMAC_REVISION_OFFS                                                        (0xc8)
#define HWIO_UMCMN_R0_UMAC_REVISION_RMSK                                                        0xffffffff
#define HWIO_UMCMN_R0_UMAC_REVISION_POR                                                         0x20040000
#define HWIO_UMCMN_R0_UMAC_REVISION_POR_RMSK                                                    0xffffffff
#define HWIO_UMCMN_R0_UMAC_REVISION_ATTR                                                                     0x1
#define HWIO_UMCMN_R0_UMAC_REVISION_IN(x)            \
                in_dword(HWIO_UMCMN_R0_UMAC_REVISION_ADDR(x))
#define HWIO_UMCMN_R0_UMAC_REVISION_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_UMAC_REVISION_ADDR(x), m)
#define HWIO_UMCMN_R0_UMAC_REVISION_MAJOR_BMSK                                                  0xf0000000
#define HWIO_UMCMN_R0_UMAC_REVISION_MAJOR_SHFT                                                          28
#define HWIO_UMCMN_R0_UMAC_REVISION_MINOR_BMSK                                                   0xfff0000
#define HWIO_UMCMN_R0_UMAC_REVISION_MINOR_SHFT                                                          16
#define HWIO_UMCMN_R0_UMAC_REVISION_STEP_BMSK                                                       0xffff
#define HWIO_UMCMN_R0_UMAC_REVISION_STEP_SHFT                                                            0

#define HWIO_UMCMN_R0_IDLE_CTRL0_ADDR(x)                                                        ((x) + 0xcc)
#define HWIO_UMCMN_R0_IDLE_CTRL0_PHYS(x)                                                        ((x) + 0xcc)
#define HWIO_UMCMN_R0_IDLE_CTRL0_OFFS                                                           (0xcc)
#define HWIO_UMCMN_R0_IDLE_CTRL0_RMSK                                                             0x3bffff
#define HWIO_UMCMN_R0_IDLE_CTRL0_POR                                                            0x000007de
#define HWIO_UMCMN_R0_IDLE_CTRL0_POR_RMSK                                                       0xffffffff
#define HWIO_UMCMN_R0_IDLE_CTRL0_ATTR                                                                        0x3
#define HWIO_UMCMN_R0_IDLE_CTRL0_IN(x)            \
                in_dword(HWIO_UMCMN_R0_IDLE_CTRL0_ADDR(x))
#define HWIO_UMCMN_R0_IDLE_CTRL0_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_IDLE_CTRL0_ADDR(x), m)
#define HWIO_UMCMN_R0_IDLE_CTRL0_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_IDLE_CTRL0_ADDR(x),v)
#define HWIO_UMCMN_R0_IDLE_CTRL0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_IDLE_CTRL0_ADDR(x),m,v,HWIO_UMCMN_R0_IDLE_CTRL0_IN(x))
#define HWIO_UMCMN_R0_IDLE_CTRL0_BLOCK_NOC_IDLE_REQ_BMSK                                          0x200000
#define HWIO_UMCMN_R0_IDLE_CTRL0_BLOCK_NOC_IDLE_REQ_SHFT                                                21
#define HWIO_UMCMN_R0_IDLE_CTRL0_BLOCK_WBM_IDLE_REQ_BMSK                                          0x100000
#define HWIO_UMCMN_R0_IDLE_CTRL0_BLOCK_WBM_IDLE_REQ_SHFT                                                20
#define HWIO_UMCMN_R0_IDLE_CTRL0_BLOCK_TQM_IDLE_REQ_BMSK                                           0x80000
#define HWIO_UMCMN_R0_IDLE_CTRL0_BLOCK_TQM_IDLE_REQ_SHFT                                                19
#define HWIO_UMCMN_R0_IDLE_CTRL0_BLOCK_REO_IDLE_REQ_BMSK                                           0x20000
#define HWIO_UMCMN_R0_IDLE_CTRL0_BLOCK_REO_IDLE_REQ_SHFT                                                17
#define HWIO_UMCMN_R0_IDLE_CTRL0_BLOCK_TCL_IDLE_REQ_BMSK                                           0x10000
#define HWIO_UMCMN_R0_IDLE_CTRL0_BLOCK_TCL_IDLE_REQ_SHFT                                                16
#define HWIO_UMCMN_R0_IDLE_CTRL0_INTER_STATE_DLY_BMSK                                               0xffc0
#define HWIO_UMCMN_R0_IDLE_CTRL0_INTER_STATE_DLY_SHFT                                                    6
#define HWIO_UMCMN_R0_IDLE_CTRL0_IDLE_INTG_CHK_DLY_BMSK                                               0x3e
#define HWIO_UMCMN_R0_IDLE_CTRL0_IDLE_INTG_CHK_DLY_SHFT                                                  1
#define HWIO_UMCMN_R0_IDLE_CTRL0_SW_IDLE_REQ_BMSK                                                      0x1
#define HWIO_UMCMN_R0_IDLE_CTRL0_SW_IDLE_REQ_SHFT                                                        0

#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_ADDR(x)                                              ((x) + 0xd0)
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_PHYS(x)                                              ((x) + 0xd0)
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_OFFS                                                 (0xd0)
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_RMSK                                                     0x1f9f
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_POR                                                  0x00000000
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_POR_RMSK                                             0xffffffff
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_ATTR                                                              0x3
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_IN(x)            \
                in_dword(HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_ADDR(x))
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_ADDR(x), m)
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_ADDR(x),v)
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_ADDR(x),m,v,HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_IN(x))
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_NOC_IDLE_REQ_SW_DATA_BMSK                                0x1000
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_NOC_IDLE_REQ_SW_DATA_SHFT                                    12
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_NOC_IDLE_REQ_SW_OVR_BMSK                                  0x800
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_NOC_IDLE_REQ_SW_OVR_SHFT                                     11
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_WBM_IDLE_REQ_SW_DATA_BMSK                                 0x400
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_WBM_IDLE_REQ_SW_DATA_SHFT                                    10
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_WBM_IDLE_REQ_SW_OVR_BMSK                                  0x200
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_WBM_IDLE_REQ_SW_OVR_SHFT                                      9
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_TQM_IDLE_REQ_SW_DATA_BMSK                                 0x100
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_TQM_IDLE_REQ_SW_DATA_SHFT                                     8
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_TQM_IDLE_REQ_SW_OVR_BMSK                                   0x80
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_TQM_IDLE_REQ_SW_OVR_SHFT                                      7
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_REO_IDLE_REQ_SW_DATA_BMSK                                  0x10
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_REO_IDLE_REQ_SW_DATA_SHFT                                     4
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_REO_IDLE_REQ_SW_OVR_BMSK                                    0x8
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_REO_IDLE_REQ_SW_OVR_SHFT                                      3
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_TCL_IDLE_REQ_SW_DATA_BMSK                                   0x4
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_TCL_IDLE_REQ_SW_DATA_SHFT                                     2
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_TCL_IDLE_REQ_SW_OVR_BMSK                                    0x2
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_TCL_IDLE_REQ_SW_OVR_SHFT                                      1
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_GLOBAL_SW_OVR_BMSK                                          0x1
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_SW_OVR_GLOBAL_SW_OVR_SHFT                                            0

#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_FSM_CTL_ADDR(x)                                             ((x) + 0xd4)
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_FSM_CTL_PHYS(x)                                             ((x) + 0xd4)
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_FSM_CTL_OFFS                                                (0xd4)
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_FSM_CTL_RMSK                                                   0x3ffff
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_FSM_CTL_POR                                                 0x00000001
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_FSM_CTL_POR_RMSK                                            0xffffffff
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_FSM_CTL_ATTR                                                             0x3
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_FSM_CTL_IN(x)            \
                in_dword(HWIO_UMCMN_R0_UMAC_IDLE_GEN_FSM_CTL_ADDR(x))
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_FSM_CTL_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_UMAC_IDLE_GEN_FSM_CTL_ADDR(x), m)
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_FSM_CTL_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_UMAC_IDLE_GEN_FSM_CTL_ADDR(x),v)
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_FSM_CTL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_UMAC_IDLE_GEN_FSM_CTL_ADDR(x),m,v,HWIO_UMCMN_R0_UMAC_IDLE_GEN_FSM_CTL_IN(x))
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_FSM_CTL_FSM_WAIT_IN_STATE_BMSK                                 0x3fffc
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_FSM_CTL_FSM_WAIT_IN_STATE_SHFT                                       2
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_FSM_CTL_FSM_FORCE_IDLE_BMSK                                        0x2
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_FSM_CTL_FSM_FORCE_IDLE_SHFT                                          1
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_FSM_CTL_FSM_EN_BMSK                                                0x1
#define HWIO_UMCMN_R0_UMAC_IDLE_GEN_FSM_CTL_FSM_EN_SHFT                                                  0

#define HWIO_UMCMN_R0_IDLE_SIGNAL_ADDR(x)                                                       ((x) + 0xd8)
#define HWIO_UMCMN_R0_IDLE_SIGNAL_PHYS(x)                                                       ((x) + 0xd8)
#define HWIO_UMCMN_R0_IDLE_SIGNAL_OFFS                                                          (0xd8)
#define HWIO_UMCMN_R0_IDLE_SIGNAL_RMSK                                                                0x1f
#define HWIO_UMCMN_R0_IDLE_SIGNAL_POR                                                           0x0000001f
#define HWIO_UMCMN_R0_IDLE_SIGNAL_POR_RMSK                                                      0xffffffff
#define HWIO_UMCMN_R0_IDLE_SIGNAL_ATTR                                                                       0x1
#define HWIO_UMCMN_R0_IDLE_SIGNAL_IN(x)            \
                in_dword(HWIO_UMCMN_R0_IDLE_SIGNAL_ADDR(x))
#define HWIO_UMCMN_R0_IDLE_SIGNAL_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_IDLE_SIGNAL_ADDR(x), m)
#define HWIO_UMCMN_R0_IDLE_SIGNAL_MXI_BMSK                                                            0x10
#define HWIO_UMCMN_R0_IDLE_SIGNAL_MXI_SHFT                                                               4
#define HWIO_UMCMN_R0_IDLE_SIGNAL_REO_BMSK                                                             0x8
#define HWIO_UMCMN_R0_IDLE_SIGNAL_REO_SHFT                                                               3
#define HWIO_UMCMN_R0_IDLE_SIGNAL_TCL_BMSK                                                             0x4
#define HWIO_UMCMN_R0_IDLE_SIGNAL_TCL_SHFT                                                               2
#define HWIO_UMCMN_R0_IDLE_SIGNAL_WBM_BMSK                                                             0x2
#define HWIO_UMCMN_R0_IDLE_SIGNAL_WBM_SHFT                                                               1
#define HWIO_UMCMN_R0_IDLE_SIGNAL_TQM_BMSK                                                             0x1
#define HWIO_UMCMN_R0_IDLE_SIGNAL_TQM_SHFT                                                               0

#define HWIO_UMCMN_R0_RING_NOT_EMPTY_STATUS_ADDR(x)                                             ((x) + 0xdc)
#define HWIO_UMCMN_R0_RING_NOT_EMPTY_STATUS_PHYS(x)                                             ((x) + 0xdc)
#define HWIO_UMCMN_R0_RING_NOT_EMPTY_STATUS_OFFS                                                (0xdc)
#define HWIO_UMCMN_R0_RING_NOT_EMPTY_STATUS_RMSK                                                      0x1e
#define HWIO_UMCMN_R0_RING_NOT_EMPTY_STATUS_POR                                                 0x00000000
#define HWIO_UMCMN_R0_RING_NOT_EMPTY_STATUS_POR_RMSK                                            0xffffffff
#define HWIO_UMCMN_R0_RING_NOT_EMPTY_STATUS_ATTR                                                             0x1
#define HWIO_UMCMN_R0_RING_NOT_EMPTY_STATUS_IN(x)            \
                in_dword(HWIO_UMCMN_R0_RING_NOT_EMPTY_STATUS_ADDR(x))
#define HWIO_UMCMN_R0_RING_NOT_EMPTY_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_RING_NOT_EMPTY_STATUS_ADDR(x), m)
#define HWIO_UMCMN_R0_RING_NOT_EMPTY_STATUS_WBM_REL_RING_BMSK                                         0x10
#define HWIO_UMCMN_R0_RING_NOT_EMPTY_STATUS_WBM_REL_RING_SHFT                                            4
#define HWIO_UMCMN_R0_RING_NOT_EMPTY_STATUS_TQM_CMD_RING_BMSK                                          0x8
#define HWIO_UMCMN_R0_RING_NOT_EMPTY_STATUS_TQM_CMD_RING_SHFT                                            3
#define HWIO_UMCMN_R0_RING_NOT_EMPTY_STATUS_REO_CMD_RING_BMSK                                          0x4
#define HWIO_UMCMN_R0_RING_NOT_EMPTY_STATUS_REO_CMD_RING_SHFT                                            2
#define HWIO_UMCMN_R0_RING_NOT_EMPTY_STATUS_TCL_CMD_RING_BMSK                                          0x2
#define HWIO_UMCMN_R0_RING_NOT_EMPTY_STATUS_TCL_CMD_RING_SHFT                                            1

#define HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_ADDR(x)                                      ((x) + 0xe0)
#define HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_PHYS(x)                                      ((x) + 0xe0)
#define HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_OFFS                                         (0xe0)
#define HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_RMSK                                              0xfcf
#define HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_POR                                          0x00000000
#define HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_POR_RMSK                                     0xffffffff
#define HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_ATTR                                                      0x3
#define HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_IN(x)            \
                in_dword(HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_ADDR(x))
#define HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_ADDR(x), m)
#define HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_ADDR(x),v)
#define HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_ADDR(x),m,v,HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_IN(x))
#define HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_NOC_IDLE_SWOVR_DATA_BMSK                          0x800
#define HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_NOC_IDLE_SWOVR_DATA_SHFT                             11
#define HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_NOC_IDLE_SWOVR_BMSK                               0x400
#define HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_NOC_IDLE_SWOVR_SHFT                                  10
#define HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_WBM_IDLE_SWOVR_DATA_BMSK                          0x200
#define HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_WBM_IDLE_SWOVR_DATA_SHFT                              9
#define HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_WBM_IDLE_SWOVR_BMSK                               0x100
#define HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_WBM_IDLE_SWOVR_SHFT                                   8
#define HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_TQM_IDLE_SWOVR_DATA_BMSK                           0x80
#define HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_TQM_IDLE_SWOVR_DATA_SHFT                              7
#define HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_TQM_IDLE_SWOVR_BMSK                                0x40
#define HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_TQM_IDLE_SWOVR_SHFT                                   6
#define HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_REO_IDLE_SWOVR_DATA_BMSK                            0x8
#define HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_REO_IDLE_SWOVR_DATA_SHFT                              3
#define HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_REO_IDLE_SWOVR_BMSK                                 0x4
#define HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_REO_IDLE_SWOVR_SHFT                                   2
#define HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_TCL_IDLE_SWOVR_DATA_BMSK                            0x2
#define HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_TCL_IDLE_SWOVR_DATA_SHFT                              1
#define HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_TCL_IDLE_SWOVR_BMSK                                 0x1
#define HWIO_UMCMN_R0_UMAC_IDLE_ACK_AND_RESP_SWOVR_TCL_IDLE_SWOVR_SHFT                                   0

#define HWIO_UMCMN_R0_S_PARE_0_ADDR(x)                                                          ((x) + 0xe4)
#define HWIO_UMCMN_R0_S_PARE_0_PHYS(x)                                                          ((x) + 0xe4)
#define HWIO_UMCMN_R0_S_PARE_0_OFFS                                                             (0xe4)
#define HWIO_UMCMN_R0_S_PARE_0_RMSK                                                             0xffffffff
#define HWIO_UMCMN_R0_S_PARE_0_POR                                                              0x00000000
#define HWIO_UMCMN_R0_S_PARE_0_POR_RMSK                                                         0xffffffff
#define HWIO_UMCMN_R0_S_PARE_0_ATTR                                                                          0x3
#define HWIO_UMCMN_R0_S_PARE_0_IN(x)            \
                in_dword(HWIO_UMCMN_R0_S_PARE_0_ADDR(x))
#define HWIO_UMCMN_R0_S_PARE_0_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_S_PARE_0_ADDR(x), m)
#define HWIO_UMCMN_R0_S_PARE_0_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_S_PARE_0_ADDR(x),v)
#define HWIO_UMCMN_R0_S_PARE_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_S_PARE_0_ADDR(x),m,v,HWIO_UMCMN_R0_S_PARE_0_IN(x))
#define HWIO_UMCMN_R0_S_PARE_0_S_PARE_0_BITS_BMSK                                               0xffffffff
#define HWIO_UMCMN_R0_S_PARE_0_S_PARE_0_BITS_SHFT                                                        0

#define HWIO_UMCMN_R0_S_PARE_1_ADDR(x)                                                          ((x) + 0xe8)
#define HWIO_UMCMN_R0_S_PARE_1_PHYS(x)                                                          ((x) + 0xe8)
#define HWIO_UMCMN_R0_S_PARE_1_OFFS                                                             (0xe8)
#define HWIO_UMCMN_R0_S_PARE_1_RMSK                                                             0xffffffff
#define HWIO_UMCMN_R0_S_PARE_1_POR                                                              0x00000000
#define HWIO_UMCMN_R0_S_PARE_1_POR_RMSK                                                         0xffffffff
#define HWIO_UMCMN_R0_S_PARE_1_ATTR                                                                          0x3
#define HWIO_UMCMN_R0_S_PARE_1_IN(x)            \
                in_dword(HWIO_UMCMN_R0_S_PARE_1_ADDR(x))
#define HWIO_UMCMN_R0_S_PARE_1_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_S_PARE_1_ADDR(x), m)
#define HWIO_UMCMN_R0_S_PARE_1_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_S_PARE_1_ADDR(x),v)
#define HWIO_UMCMN_R0_S_PARE_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_S_PARE_1_ADDR(x),m,v,HWIO_UMCMN_R0_S_PARE_1_IN(x))
#define HWIO_UMCMN_R0_S_PARE_1_S_PARE_1_BITS_BMSK                                               0xffffffff
#define HWIO_UMCMN_R0_S_PARE_1_S_PARE_1_BITS_SHFT                                                        0

#define HWIO_UMCMN_R0_S_PARE_2_ADDR(x)                                                          ((x) + 0xec)
#define HWIO_UMCMN_R0_S_PARE_2_PHYS(x)                                                          ((x) + 0xec)
#define HWIO_UMCMN_R0_S_PARE_2_OFFS                                                             (0xec)
#define HWIO_UMCMN_R0_S_PARE_2_RMSK                                                             0xffffffff
#define HWIO_UMCMN_R0_S_PARE_2_POR                                                              0x00000000
#define HWIO_UMCMN_R0_S_PARE_2_POR_RMSK                                                         0xffffffff
#define HWIO_UMCMN_R0_S_PARE_2_ATTR                                                                          0x3
#define HWIO_UMCMN_R0_S_PARE_2_IN(x)            \
                in_dword(HWIO_UMCMN_R0_S_PARE_2_ADDR(x))
#define HWIO_UMCMN_R0_S_PARE_2_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_S_PARE_2_ADDR(x), m)
#define HWIO_UMCMN_R0_S_PARE_2_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_S_PARE_2_ADDR(x),v)
#define HWIO_UMCMN_R0_S_PARE_2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_S_PARE_2_ADDR(x),m,v,HWIO_UMCMN_R0_S_PARE_2_IN(x))
#define HWIO_UMCMN_R0_S_PARE_2_S_PARE_2_BITS_BMSK                                               0xffffffff
#define HWIO_UMCMN_R0_S_PARE_2_S_PARE_2_BITS_SHFT                                                        0

#define HWIO_UMCMN_R0_S_PARE_3_ADDR(x)                                                          ((x) + 0xf0)
#define HWIO_UMCMN_R0_S_PARE_3_PHYS(x)                                                          ((x) + 0xf0)
#define HWIO_UMCMN_R0_S_PARE_3_OFFS                                                             (0xf0)
#define HWIO_UMCMN_R0_S_PARE_3_RMSK                                                             0xffffffff
#define HWIO_UMCMN_R0_S_PARE_3_POR                                                              0x00000000
#define HWIO_UMCMN_R0_S_PARE_3_POR_RMSK                                                         0xffffffff
#define HWIO_UMCMN_R0_S_PARE_3_ATTR                                                                          0x3
#define HWIO_UMCMN_R0_S_PARE_3_IN(x)            \
                in_dword(HWIO_UMCMN_R0_S_PARE_3_ADDR(x))
#define HWIO_UMCMN_R0_S_PARE_3_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_S_PARE_3_ADDR(x), m)
#define HWIO_UMCMN_R0_S_PARE_3_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_S_PARE_3_ADDR(x),v)
#define HWIO_UMCMN_R0_S_PARE_3_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_S_PARE_3_ADDR(x),m,v,HWIO_UMCMN_R0_S_PARE_3_IN(x))
#define HWIO_UMCMN_R0_S_PARE_3_S_PARE_3_BITS_BMSK                                               0xffffffff
#define HWIO_UMCMN_R0_S_PARE_3_S_PARE_3_BITS_SHFT                                                        0

#define HWIO_UMCMN_R0_UMAC_IDLE_LENGTH_ADDR(x)                                                  ((x) + 0xf4)
#define HWIO_UMCMN_R0_UMAC_IDLE_LENGTH_PHYS(x)                                                  ((x) + 0xf4)
#define HWIO_UMCMN_R0_UMAC_IDLE_LENGTH_OFFS                                                     (0xf4)
#define HWIO_UMCMN_R0_UMAC_IDLE_LENGTH_RMSK                                                         0xffff
#define HWIO_UMCMN_R0_UMAC_IDLE_LENGTH_POR                                                      0x00000008
#define HWIO_UMCMN_R0_UMAC_IDLE_LENGTH_POR_RMSK                                                 0xffffffff
#define HWIO_UMCMN_R0_UMAC_IDLE_LENGTH_ATTR                                                                  0x3
#define HWIO_UMCMN_R0_UMAC_IDLE_LENGTH_IN(x)            \
                in_dword(HWIO_UMCMN_R0_UMAC_IDLE_LENGTH_ADDR(x))
#define HWIO_UMCMN_R0_UMAC_IDLE_LENGTH_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_UMAC_IDLE_LENGTH_ADDR(x), m)
#define HWIO_UMCMN_R0_UMAC_IDLE_LENGTH_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_UMAC_IDLE_LENGTH_ADDR(x),v)
#define HWIO_UMCMN_R0_UMAC_IDLE_LENGTH_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_UMAC_IDLE_LENGTH_ADDR(x),m,v,HWIO_UMCMN_R0_UMAC_IDLE_LENGTH_IN(x))
#define HWIO_UMCMN_R0_UMAC_IDLE_LENGTH_VALUE_BMSK                                                   0xffff
#define HWIO_UMCMN_R0_UMAC_IDLE_LENGTH_VALUE_SHFT                                                        0

#define HWIO_UMCMN_R0_UMAC_TRACER_CONTROL_ADDR(x)                                               ((x) + 0xfc)
#define HWIO_UMCMN_R0_UMAC_TRACER_CONTROL_PHYS(x)                                               ((x) + 0xfc)
#define HWIO_UMCMN_R0_UMAC_TRACER_CONTROL_OFFS                                                  (0xfc)
#define HWIO_UMCMN_R0_UMAC_TRACER_CONTROL_RMSK                                                         0xf
#define HWIO_UMCMN_R0_UMAC_TRACER_CONTROL_POR                                                   0x00000000
#define HWIO_UMCMN_R0_UMAC_TRACER_CONTROL_POR_RMSK                                              0xffffffff
#define HWIO_UMCMN_R0_UMAC_TRACER_CONTROL_ATTR                                                               0x3
#define HWIO_UMCMN_R0_UMAC_TRACER_CONTROL_IN(x)            \
                in_dword(HWIO_UMCMN_R0_UMAC_TRACER_CONTROL_ADDR(x))
#define HWIO_UMCMN_R0_UMAC_TRACER_CONTROL_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_UMAC_TRACER_CONTROL_ADDR(x), m)
#define HWIO_UMCMN_R0_UMAC_TRACER_CONTROL_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_UMAC_TRACER_CONTROL_ADDR(x),v)
#define HWIO_UMCMN_R0_UMAC_TRACER_CONTROL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_UMAC_TRACER_CONTROL_ADDR(x),m,v,HWIO_UMCMN_R0_UMAC_TRACER_CONTROL_IN(x))
#define HWIO_UMCMN_R0_UMAC_TRACER_CONTROL_SUBSYSTEM_ID_BMSK                                            0xc
#define HWIO_UMCMN_R0_UMAC_TRACER_CONTROL_SUBSYSTEM_ID_SHFT                                              2
#define HWIO_UMCMN_R0_UMAC_TRACER_CONTROL_TESTBUS_VALID_CONTROL_BMSK                                   0x3
#define HWIO_UMCMN_R0_UMAC_TRACER_CONTROL_TESTBUS_VALID_CONTROL_SHFT                                     0

#define HWIO_UMCMN_R0_UMAC_NOC_MONITOR_ADDR(x)                                                  ((x) + 0x100)
#define HWIO_UMCMN_R0_UMAC_NOC_MONITOR_PHYS(x)                                                  ((x) + 0x100)
#define HWIO_UMCMN_R0_UMAC_NOC_MONITOR_OFFS                                                     (0x100)
#define HWIO_UMCMN_R0_UMAC_NOC_MONITOR_RMSK                                                           0x3f
#define HWIO_UMCMN_R0_UMAC_NOC_MONITOR_POR                                                      0x00000000
#define HWIO_UMCMN_R0_UMAC_NOC_MONITOR_POR_RMSK                                                 0xffffffff
#define HWIO_UMCMN_R0_UMAC_NOC_MONITOR_ATTR                                                                  0x1
#define HWIO_UMCMN_R0_UMAC_NOC_MONITOR_IN(x)            \
                in_dword(HWIO_UMCMN_R0_UMAC_NOC_MONITOR_ADDR(x))
#define HWIO_UMCMN_R0_UMAC_NOC_MONITOR_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_UMAC_NOC_MONITOR_ADDR(x), m)
#define HWIO_UMCMN_R0_UMAC_NOC_MONITOR_UMAC_NOC_DCD_CLKON_OUT_BMSK                                    0x20
#define HWIO_UMCMN_R0_UMAC_NOC_MONITOR_UMAC_NOC_DCD_CLKON_OUT_SHFT                                       5
#define HWIO_UMCMN_R0_UMAC_NOC_MONITOR_UMAC_NOC_DCD_CLKDIV_BMSK                                       0x1f
#define HWIO_UMCMN_R0_UMAC_NOC_MONITOR_UMAC_NOC_DCD_CLKDIV_SHFT                                          0

#define HWIO_UMCMN_R0_BUF_INIT_ADDR(x)                                                          ((x) + 0x104)
#define HWIO_UMCMN_R0_BUF_INIT_PHYS(x)                                                          ((x) + 0x104)
#define HWIO_UMCMN_R0_BUF_INIT_OFFS                                                             (0x104)
#define HWIO_UMCMN_R0_BUF_INIT_RMSK                                                                    0x1
#define HWIO_UMCMN_R0_BUF_INIT_POR                                                              0x00000000
#define HWIO_UMCMN_R0_BUF_INIT_POR_RMSK                                                         0xffffffff
#define HWIO_UMCMN_R0_BUF_INIT_ATTR                                                                          0x3
#define HWIO_UMCMN_R0_BUF_INIT_IN(x)            \
                in_dword(HWIO_UMCMN_R0_BUF_INIT_ADDR(x))
#define HWIO_UMCMN_R0_BUF_INIT_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_BUF_INIT_ADDR(x), m)
#define HWIO_UMCMN_R0_BUF_INIT_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_BUF_INIT_ADDR(x),v)
#define HWIO_UMCMN_R0_BUF_INIT_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_BUF_INIT_ADDR(x),m,v,HWIO_UMCMN_R0_BUF_INIT_IN(x))
#define HWIO_UMCMN_R0_BUF_INIT_VALUE_BMSK                                                              0x1
#define HWIO_UMCMN_R0_BUF_INIT_VALUE_SHFT                                                                0

#define HWIO_UMCMN_R0_CONTROL_ADDR(x)                                                           ((x) + 0x108)
#define HWIO_UMCMN_R0_CONTROL_PHYS(x)                                                           ((x) + 0x108)
#define HWIO_UMCMN_R0_CONTROL_OFFS                                                              (0x108)
#define HWIO_UMCMN_R0_CONTROL_RMSK                                                                     0x1
#define HWIO_UMCMN_R0_CONTROL_POR                                                               0x00000000
#define HWIO_UMCMN_R0_CONTROL_POR_RMSK                                                          0xffffffff
#define HWIO_UMCMN_R0_CONTROL_ATTR                                                                           0x3
#define HWIO_UMCMN_R0_CONTROL_IN(x)            \
                in_dword(HWIO_UMCMN_R0_CONTROL_ADDR(x))
#define HWIO_UMCMN_R0_CONTROL_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_CONTROL_ADDR(x), m)
#define HWIO_UMCMN_R0_CONTROL_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_CONTROL_ADDR(x),v)
#define HWIO_UMCMN_R0_CONTROL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_CONTROL_ADDR(x),m,v,HWIO_UMCMN_R0_CONTROL_IN(x))
#define HWIO_UMCMN_R0_CONTROL_ENABLE_VALUE_BMSK                                                        0x1
#define HWIO_UMCMN_R0_CONTROL_ENABLE_VALUE_SHFT                                                          0

#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_1_ADDR(x)                                                ((x) + 0x10c)
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_1_PHYS(x)                                                ((x) + 0x10c)
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_1_OFFS                                                   (0x10c)
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_1_RMSK                                                   0xffffffff
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_1_POR                                                    0x00000000
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_1_POR_RMSK                                               0xffffffff
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_1_ATTR                                                                0x3
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_1_IN(x)            \
                in_dword(HWIO_UMCMN_R0_CLK_GATE_DISABLE_1_ADDR(x))
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_1_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_CLK_GATE_DISABLE_1_ADDR(x), m)
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_1_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_CLK_GATE_DISABLE_1_ADDR(x),v)
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_CLK_GATE_DISABLE_1_ADDR(x),m,v,HWIO_UMCMN_R0_CLK_GATE_DISABLE_1_IN(x))
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_1_CLK_ENS_EXTEND_BMSK                                    0x80000000
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_1_CLK_ENS_EXTEND_SHFT                                            31
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_1_CLK_ENS_EXTEND_APB_BMSK                                0x40000000
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_1_CLK_ENS_EXTEND_APB_SHFT                                        30
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_1_TBD_BMSK                                               0x3ffffffc
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_1_TBD_SHFT                                                        2
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_1_APB_VAL_BMSK                                                  0x2
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_1_APB_VAL_SHFT                                                    1
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_1_VAL_BMSK                                                      0x1
#define HWIO_UMCMN_R0_CLK_GATE_DISABLE_1_VAL_SHFT                                                        0

#define HWIO_UMCMN_R0_ASYNC_ISYNC_FIFO_SOFTRESET_AND_CLK_ADDR(x)                                ((x) + 0x110)
#define HWIO_UMCMN_R0_ASYNC_ISYNC_FIFO_SOFTRESET_AND_CLK_PHYS(x)                                ((x) + 0x110)
#define HWIO_UMCMN_R0_ASYNC_ISYNC_FIFO_SOFTRESET_AND_CLK_OFFS                                   (0x110)
#define HWIO_UMCMN_R0_ASYNC_ISYNC_FIFO_SOFTRESET_AND_CLK_RMSK                                         0x7f
#define HWIO_UMCMN_R0_ASYNC_ISYNC_FIFO_SOFTRESET_AND_CLK_POR                                    0x00000000
#define HWIO_UMCMN_R0_ASYNC_ISYNC_FIFO_SOFTRESET_AND_CLK_POR_RMSK                               0xffffffff
#define HWIO_UMCMN_R0_ASYNC_ISYNC_FIFO_SOFTRESET_AND_CLK_ATTR                                                0x3
#define HWIO_UMCMN_R0_ASYNC_ISYNC_FIFO_SOFTRESET_AND_CLK_IN(x)            \
                in_dword(HWIO_UMCMN_R0_ASYNC_ISYNC_FIFO_SOFTRESET_AND_CLK_ADDR(x))
#define HWIO_UMCMN_R0_ASYNC_ISYNC_FIFO_SOFTRESET_AND_CLK_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_ASYNC_ISYNC_FIFO_SOFTRESET_AND_CLK_ADDR(x), m)
#define HWIO_UMCMN_R0_ASYNC_ISYNC_FIFO_SOFTRESET_AND_CLK_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_ASYNC_ISYNC_FIFO_SOFTRESET_AND_CLK_ADDR(x),v)
#define HWIO_UMCMN_R0_ASYNC_ISYNC_FIFO_SOFTRESET_AND_CLK_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_ASYNC_ISYNC_FIFO_SOFTRESET_AND_CLK_ADDR(x),m,v,HWIO_UMCMN_R0_ASYNC_ISYNC_FIFO_SOFTRESET_AND_CLK_IN(x))
#define HWIO_UMCMN_R0_ASYNC_ISYNC_FIFO_SOFTRESET_AND_CLK_UMAC_BMSK                                    0x40
#define HWIO_UMCMN_R0_ASYNC_ISYNC_FIFO_SOFTRESET_AND_CLK_UMAC_SHFT                                       6
#define HWIO_UMCMN_R0_ASYNC_ISYNC_FIFO_SOFTRESET_AND_CLK_CLK_WCMN_MISC_EVENT_BMSK                     0x20
#define HWIO_UMCMN_R0_ASYNC_ISYNC_FIFO_SOFTRESET_AND_CLK_CLK_WCMN_MISC_EVENT_SHFT                        5
#define HWIO_UMCMN_R0_ASYNC_ISYNC_FIFO_SOFTRESET_AND_CLK_WCMN_MISC_EVENT_BMSK                         0x10
#define HWIO_UMCMN_R0_ASYNC_ISYNC_FIFO_SOFTRESET_AND_CLK_WCMN_MISC_EVENT_SHFT                            4
#define HWIO_UMCMN_R0_ASYNC_ISYNC_FIFO_SOFTRESET_AND_CLK_CLK_WMAC2_BMSK                                0x8
#define HWIO_UMCMN_R0_ASYNC_ISYNC_FIFO_SOFTRESET_AND_CLK_CLK_WMAC2_SHFT                                  3
#define HWIO_UMCMN_R0_ASYNC_ISYNC_FIFO_SOFTRESET_AND_CLK_CLK_WMAC1_BMSK                                0x4
#define HWIO_UMCMN_R0_ASYNC_ISYNC_FIFO_SOFTRESET_AND_CLK_CLK_WMAC1_SHFT                                  2
#define HWIO_UMCMN_R0_ASYNC_ISYNC_FIFO_SOFTRESET_AND_CLK_WMAC2_BMSK                                    0x2
#define HWIO_UMCMN_R0_ASYNC_ISYNC_FIFO_SOFTRESET_AND_CLK_WMAC2_SHFT                                      1
#define HWIO_UMCMN_R0_ASYNC_ISYNC_FIFO_SOFTRESET_AND_CLK_WMAC1_BMSK                                    0x1
#define HWIO_UMCMN_R0_ASYNC_ISYNC_FIFO_SOFTRESET_AND_CLK_WMAC1_SHFT                                      0

#define HWIO_UMCMN_R0_VID0_ADDR(x)                                                              ((x) + 0x114)
#define HWIO_UMCMN_R0_VID0_PHYS(x)                                                              ((x) + 0x114)
#define HWIO_UMCMN_R0_VID0_OFFS                                                                 (0x114)
#define HWIO_UMCMN_R0_VID0_RMSK                                                                 0x1ffffff1
#define HWIO_UMCMN_R0_VID0_POR                                                                  0x0d314830
#define HWIO_UMCMN_R0_VID0_POR_RMSK                                                             0xffffffff
#define HWIO_UMCMN_R0_VID0_ATTR                                                                              0x3
#define HWIO_UMCMN_R0_VID0_IN(x)            \
                in_dword(HWIO_UMCMN_R0_VID0_ADDR(x))
#define HWIO_UMCMN_R0_VID0_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_VID0_ADDR(x), m)
#define HWIO_UMCMN_R0_VID0_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_VID0_ADDR(x),v)
#define HWIO_UMCMN_R0_VID0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_VID0_ADDR(x),m,v,HWIO_UMCMN_R0_VID0_IN(x))
#define HWIO_UMCMN_R0_VID0_MXI_BMSK                                                             0x1f000000
#define HWIO_UMCMN_R0_VID0_MXI_SHFT                                                                     24
#define HWIO_UMCMN_R0_VID0_TCL_BMSK                                                               0xf80000
#define HWIO_UMCMN_R0_VID0_TCL_SHFT                                                                     19
#define HWIO_UMCMN_R0_VID0_WBM_BMSK                                                                0x7c000
#define HWIO_UMCMN_R0_VID0_WBM_SHFT                                                                     14
#define HWIO_UMCMN_R0_VID0_TQM_BMSK                                                                 0x3e00
#define HWIO_UMCMN_R0_VID0_TQM_SHFT                                                                      9
#define HWIO_UMCMN_R0_VID0_REO_BMSK                                                                  0x1f0
#define HWIO_UMCMN_R0_VID0_REO_SHFT                                                                      4
#define HWIO_UMCMN_R0_VID0_MODULE_EN_BMSK                                                              0x1
#define HWIO_UMCMN_R0_VID0_MODULE_EN_SHFT                                                                0

#define HWIO_UMCMN_R0_VID0_EXT_ADDR(x)                                                          ((x) + 0x118)
#define HWIO_UMCMN_R0_VID0_EXT_PHYS(x)                                                          ((x) + 0x118)
#define HWIO_UMCMN_R0_VID0_EXT_OFFS                                                             (0x118)
#define HWIO_UMCMN_R0_VID0_EXT_RMSK                                                                0xfffff
#define HWIO_UMCMN_R0_VID0_EXT_POR                                                              0x0005a928
#define HWIO_UMCMN_R0_VID0_EXT_POR_RMSK                                                         0xffffffff
#define HWIO_UMCMN_R0_VID0_EXT_ATTR                                                                          0x3
#define HWIO_UMCMN_R0_VID0_EXT_IN(x)            \
                in_dword(HWIO_UMCMN_R0_VID0_EXT_ADDR(x))
#define HWIO_UMCMN_R0_VID0_EXT_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_VID0_EXT_ADDR(x), m)
#define HWIO_UMCMN_R0_VID0_EXT_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_VID0_EXT_ADDR(x),v)
#define HWIO_UMCMN_R0_VID0_EXT_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_VID0_EXT_ADDR(x),m,v,HWIO_UMCMN_R0_VID0_EXT_IN(x))
#define HWIO_UMCMN_R0_VID0_EXT_TQM2_BMSK                                                           0xf8000
#define HWIO_UMCMN_R0_VID0_EXT_TQM2_SHFT                                                                15
#define HWIO_UMCMN_R0_VID0_EXT_REO2_BMSK                                                            0x7c00
#define HWIO_UMCMN_R0_VID0_EXT_REO2_SHFT                                                                10
#define HWIO_UMCMN_R0_VID0_EXT_WBM2_BMSK                                                             0x3e0
#define HWIO_UMCMN_R0_VID0_EXT_WBM2_SHFT                                                                 5
#define HWIO_UMCMN_R0_VID0_EXT_TCL_1_BMSK                                                             0x1f
#define HWIO_UMCMN_R0_VID0_EXT_TCL_1_SHFT                                                                0

#define HWIO_UMCMN_R0_SS_ID_ADDR(x)                                                             ((x) + 0x11c)
#define HWIO_UMCMN_R0_SS_ID_PHYS(x)                                                             ((x) + 0x11c)
#define HWIO_UMCMN_R0_SS_ID_OFFS                                                                (0x11c)
#define HWIO_UMCMN_R0_SS_ID_RMSK                                                                     0x7e1
#define HWIO_UMCMN_R0_SS_ID_POR                                                                 0x000001e0
#define HWIO_UMCMN_R0_SS_ID_POR_RMSK                                                            0xffffffff
#define HWIO_UMCMN_R0_SS_ID_ATTR                                                                             0x3
#define HWIO_UMCMN_R0_SS_ID_IN(x)            \
                in_dword(HWIO_UMCMN_R0_SS_ID_ADDR(x))
#define HWIO_UMCMN_R0_SS_ID_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_SS_ID_ADDR(x), m)
#define HWIO_UMCMN_R0_SS_ID_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_SS_ID_ADDR(x),v)
#define HWIO_UMCMN_R0_SS_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_SS_ID_ADDR(x),m,v,HWIO_UMCMN_R0_SS_ID_IN(x))
#define HWIO_UMCMN_R0_SS_ID_WCMN_MISC_BMSK                                                           0x600
#define HWIO_UMCMN_R0_SS_ID_WCMN_MISC_SHFT                                                               9
#define HWIO_UMCMN_R0_SS_ID_UMAC_DBG_BMSK                                                            0x180
#define HWIO_UMCMN_R0_SS_ID_UMAC_DBG_SHFT                                                                7
#define HWIO_UMCMN_R0_SS_ID_UMAC_BMSK                                                                 0x60
#define HWIO_UMCMN_R0_SS_ID_UMAC_SHFT                                                                    5
#define HWIO_UMCMN_R0_SS_ID_ENABLE_BMSK                                                                0x1
#define HWIO_UMCMN_R0_SS_ID_ENABLE_SHFT                                                                  0

#define HWIO_UMCMN_R0_CLK_TESTBUS_OUT_ADDR(x)                                                   ((x) + 0x120)
#define HWIO_UMCMN_R0_CLK_TESTBUS_OUT_PHYS(x)                                                   ((x) + 0x120)
#define HWIO_UMCMN_R0_CLK_TESTBUS_OUT_OFFS                                                      (0x120)
#define HWIO_UMCMN_R0_CLK_TESTBUS_OUT_RMSK                                                             0x1
#define HWIO_UMCMN_R0_CLK_TESTBUS_OUT_POR                                                       0x00000000
#define HWIO_UMCMN_R0_CLK_TESTBUS_OUT_POR_RMSK                                                  0xffffffff
#define HWIO_UMCMN_R0_CLK_TESTBUS_OUT_ATTR                                                                   0x3
#define HWIO_UMCMN_R0_CLK_TESTBUS_OUT_IN(x)            \
                in_dword(HWIO_UMCMN_R0_CLK_TESTBUS_OUT_ADDR(x))
#define HWIO_UMCMN_R0_CLK_TESTBUS_OUT_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_CLK_TESTBUS_OUT_ADDR(x), m)
#define HWIO_UMCMN_R0_CLK_TESTBUS_OUT_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_CLK_TESTBUS_OUT_ADDR(x),v)
#define HWIO_UMCMN_R0_CLK_TESTBUS_OUT_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_CLK_TESTBUS_OUT_ADDR(x),m,v,HWIO_UMCMN_R0_CLK_TESTBUS_OUT_IN(x))
#define HWIO_UMCMN_R0_CLK_TESTBUS_OUT_ENABLE_BMSK                                                      0x1
#define HWIO_UMCMN_R0_CLK_TESTBUS_OUT_ENABLE_SHFT                                                        0

#define HWIO_UMCMN_R0_RRI_INT_LUT_SEL_n_ADDR(base,n)                                            ((base) + 0X124 + (0x4*(n)))
#define HWIO_UMCMN_R0_RRI_INT_LUT_SEL_n_PHYS(base,n)                                            ((base) + 0X124 + (0x4*(n)))
#define HWIO_UMCMN_R0_RRI_INT_LUT_SEL_n_OFFS(n)                                                 (0X124 + (0x4*(n)))
#define HWIO_UMCMN_R0_RRI_INT_LUT_SEL_n_RMSK                                                        0x7c1f
#define HWIO_UMCMN_R0_RRI_INT_LUT_SEL_n_MAXn                                                             7
#define HWIO_UMCMN_R0_RRI_INT_LUT_SEL_n_POR                                                     0x00000000
#define HWIO_UMCMN_R0_RRI_INT_LUT_SEL_n_POR_RMSK                                                0xffffffff
#define HWIO_UMCMN_R0_RRI_INT_LUT_SEL_n_ATTR                                                                 0x3
#define HWIO_UMCMN_R0_RRI_INT_LUT_SEL_n_INI(base,n)                \
                in_dword_masked(HWIO_UMCMN_R0_RRI_INT_LUT_SEL_n_ADDR(base,n), HWIO_UMCMN_R0_RRI_INT_LUT_SEL_n_RMSK)
#define HWIO_UMCMN_R0_RRI_INT_LUT_SEL_n_INMI(base,n,mask)        \
                in_dword_masked(HWIO_UMCMN_R0_RRI_INT_LUT_SEL_n_ADDR(base,n), mask)
#define HWIO_UMCMN_R0_RRI_INT_LUT_SEL_n_OUTI(base,n,val)        \
                out_dword(HWIO_UMCMN_R0_RRI_INT_LUT_SEL_n_ADDR(base,n),val)
#define HWIO_UMCMN_R0_RRI_INT_LUT_SEL_n_OUTMI(base,n,mask,val) \
                out_dword_masked_ns(HWIO_UMCMN_R0_RRI_INT_LUT_SEL_n_ADDR(base,n),mask,val,HWIO_UMCMN_R0_RRI_INT_LUT_SEL_n_INI(base,n))
#define HWIO_UMCMN_R0_RRI_INT_LUT_SEL_n_BLK_SEL_BMSK                                                0x7c00
#define HWIO_UMCMN_R0_RRI_INT_LUT_SEL_n_BLK_SEL_SHFT                                                    10
#define HWIO_UMCMN_R0_RRI_INT_LUT_SEL_n_SIG_SEL_BMSK                                                  0x1f
#define HWIO_UMCMN_R0_RRI_INT_LUT_SEL_n_SIG_SEL_SHFT                                                     0

#define HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_TIME_STAMP_n_ADDR(base,n)                              ((base) + 0X144 + (0x4*(n)))
#define HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_TIME_STAMP_n_PHYS(base,n)                              ((base) + 0X144 + (0x4*(n)))
#define HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_TIME_STAMP_n_OFFS(n)                                   (0X144 + (0x4*(n)))
#define HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_TIME_STAMP_n_RMSK                                      0xffffffff
#define HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_TIME_STAMP_n_MAXn                                               7
#define HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_TIME_STAMP_n_POR                                       0x00000000
#define HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_TIME_STAMP_n_POR_RMSK                                  0xffffffff
#define HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_TIME_STAMP_n_ATTR                                                   0x1
#define HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_TIME_STAMP_n_INI(base,n)                \
                in_dword_masked(HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_TIME_STAMP_n_ADDR(base,n), HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_TIME_STAMP_n_RMSK)
#define HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_TIME_STAMP_n_INMI(base,n,mask)        \
                in_dword_masked(HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_TIME_STAMP_n_ADDR(base,n), mask)
#define HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_TIME_STAMP_n_VALUE_BMSK                                0xffffffff
#define HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_TIME_STAMP_n_VALUE_SHFT                                         0

#define HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_ADDR(x)                                                ((x) + 0x164)
#define HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_PHYS(x)                                                ((x) + 0x164)
#define HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_OFFS                                                   (0x164)
#define HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_RMSK                                                   0xffffffff
#define HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_POR                                                    0x00000000
#define HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_POR_RMSK                                               0xffffffff
#define HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_ATTR                                                                0x3
#define HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_IN(x)            \
                in_dword(HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_ADDR(x))
#define HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_ADDR(x), m)
#define HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_ADDR(x),v)
#define HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_ADDR(x),m,v,HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_IN(x))
#define HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_VALUE_BMSK                                             0xffffffff
#define HWIO_UMCMN_R0_RRI_INT_LUT_STATUS_VALUE_SHFT                                                      0

#define HWIO_UMCMN_R0_TX_TIMESTAMP_RESOLUTION_SELECT_ADDR(x)                                    ((x) + 0x168)
#define HWIO_UMCMN_R0_TX_TIMESTAMP_RESOLUTION_SELECT_PHYS(x)                                    ((x) + 0x168)
#define HWIO_UMCMN_R0_TX_TIMESTAMP_RESOLUTION_SELECT_OFFS                                       (0x168)
#define HWIO_UMCMN_R0_TX_TIMESTAMP_RESOLUTION_SELECT_RMSK                                              0xf
#define HWIO_UMCMN_R0_TX_TIMESTAMP_RESOLUTION_SELECT_POR                                        0x0000000a
#define HWIO_UMCMN_R0_TX_TIMESTAMP_RESOLUTION_SELECT_POR_RMSK                                   0xffffffff
#define HWIO_UMCMN_R0_TX_TIMESTAMP_RESOLUTION_SELECT_ATTR                                                    0x3
#define HWIO_UMCMN_R0_TX_TIMESTAMP_RESOLUTION_SELECT_IN(x)            \
                in_dword(HWIO_UMCMN_R0_TX_TIMESTAMP_RESOLUTION_SELECT_ADDR(x))
#define HWIO_UMCMN_R0_TX_TIMESTAMP_RESOLUTION_SELECT_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_TX_TIMESTAMP_RESOLUTION_SELECT_ADDR(x), m)
#define HWIO_UMCMN_R0_TX_TIMESTAMP_RESOLUTION_SELECT_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_TX_TIMESTAMP_RESOLUTION_SELECT_ADDR(x),v)
#define HWIO_UMCMN_R0_TX_TIMESTAMP_RESOLUTION_SELECT_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_TX_TIMESTAMP_RESOLUTION_SELECT_ADDR(x),m,v,HWIO_UMCMN_R0_TX_TIMESTAMP_RESOLUTION_SELECT_IN(x))
#define HWIO_UMCMN_R0_TX_TIMESTAMP_RESOLUTION_SELECT_VALUE_BMSK                                        0xf
#define HWIO_UMCMN_R0_TX_TIMESTAMP_RESOLUTION_SELECT_VALUE_SHFT                                          0

#define HWIO_UMCMN_R0_UMAC_LINK_ID_ADDR(x)                                                      ((x) + 0x16c)
#define HWIO_UMCMN_R0_UMAC_LINK_ID_PHYS(x)                                                      ((x) + 0x16c)
#define HWIO_UMCMN_R0_UMAC_LINK_ID_OFFS                                                         (0x16c)
#define HWIO_UMCMN_R0_UMAC_LINK_ID_RMSK                                                            0x3ffff
#define HWIO_UMCMN_R0_UMAC_LINK_ID_POR                                                          0x0002c688
#define HWIO_UMCMN_R0_UMAC_LINK_ID_POR_RMSK                                                     0xffffffff
#define HWIO_UMCMN_R0_UMAC_LINK_ID_ATTR                                                                      0x3
#define HWIO_UMCMN_R0_UMAC_LINK_ID_IN(x)            \
                in_dword(HWIO_UMCMN_R0_UMAC_LINK_ID_ADDR(x))
#define HWIO_UMCMN_R0_UMAC_LINK_ID_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_UMAC_LINK_ID_ADDR(x), m)
#define HWIO_UMCMN_R0_UMAC_LINK_ID_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_UMAC_LINK_ID_ADDR(x),v)
#define HWIO_UMCMN_R0_UMAC_LINK_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_UMAC_LINK_ID_ADDR(x),m,v,HWIO_UMCMN_R0_UMAC_LINK_ID_IN(x))
#define HWIO_UMCMN_R0_UMAC_LINK_ID_LINK_ID_5_BMSK                                                  0x38000
#define HWIO_UMCMN_R0_UMAC_LINK_ID_LINK_ID_5_SHFT                                                       15
#define HWIO_UMCMN_R0_UMAC_LINK_ID_LINK_ID_4_BMSK                                                   0x7000
#define HWIO_UMCMN_R0_UMAC_LINK_ID_LINK_ID_4_SHFT                                                       12
#define HWIO_UMCMN_R0_UMAC_LINK_ID_LINK_ID_3_BMSK                                                    0xe00
#define HWIO_UMCMN_R0_UMAC_LINK_ID_LINK_ID_3_SHFT                                                        9
#define HWIO_UMCMN_R0_UMAC_LINK_ID_LINK_ID_2_BMSK                                                    0x1c0
#define HWIO_UMCMN_R0_UMAC_LINK_ID_LINK_ID_2_SHFT                                                        6
#define HWIO_UMCMN_R0_UMAC_LINK_ID_LINK_ID_1_BMSK                                                     0x38
#define HWIO_UMCMN_R0_UMAC_LINK_ID_LINK_ID_1_SHFT                                                        3
#define HWIO_UMCMN_R0_UMAC_LINK_ID_LINK_ID_0_BMSK                                                      0x7
#define HWIO_UMCMN_R0_UMAC_LINK_ID_LINK_ID_0_SHFT                                                        0

#define HWIO_UMCMN_R0_ENABLE_LINK_ID_ADDR(x)                                                    ((x) + 0x170)
#define HWIO_UMCMN_R0_ENABLE_LINK_ID_PHYS(x)                                                    ((x) + 0x170)
#define HWIO_UMCMN_R0_ENABLE_LINK_ID_OFFS                                                       (0x170)
#define HWIO_UMCMN_R0_ENABLE_LINK_ID_RMSK                                                             0x3f
#define HWIO_UMCMN_R0_ENABLE_LINK_ID_POR                                                        0x0000003f
#define HWIO_UMCMN_R0_ENABLE_LINK_ID_POR_RMSK                                                   0xffffffff
#define HWIO_UMCMN_R0_ENABLE_LINK_ID_ATTR                                                                    0x3
#define HWIO_UMCMN_R0_ENABLE_LINK_ID_IN(x)            \
                in_dword(HWIO_UMCMN_R0_ENABLE_LINK_ID_ADDR(x))
#define HWIO_UMCMN_R0_ENABLE_LINK_ID_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_ENABLE_LINK_ID_ADDR(x), m)
#define HWIO_UMCMN_R0_ENABLE_LINK_ID_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_ENABLE_LINK_ID_ADDR(x),v)
#define HWIO_UMCMN_R0_ENABLE_LINK_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_ENABLE_LINK_ID_ADDR(x),m,v,HWIO_UMCMN_R0_ENABLE_LINK_ID_IN(x))
#define HWIO_UMCMN_R0_ENABLE_LINK_ID_TQM_ENABLE_LINK_ID_5_BMSK                                        0x20
#define HWIO_UMCMN_R0_ENABLE_LINK_ID_TQM_ENABLE_LINK_ID_5_SHFT                                           5
#define HWIO_UMCMN_R0_ENABLE_LINK_ID_TQM_ENABLE_LINK_ID_4_BMSK                                        0x10
#define HWIO_UMCMN_R0_ENABLE_LINK_ID_TQM_ENABLE_LINK_ID_4_SHFT                                           4
#define HWIO_UMCMN_R0_ENABLE_LINK_ID_TQM_ENABLE_LINK_ID_3_BMSK                                         0x8
#define HWIO_UMCMN_R0_ENABLE_LINK_ID_TQM_ENABLE_LINK_ID_3_SHFT                                           3
#define HWIO_UMCMN_R0_ENABLE_LINK_ID_TQM_ENABLE_LINK_ID_2_BMSK                                         0x4
#define HWIO_UMCMN_R0_ENABLE_LINK_ID_TQM_ENABLE_LINK_ID_2_SHFT                                           2
#define HWIO_UMCMN_R0_ENABLE_LINK_ID_TQM_ENABLE_LINK_ID_1_BMSK                                         0x2
#define HWIO_UMCMN_R0_ENABLE_LINK_ID_TQM_ENABLE_LINK_ID_1_SHFT                                           1
#define HWIO_UMCMN_R0_ENABLE_LINK_ID_TQM_ENABLE_LINK_ID_0_BMSK                                         0x1
#define HWIO_UMCMN_R0_ENABLE_LINK_ID_TQM_ENABLE_LINK_ID_0_SHFT                                           0

#define HWIO_UMCMN_R0_TRC_CTRL_1_ADDR(x)                                                        ((x) + 0x174)
#define HWIO_UMCMN_R0_TRC_CTRL_1_PHYS(x)                                                        ((x) + 0x174)
#define HWIO_UMCMN_R0_TRC_CTRL_1_OFFS                                                           (0x174)
#define HWIO_UMCMN_R0_TRC_CTRL_1_RMSK                                                           0x7fffffff
#define HWIO_UMCMN_R0_TRC_CTRL_1_POR                                                            0x00000000
#define HWIO_UMCMN_R0_TRC_CTRL_1_POR_RMSK                                                       0xffffffff
#define HWIO_UMCMN_R0_TRC_CTRL_1_ATTR                                                                        0x3
#define HWIO_UMCMN_R0_TRC_CTRL_1_IN(x)            \
                in_dword(HWIO_UMCMN_R0_TRC_CTRL_1_ADDR(x))
#define HWIO_UMCMN_R0_TRC_CTRL_1_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_TRC_CTRL_1_ADDR(x), m)
#define HWIO_UMCMN_R0_TRC_CTRL_1_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_TRC_CTRL_1_ADDR(x),v)
#define HWIO_UMCMN_R0_TRC_CTRL_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_TRC_CTRL_1_ADDR(x),m,v,HWIO_UMCMN_R0_TRC_CTRL_1_IN(x))
#define HWIO_UMCMN_R0_TRC_CTRL_1_SW_EVENTBUS_VALID_BMSK                                         0x40000000
#define HWIO_UMCMN_R0_TRC_CTRL_1_SW_EVENTBUS_VALID_SHFT                                                 30
#define HWIO_UMCMN_R0_TRC_CTRL_1_SW_MODULE_ID_BMSK                                              0x3c000000
#define HWIO_UMCMN_R0_TRC_CTRL_1_SW_MODULE_ID_SHFT                                                      26
#define HWIO_UMCMN_R0_TRC_CTRL_1_SW_EVENT_ID_BMSK                                                0x3f00000
#define HWIO_UMCMN_R0_TRC_CTRL_1_SW_EVENT_ID_SHFT                                                       20
#define HWIO_UMCMN_R0_TRC_CTRL_1_SW_EVENTDATA_BMSK                                                 0xfffff
#define HWIO_UMCMN_R0_TRC_CTRL_1_SW_EVENTDATA_SHFT                                                       0

#define HWIO_UMCMN_R0_TRC_CTRL_2_ADDR(x)                                                        ((x) + 0x178)
#define HWIO_UMCMN_R0_TRC_CTRL_2_PHYS(x)                                                        ((x) + 0x178)
#define HWIO_UMCMN_R0_TRC_CTRL_2_OFFS                                                           (0x178)
#define HWIO_UMCMN_R0_TRC_CTRL_2_RMSK                                                           0xffffffff
#define HWIO_UMCMN_R0_TRC_CTRL_2_POR                                                            0x00000000
#define HWIO_UMCMN_R0_TRC_CTRL_2_POR_RMSK                                                       0xffffffff
#define HWIO_UMCMN_R0_TRC_CTRL_2_ATTR                                                                        0x3
#define HWIO_UMCMN_R0_TRC_CTRL_2_IN(x)            \
                in_dword(HWIO_UMCMN_R0_TRC_CTRL_2_ADDR(x))
#define HWIO_UMCMN_R0_TRC_CTRL_2_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_TRC_CTRL_2_ADDR(x), m)
#define HWIO_UMCMN_R0_TRC_CTRL_2_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_TRC_CTRL_2_ADDR(x),v)
#define HWIO_UMCMN_R0_TRC_CTRL_2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_TRC_CTRL_2_ADDR(x),m,v,HWIO_UMCMN_R0_TRC_CTRL_2_IN(x))
#define HWIO_UMCMN_R0_TRC_CTRL_2_TRC_EVENT_SEL_BMSK                                             0x80000000
#define HWIO_UMCMN_R0_TRC_CTRL_2_TRC_EVENT_SEL_SHFT                                                     31
#define HWIO_UMCMN_R0_TRC_CTRL_2_SUB_SYS_TESTBUS_SEL_BMSK                                       0x70000000
#define HWIO_UMCMN_R0_TRC_CTRL_2_SUB_SYS_TESTBUS_SEL_SHFT                                               28
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_BIT_1_BMSK                                       0xff00000
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_BIT_1_SHFT                                              20
#define HWIO_UMCMN_R0_TRC_CTRL_2_UMAC_MISC_TRC_EVENT_SEL_BMSK                                      0x80000
#define HWIO_UMCMN_R0_TRC_CTRL_2_UMAC_MISC_TRC_EVENT_SEL_SHFT                                           19
#define HWIO_UMCMN_R0_TRC_CTRL_2_TRC_BUS_MUX_SEL_BMSK                                              0x78000
#define HWIO_UMCMN_R0_TRC_CTRL_2_TRC_BUS_MUX_SEL_SHFT                                                   15
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_UMXI_BMSK                                           0x4000
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_UMXI_SHFT                                               14
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_RESERVED_BMSK                                       0x2000
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_RESERVED_SHFT                                           13
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_WBM1_BMSK                                           0x1000
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_WBM1_SHFT                                               12
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_TQM1_BMSK                                            0x800
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_TQM1_SHFT                                               11
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_REO1_BMSK                                            0x400
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_REO1_SHFT                                               10
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_TCL1_BMSK                                            0x200
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_TCL1_SHFT                                                9
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_CXC1_BMSK                                            0x100
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_CXC1_SHFT                                                8
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_REO_BMSK                                              0x80
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_REO_SHFT                                                 7
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_TCL_BMSK                                              0x40
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_TCL_SHFT                                                 6
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_WBM_BMSK                                              0x20
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_WBM_SHFT                                                 5
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_TQM_BMSK                                              0x10
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_TQM_SHFT                                                 4
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_SW_BMSK                                                0x8
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_SW_SHFT                                                  3
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_CXC_BMSK                                               0x4
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_CXC_SHFT                                                 2
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_CE_BMSK                                                0x2
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_CE_SHFT                                                  1
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_ECD_BMSK                                               0x1
#define HWIO_UMCMN_R0_TRC_CTRL_2_EVENT_BLK_MASK_ECD_SHFT                                                 0

#define HWIO_UMCMN_R0_EVENTMASK_IX0_ADDR(x)                                                     ((x) + 0x17c)
#define HWIO_UMCMN_R0_EVENTMASK_IX0_PHYS(x)                                                     ((x) + 0x17c)
#define HWIO_UMCMN_R0_EVENTMASK_IX0_OFFS                                                        (0x17c)
#define HWIO_UMCMN_R0_EVENTMASK_IX0_RMSK                                                        0xffffffff
#define HWIO_UMCMN_R0_EVENTMASK_IX0_POR                                                         0x00000000
#define HWIO_UMCMN_R0_EVENTMASK_IX0_POR_RMSK                                                    0xffffffff
#define HWIO_UMCMN_R0_EVENTMASK_IX0_ATTR                                                                     0x3
#define HWIO_UMCMN_R0_EVENTMASK_IX0_IN(x)            \
                in_dword(HWIO_UMCMN_R0_EVENTMASK_IX0_ADDR(x))
#define HWIO_UMCMN_R0_EVENTMASK_IX0_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_EVENTMASK_IX0_ADDR(x), m)
#define HWIO_UMCMN_R0_EVENTMASK_IX0_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_EVENTMASK_IX0_ADDR(x),v)
#define HWIO_UMCMN_R0_EVENTMASK_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_EVENTMASK_IX0_ADDR(x),m,v,HWIO_UMCMN_R0_EVENTMASK_IX0_IN(x))
#define HWIO_UMCMN_R0_EVENTMASK_IX0_VALUE_BMSK                                                  0xffffffff
#define HWIO_UMCMN_R0_EVENTMASK_IX0_VALUE_SHFT                                                           0

#define HWIO_UMCMN_R0_EVENTMASK_IX1_ADDR(x)                                                     ((x) + 0x180)
#define HWIO_UMCMN_R0_EVENTMASK_IX1_PHYS(x)                                                     ((x) + 0x180)
#define HWIO_UMCMN_R0_EVENTMASK_IX1_OFFS                                                        (0x180)
#define HWIO_UMCMN_R0_EVENTMASK_IX1_RMSK                                                        0xffffffff
#define HWIO_UMCMN_R0_EVENTMASK_IX1_POR                                                         0x00000000
#define HWIO_UMCMN_R0_EVENTMASK_IX1_POR_RMSK                                                    0xffffffff
#define HWIO_UMCMN_R0_EVENTMASK_IX1_ATTR                                                                     0x3
#define HWIO_UMCMN_R0_EVENTMASK_IX1_IN(x)            \
                in_dword(HWIO_UMCMN_R0_EVENTMASK_IX1_ADDR(x))
#define HWIO_UMCMN_R0_EVENTMASK_IX1_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R0_EVENTMASK_IX1_ADDR(x), m)
#define HWIO_UMCMN_R0_EVENTMASK_IX1_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R0_EVENTMASK_IX1_ADDR(x),v)
#define HWIO_UMCMN_R0_EVENTMASK_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R0_EVENTMASK_IX1_ADDR(x),m,v,HWIO_UMCMN_R0_EVENTMASK_IX1_IN(x))
#define HWIO_UMCMN_R0_EVENTMASK_IX1_VALUE_BMSK                                                  0xffffffff
#define HWIO_UMCMN_R0_EVENTMASK_IX1_VALUE_SHFT                                                           0

#define HWIO_UMCMN_R1_INVALID_APB_ACC_ADDR_ADDR(x)                                              ((x) + 0x2000)
#define HWIO_UMCMN_R1_INVALID_APB_ACC_ADDR_PHYS(x)                                              ((x) + 0x2000)
#define HWIO_UMCMN_R1_INVALID_APB_ACC_ADDR_OFFS                                                 (0x2000)
#define HWIO_UMCMN_R1_INVALID_APB_ACC_ADDR_RMSK                                                      0xfff
#define HWIO_UMCMN_R1_INVALID_APB_ACC_ADDR_POR                                                  0x00000000
#define HWIO_UMCMN_R1_INVALID_APB_ACC_ADDR_POR_RMSK                                             0xffffffff
#define HWIO_UMCMN_R1_INVALID_APB_ACC_ADDR_ATTR                                                              0x1
#define HWIO_UMCMN_R1_INVALID_APB_ACC_ADDR_IN(x)            \
                in_dword(HWIO_UMCMN_R1_INVALID_APB_ACC_ADDR_ADDR(x))
#define HWIO_UMCMN_R1_INVALID_APB_ACC_ADDR_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R1_INVALID_APB_ACC_ADDR_ADDR(x), m)
#define HWIO_UMCMN_R1_INVALID_APB_ACC_ADDR_VALUE_BMSK                                                0xfff
#define HWIO_UMCMN_R1_INVALID_APB_ACC_ADDR_VALUE_SHFT                                                    0

#define HWIO_UMCMN_R1_UMAC_IDLE_ADDR(x)                                                         ((x) + 0x2004)
#define HWIO_UMCMN_R1_UMAC_IDLE_PHYS(x)                                                         ((x) + 0x2004)
#define HWIO_UMCMN_R1_UMAC_IDLE_OFFS                                                            (0x2004)
#define HWIO_UMCMN_R1_UMAC_IDLE_RMSK                                                                  0x1f
#define HWIO_UMCMN_R1_UMAC_IDLE_POR                                                             0x00000000
#define HWIO_UMCMN_R1_UMAC_IDLE_POR_RMSK                                                        0xffffffff
#define HWIO_UMCMN_R1_UMAC_IDLE_ATTR                                                                         0x1
#define HWIO_UMCMN_R1_UMAC_IDLE_IN(x)            \
                in_dword(HWIO_UMCMN_R1_UMAC_IDLE_ADDR(x))
#define HWIO_UMCMN_R1_UMAC_IDLE_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R1_UMAC_IDLE_ADDR(x), m)
#define HWIO_UMCMN_R1_UMAC_IDLE_UMAC_IDLE_GEN_MOD_BUSY_BMSK                                           0x10
#define HWIO_UMCMN_R1_UMAC_IDLE_UMAC_IDLE_GEN_MOD_BUSY_SHFT                                              4
#define HWIO_UMCMN_R1_UMAC_IDLE_MAIN_SM_CS_BMSK                                                        0xf
#define HWIO_UMCMN_R1_UMAC_IDLE_MAIN_SM_CS_SHFT                                                          0

#define HWIO_UMCMN_R1_UMAC_IDLE_GEN_INTF_STATUS_ADDR(x)                                         ((x) + 0x2008)
#define HWIO_UMCMN_R1_UMAC_IDLE_GEN_INTF_STATUS_PHYS(x)                                         ((x) + 0x2008)
#define HWIO_UMCMN_R1_UMAC_IDLE_GEN_INTF_STATUS_OFFS                                            (0x2008)
#define HWIO_UMCMN_R1_UMAC_IDLE_GEN_INTF_STATUS_RMSK                                              0xffffff
#define HWIO_UMCMN_R1_UMAC_IDLE_GEN_INTF_STATUS_POR                                             0x00000000
#define HWIO_UMCMN_R1_UMAC_IDLE_GEN_INTF_STATUS_POR_RMSK                                        0xffffffff
#define HWIO_UMCMN_R1_UMAC_IDLE_GEN_INTF_STATUS_ATTR                                                         0x1
#define HWIO_UMCMN_R1_UMAC_IDLE_GEN_INTF_STATUS_IN(x)            \
                in_dword(HWIO_UMCMN_R1_UMAC_IDLE_GEN_INTF_STATUS_ADDR(x))
#define HWIO_UMCMN_R1_UMAC_IDLE_GEN_INTF_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R1_UMAC_IDLE_GEN_INTF_STATUS_ADDR(x), m)
#define HWIO_UMCMN_R1_UMAC_IDLE_GEN_INTF_STATUS_VALUE_BMSK                                        0xffffff
#define HWIO_UMCMN_R1_UMAC_IDLE_GEN_INTF_STATUS_VALUE_SHFT                                               0

#define HWIO_UMCMN_R1_UMAC_IDLE_GEN_ERR_ADDR(x)                                                 ((x) + 0x200c)
#define HWIO_UMCMN_R1_UMAC_IDLE_GEN_ERR_PHYS(x)                                                 ((x) + 0x200c)
#define HWIO_UMCMN_R1_UMAC_IDLE_GEN_ERR_OFFS                                                    (0x200c)
#define HWIO_UMCMN_R1_UMAC_IDLE_GEN_ERR_RMSK                                                         0x7df
#define HWIO_UMCMN_R1_UMAC_IDLE_GEN_ERR_POR                                                     0x00000000
#define HWIO_UMCMN_R1_UMAC_IDLE_GEN_ERR_POR_RMSK                                                0xffffffff
#define HWIO_UMCMN_R1_UMAC_IDLE_GEN_ERR_ATTR                                                                 0x3
#define HWIO_UMCMN_R1_UMAC_IDLE_GEN_ERR_IN(x)            \
                in_dword(HWIO_UMCMN_R1_UMAC_IDLE_GEN_ERR_ADDR(x))
#define HWIO_UMCMN_R1_UMAC_IDLE_GEN_ERR_INM(x, m)            \
                in_dword_masked(HWIO_UMCMN_R1_UMAC_IDLE_GEN_ERR_ADDR(x), m)
#define HWIO_UMCMN_R1_UMAC_IDLE_GEN_ERR_OUT(x, v)            \
                out_dword(HWIO_UMCMN_R1_UMAC_IDLE_GEN_ERR_ADDR(x),v)
#define HWIO_UMCMN_R1_UMAC_IDLE_GEN_ERR_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMCMN_R1_UMAC_IDLE_GEN_ERR_ADDR(x),m,v,HWIO_UMCMN_R1_UMAC_IDLE_GEN_ERR_IN(x))
#define HWIO_UMCMN_R1_UMAC_IDLE_GEN_ERR_IDLE_ERR_STATUS_SW_WDATA_BMSK                                0x7c0
#define HWIO_UMCMN_R1_UMAC_IDLE_GEN_ERR_IDLE_ERR_STATUS_SW_WDATA_SHFT                                    6
#define HWIO_UMCMN_R1_UMAC_IDLE_GEN_ERR_STATUS_BMSK                                                   0x1f
#define HWIO_UMCMN_R1_UMAC_IDLE_GEN_ERR_STATUS_SHFT                                                      0

/*----------------------------------------------------------------------------
 * MODULE: MAC_TCL_REG
 *--------------------------------------------------------------------------*/

#define MAC_TCL_REG_REG_BASE                                                                                (UMAC_BASE      + 0x00044000)
#define MAC_TCL_REG_REG_BASE_SIZE                                                                           0x3000
#define MAC_TCL_REG_REG_BASE_USED                                                                           0x205c
#define MAC_TCL_REG_REG_BASE_PHYS                                                                           (UMAC_BASE_PHYS + 0x00044000)
#define MAC_TCL_REG_REG_BASE_OFFS                                                                           0x00044000

#define HWIO_TCL_R0_SW2TCL1_RING_CTRL_ADDR(x)                                                               ((x) + 0x0)
#define HWIO_TCL_R0_SW2TCL1_RING_CTRL_PHYS(x)                                                               ((x) + 0x0)
#define HWIO_TCL_R0_SW2TCL1_RING_CTRL_OFFS                                                                  (0x0)
#define HWIO_TCL_R0_SW2TCL1_RING_CTRL_RMSK                                                                     0x3ffe0
#define HWIO_TCL_R0_SW2TCL1_RING_CTRL_POR                                                                   0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_CTRL_POR_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_CTRL_ATTR                                                                               0x3
#define HWIO_TCL_R0_SW2TCL1_RING_CTRL_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_CTRL_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_CTRL_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_CTRL_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_CTRL_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_CTRL_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_CTRL_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_CTRL_TIMEOUT_VAL_BMSK                                                         0x3ffc0
#define HWIO_TCL_R0_SW2TCL1_RING_CTRL_TIMEOUT_VAL_SHFT                                                               6
#define HWIO_TCL_R0_SW2TCL1_RING_CTRL_RNG_PRTY_BMSK                                                               0x20
#define HWIO_TCL_R0_SW2TCL1_RING_CTRL_RNG_PRTY_SHFT                                                                  5

#define HWIO_TCL_R0_SW2TCL2_RING_CTRL_ADDR(x)                                                               ((x) + 0x4)
#define HWIO_TCL_R0_SW2TCL2_RING_CTRL_PHYS(x)                                                               ((x) + 0x4)
#define HWIO_TCL_R0_SW2TCL2_RING_CTRL_OFFS                                                                  (0x4)
#define HWIO_TCL_R0_SW2TCL2_RING_CTRL_RMSK                                                                     0x3ffe0
#define HWIO_TCL_R0_SW2TCL2_RING_CTRL_POR                                                                   0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_CTRL_POR_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_CTRL_ATTR                                                                               0x3
#define HWIO_TCL_R0_SW2TCL2_RING_CTRL_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_CTRL_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_CTRL_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_CTRL_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_CTRL_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_CTRL_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_CTRL_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_CTRL_TIMEOUT_VAL_BMSK                                                         0x3ffc0
#define HWIO_TCL_R0_SW2TCL2_RING_CTRL_TIMEOUT_VAL_SHFT                                                               6
#define HWIO_TCL_R0_SW2TCL2_RING_CTRL_RNG_PRTY_BMSK                                                               0x20
#define HWIO_TCL_R0_SW2TCL2_RING_CTRL_RNG_PRTY_SHFT                                                                  5

#define HWIO_TCL_R0_SW2TCL3_RING_CTRL_ADDR(x)                                                               ((x) + 0x8)
#define HWIO_TCL_R0_SW2TCL3_RING_CTRL_PHYS(x)                                                               ((x) + 0x8)
#define HWIO_TCL_R0_SW2TCL3_RING_CTRL_OFFS                                                                  (0x8)
#define HWIO_TCL_R0_SW2TCL3_RING_CTRL_RMSK                                                                     0x3ffe0
#define HWIO_TCL_R0_SW2TCL3_RING_CTRL_POR                                                                   0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_CTRL_POR_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_CTRL_ATTR                                                                               0x3
#define HWIO_TCL_R0_SW2TCL3_RING_CTRL_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_CTRL_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_CTRL_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_CTRL_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_CTRL_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_CTRL_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_CTRL_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_CTRL_TIMEOUT_VAL_BMSK                                                         0x3ffc0
#define HWIO_TCL_R0_SW2TCL3_RING_CTRL_TIMEOUT_VAL_SHFT                                                               6
#define HWIO_TCL_R0_SW2TCL3_RING_CTRL_RNG_PRTY_BMSK                                                               0x20
#define HWIO_TCL_R0_SW2TCL3_RING_CTRL_RNG_PRTY_SHFT                                                                  5

#define HWIO_TCL_R0_SW2TCL4_RING_CTRL_ADDR(x)                                                               ((x) + 0xc)
#define HWIO_TCL_R0_SW2TCL4_RING_CTRL_PHYS(x)                                                               ((x) + 0xc)
#define HWIO_TCL_R0_SW2TCL4_RING_CTRL_OFFS                                                                  (0xc)
#define HWIO_TCL_R0_SW2TCL4_RING_CTRL_RMSK                                                                     0x3ffe0
#define HWIO_TCL_R0_SW2TCL4_RING_CTRL_POR                                                                   0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_CTRL_POR_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_CTRL_ATTR                                                                               0x3
#define HWIO_TCL_R0_SW2TCL4_RING_CTRL_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_CTRL_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_CTRL_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_CTRL_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_CTRL_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_CTRL_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_CTRL_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_CTRL_TIMEOUT_VAL_BMSK                                                         0x3ffc0
#define HWIO_TCL_R0_SW2TCL4_RING_CTRL_TIMEOUT_VAL_SHFT                                                               6
#define HWIO_TCL_R0_SW2TCL4_RING_CTRL_RNG_PRTY_BMSK                                                               0x20
#define HWIO_TCL_R0_SW2TCL4_RING_CTRL_RNG_PRTY_SHFT                                                                  5

#define HWIO_TCL_R0_FW2TCL1_RING_CTRL_ADDR(x)                                                               ((x) + 0x14)
#define HWIO_TCL_R0_FW2TCL1_RING_CTRL_PHYS(x)                                                               ((x) + 0x14)
#define HWIO_TCL_R0_FW2TCL1_RING_CTRL_OFFS                                                                  (0x14)
#define HWIO_TCL_R0_FW2TCL1_RING_CTRL_RMSK                                                                     0x3ffe0
#define HWIO_TCL_R0_FW2TCL1_RING_CTRL_POR                                                                   0x00000000
#define HWIO_TCL_R0_FW2TCL1_RING_CTRL_POR_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_FW2TCL1_RING_CTRL_ATTR                                                                               0x3
#define HWIO_TCL_R0_FW2TCL1_RING_CTRL_IN(x)            \
                in_dword(HWIO_TCL_R0_FW2TCL1_RING_CTRL_ADDR(x))
#define HWIO_TCL_R0_FW2TCL1_RING_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_FW2TCL1_RING_CTRL_ADDR(x), m)
#define HWIO_TCL_R0_FW2TCL1_RING_CTRL_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_FW2TCL1_RING_CTRL_ADDR(x),v)
#define HWIO_TCL_R0_FW2TCL1_RING_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_FW2TCL1_RING_CTRL_ADDR(x),m,v,HWIO_TCL_R0_FW2TCL1_RING_CTRL_IN(x))
#define HWIO_TCL_R0_FW2TCL1_RING_CTRL_TIMEOUT_VAL_BMSK                                                         0x3ffc0
#define HWIO_TCL_R0_FW2TCL1_RING_CTRL_TIMEOUT_VAL_SHFT                                                               6
#define HWIO_TCL_R0_FW2TCL1_RING_CTRL_RNG_PRTY_BMSK                                                               0x20
#define HWIO_TCL_R0_FW2TCL1_RING_CTRL_RNG_PRTY_SHFT                                                                  5

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_ADDR(x)                                                         ((x) + 0x18)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_PHYS(x)                                                         ((x) + 0x18)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_OFFS                                                            (0x18)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_RMSK                                                               0x3ffe0
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_POR                                                             0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_POR_RMSK                                                        0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_ATTR                                                                         0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_TIMEOUT_VAL_BMSK                                                   0x3ffc0
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_TIMEOUT_VAL_SHFT                                                         6
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_RNG_PRTY_BMSK                                                         0x20
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CTRL_RNG_PRTY_SHFT                                                            5

#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_ADDR(x)                                                          ((x) + 0x20)
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_PHYS(x)                                                          ((x) + 0x20)
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_OFFS                                                             (0x20)
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_RMSK                                                              0x7fb7b7f
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_POR                                                              0x03700000
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_POR_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_ATTR                                                                          0x3
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_IN(x)            \
                in_dword(HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_ADDR(x))
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_ADDR(x), m)
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_ADDR(x),v)
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_ADDR(x),m,v,HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_IN(x))
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_VLAN_LLC_SEL_BMSK                                                 0x4000000
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_VLAN_LLC_SEL_SHFT                                                        26
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_INSERT_VLAN_EN_BMSK                                               0x2000000
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_INSERT_VLAN_EN_SHFT                                                      25
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_STOP_META_RD_AT_8B_BDRY_BMSK                                      0x1000000
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_STOP_META_RD_AT_8B_BDRY_SHFT                                             24
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_DSCP_TID_MAP_PROGRAM_EN_BMSK                                       0x800000
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_DSCP_TID_MAP_PROGRAM_EN_SHFT                                             23
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_MSDU_EXTN_NUM_BUF_RD_BMSK                                          0x700000
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_MSDU_EXTN_NUM_BUF_RD_SHFT                                                20
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_TCL_IDLE_BMSK                                                       0x80000
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_TCL_IDLE_SHFT                                                            19
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_SW2TCL_CREDIT_RING_HALT_STAT_BMSK                                   0x20000
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_SW2TCL_CREDIT_RING_HALT_STAT_SHFT                                        17
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_FW2TCL1_RNG_HALT_STAT_BMSK                                          0x10000
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_FW2TCL1_RNG_HALT_STAT_SHFT                                               16
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_SW2TCL4_RNG_HALT_STAT_BMSK                                           0x4000
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_SW2TCL4_RNG_HALT_STAT_SHFT                                               14
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_SW2TCL3_RNG_HALT_STAT_BMSK                                           0x2000
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_SW2TCL3_RNG_HALT_STAT_SHFT                                               13
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_SW2TCL2_RNG_HALT_STAT_BMSK                                           0x1000
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_SW2TCL2_RNG_HALT_STAT_SHFT                                               12
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_SW2TCL1_RNG_HALT_STAT_BMSK                                            0x800
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_SW2TCL1_RNG_HALT_STAT_SHFT                                               11
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_SW2TCL_CREDIT_RING_HALT_BMSK                                          0x200
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_SW2TCL_CREDIT_RING_HALT_SHFT                                              9
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_FW2TCL1_RNG_HALT_BMSK                                                 0x100
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_FW2TCL1_RNG_HALT_SHFT                                                     8
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_SW2TCL4_RNG_HALT_BMSK                                                  0x40
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_SW2TCL4_RNG_HALT_SHFT                                                     6
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_SW2TCL3_RNG_HALT_BMSK                                                  0x20
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_SW2TCL3_RNG_HALT_SHFT                                                     5
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_SW2TCL2_RNG_HALT_BMSK                                                  0x10
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_SW2TCL2_RNG_HALT_SHFT                                                     4
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_SW2TCL1_RNG_HALT_BMSK                                                   0x8
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_SW2TCL1_RNG_HALT_SHFT                                                     3
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_HDR_FWD_EN_BMSK                                                         0x4
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_HDR_FWD_EN_SHFT                                                           2
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_MSDU_HDR_LEN_SEL_BMSK                                                   0x2
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_MSDU_HDR_LEN_SEL_SHFT                                                     1
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_CLFY_DIS_BMSK                                                           0x1
#define HWIO_TCL_R0_CONS_RING_CMN_CTRL_REG_CLFY_DIS_SHFT                                                             0

#define HWIO_TCL_R0_CMN_CONFIG_ADDR(x)                                                                      ((x) + 0x24)
#define HWIO_TCL_R0_CMN_CONFIG_PHYS(x)                                                                      ((x) + 0x24)
#define HWIO_TCL_R0_CMN_CONFIG_OFFS                                                                         (0x24)
#define HWIO_TCL_R0_CMN_CONFIG_RMSK                                                                          0xfffffff
#define HWIO_TCL_R0_CMN_CONFIG_POR                                                                          0x067993a2
#define HWIO_TCL_R0_CMN_CONFIG_POR_RMSK                                                                     0xffffffff
#define HWIO_TCL_R0_CMN_CONFIG_ATTR                                                                                      0x3
#define HWIO_TCL_R0_CMN_CONFIG_IN(x)            \
                in_dword(HWIO_TCL_R0_CMN_CONFIG_ADDR(x))
#define HWIO_TCL_R0_CMN_CONFIG_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_CMN_CONFIG_ADDR(x), m)
#define HWIO_TCL_R0_CMN_CONFIG_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_CMN_CONFIG_ADDR(x),v)
#define HWIO_TCL_R0_CMN_CONFIG_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_CMN_CONFIG_ADDR(x),m,v,HWIO_TCL_R0_CMN_CONFIG_IN(x))
#define HWIO_TCL_R0_CMN_CONFIG_VDEV_ID_MISMATCH_DROP_REASON_EN_BMSK                                          0x8000000
#define HWIO_TCL_R0_CMN_CONFIG_VDEV_ID_MISMATCH_DROP_REASON_EN_SHFT                                                 27
#define HWIO_TCL_R0_CMN_CONFIG_CLFY_DIS_INVALID_PPE_DESC_BMSK                                                0x4000000
#define HWIO_TCL_R0_CMN_CONFIG_CLFY_DIS_INVALID_PPE_DESC_SHFT                                                       26
#define HWIO_TCL_R0_CMN_CONFIG_CLFY_DIS_INVALID_BANK_ID_BMSK                                                 0x2000000
#define HWIO_TCL_R0_CMN_CONFIG_CLFY_DIS_INVALID_BANK_ID_SHFT                                                        25
#define HWIO_TCL_R0_CMN_CONFIG_CLFY_DIS_MIN_BUFFER_LEN_ERR_BMSK                                              0x1000000
#define HWIO_TCL_R0_CMN_CONFIG_CLFY_DIS_MIN_BUFFER_LEN_ERR_SHFT                                                     24
#define HWIO_TCL_R0_CMN_CONFIG_ASE_SKIP_SEARCH_EN_BMSK                                                        0x800000
#define HWIO_TCL_R0_CMN_CONFIG_ASE_SKIP_SEARCH_EN_SHFT                                                              23
#define HWIO_TCL_R0_CMN_CONFIG_MCAST_CMN_PN_SN_MLO_REINJECT_ENABLE_BMSK                                       0x400000
#define HWIO_TCL_R0_CMN_CONFIG_MCAST_CMN_PN_SN_MLO_REINJECT_ENABLE_SHFT                                             22
#define HWIO_TCL_R0_CMN_CONFIG_VDEVID_MISMATCH_EXCEPTION_BMSK                                                 0x200000
#define HWIO_TCL_R0_CMN_CONFIG_VDEVID_MISMATCH_EXCEPTION_SHFT                                                       21
#define HWIO_TCL_R0_CMN_CONFIG_FLOW_POINTER_NULL_EXCEPTION_BMSK                                               0x100000
#define HWIO_TCL_R0_CMN_CONFIG_FLOW_POINTER_NULL_EXCEPTION_SHFT                                                     20
#define HWIO_TCL_R0_CMN_CONFIG_FLOW_OVERRIDE_EXCEPTION_BMSK                                                    0x80000
#define HWIO_TCL_R0_CMN_CONFIG_FLOW_OVERRIDE_EXCEPTION_SHFT                                                         19
#define HWIO_TCL_R0_CMN_CONFIG_TX_NOTIFY_PRIORITY_BMSK                                                         0x40000
#define HWIO_TCL_R0_CMN_CONFIG_TX_NOTIFY_PRIORITY_SHFT                                                              18
#define HWIO_TCL_R0_CMN_CONFIG_PMAC_ID_SEL_BMSK                                                                0x20000
#define HWIO_TCL_R0_CMN_CONFIG_PMAC_ID_SEL_SHFT                                                                     17
#define HWIO_TCL_R0_CMN_CONFIG_C9D1_8870_VALUE_BMSK                                                            0x1fffe
#define HWIO_TCL_R0_CMN_CONFIG_C9D1_8870_VALUE_SHFT                                                                  1
#define HWIO_TCL_R0_CMN_CONFIG_ENABLE_C9D1_8870_BMSK                                                               0x1
#define HWIO_TCL_R0_CMN_CONFIG_ENABLE_C9D1_8870_SHFT                                                                 0

#define HWIO_TCL_R0_TCL2TQM_RING_CTRL_ADDR(x)                                                               ((x) + 0x2c)
#define HWIO_TCL_R0_TCL2TQM_RING_CTRL_PHYS(x)                                                               ((x) + 0x2c)
#define HWIO_TCL_R0_TCL2TQM_RING_CTRL_OFFS                                                                  (0x2c)
#define HWIO_TCL_R0_TCL2TQM_RING_CTRL_RMSK                                                                      0xffff
#define HWIO_TCL_R0_TCL2TQM_RING_CTRL_POR                                                                   0x00000000
#define HWIO_TCL_R0_TCL2TQM_RING_CTRL_POR_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_CTRL_ATTR                                                                               0x3
#define HWIO_TCL_R0_TCL2TQM_RING_CTRL_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2TQM_RING_CTRL_ADDR(x))
#define HWIO_TCL_R0_TCL2TQM_RING_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2TQM_RING_CTRL_ADDR(x), m)
#define HWIO_TCL_R0_TCL2TQM_RING_CTRL_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2TQM_RING_CTRL_ADDR(x),v)
#define HWIO_TCL_R0_TCL2TQM_RING_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2TQM_RING_CTRL_ADDR(x),m,v,HWIO_TCL_R0_TCL2TQM_RING_CTRL_IN(x))
#define HWIO_TCL_R0_TCL2TQM_RING_CTRL_DROP_NO_DROP_PRIORITY_BMSK                                                0xc000
#define HWIO_TCL_R0_TCL2TQM_RING_CTRL_DROP_NO_DROP_PRIORITY_SHFT                                                    14
#define HWIO_TCL_R0_TCL2TQM_RING_CTRL_TQM_STATUS_RING_BMSK                                                      0x2000
#define HWIO_TCL_R0_TCL2TQM_RING_CTRL_TQM_STATUS_RING_SHFT                                                          13
#define HWIO_TCL_R0_TCL2TQM_RING_CTRL_TQM_STATUS_REQUIRED_BMSK                                                  0x1000
#define HWIO_TCL_R0_TCL2TQM_RING_CTRL_TQM_STATUS_REQUIRED_SHFT                                                      12
#define HWIO_TCL_R0_TCL2TQM_RING_CTRL_TIMEOUT_VAL_BMSK                                                           0xfff
#define HWIO_TCL_R0_TCL2TQM_RING_CTRL_TIMEOUT_VAL_SHFT                                                               0

#define HWIO_TCL_R0_TCL2FW_RING_CTRL_ADDR(x)                                                                ((x) + 0x30)
#define HWIO_TCL_R0_TCL2FW_RING_CTRL_PHYS(x)                                                                ((x) + 0x30)
#define HWIO_TCL_R0_TCL2FW_RING_CTRL_OFFS                                                                   (0x30)
#define HWIO_TCL_R0_TCL2FW_RING_CTRL_RMSK                                                                        0xfff
#define HWIO_TCL_R0_TCL2FW_RING_CTRL_POR                                                                    0x00000000
#define HWIO_TCL_R0_TCL2FW_RING_CTRL_POR_RMSK                                                               0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_CTRL_ATTR                                                                                0x3
#define HWIO_TCL_R0_TCL2FW_RING_CTRL_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2FW_RING_CTRL_ADDR(x))
#define HWIO_TCL_R0_TCL2FW_RING_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2FW_RING_CTRL_ADDR(x), m)
#define HWIO_TCL_R0_TCL2FW_RING_CTRL_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2FW_RING_CTRL_ADDR(x),v)
#define HWIO_TCL_R0_TCL2FW_RING_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2FW_RING_CTRL_ADDR(x),m,v,HWIO_TCL_R0_TCL2FW_RING_CTRL_IN(x))
#define HWIO_TCL_R0_TCL2FW_RING_CTRL_TIMEOUT_VAL_BMSK                                                            0xfff
#define HWIO_TCL_R0_TCL2FW_RING_CTRL_TIMEOUT_VAL_SHFT                                                                0

#define HWIO_TCL_R0_TCL_STATUS1_RING_CTRL_ADDR(x)                                                           ((x) + 0x34)
#define HWIO_TCL_R0_TCL_STATUS1_RING_CTRL_PHYS(x)                                                           ((x) + 0x34)
#define HWIO_TCL_R0_TCL_STATUS1_RING_CTRL_OFFS                                                              (0x34)
#define HWIO_TCL_R0_TCL_STATUS1_RING_CTRL_RMSK                                                                   0xfff
#define HWIO_TCL_R0_TCL_STATUS1_RING_CTRL_POR                                                               0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_CTRL_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_CTRL_ATTR                                                                           0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_CTRL_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_CTRL_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_CTRL_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_CTRL_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_CTRL_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_CTRL_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_CTRL_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_CTRL_TIMEOUT_VAL_BMSK                                                       0xfff
#define HWIO_TCL_R0_TCL_STATUS1_RING_CTRL_TIMEOUT_VAL_SHFT                                                           0

#define HWIO_TCL_R0_GEN_CTRL_ADDR(x)                                                                        ((x) + 0x3c)
#define HWIO_TCL_R0_GEN_CTRL_PHYS(x)                                                                        ((x) + 0x3c)
#define HWIO_TCL_R0_GEN_CTRL_OFFS                                                                           (0x3c)
#define HWIO_TCL_R0_GEN_CTRL_RMSK                                                                           0xffffe1fb
#define HWIO_TCL_R0_GEN_CTRL_POR                                                                            0x00000000
#define HWIO_TCL_R0_GEN_CTRL_POR_RMSK                                                                       0xffffffff
#define HWIO_TCL_R0_GEN_CTRL_ATTR                                                                                        0x3
#define HWIO_TCL_R0_GEN_CTRL_IN(x)            \
                in_dword(HWIO_TCL_R0_GEN_CTRL_ADDR(x))
#define HWIO_TCL_R0_GEN_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_GEN_CTRL_ADDR(x), m)
#define HWIO_TCL_R0_GEN_CTRL_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_GEN_CTRL_ADDR(x),v)
#define HWIO_TCL_R0_GEN_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_GEN_CTRL_ADDR(x),m,v,HWIO_TCL_R0_GEN_CTRL_IN(x))
#define HWIO_TCL_R0_GEN_CTRL_WHO_CLASSIFY_INFO_OFFSET_BMSK                                                  0xffff0000
#define HWIO_TCL_R0_GEN_CTRL_WHO_CLASSIFY_INFO_OFFSET_SHFT                                                          16
#define HWIO_TCL_R0_GEN_CTRL_PROTOCOL_FROM_AH_OR_L4_BMSK                                                        0x8000
#define HWIO_TCL_R0_GEN_CTRL_PROTOCOL_FROM_AH_OR_L4_SHFT                                                            15
#define HWIO_TCL_R0_GEN_CTRL_PROTOCOL_FROM_AH_OR_ESP_BMSK                                                       0x4000
#define HWIO_TCL_R0_GEN_CTRL_PROTOCOL_FROM_AH_OR_ESP_SHFT                                                           14
#define HWIO_TCL_R0_GEN_CTRL_FLOW_TOEPLITZ_5_SEL_BMSK                                                           0x2000
#define HWIO_TCL_R0_GEN_CTRL_FLOW_TOEPLITZ_5_SEL_SHFT                                                               13
#define HWIO_TCL_R0_GEN_CTRL_CCE_UPDATE_DIS_BMSK                                                                 0x100
#define HWIO_TCL_R0_GEN_CTRL_CCE_UPDATE_DIS_SHFT                                                                     8
#define HWIO_TCL_R0_GEN_CTRL_FSE_UPDATE_DIS_BMSK                                                                  0x80
#define HWIO_TCL_R0_GEN_CTRL_FSE_UPDATE_DIS_SHFT                                                                     7
#define HWIO_TCL_R0_GEN_CTRL_ADDRY_UPDATE_DIS_BMSK                                                                0x40
#define HWIO_TCL_R0_GEN_CTRL_ADDRY_UPDATE_DIS_SHFT                                                                   6
#define HWIO_TCL_R0_GEN_CTRL_ADDRX_UPDATE_DIS_BMSK                                                                0x20
#define HWIO_TCL_R0_GEN_CTRL_ADDRX_UPDATE_DIS_SHFT                                                                   5
#define HWIO_TCL_R0_GEN_CTRL_FSE_EN_BMSK                                                                          0x10
#define HWIO_TCL_R0_GEN_CTRL_FSE_EN_SHFT                                                                             4
#define HWIO_TCL_R0_GEN_CTRL_CCE_EN_BMSK                                                                           0x8
#define HWIO_TCL_R0_GEN_CTRL_CCE_EN_SHFT                                                                             3
#define HWIO_TCL_R0_GEN_CTRL_TO_FW_BMSK                                                                            0x2
#define HWIO_TCL_R0_GEN_CTRL_TO_FW_SHFT                                                                              1
#define HWIO_TCL_R0_GEN_CTRL_EN_11AH_BMSK                                                                          0x1
#define HWIO_TCL_R0_GEN_CTRL_EN_11AH_SHFT                                                                            0

#define HWIO_TCL_R0_ENCAP_TYPE0_OPTIMUM_HEADER_LENGTH_n_ADDR(base,n)                                        ((base) + 0X40 + (0x4*(n)))
#define HWIO_TCL_R0_ENCAP_TYPE0_OPTIMUM_HEADER_LENGTH_n_PHYS(base,n)                                        ((base) + 0X40 + (0x4*(n)))
#define HWIO_TCL_R0_ENCAP_TYPE0_OPTIMUM_HEADER_LENGTH_n_OFFS(n)                                             (0X40 + (0x4*(n)))
#define HWIO_TCL_R0_ENCAP_TYPE0_OPTIMUM_HEADER_LENGTH_n_RMSK                                                0xffffffff
#define HWIO_TCL_R0_ENCAP_TYPE0_OPTIMUM_HEADER_LENGTH_n_MAXn                                                         1
#define HWIO_TCL_R0_ENCAP_TYPE0_OPTIMUM_HEADER_LENGTH_n_POR                                                 0x005a0060
#define HWIO_TCL_R0_ENCAP_TYPE0_OPTIMUM_HEADER_LENGTH_n_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_ENCAP_TYPE0_OPTIMUM_HEADER_LENGTH_n_ATTR                                                             0x3
#define HWIO_TCL_R0_ENCAP_TYPE0_OPTIMUM_HEADER_LENGTH_n_INI(base,n)                \
                in_dword_masked(HWIO_TCL_R0_ENCAP_TYPE0_OPTIMUM_HEADER_LENGTH_n_ADDR(base,n), HWIO_TCL_R0_ENCAP_TYPE0_OPTIMUM_HEADER_LENGTH_n_RMSK)
#define HWIO_TCL_R0_ENCAP_TYPE0_OPTIMUM_HEADER_LENGTH_n_INMI(base,n,mask)        \
                in_dword_masked(HWIO_TCL_R0_ENCAP_TYPE0_OPTIMUM_HEADER_LENGTH_n_ADDR(base,n), mask)
#define HWIO_TCL_R0_ENCAP_TYPE0_OPTIMUM_HEADER_LENGTH_n_OUTI(base,n,val)        \
                out_dword(HWIO_TCL_R0_ENCAP_TYPE0_OPTIMUM_HEADER_LENGTH_n_ADDR(base,n),val)
#define HWIO_TCL_R0_ENCAP_TYPE0_OPTIMUM_HEADER_LENGTH_n_OUTMI(base,n,mask,val) \
                out_dword_masked_ns(HWIO_TCL_R0_ENCAP_TYPE0_OPTIMUM_HEADER_LENGTH_n_ADDR(base,n),mask,val,HWIO_TCL_R0_ENCAP_TYPE0_OPTIMUM_HEADER_LENGTH_n_INI(base,n))
#define HWIO_TCL_R0_ENCAP_TYPE0_OPTIMUM_HEADER_LENGTH_n_NATIVE_WIFI_BMSK                                    0xffff0000
#define HWIO_TCL_R0_ENCAP_TYPE0_OPTIMUM_HEADER_LENGTH_n_NATIVE_WIFI_SHFT                                            16
#define HWIO_TCL_R0_ENCAP_TYPE0_OPTIMUM_HEADER_LENGTH_n_RAW_WIFI_BMSK                                           0xffff
#define HWIO_TCL_R0_ENCAP_TYPE0_OPTIMUM_HEADER_LENGTH_n_RAW_WIFI_SHFT                                                0

#define HWIO_TCL_R0_ENCAP_TYPE1_OPTIMUM_HEADER_LENGTH_n_ADDR(base,n)                                        ((base) + 0X48 + (0x4*(n)))
#define HWIO_TCL_R0_ENCAP_TYPE1_OPTIMUM_HEADER_LENGTH_n_PHYS(base,n)                                        ((base) + 0X48 + (0x4*(n)))
#define HWIO_TCL_R0_ENCAP_TYPE1_OPTIMUM_HEADER_LENGTH_n_OFFS(n)                                             (0X48 + (0x4*(n)))
#define HWIO_TCL_R0_ENCAP_TYPE1_OPTIMUM_HEADER_LENGTH_n_RMSK                                                0xffffffff
#define HWIO_TCL_R0_ENCAP_TYPE1_OPTIMUM_HEADER_LENGTH_n_MAXn                                                         1
#define HWIO_TCL_R0_ENCAP_TYPE1_OPTIMUM_HEADER_LENGTH_n_POR                                                 0x004a004a
#define HWIO_TCL_R0_ENCAP_TYPE1_OPTIMUM_HEADER_LENGTH_n_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_ENCAP_TYPE1_OPTIMUM_HEADER_LENGTH_n_ATTR                                                             0x3
#define HWIO_TCL_R0_ENCAP_TYPE1_OPTIMUM_HEADER_LENGTH_n_INI(base,n)                \
                in_dword_masked(HWIO_TCL_R0_ENCAP_TYPE1_OPTIMUM_HEADER_LENGTH_n_ADDR(base,n), HWIO_TCL_R0_ENCAP_TYPE1_OPTIMUM_HEADER_LENGTH_n_RMSK)
#define HWIO_TCL_R0_ENCAP_TYPE1_OPTIMUM_HEADER_LENGTH_n_INMI(base,n,mask)        \
                in_dword_masked(HWIO_TCL_R0_ENCAP_TYPE1_OPTIMUM_HEADER_LENGTH_n_ADDR(base,n), mask)
#define HWIO_TCL_R0_ENCAP_TYPE1_OPTIMUM_HEADER_LENGTH_n_OUTI(base,n,val)        \
                out_dword(HWIO_TCL_R0_ENCAP_TYPE1_OPTIMUM_HEADER_LENGTH_n_ADDR(base,n),val)
#define HWIO_TCL_R0_ENCAP_TYPE1_OPTIMUM_HEADER_LENGTH_n_OUTMI(base,n,mask,val) \
                out_dword_masked_ns(HWIO_TCL_R0_ENCAP_TYPE1_OPTIMUM_HEADER_LENGTH_n_ADDR(base,n),mask,val,HWIO_TCL_R0_ENCAP_TYPE1_OPTIMUM_HEADER_LENGTH_n_INI(base,n))
#define HWIO_TCL_R0_ENCAP_TYPE1_OPTIMUM_HEADER_LENGTH_n_IEEE_802_BMSK                                       0xffff0000
#define HWIO_TCL_R0_ENCAP_TYPE1_OPTIMUM_HEADER_LENGTH_n_IEEE_802_SHFT                                               16
#define HWIO_TCL_R0_ENCAP_TYPE1_OPTIMUM_HEADER_LENGTH_n_ETHERNET_II_BMSK                                        0xffff
#define HWIO_TCL_R0_ENCAP_TYPE1_OPTIMUM_HEADER_LENGTH_n_ETHERNET_II_SHFT                                             0

#define HWIO_TCL_R0_ENCAP_TYPE0_MIN_BUFFER_LENGTH_ERR_ADDR(x)                                               ((x) + 0x50)
#define HWIO_TCL_R0_ENCAP_TYPE0_MIN_BUFFER_LENGTH_ERR_PHYS(x)                                               ((x) + 0x50)
#define HWIO_TCL_R0_ENCAP_TYPE0_MIN_BUFFER_LENGTH_ERR_OFFS                                                  (0x50)
#define HWIO_TCL_R0_ENCAP_TYPE0_MIN_BUFFER_LENGTH_ERR_RMSK                                                  0xffffffff
#define HWIO_TCL_R0_ENCAP_TYPE0_MIN_BUFFER_LENGTH_ERR_POR                                                   0x00300036
#define HWIO_TCL_R0_ENCAP_TYPE0_MIN_BUFFER_LENGTH_ERR_POR_RMSK                                              0xffffffff
#define HWIO_TCL_R0_ENCAP_TYPE0_MIN_BUFFER_LENGTH_ERR_ATTR                                                               0x3
#define HWIO_TCL_R0_ENCAP_TYPE0_MIN_BUFFER_LENGTH_ERR_IN(x)            \
                in_dword(HWIO_TCL_R0_ENCAP_TYPE0_MIN_BUFFER_LENGTH_ERR_ADDR(x))
#define HWIO_TCL_R0_ENCAP_TYPE0_MIN_BUFFER_LENGTH_ERR_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_ENCAP_TYPE0_MIN_BUFFER_LENGTH_ERR_ADDR(x), m)
#define HWIO_TCL_R0_ENCAP_TYPE0_MIN_BUFFER_LENGTH_ERR_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_ENCAP_TYPE0_MIN_BUFFER_LENGTH_ERR_ADDR(x),v)
#define HWIO_TCL_R0_ENCAP_TYPE0_MIN_BUFFER_LENGTH_ERR_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_ENCAP_TYPE0_MIN_BUFFER_LENGTH_ERR_ADDR(x),m,v,HWIO_TCL_R0_ENCAP_TYPE0_MIN_BUFFER_LENGTH_ERR_IN(x))
#define HWIO_TCL_R0_ENCAP_TYPE0_MIN_BUFFER_LENGTH_ERR_NATIVE_WIFI_BMSK                                      0xffff0000
#define HWIO_TCL_R0_ENCAP_TYPE0_MIN_BUFFER_LENGTH_ERR_NATIVE_WIFI_SHFT                                              16
#define HWIO_TCL_R0_ENCAP_TYPE0_MIN_BUFFER_LENGTH_ERR_RAW_WIFI_BMSK                                             0xffff
#define HWIO_TCL_R0_ENCAP_TYPE0_MIN_BUFFER_LENGTH_ERR_RAW_WIFI_SHFT                                                  0

#define HWIO_TCL_R0_ENCAP_TYPE1_MIN_BUFFER_LENGTH_ERR_ADDR(x)                                               ((x) + 0x54)
#define HWIO_TCL_R0_ENCAP_TYPE1_MIN_BUFFER_LENGTH_ERR_PHYS(x)                                               ((x) + 0x54)
#define HWIO_TCL_R0_ENCAP_TYPE1_MIN_BUFFER_LENGTH_ERR_OFFS                                                  (0x54)
#define HWIO_TCL_R0_ENCAP_TYPE1_MIN_BUFFER_LENGTH_ERR_RMSK                                                  0xffffffff
#define HWIO_TCL_R0_ENCAP_TYPE1_MIN_BUFFER_LENGTH_ERR_POR                                                   0x001a001a
#define HWIO_TCL_R0_ENCAP_TYPE1_MIN_BUFFER_LENGTH_ERR_POR_RMSK                                              0xffffffff
#define HWIO_TCL_R0_ENCAP_TYPE1_MIN_BUFFER_LENGTH_ERR_ATTR                                                               0x3
#define HWIO_TCL_R0_ENCAP_TYPE1_MIN_BUFFER_LENGTH_ERR_IN(x)            \
                in_dword(HWIO_TCL_R0_ENCAP_TYPE1_MIN_BUFFER_LENGTH_ERR_ADDR(x))
#define HWIO_TCL_R0_ENCAP_TYPE1_MIN_BUFFER_LENGTH_ERR_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_ENCAP_TYPE1_MIN_BUFFER_LENGTH_ERR_ADDR(x), m)
#define HWIO_TCL_R0_ENCAP_TYPE1_MIN_BUFFER_LENGTH_ERR_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_ENCAP_TYPE1_MIN_BUFFER_LENGTH_ERR_ADDR(x),v)
#define HWIO_TCL_R0_ENCAP_TYPE1_MIN_BUFFER_LENGTH_ERR_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_ENCAP_TYPE1_MIN_BUFFER_LENGTH_ERR_ADDR(x),m,v,HWIO_TCL_R0_ENCAP_TYPE1_MIN_BUFFER_LENGTH_ERR_IN(x))
#define HWIO_TCL_R0_ENCAP_TYPE1_MIN_BUFFER_LENGTH_ERR_IEEE_802_BMSK                                         0xffff0000
#define HWIO_TCL_R0_ENCAP_TYPE1_MIN_BUFFER_LENGTH_ERR_IEEE_802_SHFT                                                 16
#define HWIO_TCL_R0_ENCAP_TYPE1_MIN_BUFFER_LENGTH_ERR_ETHERNET_II_BMSK                                          0xffff
#define HWIO_TCL_R0_ENCAP_TYPE1_MIN_BUFFER_LENGTH_ERR_ETHERNET_II_SHFT                                               0

#define HWIO_TCL_R0_UMXI_PRIORITY0_ADDR(x)                                                                  ((x) + 0x58)
#define HWIO_TCL_R0_UMXI_PRIORITY0_PHYS(x)                                                                  ((x) + 0x58)
#define HWIO_TCL_R0_UMXI_PRIORITY0_OFFS                                                                     (0x58)
#define HWIO_TCL_R0_UMXI_PRIORITY0_RMSK                                                                     0xff3f3cff
#define HWIO_TCL_R0_UMXI_PRIORITY0_POR                                                                      0x55000000
#define HWIO_TCL_R0_UMXI_PRIORITY0_POR_RMSK                                                                 0xffffffff
#define HWIO_TCL_R0_UMXI_PRIORITY0_ATTR                                                                                  0x3
#define HWIO_TCL_R0_UMXI_PRIORITY0_IN(x)            \
                in_dword(HWIO_TCL_R0_UMXI_PRIORITY0_ADDR(x))
#define HWIO_TCL_R0_UMXI_PRIORITY0_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_UMXI_PRIORITY0_ADDR(x), m)
#define HWIO_TCL_R0_UMXI_PRIORITY0_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_UMXI_PRIORITY0_ADDR(x),v)
#define HWIO_TCL_R0_UMXI_PRIORITY0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_UMXI_PRIORITY0_ADDR(x),m,v,HWIO_TCL_R0_UMXI_PRIORITY0_IN(x))
#define HWIO_TCL_R0_UMXI_PRIORITY0_METADATA_FETCH_GXI_RD_BMSK                                               0xc0000000
#define HWIO_TCL_R0_UMXI_PRIORITY0_METADATA_FETCH_GXI_RD_SHFT                                                       30
#define HWIO_TCL_R0_UMXI_PRIORITY0_PEER_TABLE_FETCH_GXI_RD_BMSK                                             0x30000000
#define HWIO_TCL_R0_UMXI_PRIORITY0_PEER_TABLE_FETCH_GXI_RD_SHFT                                                     28
#define HWIO_TCL_R0_UMXI_PRIORITY0_DATA_FETCH_GXI_RD_BMSK                                                    0xc000000
#define HWIO_TCL_R0_UMXI_PRIORITY0_DATA_FETCH_GXI_RD_SHFT                                                           26
#define HWIO_TCL_R0_UMXI_PRIORITY0_EXTN_DESC_GXI_RD_BMSK                                                     0x3000000
#define HWIO_TCL_R0_UMXI_PRIORITY0_EXTN_DESC_GXI_RD_SHFT                                                            24
#define HWIO_TCL_R0_UMXI_PRIORITY0_TCL_STATUS1_RING_BMSK                                                      0x300000
#define HWIO_TCL_R0_UMXI_PRIORITY0_TCL_STATUS1_RING_SHFT                                                            20
#define HWIO_TCL_R0_UMXI_PRIORITY0_TCL2FW_RING_BMSK                                                            0xc0000
#define HWIO_TCL_R0_UMXI_PRIORITY0_TCL2FW_RING_SHFT                                                                 18
#define HWIO_TCL_R0_UMXI_PRIORITY0_TCL2TQM_RING_BMSK                                                           0x30000
#define HWIO_TCL_R0_UMXI_PRIORITY0_TCL2TQM_RING_SHFT                                                                16
#define HWIO_TCL_R0_UMXI_PRIORITY0_SW2TCL_CREDIT_RING_BMSK                                                      0x3000
#define HWIO_TCL_R0_UMXI_PRIORITY0_SW2TCL_CREDIT_RING_SHFT                                                          12
#define HWIO_TCL_R0_UMXI_PRIORITY0_FW2TCL_RING_BMSK                                                              0xc00
#define HWIO_TCL_R0_UMXI_PRIORITY0_FW2TCL_RING_SHFT                                                                 10
#define HWIO_TCL_R0_UMXI_PRIORITY0_SW2TCL4_RING_BMSK                                                              0xc0
#define HWIO_TCL_R0_UMXI_PRIORITY0_SW2TCL4_RING_SHFT                                                                 6
#define HWIO_TCL_R0_UMXI_PRIORITY0_SW2TCL3_RING_BMSK                                                              0x30
#define HWIO_TCL_R0_UMXI_PRIORITY0_SW2TCL3_RING_SHFT                                                                 4
#define HWIO_TCL_R0_UMXI_PRIORITY0_SW2TCL2_RING_BMSK                                                               0xc
#define HWIO_TCL_R0_UMXI_PRIORITY0_SW2TCL2_RING_SHFT                                                                 2
#define HWIO_TCL_R0_UMXI_PRIORITY0_SW2TCL1_RING_BMSK                                                               0x3
#define HWIO_TCL_R0_UMXI_PRIORITY0_SW2TCL1_RING_SHFT                                                                 0

#define HWIO_TCL_R0_UMXI_PRIORITY1_ADDR(x)                                                                  ((x) + 0x5c)
#define HWIO_TCL_R0_UMXI_PRIORITY1_PHYS(x)                                                                  ((x) + 0x5c)
#define HWIO_TCL_R0_UMXI_PRIORITY1_OFFS                                                                     (0x5c)
#define HWIO_TCL_R0_UMXI_PRIORITY1_RMSK                                                                            0xf
#define HWIO_TCL_R0_UMXI_PRIORITY1_POR                                                                      0x00000005
#define HWIO_TCL_R0_UMXI_PRIORITY1_POR_RMSK                                                                 0xffffffff
#define HWIO_TCL_R0_UMXI_PRIORITY1_ATTR                                                                                  0x3
#define HWIO_TCL_R0_UMXI_PRIORITY1_IN(x)            \
                in_dword(HWIO_TCL_R0_UMXI_PRIORITY1_ADDR(x))
#define HWIO_TCL_R0_UMXI_PRIORITY1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_UMXI_PRIORITY1_ADDR(x), m)
#define HWIO_TCL_R0_UMXI_PRIORITY1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_UMXI_PRIORITY1_ADDR(x),v)
#define HWIO_TCL_R0_UMXI_PRIORITY1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_UMXI_PRIORITY1_ADDR(x),m,v,HWIO_TCL_R0_UMXI_PRIORITY1_IN(x))
#define HWIO_TCL_R0_UMXI_PRIORITY1_ASE_STAT_GXI_WR_BMSK                                                            0xc
#define HWIO_TCL_R0_UMXI_PRIORITY1_ASE_STAT_GXI_WR_SHFT                                                              2
#define HWIO_TCL_R0_UMXI_PRIORITY1_ASE_LOOKUP_GXI_RD_BMSK                                                          0x3
#define HWIO_TCL_R0_UMXI_PRIORITY1_ASE_LOOKUP_GXI_RD_SHFT                                                            0

#define HWIO_TCL_R0_VC_ID_MAP_ADDR(x)                                                                       ((x) + 0x60)
#define HWIO_TCL_R0_VC_ID_MAP_PHYS(x)                                                                       ((x) + 0x60)
#define HWIO_TCL_R0_VC_ID_MAP_OFFS                                                                          (0x60)
#define HWIO_TCL_R0_VC_ID_MAP_RMSK                                                                               0xf6f
#define HWIO_TCL_R0_VC_ID_MAP_POR                                                                           0x00000f00
#define HWIO_TCL_R0_VC_ID_MAP_POR_RMSK                                                                      0xffffffff
#define HWIO_TCL_R0_VC_ID_MAP_ATTR                                                                                       0x3
#define HWIO_TCL_R0_VC_ID_MAP_IN(x)            \
                in_dword(HWIO_TCL_R0_VC_ID_MAP_ADDR(x))
#define HWIO_TCL_R0_VC_ID_MAP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_VC_ID_MAP_ADDR(x), m)
#define HWIO_TCL_R0_VC_ID_MAP_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_VC_ID_MAP_ADDR(x),v)
#define HWIO_TCL_R0_VC_ID_MAP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_VC_ID_MAP_ADDR(x),m,v,HWIO_TCL_R0_VC_ID_MAP_IN(x))
#define HWIO_TCL_R0_VC_ID_MAP_METADATA_FETCH_GXI_RD_BMSK                                                         0x800
#define HWIO_TCL_R0_VC_ID_MAP_METADATA_FETCH_GXI_RD_SHFT                                                            11
#define HWIO_TCL_R0_VC_ID_MAP_PEER_TABLE_FETCH_GXI_RD_BMSK                                                       0x400
#define HWIO_TCL_R0_VC_ID_MAP_PEER_TABLE_FETCH_GXI_RD_SHFT                                                          10
#define HWIO_TCL_R0_VC_ID_MAP_DATA_FETCH_GXI_RD_BMSK                                                             0x200
#define HWIO_TCL_R0_VC_ID_MAP_DATA_FETCH_GXI_RD_SHFT                                                                 9
#define HWIO_TCL_R0_VC_ID_MAP_EXTN_DESC_GXI_RD_BMSK                                                              0x100
#define HWIO_TCL_R0_VC_ID_MAP_EXTN_DESC_GXI_RD_SHFT                                                                  8
#define HWIO_TCL_R0_VC_ID_MAP_SW2TCL_CREDIT_RING_BMSK                                                             0x40
#define HWIO_TCL_R0_VC_ID_MAP_SW2TCL_CREDIT_RING_SHFT                                                                6
#define HWIO_TCL_R0_VC_ID_MAP_FW2TCL_RING_BMSK                                                                    0x20
#define HWIO_TCL_R0_VC_ID_MAP_FW2TCL_RING_SHFT                                                                       5
#define HWIO_TCL_R0_VC_ID_MAP_SW2TCL4_RING_BMSK                                                                    0x8
#define HWIO_TCL_R0_VC_ID_MAP_SW2TCL4_RING_SHFT                                                                      3
#define HWIO_TCL_R0_VC_ID_MAP_SW2TCL3_RING_BMSK                                                                    0x4
#define HWIO_TCL_R0_VC_ID_MAP_SW2TCL3_RING_SHFT                                                                      2
#define HWIO_TCL_R0_VC_ID_MAP_SW2TCL2_RING_BMSK                                                                    0x2
#define HWIO_TCL_R0_VC_ID_MAP_SW2TCL2_RING_SHFT                                                                      1
#define HWIO_TCL_R0_VC_ID_MAP_SW2TCL1_RING_BMSK                                                                    0x1
#define HWIO_TCL_R0_VC_ID_MAP_SW2TCL1_RING_SHFT                                                                      0

#define HWIO_TCL_R0_SW2TCL1_DESC_RD_ADDR(x)                                                                 ((x) + 0x68)
#define HWIO_TCL_R0_SW2TCL1_DESC_RD_PHYS(x)                                                                 ((x) + 0x68)
#define HWIO_TCL_R0_SW2TCL1_DESC_RD_OFFS                                                                    (0x68)
#define HWIO_TCL_R0_SW2TCL1_DESC_RD_RMSK                                                                        0x1fff
#define HWIO_TCL_R0_SW2TCL1_DESC_RD_POR                                                                     0x00000002
#define HWIO_TCL_R0_SW2TCL1_DESC_RD_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R0_SW2TCL1_DESC_RD_ATTR                                                                                 0x3
#define HWIO_TCL_R0_SW2TCL1_DESC_RD_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_DESC_RD_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_DESC_RD_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_DESC_RD_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_DESC_RD_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_DESC_RD_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_DESC_RD_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_DESC_RD_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_DESC_RD_IN(x))
#define HWIO_TCL_R0_SW2TCL1_DESC_RD_TIMEOUT_LIMIT_BMSK                                                          0x1fe0
#define HWIO_TCL_R0_SW2TCL1_DESC_RD_TIMEOUT_LIMIT_SHFT                                                               5
#define HWIO_TCL_R0_SW2TCL1_DESC_RD_BUNCH_COUNT_BMSK                                                              0x1f
#define HWIO_TCL_R0_SW2TCL1_DESC_RD_BUNCH_COUNT_SHFT                                                                 0

#define HWIO_TCL_R0_SW2TCL2_DESC_RD_ADDR(x)                                                                 ((x) + 0x6c)
#define HWIO_TCL_R0_SW2TCL2_DESC_RD_PHYS(x)                                                                 ((x) + 0x6c)
#define HWIO_TCL_R0_SW2TCL2_DESC_RD_OFFS                                                                    (0x6c)
#define HWIO_TCL_R0_SW2TCL2_DESC_RD_RMSK                                                                        0x1fff
#define HWIO_TCL_R0_SW2TCL2_DESC_RD_POR                                                                     0x00000002
#define HWIO_TCL_R0_SW2TCL2_DESC_RD_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R0_SW2TCL2_DESC_RD_ATTR                                                                                 0x3
#define HWIO_TCL_R0_SW2TCL2_DESC_RD_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_DESC_RD_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_DESC_RD_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_DESC_RD_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_DESC_RD_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_DESC_RD_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_DESC_RD_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_DESC_RD_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_DESC_RD_IN(x))
#define HWIO_TCL_R0_SW2TCL2_DESC_RD_TIMEOUT_LIMIT_BMSK                                                          0x1fe0
#define HWIO_TCL_R0_SW2TCL2_DESC_RD_TIMEOUT_LIMIT_SHFT                                                               5
#define HWIO_TCL_R0_SW2TCL2_DESC_RD_BUNCH_COUNT_BMSK                                                              0x1f
#define HWIO_TCL_R0_SW2TCL2_DESC_RD_BUNCH_COUNT_SHFT                                                                 0

#define HWIO_TCL_R0_SW2TCL3_DESC_RD_ADDR(x)                                                                 ((x) + 0x70)
#define HWIO_TCL_R0_SW2TCL3_DESC_RD_PHYS(x)                                                                 ((x) + 0x70)
#define HWIO_TCL_R0_SW2TCL3_DESC_RD_OFFS                                                                    (0x70)
#define HWIO_TCL_R0_SW2TCL3_DESC_RD_RMSK                                                                        0x1fff
#define HWIO_TCL_R0_SW2TCL3_DESC_RD_POR                                                                     0x00000002
#define HWIO_TCL_R0_SW2TCL3_DESC_RD_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R0_SW2TCL3_DESC_RD_ATTR                                                                                 0x3
#define HWIO_TCL_R0_SW2TCL3_DESC_RD_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_DESC_RD_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_DESC_RD_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_DESC_RD_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_DESC_RD_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_DESC_RD_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_DESC_RD_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_DESC_RD_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_DESC_RD_IN(x))
#define HWIO_TCL_R0_SW2TCL3_DESC_RD_TIMEOUT_LIMIT_BMSK                                                          0x1fe0
#define HWIO_TCL_R0_SW2TCL3_DESC_RD_TIMEOUT_LIMIT_SHFT                                                               5
#define HWIO_TCL_R0_SW2TCL3_DESC_RD_BUNCH_COUNT_BMSK                                                              0x1f
#define HWIO_TCL_R0_SW2TCL3_DESC_RD_BUNCH_COUNT_SHFT                                                                 0

#define HWIO_TCL_R0_SW2TCL4_DESC_RD_ADDR(x)                                                                 ((x) + 0x74)
#define HWIO_TCL_R0_SW2TCL4_DESC_RD_PHYS(x)                                                                 ((x) + 0x74)
#define HWIO_TCL_R0_SW2TCL4_DESC_RD_OFFS                                                                    (0x74)
#define HWIO_TCL_R0_SW2TCL4_DESC_RD_RMSK                                                                        0x1fff
#define HWIO_TCL_R0_SW2TCL4_DESC_RD_POR                                                                     0x00000002
#define HWIO_TCL_R0_SW2TCL4_DESC_RD_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R0_SW2TCL4_DESC_RD_ATTR                                                                                 0x3
#define HWIO_TCL_R0_SW2TCL4_DESC_RD_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_DESC_RD_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_DESC_RD_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_DESC_RD_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_DESC_RD_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_DESC_RD_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_DESC_RD_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_DESC_RD_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_DESC_RD_IN(x))
#define HWIO_TCL_R0_SW2TCL4_DESC_RD_TIMEOUT_LIMIT_BMSK                                                          0x1fe0
#define HWIO_TCL_R0_SW2TCL4_DESC_RD_TIMEOUT_LIMIT_SHFT                                                               5
#define HWIO_TCL_R0_SW2TCL4_DESC_RD_BUNCH_COUNT_BMSK                                                              0x1f
#define HWIO_TCL_R0_SW2TCL4_DESC_RD_BUNCH_COUNT_SHFT                                                                 0

#define HWIO_TCL_R0_FW2TCL_DESC_RD_ADDR(x)                                                                  ((x) + 0x7c)
#define HWIO_TCL_R0_FW2TCL_DESC_RD_PHYS(x)                                                                  ((x) + 0x7c)
#define HWIO_TCL_R0_FW2TCL_DESC_RD_OFFS                                                                     (0x7c)
#define HWIO_TCL_R0_FW2TCL_DESC_RD_RMSK                                                                         0x1fff
#define HWIO_TCL_R0_FW2TCL_DESC_RD_POR                                                                      0x00000002
#define HWIO_TCL_R0_FW2TCL_DESC_RD_POR_RMSK                                                                 0xffffffff
#define HWIO_TCL_R0_FW2TCL_DESC_RD_ATTR                                                                                  0x3
#define HWIO_TCL_R0_FW2TCL_DESC_RD_IN(x)            \
                in_dword(HWIO_TCL_R0_FW2TCL_DESC_RD_ADDR(x))
#define HWIO_TCL_R0_FW2TCL_DESC_RD_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_FW2TCL_DESC_RD_ADDR(x), m)
#define HWIO_TCL_R0_FW2TCL_DESC_RD_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_FW2TCL_DESC_RD_ADDR(x),v)
#define HWIO_TCL_R0_FW2TCL_DESC_RD_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_FW2TCL_DESC_RD_ADDR(x),m,v,HWIO_TCL_R0_FW2TCL_DESC_RD_IN(x))
#define HWIO_TCL_R0_FW2TCL_DESC_RD_TIMEOUT_LIMIT_BMSK                                                           0x1fe0
#define HWIO_TCL_R0_FW2TCL_DESC_RD_TIMEOUT_LIMIT_SHFT                                                                5
#define HWIO_TCL_R0_FW2TCL_DESC_RD_BUNCH_COUNT_BMSK                                                               0x1f
#define HWIO_TCL_R0_FW2TCL_DESC_RD_BUNCH_COUNT_SHFT                                                                  0

#define HWIO_TCL_R0_SW2TCL_CREDIT_DESC_RD_ADDR(x)                                                           ((x) + 0x80)
#define HWIO_TCL_R0_SW2TCL_CREDIT_DESC_RD_PHYS(x)                                                           ((x) + 0x80)
#define HWIO_TCL_R0_SW2TCL_CREDIT_DESC_RD_OFFS                                                              (0x80)
#define HWIO_TCL_R0_SW2TCL_CREDIT_DESC_RD_RMSK                                                                  0x1fff
#define HWIO_TCL_R0_SW2TCL_CREDIT_DESC_RD_POR                                                               0x00000002
#define HWIO_TCL_R0_SW2TCL_CREDIT_DESC_RD_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_DESC_RD_ATTR                                                                           0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_DESC_RD_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_DESC_RD_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_DESC_RD_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_DESC_RD_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_DESC_RD_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_DESC_RD_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_DESC_RD_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_DESC_RD_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_DESC_RD_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_DESC_RD_TIMEOUT_LIMIT_BMSK                                                    0x1fe0
#define HWIO_TCL_R0_SW2TCL_CREDIT_DESC_RD_TIMEOUT_LIMIT_SHFT                                                         5
#define HWIO_TCL_R0_SW2TCL_CREDIT_DESC_RD_BUNCH_COUNT_BMSK                                                        0x1f
#define HWIO_TCL_R0_SW2TCL_CREDIT_DESC_RD_BUNCH_COUNT_SHFT                                                           0

#define HWIO_TCL_R0_RBM_MAPPING0_ADDR(x)                                                                    ((x) + 0x88)
#define HWIO_TCL_R0_RBM_MAPPING0_PHYS(x)                                                                    ((x) + 0x88)
#define HWIO_TCL_R0_RBM_MAPPING0_OFFS                                                                       (0x88)
#define HWIO_TCL_R0_RBM_MAPPING0_RMSK                                                                        0xff0ffff
#define HWIO_TCL_R0_RBM_MAPPING0_POR                                                                        0x00000000
#define HWIO_TCL_R0_RBM_MAPPING0_POR_RMSK                                                                   0xffffffff
#define HWIO_TCL_R0_RBM_MAPPING0_ATTR                                                                                    0x3
#define HWIO_TCL_R0_RBM_MAPPING0_IN(x)            \
                in_dword(HWIO_TCL_R0_RBM_MAPPING0_ADDR(x))
#define HWIO_TCL_R0_RBM_MAPPING0_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_RBM_MAPPING0_ADDR(x), m)
#define HWIO_TCL_R0_RBM_MAPPING0_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_RBM_MAPPING0_ADDR(x),v)
#define HWIO_TCL_R0_RBM_MAPPING0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_RBM_MAPPING0_ADDR(x),m,v,HWIO_TCL_R0_RBM_MAPPING0_IN(x))
#define HWIO_TCL_R0_RBM_MAPPING0_SW2TCL_CREDIT_RING_BMSK                                                     0xf000000
#define HWIO_TCL_R0_RBM_MAPPING0_SW2TCL_CREDIT_RING_SHFT                                                            24
#define HWIO_TCL_R0_RBM_MAPPING0_FW2TCL_RING_BMSK                                                             0xf00000
#define HWIO_TCL_R0_RBM_MAPPING0_FW2TCL_RING_SHFT                                                                   20
#define HWIO_TCL_R0_RBM_MAPPING0_SW2TCL4_RING_BMSK                                                              0xf000
#define HWIO_TCL_R0_RBM_MAPPING0_SW2TCL4_RING_SHFT                                                                  12
#define HWIO_TCL_R0_RBM_MAPPING0_SW2TCL3_RING_BMSK                                                               0xf00
#define HWIO_TCL_R0_RBM_MAPPING0_SW2TCL3_RING_SHFT                                                                   8
#define HWIO_TCL_R0_RBM_MAPPING0_SW2TCL2_RING_BMSK                                                                0xf0
#define HWIO_TCL_R0_RBM_MAPPING0_SW2TCL2_RING_SHFT                                                                   4
#define HWIO_TCL_R0_RBM_MAPPING0_SW2TCL1_RING_BMSK                                                                 0xf
#define HWIO_TCL_R0_RBM_MAPPING0_SW2TCL1_RING_SHFT                                                                   0

#define HWIO_TCL_R0_SW_CONFIG_BANK_n_ADDR(base,n)                                                           ((base) + 0X8C + (0x4*(n)))
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_PHYS(base,n)                                                           ((base) + 0X8C + (0x4*(n)))
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_OFFS(n)                                                                (0X8C + (0x4*(n)))
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_RMSK                                                                     0x7fffff
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_MAXn                                                                           23
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_POR                                                                    0x00000038
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_POR_RMSK                                                               0xffffffff
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_ATTR                                                                                0x3
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_INI(base,n)                \
                in_dword_masked(HWIO_TCL_R0_SW_CONFIG_BANK_n_ADDR(base,n), HWIO_TCL_R0_SW_CONFIG_BANK_n_RMSK)
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_INMI(base,n,mask)        \
                in_dword_masked(HWIO_TCL_R0_SW_CONFIG_BANK_n_ADDR(base,n), mask)
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_OUTI(base,n,val)        \
                out_dword(HWIO_TCL_R0_SW_CONFIG_BANK_n_ADDR(base,n),val)
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_OUTMI(base,n,mask,val) \
                out_dword_masked_ns(HWIO_TCL_R0_SW_CONFIG_BANK_n_ADDR(base,n),mask,val,HWIO_TCL_R0_SW_CONFIG_BANK_n_INI(base,n))
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_DSCP_TID_TABLE_NUM_BMSK                                                  0x7e0000
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_DSCP_TID_TABLE_NUM_SHFT                                                        17
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_PMAC_ID_BMSK                                                              0x18000
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_PMAC_ID_SHFT                                                                   15
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_VDEV_ID_CHECK_EN_BMSK                                                      0x4000
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_VDEV_ID_CHECK_EN_SHFT                                                          14
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_MESH_ENABLE_BMSK                                                           0x3000
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_MESH_ENABLE_SHFT                                                               12
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_ADDRY_EN_BMSK                                                               0x800
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_ADDRY_EN_SHFT                                                                  11
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_ADDRX_EN_BMSK                                                               0x400
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_ADDRX_EN_SHFT                                                                  10
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_INDEX_LOOKUP_ENABLE_BMSK                                                    0x200
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_INDEX_LOOKUP_ENABLE_SHFT                                                        9
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_LINK_META_SWAP_BMSK                                                         0x100
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_LINK_META_SWAP_SHFT                                                             8
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_SRC_BUFFER_SWAP_BMSK                                                         0x80
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_SRC_BUFFER_SWAP_SHFT                                                            7
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_ENCRYPT_TYPE_BMSK                                                            0x78
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_ENCRYPT_TYPE_SHFT                                                               3
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_ENCAP_TYPE_BMSK                                                               0x6
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_ENCAP_TYPE_SHFT                                                                 1
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_EPD_BMSK                                                                      0x1
#define HWIO_TCL_R0_SW_CONFIG_BANK_n_EPD_SHFT                                                                        0

#define HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_ADDR(base,n)                                               ((base) + 0X14C + (0x4*(n)))
#define HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_PHYS(base,n)                                               ((base) + 0X14C + (0x4*(n)))
#define HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_OFFS(n)                                                    (0X14C + (0x4*(n)))
#define HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_MAXn                                                               15
#define HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_POR                                                        0x00000000
#define HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_POR_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_ATTR                                                                    0x3
#define HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_INI(base,n)                \
                in_dword_masked(HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_ADDR(base,n), HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_RMSK)
#define HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_INMI(base,n,mask)        \
                in_dword_masked(HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_ADDR(base,n), mask)
#define HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_OUTI(base,n,val)        \
                out_dword(HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_ADDR(base,n),val)
#define HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_OUTMI(base,n,mask,val) \
                out_dword_masked_ns(HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_ADDR(base,n),mask,val,HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_INI(base,n))
#define HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_VAL_BMSK                                                   0xffffffff
#define HWIO_TCL_R0_VDEV_MCAST_PACKET_CTRL_MAP_n_VAL_SHFT                                                            0

#define HWIO_TCL_R0_MCAST_ECHO_CHECK_ADDR(x)                                                                ((x) + 0x18c)
#define HWIO_TCL_R0_MCAST_ECHO_CHECK_PHYS(x)                                                                ((x) + 0x18c)
#define HWIO_TCL_R0_MCAST_ECHO_CHECK_OFFS                                                                   (0x18c)
#define HWIO_TCL_R0_MCAST_ECHO_CHECK_RMSK                                                                   0xffffffff
#define HWIO_TCL_R0_MCAST_ECHO_CHECK_POR                                                                    0x00000064
#define HWIO_TCL_R0_MCAST_ECHO_CHECK_POR_RMSK                                                               0xffffffff
#define HWIO_TCL_R0_MCAST_ECHO_CHECK_ATTR                                                                                0x3
#define HWIO_TCL_R0_MCAST_ECHO_CHECK_IN(x)            \
                in_dword(HWIO_TCL_R0_MCAST_ECHO_CHECK_ADDR(x))
#define HWIO_TCL_R0_MCAST_ECHO_CHECK_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_MCAST_ECHO_CHECK_ADDR(x), m)
#define HWIO_TCL_R0_MCAST_ECHO_CHECK_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_MCAST_ECHO_CHECK_ADDR(x),v)
#define HWIO_TCL_R0_MCAST_ECHO_CHECK_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_MCAST_ECHO_CHECK_ADDR(x),m,v,HWIO_TCL_R0_MCAST_ECHO_CHECK_IN(x))
#define HWIO_TCL_R0_MCAST_ECHO_CHECK_TIMESTAMP_AGEING_BMSK                                                  0xffffffff
#define HWIO_TCL_R0_MCAST_ECHO_CHECK_TIMESTAMP_AGEING_SHFT                                                           0

#define HWIO_TCL_R0_DSCP_TID_MAP_n_ADDR(base,n)                                                             ((base) + 0X240 + (0x4*(n)))
#define HWIO_TCL_R0_DSCP_TID_MAP_n_PHYS(base,n)                                                             ((base) + 0X240 + (0x4*(n)))
#define HWIO_TCL_R0_DSCP_TID_MAP_n_OFFS(n)                                                                  (0X240 + (0x4*(n)))
#define HWIO_TCL_R0_DSCP_TID_MAP_n_RMSK                                                                     0xffffffff
#define HWIO_TCL_R0_DSCP_TID_MAP_n_MAXn                                                                            143
#define HWIO_TCL_R0_DSCP_TID_MAP_n_POR                                                                      0x00000000
#define HWIO_TCL_R0_DSCP_TID_MAP_n_POR_RMSK                                                                 0xffffffff
#define HWIO_TCL_R0_DSCP_TID_MAP_n_ATTR                                                                                  0x3
#define HWIO_TCL_R0_DSCP_TID_MAP_n_INI(base,n)                \
                in_dword_masked(HWIO_TCL_R0_DSCP_TID_MAP_n_ADDR(base,n), HWIO_TCL_R0_DSCP_TID_MAP_n_RMSK)
#define HWIO_TCL_R0_DSCP_TID_MAP_n_INMI(base,n,mask)        \
                in_dword_masked(HWIO_TCL_R0_DSCP_TID_MAP_n_ADDR(base,n), mask)
#define HWIO_TCL_R0_DSCP_TID_MAP_n_OUTI(base,n,val)        \
                out_dword(HWIO_TCL_R0_DSCP_TID_MAP_n_ADDR(base,n),val)
#define HWIO_TCL_R0_DSCP_TID_MAP_n_OUTMI(base,n,mask,val) \
                out_dword_masked_ns(HWIO_TCL_R0_DSCP_TID_MAP_n_ADDR(base,n),mask,val,HWIO_TCL_R0_DSCP_TID_MAP_n_INI(base,n))
#define HWIO_TCL_R0_DSCP_TID_MAP_n_VAL_BMSK                                                                 0xffffffff
#define HWIO_TCL_R0_DSCP_TID_MAP_n_VAL_SHFT                                                                          0

#define HWIO_TCL_R0_PCP_TID_MAP_ADDR(x)                                                                     ((x) + 0x6c0)
#define HWIO_TCL_R0_PCP_TID_MAP_PHYS(x)                                                                     ((x) + 0x6c0)
#define HWIO_TCL_R0_PCP_TID_MAP_OFFS                                                                        (0x6c0)
#define HWIO_TCL_R0_PCP_TID_MAP_RMSK                                                                          0xffffff
#define HWIO_TCL_R0_PCP_TID_MAP_POR                                                                         0x00000000
#define HWIO_TCL_R0_PCP_TID_MAP_POR_RMSK                                                                    0xffffffff
#define HWIO_TCL_R0_PCP_TID_MAP_ATTR                                                                                     0x3
#define HWIO_TCL_R0_PCP_TID_MAP_IN(x)            \
                in_dword(HWIO_TCL_R0_PCP_TID_MAP_ADDR(x))
#define HWIO_TCL_R0_PCP_TID_MAP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_PCP_TID_MAP_ADDR(x), m)
#define HWIO_TCL_R0_PCP_TID_MAP_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_PCP_TID_MAP_ADDR(x),v)
#define HWIO_TCL_R0_PCP_TID_MAP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_PCP_TID_MAP_ADDR(x),m,v,HWIO_TCL_R0_PCP_TID_MAP_IN(x))
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_7_BMSK                                                                    0xe00000
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_7_SHFT                                                                          21
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_6_BMSK                                                                    0x1c0000
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_6_SHFT                                                                          18
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_5_BMSK                                                                     0x38000
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_5_SHFT                                                                          15
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_4_BMSK                                                                      0x7000
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_4_SHFT                                                                          12
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_3_BMSK                                                                       0xe00
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_3_SHFT                                                                           9
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_2_BMSK                                                                       0x1c0
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_2_SHFT                                                                           6
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_1_BMSK                                                                        0x38
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_1_SHFT                                                                           3
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_0_BMSK                                                                         0x7
#define HWIO_TCL_R0_PCP_TID_MAP_PCP_0_SHFT                                                                           0

#define HWIO_TCL_R0_ASE_HASH_KEY_31_0_ADDR(x)                                                               ((x) + 0x6c4)
#define HWIO_TCL_R0_ASE_HASH_KEY_31_0_PHYS(x)                                                               ((x) + 0x6c4)
#define HWIO_TCL_R0_ASE_HASH_KEY_31_0_OFFS                                                                  (0x6c4)
#define HWIO_TCL_R0_ASE_HASH_KEY_31_0_RMSK                                                                  0xffffffff
#define HWIO_TCL_R0_ASE_HASH_KEY_31_0_POR                                                                   0x00000000
#define HWIO_TCL_R0_ASE_HASH_KEY_31_0_POR_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_ASE_HASH_KEY_31_0_ATTR                                                                               0x3
#define HWIO_TCL_R0_ASE_HASH_KEY_31_0_IN(x)            \
                in_dword(HWIO_TCL_R0_ASE_HASH_KEY_31_0_ADDR(x))
#define HWIO_TCL_R0_ASE_HASH_KEY_31_0_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_ASE_HASH_KEY_31_0_ADDR(x), m)
#define HWIO_TCL_R0_ASE_HASH_KEY_31_0_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_ASE_HASH_KEY_31_0_ADDR(x),v)
#define HWIO_TCL_R0_ASE_HASH_KEY_31_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_ASE_HASH_KEY_31_0_ADDR(x),m,v,HWIO_TCL_R0_ASE_HASH_KEY_31_0_IN(x))
#define HWIO_TCL_R0_ASE_HASH_KEY_31_0_VAL_BMSK                                                              0xffffffff
#define HWIO_TCL_R0_ASE_HASH_KEY_31_0_VAL_SHFT                                                                       0

#define HWIO_TCL_R0_ASE_HASH_KEY_63_32_ADDR(x)                                                              ((x) + 0x6c8)
#define HWIO_TCL_R0_ASE_HASH_KEY_63_32_PHYS(x)                                                              ((x) + 0x6c8)
#define HWIO_TCL_R0_ASE_HASH_KEY_63_32_OFFS                                                                 (0x6c8)
#define HWIO_TCL_R0_ASE_HASH_KEY_63_32_RMSK                                                                 0xffffffff
#define HWIO_TCL_R0_ASE_HASH_KEY_63_32_POR                                                                  0x00000000
#define HWIO_TCL_R0_ASE_HASH_KEY_63_32_POR_RMSK                                                             0xffffffff
#define HWIO_TCL_R0_ASE_HASH_KEY_63_32_ATTR                                                                              0x3
#define HWIO_TCL_R0_ASE_HASH_KEY_63_32_IN(x)            \
                in_dword(HWIO_TCL_R0_ASE_HASH_KEY_63_32_ADDR(x))
#define HWIO_TCL_R0_ASE_HASH_KEY_63_32_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_ASE_HASH_KEY_63_32_ADDR(x), m)
#define HWIO_TCL_R0_ASE_HASH_KEY_63_32_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_ASE_HASH_KEY_63_32_ADDR(x),v)
#define HWIO_TCL_R0_ASE_HASH_KEY_63_32_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_ASE_HASH_KEY_63_32_ADDR(x),m,v,HWIO_TCL_R0_ASE_HASH_KEY_63_32_IN(x))
#define HWIO_TCL_R0_ASE_HASH_KEY_63_32_VAL_BMSK                                                             0xffffffff
#define HWIO_TCL_R0_ASE_HASH_KEY_63_32_VAL_SHFT                                                                      0

#define HWIO_TCL_R0_ASE_HASH_KEY_64_ADDR(x)                                                                 ((x) + 0x6cc)
#define HWIO_TCL_R0_ASE_HASH_KEY_64_PHYS(x)                                                                 ((x) + 0x6cc)
#define HWIO_TCL_R0_ASE_HASH_KEY_64_OFFS                                                                    (0x6cc)
#define HWIO_TCL_R0_ASE_HASH_KEY_64_RMSK                                                                           0x1
#define HWIO_TCL_R0_ASE_HASH_KEY_64_POR                                                                     0x00000000
#define HWIO_TCL_R0_ASE_HASH_KEY_64_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R0_ASE_HASH_KEY_64_ATTR                                                                                 0x3
#define HWIO_TCL_R0_ASE_HASH_KEY_64_IN(x)            \
                in_dword(HWIO_TCL_R0_ASE_HASH_KEY_64_ADDR(x))
#define HWIO_TCL_R0_ASE_HASH_KEY_64_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_ASE_HASH_KEY_64_ADDR(x), m)
#define HWIO_TCL_R0_ASE_HASH_KEY_64_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_ASE_HASH_KEY_64_ADDR(x),v)
#define HWIO_TCL_R0_ASE_HASH_KEY_64_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_ASE_HASH_KEY_64_ADDR(x),m,v,HWIO_TCL_R0_ASE_HASH_KEY_64_IN(x))
#define HWIO_TCL_R0_ASE_HASH_KEY_64_VAL_BMSK                                                                       0x1
#define HWIO_TCL_R0_ASE_HASH_KEY_64_VAL_SHFT                                                                         0

#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_ADDR(x)                                                             ((x) + 0x6d0)
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_PHYS(x)                                                             ((x) + 0x6d0)
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_OFFS                                                                (0x6d0)
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_RMSK                                                                  0xfffdfc
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_POR                                                                 0x00840014
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_ATTR                                                                             0x3
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_IN(x)            \
                in_dword(HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_ADDR(x))
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_ADDR(x), m)
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_ADDR(x),v)
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_ADDR(x),m,v,HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_IN(x))
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_MSDU_LEN_ERR_TO_FW_EN_BMSK                                            0x800000
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_MSDU_LEN_ERR_TO_FW_EN_SHFT                                                  23
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_FSE_M0_FW_SEL_BMSK                                                    0x700000
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_FSE_M0_FW_SEL_SHFT                                                          20
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_ASE_M0_FW_SEL_BMSK                                                     0xe0000
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_ASE_M0_FW_SEL_SHFT                                                          17
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_CCE_M0_FW_SEL_BMSK                                                     0x1c000
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_CCE_M0_FW_SEL_SHFT                                                          14
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_CCE_FAIL_DROP_BMSK                                                      0x2000
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_CCE_FAIL_DROP_SHFT                                                          13
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_FSE_FAIL_DROP_BMSK                                                      0x1000
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_FSE_FAIL_DROP_SHFT                                                          12
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_CCE_FAIL_LOOP_BMSK                                                       0x800
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_CCE_FAIL_LOOP_SHFT                                                          11
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_FSE_FAIL_LOOP_BMSK                                                       0x400
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_FSE_FAIL_LOOP_SHFT                                                          10
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_PRIORITY_BMSK                                                            0x1c0
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_PRIORITY_SHFT                                                                6
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_CCE_FAIL_HANDLER_BMSK                                                     0x30
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_CCE_FAIL_HANDLER_SHFT                                                        4
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_FSE_FAIL_HANDLER_BMSK                                                      0xc
#define HWIO_TCL_R0_CONFIG_SEARCH_QUEUE_FSE_FAIL_HANDLER_SHFT                                                        2

#define HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_LOW_ADDR(x)                                                          ((x) + 0x6d4)
#define HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_LOW_PHYS(x)                                                          ((x) + 0x6d4)
#define HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_LOW_OFFS                                                             (0x6d4)
#define HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_LOW_RMSK                                                             0xffffffff
#define HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_LOW_POR                                                              0x00000000
#define HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_LOW_POR_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_LOW_ATTR                                                                          0x3
#define HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_LOW_IN(x)            \
                in_dword(HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_LOW_ADDR(x))
#define HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_LOW_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_LOW_ADDR(x), m)
#define HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_LOW_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_LOW_ADDR(x),v)
#define HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_LOW_ADDR(x),m,v,HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_LOW_IN(x))
#define HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_LOW_VAL_BMSK                                                         0xffffffff
#define HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_LOW_VAL_SHFT                                                                  0

#define HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_HIGH_ADDR(x)                                                         ((x) + 0x6d8)
#define HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_HIGH_PHYS(x)                                                         ((x) + 0x6d8)
#define HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_HIGH_OFFS                                                            (0x6d8)
#define HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_HIGH_RMSK                                                                  0xff
#define HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_HIGH_POR                                                             0x00000000
#define HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_HIGH_POR_RMSK                                                        0xffffffff
#define HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_HIGH_ATTR                                                                         0x3
#define HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_HIGH_IN(x)            \
                in_dword(HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_HIGH_ADDR(x))
#define HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_HIGH_ADDR(x), m)
#define HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_HIGH_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_HIGH_ADDR(x),v)
#define HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_HIGH_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_HIGH_ADDR(x),m,v,HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_HIGH_IN(x))
#define HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_HIGH_VAL_BMSK                                                              0xff
#define HWIO_TCL_R0_FSE_FAIL_QUEUE_NUM_HIGH_VAL_SHFT                                                                 0

#define HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_LOW_ADDR(x)                                                          ((x) + 0x6dc)
#define HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_LOW_PHYS(x)                                                          ((x) + 0x6dc)
#define HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_LOW_OFFS                                                             (0x6dc)
#define HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_LOW_RMSK                                                             0xffffffff
#define HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_LOW_POR                                                              0x00000000
#define HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_LOW_POR_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_LOW_ATTR                                                                          0x3
#define HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_LOW_IN(x)            \
                in_dword(HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_LOW_ADDR(x))
#define HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_LOW_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_LOW_ADDR(x), m)
#define HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_LOW_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_LOW_ADDR(x),v)
#define HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_LOW_ADDR(x),m,v,HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_LOW_IN(x))
#define HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_LOW_VAL_BMSK                                                         0xffffffff
#define HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_LOW_VAL_SHFT                                                                  0

#define HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_HIGH_ADDR(x)                                                         ((x) + 0x6e0)
#define HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_HIGH_PHYS(x)                                                         ((x) + 0x6e0)
#define HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_HIGH_OFFS                                                            (0x6e0)
#define HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_HIGH_RMSK                                                                  0xff
#define HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_HIGH_POR                                                             0x00000000
#define HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_HIGH_POR_RMSK                                                        0xffffffff
#define HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_HIGH_ATTR                                                                         0x3
#define HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_HIGH_IN(x)            \
                in_dword(HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_HIGH_ADDR(x))
#define HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_HIGH_ADDR(x), m)
#define HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_HIGH_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_HIGH_ADDR(x),v)
#define HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_HIGH_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_HIGH_ADDR(x),m,v,HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_HIGH_IN(x))
#define HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_HIGH_VAL_BMSK                                                              0xff
#define HWIO_TCL_R0_CCE_FAIL_QUEUE_NUM_HIGH_VAL_SHFT                                                                 0

#define HWIO_TCL_R0_CONFIG_SEARCH_METADATA_ADDR(x)                                                          ((x) + 0x6e4)
#define HWIO_TCL_R0_CONFIG_SEARCH_METADATA_PHYS(x)                                                          ((x) + 0x6e4)
#define HWIO_TCL_R0_CONFIG_SEARCH_METADATA_OFFS                                                             (0x6e4)
#define HWIO_TCL_R0_CONFIG_SEARCH_METADATA_RMSK                                                             0xffffffff
#define HWIO_TCL_R0_CONFIG_SEARCH_METADATA_POR                                                              0x00000000
#define HWIO_TCL_R0_CONFIG_SEARCH_METADATA_POR_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_CONFIG_SEARCH_METADATA_ATTR                                                                          0x3
#define HWIO_TCL_R0_CONFIG_SEARCH_METADATA_IN(x)            \
                in_dword(HWIO_TCL_R0_CONFIG_SEARCH_METADATA_ADDR(x))
#define HWIO_TCL_R0_CONFIG_SEARCH_METADATA_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_CONFIG_SEARCH_METADATA_ADDR(x), m)
#define HWIO_TCL_R0_CONFIG_SEARCH_METADATA_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_CONFIG_SEARCH_METADATA_ADDR(x),v)
#define HWIO_TCL_R0_CONFIG_SEARCH_METADATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_CONFIG_SEARCH_METADATA_ADDR(x),m,v,HWIO_TCL_R0_CONFIG_SEARCH_METADATA_IN(x))
#define HWIO_TCL_R0_CONFIG_SEARCH_METADATA_FSE_FAIL_NUM_BMSK                                                0xffff0000
#define HWIO_TCL_R0_CONFIG_SEARCH_METADATA_FSE_FAIL_NUM_SHFT                                                        16
#define HWIO_TCL_R0_CONFIG_SEARCH_METADATA_CCE_FAIL_NUM_BMSK                                                    0xffff
#define HWIO_TCL_R0_CONFIG_SEARCH_METADATA_CCE_FAIL_NUM_SHFT                                                         0

#define HWIO_TCL_R0_TID_MAP_PRTY_ADDR(x)                                                                    ((x) + 0x6e8)
#define HWIO_TCL_R0_TID_MAP_PRTY_PHYS(x)                                                                    ((x) + 0x6e8)
#define HWIO_TCL_R0_TID_MAP_PRTY_OFFS                                                                       (0x6e8)
#define HWIO_TCL_R0_TID_MAP_PRTY_RMSK                                                                             0xef
#define HWIO_TCL_R0_TID_MAP_PRTY_POR                                                                        0x00000000
#define HWIO_TCL_R0_TID_MAP_PRTY_POR_RMSK                                                                   0xffffffff
#define HWIO_TCL_R0_TID_MAP_PRTY_ATTR                                                                                    0x3
#define HWIO_TCL_R0_TID_MAP_PRTY_IN(x)            \
                in_dword(HWIO_TCL_R0_TID_MAP_PRTY_ADDR(x))
#define HWIO_TCL_R0_TID_MAP_PRTY_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TID_MAP_PRTY_ADDR(x), m)
#define HWIO_TCL_R0_TID_MAP_PRTY_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TID_MAP_PRTY_ADDR(x),v)
#define HWIO_TCL_R0_TID_MAP_PRTY_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TID_MAP_PRTY_ADDR(x),m,v,HWIO_TCL_R0_TID_MAP_PRTY_IN(x))
#define HWIO_TCL_R0_TID_MAP_PRTY_TID_DEF_BMSK                                                                     0xe0
#define HWIO_TCL_R0_TID_MAP_PRTY_TID_DEF_SHFT                                                                        5
#define HWIO_TCL_R0_TID_MAP_PRTY_VAL_BMSK                                                                          0xf
#define HWIO_TCL_R0_TID_MAP_PRTY_VAL_SHFT                                                                            0

#define HWIO_TCL_R0_INVALID_APB_ACC_ADDR_ADDR(x)                                                            ((x) + 0x6ec)
#define HWIO_TCL_R0_INVALID_APB_ACC_ADDR_PHYS(x)                                                            ((x) + 0x6ec)
#define HWIO_TCL_R0_INVALID_APB_ACC_ADDR_OFFS                                                               (0x6ec)
#define HWIO_TCL_R0_INVALID_APB_ACC_ADDR_RMSK                                                               0xffffffff
#define HWIO_TCL_R0_INVALID_APB_ACC_ADDR_POR                                                                0x00000000
#define HWIO_TCL_R0_INVALID_APB_ACC_ADDR_POR_RMSK                                                           0xffffffff
#define HWIO_TCL_R0_INVALID_APB_ACC_ADDR_ATTR                                                                            0x1
#define HWIO_TCL_R0_INVALID_APB_ACC_ADDR_IN(x)            \
                in_dword(HWIO_TCL_R0_INVALID_APB_ACC_ADDR_ADDR(x))
#define HWIO_TCL_R0_INVALID_APB_ACC_ADDR_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_INVALID_APB_ACC_ADDR_ADDR(x), m)
#define HWIO_TCL_R0_INVALID_APB_ACC_ADDR_VAL_BMSK                                                           0xffffffff
#define HWIO_TCL_R0_INVALID_APB_ACC_ADDR_VAL_SHFT                                                                    0

#define HWIO_TCL_R0_WATCHDOG_WARNING_ADDR(x)                                                                ((x) + 0x6f0)
#define HWIO_TCL_R0_WATCHDOG_WARNING_PHYS(x)                                                                ((x) + 0x6f0)
#define HWIO_TCL_R0_WATCHDOG_WARNING_OFFS                                                                   (0x6f0)
#define HWIO_TCL_R0_WATCHDOG_WARNING_RMSK                                                                   0xffffffff
#define HWIO_TCL_R0_WATCHDOG_WARNING_POR                                                                    0x0000ffff
#define HWIO_TCL_R0_WATCHDOG_WARNING_POR_RMSK                                                               0xffffffff
#define HWIO_TCL_R0_WATCHDOG_WARNING_ATTR                                                                                0x3
#define HWIO_TCL_R0_WATCHDOG_WARNING_IN(x)            \
                in_dword(HWIO_TCL_R0_WATCHDOG_WARNING_ADDR(x))
#define HWIO_TCL_R0_WATCHDOG_WARNING_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_WATCHDOG_WARNING_ADDR(x), m)
#define HWIO_TCL_R0_WATCHDOG_WARNING_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_WATCHDOG_WARNING_ADDR(x),v)
#define HWIO_TCL_R0_WATCHDOG_WARNING_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_WATCHDOG_WARNING_ADDR(x),m,v,HWIO_TCL_R0_WATCHDOG_WARNING_IN(x))
#define HWIO_TCL_R0_WATCHDOG_WARNING_STATUS_BMSK                                                            0xffff0000
#define HWIO_TCL_R0_WATCHDOG_WARNING_STATUS_SHFT                                                                    16
#define HWIO_TCL_R0_WATCHDOG_WARNING_LIMIT_BMSK                                                                 0xffff
#define HWIO_TCL_R0_WATCHDOG_WARNING_LIMIT_SHFT                                                                      0

#define HWIO_TCL_R0_WATCHDOG_HW_ERROR_ADDR(x)                                                               ((x) + 0x6f4)
#define HWIO_TCL_R0_WATCHDOG_HW_ERROR_PHYS(x)                                                               ((x) + 0x6f4)
#define HWIO_TCL_R0_WATCHDOG_HW_ERROR_OFFS                                                                  (0x6f4)
#define HWIO_TCL_R0_WATCHDOG_HW_ERROR_RMSK                                                                  0xffffffff
#define HWIO_TCL_R0_WATCHDOG_HW_ERROR_POR                                                                   0x0000ffff
#define HWIO_TCL_R0_WATCHDOG_HW_ERROR_POR_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_WATCHDOG_HW_ERROR_ATTR                                                                               0x3
#define HWIO_TCL_R0_WATCHDOG_HW_ERROR_IN(x)            \
                in_dword(HWIO_TCL_R0_WATCHDOG_HW_ERROR_ADDR(x))
#define HWIO_TCL_R0_WATCHDOG_HW_ERROR_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_WATCHDOG_HW_ERROR_ADDR(x), m)
#define HWIO_TCL_R0_WATCHDOG_HW_ERROR_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_WATCHDOG_HW_ERROR_ADDR(x),v)
#define HWIO_TCL_R0_WATCHDOG_HW_ERROR_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_WATCHDOG_HW_ERROR_ADDR(x),m,v,HWIO_TCL_R0_WATCHDOG_HW_ERROR_IN(x))
#define HWIO_TCL_R0_WATCHDOG_HW_ERROR_STATUS_BMSK                                                           0xffff0000
#define HWIO_TCL_R0_WATCHDOG_HW_ERROR_STATUS_SHFT                                                                   16
#define HWIO_TCL_R0_WATCHDOG_HW_ERROR_LIMIT_BMSK                                                                0xffff
#define HWIO_TCL_R0_WATCHDOG_HW_ERROR_LIMIT_SHFT                                                                     0

#define HWIO_TCL_R0_EXTERNAL_BACKPRESSURE_EVENT_GEN_TIMER_ADDR(x)                                           ((x) + 0x6f8)
#define HWIO_TCL_R0_EXTERNAL_BACKPRESSURE_EVENT_GEN_TIMER_PHYS(x)                                           ((x) + 0x6f8)
#define HWIO_TCL_R0_EXTERNAL_BACKPRESSURE_EVENT_GEN_TIMER_OFFS                                              (0x6f8)
#define HWIO_TCL_R0_EXTERNAL_BACKPRESSURE_EVENT_GEN_TIMER_RMSK                                                  0xffff
#define HWIO_TCL_R0_EXTERNAL_BACKPRESSURE_EVENT_GEN_TIMER_POR                                               0x0000000a
#define HWIO_TCL_R0_EXTERNAL_BACKPRESSURE_EVENT_GEN_TIMER_POR_RMSK                                          0xffffffff
#define HWIO_TCL_R0_EXTERNAL_BACKPRESSURE_EVENT_GEN_TIMER_ATTR                                                           0x3
#define HWIO_TCL_R0_EXTERNAL_BACKPRESSURE_EVENT_GEN_TIMER_IN(x)            \
                in_dword(HWIO_TCL_R0_EXTERNAL_BACKPRESSURE_EVENT_GEN_TIMER_ADDR(x))
#define HWIO_TCL_R0_EXTERNAL_BACKPRESSURE_EVENT_GEN_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_EXTERNAL_BACKPRESSURE_EVENT_GEN_TIMER_ADDR(x), m)
#define HWIO_TCL_R0_EXTERNAL_BACKPRESSURE_EVENT_GEN_TIMER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_EXTERNAL_BACKPRESSURE_EVENT_GEN_TIMER_ADDR(x),v)
#define HWIO_TCL_R0_EXTERNAL_BACKPRESSURE_EVENT_GEN_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_EXTERNAL_BACKPRESSURE_EVENT_GEN_TIMER_ADDR(x),m,v,HWIO_TCL_R0_EXTERNAL_BACKPRESSURE_EVENT_GEN_TIMER_IN(x))
#define HWIO_TCL_R0_EXTERNAL_BACKPRESSURE_EVENT_GEN_TIMER_STATUS_BMSK                                           0xff00
#define HWIO_TCL_R0_EXTERNAL_BACKPRESSURE_EVENT_GEN_TIMER_STATUS_SHFT                                                8
#define HWIO_TCL_R0_EXTERNAL_BACKPRESSURE_EVENT_GEN_TIMER_LIMIT_BMSK                                              0xff
#define HWIO_TCL_R0_EXTERNAL_BACKPRESSURE_EVENT_GEN_TIMER_LIMIT_SHFT                                                 0

#define HWIO_TCL_R0_LCE_RULE_n_ADDR(base,n)                                                                 ((base) + 0X6FC + (0x4*(n)))
#define HWIO_TCL_R0_LCE_RULE_n_PHYS(base,n)                                                                 ((base) + 0X6FC + (0x4*(n)))
#define HWIO_TCL_R0_LCE_RULE_n_OFFS(n)                                                                      (0X6FC + (0x4*(n)))
#define HWIO_TCL_R0_LCE_RULE_n_RMSK                                                                           0xffffff
#define HWIO_TCL_R0_LCE_RULE_n_MAXn                                                                                 26
#define HWIO_TCL_R0_LCE_RULE_n_POR                                                                          0x00000000
#define HWIO_TCL_R0_LCE_RULE_n_POR_RMSK                                                                     0xffffffff
#define HWIO_TCL_R0_LCE_RULE_n_ATTR                                                                                      0x3
#define HWIO_TCL_R0_LCE_RULE_n_INI(base,n)                \
                in_dword_masked(HWIO_TCL_R0_LCE_RULE_n_ADDR(base,n), HWIO_TCL_R0_LCE_RULE_n_RMSK)
#define HWIO_TCL_R0_LCE_RULE_n_INMI(base,n,mask)        \
                in_dword_masked(HWIO_TCL_R0_LCE_RULE_n_ADDR(base,n), mask)
#define HWIO_TCL_R0_LCE_RULE_n_OUTI(base,n,val)        \
                out_dword(HWIO_TCL_R0_LCE_RULE_n_ADDR(base,n),val)
#define HWIO_TCL_R0_LCE_RULE_n_OUTMI(base,n,mask,val) \
                out_dword_masked_ns(HWIO_TCL_R0_LCE_RULE_n_ADDR(base,n),mask,val,HWIO_TCL_R0_LCE_RULE_n_INI(base,n))
#define HWIO_TCL_R0_LCE_RULE_n_MATCH_MCAST_AND_L3_TYPE_BMSK                                                   0x800000
#define HWIO_TCL_R0_LCE_RULE_n_MATCH_MCAST_AND_L3_TYPE_SHFT                                                         23
#define HWIO_TCL_R0_LCE_RULE_n_MATCH_IP_PROT_BMSK                                                             0x400000
#define HWIO_TCL_R0_LCE_RULE_n_MATCH_IP_PROT_SHFT                                                                   22
#define HWIO_TCL_R0_LCE_RULE_n_MATCH_DEST_ADDR_BIT_0_BMSK                                                     0x200000
#define HWIO_TCL_R0_LCE_RULE_n_MATCH_DEST_ADDR_BIT_0_SHFT                                                           21
#define HWIO_TCL_R0_LCE_RULE_n_TCP_OR_UDP_BMSK                                                                0x180000
#define HWIO_TCL_R0_LCE_RULE_n_TCP_OR_UDP_SHFT                                                                      19
#define HWIO_TCL_R0_LCE_RULE_n_MATCH_DEST_PORT_BMSK                                                            0x40000
#define HWIO_TCL_R0_LCE_RULE_n_MATCH_DEST_PORT_SHFT                                                                 18
#define HWIO_TCL_R0_LCE_RULE_n_MATCH_SRC_PORT_BMSK                                                             0x20000
#define HWIO_TCL_R0_LCE_RULE_n_MATCH_SRC_PORT_SHFT                                                                  17
#define HWIO_TCL_R0_LCE_RULE_n_MATCH_L3_TYPE_BMSK                                                              0x10000
#define HWIO_TCL_R0_LCE_RULE_n_MATCH_L3_TYPE_SHFT                                                                   16
#define HWIO_TCL_R0_LCE_RULE_n_MATCH_VAL_BMSK                                                                   0xffff
#define HWIO_TCL_R0_LCE_RULE_n_MATCH_VAL_SHFT                                                                        0

#define HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_LSB_n_ADDR(base,n)                                               ((base) + 0X768 + (0x4*(n)))
#define HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_LSB_n_PHYS(base,n)                                               ((base) + 0X768 + (0x4*(n)))
#define HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_LSB_n_OFFS(n)                                                    (0X768 + (0x4*(n)))
#define HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_LSB_n_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_LSB_n_MAXn                                                               26
#define HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_LSB_n_POR                                                        0x00000000
#define HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_LSB_n_POR_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_LSB_n_ATTR                                                                    0x3
#define HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_LSB_n_INI(base,n)                \
                in_dword_masked(HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_LSB_n_ADDR(base,n), HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_LSB_n_RMSK)
#define HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_LSB_n_INMI(base,n,mask)        \
                in_dword_masked(HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_LSB_n_ADDR(base,n), mask)
#define HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_LSB_n_OUTI(base,n,val)        \
                out_dword(HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_LSB_n_ADDR(base,n),val)
#define HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_LSB_n_OUTMI(base,n,mask,val) \
                out_dword_masked_ns(HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_LSB_n_ADDR(base,n),mask,val,HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_LSB_n_INI(base,n))
#define HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_LSB_n_VAL_BMSK                                                   0xffffffff
#define HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_LSB_n_VAL_SHFT                                                            0

#define HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_MSB_n_ADDR(base,n)                                               ((base) + 0X7D4 + (0x4*(n)))
#define HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_MSB_n_PHYS(base,n)                                               ((base) + 0X7D4 + (0x4*(n)))
#define HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_MSB_n_OFFS(n)                                                    (0X7D4 + (0x4*(n)))
#define HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_MSB_n_RMSK                                                             0xff
#define HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_MSB_n_MAXn                                                               26
#define HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_MSB_n_POR                                                        0x00000000
#define HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_MSB_n_POR_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_MSB_n_ATTR                                                                    0x3
#define HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_MSB_n_INI(base,n)                \
                in_dword_masked(HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_MSB_n_ADDR(base,n), HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_MSB_n_RMSK)
#define HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_MSB_n_INMI(base,n,mask)        \
                in_dword_masked(HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_MSB_n_ADDR(base,n), mask)
#define HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_MSB_n_OUTI(base,n,val)        \
                out_dword(HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_MSB_n_ADDR(base,n),val)
#define HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_MSB_n_OUTMI(base,n,mask,val) \
                out_dword_masked_ns(HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_MSB_n_ADDR(base,n),mask,val,HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_MSB_n_INI(base,n))
#define HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_MSB_n_VAL_BMSK                                                         0xff
#define HWIO_TCL_R0_LCE_CLFY_INFO_FLOW_PTR_MSB_n_VAL_SHFT                                                            0

#define HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_ADDR(base,n)                                                    ((base) + 0X840 + (0x4*(n)))
#define HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_PHYS(base,n)                                                    ((base) + 0X840 + (0x4*(n)))
#define HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_OFFS(n)                                                         (0X840 + (0x4*(n)))
#define HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_RMSK                                                             0x3ffffff
#define HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_MAXn                                                                    26
#define HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_POR                                                             0x00000000
#define HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_POR_RMSK                                                        0xffffffff
#define HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_ATTR                                                                         0x3
#define HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_INI(base,n)                \
                in_dword_masked(HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_ADDR(base,n), HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_RMSK)
#define HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_INMI(base,n,mask)        \
                in_dword_masked(HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_ADDR(base,n), mask)
#define HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_OUTI(base,n,val)        \
                out_dword(HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_ADDR(base,n),val)
#define HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_OUTMI(base,n,mask,val) \
                out_dword_masked_ns(HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_ADDR(base,n),mask,val,HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_INI(base,n))
#define HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_TX_NOTIFY_FRAME_BMSK                                             0x3800000
#define HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_TX_NOTIFY_FRAME_SHFT                                                    23
#define HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_TQM_NO_DROP_BMSK                                                  0x400000
#define HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_TQM_NO_DROP_SHFT                                                        22
#define HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_RULE_HIT_BMSK                                                     0x200000
#define HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_RULE_HIT_SHFT                                                           21
#define HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_METADATA_BMSK                                                     0x1fffe0
#define HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_METADATA_SHFT                                                            5
#define HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_MSDU_DROP_BMSK                                                        0x10
#define HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_MSDU_DROP_SHFT                                                           4
#define HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_TO_TQM_IF_M0_FW_BMSK                                                   0x8
#define HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_TO_TQM_IF_M0_FW_SHFT                                                     3
#define HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_TQM_FLOW_LOOP_HANDLER_BMSK                                             0x4
#define HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_TQM_FLOW_LOOP_HANDLER_SHFT                                               2
#define HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_TQM_FLOW_HANDLER_BMSK                                                  0x3
#define HWIO_TCL_R0_LCE_CLFY_INFO_HANDLER_n_TQM_FLOW_HANDLER_SHFT                                                    0

#define HWIO_TCL_R0_CLKGATE_DISABLE0_ADDR(x)                                                                ((x) + 0x8ac)
#define HWIO_TCL_R0_CLKGATE_DISABLE0_PHYS(x)                                                                ((x) + 0x8ac)
#define HWIO_TCL_R0_CLKGATE_DISABLE0_OFFS                                                                   (0x8ac)
#define HWIO_TCL_R0_CLKGATE_DISABLE0_RMSK                                                                   0xfffffeff
#define HWIO_TCL_R0_CLKGATE_DISABLE0_POR                                                                    0x00000000
#define HWIO_TCL_R0_CLKGATE_DISABLE0_POR_RMSK                                                               0xffffffff
#define HWIO_TCL_R0_CLKGATE_DISABLE0_ATTR                                                                                0x3
#define HWIO_TCL_R0_CLKGATE_DISABLE0_IN(x)            \
                in_dword(HWIO_TCL_R0_CLKGATE_DISABLE0_ADDR(x))
#define HWIO_TCL_R0_CLKGATE_DISABLE0_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_CLKGATE_DISABLE0_ADDR(x), m)
#define HWIO_TCL_R0_CLKGATE_DISABLE0_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_CLKGATE_DISABLE0_ADDR(x),v)
#define HWIO_TCL_R0_CLKGATE_DISABLE0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_CLKGATE_DISABLE0_ADDR(x),m,v,HWIO_TCL_R0_CLKGATE_DISABLE0_IN(x))
#define HWIO_TCL_R0_CLKGATE_DISABLE0_TQM_SRNG_BUNCH_BMSK                                                    0x80000000
#define HWIO_TCL_R0_CLKGATE_DISABLE0_TQM_SRNG_BUNCH_SHFT                                                            31
#define HWIO_TCL_R0_CLKGATE_DISABLE0_APB_CLK_BMSK                                                           0x40000000
#define HWIO_TCL_R0_CLKGATE_DISABLE0_APB_CLK_SHFT                                                                   30
#define HWIO_TCL_R0_CLKGATE_DISABLE0_CLFY_RES_MEM_BMSK                                                      0x20000000
#define HWIO_TCL_R0_CLKGATE_DISABLE0_CLFY_RES_MEM_SHFT                                                              29
#define HWIO_TCL_R0_CLKGATE_DISABLE0_GSE_CTRL_BMSK                                                          0x10000000
#define HWIO_TCL_R0_CLKGATE_DISABLE0_GSE_CTRL_SHFT                                                                  28
#define HWIO_TCL_R0_CLKGATE_DISABLE0_GSE_CCE_RES_BMSK                                                        0x8000000
#define HWIO_TCL_R0_CLKGATE_DISABLE0_GSE_CCE_RES_SHFT                                                               27
#define HWIO_TCL_R0_CLKGATE_DISABLE0_TCL2_STATUS2_PROD_RING_BMSK                                             0x4000000
#define HWIO_TCL_R0_CLKGATE_DISABLE0_TCL2_STATUS2_PROD_RING_SHFT                                                    26
#define HWIO_TCL_R0_CLKGATE_DISABLE0_TCL2_STATUS1_PROD_RING_BMSK                                             0x2000000
#define HWIO_TCL_R0_CLKGATE_DISABLE0_TCL2_STATUS1_PROD_RING_SHFT                                                    25
#define HWIO_TCL_R0_CLKGATE_DISABLE0_TCL2FW_PROD_RING_BMSK                                                   0x1000000
#define HWIO_TCL_R0_CLKGATE_DISABLE0_TCL2FW_PROD_RING_SHFT                                                          24
#define HWIO_TCL_R0_CLKGATE_DISABLE0_TCL2TQM_PROD_RING_BMSK                                                   0x800000
#define HWIO_TCL_R0_CLKGATE_DISABLE0_TCL2TQM_PROD_RING_SHFT                                                         23
#define HWIO_TCL_R0_CLKGATE_DISABLE0_PROD_RING_CTRL_BMSK                                                      0x400000
#define HWIO_TCL_R0_CLKGATE_DISABLE0_PROD_RING_CTRL_SHFT                                                            22
#define HWIO_TCL_R0_CLKGATE_DISABLE0_TLV_DECODE_BMSK                                                          0x200000
#define HWIO_TCL_R0_CLKGATE_DISABLE0_TLV_DECODE_SHFT                                                                21
#define HWIO_TCL_R0_CLKGATE_DISABLE0_TLV_GEN_BMSK                                                             0x100000
#define HWIO_TCL_R0_CLKGATE_DISABLE0_TLV_GEN_SHFT                                                                   20
#define HWIO_TCL_R0_CLKGATE_DISABLE0_DATA_FETCH_BMSK                                                           0x80000
#define HWIO_TCL_R0_CLKGATE_DISABLE0_DATA_FETCH_SHFT                                                                19
#define HWIO_TCL_R0_CLKGATE_DISABLE0_DATA_BUF_BMSK                                                             0x40000
#define HWIO_TCL_R0_CLKGATE_DISABLE0_DATA_BUF_SHFT                                                                  18
#define HWIO_TCL_R0_CLKGATE_DISABLE0_DESC_BUF_BMSK                                                             0x20000
#define HWIO_TCL_R0_CLKGATE_DISABLE0_DESC_BUF_SHFT                                                                  17
#define HWIO_TCL_R0_CLKGATE_DISABLE0_DESC_RD_BMSK                                                              0x10000
#define HWIO_TCL_R0_CLKGATE_DISABLE0_DESC_RD_SHFT                                                                   16
#define HWIO_TCL_R0_CLKGATE_DISABLE0_ASE_BMSK                                                                   0x8000
#define HWIO_TCL_R0_CLKGATE_DISABLE0_ASE_SHFT                                                                       15
#define HWIO_TCL_R0_CLKGATE_DISABLE0_SRNG_P_3_BMSK                                                              0x4000
#define HWIO_TCL_R0_CLKGATE_DISABLE0_SRNG_P_3_SHFT                                                                  14
#define HWIO_TCL_R0_CLKGATE_DISABLE0_SRNG_P_2_BMSK                                                              0x2000
#define HWIO_TCL_R0_CLKGATE_DISABLE0_SRNG_P_2_SHFT                                                                  13
#define HWIO_TCL_R0_CLKGATE_DISABLE0_SRNG_P_1_BMSK                                                              0x1000
#define HWIO_TCL_R0_CLKGATE_DISABLE0_SRNG_P_1_SHFT                                                                  12
#define HWIO_TCL_R0_CLKGATE_DISABLE0_SRNG_P_0_BMSK                                                               0x800
#define HWIO_TCL_R0_CLKGATE_DISABLE0_SRNG_P_0_SHFT                                                                  11
#define HWIO_TCL_R0_CLKGATE_DISABLE0_SRNG_C_6_BMSK                                                               0x400
#define HWIO_TCL_R0_CLKGATE_DISABLE0_SRNG_C_6_SHFT                                                                  10
#define HWIO_TCL_R0_CLKGATE_DISABLE0_SRNG_C_5_BMSK                                                               0x200
#define HWIO_TCL_R0_CLKGATE_DISABLE0_SRNG_C_5_SHFT                                                                   9
#define HWIO_TCL_R0_CLKGATE_DISABLE0_SRNG_C_3_BMSK                                                                0x80
#define HWIO_TCL_R0_CLKGATE_DISABLE0_SRNG_C_3_SHFT                                                                   7
#define HWIO_TCL_R0_CLKGATE_DISABLE0_SRNG_C_2_BMSK                                                                0x40
#define HWIO_TCL_R0_CLKGATE_DISABLE0_SRNG_C_2_SHFT                                                                   6
#define HWIO_TCL_R0_CLKGATE_DISABLE0_SRNG_C_1_BMSK                                                                0x20
#define HWIO_TCL_R0_CLKGATE_DISABLE0_SRNG_C_1_SHFT                                                                   5
#define HWIO_TCL_R0_CLKGATE_DISABLE0_SRNG_C_0_BMSK                                                                0x10
#define HWIO_TCL_R0_CLKGATE_DISABLE0_SRNG_C_0_SHFT                                                                   4
#define HWIO_TCL_R0_CLKGATE_DISABLE0_TCL_IDLE_REQ_SM_BMSK                                                          0x8
#define HWIO_TCL_R0_CLKGATE_DISABLE0_TCL_IDLE_REQ_SM_SHFT                                                            3
#define HWIO_TCL_R0_CLKGATE_DISABLE0_CCE_BMSK                                                                      0x4
#define HWIO_TCL_R0_CLKGATE_DISABLE0_CCE_SHFT                                                                        2
#define HWIO_TCL_R0_CLKGATE_DISABLE0_LCE_BMSK                                                                      0x2
#define HWIO_TCL_R0_CLKGATE_DISABLE0_LCE_SHFT                                                                        1
#define HWIO_TCL_R0_CLKGATE_DISABLE0_PARSER_BMSK                                                                   0x1
#define HWIO_TCL_R0_CLKGATE_DISABLE0_PARSER_SHFT                                                                     0

#define HWIO_TCL_R0_CLKGATE_DISABLE1_ADDR(x)                                                                ((x) + 0x8b0)
#define HWIO_TCL_R0_CLKGATE_DISABLE1_PHYS(x)                                                                ((x) + 0x8b0)
#define HWIO_TCL_R0_CLKGATE_DISABLE1_OFFS                                                                   (0x8b0)
#define HWIO_TCL_R0_CLKGATE_DISABLE1_RMSK                                                                         0x1d
#define HWIO_TCL_R0_CLKGATE_DISABLE1_POR                                                                    0x00000000
#define HWIO_TCL_R0_CLKGATE_DISABLE1_POR_RMSK                                                               0xffffffff
#define HWIO_TCL_R0_CLKGATE_DISABLE1_ATTR                                                                                0x3
#define HWIO_TCL_R0_CLKGATE_DISABLE1_IN(x)            \
                in_dword(HWIO_TCL_R0_CLKGATE_DISABLE1_ADDR(x))
#define HWIO_TCL_R0_CLKGATE_DISABLE1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_CLKGATE_DISABLE1_ADDR(x), m)
#define HWIO_TCL_R0_CLKGATE_DISABLE1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_CLKGATE_DISABLE1_ADDR(x),v)
#define HWIO_TCL_R0_CLKGATE_DISABLE1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_CLKGATE_DISABLE1_ADDR(x),m,v,HWIO_TCL_R0_CLKGATE_DISABLE1_IN(x))
#define HWIO_TCL_R0_CLKGATE_DISABLE1_CLK_ENS_EXTEND_BMSK                                                          0x10
#define HWIO_TCL_R0_CLKGATE_DISABLE1_CLK_ENS_EXTEND_SHFT                                                             4
#define HWIO_TCL_R0_CLKGATE_DISABLE1_CPU_IF_EXTEND_BMSK                                                            0x8
#define HWIO_TCL_R0_CLKGATE_DISABLE1_CPU_IF_EXTEND_SHFT                                                              3
#define HWIO_TCL_R0_CLKGATE_DISABLE1_ERR_RECOV_BMSK                                                                0x4
#define HWIO_TCL_R0_CLKGATE_DISABLE1_ERR_RECOV_SHFT                                                                  2
#define HWIO_TCL_R0_CLKGATE_DISABLE1_FW_SRNG_BUNCH_BMSK                                                            0x1
#define HWIO_TCL_R0_CLKGATE_DISABLE1_FW_SRNG_BUNCH_SHFT                                                              0

#define HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_ADDR(x)                                                         ((x) + 0x8b4)
#define HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_PHYS(x)                                                         ((x) + 0x8b4)
#define HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_OFFS                                                            (0x8b4)
#define HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_RMSK                                                                 0x76f
#define HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_POR                                                             0x00000000
#define HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_POR_RMSK                                                        0xffffffff
#define HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_ATTR                                                                         0x3
#define HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_IN(x)            \
                in_dword(HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_ADDR(x))
#define HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_ADDR(x), m)
#define HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_ADDR(x),v)
#define HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_ADDR(x),m,v,HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_IN(x))
#define HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_RING_ARB_BMSK                                                        0x400
#define HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_RING_ARB_SHFT                                                           10
#define HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_FIFO_BMSK                                                            0x200
#define HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_FIFO_SHFT                                                                9
#define HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_STR_CTRL_BMSK                                                        0x100
#define HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_STR_CTRL_SHFT                                                            8
#define HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_CONS_RING6_BMSK                                                       0x40
#define HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_CONS_RING6_SHFT                                                          6
#define HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_CONS_RING5_BMSK                                                       0x20
#define HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_CONS_RING5_SHFT                                                          5
#define HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_CONS_RING3_BMSK                                                        0x8
#define HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_CONS_RING3_SHFT                                                          3
#define HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_CONS_RING2_BMSK                                                        0x4
#define HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_CONS_RING2_SHFT                                                          2
#define HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_CONS_RING1_BMSK                                                        0x2
#define HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_CONS_RING1_SHFT                                                          1
#define HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_CONS_RING0_BMSK                                                        0x1
#define HWIO_TCL_R0_CLKGATE_DISABLE_DESC_RD_CONS_RING0_SHFT                                                          0

#define HWIO_TCL_R0_CREDIT_COUNT_ADDR(x)                                                                    ((x) + 0x8b8)
#define HWIO_TCL_R0_CREDIT_COUNT_PHYS(x)                                                                    ((x) + 0x8b8)
#define HWIO_TCL_R0_CREDIT_COUNT_OFFS                                                                       (0x8b8)
#define HWIO_TCL_R0_CREDIT_COUNT_RMSK                                                                          0x1ffff
#define HWIO_TCL_R0_CREDIT_COUNT_POR                                                                        0x00000000
#define HWIO_TCL_R0_CREDIT_COUNT_POR_RMSK                                                                   0xffffffff
#define HWIO_TCL_R0_CREDIT_COUNT_ATTR                                                                                    0x3
#define HWIO_TCL_R0_CREDIT_COUNT_IN(x)            \
                in_dword(HWIO_TCL_R0_CREDIT_COUNT_ADDR(x))
#define HWIO_TCL_R0_CREDIT_COUNT_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_CREDIT_COUNT_ADDR(x), m)
#define HWIO_TCL_R0_CREDIT_COUNT_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_CREDIT_COUNT_ADDR(x),v)
#define HWIO_TCL_R0_CREDIT_COUNT_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_CREDIT_COUNT_ADDR(x),m,v,HWIO_TCL_R0_CREDIT_COUNT_IN(x))
#define HWIO_TCL_R0_CREDIT_COUNT_ENABLE_BMSK                                                                   0x10000
#define HWIO_TCL_R0_CREDIT_COUNT_ENABLE_SHFT                                                                        16
#define HWIO_TCL_R0_CREDIT_COUNT_VAL_BMSK                                                                       0xffff
#define HWIO_TCL_R0_CREDIT_COUNT_VAL_SHFT                                                                            0

#define HWIO_TCL_R0_CURRENT_CREDIT_COUNT_ADDR(x)                                                            ((x) + 0x8bc)
#define HWIO_TCL_R0_CURRENT_CREDIT_COUNT_PHYS(x)                                                            ((x) + 0x8bc)
#define HWIO_TCL_R0_CURRENT_CREDIT_COUNT_OFFS                                                               (0x8bc)
#define HWIO_TCL_R0_CURRENT_CREDIT_COUNT_RMSK                                                                   0xffff
#define HWIO_TCL_R0_CURRENT_CREDIT_COUNT_POR                                                                0x00000000
#define HWIO_TCL_R0_CURRENT_CREDIT_COUNT_POR_RMSK                                                           0xffffffff
#define HWIO_TCL_R0_CURRENT_CREDIT_COUNT_ATTR                                                                            0x1
#define HWIO_TCL_R0_CURRENT_CREDIT_COUNT_IN(x)            \
                in_dword(HWIO_TCL_R0_CURRENT_CREDIT_COUNT_ADDR(x))
#define HWIO_TCL_R0_CURRENT_CREDIT_COUNT_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_CURRENT_CREDIT_COUNT_ADDR(x), m)
#define HWIO_TCL_R0_CURRENT_CREDIT_COUNT_VAL_BMSK                                                               0xffff
#define HWIO_TCL_R0_CURRENT_CREDIT_COUNT_VAL_SHFT                                                                    0

#define HWIO_TCL_R0_ERR_RECOV_READ_ADDR(x)                                                                  ((x) + 0x8c8)
#define HWIO_TCL_R0_ERR_RECOV_READ_PHYS(x)                                                                  ((x) + 0x8c8)
#define HWIO_TCL_R0_ERR_RECOV_READ_OFFS                                                                     (0x8c8)
#define HWIO_TCL_R0_ERR_RECOV_READ_RMSK                                                                            0x1
#define HWIO_TCL_R0_ERR_RECOV_READ_POR                                                                      0x00000000
#define HWIO_TCL_R0_ERR_RECOV_READ_POR_RMSK                                                                 0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_READ_ATTR                                                                                  0x3
#define HWIO_TCL_R0_ERR_RECOV_READ_IN(x)            \
                in_dword(HWIO_TCL_R0_ERR_RECOV_READ_ADDR(x))
#define HWIO_TCL_R0_ERR_RECOV_READ_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_ERR_RECOV_READ_ADDR(x), m)
#define HWIO_TCL_R0_ERR_RECOV_READ_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_ERR_RECOV_READ_ADDR(x),v)
#define HWIO_TCL_R0_ERR_RECOV_READ_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_ERR_RECOV_READ_ADDR(x),m,v,HWIO_TCL_R0_ERR_RECOV_READ_IN(x))
#define HWIO_TCL_R0_ERR_RECOV_READ_ENABLE_BMSK                                                                     0x1
#define HWIO_TCL_R0_ERR_RECOV_READ_ENABLE_SHFT                                                                       0

#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_COUNT_ADDR(x)                                                      ((x) + 0x8cc)
#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_COUNT_PHYS(x)                                                      ((x) + 0x8cc)
#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_COUNT_OFFS                                                         (0x8cc)
#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_COUNT_RMSK                                                               0xff
#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_COUNT_POR                                                          0x00000000
#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_COUNT_POR_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_COUNT_ATTR                                                                      0x1
#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_COUNT_IN(x)            \
                in_dword(HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_COUNT_ADDR(x))
#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_COUNT_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_COUNT_ADDR(x), m)
#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_COUNT_VAL_BMSK                                                           0xff
#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_COUNT_VAL_SHFT                                                              0

#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_COUNT_ADDR(x)                                                 ((x) + 0x8d0)
#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_COUNT_PHYS(x)                                                 ((x) + 0x8d0)
#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_COUNT_OFFS                                                    (0x8d0)
#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_COUNT_RMSK                                                          0xff
#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_COUNT_POR                                                     0x00000000
#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_COUNT_POR_RMSK                                                0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_COUNT_ATTR                                                                 0x1
#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_COUNT_IN(x)            \
                in_dword(HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_COUNT_ADDR(x))
#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_COUNT_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_COUNT_ADDR(x), m)
#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_COUNT_VAL_BMSK                                                      0xff
#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_COUNT_VAL_SHFT                                                         0

#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_COUNT_ADDR(x)                                                   ((x) + 0x8d4)
#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_COUNT_PHYS(x)                                                   ((x) + 0x8d4)
#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_COUNT_OFFS                                                      (0x8d4)
#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_COUNT_RMSK                                                            0xff
#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_COUNT_POR                                                       0x00000000
#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_COUNT_POR_RMSK                                                  0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_COUNT_ATTR                                                                   0x1
#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_COUNT_IN(x)            \
                in_dword(HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_COUNT_ADDR(x))
#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_COUNT_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_COUNT_ADDR(x), m)
#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_COUNT_VAL_BMSK                                                        0xff
#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_COUNT_VAL_SHFT                                                           0

#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_COUNT_ADDR(x)                                                  ((x) + 0x8d8)
#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_COUNT_PHYS(x)                                                  ((x) + 0x8d8)
#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_COUNT_OFFS                                                     (0x8d8)
#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_COUNT_RMSK                                                           0xff
#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_COUNT_POR                                                      0x00000000
#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_COUNT_POR_RMSK                                                 0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_COUNT_ATTR                                                                  0x1
#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_COUNT_IN(x)            \
                in_dword(HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_COUNT_ADDR(x))
#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_COUNT_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_COUNT_ADDR(x), m)
#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_COUNT_VAL_BMSK                                                       0xff
#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_COUNT_VAL_SHFT                                                          0

#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_COUNT_ADDR(x)                                                   ((x) + 0x8dc)
#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_COUNT_PHYS(x)                                                   ((x) + 0x8dc)
#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_COUNT_OFFS                                                      (0x8dc)
#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_COUNT_RMSK                                                            0xff
#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_COUNT_POR                                                       0x00000000
#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_COUNT_POR_RMSK                                                  0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_COUNT_ATTR                                                                   0x1
#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_COUNT_IN(x)            \
                in_dword(HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_COUNT_ADDR(x))
#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_COUNT_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_COUNT_ADDR(x), m)
#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_COUNT_VAL_BMSK                                                        0xff
#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_COUNT_VAL_SHFT                                                           0

#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_LSB_ADDR(x)                                                        ((x) + 0x8e0)
#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_LSB_PHYS(x)                                                        ((x) + 0x8e0)
#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_LSB_OFFS                                                           (0x8e0)
#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_LSB_RMSK                                                           0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_LSB_POR                                                            0x00000000
#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_LSB_POR_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_LSB_ATTR                                                                        0x1
#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_LSB_ADDR(x))
#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_LSB_ADDR(x), m)
#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_LSB_VAL_BMSK                                                       0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_LSB_VAL_SHFT                                                                0

#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_MSB_ADDR(x)                                                        ((x) + 0x8e4)
#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_MSB_PHYS(x)                                                        ((x) + 0x8e4)
#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_MSB_OFFS                                                           (0x8e4)
#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_MSB_RMSK                                                           0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_MSB_POR                                                            0x00000000
#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_MSB_POR_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_MSB_ATTR                                                                        0x1
#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_MSB_ADDR(x))
#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_MSB_ADDR(x), m)
#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_MSB_VAL_BMSK                                                       0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_FETCH_MSB_VAL_SHFT                                                                0

#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_LSB_ADDR(x)                                                   ((x) + 0x8e8)
#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_LSB_PHYS(x)                                                   ((x) + 0x8e8)
#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_LSB_OFFS                                                      (0x8e8)
#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_LSB_RMSK                                                      0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_LSB_POR                                                       0x00000000
#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_LSB_POR_RMSK                                                  0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_LSB_ATTR                                                                   0x1
#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_LSB_ADDR(x))
#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_LSB_ADDR(x), m)
#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_LSB_VAL_BMSK                                                  0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_LSB_VAL_SHFT                                                           0

#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_MSB_ADDR(x)                                                   ((x) + 0x8ec)
#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_MSB_PHYS(x)                                                   ((x) + 0x8ec)
#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_MSB_OFFS                                                      (0x8ec)
#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_MSB_RMSK                                                      0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_MSB_POR                                                       0x00000000
#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_MSB_POR_RMSK                                                  0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_MSB_ATTR                                                                   0x1
#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_MSB_ADDR(x))
#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_MSB_ADDR(x), m)
#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_MSB_VAL_BMSK                                                  0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_DIRECT_BUF_MSB_VAL_SHFT                                                           0

#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_LSB_ADDR(x)                                                     ((x) + 0x8f0)
#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_LSB_PHYS(x)                                                     ((x) + 0x8f0)
#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_LSB_OFFS                                                        (0x8f0)
#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_LSB_RMSK                                                        0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_LSB_POR                                                         0x00000000
#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_LSB_POR_RMSK                                                    0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_LSB_ATTR                                                                     0x1
#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_LSB_ADDR(x))
#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_LSB_ADDR(x), m)
#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_LSB_VAL_BMSK                                                    0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_LSB_VAL_SHFT                                                             0

#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_MSB_ADDR(x)                                                     ((x) + 0x8f4)
#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_MSB_PHYS(x)                                                     ((x) + 0x8f4)
#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_MSB_OFFS                                                        (0x8f4)
#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_MSB_RMSK                                                        0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_MSB_POR                                                         0x00000000
#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_MSB_POR_RMSK                                                    0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_MSB_ATTR                                                                     0x1
#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_MSB_ADDR(x))
#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_MSB_ADDR(x), m)
#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_MSB_VAL_BMSK                                                    0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_DATA_BUF_MSB_VAL_SHFT                                                             0

#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_LSB_ADDR(x)                                                    ((x) + 0x8f8)
#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_LSB_PHYS(x)                                                    ((x) + 0x8f8)
#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_LSB_OFFS                                                       (0x8f8)
#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_LSB_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_LSB_POR                                                        0x00000000
#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_LSB_POR_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_LSB_ATTR                                                                    0x1
#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_LSB_ADDR(x))
#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_LSB_ADDR(x), m)
#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_LSB_VAL_BMSK                                                   0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_LSB_VAL_SHFT                                                            0

#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_MSB_ADDR(x)                                                    ((x) + 0x8fc)
#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_MSB_PHYS(x)                                                    ((x) + 0x8fc)
#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_MSB_OFFS                                                       (0x8fc)
#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_MSB_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_MSB_POR                                                        0x00000000
#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_MSB_POR_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_MSB_ATTR                                                                    0x1
#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_MSB_ADDR(x))
#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_MSB_ADDR(x), m)
#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_MSB_VAL_BMSK                                                   0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_TQM_BUNCH_MSB_VAL_SHFT                                                            0

#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_LSB_ADDR(x)                                                     ((x) + 0x900)
#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_LSB_PHYS(x)                                                     ((x) + 0x900)
#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_LSB_OFFS                                                        (0x900)
#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_LSB_RMSK                                                        0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_LSB_POR                                                         0x00000000
#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_LSB_POR_RMSK                                                    0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_LSB_ATTR                                                                     0x1
#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_LSB_ADDR(x))
#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_LSB_ADDR(x), m)
#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_LSB_VAL_BMSK                                                    0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_LSB_VAL_SHFT                                                             0

#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_MSB_ADDR(x)                                                     ((x) + 0x904)
#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_MSB_PHYS(x)                                                     ((x) + 0x904)
#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_MSB_OFFS                                                        (0x904)
#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_MSB_RMSK                                                        0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_MSB_POR                                                         0x00000000
#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_MSB_POR_RMSK                                                    0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_MSB_ATTR                                                                     0x1
#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_MSB_ADDR(x))
#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_MSB_ADDR(x), m)
#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_MSB_VAL_BMSK                                                    0xffffffff
#define HWIO_TCL_R0_ERR_RECOV_DESC_FW_BUNCH_MSB_VAL_SHFT                                                             0

#define HWIO_TCL_R0_S_PARE_REGISTER_ADDR(x)                                                                 ((x) + 0x908)
#define HWIO_TCL_R0_S_PARE_REGISTER_PHYS(x)                                                                 ((x) + 0x908)
#define HWIO_TCL_R0_S_PARE_REGISTER_OFFS                                                                    (0x908)
#define HWIO_TCL_R0_S_PARE_REGISTER_RMSK                                                                    0xffffffff
#define HWIO_TCL_R0_S_PARE_REGISTER_POR                                                                     0x00000000
#define HWIO_TCL_R0_S_PARE_REGISTER_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R0_S_PARE_REGISTER_ATTR                                                                                 0x3
#define HWIO_TCL_R0_S_PARE_REGISTER_IN(x)            \
                in_dword(HWIO_TCL_R0_S_PARE_REGISTER_ADDR(x))
#define HWIO_TCL_R0_S_PARE_REGISTER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_S_PARE_REGISTER_ADDR(x), m)
#define HWIO_TCL_R0_S_PARE_REGISTER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_S_PARE_REGISTER_ADDR(x),v)
#define HWIO_TCL_R0_S_PARE_REGISTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_S_PARE_REGISTER_ADDR(x),m,v,HWIO_TCL_R0_S_PARE_REGISTER_IN(x))
#define HWIO_TCL_R0_S_PARE_REGISTER_VAL_BMSK                                                                0xffffffff
#define HWIO_TCL_R0_S_PARE_REGISTER_VAL_SHFT                                                                         0

#define HWIO_TCL_R0_MISC_CTRL_ADDR(x)                                                                       ((x) + 0x90c)
#define HWIO_TCL_R0_MISC_CTRL_PHYS(x)                                                                       ((x) + 0x90c)
#define HWIO_TCL_R0_MISC_CTRL_OFFS                                                                          (0x90c)
#define HWIO_TCL_R0_MISC_CTRL_RMSK                                                                                 0x3
#define HWIO_TCL_R0_MISC_CTRL_POR                                                                           0x00000000
#define HWIO_TCL_R0_MISC_CTRL_POR_RMSK                                                                      0xffffffff
#define HWIO_TCL_R0_MISC_CTRL_ATTR                                                                                       0x3
#define HWIO_TCL_R0_MISC_CTRL_IN(x)            \
                in_dword(HWIO_TCL_R0_MISC_CTRL_ADDR(x))
#define HWIO_TCL_R0_MISC_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_MISC_CTRL_ADDR(x), m)
#define HWIO_TCL_R0_MISC_CTRL_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_MISC_CTRL_ADDR(x),v)
#define HWIO_TCL_R0_MISC_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_MISC_CTRL_ADDR(x),m,v,HWIO_TCL_R0_MISC_CTRL_IN(x))
#define HWIO_TCL_R0_MISC_CTRL_DATA_CORRUPT_FIX_DISABLE_CHK_BIT_BMSK                                                0x2
#define HWIO_TCL_R0_MISC_CTRL_DATA_CORRUPT_FIX_DISABLE_CHK_BIT_SHFT                                                  1
#define HWIO_TCL_R0_MISC_CTRL_MSI_DISABLE_CHK_BIT_BMSK                                                             0x1
#define HWIO_TCL_R0_MISC_CTRL_MSI_DISABLE_CHK_BIT_SHFT                                                               0

#define HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_ADDR(x)                                                           ((x) + 0x910)
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_PHYS(x)                                                           ((x) + 0x910)
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_OFFS                                                              (0x910)
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_POR                                                               0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_ATTR                                                                           0x3
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                           0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                    0

#define HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_ADDR(x)                                                           ((x) + 0x914)
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_PHYS(x)                                                           ((x) + 0x914)
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_OFFS                                                              (0x914)
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_RMSK                                                               0xfffffff
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_POR                                                               0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_ATTR                                                                           0x3
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_RING_SIZE_BMSK                                                     0xfffff00
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_RING_SIZE_SHFT                                                             8
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                 0xff
#define HWIO_TCL_R0_SW2TCL1_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                    0

#define HWIO_TCL_R0_SW2TCL1_RING_ID_ADDR(x)                                                                 ((x) + 0x918)
#define HWIO_TCL_R0_SW2TCL1_RING_ID_PHYS(x)                                                                 ((x) + 0x918)
#define HWIO_TCL_R0_SW2TCL1_RING_ID_OFFS                                                                    (0x918)
#define HWIO_TCL_R0_SW2TCL1_RING_ID_RMSK                                                                          0xff
#define HWIO_TCL_R0_SW2TCL1_RING_ID_POR                                                                     0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_ID_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_ID_ATTR                                                                                 0x3
#define HWIO_TCL_R0_SW2TCL1_RING_ID_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_ID_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_ID_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_ID_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_ID_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_ID_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_ID_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_ID_ENTRY_SIZE_BMSK                                                               0xff
#define HWIO_TCL_R0_SW2TCL1_RING_ID_ENTRY_SIZE_SHFT                                                                  0

#define HWIO_TCL_R0_SW2TCL1_RING_STATUS_ADDR(x)                                                             ((x) + 0x91c)
#define HWIO_TCL_R0_SW2TCL1_RING_STATUS_PHYS(x)                                                             ((x) + 0x91c)
#define HWIO_TCL_R0_SW2TCL1_RING_STATUS_OFFS                                                                (0x91c)
#define HWIO_TCL_R0_SW2TCL1_RING_STATUS_RMSK                                                                0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_STATUS_POR                                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_STATUS_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_STATUS_ATTR                                                                             0x1
#define HWIO_TCL_R0_SW2TCL1_RING_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                0xffff0000
#define HWIO_TCL_R0_SW2TCL1_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                        16
#define HWIO_TCL_R0_SW2TCL1_RING_STATUS_NUM_VALID_WORDS_BMSK                                                    0xffff
#define HWIO_TCL_R0_SW2TCL1_RING_STATUS_NUM_VALID_WORDS_SHFT                                                         0

#define HWIO_TCL_R0_SW2TCL1_RING_MISC_ADDR(x)                                                               ((x) + 0x920)
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_PHYS(x)                                                               ((x) + 0x920)
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_OFFS                                                                  (0x920)
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_RMSK                                                                    0x3fffff
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_POR                                                                   0x00000080
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_POR_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_ATTR                                                                               0x3
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_MISC_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_MISC_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_MISC_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_MISC_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_MISC_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_SPARE_CONTROL_BMSK                                                      0x3fc000
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_SPARE_CONTROL_SHFT                                                            14
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_SRNG_SM_STATE2_BMSK                                                       0x3000
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_SRNG_SM_STATE2_SHFT                                                           12
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_SRNG_SM_STATE1_BMSK                                                        0xf00
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_SRNG_SM_STATE1_SHFT                                                            8
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_SRNG_IS_IDLE_BMSK                                                           0x80
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_SRNG_IS_IDLE_SHFT                                                              7
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_SRNG_ENABLE_BMSK                                                            0x40
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_SRNG_ENABLE_SHFT                                                               6
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                      0x20
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                         5
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                       0x10
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                          4
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_MSI_SWAP_BIT_BMSK                                                            0x8
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_MSI_SWAP_BIT_SHFT                                                              3
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_SECURITY_BIT_BMSK                                                            0x4
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_SECURITY_BIT_SHFT                                                              2
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_LOOPCNT_DISABLE_BMSK                                                         0x2
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_LOOPCNT_DISABLE_SHFT                                                           1
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_RING_ID_DISABLE_BMSK                                                         0x1
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_RING_ID_DISABLE_SHFT                                                           0

#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_ADDR(x)                                                        ((x) + 0x92c)
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_PHYS(x)                                                        ((x) + 0x92c)
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_OFFS                                                           (0x92c)
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_RMSK                                                           0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_POR                                                            0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_POR_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_ATTR                                                                        0x3
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                      0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                               0

#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_ADDR(x)                                                        ((x) + 0x930)
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_PHYS(x)                                                        ((x) + 0x930)
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_OFFS                                                           (0x930)
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_RMSK                                                                 0xff
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_POR                                                            0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_POR_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_ATTR                                                                        0x3
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                            0xff
#define HWIO_TCL_R0_SW2TCL1_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                               0

#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                             ((x) + 0x940)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                             ((x) + 0x940)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                (0x940)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_POR                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                             0x3
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                             ((x) + 0x944)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                             ((x) + 0x944)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                (0x944)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                    0xffff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_POR                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                             0x3
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                      0xffff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                           0

#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_ADDR(x)                                                ((x) + 0x948)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_PHYS(x)                                                ((x) + 0x948)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_OFFS                                                   (0x948)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_POR                                                    0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_POR_RMSK                                               0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_ATTR                                                                0x1
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                     0xffff0000
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                             16
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                0x8000
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                    15
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                          0x7fff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                               0

#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                             ((x) + 0x94c)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                             ((x) + 0x94c)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                (0x94c)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                     0x3ff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_POR                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                             0x3
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                  0x3ff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                      0

#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                            ((x) + 0x950)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                            ((x) + 0x950)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_OFFS                                               (0x950)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                      0x7
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_POR                                                0x00000003
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                           0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                            0x3
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                 0x7
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                   0

#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                           ((x) + 0x954)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                           ((x) + 0x954)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_STATUS_OFFS                                              (0x954)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_STATUS_RMSK                                               0xfffffff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_STATUS_POR                                               0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                           0x1
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                0xff00000
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                       20
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                               0xfffff
#define HWIO_TCL_R0_SW2TCL1_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                     0

#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_ADDR(x)                                                      ((x) + 0x958)
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_PHYS(x)                                                      ((x) + 0x958)
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_OFFS                                                         (0x958)
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_POR                                                          0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_ATTR                                                                      0x3
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_ADDR_BMSK                                                    0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_LSB_ADDR_SHFT                                                             0

#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_ADDR(x)                                                      ((x) + 0x95c)
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_PHYS(x)                                                      ((x) + 0x95c)
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_OFFS                                                         (0x95c)
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_RMSK                                                              0x1ff
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_POR                                                          0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_ATTR                                                                      0x3
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                  0x100
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                      8
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_ADDR_BMSK                                                          0xff
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_BASE_MSB_ADDR_SHFT                                                             0

#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_ADDR(x)                                                          ((x) + 0x960)
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_PHYS(x)                                                          ((x) + 0x960)
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_OFFS                                                             (0x960)
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_RMSK                                                             0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_POR                                                              0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_POR_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_ATTR                                                                          0x3
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_VALUE_BMSK                                                       0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_MSI1_DATA_VALUE_SHFT                                                                0

#define HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_ADDR(x)                                                    ((x) + 0x980)
#define HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_PHYS(x)                                                    ((x) + 0x980)
#define HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_OFFS                                                       (0x980)
#define HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_RMSK                                                           0xffff
#define HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_POR                                                        0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_POR_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_ATTR                                                                    0x3
#define HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                        0xffff
#define HWIO_TCL_R0_SW2TCL1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                             0

#define HWIO_TCL_R0_SW2TCL1_RING_MISC_1_ADDR(x)                                                             ((x) + 0x984)
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_1_PHYS(x)                                                             ((x) + 0x984)
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_1_OFFS                                                                (0x984)
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_1_RMSK                                                                0xffff003f
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_1_POR                                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_1_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_1_ATTR                                                                             0x3
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_1_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL1_RING_MISC_1_ADDR(x))
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL1_RING_MISC_1_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL1_RING_MISC_1_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL1_RING_MISC_1_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL1_RING_MISC_1_IN(x))
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                       0xffff0000
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                               16
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                              0x3f
#define HWIO_TCL_R0_SW2TCL1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                 0

#define HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_ADDR(x)                                                           ((x) + 0x988)
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_PHYS(x)                                                           ((x) + 0x988)
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_OFFS                                                              (0x988)
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_POR                                                               0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_ATTR                                                                           0x3
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                           0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                    0

#define HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_ADDR(x)                                                           ((x) + 0x98c)
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_PHYS(x)                                                           ((x) + 0x98c)
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_OFFS                                                              (0x98c)
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_RMSK                                                               0xfffffff
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_POR                                                               0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_ATTR                                                                           0x3
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_RING_SIZE_BMSK                                                     0xfffff00
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_RING_SIZE_SHFT                                                             8
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                 0xff
#define HWIO_TCL_R0_SW2TCL2_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                    0

#define HWIO_TCL_R0_SW2TCL2_RING_ID_ADDR(x)                                                                 ((x) + 0x990)
#define HWIO_TCL_R0_SW2TCL2_RING_ID_PHYS(x)                                                                 ((x) + 0x990)
#define HWIO_TCL_R0_SW2TCL2_RING_ID_OFFS                                                                    (0x990)
#define HWIO_TCL_R0_SW2TCL2_RING_ID_RMSK                                                                          0xff
#define HWIO_TCL_R0_SW2TCL2_RING_ID_POR                                                                     0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_ID_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_ID_ATTR                                                                                 0x3
#define HWIO_TCL_R0_SW2TCL2_RING_ID_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_ID_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_ID_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_ID_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_ID_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_ID_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_ID_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_ID_ENTRY_SIZE_BMSK                                                               0xff
#define HWIO_TCL_R0_SW2TCL2_RING_ID_ENTRY_SIZE_SHFT                                                                  0

#define HWIO_TCL_R0_SW2TCL2_RING_STATUS_ADDR(x)                                                             ((x) + 0x994)
#define HWIO_TCL_R0_SW2TCL2_RING_STATUS_PHYS(x)                                                             ((x) + 0x994)
#define HWIO_TCL_R0_SW2TCL2_RING_STATUS_OFFS                                                                (0x994)
#define HWIO_TCL_R0_SW2TCL2_RING_STATUS_RMSK                                                                0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_STATUS_POR                                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_STATUS_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_STATUS_ATTR                                                                             0x1
#define HWIO_TCL_R0_SW2TCL2_RING_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                0xffff0000
#define HWIO_TCL_R0_SW2TCL2_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                        16
#define HWIO_TCL_R0_SW2TCL2_RING_STATUS_NUM_VALID_WORDS_BMSK                                                    0xffff
#define HWIO_TCL_R0_SW2TCL2_RING_STATUS_NUM_VALID_WORDS_SHFT                                                         0

#define HWIO_TCL_R0_SW2TCL2_RING_MISC_ADDR(x)                                                               ((x) + 0x998)
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_PHYS(x)                                                               ((x) + 0x998)
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_OFFS                                                                  (0x998)
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_RMSK                                                                    0x3fffff
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_POR                                                                   0x00000080
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_POR_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_ATTR                                                                               0x3
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_MISC_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_MISC_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_MISC_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_MISC_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_MISC_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_SPARE_CONTROL_BMSK                                                      0x3fc000
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_SPARE_CONTROL_SHFT                                                            14
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_SRNG_SM_STATE2_BMSK                                                       0x3000
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_SRNG_SM_STATE2_SHFT                                                           12
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_SRNG_SM_STATE1_BMSK                                                        0xf00
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_SRNG_SM_STATE1_SHFT                                                            8
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_SRNG_IS_IDLE_BMSK                                                           0x80
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_SRNG_IS_IDLE_SHFT                                                              7
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_SRNG_ENABLE_BMSK                                                            0x40
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_SRNG_ENABLE_SHFT                                                               6
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                      0x20
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                         5
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                       0x10
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                          4
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_MSI_SWAP_BIT_BMSK                                                            0x8
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_MSI_SWAP_BIT_SHFT                                                              3
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_SECURITY_BIT_BMSK                                                            0x4
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_SECURITY_BIT_SHFT                                                              2
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_LOOPCNT_DISABLE_BMSK                                                         0x2
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_LOOPCNT_DISABLE_SHFT                                                           1
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_RING_ID_DISABLE_BMSK                                                         0x1
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_RING_ID_DISABLE_SHFT                                                           0

#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_ADDR(x)                                                        ((x) + 0x9a4)
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_PHYS(x)                                                        ((x) + 0x9a4)
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_OFFS                                                           (0x9a4)
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_RMSK                                                           0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_POR                                                            0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_POR_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_ATTR                                                                        0x3
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                      0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                               0

#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_ADDR(x)                                                        ((x) + 0x9a8)
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_PHYS(x)                                                        ((x) + 0x9a8)
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_OFFS                                                           (0x9a8)
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_RMSK                                                                 0xff
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_POR                                                            0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_POR_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_ATTR                                                                        0x3
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                            0xff
#define HWIO_TCL_R0_SW2TCL2_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                               0

#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                             ((x) + 0x9b8)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                             ((x) + 0x9b8)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                (0x9b8)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_POR                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                             0x3
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                             ((x) + 0x9bc)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                             ((x) + 0x9bc)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                (0x9bc)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                    0xffff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_POR                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                             0x3
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                      0xffff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                           0

#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_ADDR(x)                                                ((x) + 0x9c0)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_PHYS(x)                                                ((x) + 0x9c0)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_OFFS                                                   (0x9c0)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_POR                                                    0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_POR_RMSK                                               0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_ATTR                                                                0x1
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                     0xffff0000
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                             16
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                0x8000
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                    15
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                          0x7fff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                               0

#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                             ((x) + 0x9c4)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                             ((x) + 0x9c4)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                (0x9c4)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                     0x3ff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_POR                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                             0x3
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                  0x3ff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                      0

#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                            ((x) + 0x9c8)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                            ((x) + 0x9c8)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_OFFS                                               (0x9c8)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                      0x7
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_POR                                                0x00000003
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                           0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                            0x3
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                 0x7
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                   0

#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                           ((x) + 0x9cc)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                           ((x) + 0x9cc)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_STATUS_OFFS                                              (0x9cc)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_STATUS_RMSK                                               0xfffffff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_STATUS_POR                                               0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                           0x1
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                0xff00000
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                       20
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                               0xfffff
#define HWIO_TCL_R0_SW2TCL2_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                     0

#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_ADDR(x)                                                      ((x) + 0x9d0)
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_PHYS(x)                                                      ((x) + 0x9d0)
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_OFFS                                                         (0x9d0)
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_POR                                                          0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_ATTR                                                                      0x3
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_ADDR_BMSK                                                    0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_LSB_ADDR_SHFT                                                             0

#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_ADDR(x)                                                      ((x) + 0x9d4)
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_PHYS(x)                                                      ((x) + 0x9d4)
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_OFFS                                                         (0x9d4)
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_RMSK                                                              0x1ff
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_POR                                                          0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_ATTR                                                                      0x3
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                  0x100
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                      8
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_ADDR_BMSK                                                          0xff
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_BASE_MSB_ADDR_SHFT                                                             0

#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_ADDR(x)                                                          ((x) + 0x9d8)
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_PHYS(x)                                                          ((x) + 0x9d8)
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_OFFS                                                             (0x9d8)
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_RMSK                                                             0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_POR                                                              0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_POR_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_ATTR                                                                          0x3
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_VALUE_BMSK                                                       0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_MSI1_DATA_VALUE_SHFT                                                                0

#define HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_ADDR(x)                                                    ((x) + 0x9f8)
#define HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_PHYS(x)                                                    ((x) + 0x9f8)
#define HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_OFFS                                                       (0x9f8)
#define HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_RMSK                                                           0xffff
#define HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_POR                                                        0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_POR_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_ATTR                                                                    0x3
#define HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                        0xffff
#define HWIO_TCL_R0_SW2TCL2_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                             0

#define HWIO_TCL_R0_SW2TCL2_RING_MISC_1_ADDR(x)                                                             ((x) + 0x9fc)
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_1_PHYS(x)                                                             ((x) + 0x9fc)
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_1_OFFS                                                                (0x9fc)
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_1_RMSK                                                                0xffff003f
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_1_POR                                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_1_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_1_ATTR                                                                             0x3
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_1_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL2_RING_MISC_1_ADDR(x))
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL2_RING_MISC_1_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL2_RING_MISC_1_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL2_RING_MISC_1_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL2_RING_MISC_1_IN(x))
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                       0xffff0000
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                               16
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                              0x3f
#define HWIO_TCL_R0_SW2TCL2_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                 0

#define HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_ADDR(x)                                                           ((x) + 0xa00)
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_PHYS(x)                                                           ((x) + 0xa00)
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_OFFS                                                              (0xa00)
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_POR                                                               0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_ATTR                                                                           0x3
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                           0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                    0

#define HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_ADDR(x)                                                           ((x) + 0xa04)
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_PHYS(x)                                                           ((x) + 0xa04)
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_OFFS                                                              (0xa04)
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_RMSK                                                               0xfffffff
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_POR                                                               0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_ATTR                                                                           0x3
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_RING_SIZE_BMSK                                                     0xfffff00
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_RING_SIZE_SHFT                                                             8
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                 0xff
#define HWIO_TCL_R0_SW2TCL3_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                    0

#define HWIO_TCL_R0_SW2TCL3_RING_ID_ADDR(x)                                                                 ((x) + 0xa08)
#define HWIO_TCL_R0_SW2TCL3_RING_ID_PHYS(x)                                                                 ((x) + 0xa08)
#define HWIO_TCL_R0_SW2TCL3_RING_ID_OFFS                                                                    (0xa08)
#define HWIO_TCL_R0_SW2TCL3_RING_ID_RMSK                                                                          0xff
#define HWIO_TCL_R0_SW2TCL3_RING_ID_POR                                                                     0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_ID_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_ID_ATTR                                                                                 0x3
#define HWIO_TCL_R0_SW2TCL3_RING_ID_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_ID_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_ID_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_ID_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_ID_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_ID_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_ID_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_ID_ENTRY_SIZE_BMSK                                                               0xff
#define HWIO_TCL_R0_SW2TCL3_RING_ID_ENTRY_SIZE_SHFT                                                                  0

#define HWIO_TCL_R0_SW2TCL3_RING_STATUS_ADDR(x)                                                             ((x) + 0xa0c)
#define HWIO_TCL_R0_SW2TCL3_RING_STATUS_PHYS(x)                                                             ((x) + 0xa0c)
#define HWIO_TCL_R0_SW2TCL3_RING_STATUS_OFFS                                                                (0xa0c)
#define HWIO_TCL_R0_SW2TCL3_RING_STATUS_RMSK                                                                0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_STATUS_POR                                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_STATUS_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_STATUS_ATTR                                                                             0x1
#define HWIO_TCL_R0_SW2TCL3_RING_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                0xffff0000
#define HWIO_TCL_R0_SW2TCL3_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                        16
#define HWIO_TCL_R0_SW2TCL3_RING_STATUS_NUM_VALID_WORDS_BMSK                                                    0xffff
#define HWIO_TCL_R0_SW2TCL3_RING_STATUS_NUM_VALID_WORDS_SHFT                                                         0

#define HWIO_TCL_R0_SW2TCL3_RING_MISC_ADDR(x)                                                               ((x) + 0xa10)
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_PHYS(x)                                                               ((x) + 0xa10)
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_OFFS                                                                  (0xa10)
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_RMSK                                                                    0x3fffff
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_POR                                                                   0x00000080
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_POR_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_ATTR                                                                               0x3
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_MISC_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_MISC_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_MISC_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_MISC_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_MISC_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_SPARE_CONTROL_BMSK                                                      0x3fc000
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_SPARE_CONTROL_SHFT                                                            14
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_SRNG_SM_STATE2_BMSK                                                       0x3000
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_SRNG_SM_STATE2_SHFT                                                           12
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_SRNG_SM_STATE1_BMSK                                                        0xf00
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_SRNG_SM_STATE1_SHFT                                                            8
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_SRNG_IS_IDLE_BMSK                                                           0x80
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_SRNG_IS_IDLE_SHFT                                                              7
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_SRNG_ENABLE_BMSK                                                            0x40
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_SRNG_ENABLE_SHFT                                                               6
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                      0x20
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                         5
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                       0x10
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                          4
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_MSI_SWAP_BIT_BMSK                                                            0x8
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_MSI_SWAP_BIT_SHFT                                                              3
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_SECURITY_BIT_BMSK                                                            0x4
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_SECURITY_BIT_SHFT                                                              2
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_LOOPCNT_DISABLE_BMSK                                                         0x2
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_LOOPCNT_DISABLE_SHFT                                                           1
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_RING_ID_DISABLE_BMSK                                                         0x1
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_RING_ID_DISABLE_SHFT                                                           0

#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_ADDR(x)                                                        ((x) + 0xa1c)
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_PHYS(x)                                                        ((x) + 0xa1c)
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_OFFS                                                           (0xa1c)
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_RMSK                                                           0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_POR                                                            0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_POR_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_ATTR                                                                        0x3
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                      0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                               0

#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_ADDR(x)                                                        ((x) + 0xa20)
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_PHYS(x)                                                        ((x) + 0xa20)
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_OFFS                                                           (0xa20)
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_RMSK                                                                 0xff
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_POR                                                            0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_POR_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_ATTR                                                                        0x3
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                            0xff
#define HWIO_TCL_R0_SW2TCL3_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                               0

#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                             ((x) + 0xa30)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                             ((x) + 0xa30)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                (0xa30)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_POR                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                             0x3
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                             ((x) + 0xa34)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                             ((x) + 0xa34)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                (0xa34)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                    0xffff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_POR                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                             0x3
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                      0xffff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                           0

#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_ADDR(x)                                                ((x) + 0xa38)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_PHYS(x)                                                ((x) + 0xa38)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_OFFS                                                   (0xa38)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_POR                                                    0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_POR_RMSK                                               0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_ATTR                                                                0x1
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                     0xffff0000
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                             16
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                0x8000
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                    15
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                          0x7fff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                               0

#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                             ((x) + 0xa3c)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                             ((x) + 0xa3c)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                (0xa3c)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                     0x3ff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_POR                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                             0x3
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                  0x3ff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                      0

#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                            ((x) + 0xa40)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                            ((x) + 0xa40)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_OFFS                                               (0xa40)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                      0x7
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_POR                                                0x00000003
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                           0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                            0x3
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                 0x7
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                   0

#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                           ((x) + 0xa44)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                           ((x) + 0xa44)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_STATUS_OFFS                                              (0xa44)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_STATUS_RMSK                                               0xfffffff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_STATUS_POR                                               0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                           0x1
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                0xff00000
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                       20
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                               0xfffff
#define HWIO_TCL_R0_SW2TCL3_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                     0

#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_ADDR(x)                                                      ((x) + 0xa48)
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_PHYS(x)                                                      ((x) + 0xa48)
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_OFFS                                                         (0xa48)
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_POR                                                          0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_ATTR                                                                      0x3
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_ADDR_BMSK                                                    0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_LSB_ADDR_SHFT                                                             0

#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_ADDR(x)                                                      ((x) + 0xa4c)
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_PHYS(x)                                                      ((x) + 0xa4c)
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_OFFS                                                         (0xa4c)
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_RMSK                                                              0x1ff
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_POR                                                          0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_ATTR                                                                      0x3
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                  0x100
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                      8
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_ADDR_BMSK                                                          0xff
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_BASE_MSB_ADDR_SHFT                                                             0

#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_ADDR(x)                                                          ((x) + 0xa50)
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_PHYS(x)                                                          ((x) + 0xa50)
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_OFFS                                                             (0xa50)
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_RMSK                                                             0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_POR                                                              0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_POR_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_ATTR                                                                          0x3
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_VALUE_BMSK                                                       0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_MSI1_DATA_VALUE_SHFT                                                                0

#define HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_ADDR(x)                                                    ((x) + 0xa70)
#define HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_PHYS(x)                                                    ((x) + 0xa70)
#define HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_OFFS                                                       (0xa70)
#define HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_RMSK                                                           0xffff
#define HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_POR                                                        0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_POR_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_ATTR                                                                    0x3
#define HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                        0xffff
#define HWIO_TCL_R0_SW2TCL3_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                             0

#define HWIO_TCL_R0_SW2TCL3_RING_MISC_1_ADDR(x)                                                             ((x) + 0xa74)
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_1_PHYS(x)                                                             ((x) + 0xa74)
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_1_OFFS                                                                (0xa74)
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_1_RMSK                                                                0xffff003f
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_1_POR                                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_1_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_1_ATTR                                                                             0x3
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_1_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL3_RING_MISC_1_ADDR(x))
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL3_RING_MISC_1_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL3_RING_MISC_1_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL3_RING_MISC_1_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL3_RING_MISC_1_IN(x))
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                       0xffff0000
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                               16
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                              0x3f
#define HWIO_TCL_R0_SW2TCL3_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                 0

#define HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_ADDR(x)                                                           ((x) + 0xa78)
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_PHYS(x)                                                           ((x) + 0xa78)
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_OFFS                                                              (0xa78)
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_POR                                                               0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_ATTR                                                                           0x3
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                           0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                    0

#define HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_ADDR(x)                                                           ((x) + 0xa7c)
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_PHYS(x)                                                           ((x) + 0xa7c)
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_OFFS                                                              (0xa7c)
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_RMSK                                                               0xfffffff
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_POR                                                               0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_ATTR                                                                           0x3
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_RING_SIZE_BMSK                                                     0xfffff00
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_RING_SIZE_SHFT                                                             8
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                 0xff
#define HWIO_TCL_R0_SW2TCL4_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                    0

#define HWIO_TCL_R0_SW2TCL4_RING_ID_ADDR(x)                                                                 ((x) + 0xa80)
#define HWIO_TCL_R0_SW2TCL4_RING_ID_PHYS(x)                                                                 ((x) + 0xa80)
#define HWIO_TCL_R0_SW2TCL4_RING_ID_OFFS                                                                    (0xa80)
#define HWIO_TCL_R0_SW2TCL4_RING_ID_RMSK                                                                          0xff
#define HWIO_TCL_R0_SW2TCL4_RING_ID_POR                                                                     0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_ID_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_ID_ATTR                                                                                 0x3
#define HWIO_TCL_R0_SW2TCL4_RING_ID_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_ID_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_ID_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_ID_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_ID_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_ID_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_ID_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_ID_ENTRY_SIZE_BMSK                                                               0xff
#define HWIO_TCL_R0_SW2TCL4_RING_ID_ENTRY_SIZE_SHFT                                                                  0

#define HWIO_TCL_R0_SW2TCL4_RING_STATUS_ADDR(x)                                                             ((x) + 0xa84)
#define HWIO_TCL_R0_SW2TCL4_RING_STATUS_PHYS(x)                                                             ((x) + 0xa84)
#define HWIO_TCL_R0_SW2TCL4_RING_STATUS_OFFS                                                                (0xa84)
#define HWIO_TCL_R0_SW2TCL4_RING_STATUS_RMSK                                                                0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_STATUS_POR                                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_STATUS_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_STATUS_ATTR                                                                             0x1
#define HWIO_TCL_R0_SW2TCL4_RING_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                0xffff0000
#define HWIO_TCL_R0_SW2TCL4_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                        16
#define HWIO_TCL_R0_SW2TCL4_RING_STATUS_NUM_VALID_WORDS_BMSK                                                    0xffff
#define HWIO_TCL_R0_SW2TCL4_RING_STATUS_NUM_VALID_WORDS_SHFT                                                         0

#define HWIO_TCL_R0_SW2TCL4_RING_MISC_ADDR(x)                                                               ((x) + 0xa88)
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_PHYS(x)                                                               ((x) + 0xa88)
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_OFFS                                                                  (0xa88)
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_RMSK                                                                    0x3fffff
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_POR                                                                   0x00000080
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_POR_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_ATTR                                                                               0x3
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_MISC_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_MISC_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_MISC_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_MISC_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_MISC_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_SPARE_CONTROL_BMSK                                                      0x3fc000
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_SPARE_CONTROL_SHFT                                                            14
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_SRNG_SM_STATE2_BMSK                                                       0x3000
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_SRNG_SM_STATE2_SHFT                                                           12
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_SRNG_SM_STATE1_BMSK                                                        0xf00
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_SRNG_SM_STATE1_SHFT                                                            8
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_SRNG_IS_IDLE_BMSK                                                           0x80
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_SRNG_IS_IDLE_SHFT                                                              7
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_SRNG_ENABLE_BMSK                                                            0x40
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_SRNG_ENABLE_SHFT                                                               6
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                      0x20
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                         5
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                       0x10
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                          4
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_MSI_SWAP_BIT_BMSK                                                            0x8
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_MSI_SWAP_BIT_SHFT                                                              3
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_SECURITY_BIT_BMSK                                                            0x4
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_SECURITY_BIT_SHFT                                                              2
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_LOOPCNT_DISABLE_BMSK                                                         0x2
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_LOOPCNT_DISABLE_SHFT                                                           1
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_RING_ID_DISABLE_BMSK                                                         0x1
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_RING_ID_DISABLE_SHFT                                                           0

#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_ADDR(x)                                                        ((x) + 0xa94)
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_PHYS(x)                                                        ((x) + 0xa94)
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_OFFS                                                           (0xa94)
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_RMSK                                                           0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_POR                                                            0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_POR_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_ATTR                                                                        0x3
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                      0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                               0

#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_ADDR(x)                                                        ((x) + 0xa98)
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_PHYS(x)                                                        ((x) + 0xa98)
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_OFFS                                                           (0xa98)
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_RMSK                                                                 0xff
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_POR                                                            0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_POR_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_ATTR                                                                        0x3
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                            0xff
#define HWIO_TCL_R0_SW2TCL4_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                               0

#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                             ((x) + 0xaa8)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                             ((x) + 0xaa8)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                (0xaa8)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_POR                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                             0x3
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                             ((x) + 0xaac)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                             ((x) + 0xaac)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                (0xaac)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                    0xffff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_POR                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                             0x3
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                      0xffff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                           0

#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_ADDR(x)                                                ((x) + 0xab0)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_PHYS(x)                                                ((x) + 0xab0)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_OFFS                                                   (0xab0)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_POR                                                    0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_POR_RMSK                                               0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_ATTR                                                                0x1
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                     0xffff0000
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                             16
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                0x8000
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                    15
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                          0x7fff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                               0

#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                             ((x) + 0xab4)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                             ((x) + 0xab4)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                (0xab4)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                     0x3ff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_POR                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                             0x3
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                  0x3ff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                      0

#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                            ((x) + 0xab8)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                            ((x) + 0xab8)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_OFFS                                               (0xab8)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                      0x7
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_POR                                                0x00000003
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                           0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                            0x3
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                 0x7
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                   0

#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                           ((x) + 0xabc)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                           ((x) + 0xabc)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_STATUS_OFFS                                              (0xabc)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_STATUS_RMSK                                               0xfffffff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_STATUS_POR                                               0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                           0x1
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                0xff00000
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                       20
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                               0xfffff
#define HWIO_TCL_R0_SW2TCL4_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                     0

#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_ADDR(x)                                                      ((x) + 0xac0)
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_PHYS(x)                                                      ((x) + 0xac0)
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_OFFS                                                         (0xac0)
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_POR                                                          0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_ATTR                                                                      0x3
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_ADDR_BMSK                                                    0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_LSB_ADDR_SHFT                                                             0

#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_ADDR(x)                                                      ((x) + 0xac4)
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_PHYS(x)                                                      ((x) + 0xac4)
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_OFFS                                                         (0xac4)
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_RMSK                                                              0x1ff
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_POR                                                          0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_ATTR                                                                      0x3
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                  0x100
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                      8
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_ADDR_BMSK                                                          0xff
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_BASE_MSB_ADDR_SHFT                                                             0

#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_ADDR(x)                                                          ((x) + 0xac8)
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_PHYS(x)                                                          ((x) + 0xac8)
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_OFFS                                                             (0xac8)
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_RMSK                                                             0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_POR                                                              0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_POR_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_ATTR                                                                          0x3
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_VALUE_BMSK                                                       0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_MSI1_DATA_VALUE_SHFT                                                                0

#define HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_ADDR(x)                                                    ((x) + 0xae8)
#define HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_PHYS(x)                                                    ((x) + 0xae8)
#define HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_OFFS                                                       (0xae8)
#define HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_RMSK                                                           0xffff
#define HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_POR                                                        0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_POR_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_ATTR                                                                    0x3
#define HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                        0xffff
#define HWIO_TCL_R0_SW2TCL4_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                             0

#define HWIO_TCL_R0_SW2TCL4_RING_MISC_1_ADDR(x)                                                             ((x) + 0xaec)
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_1_PHYS(x)                                                             ((x) + 0xaec)
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_1_OFFS                                                                (0xaec)
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_1_RMSK                                                                0xffff003f
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_1_POR                                                                 0x00000000
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_1_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_1_ATTR                                                                             0x3
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_1_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL4_RING_MISC_1_ADDR(x))
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL4_RING_MISC_1_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL4_RING_MISC_1_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL4_RING_MISC_1_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL4_RING_MISC_1_IN(x))
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                       0xffff0000
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                               16
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                              0x3f
#define HWIO_TCL_R0_SW2TCL4_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                 0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_ADDR(x)                                                     ((x) + 0xb68)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_PHYS(x)                                                     ((x) + 0xb68)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_OFFS                                                        (0xb68)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_RMSK                                                        0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_POR                                                         0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_POR_RMSK                                                    0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_ATTR                                                                     0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                     0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                              0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_ADDR(x)                                                     ((x) + 0xb6c)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_PHYS(x)                                                     ((x) + 0xb6c)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_OFFS                                                        (0xb6c)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_RMSK                                                         0xfffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_POR                                                         0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_POR_RMSK                                                    0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_ATTR                                                                     0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_RING_SIZE_BMSK                                               0xfffff00
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_RING_SIZE_SHFT                                                       8
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                           0xff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                              0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_ADDR(x)                                                           ((x) + 0xb70)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_PHYS(x)                                                           ((x) + 0xb70)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_OFFS                                                              (0xb70)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_RMSK                                                                    0xff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_POR                                                               0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_ATTR                                                                           0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_ENTRY_SIZE_BMSK                                                         0xff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_ID_ENTRY_SIZE_SHFT                                                            0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_STATUS_ADDR(x)                                                       ((x) + 0xb74)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_STATUS_PHYS(x)                                                       ((x) + 0xb74)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_STATUS_OFFS                                                          (0xb74)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_STATUS_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_STATUS_POR                                                           0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_STATUS_POR_RMSK                                                      0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_STATUS_ATTR                                                                       0x1
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                          0xffff0000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                  16
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_STATUS_NUM_VALID_WORDS_BMSK                                              0xffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_STATUS_NUM_VALID_WORDS_SHFT                                                   0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_ADDR(x)                                                         ((x) + 0xb78)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_PHYS(x)                                                         ((x) + 0xb78)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_OFFS                                                            (0xb78)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_RMSK                                                              0x3fffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_POR                                                             0x00000080
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_POR_RMSK                                                        0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_ATTR                                                                         0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_SPARE_CONTROL_BMSK                                                0x3fc000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_SPARE_CONTROL_SHFT                                                      14
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_SRNG_SM_STATE2_BMSK                                                 0x3000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_SRNG_SM_STATE2_SHFT                                                     12
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_SRNG_SM_STATE1_BMSK                                                  0xf00
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_SRNG_SM_STATE1_SHFT                                                      8
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_SRNG_IS_IDLE_BMSK                                                     0x80
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_SRNG_IS_IDLE_SHFT                                                        7
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_SRNG_ENABLE_BMSK                                                      0x40
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_SRNG_ENABLE_SHFT                                                         6
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                0x20
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                   5
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                 0x10
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                    4
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_MSI_SWAP_BIT_BMSK                                                      0x8
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_MSI_SWAP_BIT_SHFT                                                        3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_SECURITY_BIT_BMSK                                                      0x4
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_SECURITY_BIT_SHFT                                                        2
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_LOOPCNT_DISABLE_BMSK                                                   0x2
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_LOOPCNT_DISABLE_SHFT                                                     1
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_RING_ID_DISABLE_BMSK                                                   0x1
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_RING_ID_DISABLE_SHFT                                                     0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_ADDR(x)                                                  ((x) + 0xb84)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_PHYS(x)                                                  ((x) + 0xb84)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_OFFS                                                     (0xb84)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_POR                                                      0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_ATTR                                                                  0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                         0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_ADDR(x)                                                  ((x) + 0xb88)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_PHYS(x)                                                  ((x) + 0xb88)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_OFFS                                                     (0xb88)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_RMSK                                                           0xff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_POR                                                      0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_ATTR                                                                  0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                      0xff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                         0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                       ((x) + 0xb98)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                       ((x) + 0xb98)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_OFFS                                          (0xb98)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_RMSK                                          0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_POR                                           0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                      0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                       0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                0xffff0000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                        16
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                            0x8000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                15
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                      0x7fff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                           0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                       ((x) + 0xb9c)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                       ((x) + 0xb9c)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_OFFS                                          (0xb9c)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_RMSK                                              0xffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_POR                                           0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                      0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                       0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                0xffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                     0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_ADDR(x)                                          ((x) + 0xba0)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_PHYS(x)                                          ((x) + 0xba0)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_OFFS                                             (0xba0)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_RMSK                                             0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_POR                                              0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_POR_RMSK                                         0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_ATTR                                                          0x1
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK               0xffff0000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                       16
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                          0x8000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                              15
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                    0x7fff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                         0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                       ((x) + 0xba4)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                       ((x) + 0xba4)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_OFFS                                          (0xba4)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_RMSK                                               0x3ff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_POR                                           0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                      0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                       0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                            0x3ff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                      ((x) + 0xba8)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                      ((x) + 0xba8)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_OFFS                                         (0xba8)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                0x7
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_POR                                          0x00000003
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                     0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                      0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                           0x7
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                             0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                     ((x) + 0xbac)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                     ((x) + 0xbac)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_STATUS_OFFS                                        (0xbac)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_STATUS_RMSK                                         0xfffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_STATUS_POR                                         0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                    0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                     0x1
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                          0xff00000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                 20
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                         0xfffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                               0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_ADDR(x)                                                ((x) + 0xbb0)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_PHYS(x)                                                ((x) + 0xbb0)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_OFFS                                                   (0xbb0)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_POR                                                    0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_POR_RMSK                                               0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_ATTR                                                                0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_ADDR_BMSK                                              0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_LSB_ADDR_SHFT                                                       0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_ADDR(x)                                                ((x) + 0xbb4)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_PHYS(x)                                                ((x) + 0xbb4)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_OFFS                                                   (0xbb4)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_RMSK                                                        0x1ff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_POR                                                    0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_POR_RMSK                                               0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_ATTR                                                                0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                            0x100
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                8
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_ADDR_BMSK                                                    0xff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_BASE_MSB_ADDR_SHFT                                                       0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_ADDR(x)                                                    ((x) + 0xbb8)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_PHYS(x)                                                    ((x) + 0xbb8)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_OFFS                                                       (0xbb8)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_POR                                                        0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_POR_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_ATTR                                                                    0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_VALUE_BMSK                                                 0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MSI1_DATA_VALUE_SHFT                                                          0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_ADDR(x)                                              ((x) + 0xbd8)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_PHYS(x)                                              ((x) + 0xbd8)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_OFFS                                                 (0xbd8)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_RMSK                                                     0xffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_POR                                                  0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_POR_RMSK                                             0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_ATTR                                                              0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                  0xffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                       0

#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_ADDR(x)                                                       ((x) + 0xbdc)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_PHYS(x)                                                       ((x) + 0xbdc)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_OFFS                                                          (0xbdc)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_RMSK                                                          0xffff003f
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_POR                                                           0x00000000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_POR_RMSK                                                      0xffffffff
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_ATTR                                                                       0x3
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_IN(x)            \
                in_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_ADDR(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_ADDR(x), m)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_ADDR(x),v)
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_ADDR(x),m,v,HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_IN(x))
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                 0xffff0000
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                         16
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                        0x3f
#define HWIO_TCL_R0_SW2TCL_CREDIT_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                           0

#define HWIO_TCL_R0_FW2TCL1_RING_BASE_LSB_ADDR(x)                                                           ((x) + 0xbe0)
#define HWIO_TCL_R0_FW2TCL1_RING_BASE_LSB_PHYS(x)                                                           ((x) + 0xbe0)
#define HWIO_TCL_R0_FW2TCL1_RING_BASE_LSB_OFFS                                                              (0xbe0)
#define HWIO_TCL_R0_FW2TCL1_RING_BASE_LSB_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_FW2TCL1_RING_BASE_LSB_POR                                                               0x00000000
#define HWIO_TCL_R0_FW2TCL1_RING_BASE_LSB_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_FW2TCL1_RING_BASE_LSB_ATTR                                                                           0x3
#define HWIO_TCL_R0_FW2TCL1_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_FW2TCL1_RING_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_FW2TCL1_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_FW2TCL1_RING_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_FW2TCL1_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_FW2TCL1_RING_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_FW2TCL1_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_FW2TCL1_RING_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_FW2TCL1_RING_BASE_LSB_IN(x))
#define HWIO_TCL_R0_FW2TCL1_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                           0xffffffff
#define HWIO_TCL_R0_FW2TCL1_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                    0

#define HWIO_TCL_R0_FW2TCL1_RING_BASE_MSB_ADDR(x)                                                           ((x) + 0xbe4)
#define HWIO_TCL_R0_FW2TCL1_RING_BASE_MSB_PHYS(x)                                                           ((x) + 0xbe4)
#define HWIO_TCL_R0_FW2TCL1_RING_BASE_MSB_OFFS                                                              (0xbe4)
#define HWIO_TCL_R0_FW2TCL1_RING_BASE_MSB_RMSK                                                                0xffffff
#define HWIO_TCL_R0_FW2TCL1_RING_BASE_MSB_POR                                                               0x00000000
#define HWIO_TCL_R0_FW2TCL1_RING_BASE_MSB_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_FW2TCL1_RING_BASE_MSB_ATTR                                                                           0x3
#define HWIO_TCL_R0_FW2TCL1_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_FW2TCL1_RING_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_FW2TCL1_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_FW2TCL1_RING_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_FW2TCL1_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_FW2TCL1_RING_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_FW2TCL1_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_FW2TCL1_RING_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_FW2TCL1_RING_BASE_MSB_IN(x))
#define HWIO_TCL_R0_FW2TCL1_RING_BASE_MSB_RING_SIZE_BMSK                                                      0xffff00
#define HWIO_TCL_R0_FW2TCL1_RING_BASE_MSB_RING_SIZE_SHFT                                                             8
#define HWIO_TCL_R0_FW2TCL1_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                 0xff
#define HWIO_TCL_R0_FW2TCL1_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                    0

#define HWIO_TCL_R0_FW2TCL1_RING_ID_ADDR(x)                                                                 ((x) + 0xbe8)
#define HWIO_TCL_R0_FW2TCL1_RING_ID_PHYS(x)                                                                 ((x) + 0xbe8)
#define HWIO_TCL_R0_FW2TCL1_RING_ID_OFFS                                                                    (0xbe8)
#define HWIO_TCL_R0_FW2TCL1_RING_ID_RMSK                                                                          0xff
#define HWIO_TCL_R0_FW2TCL1_RING_ID_POR                                                                     0x00000000
#define HWIO_TCL_R0_FW2TCL1_RING_ID_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R0_FW2TCL1_RING_ID_ATTR                                                                                 0x3
#define HWIO_TCL_R0_FW2TCL1_RING_ID_IN(x)            \
                in_dword(HWIO_TCL_R0_FW2TCL1_RING_ID_ADDR(x))
#define HWIO_TCL_R0_FW2TCL1_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_FW2TCL1_RING_ID_ADDR(x), m)
#define HWIO_TCL_R0_FW2TCL1_RING_ID_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_FW2TCL1_RING_ID_ADDR(x),v)
#define HWIO_TCL_R0_FW2TCL1_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_FW2TCL1_RING_ID_ADDR(x),m,v,HWIO_TCL_R0_FW2TCL1_RING_ID_IN(x))
#define HWIO_TCL_R0_FW2TCL1_RING_ID_ENTRY_SIZE_BMSK                                                               0xff
#define HWIO_TCL_R0_FW2TCL1_RING_ID_ENTRY_SIZE_SHFT                                                                  0

#define HWIO_TCL_R0_FW2TCL1_RING_STATUS_ADDR(x)                                                             ((x) + 0xbec)
#define HWIO_TCL_R0_FW2TCL1_RING_STATUS_PHYS(x)                                                             ((x) + 0xbec)
#define HWIO_TCL_R0_FW2TCL1_RING_STATUS_OFFS                                                                (0xbec)
#define HWIO_TCL_R0_FW2TCL1_RING_STATUS_RMSK                                                                0xffffffff
#define HWIO_TCL_R0_FW2TCL1_RING_STATUS_POR                                                                 0x00000000
#define HWIO_TCL_R0_FW2TCL1_RING_STATUS_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R0_FW2TCL1_RING_STATUS_ATTR                                                                             0x1
#define HWIO_TCL_R0_FW2TCL1_RING_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_FW2TCL1_RING_STATUS_ADDR(x))
#define HWIO_TCL_R0_FW2TCL1_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_FW2TCL1_RING_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_FW2TCL1_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                0xffff0000
#define HWIO_TCL_R0_FW2TCL1_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                        16
#define HWIO_TCL_R0_FW2TCL1_RING_STATUS_NUM_VALID_WORDS_BMSK                                                    0xffff
#define HWIO_TCL_R0_FW2TCL1_RING_STATUS_NUM_VALID_WORDS_SHFT                                                         0

#define HWIO_TCL_R0_FW2TCL1_RING_MISC_ADDR(x)                                                               ((x) + 0xbf0)
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_PHYS(x)                                                               ((x) + 0xbf0)
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_OFFS                                                                  (0xbf0)
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_RMSK                                                                    0x3fffff
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_POR                                                                   0x00000080
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_POR_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_ATTR                                                                               0x3
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_IN(x)            \
                in_dword(HWIO_TCL_R0_FW2TCL1_RING_MISC_ADDR(x))
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_FW2TCL1_RING_MISC_ADDR(x), m)
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_FW2TCL1_RING_MISC_ADDR(x),v)
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_FW2TCL1_RING_MISC_ADDR(x),m,v,HWIO_TCL_R0_FW2TCL1_RING_MISC_IN(x))
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_SPARE_CONTROL_BMSK                                                      0x3fc000
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_SPARE_CONTROL_SHFT                                                            14
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_SRNG_SM_STATE2_BMSK                                                       0x3000
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_SRNG_SM_STATE2_SHFT                                                           12
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_SRNG_SM_STATE1_BMSK                                                        0xf00
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_SRNG_SM_STATE1_SHFT                                                            8
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_SRNG_IS_IDLE_BMSK                                                           0x80
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_SRNG_IS_IDLE_SHFT                                                              7
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_SRNG_ENABLE_BMSK                                                            0x40
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_SRNG_ENABLE_SHFT                                                               6
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                      0x20
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                         5
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                       0x10
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                          4
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_MSI_SWAP_BIT_BMSK                                                            0x8
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_MSI_SWAP_BIT_SHFT                                                              3
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_SECURITY_BIT_BMSK                                                            0x4
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_SECURITY_BIT_SHFT                                                              2
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_LOOPCNT_DISABLE_BMSK                                                         0x2
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_LOOPCNT_DISABLE_SHFT                                                           1
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_RING_ID_DISABLE_BMSK                                                         0x1
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_RING_ID_DISABLE_SHFT                                                           0

#define HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_LSB_ADDR(x)                                                        ((x) + 0xbfc)
#define HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_LSB_PHYS(x)                                                        ((x) + 0xbfc)
#define HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_LSB_OFFS                                                           (0xbfc)
#define HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_LSB_RMSK                                                           0xffffffff
#define HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_LSB_POR                                                            0x00000000
#define HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_LSB_POR_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_LSB_ATTR                                                                        0x3
#define HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_LSB_ADDR(x))
#define HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_LSB_ADDR(x), m)
#define HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_LSB_ADDR(x),v)
#define HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_LSB_ADDR(x),m,v,HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_LSB_IN(x))
#define HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_BMSK                                      0xffffffff
#define HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_LSB_TAIL_PTR_MEMADDR_LSB_SHFT                                               0

#define HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_MSB_ADDR(x)                                                        ((x) + 0xc00)
#define HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_MSB_PHYS(x)                                                        ((x) + 0xc00)
#define HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_MSB_OFFS                                                           (0xc00)
#define HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_MSB_RMSK                                                                 0xff
#define HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_MSB_POR                                                            0x00000000
#define HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_MSB_POR_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_MSB_ATTR                                                                        0x3
#define HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_MSB_ADDR(x))
#define HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_MSB_ADDR(x), m)
#define HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_MSB_ADDR(x),v)
#define HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_MSB_ADDR(x),m,v,HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_MSB_IN(x))
#define HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_BMSK                                            0xff
#define HWIO_TCL_R0_FW2TCL1_RING_TP_ADDR_MSB_TAIL_PTR_MEMADDR_MSB_SHFT                                               0

#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x)                                             ((x) + 0xc10)
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX0_PHYS(x)                                             ((x) + 0xc10)
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX0_OFFS                                                (0xc10)
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX0_RMSK                                                0xffffffff
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX0_POR                                                 0x00000000
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX0_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX0_ATTR                                                             0x3
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX0_IN(x)            \
                in_dword(HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x))
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX0_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x), m)
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX0_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),v)
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX0_ADDR(x),m,v,HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX0_IN(x))
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX0_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX0_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX0_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x)                                             ((x) + 0xc14)
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX1_PHYS(x)                                             ((x) + 0xc14)
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX1_OFFS                                                (0xc14)
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX1_RMSK                                                    0xffff
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX1_POR                                                 0x00000000
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX1_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX1_ATTR                                                             0x3
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX1_IN(x)            \
                in_dword(HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x))
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x), m)
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),v)
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX1_ADDR(x),m,v,HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX1_IN(x))
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_BMSK                                      0xffff
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_SETUP_IX1_LOW_THRESHOLD_SHFT                                           0

#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_STATUS_ADDR(x)                                                ((x) + 0xc18)
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_STATUS_PHYS(x)                                                ((x) + 0xc18)
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_STATUS_OFFS                                                   (0xc18)
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_STATUS_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_STATUS_POR                                                    0x00000000
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_STATUS_POR_RMSK                                               0xffffffff
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_STATUS_ATTR                                                                0x1
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_STATUS_ADDR(x))
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                     0xffff0000
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                             16
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_BMSK                                0x8000
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_STATUS_CURRENT_INT_WIRE_VALUE_SHFT                                    15
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                          0x7fff
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                               0

#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x)                                             ((x) + 0xc1c)
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_EMPTY_COUNTER_PHYS(x)                                             ((x) + 0xc1c)
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_EMPTY_COUNTER_OFFS                                                (0xc1c)
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_EMPTY_COUNTER_RMSK                                                     0x3ff
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_EMPTY_COUNTER_POR                                                 0x00000000
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_EMPTY_COUNTER_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_EMPTY_COUNTER_ATTR                                                             0x3
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_EMPTY_COUNTER_IN(x)            \
                in_dword(HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x))
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_EMPTY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x), m)
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_EMPTY_COUNTER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),v)
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_EMPTY_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_EMPTY_COUNTER_ADDR(x),m,v,HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_EMPTY_COUNTER_IN(x))
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_BMSK                                  0x3ff
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_EMPTY_COUNTER_RING_EMPTY_COUNTER_SHFT                                      0

#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x)                                            ((x) + 0xc20)
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_TIMER_PHYS(x)                                            ((x) + 0xc20)
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_TIMER_OFFS                                               (0xc20)
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_TIMER_RMSK                                                      0x7
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_TIMER_POR                                                0x00000003
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_TIMER_POR_RMSK                                           0xffffffff
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_TIMER_ATTR                                                            0x3
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_TIMER_IN(x)            \
                in_dword(HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x))
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x), m)
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_TIMER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),v)
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_TIMER_ADDR(x),m,v,HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_TIMER_IN(x))
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_TIMER_MODE_BMSK                                                 0x7
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_TIMER_MODE_SHFT                                                   0

#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_STATUS_ADDR(x)                                           ((x) + 0xc24)
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_STATUS_PHYS(x)                                           ((x) + 0xc24)
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_STATUS_OFFS                                              (0xc24)
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_STATUS_RMSK                                                0xffffff
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_STATUS_POR                                               0x00000000
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_STATUS_POR_RMSK                                          0xffffffff
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_STATUS_ATTR                                                           0x1
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_STATUS_ADDR(x))
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_BMSK                                 0xff0000
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_STATUS_PREFETCH_COUNT_SHFT                                       16
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_BMSK                                0xffff
#define HWIO_TCL_R0_FW2TCL1_RING_CONSUMER_PREFETCH_STATUS_INTERNAL_TAIL_PTR_SHFT                                     0

#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_LSB_ADDR(x)                                                      ((x) + 0xc28)
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_LSB_PHYS(x)                                                      ((x) + 0xc28)
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_LSB_OFFS                                                         (0xc28)
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_LSB_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_LSB_POR                                                          0x00000000
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_LSB_ATTR                                                                      0x3
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_LSB_ADDR_BMSK                                                    0xffffffff
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_LSB_ADDR_SHFT                                                             0

#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_MSB_ADDR(x)                                                      ((x) + 0xc2c)
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_MSB_PHYS(x)                                                      ((x) + 0xc2c)
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_MSB_OFFS                                                         (0xc2c)
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_MSB_RMSK                                                              0x1ff
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_MSB_POR                                                          0x00000000
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_MSB_ATTR                                                                      0x3
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                  0x100
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                      8
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_MSB_ADDR_BMSK                                                          0xff
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_BASE_MSB_ADDR_SHFT                                                             0

#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_DATA_ADDR(x)                                                          ((x) + 0xc30)
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_DATA_PHYS(x)                                                          ((x) + 0xc30)
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_DATA_OFFS                                                             (0xc30)
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_DATA_RMSK                                                             0xffffffff
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_DATA_POR                                                              0x00000000
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_DATA_POR_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_DATA_ATTR                                                                          0x3
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_TCL_R0_FW2TCL1_RING_MSI1_DATA_ADDR(x))
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_FW2TCL1_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_FW2TCL1_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_FW2TCL1_RING_MSI1_DATA_ADDR(x),m,v,HWIO_TCL_R0_FW2TCL1_RING_MSI1_DATA_IN(x))
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_DATA_VALUE_BMSK                                                       0xffffffff
#define HWIO_TCL_R0_FW2TCL1_RING_MSI1_DATA_VALUE_SHFT                                                                0

#define HWIO_TCL_R0_FW2TCL1_RING_HP_TP_SW_OFFSET_ADDR(x)                                                    ((x) + 0xc50)
#define HWIO_TCL_R0_FW2TCL1_RING_HP_TP_SW_OFFSET_PHYS(x)                                                    ((x) + 0xc50)
#define HWIO_TCL_R0_FW2TCL1_RING_HP_TP_SW_OFFSET_OFFS                                                       (0xc50)
#define HWIO_TCL_R0_FW2TCL1_RING_HP_TP_SW_OFFSET_RMSK                                                           0xffff
#define HWIO_TCL_R0_FW2TCL1_RING_HP_TP_SW_OFFSET_POR                                                        0x00000000
#define HWIO_TCL_R0_FW2TCL1_RING_HP_TP_SW_OFFSET_POR_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_FW2TCL1_RING_HP_TP_SW_OFFSET_ATTR                                                                    0x3
#define HWIO_TCL_R0_FW2TCL1_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_TCL_R0_FW2TCL1_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_TCL_R0_FW2TCL1_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_FW2TCL1_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_TCL_R0_FW2TCL1_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_FW2TCL1_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_TCL_R0_FW2TCL1_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_FW2TCL1_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_TCL_R0_FW2TCL1_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_TCL_R0_FW2TCL1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                        0xffff
#define HWIO_TCL_R0_FW2TCL1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                             0

#define HWIO_TCL_R0_FW2TCL1_RING_MISC_1_ADDR(x)                                                             ((x) + 0xc54)
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_1_PHYS(x)                                                             ((x) + 0xc54)
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_1_OFFS                                                                (0xc54)
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_1_RMSK                                                                0xffff003f
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_1_POR                                                                 0x00000000
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_1_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_1_ATTR                                                                             0x3
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_1_IN(x)            \
                in_dword(HWIO_TCL_R0_FW2TCL1_RING_MISC_1_ADDR(x))
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_FW2TCL1_RING_MISC_1_ADDR(x), m)
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_FW2TCL1_RING_MISC_1_ADDR(x),v)
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_FW2TCL1_RING_MISC_1_ADDR(x),m,v,HWIO_TCL_R0_FW2TCL1_RING_MISC_1_IN(x))
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                       0xffff0000
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                               16
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                              0x3f
#define HWIO_TCL_R0_FW2TCL1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                 0

#define HWIO_TCL_R0_TCL2TQM_RING_BASE_LSB_ADDR(x)                                                           ((x) + 0xcd0)
#define HWIO_TCL_R0_TCL2TQM_RING_BASE_LSB_PHYS(x)                                                           ((x) + 0xcd0)
#define HWIO_TCL_R0_TCL2TQM_RING_BASE_LSB_OFFS                                                              (0xcd0)
#define HWIO_TCL_R0_TCL2TQM_RING_BASE_LSB_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_BASE_LSB_POR                                                               0x00000000
#define HWIO_TCL_R0_TCL2TQM_RING_BASE_LSB_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_BASE_LSB_ATTR                                                                           0x3
#define HWIO_TCL_R0_TCL2TQM_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2TQM_RING_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_TCL2TQM_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2TQM_RING_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL2TQM_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2TQM_RING_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL2TQM_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2TQM_RING_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_TCL2TQM_RING_BASE_LSB_IN(x))
#define HWIO_TCL_R0_TCL2TQM_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                           0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                    0

#define HWIO_TCL_R0_TCL2TQM_RING_BASE_MSB_ADDR(x)                                                           ((x) + 0xcd4)
#define HWIO_TCL_R0_TCL2TQM_RING_BASE_MSB_PHYS(x)                                                           ((x) + 0xcd4)
#define HWIO_TCL_R0_TCL2TQM_RING_BASE_MSB_OFFS                                                              (0xcd4)
#define HWIO_TCL_R0_TCL2TQM_RING_BASE_MSB_RMSK                                                                0xffffff
#define HWIO_TCL_R0_TCL2TQM_RING_BASE_MSB_POR                                                               0x00000000
#define HWIO_TCL_R0_TCL2TQM_RING_BASE_MSB_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_BASE_MSB_ATTR                                                                           0x3
#define HWIO_TCL_R0_TCL2TQM_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2TQM_RING_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_TCL2TQM_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2TQM_RING_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL2TQM_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2TQM_RING_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL2TQM_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2TQM_RING_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_TCL2TQM_RING_BASE_MSB_IN(x))
#define HWIO_TCL_R0_TCL2TQM_RING_BASE_MSB_RING_SIZE_BMSK                                                      0xffff00
#define HWIO_TCL_R0_TCL2TQM_RING_BASE_MSB_RING_SIZE_SHFT                                                             8
#define HWIO_TCL_R0_TCL2TQM_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                 0xff
#define HWIO_TCL_R0_TCL2TQM_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                    0

#define HWIO_TCL_R0_TCL2TQM_RING_ID_ADDR(x)                                                                 ((x) + 0xcd8)
#define HWIO_TCL_R0_TCL2TQM_RING_ID_PHYS(x)                                                                 ((x) + 0xcd8)
#define HWIO_TCL_R0_TCL2TQM_RING_ID_OFFS                                                                    (0xcd8)
#define HWIO_TCL_R0_TCL2TQM_RING_ID_RMSK                                                                        0xffff
#define HWIO_TCL_R0_TCL2TQM_RING_ID_POR                                                                     0x00000000
#define HWIO_TCL_R0_TCL2TQM_RING_ID_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_ID_ATTR                                                                                 0x3
#define HWIO_TCL_R0_TCL2TQM_RING_ID_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2TQM_RING_ID_ADDR(x))
#define HWIO_TCL_R0_TCL2TQM_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2TQM_RING_ID_ADDR(x), m)
#define HWIO_TCL_R0_TCL2TQM_RING_ID_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2TQM_RING_ID_ADDR(x),v)
#define HWIO_TCL_R0_TCL2TQM_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2TQM_RING_ID_ADDR(x),m,v,HWIO_TCL_R0_TCL2TQM_RING_ID_IN(x))
#define HWIO_TCL_R0_TCL2TQM_RING_ID_RING_ID_BMSK                                                                0xff00
#define HWIO_TCL_R0_TCL2TQM_RING_ID_RING_ID_SHFT                                                                     8
#define HWIO_TCL_R0_TCL2TQM_RING_ID_ENTRY_SIZE_BMSK                                                               0xff
#define HWIO_TCL_R0_TCL2TQM_RING_ID_ENTRY_SIZE_SHFT                                                                  0

#define HWIO_TCL_R0_TCL2TQM_RING_STATUS_ADDR(x)                                                             ((x) + 0xcdc)
#define HWIO_TCL_R0_TCL2TQM_RING_STATUS_PHYS(x)                                                             ((x) + 0xcdc)
#define HWIO_TCL_R0_TCL2TQM_RING_STATUS_OFFS                                                                (0xcdc)
#define HWIO_TCL_R0_TCL2TQM_RING_STATUS_RMSK                                                                0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_STATUS_POR                                                                 0x00000000
#define HWIO_TCL_R0_TCL2TQM_RING_STATUS_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_STATUS_ATTR                                                                             0x1
#define HWIO_TCL_R0_TCL2TQM_RING_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2TQM_RING_STATUS_ADDR(x))
#define HWIO_TCL_R0_TCL2TQM_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2TQM_RING_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_TCL2TQM_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                0xffff0000
#define HWIO_TCL_R0_TCL2TQM_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                        16
#define HWIO_TCL_R0_TCL2TQM_RING_STATUS_NUM_VALID_WORDS_BMSK                                                    0xffff
#define HWIO_TCL_R0_TCL2TQM_RING_STATUS_NUM_VALID_WORDS_SHFT                                                         0

#define HWIO_TCL_R0_TCL2TQM_RING_MISC_ADDR(x)                                                               ((x) + 0xce0)
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_PHYS(x)                                                               ((x) + 0xce0)
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_OFFS                                                                  (0xce0)
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_RMSK                                                                   0x7ffffff
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_POR                                                                   0x00000080
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_POR_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_ATTR                                                                               0x3
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2TQM_RING_MISC_ADDR(x))
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2TQM_RING_MISC_ADDR(x), m)
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2TQM_RING_MISC_ADDR(x),v)
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2TQM_RING_MISC_ADDR(x),m,v,HWIO_TCL_R0_TCL2TQM_RING_MISC_IN(x))
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                           0x4000000
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                  26
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_LOOP_CNT_BMSK                                                          0x3c00000
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_LOOP_CNT_SHFT                                                                 22
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_SPARE_CONTROL_BMSK                                                      0x3fc000
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_SPARE_CONTROL_SHFT                                                            14
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_SRNG_SM_STATE2_BMSK                                                       0x3000
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_SRNG_SM_STATE2_SHFT                                                           12
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_SRNG_SM_STATE1_BMSK                                                        0xf00
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_SRNG_SM_STATE1_SHFT                                                            8
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_SRNG_IS_IDLE_BMSK                                                           0x80
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_SRNG_IS_IDLE_SHFT                                                              7
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_SRNG_ENABLE_BMSK                                                            0x40
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_SRNG_ENABLE_SHFT                                                               6
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                      0x20
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                         5
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                       0x10
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                          4
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_MSI_SWAP_BIT_BMSK                                                            0x8
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_MSI_SWAP_BIT_SHFT                                                              3
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_SECURITY_BIT_BMSK                                                            0x4
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_SECURITY_BIT_SHFT                                                              2
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_LOOPCNT_DISABLE_BMSK                                                         0x2
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_LOOPCNT_DISABLE_SHFT                                                           1
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_RING_ID_DISABLE_BMSK                                                         0x1
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_RING_ID_DISABLE_SHFT                                                           0

#define HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_LSB_ADDR(x)                                                        ((x) + 0xce4)
#define HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_LSB_PHYS(x)                                                        ((x) + 0xce4)
#define HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_LSB_OFFS                                                           (0xce4)
#define HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_LSB_RMSK                                                           0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_LSB_POR                                                            0x00000000
#define HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_LSB_POR_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_LSB_ATTR                                                                        0x3
#define HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_LSB_IN(x))
#define HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                      0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                               0

#define HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_MSB_ADDR(x)                                                        ((x) + 0xce8)
#define HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_MSB_PHYS(x)                                                        ((x) + 0xce8)
#define HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_MSB_OFFS                                                           (0xce8)
#define HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_MSB_RMSK                                                                 0xff
#define HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_MSB_POR                                                            0x00000000
#define HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_MSB_POR_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_MSB_ATTR                                                                        0x3
#define HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_MSB_IN(x))
#define HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                            0xff
#define HWIO_TCL_R0_TCL2TQM_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                               0

#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_SETUP_ADDR(x)                                                 ((x) + 0xcf4)
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_SETUP_PHYS(x)                                                 ((x) + 0xcf4)
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_SETUP_OFFS                                                    (0xcf4)
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_SETUP_RMSK                                                    0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_SETUP_POR                                                     0x00000000
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_SETUP_POR_RMSK                                                0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_SETUP_ATTR                                                                 0x3
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                          0xffff0000
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                  16
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                      0x8000
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                          15
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                                0x7fff
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                     0

#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_STATUS_ADDR(x)                                                ((x) + 0xcf8)
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_STATUS_PHYS(x)                                                ((x) + 0xcf8)
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_STATUS_OFFS                                                   (0xcf8)
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_STATUS_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_STATUS_POR                                                    0x00000000
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_STATUS_POR_RMSK                                               0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_STATUS_ATTR                                                                0x1
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                     0xffff0000
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                             16
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                             0x8000
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                 15
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                          0x7fff
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                               0

#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                              ((x) + 0xcfc)
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                              ((x) + 0xcfc)
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_FULL_COUNTER_OFFS                                                 (0xcfc)
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_FULL_COUNTER_RMSK                                                      0x3ff
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_FULL_COUNTER_POR                                                  0x00000000
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                             0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_FULL_COUNTER_ATTR                                                              0x3
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                    0x3ff
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                        0

#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_LSB_ADDR(x)                                                      ((x) + 0xd18)
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_LSB_PHYS(x)                                                      ((x) + 0xd18)
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_LSB_OFFS                                                         (0xd18)
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_LSB_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_LSB_POR                                                          0x00000000
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_LSB_ATTR                                                                      0x3
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_LSB_ADDR_BMSK                                                    0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_LSB_ADDR_SHFT                                                             0

#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_MSB_ADDR(x)                                                      ((x) + 0xd1c)
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_MSB_PHYS(x)                                                      ((x) + 0xd1c)
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_MSB_OFFS                                                         (0xd1c)
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_MSB_RMSK                                                              0x1ff
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_MSB_POR                                                          0x00000000
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_MSB_ATTR                                                                      0x3
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                  0x100
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                      8
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_MSB_ADDR_BMSK                                                          0xff
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_BASE_MSB_ADDR_SHFT                                                             0

#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_DATA_ADDR(x)                                                          ((x) + 0xd20)
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_DATA_PHYS(x)                                                          ((x) + 0xd20)
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_DATA_OFFS                                                             (0xd20)
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_DATA_RMSK                                                             0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_DATA_POR                                                              0x00000000
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_DATA_POR_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_DATA_ATTR                                                                          0x3
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2TQM_RING_MSI1_DATA_ADDR(x))
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2TQM_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2TQM_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2TQM_RING_MSI1_DATA_ADDR(x),m,v,HWIO_TCL_R0_TCL2TQM_RING_MSI1_DATA_IN(x))
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_DATA_VALUE_BMSK                                                       0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_MSI1_DATA_VALUE_SHFT                                                                0

#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT2_SETUP_ADDR(x)                                                ((x) + 0xd24)
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT2_SETUP_PHYS(x)                                                ((x) + 0xd24)
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT2_SETUP_OFFS                                                   (0xd24)
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT2_SETUP_RMSK                                                   0xffc0ffff
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT2_SETUP_POR                                                    0x00000000
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT2_SETUP_POR_RMSK                                               0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT2_SETUP_ATTR                                                                0x3
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                        0xff000000
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                                24
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                         0x800000
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                               23
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                       0x400000
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                             22
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                        0xffff
#define HWIO_TCL_R0_TCL2TQM_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                             0

#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_LSB_ADDR(x)                                                      ((x) + 0xd28)
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_LSB_PHYS(x)                                                      ((x) + 0xd28)
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_LSB_OFFS                                                         (0xd28)
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_LSB_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_LSB_POR                                                          0x00000000
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_LSB_POR_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_LSB_ATTR                                                                      0x3
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_LSB_ADDR_BMSK                                                    0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_LSB_ADDR_SHFT                                                             0

#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_MSB_ADDR(x)                                                      ((x) + 0xd2c)
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_MSB_PHYS(x)                                                      ((x) + 0xd2c)
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_MSB_OFFS                                                         (0xd2c)
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_MSB_RMSK                                                              0x1ff
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_MSB_POR                                                          0x00000000
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_MSB_POR_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_MSB_ATTR                                                                      0x3
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                  0x100
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                      8
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_MSB_ADDR_BMSK                                                          0xff
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_BASE_MSB_ADDR_SHFT                                                             0

#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_DATA_ADDR(x)                                                          ((x) + 0xd30)
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_DATA_PHYS(x)                                                          ((x) + 0xd30)
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_DATA_OFFS                                                             (0xd30)
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_DATA_RMSK                                                             0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_DATA_POR                                                              0x00000000
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_DATA_POR_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_DATA_ATTR                                                                          0x3
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2TQM_RING_MSI2_DATA_ADDR(x))
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2TQM_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2TQM_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2TQM_RING_MSI2_DATA_ADDR(x),m,v,HWIO_TCL_R0_TCL2TQM_RING_MSI2_DATA_IN(x))
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_DATA_VALUE_BMSK                                                       0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_MSI2_DATA_VALUE_SHFT                                                                0

#define HWIO_TCL_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_ADDR(x)                                                    ((x) + 0xd40)
#define HWIO_TCL_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_PHYS(x)                                                    ((x) + 0xd40)
#define HWIO_TCL_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_OFFS                                                       (0xd40)
#define HWIO_TCL_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_RMSK                                                           0xffff
#define HWIO_TCL_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_POR                                                        0x00000000
#define HWIO_TCL_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_POR_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_ATTR                                                                    0x3
#define HWIO_TCL_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_TCL_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_TCL_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_TCL_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_TCL_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_TCL_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                        0xffff
#define HWIO_TCL_R0_TCL2TQM_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                             0

#define HWIO_TCL_R0_TCL2TQM_RING_MISC_1_ADDR(x)                                                             ((x) + 0xd44)
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_1_PHYS(x)                                                             ((x) + 0xd44)
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_1_OFFS                                                                (0xd44)
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_1_RMSK                                                                0xffff003f
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_1_POR                                                                 0x00000000
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_1_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_1_ATTR                                                                             0x3
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_1_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2TQM_RING_MISC_1_ADDR(x))
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2TQM_RING_MISC_1_ADDR(x), m)
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2TQM_RING_MISC_1_ADDR(x),v)
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2TQM_RING_MISC_1_ADDR(x),m,v,HWIO_TCL_R0_TCL2TQM_RING_MISC_1_IN(x))
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                       0xffff0000
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                               16
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                              0x3f
#define HWIO_TCL_R0_TCL2TQM_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                 0

#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_ADDR(x)                                                       ((x) + 0xd48)
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_PHYS(x)                                                       ((x) + 0xd48)
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_OFFS                                                          (0xd48)
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_POR                                                           0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_ATTR                                                                       0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                       0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                0

#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_ADDR(x)                                                       ((x) + 0xd4c)
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_PHYS(x)                                                       ((x) + 0xd4c)
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_OFFS                                                          (0xd4c)
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_RMSK                                                            0xffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_POR                                                           0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_ATTR                                                                       0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_RING_SIZE_BMSK                                                  0xffff00
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_RING_SIZE_SHFT                                                         8
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                             0xff
#define HWIO_TCL_R0_TCL_STATUS1_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                0

#define HWIO_TCL_R0_TCL_STATUS1_RING_ID_ADDR(x)                                                             ((x) + 0xd50)
#define HWIO_TCL_R0_TCL_STATUS1_RING_ID_PHYS(x)                                                             ((x) + 0xd50)
#define HWIO_TCL_R0_TCL_STATUS1_RING_ID_OFFS                                                                (0xd50)
#define HWIO_TCL_R0_TCL_STATUS1_RING_ID_RMSK                                                                    0xffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_ID_POR                                                                 0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_ID_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_ID_ATTR                                                                             0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_ID_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_ID_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_ID_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_ID_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_ID_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_ID_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_ID_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_ID_RING_ID_BMSK                                                            0xff00
#define HWIO_TCL_R0_TCL_STATUS1_RING_ID_RING_ID_SHFT                                                                 8
#define HWIO_TCL_R0_TCL_STATUS1_RING_ID_ENTRY_SIZE_BMSK                                                           0xff
#define HWIO_TCL_R0_TCL_STATUS1_RING_ID_ENTRY_SIZE_SHFT                                                              0

#define HWIO_TCL_R0_TCL_STATUS1_RING_STATUS_ADDR(x)                                                         ((x) + 0xd54)
#define HWIO_TCL_R0_TCL_STATUS1_RING_STATUS_PHYS(x)                                                         ((x) + 0xd54)
#define HWIO_TCL_R0_TCL_STATUS1_RING_STATUS_OFFS                                                            (0xd54)
#define HWIO_TCL_R0_TCL_STATUS1_RING_STATUS_RMSK                                                            0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_STATUS_POR                                                             0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_STATUS_POR_RMSK                                                        0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_STATUS_ATTR                                                                         0x1
#define HWIO_TCL_R0_TCL_STATUS1_RING_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_STATUS_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                            0xffff0000
#define HWIO_TCL_R0_TCL_STATUS1_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                    16
#define HWIO_TCL_R0_TCL_STATUS1_RING_STATUS_NUM_VALID_WORDS_BMSK                                                0xffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_STATUS_NUM_VALID_WORDS_SHFT                                                     0

#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_ADDR(x)                                                           ((x) + 0xd58)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_PHYS(x)                                                           ((x) + 0xd58)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_OFFS                                                              (0xd58)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_RMSK                                                               0x7ffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_POR                                                               0x00000080
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_ATTR                                                                           0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MISC_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_MISC_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MISC_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_MISC_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_MISC_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                       0x4000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                              26
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_LOOP_CNT_BMSK                                                      0x3c00000
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_LOOP_CNT_SHFT                                                             22
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_SPARE_CONTROL_BMSK                                                  0x3fc000
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_SPARE_CONTROL_SHFT                                                        14
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_SRNG_SM_STATE2_BMSK                                                   0x3000
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_SRNG_SM_STATE2_SHFT                                                       12
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_SRNG_SM_STATE1_BMSK                                                    0xf00
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_SRNG_SM_STATE1_SHFT                                                        8
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_SRNG_IS_IDLE_BMSK                                                       0x80
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_SRNG_IS_IDLE_SHFT                                                          7
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_SRNG_ENABLE_BMSK                                                        0x40
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_SRNG_ENABLE_SHFT                                                           6
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                  0x20
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                     5
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                   0x10
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                      4
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_MSI_SWAP_BIT_BMSK                                                        0x8
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_MSI_SWAP_BIT_SHFT                                                          3
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_SECURITY_BIT_BMSK                                                        0x4
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_SECURITY_BIT_SHFT                                                          2
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_LOOPCNT_DISABLE_BMSK                                                     0x2
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_LOOPCNT_DISABLE_SHFT                                                       1
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_RING_ID_DISABLE_BMSK                                                     0x1
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_RING_ID_DISABLE_SHFT                                                       0

#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_ADDR(x)                                                    ((x) + 0xd5c)
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_PHYS(x)                                                    ((x) + 0xd5c)
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_OFFS                                                       (0xd5c)
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_RMSK                                                       0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_POR                                                        0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_POR_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_ATTR                                                                    0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                  0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                           0

#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_ADDR(x)                                                    ((x) + 0xd60)
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_PHYS(x)                                                    ((x) + 0xd60)
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_OFFS                                                       (0xd60)
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_RMSK                                                             0xff
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_POR                                                        0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_POR_RMSK                                                   0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_ATTR                                                                    0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                        0xff
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                           0

#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_ADDR(x)                                             ((x) + 0xd6c)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_PHYS(x)                                             ((x) + 0xd6c)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_OFFS                                                (0xd6c)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_RMSK                                                0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_POR                                                 0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_ATTR                                                             0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                      0xffff0000
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                              16
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                  0x8000
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                      15
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                            0x7fff
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                 0

#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_ADDR(x)                                            ((x) + 0xd70)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_PHYS(x)                                            ((x) + 0xd70)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_OFFS                                               (0xd70)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_RMSK                                               0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_POR                                                0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_POR_RMSK                                           0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_ATTR                                                            0x1
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                 0xffff0000
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                         16
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                         0x8000
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                             15
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                      0x7fff
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                           0

#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                          ((x) + 0xd74)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                          ((x) + 0xd74)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_OFFS                                             (0xd74)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_RMSK                                                  0x3ff
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_POR                                              0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                         0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_ATTR                                                          0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                0x3ff
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                    0

#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_ADDR(x)                                                  ((x) + 0xd90)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_PHYS(x)                                                  ((x) + 0xd90)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_OFFS                                                     (0xd90)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_POR                                                      0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_ATTR                                                                  0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_ADDR(x)                                                  ((x) + 0xd94)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_PHYS(x)                                                  ((x) + 0xd94)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_OFFS                                                     (0xd94)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_POR                                                      0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_ATTR                                                                  0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                              0x100
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                  8
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_ADDR(x)                                                      ((x) + 0xd98)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_PHYS(x)                                                      ((x) + 0xd98)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_OFFS                                                         (0xd98)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_POR                                                          0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_ATTR                                                                      0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI1_DATA_VALUE_SHFT                                                            0

#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_ADDR(x)                                            ((x) + 0xd9c)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_PHYS(x)                                            ((x) + 0xd9c)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_OFFS                                               (0xd9c)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_RMSK                                               0xffc0ffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_POR                                                0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_POR_RMSK                                           0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_ATTR                                                            0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                    0xff000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                            24
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                     0x800000
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                           23
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                   0x400000
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                         22
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                    0xffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                         0

#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_ADDR(x)                                                  ((x) + 0xda0)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_PHYS(x)                                                  ((x) + 0xda0)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_OFFS                                                     (0xda0)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_POR                                                      0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_POR_RMSK                                                 0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_ATTR                                                                  0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_ADDR_BMSK                                                0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_LSB_ADDR_SHFT                                                         0

#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_ADDR(x)                                                  ((x) + 0xda4)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_PHYS(x)                                                  ((x) + 0xda4)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_OFFS                                                     (0xda4)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_RMSK                                                          0x1ff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_POR                                                      0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_POR_RMSK                                                 0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_ATTR                                                                  0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                              0x100
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                  8
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_ADDR_BMSK                                                      0xff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_BASE_MSB_ADDR_SHFT                                                         0

#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_ADDR(x)                                                      ((x) + 0xda8)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_PHYS(x)                                                      ((x) + 0xda8)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_OFFS                                                         (0xda8)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_POR                                                          0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_POR_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_ATTR                                                                      0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_VALUE_BMSK                                                   0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MSI2_DATA_VALUE_SHFT                                                            0

#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_ADDR(x)                                                ((x) + 0xdb8)
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_PHYS(x)                                                ((x) + 0xdb8)
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_OFFS                                                   (0xdb8)
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_RMSK                                                       0xffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_POR                                                    0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_POR_RMSK                                               0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_ATTR                                                                0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                    0xffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                         0

#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_ADDR(x)                                                         ((x) + 0xdbc)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_PHYS(x)                                                         ((x) + 0xdbc)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_OFFS                                                            (0xdbc)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_RMSK                                                            0xffff003f
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_POR                                                             0x00000000
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_POR_RMSK                                                        0xffffffff
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_ATTR                                                                         0x3
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_ADDR(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_ADDR(x), m)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_ADDR(x),v)
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_ADDR(x),m,v,HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_IN(x))
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                   0xffff0000
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                           16
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                          0x3f
#define HWIO_TCL_R0_TCL_STATUS1_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                             0

#define HWIO_TCL_R0_TCL2FW_RING_BASE_LSB_ADDR(x)                                                            ((x) + 0xe38)
#define HWIO_TCL_R0_TCL2FW_RING_BASE_LSB_PHYS(x)                                                            ((x) + 0xe38)
#define HWIO_TCL_R0_TCL2FW_RING_BASE_LSB_OFFS                                                               (0xe38)
#define HWIO_TCL_R0_TCL2FW_RING_BASE_LSB_RMSK                                                               0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_BASE_LSB_POR                                                                0x00000000
#define HWIO_TCL_R0_TCL2FW_RING_BASE_LSB_POR_RMSK                                                           0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_BASE_LSB_ATTR                                                                            0x3
#define HWIO_TCL_R0_TCL2FW_RING_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2FW_RING_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_TCL2FW_RING_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2FW_RING_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL2FW_RING_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2FW_RING_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL2FW_RING_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2FW_RING_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_TCL2FW_RING_BASE_LSB_IN(x))
#define HWIO_TCL_R0_TCL2FW_RING_BASE_LSB_RING_BASE_ADDR_LSB_BMSK                                            0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_BASE_LSB_RING_BASE_ADDR_LSB_SHFT                                                     0

#define HWIO_TCL_R0_TCL2FW_RING_BASE_MSB_ADDR(x)                                                            ((x) + 0xe3c)
#define HWIO_TCL_R0_TCL2FW_RING_BASE_MSB_PHYS(x)                                                            ((x) + 0xe3c)
#define HWIO_TCL_R0_TCL2FW_RING_BASE_MSB_OFFS                                                               (0xe3c)
#define HWIO_TCL_R0_TCL2FW_RING_BASE_MSB_RMSK                                                                 0xffffff
#define HWIO_TCL_R0_TCL2FW_RING_BASE_MSB_POR                                                                0x00000000
#define HWIO_TCL_R0_TCL2FW_RING_BASE_MSB_POR_RMSK                                                           0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_BASE_MSB_ATTR                                                                            0x3
#define HWIO_TCL_R0_TCL2FW_RING_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2FW_RING_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_TCL2FW_RING_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2FW_RING_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL2FW_RING_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2FW_RING_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL2FW_RING_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2FW_RING_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_TCL2FW_RING_BASE_MSB_IN(x))
#define HWIO_TCL_R0_TCL2FW_RING_BASE_MSB_RING_SIZE_BMSK                                                       0xffff00
#define HWIO_TCL_R0_TCL2FW_RING_BASE_MSB_RING_SIZE_SHFT                                                              8
#define HWIO_TCL_R0_TCL2FW_RING_BASE_MSB_RING_BASE_ADDR_MSB_BMSK                                                  0xff
#define HWIO_TCL_R0_TCL2FW_RING_BASE_MSB_RING_BASE_ADDR_MSB_SHFT                                                     0

#define HWIO_TCL_R0_TCL2FW_RING_ID_ADDR(x)                                                                  ((x) + 0xe40)
#define HWIO_TCL_R0_TCL2FW_RING_ID_PHYS(x)                                                                  ((x) + 0xe40)
#define HWIO_TCL_R0_TCL2FW_RING_ID_OFFS                                                                     (0xe40)
#define HWIO_TCL_R0_TCL2FW_RING_ID_RMSK                                                                         0xffff
#define HWIO_TCL_R0_TCL2FW_RING_ID_POR                                                                      0x00000000
#define HWIO_TCL_R0_TCL2FW_RING_ID_POR_RMSK                                                                 0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_ID_ATTR                                                                                  0x3
#define HWIO_TCL_R0_TCL2FW_RING_ID_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2FW_RING_ID_ADDR(x))
#define HWIO_TCL_R0_TCL2FW_RING_ID_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2FW_RING_ID_ADDR(x), m)
#define HWIO_TCL_R0_TCL2FW_RING_ID_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2FW_RING_ID_ADDR(x),v)
#define HWIO_TCL_R0_TCL2FW_RING_ID_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2FW_RING_ID_ADDR(x),m,v,HWIO_TCL_R0_TCL2FW_RING_ID_IN(x))
#define HWIO_TCL_R0_TCL2FW_RING_ID_RING_ID_BMSK                                                                 0xff00
#define HWIO_TCL_R0_TCL2FW_RING_ID_RING_ID_SHFT                                                                      8
#define HWIO_TCL_R0_TCL2FW_RING_ID_ENTRY_SIZE_BMSK                                                                0xff
#define HWIO_TCL_R0_TCL2FW_RING_ID_ENTRY_SIZE_SHFT                                                                   0

#define HWIO_TCL_R0_TCL2FW_RING_STATUS_ADDR(x)                                                              ((x) + 0xe44)
#define HWIO_TCL_R0_TCL2FW_RING_STATUS_PHYS(x)                                                              ((x) + 0xe44)
#define HWIO_TCL_R0_TCL2FW_RING_STATUS_OFFS                                                                 (0xe44)
#define HWIO_TCL_R0_TCL2FW_RING_STATUS_RMSK                                                                 0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_STATUS_POR                                                                  0x00000000
#define HWIO_TCL_R0_TCL2FW_RING_STATUS_POR_RMSK                                                             0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_STATUS_ATTR                                                                              0x1
#define HWIO_TCL_R0_TCL2FW_RING_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2FW_RING_STATUS_ADDR(x))
#define HWIO_TCL_R0_TCL2FW_RING_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2FW_RING_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_TCL2FW_RING_STATUS_NUM_AVAIL_WORDS_BMSK                                                 0xffff0000
#define HWIO_TCL_R0_TCL2FW_RING_STATUS_NUM_AVAIL_WORDS_SHFT                                                         16
#define HWIO_TCL_R0_TCL2FW_RING_STATUS_NUM_VALID_WORDS_BMSK                                                     0xffff
#define HWIO_TCL_R0_TCL2FW_RING_STATUS_NUM_VALID_WORDS_SHFT                                                          0

#define HWIO_TCL_R0_TCL2FW_RING_MISC_ADDR(x)                                                                ((x) + 0xe48)
#define HWIO_TCL_R0_TCL2FW_RING_MISC_PHYS(x)                                                                ((x) + 0xe48)
#define HWIO_TCL_R0_TCL2FW_RING_MISC_OFFS                                                                   (0xe48)
#define HWIO_TCL_R0_TCL2FW_RING_MISC_RMSK                                                                    0x7ffffff
#define HWIO_TCL_R0_TCL2FW_RING_MISC_POR                                                                    0x00000080
#define HWIO_TCL_R0_TCL2FW_RING_MISC_POR_RMSK                                                               0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_MISC_ATTR                                                                                0x3
#define HWIO_TCL_R0_TCL2FW_RING_MISC_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2FW_RING_MISC_ADDR(x))
#define HWIO_TCL_R0_TCL2FW_RING_MISC_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2FW_RING_MISC_ADDR(x), m)
#define HWIO_TCL_R0_TCL2FW_RING_MISC_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2FW_RING_MISC_ADDR(x),v)
#define HWIO_TCL_R0_TCL2FW_RING_MISC_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2FW_RING_MISC_ADDR(x),m,v,HWIO_TCL_R0_TCL2FW_RING_MISC_IN(x))
#define HWIO_TCL_R0_TCL2FW_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_BMSK                                            0x4000000
#define HWIO_TCL_R0_TCL2FW_RING_MISC_ADD_8_ENTRIES_FOR_DEBUG_SHFT                                                   26
#define HWIO_TCL_R0_TCL2FW_RING_MISC_LOOP_CNT_BMSK                                                           0x3c00000
#define HWIO_TCL_R0_TCL2FW_RING_MISC_LOOP_CNT_SHFT                                                                  22
#define HWIO_TCL_R0_TCL2FW_RING_MISC_SPARE_CONTROL_BMSK                                                       0x3fc000
#define HWIO_TCL_R0_TCL2FW_RING_MISC_SPARE_CONTROL_SHFT                                                             14
#define HWIO_TCL_R0_TCL2FW_RING_MISC_SRNG_SM_STATE2_BMSK                                                        0x3000
#define HWIO_TCL_R0_TCL2FW_RING_MISC_SRNG_SM_STATE2_SHFT                                                            12
#define HWIO_TCL_R0_TCL2FW_RING_MISC_SRNG_SM_STATE1_BMSK                                                         0xf00
#define HWIO_TCL_R0_TCL2FW_RING_MISC_SRNG_SM_STATE1_SHFT                                                             8
#define HWIO_TCL_R0_TCL2FW_RING_MISC_SRNG_IS_IDLE_BMSK                                                            0x80
#define HWIO_TCL_R0_TCL2FW_RING_MISC_SRNG_IS_IDLE_SHFT                                                               7
#define HWIO_TCL_R0_TCL2FW_RING_MISC_SRNG_ENABLE_BMSK                                                             0x40
#define HWIO_TCL_R0_TCL2FW_RING_MISC_SRNG_ENABLE_SHFT                                                                6
#define HWIO_TCL_R0_TCL2FW_RING_MISC_DATA_TLV_SWAP_BIT_BMSK                                                       0x20
#define HWIO_TCL_R0_TCL2FW_RING_MISC_DATA_TLV_SWAP_BIT_SHFT                                                          5
#define HWIO_TCL_R0_TCL2FW_RING_MISC_HOST_FW_SWAP_BIT_BMSK                                                        0x10
#define HWIO_TCL_R0_TCL2FW_RING_MISC_HOST_FW_SWAP_BIT_SHFT                                                           4
#define HWIO_TCL_R0_TCL2FW_RING_MISC_MSI_SWAP_BIT_BMSK                                                             0x8
#define HWIO_TCL_R0_TCL2FW_RING_MISC_MSI_SWAP_BIT_SHFT                                                               3
#define HWIO_TCL_R0_TCL2FW_RING_MISC_SECURITY_BIT_BMSK                                                             0x4
#define HWIO_TCL_R0_TCL2FW_RING_MISC_SECURITY_BIT_SHFT                                                               2
#define HWIO_TCL_R0_TCL2FW_RING_MISC_LOOPCNT_DISABLE_BMSK                                                          0x2
#define HWIO_TCL_R0_TCL2FW_RING_MISC_LOOPCNT_DISABLE_SHFT                                                            1
#define HWIO_TCL_R0_TCL2FW_RING_MISC_RING_ID_DISABLE_BMSK                                                          0x1
#define HWIO_TCL_R0_TCL2FW_RING_MISC_RING_ID_DISABLE_SHFT                                                            0

#define HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_LSB_ADDR(x)                                                         ((x) + 0xe4c)
#define HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_LSB_PHYS(x)                                                         ((x) + 0xe4c)
#define HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_LSB_OFFS                                                            (0xe4c)
#define HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_LSB_RMSK                                                            0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_LSB_POR                                                             0x00000000
#define HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_LSB_POR_RMSK                                                        0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_LSB_ATTR                                                                         0x3
#define HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_LSB_ADDR(x))
#define HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_LSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_LSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_LSB_ADDR(x),m,v,HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_LSB_IN(x))
#define HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_BMSK                                       0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_LSB_HEAD_PTR_MEMADDR_LSB_SHFT                                                0

#define HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_MSB_ADDR(x)                                                         ((x) + 0xe50)
#define HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_MSB_PHYS(x)                                                         ((x) + 0xe50)
#define HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_MSB_OFFS                                                            (0xe50)
#define HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_MSB_RMSK                                                                  0xff
#define HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_MSB_POR                                                             0x00000000
#define HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_MSB_POR_RMSK                                                        0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_MSB_ATTR                                                                         0x3
#define HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_MSB_ADDR(x))
#define HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_MSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_MSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_MSB_ADDR(x),m,v,HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_MSB_IN(x))
#define HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_BMSK                                             0xff
#define HWIO_TCL_R0_TCL2FW_RING_HP_ADDR_MSB_HEAD_PTR_MEMADDR_MSB_SHFT                                                0

#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_SETUP_ADDR(x)                                                  ((x) + 0xe5c)
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_SETUP_PHYS(x)                                                  ((x) + 0xe5c)
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_SETUP_OFFS                                                     (0xe5c)
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_SETUP_RMSK                                                     0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_SETUP_POR                                                      0x00000000
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_SETUP_POR_RMSK                                                 0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_SETUP_ATTR                                                                  0x3
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_SETUP_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_SETUP_ADDR(x))
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_SETUP_ADDR(x), m)
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_SETUP_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_SETUP_ADDR(x),v)
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_SETUP_ADDR(x),m,v,HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_SETUP_IN(x))
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_BMSK                           0xffff0000
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_SETUP_INTERRUPT_TIMER_THRESHOLD_SHFT                                   16
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_BMSK                                       0x8000
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_SETUP_SW_INTERRUPT_MODE_SHFT                                           15
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_BMSK                                 0x7fff
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_SETUP_BATCH_COUNTER_THRESHOLD_SHFT                                      0

#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_STATUS_ADDR(x)                                                 ((x) + 0xe60)
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_STATUS_PHYS(x)                                                 ((x) + 0xe60)
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_STATUS_OFFS                                                    (0xe60)
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_STATUS_RMSK                                                    0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_STATUS_POR                                                     0x00000000
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_STATUS_POR_RMSK                                                0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_STATUS_ATTR                                                                 0x1
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_STATUS_ADDR(x))
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_STATUS_ADDR(x), m)
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_BMSK                      0xffff0000
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_STATUS_CURRENT_INTERRUPT_TIMER_VALUE_SHFT                              16
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_BMSK                              0x8000
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_STATUS_CURRENT_SW_INT_WIRE_VALUE_SHFT                                  15
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_BMSK                           0x7fff
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT_STATUS_INTERNAL_BATCH_COUNTER_VALUE_SHFT                                0

#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_FULL_COUNTER_ADDR(x)                                               ((x) + 0xe64)
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_FULL_COUNTER_PHYS(x)                                               ((x) + 0xe64)
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_FULL_COUNTER_OFFS                                                  (0xe64)
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_FULL_COUNTER_RMSK                                                       0x3ff
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_FULL_COUNTER_POR                                                   0x00000000
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_FULL_COUNTER_POR_RMSK                                              0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_FULL_COUNTER_ATTR                                                               0x3
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_FULL_COUNTER_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2FW_RING_PRODUCER_FULL_COUNTER_ADDR(x))
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_FULL_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2FW_RING_PRODUCER_FULL_COUNTER_ADDR(x), m)
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_FULL_COUNTER_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2FW_RING_PRODUCER_FULL_COUNTER_ADDR(x),v)
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_FULL_COUNTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2FW_RING_PRODUCER_FULL_COUNTER_ADDR(x),m,v,HWIO_TCL_R0_TCL2FW_RING_PRODUCER_FULL_COUNTER_IN(x))
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_BMSK                                     0x3ff
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_FULL_COUNTER_RING_FULL_COUNTER_SHFT                                         0

#define HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_LSB_ADDR(x)                                                       ((x) + 0xe80)
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_LSB_PHYS(x)                                                       ((x) + 0xe80)
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_LSB_OFFS                                                          (0xe80)
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_LSB_POR                                                           0x00000000
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_LSB_ATTR                                                                       0x3
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_LSB_IN(x))
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_MSB_ADDR(x)                                                       ((x) + 0xe84)
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_MSB_PHYS(x)                                                       ((x) + 0xe84)
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_MSB_OFFS                                                          (0xe84)
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_MSB_POR                                                           0x00000000
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_MSB_ATTR                                                                       0x3
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_MSB_IN(x))
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_MSB_MSI1_ENABLE_BMSK                                                   0x100
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_MSB_MSI1_ENABLE_SHFT                                                       8
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_TCL_R0_TCL2FW_RING_MSI1_DATA_ADDR(x)                                                           ((x) + 0xe88)
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_DATA_PHYS(x)                                                           ((x) + 0xe88)
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_DATA_OFFS                                                              (0xe88)
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_DATA_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_DATA_POR                                                               0x00000000
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_DATA_ATTR                                                                           0x3
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_DATA_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2FW_RING_MSI1_DATA_ADDR(x))
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2FW_RING_MSI1_DATA_ADDR(x), m)
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_DATA_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2FW_RING_MSI1_DATA_ADDR(x),v)
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2FW_RING_MSI1_DATA_ADDR(x),m,v,HWIO_TCL_R0_TCL2FW_RING_MSI1_DATA_IN(x))
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_MSI1_DATA_VALUE_SHFT                                                                 0

#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT2_SETUP_ADDR(x)                                                 ((x) + 0xe8c)
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT2_SETUP_PHYS(x)                                                 ((x) + 0xe8c)
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT2_SETUP_OFFS                                                    (0xe8c)
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT2_SETUP_RMSK                                                    0xffc0ffff
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT2_SETUP_POR                                                     0x00000000
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT2_SETUP_POR_RMSK                                                0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT2_SETUP_ATTR                                                                 0x3
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT2_SETUP_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT2_SETUP_ADDR(x))
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT2_SETUP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT2_SETUP_ADDR(x), m)
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT2_SETUP_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT2_SETUP_ADDR(x),v)
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT2_SETUP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT2_SETUP_ADDR(x),m,v,HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT2_SETUP_IN(x))
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_BMSK                         0xff000000
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT2_SETUP_INTERRUPT2_TIMER_THRESHOLD_SHFT                                 24
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_BMSK                          0x800000
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT2_SETUP_CURRENT_SW_INTR2_WIRE_VALUE_SHFT                                23
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_BMSK                                        0x400000
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT2_SETUP_SW_INTR2_MODE_SHFT                                              22
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_BMSK                                         0xffff
#define HWIO_TCL_R0_TCL2FW_RING_PRODUCER_INT2_SETUP_HIGH_THRESHOLD_SHFT                                              0

#define HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_LSB_ADDR(x)                                                       ((x) + 0xe90)
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_LSB_PHYS(x)                                                       ((x) + 0xe90)
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_LSB_OFFS                                                          (0xe90)
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_LSB_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_LSB_POR                                                           0x00000000
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_LSB_POR_RMSK                                                      0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_LSB_ATTR                                                                       0x3
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_LSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_LSB_ADDR(x))
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_LSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_LSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_LSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_LSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_LSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_LSB_ADDR(x),m,v,HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_LSB_IN(x))
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_LSB_ADDR_BMSK                                                     0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_LSB_ADDR_SHFT                                                              0

#define HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_MSB_ADDR(x)                                                       ((x) + 0xe94)
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_MSB_PHYS(x)                                                       ((x) + 0xe94)
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_MSB_OFFS                                                          (0xe94)
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_MSB_RMSK                                                               0x1ff
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_MSB_POR                                                           0x00000000
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_MSB_POR_RMSK                                                      0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_MSB_ATTR                                                                       0x3
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_MSB_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_MSB_ADDR(x))
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_MSB_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_MSB_ADDR(x), m)
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_MSB_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_MSB_ADDR(x),v)
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_MSB_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_MSB_ADDR(x),m,v,HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_MSB_IN(x))
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_MSB_MSI2_ENABLE_BMSK                                                   0x100
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_MSB_MSI2_ENABLE_SHFT                                                       8
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_MSB_ADDR_BMSK                                                           0xff
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_BASE_MSB_ADDR_SHFT                                                              0

#define HWIO_TCL_R0_TCL2FW_RING_MSI2_DATA_ADDR(x)                                                           ((x) + 0xe98)
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_DATA_PHYS(x)                                                           ((x) + 0xe98)
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_DATA_OFFS                                                              (0xe98)
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_DATA_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_DATA_POR                                                               0x00000000
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_DATA_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_DATA_ATTR                                                                           0x3
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_DATA_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2FW_RING_MSI2_DATA_ADDR(x))
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_DATA_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2FW_RING_MSI2_DATA_ADDR(x), m)
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_DATA_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2FW_RING_MSI2_DATA_ADDR(x),v)
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_DATA_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2FW_RING_MSI2_DATA_ADDR(x),m,v,HWIO_TCL_R0_TCL2FW_RING_MSI2_DATA_IN(x))
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_DATA_VALUE_BMSK                                                        0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_MSI2_DATA_VALUE_SHFT                                                                 0

#define HWIO_TCL_R0_TCL2FW_RING_HP_TP_SW_OFFSET_ADDR(x)                                                     ((x) + 0xea8)
#define HWIO_TCL_R0_TCL2FW_RING_HP_TP_SW_OFFSET_PHYS(x)                                                     ((x) + 0xea8)
#define HWIO_TCL_R0_TCL2FW_RING_HP_TP_SW_OFFSET_OFFS                                                        (0xea8)
#define HWIO_TCL_R0_TCL2FW_RING_HP_TP_SW_OFFSET_RMSK                                                            0xffff
#define HWIO_TCL_R0_TCL2FW_RING_HP_TP_SW_OFFSET_POR                                                         0x00000000
#define HWIO_TCL_R0_TCL2FW_RING_HP_TP_SW_OFFSET_POR_RMSK                                                    0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_HP_TP_SW_OFFSET_ATTR                                                                     0x3
#define HWIO_TCL_R0_TCL2FW_RING_HP_TP_SW_OFFSET_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2FW_RING_HP_TP_SW_OFFSET_ADDR(x))
#define HWIO_TCL_R0_TCL2FW_RING_HP_TP_SW_OFFSET_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2FW_RING_HP_TP_SW_OFFSET_ADDR(x), m)
#define HWIO_TCL_R0_TCL2FW_RING_HP_TP_SW_OFFSET_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2FW_RING_HP_TP_SW_OFFSET_ADDR(x),v)
#define HWIO_TCL_R0_TCL2FW_RING_HP_TP_SW_OFFSET_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2FW_RING_HP_TP_SW_OFFSET_ADDR(x),m,v,HWIO_TCL_R0_TCL2FW_RING_HP_TP_SW_OFFSET_IN(x))
#define HWIO_TCL_R0_TCL2FW_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_BMSK                                         0xffff
#define HWIO_TCL_R0_TCL2FW_RING_HP_TP_SW_OFFSET_HP_TP_OFFSET_VALUE_SHFT                                              0

#define HWIO_TCL_R0_TCL2FW_RING_MISC_1_ADDR(x)                                                              ((x) + 0xeac)
#define HWIO_TCL_R0_TCL2FW_RING_MISC_1_PHYS(x)                                                              ((x) + 0xeac)
#define HWIO_TCL_R0_TCL2FW_RING_MISC_1_OFFS                                                                 (0xeac)
#define HWIO_TCL_R0_TCL2FW_RING_MISC_1_RMSK                                                                 0xffff003f
#define HWIO_TCL_R0_TCL2FW_RING_MISC_1_POR                                                                  0x00000000
#define HWIO_TCL_R0_TCL2FW_RING_MISC_1_POR_RMSK                                                             0xffffffff
#define HWIO_TCL_R0_TCL2FW_RING_MISC_1_ATTR                                                                              0x3
#define HWIO_TCL_R0_TCL2FW_RING_MISC_1_IN(x)            \
                in_dword(HWIO_TCL_R0_TCL2FW_RING_MISC_1_ADDR(x))
#define HWIO_TCL_R0_TCL2FW_RING_MISC_1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_TCL2FW_RING_MISC_1_ADDR(x), m)
#define HWIO_TCL_R0_TCL2FW_RING_MISC_1_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_TCL2FW_RING_MISC_1_ADDR(x),v)
#define HWIO_TCL_R0_TCL2FW_RING_MISC_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_TCL2FW_RING_MISC_1_ADDR(x),m,v,HWIO_TCL_R0_TCL2FW_RING_MISC_1_IN(x))
#define HWIO_TCL_R0_TCL2FW_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_BMSK                                        0xffff0000
#define HWIO_TCL_R0_TCL2FW_RING_MISC_1_TIME_THRESHOLD_TO_UPDATE_SHFT                                                16
#define HWIO_TCL_R0_TCL2FW_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_BMSK                                               0x3f
#define HWIO_TCL_R0_TCL2FW_RING_MISC_1_NUM_THRESHOLD_TO_UPDATE_SHFT                                                  0

#define HWIO_TCL_R0_ASE_GST_BASE_ADDR_LOW_ADDR(x)                                                           ((x) + 0xeb0)
#define HWIO_TCL_R0_ASE_GST_BASE_ADDR_LOW_PHYS(x)                                                           ((x) + 0xeb0)
#define HWIO_TCL_R0_ASE_GST_BASE_ADDR_LOW_OFFS                                                              (0xeb0)
#define HWIO_TCL_R0_ASE_GST_BASE_ADDR_LOW_RMSK                                                              0xffffffff
#define HWIO_TCL_R0_ASE_GST_BASE_ADDR_LOW_POR                                                               0x00000000
#define HWIO_TCL_R0_ASE_GST_BASE_ADDR_LOW_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R0_ASE_GST_BASE_ADDR_LOW_ATTR                                                                           0x3
#define HWIO_TCL_R0_ASE_GST_BASE_ADDR_LOW_IN(x)            \
                in_dword(HWIO_TCL_R0_ASE_GST_BASE_ADDR_LOW_ADDR(x))
#define HWIO_TCL_R0_ASE_GST_BASE_ADDR_LOW_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_ASE_GST_BASE_ADDR_LOW_ADDR(x), m)
#define HWIO_TCL_R0_ASE_GST_BASE_ADDR_LOW_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_ASE_GST_BASE_ADDR_LOW_ADDR(x),v)
#define HWIO_TCL_R0_ASE_GST_BASE_ADDR_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_ASE_GST_BASE_ADDR_LOW_ADDR(x),m,v,HWIO_TCL_R0_ASE_GST_BASE_ADDR_LOW_IN(x))
#define HWIO_TCL_R0_ASE_GST_BASE_ADDR_LOW_VAL_BMSK                                                          0xffffffff
#define HWIO_TCL_R0_ASE_GST_BASE_ADDR_LOW_VAL_SHFT                                                                   0

#define HWIO_TCL_R0_ASE_GST_BASE_ADDR_HIGH_ADDR(x)                                                          ((x) + 0xeb4)
#define HWIO_TCL_R0_ASE_GST_BASE_ADDR_HIGH_PHYS(x)                                                          ((x) + 0xeb4)
#define HWIO_TCL_R0_ASE_GST_BASE_ADDR_HIGH_OFFS                                                             (0xeb4)
#define HWIO_TCL_R0_ASE_GST_BASE_ADDR_HIGH_RMSK                                                                   0xff
#define HWIO_TCL_R0_ASE_GST_BASE_ADDR_HIGH_POR                                                              0x00000000
#define HWIO_TCL_R0_ASE_GST_BASE_ADDR_HIGH_POR_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_ASE_GST_BASE_ADDR_HIGH_ATTR                                                                          0x3
#define HWIO_TCL_R0_ASE_GST_BASE_ADDR_HIGH_IN(x)            \
                in_dword(HWIO_TCL_R0_ASE_GST_BASE_ADDR_HIGH_ADDR(x))
#define HWIO_TCL_R0_ASE_GST_BASE_ADDR_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_ASE_GST_BASE_ADDR_HIGH_ADDR(x), m)
#define HWIO_TCL_R0_ASE_GST_BASE_ADDR_HIGH_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_ASE_GST_BASE_ADDR_HIGH_ADDR(x),v)
#define HWIO_TCL_R0_ASE_GST_BASE_ADDR_HIGH_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_ASE_GST_BASE_ADDR_HIGH_ADDR(x),m,v,HWIO_TCL_R0_ASE_GST_BASE_ADDR_HIGH_IN(x))
#define HWIO_TCL_R0_ASE_GST_BASE_ADDR_HIGH_VAL_BMSK                                                               0xff
#define HWIO_TCL_R0_ASE_GST_BASE_ADDR_HIGH_VAL_SHFT                                                                  0

#define HWIO_TCL_R0_ASE_GST_SIZE_ADDR(x)                                                                    ((x) + 0xeb8)
#define HWIO_TCL_R0_ASE_GST_SIZE_PHYS(x)                                                                    ((x) + 0xeb8)
#define HWIO_TCL_R0_ASE_GST_SIZE_OFFS                                                                       (0xeb8)
#define HWIO_TCL_R0_ASE_GST_SIZE_RMSK                                                                          0xfffff
#define HWIO_TCL_R0_ASE_GST_SIZE_POR                                                                        0x00000000
#define HWIO_TCL_R0_ASE_GST_SIZE_POR_RMSK                                                                   0xffffffff
#define HWIO_TCL_R0_ASE_GST_SIZE_ATTR                                                                                    0x3
#define HWIO_TCL_R0_ASE_GST_SIZE_IN(x)            \
                in_dword(HWIO_TCL_R0_ASE_GST_SIZE_ADDR(x))
#define HWIO_TCL_R0_ASE_GST_SIZE_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_ASE_GST_SIZE_ADDR(x), m)
#define HWIO_TCL_R0_ASE_GST_SIZE_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_ASE_GST_SIZE_ADDR(x),v)
#define HWIO_TCL_R0_ASE_GST_SIZE_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_ASE_GST_SIZE_ADDR(x),m,v,HWIO_TCL_R0_ASE_GST_SIZE_IN(x))
#define HWIO_TCL_R0_ASE_GST_SIZE_VAL_BMSK                                                                      0xfffff
#define HWIO_TCL_R0_ASE_GST_SIZE_VAL_SHFT                                                                            0

#define HWIO_TCL_R0_ASE_SEARCH_CTRL_ADDR(x)                                                                 ((x) + 0xebc)
#define HWIO_TCL_R0_ASE_SEARCH_CTRL_PHYS(x)                                                                 ((x) + 0xebc)
#define HWIO_TCL_R0_ASE_SEARCH_CTRL_OFFS                                                                    (0xebc)
#define HWIO_TCL_R0_ASE_SEARCH_CTRL_RMSK                                                                    0xffff3fff
#define HWIO_TCL_R0_ASE_SEARCH_CTRL_POR                                                                     0x00003806
#define HWIO_TCL_R0_ASE_SEARCH_CTRL_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R0_ASE_SEARCH_CTRL_ATTR                                                                                 0x3
#define HWIO_TCL_R0_ASE_SEARCH_CTRL_IN(x)            \
                in_dword(HWIO_TCL_R0_ASE_SEARCH_CTRL_ADDR(x))
#define HWIO_TCL_R0_ASE_SEARCH_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_ASE_SEARCH_CTRL_ADDR(x), m)
#define HWIO_TCL_R0_ASE_SEARCH_CTRL_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_ASE_SEARCH_CTRL_ADDR(x),v)
#define HWIO_TCL_R0_ASE_SEARCH_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_ASE_SEARCH_CTRL_ADDR(x),m,v,HWIO_TCL_R0_ASE_SEARCH_CTRL_IN(x))
#define HWIO_TCL_R0_ASE_SEARCH_CTRL_TIMEOUT_THRESH_BMSK                                                     0xffff0000
#define HWIO_TCL_R0_ASE_SEARCH_CTRL_TIMEOUT_THRESH_SHFT                                                             16
#define HWIO_TCL_R0_ASE_SEARCH_CTRL_CACHE_CMD_READ_BYPASS_EN_BMSK                                               0x2000
#define HWIO_TCL_R0_ASE_SEARCH_CTRL_CACHE_CMD_READ_BYPASS_EN_SHFT                                                   13
#define HWIO_TCL_R0_ASE_SEARCH_CTRL_CACHE_WRITE_BACK_FIX_EN_BMSK                                                0x1000
#define HWIO_TCL_R0_ASE_SEARCH_CTRL_CACHE_WRITE_BACK_FIX_EN_SHFT                                                    12
#define HWIO_TCL_R0_ASE_SEARCH_CTRL_CACHE_ONLY_ENTRY_CMD_FIX_EN_BMSK                                             0x800
#define HWIO_TCL_R0_ASE_SEARCH_CTRL_CACHE_ONLY_ENTRY_CMD_FIX_EN_SHFT                                                11
#define HWIO_TCL_R0_ASE_SEARCH_CTRL_CACHE_FAILURES_ENABLE_BMSK                                                   0x400
#define HWIO_TCL_R0_ASE_SEARCH_CTRL_CACHE_FAILURES_ENABLE_SHFT                                                      10
#define HWIO_TCL_R0_ASE_SEARCH_CTRL_CACHE_DISABLE_BMSK                                                           0x200
#define HWIO_TCL_R0_ASE_SEARCH_CTRL_CACHE_DISABLE_SHFT                                                               9
#define HWIO_TCL_R0_ASE_SEARCH_CTRL_SEARCH_SWAP_BMSK                                                             0x100
#define HWIO_TCL_R0_ASE_SEARCH_CTRL_SEARCH_SWAP_SHFT                                                                 8
#define HWIO_TCL_R0_ASE_SEARCH_CTRL_MAX_SEARCH_BMSK                                                               0xff
#define HWIO_TCL_R0_ASE_SEARCH_CTRL_MAX_SEARCH_SHFT                                                                  0

#define HWIO_TCL_R0_ASE_PCIE_VC_CTRL_ADDR(x)                                                                ((x) + 0xec0)
#define HWIO_TCL_R0_ASE_PCIE_VC_CTRL_PHYS(x)                                                                ((x) + 0xec0)
#define HWIO_TCL_R0_ASE_PCIE_VC_CTRL_OFFS                                                                   (0xec0)
#define HWIO_TCL_R0_ASE_PCIE_VC_CTRL_RMSK                                                                          0x3
#define HWIO_TCL_R0_ASE_PCIE_VC_CTRL_POR                                                                    0x00000000
#define HWIO_TCL_R0_ASE_PCIE_VC_CTRL_POR_RMSK                                                               0xffffffff
#define HWIO_TCL_R0_ASE_PCIE_VC_CTRL_ATTR                                                                                0x3
#define HWIO_TCL_R0_ASE_PCIE_VC_CTRL_IN(x)            \
                in_dword(HWIO_TCL_R0_ASE_PCIE_VC_CTRL_ADDR(x))
#define HWIO_TCL_R0_ASE_PCIE_VC_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_ASE_PCIE_VC_CTRL_ADDR(x), m)
#define HWIO_TCL_R0_ASE_PCIE_VC_CTRL_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_ASE_PCIE_VC_CTRL_ADDR(x),v)
#define HWIO_TCL_R0_ASE_PCIE_VC_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_ASE_PCIE_VC_CTRL_ADDR(x),m,v,HWIO_TCL_R0_ASE_PCIE_VC_CTRL_IN(x))
#define HWIO_TCL_R0_ASE_PCIE_VC_CTRL_GXI_RD_VCID_1_BMSK                                                            0x2
#define HWIO_TCL_R0_ASE_PCIE_VC_CTRL_GXI_RD_VCID_1_SHFT                                                              1
#define HWIO_TCL_R0_ASE_PCIE_VC_CTRL_GXI_RD_VCID_0_BMSK                                                            0x1
#define HWIO_TCL_R0_ASE_PCIE_VC_CTRL_GXI_RD_VCID_0_SHFT                                                              0

#define HWIO_TCL_R0_ASE_WATCHDOG_WAR_ADDR(x)                                                                ((x) + 0xec4)
#define HWIO_TCL_R0_ASE_WATCHDOG_WAR_PHYS(x)                                                                ((x) + 0xec4)
#define HWIO_TCL_R0_ASE_WATCHDOG_WAR_OFFS                                                                   (0xec4)
#define HWIO_TCL_R0_ASE_WATCHDOG_WAR_RMSK                                                                   0xffffffff
#define HWIO_TCL_R0_ASE_WATCHDOG_WAR_POR                                                                    0x0000ffff
#define HWIO_TCL_R0_ASE_WATCHDOG_WAR_POR_RMSK                                                               0xffffffff
#define HWIO_TCL_R0_ASE_WATCHDOG_WAR_ATTR                                                                                0x3
#define HWIO_TCL_R0_ASE_WATCHDOG_WAR_IN(x)            \
                in_dword(HWIO_TCL_R0_ASE_WATCHDOG_WAR_ADDR(x))
#define HWIO_TCL_R0_ASE_WATCHDOG_WAR_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_ASE_WATCHDOG_WAR_ADDR(x), m)
#define HWIO_TCL_R0_ASE_WATCHDOG_WAR_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_ASE_WATCHDOG_WAR_ADDR(x),v)
#define HWIO_TCL_R0_ASE_WATCHDOG_WAR_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_ASE_WATCHDOG_WAR_ADDR(x),m,v,HWIO_TCL_R0_ASE_WATCHDOG_WAR_IN(x))
#define HWIO_TCL_R0_ASE_WATCHDOG_WAR_STATUS_BMSK                                                            0xffff0000
#define HWIO_TCL_R0_ASE_WATCHDOG_WAR_STATUS_SHFT                                                                    16
#define HWIO_TCL_R0_ASE_WATCHDOG_WAR_LIMIT_BMSK                                                                 0xffff
#define HWIO_TCL_R0_ASE_WATCHDOG_WAR_LIMIT_SHFT                                                                      0

#define HWIO_TCL_R0_ASE_WATCHDOG_ERR_ADDR(x)                                                                ((x) + 0xec8)
#define HWIO_TCL_R0_ASE_WATCHDOG_ERR_PHYS(x)                                                                ((x) + 0xec8)
#define HWIO_TCL_R0_ASE_WATCHDOG_ERR_OFFS                                                                   (0xec8)
#define HWIO_TCL_R0_ASE_WATCHDOG_ERR_RMSK                                                                   0xffffffff
#define HWIO_TCL_R0_ASE_WATCHDOG_ERR_POR                                                                    0x0000ffff
#define HWIO_TCL_R0_ASE_WATCHDOG_ERR_POR_RMSK                                                               0xffffffff
#define HWIO_TCL_R0_ASE_WATCHDOG_ERR_ATTR                                                                                0x3
#define HWIO_TCL_R0_ASE_WATCHDOG_ERR_IN(x)            \
                in_dword(HWIO_TCL_R0_ASE_WATCHDOG_ERR_ADDR(x))
#define HWIO_TCL_R0_ASE_WATCHDOG_ERR_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_ASE_WATCHDOG_ERR_ADDR(x), m)
#define HWIO_TCL_R0_ASE_WATCHDOG_ERR_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_ASE_WATCHDOG_ERR_ADDR(x),v)
#define HWIO_TCL_R0_ASE_WATCHDOG_ERR_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_ASE_WATCHDOG_ERR_ADDR(x),m,v,HWIO_TCL_R0_ASE_WATCHDOG_ERR_IN(x))
#define HWIO_TCL_R0_ASE_WATCHDOG_ERR_STATUS_BMSK                                                            0xffff0000
#define HWIO_TCL_R0_ASE_WATCHDOG_ERR_STATUS_SHFT                                                                    16
#define HWIO_TCL_R0_ASE_WATCHDOG_ERR_LIMIT_BMSK                                                                 0xffff
#define HWIO_TCL_R0_ASE_WATCHDOG_ERR_LIMIT_SHFT                                                                      0

#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_ADDR(x)                                                             ((x) + 0xecc)
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_PHYS(x)                                                             ((x) + 0xecc)
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_OFFS                                                                (0xecc)
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_RMSK                                                                0xffffffff
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_POR                                                                 0x00000000
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_ATTR                                                                             0x3
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_IN(x)            \
                in_dword(HWIO_TCL_R0_ASE_CLKGATE_DISABLE_ADDR(x))
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_ASE_CLKGATE_DISABLE_ADDR(x), m)
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_OUT(x, v)            \
                out_dword(HWIO_TCL_R0_ASE_CLKGATE_DISABLE_ADDR(x),v)
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R0_ASE_CLKGATE_DISABLE_ADDR(x),m,v,HWIO_TCL_R0_ASE_CLKGATE_DISABLE_IN(x))
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_CLK_EXTEND_BMSK                                                     0x80000000
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_CLK_EXTEND_SHFT                                                             31
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_CPU_IF_EXTEND_BMSK                                                  0x40000000
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_CPU_IF_EXTEND_SHFT                                                          30
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_GSE_RSRVD_BMSK                                                      0x3ffffe00
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_GSE_RSRVD_SHFT                                                               9
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_GSE_TOP_BMSK                                                             0x100
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_GSE_TOP_SHFT                                                                 8
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_CACHE_BMSK                                                                0x80
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_CACHE_SHFT                                                                   7
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_SLOTS_ARRAY_HASH_BMSK                                                     0x40
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_SLOTS_ARRAY_HASH_SHFT                                                        6
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_APP_RETURN_BMSK                                                           0x20
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_APP_RETURN_SHFT                                                              5
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_MEM_RESP2_BMSK                                                            0x10
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_MEM_RESP2_SHFT                                                               4
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_MEM_RESP1_BMSK                                                             0x8
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_MEM_RESP1_SHFT                                                               3
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_MEM_ISS2_BMSK                                                              0x4
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_MEM_ISS2_SHFT                                                                2
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_MEM_ISS1_BMSK                                                              0x2
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_MEM_ISS1_SHFT                                                                1
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_GSE_CTL_BMSK                                                               0x1
#define HWIO_TCL_R0_ASE_CLKGATE_DISABLE_GSE_CTL_SHFT                                                                 0

#define HWIO_TCL_R0_ASE_WRITE_BACK_PENDING_ADDR(x)                                                          ((x) + 0xed0)
#define HWIO_TCL_R0_ASE_WRITE_BACK_PENDING_PHYS(x)                                                          ((x) + 0xed0)
#define HWIO_TCL_R0_ASE_WRITE_BACK_PENDING_OFFS                                                             (0xed0)
#define HWIO_TCL_R0_ASE_WRITE_BACK_PENDING_RMSK                                                                    0x1
#define HWIO_TCL_R0_ASE_WRITE_BACK_PENDING_POR                                                              0x00000000
#define HWIO_TCL_R0_ASE_WRITE_BACK_PENDING_POR_RMSK                                                         0xffffffff
#define HWIO_TCL_R0_ASE_WRITE_BACK_PENDING_ATTR                                                                          0x1
#define HWIO_TCL_R0_ASE_WRITE_BACK_PENDING_IN(x)            \
                in_dword(HWIO_TCL_R0_ASE_WRITE_BACK_PENDING_ADDR(x))
#define HWIO_TCL_R0_ASE_WRITE_BACK_PENDING_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R0_ASE_WRITE_BACK_PENDING_ADDR(x), m)
#define HWIO_TCL_R0_ASE_WRITE_BACK_PENDING_STATUS_BMSK                                                             0x1
#define HWIO_TCL_R0_ASE_WRITE_BACK_PENDING_STATUS_SHFT                                                               0

#define HWIO_TCL_R1_CACHE_FLUSH_ADDR(x)                                                                     ((x) + 0x1000)
#define HWIO_TCL_R1_CACHE_FLUSH_PHYS(x)                                                                     ((x) + 0x1000)
#define HWIO_TCL_R1_CACHE_FLUSH_OFFS                                                                        (0x1000)
#define HWIO_TCL_R1_CACHE_FLUSH_RMSK                                                                               0x3
#define HWIO_TCL_R1_CACHE_FLUSH_POR                                                                         0x00000000
#define HWIO_TCL_R1_CACHE_FLUSH_POR_RMSK                                                                    0xffffffff
#define HWIO_TCL_R1_CACHE_FLUSH_ATTR                                                                                     0x3
#define HWIO_TCL_R1_CACHE_FLUSH_IN(x)            \
                in_dword(HWIO_TCL_R1_CACHE_FLUSH_ADDR(x))
#define HWIO_TCL_R1_CACHE_FLUSH_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_CACHE_FLUSH_ADDR(x), m)
#define HWIO_TCL_R1_CACHE_FLUSH_OUT(x, v)            \
                out_dword(HWIO_TCL_R1_CACHE_FLUSH_ADDR(x),v)
#define HWIO_TCL_R1_CACHE_FLUSH_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R1_CACHE_FLUSH_ADDR(x),m,v,HWIO_TCL_R1_CACHE_FLUSH_IN(x))
#define HWIO_TCL_R1_CACHE_FLUSH_STATUS_BMSK                                                                        0x2
#define HWIO_TCL_R1_CACHE_FLUSH_STATUS_SHFT                                                                          1
#define HWIO_TCL_R1_CACHE_FLUSH_ENABLE_BMSK                                                                        0x1
#define HWIO_TCL_R1_CACHE_FLUSH_ENABLE_SHFT                                                                          0

#define HWIO_TCL_R1_SM_STATES_IX_0_ADDR(x)                                                                  ((x) + 0x1004)
#define HWIO_TCL_R1_SM_STATES_IX_0_PHYS(x)                                                                  ((x) + 0x1004)
#define HWIO_TCL_R1_SM_STATES_IX_0_OFFS                                                                     (0x1004)
#define HWIO_TCL_R1_SM_STATES_IX_0_RMSK                                                                     0x7fff8fff
#define HWIO_TCL_R1_SM_STATES_IX_0_POR                                                                      0x00000000
#define HWIO_TCL_R1_SM_STATES_IX_0_POR_RMSK                                                                 0xffffffff
#define HWIO_TCL_R1_SM_STATES_IX_0_ATTR                                                                                  0x1
#define HWIO_TCL_R1_SM_STATES_IX_0_IN(x)            \
                in_dword(HWIO_TCL_R1_SM_STATES_IX_0_ADDR(x))
#define HWIO_TCL_R1_SM_STATES_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_SM_STATES_IX_0_ADDR(x), m)
#define HWIO_TCL_R1_SM_STATES_IX_0_TLV_GEN_BMSK                                                             0x78000000
#define HWIO_TCL_R1_SM_STATES_IX_0_TLV_GEN_SHFT                                                                     27
#define HWIO_TCL_R1_SM_STATES_IX_0_EXTN_DESC_FETCH_BMSK                                                      0x7000000
#define HWIO_TCL_R1_SM_STATES_IX_0_EXTN_DESC_FETCH_SHFT                                                             24
#define HWIO_TCL_R1_SM_STATES_IX_0_MSDU_FETCH_BMSK                                                            0xe00000
#define HWIO_TCL_R1_SM_STATES_IX_0_MSDU_FETCH_SHFT                                                                  21
#define HWIO_TCL_R1_SM_STATES_IX_0_SW2TCL_CREDIT_RING_BMSK                                                    0x1c0000
#define HWIO_TCL_R1_SM_STATES_IX_0_SW2TCL_CREDIT_RING_SHFT                                                          18
#define HWIO_TCL_R1_SM_STATES_IX_0_FW2TCL1_RING_BMSK                                                           0x38000
#define HWIO_TCL_R1_SM_STATES_IX_0_FW2TCL1_RING_SHFT                                                                15
#define HWIO_TCL_R1_SM_STATES_IX_0_SW2TCL4_RING_BMSK                                                             0xe00
#define HWIO_TCL_R1_SM_STATES_IX_0_SW2TCL4_RING_SHFT                                                                 9
#define HWIO_TCL_R1_SM_STATES_IX_0_SW2TCL3_RING_BMSK                                                             0x1c0
#define HWIO_TCL_R1_SM_STATES_IX_0_SW2TCL3_RING_SHFT                                                                 6
#define HWIO_TCL_R1_SM_STATES_IX_0_SW2TCL2_RING_BMSK                                                              0x38
#define HWIO_TCL_R1_SM_STATES_IX_0_SW2TCL2_RING_SHFT                                                                 3
#define HWIO_TCL_R1_SM_STATES_IX_0_SW2TCL1_RING_BMSK                                                               0x7
#define HWIO_TCL_R1_SM_STATES_IX_0_SW2TCL1_RING_SHFT                                                                 0

#define HWIO_TCL_R1_SM_STATES_IX_1_ADDR(x)                                                                  ((x) + 0x1008)
#define HWIO_TCL_R1_SM_STATES_IX_1_PHYS(x)                                                                  ((x) + 0x1008)
#define HWIO_TCL_R1_SM_STATES_IX_1_OFFS                                                                     (0x1008)
#define HWIO_TCL_R1_SM_STATES_IX_1_RMSK                                                                     0xfffe3fff
#define HWIO_TCL_R1_SM_STATES_IX_1_POR                                                                      0x00000000
#define HWIO_TCL_R1_SM_STATES_IX_1_POR_RMSK                                                                 0xffffffff
#define HWIO_TCL_R1_SM_STATES_IX_1_ATTR                                                                                  0x1
#define HWIO_TCL_R1_SM_STATES_IX_1_IN(x)            \
                in_dword(HWIO_TCL_R1_SM_STATES_IX_1_ADDR(x))
#define HWIO_TCL_R1_SM_STATES_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_SM_STATES_IX_1_ADDR(x), m)
#define HWIO_TCL_R1_SM_STATES_IX_1_TCL_IDLE_SEQUENCE_BMSK                                                   0xe0000000
#define HWIO_TCL_R1_SM_STATES_IX_1_TCL_IDLE_SEQUENCE_SHFT                                                           29
#define HWIO_TCL_R1_SM_STATES_IX_1_DSCP_TABLE_ACC_BMSK                                                      0x1c000000
#define HWIO_TCL_R1_SM_STATES_IX_1_DSCP_TABLE_ACC_SHFT                                                              26
#define HWIO_TCL_R1_SM_STATES_IX_1_PROD_RING_FW_CTRL_BMSK                                                    0x3800000
#define HWIO_TCL_R1_SM_STATES_IX_1_PROD_RING_FW_CTRL_SHFT                                                           23
#define HWIO_TCL_R1_SM_STATES_IX_1_PROD_CTRL_METADATA_BMSK                                                    0x700000
#define HWIO_TCL_R1_SM_STATES_IX_1_PROD_CTRL_METADATA_SHFT                                                          20
#define HWIO_TCL_R1_SM_STATES_IX_1_PROD_CTRL_BMSK                                                              0xe0000
#define HWIO_TCL_R1_SM_STATES_IX_1_PROD_CTRL_SHFT                                                                   17
#define HWIO_TCL_R1_SM_STATES_IX_1_TCL_STATUS1_BMSK                                                             0x3800
#define HWIO_TCL_R1_SM_STATES_IX_1_TCL_STATUS1_SHFT                                                                 11
#define HWIO_TCL_R1_SM_STATES_IX_1_TCL2FW_BMSK                                                                   0x700
#define HWIO_TCL_R1_SM_STATES_IX_1_TCL2FW_SHFT                                                                       8
#define HWIO_TCL_R1_SM_STATES_IX_1_TCL2TQM_BMSK                                                                   0xe0
#define HWIO_TCL_R1_SM_STATES_IX_1_TCL2TQM_SHFT                                                                      5
#define HWIO_TCL_R1_SM_STATES_IX_1_GSE_CTRL_RES_WR_BMSK                                                           0x18
#define HWIO_TCL_R1_SM_STATES_IX_1_GSE_CTRL_RES_WR_SHFT                                                              3
#define HWIO_TCL_R1_SM_STATES_IX_1_GSE_CTRL_BMSK                                                                   0x7
#define HWIO_TCL_R1_SM_STATES_IX_1_GSE_CTRL_SHFT                                                                     0

#define HWIO_TCL_R1_SM_STATES_IX_2_ADDR(x)                                                                  ((x) + 0x100c)
#define HWIO_TCL_R1_SM_STATES_IX_2_PHYS(x)                                                                  ((x) + 0x100c)
#define HWIO_TCL_R1_SM_STATES_IX_2_OFFS                                                                     (0x100c)
#define HWIO_TCL_R1_SM_STATES_IX_2_RMSK                                                                          0x38f
#define HWIO_TCL_R1_SM_STATES_IX_2_POR                                                                      0x00000000
#define HWIO_TCL_R1_SM_STATES_IX_2_POR_RMSK                                                                 0xffffffff
#define HWIO_TCL_R1_SM_STATES_IX_2_ATTR                                                                                  0x1
#define HWIO_TCL_R1_SM_STATES_IX_2_IN(x)            \
                in_dword(HWIO_TCL_R1_SM_STATES_IX_2_ADDR(x))
#define HWIO_TCL_R1_SM_STATES_IX_2_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_SM_STATES_IX_2_ADDR(x), m)
#define HWIO_TCL_R1_SM_STATES_IX_2_ASE_SKIP_RES_HANDLER_BMSK                                                     0x380
#define HWIO_TCL_R1_SM_STATES_IX_2_ASE_SKIP_RES_HANDLER_SHFT                                                         7
#define HWIO_TCL_R1_SM_STATES_IX_2_GSE_CCE_RES_CLFY_DIS_BMSK                                                       0xc
#define HWIO_TCL_R1_SM_STATES_IX_2_GSE_CCE_RES_CLFY_DIS_SHFT                                                         2
#define HWIO_TCL_R1_SM_STATES_IX_2_TLV_DEC_CLFY_DIS_BMSK                                                           0x3
#define HWIO_TCL_R1_SM_STATES_IX_2_TLV_DEC_CLFY_DIS_SHFT                                                             0

#define HWIO_TCL_R1_STATUS_ADDR(x)                                                                          ((x) + 0x1010)
#define HWIO_TCL_R1_STATUS_PHYS(x)                                                                          ((x) + 0x1010)
#define HWIO_TCL_R1_STATUS_OFFS                                                                             (0x1010)
#define HWIO_TCL_R1_STATUS_RMSK                                                                             0xfffddbff
#define HWIO_TCL_R1_STATUS_POR                                                                              0x00000000
#define HWIO_TCL_R1_STATUS_POR_RMSK                                                                         0xffffffff
#define HWIO_TCL_R1_STATUS_ATTR                                                                                          0x1
#define HWIO_TCL_R1_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R1_STATUS_ADDR(x))
#define HWIO_TCL_R1_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_STATUS_ADDR(x), m)
#define HWIO_TCL_R1_STATUS_ASE_SKIP_RES_HANDLER_IDLE_BMSK                                                   0x80000000
#define HWIO_TCL_R1_STATUS_ASE_SKIP_RES_HANDLER_IDLE_SHFT                                                           31
#define HWIO_TCL_R1_STATUS_HDR_BUF_EMPTY_BMSK                                                               0x40000000
#define HWIO_TCL_R1_STATUS_HDR_BUF_EMPTY_SHFT                                                                       30
#define HWIO_TCL_R1_STATUS_DESC_BUF_EMPTY_BMSK                                                              0x20000000
#define HWIO_TCL_R1_STATUS_DESC_BUF_EMPTY_SHFT                                                                      29
#define HWIO_TCL_R1_STATUS_GSE_CCE_RES_IDLE_BMSK                                                            0x10000000
#define HWIO_TCL_R1_STATUS_GSE_CCE_RES_IDLE_SHFT                                                                    28
#define HWIO_TCL_R1_STATUS_PROD_RING_FW_FIFO_CTRL_IDLE_BMSK                                                  0x8000000
#define HWIO_TCL_R1_STATUS_PROD_RING_FW_FIFO_CTRL_IDLE_SHFT                                                         27
#define HWIO_TCL_R1_STATUS_PROD_RING_BUNCH_FIFO_CTRL_IDLE_BMSK                                               0x4000000
#define HWIO_TCL_R1_STATUS_PROD_RING_BUNCH_FIFO_CTRL_IDLE_SHFT                                                      26
#define HWIO_TCL_R1_STATUS_PROD_RING_CTRL_IDLE_BMSK                                                          0x2000000
#define HWIO_TCL_R1_STATUS_PROD_RING_CTRL_IDLE_SHFT                                                                 25
#define HWIO_TCL_R1_STATUS_TLV_DECODER_IDLE_BMSK                                                             0x1000000
#define HWIO_TCL_R1_STATUS_TLV_DECODER_IDLE_SHFT                                                                    24
#define HWIO_TCL_R1_STATUS_TLV_GEN_IDLE_BMSK                                                                  0x800000
#define HWIO_TCL_R1_STATUS_TLV_GEN_IDLE_SHFT                                                                        23
#define HWIO_TCL_R1_STATUS_GSE_CTRL_IDLE_BMSK                                                                 0x400000
#define HWIO_TCL_R1_STATUS_GSE_CTRL_IDLE_SHFT                                                                       22
#define HWIO_TCL_R1_STATUS_CLFY_WRAP_IDLE_BMSK                                                                0x200000
#define HWIO_TCL_R1_STATUS_CLFY_WRAP_IDLE_SHFT                                                                      21
#define HWIO_TCL_R1_STATUS_CCE_OR_LCE_IDLE_BMSK                                                               0x100000
#define HWIO_TCL_R1_STATUS_CCE_OR_LCE_IDLE_SHFT                                                                     20
#define HWIO_TCL_R1_STATUS_ASE_IDLE_BMSK                                                                       0x80000
#define HWIO_TCL_R1_STATUS_ASE_IDLE_SHFT                                                                            19
#define HWIO_TCL_R1_STATUS_PARSER_IDLE_BMSK                                                                    0x40000
#define HWIO_TCL_R1_STATUS_PARSER_IDLE_SHFT                                                                         18
#define HWIO_TCL_R1_STATUS_TCL_STATUS1_PROD_IDLE_BMSK                                                          0x10000
#define HWIO_TCL_R1_STATUS_TCL_STATUS1_PROD_IDLE_SHFT                                                               16
#define HWIO_TCL_R1_STATUS_TCL2FW_PROD_IDLE_BMSK                                                                0x8000
#define HWIO_TCL_R1_STATUS_TCL2FW_PROD_IDLE_SHFT                                                                    15
#define HWIO_TCL_R1_STATUS_TCL2TQM_PROD_IDLE_BMSK                                                               0x4000
#define HWIO_TCL_R1_STATUS_TCL2TQM_PROD_IDLE_SHFT                                                                   14
#define HWIO_TCL_R1_STATUS_SW2TCL_CREDIT_CONS_IDLE_BMSK                                                         0x1000
#define HWIO_TCL_R1_STATUS_SW2TCL_CREDIT_CONS_IDLE_SHFT                                                             12
#define HWIO_TCL_R1_STATUS_FW2TCL1_CONS_IDLE_BMSK                                                                0x800
#define HWIO_TCL_R1_STATUS_FW2TCL1_CONS_IDLE_SHFT                                                                   11
#define HWIO_TCL_R1_STATUS_SW2TCL4_CONS_IDLE_BMSK                                                                0x200
#define HWIO_TCL_R1_STATUS_SW2TCL4_CONS_IDLE_SHFT                                                                    9
#define HWIO_TCL_R1_STATUS_SW2TCL3_CONS_IDLE_BMSK                                                                0x100
#define HWIO_TCL_R1_STATUS_SW2TCL3_CONS_IDLE_SHFT                                                                    8
#define HWIO_TCL_R1_STATUS_SW2TCL2_CONS_IDLE_BMSK                                                                 0x80
#define HWIO_TCL_R1_STATUS_SW2TCL2_CONS_IDLE_SHFT                                                                    7
#define HWIO_TCL_R1_STATUS_SW2TCL1_CONS_IDLE_BMSK                                                                 0x40
#define HWIO_TCL_R1_STATUS_SW2TCL1_CONS_IDLE_SHFT                                                                    6
#define HWIO_TCL_R1_STATUS_GXI_IDLE_BMSK                                                                          0x20
#define HWIO_TCL_R1_STATUS_GXI_IDLE_SHFT                                                                             5
#define HWIO_TCL_R1_STATUS_DESC_RD_IDLE_BMSK                                                                      0x10
#define HWIO_TCL_R1_STATUS_DESC_RD_IDLE_SHFT                                                                         4
#define HWIO_TCL_R1_STATUS_SDU_HDR_FETCH_IDLE_BMSK                                                                 0x8
#define HWIO_TCL_R1_STATUS_SDU_HDR_FETCH_IDLE_SHFT                                                                   3
#define HWIO_TCL_R1_STATUS_LINK_DESC_FETCH_IDLE_BMSK                                                               0x4
#define HWIO_TCL_R1_STATUS_LINK_DESC_FETCH_IDLE_SHFT                                                                 2
#define HWIO_TCL_R1_STATUS_DATA_FETCH_IDLE_BMSK                                                                    0x2
#define HWIO_TCL_R1_STATUS_DATA_FETCH_IDLE_SHFT                                                                      1
#define HWIO_TCL_R1_STATUS_TCL_INT_IDLE_BMSK                                                                       0x1
#define HWIO_TCL_R1_STATUS_TCL_INT_IDLE_SHFT                                                                         0

#define HWIO_TCL_R1_WDOG_SM_STATES_IX_0_ADDR(x)                                                             ((x) + 0x1014)
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_0_PHYS(x)                                                             ((x) + 0x1014)
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_0_OFFS                                                                (0x1014)
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_0_RMSK                                                                0x7fff8fff
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_0_POR                                                                 0x00000000
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_0_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_0_ATTR                                                                             0x1
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_0_IN(x)            \
                in_dword(HWIO_TCL_R1_WDOG_SM_STATES_IX_0_ADDR(x))
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_WDOG_SM_STATES_IX_0_ADDR(x), m)
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_0_TLV_GEN_BMSK                                                        0x78000000
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_0_TLV_GEN_SHFT                                                                27
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_0_EXTN_DESC_FETCH_BMSK                                                 0x7000000
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_0_EXTN_DESC_FETCH_SHFT                                                        24
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_0_MSDU_FETCH_BMSK                                                       0xe00000
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_0_MSDU_FETCH_SHFT                                                             21
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_0_SW2TCL_CREDIT_RING_BMSK                                               0x1c0000
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_0_SW2TCL_CREDIT_RING_SHFT                                                     18
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_0_FW2TCL1_RING_BMSK                                                      0x38000
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_0_FW2TCL1_RING_SHFT                                                           15
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_0_SW2TCL4_RING_BMSK                                                        0xe00
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_0_SW2TCL4_RING_SHFT                                                            9
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_0_SW2TCL3_RING_BMSK                                                        0x1c0
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_0_SW2TCL3_RING_SHFT                                                            6
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_0_SW2TCL2_RING_BMSK                                                         0x38
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_0_SW2TCL2_RING_SHFT                                                            3
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_0_SW2TCL1_RING_BMSK                                                          0x7
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_0_SW2TCL1_RING_SHFT                                                            0

#define HWIO_TCL_R1_WDOG_SM_STATES_IX_1_ADDR(x)                                                             ((x) + 0x1018)
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_1_PHYS(x)                                                             ((x) + 0x1018)
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_1_OFFS                                                                (0x1018)
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_1_RMSK                                                                0xfffe3fff
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_1_POR                                                                 0x00000000
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_1_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_1_ATTR                                                                             0x1
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_1_IN(x)            \
                in_dword(HWIO_TCL_R1_WDOG_SM_STATES_IX_1_ADDR(x))
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_WDOG_SM_STATES_IX_1_ADDR(x), m)
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_1_TCL_IDLE_SEQUENCE_BMSK                                              0xe0000000
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_1_TCL_IDLE_SEQUENCE_SHFT                                                      29
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_1_DSCP_TABLE_ACC_BMSK                                                 0x1c000000
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_1_DSCP_TABLE_ACC_SHFT                                                         26
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_1_PROD_RING_FW_CTRL_BMSK                                               0x3800000
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_1_PROD_RING_FW_CTRL_SHFT                                                      23
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_1_PROD_CTRL_METADATA_BMSK                                               0x700000
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_1_PROD_CTRL_METADATA_SHFT                                                     20
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_1_PROD_CTRL_BMSK                                                         0xe0000
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_1_PROD_CTRL_SHFT                                                              17
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_1_TCL_STATUS1_BMSK                                                        0x3800
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_1_TCL_STATUS1_SHFT                                                            11
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_1_TCL2FW_BMSK                                                              0x700
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_1_TCL2FW_SHFT                                                                  8
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_1_TCL2TQM_BMSK                                                              0xe0
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_1_TCL2TQM_SHFT                                                                 5
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_1_GSE_CTRL_RES_WR_BMSK                                                      0x18
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_1_GSE_CTRL_RES_WR_SHFT                                                         3
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_1_GSE_CTRL_BMSK                                                              0x7
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_1_GSE_CTRL_SHFT                                                                0

#define HWIO_TCL_R1_WDOG_SM_STATES_IX_2_ADDR(x)                                                             ((x) + 0x101c)
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_2_PHYS(x)                                                             ((x) + 0x101c)
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_2_OFFS                                                                (0x101c)
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_2_RMSK                                                                     0x38f
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_2_POR                                                                 0x00000000
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_2_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_2_ATTR                                                                             0x1
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_2_IN(x)            \
                in_dword(HWIO_TCL_R1_WDOG_SM_STATES_IX_2_ADDR(x))
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_2_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_WDOG_SM_STATES_IX_2_ADDR(x), m)
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_2_ASE_SKIP_RES_HANDLER_BMSK                                                0x380
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_2_ASE_SKIP_RES_HANDLER_SHFT                                                    7
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_2_GSE_CCE_RES_CLFY_DIS_BMSK                                                  0xc
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_2_GSE_CCE_RES_CLFY_DIS_SHFT                                                    2
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_2_TLV_DEC_CLFY_DIS_BMSK                                                      0x3
#define HWIO_TCL_R1_WDOG_SM_STATES_IX_2_TLV_DEC_CLFY_DIS_SHFT                                                        0

#define HWIO_TCL_R1_WDOG_STATUS_ADDR(x)                                                                     ((x) + 0x1020)
#define HWIO_TCL_R1_WDOG_STATUS_PHYS(x)                                                                     ((x) + 0x1020)
#define HWIO_TCL_R1_WDOG_STATUS_OFFS                                                                        (0x1020)
#define HWIO_TCL_R1_WDOG_STATUS_RMSK                                                                        0xfffddbff
#define HWIO_TCL_R1_WDOG_STATUS_POR                                                                         0x00000000
#define HWIO_TCL_R1_WDOG_STATUS_POR_RMSK                                                                    0xffffffff
#define HWIO_TCL_R1_WDOG_STATUS_ATTR                                                                                     0x1
#define HWIO_TCL_R1_WDOG_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R1_WDOG_STATUS_ADDR(x))
#define HWIO_TCL_R1_WDOG_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_WDOG_STATUS_ADDR(x), m)
#define HWIO_TCL_R1_WDOG_STATUS_ASE_SKIP_RES_HANDLER_IDLE_BMSK                                              0x80000000
#define HWIO_TCL_R1_WDOG_STATUS_ASE_SKIP_RES_HANDLER_IDLE_SHFT                                                      31
#define HWIO_TCL_R1_WDOG_STATUS_HDR_BUF_EMPTY_BMSK                                                          0x40000000
#define HWIO_TCL_R1_WDOG_STATUS_HDR_BUF_EMPTY_SHFT                                                                  30
#define HWIO_TCL_R1_WDOG_STATUS_DESC_BUF_EMPTY_BMSK                                                         0x20000000
#define HWIO_TCL_R1_WDOG_STATUS_DESC_BUF_EMPTY_SHFT                                                                 29
#define HWIO_TCL_R1_WDOG_STATUS_GSE_CCE_RES_IDLE_BMSK                                                       0x10000000
#define HWIO_TCL_R1_WDOG_STATUS_GSE_CCE_RES_IDLE_SHFT                                                               28
#define HWIO_TCL_R1_WDOG_STATUS_PROD_RING_FW_FIFO_CTRL_IDLE_BMSK                                             0x8000000
#define HWIO_TCL_R1_WDOG_STATUS_PROD_RING_FW_FIFO_CTRL_IDLE_SHFT                                                    27
#define HWIO_TCL_R1_WDOG_STATUS_PROD_RING_BUNCH_FIFO_CTRL_IDLE_BMSK                                          0x4000000
#define HWIO_TCL_R1_WDOG_STATUS_PROD_RING_BUNCH_FIFO_CTRL_IDLE_SHFT                                                 26
#define HWIO_TCL_R1_WDOG_STATUS_PROD_RING_CTRL_IDLE_BMSK                                                     0x2000000
#define HWIO_TCL_R1_WDOG_STATUS_PROD_RING_CTRL_IDLE_SHFT                                                            25
#define HWIO_TCL_R1_WDOG_STATUS_TLV_DECODER_IDLE_BMSK                                                        0x1000000
#define HWIO_TCL_R1_WDOG_STATUS_TLV_DECODER_IDLE_SHFT                                                               24
#define HWIO_TCL_R1_WDOG_STATUS_TLV_GEN_IDLE_BMSK                                                             0x800000
#define HWIO_TCL_R1_WDOG_STATUS_TLV_GEN_IDLE_SHFT                                                                   23
#define HWIO_TCL_R1_WDOG_STATUS_GSE_CTRL_IDLE_BMSK                                                            0x400000
#define HWIO_TCL_R1_WDOG_STATUS_GSE_CTRL_IDLE_SHFT                                                                  22
#define HWIO_TCL_R1_WDOG_STATUS_CLFY_WRAP_IDLE_BMSK                                                           0x200000
#define HWIO_TCL_R1_WDOG_STATUS_CLFY_WRAP_IDLE_SHFT                                                                 21
#define HWIO_TCL_R1_WDOG_STATUS_CCE_OR_LCE_IDLE_BMSK                                                          0x100000
#define HWIO_TCL_R1_WDOG_STATUS_CCE_OR_LCE_IDLE_SHFT                                                                20
#define HWIO_TCL_R1_WDOG_STATUS_ASE_IDLE_BMSK                                                                  0x80000
#define HWIO_TCL_R1_WDOG_STATUS_ASE_IDLE_SHFT                                                                       19
#define HWIO_TCL_R1_WDOG_STATUS_PARSER_IDLE_BMSK                                                               0x40000
#define HWIO_TCL_R1_WDOG_STATUS_PARSER_IDLE_SHFT                                                                    18
#define HWIO_TCL_R1_WDOG_STATUS_TCL_STATUS1_PROD_IDLE_BMSK                                                     0x10000
#define HWIO_TCL_R1_WDOG_STATUS_TCL_STATUS1_PROD_IDLE_SHFT                                                          16
#define HWIO_TCL_R1_WDOG_STATUS_TCL2FW_PROD_IDLE_BMSK                                                           0x8000
#define HWIO_TCL_R1_WDOG_STATUS_TCL2FW_PROD_IDLE_SHFT                                                               15
#define HWIO_TCL_R1_WDOG_STATUS_TCL2TQM_PROD_IDLE_BMSK                                                          0x4000
#define HWIO_TCL_R1_WDOG_STATUS_TCL2TQM_PROD_IDLE_SHFT                                                              14
#define HWIO_TCL_R1_WDOG_STATUS_SW2TCL_CREDIT_CONS_IDLE_BMSK                                                    0x1000
#define HWIO_TCL_R1_WDOG_STATUS_SW2TCL_CREDIT_CONS_IDLE_SHFT                                                        12
#define HWIO_TCL_R1_WDOG_STATUS_FW2TCL1_CONS_IDLE_BMSK                                                           0x800
#define HWIO_TCL_R1_WDOG_STATUS_FW2TCL1_CONS_IDLE_SHFT                                                              11
#define HWIO_TCL_R1_WDOG_STATUS_SW2TCL4_CONS_IDLE_BMSK                                                           0x200
#define HWIO_TCL_R1_WDOG_STATUS_SW2TCL4_CONS_IDLE_SHFT                                                               9
#define HWIO_TCL_R1_WDOG_STATUS_SW2TCL3_CONS_IDLE_BMSK                                                           0x100
#define HWIO_TCL_R1_WDOG_STATUS_SW2TCL3_CONS_IDLE_SHFT                                                               8
#define HWIO_TCL_R1_WDOG_STATUS_SW2TCL2_CONS_IDLE_BMSK                                                            0x80
#define HWIO_TCL_R1_WDOG_STATUS_SW2TCL2_CONS_IDLE_SHFT                                                               7
#define HWIO_TCL_R1_WDOG_STATUS_SW2TCL1_CONS_IDLE_BMSK                                                            0x40
#define HWIO_TCL_R1_WDOG_STATUS_SW2TCL1_CONS_IDLE_SHFT                                                               6
#define HWIO_TCL_R1_WDOG_STATUS_GXI_IDLE_BMSK                                                                     0x20
#define HWIO_TCL_R1_WDOG_STATUS_GXI_IDLE_SHFT                                                                        5
#define HWIO_TCL_R1_WDOG_STATUS_DESC_RD_IDLE_BMSK                                                                 0x10
#define HWIO_TCL_R1_WDOG_STATUS_DESC_RD_IDLE_SHFT                                                                    4
#define HWIO_TCL_R1_WDOG_STATUS_SDU_HDR_FETCH_IDLE_BMSK                                                            0x8
#define HWIO_TCL_R1_WDOG_STATUS_SDU_HDR_FETCH_IDLE_SHFT                                                              3
#define HWIO_TCL_R1_WDOG_STATUS_LINK_DESC_FETCH_IDLE_BMSK                                                          0x4
#define HWIO_TCL_R1_WDOG_STATUS_LINK_DESC_FETCH_IDLE_SHFT                                                            2
#define HWIO_TCL_R1_WDOG_STATUS_DATA_FETCH_IDLE_BMSK                                                               0x2
#define HWIO_TCL_R1_WDOG_STATUS_DATA_FETCH_IDLE_SHFT                                                                 1
#define HWIO_TCL_R1_WDOG_STATUS_TCL_INT_IDLE_BMSK                                                                  0x1
#define HWIO_TCL_R1_WDOG_STATUS_TCL_INT_IDLE_SHFT                                                                    0

#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_ADDR(x)                                                    ((x) + 0x1024)
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_PHYS(x)                                                    ((x) + 0x1024)
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_OFFS                                                       (0x1024)
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_RMSK                                                          0x3f76f
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_POR                                                        0x00000000
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_POR_RMSK                                                   0xffffffff
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_ATTR                                                                    0x1
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_ADDR(x))
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_ADDR(x), m)
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_PARSER_BMSK                                                   0x20000
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_PARSER_SHFT                                                        17
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_ASE_BMSK                                                      0x10000
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_ASE_SHFT                                                           16
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_METADATA_FETCH_BMSK                                            0x8000
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_METADATA_FETCH_SHFT                                                15
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_PEER_DATA_FETCH_BMSK                                           0x4000
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_PEER_DATA_FETCH_SHFT                                               14
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_HDR_DATA_FETCH_BMSK                                            0x2000
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_HDR_DATA_FETCH_SHFT                                                13
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_LINK_EXTN_FETCH_BMSK                                           0x1000
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_LINK_EXTN_FETCH_SHFT                                               12
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_TCL_STATUS1_BMSK                                                0x400
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_TCL_STATUS1_SHFT                                                   10
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_TCL2FW_BMSK                                                     0x200
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_TCL2FW_SHFT                                                         9
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_TCL2TQM_BMSK                                                    0x100
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_TCL2TQM_SHFT                                                        8
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_SW2TCL_CREDIT_BMSK                                               0x40
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_SW2TCL_CREDIT_SHFT                                                  6
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_FW2TCL1_BMSK                                                     0x20
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_FW2TCL1_SHFT                                                        5
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_SW2TCL4_BMSK                                                      0x8
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_SW2TCL4_SHFT                                                        3
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_SW2TCL3_BMSK                                                      0x4
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_SW2TCL3_SHFT                                                        2
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_SW2TCL2_BMSK                                                      0x2
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_SW2TCL2_SHFT                                                        1
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_SW2TCL1_BMSK                                                      0x1
#define HWIO_TCL_R1_EXTERNAL_BACKPRESSURE_STATUS_SW2TCL1_SHFT                                                        0

#define HWIO_TCL_R1_IDLE_SEQUENCE_STATUS_ADDR(x)                                                            ((x) + 0x1028)
#define HWIO_TCL_R1_IDLE_SEQUENCE_STATUS_PHYS(x)                                                            ((x) + 0x1028)
#define HWIO_TCL_R1_IDLE_SEQUENCE_STATUS_OFFS                                                               (0x1028)
#define HWIO_TCL_R1_IDLE_SEQUENCE_STATUS_RMSK                                                                     0xff
#define HWIO_TCL_R1_IDLE_SEQUENCE_STATUS_POR                                                                0x00000000
#define HWIO_TCL_R1_IDLE_SEQUENCE_STATUS_POR_RMSK                                                           0xffffffff
#define HWIO_TCL_R1_IDLE_SEQUENCE_STATUS_ATTR                                                                            0x1
#define HWIO_TCL_R1_IDLE_SEQUENCE_STATUS_IN(x)            \
                in_dword(HWIO_TCL_R1_IDLE_SEQUENCE_STATUS_ADDR(x))
#define HWIO_TCL_R1_IDLE_SEQUENCE_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_IDLE_SEQUENCE_STATUS_ADDR(x), m)
#define HWIO_TCL_R1_IDLE_SEQUENCE_STATUS_REQ_RESP_TIME_BMSK                                                       0xff
#define HWIO_TCL_R1_IDLE_SEQUENCE_STATUS_REQ_RESP_TIME_SHFT                                                          0

#define HWIO_TCL_R1_TESTBUS_CTRL_0_ADDR(x)                                                                  ((x) + 0x102c)
#define HWIO_TCL_R1_TESTBUS_CTRL_0_PHYS(x)                                                                  ((x) + 0x102c)
#define HWIO_TCL_R1_TESTBUS_CTRL_0_OFFS                                                                     (0x102c)
#define HWIO_TCL_R1_TESTBUS_CTRL_0_RMSK                                                                     0x3fffffff
#define HWIO_TCL_R1_TESTBUS_CTRL_0_POR                                                                      0x00000000
#define HWIO_TCL_R1_TESTBUS_CTRL_0_POR_RMSK                                                                 0xffffffff
#define HWIO_TCL_R1_TESTBUS_CTRL_0_ATTR                                                                                  0x3
#define HWIO_TCL_R1_TESTBUS_CTRL_0_IN(x)            \
                in_dword(HWIO_TCL_R1_TESTBUS_CTRL_0_ADDR(x))
#define HWIO_TCL_R1_TESTBUS_CTRL_0_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_TESTBUS_CTRL_0_ADDR(x), m)
#define HWIO_TCL_R1_TESTBUS_CTRL_0_OUT(x, v)            \
                out_dword(HWIO_TCL_R1_TESTBUS_CTRL_0_ADDR(x),v)
#define HWIO_TCL_R1_TESTBUS_CTRL_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R1_TESTBUS_CTRL_0_ADDR(x),m,v,HWIO_TCL_R1_TESTBUS_CTRL_0_IN(x))
#define HWIO_TCL_R1_TESTBUS_CTRL_0_HW_ERROR_INTERRUPT_TESTBUS_OVERWRITE_BMSK                                0x20000000
#define HWIO_TCL_R1_TESTBUS_CTRL_0_HW_ERROR_INTERRUPT_TESTBUS_OVERWRITE_SHFT                                        29
#define HWIO_TCL_R1_TESTBUS_CTRL_0_TCL_MAIN_SELECT_BMSK                                                     0x1f800000
#define HWIO_TCL_R1_TESTBUS_CTRL_0_TCL_MAIN_SELECT_SHFT                                                             23
#define HWIO_TCL_R1_TESTBUS_CTRL_0_GXI_SELECT_BMSK                                                            0x7c0000
#define HWIO_TCL_R1_TESTBUS_CTRL_0_GXI_SELECT_SHFT                                                                  18
#define HWIO_TCL_R1_TESTBUS_CTRL_0_FSE_SELECT_BMSK                                                             0x3c000
#define HWIO_TCL_R1_TESTBUS_CTRL_0_FSE_SELECT_SHFT                                                                  14
#define HWIO_TCL_R1_TESTBUS_CTRL_0_ASE_SELECT_BMSK                                                              0x3c00
#define HWIO_TCL_R1_TESTBUS_CTRL_0_ASE_SELECT_SHFT                                                                  10
#define HWIO_TCL_R1_TESTBUS_CTRL_0_PARSER_SELECT_BMSK                                                            0x3e0
#define HWIO_TCL_R1_TESTBUS_CTRL_0_PARSER_SELECT_SHFT                                                                5
#define HWIO_TCL_R1_TESTBUS_CTRL_0_CCE_SELECT_BMSK                                                                0x1f
#define HWIO_TCL_R1_TESTBUS_CTRL_0_CCE_SELECT_SHFT                                                                   0

#define HWIO_TCL_R1_TESTBUS_LOW_ADDR(x)                                                                     ((x) + 0x1030)
#define HWIO_TCL_R1_TESTBUS_LOW_PHYS(x)                                                                     ((x) + 0x1030)
#define HWIO_TCL_R1_TESTBUS_LOW_OFFS                                                                        (0x1030)
#define HWIO_TCL_R1_TESTBUS_LOW_RMSK                                                                        0xffffffff
#define HWIO_TCL_R1_TESTBUS_LOW_POR                                                                         0x00000000
#define HWIO_TCL_R1_TESTBUS_LOW_POR_RMSK                                                                    0xffffffff
#define HWIO_TCL_R1_TESTBUS_LOW_ATTR                                                                                     0x1
#define HWIO_TCL_R1_TESTBUS_LOW_IN(x)            \
                in_dword(HWIO_TCL_R1_TESTBUS_LOW_ADDR(x))
#define HWIO_TCL_R1_TESTBUS_LOW_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_TESTBUS_LOW_ADDR(x), m)
#define HWIO_TCL_R1_TESTBUS_LOW_VAL_BMSK                                                                    0xffffffff
#define HWIO_TCL_R1_TESTBUS_LOW_VAL_SHFT                                                                             0

#define HWIO_TCL_R1_TESTBUS_HIGH_ADDR(x)                                                                    ((x) + 0x1034)
#define HWIO_TCL_R1_TESTBUS_HIGH_PHYS(x)                                                                    ((x) + 0x1034)
#define HWIO_TCL_R1_TESTBUS_HIGH_OFFS                                                                       (0x1034)
#define HWIO_TCL_R1_TESTBUS_HIGH_RMSK                                                                             0xff
#define HWIO_TCL_R1_TESTBUS_HIGH_POR                                                                        0x00000000
#define HWIO_TCL_R1_TESTBUS_HIGH_POR_RMSK                                                                   0xffffffff
#define HWIO_TCL_R1_TESTBUS_HIGH_ATTR                                                                                    0x1
#define HWIO_TCL_R1_TESTBUS_HIGH_IN(x)            \
                in_dword(HWIO_TCL_R1_TESTBUS_HIGH_ADDR(x))
#define HWIO_TCL_R1_TESTBUS_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_TESTBUS_HIGH_ADDR(x), m)
#define HWIO_TCL_R1_TESTBUS_HIGH_VAL_BMSK                                                                         0xff
#define HWIO_TCL_R1_TESTBUS_HIGH_VAL_SHFT                                                                            0

#define HWIO_TCL_R1_EVENTMASK_IX_0_ADDR(x)                                                                  ((x) + 0x1038)
#define HWIO_TCL_R1_EVENTMASK_IX_0_PHYS(x)                                                                  ((x) + 0x1038)
#define HWIO_TCL_R1_EVENTMASK_IX_0_OFFS                                                                     (0x1038)
#define HWIO_TCL_R1_EVENTMASK_IX_0_RMSK                                                                     0xffffffff
#define HWIO_TCL_R1_EVENTMASK_IX_0_POR                                                                      0x0000ffff
#define HWIO_TCL_R1_EVENTMASK_IX_0_POR_RMSK                                                                 0xffffffff
#define HWIO_TCL_R1_EVENTMASK_IX_0_ATTR                                                                                  0x3
#define HWIO_TCL_R1_EVENTMASK_IX_0_IN(x)            \
                in_dword(HWIO_TCL_R1_EVENTMASK_IX_0_ADDR(x))
#define HWIO_TCL_R1_EVENTMASK_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_EVENTMASK_IX_0_ADDR(x), m)
#define HWIO_TCL_R1_EVENTMASK_IX_0_OUT(x, v)            \
                out_dword(HWIO_TCL_R1_EVENTMASK_IX_0_ADDR(x),v)
#define HWIO_TCL_R1_EVENTMASK_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R1_EVENTMASK_IX_0_ADDR(x),m,v,HWIO_TCL_R1_EVENTMASK_IX_0_IN(x))
#define HWIO_TCL_R1_EVENTMASK_IX_0_VAL_BMSK                                                                 0xffffffff
#define HWIO_TCL_R1_EVENTMASK_IX_0_VAL_SHFT                                                                          0

#define HWIO_TCL_R1_EVENTMASK_IX_1_ADDR(x)                                                                  ((x) + 0x103c)
#define HWIO_TCL_R1_EVENTMASK_IX_1_PHYS(x)                                                                  ((x) + 0x103c)
#define HWIO_TCL_R1_EVENTMASK_IX_1_OFFS                                                                     (0x103c)
#define HWIO_TCL_R1_EVENTMASK_IX_1_RMSK                                                                     0xffffffff
#define HWIO_TCL_R1_EVENTMASK_IX_1_POR                                                                      0x0000ffff
#define HWIO_TCL_R1_EVENTMASK_IX_1_POR_RMSK                                                                 0xffffffff
#define HWIO_TCL_R1_EVENTMASK_IX_1_ATTR                                                                                  0x3
#define HWIO_TCL_R1_EVENTMASK_IX_1_IN(x)            \
                in_dword(HWIO_TCL_R1_EVENTMASK_IX_1_ADDR(x))
#define HWIO_TCL_R1_EVENTMASK_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_EVENTMASK_IX_1_ADDR(x), m)
#define HWIO_TCL_R1_EVENTMASK_IX_1_OUT(x, v)            \
                out_dword(HWIO_TCL_R1_EVENTMASK_IX_1_ADDR(x),v)
#define HWIO_TCL_R1_EVENTMASK_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R1_EVENTMASK_IX_1_ADDR(x),m,v,HWIO_TCL_R1_EVENTMASK_IX_1_IN(x))
#define HWIO_TCL_R1_EVENTMASK_IX_1_VAL_BMSK                                                                 0xffffffff
#define HWIO_TCL_R1_EVENTMASK_IX_1_VAL_SHFT                                                                          0

#define HWIO_TCL_R1_EVENTMASK_IX_2_ADDR(x)                                                                  ((x) + 0x1040)
#define HWIO_TCL_R1_EVENTMASK_IX_2_PHYS(x)                                                                  ((x) + 0x1040)
#define HWIO_TCL_R1_EVENTMASK_IX_2_OFFS                                                                     (0x1040)
#define HWIO_TCL_R1_EVENTMASK_IX_2_RMSK                                                                     0xffffffff
#define HWIO_TCL_R1_EVENTMASK_IX_2_POR                                                                      0x0000ffff
#define HWIO_TCL_R1_EVENTMASK_IX_2_POR_RMSK                                                                 0xffffffff
#define HWIO_TCL_R1_EVENTMASK_IX_2_ATTR                                                                                  0x3
#define HWIO_TCL_R1_EVENTMASK_IX_2_IN(x)            \
                in_dword(HWIO_TCL_R1_EVENTMASK_IX_2_ADDR(x))
#define HWIO_TCL_R1_EVENTMASK_IX_2_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_EVENTMASK_IX_2_ADDR(x), m)
#define HWIO_TCL_R1_EVENTMASK_IX_2_OUT(x, v)            \
                out_dword(HWIO_TCL_R1_EVENTMASK_IX_2_ADDR(x),v)
#define HWIO_TCL_R1_EVENTMASK_IX_2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R1_EVENTMASK_IX_2_ADDR(x),m,v,HWIO_TCL_R1_EVENTMASK_IX_2_IN(x))
#define HWIO_TCL_R1_EVENTMASK_IX_2_VAL_BMSK                                                                 0xffffffff
#define HWIO_TCL_R1_EVENTMASK_IX_2_VAL_SHFT                                                                          0

#define HWIO_TCL_R1_EVENTMASK_IX_3_ADDR(x)                                                                  ((x) + 0x1044)
#define HWIO_TCL_R1_EVENTMASK_IX_3_PHYS(x)                                                                  ((x) + 0x1044)
#define HWIO_TCL_R1_EVENTMASK_IX_3_OFFS                                                                     (0x1044)
#define HWIO_TCL_R1_EVENTMASK_IX_3_RMSK                                                                     0xffffffff
#define HWIO_TCL_R1_EVENTMASK_IX_3_POR                                                                      0x0000ffff
#define HWIO_TCL_R1_EVENTMASK_IX_3_POR_RMSK                                                                 0xffffffff
#define HWIO_TCL_R1_EVENTMASK_IX_3_ATTR                                                                                  0x3
#define HWIO_TCL_R1_EVENTMASK_IX_3_IN(x)            \
                in_dword(HWIO_TCL_R1_EVENTMASK_IX_3_ADDR(x))
#define HWIO_TCL_R1_EVENTMASK_IX_3_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_EVENTMASK_IX_3_ADDR(x), m)
#define HWIO_TCL_R1_EVENTMASK_IX_3_OUT(x, v)            \
                out_dword(HWIO_TCL_R1_EVENTMASK_IX_3_ADDR(x),v)
#define HWIO_TCL_R1_EVENTMASK_IX_3_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R1_EVENTMASK_IX_3_ADDR(x),m,v,HWIO_TCL_R1_EVENTMASK_IX_3_IN(x))
#define HWIO_TCL_R1_EVENTMASK_IX_3_VAL_BMSK                                                                 0xffffffff
#define HWIO_TCL_R1_EVENTMASK_IX_3_VAL_SHFT                                                                          0

#define HWIO_TCL_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDR(x)                                                       ((x) + 0x1048)
#define HWIO_TCL_R1_REG_ACCESS_EVENT_GEN_CTRL_PHYS(x)                                                       ((x) + 0x1048)
#define HWIO_TCL_R1_REG_ACCESS_EVENT_GEN_CTRL_OFFS                                                          (0x1048)
#define HWIO_TCL_R1_REG_ACCESS_EVENT_GEN_CTRL_RMSK                                                          0xffffffff
#define HWIO_TCL_R1_REG_ACCESS_EVENT_GEN_CTRL_POR                                                           0x7ffe0002
#define HWIO_TCL_R1_REG_ACCESS_EVENT_GEN_CTRL_POR_RMSK                                                      0xffffffff
#define HWIO_TCL_R1_REG_ACCESS_EVENT_GEN_CTRL_ATTR                                                                       0x3
#define HWIO_TCL_R1_REG_ACCESS_EVENT_GEN_CTRL_IN(x)            \
                in_dword(HWIO_TCL_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDR(x))
#define HWIO_TCL_R1_REG_ACCESS_EVENT_GEN_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDR(x), m)
#define HWIO_TCL_R1_REG_ACCESS_EVENT_GEN_CTRL_OUT(x, v)            \
                out_dword(HWIO_TCL_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDR(x),v)
#define HWIO_TCL_R1_REG_ACCESS_EVENT_GEN_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDR(x),m,v,HWIO_TCL_R1_REG_ACCESS_EVENT_GEN_CTRL_IN(x))
#define HWIO_TCL_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDRESS_RANGE_END_BMSK                                        0xfffe0000
#define HWIO_TCL_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDRESS_RANGE_END_SHFT                                                17
#define HWIO_TCL_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDRESS_RANGE_START_BMSK                                         0x1fffc
#define HWIO_TCL_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDRESS_RANGE_START_SHFT                                               2
#define HWIO_TCL_R1_REG_ACCESS_EVENT_GEN_CTRL_WRITE_ACCESS_REPORT_ENABLE_BMSK                                      0x2
#define HWIO_TCL_R1_REG_ACCESS_EVENT_GEN_CTRL_WRITE_ACCESS_REPORT_ENABLE_SHFT                                        1
#define HWIO_TCL_R1_REG_ACCESS_EVENT_GEN_CTRL_READ_ACCESS_REPORT_ENABLE_BMSK                                       0x1
#define HWIO_TCL_R1_REG_ACCESS_EVENT_GEN_CTRL_READ_ACCESS_REPORT_ENABLE_SHFT                                         0

#define HWIO_TCL_R1_SPARE_REGISTER_ADDR(x)                                                                  ((x) + 0x104c)
#define HWIO_TCL_R1_SPARE_REGISTER_PHYS(x)                                                                  ((x) + 0x104c)
#define HWIO_TCL_R1_SPARE_REGISTER_OFFS                                                                     (0x104c)
#define HWIO_TCL_R1_SPARE_REGISTER_RMSK                                                                     0xffffffff
#define HWIO_TCL_R1_SPARE_REGISTER_POR                                                                      0x00000000
#define HWIO_TCL_R1_SPARE_REGISTER_POR_RMSK                                                                 0xffffffff
#define HWIO_TCL_R1_SPARE_REGISTER_ATTR                                                                                  0x3
#define HWIO_TCL_R1_SPARE_REGISTER_IN(x)            \
                in_dword(HWIO_TCL_R1_SPARE_REGISTER_ADDR(x))
#define HWIO_TCL_R1_SPARE_REGISTER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_SPARE_REGISTER_ADDR(x), m)
#define HWIO_TCL_R1_SPARE_REGISTER_OUT(x, v)            \
                out_dword(HWIO_TCL_R1_SPARE_REGISTER_ADDR(x),v)
#define HWIO_TCL_R1_SPARE_REGISTER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R1_SPARE_REGISTER_ADDR(x),m,v,HWIO_TCL_R1_SPARE_REGISTER_IN(x))
#define HWIO_TCL_R1_SPARE_REGISTER_TCL_SPARE_FIELD_32_BMSK                                                  0xffffffff
#define HWIO_TCL_R1_SPARE_REGISTER_TCL_SPARE_FIELD_32_SHFT                                                           0

#define HWIO_TCL_R1_END_OF_TEST_CHECK_ADDR(x)                                                               ((x) + 0x1050)
#define HWIO_TCL_R1_END_OF_TEST_CHECK_PHYS(x)                                                               ((x) + 0x1050)
#define HWIO_TCL_R1_END_OF_TEST_CHECK_OFFS                                                                  (0x1050)
#define HWIO_TCL_R1_END_OF_TEST_CHECK_RMSK                                                                         0x1
#define HWIO_TCL_R1_END_OF_TEST_CHECK_POR                                                                   0x00000000
#define HWIO_TCL_R1_END_OF_TEST_CHECK_POR_RMSK                                                              0xffffffff
#define HWIO_TCL_R1_END_OF_TEST_CHECK_ATTR                                                                               0x3
#define HWIO_TCL_R1_END_OF_TEST_CHECK_IN(x)            \
                in_dword(HWIO_TCL_R1_END_OF_TEST_CHECK_ADDR(x))
#define HWIO_TCL_R1_END_OF_TEST_CHECK_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_END_OF_TEST_CHECK_ADDR(x), m)
#define HWIO_TCL_R1_END_OF_TEST_CHECK_OUT(x, v)            \
                out_dword(HWIO_TCL_R1_END_OF_TEST_CHECK_ADDR(x),v)
#define HWIO_TCL_R1_END_OF_TEST_CHECK_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R1_END_OF_TEST_CHECK_ADDR(x),m,v,HWIO_TCL_R1_END_OF_TEST_CHECK_IN(x))
#define HWIO_TCL_R1_END_OF_TEST_CHECK_END_OF_TEST_SELF_CHECK_BMSK                                                  0x1
#define HWIO_TCL_R1_END_OF_TEST_CHECK_END_OF_TEST_SELF_CHECK_SHFT                                                    0

#define HWIO_TCL_R1_ASE_END_OF_TEST_CHECK_ADDR(x)                                                           ((x) + 0x1054)
#define HWIO_TCL_R1_ASE_END_OF_TEST_CHECK_PHYS(x)                                                           ((x) + 0x1054)
#define HWIO_TCL_R1_ASE_END_OF_TEST_CHECK_OFFS                                                              (0x1054)
#define HWIO_TCL_R1_ASE_END_OF_TEST_CHECK_RMSK                                                                     0x1
#define HWIO_TCL_R1_ASE_END_OF_TEST_CHECK_POR                                                               0x00000000
#define HWIO_TCL_R1_ASE_END_OF_TEST_CHECK_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R1_ASE_END_OF_TEST_CHECK_ATTR                                                                           0x3
#define HWIO_TCL_R1_ASE_END_OF_TEST_CHECK_IN(x)            \
                in_dword(HWIO_TCL_R1_ASE_END_OF_TEST_CHECK_ADDR(x))
#define HWIO_TCL_R1_ASE_END_OF_TEST_CHECK_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_ASE_END_OF_TEST_CHECK_ADDR(x), m)
#define HWIO_TCL_R1_ASE_END_OF_TEST_CHECK_OUT(x, v)            \
                out_dword(HWIO_TCL_R1_ASE_END_OF_TEST_CHECK_ADDR(x),v)
#define HWIO_TCL_R1_ASE_END_OF_TEST_CHECK_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R1_ASE_END_OF_TEST_CHECK_ADDR(x),m,v,HWIO_TCL_R1_ASE_END_OF_TEST_CHECK_IN(x))
#define HWIO_TCL_R1_ASE_END_OF_TEST_CHECK_END_OF_TEST_SELF_CHECK_BMSK                                              0x1
#define HWIO_TCL_R1_ASE_END_OF_TEST_CHECK_END_OF_TEST_SELF_CHECK_SHFT                                                0

#define HWIO_TCL_R1_ASE_DEBUG_CLEAR_COUNTERS_ADDR(x)                                                        ((x) + 0x1058)
#define HWIO_TCL_R1_ASE_DEBUG_CLEAR_COUNTERS_PHYS(x)                                                        ((x) + 0x1058)
#define HWIO_TCL_R1_ASE_DEBUG_CLEAR_COUNTERS_OFFS                                                           (0x1058)
#define HWIO_TCL_R1_ASE_DEBUG_CLEAR_COUNTERS_RMSK                                                                  0x1
#define HWIO_TCL_R1_ASE_DEBUG_CLEAR_COUNTERS_POR                                                            0x00000000
#define HWIO_TCL_R1_ASE_DEBUG_CLEAR_COUNTERS_POR_RMSK                                                       0xffffffff
#define HWIO_TCL_R1_ASE_DEBUG_CLEAR_COUNTERS_ATTR                                                                        0x3
#define HWIO_TCL_R1_ASE_DEBUG_CLEAR_COUNTERS_IN(x)            \
                in_dword(HWIO_TCL_R1_ASE_DEBUG_CLEAR_COUNTERS_ADDR(x))
#define HWIO_TCL_R1_ASE_DEBUG_CLEAR_COUNTERS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_ASE_DEBUG_CLEAR_COUNTERS_ADDR(x), m)
#define HWIO_TCL_R1_ASE_DEBUG_CLEAR_COUNTERS_OUT(x, v)            \
                out_dword(HWIO_TCL_R1_ASE_DEBUG_CLEAR_COUNTERS_ADDR(x),v)
#define HWIO_TCL_R1_ASE_DEBUG_CLEAR_COUNTERS_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R1_ASE_DEBUG_CLEAR_COUNTERS_ADDR(x),m,v,HWIO_TCL_R1_ASE_DEBUG_CLEAR_COUNTERS_IN(x))
#define HWIO_TCL_R1_ASE_DEBUG_CLEAR_COUNTERS_EN_BMSK                                                               0x1
#define HWIO_TCL_R1_ASE_DEBUG_CLEAR_COUNTERS_EN_SHFT                                                                 0

#define HWIO_TCL_R1_ASE_DEBUG_NUM_CACHE_HITS_COUNTER_ADDR(x)                                                ((x) + 0x105c)
#define HWIO_TCL_R1_ASE_DEBUG_NUM_CACHE_HITS_COUNTER_PHYS(x)                                                ((x) + 0x105c)
#define HWIO_TCL_R1_ASE_DEBUG_NUM_CACHE_HITS_COUNTER_OFFS                                                   (0x105c)
#define HWIO_TCL_R1_ASE_DEBUG_NUM_CACHE_HITS_COUNTER_RMSK                                                   0xffffffff
#define HWIO_TCL_R1_ASE_DEBUG_NUM_CACHE_HITS_COUNTER_POR                                                    0x00000000
#define HWIO_TCL_R1_ASE_DEBUG_NUM_CACHE_HITS_COUNTER_POR_RMSK                                               0xffffffff
#define HWIO_TCL_R1_ASE_DEBUG_NUM_CACHE_HITS_COUNTER_ATTR                                                                0x1
#define HWIO_TCL_R1_ASE_DEBUG_NUM_CACHE_HITS_COUNTER_IN(x)            \
                in_dword(HWIO_TCL_R1_ASE_DEBUG_NUM_CACHE_HITS_COUNTER_ADDR(x))
#define HWIO_TCL_R1_ASE_DEBUG_NUM_CACHE_HITS_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_ASE_DEBUG_NUM_CACHE_HITS_COUNTER_ADDR(x), m)
#define HWIO_TCL_R1_ASE_DEBUG_NUM_CACHE_HITS_COUNTER_VAL_BMSK                                               0xffffffff
#define HWIO_TCL_R1_ASE_DEBUG_NUM_CACHE_HITS_COUNTER_VAL_SHFT                                                        0

#define HWIO_TCL_R1_ASE_DEBUG_NUM_SEARCHES_COUNTER_ADDR(x)                                                  ((x) + 0x1060)
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SEARCHES_COUNTER_PHYS(x)                                                  ((x) + 0x1060)
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SEARCHES_COUNTER_OFFS                                                     (0x1060)
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SEARCHES_COUNTER_RMSK                                                     0xffffffff
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SEARCHES_COUNTER_POR                                                      0x00000000
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SEARCHES_COUNTER_POR_RMSK                                                 0xffffffff
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SEARCHES_COUNTER_ATTR                                                                  0x1
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SEARCHES_COUNTER_IN(x)            \
                in_dword(HWIO_TCL_R1_ASE_DEBUG_NUM_SEARCHES_COUNTER_ADDR(x))
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SEARCHES_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_ASE_DEBUG_NUM_SEARCHES_COUNTER_ADDR(x), m)
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SEARCHES_COUNTER_VAL_BMSK                                                 0xffffffff
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SEARCHES_COUNTER_VAL_SHFT                                                          0

#define HWIO_TCL_R1_ASE_DEBUG_NUM_SKIP_SEARCHES_COUNTER_ADDR(x)                                             ((x) + 0x1064)
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SKIP_SEARCHES_COUNTER_PHYS(x)                                             ((x) + 0x1064)
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SKIP_SEARCHES_COUNTER_OFFS                                                (0x1064)
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SKIP_SEARCHES_COUNTER_RMSK                                                0xffffffff
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SKIP_SEARCHES_COUNTER_POR                                                 0x00000000
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SKIP_SEARCHES_COUNTER_POR_RMSK                                            0xffffffff
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SKIP_SEARCHES_COUNTER_ATTR                                                             0x1
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SKIP_SEARCHES_COUNTER_IN(x)            \
                in_dword(HWIO_TCL_R1_ASE_DEBUG_NUM_SKIP_SEARCHES_COUNTER_ADDR(x))
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SKIP_SEARCHES_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_ASE_DEBUG_NUM_SKIP_SEARCHES_COUNTER_ADDR(x), m)
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SKIP_SEARCHES_COUNTER_VAL_BMSK                                            0xffffffff
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SKIP_SEARCHES_COUNTER_VAL_SHFT                                                     0

#define HWIO_TCL_R1_ASE_DEBUG_CACHE_OCCUPANCY_COUNTER_ADDR(x)                                               ((x) + 0x1068)
#define HWIO_TCL_R1_ASE_DEBUG_CACHE_OCCUPANCY_COUNTER_PHYS(x)                                               ((x) + 0x1068)
#define HWIO_TCL_R1_ASE_DEBUG_CACHE_OCCUPANCY_COUNTER_OFFS                                                  (0x1068)
#define HWIO_TCL_R1_ASE_DEBUG_CACHE_OCCUPANCY_COUNTER_RMSK                                                     0xfffff
#define HWIO_TCL_R1_ASE_DEBUG_CACHE_OCCUPANCY_COUNTER_POR                                                   0x00000000
#define HWIO_TCL_R1_ASE_DEBUG_CACHE_OCCUPANCY_COUNTER_POR_RMSK                                              0xffffffff
#define HWIO_TCL_R1_ASE_DEBUG_CACHE_OCCUPANCY_COUNTER_ATTR                                                               0x1
#define HWIO_TCL_R1_ASE_DEBUG_CACHE_OCCUPANCY_COUNTER_IN(x)            \
                in_dword(HWIO_TCL_R1_ASE_DEBUG_CACHE_OCCUPANCY_COUNTER_ADDR(x))
#define HWIO_TCL_R1_ASE_DEBUG_CACHE_OCCUPANCY_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_ASE_DEBUG_CACHE_OCCUPANCY_COUNTER_ADDR(x), m)
#define HWIO_TCL_R1_ASE_DEBUG_CACHE_OCCUPANCY_COUNTER_PEAK_BMSK                                                0xffc00
#define HWIO_TCL_R1_ASE_DEBUG_CACHE_OCCUPANCY_COUNTER_PEAK_SHFT                                                     10
#define HWIO_TCL_R1_ASE_DEBUG_CACHE_OCCUPANCY_COUNTER_CURR_BMSK                                                  0x3ff
#define HWIO_TCL_R1_ASE_DEBUG_CACHE_OCCUPANCY_COUNTER_CURR_SHFT                                                      0

#define HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_ADDR(x)                                                   ((x) + 0x106c)
#define HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_PHYS(x)                                                   ((x) + 0x106c)
#define HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_OFFS                                                      (0x106c)
#define HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_RMSK                                                       0x3ffffff
#define HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_POR                                                       0x00000000
#define HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_POR_RMSK                                                  0xffffffff
#define HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_ATTR                                                                   0x1
#define HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_IN(x)            \
                in_dword(HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_ADDR(x))
#define HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_ADDR(x), m)
#define HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_SQUARE_OCCUPANCY_BMSK                                      0x3fffc00
#define HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_SQUARE_OCCUPANCY_SHFT                                             10
#define HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_PEAK_NUM_SEARCH_PENDING_BMSK                                   0x3e0
#define HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_PEAK_NUM_SEARCH_PENDING_SHFT                                       5
#define HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_NUM_SEARCH_PENDING_BMSK                                         0x1f
#define HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_NUM_SEARCH_PENDING_SHFT                                            0

#define HWIO_TCL_R1_ASE_DEBUG_NUM_CACHE_HITS_COUNTER_1_ADDR(x)                                              ((x) + 0x1070)
#define HWIO_TCL_R1_ASE_DEBUG_NUM_CACHE_HITS_COUNTER_1_PHYS(x)                                              ((x) + 0x1070)
#define HWIO_TCL_R1_ASE_DEBUG_NUM_CACHE_HITS_COUNTER_1_OFFS                                                 (0x1070)
#define HWIO_TCL_R1_ASE_DEBUG_NUM_CACHE_HITS_COUNTER_1_RMSK                                                 0xffffffff
#define HWIO_TCL_R1_ASE_DEBUG_NUM_CACHE_HITS_COUNTER_1_POR                                                  0x00000000
#define HWIO_TCL_R1_ASE_DEBUG_NUM_CACHE_HITS_COUNTER_1_POR_RMSK                                             0xffffffff
#define HWIO_TCL_R1_ASE_DEBUG_NUM_CACHE_HITS_COUNTER_1_ATTR                                                              0x1
#define HWIO_TCL_R1_ASE_DEBUG_NUM_CACHE_HITS_COUNTER_1_IN(x)            \
                in_dword(HWIO_TCL_R1_ASE_DEBUG_NUM_CACHE_HITS_COUNTER_1_ADDR(x))
#define HWIO_TCL_R1_ASE_DEBUG_NUM_CACHE_HITS_COUNTER_1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_ASE_DEBUG_NUM_CACHE_HITS_COUNTER_1_ADDR(x), m)
#define HWIO_TCL_R1_ASE_DEBUG_NUM_CACHE_HITS_COUNTER_1_VAL_BMSK                                             0xffffffff
#define HWIO_TCL_R1_ASE_DEBUG_NUM_CACHE_HITS_COUNTER_1_VAL_SHFT                                                      0

#define HWIO_TCL_R1_ASE_DEBUG_NUM_SEARCHES_COUNTER_1_ADDR(x)                                                ((x) + 0x1074)
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SEARCHES_COUNTER_1_PHYS(x)                                                ((x) + 0x1074)
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SEARCHES_COUNTER_1_OFFS                                                   (0x1074)
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SEARCHES_COUNTER_1_RMSK                                                   0xffffffff
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SEARCHES_COUNTER_1_POR                                                    0x00000000
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SEARCHES_COUNTER_1_POR_RMSK                                               0xffffffff
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SEARCHES_COUNTER_1_ATTR                                                                0x1
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SEARCHES_COUNTER_1_IN(x)            \
                in_dword(HWIO_TCL_R1_ASE_DEBUG_NUM_SEARCHES_COUNTER_1_ADDR(x))
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SEARCHES_COUNTER_1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_ASE_DEBUG_NUM_SEARCHES_COUNTER_1_ADDR(x), m)
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SEARCHES_COUNTER_1_VAL_BMSK                                               0xffffffff
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SEARCHES_COUNTER_1_VAL_SHFT                                                        0

#define HWIO_TCL_R1_ASE_DEBUG_NUM_SKIP_SEARCHES_COUNTER_1_ADDR(x)                                           ((x) + 0x1078)
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SKIP_SEARCHES_COUNTER_1_PHYS(x)                                           ((x) + 0x1078)
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SKIP_SEARCHES_COUNTER_1_OFFS                                              (0x1078)
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SKIP_SEARCHES_COUNTER_1_RMSK                                              0xffffffff
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SKIP_SEARCHES_COUNTER_1_POR                                               0x00000000
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SKIP_SEARCHES_COUNTER_1_POR_RMSK                                          0xffffffff
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SKIP_SEARCHES_COUNTER_1_ATTR                                                           0x1
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SKIP_SEARCHES_COUNTER_1_IN(x)            \
                in_dword(HWIO_TCL_R1_ASE_DEBUG_NUM_SKIP_SEARCHES_COUNTER_1_ADDR(x))
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SKIP_SEARCHES_COUNTER_1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_ASE_DEBUG_NUM_SKIP_SEARCHES_COUNTER_1_ADDR(x), m)
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SKIP_SEARCHES_COUNTER_1_VAL_BMSK                                          0xffffffff
#define HWIO_TCL_R1_ASE_DEBUG_NUM_SKIP_SEARCHES_COUNTER_1_VAL_SHFT                                                   0

#define HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_1_ADDR(x)                                                 ((x) + 0x107c)
#define HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_1_PHYS(x)                                                 ((x) + 0x107c)
#define HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_1_OFFS                                                    (0x107c)
#define HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_1_RMSK                                                         0x3ff
#define HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_1_POR                                                     0x00000000
#define HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_1_POR_RMSK                                                0xffffffff
#define HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_1_ATTR                                                                 0x1
#define HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_1_IN(x)            \
                in_dword(HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_1_ADDR(x))
#define HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_1_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_1_ADDR(x), m)
#define HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_1_PEAK_NUM_SEARCH_PENDING_BMSK                                 0x3e0
#define HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_1_PEAK_NUM_SEARCH_PENDING_SHFT                                     5
#define HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_1_NUM_SEARCH_PENDING_BMSK                                       0x1f
#define HWIO_TCL_R1_ASE_DEBUG_SEARCH_STAT_COUNTER_1_NUM_SEARCH_PENDING_SHFT                                          0

#define HWIO_TCL_R1_ASE_SM_STATES_ADDR(x)                                                                   ((x) + 0x1080)
#define HWIO_TCL_R1_ASE_SM_STATES_PHYS(x)                                                                   ((x) + 0x1080)
#define HWIO_TCL_R1_ASE_SM_STATES_OFFS                                                                      (0x1080)
#define HWIO_TCL_R1_ASE_SM_STATES_RMSK                                                                        0x3fff0f
#define HWIO_TCL_R1_ASE_SM_STATES_POR                                                                       0x00000000
#define HWIO_TCL_R1_ASE_SM_STATES_POR_RMSK                                                                  0xffffffff
#define HWIO_TCL_R1_ASE_SM_STATES_ATTR                                                                                   0x1
#define HWIO_TCL_R1_ASE_SM_STATES_IN(x)            \
                in_dword(HWIO_TCL_R1_ASE_SM_STATES_ADDR(x))
#define HWIO_TCL_R1_ASE_SM_STATES_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_ASE_SM_STATES_ADDR(x), m)
#define HWIO_TCL_R1_ASE_SM_STATES_GSE_CTRL_STATE_BMSK                                                         0x300000
#define HWIO_TCL_R1_ASE_SM_STATES_GSE_CTRL_STATE_SHFT                                                               20
#define HWIO_TCL_R1_ASE_SM_STATES_CACHE_CHK_STATE_BMSK                                                         0xc0000
#define HWIO_TCL_R1_ASE_SM_STATES_CACHE_CHK_STATE_SHFT                                                              18
#define HWIO_TCL_R1_ASE_SM_STATES_MEM_ISS1_STATE_BMSK                                                          0x30000
#define HWIO_TCL_R1_ASE_SM_STATES_MEM_ISS1_STATE_SHFT                                                               16
#define HWIO_TCL_R1_ASE_SM_STATES_MEM_ISS2_STATE_BMSK                                                           0xc000
#define HWIO_TCL_R1_ASE_SM_STATES_MEM_ISS2_STATE_SHFT                                                               14
#define HWIO_TCL_R1_ASE_SM_STATES_MEM_RESP1_STATE_BMSK                                                          0x3800
#define HWIO_TCL_R1_ASE_SM_STATES_MEM_RESP1_STATE_SHFT                                                              11
#define HWIO_TCL_R1_ASE_SM_STATES_MEM_RESP2_STATE_BMSK                                                           0x700
#define HWIO_TCL_R1_ASE_SM_STATES_MEM_RESP2_STATE_SHFT                                                               8
#define HWIO_TCL_R1_ASE_SM_STATES_APP_RETURN_STATE_BMSK                                                            0xf
#define HWIO_TCL_R1_ASE_SM_STATES_APP_RETURN_STATE_SHFT                                                              0

#define HWIO_TCL_R1_ASE_CACHE_DEBUG_ADDR(x)                                                                 ((x) + 0x1084)
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_PHYS(x)                                                                 ((x) + 0x1084)
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_OFFS                                                                    (0x1084)
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_RMSK                                                                         0x3ff
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_POR                                                                     0x00000000
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_ATTR                                                                                 0x3
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_IN(x)            \
                in_dword(HWIO_TCL_R1_ASE_CACHE_DEBUG_ADDR(x))
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_ASE_CACHE_DEBUG_ADDR(x), m)
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_OUT(x, v)            \
                out_dword(HWIO_TCL_R1_ASE_CACHE_DEBUG_ADDR(x),v)
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R1_ASE_CACHE_DEBUG_ADDR(x),m,v,HWIO_TCL_R1_ASE_CACHE_DEBUG_IN(x))
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_READ_IDX_BMSK                                                                0x3ff
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_READ_IDX_SHFT                                                                    0

#define HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_STATS_ADDR(x)                                                     ((x) + 0x1088)
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_STATS_PHYS(x)                                                     ((x) + 0x1088)
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_STATS_OFFS                                                        (0x1088)
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_STATS_RMSK                                                          0x7fffff
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_STATS_POR                                                         0x00000000
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_STATS_POR_RMSK                                                    0xffffffff
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_STATS_ATTR                                                                     0x1
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_STATS_IN(x)            \
                in_dword(HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_STATS_ADDR(x))
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_STATS_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_STATS_ADDR(x), m)
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_STATS_GST_IDX_BMSK                                                  0x7ffff8
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_STATS_GST_IDX_SHFT                                                         3
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_STATS_CACHE_ONLY_BMSK                                                    0x4
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_STATS_CACHE_ONLY_SHFT                                                      2
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_STATS_DIRTY_BMSK                                                         0x2
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_STATS_DIRTY_SHFT                                                           1
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_STATS_VALID_BMSK                                                         0x1
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_STATS_VALID_SHFT                                                           0

#define HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_n_ADDR(base,n)                                                    ((base) + 0X108C + (0x4*(n)))
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_n_PHYS(base,n)                                                    ((base) + 0X108C + (0x4*(n)))
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_n_OFFS(n)                                                         (0X108C + (0x4*(n)))
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_n_RMSK                                                            0xffffffff
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_n_MAXn                                                                    31
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_n_POR                                                             0x00000000
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_n_POR_RMSK                                                        0xffffffff
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_n_ATTR                                                                         0x1
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_n_INI(base,n)                \
                in_dword_masked(HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_n_ADDR(base,n), HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_n_RMSK)
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_n_INMI(base,n,mask)        \
                in_dword_masked(HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_n_ADDR(base,n), mask)
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_n_VAL_BMSK                                                        0xffffffff
#define HWIO_TCL_R1_ASE_CACHE_DEBUG_ENTRY_n_VAL_SHFT                                                                 0

#define HWIO_TCL_R2_SW2TCL1_RING_HP_ADDR(x)                                                                 ((x) + 0x2000)
#define HWIO_TCL_R2_SW2TCL1_RING_HP_PHYS(x)                                                                 ((x) + 0x2000)
#define HWIO_TCL_R2_SW2TCL1_RING_HP_OFFS                                                                    (0x2000)
#define HWIO_TCL_R2_SW2TCL1_RING_HP_RMSK                                                                       0xfffff
#define HWIO_TCL_R2_SW2TCL1_RING_HP_POR                                                                     0x00000000
#define HWIO_TCL_R2_SW2TCL1_RING_HP_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R2_SW2TCL1_RING_HP_ATTR                                                                                 0x3
#define HWIO_TCL_R2_SW2TCL1_RING_HP_IN(x)            \
                in_dword(HWIO_TCL_R2_SW2TCL1_RING_HP_ADDR(x))
#define HWIO_TCL_R2_SW2TCL1_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_SW2TCL1_RING_HP_ADDR(x), m)
#define HWIO_TCL_R2_SW2TCL1_RING_HP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_SW2TCL1_RING_HP_ADDR(x),v)
#define HWIO_TCL_R2_SW2TCL1_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_SW2TCL1_RING_HP_ADDR(x),m,v,HWIO_TCL_R2_SW2TCL1_RING_HP_IN(x))
#define HWIO_TCL_R2_SW2TCL1_RING_HP_HEAD_PTR_BMSK                                                              0xfffff
#define HWIO_TCL_R2_SW2TCL1_RING_HP_HEAD_PTR_SHFT                                                                    0

#define HWIO_TCL_R2_SW2TCL1_RING_TP_ADDR(x)                                                                 ((x) + 0x2004)
#define HWIO_TCL_R2_SW2TCL1_RING_TP_PHYS(x)                                                                 ((x) + 0x2004)
#define HWIO_TCL_R2_SW2TCL1_RING_TP_OFFS                                                                    (0x2004)
#define HWIO_TCL_R2_SW2TCL1_RING_TP_RMSK                                                                       0xfffff
#define HWIO_TCL_R2_SW2TCL1_RING_TP_POR                                                                     0x00000000
#define HWIO_TCL_R2_SW2TCL1_RING_TP_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R2_SW2TCL1_RING_TP_ATTR                                                                                 0x3
#define HWIO_TCL_R2_SW2TCL1_RING_TP_IN(x)            \
                in_dword(HWIO_TCL_R2_SW2TCL1_RING_TP_ADDR(x))
#define HWIO_TCL_R2_SW2TCL1_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_SW2TCL1_RING_TP_ADDR(x), m)
#define HWIO_TCL_R2_SW2TCL1_RING_TP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_SW2TCL1_RING_TP_ADDR(x),v)
#define HWIO_TCL_R2_SW2TCL1_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_SW2TCL1_RING_TP_ADDR(x),m,v,HWIO_TCL_R2_SW2TCL1_RING_TP_IN(x))
#define HWIO_TCL_R2_SW2TCL1_RING_TP_TAIL_PTR_BMSK                                                              0xfffff
#define HWIO_TCL_R2_SW2TCL1_RING_TP_TAIL_PTR_SHFT                                                                    0

#define HWIO_TCL_R2_SW2TCL2_RING_HP_ADDR(x)                                                                 ((x) + 0x2008)
#define HWIO_TCL_R2_SW2TCL2_RING_HP_PHYS(x)                                                                 ((x) + 0x2008)
#define HWIO_TCL_R2_SW2TCL2_RING_HP_OFFS                                                                    (0x2008)
#define HWIO_TCL_R2_SW2TCL2_RING_HP_RMSK                                                                       0xfffff
#define HWIO_TCL_R2_SW2TCL2_RING_HP_POR                                                                     0x00000000
#define HWIO_TCL_R2_SW2TCL2_RING_HP_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R2_SW2TCL2_RING_HP_ATTR                                                                                 0x3
#define HWIO_TCL_R2_SW2TCL2_RING_HP_IN(x)            \
                in_dword(HWIO_TCL_R2_SW2TCL2_RING_HP_ADDR(x))
#define HWIO_TCL_R2_SW2TCL2_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_SW2TCL2_RING_HP_ADDR(x), m)
#define HWIO_TCL_R2_SW2TCL2_RING_HP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_SW2TCL2_RING_HP_ADDR(x),v)
#define HWIO_TCL_R2_SW2TCL2_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_SW2TCL2_RING_HP_ADDR(x),m,v,HWIO_TCL_R2_SW2TCL2_RING_HP_IN(x))
#define HWIO_TCL_R2_SW2TCL2_RING_HP_HEAD_PTR_BMSK                                                              0xfffff
#define HWIO_TCL_R2_SW2TCL2_RING_HP_HEAD_PTR_SHFT                                                                    0

#define HWIO_TCL_R2_SW2TCL2_RING_TP_ADDR(x)                                                                 ((x) + 0x200c)
#define HWIO_TCL_R2_SW2TCL2_RING_TP_PHYS(x)                                                                 ((x) + 0x200c)
#define HWIO_TCL_R2_SW2TCL2_RING_TP_OFFS                                                                    (0x200c)
#define HWIO_TCL_R2_SW2TCL2_RING_TP_RMSK                                                                       0xfffff
#define HWIO_TCL_R2_SW2TCL2_RING_TP_POR                                                                     0x00000000
#define HWIO_TCL_R2_SW2TCL2_RING_TP_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R2_SW2TCL2_RING_TP_ATTR                                                                                 0x3
#define HWIO_TCL_R2_SW2TCL2_RING_TP_IN(x)            \
                in_dword(HWIO_TCL_R2_SW2TCL2_RING_TP_ADDR(x))
#define HWIO_TCL_R2_SW2TCL2_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_SW2TCL2_RING_TP_ADDR(x), m)
#define HWIO_TCL_R2_SW2TCL2_RING_TP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_SW2TCL2_RING_TP_ADDR(x),v)
#define HWIO_TCL_R2_SW2TCL2_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_SW2TCL2_RING_TP_ADDR(x),m,v,HWIO_TCL_R2_SW2TCL2_RING_TP_IN(x))
#define HWIO_TCL_R2_SW2TCL2_RING_TP_TAIL_PTR_BMSK                                                              0xfffff
#define HWIO_TCL_R2_SW2TCL2_RING_TP_TAIL_PTR_SHFT                                                                    0

#define HWIO_TCL_R2_SW2TCL3_RING_HP_ADDR(x)                                                                 ((x) + 0x2010)
#define HWIO_TCL_R2_SW2TCL3_RING_HP_PHYS(x)                                                                 ((x) + 0x2010)
#define HWIO_TCL_R2_SW2TCL3_RING_HP_OFFS                                                                    (0x2010)
#define HWIO_TCL_R2_SW2TCL3_RING_HP_RMSK                                                                       0xfffff
#define HWIO_TCL_R2_SW2TCL3_RING_HP_POR                                                                     0x00000000
#define HWIO_TCL_R2_SW2TCL3_RING_HP_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R2_SW2TCL3_RING_HP_ATTR                                                                                 0x3
#define HWIO_TCL_R2_SW2TCL3_RING_HP_IN(x)            \
                in_dword(HWIO_TCL_R2_SW2TCL3_RING_HP_ADDR(x))
#define HWIO_TCL_R2_SW2TCL3_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_SW2TCL3_RING_HP_ADDR(x), m)
#define HWIO_TCL_R2_SW2TCL3_RING_HP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_SW2TCL3_RING_HP_ADDR(x),v)
#define HWIO_TCL_R2_SW2TCL3_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_SW2TCL3_RING_HP_ADDR(x),m,v,HWIO_TCL_R2_SW2TCL3_RING_HP_IN(x))
#define HWIO_TCL_R2_SW2TCL3_RING_HP_HEAD_PTR_BMSK                                                              0xfffff
#define HWIO_TCL_R2_SW2TCL3_RING_HP_HEAD_PTR_SHFT                                                                    0

#define HWIO_TCL_R2_SW2TCL3_RING_TP_ADDR(x)                                                                 ((x) + 0x2014)
#define HWIO_TCL_R2_SW2TCL3_RING_TP_PHYS(x)                                                                 ((x) + 0x2014)
#define HWIO_TCL_R2_SW2TCL3_RING_TP_OFFS                                                                    (0x2014)
#define HWIO_TCL_R2_SW2TCL3_RING_TP_RMSK                                                                       0xfffff
#define HWIO_TCL_R2_SW2TCL3_RING_TP_POR                                                                     0x00000000
#define HWIO_TCL_R2_SW2TCL3_RING_TP_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R2_SW2TCL3_RING_TP_ATTR                                                                                 0x3
#define HWIO_TCL_R2_SW2TCL3_RING_TP_IN(x)            \
                in_dword(HWIO_TCL_R2_SW2TCL3_RING_TP_ADDR(x))
#define HWIO_TCL_R2_SW2TCL3_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_SW2TCL3_RING_TP_ADDR(x), m)
#define HWIO_TCL_R2_SW2TCL3_RING_TP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_SW2TCL3_RING_TP_ADDR(x),v)
#define HWIO_TCL_R2_SW2TCL3_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_SW2TCL3_RING_TP_ADDR(x),m,v,HWIO_TCL_R2_SW2TCL3_RING_TP_IN(x))
#define HWIO_TCL_R2_SW2TCL3_RING_TP_TAIL_PTR_BMSK                                                              0xfffff
#define HWIO_TCL_R2_SW2TCL3_RING_TP_TAIL_PTR_SHFT                                                                    0

#define HWIO_TCL_R2_SW2TCL4_RING_HP_ADDR(x)                                                                 ((x) + 0x2018)
#define HWIO_TCL_R2_SW2TCL4_RING_HP_PHYS(x)                                                                 ((x) + 0x2018)
#define HWIO_TCL_R2_SW2TCL4_RING_HP_OFFS                                                                    (0x2018)
#define HWIO_TCL_R2_SW2TCL4_RING_HP_RMSK                                                                       0xfffff
#define HWIO_TCL_R2_SW2TCL4_RING_HP_POR                                                                     0x00000000
#define HWIO_TCL_R2_SW2TCL4_RING_HP_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R2_SW2TCL4_RING_HP_ATTR                                                                                 0x3
#define HWIO_TCL_R2_SW2TCL4_RING_HP_IN(x)            \
                in_dword(HWIO_TCL_R2_SW2TCL4_RING_HP_ADDR(x))
#define HWIO_TCL_R2_SW2TCL4_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_SW2TCL4_RING_HP_ADDR(x), m)
#define HWIO_TCL_R2_SW2TCL4_RING_HP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_SW2TCL4_RING_HP_ADDR(x),v)
#define HWIO_TCL_R2_SW2TCL4_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_SW2TCL4_RING_HP_ADDR(x),m,v,HWIO_TCL_R2_SW2TCL4_RING_HP_IN(x))
#define HWIO_TCL_R2_SW2TCL4_RING_HP_HEAD_PTR_BMSK                                                              0xfffff
#define HWIO_TCL_R2_SW2TCL4_RING_HP_HEAD_PTR_SHFT                                                                    0

#define HWIO_TCL_R2_SW2TCL4_RING_TP_ADDR(x)                                                                 ((x) + 0x201c)
#define HWIO_TCL_R2_SW2TCL4_RING_TP_PHYS(x)                                                                 ((x) + 0x201c)
#define HWIO_TCL_R2_SW2TCL4_RING_TP_OFFS                                                                    (0x201c)
#define HWIO_TCL_R2_SW2TCL4_RING_TP_RMSK                                                                       0xfffff
#define HWIO_TCL_R2_SW2TCL4_RING_TP_POR                                                                     0x00000000
#define HWIO_TCL_R2_SW2TCL4_RING_TP_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R2_SW2TCL4_RING_TP_ATTR                                                                                 0x3
#define HWIO_TCL_R2_SW2TCL4_RING_TP_IN(x)            \
                in_dword(HWIO_TCL_R2_SW2TCL4_RING_TP_ADDR(x))
#define HWIO_TCL_R2_SW2TCL4_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_SW2TCL4_RING_TP_ADDR(x), m)
#define HWIO_TCL_R2_SW2TCL4_RING_TP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_SW2TCL4_RING_TP_ADDR(x),v)
#define HWIO_TCL_R2_SW2TCL4_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_SW2TCL4_RING_TP_ADDR(x),m,v,HWIO_TCL_R2_SW2TCL4_RING_TP_IN(x))
#define HWIO_TCL_R2_SW2TCL4_RING_TP_TAIL_PTR_BMSK                                                              0xfffff
#define HWIO_TCL_R2_SW2TCL4_RING_TP_TAIL_PTR_SHFT                                                                    0

#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_ADDR(x)                                                           ((x) + 0x2028)
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_PHYS(x)                                                           ((x) + 0x2028)
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_OFFS                                                              (0x2028)
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_RMSK                                                                 0xfffff
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_POR                                                               0x00000000
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_ATTR                                                                           0x3
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_IN(x)            \
                in_dword(HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_ADDR(x))
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_ADDR(x), m)
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_ADDR(x),v)
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_ADDR(x),m,v,HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_IN(x))
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_HEAD_PTR_BMSK                                                        0xfffff
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_HP_HEAD_PTR_SHFT                                                              0

#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_ADDR(x)                                                           ((x) + 0x202c)
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_PHYS(x)                                                           ((x) + 0x202c)
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_OFFS                                                              (0x202c)
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_RMSK                                                                 0xfffff
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_POR                                                               0x00000000
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_POR_RMSK                                                          0xffffffff
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_ATTR                                                                           0x3
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_IN(x)            \
                in_dword(HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_ADDR(x))
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_ADDR(x), m)
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_ADDR(x),v)
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_ADDR(x),m,v,HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_IN(x))
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_TAIL_PTR_BMSK                                                        0xfffff
#define HWIO_TCL_R2_SW2TCL_CREDIT_RING_TP_TAIL_PTR_SHFT                                                              0

#define HWIO_TCL_R2_FW2TCL1_RING_HP_ADDR(x)                                                                 ((x) + 0x2030)
#define HWIO_TCL_R2_FW2TCL1_RING_HP_PHYS(x)                                                                 ((x) + 0x2030)
#define HWIO_TCL_R2_FW2TCL1_RING_HP_OFFS                                                                    (0x2030)
#define HWIO_TCL_R2_FW2TCL1_RING_HP_RMSK                                                                        0xffff
#define HWIO_TCL_R2_FW2TCL1_RING_HP_POR                                                                     0x00000000
#define HWIO_TCL_R2_FW2TCL1_RING_HP_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R2_FW2TCL1_RING_HP_ATTR                                                                                 0x3
#define HWIO_TCL_R2_FW2TCL1_RING_HP_IN(x)            \
                in_dword(HWIO_TCL_R2_FW2TCL1_RING_HP_ADDR(x))
#define HWIO_TCL_R2_FW2TCL1_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_FW2TCL1_RING_HP_ADDR(x), m)
#define HWIO_TCL_R2_FW2TCL1_RING_HP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_FW2TCL1_RING_HP_ADDR(x),v)
#define HWIO_TCL_R2_FW2TCL1_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_FW2TCL1_RING_HP_ADDR(x),m,v,HWIO_TCL_R2_FW2TCL1_RING_HP_IN(x))
#define HWIO_TCL_R2_FW2TCL1_RING_HP_HEAD_PTR_BMSK                                                               0xffff
#define HWIO_TCL_R2_FW2TCL1_RING_HP_HEAD_PTR_SHFT                                                                    0

#define HWIO_TCL_R2_FW2TCL1_RING_TP_ADDR(x)                                                                 ((x) + 0x2034)
#define HWIO_TCL_R2_FW2TCL1_RING_TP_PHYS(x)                                                                 ((x) + 0x2034)
#define HWIO_TCL_R2_FW2TCL1_RING_TP_OFFS                                                                    (0x2034)
#define HWIO_TCL_R2_FW2TCL1_RING_TP_RMSK                                                                        0xffff
#define HWIO_TCL_R2_FW2TCL1_RING_TP_POR                                                                     0x00000000
#define HWIO_TCL_R2_FW2TCL1_RING_TP_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R2_FW2TCL1_RING_TP_ATTR                                                                                 0x3
#define HWIO_TCL_R2_FW2TCL1_RING_TP_IN(x)            \
                in_dword(HWIO_TCL_R2_FW2TCL1_RING_TP_ADDR(x))
#define HWIO_TCL_R2_FW2TCL1_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_FW2TCL1_RING_TP_ADDR(x), m)
#define HWIO_TCL_R2_FW2TCL1_RING_TP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_FW2TCL1_RING_TP_ADDR(x),v)
#define HWIO_TCL_R2_FW2TCL1_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_FW2TCL1_RING_TP_ADDR(x),m,v,HWIO_TCL_R2_FW2TCL1_RING_TP_IN(x))
#define HWIO_TCL_R2_FW2TCL1_RING_TP_TAIL_PTR_BMSK                                                               0xffff
#define HWIO_TCL_R2_FW2TCL1_RING_TP_TAIL_PTR_SHFT                                                                    0

#define HWIO_TCL_R2_TCL2TQM_RING_HP_ADDR(x)                                                                 ((x) + 0x2040)
#define HWIO_TCL_R2_TCL2TQM_RING_HP_PHYS(x)                                                                 ((x) + 0x2040)
#define HWIO_TCL_R2_TCL2TQM_RING_HP_OFFS                                                                    (0x2040)
#define HWIO_TCL_R2_TCL2TQM_RING_HP_RMSK                                                                        0xffff
#define HWIO_TCL_R2_TCL2TQM_RING_HP_POR                                                                     0x00000000
#define HWIO_TCL_R2_TCL2TQM_RING_HP_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R2_TCL2TQM_RING_HP_ATTR                                                                                 0x3
#define HWIO_TCL_R2_TCL2TQM_RING_HP_IN(x)            \
                in_dword(HWIO_TCL_R2_TCL2TQM_RING_HP_ADDR(x))
#define HWIO_TCL_R2_TCL2TQM_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_TCL2TQM_RING_HP_ADDR(x), m)
#define HWIO_TCL_R2_TCL2TQM_RING_HP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_TCL2TQM_RING_HP_ADDR(x),v)
#define HWIO_TCL_R2_TCL2TQM_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_TCL2TQM_RING_HP_ADDR(x),m,v,HWIO_TCL_R2_TCL2TQM_RING_HP_IN(x))
#define HWIO_TCL_R2_TCL2TQM_RING_HP_HEAD_PTR_BMSK                                                               0xffff
#define HWIO_TCL_R2_TCL2TQM_RING_HP_HEAD_PTR_SHFT                                                                    0

#define HWIO_TCL_R2_TCL2TQM_RING_TP_ADDR(x)                                                                 ((x) + 0x2044)
#define HWIO_TCL_R2_TCL2TQM_RING_TP_PHYS(x)                                                                 ((x) + 0x2044)
#define HWIO_TCL_R2_TCL2TQM_RING_TP_OFFS                                                                    (0x2044)
#define HWIO_TCL_R2_TCL2TQM_RING_TP_RMSK                                                                        0xffff
#define HWIO_TCL_R2_TCL2TQM_RING_TP_POR                                                                     0x00000000
#define HWIO_TCL_R2_TCL2TQM_RING_TP_POR_RMSK                                                                0xffffffff
#define HWIO_TCL_R2_TCL2TQM_RING_TP_ATTR                                                                                 0x3
#define HWIO_TCL_R2_TCL2TQM_RING_TP_IN(x)            \
                in_dword(HWIO_TCL_R2_TCL2TQM_RING_TP_ADDR(x))
#define HWIO_TCL_R2_TCL2TQM_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_TCL2TQM_RING_TP_ADDR(x), m)
#define HWIO_TCL_R2_TCL2TQM_RING_TP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_TCL2TQM_RING_TP_ADDR(x),v)
#define HWIO_TCL_R2_TCL2TQM_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_TCL2TQM_RING_TP_ADDR(x),m,v,HWIO_TCL_R2_TCL2TQM_RING_TP_IN(x))
#define HWIO_TCL_R2_TCL2TQM_RING_TP_TAIL_PTR_BMSK                                                               0xffff
#define HWIO_TCL_R2_TCL2TQM_RING_TP_TAIL_PTR_SHFT                                                                    0

#define HWIO_TCL_R2_TCL_STATUS1_RING_HP_ADDR(x)                                                             ((x) + 0x2048)
#define HWIO_TCL_R2_TCL_STATUS1_RING_HP_PHYS(x)                                                             ((x) + 0x2048)
#define HWIO_TCL_R2_TCL_STATUS1_RING_HP_OFFS                                                                (0x2048)
#define HWIO_TCL_R2_TCL_STATUS1_RING_HP_RMSK                                                                    0xffff
#define HWIO_TCL_R2_TCL_STATUS1_RING_HP_POR                                                                 0x00000000
#define HWIO_TCL_R2_TCL_STATUS1_RING_HP_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R2_TCL_STATUS1_RING_HP_ATTR                                                                             0x3
#define HWIO_TCL_R2_TCL_STATUS1_RING_HP_IN(x)            \
                in_dword(HWIO_TCL_R2_TCL_STATUS1_RING_HP_ADDR(x))
#define HWIO_TCL_R2_TCL_STATUS1_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_TCL_STATUS1_RING_HP_ADDR(x), m)
#define HWIO_TCL_R2_TCL_STATUS1_RING_HP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_TCL_STATUS1_RING_HP_ADDR(x),v)
#define HWIO_TCL_R2_TCL_STATUS1_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_TCL_STATUS1_RING_HP_ADDR(x),m,v,HWIO_TCL_R2_TCL_STATUS1_RING_HP_IN(x))
#define HWIO_TCL_R2_TCL_STATUS1_RING_HP_HEAD_PTR_BMSK                                                           0xffff
#define HWIO_TCL_R2_TCL_STATUS1_RING_HP_HEAD_PTR_SHFT                                                                0

#define HWIO_TCL_R2_TCL_STATUS1_RING_TP_ADDR(x)                                                             ((x) + 0x204c)
#define HWIO_TCL_R2_TCL_STATUS1_RING_TP_PHYS(x)                                                             ((x) + 0x204c)
#define HWIO_TCL_R2_TCL_STATUS1_RING_TP_OFFS                                                                (0x204c)
#define HWIO_TCL_R2_TCL_STATUS1_RING_TP_RMSK                                                                    0xffff
#define HWIO_TCL_R2_TCL_STATUS1_RING_TP_POR                                                                 0x00000000
#define HWIO_TCL_R2_TCL_STATUS1_RING_TP_POR_RMSK                                                            0xffffffff
#define HWIO_TCL_R2_TCL_STATUS1_RING_TP_ATTR                                                                             0x3
#define HWIO_TCL_R2_TCL_STATUS1_RING_TP_IN(x)            \
                in_dword(HWIO_TCL_R2_TCL_STATUS1_RING_TP_ADDR(x))
#define HWIO_TCL_R2_TCL_STATUS1_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_TCL_STATUS1_RING_TP_ADDR(x), m)
#define HWIO_TCL_R2_TCL_STATUS1_RING_TP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_TCL_STATUS1_RING_TP_ADDR(x),v)
#define HWIO_TCL_R2_TCL_STATUS1_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_TCL_STATUS1_RING_TP_ADDR(x),m,v,HWIO_TCL_R2_TCL_STATUS1_RING_TP_IN(x))
#define HWIO_TCL_R2_TCL_STATUS1_RING_TP_TAIL_PTR_BMSK                                                           0xffff
#define HWIO_TCL_R2_TCL_STATUS1_RING_TP_TAIL_PTR_SHFT                                                                0

#define HWIO_TCL_R2_TCL2FW_RING_HP_ADDR(x)                                                                  ((x) + 0x2058)
#define HWIO_TCL_R2_TCL2FW_RING_HP_PHYS(x)                                                                  ((x) + 0x2058)
#define HWIO_TCL_R2_TCL2FW_RING_HP_OFFS                                                                     (0x2058)
#define HWIO_TCL_R2_TCL2FW_RING_HP_RMSK                                                                         0xffff
#define HWIO_TCL_R2_TCL2FW_RING_HP_POR                                                                      0x00000000
#define HWIO_TCL_R2_TCL2FW_RING_HP_POR_RMSK                                                                 0xffffffff
#define HWIO_TCL_R2_TCL2FW_RING_HP_ATTR                                                                                  0x3
#define HWIO_TCL_R2_TCL2FW_RING_HP_IN(x)            \
                in_dword(HWIO_TCL_R2_TCL2FW_RING_HP_ADDR(x))
#define HWIO_TCL_R2_TCL2FW_RING_HP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_TCL2FW_RING_HP_ADDR(x), m)
#define HWIO_TCL_R2_TCL2FW_RING_HP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_TCL2FW_RING_HP_ADDR(x),v)
#define HWIO_TCL_R2_TCL2FW_RING_HP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_TCL2FW_RING_HP_ADDR(x),m,v,HWIO_TCL_R2_TCL2FW_RING_HP_IN(x))
#define HWIO_TCL_R2_TCL2FW_RING_HP_HEAD_PTR_BMSK                                                                0xffff
#define HWIO_TCL_R2_TCL2FW_RING_HP_HEAD_PTR_SHFT                                                                     0

#define HWIO_TCL_R2_TCL2FW_RING_TP_ADDR(x)                                                                  ((x) + 0x205c)
#define HWIO_TCL_R2_TCL2FW_RING_TP_PHYS(x)                                                                  ((x) + 0x205c)
#define HWIO_TCL_R2_TCL2FW_RING_TP_OFFS                                                                     (0x205c)
#define HWIO_TCL_R2_TCL2FW_RING_TP_RMSK                                                                         0xffff
#define HWIO_TCL_R2_TCL2FW_RING_TP_POR                                                                      0x00000000
#define HWIO_TCL_R2_TCL2FW_RING_TP_POR_RMSK                                                                 0xffffffff
#define HWIO_TCL_R2_TCL2FW_RING_TP_ATTR                                                                                  0x3
#define HWIO_TCL_R2_TCL2FW_RING_TP_IN(x)            \
                in_dword(HWIO_TCL_R2_TCL2FW_RING_TP_ADDR(x))
#define HWIO_TCL_R2_TCL2FW_RING_TP_INM(x, m)            \
                in_dword_masked(HWIO_TCL_R2_TCL2FW_RING_TP_ADDR(x), m)
#define HWIO_TCL_R2_TCL2FW_RING_TP_OUT(x, v)            \
                out_dword(HWIO_TCL_R2_TCL2FW_RING_TP_ADDR(x),v)
#define HWIO_TCL_R2_TCL2FW_RING_TP_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_TCL_R2_TCL2FW_RING_TP_ADDR(x),m,v,HWIO_TCL_R2_TCL2FW_RING_TP_IN(x))
#define HWIO_TCL_R2_TCL2FW_RING_TP_TAIL_PTR_BMSK                                                                0xffff
#define HWIO_TCL_R2_TCL2FW_RING_TP_TAIL_PTR_SHFT                                                                     0

/*----------------------------------------------------------------------------
 * MODULE: MAC_CMN_PARSER_REG
 *--------------------------------------------------------------------------*/

#define MAC_CMN_PARSER_REG_REG_BASE                                                        (UMAC_BASE      + 0x00047000)
#define MAC_CMN_PARSER_REG_REG_BASE_SIZE                                                   0x3000
#define MAC_CMN_PARSER_REG_REG_BASE_USED                                                   0x508
#define MAC_CMN_PARSER_REG_REG_BASE_PHYS                                                   (UMAC_BASE_PHYS + 0x00047000)
#define MAC_CMN_PARSER_REG_REG_BASE_OFFS                                                   0x00047000

#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_0_ADDR(x)                                              ((x) + 0x0)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_0_PHYS(x)                                              ((x) + 0x0)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_0_OFFS                                                 (0x0)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_0_RMSK                                                    0xfffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_0_POR                                                  0x00000000
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_0_POR_RMSK                                             0xffffffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_0_ATTR                                                              0x1
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_0_IN(x)            \
                in_dword(HWIO_CP_R0_IPV6_EXTN_HDR_IX_0_ADDR(x))
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_IPV6_EXTN_HDR_IX_0_ADDR(x), m)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_0_HDR_LEN_BMSK                                            0xfff00
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_0_HDR_LEN_SHFT                                                  8
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_0_HDR_ID_BMSK                                                0xff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_0_HDR_ID_SHFT                                                   0

#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_1_ADDR(x)                                              ((x) + 0x4)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_1_PHYS(x)                                              ((x) + 0x4)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_1_OFFS                                                 (0x4)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_1_RMSK                                                    0xfffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_1_POR                                                  0x0000002b
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_1_POR_RMSK                                             0xffffffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_1_ATTR                                                              0x1
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_1_IN(x)            \
                in_dword(HWIO_CP_R0_IPV6_EXTN_HDR_IX_1_ADDR(x))
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_IPV6_EXTN_HDR_IX_1_ADDR(x), m)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_1_HDR_LEN_BMSK                                            0xfff00
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_1_HDR_LEN_SHFT                                                  8
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_1_HDR_ID_BMSK                                                0xff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_1_HDR_ID_SHFT                                                   0

#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_2_ADDR(x)                                              ((x) + 0x8)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_2_PHYS(x)                                              ((x) + 0x8)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_2_OFFS                                                 (0x8)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_2_RMSK                                                    0xfffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_2_POR                                                  0x0000003c
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_2_POR_RMSK                                             0xffffffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_2_ATTR                                                              0x1
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_2_IN(x)            \
                in_dword(HWIO_CP_R0_IPV6_EXTN_HDR_IX_2_ADDR(x))
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_2_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_IPV6_EXTN_HDR_IX_2_ADDR(x), m)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_2_HDR_LEN_BMSK                                            0xfff00
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_2_HDR_LEN_SHFT                                                  8
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_2_HDR_ID_BMSK                                                0xff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_2_HDR_ID_SHFT                                                   0

#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_3_ADDR(x)                                              ((x) + 0xc)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_3_PHYS(x)                                              ((x) + 0xc)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_3_OFFS                                                 (0xc)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_3_RMSK                                                    0xfffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_3_POR                                                  0x00000033
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_3_POR_RMSK                                             0xffffffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_3_ATTR                                                              0x1
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_3_IN(x)            \
                in_dword(HWIO_CP_R0_IPV6_EXTN_HDR_IX_3_ADDR(x))
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_3_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_IPV6_EXTN_HDR_IX_3_ADDR(x), m)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_3_HDR_LEN_BMSK                                            0xfff00
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_3_HDR_LEN_SHFT                                                  8
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_3_HDR_ID_BMSK                                                0xff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_3_HDR_ID_SHFT                                                   0

#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_4_ADDR(x)                                              ((x) + 0x10)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_4_PHYS(x)                                              ((x) + 0x10)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_4_OFFS                                                 (0x10)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_4_RMSK                                                    0xfffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_4_POR                                                  0x00000887
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_4_POR_RMSK                                             0xffffffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_4_ATTR                                                              0x1
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_4_IN(x)            \
                in_dword(HWIO_CP_R0_IPV6_EXTN_HDR_IX_4_ADDR(x))
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_4_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_IPV6_EXTN_HDR_IX_4_ADDR(x), m)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_4_HDR_LEN_BMSK                                            0xfff00
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_4_HDR_LEN_SHFT                                                  8
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_4_HDR_ID_BMSK                                                0xff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_4_HDR_ID_SHFT                                                   0

#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_5_ADDR(x)                                              ((x) + 0x14)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_5_PHYS(x)                                              ((x) + 0x14)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_5_OFFS                                                 (0x14)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_5_RMSK                                                    0xfffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_5_POR                                                  0x0000082c
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_5_POR_RMSK                                             0xffffffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_5_ATTR                                                              0x1
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_5_IN(x)            \
                in_dword(HWIO_CP_R0_IPV6_EXTN_HDR_IX_5_ADDR(x))
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_5_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_IPV6_EXTN_HDR_IX_5_ADDR(x), m)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_5_HDR_LEN_BMSK                                            0xfff00
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_5_HDR_LEN_SHFT                                                  8
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_5_HDR_ID_BMSK                                                0xff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_5_HDR_ID_SHFT                                                   0

#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_6_ADDR(x)                                              ((x) + 0x18)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_6_PHYS(x)                                              ((x) + 0x18)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_6_OFFS                                                 (0x18)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_6_RMSK                                                    0xfffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_6_POR                                                  0x00000000
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_6_POR_RMSK                                             0xffffffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_6_ATTR                                                              0x3
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_6_IN(x)            \
                in_dword(HWIO_CP_R0_IPV6_EXTN_HDR_IX_6_ADDR(x))
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_6_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_IPV6_EXTN_HDR_IX_6_ADDR(x), m)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_6_OUT(x, v)            \
                out_dword(HWIO_CP_R0_IPV6_EXTN_HDR_IX_6_ADDR(x),v)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_6_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_IPV6_EXTN_HDR_IX_6_ADDR(x),m,v,HWIO_CP_R0_IPV6_EXTN_HDR_IX_6_IN(x))
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_6_HDR_LEN_BMSK                                            0xfff00
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_6_HDR_LEN_SHFT                                                  8
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_6_HDR_ID_BMSK                                                0xff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_6_HDR_ID_SHFT                                                   0

#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_7_ADDR(x)                                              ((x) + 0x1c)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_7_PHYS(x)                                              ((x) + 0x1c)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_7_OFFS                                                 (0x1c)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_7_RMSK                                                    0xfffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_7_POR                                                  0x00000000
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_7_POR_RMSK                                             0xffffffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_7_ATTR                                                              0x3
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_7_IN(x)            \
                in_dword(HWIO_CP_R0_IPV6_EXTN_HDR_IX_7_ADDR(x))
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_7_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_IPV6_EXTN_HDR_IX_7_ADDR(x), m)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_7_OUT(x, v)            \
                out_dword(HWIO_CP_R0_IPV6_EXTN_HDR_IX_7_ADDR(x),v)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_7_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_IPV6_EXTN_HDR_IX_7_ADDR(x),m,v,HWIO_CP_R0_IPV6_EXTN_HDR_IX_7_IN(x))
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_7_HDR_LEN_BMSK                                            0xfff00
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_7_HDR_LEN_SHFT                                                  8
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_7_HDR_ID_BMSK                                                0xff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_7_HDR_ID_SHFT                                                   0

#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_8_ADDR(x)                                              ((x) + 0x20)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_8_PHYS(x)                                              ((x) + 0x20)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_8_OFFS                                                 (0x20)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_8_RMSK                                                    0xfffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_8_POR                                                  0x00000000
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_8_POR_RMSK                                             0xffffffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_8_ATTR                                                              0x3
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_8_IN(x)            \
                in_dword(HWIO_CP_R0_IPV6_EXTN_HDR_IX_8_ADDR(x))
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_8_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_IPV6_EXTN_HDR_IX_8_ADDR(x), m)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_8_OUT(x, v)            \
                out_dword(HWIO_CP_R0_IPV6_EXTN_HDR_IX_8_ADDR(x),v)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_8_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_IPV6_EXTN_HDR_IX_8_ADDR(x),m,v,HWIO_CP_R0_IPV6_EXTN_HDR_IX_8_IN(x))
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_8_HDR_LEN_BMSK                                            0xfff00
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_8_HDR_LEN_SHFT                                                  8
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_8_HDR_ID_BMSK                                                0xff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_8_HDR_ID_SHFT                                                   0

#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_9_ADDR(x)                                              ((x) + 0x24)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_9_PHYS(x)                                              ((x) + 0x24)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_9_OFFS                                                 (0x24)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_9_RMSK                                                    0xfffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_9_POR                                                  0x00000000
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_9_POR_RMSK                                             0xffffffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_9_ATTR                                                              0x3
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_9_IN(x)            \
                in_dword(HWIO_CP_R0_IPV6_EXTN_HDR_IX_9_ADDR(x))
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_9_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_IPV6_EXTN_HDR_IX_9_ADDR(x), m)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_9_OUT(x, v)            \
                out_dword(HWIO_CP_R0_IPV6_EXTN_HDR_IX_9_ADDR(x),v)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_9_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_IPV6_EXTN_HDR_IX_9_ADDR(x),m,v,HWIO_CP_R0_IPV6_EXTN_HDR_IX_9_IN(x))
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_9_HDR_LEN_BMSK                                            0xfff00
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_9_HDR_LEN_SHFT                                                  8
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_9_HDR_ID_BMSK                                                0xff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_9_HDR_ID_SHFT                                                   0

#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_10_ADDR(x)                                             ((x) + 0x28)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_10_PHYS(x)                                             ((x) + 0x28)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_10_OFFS                                                (0x28)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_10_RMSK                                                   0xfffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_10_POR                                                 0x00000000
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_10_POR_RMSK                                            0xffffffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_10_ATTR                                                             0x3
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_10_IN(x)            \
                in_dword(HWIO_CP_R0_IPV6_EXTN_HDR_IX_10_ADDR(x))
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_10_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_IPV6_EXTN_HDR_IX_10_ADDR(x), m)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_10_OUT(x, v)            \
                out_dword(HWIO_CP_R0_IPV6_EXTN_HDR_IX_10_ADDR(x),v)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_10_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_IPV6_EXTN_HDR_IX_10_ADDR(x),m,v,HWIO_CP_R0_IPV6_EXTN_HDR_IX_10_IN(x))
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_10_HDR_LEN_BMSK                                           0xfff00
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_10_HDR_LEN_SHFT                                                 8
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_10_HDR_ID_BMSK                                               0xff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_10_HDR_ID_SHFT                                                  0

#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_11_ADDR(x)                                             ((x) + 0x2c)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_11_PHYS(x)                                             ((x) + 0x2c)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_11_OFFS                                                (0x2c)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_11_RMSK                                                   0xfffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_11_POR                                                 0x00000000
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_11_POR_RMSK                                            0xffffffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_11_ATTR                                                             0x3
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_11_IN(x)            \
                in_dword(HWIO_CP_R0_IPV6_EXTN_HDR_IX_11_ADDR(x))
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_11_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_IPV6_EXTN_HDR_IX_11_ADDR(x), m)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_11_OUT(x, v)            \
                out_dword(HWIO_CP_R0_IPV6_EXTN_HDR_IX_11_ADDR(x),v)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_11_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_IPV6_EXTN_HDR_IX_11_ADDR(x),m,v,HWIO_CP_R0_IPV6_EXTN_HDR_IX_11_IN(x))
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_11_HDR_LEN_BMSK                                           0xfff00
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_11_HDR_LEN_SHFT                                                 8
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_11_HDR_ID_BMSK                                               0xff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_11_HDR_ID_SHFT                                                  0

#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_12_ADDR(x)                                             ((x) + 0x30)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_12_PHYS(x)                                             ((x) + 0x30)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_12_OFFS                                                (0x30)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_12_RMSK                                                   0xfffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_12_POR                                                 0x00000000
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_12_POR_RMSK                                            0xffffffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_12_ATTR                                                             0x3
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_12_IN(x)            \
                in_dword(HWIO_CP_R0_IPV6_EXTN_HDR_IX_12_ADDR(x))
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_12_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_IPV6_EXTN_HDR_IX_12_ADDR(x), m)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_12_OUT(x, v)            \
                out_dword(HWIO_CP_R0_IPV6_EXTN_HDR_IX_12_ADDR(x),v)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_12_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_IPV6_EXTN_HDR_IX_12_ADDR(x),m,v,HWIO_CP_R0_IPV6_EXTN_HDR_IX_12_IN(x))
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_12_HDR_LEN_BMSK                                           0xfff00
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_12_HDR_LEN_SHFT                                                 8
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_12_HDR_ID_BMSK                                               0xff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_12_HDR_ID_SHFT                                                  0

#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_13_ADDR(x)                                             ((x) + 0x34)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_13_PHYS(x)                                             ((x) + 0x34)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_13_OFFS                                                (0x34)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_13_RMSK                                                   0xfffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_13_POR                                                 0x00000000
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_13_POR_RMSK                                            0xffffffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_13_ATTR                                                             0x3
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_13_IN(x)            \
                in_dword(HWIO_CP_R0_IPV6_EXTN_HDR_IX_13_ADDR(x))
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_13_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_IPV6_EXTN_HDR_IX_13_ADDR(x), m)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_13_OUT(x, v)            \
                out_dword(HWIO_CP_R0_IPV6_EXTN_HDR_IX_13_ADDR(x),v)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_13_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_IPV6_EXTN_HDR_IX_13_ADDR(x),m,v,HWIO_CP_R0_IPV6_EXTN_HDR_IX_13_IN(x))
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_13_HDR_LEN_BMSK                                           0xfff00
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_13_HDR_LEN_SHFT                                                 8
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_13_HDR_ID_BMSK                                               0xff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_13_HDR_ID_SHFT                                                  0

#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_14_ADDR(x)                                             ((x) + 0x38)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_14_PHYS(x)                                             ((x) + 0x38)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_14_OFFS                                                (0x38)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_14_RMSK                                                   0xfffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_14_POR                                                 0x00000000
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_14_POR_RMSK                                            0xffffffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_14_ATTR                                                             0x3
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_14_IN(x)            \
                in_dword(HWIO_CP_R0_IPV6_EXTN_HDR_IX_14_ADDR(x))
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_14_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_IPV6_EXTN_HDR_IX_14_ADDR(x), m)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_14_OUT(x, v)            \
                out_dword(HWIO_CP_R0_IPV6_EXTN_HDR_IX_14_ADDR(x),v)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_14_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_IPV6_EXTN_HDR_IX_14_ADDR(x),m,v,HWIO_CP_R0_IPV6_EXTN_HDR_IX_14_IN(x))
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_14_HDR_LEN_BMSK                                           0xfff00
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_14_HDR_LEN_SHFT                                                 8
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_14_HDR_ID_BMSK                                               0xff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_14_HDR_ID_SHFT                                                  0

#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_15_ADDR(x)                                             ((x) + 0x3c)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_15_PHYS(x)                                             ((x) + 0x3c)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_15_OFFS                                                (0x3c)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_15_RMSK                                                   0xfffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_15_POR                                                 0x00000000
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_15_POR_RMSK                                            0xffffffff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_15_ATTR                                                             0x3
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_15_IN(x)            \
                in_dword(HWIO_CP_R0_IPV6_EXTN_HDR_IX_15_ADDR(x))
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_15_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_IPV6_EXTN_HDR_IX_15_ADDR(x), m)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_15_OUT(x, v)            \
                out_dword(HWIO_CP_R0_IPV6_EXTN_HDR_IX_15_ADDR(x),v)
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_15_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_IPV6_EXTN_HDR_IX_15_ADDR(x),m,v,HWIO_CP_R0_IPV6_EXTN_HDR_IX_15_IN(x))
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_15_HDR_LEN_BMSK                                           0xfff00
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_15_HDR_LEN_SHFT                                                 8
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_15_HDR_ID_BMSK                                               0xff
#define HWIO_CP_R0_IPV6_EXTN_HDR_IX_15_HDR_ID_SHFT                                                  0

#define HWIO_CP_R0_IPV6_CRC_OPTIONS_EN_ADDR(x)                                             ((x) + 0x40)
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_EN_PHYS(x)                                             ((x) + 0x40)
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_EN_OFFS                                                (0x40)
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_EN_RMSK                                                      0xff
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_EN_POR                                                 0x00000000
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_EN_POR_RMSK                                            0xffffffff
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_EN_ATTR                                                             0x3
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_EN_IN(x)            \
                in_dword(HWIO_CP_R0_IPV6_CRC_OPTIONS_EN_ADDR(x))
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_EN_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_IPV6_CRC_OPTIONS_EN_ADDR(x), m)
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_EN_OUT(x, v)            \
                out_dword(HWIO_CP_R0_IPV6_CRC_OPTIONS_EN_ADDR(x),v)
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_EN_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_IPV6_CRC_OPTIONS_EN_ADDR(x),m,v,HWIO_CP_R0_IPV6_CRC_OPTIONS_EN_IN(x))
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_EN_HEADERS1_BMSK                                             0xf0
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_EN_HEADERS1_SHFT                                                4
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_EN_HEADERS0_BMSK                                              0xf
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_EN_HEADERS0_SHFT                                                0

#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_0_ADDR(x)                                   ((x) + 0x44)
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_0_PHYS(x)                                   ((x) + 0x44)
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_0_OFFS                                      (0x44)
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_0_RMSK                                      0xffffffff
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_0_POR                                       0x00000000
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_0_POR_RMSK                                  0xffffffff
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_0_ATTR                                                   0x3
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_0_IN(x)            \
                in_dword(HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_0_ADDR(x))
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_0_ADDR(x), m)
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_0_OUT(x, v)            \
                out_dword(HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_0_ADDR(x),v)
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_0_ADDR(x),m,v,HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_0_IN(x))
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_0_SEL3_BMSK                                 0xff000000
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_0_SEL3_SHFT                                         24
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_0_SEL2_BMSK                                   0xff0000
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_0_SEL2_SHFT                                         16
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_0_SEL1_BMSK                                     0xff00
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_0_SEL1_SHFT                                          8
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_0_SEL0_BMSK                                       0xff
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_0_SEL0_SHFT                                          0

#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_1_ADDR(x)                                   ((x) + 0x48)
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_1_PHYS(x)                                   ((x) + 0x48)
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_1_OFFS                                      (0x48)
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_1_RMSK                                      0xffffffff
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_1_POR                                       0x00000000
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_1_POR_RMSK                                  0xffffffff
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_1_ATTR                                                   0x3
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_1_IN(x)            \
                in_dword(HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_1_ADDR(x))
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_1_ADDR(x), m)
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_1_OUT(x, v)            \
                out_dword(HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_1_ADDR(x),v)
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_1_ADDR(x),m,v,HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_1_IN(x))
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_1_SEL7_BMSK                                 0xff000000
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_1_SEL7_SHFT                                         24
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_1_SEL6_BMSK                                   0xff0000
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_1_SEL6_SHFT                                         16
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_1_SEL5_BMSK                                     0xff00
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_1_SEL5_SHFT                                          8
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_1_SEL4_BMSK                                       0xff
#define HWIO_CP_R0_IPV6_CRC_OPTIONS_HEADERS_IX_1_SEL4_SHFT                                          0

#define HWIO_CP_R0_IPV6_CONFIG_ADDR(x)                                                     ((x) + 0x8c)
#define HWIO_CP_R0_IPV6_CONFIG_PHYS(x)                                                     ((x) + 0x8c)
#define HWIO_CP_R0_IPV6_CONFIG_OFFS                                                        (0x8c)
#define HWIO_CP_R0_IPV6_CONFIG_RMSK                                                             0xfff
#define HWIO_CP_R0_IPV6_CONFIG_POR                                                         0x00000080
#define HWIO_CP_R0_IPV6_CONFIG_POR_RMSK                                                    0xffffffff
#define HWIO_CP_R0_IPV6_CONFIG_ATTR                                                                     0x3
#define HWIO_CP_R0_IPV6_CONFIG_IN(x)            \
                in_dword(HWIO_CP_R0_IPV6_CONFIG_ADDR(x))
#define HWIO_CP_R0_IPV6_CONFIG_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_IPV6_CONFIG_ADDR(x), m)
#define HWIO_CP_R0_IPV6_CONFIG_OUT(x, v)            \
                out_dword(HWIO_CP_R0_IPV6_CONFIG_ADDR(x),v)
#define HWIO_CP_R0_IPV6_CONFIG_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_IPV6_CONFIG_ADDR(x),m,v,HWIO_CP_R0_IPV6_CONFIG_IN(x))
#define HWIO_CP_R0_IPV6_CONFIG_USE_AH_FOR_FLOW_ID_BMSK                                          0x800
#define HWIO_CP_R0_IPV6_CONFIG_USE_AH_FOR_FLOW_ID_SHFT                                             11
#define HWIO_CP_R0_IPV6_CONFIG_SPI_FROM_AH_OR_ESP_BMSK                                          0x400
#define HWIO_CP_R0_IPV6_CONFIG_SPI_FROM_AH_OR_ESP_SHFT                                             10
#define HWIO_CP_R0_IPV6_CONFIG_L4_BYTES_EXCEEDED_256_BMSK                                       0x200
#define HWIO_CP_R0_IPV6_CONFIG_L4_BYTES_EXCEEDED_256_SHFT                                           9
#define HWIO_CP_R0_IPV6_CONFIG_L3_BYTES_EXCEEDED_256_BMSK                                       0x100
#define HWIO_CP_R0_IPV6_CONFIG_L3_BYTES_EXCEEDED_256_SHFT                                           8
#define HWIO_CP_R0_IPV6_CONFIG_EXT_HEADER_BYTES_BMSK                                             0xff
#define HWIO_CP_R0_IPV6_CONFIG_EXT_HEADER_BYTES_SHFT                                                0

#define HWIO_CP_R0_COMMIT_TLV_CONFIG_ADDR(x)                                               ((x) + 0x90)
#define HWIO_CP_R0_COMMIT_TLV_CONFIG_PHYS(x)                                               ((x) + 0x90)
#define HWIO_CP_R0_COMMIT_TLV_CONFIG_OFFS                                                  (0x90)
#define HWIO_CP_R0_COMMIT_TLV_CONFIG_RMSK                                                     0x1ffff
#define HWIO_CP_R0_COMMIT_TLV_CONFIG_POR                                                   0x00010040
#define HWIO_CP_R0_COMMIT_TLV_CONFIG_POR_RMSK                                              0xffffffff
#define HWIO_CP_R0_COMMIT_TLV_CONFIG_ATTR                                                               0x1
#define HWIO_CP_R0_COMMIT_TLV_CONFIG_IN(x)            \
                in_dword(HWIO_CP_R0_COMMIT_TLV_CONFIG_ADDR(x))
#define HWIO_CP_R0_COMMIT_TLV_CONFIG_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_COMMIT_TLV_CONFIG_ADDR(x), m)
#define HWIO_CP_R0_COMMIT_TLV_CONFIG_COMMIT_DONE_NUM_BMSK                                     0x1ff00
#define HWIO_CP_R0_COMMIT_TLV_CONFIG_COMMIT_DONE_NUM_SHFT                                           8
#define HWIO_CP_R0_COMMIT_TLV_CONFIG_COMMIT_NUM_BMSK                                             0xff
#define HWIO_CP_R0_COMMIT_TLV_CONFIG_COMMIT_NUM_SHFT                                                0

#define HWIO_CP_R0_CLKGATE_DISABLE_ADDR(x)                                                 ((x) + 0x94)
#define HWIO_CP_R0_CLKGATE_DISABLE_PHYS(x)                                                 ((x) + 0x94)
#define HWIO_CP_R0_CLKGATE_DISABLE_OFFS                                                    (0x94)
#define HWIO_CP_R0_CLKGATE_DISABLE_RMSK                                                    0xffffffff
#define HWIO_CP_R0_CLKGATE_DISABLE_POR                                                     0x00000000
#define HWIO_CP_R0_CLKGATE_DISABLE_POR_RMSK                                                0xffffffff
#define HWIO_CP_R0_CLKGATE_DISABLE_ATTR                                                                 0x3
#define HWIO_CP_R0_CLKGATE_DISABLE_IN(x)            \
                in_dword(HWIO_CP_R0_CLKGATE_DISABLE_ADDR(x))
#define HWIO_CP_R0_CLKGATE_DISABLE_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_CLKGATE_DISABLE_ADDR(x), m)
#define HWIO_CP_R0_CLKGATE_DISABLE_OUT(x, v)            \
                out_dword(HWIO_CP_R0_CLKGATE_DISABLE_ADDR(x),v)
#define HWIO_CP_R0_CLKGATE_DISABLE_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_CLKGATE_DISABLE_ADDR(x),m,v,HWIO_CP_R0_CLKGATE_DISABLE_IN(x))
#define HWIO_CP_R0_CLKGATE_DISABLE_CLK_EXTEND_BMSK                                         0x80000000
#define HWIO_CP_R0_CLKGATE_DISABLE_CLK_EXTEND_SHFT                                                 31
#define HWIO_CP_R0_CLKGATE_DISABLE_CPU_IF_EXTEND_BMSK                                      0x40000000
#define HWIO_CP_R0_CLKGATE_DISABLE_CPU_IF_EXTEND_SHFT                                              30
#define HWIO_CP_R0_CLKGATE_DISABLE_CP_RSRVD_BMSK                                           0x3fffff00
#define HWIO_CP_R0_CLKGATE_DISABLE_CP_RSRVD_SHFT                                                    8
#define HWIO_CP_R0_CLKGATE_DISABLE_CCE_SM_BMSK                                                   0x80
#define HWIO_CP_R0_CLKGATE_DISABLE_CCE_SM_SHFT                                                      7
#define HWIO_CP_R0_CLKGATE_DISABLE_NWIFI_BMSK                                                    0x40
#define HWIO_CP_R0_CLKGATE_DISABLE_NWIFI_SHFT                                                       6
#define HWIO_CP_R0_CLKGATE_DISABLE_ETH_BMSK                                                      0x20
#define HWIO_CP_R0_CLKGATE_DISABLE_ETH_SHFT                                                         5
#define HWIO_CP_R0_CLKGATE_DISABLE_AMSDU_11AH_BMSK                                               0x10
#define HWIO_CP_R0_CLKGATE_DISABLE_AMSDU_11AH_SHFT                                                  4
#define HWIO_CP_R0_CLKGATE_DISABLE_AMSDU_11AC_BMSK                                                0x8
#define HWIO_CP_R0_CLKGATE_DISABLE_AMSDU_11AC_SHFT                                                  3
#define HWIO_CP_R0_CLKGATE_DISABLE_WIFI_BMSK                                                      0x4
#define HWIO_CP_R0_CLKGATE_DISABLE_WIFI_SHFT                                                        2
#define HWIO_CP_R0_CLKGATE_DISABLE_CORE_BMSK                                                      0x2
#define HWIO_CP_R0_CLKGATE_DISABLE_CORE_SHFT                                                        1
#define HWIO_CP_R0_CLKGATE_DISABLE_APB_BMSK                                                       0x1
#define HWIO_CP_R0_CLKGATE_DISABLE_APB_SHFT                                                         0

#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_0_ADDR(x)                                          ((x) + 0x98)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_0_PHYS(x)                                          ((x) + 0x98)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_0_OFFS                                             (0x98)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_0_RMSK                                             0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_0_POR                                              0x00000000
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_0_POR_RMSK                                         0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_0_ATTR                                                          0x3
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_0_IN(x)            \
                in_dword(HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_0_ADDR(x))
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_0_ADDR(x), m)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_0_OUT(x, v)            \
                out_dword(HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_0_ADDR(x),v)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_0_ADDR(x),m,v,HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_0_IN(x))
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_0_VALUE_BMSK                                       0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_0_VALUE_SHFT                                                0

#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_1_ADDR(x)                                          ((x) + 0x9c)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_1_PHYS(x)                                          ((x) + 0x9c)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_1_OFFS                                             (0x9c)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_1_RMSK                                             0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_1_POR                                              0x00000000
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_1_POR_RMSK                                         0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_1_ATTR                                                          0x3
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_1_IN(x)            \
                in_dword(HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_1_ADDR(x))
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_1_ADDR(x), m)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_1_OUT(x, v)            \
                out_dword(HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_1_ADDR(x),v)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_1_ADDR(x),m,v,HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_1_IN(x))
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_1_VALUE_BMSK                                       0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_1_VALUE_SHFT                                                0

#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_2_ADDR(x)                                          ((x) + 0xa0)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_2_PHYS(x)                                          ((x) + 0xa0)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_2_OFFS                                             (0xa0)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_2_RMSK                                             0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_2_POR                                              0x00000000
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_2_POR_RMSK                                         0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_2_ATTR                                                          0x3
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_2_IN(x)            \
                in_dword(HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_2_ADDR(x))
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_2_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_2_ADDR(x), m)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_2_OUT(x, v)            \
                out_dword(HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_2_ADDR(x),v)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_2_ADDR(x),m,v,HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_2_IN(x))
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_2_VALUE_BMSK                                       0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_2_VALUE_SHFT                                                0

#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_3_ADDR(x)                                          ((x) + 0xa4)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_3_PHYS(x)                                          ((x) + 0xa4)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_3_OFFS                                             (0xa4)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_3_RMSK                                             0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_3_POR                                              0x00000000
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_3_POR_RMSK                                         0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_3_ATTR                                                          0x3
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_3_IN(x)            \
                in_dword(HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_3_ADDR(x))
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_3_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_3_ADDR(x), m)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_3_OUT(x, v)            \
                out_dword(HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_3_ADDR(x),v)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_3_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_3_ADDR(x),m,v,HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_3_IN(x))
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_3_VALUE_BMSK                                       0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IX_3_VALUE_SHFT                                                0

#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_0_ADDR(x)                                          ((x) + 0xa8)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_0_PHYS(x)                                          ((x) + 0xa8)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_0_OFFS                                             (0xa8)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_0_RMSK                                             0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_0_POR                                              0x00000000
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_0_POR_RMSK                                         0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_0_ATTR                                                          0x3
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_0_IN(x)            \
                in_dword(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_0_ADDR(x))
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_0_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_0_ADDR(x), m)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_0_OUT(x, v)            \
                out_dword(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_0_ADDR(x),v)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_0_ADDR(x),m,v,HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_0_IN(x))
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_0_VALUE_BMSK                                       0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_0_VALUE_SHFT                                                0

#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_1_ADDR(x)                                          ((x) + 0xac)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_1_PHYS(x)                                          ((x) + 0xac)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_1_OFFS                                             (0xac)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_1_RMSK                                             0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_1_POR                                              0x00000000
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_1_POR_RMSK                                         0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_1_ATTR                                                          0x3
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_1_IN(x)            \
                in_dword(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_1_ADDR(x))
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_1_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_1_ADDR(x), m)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_1_OUT(x, v)            \
                out_dword(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_1_ADDR(x),v)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_1_ADDR(x),m,v,HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_1_IN(x))
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_1_VALUE_BMSK                                       0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_1_VALUE_SHFT                                                0

#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_2_ADDR(x)                                          ((x) + 0xb0)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_2_PHYS(x)                                          ((x) + 0xb0)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_2_OFFS                                             (0xb0)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_2_RMSK                                             0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_2_POR                                              0x00000000
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_2_POR_RMSK                                         0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_2_ATTR                                                          0x3
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_2_IN(x)            \
                in_dword(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_2_ADDR(x))
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_2_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_2_ADDR(x), m)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_2_OUT(x, v)            \
                out_dword(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_2_ADDR(x),v)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_2_ADDR(x),m,v,HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_2_IN(x))
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_2_VALUE_BMSK                                       0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_2_VALUE_SHFT                                                0

#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_3_ADDR(x)                                          ((x) + 0xb4)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_3_PHYS(x)                                          ((x) + 0xb4)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_3_OFFS                                             (0xb4)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_3_RMSK                                             0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_3_POR                                              0x00000000
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_3_POR_RMSK                                         0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_3_ATTR                                                          0x3
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_3_IN(x)            \
                in_dword(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_3_ADDR(x))
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_3_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_3_ADDR(x), m)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_3_OUT(x, v)            \
                out_dword(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_3_ADDR(x),v)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_3_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_3_ADDR(x),m,v,HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_3_IN(x))
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_3_VALUE_BMSK                                       0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_3_VALUE_SHFT                                                0

#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_4_ADDR(x)                                          ((x) + 0xb8)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_4_PHYS(x)                                          ((x) + 0xb8)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_4_OFFS                                             (0xb8)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_4_RMSK                                             0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_4_POR                                              0x00000000
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_4_POR_RMSK                                         0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_4_ATTR                                                          0x3
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_4_IN(x)            \
                in_dword(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_4_ADDR(x))
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_4_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_4_ADDR(x), m)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_4_OUT(x, v)            \
                out_dword(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_4_ADDR(x),v)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_4_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_4_ADDR(x),m,v,HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_4_IN(x))
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_4_VALUE_BMSK                                       0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_4_VALUE_SHFT                                                0

#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_5_ADDR(x)                                          ((x) + 0xbc)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_5_PHYS(x)                                          ((x) + 0xbc)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_5_OFFS                                             (0xbc)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_5_RMSK                                             0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_5_POR                                              0x00000000
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_5_POR_RMSK                                         0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_5_ATTR                                                          0x3
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_5_IN(x)            \
                in_dword(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_5_ADDR(x))
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_5_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_5_ADDR(x), m)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_5_OUT(x, v)            \
                out_dword(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_5_ADDR(x),v)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_5_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_5_ADDR(x),m,v,HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_5_IN(x))
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_5_VALUE_BMSK                                       0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_5_VALUE_SHFT                                                0

#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_6_ADDR(x)                                          ((x) + 0xc0)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_6_PHYS(x)                                          ((x) + 0xc0)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_6_OFFS                                             (0xc0)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_6_RMSK                                             0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_6_POR                                              0x00000000
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_6_POR_RMSK                                         0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_6_ATTR                                                          0x3
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_6_IN(x)            \
                in_dword(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_6_ADDR(x))
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_6_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_6_ADDR(x), m)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_6_OUT(x, v)            \
                out_dword(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_6_ADDR(x),v)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_6_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_6_ADDR(x),m,v,HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_6_IN(x))
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_6_VALUE_BMSK                                       0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_6_VALUE_SHFT                                                0

#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_7_ADDR(x)                                          ((x) + 0xc4)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_7_PHYS(x)                                          ((x) + 0xc4)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_7_OFFS                                             (0xc4)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_7_RMSK                                             0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_7_POR                                              0x00000000
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_7_POR_RMSK                                         0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_7_ATTR                                                          0x3
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_7_IN(x)            \
                in_dword(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_7_ADDR(x))
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_7_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_7_ADDR(x), m)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_7_OUT(x, v)            \
                out_dword(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_7_ADDR(x),v)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_7_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_7_ADDR(x),m,v,HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_7_IN(x))
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_7_VALUE_BMSK                                       0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_7_VALUE_SHFT                                                0

#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_8_ADDR(x)                                          ((x) + 0xc8)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_8_PHYS(x)                                          ((x) + 0xc8)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_8_OFFS                                             (0xc8)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_8_RMSK                                             0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_8_POR                                              0x00000000
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_8_POR_RMSK                                         0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_8_ATTR                                                          0x3
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_8_IN(x)            \
                in_dword(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_8_ADDR(x))
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_8_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_8_ADDR(x), m)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_8_OUT(x, v)            \
                out_dword(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_8_ADDR(x),v)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_8_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_8_ADDR(x),m,v,HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_8_IN(x))
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_8_VALUE_BMSK                                       0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_8_VALUE_SHFT                                                0

#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_9_ADDR(x)                                          ((x) + 0xcc)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_9_PHYS(x)                                          ((x) + 0xcc)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_9_OFFS                                             (0xcc)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_9_RMSK                                             0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_9_POR                                              0x00000000
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_9_POR_RMSK                                         0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_9_ATTR                                                          0x3
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_9_IN(x)            \
                in_dword(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_9_ADDR(x))
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_9_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_9_ADDR(x), m)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_9_OUT(x, v)            \
                out_dword(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_9_ADDR(x),v)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_9_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_9_ADDR(x),m,v,HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_9_IN(x))
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_9_VALUE_BMSK                                       0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV6_IX_9_VALUE_SHFT                                                0

#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IPV6_ADDR(x)                                          ((x) + 0xd0)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IPV6_PHYS(x)                                          ((x) + 0xd0)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IPV6_OFFS                                             (0xd0)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IPV6_RMSK                                                 0xffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IPV6_POR                                              0x00000000
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IPV6_POR_RMSK                                         0xffffffff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IPV6_ATTR                                                          0x3
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IPV6_IN(x)            \
                in_dword(HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IPV6_ADDR(x))
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IPV6_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IPV6_ADDR(x), m)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IPV6_OUT(x, v)            \
                out_dword(HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IPV6_ADDR(x),v)
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IPV6_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IPV6_ADDR(x),m,v,HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IPV6_IN(x))
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IPV6_VALUE_1_BMSK                                         0xff00
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IPV6_VALUE_1_SHFT                                              8
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IPV6_VALUE_0_BMSK                                           0xff
#define HWIO_CP_R0_TOEPLITZ_KEY_IPV4_IPV6_VALUE_0_SHFT                                              0

#define HWIO_CP_R0_MISC_CONFIG_ADDR(x)                                                     ((x) + 0xd4)
#define HWIO_CP_R0_MISC_CONFIG_PHYS(x)                                                     ((x) + 0xd4)
#define HWIO_CP_R0_MISC_CONFIG_OFFS                                                        (0xd4)
#define HWIO_CP_R0_MISC_CONFIG_RMSK                                                        0x1fffffff
#define HWIO_CP_R0_MISC_CONFIG_POR                                                         0x0003c110
#define HWIO_CP_R0_MISC_CONFIG_POR_RMSK                                                    0xffffffff
#define HWIO_CP_R0_MISC_CONFIG_ATTR                                                                     0x3
#define HWIO_CP_R0_MISC_CONFIG_IN(x)            \
                in_dword(HWIO_CP_R0_MISC_CONFIG_ADDR(x))
#define HWIO_CP_R0_MISC_CONFIG_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_MISC_CONFIG_ADDR(x), m)
#define HWIO_CP_R0_MISC_CONFIG_OUT(x, v)            \
                out_dword(HWIO_CP_R0_MISC_CONFIG_ADDR(x),v)
#define HWIO_CP_R0_MISC_CONFIG_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_MISC_CONFIG_ADDR(x),m,v,HWIO_CP_R0_MISC_CONFIG_IN(x))
#define HWIO_CP_R0_MISC_CONFIG_REPORT_FLOW_ID_OR_HASH_3_BMSK                               0x10000000
#define HWIO_CP_R0_MISC_CONFIG_REPORT_FLOW_ID_OR_HASH_3_SHFT                                       28
#define HWIO_CP_R0_MISC_CONFIG_ETH_MIN_PACKET_LEN_BMSK                                      0xffff000
#define HWIO_CP_R0_MISC_CONFIG_ETH_MIN_PACKET_LEN_SHFT                                             12
#define HWIO_CP_R0_MISC_CONFIG_TIMEOUT_EN_BMSK                                                  0x800
#define HWIO_CP_R0_MISC_CONFIG_TIMEOUT_EN_SHFT                                                     11
#define HWIO_CP_R0_MISC_CONFIG_ENABLE_8870_BMSK                                                 0x400
#define HWIO_CP_R0_MISC_CONFIG_ENABLE_8870_SHFT                                                    10
#define HWIO_CP_R0_MISC_CONFIG_ENABLE_C9D1_BMSK                                                 0x200
#define HWIO_CP_R0_MISC_CONFIG_ENABLE_C9D1_SHFT                                                     9
#define HWIO_CP_R0_MISC_CONFIG_VLAN_LLC_FOR_802_3_BMSK                                          0x100
#define HWIO_CP_R0_MISC_CONFIG_VLAN_LLC_FOR_802_3_SHFT                                              8
#define HWIO_CP_R0_MISC_CONFIG_IP_DA_SA_PREFIX_BMSK                                              0xc0
#define HWIO_CP_R0_MISC_CONFIG_IP_DA_SA_PREFIX_SHFT                                                 6
#define HWIO_CP_R0_MISC_CONFIG_UDP_LITE_PARSE_EN_BMSK                                            0x20
#define HWIO_CP_R0_MISC_CONFIG_UDP_LITE_PARSE_EN_SHFT                                               5
#define HWIO_CP_R0_MISC_CONFIG_TPID_BITMAP_VALUE_BMSK                                            0x1f
#define HWIO_CP_R0_MISC_CONFIG_TPID_BITMAP_VALUE_SHFT                                               0

#define HWIO_CP_R0_WATCHDOG_TIMER_ADDR(x)                                                  ((x) + 0xd8)
#define HWIO_CP_R0_WATCHDOG_TIMER_PHYS(x)                                                  ((x) + 0xd8)
#define HWIO_CP_R0_WATCHDOG_TIMER_OFFS                                                     (0xd8)
#define HWIO_CP_R0_WATCHDOG_TIMER_RMSK                                                     0xffffffff
#define HWIO_CP_R0_WATCHDOG_TIMER_POR                                                      0x00000000
#define HWIO_CP_R0_WATCHDOG_TIMER_POR_RMSK                                                 0xffffffff
#define HWIO_CP_R0_WATCHDOG_TIMER_ATTR                                                                  0x3
#define HWIO_CP_R0_WATCHDOG_TIMER_IN(x)            \
                in_dword(HWIO_CP_R0_WATCHDOG_TIMER_ADDR(x))
#define HWIO_CP_R0_WATCHDOG_TIMER_INM(x, m)            \
                in_dword_masked(HWIO_CP_R0_WATCHDOG_TIMER_ADDR(x), m)
#define HWIO_CP_R0_WATCHDOG_TIMER_OUT(x, v)            \
                out_dword(HWIO_CP_R0_WATCHDOG_TIMER_ADDR(x),v)
#define HWIO_CP_R0_WATCHDOG_TIMER_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R0_WATCHDOG_TIMER_ADDR(x),m,v,HWIO_CP_R0_WATCHDOG_TIMER_IN(x))
#define HWIO_CP_R0_WATCHDOG_TIMER_VALUE_BMSK                                               0xfffffffe
#define HWIO_CP_R0_WATCHDOG_TIMER_VALUE_SHFT                                                        1
#define HWIO_CP_R0_WATCHDOG_TIMER_ENABLE_BMSK                                                     0x1
#define HWIO_CP_R0_WATCHDOG_TIMER_ENABLE_SHFT                                                       0

#define HWIO_CP_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDR(x)                                       ((x) + 0x500)
#define HWIO_CP_R1_REG_ACCESS_EVENT_GEN_CTRL_PHYS(x)                                       ((x) + 0x500)
#define HWIO_CP_R1_REG_ACCESS_EVENT_GEN_CTRL_OFFS                                          (0x500)
#define HWIO_CP_R1_REG_ACCESS_EVENT_GEN_CTRL_RMSK                                          0xffffffff
#define HWIO_CP_R1_REG_ACCESS_EVENT_GEN_CTRL_POR                                           0x7ffe0002
#define HWIO_CP_R1_REG_ACCESS_EVENT_GEN_CTRL_POR_RMSK                                      0xffffffff
#define HWIO_CP_R1_REG_ACCESS_EVENT_GEN_CTRL_ATTR                                                       0x3
#define HWIO_CP_R1_REG_ACCESS_EVENT_GEN_CTRL_IN(x)            \
                in_dword(HWIO_CP_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDR(x))
#define HWIO_CP_R1_REG_ACCESS_EVENT_GEN_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_CP_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDR(x), m)
#define HWIO_CP_R1_REG_ACCESS_EVENT_GEN_CTRL_OUT(x, v)            \
                out_dword(HWIO_CP_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDR(x),v)
#define HWIO_CP_R1_REG_ACCESS_EVENT_GEN_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDR(x),m,v,HWIO_CP_R1_REG_ACCESS_EVENT_GEN_CTRL_IN(x))
#define HWIO_CP_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDRESS_RANGE_END_BMSK                        0xfffe0000
#define HWIO_CP_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDRESS_RANGE_END_SHFT                                17
#define HWIO_CP_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDRESS_RANGE_START_BMSK                         0x1fffc
#define HWIO_CP_R1_REG_ACCESS_EVENT_GEN_CTRL_ADDRESS_RANGE_START_SHFT                               2
#define HWIO_CP_R1_REG_ACCESS_EVENT_GEN_CTRL_WRITE_ACCESS_REPORT_ENABLE_BMSK                      0x2
#define HWIO_CP_R1_REG_ACCESS_EVENT_GEN_CTRL_WRITE_ACCESS_REPORT_ENABLE_SHFT                        1
#define HWIO_CP_R1_REG_ACCESS_EVENT_GEN_CTRL_READ_ACCESS_REPORT_ENABLE_BMSK                       0x1
#define HWIO_CP_R1_REG_ACCESS_EVENT_GEN_CTRL_READ_ACCESS_REPORT_ENABLE_SHFT                         0

#define HWIO_CP_R1_SM_STATES_ADDR(x)                                                       ((x) + 0x504)
#define HWIO_CP_R1_SM_STATES_PHYS(x)                                                       ((x) + 0x504)
#define HWIO_CP_R1_SM_STATES_OFFS                                                          (0x504)
#define HWIO_CP_R1_SM_STATES_RMSK                                                          0xffffffff
#define HWIO_CP_R1_SM_STATES_POR                                                           0x00000000
#define HWIO_CP_R1_SM_STATES_POR_RMSK                                                      0xffffffff
#define HWIO_CP_R1_SM_STATES_ATTR                                                                       0x1
#define HWIO_CP_R1_SM_STATES_IN(x)            \
                in_dword(HWIO_CP_R1_SM_STATES_ADDR(x))
#define HWIO_CP_R1_SM_STATES_INM(x, m)            \
                in_dword_masked(HWIO_CP_R1_SM_STATES_ADDR(x), m)
#define HWIO_CP_R1_SM_STATES_MISC_BMSK                                                     0xfffffc00
#define HWIO_CP_R1_SM_STATES_MISC_SHFT                                                             10
#define HWIO_CP_R1_SM_STATES_STATE_INFO_BMSK                                                    0x3e0
#define HWIO_CP_R1_SM_STATES_STATE_INFO_SHFT                                                        5
#define HWIO_CP_R1_SM_STATES_STATE_MAIN_BMSK                                                     0x1f
#define HWIO_CP_R1_SM_STATES_STATE_MAIN_SHFT                                                        0

#define HWIO_CP_R1_END_OF_TEST_CHECK_ADDR(x)                                               ((x) + 0x508)
#define HWIO_CP_R1_END_OF_TEST_CHECK_PHYS(x)                                               ((x) + 0x508)
#define HWIO_CP_R1_END_OF_TEST_CHECK_OFFS                                                  (0x508)
#define HWIO_CP_R1_END_OF_TEST_CHECK_RMSK                                                         0x1
#define HWIO_CP_R1_END_OF_TEST_CHECK_POR                                                   0x00000000
#define HWIO_CP_R1_END_OF_TEST_CHECK_POR_RMSK                                              0xffffffff
#define HWIO_CP_R1_END_OF_TEST_CHECK_ATTR                                                               0x3
#define HWIO_CP_R1_END_OF_TEST_CHECK_IN(x)            \
                in_dword(HWIO_CP_R1_END_OF_TEST_CHECK_ADDR(x))
#define HWIO_CP_R1_END_OF_TEST_CHECK_INM(x, m)            \
                in_dword_masked(HWIO_CP_R1_END_OF_TEST_CHECK_ADDR(x), m)
#define HWIO_CP_R1_END_OF_TEST_CHECK_OUT(x, v)            \
                out_dword(HWIO_CP_R1_END_OF_TEST_CHECK_ADDR(x),v)
#define HWIO_CP_R1_END_OF_TEST_CHECK_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_CP_R1_END_OF_TEST_CHECK_ADDR(x),m,v,HWIO_CP_R1_END_OF_TEST_CHECK_IN(x))
#define HWIO_CP_R1_END_OF_TEST_CHECK_END_OF_TEST_SELF_CHECK_BMSK                                  0x1
#define HWIO_CP_R1_END_OF_TEST_CHECK_END_OF_TEST_SELF_CHECK_SHFT                                    0

/*----------------------------------------------------------------------------
 * MODULE: UMAC_NOC
 *--------------------------------------------------------------------------*/

#define UMAC_NOC_REG_BASE                                                                                       (UMAC_NOC_BASE      + 0x00000000)
#define UMAC_NOC_REG_BASE_SIZE                                                                                  0x4200
#define UMAC_NOC_REG_BASE_USED                                                                                  0x4180
#define UMAC_NOC_REG_BASE_PHYS                                                                                  (UMAC_NOC_BASE_PHYS + 0x00000000)
#define UMAC_NOC_REG_BASE_OFFS                                                                                  0x00000000

#define HWIO_UMAC_NOC_ERL_SWID_LOW_ADDR(x)                                                                      ((x) + 0x0)
#define HWIO_UMAC_NOC_ERL_SWID_LOW_PHYS(x)                                                                      ((x) + 0x0)
#define HWIO_UMAC_NOC_ERL_SWID_LOW_OFFS                                                                         (0x0)
#define HWIO_UMAC_NOC_ERL_SWID_LOW_RMSK                                                                           0xffffff
#define HWIO_UMAC_NOC_ERL_SWID_LOW_POR                                                                          0x000124c9
#define HWIO_UMAC_NOC_ERL_SWID_LOW_POR_RMSK                                                                     0xffffffff
#define HWIO_UMAC_NOC_ERL_SWID_LOW_ATTR                                                                                      0x1
#define HWIO_UMAC_NOC_ERL_SWID_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_ERL_SWID_LOW_ADDR(x))
#define HWIO_UMAC_NOC_ERL_SWID_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_ERL_SWID_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_ERL_SWID_LOW_UNITTYPEID_BMSK                                                                0xff0000
#define HWIO_UMAC_NOC_ERL_SWID_LOW_UNITTYPEID_SHFT                                                                      16
#define HWIO_UMAC_NOC_ERL_SWID_LOW_UNITCONFID_BMSK                                                                  0xffff
#define HWIO_UMAC_NOC_ERL_SWID_LOW_UNITCONFID_SHFT                                                                       0

#define HWIO_UMAC_NOC_ERL_SWID_HIGH_ADDR(x)                                                                     ((x) + 0x4)
#define HWIO_UMAC_NOC_ERL_SWID_HIGH_PHYS(x)                                                                     ((x) + 0x4)
#define HWIO_UMAC_NOC_ERL_SWID_HIGH_OFFS                                                                        (0x4)
#define HWIO_UMAC_NOC_ERL_SWID_HIGH_RMSK                                                                        0xffffffff
#define HWIO_UMAC_NOC_ERL_SWID_HIGH_POR                                                                         0xfbb160c3
#define HWIO_UMAC_NOC_ERL_SWID_HIGH_POR_RMSK                                                                    0xffffffff
#define HWIO_UMAC_NOC_ERL_SWID_HIGH_ATTR                                                                                     0x1
#define HWIO_UMAC_NOC_ERL_SWID_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_ERL_SWID_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_ERL_SWID_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_ERL_SWID_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_ERL_SWID_HIGH_QNOCID_BMSK                                                                 0xffffffff
#define HWIO_UMAC_NOC_ERL_SWID_HIGH_QNOCID_SHFT                                                                          0

#define HWIO_UMAC_NOC_ERL_MAINCTL_LOW_ADDR(x)                                                                   ((x) + 0x8)
#define HWIO_UMAC_NOC_ERL_MAINCTL_LOW_PHYS(x)                                                                   ((x) + 0x8)
#define HWIO_UMAC_NOC_ERL_MAINCTL_LOW_OFFS                                                                      (0x8)
#define HWIO_UMAC_NOC_ERL_MAINCTL_LOW_RMSK                                                                          0xff03
#define HWIO_UMAC_NOC_ERL_MAINCTL_LOW_POR                                                                       0x00000003
#define HWIO_UMAC_NOC_ERL_MAINCTL_LOW_POR_RMSK                                                                  0xffffffff
#define HWIO_UMAC_NOC_ERL_MAINCTL_LOW_ATTR                                                                                   0x3
#define HWIO_UMAC_NOC_ERL_MAINCTL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_ERL_MAINCTL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_ERL_MAINCTL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_ERL_MAINCTL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_ERL_MAINCTL_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_ERL_MAINCTL_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_ERL_MAINCTL_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_ERL_MAINCTL_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_ERL_MAINCTL_LOW_IN(x))
#define HWIO_UMAC_NOC_ERL_MAINCTL_LOW_ERRIGNORE_BMSK                                                                0xff00
#define HWIO_UMAC_NOC_ERL_MAINCTL_LOW_ERRIGNORE_SHFT                                                                     8
#define HWIO_UMAC_NOC_ERL_MAINCTL_LOW_STALLEN_BMSK                                                                     0x2
#define HWIO_UMAC_NOC_ERL_MAINCTL_LOW_STALLEN_SHFT                                                                       1
#define HWIO_UMAC_NOC_ERL_MAINCTL_LOW_FAULTEN_BMSK                                                                     0x1
#define HWIO_UMAC_NOC_ERL_MAINCTL_LOW_FAULTEN_SHFT                                                                       0

#define HWIO_UMAC_NOC_ERL_ERRVLD_LOW_ADDR(x)                                                                    ((x) + 0x10)
#define HWIO_UMAC_NOC_ERL_ERRVLD_LOW_PHYS(x)                                                                    ((x) + 0x10)
#define HWIO_UMAC_NOC_ERL_ERRVLD_LOW_OFFS                                                                       (0x10)
#define HWIO_UMAC_NOC_ERL_ERRVLD_LOW_RMSK                                                                              0x1
#define HWIO_UMAC_NOC_ERL_ERRVLD_LOW_POR                                                                        0x00000000
#define HWIO_UMAC_NOC_ERL_ERRVLD_LOW_POR_RMSK                                                                   0xffffffff
#define HWIO_UMAC_NOC_ERL_ERRVLD_LOW_ATTR                                                                                    0x1
#define HWIO_UMAC_NOC_ERL_ERRVLD_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_ERL_ERRVLD_LOW_ADDR(x))
#define HWIO_UMAC_NOC_ERL_ERRVLD_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_ERL_ERRVLD_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_ERL_ERRVLD_LOW_ERRVLD_BMSK                                                                       0x1
#define HWIO_UMAC_NOC_ERL_ERRVLD_LOW_ERRVLD_SHFT                                                                         0

#define HWIO_UMAC_NOC_ERL_ERRCLR_LOW_ADDR(x)                                                                    ((x) + 0x18)
#define HWIO_UMAC_NOC_ERL_ERRCLR_LOW_PHYS(x)                                                                    ((x) + 0x18)
#define HWIO_UMAC_NOC_ERL_ERRCLR_LOW_OFFS                                                                       (0x18)
#define HWIO_UMAC_NOC_ERL_ERRCLR_LOW_RMSK                                                                              0x1
#define HWIO_UMAC_NOC_ERL_ERRCLR_LOW_POR                                                                        0x00000000
#define HWIO_UMAC_NOC_ERL_ERRCLR_LOW_POR_RMSK                                                                   0xffffffff
#define HWIO_UMAC_NOC_ERL_ERRCLR_LOW_ATTR                                                                                    0x2
#define HWIO_UMAC_NOC_ERL_ERRCLR_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_ERL_ERRCLR_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_ERL_ERRCLR_LOW_ERRCLR_BMSK                                                                       0x1
#define HWIO_UMAC_NOC_ERL_ERRCLR_LOW_ERRCLR_SHFT                                                                         0

#define HWIO_UMAC_NOC_ERL_ERRLOG0_LOW_ADDR(x)                                                                   ((x) + 0x20)
#define HWIO_UMAC_NOC_ERL_ERRLOG0_LOW_PHYS(x)                                                                   ((x) + 0x20)
#define HWIO_UMAC_NOC_ERL_ERRLOG0_LOW_OFFS                                                                      (0x20)
#define HWIO_UMAC_NOC_ERL_ERRLOG0_LOW_RMSK                                                                       0xf3f7777
#define HWIO_UMAC_NOC_ERL_ERRLOG0_LOW_POR                                                                       0x00000000
#define HWIO_UMAC_NOC_ERL_ERRLOG0_LOW_POR_RMSK                                                                  0xffffffff
#define HWIO_UMAC_NOC_ERL_ERRLOG0_LOW_ATTR                                                                                   0x1
#define HWIO_UMAC_NOC_ERL_ERRLOG0_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_ERL_ERRLOG0_LOW_ADDR(x))
#define HWIO_UMAC_NOC_ERL_ERRLOG0_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_ERL_ERRLOG0_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_ERL_ERRLOG0_LOW_ATOPC_BMSK                                                                 0xf000000
#define HWIO_UMAC_NOC_ERL_ERRLOG0_LOW_ATOPC_SHFT                                                                        24
#define HWIO_UMAC_NOC_ERL_ERRLOG0_LOW_ADDRSPACE_BMSK                                                              0x3f0000
#define HWIO_UMAC_NOC_ERL_ERRLOG0_LOW_ADDRSPACE_SHFT                                                                    16
#define HWIO_UMAC_NOC_ERL_ERRLOG0_LOW_TRTYPE_BMSK                                                                   0x7000
#define HWIO_UMAC_NOC_ERL_ERRLOG0_LOW_TRTYPE_SHFT                                                                       12
#define HWIO_UMAC_NOC_ERL_ERRLOG0_LOW_ERRCODE_BMSK                                                                   0x700
#define HWIO_UMAC_NOC_ERL_ERRLOG0_LOW_ERRCODE_SHFT                                                                       8
#define HWIO_UMAC_NOC_ERL_ERRLOG0_LOW_OPC_BMSK                                                                        0x70
#define HWIO_UMAC_NOC_ERL_ERRLOG0_LOW_OPC_SHFT                                                                           4
#define HWIO_UMAC_NOC_ERL_ERRLOG0_LOW_NONSECURE_BMSK                                                                   0x4
#define HWIO_UMAC_NOC_ERL_ERRLOG0_LOW_NONSECURE_SHFT                                                                     2
#define HWIO_UMAC_NOC_ERL_ERRLOG0_LOW_WORDERROR_BMSK                                                                   0x2
#define HWIO_UMAC_NOC_ERL_ERRLOG0_LOW_WORDERROR_SHFT                                                                     1
#define HWIO_UMAC_NOC_ERL_ERRLOG0_LOW_LOGINFOVLD_BMSK                                                                  0x1
#define HWIO_UMAC_NOC_ERL_ERRLOG0_LOW_LOGINFOVLD_SHFT                                                                    0

#define HWIO_UMAC_NOC_ERL_ERRLOG0_HIGH_ADDR(x)                                                                  ((x) + 0x24)
#define HWIO_UMAC_NOC_ERL_ERRLOG0_HIGH_PHYS(x)                                                                  ((x) + 0x24)
#define HWIO_UMAC_NOC_ERL_ERRLOG0_HIGH_OFFS                                                                     (0x24)
#define HWIO_UMAC_NOC_ERL_ERRLOG0_HIGH_RMSK                                                                       0xff03ff
#define HWIO_UMAC_NOC_ERL_ERRLOG0_HIGH_POR                                                                      0x00000000
#define HWIO_UMAC_NOC_ERL_ERRLOG0_HIGH_POR_RMSK                                                                 0xffffffff
#define HWIO_UMAC_NOC_ERL_ERRLOG0_HIGH_ATTR                                                                                  0x1
#define HWIO_UMAC_NOC_ERL_ERRLOG0_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_ERL_ERRLOG0_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_ERL_ERRLOG0_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_ERL_ERRLOG0_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_ERL_ERRLOG0_HIGH_REDIRECT_BMSK                                                              0xff0000
#define HWIO_UMAC_NOC_ERL_ERRLOG0_HIGH_REDIRECT_SHFT                                                                    16
#define HWIO_UMAC_NOC_ERL_ERRLOG0_HIGH_LEN1_BMSK                                                                     0x3ff
#define HWIO_UMAC_NOC_ERL_ERRLOG0_HIGH_LEN1_SHFT                                                                         0

#define HWIO_UMAC_NOC_ERL_ERRLOG1_LOW_ADDR(x)                                                                   ((x) + 0x28)
#define HWIO_UMAC_NOC_ERL_ERRLOG1_LOW_PHYS(x)                                                                   ((x) + 0x28)
#define HWIO_UMAC_NOC_ERL_ERRLOG1_LOW_OFFS                                                                      (0x28)
#define HWIO_UMAC_NOC_ERL_ERRLOG1_LOW_RMSK                                                                          0xffff
#define HWIO_UMAC_NOC_ERL_ERRLOG1_LOW_POR                                                                       0x00000000
#define HWIO_UMAC_NOC_ERL_ERRLOG1_LOW_POR_RMSK                                                                  0xffffffff
#define HWIO_UMAC_NOC_ERL_ERRLOG1_LOW_ATTR                                                                                   0x1
#define HWIO_UMAC_NOC_ERL_ERRLOG1_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_ERL_ERRLOG1_LOW_ADDR(x))
#define HWIO_UMAC_NOC_ERL_ERRLOG1_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_ERL_ERRLOG1_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_ERL_ERRLOG1_LOW_PATH_BMSK                                                                     0xffff
#define HWIO_UMAC_NOC_ERL_ERRLOG1_LOW_PATH_SHFT                                                                          0

#define HWIO_UMAC_NOC_ERL_ERRLOG1_HIGH_ADDR(x)                                                                  ((x) + 0x2c)
#define HWIO_UMAC_NOC_ERL_ERRLOG1_HIGH_PHYS(x)                                                                  ((x) + 0x2c)
#define HWIO_UMAC_NOC_ERL_ERRLOG1_HIGH_OFFS                                                                     (0x2c)
#define HWIO_UMAC_NOC_ERL_ERRLOG1_HIGH_RMSK                                                                        0x3ffff
#define HWIO_UMAC_NOC_ERL_ERRLOG1_HIGH_POR                                                                      0x00000000
#define HWIO_UMAC_NOC_ERL_ERRLOG1_HIGH_POR_RMSK                                                                 0xffffffff
#define HWIO_UMAC_NOC_ERL_ERRLOG1_HIGH_ATTR                                                                                  0x1
#define HWIO_UMAC_NOC_ERL_ERRLOG1_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_ERL_ERRLOG1_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_ERL_ERRLOG1_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_ERL_ERRLOG1_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_ERL_ERRLOG1_HIGH_EXTID_BMSK                                                                  0x3ffff
#define HWIO_UMAC_NOC_ERL_ERRLOG1_HIGH_EXTID_SHFT                                                                        0

#define HWIO_UMAC_NOC_ERL_ERRLOG2_LOW_ADDR(x)                                                                   ((x) + 0x30)
#define HWIO_UMAC_NOC_ERL_ERRLOG2_LOW_PHYS(x)                                                                   ((x) + 0x30)
#define HWIO_UMAC_NOC_ERL_ERRLOG2_LOW_OFFS                                                                      (0x30)
#define HWIO_UMAC_NOC_ERL_ERRLOG2_LOW_RMSK                                                                      0xffffffff
#define HWIO_UMAC_NOC_ERL_ERRLOG2_LOW_POR                                                                       0x00000000
#define HWIO_UMAC_NOC_ERL_ERRLOG2_LOW_POR_RMSK                                                                  0xffffffff
#define HWIO_UMAC_NOC_ERL_ERRLOG2_LOW_ATTR                                                                                   0x1
#define HWIO_UMAC_NOC_ERL_ERRLOG2_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_ERL_ERRLOG2_LOW_ADDR(x))
#define HWIO_UMAC_NOC_ERL_ERRLOG2_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_ERL_ERRLOG2_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_ERL_ERRLOG2_LOW_ERRLOG2_LSB_BMSK                                                          0xffffffff
#define HWIO_UMAC_NOC_ERL_ERRLOG2_LOW_ERRLOG2_LSB_SHFT                                                                   0

#define HWIO_UMAC_NOC_ERL_ERRLOG2_HIGH_ADDR(x)                                                                  ((x) + 0x34)
#define HWIO_UMAC_NOC_ERL_ERRLOG2_HIGH_PHYS(x)                                                                  ((x) + 0x34)
#define HWIO_UMAC_NOC_ERL_ERRLOG2_HIGH_OFFS                                                                     (0x34)
#define HWIO_UMAC_NOC_ERL_ERRLOG2_HIGH_RMSK                                                                     0x7fffffff
#define HWIO_UMAC_NOC_ERL_ERRLOG2_HIGH_POR                                                                      0x00000000
#define HWIO_UMAC_NOC_ERL_ERRLOG2_HIGH_POR_RMSK                                                                 0xffffffff
#define HWIO_UMAC_NOC_ERL_ERRLOG2_HIGH_ATTR                                                                                  0x1
#define HWIO_UMAC_NOC_ERL_ERRLOG2_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_ERL_ERRLOG2_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_ERL_ERRLOG2_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_ERL_ERRLOG2_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_ERL_ERRLOG2_HIGH_ERRLOG2_MSB_BMSK                                                         0x7fffffff
#define HWIO_UMAC_NOC_ERL_ERRLOG2_HIGH_ERRLOG2_MSB_SHFT                                                                  0

#define HWIO_UMAC_NOC_ERL_ERRLOG3_LOW_ADDR(x)                                                                   ((x) + 0x38)
#define HWIO_UMAC_NOC_ERL_ERRLOG3_LOW_PHYS(x)                                                                   ((x) + 0x38)
#define HWIO_UMAC_NOC_ERL_ERRLOG3_LOW_OFFS                                                                      (0x38)
#define HWIO_UMAC_NOC_ERL_ERRLOG3_LOW_RMSK                                                                      0xffffffff
#define HWIO_UMAC_NOC_ERL_ERRLOG3_LOW_POR                                                                       0x00000000
#define HWIO_UMAC_NOC_ERL_ERRLOG3_LOW_POR_RMSK                                                                  0xffffffff
#define HWIO_UMAC_NOC_ERL_ERRLOG3_LOW_ATTR                                                                                   0x1
#define HWIO_UMAC_NOC_ERL_ERRLOG3_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_ERL_ERRLOG3_LOW_ADDR(x))
#define HWIO_UMAC_NOC_ERL_ERRLOG3_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_ERL_ERRLOG3_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_ERL_ERRLOG3_LOW_ERRLOG3_LSB_BMSK                                                          0xffffffff
#define HWIO_UMAC_NOC_ERL_ERRLOG3_LOW_ERRLOG3_LSB_SHFT                                                                   0

#define HWIO_UMAC_NOC_ERL_ERRLOG3_HIGH_ADDR(x)                                                                  ((x) + 0x3c)
#define HWIO_UMAC_NOC_ERL_ERRLOG3_HIGH_PHYS(x)                                                                  ((x) + 0x3c)
#define HWIO_UMAC_NOC_ERL_ERRLOG3_HIGH_OFFS                                                                     (0x3c)
#define HWIO_UMAC_NOC_ERL_ERRLOG3_HIGH_RMSK                                                                     0xffffffff
#define HWIO_UMAC_NOC_ERL_ERRLOG3_HIGH_POR                                                                      0x00000000
#define HWIO_UMAC_NOC_ERL_ERRLOG3_HIGH_POR_RMSK                                                                 0xffffffff
#define HWIO_UMAC_NOC_ERL_ERRLOG3_HIGH_ATTR                                                                                  0x1
#define HWIO_UMAC_NOC_ERL_ERRLOG3_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_ERL_ERRLOG3_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_ERL_ERRLOG3_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_ERL_ERRLOG3_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_ERL_ERRLOG3_HIGH_ERRLOG3_MSB_BMSK                                                         0xffffffff
#define HWIO_UMAC_NOC_ERL_ERRLOG3_HIGH_ERRLOG3_MSB_SHFT                                                                  0

#define HWIO_UMAC_NOC_DCD_SWID_LOW_ADDR(x)                                                                      ((x) + 0x100)
#define HWIO_UMAC_NOC_DCD_SWID_LOW_PHYS(x)                                                                      ((x) + 0x100)
#define HWIO_UMAC_NOC_DCD_SWID_LOW_OFFS                                                                         (0x100)
#define HWIO_UMAC_NOC_DCD_SWID_LOW_RMSK                                                                           0xffffff
#define HWIO_UMAC_NOC_DCD_SWID_LOW_POR                                                                          0x0000e93b
#define HWIO_UMAC_NOC_DCD_SWID_LOW_POR_RMSK                                                                     0xffffffff
#define HWIO_UMAC_NOC_DCD_SWID_LOW_ATTR                                                                                      0x1
#define HWIO_UMAC_NOC_DCD_SWID_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_DCD_SWID_LOW_ADDR(x))
#define HWIO_UMAC_NOC_DCD_SWID_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_DCD_SWID_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_DCD_SWID_LOW_UNITTYPEID_BMSK                                                                0xff0000
#define HWIO_UMAC_NOC_DCD_SWID_LOW_UNITTYPEID_SHFT                                                                      16
#define HWIO_UMAC_NOC_DCD_SWID_LOW_UNITCONFID_BMSK                                                                  0xffff
#define HWIO_UMAC_NOC_DCD_SWID_LOW_UNITCONFID_SHFT                                                                       0

#define HWIO_UMAC_NOC_DCD_SWID_HIGH_ADDR(x)                                                                     ((x) + 0x104)
#define HWIO_UMAC_NOC_DCD_SWID_HIGH_PHYS(x)                                                                     ((x) + 0x104)
#define HWIO_UMAC_NOC_DCD_SWID_HIGH_OFFS                                                                        (0x104)
#define HWIO_UMAC_NOC_DCD_SWID_HIGH_RMSK                                                                        0xffffffff
#define HWIO_UMAC_NOC_DCD_SWID_HIGH_POR                                                                         0xfbb160c3
#define HWIO_UMAC_NOC_DCD_SWID_HIGH_POR_RMSK                                                                    0xffffffff
#define HWIO_UMAC_NOC_DCD_SWID_HIGH_ATTR                                                                                     0x1
#define HWIO_UMAC_NOC_DCD_SWID_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_DCD_SWID_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_DCD_SWID_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_DCD_SWID_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_DCD_SWID_HIGH_QNOCID_BMSK                                                                 0xffffffff
#define HWIO_UMAC_NOC_DCD_SWID_HIGH_QNOCID_SHFT                                                                          0

#define HWIO_UMAC_NOC_DCD_MAXDIV_LOW_ADDR(x)                                                                    ((x) + 0x108)
#define HWIO_UMAC_NOC_DCD_MAXDIV_LOW_PHYS(x)                                                                    ((x) + 0x108)
#define HWIO_UMAC_NOC_DCD_MAXDIV_LOW_OFFS                                                                       (0x108)
#define HWIO_UMAC_NOC_DCD_MAXDIV_LOW_RMSK                                                                              0x7
#define HWIO_UMAC_NOC_DCD_MAXDIV_LOW_POR                                                                        0x00000000
#define HWIO_UMAC_NOC_DCD_MAXDIV_LOW_POR_RMSK                                                                   0xffffffff
#define HWIO_UMAC_NOC_DCD_MAXDIV_LOW_ATTR                                                                                    0x3
#define HWIO_UMAC_NOC_DCD_MAXDIV_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_DCD_MAXDIV_LOW_ADDR(x))
#define HWIO_UMAC_NOC_DCD_MAXDIV_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_DCD_MAXDIV_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_DCD_MAXDIV_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_DCD_MAXDIV_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_DCD_MAXDIV_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_DCD_MAXDIV_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_DCD_MAXDIV_LOW_IN(x))
#define HWIO_UMAC_NOC_DCD_MAXDIV_LOW_MAXDIV_BMSK                                                                       0x7
#define HWIO_UMAC_NOC_DCD_MAXDIV_LOW_MAXDIV_SHFT                                                                         0

#define HWIO_UMAC_NOC_DCD_FIRSTHYSTCNT_LOW_ADDR(x)                                                              ((x) + 0x110)
#define HWIO_UMAC_NOC_DCD_FIRSTHYSTCNT_LOW_PHYS(x)                                                              ((x) + 0x110)
#define HWIO_UMAC_NOC_DCD_FIRSTHYSTCNT_LOW_OFFS                                                                 (0x110)
#define HWIO_UMAC_NOC_DCD_FIRSTHYSTCNT_LOW_RMSK                                                                     0xffff
#define HWIO_UMAC_NOC_DCD_FIRSTHYSTCNT_LOW_POR                                                                  0x00000100
#define HWIO_UMAC_NOC_DCD_FIRSTHYSTCNT_LOW_POR_RMSK                                                             0xffffffff
#define HWIO_UMAC_NOC_DCD_FIRSTHYSTCNT_LOW_ATTR                                                                              0x3
#define HWIO_UMAC_NOC_DCD_FIRSTHYSTCNT_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_DCD_FIRSTHYSTCNT_LOW_ADDR(x))
#define HWIO_UMAC_NOC_DCD_FIRSTHYSTCNT_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_DCD_FIRSTHYSTCNT_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_DCD_FIRSTHYSTCNT_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_DCD_FIRSTHYSTCNT_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_DCD_FIRSTHYSTCNT_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_DCD_FIRSTHYSTCNT_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_DCD_FIRSTHYSTCNT_LOW_IN(x))
#define HWIO_UMAC_NOC_DCD_FIRSTHYSTCNT_LOW_FIRSTHYSTCNT_BMSK                                                        0xffff
#define HWIO_UMAC_NOC_DCD_FIRSTHYSTCNT_LOW_FIRSTHYSTCNT_SHFT                                                             0

#define HWIO_UMAC_NOC_DCD_NEXTHYSTCNT_LOW_ADDR(x)                                                               ((x) + 0x118)
#define HWIO_UMAC_NOC_DCD_NEXTHYSTCNT_LOW_PHYS(x)                                                               ((x) + 0x118)
#define HWIO_UMAC_NOC_DCD_NEXTHYSTCNT_LOW_OFFS                                                                  (0x118)
#define HWIO_UMAC_NOC_DCD_NEXTHYSTCNT_LOW_RMSK                                                                       0xfff
#define HWIO_UMAC_NOC_DCD_NEXTHYSTCNT_LOW_POR                                                                   0x00000080
#define HWIO_UMAC_NOC_DCD_NEXTHYSTCNT_LOW_POR_RMSK                                                              0xffffffff
#define HWIO_UMAC_NOC_DCD_NEXTHYSTCNT_LOW_ATTR                                                                               0x3
#define HWIO_UMAC_NOC_DCD_NEXTHYSTCNT_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_DCD_NEXTHYSTCNT_LOW_ADDR(x))
#define HWIO_UMAC_NOC_DCD_NEXTHYSTCNT_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_DCD_NEXTHYSTCNT_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_DCD_NEXTHYSTCNT_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_DCD_NEXTHYSTCNT_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_DCD_NEXTHYSTCNT_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_DCD_NEXTHYSTCNT_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_DCD_NEXTHYSTCNT_LOW_IN(x))
#define HWIO_UMAC_NOC_DCD_NEXTHYSTCNT_LOW_NEXTHYSTCNT_BMSK                                                           0xfff
#define HWIO_UMAC_NOC_DCD_NEXTHYSTCNT_LOW_NEXTHYSTCNT_SHFT                                                               0

#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SWID_LOW_ADDR(x)                                                  ((x) + 0x200)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SWID_LOW_PHYS(x)                                                  ((x) + 0x200)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SWID_LOW_OFFS                                                     (0x200)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SWID_LOW_RMSK                                                       0xffffff
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SWID_LOW_POR                                                      0x000e3a95
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SWID_LOW_POR_RMSK                                                 0xffffffff
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SWID_LOW_ATTR                                                                  0x1
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SWID_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SWID_LOW_ADDR(x))
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SWID_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SWID_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SWID_LOW_UNITTYPEID_BMSK                                            0xff0000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SWID_LOW_UNITTYPEID_SHFT                                                  16
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SWID_LOW_UNITCONFID_BMSK                                              0xffff
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SWID_LOW_UNITCONFID_SHFT                                                   0

#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SWID_HIGH_ADDR(x)                                                 ((x) + 0x204)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SWID_HIGH_PHYS(x)                                                 ((x) + 0x204)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SWID_HIGH_OFFS                                                    (0x204)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SWID_HIGH_RMSK                                                    0xffffffff
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SWID_HIGH_POR                                                     0xfbb160c3
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SWID_HIGH_POR_RMSK                                                0xffffffff
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SWID_HIGH_ATTR                                                                 0x1
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SWID_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SWID_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SWID_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SWID_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SWID_HIGH_QNOCID_BMSK                                             0xffffffff
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SWID_HIGH_QNOCID_SHFT                                                      0

#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_ADDR(x)                                            ((x) + 0x240)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PHYS(x)                                            ((x) + 0x240)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_OFFS                                               (0x240)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_RMSK                                                   0xffff
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_POR                                                0x00000000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_POR_RMSK                                           0xffffffff
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_ATTR                                                            0x3
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_ADDR(x))
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_IN(x))
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT15_BMSK                                            0x8000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT15_SHFT                                                15
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT14_BMSK                                            0x4000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT14_SHFT                                                14
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT13_BMSK                                            0x2000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT13_SHFT                                                13
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT12_BMSK                                            0x1000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT12_SHFT                                                12
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT11_BMSK                                             0x800
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT11_SHFT                                                11
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT10_BMSK                                             0x400
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT10_SHFT                                                10
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT9_BMSK                                              0x200
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT9_SHFT                                                  9
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT8_BMSK                                              0x100
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT8_SHFT                                                  8
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT7_BMSK                                               0x80
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT7_SHFT                                                  7
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT6_BMSK                                               0x40
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT6_SHFT                                                  6
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT5_BMSK                                               0x20
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT5_SHFT                                                  5
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT4_BMSK                                               0x10
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT4_SHFT                                                  4
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT3_BMSK                                                0x8
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT3_SHFT                                                  3
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT2_BMSK                                                0x4
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT2_SHFT                                                  2
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT1_BMSK                                                0x2
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT1_SHFT                                                  1
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT0_BMSK                                                0x1
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINEN0_LOW_PORT0_SHFT                                                  0

#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_ADDR(x)                                        ((x) + 0x248)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PHYS(x)                                        ((x) + 0x248)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_OFFS                                           (0x248)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_RMSK                                               0xffff
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_POR                                            0x00000000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_POR_RMSK                                       0xffffffff
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_ATTR                                                        0x1
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_ADDR(x))
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT15_BMSK                                        0x8000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT15_SHFT                                            15
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT14_BMSK                                        0x4000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT14_SHFT                                            14
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT13_BMSK                                        0x2000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT13_SHFT                                            13
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT12_BMSK                                        0x1000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT12_SHFT                                            12
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT11_BMSK                                         0x800
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT11_SHFT                                            11
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT10_BMSK                                         0x400
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT10_SHFT                                            10
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT9_BMSK                                          0x200
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT9_SHFT                                              9
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT8_BMSK                                          0x100
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT8_SHFT                                              8
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT7_BMSK                                           0x80
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT7_SHFT                                              7
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT6_BMSK                                           0x40
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT6_SHFT                                              6
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT5_BMSK                                           0x20
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT5_SHFT                                              5
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT4_BMSK                                           0x10
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT4_SHFT                                              4
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT3_BMSK                                            0x8
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT3_SHFT                                              3
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT2_BMSK                                            0x4
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT2_SHFT                                              2
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT1_BMSK                                            0x2
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT1_SHFT                                              1
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT0_BMSK                                            0x1
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FAULTINSTATUS0_LOW_PORT0_SHFT                                              0

#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTCLR0_LOW_ADDR(x)                                           ((x) + 0x280)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTCLR0_LOW_PHYS(x)                                           ((x) + 0x280)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTCLR0_LOW_OFFS                                              (0x280)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTCLR0_LOW_RMSK                                                  0x2f7e
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTCLR0_LOW_POR                                               0x00000000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTCLR0_LOW_POR_RMSK                                          0xffffffff
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTCLR0_LOW_ATTR                                                           0x2
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTCLR0_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTCLR0_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTCLR0_LOW_PORT13_BMSK                                           0x2000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTCLR0_LOW_PORT13_SHFT                                               13
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTCLR0_LOW_PORT11_BMSK                                            0x800
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTCLR0_LOW_PORT11_SHFT                                               11
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTCLR0_LOW_PORT10_BMSK                                            0x400
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTCLR0_LOW_PORT10_SHFT                                               10
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTCLR0_LOW_PORT9_BMSK                                             0x200
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTCLR0_LOW_PORT9_SHFT                                                 9
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTCLR0_LOW_PORT8_BMSK                                             0x100
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTCLR0_LOW_PORT8_SHFT                                                 8
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTCLR0_LOW_PORT6_BMSK                                              0x40
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTCLR0_LOW_PORT6_SHFT                                                 6
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTCLR0_LOW_PORT5_BMSK                                              0x20
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTCLR0_LOW_PORT5_SHFT                                                 5
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTCLR0_LOW_PORT4_BMSK                                              0x10
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTCLR0_LOW_PORT4_SHFT                                                 4
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTCLR0_LOW_PORT3_BMSK                                               0x8
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTCLR0_LOW_PORT3_SHFT                                                 3
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTCLR0_LOW_PORT2_BMSK                                               0x4
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTCLR0_LOW_PORT2_SHFT                                                 2
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTCLR0_LOW_PORT1_BMSK                                               0x2
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTCLR0_LOW_PORT1_SHFT                                                 1

#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSET0_LOW_ADDR(x)                                           ((x) + 0x288)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSET0_LOW_PHYS(x)                                           ((x) + 0x288)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSET0_LOW_OFFS                                              (0x288)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSET0_LOW_RMSK                                                  0x2f7e
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSET0_LOW_POR                                               0x00000000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSET0_LOW_POR_RMSK                                          0xffffffff
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSET0_LOW_ATTR                                                           0x2
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSET0_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSET0_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSET0_LOW_PORT13_BMSK                                           0x2000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSET0_LOW_PORT13_SHFT                                               13
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSET0_LOW_PORT11_BMSK                                            0x800
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSET0_LOW_PORT11_SHFT                                               11
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSET0_LOW_PORT10_BMSK                                            0x400
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSET0_LOW_PORT10_SHFT                                               10
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSET0_LOW_PORT9_BMSK                                             0x200
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSET0_LOW_PORT9_SHFT                                                 9
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSET0_LOW_PORT8_BMSK                                             0x100
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSET0_LOW_PORT8_SHFT                                                 8
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSET0_LOW_PORT6_BMSK                                              0x40
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSET0_LOW_PORT6_SHFT                                                 6
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSET0_LOW_PORT5_BMSK                                              0x20
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSET0_LOW_PORT5_SHFT                                                 5
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSET0_LOW_PORT4_BMSK                                              0x10
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSET0_LOW_PORT4_SHFT                                                 4
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSET0_LOW_PORT3_BMSK                                               0x8
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSET0_LOW_PORT3_SHFT                                                 3
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSET0_LOW_PORT2_BMSK                                               0x4
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSET0_LOW_PORT2_SHFT                                                 2
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSET0_LOW_PORT1_BMSK                                               0x2
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSET0_LOW_PORT1_SHFT                                                 1

#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_ADDR(x)                                        ((x) + 0x290)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_PHYS(x)                                        ((x) + 0x290)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_OFFS                                           (0x290)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_RMSK                                               0x2f7e
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_POR                                            0x00002f7e
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_POR_RMSK                                       0xffffffff
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_ATTR                                                        0x1
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_ADDR(x))
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_PORT13_BMSK                                        0x2000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_PORT13_SHFT                                            13
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_PORT11_BMSK                                         0x800
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_PORT11_SHFT                                            11
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_PORT10_BMSK                                         0x400
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_PORT10_SHFT                                            10
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_PORT9_BMSK                                          0x200
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_PORT9_SHFT                                              9
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_PORT8_BMSK                                          0x100
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_PORT8_SHFT                                              8
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_PORT6_BMSK                                           0x40
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_PORT6_SHFT                                              6
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_PORT5_BMSK                                           0x20
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_PORT5_SHFT                                              5
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_PORT4_BMSK                                           0x10
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_PORT4_SHFT                                              4
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_PORT3_BMSK                                            0x8
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_PORT3_SHFT                                              3
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_PORT2_BMSK                                            0x4
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_PORT2_SHFT                                              2
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_PORT1_BMSK                                            0x2
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_FLAGOUTSTATUS0_LOW_PORT1_SHFT                                              1

#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_ADDR(x)                                              ((x) + 0x300)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_PHYS(x)                                              ((x) + 0x300)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_OFFS                                                 (0x300)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_RMSK                                                     0x2f7e
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_POR                                                  0x00000000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_POR_RMSK                                             0xffffffff
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_ATTR                                                              0x1
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_ADDR(x))
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_PORT13_BMSK                                              0x2000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_PORT13_SHFT                                                  13
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_PORT11_BMSK                                               0x800
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_PORT11_SHFT                                                  11
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_PORT10_BMSK                                               0x400
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_PORT10_SHFT                                                  10
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_PORT9_BMSK                                                0x200
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_PORT9_SHFT                                                    9
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_PORT8_BMSK                                                0x100
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_PORT8_SHFT                                                    8
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_PORT6_BMSK                                                 0x40
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_PORT6_SHFT                                                    6
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_PORT5_BMSK                                                 0x20
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_PORT5_SHFT                                                    5
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_PORT4_BMSK                                                 0x10
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_PORT4_SHFT                                                    4
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_PORT3_BMSK                                                  0x8
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_PORT3_SHFT                                                    3
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_PORT2_BMSK                                                  0x4
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_PORT2_SHFT                                                    2
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_PORT1_BMSK                                                  0x2
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_ERR_SBM_SENSEIN0_LOW_PORT1_SHFT                                                    1

#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SWID_LOW_ADDR(x)                                                  ((x) + 0x600)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SWID_LOW_PHYS(x)                                                  ((x) + 0x600)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SWID_LOW_OFFS                                                     (0x600)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SWID_LOW_RMSK                                                       0xffffff
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SWID_LOW_POR                                                      0x000e9029
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SWID_LOW_POR_RMSK                                                 0xffffffff
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SWID_LOW_ATTR                                                                  0x1
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SWID_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SWID_LOW_ADDR(x))
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SWID_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SWID_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SWID_LOW_UNITTYPEID_BMSK                                            0xff0000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SWID_LOW_UNITTYPEID_SHFT                                                  16
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SWID_LOW_UNITCONFID_BMSK                                              0xffff
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SWID_LOW_UNITCONFID_SHFT                                                   0

#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SWID_HIGH_ADDR(x)                                                 ((x) + 0x604)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SWID_HIGH_PHYS(x)                                                 ((x) + 0x604)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SWID_HIGH_OFFS                                                    (0x604)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SWID_HIGH_RMSK                                                    0xffffffff
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SWID_HIGH_POR                                                     0xfbb160c3
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SWID_HIGH_POR_RMSK                                                0xffffffff
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SWID_HIGH_ATTR                                                                 0x1
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SWID_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SWID_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SWID_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SWID_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SWID_HIGH_QNOCID_BMSK                                             0xffffffff
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SWID_HIGH_QNOCID_SHFT                                                      0

#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINEN0_LOW_ADDR(x)                                            ((x) + 0x640)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINEN0_LOW_PHYS(x)                                            ((x) + 0x640)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINEN0_LOW_OFFS                                               (0x640)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINEN0_LOW_RMSK                                                     0x1f
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINEN0_LOW_POR                                                0x00000000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINEN0_LOW_POR_RMSK                                           0xffffffff
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINEN0_LOW_ATTR                                                            0x3
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINEN0_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINEN0_LOW_ADDR(x))
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINEN0_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINEN0_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINEN0_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINEN0_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINEN0_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINEN0_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINEN0_LOW_IN(x))
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINEN0_LOW_PORT4_BMSK                                               0x10
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINEN0_LOW_PORT4_SHFT                                                  4
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINEN0_LOW_PORT3_BMSK                                                0x8
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINEN0_LOW_PORT3_SHFT                                                  3
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINEN0_LOW_PORT2_BMSK                                                0x4
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINEN0_LOW_PORT2_SHFT                                                  2
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINEN0_LOW_PORT1_BMSK                                                0x2
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINEN0_LOW_PORT1_SHFT                                                  1
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINEN0_LOW_PORT0_BMSK                                                0x1
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINEN0_LOW_PORT0_SHFT                                                  0

#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINSTATUS0_LOW_ADDR(x)                                        ((x) + 0x648)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINSTATUS0_LOW_PHYS(x)                                        ((x) + 0x648)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINSTATUS0_LOW_OFFS                                           (0x648)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINSTATUS0_LOW_RMSK                                                 0x1f
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINSTATUS0_LOW_POR                                            0x00000000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINSTATUS0_LOW_POR_RMSK                                       0xffffffff
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINSTATUS0_LOW_ATTR                                                        0x1
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINSTATUS0_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINSTATUS0_LOW_ADDR(x))
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINSTATUS0_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINSTATUS0_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINSTATUS0_LOW_PORT4_BMSK                                           0x10
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINSTATUS0_LOW_PORT4_SHFT                                              4
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINSTATUS0_LOW_PORT3_BMSK                                            0x8
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINSTATUS0_LOW_PORT3_SHFT                                              3
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINSTATUS0_LOW_PORT2_BMSK                                            0x4
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINSTATUS0_LOW_PORT2_SHFT                                              2
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINSTATUS0_LOW_PORT1_BMSK                                            0x2
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINSTATUS0_LOW_PORT1_SHFT                                              1
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINSTATUS0_LOW_PORT0_BMSK                                            0x1
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FAULTINSTATUS0_LOW_PORT0_SHFT                                              0

#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_ADDR(x)                                           ((x) + 0x680)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PHYS(x)                                           ((x) + 0x680)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_OFFS                                              (0x680)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_RMSK                                                0xfffff7
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_POR                                               0x00000000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_POR_RMSK                                          0xffffffff
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_ATTR                                                           0x2
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT23_BMSK                                         0x800000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT23_SHFT                                               23
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT22_BMSK                                         0x400000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT22_SHFT                                               22
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT21_BMSK                                         0x200000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT21_SHFT                                               21
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT20_BMSK                                         0x100000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT20_SHFT                                               20
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT19_BMSK                                          0x80000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT19_SHFT                                               19
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT18_BMSK                                          0x40000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT18_SHFT                                               18
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT17_BMSK                                          0x20000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT17_SHFT                                               17
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT16_BMSK                                          0x10000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT16_SHFT                                               16
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT15_BMSK                                           0x8000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT15_SHFT                                               15
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT14_BMSK                                           0x4000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT14_SHFT                                               14
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT13_BMSK                                           0x2000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT13_SHFT                                               13
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT12_BMSK                                           0x1000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT12_SHFT                                               12
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT11_BMSK                                            0x800
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT11_SHFT                                               11
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT10_BMSK                                            0x400
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT10_SHFT                                               10
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT9_BMSK                                             0x200
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT9_SHFT                                                 9
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT8_BMSK                                             0x100
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT8_SHFT                                                 8
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT7_BMSK                                              0x80
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT7_SHFT                                                 7
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT6_BMSK                                              0x40
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT6_SHFT                                                 6
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT5_BMSK                                              0x20
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT5_SHFT                                                 5
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT4_BMSK                                              0x10
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT4_SHFT                                                 4
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT2_BMSK                                               0x4
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT2_SHFT                                                 2
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT1_BMSK                                               0x2
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT1_SHFT                                                 1
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT0_BMSK                                               0x1
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTCLR0_LOW_PORT0_SHFT                                                 0

#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_ADDR(x)                                           ((x) + 0x688)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PHYS(x)                                           ((x) + 0x688)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_OFFS                                              (0x688)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_RMSK                                                0xfffff7
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_POR                                               0x00000000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_POR_RMSK                                          0xffffffff
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_ATTR                                                           0x2
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT23_BMSK                                         0x800000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT23_SHFT                                               23
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT22_BMSK                                         0x400000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT22_SHFT                                               22
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT21_BMSK                                         0x200000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT21_SHFT                                               21
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT20_BMSK                                         0x100000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT20_SHFT                                               20
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT19_BMSK                                          0x80000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT19_SHFT                                               19
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT18_BMSK                                          0x40000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT18_SHFT                                               18
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT17_BMSK                                          0x20000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT17_SHFT                                               17
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT16_BMSK                                          0x10000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT16_SHFT                                               16
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT15_BMSK                                           0x8000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT15_SHFT                                               15
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT14_BMSK                                           0x4000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT14_SHFT                                               14
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT13_BMSK                                           0x2000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT13_SHFT                                               13
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT12_BMSK                                           0x1000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT12_SHFT                                               12
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT11_BMSK                                            0x800
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT11_SHFT                                               11
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT10_BMSK                                            0x400
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT10_SHFT                                               10
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT9_BMSK                                             0x200
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT9_SHFT                                                 9
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT8_BMSK                                             0x100
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT8_SHFT                                                 8
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT7_BMSK                                              0x80
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT7_SHFT                                                 7
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT6_BMSK                                              0x40
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT6_SHFT                                                 6
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT5_BMSK                                              0x20
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT5_SHFT                                                 5
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT4_BMSK                                              0x10
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT4_SHFT                                                 4
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT2_BMSK                                               0x4
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT2_SHFT                                                 2
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT1_BMSK                                               0x2
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT1_SHFT                                                 1
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT0_BMSK                                               0x1
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSET0_LOW_PORT0_SHFT                                                 0

#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_ADDR(x)                                        ((x) + 0x690)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PHYS(x)                                        ((x) + 0x690)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_OFFS                                           (0x690)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_RMSK                                             0xfffff7
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_POR                                            0x00000001
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_POR_RMSK                                       0xffffffff
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_ATTR                                                        0x1
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_ADDR(x))
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT23_BMSK                                      0x800000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT23_SHFT                                            23
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT22_BMSK                                      0x400000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT22_SHFT                                            22
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT21_BMSK                                      0x200000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT21_SHFT                                            21
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT20_BMSK                                      0x100000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT20_SHFT                                            20
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT19_BMSK                                       0x80000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT19_SHFT                                            19
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT18_BMSK                                       0x40000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT18_SHFT                                            18
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT17_BMSK                                       0x20000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT17_SHFT                                            17
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT16_BMSK                                       0x10000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT16_SHFT                                            16
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT15_BMSK                                        0x8000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT15_SHFT                                            15
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT14_BMSK                                        0x4000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT14_SHFT                                            14
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT13_BMSK                                        0x2000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT13_SHFT                                            13
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT12_BMSK                                        0x1000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT12_SHFT                                            12
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT11_BMSK                                         0x800
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT11_SHFT                                            11
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT10_BMSK                                         0x400
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT10_SHFT                                            10
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT9_BMSK                                          0x200
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT9_SHFT                                              9
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT8_BMSK                                          0x100
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT8_SHFT                                              8
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT7_BMSK                                           0x80
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT7_SHFT                                              7
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT6_BMSK                                           0x40
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT6_SHFT                                              6
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT5_BMSK                                           0x20
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT5_SHFT                                              5
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT4_BMSK                                           0x10
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT4_SHFT                                              4
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT2_BMSK                                            0x4
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT2_SHFT                                              2
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT1_BMSK                                            0x2
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT1_SHFT                                              1
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT0_BMSK                                            0x1
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_FLAGOUTSTATUS0_LOW_PORT0_SHFT                                              0

#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_ADDR(x)                                              ((x) + 0x700)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PHYS(x)                                              ((x) + 0x700)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_OFFS                                                 (0x700)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_RMSK                                                    0xffff6
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_POR                                                  0x00000000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_POR_RMSK                                             0xffffffff
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_ATTR                                                              0x1
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_ADDR(x))
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT19_BMSK                                             0x80000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT19_SHFT                                                  19
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT18_BMSK                                             0x40000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT18_SHFT                                                  18
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT17_BMSK                                             0x20000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT17_SHFT                                                  17
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT16_BMSK                                             0x10000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT16_SHFT                                                  16
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT15_BMSK                                              0x8000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT15_SHFT                                                  15
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT14_BMSK                                              0x4000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT14_SHFT                                                  14
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT13_BMSK                                              0x2000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT13_SHFT                                                  13
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT12_BMSK                                              0x1000
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT12_SHFT                                                  12
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT11_BMSK                                               0x800
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT11_SHFT                                                  11
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT10_BMSK                                               0x400
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT10_SHFT                                                  10
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT9_BMSK                                                0x200
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT9_SHFT                                                    9
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT8_BMSK                                                0x100
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT8_SHFT                                                    8
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT7_BMSK                                                 0x80
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT7_SHFT                                                    7
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT6_BMSK                                                 0x40
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT6_SHFT                                                    6
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT5_BMSK                                                 0x20
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT5_SHFT                                                    5
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT4_BMSK                                                 0x10
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT4_SHFT                                                    4
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT2_BMSK                                                  0x4
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT2_SHFT                                                    2
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT1_BMSK                                                  0x2
#define HWIO_UMAC_NOC_SIDEBANDMANAGER_CMN_SBM_SENSEIN0_LOW_PORT1_SHFT                                                    1

#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SWID_LOW_ADDR(x)                                                         ((x) + 0x800)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SWID_LOW_PHYS(x)                                                         ((x) + 0x800)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SWID_LOW_OFFS                                                            (0x800)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SWID_LOW_RMSK                                                              0xffffff
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SWID_LOW_POR                                                             0x00083dc8
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SWID_LOW_POR_RMSK                                                        0xffffffff
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SWID_LOW_ATTR                                                                         0x1
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SWID_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SWID_LOW_ADDR(x))
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SWID_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SWID_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SWID_LOW_UNITTYPEID_BMSK                                                   0xff0000
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SWID_LOW_UNITTYPEID_SHFT                                                         16
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SWID_LOW_UNITCONFID_BMSK                                                     0xffff
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SWID_LOW_UNITCONFID_SHFT                                                          0

#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SWID_HIGH_ADDR(x)                                                        ((x) + 0x804)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SWID_HIGH_PHYS(x)                                                        ((x) + 0x804)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SWID_HIGH_OFFS                                                           (0x804)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SWID_HIGH_RMSK                                                           0xffffffff
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SWID_HIGH_POR                                                            0xfbb160c3
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SWID_HIGH_POR_RMSK                                                       0xffffffff
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SWID_HIGH_ATTR                                                                        0x1
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SWID_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SWID_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SWID_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SWID_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SWID_HIGH_QNOCID_BMSK                                                    0xffffffff
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SWID_HIGH_QNOCID_SHFT                                                             0

#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINCTL_LOW_ADDR(x)                                                      ((x) + 0x808)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINCTL_LOW_PHYS(x)                                                      ((x) + 0x808)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINCTL_LOW_OFFS                                                         (0x808)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINCTL_LOW_RMSK                                                          0x1003f3f
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINCTL_LOW_POR                                                          0x00000008
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINCTL_LOW_POR_RMSK                                                     0xffffffff
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINCTL_LOW_ATTR                                                                      0x3
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINCTL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINCTL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINCTL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINCTL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINCTL_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINCTL_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINCTL_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINCTL_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINCTL_LOW_IN(x))
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINCTL_LOW_QOSDISABLE_BMSK                                               0x1000000
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINCTL_LOW_QOSDISABLE_SHFT                                                      24
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINCTL_LOW_URGDELAY_BMSK                                                    0x3f00
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINCTL_LOW_URGDELAY_SHFT                                                         8
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINCTL_LOW_DFLTPRIORITY_BMSK                                                  0x30
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINCTL_LOW_DFLTPRIORITY_SHFT                                                     4
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINCTL_LOW_SLVURGMSGEN_BMSK                                                    0x8
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINCTL_LOW_SLVURGMSGEN_SHFT                                                      3
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINCTL_LOW_STOP_BMSK                                                           0x4
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINCTL_LOW_STOP_SHFT                                                             2
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINCTL_LOW_SHAPEREN_BMSK                                                       0x2
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINCTL_LOW_SHAPEREN_SHFT                                                         1
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINCTL_LOW_BWLIMITEN_BMSK                                                      0x1
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINCTL_LOW_BWLIMITEN_SHFT                                                        0

#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINSTATUS_LOW_ADDR(x)                                                   ((x) + 0x810)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINSTATUS_LOW_PHYS(x)                                                   ((x) + 0x810)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINSTATUS_LOW_OFFS                                                      (0x810)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINSTATUS_LOW_RMSK                                                       0xfff003f
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINSTATUS_LOW_POR                                                       0x00a00000
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINSTATUS_LOW_POR_RMSK                                                  0xffffffff
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINSTATUS_LOW_ATTR                                                                   0x1
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINSTATUS_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINSTATUS_LOW_ADDR(x))
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINSTATUS_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINSTATUS_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINSTATUS_LOW_NOMINALFREQ_BMSK                                           0xfff0000
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINSTATUS_LOW_NOMINALFREQ_SHFT                                                  16
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINSTATUS_LOW_PENDING_BMSK                                                    0x3f
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_MAINSTATUS_LOW_PENDING_SHFT                                                       0

#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_LIMITBW_LOW_ADDR(x)                                                      ((x) + 0x818)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_LIMITBW_LOW_PHYS(x)                                                      ((x) + 0x818)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_LIMITBW_LOW_OFFS                                                         (0x818)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_LIMITBW_LOW_RMSK                                                          0x3ff07ff
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_LIMITBW_LOW_POR                                                          0x00800266
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_LIMITBW_LOW_POR_RMSK                                                     0xffffffff
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_LIMITBW_LOW_ATTR                                                                      0x3
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_LIMITBW_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_LIMITBW_LOW_ADDR(x))
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_LIMITBW_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_LIMITBW_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_LIMITBW_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_LIMITBW_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_LIMITBW_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_LIMITBW_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_LIMITBW_LOW_IN(x))
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_LIMITBW_LOW_SATURATION_BMSK                                               0x3ff0000
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_LIMITBW_LOW_SATURATION_SHFT                                                      16
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_LIMITBW_LOW_BANDWIDTH_BMSK                                                    0x7ff
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_LIMITBW_LOW_BANDWIDTH_SHFT                                                        0

#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SHAPING_LOW_ADDR(x)                                                      ((x) + 0x820)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SHAPING_LOW_PHYS(x)                                                      ((x) + 0x820)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SHAPING_LOW_OFFS                                                         (0x820)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SHAPING_LOW_RMSK                                                         0x1f1f1f1f
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SHAPING_LOW_POR                                                          0x00000000
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SHAPING_LOW_POR_RMSK                                                     0xffffffff
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SHAPING_LOW_ATTR                                                                      0x3
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SHAPING_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SHAPING_LOW_ADDR(x))
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SHAPING_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SHAPING_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SHAPING_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SHAPING_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SHAPING_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SHAPING_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SHAPING_LOW_IN(x))
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SHAPING_LOW_LVL3_BMSK                                                    0x1f000000
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SHAPING_LOW_LVL3_SHFT                                                            24
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SHAPING_LOW_LVL2_BMSK                                                      0x1f0000
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SHAPING_LOW_LVL2_SHFT                                                            16
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SHAPING_LOW_LVL1_BMSK                                                        0x1f00
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SHAPING_LOW_LVL1_SHFT                                                             8
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SHAPING_LOW_LVL0_BMSK                                                          0x1f
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_SHAPING_LOW_LVL0_SHFT                                                             0

#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0CTL_LOW_ADDR(x)                                                    ((x) + 0x840)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0CTL_LOW_PHYS(x)                                                    ((x) + 0x840)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0CTL_LOW_OFFS                                                       (0x840)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0CTL_LOW_RMSK                                                           0x3303
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0CTL_LOW_POR                                                        0x00000000
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0CTL_LOW_POR_RMSK                                                   0xffffffff
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0CTL_LOW_ATTR                                                                    0x3
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0CTL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0CTL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0CTL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0CTL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0CTL_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0CTL_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0CTL_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0CTL_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0CTL_LOW_IN(x))
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0CTL_LOW_HIGHPRIORITY_BMSK                                              0x3000
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0CTL_LOW_HIGHPRIORITY_SHFT                                                  12
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0CTL_LOW_LOWPRIORITY_BMSK                                                0x300
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0CTL_LOW_LOWPRIORITY_SHFT                                                    8
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0CTL_LOW_WREN_BMSK                                                         0x2
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0CTL_LOW_WREN_SHFT                                                           1
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0CTL_LOW_RDEN_BMSK                                                         0x1
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0CTL_LOW_RDEN_SHFT                                                           0

#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0BW_LOW_ADDR(x)                                                     ((x) + 0x848)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0BW_LOW_PHYS(x)                                                     ((x) + 0x848)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0BW_LOW_OFFS                                                        (0x848)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0BW_LOW_RMSK                                                         0x3ff07ff
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0BW_LOW_POR                                                         0x00400133
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0BW_LOW_POR_RMSK                                                    0xffffffff
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0BW_LOW_ATTR                                                                     0x3
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0BW_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0BW_LOW_ADDR(x))
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0BW_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0BW_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0BW_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0BW_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0BW_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0BW_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0BW_LOW_IN(x))
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0BW_LOW_SATURATION_BMSK                                              0x3ff0000
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0BW_LOW_SATURATION_SHFT                                                     16
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0BW_LOW_BANDWIDTH_BMSK                                                   0x7ff
#define HWIO_UMAC_NOC_QNS4M_PHY_QOSGEN_REGUL0BW_LOW_BANDWIDTH_SHFT                                                       0

#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SWID_LOW_ADDR(x)                                                           ((x) + 0x880)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SWID_LOW_PHYS(x)                                                           ((x) + 0x880)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SWID_LOW_OFFS                                                              (0x880)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SWID_LOW_RMSK                                                                0xffffff
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SWID_LOW_POR                                                               0x0008b525
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SWID_LOW_POR_RMSK                                                          0xffffffff
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SWID_LOW_ATTR                                                                           0x1
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SWID_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SWID_LOW_ADDR(x))
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SWID_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SWID_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SWID_LOW_UNITTYPEID_BMSK                                                     0xff0000
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SWID_LOW_UNITTYPEID_SHFT                                                           16
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SWID_LOW_UNITCONFID_BMSK                                                       0xffff
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SWID_LOW_UNITCONFID_SHFT                                                            0

#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SWID_HIGH_ADDR(x)                                                          ((x) + 0x884)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SWID_HIGH_PHYS(x)                                                          ((x) + 0x884)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SWID_HIGH_OFFS                                                             (0x884)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SWID_HIGH_RMSK                                                             0xffffffff
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SWID_HIGH_POR                                                              0xfbb160c3
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SWID_HIGH_POR_RMSK                                                         0xffffffff
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SWID_HIGH_ATTR                                                                          0x1
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SWID_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SWID_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SWID_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SWID_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SWID_HIGH_QNOCID_BMSK                                                      0xffffffff
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SWID_HIGH_QNOCID_SHFT                                                               0

#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINCTL_LOW_ADDR(x)                                                        ((x) + 0x888)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINCTL_LOW_PHYS(x)                                                        ((x) + 0x888)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINCTL_LOW_OFFS                                                           (0x888)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINCTL_LOW_RMSK                                                            0x1003f37
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINCTL_LOW_POR                                                            0x00000000
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINCTL_LOW_POR_RMSK                                                       0xffffffff
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINCTL_LOW_ATTR                                                                        0x3
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINCTL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINCTL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINCTL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINCTL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINCTL_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINCTL_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINCTL_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINCTL_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINCTL_LOW_IN(x))
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINCTL_LOW_QOSDISABLE_BMSK                                                 0x1000000
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINCTL_LOW_QOSDISABLE_SHFT                                                        24
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINCTL_LOW_URGDELAY_BMSK                                                      0x3f00
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINCTL_LOW_URGDELAY_SHFT                                                           8
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINCTL_LOW_DFLTPRIORITY_BMSK                                                    0x30
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINCTL_LOW_DFLTPRIORITY_SHFT                                                       4
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINCTL_LOW_STOP_BMSK                                                             0x4
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINCTL_LOW_STOP_SHFT                                                               2
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINCTL_LOW_SHAPEREN_BMSK                                                         0x2
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINCTL_LOW_SHAPEREN_SHFT                                                           1
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINCTL_LOW_BWLIMITEN_BMSK                                                        0x1
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINCTL_LOW_BWLIMITEN_SHFT                                                          0

#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINSTATUS_LOW_ADDR(x)                                                     ((x) + 0x890)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINSTATUS_LOW_PHYS(x)                                                     ((x) + 0x890)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINSTATUS_LOW_OFFS                                                        (0x890)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINSTATUS_LOW_RMSK                                                         0xfff003f
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINSTATUS_LOW_POR                                                         0x00a00000
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINSTATUS_LOW_POR_RMSK                                                    0xffffffff
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINSTATUS_LOW_ATTR                                                                     0x1
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINSTATUS_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINSTATUS_LOW_ADDR(x))
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINSTATUS_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINSTATUS_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINSTATUS_LOW_NOMINALFREQ_BMSK                                             0xfff0000
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINSTATUS_LOW_NOMINALFREQ_SHFT                                                    16
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINSTATUS_LOW_PENDING_BMSK                                                      0x3f
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_MAINSTATUS_LOW_PENDING_SHFT                                                         0

#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_LIMITBW_LOW_ADDR(x)                                                        ((x) + 0x898)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_LIMITBW_LOW_PHYS(x)                                                        ((x) + 0x898)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_LIMITBW_LOW_OFFS                                                           (0x898)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_LIMITBW_LOW_RMSK                                                            0x3ff07ff
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_LIMITBW_LOW_POR                                                            0x00c000cc
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_LIMITBW_LOW_POR_RMSK                                                       0xffffffff
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_LIMITBW_LOW_ATTR                                                                        0x3
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_LIMITBW_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_XM_UMXI_QOSGEN_LIMITBW_LOW_ADDR(x))
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_LIMITBW_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_XM_UMXI_QOSGEN_LIMITBW_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_LIMITBW_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_XM_UMXI_QOSGEN_LIMITBW_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_LIMITBW_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_XM_UMXI_QOSGEN_LIMITBW_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_XM_UMXI_QOSGEN_LIMITBW_LOW_IN(x))
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_LIMITBW_LOW_SATURATION_BMSK                                                 0x3ff0000
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_LIMITBW_LOW_SATURATION_SHFT                                                        16
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_LIMITBW_LOW_BANDWIDTH_BMSK                                                      0x7ff
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_LIMITBW_LOW_BANDWIDTH_SHFT                                                          0

#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SHAPING_LOW_ADDR(x)                                                        ((x) + 0x8a0)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SHAPING_LOW_PHYS(x)                                                        ((x) + 0x8a0)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SHAPING_LOW_OFFS                                                           (0x8a0)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SHAPING_LOW_RMSK                                                           0x1f1f1f1f
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SHAPING_LOW_POR                                                            0x00000000
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SHAPING_LOW_POR_RMSK                                                       0xffffffff
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SHAPING_LOW_ATTR                                                                        0x3
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SHAPING_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SHAPING_LOW_ADDR(x))
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SHAPING_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SHAPING_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SHAPING_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SHAPING_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SHAPING_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SHAPING_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SHAPING_LOW_IN(x))
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SHAPING_LOW_LVL3_BMSK                                                      0x1f000000
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SHAPING_LOW_LVL3_SHFT                                                              24
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SHAPING_LOW_LVL2_BMSK                                                        0x1f0000
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SHAPING_LOW_LVL2_SHFT                                                              16
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SHAPING_LOW_LVL1_BMSK                                                          0x1f00
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SHAPING_LOW_LVL1_SHFT                                                               8
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SHAPING_LOW_LVL0_BMSK                                                            0x1f
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_SHAPING_LOW_LVL0_SHFT                                                               0

#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0CTL_LOW_ADDR(x)                                                      ((x) + 0x8c0)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0CTL_LOW_PHYS(x)                                                      ((x) + 0x8c0)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0CTL_LOW_OFFS                                                         (0x8c0)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0CTL_LOW_RMSK                                                             0x3303
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0CTL_LOW_POR                                                          0x00000000
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0CTL_LOW_POR_RMSK                                                     0xffffffff
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0CTL_LOW_ATTR                                                                      0x3
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0CTL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0CTL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0CTL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0CTL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0CTL_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0CTL_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0CTL_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0CTL_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0CTL_LOW_IN(x))
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0CTL_LOW_HIGHPRIORITY_BMSK                                                0x3000
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0CTL_LOW_HIGHPRIORITY_SHFT                                                    12
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0CTL_LOW_LOWPRIORITY_BMSK                                                  0x300
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0CTL_LOW_LOWPRIORITY_SHFT                                                      8
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0CTL_LOW_WREN_BMSK                                                           0x2
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0CTL_LOW_WREN_SHFT                                                             1
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0CTL_LOW_RDEN_BMSK                                                           0x1
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0CTL_LOW_RDEN_SHFT                                                             0

#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0BW_LOW_ADDR(x)                                                       ((x) + 0x8c8)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0BW_LOW_PHYS(x)                                                       ((x) + 0x8c8)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0BW_LOW_OFFS                                                          (0x8c8)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0BW_LOW_RMSK                                                           0x3ff07ff
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0BW_LOW_POR                                                           0x00600066
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0BW_LOW_POR_RMSK                                                      0xffffffff
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0BW_LOW_ATTR                                                                       0x3
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0BW_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0BW_LOW_ADDR(x))
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0BW_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0BW_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0BW_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0BW_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0BW_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0BW_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0BW_LOW_IN(x))
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0BW_LOW_SATURATION_BMSK                                                0x3ff0000
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0BW_LOW_SATURATION_SHFT                                                       16
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0BW_LOW_BANDWIDTH_BMSK                                                     0x7ff
#define HWIO_UMAC_NOC_XM_UMXI_QOSGEN_REGUL0BW_LOW_BANDWIDTH_SHFT                                                         0

#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SWID_LOW_ADDR(x)                                                           ((x) + 0x900)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SWID_LOW_PHYS(x)                                                           ((x) + 0x900)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SWID_LOW_OFFS                                                              (0x900)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SWID_LOW_RMSK                                                                0xffffff
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SWID_LOW_POR                                                               0x0008d806
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SWID_LOW_POR_RMSK                                                          0xffffffff
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SWID_LOW_ATTR                                                                           0x1
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SWID_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SWID_LOW_ADDR(x))
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SWID_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SWID_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SWID_LOW_UNITTYPEID_BMSK                                                     0xff0000
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SWID_LOW_UNITTYPEID_SHFT                                                           16
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SWID_LOW_UNITCONFID_BMSK                                                       0xffff
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SWID_LOW_UNITCONFID_SHFT                                                            0

#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SWID_HIGH_ADDR(x)                                                          ((x) + 0x904)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SWID_HIGH_PHYS(x)                                                          ((x) + 0x904)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SWID_HIGH_OFFS                                                             (0x904)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SWID_HIGH_RMSK                                                             0xffffffff
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SWID_HIGH_POR                                                              0xfbb160c3
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SWID_HIGH_POR_RMSK                                                         0xffffffff
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SWID_HIGH_ATTR                                                                          0x1
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SWID_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SWID_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SWID_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SWID_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SWID_HIGH_QNOCID_BMSK                                                      0xffffffff
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SWID_HIGH_QNOCID_SHFT                                                               0

#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINCTL_LOW_ADDR(x)                                                        ((x) + 0x908)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINCTL_LOW_PHYS(x)                                                        ((x) + 0x908)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINCTL_LOW_OFFS                                                           (0x908)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINCTL_LOW_RMSK                                                            0x1003f37
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINCTL_LOW_POR                                                            0x00000000
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINCTL_LOW_POR_RMSK                                                       0xffffffff
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINCTL_LOW_ATTR                                                                        0x3
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINCTL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINCTL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINCTL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINCTL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINCTL_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINCTL_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINCTL_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINCTL_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINCTL_LOW_IN(x))
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINCTL_LOW_QOSDISABLE_BMSK                                                 0x1000000
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINCTL_LOW_QOSDISABLE_SHFT                                                        24
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINCTL_LOW_URGDELAY_BMSK                                                      0x3f00
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINCTL_LOW_URGDELAY_SHFT                                                           8
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINCTL_LOW_DFLTPRIORITY_BMSK                                                    0x30
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINCTL_LOW_DFLTPRIORITY_SHFT                                                       4
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINCTL_LOW_STOP_BMSK                                                             0x4
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINCTL_LOW_STOP_SHFT                                                               2
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINCTL_LOW_SHAPEREN_BMSK                                                         0x2
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINCTL_LOW_SHAPEREN_SHFT                                                           1
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINCTL_LOW_BWLIMITEN_BMSK                                                        0x1
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINCTL_LOW_BWLIMITEN_SHFT                                                          0

#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINSTATUS_LOW_ADDR(x)                                                     ((x) + 0x910)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINSTATUS_LOW_PHYS(x)                                                     ((x) + 0x910)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINSTATUS_LOW_OFFS                                                        (0x910)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINSTATUS_LOW_RMSK                                                         0xfff001f
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINSTATUS_LOW_POR                                                         0x00a00000
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINSTATUS_LOW_POR_RMSK                                                    0xffffffff
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINSTATUS_LOW_ATTR                                                                     0x1
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINSTATUS_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINSTATUS_LOW_ADDR(x))
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINSTATUS_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINSTATUS_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINSTATUS_LOW_NOMINALFREQ_BMSK                                             0xfff0000
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINSTATUS_LOW_NOMINALFREQ_SHFT                                                    16
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINSTATUS_LOW_PENDING_BMSK                                                      0x1f
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_MAINSTATUS_LOW_PENDING_SHFT                                                         0

#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_LIMITBW_LOW_ADDR(x)                                                        ((x) + 0x918)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_LIMITBW_LOW_PHYS(x)                                                        ((x) + 0x918)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_LIMITBW_LOW_OFFS                                                           (0x918)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_LIMITBW_LOW_RMSK                                                            0x3ff07ff
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_LIMITBW_LOW_POR                                                            0x00c00266
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_LIMITBW_LOW_POR_RMSK                                                       0xffffffff
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_LIMITBW_LOW_ATTR                                                                        0x3
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_LIMITBW_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_XM_DMAC_QOSGEN_LIMITBW_LOW_ADDR(x))
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_LIMITBW_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_XM_DMAC_QOSGEN_LIMITBW_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_LIMITBW_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_XM_DMAC_QOSGEN_LIMITBW_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_LIMITBW_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_XM_DMAC_QOSGEN_LIMITBW_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_XM_DMAC_QOSGEN_LIMITBW_LOW_IN(x))
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_LIMITBW_LOW_SATURATION_BMSK                                                 0x3ff0000
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_LIMITBW_LOW_SATURATION_SHFT                                                        16
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_LIMITBW_LOW_BANDWIDTH_BMSK                                                      0x7ff
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_LIMITBW_LOW_BANDWIDTH_SHFT                                                          0

#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SHAPING_LOW_ADDR(x)                                                        ((x) + 0x920)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SHAPING_LOW_PHYS(x)                                                        ((x) + 0x920)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SHAPING_LOW_OFFS                                                           (0x920)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SHAPING_LOW_RMSK                                                            0xf0f0f0f
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SHAPING_LOW_POR                                                            0x00000000
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SHAPING_LOW_POR_RMSK                                                       0xffffffff
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SHAPING_LOW_ATTR                                                                        0x3
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SHAPING_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SHAPING_LOW_ADDR(x))
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SHAPING_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SHAPING_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SHAPING_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SHAPING_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SHAPING_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SHAPING_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SHAPING_LOW_IN(x))
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SHAPING_LOW_LVL3_BMSK                                                       0xf000000
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SHAPING_LOW_LVL3_SHFT                                                              24
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SHAPING_LOW_LVL2_BMSK                                                         0xf0000
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SHAPING_LOW_LVL2_SHFT                                                              16
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SHAPING_LOW_LVL1_BMSK                                                           0xf00
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SHAPING_LOW_LVL1_SHFT                                                               8
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SHAPING_LOW_LVL0_BMSK                                                             0xf
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_SHAPING_LOW_LVL0_SHFT                                                               0

#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0CTL_LOW_ADDR(x)                                                      ((x) + 0x940)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0CTL_LOW_PHYS(x)                                                      ((x) + 0x940)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0CTL_LOW_OFFS                                                         (0x940)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0CTL_LOW_RMSK                                                             0x3303
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0CTL_LOW_POR                                                          0x00000000
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0CTL_LOW_POR_RMSK                                                     0xffffffff
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0CTL_LOW_ATTR                                                                      0x3
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0CTL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0CTL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0CTL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0CTL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0CTL_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0CTL_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0CTL_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0CTL_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0CTL_LOW_IN(x))
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0CTL_LOW_HIGHPRIORITY_BMSK                                                0x3000
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0CTL_LOW_HIGHPRIORITY_SHFT                                                    12
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0CTL_LOW_LOWPRIORITY_BMSK                                                  0x300
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0CTL_LOW_LOWPRIORITY_SHFT                                                      8
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0CTL_LOW_WREN_BMSK                                                           0x2
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0CTL_LOW_WREN_SHFT                                                             1
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0CTL_LOW_RDEN_BMSK                                                           0x1
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0CTL_LOW_RDEN_SHFT                                                             0

#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0BW_LOW_ADDR(x)                                                       ((x) + 0x948)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0BW_LOW_PHYS(x)                                                       ((x) + 0x948)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0BW_LOW_OFFS                                                          (0x948)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0BW_LOW_RMSK                                                           0x3ff07ff
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0BW_LOW_POR                                                           0x00600133
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0BW_LOW_POR_RMSK                                                      0xffffffff
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0BW_LOW_ATTR                                                                       0x3
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0BW_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0BW_LOW_ADDR(x))
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0BW_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0BW_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0BW_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0BW_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0BW_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0BW_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0BW_LOW_IN(x))
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0BW_LOW_SATURATION_BMSK                                                0x3ff0000
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0BW_LOW_SATURATION_SHFT                                                       16
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0BW_LOW_BANDWIDTH_BMSK                                                     0x7ff
#define HWIO_UMAC_NOC_XM_DMAC_QOSGEN_REGUL0BW_LOW_BANDWIDTH_SHFT                                                         0

#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SWID_LOW_ADDR(x)                                                          ((x) + 0x980)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SWID_LOW_PHYS(x)                                                          ((x) + 0x980)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SWID_LOW_OFFS                                                             (0x980)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SWID_LOW_RMSK                                                               0xffffff
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SWID_LOW_POR                                                              0x0008d806
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SWID_LOW_POR_RMSK                                                         0xffffffff
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SWID_LOW_ATTR                                                                          0x1
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SWID_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SWID_LOW_ADDR(x))
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SWID_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SWID_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SWID_LOW_UNITTYPEID_BMSK                                                    0xff0000
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SWID_LOW_UNITTYPEID_SHFT                                                          16
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SWID_LOW_UNITCONFID_BMSK                                                      0xffff
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SWID_LOW_UNITCONFID_SHFT                                                           0

#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SWID_HIGH_ADDR(x)                                                         ((x) + 0x984)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SWID_HIGH_PHYS(x)                                                         ((x) + 0x984)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SWID_HIGH_OFFS                                                            (0x984)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SWID_HIGH_RMSK                                                            0xffffffff
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SWID_HIGH_POR                                                             0xfbb160c3
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SWID_HIGH_POR_RMSK                                                        0xffffffff
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SWID_HIGH_ATTR                                                                         0x1
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SWID_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SWID_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SWID_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SWID_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SWID_HIGH_QNOCID_BMSK                                                     0xffffffff
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SWID_HIGH_QNOCID_SHFT                                                              0

#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINCTL_LOW_ADDR(x)                                                       ((x) + 0x988)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINCTL_LOW_PHYS(x)                                                       ((x) + 0x988)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINCTL_LOW_OFFS                                                          (0x988)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINCTL_LOW_RMSK                                                           0x1003f37
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINCTL_LOW_POR                                                           0x00000000
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINCTL_LOW_POR_RMSK                                                      0xffffffff
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINCTL_LOW_ATTR                                                                       0x3
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINCTL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINCTL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINCTL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINCTL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINCTL_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINCTL_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINCTL_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINCTL_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINCTL_LOW_IN(x))
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINCTL_LOW_QOSDISABLE_BMSK                                                0x1000000
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINCTL_LOW_QOSDISABLE_SHFT                                                       24
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINCTL_LOW_URGDELAY_BMSK                                                     0x3f00
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINCTL_LOW_URGDELAY_SHFT                                                          8
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINCTL_LOW_DFLTPRIORITY_BMSK                                                   0x30
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINCTL_LOW_DFLTPRIORITY_SHFT                                                      4
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINCTL_LOW_STOP_BMSK                                                            0x4
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINCTL_LOW_STOP_SHFT                                                              2
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINCTL_LOW_SHAPEREN_BMSK                                                        0x2
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINCTL_LOW_SHAPEREN_SHFT                                                          1
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINCTL_LOW_BWLIMITEN_BMSK                                                       0x1
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINCTL_LOW_BWLIMITEN_SHFT                                                         0

#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINSTATUS_LOW_ADDR(x)                                                    ((x) + 0x990)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINSTATUS_LOW_PHYS(x)                                                    ((x) + 0x990)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINSTATUS_LOW_OFFS                                                       (0x990)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINSTATUS_LOW_RMSK                                                        0xfff001f
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINSTATUS_LOW_POR                                                        0x00a00000
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINSTATUS_LOW_POR_RMSK                                                   0xffffffff
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINSTATUS_LOW_ATTR                                                                    0x1
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINSTATUS_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINSTATUS_LOW_ADDR(x))
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINSTATUS_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINSTATUS_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINSTATUS_LOW_NOMINALFREQ_BMSK                                            0xfff0000
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINSTATUS_LOW_NOMINALFREQ_SHFT                                                   16
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINSTATUS_LOW_PENDING_BMSK                                                     0x1f
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_MAINSTATUS_LOW_PENDING_SHFT                                                        0

#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_LIMITBW_LOW_ADDR(x)                                                       ((x) + 0x998)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_LIMITBW_LOW_PHYS(x)                                                       ((x) + 0x998)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_LIMITBW_LOW_OFFS                                                          (0x998)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_LIMITBW_LOW_RMSK                                                           0x3ff07ff
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_LIMITBW_LOW_POR                                                           0x00c00266
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_LIMITBW_LOW_POR_RMSK                                                      0xffffffff
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_LIMITBW_LOW_ATTR                                                                       0x3
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_LIMITBW_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_LIMITBW_LOW_ADDR(x))
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_LIMITBW_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_LIMITBW_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_LIMITBW_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_LIMITBW_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_LIMITBW_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_LIMITBW_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_LIMITBW_LOW_IN(x))
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_LIMITBW_LOW_SATURATION_BMSK                                                0x3ff0000
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_LIMITBW_LOW_SATURATION_SHFT                                                       16
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_LIMITBW_LOW_BANDWIDTH_BMSK                                                     0x7ff
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_LIMITBW_LOW_BANDWIDTH_SHFT                                                         0

#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SHAPING_LOW_ADDR(x)                                                       ((x) + 0x9a0)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SHAPING_LOW_PHYS(x)                                                       ((x) + 0x9a0)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SHAPING_LOW_OFFS                                                          (0x9a0)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SHAPING_LOW_RMSK                                                           0xf0f0f0f
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SHAPING_LOW_POR                                                           0x00000000
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SHAPING_LOW_POR_RMSK                                                      0xffffffff
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SHAPING_LOW_ATTR                                                                       0x3
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SHAPING_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SHAPING_LOW_ADDR(x))
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SHAPING_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SHAPING_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SHAPING_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SHAPING_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SHAPING_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SHAPING_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SHAPING_LOW_IN(x))
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SHAPING_LOW_LVL3_BMSK                                                      0xf000000
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SHAPING_LOW_LVL3_SHFT                                                             24
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SHAPING_LOW_LVL2_BMSK                                                        0xf0000
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SHAPING_LOW_LVL2_SHFT                                                             16
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SHAPING_LOW_LVL1_BMSK                                                          0xf00
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SHAPING_LOW_LVL1_SHFT                                                              8
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SHAPING_LOW_LVL0_BMSK                                                            0xf
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_SHAPING_LOW_LVL0_SHFT                                                              0

#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0CTL_LOW_ADDR(x)                                                     ((x) + 0x9c0)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0CTL_LOW_PHYS(x)                                                     ((x) + 0x9c0)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0CTL_LOW_OFFS                                                        (0x9c0)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0CTL_LOW_RMSK                                                            0x3303
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0CTL_LOW_POR                                                         0x00000000
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0CTL_LOW_POR_RMSK                                                    0xffffffff
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0CTL_LOW_ATTR                                                                     0x3
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0CTL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0CTL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0CTL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0CTL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0CTL_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0CTL_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0CTL_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0CTL_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0CTL_LOW_IN(x))
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0CTL_LOW_HIGHPRIORITY_BMSK                                               0x3000
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0CTL_LOW_HIGHPRIORITY_SHFT                                                   12
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0CTL_LOW_LOWPRIORITY_BMSK                                                 0x300
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0CTL_LOW_LOWPRIORITY_SHFT                                                     8
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0CTL_LOW_WREN_BMSK                                                          0x2
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0CTL_LOW_WREN_SHFT                                                            1
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0CTL_LOW_RDEN_BMSK                                                          0x1
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0CTL_LOW_RDEN_SHFT                                                            0

#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0BW_LOW_ADDR(x)                                                      ((x) + 0x9c8)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0BW_LOW_PHYS(x)                                                      ((x) + 0x9c8)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0BW_LOW_OFFS                                                         (0x9c8)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0BW_LOW_RMSK                                                          0x3ff07ff
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0BW_LOW_POR                                                          0x00600133
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0BW_LOW_POR_RMSK                                                     0xffffffff
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0BW_LOW_ATTR                                                                      0x3
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0BW_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0BW_LOW_ADDR(x))
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0BW_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0BW_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0BW_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0BW_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0BW_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0BW_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0BW_LOW_IN(x))
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0BW_LOW_SATURATION_BMSK                                               0x3ff0000
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0BW_LOW_SATURATION_SHFT                                                      16
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0BW_LOW_BANDWIDTH_BMSK                                                    0x7ff
#define HWIO_UMAC_NOC_XM_PMAC0_QOSGEN_REGUL0BW_LOW_BANDWIDTH_SHFT                                                        0

#define HWIO_UMAC_NOC_STP_SWID_LOW_ADDR(x)                                                                      ((x) + 0xe00)
#define HWIO_UMAC_NOC_STP_SWID_LOW_PHYS(x)                                                                      ((x) + 0xe00)
#define HWIO_UMAC_NOC_STP_SWID_LOW_OFFS                                                                         (0xe00)
#define HWIO_UMAC_NOC_STP_SWID_LOW_RMSK                                                                           0xffffff
#define HWIO_UMAC_NOC_STP_SWID_LOW_POR                                                                          0x000ce93b
#define HWIO_UMAC_NOC_STP_SWID_LOW_POR_RMSK                                                                     0xffffffff
#define HWIO_UMAC_NOC_STP_SWID_LOW_ATTR                                                                                      0x1
#define HWIO_UMAC_NOC_STP_SWID_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_STP_SWID_LOW_ADDR(x))
#define HWIO_UMAC_NOC_STP_SWID_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_STP_SWID_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_STP_SWID_LOW_UNITTYPEID_BMSK                                                                0xff0000
#define HWIO_UMAC_NOC_STP_SWID_LOW_UNITTYPEID_SHFT                                                                      16
#define HWIO_UMAC_NOC_STP_SWID_LOW_UNITCONFID_BMSK                                                                  0xffff
#define HWIO_UMAC_NOC_STP_SWID_LOW_UNITCONFID_SHFT                                                                       0

#define HWIO_UMAC_NOC_STP_SWID_HIGH_ADDR(x)                                                                     ((x) + 0xe04)
#define HWIO_UMAC_NOC_STP_SWID_HIGH_PHYS(x)                                                                     ((x) + 0xe04)
#define HWIO_UMAC_NOC_STP_SWID_HIGH_OFFS                                                                        (0xe04)
#define HWIO_UMAC_NOC_STP_SWID_HIGH_RMSK                                                                        0xffffffff
#define HWIO_UMAC_NOC_STP_SWID_HIGH_POR                                                                         0xfbb160c3
#define HWIO_UMAC_NOC_STP_SWID_HIGH_POR_RMSK                                                                    0xffffffff
#define HWIO_UMAC_NOC_STP_SWID_HIGH_ATTR                                                                                     0x1
#define HWIO_UMAC_NOC_STP_SWID_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_STP_SWID_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_STP_SWID_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_STP_SWID_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_STP_SWID_HIGH_QNOCID_BMSK                                                                 0xffffffff
#define HWIO_UMAC_NOC_STP_SWID_HIGH_QNOCID_SHFT                                                                          0

#define HWIO_UMAC_NOC_STP_ATBEN_LOW_ADDR(x)                                                                     ((x) + 0xe08)
#define HWIO_UMAC_NOC_STP_ATBEN_LOW_PHYS(x)                                                                     ((x) + 0xe08)
#define HWIO_UMAC_NOC_STP_ATBEN_LOW_OFFS                                                                        (0xe08)
#define HWIO_UMAC_NOC_STP_ATBEN_LOW_RMSK                                                                               0x1
#define HWIO_UMAC_NOC_STP_ATBEN_LOW_POR                                                                         0x00000000
#define HWIO_UMAC_NOC_STP_ATBEN_LOW_POR_RMSK                                                                    0xffffffff
#define HWIO_UMAC_NOC_STP_ATBEN_LOW_ATTR                                                                                     0x3
#define HWIO_UMAC_NOC_STP_ATBEN_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_STP_ATBEN_LOW_ADDR(x))
#define HWIO_UMAC_NOC_STP_ATBEN_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_STP_ATBEN_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_STP_ATBEN_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_STP_ATBEN_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_STP_ATBEN_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_STP_ATBEN_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_STP_ATBEN_LOW_IN(x))
#define HWIO_UMAC_NOC_STP_ATBEN_LOW_ATBEN_BMSK                                                                         0x1
#define HWIO_UMAC_NOC_STP_ATBEN_LOW_ATBEN_SHFT                                                                           0

#define HWIO_UMAC_NOC_STP_ATBID_LOW_ADDR(x)                                                                     ((x) + 0xe10)
#define HWIO_UMAC_NOC_STP_ATBID_LOW_PHYS(x)                                                                     ((x) + 0xe10)
#define HWIO_UMAC_NOC_STP_ATBID_LOW_OFFS                                                                        (0xe10)
#define HWIO_UMAC_NOC_STP_ATBID_LOW_RMSK                                                                              0x7f
#define HWIO_UMAC_NOC_STP_ATBID_LOW_POR                                                                         0x00000000
#define HWIO_UMAC_NOC_STP_ATBID_LOW_POR_RMSK                                                                    0xffffffff
#define HWIO_UMAC_NOC_STP_ATBID_LOW_ATTR                                                                                     0x3
#define HWIO_UMAC_NOC_STP_ATBID_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_STP_ATBID_LOW_ADDR(x))
#define HWIO_UMAC_NOC_STP_ATBID_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_STP_ATBID_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_STP_ATBID_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_STP_ATBID_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_STP_ATBID_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_STP_ATBID_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_STP_ATBID_LOW_IN(x))
#define HWIO_UMAC_NOC_STP_ATBID_LOW_ATBID_BMSK                                                                        0x7f
#define HWIO_UMAC_NOC_STP_ATBID_LOW_ATBID_SHFT                                                                           0

#define HWIO_UMAC_NOC_STP_SYNCOUTPERIOD_LOW_ADDR(x)                                                             ((x) + 0xe18)
#define HWIO_UMAC_NOC_STP_SYNCOUTPERIOD_LOW_PHYS(x)                                                             ((x) + 0xe18)
#define HWIO_UMAC_NOC_STP_SYNCOUTPERIOD_LOW_OFFS                                                                (0xe18)
#define HWIO_UMAC_NOC_STP_SYNCOUTPERIOD_LOW_RMSK                                                                     0x3ff
#define HWIO_UMAC_NOC_STP_SYNCOUTPERIOD_LOW_POR                                                                 0x00000000
#define HWIO_UMAC_NOC_STP_SYNCOUTPERIOD_LOW_POR_RMSK                                                            0xffffffff
#define HWIO_UMAC_NOC_STP_SYNCOUTPERIOD_LOW_ATTR                                                                             0x3
#define HWIO_UMAC_NOC_STP_SYNCOUTPERIOD_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_STP_SYNCOUTPERIOD_LOW_ADDR(x))
#define HWIO_UMAC_NOC_STP_SYNCOUTPERIOD_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_STP_SYNCOUTPERIOD_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_STP_SYNCOUTPERIOD_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_STP_SYNCOUTPERIOD_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_STP_SYNCOUTPERIOD_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_STP_SYNCOUTPERIOD_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_STP_SYNCOUTPERIOD_LOW_IN(x))
#define HWIO_UMAC_NOC_STP_SYNCOUTPERIOD_LOW_SYNCOUTPERIOD_BMSK                                                       0x3ff
#define HWIO_UMAC_NOC_STP_SYNCOUTPERIOD_LOW_SYNCOUTPERIOD_SHFT                                                           0

#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_SWID_LOW_ADDR(x)                                                     ((x) + 0x1000)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_SWID_LOW_PHYS(x)                                                     ((x) + 0x1000)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_SWID_LOW_OFFS                                                        (0x1000)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_SWID_LOW_RMSK                                                          0xffffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_SWID_LOW_POR                                                         0x00120bec
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_SWID_LOW_POR_RMSK                                                    0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_SWID_LOW_ATTR                                                                     0x1
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_SWID_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_SWID_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_SWID_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_SWID_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_SWID_LOW_UNITTYPEID_BMSK                                               0xff0000
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_SWID_LOW_UNITTYPEID_SHFT                                                     16
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_SWID_LOW_UNITCONFID_BMSK                                                 0xffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_SWID_LOW_UNITCONFID_SHFT                                                      0

#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_SWID_HIGH_ADDR(x)                                                    ((x) + 0x1004)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_SWID_HIGH_PHYS(x)                                                    ((x) + 0x1004)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_SWID_HIGH_OFFS                                                       (0x1004)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_SWID_HIGH_RMSK                                                       0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_SWID_HIGH_POR                                                        0xfbb160c3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_SWID_HIGH_POR_RMSK                                                   0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_SWID_HIGH_ATTR                                                                    0x1
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_SWID_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_SWID_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_SWID_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_SWID_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_SWID_HIGH_QNOCID_BMSK                                                0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_SWID_HIGH_QNOCID_SHFT                                                         0

#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_MAINCTL_LOW_ADDR(x)                                                  ((x) + 0x1008)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_MAINCTL_LOW_PHYS(x)                                                  ((x) + 0x1008)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_MAINCTL_LOW_OFFS                                                     (0x1008)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_MAINCTL_LOW_RMSK                                                           0x2f
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_MAINCTL_LOW_POR                                                      0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_MAINCTL_LOW_POR_RMSK                                                 0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_MAINCTL_LOW_ATTR                                                                  0x3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_MAINCTL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_MAINCTL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_MAINCTL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_MAINCTL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_MAINCTL_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_MAINCTL_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_MAINCTL_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_MAINCTL_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_MAINCTL_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_MAINCTL_LOW_IGNORECTITRIGIN0_BMSK                                          0x20
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_MAINCTL_LOW_IGNORECTITRIGIN0_SHFT                                             5
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_MAINCTL_LOW_DUMPFORMAT_BMSK                                                 0x8
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_MAINCTL_LOW_DUMPFORMAT_SHFT                                                   3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_MAINCTL_LOW_ALARMEN_BMSK                                                    0x4
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_MAINCTL_LOW_ALARMEN_SHFT                                                      2
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_MAINCTL_LOW_DUMPEN_BMSK                                                     0x2
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_MAINCTL_LOW_DUMPEN_SHFT                                                       1
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_MAINCTL_LOW_GLBEN_BMSK                                                      0x1
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_MAINCTL_LOW_GLBEN_SHFT                                                        0

#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_EN_LOW_ADDR(x)                                                 ((x) + 0x1010)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_EN_LOW_PHYS(x)                                                 ((x) + 0x1010)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_EN_LOW_OFFS                                                    (0x1010)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_EN_LOW_RMSK                                                    0x80000003
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_EN_LOW_POR                                                     0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_EN_LOW_POR_RMSK                                                0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_EN_LOW_ATTR                                                                 0x3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_EN_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_EN_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_EN_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_EN_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_EN_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_EN_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_EN_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_EN_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_EN_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_EN_LOW_PLA_BMSK                                                0x80000000
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_EN_LOW_PLA_SHFT                                                        31
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_EN_LOW_FILTER_BMSK                                                    0x3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_EN_LOW_FILTER_SHFT                                                      0

#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_STATUS_LOW_ADDR(x)                                             ((x) + 0x1018)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_STATUS_LOW_PHYS(x)                                             ((x) + 0x1018)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_STATUS_LOW_OFFS                                                (0x1018)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_STATUS_LOW_RMSK                                                0x80000003
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_STATUS_LOW_POR                                                 0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_STATUS_LOW_POR_RMSK                                            0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_STATUS_LOW_ATTR                                                             0x1
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_STATUS_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_STATUS_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_STATUS_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_STATUS_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_STATUS_LOW_PLA_BMSK                                            0x80000000
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_STATUS_LOW_PLA_SHFT                                                    31
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_STATUS_LOW_FILTER_BMSK                                                0x3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_STATUS_LOW_FILTER_SHFT                                                  0

#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_CLR_LOW_ADDR(x)                                                ((x) + 0x1020)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_CLR_LOW_PHYS(x)                                                ((x) + 0x1020)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_CLR_LOW_OFFS                                                   (0x1020)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_CLR_LOW_RMSK                                                   0x80000003
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_CLR_LOW_POR                                                    0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_CLR_LOW_POR_RMSK                                               0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_CLR_LOW_ATTR                                                                0x2
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_CLR_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_CLR_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_CLR_LOW_PLA_BMSK                                               0x80000000
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_CLR_LOW_PLA_SHFT                                                       31
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_CLR_LOW_FILTER_BMSK                                                   0x3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ALARM_CLR_LOW_FILTER_SHFT                                                     0

#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ANDINV_LOW_ADDR(x)                                                   ((x) + 0x1028)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ANDINV_LOW_PHYS(x)                                                   ((x) + 0x1028)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ANDINV_LOW_OFFS                                                      (0x1028)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ANDINV_LOW_RMSK                                                      0x80000003
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ANDINV_LOW_POR                                                       0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ANDINV_LOW_POR_RMSK                                                  0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ANDINV_LOW_ATTR                                                                   0x3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ANDINV_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ANDINV_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ANDINV_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ANDINV_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ANDINV_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ANDINV_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ANDINV_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ANDINV_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ANDINV_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ANDINV_LOW_PLA_BMSK                                                  0x80000000
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ANDINV_LOW_PLA_SHFT                                                          31
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ANDINV_LOW_FILTER_BMSK                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_ANDINV_LOW_FILTER_SHFT                                                        0

#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_PORTSEL_LOW_ADDR(x)                                                  ((x) + 0x1030)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_PORTSEL_LOW_PHYS(x)                                                  ((x) + 0x1030)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_PORTSEL_LOW_OFFS                                                     (0x1030)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_PORTSEL_LOW_RMSK                                                            0x3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_PORTSEL_LOW_POR                                                      0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_PORTSEL_LOW_POR_RMSK                                                 0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_PORTSEL_LOW_ATTR                                                                  0x3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_PORTSEL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_PORTSEL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_PORTSEL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_PORTSEL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_PORTSEL_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_PORTSEL_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_PORTSEL_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_PORTSEL_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_PORTSEL_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_PORTSEL_LOW_PORTSEL_BMSK                                                    0x3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_PORTSEL_LOW_PORTSEL_SHFT                                                      0

#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_BASE_LOW_ADDR(x)                                      ((x) + 0x1100)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_BASE_LOW_PHYS(x)                                      ((x) + 0x1100)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_BASE_LOW_OFFS                                         (0x1100)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_BASE_LOW_RMSK                                               0x3f
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_BASE_LOW_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_BASE_LOW_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_BASE_LOW_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_BASE_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_BASE_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_BASE_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_BASE_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_BASE_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_BASE_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_BASE_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_BASE_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_BASE_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_BASE_LOW_FILTERS_0_PATH_BASE_BMSK                           0x3f
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_BASE_LOW_FILTERS_0_PATH_BASE_SHFT                              0

#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_MASK_LOW_ADDR(x)                                      ((x) + 0x1108)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_MASK_LOW_PHYS(x)                                      ((x) + 0x1108)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_MASK_LOW_OFFS                                         (0x1108)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_MASK_LOW_RMSK                                               0x3f
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_MASK_LOW_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_MASK_LOW_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_MASK_LOW_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_MASK_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_MASK_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_MASK_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_MASK_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_MASK_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_MASK_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_MASK_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_MASK_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_MASK_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_MASK_LOW_FILTERS_0_PATH_MASK_BMSK                           0x3f
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_PATH_MASK_LOW_FILTERS_0_PATH_MASK_SHFT                              0

#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_ADDR(x)                                       ((x) + 0x1120)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_PHYS(x)                                       ((x) + 0x1120)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_OFFS                                          (0x1120)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_RMSK                                          0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_POR                                           0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_POR_RMSK                                      0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_ATTR                                                       0x3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_VALUE_LSB_BMSK                                0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_VALUE_LSB_SHFT                                         6

#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_ADDR(x)                                      ((x) + 0x1124)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_PHYS(x)                                      ((x) + 0x1124)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_OFFS                                         (0x1124)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_RMSK                                                0xf
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_VALUE_MSB_BMSK                                      0xf
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_VALUE_MSB_SHFT                                        0

#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_ADDR(x)                                       ((x) + 0x1128)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_PHYS(x)                                       ((x) + 0x1128)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_OFFS                                          (0x1128)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_RMSK                                          0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_POR                                           0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_POR_RMSK                                      0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_ATTR                                                       0x3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_VALUE_LSB_BMSK                                0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_VALUE_LSB_SHFT                                         6

#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_ADDR(x)                                      ((x) + 0x112c)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_PHYS(x)                                      ((x) + 0x112c)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_OFFS                                         (0x112c)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_RMSK                                                0xf
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_VALUE_MSB_BMSK                                      0xf
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_VALUE_MSB_SHFT                                        0

#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_OPCODE_LOW_ADDR(x)                                         ((x) + 0x1138)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_OPCODE_LOW_PHYS(x)                                         ((x) + 0x1138)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_OPCODE_LOW_OFFS                                            (0x1138)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_OPCODE_LOW_RMSK                                                  0x1f
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_OPCODE_LOW_POR                                             0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_OPCODE_LOW_POR_RMSK                                        0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_OPCODE_LOW_ATTR                                                         0x3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_OPCODE_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_OPCODE_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_OPCODE_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_OPCODE_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_OPCODE_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_OPCODE_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_OPCODE_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_OPCODE_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_OPCODE_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_OPCODE_LOW_ATOMEN_BMSK                                           0x10
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_OPCODE_LOW_ATOMEN_SHFT                                              4
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_OPCODE_LOW_CMEN_BMSK                                              0x8
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_OPCODE_LOW_CMEN_SHFT                                                3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_OPCODE_LOW_EXCLEN_BMSK                                            0x4
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_OPCODE_LOW_EXCLEN_SHFT                                              2
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_OPCODE_LOW_WREN_BMSK                                              0x2
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_OPCODE_LOW_WREN_SHFT                                                1
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_OPCODE_LOW_RDEN_BMSK                                              0x1
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_OPCODE_LOW_RDEN_SHFT                                                0

#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_STATUS_LOW_ADDR(x)                                         ((x) + 0x1140)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_STATUS_LOW_PHYS(x)                                         ((x) + 0x1140)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_STATUS_LOW_OFFS                                            (0x1140)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_STATUS_LOW_RMSK                                                   0xf
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_STATUS_LOW_POR                                             0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_STATUS_LOW_POR_RMSK                                        0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_STATUS_LOW_ATTR                                                         0x3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_STATUS_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_STATUS_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_STATUS_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_STATUS_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_STATUS_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_STATUS_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_STATUS_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_STATUS_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_STATUS_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_STATUS_LOW_FAILEN_BMSK                                            0x8
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_STATUS_LOW_FAILEN_SHFT                                              3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_STATUS_LOW_RSPEEN_BMSK                                            0x4
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_STATUS_LOW_RSPEEN_SHFT                                              2
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_STATUS_LOW_ERREN_BMSK                                             0x2
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_STATUS_LOW_ERREN_SHFT                                               1
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_STATUS_LOW_REQRSPEN_BMSK                                          0x1
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_STATUS_LOW_REQRSPEN_SHFT                                            0

#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_ADDR(x)                                     ((x) + 0x1178)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_PHYS(x)                                     ((x) + 0x1178)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_OFFS                                        (0x1178)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_RMSK                                            0xffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_POR                                         0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_POR_RMSK                                    0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_ATTR                                                     0x3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_FILTERS_0_EXTID_BASE_BMSK                       0xffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_FILTERS_0_EXTID_BASE_SHFT                            0

#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_ADDR(x)                                     ((x) + 0x1180)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_PHYS(x)                                     ((x) + 0x1180)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_OFFS                                        (0x1180)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_RMSK                                            0xffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_POR                                         0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_POR_RMSK                                    0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_ATTR                                                     0x3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_FILTERS_0_EXTID_MASK_BMSK                       0xffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_FILTERS_0_EXTID_MASK_SHFT                            0

#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_BASE_LOW_ADDR(x)                                      ((x) + 0x1200)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_BASE_LOW_PHYS(x)                                      ((x) + 0x1200)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_BASE_LOW_OFFS                                         (0x1200)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_BASE_LOW_RMSK                                               0x3f
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_BASE_LOW_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_BASE_LOW_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_BASE_LOW_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_BASE_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_BASE_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_BASE_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_BASE_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_BASE_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_BASE_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_BASE_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_BASE_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_BASE_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_BASE_LOW_FILTERS_1_PATH_BASE_BMSK                           0x3f
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_BASE_LOW_FILTERS_1_PATH_BASE_SHFT                              0

#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_MASK_LOW_ADDR(x)                                      ((x) + 0x1208)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_MASK_LOW_PHYS(x)                                      ((x) + 0x1208)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_MASK_LOW_OFFS                                         (0x1208)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_MASK_LOW_RMSK                                               0x3f
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_MASK_LOW_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_MASK_LOW_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_MASK_LOW_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_MASK_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_MASK_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_MASK_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_MASK_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_MASK_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_MASK_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_MASK_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_MASK_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_MASK_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_MASK_LOW_FILTERS_1_PATH_MASK_BMSK                           0x3f
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_PATH_MASK_LOW_FILTERS_1_PATH_MASK_SHFT                              0

#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_ADDR(x)                                       ((x) + 0x1220)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_PHYS(x)                                       ((x) + 0x1220)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_OFFS                                          (0x1220)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_RMSK                                          0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_POR                                           0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_POR_RMSK                                      0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_ATTR                                                       0x3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_VALUE_LSB_BMSK                                0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_VALUE_LSB_SHFT                                         6

#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_ADDR(x)                                      ((x) + 0x1224)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_PHYS(x)                                      ((x) + 0x1224)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_OFFS                                         (0x1224)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_RMSK                                                0xf
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_VALUE_MSB_BMSK                                      0xf
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_VALUE_MSB_SHFT                                        0

#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_ADDR(x)                                       ((x) + 0x1228)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_PHYS(x)                                       ((x) + 0x1228)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_OFFS                                          (0x1228)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_RMSK                                          0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_POR                                           0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_POR_RMSK                                      0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_ATTR                                                       0x3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_VALUE_LSB_BMSK                                0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_VALUE_LSB_SHFT                                         6

#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_ADDR(x)                                      ((x) + 0x122c)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_PHYS(x)                                      ((x) + 0x122c)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_OFFS                                         (0x122c)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_RMSK                                                0xf
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_VALUE_MSB_BMSK                                      0xf
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_VALUE_MSB_SHFT                                        0

#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_OPCODE_LOW_ADDR(x)                                         ((x) + 0x1238)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_OPCODE_LOW_PHYS(x)                                         ((x) + 0x1238)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_OPCODE_LOW_OFFS                                            (0x1238)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_OPCODE_LOW_RMSK                                                  0x1f
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_OPCODE_LOW_POR                                             0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_OPCODE_LOW_POR_RMSK                                        0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_OPCODE_LOW_ATTR                                                         0x3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_OPCODE_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_OPCODE_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_OPCODE_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_OPCODE_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_OPCODE_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_OPCODE_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_OPCODE_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_OPCODE_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_OPCODE_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_OPCODE_LOW_ATOMEN_BMSK                                           0x10
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_OPCODE_LOW_ATOMEN_SHFT                                              4
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_OPCODE_LOW_CMEN_BMSK                                              0x8
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_OPCODE_LOW_CMEN_SHFT                                                3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_OPCODE_LOW_EXCLEN_BMSK                                            0x4
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_OPCODE_LOW_EXCLEN_SHFT                                              2
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_OPCODE_LOW_WREN_BMSK                                              0x2
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_OPCODE_LOW_WREN_SHFT                                                1
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_OPCODE_LOW_RDEN_BMSK                                              0x1
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_OPCODE_LOW_RDEN_SHFT                                                0

#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_STATUS_LOW_ADDR(x)                                         ((x) + 0x1240)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_STATUS_LOW_PHYS(x)                                         ((x) + 0x1240)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_STATUS_LOW_OFFS                                            (0x1240)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_STATUS_LOW_RMSK                                                   0xf
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_STATUS_LOW_POR                                             0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_STATUS_LOW_POR_RMSK                                        0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_STATUS_LOW_ATTR                                                         0x3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_STATUS_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_STATUS_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_STATUS_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_STATUS_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_STATUS_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_STATUS_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_STATUS_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_STATUS_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_STATUS_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_STATUS_LOW_FAILEN_BMSK                                            0x8
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_STATUS_LOW_FAILEN_SHFT                                              3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_STATUS_LOW_RSPEEN_BMSK                                            0x4
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_STATUS_LOW_RSPEEN_SHFT                                              2
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_STATUS_LOW_ERREN_BMSK                                             0x2
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_STATUS_LOW_ERREN_SHFT                                               1
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_STATUS_LOW_REQRSPEN_BMSK                                          0x1
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_STATUS_LOW_REQRSPEN_SHFT                                            0

#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_ADDR(x)                                     ((x) + 0x1278)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_PHYS(x)                                     ((x) + 0x1278)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_OFFS                                        (0x1278)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_RMSK                                            0xffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_POR                                         0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_POR_RMSK                                    0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_ATTR                                                     0x3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_FILTERS_1_EXTID_BASE_BMSK                       0xffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_FILTERS_1_EXTID_BASE_SHFT                            0

#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_ADDR(x)                                     ((x) + 0x1280)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_PHYS(x)                                     ((x) + 0x1280)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_OFFS                                        (0x1280)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_RMSK                                            0xffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_POR                                         0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_POR_RMSK                                    0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_ATTR                                                     0x3
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_FILTERS_1_EXTID_MASK_BMSK                       0xffff
#define HWIO_UMAC_NOC_TRACEPROBE0_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_FILTERS_1_EXTID_MASK_SHFT                            0

#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_SWID_LOW_ADDR(x)                                                     ((x) + 0x1400)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_SWID_LOW_PHYS(x)                                                     ((x) + 0x1400)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_SWID_LOW_OFFS                                                        (0x1400)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_SWID_LOW_RMSK                                                          0xffffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_SWID_LOW_POR                                                         0x0012a0b3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_SWID_LOW_POR_RMSK                                                    0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_SWID_LOW_ATTR                                                                     0x1
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_SWID_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_SWID_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_SWID_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_SWID_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_SWID_LOW_UNITTYPEID_BMSK                                               0xff0000
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_SWID_LOW_UNITTYPEID_SHFT                                                     16
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_SWID_LOW_UNITCONFID_BMSK                                                 0xffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_SWID_LOW_UNITCONFID_SHFT                                                      0

#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_SWID_HIGH_ADDR(x)                                                    ((x) + 0x1404)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_SWID_HIGH_PHYS(x)                                                    ((x) + 0x1404)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_SWID_HIGH_OFFS                                                       (0x1404)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_SWID_HIGH_RMSK                                                       0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_SWID_HIGH_POR                                                        0xfbb160c3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_SWID_HIGH_POR_RMSK                                                   0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_SWID_HIGH_ATTR                                                                    0x1
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_SWID_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_SWID_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_SWID_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_SWID_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_SWID_HIGH_QNOCID_BMSK                                                0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_SWID_HIGH_QNOCID_SHFT                                                         0

#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_MAINCTL_LOW_ADDR(x)                                                  ((x) + 0x1408)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_MAINCTL_LOW_PHYS(x)                                                  ((x) + 0x1408)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_MAINCTL_LOW_OFFS                                                     (0x1408)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_MAINCTL_LOW_RMSK                                                           0x2f
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_MAINCTL_LOW_POR                                                      0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_MAINCTL_LOW_POR_RMSK                                                 0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_MAINCTL_LOW_ATTR                                                                  0x3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_MAINCTL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_MAINCTL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_MAINCTL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_MAINCTL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_MAINCTL_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_MAINCTL_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_MAINCTL_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_MAINCTL_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_MAINCTL_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_MAINCTL_LOW_IGNORECTITRIGIN0_BMSK                                          0x20
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_MAINCTL_LOW_IGNORECTITRIGIN0_SHFT                                             5
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_MAINCTL_LOW_DUMPFORMAT_BMSK                                                 0x8
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_MAINCTL_LOW_DUMPFORMAT_SHFT                                                   3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_MAINCTL_LOW_ALARMEN_BMSK                                                    0x4
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_MAINCTL_LOW_ALARMEN_SHFT                                                      2
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_MAINCTL_LOW_DUMPEN_BMSK                                                     0x2
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_MAINCTL_LOW_DUMPEN_SHFT                                                       1
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_MAINCTL_LOW_GLBEN_BMSK                                                      0x1
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_MAINCTL_LOW_GLBEN_SHFT                                                        0

#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_EN_LOW_ADDR(x)                                                 ((x) + 0x1410)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_EN_LOW_PHYS(x)                                                 ((x) + 0x1410)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_EN_LOW_OFFS                                                    (0x1410)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_EN_LOW_RMSK                                                    0x80000003
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_EN_LOW_POR                                                     0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_EN_LOW_POR_RMSK                                                0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_EN_LOW_ATTR                                                                 0x3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_EN_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_EN_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_EN_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_EN_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_EN_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_EN_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_EN_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_EN_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_EN_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_EN_LOW_PLA_BMSK                                                0x80000000
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_EN_LOW_PLA_SHFT                                                        31
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_EN_LOW_FILTER_BMSK                                                    0x3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_EN_LOW_FILTER_SHFT                                                      0

#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_STATUS_LOW_ADDR(x)                                             ((x) + 0x1418)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_STATUS_LOW_PHYS(x)                                             ((x) + 0x1418)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_STATUS_LOW_OFFS                                                (0x1418)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_STATUS_LOW_RMSK                                                0x80000003
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_STATUS_LOW_POR                                                 0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_STATUS_LOW_POR_RMSK                                            0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_STATUS_LOW_ATTR                                                             0x1
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_STATUS_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_STATUS_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_STATUS_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_STATUS_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_STATUS_LOW_PLA_BMSK                                            0x80000000
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_STATUS_LOW_PLA_SHFT                                                    31
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_STATUS_LOW_FILTER_BMSK                                                0x3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_STATUS_LOW_FILTER_SHFT                                                  0

#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_CLR_LOW_ADDR(x)                                                ((x) + 0x1420)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_CLR_LOW_PHYS(x)                                                ((x) + 0x1420)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_CLR_LOW_OFFS                                                   (0x1420)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_CLR_LOW_RMSK                                                   0x80000003
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_CLR_LOW_POR                                                    0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_CLR_LOW_POR_RMSK                                               0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_CLR_LOW_ATTR                                                                0x2
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_CLR_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_CLR_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_CLR_LOW_PLA_BMSK                                               0x80000000
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_CLR_LOW_PLA_SHFT                                                       31
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_CLR_LOW_FILTER_BMSK                                                   0x3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ALARM_CLR_LOW_FILTER_SHFT                                                     0

#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ANDINV_LOW_ADDR(x)                                                   ((x) + 0x1428)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ANDINV_LOW_PHYS(x)                                                   ((x) + 0x1428)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ANDINV_LOW_OFFS                                                      (0x1428)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ANDINV_LOW_RMSK                                                      0x80000003
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ANDINV_LOW_POR                                                       0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ANDINV_LOW_POR_RMSK                                                  0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ANDINV_LOW_ATTR                                                                   0x3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ANDINV_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ANDINV_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ANDINV_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ANDINV_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ANDINV_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ANDINV_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ANDINV_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ANDINV_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ANDINV_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ANDINV_LOW_PLA_BMSK                                                  0x80000000
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ANDINV_LOW_PLA_SHFT                                                          31
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ANDINV_LOW_FILTER_BMSK                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_ANDINV_LOW_FILTER_SHFT                                                        0

#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_PORTSEL_LOW_ADDR(x)                                                  ((x) + 0x1430)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_PORTSEL_LOW_PHYS(x)                                                  ((x) + 0x1430)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_PORTSEL_LOW_OFFS                                                     (0x1430)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_PORTSEL_LOW_RMSK                                                            0x3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_PORTSEL_LOW_POR                                                      0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_PORTSEL_LOW_POR_RMSK                                                 0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_PORTSEL_LOW_ATTR                                                                  0x3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_PORTSEL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_PORTSEL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_PORTSEL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_PORTSEL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_PORTSEL_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_PORTSEL_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_PORTSEL_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_PORTSEL_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_PORTSEL_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_PORTSEL_LOW_PORTSEL_BMSK                                                    0x3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_PORTSEL_LOW_PORTSEL_SHFT                                                      0

#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_BASE_LOW_ADDR(x)                                      ((x) + 0x1500)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_BASE_LOW_PHYS(x)                                      ((x) + 0x1500)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_BASE_LOW_OFFS                                         (0x1500)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_BASE_LOW_RMSK                                               0x3f
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_BASE_LOW_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_BASE_LOW_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_BASE_LOW_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_BASE_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_BASE_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_BASE_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_BASE_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_BASE_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_BASE_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_BASE_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_BASE_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_BASE_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_BASE_LOW_FILTERS_0_PATH_BASE_BMSK                           0x3f
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_BASE_LOW_FILTERS_0_PATH_BASE_SHFT                              0

#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_MASK_LOW_ADDR(x)                                      ((x) + 0x1508)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_MASK_LOW_PHYS(x)                                      ((x) + 0x1508)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_MASK_LOW_OFFS                                         (0x1508)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_MASK_LOW_RMSK                                               0x3f
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_MASK_LOW_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_MASK_LOW_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_MASK_LOW_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_MASK_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_MASK_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_MASK_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_MASK_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_MASK_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_MASK_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_MASK_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_MASK_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_MASK_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_MASK_LOW_FILTERS_0_PATH_MASK_BMSK                           0x3f
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_PATH_MASK_LOW_FILTERS_0_PATH_MASK_SHFT                              0

#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_ADDR(x)                                       ((x) + 0x1520)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_PHYS(x)                                       ((x) + 0x1520)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_OFFS                                          (0x1520)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_RMSK                                          0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_POR                                           0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_POR_RMSK                                      0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_ATTR                                                       0x3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_VALUE_LSB_BMSK                                0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_VALUE_LSB_SHFT                                         6

#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_ADDR(x)                                      ((x) + 0x1524)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_PHYS(x)                                      ((x) + 0x1524)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_OFFS                                         (0x1524)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_RMSK                                                0xf
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_VALUE_MSB_BMSK                                      0xf
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_VALUE_MSB_SHFT                                        0

#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_ADDR(x)                                       ((x) + 0x1528)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_PHYS(x)                                       ((x) + 0x1528)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_OFFS                                          (0x1528)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_RMSK                                          0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_POR                                           0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_POR_RMSK                                      0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_ATTR                                                       0x3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_VALUE_LSB_BMSK                                0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_VALUE_LSB_SHFT                                         6

#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_ADDR(x)                                      ((x) + 0x152c)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_PHYS(x)                                      ((x) + 0x152c)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_OFFS                                         (0x152c)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_RMSK                                                0xf
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_VALUE_MSB_BMSK                                      0xf
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_VALUE_MSB_SHFT                                        0

#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_OPCODE_LOW_ADDR(x)                                         ((x) + 0x1538)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_OPCODE_LOW_PHYS(x)                                         ((x) + 0x1538)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_OPCODE_LOW_OFFS                                            (0x1538)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_OPCODE_LOW_RMSK                                                  0x1f
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_OPCODE_LOW_POR                                             0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_OPCODE_LOW_POR_RMSK                                        0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_OPCODE_LOW_ATTR                                                         0x3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_OPCODE_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_OPCODE_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_OPCODE_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_OPCODE_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_OPCODE_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_OPCODE_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_OPCODE_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_OPCODE_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_OPCODE_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_OPCODE_LOW_ATOMEN_BMSK                                           0x10
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_OPCODE_LOW_ATOMEN_SHFT                                              4
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_OPCODE_LOW_CMEN_BMSK                                              0x8
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_OPCODE_LOW_CMEN_SHFT                                                3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_OPCODE_LOW_EXCLEN_BMSK                                            0x4
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_OPCODE_LOW_EXCLEN_SHFT                                              2
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_OPCODE_LOW_WREN_BMSK                                              0x2
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_OPCODE_LOW_WREN_SHFT                                                1
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_OPCODE_LOW_RDEN_BMSK                                              0x1
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_OPCODE_LOW_RDEN_SHFT                                                0

#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_STATUS_LOW_ADDR(x)                                         ((x) + 0x1540)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_STATUS_LOW_PHYS(x)                                         ((x) + 0x1540)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_STATUS_LOW_OFFS                                            (0x1540)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_STATUS_LOW_RMSK                                                   0xf
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_STATUS_LOW_POR                                             0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_STATUS_LOW_POR_RMSK                                        0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_STATUS_LOW_ATTR                                                         0x3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_STATUS_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_STATUS_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_STATUS_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_STATUS_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_STATUS_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_STATUS_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_STATUS_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_STATUS_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_STATUS_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_STATUS_LOW_FAILEN_BMSK                                            0x8
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_STATUS_LOW_FAILEN_SHFT                                              3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_STATUS_LOW_RSPEEN_BMSK                                            0x4
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_STATUS_LOW_RSPEEN_SHFT                                              2
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_STATUS_LOW_ERREN_BMSK                                             0x2
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_STATUS_LOW_ERREN_SHFT                                               1
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_STATUS_LOW_REQRSPEN_BMSK                                          0x1
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_STATUS_LOW_REQRSPEN_SHFT                                            0

#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_ADDR(x)                                     ((x) + 0x1578)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_PHYS(x)                                     ((x) + 0x1578)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_OFFS                                        (0x1578)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_RMSK                                            0xffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_POR                                         0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_POR_RMSK                                    0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_ATTR                                                     0x3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_FILTERS_0_EXTID_BASE_BMSK                       0xffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_FILTERS_0_EXTID_BASE_SHFT                            0

#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_ADDR(x)                                     ((x) + 0x1580)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_PHYS(x)                                     ((x) + 0x1580)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_OFFS                                        (0x1580)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_RMSK                                            0xffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_POR                                         0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_POR_RMSK                                    0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_ATTR                                                     0x3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_FILTERS_0_EXTID_MASK_BMSK                       0xffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_FILTERS_0_EXTID_MASK_SHFT                            0

#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_BASE_LOW_ADDR(x)                                      ((x) + 0x1600)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_BASE_LOW_PHYS(x)                                      ((x) + 0x1600)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_BASE_LOW_OFFS                                         (0x1600)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_BASE_LOW_RMSK                                               0x3f
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_BASE_LOW_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_BASE_LOW_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_BASE_LOW_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_BASE_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_BASE_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_BASE_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_BASE_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_BASE_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_BASE_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_BASE_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_BASE_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_BASE_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_BASE_LOW_FILTERS_1_PATH_BASE_BMSK                           0x3f
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_BASE_LOW_FILTERS_1_PATH_BASE_SHFT                              0

#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_MASK_LOW_ADDR(x)                                      ((x) + 0x1608)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_MASK_LOW_PHYS(x)                                      ((x) + 0x1608)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_MASK_LOW_OFFS                                         (0x1608)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_MASK_LOW_RMSK                                               0x3f
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_MASK_LOW_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_MASK_LOW_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_MASK_LOW_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_MASK_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_MASK_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_MASK_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_MASK_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_MASK_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_MASK_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_MASK_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_MASK_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_MASK_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_MASK_LOW_FILTERS_1_PATH_MASK_BMSK                           0x3f
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_PATH_MASK_LOW_FILTERS_1_PATH_MASK_SHFT                              0

#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_ADDR(x)                                       ((x) + 0x1620)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_PHYS(x)                                       ((x) + 0x1620)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_OFFS                                          (0x1620)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_RMSK                                          0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_POR                                           0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_POR_RMSK                                      0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_ATTR                                                       0x3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_VALUE_LSB_BMSK                                0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_VALUE_LSB_SHFT                                         6

#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_ADDR(x)                                      ((x) + 0x1624)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_PHYS(x)                                      ((x) + 0x1624)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_OFFS                                         (0x1624)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_RMSK                                                0xf
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_VALUE_MSB_BMSK                                      0xf
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_VALUE_MSB_SHFT                                        0

#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_ADDR(x)                                       ((x) + 0x1628)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_PHYS(x)                                       ((x) + 0x1628)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_OFFS                                          (0x1628)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_RMSK                                          0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_POR                                           0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_POR_RMSK                                      0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_ATTR                                                       0x3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_VALUE_LSB_BMSK                                0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_VALUE_LSB_SHFT                                         6

#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_ADDR(x)                                      ((x) + 0x162c)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_PHYS(x)                                      ((x) + 0x162c)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_OFFS                                         (0x162c)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_RMSK                                                0xf
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_VALUE_MSB_BMSK                                      0xf
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_VALUE_MSB_SHFT                                        0

#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_OPCODE_LOW_ADDR(x)                                         ((x) + 0x1638)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_OPCODE_LOW_PHYS(x)                                         ((x) + 0x1638)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_OPCODE_LOW_OFFS                                            (0x1638)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_OPCODE_LOW_RMSK                                                  0x1f
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_OPCODE_LOW_POR                                             0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_OPCODE_LOW_POR_RMSK                                        0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_OPCODE_LOW_ATTR                                                         0x3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_OPCODE_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_OPCODE_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_OPCODE_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_OPCODE_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_OPCODE_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_OPCODE_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_OPCODE_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_OPCODE_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_OPCODE_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_OPCODE_LOW_ATOMEN_BMSK                                           0x10
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_OPCODE_LOW_ATOMEN_SHFT                                              4
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_OPCODE_LOW_CMEN_BMSK                                              0x8
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_OPCODE_LOW_CMEN_SHFT                                                3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_OPCODE_LOW_EXCLEN_BMSK                                            0x4
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_OPCODE_LOW_EXCLEN_SHFT                                              2
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_OPCODE_LOW_WREN_BMSK                                              0x2
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_OPCODE_LOW_WREN_SHFT                                                1
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_OPCODE_LOW_RDEN_BMSK                                              0x1
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_OPCODE_LOW_RDEN_SHFT                                                0

#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_STATUS_LOW_ADDR(x)                                         ((x) + 0x1640)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_STATUS_LOW_PHYS(x)                                         ((x) + 0x1640)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_STATUS_LOW_OFFS                                            (0x1640)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_STATUS_LOW_RMSK                                                   0xf
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_STATUS_LOW_POR                                             0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_STATUS_LOW_POR_RMSK                                        0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_STATUS_LOW_ATTR                                                         0x3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_STATUS_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_STATUS_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_STATUS_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_STATUS_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_STATUS_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_STATUS_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_STATUS_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_STATUS_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_STATUS_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_STATUS_LOW_FAILEN_BMSK                                            0x8
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_STATUS_LOW_FAILEN_SHFT                                              3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_STATUS_LOW_RSPEEN_BMSK                                            0x4
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_STATUS_LOW_RSPEEN_SHFT                                              2
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_STATUS_LOW_ERREN_BMSK                                             0x2
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_STATUS_LOW_ERREN_SHFT                                               1
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_STATUS_LOW_REQRSPEN_BMSK                                          0x1
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_STATUS_LOW_REQRSPEN_SHFT                                            0

#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_ADDR(x)                                     ((x) + 0x1678)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_PHYS(x)                                     ((x) + 0x1678)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_OFFS                                        (0x1678)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_RMSK                                            0xffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_POR                                         0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_POR_RMSK                                    0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_ATTR                                                     0x3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_FILTERS_1_EXTID_BASE_BMSK                       0xffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_FILTERS_1_EXTID_BASE_SHFT                            0

#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_ADDR(x)                                     ((x) + 0x1680)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_PHYS(x)                                     ((x) + 0x1680)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_OFFS                                        (0x1680)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_RMSK                                            0xffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_POR                                         0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_POR_RMSK                                    0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_ATTR                                                     0x3
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_FILTERS_1_EXTID_MASK_BMSK                       0xffff
#define HWIO_UMAC_NOC_TRACEPROBE1_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_FILTERS_1_EXTID_MASK_SHFT                            0

#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_SWID_LOW_ADDR(x)                                                     ((x) + 0x1800)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_SWID_LOW_PHYS(x)                                                     ((x) + 0x1800)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_SWID_LOW_OFFS                                                        (0x1800)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_SWID_LOW_RMSK                                                          0xffffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_SWID_LOW_POR                                                         0x00120bec
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_SWID_LOW_POR_RMSK                                                    0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_SWID_LOW_ATTR                                                                     0x1
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_SWID_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_SWID_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_SWID_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_SWID_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_SWID_LOW_UNITTYPEID_BMSK                                               0xff0000
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_SWID_LOW_UNITTYPEID_SHFT                                                     16
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_SWID_LOW_UNITCONFID_BMSK                                                 0xffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_SWID_LOW_UNITCONFID_SHFT                                                      0

#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_SWID_HIGH_ADDR(x)                                                    ((x) + 0x1804)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_SWID_HIGH_PHYS(x)                                                    ((x) + 0x1804)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_SWID_HIGH_OFFS                                                       (0x1804)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_SWID_HIGH_RMSK                                                       0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_SWID_HIGH_POR                                                        0xfbb160c3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_SWID_HIGH_POR_RMSK                                                   0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_SWID_HIGH_ATTR                                                                    0x1
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_SWID_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_SWID_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_SWID_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_SWID_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_SWID_HIGH_QNOCID_BMSK                                                0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_SWID_HIGH_QNOCID_SHFT                                                         0

#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_MAINCTL_LOW_ADDR(x)                                                  ((x) + 0x1808)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_MAINCTL_LOW_PHYS(x)                                                  ((x) + 0x1808)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_MAINCTL_LOW_OFFS                                                     (0x1808)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_MAINCTL_LOW_RMSK                                                           0x2f
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_MAINCTL_LOW_POR                                                      0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_MAINCTL_LOW_POR_RMSK                                                 0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_MAINCTL_LOW_ATTR                                                                  0x3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_MAINCTL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_MAINCTL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_MAINCTL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_MAINCTL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_MAINCTL_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_MAINCTL_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_MAINCTL_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_MAINCTL_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_MAINCTL_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_MAINCTL_LOW_IGNORECTITRIGIN0_BMSK                                          0x20
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_MAINCTL_LOW_IGNORECTITRIGIN0_SHFT                                             5
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_MAINCTL_LOW_DUMPFORMAT_BMSK                                                 0x8
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_MAINCTL_LOW_DUMPFORMAT_SHFT                                                   3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_MAINCTL_LOW_ALARMEN_BMSK                                                    0x4
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_MAINCTL_LOW_ALARMEN_SHFT                                                      2
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_MAINCTL_LOW_DUMPEN_BMSK                                                     0x2
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_MAINCTL_LOW_DUMPEN_SHFT                                                       1
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_MAINCTL_LOW_GLBEN_BMSK                                                      0x1
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_MAINCTL_LOW_GLBEN_SHFT                                                        0

#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_EN_LOW_ADDR(x)                                                 ((x) + 0x1810)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_EN_LOW_PHYS(x)                                                 ((x) + 0x1810)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_EN_LOW_OFFS                                                    (0x1810)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_EN_LOW_RMSK                                                    0x80000003
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_EN_LOW_POR                                                     0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_EN_LOW_POR_RMSK                                                0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_EN_LOW_ATTR                                                                 0x3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_EN_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_EN_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_EN_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_EN_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_EN_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_EN_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_EN_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_EN_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_EN_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_EN_LOW_PLA_BMSK                                                0x80000000
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_EN_LOW_PLA_SHFT                                                        31
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_EN_LOW_FILTER_BMSK                                                    0x3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_EN_LOW_FILTER_SHFT                                                      0

#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_STATUS_LOW_ADDR(x)                                             ((x) + 0x1818)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_STATUS_LOW_PHYS(x)                                             ((x) + 0x1818)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_STATUS_LOW_OFFS                                                (0x1818)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_STATUS_LOW_RMSK                                                0x80000003
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_STATUS_LOW_POR                                                 0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_STATUS_LOW_POR_RMSK                                            0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_STATUS_LOW_ATTR                                                             0x1
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_STATUS_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_STATUS_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_STATUS_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_STATUS_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_STATUS_LOW_PLA_BMSK                                            0x80000000
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_STATUS_LOW_PLA_SHFT                                                    31
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_STATUS_LOW_FILTER_BMSK                                                0x3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_STATUS_LOW_FILTER_SHFT                                                  0

#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_CLR_LOW_ADDR(x)                                                ((x) + 0x1820)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_CLR_LOW_PHYS(x)                                                ((x) + 0x1820)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_CLR_LOW_OFFS                                                   (0x1820)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_CLR_LOW_RMSK                                                   0x80000003
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_CLR_LOW_POR                                                    0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_CLR_LOW_POR_RMSK                                               0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_CLR_LOW_ATTR                                                                0x2
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_CLR_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_CLR_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_CLR_LOW_PLA_BMSK                                               0x80000000
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_CLR_LOW_PLA_SHFT                                                       31
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_CLR_LOW_FILTER_BMSK                                                   0x3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ALARM_CLR_LOW_FILTER_SHFT                                                     0

#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ANDINV_LOW_ADDR(x)                                                   ((x) + 0x1828)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ANDINV_LOW_PHYS(x)                                                   ((x) + 0x1828)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ANDINV_LOW_OFFS                                                      (0x1828)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ANDINV_LOW_RMSK                                                      0x80000003
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ANDINV_LOW_POR                                                       0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ANDINV_LOW_POR_RMSK                                                  0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ANDINV_LOW_ATTR                                                                   0x3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ANDINV_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ANDINV_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ANDINV_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ANDINV_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ANDINV_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ANDINV_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ANDINV_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ANDINV_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ANDINV_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ANDINV_LOW_PLA_BMSK                                                  0x80000000
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ANDINV_LOW_PLA_SHFT                                                          31
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ANDINV_LOW_FILTER_BMSK                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_ANDINV_LOW_FILTER_SHFT                                                        0

#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_PORTSEL_LOW_ADDR(x)                                                  ((x) + 0x1830)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_PORTSEL_LOW_PHYS(x)                                                  ((x) + 0x1830)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_PORTSEL_LOW_OFFS                                                     (0x1830)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_PORTSEL_LOW_RMSK                                                            0x3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_PORTSEL_LOW_POR                                                      0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_PORTSEL_LOW_POR_RMSK                                                 0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_PORTSEL_LOW_ATTR                                                                  0x3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_PORTSEL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_PORTSEL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_PORTSEL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_PORTSEL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_PORTSEL_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_PORTSEL_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_PORTSEL_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_PORTSEL_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_PORTSEL_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_PORTSEL_LOW_PORTSEL_BMSK                                                    0x3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_PORTSEL_LOW_PORTSEL_SHFT                                                      0

#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_BASE_LOW_ADDR(x)                                      ((x) + 0x1900)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_BASE_LOW_PHYS(x)                                      ((x) + 0x1900)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_BASE_LOW_OFFS                                         (0x1900)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_BASE_LOW_RMSK                                               0x3f
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_BASE_LOW_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_BASE_LOW_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_BASE_LOW_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_BASE_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_BASE_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_BASE_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_BASE_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_BASE_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_BASE_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_BASE_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_BASE_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_BASE_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_BASE_LOW_FILTERS_0_PATH_BASE_BMSK                           0x3f
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_BASE_LOW_FILTERS_0_PATH_BASE_SHFT                              0

#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_MASK_LOW_ADDR(x)                                      ((x) + 0x1908)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_MASK_LOW_PHYS(x)                                      ((x) + 0x1908)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_MASK_LOW_OFFS                                         (0x1908)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_MASK_LOW_RMSK                                               0x3f
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_MASK_LOW_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_MASK_LOW_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_MASK_LOW_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_MASK_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_MASK_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_MASK_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_MASK_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_MASK_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_MASK_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_MASK_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_MASK_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_MASK_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_MASK_LOW_FILTERS_0_PATH_MASK_BMSK                           0x3f
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_PATH_MASK_LOW_FILTERS_0_PATH_MASK_SHFT                              0

#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_ADDR(x)                                       ((x) + 0x1920)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_PHYS(x)                                       ((x) + 0x1920)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_OFFS                                          (0x1920)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_RMSK                                          0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_POR                                           0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_POR_RMSK                                      0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_ATTR                                                       0x3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_VALUE_LSB_BMSK                                0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_VALUE_LSB_SHFT                                         6

#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_ADDR(x)                                      ((x) + 0x1924)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_PHYS(x)                                      ((x) + 0x1924)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_OFFS                                         (0x1924)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_RMSK                                                0xf
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_VALUE_MSB_BMSK                                      0xf
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_VALUE_MSB_SHFT                                        0

#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_ADDR(x)                                       ((x) + 0x1928)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_PHYS(x)                                       ((x) + 0x1928)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_OFFS                                          (0x1928)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_RMSK                                          0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_POR                                           0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_POR_RMSK                                      0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_ATTR                                                       0x3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_VALUE_LSB_BMSK                                0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_VALUE_LSB_SHFT                                         6

#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_ADDR(x)                                      ((x) + 0x192c)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_PHYS(x)                                      ((x) + 0x192c)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_OFFS                                         (0x192c)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_RMSK                                                0xf
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_VALUE_MSB_BMSK                                      0xf
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_VALUE_MSB_SHFT                                        0

#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_OPCODE_LOW_ADDR(x)                                         ((x) + 0x1938)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_OPCODE_LOW_PHYS(x)                                         ((x) + 0x1938)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_OPCODE_LOW_OFFS                                            (0x1938)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_OPCODE_LOW_RMSK                                                  0x1f
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_OPCODE_LOW_POR                                             0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_OPCODE_LOW_POR_RMSK                                        0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_OPCODE_LOW_ATTR                                                         0x3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_OPCODE_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_OPCODE_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_OPCODE_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_OPCODE_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_OPCODE_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_OPCODE_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_OPCODE_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_OPCODE_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_OPCODE_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_OPCODE_LOW_ATOMEN_BMSK                                           0x10
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_OPCODE_LOW_ATOMEN_SHFT                                              4
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_OPCODE_LOW_CMEN_BMSK                                              0x8
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_OPCODE_LOW_CMEN_SHFT                                                3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_OPCODE_LOW_EXCLEN_BMSK                                            0x4
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_OPCODE_LOW_EXCLEN_SHFT                                              2
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_OPCODE_LOW_WREN_BMSK                                              0x2
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_OPCODE_LOW_WREN_SHFT                                                1
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_OPCODE_LOW_RDEN_BMSK                                              0x1
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_OPCODE_LOW_RDEN_SHFT                                                0

#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_STATUS_LOW_ADDR(x)                                         ((x) + 0x1940)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_STATUS_LOW_PHYS(x)                                         ((x) + 0x1940)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_STATUS_LOW_OFFS                                            (0x1940)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_STATUS_LOW_RMSK                                                   0xf
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_STATUS_LOW_POR                                             0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_STATUS_LOW_POR_RMSK                                        0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_STATUS_LOW_ATTR                                                         0x3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_STATUS_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_STATUS_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_STATUS_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_STATUS_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_STATUS_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_STATUS_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_STATUS_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_STATUS_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_STATUS_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_STATUS_LOW_FAILEN_BMSK                                            0x8
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_STATUS_LOW_FAILEN_SHFT                                              3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_STATUS_LOW_RSPEEN_BMSK                                            0x4
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_STATUS_LOW_RSPEEN_SHFT                                              2
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_STATUS_LOW_ERREN_BMSK                                             0x2
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_STATUS_LOW_ERREN_SHFT                                               1
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_STATUS_LOW_REQRSPEN_BMSK                                          0x1
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_STATUS_LOW_REQRSPEN_SHFT                                            0

#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_ADDR(x)                                     ((x) + 0x1978)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_PHYS(x)                                     ((x) + 0x1978)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_OFFS                                        (0x1978)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_RMSK                                            0xffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_POR                                         0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_POR_RMSK                                    0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_ATTR                                                     0x3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_FILTERS_0_EXTID_BASE_BMSK                       0xffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_FILTERS_0_EXTID_BASE_SHFT                            0

#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_ADDR(x)                                     ((x) + 0x1980)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_PHYS(x)                                     ((x) + 0x1980)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_OFFS                                        (0x1980)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_RMSK                                            0xffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_POR                                         0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_POR_RMSK                                    0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_ATTR                                                     0x3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_FILTERS_0_EXTID_MASK_BMSK                       0xffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_FILTERS_0_EXTID_MASK_SHFT                            0

#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_BASE_LOW_ADDR(x)                                      ((x) + 0x1a00)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_BASE_LOW_PHYS(x)                                      ((x) + 0x1a00)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_BASE_LOW_OFFS                                         (0x1a00)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_BASE_LOW_RMSK                                               0x3f
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_BASE_LOW_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_BASE_LOW_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_BASE_LOW_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_BASE_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_BASE_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_BASE_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_BASE_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_BASE_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_BASE_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_BASE_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_BASE_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_BASE_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_BASE_LOW_FILTERS_1_PATH_BASE_BMSK                           0x3f
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_BASE_LOW_FILTERS_1_PATH_BASE_SHFT                              0

#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_MASK_LOW_ADDR(x)                                      ((x) + 0x1a08)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_MASK_LOW_PHYS(x)                                      ((x) + 0x1a08)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_MASK_LOW_OFFS                                         (0x1a08)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_MASK_LOW_RMSK                                               0x3f
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_MASK_LOW_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_MASK_LOW_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_MASK_LOW_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_MASK_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_MASK_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_MASK_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_MASK_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_MASK_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_MASK_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_MASK_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_MASK_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_MASK_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_MASK_LOW_FILTERS_1_PATH_MASK_BMSK                           0x3f
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_PATH_MASK_LOW_FILTERS_1_PATH_MASK_SHFT                              0

#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_ADDR(x)                                       ((x) + 0x1a20)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_PHYS(x)                                       ((x) + 0x1a20)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_OFFS                                          (0x1a20)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_RMSK                                          0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_POR                                           0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_POR_RMSK                                      0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_ATTR                                                       0x3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_VALUE_LSB_BMSK                                0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_VALUE_LSB_SHFT                                         6

#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_ADDR(x)                                      ((x) + 0x1a24)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_PHYS(x)                                      ((x) + 0x1a24)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_OFFS                                         (0x1a24)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_RMSK                                                0xf
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_VALUE_MSB_BMSK                                      0xf
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_VALUE_MSB_SHFT                                        0

#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_ADDR(x)                                       ((x) + 0x1a28)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_PHYS(x)                                       ((x) + 0x1a28)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_OFFS                                          (0x1a28)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_RMSK                                          0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_POR                                           0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_POR_RMSK                                      0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_ATTR                                                       0x3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_VALUE_LSB_BMSK                                0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_VALUE_LSB_SHFT                                         6

#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_ADDR(x)                                      ((x) + 0x1a2c)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_PHYS(x)                                      ((x) + 0x1a2c)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_OFFS                                         (0x1a2c)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_RMSK                                                0xf
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_VALUE_MSB_BMSK                                      0xf
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_VALUE_MSB_SHFT                                        0

#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_OPCODE_LOW_ADDR(x)                                         ((x) + 0x1a38)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_OPCODE_LOW_PHYS(x)                                         ((x) + 0x1a38)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_OPCODE_LOW_OFFS                                            (0x1a38)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_OPCODE_LOW_RMSK                                                  0x1f
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_OPCODE_LOW_POR                                             0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_OPCODE_LOW_POR_RMSK                                        0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_OPCODE_LOW_ATTR                                                         0x3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_OPCODE_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_OPCODE_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_OPCODE_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_OPCODE_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_OPCODE_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_OPCODE_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_OPCODE_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_OPCODE_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_OPCODE_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_OPCODE_LOW_ATOMEN_BMSK                                           0x10
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_OPCODE_LOW_ATOMEN_SHFT                                              4
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_OPCODE_LOW_CMEN_BMSK                                              0x8
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_OPCODE_LOW_CMEN_SHFT                                                3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_OPCODE_LOW_EXCLEN_BMSK                                            0x4
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_OPCODE_LOW_EXCLEN_SHFT                                              2
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_OPCODE_LOW_WREN_BMSK                                              0x2
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_OPCODE_LOW_WREN_SHFT                                                1
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_OPCODE_LOW_RDEN_BMSK                                              0x1
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_OPCODE_LOW_RDEN_SHFT                                                0

#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_STATUS_LOW_ADDR(x)                                         ((x) + 0x1a40)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_STATUS_LOW_PHYS(x)                                         ((x) + 0x1a40)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_STATUS_LOW_OFFS                                            (0x1a40)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_STATUS_LOW_RMSK                                                   0xf
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_STATUS_LOW_POR                                             0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_STATUS_LOW_POR_RMSK                                        0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_STATUS_LOW_ATTR                                                         0x3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_STATUS_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_STATUS_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_STATUS_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_STATUS_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_STATUS_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_STATUS_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_STATUS_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_STATUS_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_STATUS_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_STATUS_LOW_FAILEN_BMSK                                            0x8
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_STATUS_LOW_FAILEN_SHFT                                              3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_STATUS_LOW_RSPEEN_BMSK                                            0x4
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_STATUS_LOW_RSPEEN_SHFT                                              2
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_STATUS_LOW_ERREN_BMSK                                             0x2
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_STATUS_LOW_ERREN_SHFT                                               1
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_STATUS_LOW_REQRSPEN_BMSK                                          0x1
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_STATUS_LOW_REQRSPEN_SHFT                                            0

#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_ADDR(x)                                     ((x) + 0x1a78)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_PHYS(x)                                     ((x) + 0x1a78)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_OFFS                                        (0x1a78)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_RMSK                                            0xffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_POR                                         0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_POR_RMSK                                    0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_ATTR                                                     0x3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_FILTERS_1_EXTID_BASE_BMSK                       0xffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_FILTERS_1_EXTID_BASE_SHFT                            0

#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_ADDR(x)                                     ((x) + 0x1a80)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_PHYS(x)                                     ((x) + 0x1a80)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_OFFS                                        (0x1a80)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_RMSK                                            0xffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_POR                                         0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_POR_RMSK                                    0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_ATTR                                                     0x3
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_FILTERS_1_EXTID_MASK_BMSK                       0xffff
#define HWIO_UMAC_NOC_TRACEPROBE2_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_FILTERS_1_EXTID_MASK_SHFT                            0

#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_SWID_LOW_ADDR(x)                                                     ((x) + 0x1c00)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_SWID_LOW_PHYS(x)                                                     ((x) + 0x1c00)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_SWID_LOW_OFFS                                                        (0x1c00)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_SWID_LOW_RMSK                                                          0xffffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_SWID_LOW_POR                                                         0x0012a0b3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_SWID_LOW_POR_RMSK                                                    0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_SWID_LOW_ATTR                                                                     0x1
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_SWID_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_SWID_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_SWID_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_SWID_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_SWID_LOW_UNITTYPEID_BMSK                                               0xff0000
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_SWID_LOW_UNITTYPEID_SHFT                                                     16
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_SWID_LOW_UNITCONFID_BMSK                                                 0xffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_SWID_LOW_UNITCONFID_SHFT                                                      0

#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_SWID_HIGH_ADDR(x)                                                    ((x) + 0x1c04)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_SWID_HIGH_PHYS(x)                                                    ((x) + 0x1c04)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_SWID_HIGH_OFFS                                                       (0x1c04)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_SWID_HIGH_RMSK                                                       0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_SWID_HIGH_POR                                                        0xfbb160c3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_SWID_HIGH_POR_RMSK                                                   0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_SWID_HIGH_ATTR                                                                    0x1
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_SWID_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_SWID_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_SWID_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_SWID_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_SWID_HIGH_QNOCID_BMSK                                                0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_SWID_HIGH_QNOCID_SHFT                                                         0

#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_MAINCTL_LOW_ADDR(x)                                                  ((x) + 0x1c08)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_MAINCTL_LOW_PHYS(x)                                                  ((x) + 0x1c08)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_MAINCTL_LOW_OFFS                                                     (0x1c08)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_MAINCTL_LOW_RMSK                                                           0x2f
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_MAINCTL_LOW_POR                                                      0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_MAINCTL_LOW_POR_RMSK                                                 0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_MAINCTL_LOW_ATTR                                                                  0x3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_MAINCTL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_MAINCTL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_MAINCTL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_MAINCTL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_MAINCTL_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_MAINCTL_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_MAINCTL_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_MAINCTL_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_MAINCTL_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_MAINCTL_LOW_IGNORECTITRIGIN0_BMSK                                          0x20
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_MAINCTL_LOW_IGNORECTITRIGIN0_SHFT                                             5
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_MAINCTL_LOW_DUMPFORMAT_BMSK                                                 0x8
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_MAINCTL_LOW_DUMPFORMAT_SHFT                                                   3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_MAINCTL_LOW_ALARMEN_BMSK                                                    0x4
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_MAINCTL_LOW_ALARMEN_SHFT                                                      2
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_MAINCTL_LOW_DUMPEN_BMSK                                                     0x2
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_MAINCTL_LOW_DUMPEN_SHFT                                                       1
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_MAINCTL_LOW_GLBEN_BMSK                                                      0x1
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_MAINCTL_LOW_GLBEN_SHFT                                                        0

#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_EN_LOW_ADDR(x)                                                 ((x) + 0x1c10)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_EN_LOW_PHYS(x)                                                 ((x) + 0x1c10)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_EN_LOW_OFFS                                                    (0x1c10)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_EN_LOW_RMSK                                                    0x80000003
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_EN_LOW_POR                                                     0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_EN_LOW_POR_RMSK                                                0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_EN_LOW_ATTR                                                                 0x3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_EN_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_EN_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_EN_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_EN_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_EN_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_EN_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_EN_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_EN_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_EN_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_EN_LOW_PLA_BMSK                                                0x80000000
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_EN_LOW_PLA_SHFT                                                        31
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_EN_LOW_FILTER_BMSK                                                    0x3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_EN_LOW_FILTER_SHFT                                                      0

#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_STATUS_LOW_ADDR(x)                                             ((x) + 0x1c18)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_STATUS_LOW_PHYS(x)                                             ((x) + 0x1c18)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_STATUS_LOW_OFFS                                                (0x1c18)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_STATUS_LOW_RMSK                                                0x80000003
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_STATUS_LOW_POR                                                 0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_STATUS_LOW_POR_RMSK                                            0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_STATUS_LOW_ATTR                                                             0x1
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_STATUS_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_STATUS_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_STATUS_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_STATUS_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_STATUS_LOW_PLA_BMSK                                            0x80000000
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_STATUS_LOW_PLA_SHFT                                                    31
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_STATUS_LOW_FILTER_BMSK                                                0x3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_STATUS_LOW_FILTER_SHFT                                                  0

#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_CLR_LOW_ADDR(x)                                                ((x) + 0x1c20)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_CLR_LOW_PHYS(x)                                                ((x) + 0x1c20)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_CLR_LOW_OFFS                                                   (0x1c20)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_CLR_LOW_RMSK                                                   0x80000003
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_CLR_LOW_POR                                                    0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_CLR_LOW_POR_RMSK                                               0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_CLR_LOW_ATTR                                                                0x2
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_CLR_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_CLR_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_CLR_LOW_PLA_BMSK                                               0x80000000
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_CLR_LOW_PLA_SHFT                                                       31
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_CLR_LOW_FILTER_BMSK                                                   0x3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ALARM_CLR_LOW_FILTER_SHFT                                                     0

#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ANDINV_LOW_ADDR(x)                                                   ((x) + 0x1c28)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ANDINV_LOW_PHYS(x)                                                   ((x) + 0x1c28)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ANDINV_LOW_OFFS                                                      (0x1c28)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ANDINV_LOW_RMSK                                                      0x80000003
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ANDINV_LOW_POR                                                       0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ANDINV_LOW_POR_RMSK                                                  0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ANDINV_LOW_ATTR                                                                   0x3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ANDINV_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ANDINV_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ANDINV_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ANDINV_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ANDINV_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ANDINV_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ANDINV_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ANDINV_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ANDINV_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ANDINV_LOW_PLA_BMSK                                                  0x80000000
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ANDINV_LOW_PLA_SHFT                                                          31
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ANDINV_LOW_FILTER_BMSK                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_ANDINV_LOW_FILTER_SHFT                                                        0

#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_PORTSEL_LOW_ADDR(x)                                                  ((x) + 0x1c30)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_PORTSEL_LOW_PHYS(x)                                                  ((x) + 0x1c30)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_PORTSEL_LOW_OFFS                                                     (0x1c30)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_PORTSEL_LOW_RMSK                                                            0x3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_PORTSEL_LOW_POR                                                      0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_PORTSEL_LOW_POR_RMSK                                                 0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_PORTSEL_LOW_ATTR                                                                  0x3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_PORTSEL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_PORTSEL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_PORTSEL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_PORTSEL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_PORTSEL_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_PORTSEL_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_PORTSEL_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_PORTSEL_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_PORTSEL_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_PORTSEL_LOW_PORTSEL_BMSK                                                    0x3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_PORTSEL_LOW_PORTSEL_SHFT                                                      0

#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_BASE_LOW_ADDR(x)                                      ((x) + 0x1d00)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_BASE_LOW_PHYS(x)                                      ((x) + 0x1d00)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_BASE_LOW_OFFS                                         (0x1d00)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_BASE_LOW_RMSK                                               0x3f
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_BASE_LOW_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_BASE_LOW_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_BASE_LOW_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_BASE_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_BASE_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_BASE_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_BASE_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_BASE_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_BASE_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_BASE_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_BASE_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_BASE_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_BASE_LOW_FILTERS_0_PATH_BASE_BMSK                           0x3f
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_BASE_LOW_FILTERS_0_PATH_BASE_SHFT                              0

#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_MASK_LOW_ADDR(x)                                      ((x) + 0x1d08)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_MASK_LOW_PHYS(x)                                      ((x) + 0x1d08)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_MASK_LOW_OFFS                                         (0x1d08)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_MASK_LOW_RMSK                                               0x3f
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_MASK_LOW_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_MASK_LOW_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_MASK_LOW_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_MASK_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_MASK_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_MASK_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_MASK_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_MASK_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_MASK_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_MASK_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_MASK_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_MASK_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_MASK_LOW_FILTERS_0_PATH_MASK_BMSK                           0x3f
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_PATH_MASK_LOW_FILTERS_0_PATH_MASK_SHFT                              0

#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_ADDR(x)                                       ((x) + 0x1d20)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_PHYS(x)                                       ((x) + 0x1d20)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_OFFS                                          (0x1d20)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_RMSK                                          0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_POR                                           0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_POR_RMSK                                      0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_ATTR                                                       0x3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_VALUE_LSB_BMSK                                0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_LOW_VALUE_LSB_SHFT                                         6

#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_ADDR(x)                                      ((x) + 0x1d24)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_PHYS(x)                                      ((x) + 0x1d24)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_OFFS                                         (0x1d24)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_RMSK                                                0xf
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_VALUE_MSB_BMSK                                      0xf
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MIN_HIGH_VALUE_MSB_SHFT                                        0

#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_ADDR(x)                                       ((x) + 0x1d28)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_PHYS(x)                                       ((x) + 0x1d28)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_OFFS                                          (0x1d28)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_RMSK                                          0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_POR                                           0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_POR_RMSK                                      0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_ATTR                                                       0x3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_VALUE_LSB_BMSK                                0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_LOW_VALUE_LSB_SHFT                                         6

#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_ADDR(x)                                      ((x) + 0x1d2c)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_PHYS(x)                                      ((x) + 0x1d2c)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_OFFS                                         (0x1d2c)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_RMSK                                                0xf
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_VALUE_MSB_BMSK                                      0xf
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_ADDR_MAX_HIGH_VALUE_MSB_SHFT                                        0

#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_OPCODE_LOW_ADDR(x)                                         ((x) + 0x1d38)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_OPCODE_LOW_PHYS(x)                                         ((x) + 0x1d38)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_OPCODE_LOW_OFFS                                            (0x1d38)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_OPCODE_LOW_RMSK                                                  0x1f
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_OPCODE_LOW_POR                                             0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_OPCODE_LOW_POR_RMSK                                        0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_OPCODE_LOW_ATTR                                                         0x3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_OPCODE_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_OPCODE_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_OPCODE_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_OPCODE_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_OPCODE_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_OPCODE_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_OPCODE_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_OPCODE_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_OPCODE_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_OPCODE_LOW_ATOMEN_BMSK                                           0x10
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_OPCODE_LOW_ATOMEN_SHFT                                              4
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_OPCODE_LOW_CMEN_BMSK                                              0x8
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_OPCODE_LOW_CMEN_SHFT                                                3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_OPCODE_LOW_EXCLEN_BMSK                                            0x4
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_OPCODE_LOW_EXCLEN_SHFT                                              2
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_OPCODE_LOW_WREN_BMSK                                              0x2
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_OPCODE_LOW_WREN_SHFT                                                1
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_OPCODE_LOW_RDEN_BMSK                                              0x1
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_OPCODE_LOW_RDEN_SHFT                                                0

#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_STATUS_LOW_ADDR(x)                                         ((x) + 0x1d40)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_STATUS_LOW_PHYS(x)                                         ((x) + 0x1d40)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_STATUS_LOW_OFFS                                            (0x1d40)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_STATUS_LOW_RMSK                                                   0xf
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_STATUS_LOW_POR                                             0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_STATUS_LOW_POR_RMSK                                        0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_STATUS_LOW_ATTR                                                         0x3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_STATUS_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_STATUS_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_STATUS_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_STATUS_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_STATUS_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_STATUS_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_STATUS_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_STATUS_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_STATUS_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_STATUS_LOW_FAILEN_BMSK                                            0x8
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_STATUS_LOW_FAILEN_SHFT                                              3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_STATUS_LOW_RSPEEN_BMSK                                            0x4
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_STATUS_LOW_RSPEEN_SHFT                                              2
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_STATUS_LOW_ERREN_BMSK                                             0x2
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_STATUS_LOW_ERREN_SHFT                                               1
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_STATUS_LOW_REQRSPEN_BMSK                                          0x1
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_STATUS_LOW_REQRSPEN_SHFT                                            0

#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_ADDR(x)                                     ((x) + 0x1d78)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_PHYS(x)                                     ((x) + 0x1d78)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_OFFS                                        (0x1d78)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_RMSK                                            0xffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_POR                                         0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_POR_RMSK                                    0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_ATTR                                                     0x3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_FILTERS_0_EXTID_BASE_BMSK                       0xffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_BASE_LOW_FILTERS_0_EXTID_BASE_SHFT                            0

#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_ADDR(x)                                     ((x) + 0x1d80)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_PHYS(x)                                     ((x) + 0x1d80)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_OFFS                                        (0x1d80)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_RMSK                                            0xffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_POR                                         0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_POR_RMSK                                    0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_ATTR                                                     0x3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_FILTERS_0_EXTID_MASK_BMSK                       0xffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_0_EXTID_MASK_LOW_FILTERS_0_EXTID_MASK_SHFT                            0

#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_BASE_LOW_ADDR(x)                                      ((x) + 0x1e00)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_BASE_LOW_PHYS(x)                                      ((x) + 0x1e00)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_BASE_LOW_OFFS                                         (0x1e00)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_BASE_LOW_RMSK                                               0x3f
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_BASE_LOW_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_BASE_LOW_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_BASE_LOW_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_BASE_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_BASE_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_BASE_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_BASE_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_BASE_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_BASE_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_BASE_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_BASE_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_BASE_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_BASE_LOW_FILTERS_1_PATH_BASE_BMSK                           0x3f
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_BASE_LOW_FILTERS_1_PATH_BASE_SHFT                              0

#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_MASK_LOW_ADDR(x)                                      ((x) + 0x1e08)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_MASK_LOW_PHYS(x)                                      ((x) + 0x1e08)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_MASK_LOW_OFFS                                         (0x1e08)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_MASK_LOW_RMSK                                               0x3f
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_MASK_LOW_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_MASK_LOW_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_MASK_LOW_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_MASK_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_MASK_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_MASK_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_MASK_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_MASK_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_MASK_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_MASK_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_MASK_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_MASK_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_MASK_LOW_FILTERS_1_PATH_MASK_BMSK                           0x3f
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_PATH_MASK_LOW_FILTERS_1_PATH_MASK_SHFT                              0

#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_ADDR(x)                                       ((x) + 0x1e20)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_PHYS(x)                                       ((x) + 0x1e20)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_OFFS                                          (0x1e20)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_RMSK                                          0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_POR                                           0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_POR_RMSK                                      0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_ATTR                                                       0x3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_VALUE_LSB_BMSK                                0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_LOW_VALUE_LSB_SHFT                                         6

#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_ADDR(x)                                      ((x) + 0x1e24)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_PHYS(x)                                      ((x) + 0x1e24)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_OFFS                                         (0x1e24)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_RMSK                                                0xf
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_VALUE_MSB_BMSK                                      0xf
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MIN_HIGH_VALUE_MSB_SHFT                                        0

#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_ADDR(x)                                       ((x) + 0x1e28)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_PHYS(x)                                       ((x) + 0x1e28)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_OFFS                                          (0x1e28)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_RMSK                                          0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_POR                                           0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_POR_RMSK                                      0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_ATTR                                                       0x3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_VALUE_LSB_BMSK                                0xffffffc0
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_LOW_VALUE_LSB_SHFT                                         6

#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_ADDR(x)                                      ((x) + 0x1e2c)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_PHYS(x)                                      ((x) + 0x1e2c)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_OFFS                                         (0x1e2c)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_RMSK                                                0xf
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_POR                                          0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_POR_RMSK                                     0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_ATTR                                                      0x3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_VALUE_MSB_BMSK                                      0xf
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_ADDR_MAX_HIGH_VALUE_MSB_SHFT                                        0

#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_OPCODE_LOW_ADDR(x)                                         ((x) + 0x1e38)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_OPCODE_LOW_PHYS(x)                                         ((x) + 0x1e38)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_OPCODE_LOW_OFFS                                            (0x1e38)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_OPCODE_LOW_RMSK                                                  0x1f
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_OPCODE_LOW_POR                                             0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_OPCODE_LOW_POR_RMSK                                        0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_OPCODE_LOW_ATTR                                                         0x3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_OPCODE_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_OPCODE_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_OPCODE_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_OPCODE_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_OPCODE_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_OPCODE_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_OPCODE_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_OPCODE_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_OPCODE_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_OPCODE_LOW_ATOMEN_BMSK                                           0x10
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_OPCODE_LOW_ATOMEN_SHFT                                              4
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_OPCODE_LOW_CMEN_BMSK                                              0x8
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_OPCODE_LOW_CMEN_SHFT                                                3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_OPCODE_LOW_EXCLEN_BMSK                                            0x4
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_OPCODE_LOW_EXCLEN_SHFT                                              2
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_OPCODE_LOW_WREN_BMSK                                              0x2
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_OPCODE_LOW_WREN_SHFT                                                1
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_OPCODE_LOW_RDEN_BMSK                                              0x1
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_OPCODE_LOW_RDEN_SHFT                                                0

#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_STATUS_LOW_ADDR(x)                                         ((x) + 0x1e40)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_STATUS_LOW_PHYS(x)                                         ((x) + 0x1e40)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_STATUS_LOW_OFFS                                            (0x1e40)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_STATUS_LOW_RMSK                                                   0xf
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_STATUS_LOW_POR                                             0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_STATUS_LOW_POR_RMSK                                        0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_STATUS_LOW_ATTR                                                         0x3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_STATUS_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_STATUS_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_STATUS_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_STATUS_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_STATUS_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_STATUS_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_STATUS_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_STATUS_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_STATUS_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_STATUS_LOW_FAILEN_BMSK                                            0x8
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_STATUS_LOW_FAILEN_SHFT                                              3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_STATUS_LOW_RSPEEN_BMSK                                            0x4
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_STATUS_LOW_RSPEEN_SHFT                                              2
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_STATUS_LOW_ERREN_BMSK                                             0x2
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_STATUS_LOW_ERREN_SHFT                                               1
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_STATUS_LOW_REQRSPEN_BMSK                                          0x1
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_STATUS_LOW_REQRSPEN_SHFT                                            0

#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_ADDR(x)                                     ((x) + 0x1e78)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_PHYS(x)                                     ((x) + 0x1e78)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_OFFS                                        (0x1e78)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_RMSK                                            0xffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_POR                                         0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_POR_RMSK                                    0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_ATTR                                                     0x3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_FILTERS_1_EXTID_BASE_BMSK                       0xffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_BASE_LOW_FILTERS_1_EXTID_BASE_SHFT                            0

#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_ADDR(x)                                     ((x) + 0x1e80)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_PHYS(x)                                     ((x) + 0x1e80)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_OFFS                                        (0x1e80)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_RMSK                                            0xffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_POR                                         0x00000000
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_POR_RMSK                                    0xffffffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_ATTR                                                     0x3
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_ADDR(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_IN(x))
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_FILTERS_1_EXTID_MASK_BMSK                       0xffff
#define HWIO_UMAC_NOC_TRACEPROBE3_TRACEPRB_FILTERS_1_EXTID_MASK_LOW_FILTERS_1_EXTID_MASK_SHFT                            0

#define HWIO_UMAC_NOC_EC_SWID_LOW_ADDR(x)                                                                       ((x) + 0x3000)
#define HWIO_UMAC_NOC_EC_SWID_LOW_PHYS(x)                                                                       ((x) + 0x3000)
#define HWIO_UMAC_NOC_EC_SWID_LOW_OFFS                                                                          (0x3000)
#define HWIO_UMAC_NOC_EC_SWID_LOW_RMSK                                                                            0xffffff
#define HWIO_UMAC_NOC_EC_SWID_LOW_POR                                                                           0x000203e0
#define HWIO_UMAC_NOC_EC_SWID_LOW_POR_RMSK                                                                      0xffffffff
#define HWIO_UMAC_NOC_EC_SWID_LOW_ATTR                                                                                       0x1
#define HWIO_UMAC_NOC_EC_SWID_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_EC_SWID_LOW_ADDR(x))
#define HWIO_UMAC_NOC_EC_SWID_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_EC_SWID_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_EC_SWID_LOW_UNITTYPEID_BMSK                                                                 0xff0000
#define HWIO_UMAC_NOC_EC_SWID_LOW_UNITTYPEID_SHFT                                                                       16
#define HWIO_UMAC_NOC_EC_SWID_LOW_UNITCONFID_BMSK                                                                   0xffff
#define HWIO_UMAC_NOC_EC_SWID_LOW_UNITCONFID_SHFT                                                                        0

#define HWIO_UMAC_NOC_EC_SWID_HIGH_ADDR(x)                                                                      ((x) + 0x3004)
#define HWIO_UMAC_NOC_EC_SWID_HIGH_PHYS(x)                                                                      ((x) + 0x3004)
#define HWIO_UMAC_NOC_EC_SWID_HIGH_OFFS                                                                         (0x3004)
#define HWIO_UMAC_NOC_EC_SWID_HIGH_RMSK                                                                         0xffffffff
#define HWIO_UMAC_NOC_EC_SWID_HIGH_POR                                                                          0xfbb160c3
#define HWIO_UMAC_NOC_EC_SWID_HIGH_POR_RMSK                                                                     0xffffffff
#define HWIO_UMAC_NOC_EC_SWID_HIGH_ATTR                                                                                      0x1
#define HWIO_UMAC_NOC_EC_SWID_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_EC_SWID_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_EC_SWID_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_EC_SWID_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_EC_SWID_HIGH_QNOCID_BMSK                                                                  0xffffffff
#define HWIO_UMAC_NOC_EC_SWID_HIGH_QNOCID_SHFT                                                                           0

#define HWIO_UMAC_NOC_EC_MAINCTL_LOW_ADDR(x)                                                                    ((x) + 0x3008)
#define HWIO_UMAC_NOC_EC_MAINCTL_LOW_PHYS(x)                                                                    ((x) + 0x3008)
#define HWIO_UMAC_NOC_EC_MAINCTL_LOW_OFFS                                                                       (0x3008)
#define HWIO_UMAC_NOC_EC_MAINCTL_LOW_RMSK                                                                              0x7
#define HWIO_UMAC_NOC_EC_MAINCTL_LOW_POR                                                                        0x00000000
#define HWIO_UMAC_NOC_EC_MAINCTL_LOW_POR_RMSK                                                                   0xffffffff
#define HWIO_UMAC_NOC_EC_MAINCTL_LOW_ATTR                                                                                    0x3
#define HWIO_UMAC_NOC_EC_MAINCTL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_EC_MAINCTL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_EC_MAINCTL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_EC_MAINCTL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_EC_MAINCTL_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_EC_MAINCTL_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_EC_MAINCTL_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_EC_MAINCTL_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_EC_MAINCTL_LOW_IN(x))
#define HWIO_UMAC_NOC_EC_MAINCTL_LOW_IGNORECTITRIGIN0_BMSK                                                             0x4
#define HWIO_UMAC_NOC_EC_MAINCTL_LOW_IGNORECTITRIGIN0_SHFT                                                               2
#define HWIO_UMAC_NOC_EC_MAINCTL_LOW_DUMPEN_BMSK                                                                       0x2
#define HWIO_UMAC_NOC_EC_MAINCTL_LOW_DUMPEN_SHFT                                                                         1
#define HWIO_UMAC_NOC_EC_MAINCTL_LOW_GLBEN_BMSK                                                                        0x1
#define HWIO_UMAC_NOC_EC_MAINCTL_LOW_GLBEN_SHFT                                                                          0

#define HWIO_UMAC_NOC_EC_DUMPGO_LOW_ADDR(x)                                                                     ((x) + 0x3010)
#define HWIO_UMAC_NOC_EC_DUMPGO_LOW_PHYS(x)                                                                     ((x) + 0x3010)
#define HWIO_UMAC_NOC_EC_DUMPGO_LOW_OFFS                                                                        (0x3010)
#define HWIO_UMAC_NOC_EC_DUMPGO_LOW_RMSK                                                                               0x1
#define HWIO_UMAC_NOC_EC_DUMPGO_LOW_POR                                                                         0x00000000
#define HWIO_UMAC_NOC_EC_DUMPGO_LOW_POR_RMSK                                                                    0xffffffff
#define HWIO_UMAC_NOC_EC_DUMPGO_LOW_ATTR                                                                                     0x2
#define HWIO_UMAC_NOC_EC_DUMPGO_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_EC_DUMPGO_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_EC_DUMPGO_LOW_DUMPGO_BMSK                                                                        0x1
#define HWIO_UMAC_NOC_EC_DUMPGO_LOW_DUMPGO_SHFT                                                                          0

#define HWIO_UMAC_NOC_EC_DUMPPERIOD_LOW_ADDR(x)                                                                 ((x) + 0x3018)
#define HWIO_UMAC_NOC_EC_DUMPPERIOD_LOW_PHYS(x)                                                                 ((x) + 0x3018)
#define HWIO_UMAC_NOC_EC_DUMPPERIOD_LOW_OFFS                                                                    (0x3018)
#define HWIO_UMAC_NOC_EC_DUMPPERIOD_LOW_RMSK                                                                          0x1f
#define HWIO_UMAC_NOC_EC_DUMPPERIOD_LOW_POR                                                                     0x00000000
#define HWIO_UMAC_NOC_EC_DUMPPERIOD_LOW_POR_RMSK                                                                0xffffffff
#define HWIO_UMAC_NOC_EC_DUMPPERIOD_LOW_ATTR                                                                                 0x3
#define HWIO_UMAC_NOC_EC_DUMPPERIOD_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_EC_DUMPPERIOD_LOW_ADDR(x))
#define HWIO_UMAC_NOC_EC_DUMPPERIOD_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_EC_DUMPPERIOD_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_EC_DUMPPERIOD_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_EC_DUMPPERIOD_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_EC_DUMPPERIOD_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_EC_DUMPPERIOD_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_EC_DUMPPERIOD_LOW_IN(x))
#define HWIO_UMAC_NOC_EC_DUMPPERIOD_LOW_DUMPPERIOD_BMSK                                                               0x1f
#define HWIO_UMAC_NOC_EC_DUMPPERIOD_LOW_DUMPPERIOD_SHFT                                                                  0

#define HWIO_UMAC_NOC_EC_DUMPTHR_LOW_ADDR(x)                                                                    ((x) + 0x3020)
#define HWIO_UMAC_NOC_EC_DUMPTHR_LOW_PHYS(x)                                                                    ((x) + 0x3020)
#define HWIO_UMAC_NOC_EC_DUMPTHR_LOW_OFFS                                                                       (0x3020)
#define HWIO_UMAC_NOC_EC_DUMPTHR_LOW_RMSK                                                                           0xffff
#define HWIO_UMAC_NOC_EC_DUMPTHR_LOW_POR                                                                        0x00000000
#define HWIO_UMAC_NOC_EC_DUMPTHR_LOW_POR_RMSK                                                                   0xffffffff
#define HWIO_UMAC_NOC_EC_DUMPTHR_LOW_ATTR                                                                                    0x3
#define HWIO_UMAC_NOC_EC_DUMPTHR_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_EC_DUMPTHR_LOW_ADDR(x))
#define HWIO_UMAC_NOC_EC_DUMPTHR_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_EC_DUMPTHR_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_EC_DUMPTHR_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_EC_DUMPTHR_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_EC_DUMPTHR_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_EC_DUMPTHR_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_EC_DUMPTHR_LOW_IN(x))
#define HWIO_UMAC_NOC_EC_DUMPTHR_LOW_DUMPTHR_BMSK                                                                   0xffff
#define HWIO_UMAC_NOC_EC_DUMPTHR_LOW_DUMPTHR_SHFT                                                                        0

#define HWIO_UMAC_NOC_EC_ALARMMIN_LOW_ADDR(x)                                                                   ((x) + 0x3028)
#define HWIO_UMAC_NOC_EC_ALARMMIN_LOW_PHYS(x)                                                                   ((x) + 0x3028)
#define HWIO_UMAC_NOC_EC_ALARMMIN_LOW_OFFS                                                                      (0x3028)
#define HWIO_UMAC_NOC_EC_ALARMMIN_LOW_RMSK                                                                          0xffff
#define HWIO_UMAC_NOC_EC_ALARMMIN_LOW_POR                                                                       0x00000000
#define HWIO_UMAC_NOC_EC_ALARMMIN_LOW_POR_RMSK                                                                  0xffffffff
#define HWIO_UMAC_NOC_EC_ALARMMIN_LOW_ATTR                                                                                   0x3
#define HWIO_UMAC_NOC_EC_ALARMMIN_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_EC_ALARMMIN_LOW_ADDR(x))
#define HWIO_UMAC_NOC_EC_ALARMMIN_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_EC_ALARMMIN_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_EC_ALARMMIN_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_EC_ALARMMIN_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_EC_ALARMMIN_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_EC_ALARMMIN_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_EC_ALARMMIN_LOW_IN(x))
#define HWIO_UMAC_NOC_EC_ALARMMIN_LOW_ALARMMIN_BMSK                                                                 0xffff
#define HWIO_UMAC_NOC_EC_ALARMMIN_LOW_ALARMMIN_SHFT                                                                      0

#define HWIO_UMAC_NOC_EC_ALARMMAX_LOW_ADDR(x)                                                                   ((x) + 0x3030)
#define HWIO_UMAC_NOC_EC_ALARMMAX_LOW_PHYS(x)                                                                   ((x) + 0x3030)
#define HWIO_UMAC_NOC_EC_ALARMMAX_LOW_OFFS                                                                      (0x3030)
#define HWIO_UMAC_NOC_EC_ALARMMAX_LOW_RMSK                                                                          0xffff
#define HWIO_UMAC_NOC_EC_ALARMMAX_LOW_POR                                                                       0x00000000
#define HWIO_UMAC_NOC_EC_ALARMMAX_LOW_POR_RMSK                                                                  0xffffffff
#define HWIO_UMAC_NOC_EC_ALARMMAX_LOW_ATTR                                                                                   0x3
#define HWIO_UMAC_NOC_EC_ALARMMAX_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_EC_ALARMMAX_LOW_ADDR(x))
#define HWIO_UMAC_NOC_EC_ALARMMAX_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_EC_ALARMMAX_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_EC_ALARMMAX_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_EC_ALARMMAX_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_EC_ALARMMAX_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_EC_ALARMMAX_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_EC_ALARMMAX_LOW_IN(x))
#define HWIO_UMAC_NOC_EC_ALARMMAX_LOW_ALARMMAX_BMSK                                                                 0xffff
#define HWIO_UMAC_NOC_EC_ALARMMAX_LOW_ALARMMAX_SHFT                                                                      0

#define HWIO_UMAC_NOC_EC_ALARMSTATUS_LOW_ADDR(x)                                                                ((x) + 0x3038)
#define HWIO_UMAC_NOC_EC_ALARMSTATUS_LOW_PHYS(x)                                                                ((x) + 0x3038)
#define HWIO_UMAC_NOC_EC_ALARMSTATUS_LOW_OFFS                                                                   (0x3038)
#define HWIO_UMAC_NOC_EC_ALARMSTATUS_LOW_RMSK                                                                          0x1
#define HWIO_UMAC_NOC_EC_ALARMSTATUS_LOW_POR                                                                    0x00000000
#define HWIO_UMAC_NOC_EC_ALARMSTATUS_LOW_POR_RMSK                                                               0xffffffff
#define HWIO_UMAC_NOC_EC_ALARMSTATUS_LOW_ATTR                                                                                0x1
#define HWIO_UMAC_NOC_EC_ALARMSTATUS_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_EC_ALARMSTATUS_LOW_ADDR(x))
#define HWIO_UMAC_NOC_EC_ALARMSTATUS_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_EC_ALARMSTATUS_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_EC_ALARMSTATUS_LOW_ALARMSTATUS_BMSK                                                              0x1
#define HWIO_UMAC_NOC_EC_ALARMSTATUS_LOW_ALARMSTATUS_SHFT                                                                0

#define HWIO_UMAC_NOC_EC_ALARMCLR_LOW_ADDR(x)                                                                   ((x) + 0x3040)
#define HWIO_UMAC_NOC_EC_ALARMCLR_LOW_PHYS(x)                                                                   ((x) + 0x3040)
#define HWIO_UMAC_NOC_EC_ALARMCLR_LOW_OFFS                                                                      (0x3040)
#define HWIO_UMAC_NOC_EC_ALARMCLR_LOW_RMSK                                                                             0x1
#define HWIO_UMAC_NOC_EC_ALARMCLR_LOW_POR                                                                       0x00000000
#define HWIO_UMAC_NOC_EC_ALARMCLR_LOW_POR_RMSK                                                                  0xffffffff
#define HWIO_UMAC_NOC_EC_ALARMCLR_LOW_ATTR                                                                                   0x2
#define HWIO_UMAC_NOC_EC_ALARMCLR_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_EC_ALARMCLR_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_EC_ALARMCLR_LOW_ALARMCLR_BMSK                                                                    0x1
#define HWIO_UMAC_NOC_EC_ALARMCLR_LOW_ALARMCLR_SHFT                                                                      0

#define HWIO_UMAC_NOC_EC_ALARMEN_LOW_ADDR(x)                                                                    ((x) + 0x3048)
#define HWIO_UMAC_NOC_EC_ALARMEN_LOW_PHYS(x)                                                                    ((x) + 0x3048)
#define HWIO_UMAC_NOC_EC_ALARMEN_LOW_OFFS                                                                       (0x3048)
#define HWIO_UMAC_NOC_EC_ALARMEN_LOW_RMSK                                                                              0x1
#define HWIO_UMAC_NOC_EC_ALARMEN_LOW_POR                                                                        0x00000000
#define HWIO_UMAC_NOC_EC_ALARMEN_LOW_POR_RMSK                                                                   0xffffffff
#define HWIO_UMAC_NOC_EC_ALARMEN_LOW_ATTR                                                                                    0x3
#define HWIO_UMAC_NOC_EC_ALARMEN_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_EC_ALARMEN_LOW_ADDR(x))
#define HWIO_UMAC_NOC_EC_ALARMEN_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_EC_ALARMEN_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_EC_ALARMEN_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_EC_ALARMEN_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_EC_ALARMEN_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_EC_ALARMEN_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_EC_ALARMEN_LOW_IN(x))
#define HWIO_UMAC_NOC_EC_ALARMEN_LOW_ALARMEN_BMSK                                                                      0x1
#define HWIO_UMAC_NOC_EC_ALARMEN_LOW_ALARMEN_SHFT                                                                        0

#define HWIO_UMAC_NOC_EC_COUNTERCLR_LOW_ADDR(x)                                                                 ((x) + 0x3050)
#define HWIO_UMAC_NOC_EC_COUNTERCLR_LOW_PHYS(x)                                                                 ((x) + 0x3050)
#define HWIO_UMAC_NOC_EC_COUNTERCLR_LOW_OFFS                                                                    (0x3050)
#define HWIO_UMAC_NOC_EC_COUNTERCLR_LOW_RMSK                                                                          0xff
#define HWIO_UMAC_NOC_EC_COUNTERCLR_LOW_POR                                                                     0x00000000
#define HWIO_UMAC_NOC_EC_COUNTERCLR_LOW_POR_RMSK                                                                0xffffffff
#define HWIO_UMAC_NOC_EC_COUNTERCLR_LOW_ATTR                                                                                 0x2
#define HWIO_UMAC_NOC_EC_COUNTERCLR_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_EC_COUNTERCLR_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_EC_COUNTERCLR_LOW_COUNTERCLR_BMSK                                                               0xff
#define HWIO_UMAC_NOC_EC_COUNTERCLR_LOW_COUNTERCLR_SHFT                                                                  0

#define HWIO_UMAC_NOC_EC_COUNTER0CTL_LOW_ADDR(x)                                                                ((x) + 0x3100)
#define HWIO_UMAC_NOC_EC_COUNTER0CTL_LOW_PHYS(x)                                                                ((x) + 0x3100)
#define HWIO_UMAC_NOC_EC_COUNTER0CTL_LOW_OFFS                                                                   (0x3100)
#define HWIO_UMAC_NOC_EC_COUNTER0CTL_LOW_RMSK                                                                        0x77f
#define HWIO_UMAC_NOC_EC_COUNTER0CTL_LOW_POR                                                                    0x0000007f
#define HWIO_UMAC_NOC_EC_COUNTER0CTL_LOW_POR_RMSK                                                               0xffffffff
#define HWIO_UMAC_NOC_EC_COUNTER0CTL_LOW_ATTR                                                                                0x3
#define HWIO_UMAC_NOC_EC_COUNTER0CTL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_EC_COUNTER0CTL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_EC_COUNTER0CTL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_EC_COUNTER0CTL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_EC_COUNTER0CTL_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_EC_COUNTER0CTL_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_EC_COUNTER0CTL_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_EC_COUNTER0CTL_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_EC_COUNTER0CTL_LOW_IN(x))
#define HWIO_UMAC_NOC_EC_COUNTER0CTL_LOW_ALARMMODE_BMSK                                                              0x600
#define HWIO_UMAC_NOC_EC_COUNTER0CTL_LOW_ALARMMODE_SHFT                                                                  9
#define HWIO_UMAC_NOC_EC_COUNTER0CTL_LOW_DUMPTHREN_BMSK                                                              0x100
#define HWIO_UMAC_NOC_EC_COUNTER0CTL_LOW_DUMPTHREN_SHFT                                                                  8
#define HWIO_UMAC_NOC_EC_COUNTER0CTL_LOW_EVENTSRC_BMSK                                                                0x7f
#define HWIO_UMAC_NOC_EC_COUNTER0CTL_LOW_EVENTSRC_SHFT                                                                   0

#define HWIO_UMAC_NOC_EC_COUNTER0VAL_LOW_ADDR(x)                                                                ((x) + 0x3140)
#define HWIO_UMAC_NOC_EC_COUNTER0VAL_LOW_PHYS(x)                                                                ((x) + 0x3140)
#define HWIO_UMAC_NOC_EC_COUNTER0VAL_LOW_OFFS                                                                   (0x3140)
#define HWIO_UMAC_NOC_EC_COUNTER0VAL_LOW_RMSK                                                                       0xffff
#define HWIO_UMAC_NOC_EC_COUNTER0VAL_LOW_POR                                                                    0x00000000
#define HWIO_UMAC_NOC_EC_COUNTER0VAL_LOW_POR_RMSK                                                               0xffffffff
#define HWIO_UMAC_NOC_EC_COUNTER0VAL_LOW_ATTR                                                                                0x1
#define HWIO_UMAC_NOC_EC_COUNTER0VAL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_EC_COUNTER0VAL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_EC_COUNTER0VAL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_EC_COUNTER0VAL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_EC_COUNTER0VAL_LOW_COUNTER0VAL_BMSK                                                           0xffff
#define HWIO_UMAC_NOC_EC_COUNTER0VAL_LOW_COUNTER0VAL_SHFT                                                                0

#define HWIO_UMAC_NOC_EC_COUNTER1CTL_LOW_ADDR(x)                                                                ((x) + 0x3180)
#define HWIO_UMAC_NOC_EC_COUNTER1CTL_LOW_PHYS(x)                                                                ((x) + 0x3180)
#define HWIO_UMAC_NOC_EC_COUNTER1CTL_LOW_OFFS                                                                   (0x3180)
#define HWIO_UMAC_NOC_EC_COUNTER1CTL_LOW_RMSK                                                                        0x77f
#define HWIO_UMAC_NOC_EC_COUNTER1CTL_LOW_POR                                                                    0x0000007f
#define HWIO_UMAC_NOC_EC_COUNTER1CTL_LOW_POR_RMSK                                                               0xffffffff
#define HWIO_UMAC_NOC_EC_COUNTER1CTL_LOW_ATTR                                                                                0x3
#define HWIO_UMAC_NOC_EC_COUNTER1CTL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_EC_COUNTER1CTL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_EC_COUNTER1CTL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_EC_COUNTER1CTL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_EC_COUNTER1CTL_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_EC_COUNTER1CTL_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_EC_COUNTER1CTL_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_EC_COUNTER1CTL_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_EC_COUNTER1CTL_LOW_IN(x))
#define HWIO_UMAC_NOC_EC_COUNTER1CTL_LOW_ALARMMODE_BMSK                                                              0x600
#define HWIO_UMAC_NOC_EC_COUNTER1CTL_LOW_ALARMMODE_SHFT                                                                  9
#define HWIO_UMAC_NOC_EC_COUNTER1CTL_LOW_DUMPTHREN_BMSK                                                              0x100
#define HWIO_UMAC_NOC_EC_COUNTER1CTL_LOW_DUMPTHREN_SHFT                                                                  8
#define HWIO_UMAC_NOC_EC_COUNTER1CTL_LOW_EVENTSRC_BMSK                                                                0x7f
#define HWIO_UMAC_NOC_EC_COUNTER1CTL_LOW_EVENTSRC_SHFT                                                                   0

#define HWIO_UMAC_NOC_EC_COUNTER1VAL_LOW_ADDR(x)                                                                ((x) + 0x31c0)
#define HWIO_UMAC_NOC_EC_COUNTER1VAL_LOW_PHYS(x)                                                                ((x) + 0x31c0)
#define HWIO_UMAC_NOC_EC_COUNTER1VAL_LOW_OFFS                                                                   (0x31c0)
#define HWIO_UMAC_NOC_EC_COUNTER1VAL_LOW_RMSK                                                                       0xffff
#define HWIO_UMAC_NOC_EC_COUNTER1VAL_LOW_POR                                                                    0x00000000
#define HWIO_UMAC_NOC_EC_COUNTER1VAL_LOW_POR_RMSK                                                               0xffffffff
#define HWIO_UMAC_NOC_EC_COUNTER1VAL_LOW_ATTR                                                                                0x1
#define HWIO_UMAC_NOC_EC_COUNTER1VAL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_EC_COUNTER1VAL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_EC_COUNTER1VAL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_EC_COUNTER1VAL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_EC_COUNTER1VAL_LOW_COUNTER1VAL_BMSK                                                           0xffff
#define HWIO_UMAC_NOC_EC_COUNTER1VAL_LOW_COUNTER1VAL_SHFT                                                                0

#define HWIO_UMAC_NOC_EC_COUNTER2CTL_LOW_ADDR(x)                                                                ((x) + 0x3200)
#define HWIO_UMAC_NOC_EC_COUNTER2CTL_LOW_PHYS(x)                                                                ((x) + 0x3200)
#define HWIO_UMAC_NOC_EC_COUNTER2CTL_LOW_OFFS                                                                   (0x3200)
#define HWIO_UMAC_NOC_EC_COUNTER2CTL_LOW_RMSK                                                                        0x77f
#define HWIO_UMAC_NOC_EC_COUNTER2CTL_LOW_POR                                                                    0x0000007f
#define HWIO_UMAC_NOC_EC_COUNTER2CTL_LOW_POR_RMSK                                                               0xffffffff
#define HWIO_UMAC_NOC_EC_COUNTER2CTL_LOW_ATTR                                                                                0x3
#define HWIO_UMAC_NOC_EC_COUNTER2CTL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_EC_COUNTER2CTL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_EC_COUNTER2CTL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_EC_COUNTER2CTL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_EC_COUNTER2CTL_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_EC_COUNTER2CTL_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_EC_COUNTER2CTL_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_EC_COUNTER2CTL_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_EC_COUNTER2CTL_LOW_IN(x))
#define HWIO_UMAC_NOC_EC_COUNTER2CTL_LOW_ALARMMODE_BMSK                                                              0x600
#define HWIO_UMAC_NOC_EC_COUNTER2CTL_LOW_ALARMMODE_SHFT                                                                  9
#define HWIO_UMAC_NOC_EC_COUNTER2CTL_LOW_DUMPTHREN_BMSK                                                              0x100
#define HWIO_UMAC_NOC_EC_COUNTER2CTL_LOW_DUMPTHREN_SHFT                                                                  8
#define HWIO_UMAC_NOC_EC_COUNTER2CTL_LOW_EVENTSRC_BMSK                                                                0x7f
#define HWIO_UMAC_NOC_EC_COUNTER2CTL_LOW_EVENTSRC_SHFT                                                                   0

#define HWIO_UMAC_NOC_EC_COUNTER2VAL_LOW_ADDR(x)                                                                ((x) + 0x3240)
#define HWIO_UMAC_NOC_EC_COUNTER2VAL_LOW_PHYS(x)                                                                ((x) + 0x3240)
#define HWIO_UMAC_NOC_EC_COUNTER2VAL_LOW_OFFS                                                                   (0x3240)
#define HWIO_UMAC_NOC_EC_COUNTER2VAL_LOW_RMSK                                                                       0xffff
#define HWIO_UMAC_NOC_EC_COUNTER2VAL_LOW_POR                                                                    0x00000000
#define HWIO_UMAC_NOC_EC_COUNTER2VAL_LOW_POR_RMSK                                                               0xffffffff
#define HWIO_UMAC_NOC_EC_COUNTER2VAL_LOW_ATTR                                                                                0x1
#define HWIO_UMAC_NOC_EC_COUNTER2VAL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_EC_COUNTER2VAL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_EC_COUNTER2VAL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_EC_COUNTER2VAL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_EC_COUNTER2VAL_LOW_COUNTER2VAL_BMSK                                                           0xffff
#define HWIO_UMAC_NOC_EC_COUNTER2VAL_LOW_COUNTER2VAL_SHFT                                                                0

#define HWIO_UMAC_NOC_EC_COUNTER3CTL_LOW_ADDR(x)                                                                ((x) + 0x3280)
#define HWIO_UMAC_NOC_EC_COUNTER3CTL_LOW_PHYS(x)                                                                ((x) + 0x3280)
#define HWIO_UMAC_NOC_EC_COUNTER3CTL_LOW_OFFS                                                                   (0x3280)
#define HWIO_UMAC_NOC_EC_COUNTER3CTL_LOW_RMSK                                                                        0x77f
#define HWIO_UMAC_NOC_EC_COUNTER3CTL_LOW_POR                                                                    0x0000007f
#define HWIO_UMAC_NOC_EC_COUNTER3CTL_LOW_POR_RMSK                                                               0xffffffff
#define HWIO_UMAC_NOC_EC_COUNTER3CTL_LOW_ATTR                                                                                0x3
#define HWIO_UMAC_NOC_EC_COUNTER3CTL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_EC_COUNTER3CTL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_EC_COUNTER3CTL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_EC_COUNTER3CTL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_EC_COUNTER3CTL_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_EC_COUNTER3CTL_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_EC_COUNTER3CTL_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_EC_COUNTER3CTL_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_EC_COUNTER3CTL_LOW_IN(x))
#define HWIO_UMAC_NOC_EC_COUNTER3CTL_LOW_ALARMMODE_BMSK                                                              0x600
#define HWIO_UMAC_NOC_EC_COUNTER3CTL_LOW_ALARMMODE_SHFT                                                                  9
#define HWIO_UMAC_NOC_EC_COUNTER3CTL_LOW_DUMPTHREN_BMSK                                                              0x100
#define HWIO_UMAC_NOC_EC_COUNTER3CTL_LOW_DUMPTHREN_SHFT                                                                  8
#define HWIO_UMAC_NOC_EC_COUNTER3CTL_LOW_EVENTSRC_BMSK                                                                0x7f
#define HWIO_UMAC_NOC_EC_COUNTER3CTL_LOW_EVENTSRC_SHFT                                                                   0

#define HWIO_UMAC_NOC_EC_COUNTER3VAL_LOW_ADDR(x)                                                                ((x) + 0x32c0)
#define HWIO_UMAC_NOC_EC_COUNTER3VAL_LOW_PHYS(x)                                                                ((x) + 0x32c0)
#define HWIO_UMAC_NOC_EC_COUNTER3VAL_LOW_OFFS                                                                   (0x32c0)
#define HWIO_UMAC_NOC_EC_COUNTER3VAL_LOW_RMSK                                                                       0xffff
#define HWIO_UMAC_NOC_EC_COUNTER3VAL_LOW_POR                                                                    0x00000000
#define HWIO_UMAC_NOC_EC_COUNTER3VAL_LOW_POR_RMSK                                                               0xffffffff
#define HWIO_UMAC_NOC_EC_COUNTER3VAL_LOW_ATTR                                                                                0x1
#define HWIO_UMAC_NOC_EC_COUNTER3VAL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_EC_COUNTER3VAL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_EC_COUNTER3VAL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_EC_COUNTER3VAL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_EC_COUNTER3VAL_LOW_COUNTER3VAL_BMSK                                                           0xffff
#define HWIO_UMAC_NOC_EC_COUNTER3VAL_LOW_COUNTER3VAL_SHFT                                                                0

#define HWIO_UMAC_NOC_EC_COUNTER4CTL_LOW_ADDR(x)                                                                ((x) + 0x3300)
#define HWIO_UMAC_NOC_EC_COUNTER4CTL_LOW_PHYS(x)                                                                ((x) + 0x3300)
#define HWIO_UMAC_NOC_EC_COUNTER4CTL_LOW_OFFS                                                                   (0x3300)
#define HWIO_UMAC_NOC_EC_COUNTER4CTL_LOW_RMSK                                                                        0x77f
#define HWIO_UMAC_NOC_EC_COUNTER4CTL_LOW_POR                                                                    0x0000007f
#define HWIO_UMAC_NOC_EC_COUNTER4CTL_LOW_POR_RMSK                                                               0xffffffff
#define HWIO_UMAC_NOC_EC_COUNTER4CTL_LOW_ATTR                                                                                0x3
#define HWIO_UMAC_NOC_EC_COUNTER4CTL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_EC_COUNTER4CTL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_EC_COUNTER4CTL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_EC_COUNTER4CTL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_EC_COUNTER4CTL_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_EC_COUNTER4CTL_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_EC_COUNTER4CTL_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_EC_COUNTER4CTL_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_EC_COUNTER4CTL_LOW_IN(x))
#define HWIO_UMAC_NOC_EC_COUNTER4CTL_LOW_ALARMMODE_BMSK                                                              0x600
#define HWIO_UMAC_NOC_EC_COUNTER4CTL_LOW_ALARMMODE_SHFT                                                                  9
#define HWIO_UMAC_NOC_EC_COUNTER4CTL_LOW_DUMPTHREN_BMSK                                                              0x100
#define HWIO_UMAC_NOC_EC_COUNTER4CTL_LOW_DUMPTHREN_SHFT                                                                  8
#define HWIO_UMAC_NOC_EC_COUNTER4CTL_LOW_EVENTSRC_BMSK                                                                0x7f
#define HWIO_UMAC_NOC_EC_COUNTER4CTL_LOW_EVENTSRC_SHFT                                                                   0

#define HWIO_UMAC_NOC_EC_COUNTER4VAL_LOW_ADDR(x)                                                                ((x) + 0x3340)
#define HWIO_UMAC_NOC_EC_COUNTER4VAL_LOW_PHYS(x)                                                                ((x) + 0x3340)
#define HWIO_UMAC_NOC_EC_COUNTER4VAL_LOW_OFFS                                                                   (0x3340)
#define HWIO_UMAC_NOC_EC_COUNTER4VAL_LOW_RMSK                                                                       0xffff
#define HWIO_UMAC_NOC_EC_COUNTER4VAL_LOW_POR                                                                    0x00000000
#define HWIO_UMAC_NOC_EC_COUNTER4VAL_LOW_POR_RMSK                                                               0xffffffff
#define HWIO_UMAC_NOC_EC_COUNTER4VAL_LOW_ATTR                                                                                0x1
#define HWIO_UMAC_NOC_EC_COUNTER4VAL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_EC_COUNTER4VAL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_EC_COUNTER4VAL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_EC_COUNTER4VAL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_EC_COUNTER4VAL_LOW_COUNTER4VAL_BMSK                                                           0xffff
#define HWIO_UMAC_NOC_EC_COUNTER4VAL_LOW_COUNTER4VAL_SHFT                                                                0

#define HWIO_UMAC_NOC_EC_COUNTER5CTL_LOW_ADDR(x)                                                                ((x) + 0x3380)
#define HWIO_UMAC_NOC_EC_COUNTER5CTL_LOW_PHYS(x)                                                                ((x) + 0x3380)
#define HWIO_UMAC_NOC_EC_COUNTER5CTL_LOW_OFFS                                                                   (0x3380)
#define HWIO_UMAC_NOC_EC_COUNTER5CTL_LOW_RMSK                                                                        0x77f
#define HWIO_UMAC_NOC_EC_COUNTER5CTL_LOW_POR                                                                    0x0000007f
#define HWIO_UMAC_NOC_EC_COUNTER5CTL_LOW_POR_RMSK                                                               0xffffffff
#define HWIO_UMAC_NOC_EC_COUNTER5CTL_LOW_ATTR                                                                                0x3
#define HWIO_UMAC_NOC_EC_COUNTER5CTL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_EC_COUNTER5CTL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_EC_COUNTER5CTL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_EC_COUNTER5CTL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_EC_COUNTER5CTL_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_EC_COUNTER5CTL_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_EC_COUNTER5CTL_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_EC_COUNTER5CTL_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_EC_COUNTER5CTL_LOW_IN(x))
#define HWIO_UMAC_NOC_EC_COUNTER5CTL_LOW_ALARMMODE_BMSK                                                              0x600
#define HWIO_UMAC_NOC_EC_COUNTER5CTL_LOW_ALARMMODE_SHFT                                                                  9
#define HWIO_UMAC_NOC_EC_COUNTER5CTL_LOW_DUMPTHREN_BMSK                                                              0x100
#define HWIO_UMAC_NOC_EC_COUNTER5CTL_LOW_DUMPTHREN_SHFT                                                                  8
#define HWIO_UMAC_NOC_EC_COUNTER5CTL_LOW_EVENTSRC_BMSK                                                                0x7f
#define HWIO_UMAC_NOC_EC_COUNTER5CTL_LOW_EVENTSRC_SHFT                                                                   0

#define HWIO_UMAC_NOC_EC_COUNTER5VAL_LOW_ADDR(x)                                                                ((x) + 0x33c0)
#define HWIO_UMAC_NOC_EC_COUNTER5VAL_LOW_PHYS(x)                                                                ((x) + 0x33c0)
#define HWIO_UMAC_NOC_EC_COUNTER5VAL_LOW_OFFS                                                                   (0x33c0)
#define HWIO_UMAC_NOC_EC_COUNTER5VAL_LOW_RMSK                                                                       0xffff
#define HWIO_UMAC_NOC_EC_COUNTER5VAL_LOW_POR                                                                    0x00000000
#define HWIO_UMAC_NOC_EC_COUNTER5VAL_LOW_POR_RMSK                                                               0xffffffff
#define HWIO_UMAC_NOC_EC_COUNTER5VAL_LOW_ATTR                                                                                0x1
#define HWIO_UMAC_NOC_EC_COUNTER5VAL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_EC_COUNTER5VAL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_EC_COUNTER5VAL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_EC_COUNTER5VAL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_EC_COUNTER5VAL_LOW_COUNTER5VAL_BMSK                                                           0xffff
#define HWIO_UMAC_NOC_EC_COUNTER5VAL_LOW_COUNTER5VAL_SHFT                                                                0

#define HWIO_UMAC_NOC_EC_COUNTER6CTL_LOW_ADDR(x)                                                                ((x) + 0x3400)
#define HWIO_UMAC_NOC_EC_COUNTER6CTL_LOW_PHYS(x)                                                                ((x) + 0x3400)
#define HWIO_UMAC_NOC_EC_COUNTER6CTL_LOW_OFFS                                                                   (0x3400)
#define HWIO_UMAC_NOC_EC_COUNTER6CTL_LOW_RMSK                                                                        0x77f
#define HWIO_UMAC_NOC_EC_COUNTER6CTL_LOW_POR                                                                    0x0000007f
#define HWIO_UMAC_NOC_EC_COUNTER6CTL_LOW_POR_RMSK                                                               0xffffffff
#define HWIO_UMAC_NOC_EC_COUNTER6CTL_LOW_ATTR                                                                                0x3
#define HWIO_UMAC_NOC_EC_COUNTER6CTL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_EC_COUNTER6CTL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_EC_COUNTER6CTL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_EC_COUNTER6CTL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_EC_COUNTER6CTL_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_EC_COUNTER6CTL_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_EC_COUNTER6CTL_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_EC_COUNTER6CTL_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_EC_COUNTER6CTL_LOW_IN(x))
#define HWIO_UMAC_NOC_EC_COUNTER6CTL_LOW_ALARMMODE_BMSK                                                              0x600
#define HWIO_UMAC_NOC_EC_COUNTER6CTL_LOW_ALARMMODE_SHFT                                                                  9
#define HWIO_UMAC_NOC_EC_COUNTER6CTL_LOW_DUMPTHREN_BMSK                                                              0x100
#define HWIO_UMAC_NOC_EC_COUNTER6CTL_LOW_DUMPTHREN_SHFT                                                                  8
#define HWIO_UMAC_NOC_EC_COUNTER6CTL_LOW_EVENTSRC_BMSK                                                                0x7f
#define HWIO_UMAC_NOC_EC_COUNTER6CTL_LOW_EVENTSRC_SHFT                                                                   0

#define HWIO_UMAC_NOC_EC_COUNTER6VAL_LOW_ADDR(x)                                                                ((x) + 0x3440)
#define HWIO_UMAC_NOC_EC_COUNTER6VAL_LOW_PHYS(x)                                                                ((x) + 0x3440)
#define HWIO_UMAC_NOC_EC_COUNTER6VAL_LOW_OFFS                                                                   (0x3440)
#define HWIO_UMAC_NOC_EC_COUNTER6VAL_LOW_RMSK                                                                       0xffff
#define HWIO_UMAC_NOC_EC_COUNTER6VAL_LOW_POR                                                                    0x00000000
#define HWIO_UMAC_NOC_EC_COUNTER6VAL_LOW_POR_RMSK                                                               0xffffffff
#define HWIO_UMAC_NOC_EC_COUNTER6VAL_LOW_ATTR                                                                                0x1
#define HWIO_UMAC_NOC_EC_COUNTER6VAL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_EC_COUNTER6VAL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_EC_COUNTER6VAL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_EC_COUNTER6VAL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_EC_COUNTER6VAL_LOW_COUNTER6VAL_BMSK                                                           0xffff
#define HWIO_UMAC_NOC_EC_COUNTER6VAL_LOW_COUNTER6VAL_SHFT                                                                0

#define HWIO_UMAC_NOC_EC_COUNTER7CTL_LOW_ADDR(x)                                                                ((x) + 0x3480)
#define HWIO_UMAC_NOC_EC_COUNTER7CTL_LOW_PHYS(x)                                                                ((x) + 0x3480)
#define HWIO_UMAC_NOC_EC_COUNTER7CTL_LOW_OFFS                                                                   (0x3480)
#define HWIO_UMAC_NOC_EC_COUNTER7CTL_LOW_RMSK                                                                        0x77f
#define HWIO_UMAC_NOC_EC_COUNTER7CTL_LOW_POR                                                                    0x0000007f
#define HWIO_UMAC_NOC_EC_COUNTER7CTL_LOW_POR_RMSK                                                               0xffffffff
#define HWIO_UMAC_NOC_EC_COUNTER7CTL_LOW_ATTR                                                                                0x3
#define HWIO_UMAC_NOC_EC_COUNTER7CTL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_EC_COUNTER7CTL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_EC_COUNTER7CTL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_EC_COUNTER7CTL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_EC_COUNTER7CTL_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_EC_COUNTER7CTL_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_EC_COUNTER7CTL_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_EC_COUNTER7CTL_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_EC_COUNTER7CTL_LOW_IN(x))
#define HWIO_UMAC_NOC_EC_COUNTER7CTL_LOW_ALARMMODE_BMSK                                                              0x600
#define HWIO_UMAC_NOC_EC_COUNTER7CTL_LOW_ALARMMODE_SHFT                                                                  9
#define HWIO_UMAC_NOC_EC_COUNTER7CTL_LOW_DUMPTHREN_BMSK                                                              0x100
#define HWIO_UMAC_NOC_EC_COUNTER7CTL_LOW_DUMPTHREN_SHFT                                                                  8
#define HWIO_UMAC_NOC_EC_COUNTER7CTL_LOW_EVENTSRC_BMSK                                                                0x7f
#define HWIO_UMAC_NOC_EC_COUNTER7CTL_LOW_EVENTSRC_SHFT                                                                   0

#define HWIO_UMAC_NOC_EC_COUNTER7VAL_LOW_ADDR(x)                                                                ((x) + 0x34c0)
#define HWIO_UMAC_NOC_EC_COUNTER7VAL_LOW_PHYS(x)                                                                ((x) + 0x34c0)
#define HWIO_UMAC_NOC_EC_COUNTER7VAL_LOW_OFFS                                                                   (0x34c0)
#define HWIO_UMAC_NOC_EC_COUNTER7VAL_LOW_RMSK                                                                       0xffff
#define HWIO_UMAC_NOC_EC_COUNTER7VAL_LOW_POR                                                                    0x00000000
#define HWIO_UMAC_NOC_EC_COUNTER7VAL_LOW_POR_RMSK                                                               0xffffffff
#define HWIO_UMAC_NOC_EC_COUNTER7VAL_LOW_ATTR                                                                                0x1
#define HWIO_UMAC_NOC_EC_COUNTER7VAL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_EC_COUNTER7VAL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_EC_COUNTER7VAL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_EC_COUNTER7VAL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_EC_COUNTER7VAL_LOW_COUNTER7VAL_BMSK                                                           0xffff
#define HWIO_UMAC_NOC_EC_COUNTER7VAL_LOW_COUNTER7VAL_SHFT                                                                0

#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_SWID_LOW_ADDR(x)                                                     ((x) + 0x4000)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_SWID_LOW_PHYS(x)                                                     ((x) + 0x4000)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_SWID_LOW_OFFS                                                        (0x4000)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_SWID_LOW_RMSK                                                          0xffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_SWID_LOW_POR                                                         0x0003fc04
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_SWID_LOW_POR_RMSK                                                    0xffffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_SWID_LOW_ATTR                                                                     0x1
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_SWID_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_SWID_LOW_ADDR(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_SWID_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_SWID_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_SWID_LOW_UNITTYPEID_BMSK                                               0xff0000
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_SWID_LOW_UNITTYPEID_SHFT                                                     16
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_SWID_LOW_UNITCONFID_BMSK                                                 0xffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_SWID_LOW_UNITCONFID_SHFT                                                      0

#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_SWID_HIGH_ADDR(x)                                                    ((x) + 0x4004)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_SWID_HIGH_PHYS(x)                                                    ((x) + 0x4004)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_SWID_HIGH_OFFS                                                       (0x4004)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_SWID_HIGH_RMSK                                                       0xffffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_SWID_HIGH_POR                                                        0xfbb160c3
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_SWID_HIGH_POR_RMSK                                                   0xffffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_SWID_HIGH_ATTR                                                                    0x1
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_SWID_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_SWID_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_SWID_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_SWID_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_SWID_HIGH_QNOCID_BMSK                                                0xffffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_SWID_HIGH_QNOCID_SHFT                                                         0

#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_MAINCTL_LOW_ADDR(x)                                                  ((x) + 0x4008)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_MAINCTL_LOW_PHYS(x)                                                  ((x) + 0x4008)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_MAINCTL_LOW_OFFS                                                     (0x4008)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_MAINCTL_LOW_RMSK                                                          0x33f
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_MAINCTL_LOW_POR                                                      0x00000020
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_MAINCTL_LOW_POR_RMSK                                                 0xffffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_MAINCTL_LOW_ATTR                                                                  0x3
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_MAINCTL_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_MAINCTL_LOW_ADDR(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_MAINCTL_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_MAINCTL_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_MAINCTL_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_MAINCTL_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_MAINCTL_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_MAINCTL_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_MAINCTL_LOW_IN(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_MAINCTL_LOW_HISTPENDLAW_BMSK                                              0x300
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_MAINCTL_LOW_HISTPENDLAW_SHFT                                                  8
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_MAINCTL_LOW_IGNORECTITRIGIN0_BMSK                                          0x20
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_MAINCTL_LOW_IGNORECTITRIGIN0_SHFT                                             5
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_MAINCTL_LOW_CTITRIGOUTEN_BMSK                                              0x10
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_MAINCTL_LOW_CTITRIGOUTEN_SHFT                                                 4
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_MAINCTL_LOW_SCALEEN_BMSK                                                    0x8
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_MAINCTL_LOW_SCALEEN_SHFT                                                      3
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_MAINCTL_LOW_DUMPEN_BMSK                                                     0x4
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_MAINCTL_LOW_DUMPEN_SHFT                                                       2
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_MAINCTL_LOW_MODE_BMSK                                                       0x3
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_MAINCTL_LOW_MODE_SHFT                                                         0

#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_DUMPGO_LOW_ADDR(x)                                                   ((x) + 0x4010)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_DUMPGO_LOW_PHYS(x)                                                   ((x) + 0x4010)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_DUMPGO_LOW_OFFS                                                      (0x4010)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_DUMPGO_LOW_RMSK                                                             0x1
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_DUMPGO_LOW_POR                                                       0x00000000
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_DUMPGO_LOW_POR_RMSK                                                  0xffffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_DUMPGO_LOW_ATTR                                                                   0x2
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_DUMPGO_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_DUMPGO_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_DUMPGO_LOW_DUMPGO_BMSK                                                      0x1
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_DUMPGO_LOW_DUMPGO_SHFT                                                        0

#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_DUMPTHR_LOW_ADDR(x)                                                  ((x) + 0x4018)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_DUMPTHR_LOW_PHYS(x)                                                  ((x) + 0x4018)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_DUMPTHR_LOW_OFFS                                                     (0x4018)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_DUMPTHR_LOW_RMSK                                                       0xffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_DUMPTHR_LOW_POR                                                      0x00001000
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_DUMPTHR_LOW_POR_RMSK                                                 0xffffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_DUMPTHR_LOW_ATTR                                                                  0x3
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_DUMPTHR_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_DUMPTHR_LOW_ADDR(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_DUMPTHR_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_DUMPTHR_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_DUMPTHR_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_DUMPTHR_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_DUMPTHR_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_DUMPTHR_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_DUMPTHR_LOW_IN(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_DUMPTHR_LOW_DUMPTHR_BMSK                                               0xffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_DUMPTHR_LOW_DUMPTHR_SHFT                                                      0

#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_BIN_LOW_ADDR(x)                                                      ((x) + 0x4020)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_BIN_LOW_PHYS(x)                                                      ((x) + 0x4020)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_BIN_LOW_OFFS                                                         (0x4020)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_BIN_LOW_RMSK                                                          0xfffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_BIN_LOW_POR                                                          0x00a0083f
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_BIN_LOW_POR_RMSK                                                     0xffffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_BIN_LOW_ATTR                                                                      0x3
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_BIN_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_BIN_LOW_ADDR(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_BIN_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_BIN_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_BIN_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_BIN_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_BIN_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_BIN_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_BIN_LOW_IN(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_BIN_LOW_NOMINALFREQ_BMSK                                              0xfff0000
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_BIN_LOW_NOMINALFREQ_SHFT                                                     16
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_BIN_LOW_OFFSET_BMSK                                                      0xff00
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_BIN_LOW_OFFSET_SHFT                                                           8
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_BIN_LOW_WIDTH_BMSK                                                         0xff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_BIN_LOW_WIDTH_SHFT                                                            0

#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_AVLATENCY_LOW_ADDR(x)                                                ((x) + 0x4028)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_AVLATENCY_LOW_PHYS(x)                                                ((x) + 0x4028)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_AVLATENCY_LOW_OFFS                                                   (0x4028)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_AVLATENCY_LOW_RMSK                                                   0xffffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_AVLATENCY_LOW_POR                                                    0x00000000
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_AVLATENCY_LOW_POR_RMSK                                               0xffffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_AVLATENCY_LOW_ATTR                                                                0x1
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_AVLATENCY_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_AVLATENCY_LOW_ADDR(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_AVLATENCY_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_AVLATENCY_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_AVLATENCY_LOW_LATSUM_LSB_BMSK                                        0xffffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_AVLATENCY_LOW_LATSUM_LSB_SHFT                                                 0

#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_AVLATENCY_HIGH_ADDR(x)                                               ((x) + 0x402c)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_AVLATENCY_HIGH_PHYS(x)                                               ((x) + 0x402c)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_AVLATENCY_HIGH_OFFS                                                  (0x402c)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_AVLATENCY_HIGH_RMSK                                                  0xffffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_AVLATENCY_HIGH_POR                                                   0x00000000
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_AVLATENCY_HIGH_POR_RMSK                                              0xffffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_AVLATENCY_HIGH_ATTR                                                               0x1
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_AVLATENCY_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_AVLATENCY_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_AVLATENCY_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_AVLATENCY_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_AVLATENCY_HIGH_TRCNT_BMSK                                            0xffffff00
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_AVLATENCY_HIGH_TRCNT_SHFT                                                     8
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_AVLATENCY_HIGH_LATSUM_MSB_BMSK                                             0xff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_AVLATENCY_HIGH_LATSUM_MSB_SHFT                                                0

#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN0_LOW_ADDR(x)                                                 ((x) + 0x4040)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN0_LOW_PHYS(x)                                                 ((x) + 0x4040)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN0_LOW_OFFS                                                    (0x4040)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN0_LOW_RMSK                                                      0xffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN0_LOW_POR                                                     0x00000000
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN0_LOW_POR_RMSK                                                0xffffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN0_LOW_ATTR                                                                 0x1
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN0_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN0_LOW_ADDR(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN0_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN0_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN0_LOW_HISTBIN0_BMSK                                             0xffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN0_LOW_HISTBIN0_SHFT                                                    0

#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN1_LOW_ADDR(x)                                                 ((x) + 0x4048)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN1_LOW_PHYS(x)                                                 ((x) + 0x4048)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN1_LOW_OFFS                                                    (0x4048)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN1_LOW_RMSK                                                      0xffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN1_LOW_POR                                                     0x00000000
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN1_LOW_POR_RMSK                                                0xffffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN1_LOW_ATTR                                                                 0x1
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN1_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN1_LOW_ADDR(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN1_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN1_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN1_LOW_HISTBIN1_BMSK                                             0xffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN1_LOW_HISTBIN1_SHFT                                                    0

#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN2_LOW_ADDR(x)                                                 ((x) + 0x4050)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN2_LOW_PHYS(x)                                                 ((x) + 0x4050)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN2_LOW_OFFS                                                    (0x4050)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN2_LOW_RMSK                                                      0xffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN2_LOW_POR                                                     0x00000000
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN2_LOW_POR_RMSK                                                0xffffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN2_LOW_ATTR                                                                 0x1
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN2_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN2_LOW_ADDR(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN2_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN2_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN2_LOW_HISTBIN2_BMSK                                             0xffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN2_LOW_HISTBIN2_SHFT                                                    0

#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN3_LOW_ADDR(x)                                                 ((x) + 0x4058)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN3_LOW_PHYS(x)                                                 ((x) + 0x4058)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN3_LOW_OFFS                                                    (0x4058)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN3_LOW_RMSK                                                      0xffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN3_LOW_POR                                                     0x00000000
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN3_LOW_POR_RMSK                                                0xffffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN3_LOW_ATTR                                                                 0x1
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN3_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN3_LOW_ADDR(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN3_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN3_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN3_LOW_HISTBIN3_BMSK                                             0xffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN3_LOW_HISTBIN3_SHFT                                                    0

#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN4_LOW_ADDR(x)                                                 ((x) + 0x4060)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN4_LOW_PHYS(x)                                                 ((x) + 0x4060)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN4_LOW_OFFS                                                    (0x4060)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN4_LOW_RMSK                                                      0xffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN4_LOW_POR                                                     0x00000000
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN4_LOW_POR_RMSK                                                0xffffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN4_LOW_ATTR                                                                 0x1
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN4_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN4_LOW_ADDR(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN4_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN4_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN4_LOW_HISTBIN4_BMSK                                             0xffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN4_LOW_HISTBIN4_SHFT                                                    0

#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN5_LOW_ADDR(x)                                                 ((x) + 0x4068)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN5_LOW_PHYS(x)                                                 ((x) + 0x4068)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN5_LOW_OFFS                                                    (0x4068)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN5_LOW_RMSK                                                      0xffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN5_LOW_POR                                                     0x00000000
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN5_LOW_POR_RMSK                                                0xffffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN5_LOW_ATTR                                                                 0x1
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN5_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN5_LOW_ADDR(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN5_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN5_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN5_LOW_HISTBIN5_BMSK                                             0xffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN5_LOW_HISTBIN5_SHFT                                                    0

#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN6_LOW_ADDR(x)                                                 ((x) + 0x4070)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN6_LOW_PHYS(x)                                                 ((x) + 0x4070)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN6_LOW_OFFS                                                    (0x4070)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN6_LOW_RMSK                                                      0xffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN6_LOW_POR                                                     0x00000000
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN6_LOW_POR_RMSK                                                0xffffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN6_LOW_ATTR                                                                 0x1
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN6_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN6_LOW_ADDR(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN6_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN6_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN6_LOW_HISTBIN6_BMSK                                             0xffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN6_LOW_HISTBIN6_SHFT                                                    0

#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN7_LOW_ADDR(x)                                                 ((x) + 0x4078)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN7_LOW_PHYS(x)                                                 ((x) + 0x4078)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN7_LOW_OFFS                                                    (0x4078)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN7_LOW_RMSK                                                      0xffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN7_LOW_POR                                                     0x00000000
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN7_LOW_POR_RMSK                                                0xffffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN7_LOW_ATTR                                                                 0x1
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN7_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN7_LOW_ADDR(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN7_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN7_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN7_LOW_HISTBIN7_BMSK                                             0xffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_HISTBIN7_LOW_HISTBIN7_SHFT                                                    0

#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_LATMAX_LOW_ADDR(x)                                                   ((x) + 0x4080)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_LATMAX_LOW_PHYS(x)                                                   ((x) + 0x4080)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_LATMAX_LOW_OFFS                                                      (0x4080)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_LATMAX_LOW_RMSK                                                            0xff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_LATMAX_LOW_POR                                                       0x00000000
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_LATMAX_LOW_POR_RMSK                                                  0xffffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_LATMAX_LOW_ATTR                                                                   0x1
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_LATMAX_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_LATMAX_LOW_ADDR(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_LATMAX_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_LATMAX_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_LATMAX_LOW_LATMAX_BMSK                                                     0xff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_LATMAX_LOW_LATMAX_SHFT                                                        0

#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_LOW_ADDR(x)                                          ((x) + 0x4120)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_LOW_PHYS(x)                                          ((x) + 0x4120)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_LOW_OFFS                                             (0x4120)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_LOW_RMSK                                             0xfffffc00
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_LOW_POR                                              0x00000000
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_LOW_POR_RMSK                                         0xffffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_LOW_ATTR                                                          0x3
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_LOW_ADDR(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_LOW_IN(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_LOW_VALUE_LSB_BMSK                                   0xfffffc00
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_LOW_VALUE_LSB_SHFT                                           10

#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_HIGH_ADDR(x)                                         ((x) + 0x4124)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_HIGH_PHYS(x)                                         ((x) + 0x4124)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_HIGH_OFFS                                            (0x4124)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_HIGH_RMSK                                                  0x1f
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_HIGH_POR                                             0x00000000
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_HIGH_POR_RMSK                                        0xffffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_HIGH_ATTR                                                         0x3
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_HIGH_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_HIGH_ADDR(x),v)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_HIGH_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_HIGH_ADDR(x),m,v,HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_HIGH_IN(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_HIGH_VALUE_MSB_BMSK                                        0x1f
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MIN_HIGH_VALUE_MSB_SHFT                                           0

#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_LOW_ADDR(x)                                          ((x) + 0x4128)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_LOW_PHYS(x)                                          ((x) + 0x4128)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_LOW_OFFS                                             (0x4128)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_LOW_RMSK                                             0xfffffc00
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_LOW_POR                                              0xfffffc00
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_LOW_POR_RMSK                                         0xffffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_LOW_ATTR                                                          0x3
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_LOW_ADDR(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_LOW_IN(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_LOW_VALUE_LSB_BMSK                                   0xfffffc00
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_LOW_VALUE_LSB_SHFT                                           10

#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_HIGH_ADDR(x)                                         ((x) + 0x412c)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_HIGH_PHYS(x)                                         ((x) + 0x412c)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_HIGH_OFFS                                            (0x412c)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_HIGH_RMSK                                                  0x1f
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_HIGH_POR                                             0x0000001f
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_HIGH_POR_RMSK                                        0xffffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_HIGH_ATTR                                                         0x3
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_HIGH_IN(x)            \
                in_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_HIGH_ADDR(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_HIGH_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_HIGH_ADDR(x), m)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_HIGH_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_HIGH_ADDR(x),v)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_HIGH_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_HIGH_ADDR(x),m,v,HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_HIGH_IN(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_HIGH_VALUE_MSB_BMSK                                        0x1f
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_ADDR_MAX_HIGH_VALUE_MSB_SHFT                                           0

#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_OPCODE_LOW_ADDR(x)                                            ((x) + 0x4138)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_OPCODE_LOW_PHYS(x)                                            ((x) + 0x4138)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_OPCODE_LOW_OFFS                                               (0x4138)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_OPCODE_LOW_RMSK                                                     0x1f
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_OPCODE_LOW_POR                                                0x00000003
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_OPCODE_LOW_POR_RMSK                                           0xffffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_OPCODE_LOW_ATTR                                                            0x3
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_OPCODE_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_OPCODE_LOW_ADDR(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_OPCODE_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_OPCODE_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_OPCODE_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_OPCODE_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_OPCODE_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_OPCODE_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_OPCODE_LOW_IN(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_OPCODE_LOW_ATOMEN_BMSK                                              0x10
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_OPCODE_LOW_ATOMEN_SHFT                                                 4
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_OPCODE_LOW_CMEN_BMSK                                                 0x8
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_OPCODE_LOW_CMEN_SHFT                                                   3
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_OPCODE_LOW_EXCLEN_BMSK                                               0x4
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_OPCODE_LOW_EXCLEN_SHFT                                                 2
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_OPCODE_LOW_WREN_BMSK                                                 0x2
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_OPCODE_LOW_WREN_SHFT                                                   1
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_OPCODE_LOW_RDEN_BMSK                                                 0x1
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_OPCODE_LOW_RDEN_SHFT                                                   0

#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_BASE_LOW_ADDR(x)                                        ((x) + 0x4178)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_BASE_LOW_PHYS(x)                                        ((x) + 0x4178)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_BASE_LOW_OFFS                                           (0x4178)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_BASE_LOW_RMSK                                               0xffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_BASE_LOW_POR                                            0x00000000
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_BASE_LOW_POR_RMSK                                       0xffffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_BASE_LOW_ATTR                                                        0x3
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_BASE_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_BASE_LOW_ADDR(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_BASE_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_BASE_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_BASE_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_BASE_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_BASE_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_BASE_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_BASE_LOW_IN(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_BASE_LOW_FILTER_EXTID_BASE_BMSK                             0xffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_BASE_LOW_FILTER_EXTID_BASE_SHFT                                  0

#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_MASK_LOW_ADDR(x)                                        ((x) + 0x4180)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_MASK_LOW_PHYS(x)                                        ((x) + 0x4180)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_MASK_LOW_OFFS                                           (0x4180)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_MASK_LOW_RMSK                                               0xffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_MASK_LOW_POR                                            0x00000000
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_MASK_LOW_POR_RMSK                                       0xffffffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_MASK_LOW_ATTR                                                        0x3
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_MASK_LOW_IN(x)            \
                in_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_MASK_LOW_ADDR(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_MASK_LOW_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_MASK_LOW_ADDR(x), m)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_MASK_LOW_OUT(x, v)            \
                out_dword(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_MASK_LOW_ADDR(x),v)
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_MASK_LOW_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_MASK_LOW_ADDR(x),m,v,HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_MASK_LOW_IN(x))
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_MASK_LOW_FILTER_EXTID_MASK_BMSK                             0xffff
#define HWIO_UMAC_NOC_QNS4S_SNOC_TENUREPRB_FILTER_EXTID_MASK_LOW_FILTER_EXTID_MASK_SHFT                                  0

/*----------------------------------------------------------------------------
 * MODULE: UMAC_ACMT
 *--------------------------------------------------------------------------*/

#define UMAC_ACMT_REG_BASE                                                           (UMAC_ACMT_BASE      + 0x00000000)
#define UMAC_ACMT_REG_BASE_SIZE                                                      0x1000
#define UMAC_ACMT_REG_BASE_USED                                                      0x13c
#define UMAC_ACMT_REG_BASE_PHYS                                                      (UMAC_ACMT_BASE_PHYS + 0x00000000)
#define UMAC_ACMT_REG_BASE_OFFS                                                      0x00000000

#define HWIO_UMAC_ACMT_CTRL_ADDR(x)                                                  ((x) + 0x0)
#define HWIO_UMAC_ACMT_CTRL_PHYS(x)                                                  ((x) + 0x0)
#define HWIO_UMAC_ACMT_CTRL_OFFS                                                     (0x0)
#define HWIO_UMAC_ACMT_CTRL_RMSK                                                            0x1
#define HWIO_UMAC_ACMT_CTRL_POR                                                      0x00000000
#define HWIO_UMAC_ACMT_CTRL_POR_RMSK                                                 0xffffffff
#define HWIO_UMAC_ACMT_CTRL_ATTR                                                                  0x3
#define HWIO_UMAC_ACMT_CTRL_IN(x)            \
                in_dword(HWIO_UMAC_ACMT_CTRL_ADDR(x))
#define HWIO_UMAC_ACMT_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_ACMT_CTRL_ADDR(x), m)
#define HWIO_UMAC_ACMT_CTRL_OUT(x, v)            \
                out_dword(HWIO_UMAC_ACMT_CTRL_ADDR(x),v)
#define HWIO_UMAC_ACMT_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_ACMT_CTRL_ADDR(x),m,v,HWIO_UMAC_ACMT_CTRL_IN(x))
#define HWIO_UMAC_ACMT_CTRL_ENABLE_BMSK                                                     0x1
#define HWIO_UMAC_ACMT_CTRL_ENABLE_SHFT                                                       0

#define HWIO_UMAC_ACMT_INTR_ENABLE_ADDR(x)                                           ((x) + 0x4)
#define HWIO_UMAC_ACMT_INTR_ENABLE_PHYS(x)                                           ((x) + 0x4)
#define HWIO_UMAC_ACMT_INTR_ENABLE_OFFS                                              (0x4)
#define HWIO_UMAC_ACMT_INTR_ENABLE_RMSK                                                     0x1
#define HWIO_UMAC_ACMT_INTR_ENABLE_POR                                               0x00000000
#define HWIO_UMAC_ACMT_INTR_ENABLE_POR_RMSK                                          0xffffffff
#define HWIO_UMAC_ACMT_INTR_ENABLE_ATTR                                                           0x3
#define HWIO_UMAC_ACMT_INTR_ENABLE_IN(x)            \
                in_dword(HWIO_UMAC_ACMT_INTR_ENABLE_ADDR(x))
#define HWIO_UMAC_ACMT_INTR_ENABLE_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_ACMT_INTR_ENABLE_ADDR(x), m)
#define HWIO_UMAC_ACMT_INTR_ENABLE_OUT(x, v)            \
                out_dword(HWIO_UMAC_ACMT_INTR_ENABLE_ADDR(x),v)
#define HWIO_UMAC_ACMT_INTR_ENABLE_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_ACMT_INTR_ENABLE_ADDR(x),m,v,HWIO_UMAC_ACMT_INTR_ENABLE_IN(x))
#define HWIO_UMAC_ACMT_INTR_ENABLE_INTR_EN_BMSK                                             0x1
#define HWIO_UMAC_ACMT_INTR_ENABLE_INTR_EN_SHFT                                               0

#define HWIO_UMAC_ACMT_INTR_STATUS_ADDR(x)                                           ((x) + 0x8)
#define HWIO_UMAC_ACMT_INTR_STATUS_PHYS(x)                                           ((x) + 0x8)
#define HWIO_UMAC_ACMT_INTR_STATUS_OFFS                                              (0x8)
#define HWIO_UMAC_ACMT_INTR_STATUS_RMSK                                                     0x1
#define HWIO_UMAC_ACMT_INTR_STATUS_POR                                               0x00000000
#define HWIO_UMAC_ACMT_INTR_STATUS_POR_RMSK                                          0xffffffff
#define HWIO_UMAC_ACMT_INTR_STATUS_ATTR                                                           0x1
#define HWIO_UMAC_ACMT_INTR_STATUS_IN(x)            \
                in_dword(HWIO_UMAC_ACMT_INTR_STATUS_ADDR(x))
#define HWIO_UMAC_ACMT_INTR_STATUS_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_ACMT_INTR_STATUS_ADDR(x), m)
#define HWIO_UMAC_ACMT_INTR_STATUS_VALID_BMSK                                               0x1
#define HWIO_UMAC_ACMT_INTR_STATUS_VALID_SHFT                                                 0

#define HWIO_UMAC_ACMT_INTR_CLEAR_ADDR(x)                                            ((x) + 0xc)
#define HWIO_UMAC_ACMT_INTR_CLEAR_PHYS(x)                                            ((x) + 0xc)
#define HWIO_UMAC_ACMT_INTR_CLEAR_OFFS                                               (0xc)
#define HWIO_UMAC_ACMT_INTR_CLEAR_RMSK                                                      0x1
#define HWIO_UMAC_ACMT_INTR_CLEAR_POR                                                0x00000000
#define HWIO_UMAC_ACMT_INTR_CLEAR_POR_RMSK                                           0xffffffff
#define HWIO_UMAC_ACMT_INTR_CLEAR_ATTR                                                            0x2
#define HWIO_UMAC_ACMT_INTR_CLEAR_OUT(x, v)            \
                out_dword(HWIO_UMAC_ACMT_INTR_CLEAR_ADDR(x),v)
#define HWIO_UMAC_ACMT_INTR_CLEAR_CLR_BMSK                                                  0x1
#define HWIO_UMAC_ACMT_INTR_CLEAR_CLR_SHFT                                                    0

#define HWIO_UMAC_ACMT_DEBUG0_ADDR(x)                                                ((x) + 0x10)
#define HWIO_UMAC_ACMT_DEBUG0_PHYS(x)                                                ((x) + 0x10)
#define HWIO_UMAC_ACMT_DEBUG0_OFFS                                                   (0x10)
#define HWIO_UMAC_ACMT_DEBUG0_RMSK                                                     0xffffff
#define HWIO_UMAC_ACMT_DEBUG0_POR                                                    0x00000000
#define HWIO_UMAC_ACMT_DEBUG0_POR_RMSK                                               0xffffffff
#define HWIO_UMAC_ACMT_DEBUG0_ATTR                                                                0x1
#define HWIO_UMAC_ACMT_DEBUG0_IN(x)            \
                in_dword(HWIO_UMAC_ACMT_DEBUG0_ADDR(x))
#define HWIO_UMAC_ACMT_DEBUG0_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_ACMT_DEBUG0_ADDR(x), m)
#define HWIO_UMAC_ACMT_DEBUG0_ADDRESS_BMSK                                             0xffffff
#define HWIO_UMAC_ACMT_DEBUG0_ADDRESS_SHFT                                                    0

#define HWIO_UMAC_ACMT_DEBUG1_ADDR(x)                                                ((x) + 0x14)
#define HWIO_UMAC_ACMT_DEBUG1_PHYS(x)                                                ((x) + 0x14)
#define HWIO_UMAC_ACMT_DEBUG1_OFFS                                                   (0x14)
#define HWIO_UMAC_ACMT_DEBUG1_RMSK                                                   0x10000000
#define HWIO_UMAC_ACMT_DEBUG1_POR                                                    0x00000000
#define HWIO_UMAC_ACMT_DEBUG1_POR_RMSK                                               0xffffffff
#define HWIO_UMAC_ACMT_DEBUG1_ATTR                                                                0x1
#define HWIO_UMAC_ACMT_DEBUG1_IN(x)            \
                in_dword(HWIO_UMAC_ACMT_DEBUG1_ADDR(x))
#define HWIO_UMAC_ACMT_DEBUG1_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_ACMT_DEBUG1_ADDR(x), m)
#define HWIO_UMAC_ACMT_DEBUG1_RW_BMSK                                                0x10000000
#define HWIO_UMAC_ACMT_DEBUG1_RW_SHFT                                                        28

#define HWIO_UMAC_ACMT_CFG_ADDR(x)                                                   ((x) + 0x1c)
#define HWIO_UMAC_ACMT_CFG_PHYS(x)                                                   ((x) + 0x1c)
#define HWIO_UMAC_ACMT_CFG_OFFS                                                      (0x1c)
#define HWIO_UMAC_ACMT_CFG_RMSK                                                            0x11
#define HWIO_UMAC_ACMT_CFG_POR                                                       0x00000001
#define HWIO_UMAC_ACMT_CFG_POR_RMSK                                                  0xffffffff
#define HWIO_UMAC_ACMT_CFG_ATTR                                                                   0x1
#define HWIO_UMAC_ACMT_CFG_IN(x)            \
                in_dword(HWIO_UMAC_ACMT_CFG_ADDR(x))
#define HWIO_UMAC_ACMT_CFG_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_ACMT_CFG_ADDR(x), m)
#define HWIO_UMAC_ACMT_CFG_DFLT_PROTECTION_BMSK                                            0x10
#define HWIO_UMAC_ACMT_CFG_DFLT_PROTECTION_SHFT                                               4
#define HWIO_UMAC_ACMT_CFG_PROTECTION_MODE_BMSK                                             0x1
#define HWIO_UMAC_ACMT_CFG_PROTECTION_MODE_SHFT                                               0

#define HWIO_UMAC_ACMT_NOC_TSLV_CTRL_ADDR(x)                                         ((x) + 0x40)
#define HWIO_UMAC_ACMT_NOC_TSLV_CTRL_PHYS(x)                                         ((x) + 0x40)
#define HWIO_UMAC_ACMT_NOC_TSLV_CTRL_OFFS                                            (0x40)
#define HWIO_UMAC_ACMT_NOC_TSLV_CTRL_RMSK                                                 0x111
#define HWIO_UMAC_ACMT_NOC_TSLV_CTRL_POR                                             0x00000111
#define HWIO_UMAC_ACMT_NOC_TSLV_CTRL_POR_RMSK                                        0xffffffff
#define HWIO_UMAC_ACMT_NOC_TSLV_CTRL_ATTR                                                         0x3
#define HWIO_UMAC_ACMT_NOC_TSLV_CTRL_IN(x)            \
                in_dword(HWIO_UMAC_ACMT_NOC_TSLV_CTRL_ADDR(x))
#define HWIO_UMAC_ACMT_NOC_TSLV_CTRL_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_ACMT_NOC_TSLV_CTRL_ADDR(x), m)
#define HWIO_UMAC_ACMT_NOC_TSLV_CTRL_OUT(x, v)            \
                out_dword(HWIO_UMAC_ACMT_NOC_TSLV_CTRL_ADDR(x),v)
#define HWIO_UMAC_ACMT_NOC_TSLV_CTRL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_ACMT_NOC_TSLV_CTRL_ADDR(x),m,v,HWIO_UMAC_ACMT_NOC_TSLV_CTRL_IN(x))
#define HWIO_UMAC_ACMT_NOC_TSLV_CTRL_RET_AHB_FORCE_POSTED_WR_BMSK                         0x100
#define HWIO_UMAC_ACMT_NOC_TSLV_CTRL_RET_AHB_FORCE_POSTED_WR_SHFT                             8
#define HWIO_UMAC_ACMT_NOC_TSLV_CTRL_RET_AHB_DEVBUFFABLE_BMSK                              0x10
#define HWIO_UMAC_ACMT_NOC_TSLV_CTRL_RET_AHB_DEVBUFFABLE_SHFT                                 4
#define HWIO_UMAC_ACMT_NOC_TSLV_CTRL_TIMEOUT_ENABLE_BMSK                                    0x1
#define HWIO_UMAC_ACMT_NOC_TSLV_CTRL_TIMEOUT_ENABLE_SHFT                                      0

#define HWIO_UMAC_ACMT_NOC_TESTBUS_SEL_ADDR(x)                                       ((x) + 0x44)
#define HWIO_UMAC_ACMT_NOC_TESTBUS_SEL_PHYS(x)                                       ((x) + 0x44)
#define HWIO_UMAC_ACMT_NOC_TESTBUS_SEL_OFFS                                          (0x44)
#define HWIO_UMAC_ACMT_NOC_TESTBUS_SEL_RMSK                                                 0xf
#define HWIO_UMAC_ACMT_NOC_TESTBUS_SEL_POR                                           0x00000000
#define HWIO_UMAC_ACMT_NOC_TESTBUS_SEL_POR_RMSK                                      0xffffffff
#define HWIO_UMAC_ACMT_NOC_TESTBUS_SEL_ATTR                                                       0x3
#define HWIO_UMAC_ACMT_NOC_TESTBUS_SEL_IN(x)            \
                in_dword(HWIO_UMAC_ACMT_NOC_TESTBUS_SEL_ADDR(x))
#define HWIO_UMAC_ACMT_NOC_TESTBUS_SEL_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_ACMT_NOC_TESTBUS_SEL_ADDR(x), m)
#define HWIO_UMAC_ACMT_NOC_TESTBUS_SEL_OUT(x, v)            \
                out_dword(HWIO_UMAC_ACMT_NOC_TESTBUS_SEL_ADDR(x),v)
#define HWIO_UMAC_ACMT_NOC_TESTBUS_SEL_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_ACMT_NOC_TESTBUS_SEL_ADDR(x),m,v,HWIO_UMAC_ACMT_NOC_TESTBUS_SEL_IN(x))
#define HWIO_UMAC_ACMT_NOC_TESTBUS_SEL_TESTBUS_SEL_BMSK                                     0xf
#define HWIO_UMAC_ACMT_NOC_TESTBUS_SEL_TESTBUS_SEL_SHFT                                       0

#define HWIO_UMAC_ACMT_ACC_CTL_TABLE0_ADDR(x)                                        ((x) + 0x100)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE0_PHYS(x)                                        ((x) + 0x100)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE0_OFFS                                           (0x100)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE0_RMSK                                           0x3fff3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE0_POR                                            0x00000000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE0_POR_RMSK                                       0xffffffff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE0_ATTR                                                        0x3
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE0_IN(x)            \
                in_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE0_ADDR(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE0_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_ACMT_ACC_CTL_TABLE0_ADDR(x), m)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE0_OUT(x, v)            \
                out_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE0_ADDR(x),v)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE0_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_ACMT_ACC_CTL_TABLE0_ADDR(x),m,v,HWIO_UMAC_ACMT_ACC_CTL_TABLE0_IN(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE0_REGS_SIZE_BMSK                                 0x3fff0000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE0_REGS_SIZE_SHFT                                         16
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE0_REGS_BASE_BMSK                                     0x3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE0_REGS_BASE_SHFT                                          0

#define HWIO_UMAC_ACMT_ACC_CTL_TABLE1_ADDR(x)                                        ((x) + 0x104)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE1_PHYS(x)                                        ((x) + 0x104)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE1_OFFS                                           (0x104)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE1_RMSK                                           0x3fff3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE1_POR                                            0x00000000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE1_POR_RMSK                                       0xffffffff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE1_ATTR                                                        0x3
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE1_IN(x)            \
                in_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE1_ADDR(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE1_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_ACMT_ACC_CTL_TABLE1_ADDR(x), m)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE1_OUT(x, v)            \
                out_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE1_ADDR(x),v)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE1_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_ACMT_ACC_CTL_TABLE1_ADDR(x),m,v,HWIO_UMAC_ACMT_ACC_CTL_TABLE1_IN(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE1_REGS_SIZE_BMSK                                 0x3fff0000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE1_REGS_SIZE_SHFT                                         16
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE1_REGS_BASE_BMSK                                     0x3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE1_REGS_BASE_SHFT                                          0

#define HWIO_UMAC_ACMT_ACC_CTL_TABLE2_ADDR(x)                                        ((x) + 0x108)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE2_PHYS(x)                                        ((x) + 0x108)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE2_OFFS                                           (0x108)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE2_RMSK                                           0x3fff3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE2_POR                                            0x00000000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE2_POR_RMSK                                       0xffffffff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE2_ATTR                                                        0x3
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE2_IN(x)            \
                in_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE2_ADDR(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE2_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_ACMT_ACC_CTL_TABLE2_ADDR(x), m)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE2_OUT(x, v)            \
                out_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE2_ADDR(x),v)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE2_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_ACMT_ACC_CTL_TABLE2_ADDR(x),m,v,HWIO_UMAC_ACMT_ACC_CTL_TABLE2_IN(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE2_REGS_SIZE_BMSK                                 0x3fff0000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE2_REGS_SIZE_SHFT                                         16
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE2_REGS_BASE_BMSK                                     0x3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE2_REGS_BASE_SHFT                                          0

#define HWIO_UMAC_ACMT_ACC_CTL_TABLE3_ADDR(x)                                        ((x) + 0x10c)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE3_PHYS(x)                                        ((x) + 0x10c)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE3_OFFS                                           (0x10c)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE3_RMSK                                           0x3fff3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE3_POR                                            0x00000000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE3_POR_RMSK                                       0xffffffff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE3_ATTR                                                        0x3
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE3_IN(x)            \
                in_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE3_ADDR(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE3_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_ACMT_ACC_CTL_TABLE3_ADDR(x), m)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE3_OUT(x, v)            \
                out_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE3_ADDR(x),v)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE3_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_ACMT_ACC_CTL_TABLE3_ADDR(x),m,v,HWIO_UMAC_ACMT_ACC_CTL_TABLE3_IN(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE3_REGS_SIZE_BMSK                                 0x3fff0000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE3_REGS_SIZE_SHFT                                         16
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE3_REGS_BASE_BMSK                                     0x3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE3_REGS_BASE_SHFT                                          0

#define HWIO_UMAC_ACMT_ACC_CTL_TABLE4_ADDR(x)                                        ((x) + 0x110)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE4_PHYS(x)                                        ((x) + 0x110)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE4_OFFS                                           (0x110)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE4_RMSK                                           0x3fff3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE4_POR                                            0x00000000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE4_POR_RMSK                                       0xffffffff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE4_ATTR                                                        0x3
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE4_IN(x)            \
                in_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE4_ADDR(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE4_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_ACMT_ACC_CTL_TABLE4_ADDR(x), m)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE4_OUT(x, v)            \
                out_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE4_ADDR(x),v)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE4_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_ACMT_ACC_CTL_TABLE4_ADDR(x),m,v,HWIO_UMAC_ACMT_ACC_CTL_TABLE4_IN(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE4_REGS_SIZE_BMSK                                 0x3fff0000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE4_REGS_SIZE_SHFT                                         16
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE4_REGS_BASE_BMSK                                     0x3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE4_REGS_BASE_SHFT                                          0

#define HWIO_UMAC_ACMT_ACC_CTL_TABLE5_ADDR(x)                                        ((x) + 0x114)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE5_PHYS(x)                                        ((x) + 0x114)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE5_OFFS                                           (0x114)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE5_RMSK                                           0x3fff3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE5_POR                                            0x00000000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE5_POR_RMSK                                       0xffffffff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE5_ATTR                                                        0x3
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE5_IN(x)            \
                in_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE5_ADDR(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE5_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_ACMT_ACC_CTL_TABLE5_ADDR(x), m)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE5_OUT(x, v)            \
                out_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE5_ADDR(x),v)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE5_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_ACMT_ACC_CTL_TABLE5_ADDR(x),m,v,HWIO_UMAC_ACMT_ACC_CTL_TABLE5_IN(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE5_REGS_SIZE_BMSK                                 0x3fff0000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE5_REGS_SIZE_SHFT                                         16
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE5_REGS_BASE_BMSK                                     0x3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE5_REGS_BASE_SHFT                                          0

#define HWIO_UMAC_ACMT_ACC_CTL_TABLE6_ADDR(x)                                        ((x) + 0x118)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE6_PHYS(x)                                        ((x) + 0x118)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE6_OFFS                                           (0x118)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE6_RMSK                                           0x3fff3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE6_POR                                            0x00000000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE6_POR_RMSK                                       0xffffffff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE6_ATTR                                                        0x3
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE6_IN(x)            \
                in_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE6_ADDR(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE6_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_ACMT_ACC_CTL_TABLE6_ADDR(x), m)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE6_OUT(x, v)            \
                out_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE6_ADDR(x),v)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE6_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_ACMT_ACC_CTL_TABLE6_ADDR(x),m,v,HWIO_UMAC_ACMT_ACC_CTL_TABLE6_IN(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE6_REGS_SIZE_BMSK                                 0x3fff0000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE6_REGS_SIZE_SHFT                                         16
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE6_REGS_BASE_BMSK                                     0x3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE6_REGS_BASE_SHFT                                          0

#define HWIO_UMAC_ACMT_ACC_CTL_TABLE7_ADDR(x)                                        ((x) + 0x11c)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE7_PHYS(x)                                        ((x) + 0x11c)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE7_OFFS                                           (0x11c)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE7_RMSK                                           0x3fff3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE7_POR                                            0x00000000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE7_POR_RMSK                                       0xffffffff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE7_ATTR                                                        0x3
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE7_IN(x)            \
                in_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE7_ADDR(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE7_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_ACMT_ACC_CTL_TABLE7_ADDR(x), m)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE7_OUT(x, v)            \
                out_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE7_ADDR(x),v)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE7_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_ACMT_ACC_CTL_TABLE7_ADDR(x),m,v,HWIO_UMAC_ACMT_ACC_CTL_TABLE7_IN(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE7_REGS_SIZE_BMSK                                 0x3fff0000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE7_REGS_SIZE_SHFT                                         16
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE7_REGS_BASE_BMSK                                     0x3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE7_REGS_BASE_SHFT                                          0

#define HWIO_UMAC_ACMT_ACC_CTL_TABLE8_ADDR(x)                                        ((x) + 0x120)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE8_PHYS(x)                                        ((x) + 0x120)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE8_OFFS                                           (0x120)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE8_RMSK                                           0x3fff3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE8_POR                                            0x00000000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE8_POR_RMSK                                       0xffffffff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE8_ATTR                                                        0x3
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE8_IN(x)            \
                in_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE8_ADDR(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE8_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_ACMT_ACC_CTL_TABLE8_ADDR(x), m)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE8_OUT(x, v)            \
                out_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE8_ADDR(x),v)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE8_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_ACMT_ACC_CTL_TABLE8_ADDR(x),m,v,HWIO_UMAC_ACMT_ACC_CTL_TABLE8_IN(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE8_REGS_SIZE_BMSK                                 0x3fff0000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE8_REGS_SIZE_SHFT                                         16
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE8_REGS_BASE_BMSK                                     0x3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE8_REGS_BASE_SHFT                                          0

#define HWIO_UMAC_ACMT_ACC_CTL_TABLE9_ADDR(x)                                        ((x) + 0x124)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE9_PHYS(x)                                        ((x) + 0x124)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE9_OFFS                                           (0x124)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE9_RMSK                                           0x3fff3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE9_POR                                            0x00000000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE9_POR_RMSK                                       0xffffffff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE9_ATTR                                                        0x3
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE9_IN(x)            \
                in_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE9_ADDR(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE9_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_ACMT_ACC_CTL_TABLE9_ADDR(x), m)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE9_OUT(x, v)            \
                out_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE9_ADDR(x),v)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE9_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_ACMT_ACC_CTL_TABLE9_ADDR(x),m,v,HWIO_UMAC_ACMT_ACC_CTL_TABLE9_IN(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE9_REGS_SIZE_BMSK                                 0x3fff0000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE9_REGS_SIZE_SHFT                                         16
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE9_REGS_BASE_BMSK                                     0x3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE9_REGS_BASE_SHFT                                          0

#define HWIO_UMAC_ACMT_ACC_CTL_TABLE10_ADDR(x)                                       ((x) + 0x128)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE10_PHYS(x)                                       ((x) + 0x128)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE10_OFFS                                          (0x128)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE10_RMSK                                          0x3fff3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE10_POR                                           0x00000000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE10_POR_RMSK                                      0xffffffff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE10_ATTR                                                       0x3
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE10_IN(x)            \
                in_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE10_ADDR(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE10_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_ACMT_ACC_CTL_TABLE10_ADDR(x), m)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE10_OUT(x, v)            \
                out_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE10_ADDR(x),v)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE10_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_ACMT_ACC_CTL_TABLE10_ADDR(x),m,v,HWIO_UMAC_ACMT_ACC_CTL_TABLE10_IN(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE10_REGS_SIZE_BMSK                                0x3fff0000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE10_REGS_SIZE_SHFT                                        16
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE10_REGS_BASE_BMSK                                    0x3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE10_REGS_BASE_SHFT                                         0

#define HWIO_UMAC_ACMT_ACC_CTL_TABLE11_ADDR(x)                                       ((x) + 0x12c)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE11_PHYS(x)                                       ((x) + 0x12c)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE11_OFFS                                          (0x12c)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE11_RMSK                                          0x3fff3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE11_POR                                           0x00000000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE11_POR_RMSK                                      0xffffffff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE11_ATTR                                                       0x3
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE11_IN(x)            \
                in_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE11_ADDR(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE11_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_ACMT_ACC_CTL_TABLE11_ADDR(x), m)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE11_OUT(x, v)            \
                out_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE11_ADDR(x),v)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE11_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_ACMT_ACC_CTL_TABLE11_ADDR(x),m,v,HWIO_UMAC_ACMT_ACC_CTL_TABLE11_IN(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE11_REGS_SIZE_BMSK                                0x3fff0000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE11_REGS_SIZE_SHFT                                        16
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE11_REGS_BASE_BMSK                                    0x3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE11_REGS_BASE_SHFT                                         0

#define HWIO_UMAC_ACMT_ACC_CTL_TABLE12_ADDR(x)                                       ((x) + 0x130)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE12_PHYS(x)                                       ((x) + 0x130)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE12_OFFS                                          (0x130)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE12_RMSK                                          0x3fff3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE12_POR                                           0x00000000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE12_POR_RMSK                                      0xffffffff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE12_ATTR                                                       0x3
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE12_IN(x)            \
                in_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE12_ADDR(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE12_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_ACMT_ACC_CTL_TABLE12_ADDR(x), m)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE12_OUT(x, v)            \
                out_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE12_ADDR(x),v)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE12_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_ACMT_ACC_CTL_TABLE12_ADDR(x),m,v,HWIO_UMAC_ACMT_ACC_CTL_TABLE12_IN(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE12_REGS_SIZE_BMSK                                0x3fff0000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE12_REGS_SIZE_SHFT                                        16
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE12_REGS_BASE_BMSK                                    0x3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE12_REGS_BASE_SHFT                                         0

#define HWIO_UMAC_ACMT_ACC_CTL_TABLE13_ADDR(x)                                       ((x) + 0x134)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE13_PHYS(x)                                       ((x) + 0x134)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE13_OFFS                                          (0x134)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE13_RMSK                                          0x3fff3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE13_POR                                           0x00000000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE13_POR_RMSK                                      0xffffffff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE13_ATTR                                                       0x3
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE13_IN(x)            \
                in_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE13_ADDR(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE13_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_ACMT_ACC_CTL_TABLE13_ADDR(x), m)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE13_OUT(x, v)            \
                out_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE13_ADDR(x),v)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE13_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_ACMT_ACC_CTL_TABLE13_ADDR(x),m,v,HWIO_UMAC_ACMT_ACC_CTL_TABLE13_IN(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE13_REGS_SIZE_BMSK                                0x3fff0000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE13_REGS_SIZE_SHFT                                        16
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE13_REGS_BASE_BMSK                                    0x3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE13_REGS_BASE_SHFT                                         0

#define HWIO_UMAC_ACMT_ACC_CTL_TABLE14_ADDR(x)                                       ((x) + 0x138)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE14_PHYS(x)                                       ((x) + 0x138)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE14_OFFS                                          (0x138)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE14_RMSK                                          0x3fff3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE14_POR                                           0x00000000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE14_POR_RMSK                                      0xffffffff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE14_ATTR                                                       0x3
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE14_IN(x)            \
                in_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE14_ADDR(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE14_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_ACMT_ACC_CTL_TABLE14_ADDR(x), m)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE14_OUT(x, v)            \
                out_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE14_ADDR(x),v)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE14_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_ACMT_ACC_CTL_TABLE14_ADDR(x),m,v,HWIO_UMAC_ACMT_ACC_CTL_TABLE14_IN(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE14_REGS_SIZE_BMSK                                0x3fff0000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE14_REGS_SIZE_SHFT                                        16
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE14_REGS_BASE_BMSK                                    0x3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE14_REGS_BASE_SHFT                                         0

#define HWIO_UMAC_ACMT_ACC_CTL_TABLE15_ADDR(x)                                       ((x) + 0x13c)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE15_PHYS(x)                                       ((x) + 0x13c)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE15_OFFS                                          (0x13c)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE15_RMSK                                          0x3fff3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE15_POR                                           0x00000000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE15_POR_RMSK                                      0xffffffff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE15_ATTR                                                       0x3
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE15_IN(x)            \
                in_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE15_ADDR(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE15_INM(x, m)            \
                in_dword_masked(HWIO_UMAC_ACMT_ACC_CTL_TABLE15_ADDR(x), m)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE15_OUT(x, v)            \
                out_dword(HWIO_UMAC_ACMT_ACC_CTL_TABLE15_ADDR(x),v)
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE15_OUTM(x,m,v) \
                out_dword_masked_ns(HWIO_UMAC_ACMT_ACC_CTL_TABLE15_ADDR(x),m,v,HWIO_UMAC_ACMT_ACC_CTL_TABLE15_IN(x))
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE15_REGS_SIZE_BMSK                                0x3fff0000
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE15_REGS_SIZE_SHFT                                        16
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE15_REGS_BASE_BMSK                                    0x3fff
#define HWIO_UMAC_ACMT_ACC_CTL_TABLE15_REGS_BASE_SHFT                                         0


#endif /* __WCSS_SEQ_HWIOREG_UMAC_H__ */
